systemheader:(AT    )#                                                  AT     1
#####################################################################   AT     2
##      Copyright (C) 2000, The Xtal System, The University of        # AT     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # AT     4
## Distributed under the GNU General Public Licence as published by   # AT     5
## the Free Software Foundation, in the hope that it will be useful   # AT     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # AT     7
## for more details.                                                  # AT     8
#                                                                   #   AT     9
#                          *** ATABLE ***                           #   AT    10
#                                                                   #   AT    11
#       PROGRAM TO PREPARE TABLES OF ATOMIC PARAMETERS FOR          #   AT    12
#       PUBLICATION. SEVERAL TABLE VARIATIONS ARE PROVIDED.         #   AT    13
#       FOR B(EQUIV) CALC SEE: ACTA 1988 C44, 775-776.              #   AT    14
#                                                                   #   AT    15
#####################################################################   AT    16
#                                                                       AT    17
include:(XMACRO)#                                                       AT    18
#                                                                       AT    19
macro:(putline:, writepch:(CHROT,ML); writeline:(0,0,0,1,3))#           AT    20
#                                                                       AT    21
systemheader:(AT00)#                   Tabulates atom coords & t.f      AT00   1
####################################################################    AT00   2
#                                                                       AT00   3
#                        AT00                                           AT00   4
#                                                                       AT00   5
####################################################################    AT00   6
SUBROUTINE AT00#                                                        AT00   7
include:(AACOMN)#                      S.r.hall  may 1989               AT00   8
#                                      H.d.flack sept 1990 pop. params  AT00   9
#                                      H.d.flack nov 1990 constraints   AT00  10
#                                                                       AT00  11
INTEGER I,IN,IX,J,JC,K,LMAX,N#                                          AT00  12
INTEGER IR(33),IW(32),KEY(4)#                                           AT00  13
INTEGER IH,IS,IA,IP,JP,IC#                                              AT00  14
INTEGER LLEN,SLEN#                                                      AT00  15
INTEGER BRAC,MARKA,STOPA,STEPA#                                         AT00  16
INTEGER MARKX,STOPX,STEPX#                                              AT00  17
INTEGER POP(3)#                                                         AT00  18
INTEGER PCH,ML#                                                         AT00  19
REAL    DCELL(6),RCELL(6),UEQU(6)#                                      AT00  20
#                                                                       AT00  21
string:(TEMP,24); string:(NAME,30)#                                     AT00  22
string:(TEMP1,24)#                                                      AT00  23
chardata:(AT0,- NO )#                                                   AT00  24
chardata:(AT1, END )#                                                   AT00  25
chardata:(AT2,"Atomic Positional and Isotropic $#                       AT00  26
Displacement Parameters")#                                              AT00  27
chardata:(AT22,["Atomic Positional, Isotropic Displacement and $#       AT00  28
Site Occupation Parameters"])#                                          AT00  29
chardata:(AT3,"Non-Hydrogen Positional and Isotropic Displacement $#    AT00  30
Parameters")#                                                           AT00  31
chardata:(AT33,["Non-Hydrogen Positional, Isotropic Displacement and $# AT00  32
Site Occupation Parameters"])#                                          AT00  33
chardata:(AT4,"Hydrogen Positional and Isotropic Displacement $#        AT00  34
Parameters")#                                                           AT00  35
chardata:(AT44,["Hydrogen Positional, Isotropic Displacement and $#     AT00  36
Site Occupation Parameters"])#                                          AT00  37
chardata:(AT5," x/a         y/b         z/c        $#                   AT00  38
U(eq) A**2    PP    ")#                                                 AT00  39
chardata:(AT6,"Atomic Displacement Parameters")#                        AT00  40
chardata:(AT7,"Atomic Anisotropic Displacement Parameters")#            AT00  41
chardata:(AT8," U11         U22         U33         $#                  AT00  42
U12         U13         U23    ")#                                      AT00  43
datastuff:#                                                             AT00  44
DO I=1,3; POP(I)=no:#                                                   AT00  45
#                                                                       AT00  46
#    PROCESS ATABLE CONTROLS                                            AT00  47
#    -----------------------                                            AT00  48
#                                                                       AT00  49
BRAC=yes:#                             Brackets in names                AT00  50
ML=80#                                 Default max pch line length      AT00  51
IH=1;    IS=1;    IN=0#                Set hydr & iso tf loops          AT00  52
ifnv:(BUFIN(1))#                       Test if data entered             AT00  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AT00  54
stringlim:(1,J,K)#                     Get string limits                AT00  55
compchar:(CHRIN,J,AT0,3,2,3,NAT0,K)#   Identify string                  AT00  56
IF(K==0) iquit:(AT0005)#               Unknown control                  AT00  57
IF(K==1) BRAC=no:#                     No  brackets in name             AT00  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AT00  59
readline:(AT1,NAT1)#                   Read the end line                AT00  60
#                                                                       AT00  61
#  INITIATE ARCHIVE BDF BUFFER                                          AT00  62
#  ---------------------------                                          AT00  63
#                                                                       AT00  64
IOMARK(1)=QXSTR#                       Start of xtal bdf buffer         AT00  65
incrqx:(MARKA,IOMARK(1)+bdfbuf:,AT0010)# Expand memory                  AT00  66
STOPA=MARKA;     STEPA=32#             Define atom list pointers        AT00  67
#                                                                       AT00  68
#     GET CELL DATA FROM BDF                                            AT00  69
#     ----------------------                                            AT00  70
#                                                                       AT00  71
DO I=1,3#                              Loop first two packets           AT00  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AT00  73
readwpkt:(1,lrcell:,JP,IP,0)#          Get next cell packet             AT00  74
IF(I==1) DO J=1,6; DCELL(J)=QX(IP+J)#  Store direct cell constants      AT00  75
IF(I==3) DO J=1,6; RCELL(J)=QX(IP+J)#  Store recipl cell constants      AT00  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AT00  77
UEQU(1)=(DCELL(1)*RCELL(1))**2/3.#     U(11) to uequiv                  AT00  78
UEQU(2)=(DCELL(2)*RCELL(2))**2/3.#     U(22) to uequiv                  AT00  79
UEQU(3)=(DCELL(3)*RCELL(3))**2/3.#     U(33) to uequiv                  AT00  80
UEQU(4)=2.*DCELL(1)*RCELL(1)*DCELL(2)*RCELL(2)*DCELL(6)/3.# U(12)       AT00  81
UEQU(5)=2.*DCELL(1)*RCELL(1)*DCELL(3)*RCELL(3)*DCELL(5)/3.# U(13)       AT00  82
UEQU(6)=2.*DCELL(2)*RCELL(2)*DCELL(3)*RCELL(3)*DCELL(4)/3.# U(23)       AT00  83
#                                                                       AT00  84
#     GET ATOM DATA FROM BDF                                            AT00  85
#     ----------------------                                            AT00  86
#                                                                       AT00  87
DO I= 1,11;  IW(I)=I#                  Request x,y,z,u,uij,pop          AT00  88
DO I=12,22;  IW(I)=I+89#               Request sigmas of above          AT00  89
IW(23)=23;   IW(24)=14#                Request tf type & name           AT00  90
KEY(1)=0; KEY(2)=24; KEY(3)=0; KEY(4)=0# Set search limits              AT00  91
indexpkt:(1,lratom:,JP,IP,0,KEY,IW,IR)# Get relative pointers           AT00  92
IF(IP*IR(24)<=0) iquit:(AT0001)#       No atom data                     AT00  93
FOR(IA=MARKA;;IA=STOPA)#               Loop over atom packets           AT00  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AT00  95
readwpkt:(1,lratom:,JP,IP,0)#          Point to atom pkt                AT00  96
IF(IP<=0) BREAK#                       Exit after last packet           AT00  97
incrqx:(STOPA,IA+STEPA,AT0002)#        Get next atom packet             AT00  98
DO I=1,23; IF(IR(I)>0) QX(IA+I)=QX(IP+IR(I))# Store atom data           AT00  99
movertoc:(QX(IP+IR(24)),1,NAME,1,24,0)# Store atom label                AT00 100
movector:(NAME,1,QX(IA+24),1,24,0)#    Put label in list                AT00 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AT00 102
#                                                                       AT00 103
#     GET CONSTRAINT DATA FROM BDF                                      AT00 104
#     ----------------------------                                      AT00 105
#                                                                       AT00 106
#    PUT THE INFORMATION INTO CORE INTO THE MARKX ARRAY LIKE THIS:      AT00 107
#                                                                       AT00 108
#    MARKX   CONTENTS                                                   AT00 109
#    +1      MARKA POINTER TO ATOM LABEL TO WHICH RESTRICTION APPLIES.  AT00 110
#    +2      POINTER TO SUBJECT PARAMETER.                              AT00 111
#    +3      NATURE OF RESTRICTION AS 1=CONSTRAINED; 3=FIXED.           AT00 112
#    +4      POINTER TO THE REFERENCE PARAMETER.                        AT00 113
#    +5      MULTIPLICATION FACTOR TO CONVERT THE UNRESTRICTED          AT00 114
#            PARAMETER INTO THE RESTRICTED ONE.                         AT00 115
#    +7      CONSTANT IN CONSTRAINT EQUATION                            AT00 116
#                                                                       AT00 117
MARKX=STOPA; STEPX=7; STOPX=MARKX#     Initialize memory pointers       AT00 118
DO I= 1,5;  IW(I)=I#                   Request items 1 to 5             AT00 119
DO I= 6,8;  IW(I)=I+5#                 Request itmes 11 to 13           AT00 120
KEY(1)=0; KEY(2)=8; KEY(3)=0; KEY(4)=0# Set search limits               AT00 121
indexpkt:(1,lrcons:,JP,IP,0,KEY,IW,IR)# Get relative pointers           AT00 122
FOR(IX=MARKX;;IX=STOPX)#               Loop over constraint packets     AT00 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AT00 124
readwpkt:(1,lrcons:,JP,IP,0)#          Point to cons pkt                AT00 125
IF(IP<=0) BREAK#                       Exit after last packet           AT00 126
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Check names in cons and atom     AT00 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AT00 128
movertoc:(QX(IA+24),1,TEMP,1,24,0)#    Store atom label                 AT00 129
movertoc:(QX(IP+IR(1)),1,TEMP1,1,24,0)# Store subject atom label        AT00 130
IF(TEMP!=TEMP1) NEXT#                  Are atom and subject same?       AT00 131
movertoc:(QX(IP+IR(6)),1,TEMP1,1,24,0)# Store reference atom label      AT00 132
IF(TEMP!=TEMP1) NEXT#                  Are atom and reference same?     AT00 133
incrqx:(STOPX,IX+STEPX,AT0002)#        Get next cons packet             AT00 134
QX(IX+1)=REAL(IA);QX(IX+2)=QX(IP+IR(2))# Atom pointer /subject parame   AT00 135
QX(IX+3)=QX(IP+IR(5));QX(IX+4)=QX(IP+IR(7))# Key/ref parameter          AT00 136
QX(IX+5)=QX(IP+IR(8));QX(IX+6)=QX(IP+IR(8))# Mult factor                AT00 137
QX(IX+7)=QX(IP+IR(4))#                 Contraint constant               AT00 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AT00 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AT00 140
readwpkt:(1,endrecord:,JP,IP,0)#       Close off archive file           AT00 141
#                                                                       AT00 142
#    PREPARE ATOM DATA FOR OUTPUT                                       AT00 143
#    ----------------------------                                       AT00 144
#                                                                       AT00 145
LMAX=0#                                Start label max length           AT00 146
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over atom list              AT00 147
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AT00 148
movertoc:(QX(IA+24),1,TEMP,1,24,0)#    Store atom name                  AT00 149
label:(TEMP,LLEN,SLEN)#                Get symbol from label            AT00 150
IF(SLEN==1&(TEMP(1^1)=='H'\TEMP(1^1)=='h'))# Test if hydrogen atom      AT00 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AT00 152
QX(IA+32)=-1.;     IH=3#               Flag as hydrogen atom            AT00 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AT00 154
ELSE QX(IA+32)=+1.#                    Flag as non-h atom               AT00 155
IF(BRAC==no:\SLEN==LLEN) NAME=TEMP(1^LLEN)# Transfer atom label only    AT00 156
ELSE#                                  Surround atom symbol with ( )    AT00 157
NAME=TEMP(1^SLEN)//'('//TEMP(SLEN+1^LLEN)//')'# Bracketed atom label    AT00 158
movector:(NAME,1,QX(IA+24),1,26,0)#    Store atom name                  AT00 159
#                                                                       AT00 160
ifne:(QX(IA+11),0.0)ifne:(QX(IA+11),1.0)# Population params?            AT00 161
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AT00 162
POP(1)=yes:#                           Population in all-atoms list     AT00 163
ifeq:(QX(IA+32),-1.) POP(3)=yes:#      Population in hydrogen list      AT00 164
ifeq:(QX(IA+32),1.) POP(2)=yes:#       Population in non-hydrogen lis   AT00 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AT00 166
#                                                                       AT00 167
ifeq:(QX(IA+23),1.)#                   If isotropic present convert     AT00 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AT00 169
QX(IA+5)=QX(IA+4); QX(IA+16)=QX(IA+15)# Store u's as u11                AT00 170
IS=2;    NEXT#                         Loop aniso separately            AT00 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AT00 172
QX(IA+4)=0.; QX(IA+15)=0.;  IN=1#      Zero uequiv values               AT00 173
DO I=1,6#                              Loop over aniso elements         AT00 174
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AT00 175
QX(IA+ 4)=QX(IA+ 4)+QX(IA+I+ 4)*UEQU(I)# Calc uequiv value              AT00 176
QX(IA+15)=QX(IA+15)+(QX(IA+I+15)*UEQU(I))**2# Calc uequiv variance      AT00 177
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AT00 178
QX(IA+15)=SQRT(3.*ABS(QX(IA+15)))#     Variance to std dev for ueq      AT00 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AT00 180
#                                                                       AT00 181
#    OUTPUT XYZ AND U PARAMETERS                                        AT00 182
#    ---------------------------                                        AT00 183
#                                                                       AT00 184
DO N=1,IH#                             Loop total, nonh and h lists     AT00 185
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AT00 186
putline:; putline:; putline:#          Output 3 spaces                  AT00 187
IF(POP(N)==no:)#                       No site occupations              AT00 188
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AT00 189
IF(N==1)#                              For total atom list              AT00 190
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AT00 191
movechar:(AT2,1,CHROT,2+8,NAT2,0)#     Insert atom list header          AT00 192
putline:#                              Punch header line                AT00 193
movechar:(AT0,1,CHROT,2+8,NAT2,1)#     Insert underline                 AT00 194
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AT00 195
IF(N==2)#                              For nonhydrogen atom list        AT00 196
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AT00 197
movechar:(AT3,1,CHROT,2+8,NAT3,0)#     Insert atom list header          AT00 198
putline:#                              Punch header line                AT00 199
movechar:(AT0,1,CHROT,2+8,NAT3,1)#     Insert underline                 AT00 200
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AT00 201
IF(N==3)#                              For hydrogen atom list           AT00 202
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AT00 203
movechar:(AT4,1,CHROT,2+8,NAT4,0)#     Insert atom list header          AT00 204
putline:#                              Punch header line                AT00 205
movechar:(AT0,1,CHROT,2+8,NAT4,1)#     Insert underline                 AT00 206
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AT00 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AT00 208
ELSE#                                  Significant site occupations     AT00 209
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AT00 210
IF(N==1)#                              For total atom list              AT00 211
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AT00 212
movechar:(AT22,1,CHROT,2,NAT22,0)#     Insert atom list header          AT00 213
putline:#                              Punch header line                AT00 214
movechar:(AT0,1,CHROT,2,NAT22,1)#      Insert underline                 AT00 215
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AT00 216
IF(N==2)#                              For nonhydrogen atom list        AT00 217
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AT00 218
movechar:(AT33,1,CHROT,2,NAT33,0)#     Insert atom list header          AT00 219
putline:#                              Punch header line                AT00 220
movechar:(AT0,1,CHROT,2,NAT33,1)#      Insert underline                 AT00 221
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AT00 222
IF(N==3)#                              For hydrogen atom list           AT00 223
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AT00 224
movechar:(AT44,1,CHROT,2+5,NAT44,0)#   Insert atom list header          AT00 225
putline:#                              Punch header line                AT00 226
movechar:(AT0,1,CHROT,2+5,NAT44,1)#    Insert underline                 AT00 227
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AT00 228
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AT00 229
JC=LABMAX+2*BRAC+3#                    Start char pointer               AT00 230
putline:; putline:#                    Punch underline and space        AT00 231
IF(POP(N)==yes:)PCH=0#                 Use full line                    AT00 232
ELSE            PCH=-10#               10 chars short of full line      AT00 233
movechar:(AT0,1,CHROT,2,NAT5+JC+PCH,1)# Rule line at top                AT00 234
putline:#                              Write line                       AT00 235
movechar:(AT5,1,CHROT,JC+2,NAT5+PCH,0)# Insert subheader                AT00 236
movechar:(AT22,1,CHROT,2,4,0)#         Copy atom heading                AT00 237
putline:#                              Punch subheader                  AT00 238
movechar:(AT0,1,CHROT,2,NAT5+JC+PCH,1)# Rule line beneath header        AT00 239
putline:#                              Write line                       AT00 240
#                                                                       AT00 241
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over atom list              AT00 242
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AT00 243
J=NINT(QX(IA+32))#                     Non-h is +1; h is -1             AT00 244
IF(J*N==-2\J*N==3) NEXT#               Skip inappropriate h/nonh        AT00 245
movertoc:(QX(IA+24),1,CHROT,2,26,0)#   Insert atom name                 AT00 246
IC=JC#                                 Start char pointer               AT00 247
DO I=1,3#                              Loop over coords                 AT00 248
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 AT00 249
CALL AT10(NAME,I*J,QX(IA+I),QX(IA+I+11))# Assemble coord & sigma        AT00 250
FOR(IX=MARKX;IX<STOPX;IX=IX+STEPX)#    Loop through constraints         AT00 251
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 AT00 252
IF(IA!=NINT(QX(IX+1))) NEXT#           Contraint not for this atom      AT00 253
IF(I==NINT(QX(IX+2))) CALL AT20(IX,NAME)# Apply constraint              AT00 254
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 AT00 255
CHROT(IC^IC+11)=NAME#                  Insert coord & sigma             AT00 256
IC=IC+12#                              Incr char pointer                AT00 257
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 AT00 258
CALL AT10(NAME,4*J,QX(IA+4),QX(IA+15))# Format uequiv values            AT00 259
CHROT(IC+1^)=NAME#                     Insert uequiv & sigma            AT00 260
IF(QX(IA+23)>1.) CHROT(IC^IC)='*'#     Flag as u(equiv)                 AT00 261
IC=IC+13#                                                               AT00 262
ifne:(QX(IA+11),0.0)ifne:(QX(IA+11),1.0)# Population params?            AT00 263
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 AT00 264
CALL AT10(NAME,4*J,QX(IA+11),QX(IA+22))# Format population values       AT00 265
CHROT(IC^IC+11)=NAME#                  Insert pop & sigma               AT00 266
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 AT00 267
putline:#                              Ouput the current buffer         AT00 268
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AT00 269
movechar:(AT0,1,CHROT,2,NAT5+JC+PCH,1)# Rule line beneath header        AT00 270
putline:#                              Write line                       AT00 271
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AT00 272
#                                                                       AT00 273
#    OUTPUT ANISOTROPIC THERMAL PARAMETERS                              AT00 274
#    -------------------------------------                              AT00 275
#                                                                       AT00 276
IF(IN>0) DO N=1,IS#                    Loop mixed and aniso tf lists    AT00 277
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 AT00 278
putline:; putline:; putline:#          Output 3 spaces                  AT00 279
IF(N==1)#                              For mix tf list                  AT00 280
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 AT00 281
movechar:(AT6,1,CHROT,2+8,NAT6,0)#     Insert atom list header          AT00 282
putline:#                              Punch header line                AT00 283
movechar:(AT0,1,CHROT,2+8,NAT6,1)#     Insert underline                 AT00 284
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 AT00 285
IF(N==2)#                              For aniso tf list                AT00 286
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 AT00 287
movechar:(AT7,1,CHROT,2+8,NAT7,0)#     Insert atom list header          AT00 288
putline:#                              Punch header line                AT00 289
movechar:(AT0,1,CHROT,2+8,NAT7,1)#     Insert underline                 AT00 290
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 AT00 291
putline:; putline:#                    Punch underline and space        AT00 292
movechar:(AT0,1,CHROT,2,NAT8+JC,1)#    Rule table top line              AT00 293
putline:#                              Write line                       AT00 294
movechar:(AT8,1,CHROT,JC+2,NAT8,0)#    Insert subheader                 AT00 295
movechar:(AT22,1,CHROT,2,4,0)#         Copy atom heading                AT00 296
putline:#                              Write line                       AT00 297
movechar:(AT0,1,CHROT,2,NAT8+JC,1)#    Rule line beneath header         AT00 298
putline:#                              Write line                       AT00 299
#                                                                       AT00 300
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over atom list              AT00 301
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 AT00 302
J=NINT(QX(IA+32))#                     Non-h is +1; h is -1             AT00 303
IF(N==2&QX(IA+23)<2.) NEXT#            Skip isotropic atoms             AT00 304
movertoc:(QX(IA+24),1,CHROT,2,26,0)#   Insert atom name                 AT00 305
IC=JC#                                 Start char pointer               AT00 306
DO I=5,10#                             Loop over uij                    AT00 307
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 AT00 308
CALL AT10(NAME,I*J,QX(IA+I),QX(IA+I+11))# Assemble coord & sigma        AT00 309
FOR(IX=MARKX;IX<STOPX;IX=IX+STEPX)#    Loop through constraints         AT00 310
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 AT00 311
IF(IA!=NINT(QX(IX+1))) NEXT#           Contraint not for this atom      AT00 312
IF(I-1==NINT(QX(IX+2))) CALL AT20(IX,NAME)# Apply constraint            AT00 313
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 AT00 314
CHROT(IC^IC+12)=NAME#                  Insert coord & sigma             AT00 315
IC=IC+12#                              Incr char pointer                AT00 316
ifeq:(QX(IA+23),1.) BREAK#             Exit if isotropic                AT00 317
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 AT00 318
FOR(;(IC>80&CHROT(IC^IC)==' ');IC=IC-1);# Get last blank                AT00 319
IF(IC>80)ML=IC#                        Output complete line             AT00 320
putline:#                              Ouput the current buffer         AT00 321
ML=80#                                 Reset line length                AT00 322
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 AT00 323
movechar:(AT0,1,CHROT,2,NAT8+JC,1)#    Rule line beneath header         AT00 324
putline:#                              Write line                       AT00 325
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 AT00 326
putline:; putline:; putline:#          Output 3 spaces                  AT00 327
#                                                                       AT00 328
RETURN#                                                                 AT00 329
END#                                                                    AT00 330
systemheader:(AT10)#                   Format value and sigma           AT10   1
####################################################################    AT10   2
#                                                                       AT10   3
#                        AT10                                           AT10   4
#                                                                       AT10   5
####################################################################    AT10   6
SUBROUTINE AT10(NAME,N,VAL,SIG)#                                        AT10   7
include:(AACOMN)#                      S.r.hall  may 1989               AT10   8
#                                                                       AT10   9
REAL VAL,SIG,FMT,S#                                                     AT10  10
INTEGER J,N#                                                            AT10  11
string:(NAME,*)#                                                        AT10  12
#                                                                       AT10  13
NAME=' '#                              Blank output string              AT10  14
IF(SIG<=.000001)#                      Test if special value            AT10  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AT10  16
#                                                                       AT10  17
IF(ABS(N)<4&N>0) J=5#                  Precisn fixed non-h xyz          AT10  18
IF(ABS(N)>=4&N>0) J=4#                 Precisn fixed non-h u's          AT10  19
IF(ABS(N)<4&N<0) J=4#                  Precisn fixed hydrogen xyz       AT10  20
IF(ABS(N)>=4&N<0) J=3#                 Precisn fixed hydrogen u's       AT10  21
NAME(J+4^J+6)='(-)'#                   Insert noref parentheses         AT10  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AT10  23
ELSE#                                  Sigma is non-zero so output      AT10  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AT10  25
J=MIN(6,INT(-LOG10(SIG))+1)#           Get precision of sigma           AT10  26
S=SIG*FLOAT(10**J)#                    Get most significant digit       AT10  27
IF(J>0&S>9.49999)#                     Test for rounding-up problem     AT10  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AT10  29
S=MAX(1.,S*0.01);    J=J-1#            Reduce precision by one          AT10  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AT10  31
NAME(J+4^J+6)='( )'#                   Insert parentheses               AT10  32
ncodefld:(S,1,NAME,FLOAT((J+5)*10000+113),1)# Insert sigma digit        AT10  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AT10  34
FMT=FLOAT((J+3)*10100+J*10+2)#         Set output format                AT10  35
ncodefld:(VAL,1,NAME,FMT,1)#           Format parameter                 AT10  36
IF(ABS(N)<11&NAME(2^2)==' ') NAME(2^2)='0'# Insert leading zero         AT10  37
IF(ABS(N)<11&NAME(2^2)=='-') NAME(1^2)='-0'# Insert leading neg zero    AT10  38
#                                                                       AT10  39
RETURN#                                                                 AT10  40
END#                                                                    AT10  41
systemheader:(AT20)#                   Format the constraints           AT20   1
# ################################################################## #  AT20   2
#                                                                    #  AT20   3
#                               AT20                                 #  AT20   4
#                                                                    #  AT20   5
# ################################################################## #  AT20   6
SUBROUTINE AT20(IX,CH)#                                                 AT20   7
include:(AACOMN)#                                                       AT20   8
#                                                                       AT20   9
INTEGER IPAR,IX,K#                                                      AT20  10
string:(CH,11)#                                                         AT20  11
chardata:(AT21,  0   1/24 1/12 1/8  1/6  5/24 1/4  7/24 1/3  3/8 $#     AT20  12
 5/1211/24 1/2 13/24 7/12 5/8  2/3 17/24 3/4 19/24 5/6  7/8 11/12$#     AT20  13
23/24  1  25/2413/12 9/8  7/6 29/24 5/4 31/24 4/3  11/817/1235/24$#     AT20  14
 3/2 37/2419/12 13/8 5/3 41/24 7/4 43/24 11/6 15/823/1247/24  2  )#     AT20  15
chardata:(AT22,X  Y  Z  U11U22U33U12U13U23)#                            AT20  16
datastuff:#                                                             AT20  17
#                                                                       AT20  18
CH=' '#                                Blank the spec pos buffer        AT20  19
IPAR=NINT(QX(IX+2))#                   Pick up the parameter            AT20  20
IF(QX(IX+3)<2.0)#                      Is this related parameter        AT20  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AT20  22
K=(NINT(QX(IX+4))-1)*3+1#              Find reference symbol pointe     AT20  23
movechar:(AT22,K,CH,4,3,0)#            Insert ref param chrs 'x' etc    AT20  24
IF(ABS(QX(IX+5))>1.0)#                 If /multiplier/ > 2. insert      AT20  25
ncodefld:(QX(IX+5),1,CH,30213.,1)#     Format spec. posn.               AT20  26
ELSE IF(QX(IX+5)<0.0) CH(3^3)='-'#     Check for -1. multiplier         AT20  27
ELSE IF(QX(IX+5)>0.&QX(IX+5)<1.)#      Positive decimal                 AT20  28
ncodefld:(QX(IX+5),1,CH,30212.,1)#     Format value                     AT20  29
ifne:(QX(IX+7),0.)#                    Constant is not zero             AT20  30
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AT20  31
K=NINT(ABS(QX(IX+7))*24.)#             Convert to base 24               AT20  32
movechar:(AT21,K*5+2,CH,6,3,0)#        Insert fraction                  AT20  33
IF(QX(IX+7)>.1) CH(5^5)='+'#           Inset + fraction                 AT20  34
ELSE            CH(5^5)='-'#           Inset - fraction                 AT20  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AT20  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AT20  37
ELSE#                                  Make fixed values fractions      AT20  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AT20  39
K=NINT(ABS(QX(IX+7))*24.)#             Convert to base 24               AT20  40
movechar:(AT21,K*5+1,CH,3,5,0)#        Insert fraction                  AT20  41
IF(QX(IX+7)<0.) CH(2^2)='-'#           Insert if negative value         AT20  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AT20  43
#                                                                       AT20  44
RETURN#                                                                 AT20  45
END#                                                                    AT20  46
pmacro:([no:])#                                                         AT20  47
