systemheader:(BT    )#                                                  BT     1
####################################################################### BT     2
##      Copyright (C) 2000, The Xtal System, The University of        # BT     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # BT     4
## Distributed under the GNU General Public Licence as published by   # BT     5
## the Free Software Foundation, in the hope that it will be useful   # BT     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # BT     7
## for more details.                                                  # BT     8
#                                                                     # BT     9
#                           *** BONDAT ***                            # BT    10
#                                                                     # BT    11
#    BONDAT GENERATES THE COORDINATES OF AN ATOM WHOSE POSITION       # BT    12
#    CAN BE INFERRED FROM THE GEOMETRY OF THE STRUCTURE.              # BT    13
#                                                                     # BT    14
####################################################################### BT    15
#                                                                       BT    16
include:(XMACRO)#                                                       BT    17
#                                                                       BT    18
extrude:(BTCOMN)#                                                       BT    19
REAL G1,G2,G3,G5,G6,G9#                Coefficients to calculate di     BT    20
REAL DIST#                             Bond distance to gened atom      BT    21
REAL DPATOM#                           Displacement parameter value     BT    22
REAL RI(9)#                            Inverse metric tensor            BT    23
REAL SMLTST#                           Screen against div. overflow     BT    24
REAL ALPHA1,ALPHA2#                    Angles if required               BT    25
INTEGER ADR(7)#                        Pointers to generator atoms      BT    26
INTEGER CALTYP#                        Calculation type                 BT    27
INTEGER MARK2,STEP2,STOP2#             Markers for atoms in qx arra     BT    28
INTEGER UPDATE#                                                         BT    29
#                                                                       BT    30
COMMON/COMFBT/G1,G2,G3,G5,G6,G9,RI,DIST,SMLTST,DPATOM,ALPHA1,ALPHA2#    BT    31
COMMON/COMIBT/MARK2,STEP2,STOP2,ADR,CALTYP,UPDATE#                      BT    32
endext:#                                                                BT    33
#                                                                       BT    34
systemheader:(BT00)#                                                    BT00   1
######################################################################  BT00   2
#                                                                       BT00   3
#                                BT00                                   BT00   4
#                                                                       BT00   5
######################################################################  BT00   6
SUBROUTINE BT00#                       R. doherty 1980                  BT00   7
include:(AACOMN)#                      J.m. stewart 1983                BT00   8
include:(BTCOMN)#                      S.r.hall 1989                    BT00   9
#                                                                       BT00  10
FILEXT(IOUNIT(3))='XX1'#               Extension for scratch file       BT00  11
#                                                                       BT00  12
CALL BT10#                             Process bondat line              BT00  13
CALL BT15#                             Get cell and atom data           BT00  14
WHILE(CALTYP!=0)#                      Loop over calc. types            BT00  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT00  16
ALPHA1=0.0;ALPHA2=0.0#                 Initialize                       BT00  17
IF     (CALTYP==1) CALL BT25#          Linear case                      BT00  18
ELSE IF(CALTYP==2) CALL BT30#          Trigonal case                    BT00  19
ELSE IF(CALTYP==3\CALTYP==4) CALL BT35# Tetrahedral case                BT00  20
ELSE IF(CALTYP==5\CALTYP==6) CALL BT40# Squ.planar/oct.                 BT00  21
ELSE IF(CALTYP==7) CALL BT45#          Hexagonal case                   BT00  22
ELSE IF(CALTYP==8) CALL BT50#          General case                     BT00  23
ELSE IF(CALTYP==9) CALL BT55#          Methyne case                     BT00  24
ELSE IF(CALTYP==10)CALL BT70#          Trigonal terminal case           BT00  25
ELSE IF(CALTYP==11)CALL BT75#          Median methyne case              BT00  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT00  27
CALL BT60#                             Print summary of results         BT00  28
#                                                                       BT00  29
RETURN#                                                                 BT00  30
END#                                                                    BT00  31
systemheader:(BT02)#                                                    BT02   1
######################################################################  BT02   2
#                                                                       BT02   3
#                                BT02                                   BT02   4
#                                                                       BT02   5
######################################################################  BT02   6
SUBROUTINE BT02(A,B,C,D,E)#                                             BT02   7
include:(AACOMN)#                                                       BT02   8
include:(BTCOMN)#                                                       BT02   9
#                                                                       BT02  10
# THIS SUBROUTINE FINDS THE DIFFERENCE BETWEEN VECTORS A AND B, FINDS   BT02  11
# ITS MAGNITUDE, SCALES IT TO A DISTANCE D, AND ADDS IT TO VECTOR E     BT02  12
# AND STORES IT IN VECTOR C.                                            BT02  13
# DOHERTY 8/80                                                          BT02  14
#                                                                       BT02  15
REAL A(3),B(3)#                        Generator coords                 BT02  16
REAL C(3)#                             Generated atom coordinates       BT02  17
REAL E(3)#                             Coordinates of attachment po     BT02  18
REAL D#                                Distance of attachment           BT02  19
REAL DP#                               Distance between a and b         BT02  20
REAL DELX,DELY,DELZ#                   Diff in x,y, and z coords of     BT02  21
#                                                                       BT02  22
# FIND DISTANCE BETWEEN A AND B                                         BT02  23
#                                                                       BT02  24
DELX=A(1)-B(1)#                                                         BT02  25
DELY=A(2)-B(2)#                                                         BT02  26
DELZ=A(3)-B(3)#                                                         BT02  27
DP=G1*DELX**2+G5*DELY**2+G9*DELZ**2+G2*DELX*DELY+G3*DELX*DELZ$#         BT02  28
+G6*DELY*DELZ#                                                          BT02  29
#                                                                       BT02  30
# PROTECT AGAINST A NEGATIVE SQUARE ROOT AND VERY SMALL DISTANCES       BT02  31
#                                                                       BT02  32
IF(DP>=SMLTST) DP=SQRT(DP)#                                             BT02  33
ELSE IF(DP<0.0) iquit:(BT0201)#        -ve sqrt check input             BT02  34
ELSE            iquit:(BT0202)#        Generating atoms too close       BT02  35
#                                                                       BT02  36
# SCALE THE VECTOR (DELX,DELY,DELZ) TO DISTANCE D AND ADD TO COORDS OF  BT02  37
# POINT E TO GIVE COORDS OF THE GENERATED ATOM.                         BT02  38
#                                                                       BT02  39
C(1)= DELX*D/DP + E(1)#                                                 BT02  40
C(2)= DELY*D/DP + E(2)#                                                 BT02  41
C(3)= DELZ*D/DP + E(3)#                                                 BT02  42
#                                                                       BT02  43
RETURN#                                                                 BT02  44
END#                                                                    BT02  45
systemheader:(BT03)#                   Cross product a x b = c          BT03   1
######################################################################  BT03   2
#                                                                       BT03   3
#                               BT03                                    BT03   4
#                                                                       BT03   5
######################################################################  BT03   6
SUBROUTINE BT03(A,B,D)#                                                 BT03   7
include:(AACOMN)#                                                       BT03   8
include:(BTCOMN)#                                                       BT03   9
#                                                                       BT03  10
REAL A(3),B(3)#                        Generating coordinates           BT03  11
REAL D(3)#                             Generated coordinates            BT03  12
REAL V(3)#                                                              BT03  13
REAL C(3)#                                                              BT03  14
REAL DP#                                                                BT03  15
INTEGER N#                                                              BT03  16
#                                                                       BT03  17
# APPLY INVERSE METRIC TENSOR TO CROSS PRODUCT,C.                       BT03  18
#                                                                       BT03  19
C(1)=A(2)*B(3)-B(2)*A(3)#                                               BT03  20
C(2)=A(3)*B(1)-B(3)*A(1)#                                               BT03  21
C(3)=A(1)*B(2)-B(1)*A(2)#                                               BT03  22
DO N=1,3; V(N)=C(1)*RI(N)+C(2)*RI(N+3)+C(3)*RI(N+6)#                    BT03  23
#                                                                       BT03  24
# PROTECT AGAINST NEGATIVE SQ. ROOT AND VERY SMALL VECTORS              BT03  25
#                                                                       BT03  26
DP=G1*V(1)**2+G5*V(2)**2+G9*V(3)**2+G2*V(1)*V(2)+G3*V(1)*V(3)$#         BT03  27
+G6*V(2)*V(3)#                                                          BT03  28
IF(DP>=SMLTST) DP=SQRT(DP)#                                             BT03  29
ELSE IF(DP<0.0) iquit:(BT0301)#        -ve sqrt check input             BT03  30
ELSE            iquit:(BT0302)#        Generating atoms too close       BT03  31
DO N=1,3; D(N)=V(N)/DP#                                                 BT03  32
#                                                                       BT03  33
RETURN#                                                                 BT03  34
END#                                                                    BT03  35
systemheader:(BT06)#                   Read calcat and atom lines       BT06   1
#********************************************************************** BT06   2
#                                                                       BT06   3
#                                BT06                                   BT06   4
#                                                                       BT06   5
#********************************************************************** BT06   6
SUBROUTINE BT06#                       Doherty 1980                     BT06   7
include:(AACOMN)#                      Stewart 1983                     BT06   8
include:(BTCOMN)#                      Hall 1989                        BT06   9
#                                                                       BT06  10
string:(NAME,24);  string:(LABEL,24)#                                   BT06  11
INTEGER I,J,K,L,M#                     Local indices                    BT06  12
INTEGER NUMIN#                         Number of generator atoms        BT06  13
INTEGER NUMOT#                         Number of generated atoms        BT06  14
chardata:(B181, CALCAT END )#                                           BT06  15
chardata:(B182, LINEAR TRIGON TETCHN TETERM SQRPLN OCTHED HEXGNL $#     BT06  16
GENRAL METHYN TRTERM MEDIAN )#                                          BT06  17
chardata:(B184, CALCAT XXXXXX IS IGNORED.)#                             BT06  18
intdata:(CALIN,[2,3,3,3,3,3,3,3,4,3,4])#                                BT06  19
intdata:(CALOT,[1,1,2,3,2,4,3,1,1,2,1])#                                BT06  20
datastuff:#                                                             BT06  21
#                                                                       BT06  22
REPEAT#                                Loop over input lines            BT06  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT06  24
CALTYP=0#                              This is the end signal           BT06  25
readline:(B181,NB181)#                 Read another line                BT06  26
IF(LINID==2) RETURN#                   Exit if end line                 BT06  27
#                                      ******* calcat line *********    BT06  28
IF(BUFIN(1)>=voidflg:) iquit:(BT0601,1)# Calc type code missing         BT06  29
stringlim:(1,I,J)#                                                      BT06  30
compchar:(CHRIN,I,B182,2,6,7,NB182,CALTYP)# Identify calc type          BT06  31
IF(CALTYP!=0) BREAK#                   Exit when identified             BT06  32
movechar:(CHRIN,I,B184,9,6,0)#                                          BT06  33
writeline:(0,B184,NB184,3,3)#          Warn user of bad type            BT06  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT06  35
NUMIN=CALIN(CALTYP); NUMOT=CALOT(CALTYP)# Get atoms in and out          BT06  36
#                                                                       BT06  37
#  PROCESS THE CALCAT LINE                                              BT06  38
#  ______________________                                               BT06  39
#                                                                       BT06  40
IF(BUFIN(2)>0.01) DIST=BUFIN(2)#       Set attachment distance          BT06  41
ELSE              DIST=1.02#                                            BT06  42
DO K=1,NUMIN#                          Get input atoms                  BT06  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BT06  44
stringlim:(K+2,I,J)#                   Get label string limits          BT06  45
LABEL=CHRIP(I^J)#                      Store atom label                 BT06  46
FOR(I=MARK2;I<STOP2;I=I+STEP2)#        Loop over atom list              BT06  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BT06  48
movertoc:(QX(I+5),1,NAME,1,24,0)#      Extract atom label               BT06  49
IF(LABEL==NAME) BREAK#                 Exit on match                    BT06  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BT06  51
IF(I==STOP2) iquit:(BT0605,K+2)#       Unrecognised atom label          BT06  52
QX(I+4)=DIST#                          Store input distance             BT06  53
ADR(K)=I+1#                            Store address of x coord         BT06  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BT06  55
#                                                                       BT06  56
DO K=1,NUMOT#                          Loop over output atoms           BT06  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BT06  58
stringlim:(K+2+NUMIN,I,J)#             Get label string limits          BT06  59
LABEL=CHRIP(I^J)#                      Store atom label                 BT06  60
label:(LABEL,L,M)#                     Process atom label for labmax    BT06  61
FOR(I=MARK2;I<STOP2;I=I+STEP2)#        Loop over atom list              BT06  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BT06  63
movertoc:(QX(I+5),1,NAME,1,24,0)#      Extract atom label               BT06  64
IF(LABEL==NAME) BREAK#                 Exit on match                    BT06  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BT06  66
IF(I==STOP2)#                          This is a new atom label         BT06  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BT06  68
incrqx:(STOP2,I+STEP2,BT0610)#         Expand atom list                 BT06  69
movector:(LABEL,1,QX(I+5),1,24,0)#     Store new atom label             BT06  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BT06  71
QX(I+4)=DIST#                          Store input distance             BT06  72
ADR(K+NUMIN)=I+1#                      Store address of x coord         BT06  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BT06  74
#                                                                       BT06  75
RETURN#                                                                 BT06  76
END#                                                                    BT06  77
systemheader:(BT09)#                   Write data to scratch file       BT09   1
####################################################################### BT09   2
#                                                                       BT09   3
#                              BT09                                     BT09   4
#                                                                       BT09   5
####################################################################### BT09   6
SUBROUTINE BT09#                                                        BT09   7
include:(AACOMN)#                                                       BT09   8
include:(BTCOMN)#                                                       BT09   9
#                                                                       BT09  10
INTEGER I,IP#                                                           BT09  11
writepkt:(3,33,11,IP)#                 Point to next packet             BT09  12
QX(IP+1)=FLOAT(CALTYP)#                Store caltype                    BT09  13
DO I=1,7; QX(IP+I+1)=FLOAT(ADR(I))#    Store atom addresses             BT09  14
QX(IP+ 9)=DIST#                        Store atom distance              BT09  15
QX(IP+10)=ALPHA1#                      Store angle1                     BT09  16
QX(IP+11)=ALPHA2#                      Store angle2                     BT09  17
RETURN#                                                                 BT09  18
END#                                                                    BT09  19
systemheader:(BT10)#                                                    BT10   1
######################################################################  BT10   2
#                                                                       BT10   3
#                              BT10                                     BT10   4
#                                                                       BT10   5
######################################################################  BT10   6
SUBROUTINE BT10#                                                        BT10   7
include:(AACOMN)#                                                       BT10   8
include:(BTCOMN)#                                                       BT10   9
#                                                                       BT10  10
# THIS PROGRAM PUTS AWAY THE KEYS FROM THE =BONDAT= LINE                BT10  11
#                                                                       BT10  12
INTEGER K,J,I#                                                          BT10  13
chardata:(BT20,UF NU DP )#                                              BT10  14
chardata:(BT1C," Add new atoms to bdf with an isotropic U = X.XXX")#    BT10  15
datastuff:#                                                             BT10  16
#                                                                       BT10  17
# FIRST EXTRACT THE INFORMATION ENTERED IN THE =BONDAT= LINE. THE FIEL  BT10  18
# CONTAIN THE FOLLOWING KEYS                                            BT10  19
# VARIABLE                                                              BT10  20
#  UPDATE           VOID=DO NOT,  1=DO UPDATE THE BDF BY RESTREAMING    BT10  21
#  DPATOM           DISPLACEMENT PARM. FOR GENERATED ATOMS. IF THIS     BT10  22
#                   FIELD IS VOID A VALUE OF .038 WILL BE SUPPLIED FOR  BT10  23
#                                                                       BT10  24
UPDATE=no:#                            Assume no bdf update             BT10  25
DPATOM=0.038#                          Default u to 0.038               BT10  26
K = 0#                                 Scan input, starting in field    BT10  27
REPEAT#                                Loop over non-void input field   BT10  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT10  29
K = K + 1#                             Move on to next field            BT10  30
IF (BUFIN(K)>=voidflg:) BREAK#         Escape at first void field       BT10  31
stringlim:(K,I,J)#                     Find out which code this is      BT10  32
compchar:(CHRIN,I,BT20,1,2,3,NBT20,J)##                                 BT10  33
IF (J==0)  iquit:(BT1001,K)#           Unrecognizable code              BT10  34
ELSE IF (J==1) UPDATE = yes:#          Update bdf                       BT10  35
ELSE IF (J==3)#                        Expect disp. parm.  in next      BT10  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BT10  37
K = K + 1#                             Move counter to next field       BT10  38
ifnm:(BUFIN(K)) DPATOM = BUFIN(K)#     Pick up displ. parm to be used   BT10  39
ELSE iquit:(BT1002,K)#                 Register a complaint             BT10  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BT10  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT10  42
#                                                                       BT10  43
IF(UPDATE==yes:)#                                                       BT10  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BT10  45
ncodefld:(DPATOM,1,BT1C,490532.,1)#                                     BT10  46
writeline:(0,BT1C,NBT1C,3,3)#                                           BT10  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BT10  48
#                                                                       BT10  49
#                                                                       BT10  50
RETURN#                                                                 BT10  51
END#                                                                    BT10  52
systemheader:(BT12)#                                                    BT12   1
######################################################################  BT12   2
#                                                                       BT12   3
#                                BT12                                   BT12   4
#                                                                       BT12   5
######################################################################  BT12   6
SUBROUTINE BT12(A,B,D,E)#                                               BT12   7
include:(AACOMN)#                                                       BT12   8
include:(BTCOMN)#                                                       BT12   9
#                                                                       BT12  10
# THIS SUBROUTINE FINDS THE SCALAR PRODUCT THE VECTORS (A-E) AND        BT12  11
# (B-E) AND STORES THE RESULT IN D                                      BT12  12
# FLACK 2/90                                                            BT12  13
#                                                                       BT12  14
REAL A(3),B(3)#                        Generator coords                 BT12  15
REAL E(3)#                             Coordinates of attachment po     BT12  16
REAL D#                                Distance of attachment           BT12  17
REAL DELX1,DELY1,DELZ1,DELX2,DELY2,DELZ2# Vector coordinates            BT12  18
#                                                                       BT12  19
DELX1=A(1)-E(1);DELY1=A(2)-E(2);DELZ1=A(3)-E(3)#                        BT12  20
DELX2=B(1)-E(1);DELY2=B(2)-E(2);DELZ2=B(3)-E(3)#                        BT12  21
#                                                                       BT12  22
# FIND DOT PRODUCT BETWEEN A-E AND B-E                                  BT12  23
#                                                                       BT12  24
D=G1*DELX1*DELX2+G5*DELY1*DELY2+G9*DELZ1*DELZ2+0.5*$#                   BT12  25
(G2*(DELX1*DELY2+DELX2*DELY1)+G3*(DELX1*DELZ2+DELX2*DELZ1)+$#           BT12  26
G6*(DELY1*DELZ2+DELY2*DELZ1))#                                          BT12  27
RETURN#                                                                 BT12  28
END#                                                                    BT12  29
systemheader:(BT15)#                                                    BT15   1
####################################################################### BT15   2
#                                                                       BT15   3
#                              BT15                                     BT15   4
#                                                                       BT15   5
####################################################################### BT15   6
SUBROUTINE BT15#                                                        BT15   7
include:(AACOMN)#                                                       BT15   8
include:(BTCOMN)#                                                       BT15   9
#                                                                       BT15  10
#  THE MARK2 ARRAY CONTAINS THE FOLLOWING QUANTITIES.                   BT15  11
#  MARK2+1,2,3                   X,Y,Z                                  BT15  12
#  MARK2+4                       INTER ATOM DISTANCE                    BT15  13
#  MARK2+5                       ATOM NAME (24 CHARS)                   BT15  14
#                                                                       BT15  15
INTEGER IP#                                                             BT15  16
INTEGER PSIZ#                                                           BT15  17
INTEGER I,K,J,L,M#                                                      BT15  18
INTEGER KEY(4),WANT(13),IREL(12)#                                       BT15  19
REAL C(9),R(9)#                                                         BT15  20
REAL CF1,CF2,CF3,CF4,CF5,CF6,DETER#                                     BT15  21
#                                                                       BT15  22
string:(NAME,24);   string:(TEMP,24)#                                   BT15  23
chardata:(BT31," Input Atom Coordinates-")#                             BT15  24
chardata:(BT32,"   x/a      y/b      z/c")#                             BT15  25
chardata:(BT33, SITE END )#                                             BT15  26
realdata:(FMT,[952.,952.,952.])#                                        BT15  27
datastuff:#                                                             BT15  28
#                                                                       BT15  29
# ASSIGN MEMORY TO BUFFERS, ETC.                                        BT15  30
# ------------------------------                                        BT15  31
#                                                                       BT15  32
IOMARK(1)=QXSTR#                       Start of ip archive buffer       BT15  33
IOMARK(3)=QXSTR+bdfbuf:#               Start of scratch buffer          BT15  34
incrqx:(MARK2,IOMARK(3)+bdfbuf:,BT1505)# Get memory for buffers         BT15  35
STEP2=10;    STOP2=MARK2#              Initialize atom list             BT15  36
#                                                                       BT15  37
# READ THE CELL CONSTANTS FROM THE BDF                                  BT15  38
# -----------------------------------                                   BT15  39
#                                                                       BT15  40
readwpkt:(1,lrcell:,PSIZ,IP,0)#                                         BT15  41
movereal:(QX,IP+1,C,1,9,0)#                                             BT15  42
FOR(K=7;K<=9;K=K+1) C(K)=C(K)*360.#                                     BT15  43
#                                                                       BT15  44
# BUILD THE COEFFICIENTS FOR CALCULATING DISTANCES                      BT15  45
#                                                                       BT15  46
G1=C(1)*C(1)#                                                           BT15  47
G5=C(2)*C(2)#                                                           BT15  48
G9=C(3)*C(3)#                                                           BT15  49
G2=C(1)*C(2)*C(6)*2.#                                                   BT15  50
G3=C(1)*C(3)*C(5)*2.#                                                   BT15  51
G6=C(2)*C(3)*C(4)*2.#                                                   BT15  52
#                                                                       BT15  53
# FIND THE METRIC TENSOR AND CHECK FOR A REASONABLE CELL VOLUME         BT15  54
#                                                                       BT15  55
R(1)=G1#                                                                BT15  56
R(2)=G2/2.#                                                             BT15  57
R(3)=G3/2.#                                                             BT15  58
R(4)=R(2)#                                                              BT15  59
R(5)=G5#                                                                BT15  60
R(6)=G6/2.#                                                             BT15  61
R(7)=R(3)#                                                              BT15  62
R(8)=R(6)#                                                              BT15  63
R(9)=G9#                                                                BT15  64
CF1=R(5)*R(9)-R(6)*R(8)#                                                BT15  65
CF2=R(8)*R(3)-R(2)*R(9)#                                                BT15  66
CF3=R(2)*R(6)-R(5)*R(3)#                                                BT15  67
CF4=R(1)*R(9)-R(7)*R(3)#                                                BT15  68
CF5=R(4)*R(3)-R(1)*R(6)#                                                BT15  69
CF6=R(1)*R(5)-R(4)*R(2)#                                                BT15  70
DETER=R(1)*CF1+R(4)*CF2+R(7)*CF3#                                       BT15  71
IF(DETER<=729.) writeline:(1,BT33,NBT33,3,3)#                           BT15  72
SMLTST=AMAX1((.0001/DETER),mnfpnbr:)#  Make vector test                 BT15  73
#                                                                       BT15  74
# FORM THE RECIPROCAL METRIC TENSOR                                     BT15  75
#                                                                       BT15  76
RI(1)=CF1/DETER#                                                        BT15  77
RI(2)=CF2/DETER#                                                        BT15  78
RI(3)=CF3/DETER#                                                        BT15  79
RI(4)=RI(2)#                                                            BT15  80
RI(5)=CF4/DETER#                                                        BT15  81
RI(6)=CF5/DETER#                                                        BT15  82
RI(7)=RI(3)#                                                            BT15  83
RI(8)=RI(6)#                                                            BT15  84
RI(9)=CF6/DETER#                                                        BT15  85
#                                                                       BT15  86
# READ ATOM PARAMETERS                                                  BT15  87
# --------------------                                                  BT15  88
#                                                                       BT15  89
DO I=1,3; WANT(I)=I#                   Request x, y, z                  BT15  90
WANT(4)=14#                            Request atom label & type no.    BT15  91
KEY(1)=4; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 BT15  92
indexpkt:(1,lratom:,PSIZ,IP,0,KEY,WANT,IREL)#                           BT15  93
FOR(J=MARK2;J>0;J=STOP2)#              Read all atoms                   BT15  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT15  95
readwpkt:(1,lratom:,PSIZ,IP,0)#        Get atom packet                  BT15  96
IF(IP<=0) BREAK#                       Exit after last atom             BT15  97
incrqx:(STOP2,J+STEP2,BT1503)#         More memory please               BT15  98
K=IP+IREL(1);  QX(J+1)=QX(K)#          Store x coordinate               BT15  99
K=IP+IREL(2);  QX(J+2)=QX(K)#          Store y coordinate               BT15 100
K=IP+IREL(3);  QX(J+3)=QX(K)#          Store z coordinate               BT15 101
K=IP+IREL(4)#                          Pick up atom name                BT15 102
movertoc:(QX(K),1,CHROT,2,24,0)#       Atom name to output line         BT15 103
movector:(CHROT,2,QX(J+5),1,24,0)#     Move to mark2 section of qx      BT15 104
label:(CHROT(2^),L,M)#                 Process atom label               BT15 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT15 106
readwpkt:(1,endrecord:,PSIZ,IP,0)#     All done for today               BT15 107
#                                                                       BT15 108
# ENTER SITE LINES IF ANY                                               BT15 109
# -----------------------                                               BT15 110
#                                                                       BT15 111
REPEAT#                                Loop over input lines            BT15 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BT15 113
readline:(BT33,-NBT33)#                Read the next line               BT15 114
#                                                                       BT15 115
IF(LINID!=1) BREAK#                    Exit if not site line            BT15 116
#                                                                       BT15 117
stringlim:(1,J,K)#                     Get name limits                  BT15 118
NAME=CHRIP(J^K)#                       Extract atom label               BT15 119
label:(NAME,L,M)#                      Process atom label               BT15 120
FOR(J=MARK2;J<STOP2;J=J+STEP2)#        Loop over all atom sites         BT15 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BT15 122
movertoc:(QX(J+5),1,TEMP,1,24,0)#      Extract stored atom label        BT15 123
IF(NAME==TEMP) BREAK#                  Exit if match found              BT15 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BT15 125
IF(J>=STOP2)#                          Test if new site                 BT15 126
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BT15 127
incrqx:(STOP2,J+STEP2,BT1503)#         More memory please               BT15 128
movector:(NAME,1,QX(J+5),1,24,0)#      Store the atom label             BT15 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BT15 130
DO I=1,3; QX(J+I)=BUFIN(I+1)#          Store the new coordinates        BT15 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BT15 132
#                                                                       BT15 133
# LIST ATOM PARAMETERS                                                  BT15 134
# --------------------                                                  BT15 135
#                                                                       BT15 136
LINRM=6; movechar:(BT31,NBT31,CHROT,2,NBT31-2,1)# Insert underline      BT15 137
writeline:(1,BT31,NBT31-1,2,3); LINRM=3# Print atom list header         BT15 138
HEADOT=' '; HEADOT(LABMAX+5^)=BT32#    Store atom list header           BT15 139
FOR(J=MARK2;J<STOP2;J=J+STEP2)#        Loop atom list                   BT15 140
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BT15 141
movertoc:(QX(J+5),1,CHROT,2,24,0)#     Atom name to output line         BT15 142
LCHROT=LABMAX+2#                       Set format pointer               BT15 143
ncodefld:(QX,J+1,CHROT,FMT,3)#         X,y,z                            BT15 144
writeline:(0,HEADOT,100,1,3)#          Print input atoms                BT15 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BT15 146
CALL BT06#                             Read next line                   BT15 147
#                                                                       BT15 148
RETURN#                                                                 BT15 149
END#                                                                    BT15 150
systemheader:(BT25)#                   Linear case                      BT25   1
#*******************************************************************    BT25   2
#                                                                       BT25   3
#                                BT25                                   BT25   4
#                                                                       BT25   5
#*******************************************************************    BT25   6
SUBROUTINE BT25#                                                        BT25   7
include:(AACOMN)#                                                       BT25   8
include:(BTCOMN)#                                                       BT25   9
#                                                                       BT25  10
INTEGER K,J,I#                                                          BT25  11
#                                                                       BT25  12
WHILE (CALTYP==1)#                                                      BT25  13
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT25  14
I=ADR(1);  J=ADR(2);  K=ADR(3);ALPHA1=0.# Set rotation angle            BT25  15
CALL BT02(QX(I),QX(J),QX(K),DIST,QX(J))#                                BT25  16
CALL BT09#                             Write into scratch file          BT25  17
CALL BT06#                             Read next line                   BT25  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT25  19
#                                                                       BT25  20
RETURN#                                                                 BT25  21
END#                                                                    BT25  22
systemheader:(BT30)#                   Trigonal case                    BT30   1
#*******************************************************************    BT30   2
#                                                                       BT30   3
#                                BT30                                   BT30   4
#                                                                       BT30   5
#*******************************************************************    BT30   6
SUBROUTINE BT30#                                                        BT30   7
include:(AACOMN)#                                                       BT30   8
include:(BTCOMN)#                                                       BT30   9
#                                                                       BT30  10
INTEGER K,J,I#                                                          BT30  11
REAL DUMMY(9)#                         Scratch vectors                  BT30  12
REAL D#                                                                 BT30  13
#                                                                       BT30  14
WHILE(CALTYP==2)#                                                       BT30  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT30  16
DO K=7,9; DUMMY(K)=0.#                 Store zeroes for null vector     BT30  17
I=ADR(1);   J=ADR(2);    K=ADR(3)#                                      BT30  18
D=-1.0#                                                                 BT30  19
CALL BT02(QX(I),QX(J),DUMMY(1),D,DUMMY(7))#                             BT30  20
D=1.0#                                                                  BT30  21
CALL BT02(QX(K),QX(J),DUMMY(4),D,DUMMY(7))#                             BT30  22
K=ADR(4)#                                                               BT30  23
CALL BT02(DUMMY(1),DUMMY(4),QX(K),DIST,QX(J))#                          BT30  24
CALL BT09#                             Write result to scratch          BT30  25
CALL BT06#                             Read next line                   BT30  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT30  27
#                                                                       BT30  28
RETURN#                                                                 BT30  29
END#                                                                    BT30  30
systemheader:(BT35)#                   Tetrahedral cases                BT35   1
#*******************************************************************    BT35   2
#                                                                       BT35   3
#                                BT35                                   BT35   4
#                                                                       BT35   5
#*******************************************************************    BT35   6
SUBROUTINE BT35#                                                        BT35   7
include:(AACOMN)#                                                       BT35   8
include:(BTCOMN)#                                                       BT35   9
#                                                                       BT35  10
INTEGER H,I,J,K,L,M,N#                                                  BT35  11
REAL DP#                                                                BT35  12
REAL DUMMY(9)#                         Scratch vectors                  BT35  13
REAL D,CA1,SA1#                                                         BT35  14
REAL A(3),B(3),C(3)#                                                    BT35  15
realdata:(DTOR,0.017453)#                                               BT35  16
realdata:(TETFAC,0.70717);    datastuff:#                               BT35  17
#                                                                       BT35  18
WHILE(CALTYP==3\CALTYP==4)#                                             BT35  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT35  20
DO K=7,9; DUMMY(K)=0.#                 Store zeroes for null vector     BT35  21
I=ADR(1);  J=ADR(2);  K=ADR(3)#        Pointers to p1, p2, p3           BT35  22
IF(CALTYP==4)#                         Tetrahedral terminal             BT35  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BT35  24
L=ADR(4);  M=ADR(5);  N=ADR(6)#        Pointers to p4, p5, p6           BT35  25
IF (BUFIN(9)>(-359.99)) ALPHA1=BUFIN(9)*DTOR# Get rotation angle        BT35  26
ELSE                    ALPHA1=0.#                                      BT35  27
#CALL BT02(QX(J),QX(I),QX(N),DIST,QX(K))# P6 FOR ZERO ROTATION          BT35  28
##                                                                      BT35  29
DO H=1,3;DUMMY(H  )=QX(J+H-1)-QX(K+H-1)# (p2-p3) fractional coords      BT35  30
DO H=1,3;DUMMY(3+H)=QX(J+H-1)-QX(I+H-1)# (p2-p1) fractional coords      BT35  31
CALL BT03(DUMMY(1),DUMMY(4),C)#        (p2-p3)x(p2-p1) norm frac coor   BT35  32
CALL BT03(C,DUMMY(1),B)#               C x(p2-p3) norm frac coords      BT35  33
CALL BT03(B,C,A)#                      Normalised (p2-p3) frac coords   BT35  34
DO H=1,3;C(H)=DIST*(2.828427*B(H)-A(H))/3.# Scaled  cos 19b - sin19a    BT35  35
DO H=1,3;QX(N+H-1)=QX(K+H-1)+C(H)#     Ideal p6 zero rotate position    BT35  36
#                                                                       BT35  37
ifne:(ALPHA1,0.0)#                     Make a rotation about p2-p3      BT35  38
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BT35  39
CA1=COS(ALPHA1);SA1=SIN(ALPHA1)#       Cosine/sine (rotation angle)     BT35  40
CALL BT02(QX(N),QX(K),QX(L),DIST,DUMMY(7))# P6 - p3 in p4               BT35  41
D=1.0;CALL BT02(QX(K),QX(J),DUMMY(1),D,DUMMY(7))# Unit p3 - p2 in d1    BT35  42
CALL BT12(QX(L),DUMMY(1),DP,DUMMY(7))#                                  BT35  43
CALL BT02(QX(K),QX(J),DUMMY(4),DP,QX(K))# D4 at dp from p3 along p3-p   BT35  44
QX(N)=QX(N)-DUMMY(4)#                  Form in p6 vector p6-d4 and      BT35  45
QX(N+1)=QX(N+1)-DUMMY(5)#                                               BT35  46
QX(N+2)=QX(N+2)-DUMMY(6)#                                               BT35  47
CALL BT12(QX(N),QX(N),DP,DUMMY(7));DP=SQRT(DP)# Its length in dp        BT35  48
CALL BT03(QX(L),DUMMY(1),QX(L))#       Normal to p1 p2 p3 p6 d4         BT35  49
CALL BT02(QX(L),DUMMY(7),QX(L),DP,DUMMY(7))# With length dp             BT35  50
QX(N)=CA1*QX(N);QX(N+1)=CA1*QX(N+1);QX(N+2)=CA1*QX(N+2)# Scale cos p6   BT35  51
QX(L)=SA1*QX(L);QX(L+1)=SA1*QX(L+1);QX(L+2)=SA1*QX(L+2)# Scale sin p4   BT35  52
CALL BT02(QX(N),QX(L),QX(N),DP,DUMMY(4))#                               BT35  53
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BT35  54
I=J;J=K;K=N#                                                            BT35  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BT35  56
M=ADR(4)#                                                               BT35  57
D=1.0#                                                                  BT35  58
CALL BT02(QX(J),QX(I),DUMMY(1),D,DUMMY(7))#                             BT35  59
CALL BT02(QX(K),QX(J),DUMMY(4),D,DUMMY(7))#                             BT35  60
CALL BT02(DUMMY(1),DUMMY(4),QX(M),D,DUMMY(7))#                          BT35  61
CALL BT03(DUMMY(1),DUMMY(4),DUMMY(1))#                                  BT35  62
DO N=1,3; DUMMY(N+3)=-DUMMY(N)#        Make -ve unit x-vector           BT35  63
DO N=0,2; QX(M+N)=QX(M+N)*TETFAC#      Apply scalar x-product           BT35  64
N=ADR(5)#                                                               BT35  65
CALL BT02(QX(M),DUMMY(1),QX(N),DIST,QX(J))#                             BT35  66
CALL BT02(QX(M),DUMMY(4),QX(M),DIST,QX(J))#                             BT35  67
CALL BT09#                             Write result to scratch          BT35  68
CALL BT06#                             Read next line                   BT35  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT35  70
#                                                                       BT35  71
RETURN#                                                                 BT35  72
END#                                                                    BT35  73
systemheader:(BT40)#                   Square planar & octahedral       BT40   1
#*******************************************************************    BT40   2
#                                                                       BT40   3
#                                BT40                                   BT40   4
#                                                                       BT40   5
#*******************************************************************    BT40   6
SUBROUTINE BT40#                                                        BT40   7
include:(AACOMN)#                                                       BT40   8
include:(BTCOMN)#                                                       BT40   9
#                                                                       BT40  10
INTEGER K,M,N,J,I#                                                      BT40  11
REAL DUMMY(9)#                         Scratch vectors                  BT40  12
REAL D#                                                                 BT40  13
#                                                                       BT40  14
WHILE(CALTYP==5\CALTYP==6)#                                             BT40  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT40  16
DO K=7,9; DUMMY(K)=0.#                 Store zeroes for null vector     BT40  17
I=ADR(1);  J=ADR(2);  K=ADR(3)#                                         BT40  18
IF(CALTYP==6)#                                                          BT40  19
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BT40  20
D=1.0#                                                                  BT40  21
CALL BT02(QX(I),QX(J),DUMMY(1),D,DUMMY(7))#                             BT40  22
CALL BT02(QX(K),QX(J),DUMMY(4),D,DUMMY(7))#                             BT40  23
M=ADR(7)#                                                               BT40  24
CALL BT03(DUMMY(1),DUMMY(4),QX(M))#                                     BT40  25
N=ADR(6)#                                                               BT40  26
CALL BT02(QX(M),DUMMY(7),QX(N),DIST,QX(J))#                             BT40  27
CALL BT02(DUMMY(7),QX(M),QX(M),DIST,QX(J))#                             BT40  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BT40  29
#                                                                       BT40  30
M=ADR(4);   N=ADR(5)#                                                   BT40  31
CALL BT02(QX(J),QX(I),QX(M),DIST,QX(J))#                                BT40  32
CALL BT02(QX(J),QX(K),QX(N),DIST,QX(J))#                                BT40  33
CALL BT09#                             Write result to scratch          BT40  34
CALL BT06#                             Read input line                  BT40  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT40  36
#                                                                       BT40  37
RETURN#                                                                 BT40  38
END#                                                                    BT40  39
systemheader:(BT45)#                   Hexagonal case                   BT45   1
#*******************************************************************    BT45   2
#                                                                       BT45   3
#                                BT45                                   BT45   4
#                                                                       BT45   5
#*******************************************************************    BT45   6
SUBROUTINE BT45#                                                        BT45   7
include:(AACOMN)#                                                       BT45   8
include:(BTCOMN)#                                                       BT45   9
#                                                                       BT45  10
#                         I----N3                                       BT45  11
#                       /         \                                     BT45  12
#                      J           N2                                   BT45  13
#                       \         /                                     BT45  14
#                         K----N1                                       BT45  15
#                                                                       BT45  16
INTEGER K,M,N,J,I#                                                      BT45  17
REAL DUMMY(9)#                         Scratch vectors                  BT45  18
REAL D#                                                                 BT45  19
#                                                                       BT45  20
#                                                                       BT45  21
WHILE(CALTYP==7)#                                                       BT45  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT45  23
DO K=7,9; DUMMY(K)=0.#                 Store zeroes for null vector     BT45  24
D=1.0#                                                                  BT45  25
I=ADR(1);   J=ADR(2);    K=ADR(3)#                                      BT45  26
CALL BT02(QX(I),QX(J),DUMMY(1),D,DUMMY(7))#                             BT45  27
D=-1.0#                                                                 BT45  28
CALL BT02(QX(K),QX(J),DUMMY(4),D,DUMMY(7))#                             BT45  29
D=2.*DIST#                                                              BT45  30
M=ADR(5);    N=ADR(6)#                                                  BT45  31
CALL BT02(DUMMY(1),DUMMY(4),QX(M),D,QX(J))#                             BT45  32
CALL BT02(DUMMY(1),DUMMY(4),QX(N),DIST,QX(I))#                          BT45  33
N=ADR(4)#                                                               BT45  34
CALL BT02(DUMMY(1),DUMMY(4),QX(N),DIST,QX(K))#                          BT45  35
CALL BT09#                             Write result to scratch          BT45  36
CALL BT06#                             Read next line                   BT45  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT45  38
#                                                                       BT45  39
RETURN#                                                                 BT45  40
END#                                                                    BT45  41
systemheader:(BT50)#                   General case                     BT50   1
#*******************************************************************    BT50   2
#                                                                       BT50   3
#                                BT50                                   BT50   4
#                                                                       BT50   5
#*******************************************************************    BT50   6
SUBROUTINE BT50#                                                        BT50   7
include:(AACOMN)#                                                       BT50   8
include:(BTCOMN)#                                                       BT50   9
#                                                                       BT50  10
INTEGER K,N,J,I#                                                        BT50  11
#REAL ALPHA1,ALPHA2#                                                    BT50  12
REAL CA1,CA2,SA1,SA2#                  Cosines and sines of project     BT50  13
REAL DUMMY(9)#                         Scratch vectors                  BT50  14
REAL D#                                                                 BT50  15
realdata:(DTOR,0.017453);    datastuff:#                                BT50  16
#                                                                       BT50  17
WHILE(CALTYP==8)#                                                       BT50  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT50  19
DO K=7,9; DUMMY(K)=0.#                 Store zeroes for null vector     BT50  20
IF(BUFIN(7)>(-359.99)) ALPHA1=BUFIN(7)*DTOR#                            BT50  21
ELSE                   ALPHA1=0.#                                       BT50  22
IF(BUFIN(8)>(-359.99)) ALPHA2=BUFIN(8)*DTOR#                            BT50  23
ELSE                   ALPHA2=0.#                                       BT50  24
CA1=-COS(ALPHA1);  SA1=-SIN(ALPHA1)#                                    BT50  25
CA2=COS(ALPHA2);   SA2=SIN(ALPHA2)#                                     BT50  26
#                                                                       BT50  27
# FIND UNIT VECTORS P1-P2 AND P3-P2 FROM ORIGIN                         BT50  28
#                                                                       BT50  29
I=ADR(1);   J=ADR(2);   K=ADR(3)#                                       BT50  30
D=1.0#                                                                  BT50  31
CALL BT02(QX(I),QX(J),DUMMY(1),D,DUMMY(7))#                             BT50  32
CALL BT02(QX(K),QX(J),DUMMY(4),D,DUMMY(7))#                             BT50  33
#                                                                       BT50  34
# PLACE CROSS PRODUCT (1) IN NEW ATOM'S PLACE TEMPORARILY               BT50  35
#                                                                       BT50  36
K=ADR(4)#                                                               BT50  37
CALL BT03(DUMMY(4),DUMMY(1),QX(K))#                                     BT50  38
#                                                                       BT50  39
# PLACE CROSS PRODUCT(2) IN FIRST DUMMY VECTOR                          BT50  40
#                                                                       BT50  41
CALL BT03(QX(K),DUMMY(4),DUMMY(1))#                                     BT50  42
#                                                                       BT50  43
# ADJUST CP2 AND P2-P3 BY SCALERS                                       BT50  44
#                                                                       BT50  45
DO N=1,3; DUMMY(N)=SA1*DUMMY(N)#                                        BT50  46
DO N=4,7; DUMMY(N)=CA1*DUMMY(N)#                                        BT50  47
#                                                                       BT50  48
# GET UNIT VECTOR IN PLANE OF P1-P2-P3 AT ANGLE ALPHA1 FROM P2-P3       BT50  49
#                                                                       BT50  50
D=1.0#                                                                  BT50  51
CALL BT02(DUMMY(1),DUMMY(4),DUMMY(1),D,DUMMY(7))#                       BT50  52
#                                                                       BT50  53
# ADJUST CP1 AND VECTOR IN PLANE                                        BT50  54
#                                                                       BT50  55
DO N=1,3; DUMMY(N)=CA2*DUMMY(N)#                                        BT50  56
FOR(N=K;N<=(K+2);N=N+1)#                                                BT50  57
QX(N)=SA2*QX(N)#                                                        BT50  58
CALL BT02(DUMMY(1),QX(K),QX(K),DIST,QX(J))# Get resultant vector        BT50  59
CALL BT09#                             Write result to scratch          BT50  60
CALL BT06#                             Get next line                    BT50  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT50  62
#                                                                       BT50  63
RETURN#                                                                 BT50  64
END#                                                                    BT50  65
systemheader:(BT55)#                   Methyne case                     BT55   1
#*******************************************************************    BT55   2
#                                                                       BT55   3
#                                BT55                                   BT55   4
#                                                                       BT55   5
#*******************************************************************    BT55   6
SUBROUTINE BT55#                                                        BT55   7
include:(AACOMN)#                                                       BT55   8
include:(BTCOMN)#                                                       BT55   9
#                                                                       BT55  10
INTEGER K,M,N,J,I#                                                      BT55  11
REAL DUMMY(9)#                         Scratch vectors                  BT55  12
REAL D#                                                                 BT55  13
chardata:(B113, AN INTERATOMIC DISTANCE IS TOO SHORT.)#                 BT55  14
datastuff:#                                                             BT55  15
#                                                                       BT55  16
WHILE(CALTYP==9)#                                                       BT55  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT55  18
DO K=7,9; DUMMY(K)=0.#                 Store zeroes for null vector     BT55  19
I=ADR(1);  J=ADR(2);  K=ADR(3);  M=ADR(4)#                              BT55  20
D=1.0#                                                                  BT55  21
CALL BT02(QX(I),QX(J),DUMMY(1),D,DUMMY(7))#                             BT55  22
CALL BT02(QX(I),QX(K),DUMMY(4),D,DUMMY(7))#                             BT55  23
K=ADR(5)#                                                               BT55  24
CALL BT02(QX(I),QX(M),QX(K),D,DUMMY(7))#                                BT55  25
#                                                                       BT55  26
# SUM THREE VECTORS                                                     BT55  27
#                                                                       BT55  28
QX(K  )=QX(K  )+DUMMY(1)+DUMMY(4)#                                      BT55  29
QX(K+1)=QX(K+1)+DUMMY(2)+DUMMY(5)#                                      BT55  30
QX(K+2)=QX(K+2)+DUMMY(3)+DUMMY(6)#                                      BT55  31
#                                                                       BT55  32
# CHECK FOR REASONABLE VECTOR MAGNITUDE                                 BT55  33
#                                                                       BT55  34
D=G1*QX(K)**2+G5*QX(K+1)**2+G9*QX(K+2)**2+G2*QX(K)$#                    BT55  35
*QX(K+1)+G3*QX(K)*QX(K+2)+G6*QX(K+1)*QX(K+2)#                           BT55  36
IF(D<=0.00001)#                                                         BT55  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BT55  38
writeline:(1,B113,NB113,3,3)#                                           BT55  39
writeline:(0,CHRIN,80,3,3)#                                             BT55  40
D=1.#                                  If an error occurs, set d=1.     BT55  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BT55  42
D=SQRT(D)#                                                              BT55  43
#                                                                       BT55  44
# SCALE VECTOR LENGTH TO DIST AND ADD TO POINT OF ATTACHMENT            BT55  45
#                                                                       BT55  46
N=ADR(5)#                                                               BT55  47
DO M=1,3#                                                               BT55  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BT55  49
QX(N)=QX(N)*DIST/D+QX(I)#                                               BT55  50
I=I+1;   N=N+1#                                                         BT55  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BT55  52
CALL BT09#                             Write result to scratch          BT55  53
CALL BT06#                             Read next line                   BT55  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT55  55
#                                                                       BT55  56
RETURN#                                                                 BT55  57
END#                                                                    BT55  58
systemheader:(BT60)#                   Read scratch & op summary        BT60   1
#*********************************************************************# BT60   2
#                                                                     # BT60   3
#                               BT60                                  # BT60   4
#                                                                     # BT60   5
#*********************************************************************# BT60   6
SUBROUTINE BT60#                                                        BT60   7
include:(AACOMN)#                                                       BT60   8
include:(BTCOMN)#                                                       BT60   9
#                                                                       BT60  10
INTEGER H,I,J,K,L,M,N,NUMIN,NUMOT#                                      BT60  11
INTEGER PAKSIZ#                        No. of items in file packet      BT60  12
INTEGER IPT#                           Pointer to file packet           BT60  13
REAL    Z#                                                              BT60  14
#                                                                       BT60  15
chardata:(B121," Generated Atom Coordinates-")#                         BT60  16
chardata:(B122,"x/a      y/b      z/c     type   dist  attached atoms")#BT60  17
chardata:(B123,LINEAR TRIGON TETCHN TETERM SQRPLN OCTHED HEXGNL $#      BT60  18
GENRAL METHYN TRTERM MEDIAN )#                                          BT60  19
realdata:(FMT,[952.,952.,952.,1522.])#                                  BT60  20
intdata:(CATIN,[2,3,3,3,3,3,3,3,4,3,4])#                                BT60  21
intdata:(CATOT,[1,1,2,3,2,4,3,1,1,2,1])#                                BT60  22
string:(LINE,80)#                                                       BT60  23
string:(LINE1,200)#                                                     BT60  24
string:(LINE2,100)#                                                     BT60  25
datastuff:#                                                             BT60  26
#                                                                       BT60  27
#     OUTPUT ADDATM LINES AND FORCE EXECUTION (IF NECESSARY)            BT60  28
#     ------------------------------------------------------            BT60  29
#                                                                       BT60  30
IF(UPDATE==yes:)#                      Force addatm                     BT60  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT60  32
FILEXT(iofm1:)='adi'#                  Define fmt as atom line file     BT60  33
openfmt:(iofm1:,' ')#                  Open atom line file              BT60  34
LINE='ADDATM UPD MIXED'#               Reset line buffer                BT60  35
writefmt:(iofm1:,'(A)',LINE(1^16))#    Write addatm header to file      BT60  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT60  37
#                                                                       BT60  38
# LOOP OVER ALL THE PACKETS ON THE SCRATCH FILE                         BT60  39
# ---------------------------------------------                         BT60  40
#                                                                       BT60  41
PAKSIZ=0#                              Initialize variable              BT60  42
writepkt:(3,endrecord:,PAKSIZ,I)#      Finish off scratch               BT60  43
movechar:(B121,NB121,CHROT,2,NB121-2,1)# Insert underline               BT60  44
writeline:(1,B121,NB121-1,2,3); LINRM=3# Print header                   BT60  45
HEADOT=' '; HEADOT(LABMAX+8^)=B122#    Setup headers                    BT60  46
#                                                                       BT60  47
REPEAT#                                Loop for all calcat's            BT60  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BT60  49
readwpkt:(3,33,PAKSIZ,IPT,0)#          Read scratch file                BT60  50
IF(IPT<=0) BREAK#                      Exit when complete               BT60  51
I=NINT(QX(IPT+1))#                     Find calculation type            BT60  52
NUMIN=CATIN(I);  NUMOT=CATOT(I)#       Get atoms input & output         BT60  53
#                                                                       BT60  54
LINE2=' ';H=1#                         Reconstruct the calcat line      BT60  55
DO N=1,NUMOT#                          List each new atom               BT60  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BT60  57
L=NINT(QX(IPT+NUMIN+N+1))-1#           Get stored address               BT60  58
movertoc:(QX(L+5),1,LINE2,H,24,0)#     Transfer atom name               BT60  59
H=H+LABMAX+1#                          Incr label pointer               BT60  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BT60  61
#                                                                       BT60  62
DO N=1,NUMOT#                          List each new atom               BT60  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BT60  64
L=NINT(QX(IPT+NUMIN+N+1))-1#           Get stored address               BT60  65
LCHROT=LABMAX+2#                       Set format pointer               BT60  66
movertoc:(QX(L+5),1,CHROT,2,24,0)#     Transfer atom name               BT60  67
ncodefld:(QX,L+1,CHROT,FMT,4)#         Format coords and dist           BT60  68
movechar:(B123,I*7-6,CHROT,LABMAX+33,6,0)# Insert calc type             BT60  69
M=LABMAX+48#                           Set addon char pointer           BT60  70
DO J=1,NUMIN#                          Loop each input atom             BT60  71
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BT60  72
K=NINT(QX(IPT+J+1))-1#                 Get atom list address            BT60  73
movertoc:(QX(K+5),1,CHROT,M,24,0)#     Get atom name                    BT60  74
M=M+LABMAX+1#                          Incr label pointer               BT60  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BT60  76
LINE1=' '#                             Initialize the line              BT60  77
LINE1='link '//CHROT(2^2+LABMAX)#      Encode link and atom label       BT60  78
LINE1(8+LABMAX^)=B123(I*7-6^I*7)//'         '//CHROT(LABMAX+48^M)#      BT60  79
Z=FLOAT(22+LABMAX)*10000.+732.#        Format for bondlength        ^   BT60  80
ncodefld:(QX,IPT+9,LINE1,Z,1)#         Encode bond length               BT60  81
J=22+M-48+1#                                                            BT60  82
LINE1(J+1^)=LINE2#                     Copy covariant atoms             BT60  83
Z=FLOAT(J+8+H)*10000.+822.#            Point to end of angle            BT60  84
IF(I==4\I==8\I==1)ncodefld:(QX,IPT+10,LINE1,Z,1)# Add angle1            BT60  85
IF(I==8)#                              Only for a general atom          BT60  86
$(Z=Z+80000.;ncodefld:(QX,IPT+11,LINE1,Z,1)$)# Add 8 chars for genral   BT60  87
writeline:(0,HEADOT,100,1,3)#          Print results                    BT60  88
#                                                                       BT60  89
CHROT='atom '#                         Initializr punch buffer          BT60  90
movertoc:(QX(L+5),1,CHROT,6,24,0)#     Name of atom                     BT60  91
LCHROT=LABMAX+6#                       Set format pointer               BT60  92
ncodefld:(QX,L+1,CHROT,FMT,3)#         X,y,z                            BT60  93
ncodefld:(DPATOM,1,CHROT,932.,1)#      Insert average u                 BT60  94
IF (UPDATE==yes:) writefmt:(iofm1:,'(A80)',CHROT)# Write to file        BT60  95
ELSE writepch:(CHROT,80)#              Punch the line                   BT60  96
CHROT=' '#                             Blank the output buffer          BT60  97
#                                                                       BT60  98
FOR(K=1;K<=200;K=K+1)#                 Compress white space             BT60  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BT60 100
IF(LINE1(K^K)!=' ')NEXT#               Skip white space                 BT60 101
DO J=K+1,200;IF(LINE1(J^J)!=' ')BREAK# Find next nonblank               BT60 102
IF(J>=200)BREAK#                       Hit end of string                BT60 103
LINE1(K+1^)=LINE1(J^)#                 Copy remaindr back with 1 spac   BT60 104
K=J#                                   Update                           BT60 105
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BT60 106
IF(UPDATE==yes:)writefmt:(iofm1:,'(A)',LINE1(1^K))# Write to file       BT60 107
#                                                                       BT60 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BT60 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BT60 110
readwpkt:(3,endrecord:,I,IPT,0)#       Close off scratch file           BT60 111
#                                                                       BT60 112
IF(UPDATE==yes:)#                      Finish of stream                 BT60 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BT60 114
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  If next input line is not end    BT60 115
#                                      And not an eof                   BT60 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BT60 117
LINFLG=1; LINE=CHRIP#                  Ensure this line not lost        BT60 118
writefmt:(iofm1:,'(A)',LINE(1^44))#    Write header to file             BT60 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BT60 120
closefmt:(iofm1:)#                     Shut down the line file          BT60 121
linestream:('adi')#                    Insert file into line stream     BT60 122
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BT60 123
RETURN#                                                                 BT60 124
END#                                                                    BT60 125
systemheader:(BT70)#                   Terminal trigonal case           BT70   1
#*******************************************************************    BT70   2
#                                                                       BT70   3
#                                BT70                                   BT70   4
#                                                                       BT70   5
#*******************************************************************    BT70   6
SUBROUTINE BT70#                                                        BT70   7
include:(AACOMN)#                                                       BT70   8
include:(BTCOMN)#                                                       BT70   9
#                                                                       BT70  10
INTEGER L,K,J,I#                                                        BT70  11
REAL DUMMY(9)#                         Scratch vectors                  BT70  12
REAL D#                                                                 BT70  13
#                                                                       BT70  14
#  TERMINAL TRIGONAL MEANS THREE ATOMS IN - TWO NEW ONES GENERATED      BT70  15
#  -----------------------------------------------------                BT70  16
#                                                                       BT70  17
WHILE (CALTYP==10)#                                                     BT70  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT70  19
DO K=7,9; DUMMY(K)=0.#                 Store zeroes for null vector     BT70  20
I=ADR(1); J=ADR(2); K=ADR(3); L=ADR(4)# Atom pointers                   BT70  21
CALL BT02(QX(J),QX(I),QX(L),DIST,QX(K))#                                BT70  22
D=1.0;   L=ADR(5)#                     Length and pointer               BT70  23
CALL BT02(QX(I),QX(J),DUMMY(1),D,DUMMY(7))#                             BT70  24
CALL BT02(QX(K),QX(J),DUMMY(4),D,DUMMY(1))#                             BT70  25
CALL BT02(DUMMY(4),DUMMY(7),QX(L),DIST,QX(K))#                          BT70  26
CALL BT09#                             Write result to scratch          BT70  27
CALL BT06#                             Read next line                   BT70  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT70  29
#                                                                       BT70  30
RETURN#                                                                 BT70  31
END#                                                                    BT70  32
systemheader:(BT75)#                   Median methylene case            BT75   1
#*******************************************************************    BT75   2
#                                                                       BT75   3
#                                BT75                                   BT75   4
#                                                                       BT75   5
#*******************************************************************    BT75   6
SUBROUTINE BT75#                                                        BT75   7
include:(AACOMN)#                                                       BT75   8
include:(BTCOMN)#                                                       BT75   9
#                                                                       BT75  10
INTEGER K,M,J,I#                                                        BT75  11
INTEGER I1,J1#                                                          BT75  12
REAL DUMMY(9)#                         Scratch vectors                  BT75  13
REAL DUM1(3,3), DUM2(3,3)#             Scratch matrices                 BT75  14
REAL D,DMAT#                                                            BT75  15
datastuff:#                                                             BT75  16
#                                                                       BT75  17
WHILE (CALTYP==11)#                                                     BT75  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BT75  19
DO K=1,9; DUMMY(K)=0.#                 Store zeroes for dummy vector    BT75  20
I=ADR(1); J=ADR(2); K=ADR(3); M=ADR(4)# Get atom addresses              BT75  21
D=1.0#                                                                  BT75  22
CALL BT02(QX(I),QX(J),DUM1(1,1),D,DUMMY(7))#                            BT75  23
CALL BT02(QX(I),QX(K),DUM1(1,2),D,DUMMY(7))#                            BT75  24
CALL BT02(QX(I),QX(M),DUM1(1,3),D,DUMMY(7))#                            BT75  25
#                                                                       BT75  26
# INVERT THE MATRIX DUM1 USING DUM2 AND PREMULTIPLY BY (1,1,1)          BT75  27
# INTO DUMMY(1)                                                         BT75  28
#                                                                       BT75  29
DUM2(1,1)=DUM1(2,2)*DUM1(3,3)-DUM1(2,3)*DUM1(3,2)#                      BT75  30
DUM2(2,1)=-(DUM1(2,1)*DUM1(3,3)-DUM1(2,3)*DUM1(3,1))#                   BT75  31
DUM2(3,1)=DUM1(2,1)*DUM1(3,2)-DUM1(2,2)*DUM1(3,1)#                      BT75  32
DUM2(1,2)=-(DUM1(1,2)*DUM1(3,3)-DUM1(1,3)*DUM1(3,2))#                   BT75  33
DUM2(2,2)=DUM1(1,1)*DUM1(3,3)-DUM1(1,3)*DUM1(3,1)#                      BT75  34
DUM2(3,2)=-(DUM1(1,1)*DUM1(3,2)-DUM1(1,2)*DUM1(3,1))#                   BT75  35
DUM2(1,3)=DUM1(1,2)*DUM1(2,3)-DUM1(1,3)*DUM1(2,2)#                      BT75  36
DUM2(2,3)=-(DUM1(1,1)*DUM1(2,3)-DUM1(1,3)*DUM1(2,1))#                   BT75  37
DUM2(3,3)=DUM1(1,1)*DUM1(2,2)-DUM1(1,2)*DUM1(2,1)#                      BT75  38
DMAT=DUM1(1,1)*DUM2(1,1)+DUM1(1,2)*DUM2(2,1)+DUM1(1,3)*DUM2(3,1)#       BT75  39
DO I1=1,3;DO J1=1,3;DUMMY(J1)=DUMMY(J1)+DUM2(I1,J1)/DMAT#               BT75  40
DO I1=1,3;DO J1=1,3;DUMMY(J1+3)=DUMMY(J1+3)+DUMMY(I1)*RI(I1+3*J1-3)#    BT75  41
#                                                                       BT75  42
M=ADR(5)#                                                               BT75  43
CALL BT02(DUMMY(4),DUMMY(7),QX(M),DIST,QX(I))#                          BT75  44
CALL BT09#                             Write result to scratch          BT75  45
CALL BT06#                             Read next line                   BT75  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BT75  47
#                                                                       BT75  48
RETURN#                                                                 BT75  49
END#                                                                    BT75  50
pmacro:([no:])#                                                         BT75  51
