systemheader:(FR    )#                                                  FR     1
####################################################################    FR     2
##      Copyright (C) 2000, The Xtal System, The University of        # FR     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # FR     4
## Distributed under the GNU General Public Licence as published by   # FR     5
## the Free Software Foundation, in the hope that it will be useful   # FR     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # FR     7
## for more details.                                                  # FR     8
#                                                                  #    FR     9
#                         ***** RMAP *****                         #    FR    10
#                                                                  #    FR    11
#    THE PROGRAM RMAP IS USED TO CALCULATE 1/R FACTOR MAPS,        #    FR    12
#    FO*FC CORRELATION MAPS, OR LINEAR COMBINATIONS OF 1/R         #    FR    13
#    FO*FC CORRELATIONS.  THE MAPS WILL SHOW A MAXIMUM AT THE      #    FR    14
#    OPTIMUM TRASLATIONAL POSITION OF A FRAGMENT IN THE UNIT CELL. #    FR    15
#    THE GUTS OF THE PROGRAM WERE WRITTEN BY WILLIAM FUREY         #    FR    16
#    AT THE VETRANS ADMINISTRATION MEDICAL CENTER AND UNIV. OF     #    FR    17
#    PITTSBURG, DEPT OF CRYSTALLOGRAPY IN SEPTEMBER 1983. THIS     #    FR    18
#    XTAL ADAPTATION IS MADE BY J. STEWART WITH W.F.'S PERMISSION. #    FR    19
#    DECEMBER 1987,  NAVAL RESEARCH LAB. WASHINGTON D.C.           #    FR    20
#    THE PROGRAM IS INTENDED TO COMPUTE R VALUES AND CORRELATION   #    FR    21
#    COEFFICIENTS BASED ON STRUCTURE FACTORS FROM A FRAGMENT OF    #    FR    22
#    A MOLECULE.  A GRID IS ESTABLISHED OVER THE UNIT CELL AND     #    FR    23
#    MAP OF THE 1/R VALUES/CORRELATION COEFFICIENTS AS A FUNCTION  #    FR    24
#    OF THE TRANSLATION OF THE FRAGMENT IS PRODUCED.  THE ATOMS    #    FR    25
#    TREATED MAY BE DIVIDED INTO TWO SUBGROUPS; ONE OF WHICH IS    #    FR    26
#    TRANSLATED DURING THE STRUCTURE FACTOR CALCULATION AND,       #    FR    27
#    OPTIONALLY, ONE OF WHICH IS HELD IN A FIXED POSITION.         #    FR    28
#                                                                  #    FR    29
####################################################################    FR    30
#                                                                       FR    31
include:(XMACRO)#                                                       FR    32
#                                                                       FR    33
macro:(mxwd8c:,incr:(arith:(7,/,mxchwd:)))#                             FR    34
#                                                                       FR    35
extrude:(FRCOMN)#                                                       FR    36
REAL UOVL#                             Overall tf                       FR    37
REAL CELCON(6)#                        A,b,c,cos(a),cos(b),cos(g)       FR    38
INTEGER CENT#                          Centro flag                      FR    39
REAL FTHRSH#                           F obs threshold for rejection    FR    40
REAL DLIS#                             Delta(f) listing control         FR    41
REAL DSTL#                             Delta st/l for ff table          FR    42
REAL DSNM#                             Data set number                  FR    43
REAL FMUL#                             S.f. multiplicity                FR    44
INTEGER IATM#                          Atom list increment              FR    45
INTEGER IFFF#                          Refl form factor flag            FR    46
INTEGER IP,JP#                         Working ip/op pointers           FR    47
INTEGER INCX(3)#                       Increments in map grid           FR    48
INTEGER ISCF#                          Step in ff name list             FR    49
INTEGER ISIN#                          Sin/cos lookup flag              FR    50
INTEGER IREL(67)#                      Relative packet pointers         FR    51
INTEGER IRF,IRF2,IRH,IRJ,IRL,IRS,IRX#  Relative pointers for lrrefl:    FR    52
INTEGER IWNT(66)#                      Want list of idnums              FR    53
INTEGER KEY(4)#                        Indexpkt control signals         FR    54
INTEGER LPAK#                          Input packet length              FR    55
INTEGER MAPOUT#                        Signal for map printing yes/no   FR    56
INTEGER MARK1#                         Start-1 of sym matrices          FR    57
INTEGER MARK2#                         Start-1 of ff name list          FR    58
INTEGER MARK3#                         Start-1 of scatfac table         FR    59
INTEGER MARK4#                         Start-1 of scale list            FR    60
INTEGER MARK5#                         Start-1 of select list           FR    61
INTEGER MARK6#                         Start-1 of atoms list            FR    62
INTEGER MARK7#                         Start-1 of sin/cos table         FR    63
INTEGER MARKR#                         Start-1 of r sums array          FR    64
REAL MAXH,MAXK,MAXL#                   Maximum /h/,/k/,/l/              FR    65
INTEGER MODREF#                        Control use of reflections       FR    66
INTEGER MODTHR#                        By modulus of reflection count   FR    67
INTEGER NAME#                          Qx step for select list          FR    68
INTEGER NATM#                          Count number of atoms            FR    69
INTEGER NATM1#                         Atoms in translating subgrp      FR    70
INTEGER NATM2#                         Atoms in fixed position subgrp   FR    71
INTEGER NEUT#                          Radiation type flag              FR    72
INTEGER NDEL#                          Extra items in op packet         FR    73
INTEGER NG(3)#                         Number of grid points, sum ord   FR    74
INTEGER NGRX,NGRY,NGRZ#                Number of grid points in x,y&z   FR    75
INTEGER NLIS#                          Number of reflections to dump    FR    76
INTEGER NMDS#                          Data set number *1000            FR    77
INTEGER NPAK#                          Output packet length             FR    78
INTEGER NP(3)#                         Number of points in output map   FR    79
INTEGER NROT#                          Number of rotation matrices      FR    80
INTEGER NSCF#                          Length of ff table               FR    81
INTEGER NSCL#                          Number of scale groups           FR    82
INTEGER NTYP#                          Number of atom types             FR    83
INTEGER OFF(10)#                       Ff table offsets                 FR    84
INTEGER ORGX(3)#                       Origins in map grid              FR    85
REAL REGPAR(9)#                        Region of unit cell to search    FR    86
REAL REJF#                             Reject code flag                 FR    87
REAL SMAX,SMIN#                        Max/min st/l limits              FR    88
REAL SMFOFC#                           Sum of f(calc)*f(obs)            FR    89
INTEGER STEPR#                         No. of items per r value         FR    90
INTEGER STOPR#                         End of r value array in qx       FR    91
REAL SUMFC2#                           Sum of f(calc)**2                FR    92
REAL SUMFO#                            Sum of scaled f(rel) f(obs)      FR    93
REAL SUMFR2#                           Sum of f(obs)**2                 FR    94
INTEGER TYPE#                          Temp. factor type                FR    95
REAL WEIGHT#                           Wgt to proportion between r      FR    96
#                                      And correlation in output map    FR    97
#                                                                       FR    98
COMMON /COMIFR/$#                                                       FR    99
CENT,IATM,IFFF,INCX,IP,IREL,IRF,IRF2,IRH,IRJ,IRL,IRS,IRX,$#             FR   100
ISCF,ISIN,IWNT,$#                                                       FR   101
JP,KEY,LPAK,MAPOUT,MARK1,MARK2,MARK3,MARK4,$#                           FR   102
MARK5,MARK6,MARK7,MARKR,MODREF,MODTHR,NAME,NATM,NATM1,NATM2,$#          FR   103
NEUT,NDEL,NG,NGRX,NGRY,NGRZ,NLIS,NMDS,NP,NPAK,$#                        FR   104
NROT,NSCF,NSCL,NTYP,OFF,ORGX,STEPR,STOPR,TYPE#                          FR   105
#                                                                       FR   106
COMMON /COMFFR/$#                                                       FR   107
UOVL,CELCON,FTHRSH,DLIS,DSNM,DSTL,FMUL,$#                               FR   108
MAXH,MAXK,MAXL,REGPAR,REJF,SMAX,SMIN,SMFOFC,SUMFC2,$#                   FR   109
SUMFO,SUMFR2,WEIGHT#                                                    FR   110
endext:#                                                                FR   111
#                                                                       FR   112
systemheader:(FR00)## Fo-fc agreement from molecular translation        FR00   1
# ####################################################################  FR00   2
#                                                                    #  FR00   3
#                               FR00                                 #  FR00   4
#                                                                    #  FR00   5
# ####################################################################  FR00   6
SUBROUTINE FR00#                       J.m.stewart  december 1987       FR00   7
#                                                                       FR00   8
include:(AACOMN)#                                                       FR00   9
include:(FRCOMN)#                                                       FR00  10
#                                                                       FR00  11
FILEXT(IOUNIT(3))='MAP'#               Ext for map of rvalues           FR00  12
FILEXT(IOUNIT(4))='XX1'#               Ext for scratch file             FR00  13
#                                                                       FR00  14
CALL FR01#                             Read rmap line & start bdf       FR00  15
CALL FR02#                             Read supplementary input lines   FR00  16
CALL FR03#                             Get atom parameters from bdf     FR00  17
CALL FR04#                             Print run conds & start lrrefl   FR00  18
CALL FR05#                             Calculate structure factors      FR00  19
CALL FR06#                             Put out r map                    FR00  20
#                                                                       FR00  21
RETURN#                                                                 FR00  22
END#                                                                    FR00  23
systemheader:(FR01)#                   Read bdf lrsymm: to lrdset:      FR01   1
# ####################################################################  FR01   2
#                                                                       FR01   3
#                                FR01                                   FR01   4
#                                                                       FR01   5
# ####################################################################  FR01   6
SUBROUTINE FR01#                       J. m. stewart dec 1987           FR01   7
include:(AACOMN)#                                                       FR01   8
include:(FRCOMN)#                                                       FR01   9
#                                                                       FR01  10
INTEGER I,J,K,L#                       Working indices                  FR01  11
INTEGER IDS#                           Compound pointer and offset      FR01  12
INTEGER IPO#                           Pointer to output buffer         FR01  13
INTEGER J2#                            Index for sf names in mark2      FR01  14
#                                                                       FR01  15
chardata:(FR11,SCT NOS OVE ISO $#                                       FR01  16
XRA NEU DSE LIS REJ NLI NRE WEI MAP NML THR STH SEL )#                  FR01  17
datastuff:#                                                             FR01  18
#                                                                       FR01  19
#---------------------------------------------------------------------- FR01  20
#                                                                       FR01  21
# THE FR INPUT LINE CONTAINS CODES TO DIRECT THE SETTING OF THE         FR01  22
# FOLLOWING  VARIABLES.                                                 FR01  23
#                                                                       FR01  24
# VARIABLE  POSSIBLE  VALUE OF  MEANING                                 FR01  25
#   NAME     CODES    VARIABLE                                          FR01  26
#                                                                       FR01  27
#  ISIN      SCT       YES:    CALC A & B WITH SIN TABLE 0-0/1/449 DEGR FR01  28
#            NOS       NO:     CALC A & B WITH LIBRARY SUBROUTINE       FR01  29
#                                                                       FR01  30
#  TYPE      OVE        2      OVERALL TEMPERATURE FACTOR               FR01  31
#            ISO        3      INDIVIDUAL ISOTROPIC TEMP. FACTORS       FR01  32
#                                                                       FR01  33
#  DSNM      DSE       INPUT   DATASET FLAG PRECEDES NUMERIC VALUE THAT FR01  34
#                              FOLLOWS. IF NO VALUE ENTERED SET AT 1.   FR01  35
#                                                                       FR01  36
#  DLIS      LIS       YES:    LIST FR'S IF FDIFF > VALUE FOLLOWING     FR01  37
#            NLI               THIS FLAG. IF NO VALUE INPUT - LIST ALL. FR01  38
#                                                                       FR01  39
#  REJF      REJ       YES:    REJECT REFLN IF JCODE >= VALUE FOLLOWING FR01  40
#            NRE               THIS FLAG.  IF NO VALUE: REJECT > 0.     FR01  41
#                                                                       FR01  42
#  WEIGHT    WEI       INPUT   THE WEIGHT TO BE USED TO PROPORTION R    FR01  43
#                              AND CORRELATION FUNCTION FOR OUTPUT MAP  FR01  44
#                                                                       FR01  45
# MAPOUT     MAP       YES:    CAUSE THE R MAP TO BE PRINTED OUT        FR01  46
#                                                                       FR01  47
# MODREF     SEL       N       MODULUS OF REFLECTION COUNT TO BE        FR01  48
#                              REJECTED. N=1 MEANS REJECT ALL, N=10     FR01  49
#                              MEANS REJECT EVERY 10TH, ETC.            FR01  50
#                                                                       FR01  51
# FTHRSH     THR      X.XX     F OBS THRESHOLD FOR REJECTION OF SMALL   FR01  52
#                              F REFLECTIONS.  USED IN CONJUNCTION WITH FR01  53
#                              MODTHR TO SPEED UP CALCULATION.          FR01  54
#                                                                       FR01  55
# MODTHR     STH       N       CONTROL SELECTION OF REJECTED SMALL F    FR01  56
#                              REFLECTIONS. LIKE MODREF BUT FOR INCLUSI FR01  57
#                              OF EVERY NTH SMALL REFLECTION            FR01  58
#---------------------------------------------------------------------- FR01  59
#                                                                       FR01  60
#                                                                       FR01  61
#    DECODE =RMAP= LINE PARAMETERS                                      FR01  62
#    -----------------------------                                      FR01  63
#                                                                       FR01  64
ISIN=no:#                              Set to use library sin/cos       FR01  65
TYPE=2#                                Set overall isotropic t.f.       FR01  66
IFFF=0#                                Set default parameters           FR01  67
NEUT=no:#                              Set no neutron scattering        FR01  68
DSNM=1.#                               Set default parameters           FR01  69
DLIS=999999. ; NLIS=0#                 Set to list no reflections       FR01  70
FTHRSH=0.0 ; MODTHR=1#                 Set no rejection of small fs     FR01  71
MODREF=99999#                          No reject based on refl count    FR01  72
REJF=6.#                               Set default parameters           FR01  73
WEIGHT=1.0 ; STEPR=1#                  Set for pure r value map         FR01  74
MAPOUT=no:#                            Set for no map printing          FR01  75
NATM1=0 ; NATM2=0#                     Initialize atom counts in        FR01  76
#                                      Fixed and translating groups     FR01  77
#                                                                       FR01  78
FOR(I=1;I<30;I=I+1)#                   Loop over input fields           FR01  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FR01  80
ifvo:(BUFIN(I)) BREAK#                 Exit after last field            FR01  81
stringlim:(I,J,K)#                     Find limits of the field         FR01  82
compchar:(CHRIN,J,FR11,1,3,4,NFR11,K)# Find what's there                FR01  83
IF(K==0) iquit:(FR0101,I)#             Dud flag.......50101             FR01  84
ELSE IF(K==2)  ISIN=no:#               Do not use lookup table          FR01  85
ELSE IF(K==3)  TYPE=2#                 Overall tf                       FR01  86
ELSE IF(K==4)  TYPE=3#                 Individual isotropic tf          FR01  87
ELSE IF(K==7)#                         Data set number to follow        FR01  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FR01  89
IF(BUFIN(I+1)>voidflg:)#               Should be numeric dsetnum        FR01  90
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FR01  91
DSNM=NINT(BUFIN(I+1))#                 Get dataset number               FR01  92
I=I+1#                                 Advance field counter            FR01  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FR01  94
ELSE DSNM=1.#                          Default dataset is 1             FR01  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FR01  96
ELSE IF(K==8)#                         Test for list flag               FR01  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FR01  98
IF(BUFIN(I+1)>voidflg:)#               Test if diff limit follows       FR01  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FR01 100
DLIS=BUFIN(I+1)#                       Extract diff list limit          FR01 101
I=I+1#                                 Advance field counter            FR01 102
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FR01 103
ELSE DLIS=0.0#                         Force all to be listed           FR01 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FR01 105
ELSE IF(K==9)#                         Test for reject refln flag       FR01 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FR01 107
IF(BUFIN(I+1)>voidflg:)#               Is reject limit following        FR01 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FR01 109
REJF=BUFIN(I+1)-0.5#                   Set up reject limit              FR01 110
I=I+1#                                 Advance field counter            FR01 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FR01 112
ELSE REJF=1.5#                         Default reject all but 1.        FR01 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FR01 114
ELSE IF(K==12)#                        Test for weight flag             FR01 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FR01 116
IF((BUFIN(I+1)>=0.0)&(BUFIN(I+1)<1.0))# Must be a decent weight         FR01 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FR01 118
WEIGHT=BUFIN(I+1) ; I=I+1 ; STEPR=3#   Set up to make correlations to   FR01 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FR01 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FR01 121
ELSE IF(K==13) MAPOUT=yes:#            Set map printing .true.          FR01 122
ELSE IF(K==15&BUFIN(I+1)>0.0)#         Check for small f rejection      FR01 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FR01 124
FTHRSH=BUFIN(I+1) ; I=I+1#             Store threshold                  FR01 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FR01 126
ELSE IF(K==16&BUFIN(I+1)>0.0)#         Test for modulus control which   FR01 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FR01 128
MODTHR=NINT(BUFIN(I+1)) ; I=I+1#       Allows selection of low refls    FR01 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FR01 130
ELSE IF(K==17&BUFIN(I+1)>0.0)#         Test for modulus control which   FR01 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FR01 132
MODREF=NINT(BUFIN(I+1)) ; I=I+1#       Allows rejectn of every nth re   FR01 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FR01 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FR01 135
IF(DLIS<0.)#                           Test for max hkl listed          FR01 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FR01 137
NLIS=-NINT(DLIS);    DLIS=999999.#     Set max limit                    FR01 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FR01 139
#                                                                       FR01 140
NMDS=NINT(DSNM)*1000#                  Form dataset offset              FR01 141
#                                                                       FR01 142
#   ASSIGN BDF BUFFERS 1, 3 AND 4                                       FR01 143
#   -----------------------------                                       FR01 144
#                                                                       FR01 145
IOMARK(1)=QXSTR#                       Set start of io buffer1 for fi   FR01 146
IOMARK(3)=IOMARK(1)+bdfbuf:#           Start of buffer3 for file c      FR01 147
IOMARK(4)=IOMARK(3)+bdfbuf:#           Start of buffer4 for file d      FR01 148
incrqx:(MARK1,IOMARK(4)+bdfbuf:,FR0104)# Expand mememory                FR01 149
copyfile:(1,3,1,decr:(lrcell:))#       Copy to cell parameter record    FR01 150
#                                                                       FR01 151
#   EXTRACT CELL PARAMETERS FOR AUTOMATIC GRID SIZING                   FR01 152
#   -------------------------------------------------                   FR01 153
#                                                                       FR01 154
J=0 ; REPEAT#                          Loop over all packets            FR01 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FR01 156
J=J+1 ; readwpkt:(1,lrcell:,LPAK,IP,0)# Read the next packet            FR01 157
IF(IP<=0) BREAK#                       Get out when all are read        FR01 158
writepkt:(3,4,LPAK,IPO)#               Write cell info to file c        FR01 159
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy data to output buffer       FR01 160
IF(J==1)#                              First packet?                    FR01 161
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FR01 162
movereal:(QX,IP+1,CELCON,1,6,0)#       Save a,b,c, and cosines          FR01 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FR01 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FR01 165
#                                                                       FR01 166
#   EXTRACT SYMMETRY CODES & MATRICES (LRSYMM:)                         FR01 167
#   -------------------------------------------                         FR01 168
#                                                                       FR01 169
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read first packet of lr lrsy     FR01 170
writepkt:(3,5,LPAK,IPO)#               Copy to output file              FR01 171
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#                                     FR01 172
CENT=NINT(QX(IP+2))#                   Centric=0 / acentric=1           FR01 173
NROT=NINT(QX(IP+4))#                   Get number rotation matrices     FR01 174
#                                                                       FR01 175
#    AS MUCH AS THIS WILL BOTHER AN OLD TIMER, WHEN THE UNIT CELL       FR01 176
#    HAS A CENTER OF SYMMETRY, DO ALL CALCULATIONS AS IF ACENTRIC       FR01 177
#    BY PUTTING THE NEGATIVE ROTATION MATRICIES IN THE SYMOP STACK.     FR01 178
#    THIS IS DONE FOR TWO REASONS.  MOST STRUCTURES FOR WHICH THIS      FR01 179
#    PROGRAM WILL BE USED WILL BE ACENTRIC.  THE INNER LOOPS WILL       FR01 180
#    BE MUCH MORE EFFICIENT ON VECTOR MACHINES.                         FR01 181
#    -------------------------------------------------------------      FR01 182
#                                                                       FR01 183
IF(CENT==0) NROT=2*NROT#               If centro double ops             FR01 184
FMUL=QX(IP+6)#                         Get reflection multiplicity      FR01 185
incrqx:(MARK2,MARK1+NROT*LPAK,FR0105)# Expand qx for symops             FR01 186
J=MARK1-LPAK#                          Set pointer to symops            FR01 187
REPEAT#                                Loop over symm matrices          FR01 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FR01 189
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Get packet pointer               FR01 190
IF(IP<=0) BREAK#                       Exit after last packet           FR01 191
writepkt:(3,5,LPAK,IPO)#               Get pointer to o/p buffer        FR01 192
J=J+LPAK#                              Advance storage pointer          FR01 193
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    And copy the packet              FR01 194
movereal:(QX,IP+1,QX,J+1,LPAK,1)#      Save the symop for later         FR01 195
IF(CENT==0)#                           If centric make the - one        FR01 196
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FR01 197
DO I=1,LPAK ; QX(J+LPAK+I)=-QX(J+I)#   Through the center               FR01 198
J=J+LPAK#                                                               FR01 199
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FR01 200
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FR01 201
#                                                                       FR01 202
#   ENTER SCATT. FACTOR & ATOM SUMMARY (LR LRSCAT:)                     FR01 203
#   -----------------------------------------------                     FR01 204
#                                                                       FR01 205
incrqx:(MARK3,MARK2+16*mxwd8c:,FR0106)# Save room for 16 sf types       FR01 206
ISCF=mxwd8c:#                          Allow for 8 char. per name       FR01 207
J2=MARK2#                              Set marker for first sf name     FR01 208
IWNT(1)=NINT(DSNM+20.);  IWNT(3)=100#  Set real ad & ff idnums          FR01 209
IWNT(2)=NINT(DSNM+60.);  IWNT(4)=10#   Set imag ad & neut ff            FR01 210
IWNT(5)=11 ;  IWNT(6)=7#               Set sf name idnum                FR01 211
KEY(1)=0;  KEY(2)=6;  KEY(3)=0#        Set search delimiters            FR01 212
KEY(4) = 0#                                                             FR01 213
indexpkt:(1,lrscat:,LPAK,IP,3,KEY,IWNT,IREL)## Get packet pointers      FR01 214
IF(IREL(4)>0) NEUT=yes:#               This is neutron data             FR01 215
#                                                                       FR01 216
FOR(I=IP+IREL(3);I<=IP+LPAK;I=I+1)#    Loop over ff list                FR01 217
IF((QX(I)<99.5)\(QX(I)>299.5)) BREAK#  Exit after last ff               FR01 218
IF(IREL(3)>0)  NSCF=I-IP-IREL(3)#      Count contiguous ff              FR01 219
ELSE           NSCF=0#                 Ff table present                 FR01 220
IF(NEUT==yes:) NSCF=1#                 Count neutron ff                 FR01 221
IF(IREL(3)>0) DSTL=(QX(I-1)-QX(I-2))*.01# Set st/l interval             FR01 222
#                                                                       FR01 223
NTYP=0;    MARK4=MARK3#                Zero count of atom types         FR01 224
FOR(J=MARK3;J>0;J=J+NSCF)#             Loop over each atom type         FR01 225
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FR01 226
readwpkt:(1,lrscat:,LPAK,IP,0)#        Get packet pointer               FR01 227
IF(IP<=0) BREAK#                       Exit after last packet           FR01 228
writepkt:(3,8,LPAK,IPO)#               Get output pointer               FR01 229
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy packet                      FR01 230
L=IP+IREL(5)#                          Set pointer for sf name          FR01 231
movereal:(QX,L,QX,J2+1,ISCF,1)#        Move sf name to mark2 array      FR01 232
J2=J2+ISCF#                            Advance sf name pointer          FR01 233
NTYP=NTYP+1#                           Count atom types                 FR01 234
I=IP+IREL(6); IF(I>IP) IFFF=NINT(QX(I))# Get refl ff flag               FR01 235
IF(IFFF==yes:) NEXT#                   Skip ff table not needed         FR01 236
incrqx:(MARK4,J+NSCF,FR0108)#          Expand qx for scattering facto   FR01 237
I=IP+IREL(4)#                          Point to neutron ff              FR01 238
IF(NEUT==yes:) QX(MARK4)=QX(I)#        Store neutron ff                 FR01 239
ELSE IF(IREL(3)>0)#                    If xray ff present               FR01 240
FOR(I=J;I<MARK4;I=I+1)#                Loop over sf data points         FR01 241
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FR01 242
K=IP+IREL(3)+I-J#                      Point to each ff value           FR01 243
QX(I+1)=QX(K)#                         Store each ff value              FR01 244
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FR01 245
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FR01 246
#                                                                       FR01 247
#   MOVE LRDDEF: RECORD TO FILE C                                       FR01 248
#   -----------------------------                                       FR01 249
#                                                                       FR01 250
REPEAT#                                                                 FR01 251
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FR01 252
readwpkt:(1,lrddef:,LPAK,IP,0)#                                         FR01 253
IF(IP<=0) BREAK#                                                        FR01 254
writepkt:(3,10,LPAK,IPO)#                                               FR01 255
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#                                     FR01 256
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FR01 257
#                                                                       FR01 258
#   ENTER SCALE INFORMATION (LR LREXPL:)                                FR01 259
#   ------------------------------------                                FR01 260
#                                                                       FR01 261
IWNT(1)=1;   IWNT(2)=100#              Set data set & nscl idnums       FR01 262
KEY(1)=1;  KEY(2)=2;  KEY(3)=0#        Set search delimiters            FR01 263
KEY(4)=0#                              Set update mode                  FR01 264
indexpkt:(1,lrexpl:,LPAK,IP,0,KEY,IWNT,IREL)# Get packet pointers       FR01 265
incrqx:(MARK5,MARK4+64,FR0109)#        Expand qx for scale factors      FR01 266
NSCL=1;   QX(MARK4+1)=1.#              Default group & rel pointer&     FR01 267
FOR(I=IP+1;I<=IP+LPAK;I=I+1)#          Loop over directory              FR01 268
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FR01 269
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           FR01 270
J=MARK4+NINT(QX(I))-100#               Get group number of scale        FR01 271
QX(J)=FLOAT(I-IP)#                     Store relative position          FR01 272
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FR01 273
REPEAT#                                Loop over data sets              FR01 274
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FR01 275
readwpkt:(1,lrexpl:,LPAK,IP,0)#        Get packet pointer               FR01 276
IF(IP<=0) BREAK#                       Exit after last packet           FR01 277
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        FR01 278
ifne:(DSNM,QX(I)) NEXT#                Skip unwanted data set           FR01 279
I=IP+IREL(2); IF(I>IP) NSCL=NINT(QX(I))# Number of scales               FR01 280
FOR(I=MARK4;I<MARK4+NSCL;I=I+1)#       Loop over scale factors          FR01 281
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FR01 282
J=IP+NINT(QX(I+1))#                    Point to scale location          FR01 283
IF(J>IP) QX(I+1)=QX(J)#                Store scale in table             FR01 284
ELSE     QX(I+1)=1.#                   Default scale is 1.              FR01 285
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FR01 286
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FR01 287
MARK5=MARK4+NSCL#                      Reset mark5 for true nscl        FR01 288
#                                                                       FR01 289
#   ENTER DATA SET INFORMATION (LR LRDSET:)                             FR01 290
#   ---------------------------------------                             FR01 291
#                                                                       FR01 292
IWNT(1)=2;  IWNT(7)=1#                 Request ovb, dataset number      FR01 293
DO I=2,6;   IWNT(I)=I+9#               Request maxhkl, max&min stol     FR01 294
KEY(1)=0;  KEY(2)=7; KEY(3)=0#         Set search delimiters            FR01 295
indexpkt:(1,lrdset:,LPAK,IP,0,KEY,IWNT,IREL)# Search rel pointers       FR01 296
UOVL=0.; SMIN=0.; SMAX=2.#             Set default parameters           FR01 297
MAXH=256.; MAXK=256.; MAXL=256.#       Set default parameters           FR01 298
IF (IP>0) $#                           If there was a directory         FR01 299
REPEAT#                                Loop over data sets              FR01 300
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FR01 301
readwpkt:(1,lrdset:,LPAK,IP,0)#        Read the next packet             FR01 302
IF(IP<=0) BREAK#                       Exit when thru                   FR01 303
IDS=IP+IREL(7)#                        Make pointer to dataset no.      FR01 304
ifne:(DSNM,QX(IDS)) NEXT#              Skip unwanted datasets           FR01 305
I=IP+IREL(1); IF(I>IP) UOVL=QX(I)#     Get active u overall             FR01 306
I=IP+IREL(2); IF(I>IP) MAXH=QX(I)#     Get active max /h/               FR01 307
I=IP+IREL(3); IF(I>IP) MAXK=QX(I)#     Get active max /k/               FR01 308
I=IP+IREL(4); IF(I>IP) MAXL=QX(I)#     Get active max /l/               FR01 309
I=IP+IREL(5); IF(I>IP) SMIN=QX(I)#     Get active smin                  FR01 310
I=IP+IREL(6); IF(I>IP) SMAX=QX(I)#     Get active smax                  FR01 311
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FR01 312
#                                                                       FR01 313
RETURN#                                                                 FR01 314
END#                                                                    FR01 315
systemheader:(FR02)#                   Read controls                    FR02   1
# ####################################################################  FR02   2
#                                                                       FR02   3
#                                FR02                                   FR02   4
#                                                                       FR02   5
# ####################################################################  FR02   6
SUBROUTINE FR02#                       J. m stewart dec 1987            FR02   7
include:(AACOMN)#                                                       FR02   8
include:(FRCOMN)#                                                       FR02   9
#                                                                       FR02  10
INTEGER NPOSX,NPOSY,NPOSZ#             Possible fourier grid points     FR02  11
INTEGER I,J,K,M#                       Working indices                  FR02  12
#                                                                       FR02  13
chardata:(FR21, SCALE  MAXHKL SELECT FIXATM BOUNDS END    )#            FR02  14
chardata:(FR22,        )#                                               FR02  15
datastuff:#                                                             FR02  16
#                                                                       FR02  17
#   SET DEFAULT SUMMATION RANGES OVER UNIT CELL                         FR02  18
#   -------------------------------------------                         FR02  19
#                                                                       FR02  20
DO I=1,3; CELCON(I)=FLOAT(INT(CELCON(I)/0.3))# Get cell incr            FR02  21
REGPAR(1)=0.0 ; REGPAR(2)=1.0#         Set x min and x max              FR02  22
REGPAR(3)=1.0/CELCON(1)#               Set angstrom delta x             FR02  23
REGPAR(4)=0.0#                         Set y minimum                    FR02  24
IF(CENT==0) REGPAR(5)=0.5#             Set y max for centric cells      FR02  25
ELSE        REGPAR(5)=1.0#             Set y max acentric cells         FR02  26
REGPAR(6)=1.0/CELCON(2)#               Set angstrom delta y             FR02  27
REGPAR(7)=0.0 ; REGPAR(8)=1.0#         Set z min and max                FR02  28
REGPAR(9)=1.0/CELCON(3)#               Set angstrom delta z             FR02  29
#                                                                       FR02  30
#   ENTER CONTROL LINES                                                 FR02  31
#   -------------------                                                 FR02  32
#                                                                       FR02  33
MARK6=MARK5#                           Set select atom marker           FR02  34
NAME=incr:(arith:(23,/,mxchwd:))#      Set atom name length             FR02  35
#                                                                       FR02  36
REPEAT#                                Loop over control lines          FR02  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FR02  38
readline:(FR21,NFR21)#                 Process control line             FR02  39
#                                                                       FR02  40
IF(LINID==1)#                          ****** scale *******             FR02  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FR02  42
ifvo:(BUFIN(1)) NEXT#                  Skip if void scale               FR02  43
ifvo:(BUFIN(2)) I=1#                   Default scale group              FR02  44
ELSE            I=NINT(BUFIN(2))#      Enter scale group                FR02  45
QX(MARK4+I)=BUFIN(1)#                  Store scale value                FR02  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FR02  47
#                                                                       FR02  48
ELSE IF(LINID==2)#                     ****** maxhkl *******            FR02  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FR02  50
ifnv:(BUFIN(1)) MAXH=BUFIN(1)#         Set active max /h/               FR02  51
ifnv:(BUFIN(2)) MAXK=BUFIN(2)#         Set active max /k/               FR02  52
ifnv:(BUFIN(2)) MAXK=BUFIN(2)#         Set active max /k/               FR02  53
ifnv:(BUFIN(3)) MAXL=BUFIN(3)#         Set active max /l/               FR02  54
ifnv:(BUFIN(4)) SMIN=BUFIN(4)#         Set active min st/l              FR02  55
ifnv:(BUFIN(5)) SMAX=BUFIN(5)#         Set active max st/l              FR02  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FR02  57
#                                                                       FR02  58
ELSE IF(LINID==3)#                     ****** select *******            FR02  59
DO I=1,30#                             Loop over select fields          FR02  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FR02  61
ifvo:(BUFIN(I)) BREAK#                 Exit first inactive field        FR02  62
M=MARK6+1#                             Point to next name               FR02  63
incrqx:(MARK6,MARK6+NAME,FR0202)#      Expand qx for selected atoms     FR02  64
stringlim:(I,J,K)#                     Extract string limits            FR02  65
K=MIN0(K-J,24)#                        Limit to 8 characters            FR02  66
movector:(FR22,1,QX(M),1,24,0)#        Blank out qx region              FR02  67
movector:(CHRIN,J,QX(M),1,K,0)#        Store name in qx                 FR02  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FR02  69
#                                                                       FR02  70
ELSE IF(LINID==4)#                     ***** fixatm ******              FR02  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FR02  72
IF(BUFIN(1)>0.0) NATM1=NINT(BUFIN(1))# Take no. of atoms as 'fixed'     FR02  73
IF(BUFIN(2)>0.0) NATM2=NINT(BUFIN(2))# Take no. atoms to translate      FR02  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FR02  75
#                                                                       FR02  76
ELSE IF(LINID==5)#                     ****** bounds *******            FR02  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FR02  78
DO I=1,9; ifnv:(BUFIN(I)) REGPAR(I)=BUFIN(I)# Save map bounds           FR02  79
DO I=3,9,3; ifeq:(REGPAR(I),0.) REGPAR(I)=1.# Reset zero intervals      FR02  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FR02  81
ELSE BREAK#                            ****** end *******               FR02  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FR02  83
#                                                                       FR02  84
#                                                                       FR02  85
#    DETERMINE NO. GRID POINTS IN TRANSLATION MAP FROM INPUT RANGES AND FR02  86
#    INCREMENTS (INPUT AS FRACTIONAL COORDINATES).                      FR02  87
#    ------------------------------------------------------------------ FR02  88
#                                                                       FR02  89
NGRX=NINT((REGPAR(2)-REGPAR(1))/REGPAR(3))+1#                           FR02  90
NGRY=NINT((REGPAR(5)-REGPAR(4))/REGPAR(6))+1#                           FR02  91
NGRZ=NINT((REGPAR(8)-REGPAR(7))/REGPAR(9))+1#                           FR02  92
NPOSX=NINT(1.0/REGPAR(3))+1#                                            FR02  93
NPOSY=NINT(1.0/REGPAR(6))+1#                                            FR02  94
NPOSZ=NINT(1.0/REGPAR(9))+1#                                            FR02  95
#                                                                       FR02  96
#    ADJUST RANGES TO CORRESPOND TO MULTIPLES OF INCREMENTS AND LIST TH FR02  97
#    ------------------------------------------------------------------ FR02  98
#                                                                       FR02  99
REGPAR(2)=REGPAR(1)+FLOAT((NGRX-1))*REGPAR(3)#                          FR02 100
REGPAR(5)=REGPAR(4)+FLOAT((NGRY-1))*REGPAR(6)#                          FR02 101
REGPAR(8)=REGPAR(7)+FLOAT((NGRZ-1))*REGPAR(9)#                          FR02 102
INCX(1)=1 ; INCX(2)=1 ; INCX(3)=1#     Set increment along grids        FR02 103
NP(1)=NGRZ ; NP(2)=NGRY ; NP(3)=NGRX#  Set actual no. of map points     FR02 104
NG(1)=NPOSZ ; NG(2)=NPOSY ; NG(3)=NPOSX# Set actual no. of grid point   FR02 105
ORGX(1)=0 ; ORGX(2)=0 ; ORGX(3)=0#     Set origin points                FR02 106
#                                                                       FR02 107
RETURN#                                                                 FR02 108
END#                                                                    FR02 109
systemheader:(FR03)## Get atom parameters from lratom                   FR03   1
# ####################################################################  FR03   2
#                                                                       FR03   3
#                               FR03                                    FR03   4
#                                                                       FR03   5
# ####################################################################  FR03   6
SUBROUTINE FR03#                       J.m. stewart dec 1987            FR03   7
include:(AACOMN)#                                                       FR03   8
include:(FRCOMN)#                                                       FR03   9
#                                                                       FR03  10
INTEGER I,J,K,N#                       Working indices                  FR03  11
INTEGER IPO#                           O/p buffer pointer               FR03  12
#                                                                       FR03  13
string:(NAME1,24)#                                                      FR03  14
string:(NAME2,24)#                                                      FR03  15
string:(NAME3,24)#                                                      FR03  16
chardata:(FR31, X       Y       Z   MULT    U       ACTION)#            FR03  17
chardata:(FR33, HELD FIXED)#                                            FR03  18
chardata:(FR34, TRANSLATED)#                                            FR03  19
realdata:(FMT,[842.,842.,842.,722.,842.])#                              FR03  20
datastuff:#                                                             FR03  21
#                                                                       FR03  22
copyfile:(1,3,incr:(lrdset:),decr:(lratom:))# Copy to atom rec.         FR03  23
#                                                                       FR03  24
#--------------------------------------------------------------------   FR03  25
##### Layout of atom parameter storage                                  FR03  26
# RELATIVE ADDRESS                                                      FR03  27
# IN QX ARRAY                                                           FR03  28
#      1                SCAT. FACTOR POINTER                            FR03  29
#      2                X                                               FR03  30
#      3                Y                                               FR03  31
#      4                Z                                               FR03  32
#      5                ATOM MULTIPLICITY                               FR03  33
#      6                B                                               FR03  34
#---------------------------------------------------------------------- FR03  35
#                                                                       FR03  36
#   LOCATE REQUIRED PARAMETERS IN LR LRATOM:                            FR03  37
#   ----------------------------------------                            FR03  38
#                                                                       FR03  39
IWNT(1)=22; IWNT(7)=21#                Set nscf, mult                   FR03  40
IWNT(2)=14#                            Set atom name idnum              FR03  41
DO I=1,3;  IWNT(I+2)=I#                Set x to z idnums                FR03  42
IWNT(6)=4#                             Set u iso idnum                  FR03  43
KEY(1)=4;  KEY(2)=7;  KEY(3)=0#        Set search delimiters            FR03  44
KEY(4)=0#                              Copy mode for indexpkt:          FR03  45
indexpkt:(1,lratom:,LPAK,IP,3,KEY,IWNT,IREL)# Get relative pointers     FR03  46
IF(KEY(4)<0) iquit:(FR0301)#           Data missing.....fr0301          FR03  47
IF((TYPE==3)&(IREL(6)<=0)) TYPE=2#     Type 3 calc needs iso u          FR03  48
IF((TYPE==2)&(UOVL<0.)) iquit:(FR0301)# Type 2 needs overall dp         FR03  49
#                                                                       FR03  50
#   EXTRACT ATOM PARAMETERS FROM LR LRATOM:                             FR03  51
#   ---------------------------------------                             FR03  52
#                                                                       FR03  53
IATM=6#                                Allow for ff,x,y,z,m & b         FR03  54
writeline:(0,0,0,1,4);  LINRM=4#       Prepare for list header          FR03  55
HEADOT=' '; HEADOT(LABMAX+5^)=FR31#    Store atom headers               FR03  56
NATM=0#                                Zero count of selected atoms     FR03  57
K=MARK6#                               Start atom list pointer          FR03  58
REPEAT#                                Loop over lr16 packets           FR03  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FR03  60
readwpkt:(1,lratom:,LPAK,IP,0)#        Get packet pointer               FR03  61
IF(IP<=0) BREAK#                       Exit after last packet           FR03  62
writepkt:(3,16,LPAK,IPO)#              Get o/p buffer pointer           FR03  63
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy the packet                  FR03  64
N=IP+IREL(2)#                          Make pointer to atom name        FR03  65
movertoc:(QX(N),1,NAME1,1,24,0)#       Move name to character array     FR03  66
label:(NAME1,I,J)#                     Process atom label               FR03  67
movechar:(BLANK,1,NAME2,1,24,1)#       Blank atom name 2                FR03  68
movechar:(NAME1,1,NAME2,1,J,0)#        Put atom type symbol             FR03  69
FOR(I=MARK5+1;I<=MARK6;I=I+NAME)#      Loop over selected atoms         FR03  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FR03  71
movertoc:(QX(I),1,NAME3,1,24,0)#       Move name of selected atom       FR03  72
IF(NAME3==NAME1\NAME3==NAME2) BREAK#   Exit if label or symbol matche   FR03  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FR03  74
IF((I>MARK6)&(MARK6>MARK5)) NEXT#      Skip unwanted atoms              FR03  75
NATM=NATM+1#                           Increment count of found ato     FR03  76
incrqx:(MARK7,K+IATM,FR0302)#          Expand qx for atom parameters    FR03  77
I=IP+IREL(1); QX(K+1)=QX(I)#           Atom scattering factor pointer   FR03  78
I=IP+IREL(3); QX(K+2)=QX(I)#           Store x coordinate               FR03  79
I=IP+IREL(4); QX(K+3)=QX(I)#           Store y coordinate               FR03  80
I=IP+IREL(5); QX(K+4)=QX(I)#           Store z coordinate               FR03  81
QX(K+5)=1.0#                           Default site mult to 1.0         FR03  82
I=IP+IREL(7); IF(I>IP) QX(K+5)=QX(I)#  Store site mult. from lratom:    FR03  83
QX(K+6)=UOVL#                          Default to overall d.p.          FR03  84
IF(TYPE>2)#                            Test if more data needed         FR03  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FR03  86
I=IP+IREL(6); IF(I>IP) QX(K+6)=QX(I)#  Store isotropic u                FR03  87
ELSE      QX(K+6)=UOVL#                Else store overall u             FR03  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FR03  89
#                                                                       FR03  90
#    LIST INPUT ATOMS                                                   FR03  91
#    ----------------                                                   FR03  92
#                                                                       FR03  93
movechar:(NAME1,1,CHROT,2,24,0)#       Get current atom name            FR03  94
IF(NATM>NATM1) movechar:(FR34,1,CHROT,55,NFR34,0)# Translated           FR03  95
ELSE           movechar:(FR33,1,CHROT,55,NFR33,0)# Fixed atoms          FR03  96
LCHROT=15#                             Set format pointer               FR03  97
ncodefld:(QX,K+2,CHROT,FMT,5)#         Format stored items              FR03  98
writeline:(0,HEADOT,120,1,4)#          Print atoms loaded for fc        FR03  99
K=K+IATM#                              Incr atom list pointer           FR03 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FR03 101
#                                                                       FR03 102
#    SET UP ATOMS TO BE HELD FIXED AND THOSE TO BE TRANSLATED           FR03 103
#    --------------------------------------------------------           FR03 104
#                                                                       FR03 105
IF(NATM1+NATM2>NATM) iquit:(FR0309)#   Counts don't balance out         FR03 106
IF(NATM1==0&NATM2==0) NATM2=NATM#      By default translate all         FR03 107
IF(NATM2==0) iquit:(FR0310)#           No point if no translation       FR03 108
RETURN#                                                                 FR03 109
END#                                                                    FR03 110
systemheader:(FR04)#                   Prepare lr lrrefl: & copy fi     FR04   1
# ####################################################################  FR04   2
#                                                                       FR04   3
#                                FR04                                   FR04   4
#                                                                       FR04   5
# ####################################################################  FR04   6
SUBROUTINE FR04#                       J.m. stewart dec 1987            FR04   7
include:(AACOMN)#                                                       FR04   8
include:(FRCOMN)#                                                       FR04   9
#                                                                       FR04  10
INTEGER I,J,JJ#                        Working indices                  FR04  11
INTEGER IPO#                           Output packet pointer            FR04  12
INTEGER RSIZ#                          Output packet size file c        FR04  13
chardata:(FR41,-NO YESXRAYNEUTSCATREFLOVERALL  $#                       FR04  14
ISOTROPICMIXED    ALL)#                                                 FR04  15
chardata:(FR42, RMAP CALCULATION PARAMETERS)#                           FR04  16
chardata:(FR43, DATA SET NUMBER USED                 )#                 FR04  17
chardata:(FR44, ATOMIC DISPLACEMENT PARAMETER                    )#     FR04  18
chardata:(FR45,[ RMAP FUNCTION APPLIED         (1/R+1.0)])#             FR04  19
chardata:(FR46,[ RMAP GRID START,STOP,INT X                      ])#    FR04  20
chardata:(FR47, SIN/COS LOOKUP TABLE                 )#                 FR04  21
chardata:(FR48,[ REJECT REFLECTIONS WITH RCODE >      ])#               FR04  22
chardata:(FR49,[ LIST   REFLECTIONS WITH DELF >         ])#             FR04  23
chardata:(FR4A, RMAP GRID POINTS ALONG XYZ                       )#     FR04  24
chardata:(FR4B,[((1-W)*10*C+1.0)*(W/R+1.0)  W=       ])#                FR04  25
chardata:(FR4C,[ LIST REFLECTIONS WITH NREF <         ])#               FR04  26
chardata:(FR410, RADIATION TYPE USED                 )#                 FR04  27
chardata:(FR411, SOURCE OF SCATTERING FACTOR      LR           )#       FR04  28
chardata:(FR412, MAXIMUM H K L USED                            )#       FR04  29
chardata:(FR413, MIN/MAX ST/L  USED                            )#       FR04  30
chardata:(FR414, NUMBER OF ATOMS LOADED              )#                 FR04  31
chardata:(FR416, NUMBER OF ATOMS FIXED               )#                 FR04  32
chardata:(FR417, NUMBER OF ATOMS TRANSLATED          )#                 FR04  33
chardata:(FR415, FREL SCALE FOR GROUP             1             )#      FR04  34
chardata:(FR420, REJECT REFLECTIONS INTERVAL         )#                 FR04  35
chardata:(FR421,[ REJECT REFLECTIONS FOBS <          INCLUDE      ])#   FR04  36
realdata:(FMT1,[350642.,420642.,490642.])#                              FR04  37
realdata:(FMT2,[450413.,400413.,350413.])#                              FR04  38
datastuff:#                                                             FR04  39
#                                                                       FR04  40
#    LIST CALCULATION PARAMETERS                                        FR04  41
#    ---------------------------                                        FR04  42
#                                                                       FR04  43
LINRM=10#                              Force parameter header           FR04  44
movechar:(FR41,1,CHROT,2,NFR42-1,2)#   Underline header                 FR04  45
writeline:(1,FR42,NFR42,1,3)#          Print calculation header         FR04  46
movechar:(FR45,1,CHROT,1,NFR45,0)#     Inser function line              FR04  47
IF(WEIGHT<1.)#                         If some correlation              FR04  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FR04  49
movechar:(FR4B,1,CHROT,32,NFR4B,0)#    Insert function                  FR04  50
ncodefld:(WEIGHT,1,CHROT,650522.,1)#   Format weight                    FR04  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FR04  52
writeline:(0,0,0,1,3)#                 Print function                   FR04  53
DO I=1,3#                              Loop over cell edges             FR04  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FR04  55
movechar:(FR4A,24+I,FR46,27,1,0)#      Insert x,y,z                     FR04  56
ncodefld:(REGPAR,I*3-2,FR46,FMT1,3)#   Format map parameters            FR04  57
writeline:(0,FR46,NFR46,3,3)#          Print map parameters             FR04  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FR04  59
ncodefld:(FLOAT(NP(1)),1,FR4A,FMT2,1)# Format grid points calc          FR04  60
ncodefld:(FLOAT(NP(2)),1,FR4A,FMT2(2),1)# Format grid points calc       FR04  61
ncodefld:(FLOAT(NP(3)),1,FR4A,FMT2(3),1)# Format grid points calc       FR04  62
writeline:(0,FR4A,NFR4A,3,3)#          Print grid points                FR04  63
#                                                                       FR04  64
ncodefld:(DSNM,1,FR43,350513.,1)#      Format dataset number            FR04  65
writeline:(1,FR43,NFR43,3,3)#          Print dataset number             FR04  66
movechar:(FR41,NEUT*4+8,FR410,33,4,0)# Insert radiation type            FR04  67
writeline:(0,FR410,NFR410,3,3)#        Print radiation type             FR04  68
IF(IFFF==0)#                           Test if ff in lrrefl             FR04  69
ncodefld:(DSTL,1,FR411,400522.,1)#     Add stol interval to o/p         FR04  70
movechar:(FR41,IFFF*4+16,FR411,33,4,0)# Insert lr number                FR04  71
writeline:(0,FR411,NFR411,3,3)#        Print scat.fac. source           FR04  72
ncodefld:(MAXH,1,FR412,350413.,1)#     Format max/h/                    FR04  73
ncodefld:(MAXK,1,FR412,400413.,1)#     Format max/k/                    FR04  74
ncodefld:(MAXL,1,FR412,450413.,1)#     Format max/l/                    FR04  75
writeline:(0,FR412,NFR412,3,3)#        Print max hkl                    FR04  76
ncodefld:(SMIN,1,FR413,350532.,1)#     Format min st/l                  FR04  77
ncodefld:(SMAX,1,FR413,450532.,1)#     Format max st/l                  FR04  78
writeline:(0,FR413,NFR413,3,3)#        Print st/l min/max               FR04  79
#                                                                       FR04  80
ncodefld:(FLOAT(NATM),1,FR414,350813.,1)# Format atom count             FR04  81
writeline:(1,FR414,NFR414,3,3)#        Print total atom count           FR04  82
ncodefld:(FLOAT(NATM1),1,FR416,350813.,1)# Format atom count            FR04  83
writeline:(0,FR416,NFR416,3,3)#        Print fixed atom count           FR04  84
ncodefld:(FLOAT(NATM2),1,FR417,350813.,1)# Format atom count            FR04  85
writeline:(0,FR417,NFR417,3,3)#        Print translated atom count      FR04  86
movechar:(FR41,(TYPE-2)*9+24,FR44,33,9,0)# Insert dp type               FR04  87
IF(TYPE==2)ncodefld:(UOVL,1,FR44,450532.,1)# Insert uovl value          FR04  88
writeline:(0,FR44,NFR44,3,3)#          Print dp type                    FR04  89
movechar:(FR41,ISIN*3+2,FR47,34,3,0)#  Insert no/yes s/c table          FR04  90
writeline:(0,FR47,NFR47,3,3)#          Print s/c table status           FR04  91
ncodefld:(QX,MARK4+1,FR415,450732.,1)# Format scale 1                   FR04  92
writeline:(0,FR415,NFR415,3,3)#        Print scale 1                    FR04  93
FOR(I=2;I<=NSCL;I=I+1)#                Loop over scale groups           FR04  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FR04  95
ncodefld:(FLOAT(I),1,CHROT,350213.,1)# Format scale group               FR04  96
ncodefld:(QX,MARK4+I,CHROT,450732.,1)# Format scale value               FR04  97
writeline:(1,0,0,1,3)#                 Print scales only                FR04  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FR04  99
#                                                                       FR04 100
IF(NLIS>0)#                            For nlist max                    FR04 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FR04 102
ncodefld:(FLOAT(NLIS+1),1,FR4C,350513.,1)# Format list reflections      FR04 103
writeline:(1,FR4C,NFR4C,3,3)#          Print list parameters            FR04 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FR04 105
ELSE IF(DLIS<9999.)#                   For del f limit                  FR04 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FR04 107
ncodefld:(DLIS,1,FR49,350622.,1)#      Format list limit                FR04 108
writeline:(1,FR49,NFR49,3,3)#          Print list parameters            FR04 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FR04 110
ifne:(REJF,6.)#                        Test for rejections              FR04 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FR04 112
ncodefld:(REJF-.5,1,FR48,350113.,1)#   Format reject flag               FR04 113
writeline:(0,FR48,NFR48,3,3)#          Print reject conditions          FR04 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FR04 115
IF(MODREF<99999)#                      Test for interval                FR04 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FR04 117
ncodefld:(FLOAT(MODREF),1,FR420,350713.,1)# Format drop mod             FR04 118
writeline:(0,FR420,NFR420,3,3)#                                         FR04 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FR04 120
ifne:(FTHRSH,0.)#                      Test for fobs threshold          FR04 121
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FR04 122
ncodefld:(FTHRSH,1,FR421,350722.,1)#   Format threshold                 FR04 123
ncodefld:(FLOAT(MODTHR),1,FR421,500713.,1)# Format thresh modulus       FR04 124
writeline:(0,FR421,NFR421,3,3)#                                         FR04 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FR04 126
#                                                                       FR04 127
#   SET UP FILE FOR MAP OF R FACTOR/CORRELATION COEFFICIENTS            FR04 128
#   --------------------------------------------------------            FR04 129
#                                                                       FR04 130
RSIZ=24 ; writepkt:(3,21,RSIZ,IPO)#    Get a packet pointer             FR04 131
DO J=1,3#                              Loop over the three space        FR04 132
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FR04 133
JJ=IPO+J ; QX(JJ  )=FLOAT(ORGX(J)) ; QX(JJ+3)=FLOAT(INCX(J))#           FR04 134
QX(JJ+6)=FLOAT(NG(J)) ; QX(JJ+9)=FLOAT(NP(J))#                          FR04 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FR04 136
QX(IPO+13)=3.0 ; QX(IPO+14)=2.0 ; QX(IPO+15)=1.0# Z slow;y mid;x fast   FR04 137
QX(IPO+16)=3.0 ; QX(IPO+17)=2.0 ; QX(IPO+18)=1.0# Isum, jsum            FR04 138
QX(IPO+19)=0.0 ; QX(IPO+20)=0.0#                                        FR04 139
QX(IPO+21)=5.0#                        Pretend its an fo map            FR04 140
QX(IPO+22)=1.0 ; QX(IPO+23)=1.0 ; QX(IPO+24)=1.0# Pseudo pass & scale   FR04 141
#                                                                       FR04 142
#   SEARCH LR LRREFL: POINTERS & CONSTRUCT O/P                          FR04 143
#   -------------------------------------------                         FR04 144
#                                                                       FR04 145
DO I=1,NTYP;  IWNT(I)=500+I#           Set scat.fac. idnums             FR04 146
IWNT(NTYP+1)=NMDS+304#                 Set frel idnum                   FR04 147
IWNT(NTYP+2)=NMDS+308#                 Set jcode idnum                  FR04 148
IWNT(NTYP+3)=NMDS+309#                 Set nscl idnum                   FR04 149
IWNT(NTYP+4)=1 ;IWNT(NTYP+5)=2#        Set hkl and stol idnums          FR04 150
IWNT(NTYP+6)=NMDS+302#                 Set frel**2 too                  FR04 151
KEY(1)=0;     KEY(2)=NTYP+6#           Set search delimiters            FR04 152
KEY(4)=0;     KEY(3)=NTYP+6#           Set search delimiters            FR04 153
indexpkt:(1,lrrefl:,LPAK,IP,0,KEY,IWNT,IREL)# Search rel pointers       FR04 154
#                                                                       FR04 155
DO I=1,NTYP#                           Loop over atom types             FR04 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FR04 157
IF(IFFF==yes:&IREL(I)==0) iquit:(FR0401)# No ff......50401              FR04 158
IF(NEUT==no:) OFF(I)=MARK3+(I-1)*NSCF+1# Get ff table offset            FR04 159
ELSE          OFF(I)=QX(MARK3+I)#      Store neutron ff                 FR04 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FR04 161
#                                                                       FR04 162
IRF=IREL(NTYP+1) ; IRF2=IREL(NTYP+6)#  Frel and frel**2                 FR04 163
IF(IRF<=0&IRF2<=0) iquit:(FR0403)#     Must have some form of f         FR04 164
IRJ=IREL(NTYP+2)#                      Rcode pointer                    FR04 165
IRS=IREL(NTYP+3)#                      Scale pointer                    FR04 166
IRH=IREL(NTYP+4);  IRL=IREL(NTYP+5)#   Hkl and stol pointers            FR04 167
writeline:(0,0,0,1,3);  LINRM=4#       Prepare for fc listing           FR04 168
#                                                                       FR04 169
#   SETUP SIN/COS TABLE IF NEEDED                                       FR04 170
#   -----------------------------                                       FR04 171
#                                                                       FR04 172
MARKR=MARK7#                           Set up for map storage           FR04 173
IF(ISIN==yes:)#                        Test if table requested          FR04 174
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FR04 175
IF(MARK7+452<=QXMAX)#                  Check if enough memory           FR04 176
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FR04 177
incrqx:(MARKR,MARK7+452,-FR0402)#      Expand qx for sin/cos tables     FR04 178
FOR(I=MARK7;I<MARKR;I=I+1)#            Loop over degree intervals       FR04 179
QX(I+1)=SIN(FLOAT(I-MARK7)*.0174532925)# Sine 0/s/449                   FR04 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FR04 181
ELSE ISIN=no:#                         Shutoff table lookup             FR04 182
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FR04 183
#                                                                       FR04 184
RETURN#                                                                 FR04 185
END#                                                                    FR04 186
systemheader:(FR05)#                   Calculate structure factors      FR05   1
# ####################################################################  FR05   2
#                                                                       FR05   3
#                                FR05                                   FR05   4
#                                                                       FR05   5
# ####################################################################  FR05   6
SUBROUTINE FR05#                       W. furey 1984, j. stewart 1987   FR05   7
include:(AACOMN)#                                                       FR05   8
include:(FRCOMN)#                                                       FR05   9
#                                                                       FR05  10
#    PROGRAM TO COMPUTE R FACTOR MAPS WHERE R (BASED ON F) IS           FR05  11
#    COMPUTED AT EACH GRID POINT IN THE MAP.  THERE ARE TWO TYPES       FR05  12
#    OF INPUT "MOLECULES" WHICH ENTER THE R CALCULATION.  THE FIRST     FR05  13
#    (MOLECULE 1) CONTAINS ATOMS TO BE HELD FIXED AT THEIR INPUT        FR05  14
#    POSITIONS, WHEREAS ATOMS IN MOLECULE 2 ARE TRANSLATED RELATIVE     FR05  15
#    TO THEIR INPUT POSITIONS.                                          FR05  16
#    PROGRAM WRITTEN BY W. FUREY, VA MEDICAL CENTER AND UNIV. OF        FR05  17
#    PITTSBURGH, DEPT OF CRYSTALLOGRAPHY, SEPTEMBER,  1983              FR05  18
#    MODIFIED TO ACCOMODATE ANY SPACE GROUP, CHANGE SYMMETRY LOOPS      FR05  19
#    TO UTILIZE TRANSFORMED INDICES, SPEED UP FINAL R CALCULATION,      FR05  20
#    BY  W. FUREY   FEBRUARY 2, 1984                                    FR05  21
#                                                                       FR05  22
#    ADAPTED TO XTAL AND RATMAC BY J. STEWART IN DECEMBER 1987          FR05  23
#                                                                       FR05  24
# SUGGESTED IMPROVEMENT-  NESTING WITHIN THE INNER TRANSLATION LOOPS    FR05  25
# SHOULD PROBABLY BE REVERSED SUCH THAT LOOPS OVER NSYM ARE OUTERMOST.  FR05  26
# THIS HOWEVER, ALSO WOULD REQUIRE MUCH ADDITIONAL STORAGE AS REAL AND  FR05  27
# IMAGINARY COMPONENTS MUST THEN BE STORED AT EACH GRID POINT UNTIL     FR05  28
# ALL POINTS ARE PROCESSED FOR ANY GIVEN REFLECTION. W.F.               FR05  29
#                                                                       FR05  30
REAL A1#                               Real s.f. components             FR05  31
REAL ARG,ARGX,ARGY,ARGZ#               Various 2pi(hk+ky+lz) terms      FR05  32
REAL B1#                               Imag s.f. components             FR05  33
REAL C#                                Cos(arg)                         FR05  34
REAL CODE#                             Bdf reflection code              FR05  35
REAL A2(96),B2(96)#                                                     FR05  36
REAL CX(96),CY(96),CZ(96)#                                              FR05  37
REAL SX(96),SY(96),SZ(96)#                                              FR05  38
REAL A(96),A0(96),AA(96)#                                               FR05  39
REAL B(96),B0(96),BB(96)#                                               FR05  40
REAL FA,FB,FC#                         Calculated structure factor te   FR05  41
REAL FCSQ#                             Fc**2                            FR05  42
REAL FIMAG,FREAL#                      More calc structure factors      FR05  43
REAL FREL#                             Obs structure factors            FR05  44
REAL H(3),HNOPI(3)#                    Miller indices & products        FR05  45
REAL HT(3)#                            Transformed miller indices       FR05  46
REAL PSHIFT#                                                            FR05  47
INTEGER I,II,III,J,K,KK#               Working indices                  FR05  48
INTEGER IFIRST#                        Signal first reflection hit      FR05  49
INTEGER IPP,IPO#                       Packet pointers for i/o          FR05  50
INTEGER IPUT#                          Pointer for storing map          FR05  51
INTEGER ISCG#                          Scale factor group pointer       FR05  52
INTEGER NRF,NRFCON#                    No. refs found/used              FR05  53
INTEGER NSYM#                          Local for nrot in common         FR05  54
INTEGER N1,N2,N3#                      Loop indices for z,y,x           FR05  55
INTEGER PATOM#                         Pointer to atoms in qx           FR05  56
REAL SF(16)#                           Dynamic scattering factors       FR05  57
INTEGER RSIZ#                          Packet size for scratch file     FR05  58
REAL S#                                Sin(arg)                         FR05  59
REAL SCL#                              Frel scale factor                FR05  60
REAL STOL,SLS#                         St/l & 8*pi**2*s**2t/l**2        FR05  61
REAL TMP#                              Exp(-b*sls)*f(atom type)         FR05  62
#                                                                       FR05  63
chardata:(FR51,    H   K   L      FREL    $#                            FR05  64
FCAL    ACAL    BCAL    DELF     X     Y     Z)#                        FR05  65
chardata:(FR05B, REFLECTIONS ON INPUT BDF             )#                FR05  66
chardata:(FR05A, FREL RESCALE FACTOR                  )#                FR05  67
chardata:(FR05C, REFLECTIONS USED IN R MAP            )#                FR05  68
realdata:(FMT,[$#                                                       FR05  69
50413.,90413.,130413.,231022.,310822.,390822.,#                         FR05  70
470822.,550822.,610513.,670513.,730513.])#                              FR05  71
realdata:(TOPI,[6.2831853])#           Twice pi                         FR05  72
datastuff:#                                                             FR05  73
#                                                                       FR05  74
#    INITIALIZE SUMS AND COUNTS FOR STRUCTURE FACTOR CALCULATION        FR05  75
#    -----------------------------------------------------------        FR05  76
#                                                                       FR05  77
NSYM=NROT ; NRF=0 ; SUMFO=0. ; SUMFC2=0.#                               FR05  78
SMFOFC=0. ; SUMFR2=0. ; NRFCON=0#                                       FR05  79
RSIZ=2*NSYM+6#                         Set packet size for fcs          FR05  80
#                                                                       FR05  81
#    LOOP OVER REFLECTION PACKETS (LRREFL:)                             FR05  82
#    --------------------------------------                             FR05  83
#                                                                       FR05  84
REPEAT#                                Loop over refln packets          FR05  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FR05  86
readwpkt:(1,lrrefl:,LPAK,IPP,0)#       Point to input packet            FR05  87
IF(IPP<=0) BREAK#                      Exit after last packet           FR05  88
#                                                                       FR05  89
NRF=NRF+1#                             Count reflections input          FR05  90
STOL=QX(IPP+IRL)#                      Extract st/l                     FR05  91
IF((STOL<SMIN)\(STOL>SMAX)) NEXT#      Skip if outside s limits         FR05  92
SLS=78.9568*STOL**2#                   Get 8pi**2*(st/l)**2             FR05  93
#                                                                       FR05  94
#  EXTRACT & SCALE F-RELATIVE                                           FR05  95
#  --------------------------                                           FR05  96
#                                                                       FR05  97
IF(IRF>0) FREL=QX(IPP+IRF)#            Frel is on bdf                   FR05  98
ELSE FREL=SQRT(QX(IPP+IRF2))#          Frel**2 is on bdf                FR05  99
J=IPP+IRS#                             Point to scale group             FR05 100
IF(IRS==0) ISCG=MARK4+1#               Point to scale one               FR05 101
ELSE       ISCG=MARK4+NINT(QX(J))#     Point to scale group             FR05 102
FREL=FREL*QX(ISCG)#                    Scale measured s.f.              FR05 103
IF(IRJ>0) CODE=QX(IPP+IRJ)#            Extract reflection code          FR05 104
IF(CODE>REJF) NEXT#                    Skip rejected reflections        FR05 105
gethkl:(IPP+IRH,H)#                    Extract signed h,k,l             FR05 106
IF(ABS(H(1))>MAXH) NEXT#               Skip if /h/ too big              FR05 107
IF(ABS(H(2))>MAXK) NEXT#               Skip if /k/ too big              FR05 108
IF(ABS(H(3))>MAXL) NEXT#               Skip if /l/ too big              FR05 109
IF(FREL<FTHRSH&MOD(NRF,MODTHR)>0) NEXT# Reject low depending            FR05 110
IF(MOD(NRF,MODREF)==0) NEXT#           Reject every nth refl            FR05 111
NRFCON=NRFCON+1#                       Count contributor                FR05 112
DO I=1,3 ; H(I)=H(I)*TOPI#             Multiply h,k,l by 2 pi           FR05 113
DO I=1,NTYP#                           Loop over all atom types         FR05 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FR05 115
IF(IREL(I)>0) SF(I)=QX(IPP+IREL(I))#                                    FR05 116
ELSE IF(NEUT==yes:) SF(I)=OFF(I)#                                       FR05 117
ELSE#                                  Must interpolate s.f. from tab   FR05 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FR05 119
J=OFF(I)+NINT(STOL/DSTL)#              Point to ff table                FR05 120
SF(I)=QX(J)#                           Extract closest ff               FR05 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FR05 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FR05 123
#                                                                       FR05 124
#    CALCULATE A1,B1,A2 AND B2 I.E. REAL AND IMAGINARY PARTS OF         FR05 125
#    STRUCTURE FACTOR CONTRIBUTIONS FROM MOLECULES 1 AND 2,             FR05 126
#    RESPECTIVELY, AT THEIR INPUT POSITIONS FOR EACH REFLECTION.        FR05 127
#    FOR MOLECULE 2, KEEP COMPONENTS ARISING FROM EACH SYMMETRY         FR05 128
#    RELATED POSITION SEPARATE.                                         FR05 129
#                                                                       FR05 130
A1=0. ; B1=0.#                         Clear real and imaginary         FR05 131
III=MARK1-12#                          Set symmetry pointer             FR05 132
DO II=1,NSYM#                          Loop over symops                 FR05 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FR05 134
III=III+12 ; KK=0 ; PSHIFT=0. ; DO J=1,3#                               FR05 135
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FR05 136
HT(J)=0. ; DO K=1,3#                                                    FR05 137
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FR05 138
KK=KK+1; HT(J)=HT(J)+QX(III+KK)*H(K)#  Matrix multiply h times r        FR05 139
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FR05 140
PSHIFT=PSHIFT+H(J)*QX(III+J+9)#        Form h dot t                     FR05 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FR05 142
PATOM=MARK6-IATM#                      Get ready to fetch atom params   FR05 143
A2(II)=0. ; B2(II)=0.#                 Reset sf components              FR05 144
#                                                                       FR05 145
IF(NATM1!=0)#                          ******* mol 1 ********           FR05 146
DO I=1,NATM1#                          Loop over atoms in molecule 1    FR05 147
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FR05 148
PATOM=PATOM+IATM ; J=NINT(QX(PATOM+1))# Get scat fac pointer            FR05 149
TMP=SF(J)*QX(PATOM+5)*EXP(-QX(PATOM+6)*SLS)# Scale by mult and d.p.     FR05 150
ARG=PSHIFT+HT(1)*QX(PATOM+2)+HT(2)*QX(PATOM+3)+HT(3)*QX(PATOM+4)#       FR05 151
A1=A1+TMP*COS(ARG) ;  B1=B1+TMP*SIN(ARG)# Store a & b of fc             FR05 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FR05 153
#                                                                       FR05 154
DO I=1,NATM2#                          ******* mol 2 *******            FR05 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FR05 156
PATOM=PATOM+IATM ; J=NINT(QX(PATOM+1))# Get scat fac pointer            FR05 157
TMP=SF(J)*EXP(-QX(PATOM+6)*SLS)#       Scale by disp.parameter          FR05 158
ARG=PSHIFT+HT(1)*QX(PATOM+2)+HT(2)*QX(PATOM+3)+HT(3)*QX(PATOM+4)#       FR05 159
A2(II)=A2(II)+TMP*COS(ARG) ; B2(II)=B2(II)+TMP*SIN(ARG)#                FR05 160
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FR05 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FR05 162
#                                                                       FR05 163
#    COMPUTE TOTAL STRUCTURE FACTOR AND SAVE CONTRIBUTIONS FROM         FR05 164
#    EACH EQUIVALENT POSITION FOR MOLECULE 2 ON SCRATCH FILE D.         FR05 165
#    ----------------------------------------------------------         FR05 166
#                                                                       FR05 167
FA=A1 ; FB=B1#                         Start with the fixed atoms       FR05 168
DO II=1,NSYM#                          Loop back over the symops agai   FR05 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FR05 170
FA=FA+A2(II) ; FB=FB+B2(II)#           Gather in the stepped atoms      FR05 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FR05 172
FCSQ=FA**2+FB**2 ; SUMFO=SUMFO+FREL ; SUMFC2=SUMFC2+FCSQ#               FR05 173
SMFOFC=SMFOFC+FREL*SQRT(FCSQ)#         Get sum of fo*fc                 FR05 174
SUMFR2=SUMFR2+FREL**2#                 Get sum of fo squared            FR05 175
#                                                                       FR05 176
#    WRITE REFLECTION INFORMATION TO FILE D FOR FUTURE FC WORK          FR05 177
#    ---------------------------------------------------------          FR05 178
#                                                                       FR05 179
writepkt:(4,27,RSIZ,IPO)#              Get packet pointer for record    FR05 180
QX(IPO+1)=H(1) ; QX(IPO+2)=H(2) ; QX(IPO+3)=H(3)# F(h,k,l)              FR05 181
QX(IPO+4)=FREL ; QX(IPO+5)=A1 ; QX(IPO+6)=B1#                           FR05 182
II=IPO+7 ; DO J=1,NSYM#                                                 FR05 183
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FR05 184
QX(II)=A2(J) ; QX(II+1)=B2(J) ; II=II+2#                                FR05 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FR05 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FR05 187
writepkt:(4,endrecord:,RSIZ,IPO)#      End off file d and rewind        FR05 188
#                                                                       FR05 189
#    DETERMINE SCALE FACTOR BY LEAST SQUARES FIT AT INPUT POSITIONS     FR05 190
#    --------------------------------------------------------------     FR05 191
#                                                                       FR05 192
ncodefld:(FLOAT(NRF),1,FR05B,350513.,1)# Total reflections              FR05 193
writeline:(0,FR05B,NFR05B,3,3)#                                         FR05 194
ncodefld:(FLOAT(NRFCON),1,FR05C,350613.,1)# Encode contributors         FR05 195
writeline:(0,FR05C,NFR05C,3,3)#                                         FR05 196
SCL=SUMFC2/AMAX1(1.0,SMFOFC)#          Get f rel rescale factor         FR05 197
ncodefld:(SCL,1,FR05A,351052.,1)#      Encode rescale factor            FR05 198
writeline:(0,FR05A,NFR05A,2,3)#        And report it out                FR05 199
#                                                                       FR05 200
#    INITIALIZE R FACTOR MAP                                            FR05 201
#    -----------------------                                            FR05 202
#                                                                       FR05 203
incrqx:(STOPR,MARKR+STEPR*NGRX*NGRY*NGRZ,FR0507)# F                     FR05 204
IFIRST=yes:#                           Signal for reflection list       FR05 205
#                                                                       FR05 206
#    BEGIN R FACTOR TRANSLATION SEARCH                                  FR05 207
#    ---------------------------------                                  FR05 208
#                                                                       FR05 209
REPEAT#                                                                 FR05 210
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FR05 211
readwpkt:(4,27,RSIZ,IPP,0)#                                             FR05 212
IF(IPP<=0) BREAK#                                                       FR05 213
H(1)=QX(IPP+1) ; H(2)=QX(IPP+2) ; H(3)=QX(IPP+3)# Get back 2*pi*h etc   FR05 214
FREL=QX(IPP+4) ; A1=QX(IPP+5) ; B1=QX(IPP+6)#                           FR05 215
II=IPP+7 ; DO I=1,NSYM#                                                 FR05 216
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FR05 217
A2(I)=QX(II) ; B2(I)=QX(II+1) ; II=II+2#                                FR05 218
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FR05 219
III=MARK1-12 ; DO II=1,NSYM#           Loop over symops                 FR05 220
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FR05 221
III=III+12 ; KK=0 ; DO J=1,3#                                           FR05 222
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FR05 223
HT(J)=0. ; DO K=1,3#                   Remake transformed indices       FR05 224
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FR05 225
KK=KK+1; HT(J)=HT(J)+QX(III+KK)*H(K)#  Matrix multiply h times r        FR05 226
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FR05 227
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FR05 228
#                                                                       FR05 229
#    GET PHASE VALUES CORRESPONDING TO SHIFTS OF ONE GRID POINT         FR05 230
#    IN EACH OF THE X,Y AND Z DIRECTIONS                                FR05 231
#    ----------------------------------------------------------         FR05 232
#                                                                       FR05 233
ARGX=HT(1)*REGPAR(3) ; ARGY=HT(2)*REGPAR(6) ; ARGZ=HT(3)*REGPAR(9)#     FR05 234
CX(II)=COS(ARGX) ; SX(II)=SIN(ARGX) ; CY(II)=COS(ARGY)#                 FR05 235
SY(II)=SIN(ARGY) ; CZ(II)=COS(ARGZ) ; SZ(II)=SIN(ARGZ)#                 FR05 236
#                                                                       FR05 237
#    ADJUST A AND B VALUES TO CORRESPOND TO SHIFT OF XMIN, YMIN, ZMIN   FR05 238
#    MINUS ONE GRID POINT IN EACH DIRECTION FOR EACH EQUIVALENT         FR05 239
#    POSITION FOR MOLECULE 2.                                           FR05 240
#    ----------------------------------------------------------------   FR05 241
#                                                                       FR05 242
ARG=HT(1)*REGPAR(1)+HT(2)*REGPAR(4)+HT(3)*REGPAR(7)-ARGX-ARGY-ARGZ#     FR05 243
C=COS(ARG) ; S=SIN(ARG)#                                                FR05 244
A0(II)=A2(II)*C-B2(II)*S ; B0(II)=B2(II)*C+A2(II)*S#                    FR05 245
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FR05 246
#                                                                       FR05 247
#    FINALLY, LOOP OVER ALL POINTS IN THE DESIRED REGION                FR05 248
#    ---------------------------------------------------                FR05 249
#                                                                       FR05 250
IPUT=MARKR-STEPR ; DO N3=1,NGRZ#       Loop over translations along z   FR05 251
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FR05 252
DO II=1,NSYM#                          Loop over symops again           FR05 253
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FR05 254
A(II)=A0(II)*CZ(II)-B0(II)*SZ(II) ; B(II)=B0(II)*CZ(II)+A0(II)*SZ(II)#  FR05 255
A0(II)=A(II) ; B0(II)=B(II)#                                            FR05 256
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FR05 257
DO N2=1,NGRY#                          Loop over translations along y   FR05 258
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FR05 259
DO II=1,NSYM#                          And the blessed symops           FR05 260
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FR05 261
AA(II)=A(II)*CY(II)-B(II)*SY(II) ; BB(II)=B(II)*CY(II)+A(II)*SY(II)#    FR05 262
A(II)=AA(II) ; B(II)=BB(II)#                                            FR05 263
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FR05 264
DO N1=1,NGRX#                          Loop over translations along x   FR05 265
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FR05 266
#                                                                       FR05 267
#    INITIALIZE WITH FIXED ATOM CONTRIBUTIONS (MOLECULE 1)              FR05 268
#    -----------------------------------------------------              FR05 269
#                                                                       FR05 270
FA=A1 ; FB=B1#                                                          FR05 271
#                                                                       FR05 272
#    FORM COMPLETE STRUCTURE FACTOR AT THE NEW POSITION BY ADDING       FR05 273
#    CONTRIBUTIONS FROM EACH EQUIVALENT POSITION                        FR05 274
#    ------------------------------------------------------------       FR05 275
#                                                                       FR05 276
DO II=1,NSYM#                          The symops again, with feeling   FR05 277
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FR05 278
FREAL=AA(II)*CX(II)-BB(II)*SX(II) ; FIMAG=BB(II)*CX(II)+AA(II)*SX(II)#  FR05 279
AA(II)=FREAL ; BB(II)=FIMAG ; FA=FA+FREAL ; FB=FB+FIMAG#                FR05 280
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FR05 281
FC=SQRT(FA**2+FB**2)#                                                   FR05 282
#                                                                       FR05 283
#    INCREMENT NUMERATOR FOR R FACTOR AT THIS GRID POINT                FR05 284
#    ---------------------------------------------------                FR05 285
#                                                                       FR05 286
IPUT=IPUT+STEPR ; QX(IPUT+1)=QX(IPUT+1)+ABS(FREL-FC)#                   FR05 287
IF(WEIGHT<1.0)#                        Test for correlations too        FR05 288
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FR05 289
QX(IPUT+2)=QX(IPUT+2)+FREL*FC#         Get cross product                FR05 290
QX(IPUT+3)=QX(IPUT+3)+FC**2#           Get sum of fc squared            FR05 291
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FR05 292
#                                                                       FR05 293
#    LIST REFLECTIONS IF REQUESTED                                      FR05 294
#    -----------------------------                                      FR05 295
#                                                                       FR05 296
IF(ABS(FREL-FC)>DLIS\NLIS>0)#          List if large difference         FR05 297
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FR05 298
IF(IFIRST==yes:)#                      Watch for first encounter        FR05 299
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FR05 300
IFIRST=no: ; LINRM=8#                                                   FR05 301
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FR05 302
BUFOT(1)=FREL#                         Store measured s.f.              FR05 303
BUFOT(2)=FC#                           Store total fc                   FR05 304
BUFOT(3)=FA#                           Store real part of fc            FR05 305
BUFOT(4)=FB#                           Store imag part of fc            FR05 306
BUFOT(5)=ABS(FREL-FC)#                 Store fdiff                      FR05 307
BUFOT(6)=FLOAT(N1)#                    At point in x scan               FR05 308
BUFOT(7)=FLOAT(N2) ; BUFOT(8)=FLOAT(N3)#                                FR05 309
DO II=1,3 ; HNOPI(II)=H(II)/TOPI#      Take two pi back out             FR05 310
ncodefld:(HNOPI,1,CHROT,FMT,3)#        Format h,k,l                     FR05 311
ncodefld:(BUFOT,1,CHROT,FMT(4),8)#     Format frel, etc.                FR05 312
writeline:(0,FR51,NFR51,1,1)#          Print all data                   FR05 313
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FR05 314
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FR05 315
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FR05 316
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FR05 317
NLIS=NLIS-1#                           Count down lines                 FR05 318
#                                                                       FR05 319
#    END OF TRANSLATION LOOP FOR REFLECTION, DO NEXT REFLECTION         FR05 320
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FR05 321
#                                                                       FR05 322
RETURN#                                                                 FR05 323
END#                                                                    FR05 324
systemheader:(FR06)## Calculate r map and send to FOURR like bdf        FR06   1
######################################################################  FR06   2
#                                                                    #  FR06   3
#                               FR06                                 #  FR06   4
#                                                                    #  FR06   5
######################################################################  FR06   6
SUBROUTINE FR06#                       J.m. stewart dec 1987            FR06   7
include:(AACOMN)#                                                       FR06   8
include:(FRCOMN)#                                                       FR06   9
#                                                                       FR06  10
REAL C,CMAX#                           Correlation coefficients         FR06  11
REAL FMTA(21)#                         Format for map printing          FR06  12
REAL FMTB(21)#                         Format for map printing          FR06  13
INTEGER IPO,ISTOP,ISTRT#                                                FR06  14
INTEGER I,II,J,JJ#                     Misc. subscripts                 FR06  15
INTEGER JX,JY,JZ#                      Loop indices                     FR06  16
INTEGER N1,N2,N3#                      More loop indices                FR06  17
INTEGER NGI#                           Misc loop maximum                FR06  18
REAL P,PMAX#                           Combined coefficients            FR06  19
REAL RMIN#                             R minimum for survey             FR06  20
REAL RBEST(3),PBEST(3),CBEST(3)#       Coordinates of most promising    FR06  21
INTEGER IRBEST(3),IPBEST(3),ICBEST(3)# Points in the three spaces       FR06  22
INTEGER STPLAY,STPLIN#                 Three-d storage steppers         FR06  23
REAL Z#                                Z coordinate for print-out       FR06  24
chardata:(FR06A, FUNCTION       VALUE       DX        $#                FR06  25
DY        DZ)#                                                          FR06  26
chardata:(FR06B,MINIMUM R)#                                             FR06  27
chardata:(FR06C,MAX CORRELATION)#                                       FR06  28
chardata:(FR06D,MAX COMBINED CORR/R)#                                   FR06  29
chardata:(FR06E, *** SECTION DZ =        ***)#                          FR06  30
chardata:(FR06F, DX ACROSS )#                                           FR06  31
chardata:(FR06G, DY=)#                                                  FR06  32
chardata:(FR06L,[ THE FUNCTION ((1-W)*10*C+1)*(W/R+1) $#                FR06  33
WRITTEN AS AN R MAP ])#                                                 FR06  34
chardata:(FR06M,[ THE FUNCTION (1/R + 1) $#                             FR06  35
WRITTEN AS AN R MAP ])#                                                 FR06  36
realdata:(FMTO,[331052.,431052.,531052.])#                              FR06  37
datastuff:#                                                             FR06  38
#                                                                       FR06  39
#   CALCULATE STATISTICS                                                FR06  40
#   --------------------                                                FR06  41
#    GET SUMMARY OF R VALUES AND STORE AS A 'FOURIER MAP' FOR PEKPIK    FR06  42
#    SAVE THE MAP (FOR INPUT TO PEAK SEARCH PROGRAM PEKPIK)             FR06  43
#    THE MAP WILL BE IN THE SAME FORM AS ONE FROM A FOURIER             FR06  44
#    ---------------------------------------------------------------    FR06  45
#                                                                       FR06  46
RMIN=999999.0 ; CMAX=0.0 ; PMAX=0.0#   Get ready to search              FR06  47
#                                                                       FR06  48
#    LOOP OVER ALL THE GRID POINTS IN THE R MAP                         FR06  49
#    ------------------------------------------                         FR06  50
#                                                                       FR06  51
II=MARKR-STEPR ; DO JZ=1,NGRZ ; DO JY=1,NGRY#                           FR06  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FR06  53
writepkt:(3,22,NGRX,IPO)#              One packet per line              FR06  54
DO JX=1,NGRX#                                                           FR06  55
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FR06  56
II=II+STEPR ; IF(WEIGHT<1.0)#                                           FR06  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FR06  58
C=SQRT(QX(II+2)/AMAX1(1.0,SQRT(SUMFR2*QX(II+3))))# Calculate correlat   FR06  59
P=((1.0-WEIGHT)*C*10.0+1.0)*((WEIGHT*SUMFO/AMAX1(1.0,QX(II+1)))+1.0)#   FR06  60
QX(IPO+JX)=P#                          Save correlation function for    FR06  61
IF(C>CMAX)#                            Look for highest correlation     FR06  62
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FR06  63
CMAX=C ; ICBEST(1)=JX ; ICBEST(2)=JY ; ICBEST(3)=JZ# Save point         FR06  64
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FR06  65
IF(P>PMAX)#                            Look for highest combined f      FR06  66
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FR06  67
PMAX=P ; IPBEST(1)=JX ; IPBEST(2)=JY ; IPBEST(3)=JZ# Save point         FR06  68
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FR06  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FR06  70
ELSE QX(IPO+JX)=(SUMFO/AMAX1(1.0,QX(II+1)))+1.0# 1/r to o/p             FR06  71
IF(QX(II+1)>=RMIN) NEXT#               Check for lowest r               FR06  72
RMIN=QX(II+1) ; IRBEST(1)=JX ; IRBEST(2)=JY ;  IRBEST(3)=JZ#            FR06  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FR06  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FR06  75
#                                                                       FR06  76
#    OUTPUT TRANSLATION SHIFT CORRESPONDING TO LOWEST R FACTOR          FR06  77
#    ---------------------------------------------------------          FR06  78
#                                                                       FR06  79
RBEST(1)=REGPAR(1)+FLOAT(IRBEST(1)-1)*REGPAR(3)#                        FR06  80
RBEST(2)=REGPAR(4)+FLOAT(IRBEST(2)-1)*REGPAR(6)#                        FR06  81
RBEST(3)=REGPAR(7)+FLOAT(IRBEST(3)-1)*REGPAR(9)#                        FR06  82
RMIN=RMIN/SUMFO#                                                        FR06  83
CBEST(1)=REGPAR(1)+FLOAT(ICBEST(1)-1)*REGPAR(3)#                        FR06  84
CBEST(2)=REGPAR(4)+FLOAT(ICBEST(2)-1)*REGPAR(6)#                        FR06  85
CBEST(3)=REGPAR(7)+FLOAT(ICBEST(3)-1)*REGPAR(9)#                        FR06  86
PBEST(1)=REGPAR(1)+FLOAT(IPBEST(1)-1)*REGPAR(3)#                        FR06  87
PBEST(2)=REGPAR(4)+FLOAT(IPBEST(2)-1)*REGPAR(6)#                        FR06  88
PBEST(3)=REGPAR(7)+FLOAT(IPBEST(3)-1)*REGPAR(9)#                        FR06  89
#                                                                       FR06  90
LINRM=10 ; writeline:(2,FR06A,NFR06A,3,3)#                              FR06  91
ncodefld:(RMIN,1,CHROT,221031.,1) ; ncodefld:(RBEST,1,CHROT,FMTO,3)#    FR06  92
movechar:(FR06B,1,CHROT,2,NFR06B,0) ; writeline:(0,0,0,1,3)#            FR06  93
#                                                                       FR06  94
IF(WEIGHT<1.0)#                                                         FR06  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FR06  96
ncodefld:(CMAX,1,CHROT,221031.,1) ; ncodefld:(CBEST,1,CHROT,FMTO,3)#    FR06  97
movechar:(FR06C,1,CHROT,2,NFR06B,0) ; writeline:(0,0,0,1,3)#            FR06  98
ncodefld:(PMAX,1,CHROT,221031.,1) ; ncodefld:(PBEST,1,CHROT,FMTO,3)#    FR06  99
movechar:(FR06D,1,CHROT,2,NFR06B,0) ; writeline:(0,0,0,1,3)#            FR06 100
writeline:(1,FR06L,NFR06L,3,3)#                                         FR06 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FR06 102
ELSE writeline:(1,FR06M,NFR06M,3,3)#                                    FR06 103
#                                                                       FR06 104
#    PRINT OUT R MAP IF SO REQUESTED                                    FR06 105
#    -------------------------------                                    FR06 106
#                                                                       FR06 107
IF(MAPOUT==yes:)#                      See if print-out wanted          FR06 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FR06 109
STPLIN=NGRX*STEPR ; STPLAY=NGRY*STPLIN#                                 FR06 110
FMTA(1)=100632.;FMTA(2)=170622.#       Set line formats                 FR06 111
DO J=3,21; FMTA(J)=FMTA(J-1)+60000.#   Set line formats                 FR06 112
FMTB(1)=170632.#                       Set line formats                 FR06 113
DO J=2,20; FMTB(J)=FMTB(J-1)+60000.#   Set line formats                 FR06 114
Z=REGPAR(7)-REGPAR(9)#                                                  FR06 115
#                                                                       FR06 116
#                                                                       FR06 117
DO N3=1,NGRZ#                          Loop over sections               FR06 118
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FR06 119
Z=Z+REGPAR(9) ; NGI=NGRX/20+1#                                          FR06 120
DO I=1,NGI#                            Loop over section parts          FR06 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FR06 122
#                                                                       FR06 123
ncodefld:(Z,1,FR06E,240632.,1)#        Format section header            FR06 124
writeline:(1,FR06E,NFR06E,3,3)#        Write section header             FR06 125
ISTRT=(I-1)*20+1 ; ISTOP=ISTRT+19 ; IF(ISTOP>NGRX) ISTOP=NGRX#          FR06 126
JJ=0 ; DO J=ISTRT,ISTOP#               Build x coordinates across       FR06 127
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FR06 128
JJ=JJ+1 ; BUFOT(JJ)=REGPAR(1)+FLOAT(J-1)*REGPAR(3)#                     FR06 129
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FR06 130
#                                                                       FR06 131
movechar:(FR06F,1,CHROT,1,NFR06F,0)#   Insert section subheader         FR06 132
ncodefld:(BUFOT,1,CHROT,FMTB,JJ)#      Format section subheader         FR06 133
writeline:(1,0,0,1,3)#                 Write section subheader          FR06 134
DO N2=1,NGRY#                                                           FR06 135
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FR06 136
BUFOT(1)=REGPAR(4)+FLOAT(N2-1)*REGPAR(6)# Insert line interval          FR06 137
JJ=1 ; DO N1=ISTRT,ISTOP#              Loop over grid points            FR06 138
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FR06 139
JJ=JJ+1 ; II=(N3-1)*STPLAY+(N2-1)*STPLIN+(N1-1)*STEPR+MARKR#            FR06 140
IF(WEIGHT<1.0)#                        If some correlation              FR06 141
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FR06 142
C=SQRT(QX(II+2)/AMAX1(1.0,SQRT(SUMFR2*QX(II+3))))# Calc correlation     FR06 143
BUFOT(JJ)=((1.0-WEIGHT)*C*10.0+1.0)*$# Combine c and r                  FR06 144
((WEIGHT*SUMFO/AMAX1(1.0,QX(II+1)))+1.0)# Combine c and r               FR06 145
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FR06 146
ELSE BUFOT(JJ)=(SUMFO/AMAX1(1.0,QX(II+1)))+1.0# If only r map           FR06 147
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FR06 148
movechar:(FR06G,1,CHROT,1,NFR06G,0)#   Insert line header               FR06 149
ncodefld:(BUFOT,1,CHROT,FMTA,JJ)#      Format line                      FR06 150
writeline:(0,0,0,1,3)#                 Print line                       FR06 151
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FR06 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FR06 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FR06 154
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FR06 155
#                                                                       FR06 156
writepkt:(3,endrecord:,3,IPO)#         End file and rewind r map        FR06 157
RETURN#                                                                 FR06 158
END#                                                                    FR06 159
pmacro:([no:])#                                                         FR06 160
