systemheader:(LS    )#                                                  LS     1
####################################################################    LS     2
##      Copyright (C) 2000, The Xtal System, The University of        # LS     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # LS     4
## Distributed under the GNU General Public Licence as published by   # LS     5
## the Free Software Foundation, in the hope that it will be useful   # LS     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # LS     7
## for more details.                                                  # LS     8
#                                                                  #    LS     9
#                     *** LSQPL ***                                #    LS    10
#                                                                  #    LS    11
#  THE LSQPL PROGRAM WILL DETERMINE THE LEAST-SQUARES PLANE        #    LS    12
#  THROUGH AN ASSEMBLY OF POINTS.  THE COEFFICIENTS OF THE         #    LS    13
#  EQUATION OF THE PLANE ARE GIVEN IN FRACTIONAL COORDINATES       #    LS    14
#  AND ORTHOGONAL ANGSTROM COORDINATES.                            #    LS    15
#                                                                  #    LS    16
####################################################################    LS    17
#                                                                       LS    18
include:(XMACRO)#                                                       LS    19
macro:(amx1:,ifelse:(mxbtwd:,32,DMAX1($1),AMAX1($1)))#                  LS    20
macro:(dabs:,ifelse:(mxbtwd:,32,DABS($1),ABS($1)))#                     LS    21
macro:(db:,ifelse:(mxbtwd:,32,DBLE($1),$1))#                            LS    22
macro:(dcos:,ifelse:(mxbtwd:,32,DCOS($1),COS($1)))#                     LS    23
macro:(dp:,ifelse:(mxbtwd:,32,DOUBLE PRECISION ,REAL ))#                LS    24
macro:(dsign:,ifelse:(mxbtwd:,32,DSIGN(1.0D0,$1),SIGN(1.0,$1)))#        LS    25
macro:(dsmall:,ifelse:(mxbtwd:,32,5.0D-mxsgfp:,5.0E-mxsgfp:))#          LS    26
macro:(dsqrt:,ifelse:(mxbtwd:,32,DSQRT($1),SQRT($1)))#                  LS    27
macro:(sg:,ifelse:(mxbtwd:,32,SNGL($1),$1))#                            LS    28
macro:(vsmall:,ifelse:(mxbtwd:,32,1.0D-13,1.0E-13))#                    LS    29
macro:(zero:,ifelse:(mxbtwd:,32,0.0D0,0.0))#                            LS    30
macro:(p01:,ifelse:(mxbtwd:,32,1D-2,1E-2))#                             LS    31
macro:(quart:,ifelse:(mxbtwd:,32,0.25D0,0.25))#                         LS    32
macro:(half:,ifelse:(mxbtwd:,32,0.5D0,0.5))#                            LS    33
macro:(one:,ifelse:(mxbtwd:,32,1.0D0,1.0))#                             LS    34
macro:(two:,ifelse:(mxbtwd:,32,2.0D0,2.0))#                             LS    35
macro:(three:,ifelse:(mxbtwd:,32,3.0D0,3.0))#                           LS    36
macro:(four:,ifelse:(mxbtwd:,32,4.0D0,4.0))#                            LS    37
macro:(nine:,ifelse:(mxbtwd:,32,9.0D0,9.0))#                            LS    38
macro:(two7:,ifelse:(mxbtwd:,32,27.0D0,27.0))#                          LS    39
#                                                                       LS    40
extrude:(LSCOMN)#                                                       LS    41
INTEGER ISERAL#                        Serial number of line or plane   LS    42
INTEGER ISTOP#                         Atom array pointer               LS    43
INTEGER LORP#                          Plane/line flag                  LS    44
INTEGER MARK#                          Atom array pointer               LS    45
INTEGER NSTEP#                         Atom array pointer               LS    46
REAL CDIM(3)#                          Cell dimension a,b,c             LS    47
REAL GI(3,3)#                          Reciprocal metric tensor         LS    48
REAL GR(3,3)#                          Real metric tensor               LS    49
REAL OX(3)#                            Centroid of contributing atoms   LS    50
REAL TMSAV(4,100)#                     Save plane/line normals          LS    51
REAL TR(3,3)#                          Plane normal frac to orthog      LS    52
REAL V(4,4,100)#                       Saved variance-covariance of t   LS    53
#                                                                       LS    54
#                                                                       LS    55
COMMON/COMFLS/CDIM,GI,GR,OX,TMSAV,TR,V#                                 LS    56
#                                                                       LS    57
COMMON/COMILS/ISERAL,ISTOP,LORP,MARK,NSTEP#                             LS    58
endext:#                                                                LS    59
#                                                                       LS    60
systemheader:(LS00)#                                                    LS00   1
####################################################################    LS00   2
#                                                                  #    LS00   3
#                              LS00                                #    LS00   4
#                                                                  #    LS00   5
####################################################################    LS00   6
SUBROUTINE LS00#                                                        LS00   7
include:(AACOMN)#                                                       LS00   8
include:(LSCOMN)#                                                       LS00   9
INTEGER I#                                                              LS00  10
#                                                                       LS00  11
chardata:(LS000, DEFINE NONDEF SITE END PLANE LINE)#                    LS00  12
datastuff:#                                                             LS00  13
#                                                                       LS00  14
# REQUEST INPUT FILE BUFFER                                             LS00  15
# -------------------------                                             LS00  16
#                                                                       LS00  17
IOMARK(1)=QXSTR#                       Start of file buffer             LS00  18
incrqx:(MARK,IOMARK(1)+bdfbuf:,LS0001)# Get mem                         LS00  19
ISERAL=1#                              Line/plane 1                     LS00  20
NSTEP=16#                              Words per atom                   LS00  21
readline:(LS000,NLS000)#               Read line                        LS00  22
REPEAT#                                Loop over lines/planes           LS00  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LS00  24
IF(LINID==4) BREAK#                    Exit on end line                 LS00  25
IF(LINID< 4) iquit:(LS0002)#           Plane or line required           LS00  26
CALL LS11#                             Input section                    LS00  27
CALL LS21#                             Calculation section              LS00  28
CALL LS31#                             Output section                   LS00  29
rewindbdf:(1)#                         Rewind input bdf                 LS00  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LS00  31
readwpkt:(1,endrecord:,I,I,0)#         Close the input bdf              LS00  32
#                                                                       LS00  33
RETURN#                                                                 LS00  34
END#                                                                    LS00  35
systemheader:(LS11)#                   Input section                    LS11   1
####################################################################    LS11   2
#                                                                  #    LS11   3
#                             LS11                                 #    LS11   4
#                                                                  #    LS11   5
####################################################################    LS11   6
SUBROUTINE LS11#                                                        LS11   7
include:(AACOMN)#                                                       LS11   8
include:(LSCOMN)#                                                       LS11   9
#                                                                       LS11  10
INTEGER I,J,K#                                                          LS11  11
INTEGER ICENT#                         Flag for center of symmetry      LS11  12
INTEGER II,IP#                         Pointers                         LS11  13
INTEGER IREL(8)#                       Relative pointer list            LS11  14
INTEGER KK#                            Atom storage pointer             LS11  15
INTEGER M,N#                           String limits                    LS11  16
INTEGER PSIZE#                         Packet size                      LS11  17
string:(NAME1,24)#                     Temp store of atom name          LS11  18
string:(NAME2,24)#                     Temp store of atom name          LS11  19
REAL CENSYM(3)#                        Center of symmetry               LS11  20
REAL TEMP#                             Real temp store                  LS11  21
#                                                                       LS11  22
chardata:(LS100, DEFINE NONDEF SITE END PLANE LINE)#                    LS11  23
intdata:(IWANT,[1,2,3,101,102,103,14])#                                 LS11  24
intdata:(KEY,[0,7,0,0])#                                                LS11  25
datastuff:#                                                             LS11  26
#                                                                       LS11  27
# GET CELL PARAMETERS FROM BDF                                          LS11  28
# ----------------------------                                          LS11  29
#                                                                       LS11  30
qxmemory:(MARK)#                       Reset memory each cycle          LS11  31
DO I=1,8#                              Loop over lrcell: packets        LS11  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LS11  33
readwpkt:(1,lrcell:,PSIZE,IP,0)#       Read a packet                    LS11  34
IF(IP<=0) BREAK#                       End of logical record            LS11  35
IF(I==1)#                              Direct cell parameters           LS11  36
DO J=1,3 ; CDIM(J)=QX(IP+J)#           Get a,b,c                        LS11  37
ELSE IF(I==5)#                         Transformation matrix            LS11  38
DO J=1,3#                              Column index                     LS11  39
DO K=1,3#                              Row index                        LS11  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  LS11  41
II=IP+3*(J-1)+K#                       Pointer to element               LS11  42
TR(K,J)=QX(II)#                        Get element                      LS11  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  LS11  44
ELSE IF(I==7)#                         Real metric tensor               LS11  45
DO J=1,3#                              Loop over rows                   LS11  46
DO K=1,3#                              Loop over columns                LS11  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  LS11  48
II=IP+3*(J-1)+K#                       Pointer to element               LS11  49
GR(J,K)=QX(II)#                        Get element                      LS11  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  LS11  51
ELSE IF(I==8)#                         Recip metric tensor              LS11  52
DO J=1,3#                              Loop over rows                   LS11  53
DO K=1,3#                              Loop over columns                LS11  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  LS11  55
II=IP+3*(J-1)+K#                       Pointer to element               LS11  56
GI(J,K)=QX(II)#                        Get element                      LS11  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  LS11  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LS11  59
#                                                                       LS11  60
# TREAT A **PLANE** OR **LINE** LINE                                    LS11  61
# ----------------------------------                                    LS11  62
#                                                                       LS11  63
IF(LINID==6) LORP=1#                   Line                             LS11  64
ELSE         LORP=2#                   Plane                            LS11  65
#                                                                       LS11  66
# CHECK FOR CENTER OF SYMMETRY                                          LS11  67
# ----------------------------                                          LS11  68
#                                                                       LS11  69
IF(BUFIN(1)>voidflg:)#                 Numeric field                    LS11  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  LS11  71
ICENT=yes:#                            Flag center of symmetry          LS11  72
DO I=1,3#                              Loop over coords                 LS11  73
CENSYM(I)=BUFIN(I)#                    Store coord                      LS11  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  LS11  75
ELSE ICENT=no:#                        Flag no center of symmetry       LS11  76
#                                                                       LS11  77
#-------------------------------------------------------------------    LS11  78
# STORAGE FOR EACH SITE IS AS FOLLOWS:                                  LS11  79
# <1> FLAG  -1=NON-DEFINING                                             LS11  80
#            0=DEFINING, GENERATED FROM CENTER OF SYMMETRY              LS11  81
#            1=DEFINING                                                 LS11  82
# <2> X, FRACTIONAL COORDINATES                                         LS11  83
# <3> Y, FRACTIONAL COORDINATES                                         LS11  84
# <4> Z, FRACTIONAL COORDINATES                                         LS11  85
# <5> E.S.D. X                                                          LS11  86
# <6> E.S.D. Y                                                          LS11  87
# <7> E.S.D. Z                                                          LS11  88
# <8> MAX(ANGSTOM ESD X, ESD Y, ESD Z)                                  LS11  89
# <9> DISTANCE FROM LINE OR PLANE                                       LS11  90
#<10> SIGMA DIST                                                        LS11  91
#<11> SITE NAME                                                         LS11  92
#-------------------------------------------------------------------    LS11  93
#                                                                       LS11  94
#  ENTER *DEFINE* AND *NONDEF* LINES                                    LS11  95
#  --------------------------------                                     LS11  96
#                                                                       LS11  97
ISTOP=MARK#                            Running pointer                  LS11  98
REPEAT#                                Loop over def/nodef lines        LS11  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  LS11 100
readline:(LS100,NLS100)#               Read a line                      LS11 101
IF(LINID>2) BREAK#                     Break if not a def/nodef line    LS11 102
DO K=1,mxfdim:#                        Loop over input fields           LS11 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  LS11 104
ifvo:(BUFIN(K)) BREAK#                 Exit loop on void                LS11 105
KK=ISTOP#                              Update atom list pointer         LS11 106
incrqx:(ISTOP,KK+NSTEP,LS1101)#        Request more storage             LS11 107
movector:(BLANK,1,QX(KK+11),1,24,1)#   Blank out atom name space        LS11 108
stringlim:(K,M,N)#                     Get atom name limits             LS11 109
movector:(CHRIP,M,QX(KK+11),1,N-M,0)#  Transfer atom name               LS11 110
IF(LINID==2) QX(KK+1)=-1.0#            Non-defining atom                LS11 111
ELSE         QX(KK+1)= 1.0#            Defining atom                    LS11 112
QX(KK+2)=-99999.#                      Flag as not entered yet          LS11 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  LS11 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  LS11 115
IF(MARK==ISTOP) iquit:(LS1103)#        No define or nondef lines        LS11 116
#                                                                       LS11 117
#   ENTER ATOM DATA FROM BDF                                            LS11 118
#   ------------------------                                            LS11 119
#                                                                       LS11 120
indexpkt:(1,lratom:,PSIZE,IP,0,KEY,IWANT,IREL)# Search directory        LS11 121
IF(IP>0)#                              If lratom: is present            LS11 122
REPEAT#                                Loop over atom packets           LS11 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  LS11 124
readwpkt:(1,lratom:,PSIZE,IP,0)#       Read an atom packet              LS11 125
IF(IP<=0) BREAK#                       End of logical record            LS11 126
II=IP+IREL(7)#                         Point to name                    LS11 127
movertoc:(QX(II),1,NAME1,1,24,0)#      Store name of bdf atom           LS11 128
FOR(K=MARK;K<ISTOP;K=K+NSTEP)#         Loop over atom list              LS11 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  LS11 130
movertoc:(QX(K+11),1,NAME2,1,24,0)#    Store name of atom in list       LS11 131
IF(NAME1==NAME2) BREAK#                If match exit search loop        LS11 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  LS11 133
IF(K>=ISTOP) NEXT#                     Atom name not found              LS11 134
DO J=1,6#                              Loop over items                  LS11 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 LS11 136
I=IP+IREL(J)#                          Point to coord or sigma          LS11 137
IF(I>IP) QX(J+K+1)=QX(I)#              Store active coord or sigma      LS11 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 LS11 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  LS11 140
#                                                                       LS11 141
#   ENTER *SITE* LINES                                                  LS11 142
#   ------------------                                                  LS11 143
#                                                                       LS11 144
WHILE(LINID==3)#                       For all site lines               LS11 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 LS11 146
movechar:(BLANK,1,NAME1,1,24,1)#       Blank out site name              LS11 147
stringlim:(1,N,M)#                     Get char string limits           LS11 148
movechar:(CHRIP,N,NAME1,1,M-N,0)#      Insert site name                 LS11 149
FOR(K=MARK;K<ISTOP;K=K+NSTEP)#         Loop over atoms list             LS11 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 LS11 151
movertoc:(QX(K+11),1,NAME2,1,24,0)#    Transfer atom name               LS11 152
IF(NAME1==NAME2) BREAK#                Test for match                   LS11 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 LS11 154
IF(K>=ISTOP) iquit:(LS1102)#           Name not recognised              LS11 155
DO I=1,6#                              Loop over coords                 LS11 156
IF(BUFIN(I+1)>voidflg:) QX(K+I+1)=BUFIN(I+1)# Store coord or sigma      LS11 157
readline:(LS100,NLS100)#               Read next input line             LS11 158
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 LS11 159
#                                                                       LS11 160
#   PREPARE ATOM LIST FOR LS CALC                                       LS11 161
#   -----------------------------                                       LS11 162
#                                                                       LS11 163
FOR(I=MARK;I<ISTOP;I=I+NSTEP)#         Loop over atoms                  LS11 164
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 LS11 165
IF(QX(I+2)<-99998.) iquit:(LS1110)#    No atom data entered             LS11 166
QX(I+8)=1.0E-5#                        Default max sd                   LS11 167
DO J=5,7#                                                               LS11 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 LS11 169
K=I+J#                                 Point to sdev                    LS11 170
QX(K)=AMAX1(QX(K),0.001/CDIM(J-4))#    Ensure nonzero sdev              LS11 171
TEMP=QX(K)*CDIM(J-4)#                                                   LS11 172
QX(I+8)=MAX(QX(I+8),TEMP)#                                              LS11 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 LS11 174
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 LS11 175
#                                                                       LS11 176
# GENERATE CENTRO-SYMMETRICALLY RELATED ATOMS                           LS11 177
# -------------------------------------------                           LS11 178
#                                                                       LS11 179
IF(ICENT==yes:)#                       Center of symmetry given         LS11 180
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 LS11 181
II=ISTOP#                              Current end of atom storage      LS11 182
FOR(I=MARK;I<II;I=I+NSTEP)#            Loop over atoms                  LS11 183
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 LS11 184
IF(QX(I+1)<0.0) NEXT#                  Skip non-defining                LS11 185
ifeq:(QX(I+2),CENSYM(1))#              X coords the same                LS11 186
ifeq:(QX(I+3),CENSYM(2))#              Y coords the same                LS11 187
ifeq:(QX(I+4),CENSYM(3))#              Z coords the same                LS11 188
NEXT#                                  Skip atom on center              LS11 189
KK=ISTOP#                              Update atom list pointer         LS11 190
incrqx:(ISTOP,ISTOP+NSTEP,LS1104)#     Request more storage             LS11 191
QX(KK+1)=0.0#                          Flag generated by symmetry       LS11 192
DO J=2,4#                              Loop over coords                 LS11 193
QX(KK+J)=2.0*CENSYM(J-1)-QX(I+J)#      New coords                       LS11 194
DO J=5,8#                              Loop over sigmas                 LS11 195
QX(KK+J)=QX(I+J)#                      Same sigmas                      LS11 196
movereal:(QX,I+11,QX,KK+11,6,0)#       Same name                        LS11 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 LS11 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 LS11 199
RETURN#                                                                 LS11 200
END#                                                                    LS11 201
systemheader:(LS21)#                   Calculation of best plane/line   LS21   1
####################################################################    LS21   2
#                                                                  #    LS21   3
#                               LS21                               #    LS21   4
#                                                                  #    LS21   5
####################################################################    LS21   6
SUBROUTINE LS21#                                                        LS21   7
include:(AACOMN)#                                                       LS21   8
include:(LSCOMN)#                                                       LS21   9
#                                                                       LS21  10
INTEGER I,J,K,L,M#                                                      LS21  11
REAL A2(2,2)#                          2x2 normal-equations matrix      LS21  12
REAL A3(3,3)#                          Least-squares matrix             LS21  13
REAL AX(3)#                            Shifted coordinates              LS21  14
REAL B2(2,2)#                          2x2 variance-covariance mat.     LS21  15
REAL D#                                Distance point to plane/line     LS21  16
REAL DD#                               Matrix determinant               LS21  17
REAL EQS(3,3)#                         Coefficients of homogeneous e    LS21  18
REAL H(3)#                             Constraint equation              LS21  19
REAL Q(3,2)#                           Variable elimination matrix      LS21  20
REAL SCALE,SCALF#                      Variance-covariance scales       LS21  21
REAL SIGTM(4)#                         Esd of tm                        LS21  22
REAL SUMTM#                            Norm constant for tm             LS21  23
REAL SUMSTM#                           Norm constant for e.s.d. tm      LS21  24
REAL TEMP#                             Temporary variable               LS21  25
REAL TM(4)#                            Plane/line normal and d          LS21  26
REAL XL(3)#                            Roots of cubic equation          LS21  27
REAL XLMOM#                            Relevant root for line/plane     LS21  28
REAL W#                                Atom weight                      LS21  29
REAL WT#                               Centroid weight                  LS21  30
#                                                                       LS21  31
chardata:(LS200, ERROR MATRIX                                      $#   LS21  32
CORRELATION MATRIX)#                                                    LS21  33
chardata:(LS201, PLANE NUMBER             )#                            LS21  34
chardata:(LS203,[ EQUATION OF PLANE AS AX+BY+CZ=D, XYZ IN $#            LS21  35
FRACTIONAL AND ORTHOGONAL UNITS])#                                      LS21  36
chardata:(LS204,        A        B        C        $#                   LS21  37
D     ESDA     ESDB     ESDC     ESDD)#                                 LS21  38
realdata:(FM1,[90842.,180842.,270842.,360842.,#                         LS21  39
450942.,540942.,630942.,720942.])#                                      LS21  40
chardata:(LS206, PLANE LINE )#                                          LS21  41
chardata:(LS207,[EQUATION OF LINE AS POINT ON LINE X(0), Y(0), Z(0)])#  LS21  42
chardata:(LS208,[     X(0)     Y(0)     Z(0)])#                         LS21  43
chardata:(LS209,        A        B        C     ESDA     ESDB     ESDC)#LS21  44
chardata:(LS210,[AND LINE DIRECTION A, B, C IN RECIPROCAL AND $#        LS21  45
ORTHOGONAL BASES])#                                                     LS21  46
datastuff:#                                                             LS21  47
#                                                                       LS21  48
# FIND THE CENTROID OF POINTS                                           LS21  49
#                                                                       LS21  50
WT=0.0#                                Zeroize weight sum               LS21  51
DO J=1,3;OX(J)=0.0#                    Zeroize centroid                 LS21  52
FOR(I=MARK;I<ISTOP;I=I+NSTEP)#         Loop over atoms                  LS21  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LS21  54
IF(QX(I+1)<0.0) NEXT#                  Skip non-defining                LS21  55
W=1.0/QX(I+8)**2;WT=WT+W#              Weight and total weight          LS21  56
DO J=1,3;OX(J)=OX(J)+W*QX(I+J+1)#      Centroid sum                     LS21  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LS21  58
DO J=1,3;OX(J)=OX(J)/WT#               Centroid coordinates             LS21  59
#                                                                       LS21  60
# FORM LS MATRIX A (3 X 3)                                              LS21  61
#                                                                       LS21  62
DO J=1,3;DO K=1,3;A3(J,K)=0.0#         Zero the matrix                  LS21  63
FOR(I=MARK;I<ISTOP;I=I+NSTEP)#         Loop over atoms                  LS21  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  LS21  65
IF(QX(I+1)<0.0) NEXT#                  Skip non-defining                LS21  66
W=1.0/QX(I+8)**2#                      Weight                           LS21  67
DO J=1,3;AX(J)=QX(I+J+1)-OX(J)#        Shifted coordinates              LS21  68
DO J=1,3;DO K=1,3;A3(J,K)=A3(J,K)+W*(AX(J)*AX(K))# Contribute to a      LS21  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  LS21  70
#                                                                       LS21  71
CALL LS62(A3,GI,XL)#                   Find cubic roots                 LS21  72
IF(LORP==1)XLMOM=AMAX1(XL(1),XL(2),XL(3))# Largest root for line        LS21  73
ELSE XLMOM=AMIN1(XL(1),XL(2),XL(3))#   Smallest root for plane          LS21  74
#                                                                       LS21  75
# EVALUATE COEFICIENTS OF HOMOGENEOUS EQUATIONS FOR RELEVANT ROOT       LS21  76
#                                                                       LS21  77
DO I=1,3; DO J=1,3; EQS(I,J)=A3(I,J)-XLMOM*GI(I,J)#                     LS21  78
#                                                                       LS21  79
# SOLVE EQUATIONS FOR THE NON-TRIVIAL SOLUTION. THIS GIVES PLANE        LS21  80
# OR LINE NORMAL.                                                       LS21  81
#                                                                       LS21  82
CALL LS63(EQS,TM)#                     Solve 3x3 homogenous equns.      LS21  83
#                                                                       LS21  84
SUMTM=0.0#                             Make tm a unit vector            LS21  85
DO I=1,3; DO J=1,3; SUMTM=SUMTM+TM(I)*GI(I,J)*TM(J)#                    LS21  86
SUMTM=1.0/SQRT(SUMTM)#                                                  LS21  87
DO I=1,3; TM(I)=SUMTM*TM(I)#                                            LS21  88
#                                                                       LS21  89
# VARIANCE - COVARIANCE MATRIX OF TM                                    LS21  90
#                                                                       LS21  91
# REDUCE THE 3 X 3 NORMAL-EQUATIONS MATRIX A3 TO DIMENSION 2 X 2 BY     LS21  92
# REMOVAL OF VARIABLE TO IMPOSE THE CONSTRAINT THAT TM IS A UNIT        LS21  93
# GEOMETRIC VECTOR. THEN INVERT THIS 2 X 2 NORMAL EQUATIONS MATRIX TO   LS21  94
# OBTAIN THE 2 X 2 VARIANCE-COVARIANCE MATRIX OF THE INDEPENDENT        LS21  95
# VARIABLES. THEN EXPAND THIS MATRIX, FIRST TO 3 X 3 FOR THE            LS21  96
# ELIMINATED COMPONENT OF TM AND THEN TO 4 X 4 FOR THE DISTANCE TO      LS21  97
# ORIGIN.                                                               LS21  98
#                                                                       LS21  99
# FIND SCALE FOR NORMAL EQUATIONS MATRIX                                LS21 100
#                                                                       LS21 101
SCALE=0.0#                                                              LS21 102
FOR(I=MARK;I<ISTOP;I=I+NSTEP)#         Loop over atoms                  LS21 103
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  LS21 104
IF(QX(I+1)<0.0) NEXT#                  Skip non-defining                LS21 105
W=1.0/QX(I+8)**2#                      Weight                           LS21 106
DO J=1,3;AX(J)=QX(I+J+1)-OX(J)#        Shifted coordinates              LS21 107
D=0.0#                                                                  LS21 108
DO J=1,3;D=D+TM(J)*AX(J)#              Distance point to plane          LS21 109
IF(LORP==1)#                           Line                             LS21 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  LS21 111
TEMP=4.0*W*D*W*D#                      Mult factor                      LS21 112
DO J=1,3; SCALE=SCALE+TEMP*(AX(J)*AX(J))# Contribute to a               LS21 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  LS21 114
ELSE#                                  Plane                            LS21 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  LS21 116
DO J=1,3;SCALE=SCALE+W*(AX(J)*AX(J))#  Contribute to a                  LS21 117
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  LS21 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  LS21 119
SCALE=3.0/SCALE#                       Scale for variance-cov matrix    LS21 120
#                                                                       LS21 121
# FORM LS MATRIX A (3 X 3)                                              LS21 122
#                                                                       LS21 123
DO J=1,3;DO K=1,3;A3(J,K)=0.0#         Zero the matrix                  LS21 124
FOR(I=MARK;I<ISTOP;I=I+NSTEP)#         Loop over atoms                  LS21 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  LS21 126
IF(QX(I+1)<0.0) NEXT#                  Skip non-defining                LS21 127
W=1.0/QX(I+8)**2#                      Weight                           LS21 128
DO J=1,3;AX(J)=QX(I+J+1)-OX(J)#        Shifted coordinates              LS21 129
D=0.0#                                                                  LS21 130
DO J=1,3;D=D+TM(J)*AX(J)#              Distance point to plane          LS21 131
IF(LORP==1)#                           Line                             LS21 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  LS21 133
TEMP=4.0*SCALE*W*D*W*D#                Mult factor                      LS21 134
DO J=1,3;DO K=1,3;A3(J,K)=A3(J,K)+TEMP*(AX(J)*AX(K))# Contribute to a   LS21 135
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  LS21 136
ELSE#                                  Plane                            LS21 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  LS21 138
DO J=1,3;DO K=1,3;A3(J,K)=A3(J,K)+SCALE*W*(AX(J)*AX(K))# Contribute t   LS21 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  LS21 140
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  LS21 141
#                                                                       LS21 142
DO I=1,3; H(I)=0.0#                    Zero constraint vector           LS21 143
DO I=1,3; DO J=1,3; H(I)=H(I)+GI(I,J)*TM(J)# Constraint vector          LS21 144
M=1#                                                                    LS21 145
DO I=1,3; IF(ABS(H(I))>ABS(H(M))) M=I# Point to largest abs hi          LS21 146
#                                      Fill up the transformation matri LS21 147
K=0#                                   To eliminate one of the three    LS21 148
DO J=1,2#                              Variables.                       LS21 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  LS21 150
K=K+1;IF(K==M) K=K+1#                                                   LS21 151
DO I=1,3#                                                               LS21 152
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 LS21 153
IF(I==M) Q(I,J)=-H(K)/H(M)#                                             LS21 154
ELSE IF(I==K) Q(I,J)=1.0#                                               LS21 155
ELSE Q(I,J)=0.0#                                                        LS21 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 LS21 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  LS21 158
DO I=1,3; DO J=1,3; V(I,J,ISERAL)=0.0# Zero variance-covariance matri   LS21 159
DO I=1,2; DO L=1,2; A2(I,L)=0.0#       Prepare collapse 3x3 to 2x2      LS21 160
SCALF=0.0#                             Scale for 2x2 matrix             LS21 161
DO I=1,2; DO J=1,3; DO K=1,3#                                           LS21 162
SCALF=SCALF+(Q(J,I)*Q(K,I))*A3(J,K)#                                    LS21 163
ifeq:(SCALF,0.0) SCALF=1.0#            Avoid silly scales               LS21 164
ELSE             SCALF=2.0/SCALF#                                       LS21 165
DO I=1,2; DO J=1,3; DO K=1,3; DO L=1,2#                                 LS21 166
A2(I,L)=A2(I,L)+(Q(J,I)*Q(K,L))*(SCALF*A3(J,K))#                        LS21 167
DD=(A2(1,1)*A2(2,2)-A2(1,2)*A2(2,1))/SCALF# Scaled determinant of 2x2   LS21 168
IF(DD>small:)#                                                          LS21 169
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 LS21 170
B2(1,1)=A2(2,2)/DD#                    Invert a2 into b2 to obtain 2x   LS21 171
B2(1,2)=-A2(2,1)/DD#                   Variance-covariance matrix       LS21 172
B2(2,1)=B2(1,2)#                                                        LS21 173
B2(2,2)=A2(1,1)/DD#                                                     LS21 174
#                                      Line removed here                LS21 175
DO I=1,3; DO J=1,2; DO K=1,2; DO L=1,3# Into 3x3 var-covar matrix       LS21 176
V(I,L,ISERAL)=V(I,L,ISERAL)+Q(I,J)*B2(J,K)*Q(L,K)#                      LS21 177
DO I=1,3; DO J=1,3; V(I,J,ISERAL)=SCALE*V(I,J,ISERAL)#                  LS21 178
DO I=1,4; V(I,4,ISERAL)=0.0#           Zero correlation                 LS21 179
DO I=1,3; DO J=1,3#                                                     LS21 180
V(4,4,ISERAL)=V(4,4,ISERAL)+OX(I)*V(I,J,ISERAL)*OX(J)# Variance d       LS21 181
DO I=1,3; DO J=1,3#                                                     LS21 182
V(I,4,ISERAL)=V(I,4,ISERAL)+V(I,J,ISERAL)*OX(J)# Covariance d tm(i)     LS21 183
DO J=1,3; V(4,J,ISERAL)=V(J,4,ISERAL)#                                  LS21 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 LS21 185
DO I=1,4; SIGTM(I)=SQRT(MAX(0.,V(I,I,ISERAL)))# Esd of values           LS21 186
#                                                                       LS21 187
TM(4)=0.0#                             Distance to origin               LS21 188
DO I=1,3; TM(4)=TM(4)+OX(I)*TM(I)#                                      LS21 189
DO I=1,4; TMSAV(I,ISERAL)=TM(I)#       Save plane/line normal           LS21 190
#                                                                       LS21 191
# PRINT SERIAL NUMBER                                                   LS21 192
# -------------------                                                   LS21 193
#                                                                       LS21 194
LINRM=10#                              Leave enough room                LS21 195
movechar:(LS203,31,CHROT,2,15,2)#      Underline header                 LS21 196
IF(LORP==1) movechar:(LS206,7,LS201,1,6,0)# Line                        LS21 197
ELSE        movechar:(LS206,1,LS201,1,6,0)# Plane                       LS21 198
ncodefld:(REAL(ISERAL),1,LS201,160213.,1)#                              LS21 199
writeline:(2,LS201,NLS201,2,3)#                                         LS21 200
IF(LORP==2)#                           Plane                            LS21 201
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 LS21 202
#                                                                       LS21 203
# EQUATION OF PLANE, X,Y,Z FRACTIONAL                                   LS21 204
# -----------------------------------                                   LS21 205
#                                                                       LS21 206
writeline:(1,LS203,NLS203,3,3)#                                         LS21 207
writeline:(0,LS204,NLS204,3,3)#                                         LS21 208
DO I=1,4#                                                               LS21 209
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 LS21 210
BUFOT(I)=TM(I)#                                                         LS21 211
BUFOT(I+4)=SIGTM(I)#                                                    LS21 212
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 LS21 213
ncodefld:(BUFOT,1,CHROT,FM1,8)#                                         LS21 214
writeline:(0,0,0,1,3)#                                                  LS21 215
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 LS21 216
ELSE#                                  Line                             LS21 217
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 LS21 218
#                                                                       LS21 219
# EQUATION OF LINE   X,Y,Z FRACTIONAL                                   LS21 220
# -----------------------------------                                   LS21 221
#                                                                       LS21 222
writeline:(1,LS207,NLS207,3,3)#                                         LS21 223
writeline:(0,LS208,NLS208,3,3)#                                         LS21 224
DO I=1,3; BUFOT(I)=OX(I)#              Centroid coordinates             LS21 225
ncodefld:(BUFOT,1,CHROT,FM1,3)#                                         LS21 226
writeline:(0,0,0,1,3)#                                                  LS21 227
writeline:(0,LS210,NLS210,3,3)#                                         LS21 228
writeline:(0,LS209,NLS209,3,3)#                                         LS21 229
DO I=1,3#                                                               LS21 230
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 LS21 231
BUFOT(I)=TM(I)#                                                         LS21 232
BUFOT(I+3)=SIGTM(I)#                                                    LS21 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 LS21 234
ncodefld:(BUFOT,1,CHROT,FM1,6)#                                         LS21 235
writeline:(0,0,0,1,3)#                                                  LS21 236
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 LS21 237
#                                                                       LS21 238
# EQUATION OF PLANE/LINE IN ORTHOGONAL ANGSTROMS                        LS21 239
# ----------------------------------------------                        LS21 240
#                                                                       LS21 241
DO I=1,3#                                                               LS21 242
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 LS21 243
SUMTM=0.0 ; SUMSTM=0.0#                Reset to zero                    LS21 244
DO J=1,3#                              Loop over columns                LS21 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 LS21 246
SUMTM=SUMTM+TM(J)*TR(I,J)#             Ith element of normal            LS21 247
SUMSTM=SUMSTM+(SIGTM(J)*TR(I,J))**2#   Esd of transformed normal        LS21 248
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 LS21 249
BUFOT(I)=SUMTM#                        Output ith element of normal     LS21 250
BUFOT(I+4)=SQRT(SUMSTM)#               Output esd                       LS21 251
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 LS21 252
IF(LORP==2)#                           Plane                            LS21 253
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 LS21 254
ncodefld:(BUFOT,1,CHROT,FM1,8)#                                         LS21 255
writeline:(0,0,0,1,3)#                                                  LS21 256
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 LS21 257
ELSE#                                                                   LS21 258
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 LS21 259
ncodefld:(BUFOT,1,CHROT,FM1,3)#                                         LS21 260
ncodefld:(BUFOT,5,CHROT,FM1(4),3)#                                      LS21 261
writeline:(0,0,0,1,3)#                                                  LS21 262
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 LS21 263
#                                                                       LS21 264
# ERROR MATRIX IN A**2 AND CORRELATION MATRIX                           LS21 265
# -------------------------------------------                           LS21 266
#                                                                       LS21 267
DO I=1,4 ; IF (SIGTM(I)<small:) SIGTM(I)=1.0#                           LS21 268
writeline:(1,LS200,NLS200,3,4)#                                         LS21 269
DO I=1,4#                                                               LS21 270
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 LS21 271
DO J=1,4#                                                               LS21 272
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 LS21 273
BUFOT(J)=V(I,J,ISERAL)#                                                 LS21 274
BUFOT(J+4)=V(I,J,ISERAL)/(SIGTM(I)*SIGTM(J))#                           LS21 275
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 LS21 276
ncodefld:(BUFOT,1,CHROT,FM1,8)#                                         LS21 277
writeline:(0,0,0,1,4)#                                                  LS21 278
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 LS21 279
#                                                                       LS21 280
RETURN#                                                                 LS21 281
END#                                                                    LS21 282
systemheader:(LS31)#                   Output section                   LS31   1
####################################################################    LS31   2
#                                                                  #    LS31   3
#                               LS31                               #    LS31   4
#                                                                  #    LS31   5
####################################################################    LS31   6
SUBROUTINE LS31#                                                        LS31   7
include:(AACOMN)#                                                       LS31   8
include:(LSCOMN)#                                                       LS31   9
#                                                                       LS31  10
REAL ANGLE#                            Inter-plane or -line angle       LS31  11
REAL AX(3)#                            Shifted coordinates              LS31  12
REAL CHI2#                             Chi**2 value                     LS31  13
REAL COST#                             Cosine interplanar angle         LS31  14
REAL D#                                Atom distance to plane/line      LS31  15
REAL ESDANG#                           Esd of interplanar angle         LS31  16
REAL GOF#                              Goodness of fit                  LS31  17
INTEGER I,J,K,L,N#                                                      LS31  18
INTEGER NO3#                           Number of degrees of freedom     LS31  19
REAL PAI#                              Convert radians to degrees       LS31  20
REAL S#                                Weighted sum of squares          LS31  21
REAL SD,SDSQ#                          Esd and variance of atom dist.   LS31  22
REAL TEMP#                             Temporary storage variable       LS31  23
#                                                                       LS31  24
chardata:(LS400, SUM W*D**2 AFTER REFINEMENT =           )#             LS31  25
chardata:(LS401,[ <CHI**2>    <GOODNESS OF FIT>    <N-3>])#             LS31  26
chardata:(LS402,[ ATOM                    DIST(A)    ESDD       $#      LS31  27
X        Y        Z])#                                                  LS31  28
chardata:(LS404, NON-DEFINING    DEFINING)#                             LS31  29
chardata:(LS405, ANGLE BETWEEN PLANES/LINES                    $#       LS31  30
ESD      )#                                                             LS31  31
chardata:(LS406, VERY LARGE E.S.D. OF INTERPLANAR ANGLE SET TO 1.0)#    LS31  32
realdata:(FM1,[320842.,400842.,480842.,570842.,660842.])#               LS31  33
datastuff:#                                                             LS31  34
#                                                                       LS31  35
PAI=57.29577951#                       Radians to degrees               LS31  36
S=0.0#                                 Weighted sum of squares          LS31  37
NO3=-3#                                Degrees of freedom               LS31  38
CHI2=0.0#                              Chi**2                           LS31  39
#                                                                       LS31  40
# CALCULATE DISTANCE AND ESD OF ATOM TO LINE/PLANE                      LS31  41
#                                                                       LS31  42
FOR(I=MARK;I<ISTOP;I=I+NSTEP)#         Atom loop                        LS31  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LS31  44
D=0.0#                                 Set distance to zero             LS31  45
DO J=1,3#                                                               LS31  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  LS31  47
AX(J)=QX(I+J+1)-OX(J)#                 Keep shifted distance            LS31  48
D=D+AX(J)*TMSAV(J,ISERAL)#             X(shifted) dot m                 LS31  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  LS31  50
IF(LORP==1)#                           Line                             LS31  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  LS31  52
D=-D*D#                                Remove x dot m contribution      LS31  53
DO J=1,3;DO K=1,3;D=D+AX(J)*GR(J,K)*AX(K)# Add atom contribution        LS31  54
D=SQRT(MAX(0.0,D))#                                                     LS31  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  LS31  56
QX(I+9)=D#                             Store distance: atom - plane/l   LS31  57
SDSQ=QX(I+8)**2#                       Esd calculation                  LS31  58
DO J=1,3;DO K=1,3;SDSQ=SDSQ+AX(J)*V(J,K,ISERAL)*AX(K)# Normal contrib   LS31  59
SD=SQRT(MAX(0.,SDSQ));QX(I+10)=SD#     Get esd(d) and store it.         LS31  60
IF(QX(I+1)<0.0) NEXT#                                                   LS31  61
NO3=NO3+1#                             Degrees of freedom               LS31  62
CHI2=CHI2+(D/SD)**2#                   Chi**2 value                     LS31  63
S=S+(D/QX(I+8))**2#                    Weighted sum of squares          LS31  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LS31  65
movechar:(BLANK,1,LS400,31,11,1)#                                       LS31  66
TEMP=S; ncodefld:(TEMP,1,LS400,410941.,1)#                              LS31  67
writeline:(1,LS400,NLS400,3,4)#                                         LS31  68
#                                                                       LS31  69
IF(NO3>0)#                             If def atoms > 3                 LS31  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  LS31  71
TEMP=REAL(NO3)#                                                         LS31  72
GOF=SQRT(MAX(0.,CHI2/TEMP))#                                            LS31  73
writeline:(1,LS401,NLS401,3,3)#                                         LS31  74
ncodefld:(CHI2,1,CHROT,80742.,1)#                                       LS31  75
ncodefld:(GOF,1,CHROT,260842.,1)#                                       LS31  76
ncodefld:(TEMP,1,CHROT,380513.,1)#                                      LS31  77
writeline:(0,0,0,1,3)#                                                  LS31  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  LS31  79
#                                                                       LS31  80
# FIND ANGLES BETWEEN PLANES AND LINES                                  LS31  81
# ------------------------------------                                  LS31  82
#                                                                       LS31  83
FOR(N=1;N<ISERAL;N=N+1)#                                                LS31  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  LS31  85
COST=0.0#                                                               LS31  86
DO I=1,3#                                                               LS31  87
DO J=1,3#                                                               LS31  88
COST=COST+TMSAV(I,ISERAL)*GI(I,J)*TMSAV(J,N)#                           LS31  89
COST=MAX(MIN(1.,COST),-1.)#            Protect cosine limits            LS31  90
ANGLE=ACOS(COST)#                                                       LS31  91
TEMP=0.0#                              Error calc. esd**2 of cos(angl   LS31  92
DO I=1,3; DO J=1,3; DO K=1,3; DO L=1,3#                                 LS31  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  LS31  94
TEMP=TEMP+TMSAV(I,N)*GI(I,J)*V(J,K,ISERAL)*GI(K,L)*TMSAV(L,N)#          LS31  95
TEMP=TEMP+TMSAV(I,ISERAL)*GI(I,J)*V(J,K,N)*GI(K,L)*TMSAV(L,ISERAL)#     LS31  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  LS31  97
TEMP=SQRT(MAX(0.,TEMP))#               Esd of cos(angle)                LS31  98
IF(TEMP>=1.0)#                         Very bad error calculation       LS31  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  LS31 100
ESDANG=1.0/PAI#                        Set to 1 degree                  LS31 101
writeline:(0,LS406,NLS406,3,3)#        Shout                            LS31 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  LS31 103
ELSE#                                                                   LS31 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  LS31 105
IF(COST>=0) ESDANG=ABS(ACOS(COST-TEMP)-ANGLE)# Esd of angle             LS31 106
ELSE ESDANG=ABS(ACOS(COST+TEMP)-ANGLE)# Esd of angle                    LS31 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  LS31 108
ANGLE=ANGLE*PAI;ESDANG=ESDANG*PAI#     Convert to degrees               LS31 109
ncodefld:(REAL(N),1,LS405,310413.,1)#                                   LS31 110
ncodefld:(REAL(ISERAL),1,LS405,360413.,1)#                              LS31 111
ncodefld:(ANGLE,1,LS405,460832.,1)#                                     LS31 112
ncodefld:(ESDANG,1,LS405,560532.,1)#                                    LS31 113
writeline:(1,LS405,NLS405,3,3)#                                         LS31 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  LS31 115
#                                                                       LS31 116
# WRITE OUT ATOM INFORMATION                                            LS31 117
# --------------------------                                            LS31 118
#                                                                       LS31 119
writeline:(1,LS402,NLS402,3,3)#                                         LS31 120
FOR(I=MARK;I<ISTOP;I=I+NSTEP)#                                          LS31 121
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  LS31 122
movertoc:(QX(I+11),1,CHROT,2,24,0)#    Insert atom label                LS31 123
IF(QX(I+1)<0.0) movechar:(LS404, 2,CHROT,13,12,0)#                      LS31 124
ELSE            movechar:(LS404,14,CHROT,13,12,0)#                      LS31 125
ifeq:(QX(I+1),0.0)#                    Centro-symmetrically generat     LS31 126
movechar:(LS401,7,CHROT,11,1,0)#       Insert asterisk                  LS31 127
ncodefld:(QX,I+2,CHROT,FM1(3),3)#                                       LS31 128
ncodefld:(QX,I+9,CHROT,FM1,2)#                                          LS31 129
writeline:(0,0,0,1,3)#                                                  LS31 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  LS31 131
ISERAL=ISERAL+1#                                                        LS31 132
RETURN#                                                                 LS31 133
END#                                                                    LS31 134
systemheader:(LS62)#                   Roots of a cubic equation        LS62   1
####################################################################    LS62   2
#                                                                  #    LS62   3
#                               LS62                               #    LS62   4
#                                                                  #    LS62   5
####################################################################    LS62   6
SUBROUTINE LS62(SA3,GI,SY)#                                             LS62   7
include:(AACOMN)#                                                       LS62   8
#                                                                       LS62   9
REAL SA3(3,3),GI(3,3)#                 Matrix and metric tensor         LS62  10
dp: DA3(3,3),DI(3,3)#                  Matrix and metric tensor (d.p.   LS62  11
dp: AA,BB,CC,DD#                                                        LS62  12
REAL SY(3)#                                                             LS62  13
dp: P,Q,R,A,B,U,VV,W,Z#                                                 LS62  14
dp: DISC,A3(3,3),SCALE#                                                 LS62  15
INTEGER I,J#                                                            LS62  16
#                                                                       LS62  17
chardata:(LS625, THE DISCRIMINANT IN THE CUBIC $#                       LS62  18
EQUATION OF THE LAGRANGIAN MULTIPLIER)#                                 LS62  19
chardata:(LS626,[ HAS BEEN SET TO ZERO. 0.0< REAL VALUE < 0.1])#        LS62  20
datastuff:#                                                             LS62  21
#                                                                       LS62  22
DO I=1,3;DO J=1,3#                                                      LS62  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LS62  24
DA3(I,J)=db:(SA3(I,J))#                                                 LS62  25
DI(I,J)=db:(GI(I,J))#                                                   LS62  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LS62  27
SCALE=(DI(1,1)+DI(2,2)+DI(3,3))/(DA3(1,1)+DA3(2,2)+DA3(3,3))# Scale     LS62  28
DO I=1,3; DO J=1,3; A3(I,J)=SCALE*DA3(I,J)# Normal equations matrix     LS62  29
#                                                                       LS62  30
# EVALUATE THE COEFFICIENTS OF THE CUBIC EQUATION IN LAMBDA AND         LS62  31
# THEN SOLVE FOR THE THREE ROOTS.                                       LS62  32
#                                                                       LS62  33
AA=DI(1,1)*DI(2,3)**2+DI(2,2)*DI(1,3)**2+DI(3,3)*DI(1,2)**2$#           LS62  34
-DI(1,1)*DI(2,2)*DI(3,3)-2.*DI(1,2)*DI(1,3)*DI(2,3)#                    LS62  35
BB=A3(1,1)*DI(2,2)*DI(3,3)+DI(1,1)*(A3(2,2)*DI(3,3)+A3(3,3)*DI(2,2))$#  LS62  36
-A3(1,1)*DI(2,3)**2-A3(2,2)*DI(1,3)**2-A3(3,3)*DI(1,2)**2+2.*($#        LS62  37
A3(1,2)*(DI(1,3)*DI(2,3)-DI(1,2)*DI(3,3))+$#                            LS62  38
A3(1,3)*(DI(1,2)*DI(2,3)-DI(1,3)*DI(2,2))+$#                            LS62  39
A3(2,3)*(DI(1,2)*DI(1,3)-DI(1,1)*DI(2,3)))#                             LS62  40
CC=DI(3,3)*A3(1,2)**2+DI(2,2)*A3(1,3)**2+DI(1,1)*A3(2,3)**2-$#          LS62  41
(A3(1,1)*(A3(2,2)*DI(3,3)+A3(3,3)*DI(2,2))+A3(2,2)*A3(3,3)*DI(1,1))$#   LS62  42
+2.*(A3(1,2)*(A3(3,3)*DI(1,2)-A3(2,3)*DI(1,3)-A3(1,3)*DI(2,3))+$#       LS62  43
A3(1,3)*(A3(2,2)*DI(1,3)-A3(2,3)*DI(1,2))+A3(1,1)*A3(2,3)*DI(2,3))#     LS62  44
DD=A3(1,1)*(A3(2,2)*A3(3,3)-A3(2,3)**2)-A3(2,2)*(A3(1,3)**2) $#         LS62  45
-A3(3,3)*(A3(1,2)**2)+2.*(A3(1,2)*A3(1,3)*A3(2,3))#                     LS62  46
#                                                                       LS62  47
IF(dabs:(AA)<vsmall:)iquit:(LS6201)#   Small lambda**3                  LS62  48
P=BB/AA; Q=CC/AA; R=DD/AA#                                              LS62  49
IF(R==zero:)#                          Zero determinant                 LS62  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  LS62  51
DISC=dsqrt:(P*P-four:*Q)#                                               LS62  52
SY(1)=0.5*sg:((-P+DISC)/SCALE)#                                         LS62  53
SY(2)=0.5*sg:((-P-DISC)/SCALE)#                                         LS62  54
SY(3)=0.0#                                                              LS62  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  LS62  56
ELSE#                                                                   LS62  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  LS62  58
A=(three:*Q-P*P)/three:#                                                LS62  59
B=(two:*P*P*P-nine:*P*Q+two7:*R)/two7:#                                 LS62  60
U=quart:*B*B; VV=-(A*A*A/two7:); DISC=U-VV#                             LS62  61
IF(DISC>p01:)iquit:(LS6202)#           Large positive disc              LS62  62
IF(DISC<=zero:) W=(-half:*B)/dsqrt:(VV)# Negative disc                  LS62  63
ELSE#                                  Small positive disc              LS62  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  LS62  65
W=dsign:(-B)#                                                           LS62  66
writeline:(1,LS625,NLS625,3,3)#                                         LS62  67
writeline:(0,LS626,NLS626,3,3)#                                         LS62  68
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  LS62  69
W=ACOS(W)/three:; Z=two:*SQRT(-A/three:); P=P/three:#                   LS62  70
DO I=1,3; SY(I)=sg:(-P+Z*dcos:(W+ $#                                    LS62  71
  ifelse:(mxbtwd:,32,2.0944D0*DBLE(I-1),2.0944*REAL(I-1))))/SCALE#      LS62  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  LS62  73
#                                                                       LS62  74
RETURN#                                                                 LS62  75
END#                                                                    LS62  76
systemheader:(LS63)#                   Solve 3 homogeneous equations    LS63   1
####################################################################    LS63   2
#                                                                  #    LS63   3
#                               LS63                               #    LS63   4
#                                                                  #    LS63   5
####################################################################    LS63   6
SUBROUTINE LS63(SC,X)#                                                  LS63   7
include:(AACOMN)#                                                       LS63   8
#                                                                       LS63   9
# THIS SUBROUTINE IS DESIGNED TO GIVE A SOLUTION FOR THREE HOMOGENEOUS  LS63  10
# EQUATIONS OF THREE UNKNOWNS. THE SOLUTION RETURNED IS OF COURSE NOT   LS63  11
# UNIQUE BUT IS PROPORTIONAL TO THE DESIRED SOLUTION. IN THE CALLING    LS63  12
# SEQUENCE C IS THE 3 X 3 MATRIX OF THE COEFFICIENTS OF THE EQUATIONS.  LS63  13
# X IS THE 3 X 1 MATRIX OF THE SOLUTION VALUES.                         LS63  14
#                                                                       LS63  15
REAL SC(3,3),X(3)#                                                      LS63  16
dp: C(3,3),AC(3,3),RCM(3),B(3,3),PM(3),STO,CM,ABM#                      LS63  17
INTEGER I,J,K,K1,K2,K3#                                                 LS63  18
INTEGER ICMAX,JCMAX#                                                    LS63  19
#                                                                       LS63  20
K1=1;K2=2;K3=3#                        Coefficient order and error      LS63  21
DO I=1,3; DO J=1,3#                                                     LS63  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LS63  23
C(I,J)=SC(I,J)#                                                         LS63  24
AC(I,J)=dabs:(C(I,J))#                 Ac with absolute values of c     LS63  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LS63  26
DO I=1,3; RCM(I)=amx1:(AC(I,1)$,AC(I,2)$,AC(I,3))# Row abs. maxima      LS63  27
CM=amx1:(RCM(1)$,RCM(2)$,RCM(3))#      Maximum ac element               LS63  28
IF(CM<dsmall:) iquit:(LS6301)#         Too small largest element        LS63  29
IF(AC(3,3)<CM)#                        Skip is ac(3,3) is largest       LS63  30
# INTERCHANGE ROWS AND COLUMNS IN C TO PUT EL. WITH MAX MAG. IN 3,3     LS63  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  LS63  32
DO I=1,3;IF(RCM(I)>=CM) ICMAX=I#       Find pointer to row max          LS63  33
DO J=1,3#                                                               LS63  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  LS63  35
STO=C(3,J);C(3,J)=C(ICMAX,J);C(ICMAX,J)=STO# Swop large row to 3        LS63  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  LS63  37
# INTERCHANGE COLUMNS. NEED TO INTERCHANGE X(I)'S BY WAY OF K1,K2,K3    LS63  38
DO J=1,3;IF(AC(ICMAX,J)>=CM) JCMAX=J#  Find pointer to col max          LS63  39
IF(JCMAX==1)#                          Pointer interchange              LS63  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  LS63  41
K1=3;K3=1#                                                              LS63  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  LS63  43
ELSE IF(JCMAX==2)#                     Pointer interchange              LS63  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  LS63  45
K2=3;K3=2#                                                              LS63  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  LS63  47
DO I=1,3#                              Column interchange               LS63  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  LS63  49
STO=C(I,3);C(I,3)=C(I,JCMAX);C(I,JCMAX)=STO# Swop large col to 3        LS63  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  LS63  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  LS63  52
# MAKE EQUIVALENCE TRANSFORMATIONS OF C INTO B                          LS63  53
B(1,1)=C(1,1)-C(3,1)*C(1,3)/C(3,3)#                                     LS63  54
B(1,2)=C(1,2)-C(3,2)*C(1,3)/C(3,3)#                                     LS63  55
B(2,1)=C(2,1)-C(3,1)*C(2,3)/C(3,3)#                                     LS63  56
B(2,2)=C(2,2)-C(3,2)*C(2,3)/C(3,3)#                                     LS63  57
B(3,1)=C(3,1)/C(3,3);B(3,2)=C(3,2)/C(3,3)#                              LS63  58
B(1,3)=zero:;B(2,3)=zero:;B(3,3)=one:#                                  LS63  59
# SOLUTION OF THE EQUIVALENCE. USE 3RD AND EITHER 1ST. OR 2ND. FOR      LS63  60
# DIVISION BY LARGEST MAGNITUDE                                         LS63  61
ABM=zero:#                                                              LS63  62
DO I=1,2; DO J=1,2; IF(dabs:(B(I,J))>ABM)#                              LS63  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  LS63  64
K=2*I+J-2;ABM=dabs:(B(I,J))#                                            LS63  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  LS63  66
IF(ABM<dsmall:)iquit:(LS6302)#         Too small a large term           LS63  67
PM(1)=one:;PM(2)=one:#                                                  LS63  68
IF(K==1) PM(1)=-B(1,2)/B(1,1)#         |b(1,1)| largest                 LS63  69
ELSE IF(K==2) PM(2)=-B(1,1)/B(1,2)#    |b(1,2)| largest                 LS63  70
ELSE IF(K==3) PM(1)=-B(2,2)/B(2,1)#    |b(2,1)| largest                 LS63  71
ELSE IF(K==4) PM(2)=-B(2,1)/B(2,2)#    |b(1,2)| largest                 LS63  72
PM(3)=-B(3,1)*PM(1)-B(3,2)*PM(2)#      The permuted solution            LS63  73
X(1)=sg:(PM(K1));X(2)=sg:(PM(K2));X(3)=sg:(PM(K3))# Permute solution    LS63  74
#                                                                       LS63  75
RETURN#                                                                 LS63  76
END#                                                                    LS63  77
pmacro:([no:])#                        Purge xtal system macros         LS63  78
