systemheader:(MH    )#                                                  MH     1
####################################################################### MH     2
##      Copyright (C) 2000, The Xtal System, The University of        # MH     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # MH     4
## Distributed under the GNU General Public Licence as published by   # MH     5
## the Free Software Foundation, in the hope that it will be useful   # MH     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # MH     7
## for more details.                                                  # MH     8
#                                                                       MH     9
#                        *** MODHKL ***                                 MH    10
#     SUBROUTINE FOR MODIFYING DATA ON SPECIFIC HKL RECORDS OF THE      MH    11
#     BINARY DATA FILE.                                                 MH    12
#                                                                       MH    13
####################################################################### MH    14
#                                                                       MH    15
include:(XMACRO)#                                                       MH    16
#                                                                       MH    17
systemheader:(MH00)#                   Modify hkl data on bdf           MH00   1
# ################################################################## #  MH00   2
#                                                                    #  MH00   3
#                               MH00                                 #  MH00   4
#                                                                    #  MH00   5
# ################################################################## #  MH00   6
SUBROUTINE    MH00#                                                     MH00   7
#                                        J.m. stewart august 1985       MH00   8
include:(AACOMN)#                      S.r. hall 1984, 1988             MH00   9
#                                                                       MH00  10
INTEGER I,J,JJ,K,IP,JP,IPAK,NPAK#                                       MH00  11
INTEGER IR,IC,IR1,IR2,IR3,IR4#                                          MH00  12
INTEGER IR5,IR6,IR7,IR8#                                                MH00  13
INTEGER ICOD,IPUR#                                                      MH00  14
INTEGER IDEL,IDELC,IDELN(200)#         For deletion of refl pkt items   MH00  15
INTEGER IDNM(256)#                                                      MH00  16
INTEGER IHIT#                          Signal for refl search matches   MH00  17
INTEGER IWNT(210),IREL(212),KEY(4)#                                     MH00  18
INTEGER LIST,MARK#                                                      MH00  19
REAL H(3),COEF(16)#                                                     MH00  20
REAL HPREV#                            Previous h,k,l                   MH00  21
REAL RCODE,FAC1,FAC2#                                                   MH00  22
INTEGER NFIELD#                        Input field scan pointer         MH00  23
INTEGER ORDREQ#                        Requested ordinal number         MH00  24
INTEGER ORDCNT#                        Count of identical reflections   MH00  25
#                                                                       MH00  26
chardata:(MH01, PURGE RCODE MODIFY DELETE MODMUL DELMUL END REMOVE )#   MH00  27
chardata:(MH02, ACTION    H   K   L   OCCURRENCE   IDNUM    OLD $#      MH00  28
VALUE    NEW VALUE)#                                                    MH00  29
chardata:(MH03,MODIFYPURGE RCODE DELETEDELMULMODMUL)#                   MH00  30
chardata:(MH05,' Items in Lrrefl:      Input IDNUM    Output IDNUM')#   MH00  31
realdata:(FMT,[120413.,160413.,200413.,320613.,410613.,#                MH00  32
671042.,541042.])#                                                      MH00  33
realdata:(FMTP,[200613.,300713.,470813.])#                              MH00  34
datastuff:#                                                             MH00  35
#                                                                       MH00  36
#    SET IO BUFFERS                                                     MH00  37
#    --------------                                                     MH00  38
#                                                                       MH00  39
IOMARK(1)=QXSTR#                       Start of buffer for file a       MH00  40
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of buffer for file b       MH00  41
incrqx:(MARK,IOMARK(2)+bdfbuf:,MH0005)# Incr memory.....mh0005          MH00  42
#                                                                       MH00  43
#   SET UP DEFAULT VALUES                                               MH00  44
#   ---------------------                                               MH00  45
#                                                                       MH00  46
IDELC=0; IDEL=no:;  ORDREQ=0#          Reset variables                  MH00  47
intpak:(0,HPREV,0,mxbtwd:)#            Zero previous h,k,l              MH00  48
DO I=1,16; COEF(I)=1.#                 Loop over default coeff          MH00  49
IPUR=no:;  ICOD=no:#                   Switch flags off                 MH00  50
RCODE=2.; NFIELD=4; IHIT=no:#          Default rcode is 2.              MH00  51
#                                                                       MH00  52
#    ENTER CONTROL LINES                                                MH00  53
#    -------------------                                                MH00  54
#                                                                       MH00  55
ifnv:(BUFIN(1)) LIST=yes:#             Set listing of changes on        MH00  56
ELSE            LIST=no:#              Default is listing off           MH00  57
REPEAT#                                Loop over control lines          MH00  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MH00  59
readline:(MH01,NMH01)#                 Enter control lines              MH00  60
#                                                                       MH00  61
IF(LINID==1)#                          *********** purge line           MH00  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MH00  63
DO I=1,8; ifnv:(BUFIN(I)) COEF(I)=BUFIN(I)# Get active coeffs           MH00  64
IF(BUFIN(1)>voidflg:\BUFIN(2)>voidflg:) IPUR=1# Set purge on            MH00  65
IF(BUFIN(5)>voidflg:\BUFIN(6)>voidflg:) IPUR=2# Set purge on            MH00  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MH00  67
#                                                                       MH00  68
ELSE IF(LINID==2)#                     *********** rcode line           MH00  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MH00  70
ifnv:(BUFIN(1)) RCODE=BUFIN(1)#        Store new rcode                  MH00  71
DO I=1,8; ifnv:(BUFIN(I+1)) COEF(I+8)=BUFIN(I+1)# Get active coeffs     MH00  72
IF(BUFIN(2)>voidflg:\BUFIN(3)>voidflg:) ICOD=1# Set rcode on            MH00  73
IF(BUFIN(6)>voidflg:\BUFIN(7)>voidflg:) ICOD=2# Set rcode on            MH00  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MH00  75
#                                                                       MH00  76
ELSE IF(LINID==8)#                     *********** remove line          MH00  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MH00  78
DO I=1,mxfdim:#                        Loop over line to void field     MH00  79
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MH00  80
ifvo:(BUFIN(I)) BREAK#                 Stop scanning at void            MH00  81
IDELC=IDELC+1#                         Count items to be deleted        MH00  82
IF(IDELC>200) iquit:(MH0007)#          Protect upper limit on array     MH00  83
IDELN(IDELC)=NINT(BUFIN(I))#           Memorize the pkt id number       MH00  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MH00  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MH00  86
ELSE BREAK#                            Exit on modify or end            MH00  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MH00  88
#                                                                       MH00  89
IF(LINID==5\LINID==6)#                 Check modmul, delmul             MH00  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MH00  91
NFIELD=5#                              Set scan to start in field 5     MH00  92
IF(BUFIN(4)>0.) ORDREQ=NINT(BUFIN(4))# Set refl sought.. 1,2,3....      MH00  93
ELSE            ORDREQ=-1#             Process all occurences           MH00  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MH00  95
#                                                                       MH00  96
copyfile:(1,2,1,decr:(lrrefl:))#       Copy to refl records             MH00  97
#                                                                       MH00  98
#    SEARCH DIRECTORY OF LRREFL:                                        MH00  99
#    ---------------------------                                        MH00 100
#                                                                       MH00 101
DO I=1,210;   IWNT(I)=0#               Switch off all wanted idnums     MH00 102
IWNT(1)=1;    IWNT(2)=1308#            Request hkl & rcode idnum        MH00 103
DO I=2,16,2#                           Loop over coeffs                 MH00 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MH00 105
IF(COEF(I)<1.5) NEXT#                  Skip if not used                 MH00 106
K=I/2+2#                               Incr idnum counter               MH00 107
IWNT(K)=NINT(COEF(I))#                 Store in want array              MH00 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MH00 109
KEY(1)=1; KEY(2)=10; KEY(3)=0; KEY(4)=0# Set search keys                MH00 110
IF(ICOD>0) KEY(4)=1#                   Force rcod item to be made       MH00 111
IF(IDELC>0)#                           See if some archiving needed     MH00 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MH00 113
KEY(3)=KEY(2)+IDELC ; KEY(4)=1#        Set up for archive mode          MH00 114
K=KEY(2)#                              Find want list starting point    MH00 115
DO I=1,IDELC#                          Loop over items to be deleted    MH00 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MH00 117
K=K+1 ; IWNT(K)=-IDELN(I)#             And set unwants                  MH00 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MH00 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MH00 120
indexpkt:(1,lrrefl:,IPAK,IP,0,KEY,IWNT,IREL)# Search lrrefl directory   MH00 121
IF(KEY(4)<=0) iquit:(MH0015)#          Hkl not found...mh0015           MH00 122
NPAK=KEY(4)#                           Set output packet size           MH00 123
writepkt:(2,lrrefl:,NPAK,JP)#          Get output packet                MH00 124
IF(IDELC>0)#                           Are pkt items to be deleted      MH00 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MH00 126
#                                                                       MH00 127
#   COMPACT THE HEADER PACKET FROM INPUT TO OUTPUT                      MH00 128
#   ----------------------------------------------                      MH00 129
#                                                                       MH00 130
J=JP+1 ; K=KEY(2)+1#                   Pointer to output and irels      MH00 131
DO I=1,IPAK#                           Scan whole input pkt             MH00 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MH00 133
QX(J) = QX(IP+I)#                      Move input word to output        MH00 134
IF(IREL(K)==I) K=K+1#                  If not wanted drop it            MH00 135
ELSE J=J+1#                            Else advance file b pointer      MH00 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MH00 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MH00 138
ELSE#                                  Packets remain same size         MH00 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MH00 140
movereal:(QX,IP+1,QX,JP+1,IPAK,0)#     Move input to output             MH00 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MH00 142
DO I=2,16,2#                           Scan rel pointers & store        MH00 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MH00 144
K=I/2+2#                               Incr rel pointer                 MH00 145
IF((COEF(I)>1.5)&(IREL(K)<=0)) iquit:(MH0017)# Idnum missing...mh001    MH00 146
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MH00 147
IF(ICOD>0&IREL(2)<=0) iquit:(MH0018)#  Rcode missing....mh0018          MH00 148
DO I=1,IPAK; IDNM(I)=NINT(QX(IP+I))#   Store all lrrefl idnums          MH00 149
IR=IREL(1);    IC=IREL(2)#             Store hkl rel pointer            MH00 150
IR1=IREL(3);   IR2=IREL(4)#            Store coeff pointer              MH00 151
IR3=IREL(5);   IR4=IREL(6)#            Store coeff pointer              MH00 152
IR5=IREL(7);   IR6=IREL(8)#            Store coeff pointer              MH00 153
IR7=IREL(9);   IR8=IREL(10)#           Store coeff pointer              MH00 154
#                                                                       MH00 155
#    WRITE OUT THE LRREFL: STATUS                                       MH00 156
#    ----------------------------                                       MH00 157
#                                                                       MH00 158
writeline:(0,0,0,1,3)#                 Force blank line                 MH00 159
LINRM=6;JJ=MAX0(IPAK,NPAK,KEY(3))#     Find longest list                MH00 160
DO J=1,JJ#                             Loop over all                    MH00 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MH00 162
BUFOT(1)=FLOAT(J)#                     Order of output items            MH00 163
IF(J<=IPAK)BUFOT(2)=QX(IP+J)#          Get input packet id num          MH00 164
IF(J<=NPAK)BUFOT(3)=QX(JP+J)#          Get output packet id num         MH00 165
ncodefld:(BUFOT,1,CHROT,FMTP,3)#       Prepare numbers for printing     MH00 166
writeline:(0,MH05,NMH05,1,3)#          And print them                   MH00 167
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MH00 168
writeline:(0,0,0,1,3); LINRM=6#        Force first header               MH00 169
#                                                                       MH00 170
#    ENTER LRREFL: BDF RECORDS                                          MH00 171
#    -------------------------                                          MH00 172
#                                                                       MH00 173
REPEAT#                                Loop over lrrefl records         MH00 174
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MH00 175
readwpkt:(1,lrrefl:,IPAK,IP,0)#        Point to ip packet               MH00 176
IF(IP<=0) BREAK#                       Exit reflection loop             MH00 177
gethkl:(IP+IR,H)#                      Extract h,k,l                    MH00 178
compakwd:(QX(IP+IR),NE,HPREV,ORDCNT=0)# Reset ordinal count if new      MH00 179
movepakwd:(QX(IP+IR),HPREV)#           Restore packed hkl               MH00 180
ORDCNT=ORDCNT+1#                       Incr hkl ordinal count           MH00 181
#                                                                       MH00 182
#   APPLY PURGE TESTS IF REQUESTED                                      MH00 183
#   ------------------------------                                      MH00 184
#                                                                       MH00 185
IF(IPUR>0)#                            If purge requested               MH00 186
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MH00 187
IF(IR1>0) FAC1=COEF(1)*QX(IP+IR1)#     Get first product                MH00 188
ELSE      FAC1=COEF(1)#                Get first factor                 MH00 189
IF(IR2>0) FAC2=COEF(3)*QX(IP+IR2)#     Get secnd product                MH00 190
ELSE      FAC2=COEF(3)#                Get secnd factor                 MH00 191
IF(FAC1>FAC2)#                         Reject on first test             MH00 192
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MH00 193
IF(IPUR==2)#                           If purge two requested           MH00 194
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MH00 195
IF(IR3>0) FAC1=COEF(5)*QX(IP+IR3)#     Get first product                MH00 196
ELSE      FAC1=COEF(5)#                Get first factor                 MH00 197
IF(IR4>0) FAC2=COEF(7)*QX(IP+IR4)#     Get secnd product                MH00 198
ELSE      FAC2=COEF(7)#                Get secnd factor                 MH00 199
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MH00 200
IF(FAC1>FAC2)#                         Reject on both tests             MH00 201
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MH00 202
IF(LIST==yes:)#                        Is listing requested             MH00 203
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MH00 204
movechar:(MH03,7,CHROT,2,6,0)#         Insert action                    MH00 205
ncodefld:(H,1,CHROT,FMT,3)#            Format h,k,l                     MH00 206
writeline:(0,MH02,NMH02,1,3)#          Print purge message              MH00 207
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MH00 208
NEXT#                                  Skip without copying             MH00 209
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MH00 210
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MH00 211
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MH00 212
#                                                                       MH00 213
#   APPLY RCODE TESTS IF REQUESTED                                      MH00 214
#   ------------------------------                                      MH00 215
#                                                                       MH00 216
IF(ICOD>0)#                            If rcode test requested          MH00 217
ifne:(RCODE,QX(IP+IR5))#               Test if already set              MH00 218
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MH00 219
IF(IR5>0) FAC1=COEF(9)*QX(IP+IR5)#     Get first product                MH00 220
ELSE      FAC1=COEF(9)#                Get first factor                 MH00 221
IF(IR6>0) FAC2=COEF(11)*QX(IP+IR6)#    Get secnd product                MH00 222
ELSE      FAC2=COEF(11)#               Get secnd factor                 MH00 223
IF(FAC1>FAC2)#                         First test applies               MH00 224
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MH00 225
IF(ICOD==2)#                           If purge two requested           MH00 226
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MH00 227
IF(IR7>0) FAC1=COEF(13)*QX(IP+IR7)#    Get first product                MH00 228
ELSE      FAC1=COEF(13)#               Get first factor                 MH00 229
IF(IR8>0) FAC2=COEF(15)*QX(IP+IR8)#    Get secnd product                MH00 230
ELSE      FAC2=COEF(15)#               Get secnd factor                 MH00 231
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MH00 232
IF(FAC1>FAC2)#                         Insert new rcode                 MH00 233
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MH00 234
IF(LIST==yes:)#                        List if requested                MH00 235
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MH00 236
movechar:(MH03,13,CHROT,2,6,0)#        Insert rcode string              MH00 237
ncodefld:(H,1,CHROT,FMT,3)#            Format h,k,l                     MH00 238
BUFOT(1)=1308.#                        Store rcode idnum                MH00 239
BUFOT(2)=RCODE#                        Store new rcode                  MH00 240
BUFOT(3)=QX(IP+IC)#                    Store old rcode                  MH00 241
ncodefld:(BUFOT,1,CHROT,FMT(5),3)#     Format rcodes                    MH00 242
writeline:(0,MH02,NMH02,1,3)#          Print rcode change               MH00 243
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MH00 244
QX(IP+IC)=RCODE#                       Insert new rcode                 MH00 245
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MH00 246
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MH00 247
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MH00 248
#                                                                       MH00 249
#   TEST FOR MODIFICATION OF DATA                                       MH00 250
#   -----------------------------                                       MH00 251
#                                                                       MH00 252
IF(LINID!=7)#                          Modify,delete,modmul,delmul      MH00 253
REPEAT#                                Loop over input lines            MH00 254
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MH00 255
IF(IHIT==yes:&ORDCNT==1) GOTO 100#     Get another input line           MH00 256
ifne:(H(1),BUFIN(1)) BREAK#            Test for h match                 MH00 257
ifne:(H(2),BUFIN(2)) BREAK#            Test for k match                 MH00 258
ifne:(H(3),BUFIN(3)) BREAK#            Test for l match                 MH00 259
IF(ORDREQ>0&ORDREQ!=ORDCNT) BREAK#     Test for ordcnt match            MH00 260
IHIT=yes:#                             Process this reflection          MH00 261
#                                                                       MH00 262
IF(LINID==3\LINID==5)#                 ****** modify/modmul ********    MH00 263
DO J=NFIELD,mxfdim:,2#                 Loop over fields on modify       MH00 264
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MH00 265
ifvo:(BUFIN(J)) BREAK#                 Test for active field            MH00 266
I=NINT(BUFIN(J))#                      Extract input idnum              MH00 267
FOR(K=1;K<=IPAK;K=K+1) IF(I==IDNM(K)) BREAK# Exit if idnums match       MH00 268
IF(K>IPAK) iquit:(MH0020)#             Idnum not found...mh0020         MH00 269
IF(LINID==3)movechar:(MH03, 1,CHROT,2,6,0)# Insert modify string        MH00 270
ELSE        movechar:(MH03,31,CHROT,2,6,0)# Insert modmul string        MH00 271
BUFOT(1)=FLOAT(MAX0(ORDREQ,1))#        Get occurence                    MH00 272
ncodefld:(H,1,CHROT,FMT,3)#            Format h,k,l                     MH00 273
ncodefld:(BUFOT,1,CHROT,FMT(4),1)#     Format occurence                 MH00 274
ncodefld:(BUFIN,J,CHROT,FMT(5),2)#     Format idnum & new value         MH00 275
ncodefld:(QX,IP+K,CHROT,FMT(7),1)#     Format old value                 MH00 276
QX(IP+K)=BUFIN(J+1)#                   Insert modified value            MH00 277
writeline:(0,MH02,NMH02,1,3)#          Print modified values            MH00 278
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MH00 279
#                                                                       MH00 280
ELSE IF(LINID==4\LINID==6)#            ****** delete/delmul *******     MH00 281
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MH00 282
IF(LINID==4) movechar:(MH03,19,CHROT,2,6,0)# Tell its a delete          MH00 283
ELSE         movechar:(MH03,25,CHROT,2,6,0)# Unless its a delmul        MH00 284
BUFOT(1)=FLOAT(MAX0(ORDREQ,1))#        Get occurence                    MH00 285
ncodefld:(H,1,CHROT,FMT,3)#            Pointer unadvanced thus          MH00 286
ncodefld:(BUFOT,1,CHROT,FMT(4),1)#     Format occurence                 MH00 287
writeline:(0,MH02,NMH02,1,3)#          List the deleted reflections     MH00 288
IDEL=yes:#                             Yea, kill this one               MH00 289
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MH00 290
#                                                                       MH00 291
IF(ORDREQ<0) BREAK#                    All occurences effected          MH00 292
100 CONTINUE#                          Reset process flag               MH00 293
readline:(MH01,NMH01)#                 Read another del/mod line        MH00 294
NFIELD=4;  ORDREQ=0;  IHIT=no:#        Field start for modify           MH00 295
IF(LINID==5\LINID==6)#                 If delmul or modmul lines        MH00 296
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MH00 297
NFIELD=5#                              Field start for modmul           MH00 298
IF(BUFIN(4)>0.) ORDREQ=NINT(BUFIN(4))# Set refl sought.. 1,2,3....      MH00 299
ELSE            ORDREQ=-1#             Process all occurences           MH00 300
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MH00 301
IF(LINID==7)BREAK#                     Get out if end line              MH00 302
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MH00 303
#                                                                       MH00 304
#    COPY LRREFL PACKET                                                 MH00 305
#    ------------------                                                 MH00 306
#                                                                       MH00 307
IF(IDEL==no:)#                         Do not copy if delete            MH00 308
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MH00 309
writepkt:(2,lrrefl:,NPAK,JP)#          Point to op packet               MH00 310
IF(IDELC>0)#                           Test to see if archiving         MH00 311
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MH00 312
J=JP+1 ; K=KEY(2)+1#                   Set up for compression           MH00 313
DO JJ=1,IPAK#                          Loop over input packet           MH00 314
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MH00 315
QX(J) = QX(IP+JJ)#                     Move an item                     MH00 316
IF(IREL(K)==JJ) K=K+1#                 Unless it marked for deletion    MH00 317
ELSE            J=J+1#                 If not move on in output         MH00 318
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MH00 319
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MH00 320
ELSE movereal:(QX,IP+1,QX,JP+1,NPAK,0)# Transfer pkt ip to op           MH00 321
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MH00 322
ELSE IDEL=no:#                         Reset delete flag                MH00 323
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MH00 324
#                                                                       MH00 325
IF(LINID!=7) iquit:(MH0025)#           Out of order....mh0025           MH00 326
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off copy               MH00 327
#                                                                       MH00 328
RETURN#                                Mh                               MH00 329
END#                                                                    MH00 330
pmacro:([no:])#                                                         MH00 331
