systemheader:(PP    )#                                                  PP     1
####################################################################### PP     2
##      Copyright (C) 2000, The Xtal System, The University of        # PP     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # PP     4
## Distributed under the GNU General Public Licence as published by   # PP     5
## the Free Software Foundation, in the hope that it will be useful   # PP     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # PP     7
## for more details.                                                  # PP     8
#                                                                     # PP     9
#                            *** PEKPIK ***                           # PP    10
#                                                                     # PP    11
#     THE PROGRAM PEKPIK SCANS THE FOURIER TRANSFORM MAP PRODUCED     # PP    12
#     BY THE FOURR PROGRAM FOR MAXIMA AND THE MINIMA IN THE MAP.      # PP    13
#                                                                     # PP    14
####################################################################### PP    15
#                                                                       PP    16
include:(XMACRO)#                                                       PP    17
#                                                                       PP    18
macro:(name:,incr:(arith:(23,/,mxchwd:)))#                              PP    19
#                                                                       PP    20
macro:(templist:,[ifelse:($1,,MP,$1)])# Define list pointer             PP    21
macro:(flag:,[QX(templist:($1)+1)])#   Define storage flag              PP    22
macro:(code:,[QX(templist:($1)+2)])#   Define position code             PP    23
macro:(pnt1:,[QX(templist:($1)+3)])#   Define point 1 value             PP    24
macro:(lin1:,[QX(templist:($1)+4)])#   Define line  1 value             PP    25
macro:(lay1:,[QX(templist:($1)+5)])#   Define layer 1 value             PP    26
macro:(pek1:,[QX(templist:($1)+6)])#   Define peakh 1 value             PP    27
macro:(pnt2:,[QX(templist:($1)+7)])#   Define point 2 value             PP    28
macro:(lin2:,[QX(templist:($1)+8)])#   Define line  2 value             PP    29
macro:(lay2:,[QX(templist:($1)+9)])#   Define layer 2 value             PP    30
macro:(pek2:,[QX(templist:($1)+10)])#  Define peakh 2 value             PP    31
#                                                                       PP    32
macro:(permlist:,[ifelse:($1,,KP,$1)])# Define list pointer             PP    33
macro:(peakx:,[QX(permlist:($1)+1)])#  Define x coordinate              PP    34
macro:(peaky:,[QX(permlist:($1)+2)])#  Define y coordinate              PP    35
macro:(peakz:,[QX(permlist:($1)+3)])#  Define z coordinate              PP    36
macro:(peakh:,[QX(permlist:($1)+4)])#  Define peak height               PP    37
macro:(index:,[QX(permlist:($1)+5)])#  Define reliability index         PP    38
#                                                                       PP    39
extrude:(PPCOMN)#                                                       PP    40
INTEGER CTYPE#     ## Fourier map type                                  PP    41
INTEGER HOLE#      ## Flag search for holes by negation                 PP    42
INTEGER ICNT#      ## Centre flag (c=1, nc=2)                           PP    43
INTEGER IFILE#     ## Signal to write scratch file for compar           PP    44
INTEGER IN(3)#     ## Increments along the fourier axes                 PP    45
INTEGER IPCH#      ## Signal to punch coordinates of peaks              PP    46
INTEGER ISYM#      ## Signal symmetry in peak overlap                   PP    47
INTEGER IS1,IS2,IS3## Order of crystal axes                             PP    48
INTEGER LTYP#      ## Lattice type indicator                            PP    49
INTEGER MARK1,STEP1,STOP1## Marker,step,and end of symops               PP    50
INTEGER MARK2,STEP2,STOP2## Marker,step,and end of atom names           PP    51
INTEGER MARK3,STEP3,STOP3## Marker,step,and end of atom coordinates     PP    52
INTEGER MARK4,STOP4## Line buffer 1                                     PP    53
INTEGER MARK5,STOP5## Line buffer 2                                     PP    54
INTEGER MARK6,STOP6## Line buffer 3                                     PP    55
INTEGER MARK7,STEP7,STOP7## Marker,step,end of temporary peak array     PP    56
INTEGER MARK8,STEP8,STOP8## Marker,step,end of permanent peak array     PP    57
INTEGER MXPEAK#    ## Total number of peaks to seek                     PP    58
INTEGER NG(3),NP(3)## No. of grid & span points in fourier map          PP    59
INTEGER NPEAKS#    ## No. of largest peaks to list in sorted order      PP    60
INTEGER NPTS#      ## No. of points in the permanent array              PP    61
INTEGER NSYM#      ## No. of symmetry operations                        PP    62
INTEGER OR(3)#     ## Origins in grid points                            PP    63
INTEGER STOPP#     ## End of all peak tables                            PP    64
#                                                                       PP    65
REAL G1,G2,G3,G5,G6,G9## Terms for distance calculation                 PP    66
REAL GR1,GR2,GR3#  ## Real gr values                                    PP    67
REAL DMIN#         ## Upper density limits for search                   PP    68
REAL PLIM#         ## Initial peak limit (= initial dmin)               PP    69
REAL PMIN#         ## Reak threshold - auto adjusted                    PP    70
REAL RES#          ## Resolution sphere squared                         PP    71
#                                                                       PP    72
COMMON/COMIPP/  HOLE , IFILE ,OR ,IN  ,MXPEAK ,IPCH  ,#                 PP    73
ICNT ,STOPP ,IS1, IS2, IS3, ISYM,#                                      PP    74
STOP1, STOP2, STOP3, STOP4, STOP5, STOP6, STOP7,#                       PP    75
STOP8, LTYP  ,MARK1 ,MARK2 ,#                                           PP    76
MARK3 ,MARK4 ,MARK5 ,MARK6 ,MARK7 ,MARK8 ,#                             PP    77
NPEAKS, NPTS  ,NP,  NG,#                                                PP    78
STEP1, STEP2, STEP3, STEP7, STEP8,NSYM  ,CTYPE#                         PP    79
#                                                                       PP    80
COMMON/COMFPP/ DMIN,PLIM,PMIN,RES,G1,G2,G3,G5,G6,G9,GR1,GR2,GR3#        PP    81
endext:#                                                                PP    82
#                                                                       PP    83
systemheader:(PP00)#                                                    PP00   1
#********************************************************************#  PP00   2
#                                                                    #  PP00   3
#                                PP00                                #  PP00   4
#                                                                    #  PP00   5
#********************************************************************#  PP00   6
SUBROUTINE PP00#                       S.r.hall  1982                   PP00   7
include:(AACOMN)#                                                       PP00   8
include:(PPCOMN)#                                                       PP00   9
#                                                                       PP00  10
FILEXT(IOUNIT(3))='MAP'#               Extension for ip fourr map       PP00  11
FILEXT(IOUNIT(5))='PEK'#               Extension for op peaks           PP00  12
#                                                                       PP00  13
CALL PP01#                             Enter bdf & setup search         PP00  14
CALL PP02#                             Scan map & make peak list        PP00  15
CALL PP05#                             Sort peaks & output list         PP00  16
#                                                                       PP00  17
RETURN#                                                                 PP00  18
END#                                                                    PP00  19
systemheader:(PP01)#                                                    PP01   1
#********************************************************************#  PP01   2
#                                                                    #  PP01   3
#                                PP01                                #  PP01   4
#                                                                    #  PP01   5
#********************************************************************** PP01   6
SUBROUTINE PP01#                       R.m. doherty 1981                PP01   7
include:(AACOMN)#                      S.r.hall 1982                    PP01   8
include:(PPCOMN)#                                                       PP01   9
#                                                                       PP01  10
INTEGER I,IK,K,J,IIP,IP,L,N,NNN,PSIZ#                                   PP01  11
INTEGER IWNT(8),IREL(8),KEY(4)#        Id nos. for x,y,z and name       PP01  12
INTEGER ISUM(3),JSUM(3),MOLZ#                                           PP01  13
#                                                                       PP01  14
string:(LABEL,24)#                                                      PP01  15
chardata:(PP101,PUN NFI SFI NPU HOL NHO NSY SYM BDF )#                  PP01  16
chardata:(PP102, PLIMIT END )#                                          PP01  17
chardata:(PP21," PEKPIK Control Parameters")#                           PP01  18
chardata:(PP22," Fourier map type processed                       ")#   PP01  19
chardata:(PP23,COEFPATTEPATVECTEMAPFRELFDIFFCALWFRLWFDF)#               PP01  20
chardata:(PP25," Maximum unique peaks output                      ")#   PP01  21
chardata:(PP26," Peak overstore buffer holds                      ")#   PP01  22
chardata:(PP27," Minimum separation of peaks (A)                  ")#   PP01  23
chardata:(PP28," Number of symops applied                     NONE")#   PP01  24
chardata:(PP29," Preset threshold density                         ")#   PP01  25
chardata:(PP2B,-MAXMEM LIMIT)#                                          PP01  26
chardata:(PP2C,"peaksholes")#                                           PP01  27
realdata:(HLIM,[ 1.,10., 5., 2.,2.,1.,.25,1.])#                         PP01  28
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              PP01  29
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              PP01  30
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              PP01  31
realdata:(TR21,[.3333333,.5])#                                          PP01  32
realdata:(TR22,[.6666667,0.])#                                          PP01  33
realdata:(TR23,[.6666667,.5])#                                          PP01  34
datastuff:#                                                             PP01  35
#                                                                       PP01  36
# PICK UP INFORMATION FROM PEKPIK LINE.                                 PP01  37
# -----------------------------------                                   PP01  38
#                                                                       PP01  39
IPCH=no:#                              Assume no punched cards          PP01  40
ISYM=yes:#                             Assume symmetry applied          PP01  41
IFILE=yes:#                            Assume writing of scratch fi     PP01  42
HOLE=no:#                              Assume search is for peaks       PP01  43
FOR(K=1;K<20;K=K+1)#                   Loop over input fields           PP01  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PP01  45
IF(BUFIN(K)>=voidflg:) BREAK#          Exit on null field               PP01  46
stringlim:(K,I,J)#                     Get string limits                PP01  47
compchar:(CHRIN,I,PP101,1,3,4,NPP101,J)# Identify char string           PP01  48
IF(J==0) iquit:(PP0101)#               Input field is unidentifiabl     PP01  49
ELSE IF(J==1) IPCH=yes:#               User wants cards punched         PP01  50
ELSE IF(J==2) IFILE=no:#               Don't write scratch file         PP01  51
ELSE IF(J==5) HOLE=yes:#               Search for holes, not peaks      PP01  52
ELSE IF(J==7) ISYM=no:#                Do not use symmetry in search    PP01  53
ELSE IF(J==9)#                         Extract new input file           PP01  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PP01  55
K=K+1;   ifvo:(BUFIN(K)) NEXT#         Skip if nonsense                 PP01  56
stringlim:(K,I,J)#                     Get string limits                PP01  57
FILEXT(IOUNIT(5))=CHRIN(I^I+2)#        Get new ip filename              PP01  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PP01  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PP01  60
#                                                                       PP01  61
#    ENTER CONTROL LINES                                                PP01  62
#    -------------------                                                PP01  63
#                                                                       PP01  64
DMIN=+99999.#                          Cutoff limits                    PP01  65
NPEAKS=10000#                          Number unique peaks expected     PP01  66
MXPEAK=1000#                           No. of peaks to be considere     PP01  67
RES=.75#                               Desired resolution in angstr     PP01  68
#                                                                       PP01  69
REPEAT#                                Loop over input lines            PP01  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PP01  71
readline:(PP102,NPP102)#               Enter control line               PP01  72
#                                                                       PP01  73
IF(LINID==1)#                          Test if plimit line              PP01  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PP01  75
IF(BUFIN(1)>voidflg:) DMIN=BUFIN(1)#   Enter density threshold          PP01  76
IF(BUFIN(2)>voidflg:) RES=BUFIN(2)#    Enter peak resolution d          PP01  77
IF(BUFIN(3)>0.)       NPEAKS=NINT(BUFIN(3))# Enter sorted peak max      PP01  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PP01  79
ELSE BREAK#                            End line detected                PP01  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PP01  81
#                                                                       PP01  82
#   ASSIGN MEMORY FOR FILE BUFFERS                                      PP01  83
#   ------------------------------                                      PP01  84
#                                                                       PP01  85
IOMARK(3)=QXSTR#                       Set buffer file c                PP01  86
IF(IFILE==yes:) IOMARK(5)=IOMARK(3)+bdfbuf:# Set buffer file e          PP01  87
ELSE            IOMARK(5)=IOMARK(3)#   Set buffer file e                PP01  88
incrqx:(MARK1,IOMARK(5)+bdfbuf:,PP0107)# Get memory for buffers         PP01  89
#                                                                       PP01  90
# READ BDF AND CONSTRUCT TENSOR FOR THE CELL                            PP01  91
# ------------------------------------------                            PP01  92
#                                                                       PP01  93
IF(IFILE==yes:) copyfile:(3,5,1,1)#    Copy header to new scratch f     PP01  94
DO I=1,7#                              Loop over cell packets           PP01  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PP01  96
readwpkt:(3,lrcell:,PSIZ,IP,0)#        Read lrcell constants            PP01  97
IF(IP<=0) BREAK#                       Exit at end record               PP01  98
IF(IFILE==no:) NEXT#                   If there is an op file           PP01  99
writepkt:(5,lrcell:,PSIZ,IK)#          Get op packet pointer            PP01 100
movereal:(QX,IP+1,QX,IK+1,PSIZ,1)#     Transfer packet 7 of lrcell:     PP01 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PP01 102
G1=QX(IP+1)#                           A**2                             PP01 103
G2=QX(IP+2)*2.#                        2 a b cosg                       PP01 104
G3=QX(IP+3)*2.#                        2 a c cosb                       PP01 105
G5=QX(IP+5)#                           A**2                             PP01 106
G6=QX(IP+6)*2.#                        2 b c cosa                       PP01 107
G9=QX(IP+9)#                           C**2                             PP01 108
#                                                                       PP01 109
# GET LATTICE AND SYMMETRY INFORMATION                                  PP01 110
# -------------------------------------                                 PP01 111
#                                                                       PP01 112
readwpkt:(3,lrsymm:,PSIZ,IP,0)#        Read lrsymm record               PP01 113
IF(IP<=0) iquit:(PP0103)#              P                                PP01 114
IF(IFILE==yes:)#                                                        PP01 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PP01 116
writepkt:(5,lrsymm:,PSIZ,IK)#          Write lrsymm record              PP01 117
movereal:(QX,IP+1,QX,IK+1,PSIZ,1)#                                      PP01 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PP01 119
LTYP=NINT(QX(IP+1))#                   Get lattice type                 PP01 120
ICNT=NINT(QX(IP+2))+1#                 Get centro flag (nc=2)           PP01 121
NSYM=NINT(QX(IP+3))#                   Total number of equiv. pos.      PP01 122
ifeq:(QX(IP+8),0.) MOLZ=NINT(QX(IP+3))# If z missing assume nsymops     PP01 123
ELSE MOLZ=NINT(MIN(QX(IP+3),QX(IP+8)))# Get min moles/cell              PP01 124
IF(LTYP>7) LTYP=LTYP-7#                Reduce lat to modulo 7           PP01 125
incrqx:(STOP1,MARK1+12*NSYM,PP0104)#   Quit if no room for symops       PP01 126
STEP1=12#                              Set symop packet size            PP01 127
FOR(I=MARK1;I>0;I=I+STEP1)#            Enter symops from bdf            PP01 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PP01 129
readwpkt:(3,lrsymm:,PSIZ,IP,0)#        Read the symmetry elements       PP01 130
IF(IP<=0) BREAK#                       Exit when finished               PP01 131
IF(IFILE==yes:)#                       Write a pek file                 PP01 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PP01 133
writepkt:(5,lrsymm:,PSIZ,IK)#          Point to ouput buffer            PP01 134
movereal:(QX,IP+1,QX,IK+1,PSIZ,1)#     Transfer symmetry elements       PP01 135
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PP01 136
movereal:(QX,IP+1,QX,I+1,PSIZ,1)#      Store symop matrices             PP01 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PP01 138
NNN=I#                                 Set storage pointer              PP01 139
#                                                                       PP01 140
#   GET ATOMIC CONTENTS INFO                                            PP01 141
#   ------------------------                                            PP01 142
#                                                                       PP01 143
N=0;  IWNT(1)=1;  IWNT(2)=3#           Request at/cell & at no.         PP01 144
KEY(1)=0; KEY(2)=2; KEY(3)=0; KEY(4)=0# Set search limits               PP01 145
indexpkt:(3,lrscat:,PSIZ,IP,0,KEY,IWNT,IREL)# Search for idnums         PP01 146
IF(IFILE==yes:)#                                                        PP01 147
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PP01 148
writepkt:(5,lrscat:,PSIZ,IK)#                                           PP01 149
movereal:(QX,IP+1,QX,IK+1,PSIZ,1)#                                      PP01 150
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PP01 151
IF(IREL(1)*IREL(2)>0)#                 Test if items found              PP01 152
REPEAT#                                Loop over lrscat packets         PP01 153
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PP01 154
readwpkt:(3,lrscat:,PSIZ,IP,0)#        Point to input packet            PP01 155
IF(IP<=0) BREAK#                       Exit after last packet           PP01 156
I=IP+IREL(1);   J=IP+IREL(2)#          Point to at/cell & at no.        PP01 157
IF(QX(J)>2.5) N=N+NINT(QX(I))#         Sum nonh atoms in cell           PP01 158
IF(IFILE==yes:)#                                                        PP01 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PP01 160
writepkt:(5,lrscat:,PSIZ,IK)#                                           PP01 161
movereal:(QX,IP+1,QX,IK+1,PSIZ,1)#                                      PP01 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PP01 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PP01 164
#                                                                       PP01 165
#   EXTRACT ATOM COORDS IF PRESENT                                      PP01 166
#   ------------------------------                                      PP01 167
#                                                                       PP01 168
MARK2=STOP1+1; STEP2=1; STOP2=MARK2+100# Setup peak max profile         PP01 169
MARK3=STOP2;  STOP3=MARK3#             Start of atomic coordinates      PP01 170
STEP3=arith:(4,+,name:)#               Save x,y,z and name              PP01 171
IWNT(1)=1;    IWNT(2)=2#               Request xcoord & ycoord          PP01 172
IWNT(3)=3;    IWNT(4)=14#              Request zcoord & aname           PP01 173
KEY(1)=0; KEY(2)=4; KEY(3)=4; KEY(4)=0# Set search parameters           PP01 174
indexpkt:(3,lratom:,PSIZ,IP,0,KEY,IWNT,IREL)# Find x,y,z and name       PP01 175
IF(IP>0)#                              If there are any atoms...        PP01 176
FOR(I=MARK3;I>0;I=STOP3)#              Loop over atoms list             PP01 177
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PP01 178
readwpkt:(3,lratom:,PSIZ,IP,0)#        Read atom packet                 PP01 179
IF(IP<=0) BREAK#                       Exit after last packet           PP01 180
incrqx:(STOP3,I+STEP3,PP0105)#         Save room for next atom          PP01 181
J=IP+IREL(1);  QX(I+1)=QX(J)#          Get x coordinate                 PP01 182
J=IP+IREL(2);  QX(I+2)=QX(J)#          Get y coordinate                 PP01 183
J=IP+IREL(3);  QX(I+3)=QX(J)#          Get z coordinate                 PP01 184
QX(I+4)=0.;  J=IP+IREL(4)#             Reset match flag                 PP01 185
movertoc:(QX(J),1,LABEL,1,24,0)#       Pick up atom label               PP01 186
label:(LABEL,K,L)#                     Process atom label               PP01 187
movereal:(QX,J,QX,I+5,name:,1)#        Store atom label                 PP01 188
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PP01 189
#                                                                       PP01 190
# RETRIEVE THE MAP PARAMETERS FROM LR 21                                PP01 191
# --------------------------------------                                PP01 192
#                                                                       PP01 193
readwpkt:(3,21,PSIZ,IP,0)#                                              PP01 194
DO K=1,3#                                                               PP01 195
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PP01 196
IIP=IP+K#                                                               PP01 197
OR(K)=NINT(QX(IIP))#                   Pick up origins                  PP01 198
IN(K)=NINT(QX(IIP+3))#                 Increments along axes            PP01 199
NG(K)=NINT(QX(IIP+6))#                 No. of grid points               PP01 200
NP(K)=NINT(QX(IIP+9))#                 Calculated points                PP01 201
ISUM(K)=NINT(QX(IIP+12))#              Correlations between crystal     PP01 202
JSUM(K)=NINT(QX(IIP+15))#              Axes and calculation axes        PP01 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PP01 204
CTYPE=NINT(QX(IP+21))#                 Extract fourr type               PP01 205
#                                                                       PP01 206
#   ADJUST SYMOPS TO MAP TYPE                                           PP01 207
#   -------------------------                                           PP01 208
#                                                                       PP01 209
IF(CTYPE>0&CTYPE<4)#                   If patt or vector map            PP01 210
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PP01 211
IF(CTYPE>0) STOP3=MARK3#               Cancel atom list for vect map    PP01 212
FOR(I=MARK1;I<NNN;I=I+STEP1)#          Loop over input symops           PP01 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PP01 214
QX(I+10)=0.; QX(I+11)=0.; QX(I+12)=0.# Remove all translations          PP01 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PP01 216
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PP01 217
K=NNN#                                 Store temp end marker            PP01 218
IF(LTYP>1)#                            Test if sg centered              PP01 219
FOR(J=MARK1;J<NNN;J=J+STEP1)#          Loop over symm matrices          PP01 220
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PP01 221
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            PP01 222
QX(K+10)=QX(J+10)+TR11(LTYP-1)#        Transfer t1                      PP01 223
QX(K+11)=QX(J+11)+TR12(LTYP-1)#        Transfer t2                      PP01 224
QX(K+12)=QX(J+12)+TR13(LTYP-1)#        Transfer t3                      PP01 225
K=K+STEP1#                             Incr storage pointer             PP01 226
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               PP01 227
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            PP01 228
QX(K+10)=QX(J+10)+TR21(LTYP-2)#        Transfer t1                      PP01 229
QX(K+11)=QX(J+11)+TR22(LTYP-2)#        Transfer t2                      PP01 230
QX(K+12)=QX(J+12)+TR23(LTYP-2)#        Transfer t3                      PP01 231
K=K+STEP1#                             Incr storage pointer             PP01 232
IF(LTYP!=4) NEXT#                      Skip if not f-centre             PP01 233
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            PP01 234
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      PP01 235
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      PP01 236
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      PP01 237
K=K+STEP1#                             Incr storage pointer             PP01 238
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PP01 239
NNN=K#                                 Store current end of symops      PP01 240
IF((CTYPE<4)\(ICNT==1))#               Test if centro symops needed     PP01 241
FOR(J=MARK1;J<NNN;J=J+1)#              Loop over symm matrices          PP01 242
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PP01 243
K=K+1#                                 Incr storage pointer             PP01 244
QX(K)=-QX(J+1)#                        Store inverse element            PP01 245
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PP01 246
ELSE STOP1=MARK1+12*NSYM#              Reset symop limit                PP01 247
#                                                                       PP01 248
#    ASSIGN STORAGE FOR PEAK LISTS                                      PP01 249
#    -----------------------------                                      PP01 250
#                                                                       PP01 251
IF(NPEAKS>9999&N>0) NPEAKS=2*N/MOLZ#   Maxpeak is 2x at/asym unit       PP01 252
IF(NPEAKS>9999)     NPEAKS=50#         Default is 50 if no info         PP01 253
IF(ISYM==no:)       NPEAKS=NPEAKS*NSYM# Allow for related peaks         PP01 254
MARK4=STOP3#                           Start of first line buffer       PP01 255
STOP4=MARK4+NP(3)#                     End of first line buffer         PP01 256
MARK5=STOP4#                           Start of second line buffer      PP01 257
STOP5=MARK5+NP(3)#                     End of second line buffer        PP01 258
MARK6=STOP5#                           Start of third line buffer       PP01 259
STOP6=MARK6+NP(3)#                     End of third line buffer         PP01 260
MARK7=STOP6#                           Start temporary peak list        PP01 261
STOP7=MARK7#                           End temporary peak list          PP01 262
STEP7=10#                              Step temporary peak list         PP01 263
STEP8=5#                               Step permanent peak list         PP01 264
MXPEAK=MAX0(MXPEAK,(NPEAKS*2)/10)#     Force list to size of npeak      PP01 265
MARK8=STOP7+STEP7*MXPEAK#              Start permanent peak list        PP01 266
STOPP=MARK8+((MXPEAK*10)/2)*STEP8#     Request total memory             PP01 267
IF(QXMAX<STOPP)#                       Find out how many peak will      PP01 268
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PP01 269
STOPP=MARK8+NPEAKS*STEP8#              Try again smaller memory         PP01 270
IF(QXMAX<STOPP)#                       Test if  this available          PP01 271
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PP01 272
NPEAKS=MIN0(NPEAKS,(QXMAX-MARK7)/10)#  Allow for requested peaks        PP01 273
MXPEAK=(QXMAX-MARK7-NPEAKS*5)/10#      Get max buffer area              PP01 274
IF(MXPEAK<1)      iquit:(PP0106)#      Overflow.....pp0106              PP01 275
movechar:(PP2B,2,PP26,35,12,0)#        Insert memory max warning        PP01 276
STOPP=MARK8+NPEAKS*STEP8#              Mark end of table                PP01 277
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PP01 278
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PP01 279
qxmemory:(STOPP)#                      Get memory available             PP01 280
STOP8=MARK8#                           Initialize perm peak list        PP01 281
#                                                                       PP01 282
# DO SOME GENERAL INITIALIZATIONS                                       PP01 283
# --------------------------------                                      PP01 284
#                                                                       PP01 285
NPTS=0#                                Zero count of pts. in perm.      PP01 286
IF(DMIN>99998.)  DMIN=HLIM(CTYPE+1)#   Set  hi limit for calc           PP01 287
IS1=ISUM(1); IS2=ISUM(2); IS3=ISUM(3)# Move to global variables         PP01 288
GR1=FLOAT(NG(1)); GR2=FLOAT(NG(2)); GR3=FLOAT(NG(3))# Float map grid    PP01 289
#                                                                       PP01 290
#    REPORT SEARCH PARAMETERS                                           PP01 291
#    ------------------------                                           PP01 292
#                                                                       PP01 293
movechar:(PP2B,1,CHROT,2,NPP21-1,2)#   Underline pekpik header          PP01 294
writeline:(1,PP21,NPP21,2,3)#          Print pekpik header              PP01 295
movechar:(PP23,CTYPE*4+1,PP22,47,4,0)# Insert fourier type              PP01 296
writeline:(0,PP22,NPP22,3,3)#          Print fourier type               PP01 297
ncodefld:(FLOAT(NPEAKS),1,PP25,500413.,1)# Format peaks sought          PP01 298
writeline:(0,PP25,NPP25,3,3)#          Print peaks sought               PP01 299
ncodefld:(FLOAT(MXPEAK),1,PP26,500413.,1)# Format peaks stored          PP01 300
writeline:(0,PP26,NPP26,3,3)#          Print peaks stored               PP01 301
IF(HOLE==no:) movechar:(PP2C,1,PP27,24,5,0)# Put peaks in line          PP01 302
ELSE          movechar:(PP2C,6,PP27,24,5,0)# Say holes                  PP01 303
ncodefld:(RES,1,PP27,500522.,1)#       Format min separation            PP01 304
writeline:(0,PP27,NPP27,3,3)#          Print min separation             PP01 305
IF(ISYM==yes:)ncodefld:(FLOAT(NSYM),1,PP28,500513.,1)# Format symops    PP01 306
writeline:(0,PP28,NPP28,3,3)#          Print max symops                 PP01 307
ncodefld:(DMIN,1,PP29,500622.,1)#      Format min for peaks             PP01 308
writeline:(0,PP29,NPP29,3,3)#          Print thr for peaks              PP01 309
#                                                                       PP01 310
RETURN#                                                                 PP01 311
END#                                                                    PP01 312
systemheader:(PP02)#                                                    PP02   1
#********************************************************************** PP02   2
#                                                                       PP02   3
#                                PP02                                   PP02   4
#                                                                       PP02   5
#********************************************************************** PP02   6
SUBROUTINE PP02#                       R.m.doherty 1981                 PP02   7
include:(AACOMN)#                      S.r.hall 1982                    PP02   8
include:(PPCOMN)#                                                       PP02   9
#                                                                       PP02  10
INTEGER I,J,K,M,H1,H2#                                                  PP02  11
INTEGER P1,P2,P3,P4,P5#                Pointers to map points           PP02  12
INTEGER LAY,LIN,PNT,PSIZ#                                               PP02  13
INTEGER ILAY,NLAY,MLAY#                                                 PP02  14
INTEGER ILIN,NLIN,MLIN#                                                 PP02  15
INTEGER IP,IPNT,NPNT,MPNT,MAXP,MPEAK,MXL,NDEN#                          PP02  16
INTEGER M1,M2,M3,MC,KP#                                                 PP02  17
INTEGER POS,MDEN,TPEAK#                                                 PP02  18
REAL X,ALAY,ALIN,APNT,BLAY#                                             PP02  19
REAL A,B,CODE,DENS,DM,DX,DY,DZ,PH,PM,PMAX,PP#                           PP02  20
#                                                                       PP02  21
chardata:(P301, MORE THAN     PEAKS FOUND ON LAYER    . THE LEAST $#    PP02  22
SIGNIFICANT ARE LOST.)#                                                 PP02  23
chardata:(P302," Adjusted min peak density                        ")#   PP02  24
intdata:(MP,0)#                                                         PP02  25
datastuff:#                                                             PP02  26
#                                                                       PP02  27
#     PREPARE TO ENTER FOURR MAP                                        PP02  28
#     --------------------------                                        PP02  29
#                                                                       PP02  30
ILAY=OR(1); NLAY=IN(1); MLAY=(NP(1)-1)*NLAY+ILAY# Set map limits        PP02  31
ILIN=OR(2); NLIN=IN(2); MLIN=(NP(2)-1)*NLIN+ILIN# Set map limits        PP02  32
IPNT=OR(3); NPNT=IN(3); MPNT=NP(3)#    Set map limits                   PP02  33
TPEAK=0;  MPEAK=0;   MXL=0#            Set temp & perm peak count       PP02  34
DENS=0.;  NDEN=0;  MDEN=NP(2)*NP(3)/3# Set values for thresh test       PP02  35
MAXP=MXPEAK/2#                         Set res limit & list limit       PP02  36
PMIN=DMIN;   PLIM=DMIN#                Set initial peak min values      PP02  37
#                                                                       PP02  38
#    ENTER FOURR MAP FROM FILE 3                                        PP02  39
#    ---------------------------                                        PP02  40
#                                                                       PP02  41
FOR(LAY=ILAY;LAY<=MLAY;LAY=LAY+NLAY)#  Loop over map sections           PP02  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PP02  43
M3=MARK4; M2=MARK5; M1=MARK6#          Reset line buffer pointers       PP02  44
ALAY=FLOAT(LAY);   BLAY=ALAY-1.#       Float layer number               PP02  45
#                                                                       PP02  46
readwpkt:(3,22,PSIZ,IP,0)#             Read in line 1 of layer          PP02  47
IF(IP==0) BREAK#                       Exit when map complete           PP02  48
IF(HOLE==no:)#                         Test if peak search              PP02  49
movereal:(QX,IP+1,QX,M3+1,PSIZ,1)#     Move line to buffer 3            PP02  50
ELSE#                                  Negate map                       PP02  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PP02  52
H1=IP ; H2=M3#                         Set buffer pointers              PP02  53
DO PNT=1,PSIZ#                         Move whole packet                PP02  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PP02  55
H1=H1+1 ; H2=H2+1#                     Word by word                     PP02  56
QX(H2)=-QX(H1)#                        Changing the sign                PP02  57
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PP02  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PP02  59
#                                                                       PP02  60
#   LOOP OVER LINES PER LAYER                                           PP02  61
#   -------------------------                                           PP02  62
#                                                                       PP02  63
FOR(LIN=ILIN;LIN<=MLIN;LIN=LIN+NLIN)#  Loop over lines per layer        PP02  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PP02  65
J=M1; M1=M2; M2=M3; M3=J#              Rotate buffer pointers           PP02  66
ALIN=FLOAT(LIN)#                       Float line number                PP02  67
#                                                                       PP02  68
IF(LIN<MLIN)#                          For all but last line/layer      PP02  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PP02  70
readwpkt:(3,22,PSIZ,IP,0)#             Enter next map line              PP02  71
IF(IP<=0) iquit:(PP0201)#              Unexpected.....pp0201            PP02  72
IF(HOLE==no:)#                         Test if peak search              PP02  73
movereal:(QX,IP+1,QX,M3+1,PSIZ,1)#     Store next line in buffer        PP02  74
ELSE#                                  Negate map                       PP02  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PP02  76
H1=IP ; H2=M3#                         Set buffer pointers              PP02  77
DO PNT=1,PSIZ#                         Move whole packet                PP02  78
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PP02  79
H1=H1+1 ; H2=H2+1#                     Word by word                     PP02  80
QX(H2)=-QX(H1)#                        Changing the sign                PP02  81
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PP02  82
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PP02  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PP02  84
#                                                                       PP02  85
IF(LIN==ILIN)     POS=1#               First line of the section        PP02  86
ELSE IF(LIN<MLIN) POS=4#               Not first line or last line      PP02  87
ELSE              POS=7#               This is the last line            PP02  88
#                                                                       PP02  89
#    LOOP OVER POINTS PER LINE                                          PP02  90
#    -------------------------                                          PP02  91
#                                                                       PP02  92
DO PNT=1,MPNT#                         Loop over fourr points           PP02  93
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PP02  94
IF((PNT==2)\(PNT==MPNT)) POS=POS+1#    Adjust point code in line        PP02  95
#                                                                       PP02  96
#  SCAN 3-LINE BUFFER FOR PEAK                                          PP02  97
#  ---------------------------                                          PP02  98
#                                                                       PP02  99
KP=M2+PNT#                             Point to next density            PP02 100
IF(QX(KP)<DMIN) NEXT#                  Test for possible peak           PP02 101
PH=QX(KP);  DX=0.;  DY=0.; PMAX=PH#    Set default shifts & peak        PP02 102
DENS=DENS+PH;  NDEN=NDEN+1#            Sum average density              PP02 103
#                                                                       PP02 104
IF(POS==5)#                            ********** inside map            PP02 105
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PP02 106
P1=M1+PNT;   P2=M3+PNT#                Vertical points                  PP02 107
IF((PH<QX(P1-1))\(PH<QX(P1))\(PH<QX(P1+1))\$# Test if peak              PP02 108
(PH<QX(KP-1))\(PH<QX(KP+1))\(PH<QX(P2-1))\$# Test if peak               PP02 109
(PH<QX(P2))\(PH<QX(P2+1))) NEXT#       Exit if not peak                 PP02 110
PM=QX(KP-1);   PP=QX(KP+1)#            Interpolate horizontally         PP02 111
CALL PP03(PM,PH,PP,DX,DM)#             Do 3-point peak interpolate      PP02 112
PMAX=DM#                               Store new peak height            PP02 113
PM=QX(P1);   PP=QX(P2)#                Interpolate vertically           PP02 114
CALL PP03(PM,PH,PP,DY,DM)#             Do 3-point peak interpolate      PP02 115
PMAX=(PMAX+DM)/2.+PH#                  Store new peak height            PP02 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PP02 117
#                                                                       PP02 118
ELSE IF((POS==2)\(POS==8))#            *********top/bot map             PP02 119
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PP02 120
IF(POS==2) P1=M3+PNT#                  Top                              PP02 121
ELSE       P1=M1+PNT#                  Bottom                           PP02 122
IF((PH<QX(KP-1))\(PH<QX(KP+1))\(PH<QX(P1-1))\$# Test if peak            PP02 123
(PH<QX(P1))\(PH<QX(P1+1))) NEXT#       Exit if not peak                 PP02 124
PM=QX(KP-1);   PP=QX(KP+1)#            Interpolate horizontally         PP02 125
CALL PP03(PM,PH,PP,DX,DM)#             Do 3-point peak interpolate      PP02 126
PMAX=PH+DM#                            Store new peak height            PP02 127
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PP02 128
#                                                                       PP02 129
ELSE IF((POS==4)\(POS==6))#            ***********left/right map        PP02 130
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PP02 131
P1=M1+PNT;   P3=M3+PNT#                Vertical points                  PP02 132
IF(POS==4) K=+1;  ELSE K=-1#           Get left/right move              PP02 133
P2=P1+K;   P4=P3+K;   P5=KP+K#         Horizontal points                PP02 134
IF((PH<QX(P1))\(PH<QX(P2))\(PH<QX(P3))\$# Test if peak                  PP02 135
(PH<QX(P4))\(PH<QX(P5))) NEXT#         Exit if not peak                 PP02 136
PM=QX(P1);   PP=QX(P3)#                Interpolate vertically           PP02 137
CALL PP03(PM,PH,PP,DY,DM)#             Do 3-point peak interpolate      PP02 138
PMAX=PH+DM#                            Store new peak height            PP02 139
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PP02 140
#                                                                       PP02 141
ELSE#                                  *************corner              PP02 142
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PP02 143
IF(POS==1\POS==7) P1=KP+1#             Left corner move horiz           PP02 144
ELSE              P1=KP-1#             Right corner move horiz          PP02 145
IF(POS<4)         P2=M3+PNT#           Top corner move down             PP02 146
ELSE              P2=M1+PNT#           Bot corner move up               PP02 147
IF(P1>KP)         P3=P2+1#             Left adjust                      PP02 148
ELSE              P3=P2-1#             Right adjust                     PP02 149
IF((PH<QX(P1))\(PH<QX(P2))\(PH<QX(P3)))NEXT# Exit if no peak            PP02 150
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PP02 151
CODE=FLOAT(POS)#                       Float point position code        PP02 152
APNT=FLOAT((PNT-1)*NPNT+IPNT)#         Float point index                PP02 153
#                                                                       PP02 154
#   PEAK FOUND -- PROCESS                                               PP02 155
#   ---------------------                                               PP02 156
#                                                                       PP02 157
IF(LAY>ILAY)#                          Except for first layer           PP02 158
FOR(MP=MARK7;MP<STOP7;MP=MP+STEP7)#    Loop over temp peak list         PP02 159
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PP02 160
ifne:(lay1:,BLAY) NEXT#                Skip except if prev layer        PP02 161
IF((lin1:>ALIN+1.5)\(lin1:<ALIN-1.5))NEXT# Skip if too far away         PP02 162
IF((pnt1:>APNT+1.5)\(pnt1:<APNT-1.5))NEXT# Skip if too far away         PP02 163
#                                                                       PP02 164
#    NEW PEAK UNRESOLVED FROM PEAK IN LIST                              PP02 165
#    ---------------------------------------                            PP02 166
#                                                                       PP02 167
IF(PMAX>pek1:)#                        Test if new peak larger          PP02 168
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PP02 169
pnt2:=pnt1:#                           Store peak parameters            PP02 170
lin2:=lin1:#                           Store peak parameters            PP02 171
lay2:=lay1:#                           Store peak parameters            PP02 172
pek2:=pek1:#                           Store peak parameters            PP02 173
flag:=1.#                              Set second layer flag            PP02 174
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PP02 175
ELSE IF(flag:<.5)#                     Peak on 2 layers only            PP02 176
CALL PP04(MP,pek1:,lay1:)#             Put peak in layer 1 in perm      PP02 177
ELSE IF(flag:<1.5)#                    Peak on middle of 3 layers       PP02 178
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PP02 179
CALL PP03(pek2:,pek1:,PMAX,DZ,DM)#     Get new peak position            PP02 180
A=DM+pek1:;  B=DZ+lay1:#               Store new peak values            PP02 181
IF(DZ>0.)#                             Is peak between layers 2 & 3     PP02 182
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PP02 183
DZ=-DZ; pnt2:=APNT+DX; lin2:=ALIN+DY#  Overstore layer 1 peak           PP02 184
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PP02 185
pnt1:=pnt1:+(pnt1:-pnt2:)*DZ#          Adjust x coordinate              PP02 186
lin1:=lin1:+(lin1:-lin2:)*DZ#          Adjust y coordinate              PP02 187
CALL PP04(MP,A,B)#                     Transfer peak to perm list       PP02 188
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PP02 189
pnt1:=APNT+DX#                         Store peak parameters            PP02 190
lin1:=ALIN+DY#                         Store peak parameters            PP02 191
lay1:=ALAY#                            Mark as perm peak                PP02 192
pek1:=PMAX#                            Store peak parameters            PP02 193
code:=CODE#                            Store peak parameters            PP02 194
BREAK#                                 Exit after peak processed        PP02 195
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PP02 196
#                                                                       PP02 197
#    IF FIRST LAYER OR UNIQUE PEAK FOUND                                PP02 198
#    -----------------------------------                                PP02 199
#                                                                       PP02 200
IF((LAY==ILAY)\(MP==STOP7))#           For layer 1 or unmatched pea     PP02 201
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PP02 202
TPEAK=TPEAK+1;     MC=STOP7#           Count temp peak                  PP02 203
IF((TPEAK-MPEAK>MAXP)\(TPEAK>=MXPEAK))# Max no. of peaks exceeded       PP02 204
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PP02 205
IF(MXL==0)#                            Write spill-over message onc     PP02 206
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PP02 207
MXL=1#                                 Set spill flag                   PP02 208
ncodefld:(FLOAT(TPEAK-MPEAK),1,P301,140313.,1)# Format overflow         PP02 209
ncodefld:(ALAY,1,P301,390313.,1)#      Format section number            PP02 210
writeline:(1,P301,NP301,3,3)#          Print warning message            PP02 211
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PP02 212
TPEAK=TPEAK-1#                         Reset no. of peaks to max.       PP02 213
M=MARK7+MPEAK*STEP7#                   Point to start of peaks          PP02 214
X=100000.#                             Set arbitrarily large refere     PP02 215
FOR(MP=M;MP<STOP7;MP=MP+STEP7)#        Loop over part peak list         PP02 216
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PP02 217
IF(pek1:>X) NEXT#                      Look for smallest peak           PP02 218
X=pek1:;   MC=MP#                      Save new minimum                 PP02 219
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PP02 220
IF(X>=PMAX) MC=0#                      Cancel if new peak smaller       PP02 221
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PP02 222
ELSE  STOP7=STOP7+STEP7#               Incr temp peak pointer           PP02 223
#                                                                       PP02 224
#    STORE NEW PEAK IN TEMP LIST 7                                      PP02 225
#    -----------------------------                                      PP02 226
#                                                                       PP02 227
IF(MC>0)#                              If it's not an extra and the     PP02 228
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PP02 229
pnt1:(MC)=DX+APNT#                     Store point values               PP02 230
lin1:(MC)=DY+ALIN#                     Store line  values               PP02 231
lay1:(MC)=ALAY#                        Store section values             PP02 232
pek1:(MC)=PMAX#                        Store peak  values               PP02 233
code:(MC)=CODE#                        Store position code              PP02 234
flag:=0.#                              Initial storage flag             PP02 235
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PP02 236
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PP02 237
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PP02 238
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PP02 239
#                                                                       PP02 240
#    CHECK DENSITY THRESHOLD AFTER FIRST LAYER                          PP02 241
#    -----------------------------------------                          PP02 242
#                                                                       PP02 243
IF(LAY==ILAY&((NDEN>MDEN)\(MXL>0)))#   Is adjustment necessary          PP02 244
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PP02 245
DMIN=DMIN+DENS*.25/FLOAT(NDEN)#        Estimate new dmin                PP02 246
ncodefld:(DMIN,1,P302,500622.,1)#      Format adjusted peak max         PP02 247
writeline:(0,P302,NP302,3,3)#          Print adjusted peak limit        PP02 248
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PP02 249
#                                                                       PP02 250
#    PROCESS PEAKS IN TEMP LIST & COMPRESS                              PP02 251
#    ------------------------------------                               PP02 252
#                                                                       PP02 253
IF(TPEAK==0) NEXT#                     Skip if no peaks                 PP02 254
FOR(MP=MARK7;MP<STOP7;MP=MP+STEP7)#    Loop over temp peak list         PP02 255
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PP02 256
IF((flag:>1.5)\(lay1:>ALAY-.5)) NEXT#  Skip if transferred              PP02 257
CALL PP04(MP,pek1:,lay1:)#             Transfer to permanent list       PP02 258
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PP02 259
#                                                                       PP02 260
#  COMPRESS TEMP LIST IF NOT LAST LAYER                                 PP02 261
#  ---------------------------------                                    PP02 262
#                                                                       PP02 263
IF(LAY<MLAY)#                          Test if last layer               PP02 264
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PP02 265
MC=MARK7#                              Reset compress pointer           PP02 266
FOR(MP=MARK7;MP<STOP7;MP=MP+STEP7)#    Loop over temp list              PP02 267
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 PP02 268
IF((flag:>1.5)&(lay1:<ALAY-.5))NEXT#   Skip if peak transferred         PP02 269
movereal:(QX,MP+1,QX,MC+1,STEP7,1)#    Push back temp list              PP02 270
MC=MC+STEP7#                           Incr push back pointer           PP02 271
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 PP02 272
STOP7=MC#                              Store new temp peak limit        PP02 273
TPEAK=(MC-MARK7)/STEP7#                Calc number temp peaks           PP02 274
MPEAK=TPEAK#                           Store current peak number        PP02 275
MXL=0#                                 Reset signal for spillover m     PP02 276
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PP02 277
#                                                                       PP02 278
#    THIS IS THE LAST LAYER                                             PP02 279
#    ----------------------                                             PP02 280
#                                                                       PP02 281
ELSE#                                  Last section has been done       PP02 282
FOR(MP=MARK7;MP<STOP7;MP=MP+STEP7)#    Loop over temp peak list         PP02 283
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 PP02 284
IF(flag:>1.5) NEXT#                    Skip transferred peaks           PP02 285
CALL PP04(MP,pek1:,lay1:)#             Transfer to permanent list       PP02 286
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 PP02 287
#                                                                       PP02 288
#   RESET PEAK MAX FROM PROFILE                                         PP02 289
#   ---------------------------                                         PP02 290
#                                                                       PP02 291
J=0;  K=NPEAKS*1.5#                    Reset peak counter               PP02 292
FOR(I=STOP2;I>MARK2;I=I-1)#            Loop over peak profile table     PP02 293
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 PP02 294
J=J+NINT(QX(I))#                       Sum peaks in perm list           PP02 295
IF(J<K) NEXT#                          Skip if limit not reached        PP02 296
PMIN=AMAX1(PMIN,FLOAT(I-MARK2)+PLIM)#  Calc new peak min                PP02 297
DMIN=AMAX1(DMIN,PMIN/4)#               Calc new density min             PP02 298
BREAK#                                 Exit with new values             PP02 299
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 PP02 300
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PP02 301
#                                                                       PP02 302
readwpkt:(3,endrecord:,I,I,0)#         Close off fourr file c           PP02 303
#                                                                       PP02 304
RETURN#                                                                 PP02 305
END#                                                                    PP02 306
systemheader:(PP03)#                                                    PP03   1
#******************************************************************#    PP03   2
#                                                                  #    PP03   3
#                                PP03                              #    PP03   4
#                                                                  #    PP03   5
#******************************************************************#    PP03   6
SUBROUTINE PP03(PM,PH,PP,DV,DM)#                                        PP03   7
#                                                                       PP03   8
REAL S,PM,PP,PH,DV,DM#                                                  PP03   9
#                                                                       PP03  10
S=PP+PM-2.*PH#                                                          PP03  11
IF(ABS(S)>small:)#                     If s is not zero                 PP03  12
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PP03  13
DV=(PM-PP)/(2.*S); DM=-0.5*S*DV*DV#                                     PP03  14
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PP03  15
ELSE#                                                                   PP03  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PP03  17
DV=0.; DM=0.#                                                           PP03  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PP03  19
RETURN#                                                                 PP03  20
END#                                                                    PP03  21
systemheader:(PP04)#                                                    PP04   1
#******************************************************************#    PP04   2
#                                                                  #    PP04   3
#                                PP04                              #    PP04   4
#                                                                  #    PP04   5
#******************************************************************#    PP04   6
SUBROUTINE PP04(MP,PH,SECTN)#          Transfer peak to perm list       PP04   7
include:(AACOMN)#                                                       PP04   8
include:(PPCOMN)#                                                       PP04   9
#                                                                       PP04  10
INTEGER I,J,K,ISTOP,NEW,NOVER#                                          PP04  11
INTEGER MTAB(10)#                                                       PP04  12
INTEGER MP,KP,IND#                                                      PP04  13
REAL A,B,C,X,Y,Z,U,V,W,DX,DY,DZ#                                        PP04  14
REAL P(3),PH,SECTN,DD,RES1#                                             PP04  15
intdata:(INDX,[3,2,3,2,1,2,3,2,3])#                                     PP04  16
datastuff:#                                                             PP04  17
#                                                                       PP04  18
#    PREPARE TO CHECK EXISTING PEAK LIST                                PP04  19
#    -----------------------------------                                PP04  20
#                                                                       PP04  21
IF(PH<PMIN) GOTO 100#                  Exit if peak too small           PP04  22
K=NINT(code:);  IND=INDX(K)#           Extract reliability index        PP04  23
NOVER=0;   RES1=RES*RES#               Reset overlap table pointer      PP04  24
NEW=yes:#                              Set new peak flag                PP04  25
P(3)=pnt1:/GR3#                        Convert across to fractions      PP04  26
P(2)=lin1:/GR2#                        Convert down   to fractions      PP04  27
P(1)=SECTN/GR1#                        Convert layer  to fractions      PP04  28
A=P(IS1);  B=P(IS2);  C=P(IS3)#        Convert to crystal axes          PP04  29
IF(ISYM==no:) ISTOP=MARK1+STEP1#       Apply only trivial symop         PP04  30
ELSE          ISTOP=STOP1#             Apply all symops                 PP04  31
#                                                                       PP04  32
#   LOOP OVER EXISTING PEAKS IN LIST                                    PP04  33
#   --------------------------------                                    PP04  34
#                                                                       PP04  35
FOR(KP=MARK8;KP<STOP8;KP=KP+STEP8)#    Loop over peaks list             PP04  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PP04  37
IF(peakh:<PMIN) NEXT#                  Ignore rejected peaks            PP04  38
X=peakx:;  Y=peaky:;  Z=peakz:#        Store peak coords local          PP04  39
#                                                                       PP04  40
#  SEARCH SYMMETRY EQUIVALENT COORDINATES                               PP04  41
#  --------------------------------------                               PP04  42
#                                                                       PP04  43
FOR(K=MARK1;K<ISTOP;K=K+STEP1)#        Loop over all symops             PP04  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PP04  45
U=X*QX(K+1)+Y*QX(K+4)+Z*QX(K+7)+QX(K+10)# Generate equivalent x         PP04  46
V=X*QX(K+2)+Y*QX(K+5)+Z*QX(K+8)+QX(K+11)# Generate equivalent y         PP04  47
W=X*QX(K+3)+Y*QX(K+6)+Z*QX(K+9)+QX(K+12)# Generate equivalent z         PP04  48
DX=MOD(99.5+A-U,1.)-0.5#               Ensure x' close to x             PP04  49
DY=MOD(99.5+B-V,1.)-0.5#               Ensure y' close to y             PP04  50
DZ=MOD(99.5+C-W,1.)-0.5#               Ensure z' close to z             PP04  51
DD=G1*DX**2+G6*DY*DZ+G5*DY**2+G3*DX*DZ+G9*DZ**2+G2*DX*DY#               PP04  52
IF(DD>RES1) NEXT#                      Continue if not overlapped       PP04  53
#                                                                       PP04  54
#  OVERLAPPED PEAK FOUND                                                PP04  55
#  ---------------------                                                PP04  56
#                                                                       PP04  57
I=NINT(index:)#                        Store reliability index          PP04  58
IF((IND>I)\(IND==I&PH<peakh:)) NEW=no:# Reject new peak                 PP04  59
ELSE#                                  New overlap peak larger          PP04  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PP04  61
IF(NOVER==10) BREAK#                   Store only 10 overlaps           PP04  62
NOVER=NOVER+1#                         Count number of overlaps         PP04  63
MTAB(NOVER)=KP#                        Pointer in overlap table         PP04  64
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PP04  65
BREAK#                                 Exit symop loop                  PP04  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PP04  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PP04  68
#                                                                       PP04  69
#   ACCEPT NEW PEAK                                                     PP04  70
#   ---------------                                                     PP04  71
#                                                                       PP04  72
IF(NOVER>0)#                           Test if any overlaps             PP04  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PP04  74
DO I=1,NOVER#                          Loop peak overlap list           PP04  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PP04  76
KP=MTAB(I)#                            Point to overlaped peak          PP04  77
J=MIN0(MARK2+INT(peakh:-PLIM),STOP2)#  Point to peak ht array           PP04  78
QX(J)=QX(J)-1.#                        Decr peak ht array               PP04  79
peakh:=0.#                             Flag as reject in peak table     PP04  80
NPTS=NPTS-1#                           Reduce peak count                PP04  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PP04  82
IF(NEW==no:) GO TO 100#                Not largest overlap              PP04  83
KP=MTAB(1)#                            Insert new peak in old slot      PP04  84
NPTS=NPTS+1#                           Count new peak                   PP04  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PP04  86
ELSE IF(NEW==yes:)#                    No overlap check free slots&     PP04  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PP04  88
I=MARK8; DD=999999.#                   Set sort parameters              PP04  89
FOR(KP=MARK8;KP<STOP8;KP=KP+STEP8)#    Loop over peak table             PP04  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PP04  91
IF(peakh:<PMIN)#                       Use slot of culled peak          PP04  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PP04  93
NPTS=NPTS+1 ; GOTO 50#                 Count additional peak            PP04  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PP04  95
IF(peakh:>DD)    NEXT#                 Sort on peak height              PP04  96
I=KP; DD=peakh:#                       Store smallest peak              PP04  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PP04  98
IF(STOP8<STOPP)#                       Test if inside max               PP04  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PP04 100
KP=STOP8#                              Point to end of table            PP04 101
STOP8=STOP8+STEP8#                     Expand table                     PP04 102
NPTS=NPTS+1#                           Count additional peak            PP04 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PP04 104
ELSE IF(DD<PH)     KP=I#               Point to smallest peak           PP04 105
ELSE         GO TO 100#                If too small ignore              PP04 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PP04 107
ELSE GO TO 100#                        Reject small overlap peak        PP04 108
#                                                                       PP04 109
#  PREPARE NEW COORDS FOR PEAK TABLE                                    PP04 110
#  ---------------------------------                                    PP04 111
#                                                                       PP04 112
50  CONTINUE#                          Branch point for transfer        PP04 113
peakx:=A#                              Store x coord                    PP04 114
peaky:=B#                              Store y coord                    PP04 115
peakz:=C#                              Store z coord                    PP04 116
peakh:=PH+.0001#                       Store peak height                PP04 117
index:=FLOAT(IND)#                     Store reliability index          PP04 118
I=MIN0(MARK2+INT(PH-PLIM),STOP2)#      Point to peak max profile        PP04 119
QX(I)=QX(I)+1.#                        Count peak max as profile        PP04 120
100 CONTINUE#                                                           PP04 121
flag:=2.#                              Flag peak as processed           PP04 122
#                                                                       PP04 123
RETURN#                                                                 PP04 124
END#                                                                    PP04 125
systemheader:(PP05)#                                                    PP05   1
#*********************************************************************# PP05   2
#                                                                     # PP05   3
#                                PP05                                 # PP05   4
#                                                                     # PP05   5
#*********************************************************************# PP05   6
SUBROUTINE PP05#                                                        PP05   7
include:(AACOMN)#                                                       PP05   8
include:(PPCOMN)#                                                       PP05   9
#                                                                       PP05  10
string:(OUTL,80)#                                                       PP05  11
INTEGER I,J,K,M,N#                                                      PP05  12
INTEGER IP,KP#                                                          PP05  13
REAL A,B,C,X,Y,Z,U,V,W,DD,DX,DY,DZ#                                     PP05  14
chardata:(P50," warning: Peaks may not match equivalent sites $#        PP05  15
because of different phase origin")#                                    PP05  16
chardata:(P51," Atom Sites NOT matched with Peaks-")#                   PP05  17
chardata:(P52," x/a     y/b     z/c")#                                  PP05  18
chardata:(P53," Unique peaks resolved                            ")#    PP05  19
chardata:(P54," Atom or peak sites found in map")#                      PP05  20
chardata:(P55," Atom and peak matches if closer than (A)     0.35")#    PP05  21
chardata:(P56," x/a     y/b     z/c     $#                              PP05  22
max    gridX   gridY   gridZ   Vector (A)")#                            PP05  23
chardata:(P5A,"holepeak")#                                              PP05  24
realdata:(FT,[822.,822.,822.])#                                         PP05  25
realdata:(FOM,[842.,842.,842.,832.])#                                   PP05  26
datastuff:#                                                             PP05  27
#                                                                       PP05  28
#    SET UP TITLES TO TELL WHETHER PEAKS OR HOLES ARE SOUGHT            PP05  29
#    -------------------------------------------------------            PP05  30
#                                                                       PP05  31
IF(HOLE==no:)#                         Set up headings                  PP05  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PP05  33
movechar:(P5A,5,P51,30,4,0)#           Put 'peak' in header             PP05  34
movechar:(P5A,5,P53,9,4,0)#            Put 'peak' in header             PP05  35
movechar:(P5A,5,P54,10,4,0)#           Put 'peak' in header             PP05  36
movechar:(P5A,5,P55,11,4,0)#           Put 'peak' in header             PP05  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PP05  38
ELSE#                                                                   PP05  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PP05  40
movechar:(P5A,1,P51,30,4,0)#           Put 'hole' in header             PP05  41
movechar:(P5A,1,P53,9,4,0)#            Put 'hole' in header             PP05  42
movechar:(P5A,1,P54,10,4,0)#           Put 'hole' in header             PP05  43
movechar:(P5A,1,P55,11,4,0)#           Put 'hole' in header             PP05  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PP05  45
#                                                                       PP05  46
#    SORT PERMANENT PEAK LIST                                           PP05  47
#    ------------------------                                           PP05  48
#                                                                       PP05  49
NPTS=MIN0(NPTS,NPEAKS)#                Set as smaller number            PP05  50
STOP7=MIN0(MARK8,MARK7+2*NPTS)#        End of sort list pointers        PP05  51
FOR(I=MARK7;I<STOP7;I=I+2)#            Loop over sort pointers          PP05  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PP05  53
A=0.;    K=MARK8#                      Initialize sort values           PP05  54
FOR(KP=MARK8;KP<STOP8;KP=KP+STEP8)#    Loop over perm peak list         PP05  55
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PP05  56
IF(index:>100.\A>peakh:) NEXT#         Skip if smaller                  PP05  57
A=peakh:;   K=KP#                      Store largest peak               PP05  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PP05  59
QX(I+1)=FLOAT(K)#                      Store addr sorted peak           PP05  60
QX(I+2)=0.#                            Reset for atom list              PP05  61
index:(K)=1000.#                       Cull peak from sort              PP05  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PP05  63
#                                                                       PP05  64
#   CONNECT ATOMS LIST TO PEAK LIST                                     PP05  65
#   -------------------------------                                     PP05  66
#                                                                       PP05  67
N=0#                                   Count atom sites                 PP05  68
IF(STOP3>MARK3)#                       Ignore if no sites or vect map   PP05  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PP05  70
FOR(J=MARK7;J<STOP7;J=J+2)#            Loop over sort pointers          PP05  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PP05  72
M=NINT(QX(J+1))#                       Extract peak list address        PP05  73
A=peakx:(M); B=peaky:(M); C=peakz:(M)# Get peak coords to local         PP05  74
FOR(KP=MARK3;KP<STOP3;KP=KP+STEP3)#    Loop over atoms list             PP05  75
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PP05  76
ifne:(peakh:,0.) NEXT#                 Skip if already matched          PP05  77
X=peakx:; Y=peaky:; Z=peakz:#          Store atom coords local          PP05  78
FOR(K=MARK1;K<STOP1;K=K+STEP1)#        Loop over all symops             PP05  79
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PP05  80
U=X*QX(K+1)+Y*QX(K+4)+Z*QX(K+7)+QX(K+10)# Generate equivalent x         PP05  81
V=X*QX(K+2)+Y*QX(K+5)+Z*QX(K+8)+QX(K+11)# Generate equivalent y         PP05  82
W=X*QX(K+3)+Y*QX(K+6)+Z*QX(K+9)+QX(K+12)# Generate equivalent z         PP05  83
DX=MOD(99.5+A-U,1.)-0.5#               Ensure x' close to x             PP05  84
DY=MOD(99.5+B-V,1.)-0.5#               Ensure y' close to y             PP05  85
DZ=MOD(99.5+C-W,1.)-0.5#               Ensure z' close to z             PP05  86
DD=G1*DX**2+G6*DY*DZ+G5*DY**2+G3*DX*DZ+G9*DZ**2+G2*DX*DY#               PP05  87
IF(DD>0.12) NEXT#                      Skip if outside d=0.35 angst     PP05  88
QX(J+2)=FLOAT(KP)#                     Store atom addr in sort list     PP05  89
peakh:=FLOAT(M);   N=N+1#              Store peak addr in atom list     PP05  90
GOTO 100#                              Exit search list                 PP05  91
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PP05  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PP05  93
100 CONTINUE#                                                           PP05  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PP05  95
#                                                                       PP05  96
#   LIST UNCONNECTED ATOMS                                              PP05  97
#   ----------------------                                              PP05  98
#                                                                       PP05  99
ncodefld:(FLOAT(NPTS),1,P53,500313.,1)# Format peak number              PP05 100
writeline:(0,P53,NP53,3,3)#            Write headings                   PP05 101
writeline:(0,P55,NP55,3,3)#            Write atom/peak resolution       PP05 102
K=0#                                   Initialize heading signal        PP05 103
FOR(I=MARK3;I<STOP3;I=I+STEP3)#        Loop over atom list              PP05 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PP05 105
IF(QX(I+4)>.5) NEXT#                   Skip if atom connected           PP05 106
IF(K==0)#                              Write heading first time         PP05 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PP05 108
IF(CTYPE==4) writeline:(1,P50,NP50,3,3)# Warn of origin if emap         PP05 109
movechar:(P51,NP51,CHROT,2,NP51-2,2)#  Insert header underline          PP05 110
writeline:(1,P51,NP51-1,2,3)#          Print header                     PP05 111
LINRM=6;   K=1#                        Force header & flagoff           PP05 112
HEADOT=' '; HEADOT(LABMAX+8^)=P52#     Store atom header line           PP05 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PP05 114
movertoc:(QX(I+5),1,CHROT,2,24,0)#     Move name to output line         PP05 115
LCHROT=LABMAX+4#                       Set format pointer               PP05 116
ncodefld:(QX,I+1,CHROT,FOM,3)#         X,y,z                            PP05 117
writeline:(0,HEADOT,100,1,3)#          Print atom coords                PP05 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PP05 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PP05 120
#                                                                       PP05 121
#   PRINT SORTED PEAKS                                                  PP05 122
#   ------------------                                                  PP05 123
#                                                                       PP05 124
IF(CTYPE>3)movechar:(BLANK,1,P56,NP56-9,10,2)# Blank vector             PP05 125
movechar:(P51,NP51,CHROT,2,NP54-1,2)#  Insert header underline          PP05 126
writeline:(1,P54,NP54,2,3)#            Write headings                   PP05 127
HEADOT=' '; HEADOT(LABMAX+10^)=P56#    Store header line                PP05 128
LINRM=10#                              Force first header               PP05 129
KP=NINT(QX(MARK7+1)); A=peakh:#        Get maximum peak height          PP05 130
FOR(I=MARK7;I<STOP7;I=I+2)#            Loop over sort list              PP05 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PP05 132
KP=NINT(QX(I+1))#                      Get peak list pointer            PP05 133
IP=NINT(QX(I+2))#                      Get atom list pointer            PP05 134
LCHROT=LABMAX+6#                       Set format pointer               PP05 135
ncodefld:(QX,KP+1,CHROT,FOM,4)#        Get x,y,z and peak height        PP05 136
BUFOT(1)=QX(KP+1)*FLOAT(NG(IS1))#      Get mapx                         PP05 137
BUFOT(2)=QX(KP+2)*FLOAT(NG(IS2))#      Get mapy                         PP05 138
BUFOT(3)=QX(KP+3)*FLOAT(NG(IS3))#      Get mapz                         PP05 139
ncodefld:(BUFOT,1,CHROT,FT,3)#         Format mapx,y,z                  PP05 140
IF(CTYPE>=1&CTYPE<=3)#                 For vector maps                  PP05 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PP05 142
DX=QX(KP+1); DY=QX(KP+2); DZ=QX(KP+3)# Get fraction coords              PP05 143
DD=SQRT(G1*DX**2+G6*DY*DZ+G5*DY**2+G3*DX*DZ+G9*DZ**2+G2*DX*DY)#         PP05 144
ncodefld:(DD,1,CHROT,1022.,1)#         Format dist from origin          PP05 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PP05 146
IF(IP>0)#                              Test for overlap atom            PP05 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PP05 148
movertoc:(QX(IP+5),1,CHROT,2,LABMAX,0)# Insert atom name                PP05 149
QX(KP+4)=1000000.+QX(KP+4)#            Flag overlapped peak             PP05 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PP05 151
ELSE#                                  Else this is a peak              PP05 152
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PP05 153
N=N+1#                                 Peak counter                     PP05 154
ncodefld:(FLOAT(N),1,CHROT,70313.,1)#  Format peak number               PP05 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PP05 156
writeline:(0,HEADOT,120,1,3)#          Print peak coords                PP05 157
#                                                                       PP05 158
IF(IPCH==no:) NEXT#                    Is punch output requested        PP05 159
OUTL='ATOM C '#                        Initialize punch line            PP05 160
IF(IP>0) movertoc:(QX(IP+5),1,OUTL,6,24,0)# Insert atom name            PP05 161
ELSE     ncodefld:(FLOAT(N),1,OUTL,100443.,1)# Insert atom number       PP05 162
LCHROT=LABMAX+12#                      Set format pointer               PP05 163
ncodefld:(QX,KP+1,OUTL,FOM,3)#         Get x,y,z                        PP05 164
writepch:(OUTL,80)#                    Punch 72-char line               PP05 165
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PP05 166
#                                                                       PP05 167
#   OUTPUT FILE PEK                                                     PP05 168
#   ---------------                                                     PP05 169
#                                                                       PP05 170
IF(IFILE==yes:)#                       If file e requested              PP05 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PP05 172
writepkt:(5,21,STEP3,IP)#              Point to atoms list packet       PP05 173
QX(IP+1)=FLOAT((STOP3-MARK3)/STEP3)#   Store number of atoms            PP05 174
QX(IP+2)=FLOAT(NPTS)#                  Store new peak count             PP05 175
QX(IP+3)=RES#                          And resolution                   PP05 176
QX(IP+4)=FLOAT(NPEAKS)#                And expected peak count          PP05 177
FOR(I=MARK3;I<STOP3;I=I+STEP3)#        Loop over atoms list             PP05 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PP05 179
writepkt:(5,21,STEP3,IP)#              Point to atoms packet            PP05 180
QX(I+4)=AMAX1(A,5.)#                   Set peak height at max           PP05 181
movereal:(QX,I+1,QX,IP+1,STEP3,0)#     Transfer x,y,z,peak,name         PP05 182
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PP05 183
#                                                                       PP05 184
FOR(I=MARK7;I<STOP7;I=I+2)#            Loop over all peaks saved        PP05 185
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PP05 186
J=NINT(QX(I+1))#                       Get peaks in sort order          PP05 187
writepkt:(5,22,4,IP)#                  Point to next packet             PP05 188
movereal:(QX,J+1,QX,IP+1,4,1)#         Put packet in scratch file b     PP05 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PP05 190
writepkt:(5,endrecord:,1,IP)#          Finish off file properly         PP05 191
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PP05 192
#                                                                       PP05 193
RETURN#                                                                 PP05 194
END#                                                                    PP05 195
pmacro:([no:])#                        Purge xtal system macros         PP05 196
