systemheader:(PV    )#                                                  PV     1
####################################################################    PV     2
##      Copyright (C) 2000, The Xtal System, The University of        # PV     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # PV     4
## Distributed under the GNU General Public Licence as published by   # PV     5
## the Free Software Foundation, in the hope that it will be useful   # PV     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # PV     7
## for more details.                                                  # PV     8
##                                                                 #    PV     9
##                       *** PREVUE ***                            #    PV    10
##                                                                 #    PV    11
## PREVUE is used to manipulate atom labels from plot files output #    PV    12
## by ORTEP, ABSORB, CONTRS, and NEWMAN. The output file is read   #    PV    13
## by PLOTX for hardcopy plotting.                                 #    PV    14
##                                                                 #    PV    15
####################################################################    PV    16
##                                                                      PV    17
include:(XMACRO)#                                                       PV    18
##                                                                      PV    19
##              MACRO:s FOR GRAPHICS LIBRARIES                          PV    20
##              ------------------------------                          PV    21
##                                                                      PV    22
##                                                                      PV    23
macro:(noop:,IWIWIW=0)#                Passive no-operation             PV    24
macro:(dcode:,X11LIB)#                 Local device name (6chrs)        PV    25
macro:(xmaxw:,1.)#                     Plot width  (x) in units         PV    26
macro:(ymaxh:,0.95)#                   Plot height (y) in units         PV    27
macro:(xpixl:,1000.)#                  Pixels per unit along x          PV    28
macro:(ypixl:,1000.)#                  Pixels per unit along y          PV    29
macro:(buffr:,1000)#                   Qx buffer size for plot          PV    30
macro:(color:,yes:)#                   Is color supported               PV    31
#                                                                       PV    32
#                                                                       PV    33
ifsel:(VMS)#                           Obscure c interface vms-ism      PV    34
macro:(vms:,%REF($1))#                 Pass by reference, not by desc   PV    35
ifsel:#                                                                 PV    36
macro:(vms:,$1)#                       Always by reference              PV    37
endsel:#                                                                PV    38
#                                                                       PV    39
# WATCH OUT FOR THESE OBSCURE VMS STRING PASSING REQUIREMENTS           PV    40
macro:(xmouse:,             CALL XBNDME($1,$2,vms:($3)))#               PV    41
macro:(xcontact:,               CALL XCONT($1,vms:($2)))#               PV    42
macro:(getwid:,        CALL XGETID(WINDOW($1),vms:($2)))#               PV    43
macro:(xstart:,             CALL XSTART($1,$2,vms:($3)))#               PV    44
macro:(requstrg:,$(WI=WIN;  CALL XGETST(WI,$1,vms:($2))#                PV    45
IF(WI==0) iquit:(PV0001)$))#           Get string                       PV    46
macro:(drawtext:,CALL XTEXT($1,$2,$3,$4,$5,$6,vms:($7)))#               PV    47
#                                                                       PV    48
## X Window System Version 11 interface                                 PV    49
macro:(xstdc:,   CALL XSTDC())#                                         PV    50
macro:(setcolor:,CALL XDEFC($1,$2,$3,$4))# Colour index $1              PV    51
macro:(xsetpg:,  CALL XSETPG($1,$2))#                                   PV    52
macro:(requpick:,$(WI=WIN;CALL XGETSG(WI,WIGLEV,$1)#                    PV    53
IF(WI==0) iquit:(PV0001)$))#                                            PV    54
macro:(requlocr:,$(WI=WIN;CALL XGETXY(WI,$1,$2)# Request mouse posn     PV    55
IF(WI==0) iquit:(PV0001)$))#           Get string                       PV    56
macro:(frame:,   $(WI=WIN;CALL XFRAME(WI,0)$))# Don't wait - just era   PV    57
macro:(finis:,   CALL XFINIS())#                                        PV    58
macro:(xflush:,  CALL FLUSHX())#                                        PV    59
macro:(xauxrefcom:, CALL XADARC($1,$2))#                                PV    60
macro:(xauxwinconf:, CALL XADAWC($1,$2))#                               PV    61
##                                                                      PV    62
##                                                                      PV    63
macro:(start:,#                                                         PV    64
[$(ANSWER=0;xcontact:(ANSWER,"prevue.tcl")# Contact x server            PV    65
IF(ANSWER>0)iquit:(PV4000)#            Quit if none available           PV    66
DBUF=0; xstart:(DBUF,WIN,".prevue.main")#                               PV    67
IF(WIN==0) iquit:(PV4000)#             Bail out if can't open wndo      PV    68
CALL XGETMC(MINCOL,MAXCOL)#            Get number of open color cells   PV    69
xstdc:#                                Define standard 8 colors         PV    70
I=0;xsetpg:(WIN,I)#                    Set default page                 PV    71
$)])#                                                                   PV    72
#                                                                       PV    73
macro:(plotp:, [CALL XLINES($1,QX($2),QX($2+NBUF),$3)])# Draw polylin   PV    74
macro:(areap:, [CALL XFILL($1,QX($2),QX($2+NBUF))])# Fill area          PV    75
macro:(nupen:, [$(IF(COLOR==2) CALL XSETFS($1)# Pv                      PV    76
ELSE $(CALL XSETFC($1); CALL XSETLC($1)$)# Set colour index             PV    77
CALL XSETLS($2)$)])#                                                    PV    78
##--------------------------------------------------------------------  PV    79
##                                                                      PV    80
##               DEVICE INDEPENDENT MACROS                              PV    81
##               -------------------------                              PV    82
##                                                                      PV    83
macro:(mess:,CALL PV02($1,$2))#                                         PV    84
macro:(segcreat:,CALL XSMAKE($1))#     Create a segment                 PV    85
macro:(segclose:,CALL XSCLOS())#       Close a segment                  PV    86
macro:(segdetec:,CALL XSSETD($1,1))#   Set segment detectable           PV    87
macro:(segundet:,CALL XSSETD($1,0))#   Set segment undetectable         PV    88
macro:(segdelet:,CALL XSDEL($1))#      Delete segment                   PV    89
macro:(fillcolr:,CALL XSETFC($1))#     Define fill color                PV    90
macro:(fillarea:,CALL XFILL($1,$2,$3))# Draw fill area                  PV    91
macro:(swapbuff:,IF(DBUF==yes:)CALL XBFCPY(WIN))# Copy backbuffer to    PV    92
macro:(registercbs1:,$(WI=WIN#         Register call back functions     PV    93
CALL XB1PCB(WI,1,PV74);CALL XB2PCB(WI,0,PV71);CALL XB3PCB(WI,1,PV71)#   PV    94
CALL XB1MCB(WI,1,PV75);CALL XB2MCB(WI,0,PV71);CALL XB3MCB(WI,1,PV72)#   PV    95
CALL XB1RCB(WI,1,PV76);CALL XB2RCB(WI,0,PV71);CALL XB3RCB(WI,1,PV73)#   PV    96
$))#                                                                    PV    97
macro:(deregistercbs:,$(WI=WIN#        De-register call back function   PV    98
CALL XB1PCB(WI,0,PV71);CALL XB1MCB(WI,0,PV71);CALL XB1RCB(WI,0,PV71)#   PV    99
CALL XB2PCB(WI,0,PV71);CALL XB2MCB(WI,0,PV71);CALL XB2RCB(WI,0,PV71)#   PV   100
CALL XB3PCB(WI,0,PV71);CALL XB3MCB(WI,0,PV71);CALL XB3RCB(WI,0,PV71)#   PV   101
$))#                                                                    PV   102
macro:(setgcxor:,CALL XGCXOR(1)  )#    Exclusive or on screen           PV   103
macro:(setgcxcopy:,CALL XGCXOR(0))#    Overwrite    on screen           PV   104
macro:(linecolr:,$(CURLC=$1;CALL XSETLC(CURLC)$))#                      PV   105
macro:(linesize:,$(CURLS=$1;CALL XSETLW(CURLS)$))#                      PV   106
macro:(linedraw:,CALL XLINES($1,$2,$3,3))# Polyline                     PV   107
#                                                                       PV   108
macro:(markcolr:,CALL XSETMC($1))#     Define polymarker color          PV   109
macro:(marksize:,CALL XSETMS($1*OMAG))# Polymarker scale                PV   110
macro:(marktype:, )#                   Define polymarker type           PV   111
macro:(markdraw:,CALL XMARK($1,OMAG*($2+XOFF),OMAG*($3+YOFF)))# Polym   PV   112
##                                                                      PV   113
# --------------------------------------------------------------------  PV   114
##                                                                      PV   115
##                                                                      PV   116
extrude:(PVCOMN)#                                                       PV   117
##                                                                      PV   118
INTEGER AREAOT#                        Count of area buffer             PV   119
INTEGER BCOL#                          Bond colour index                PV   120
INTEGER CCOL#                          Character colour index           PV   121
INTEGER COLOR#                         Indicates colour changes         PV   122
INTEGER COLR(10)#                      Colour index array               PV   123
INTEGER ALIN(10)#                      Dot-dash array index             PV   124
INTEGER CONTUR#                        Contour flag                     PV   125
INTEGER FILL#                          Fill bonds/atoms flag            PV   126
INTEGER FILLUP#                        Fillup this item                 PV   127
INTEGER FULL#                          End of coord buffer 1            PV   128
INTEGER FIRSTT#                        Signal first call of py11        PV   129
INTEGER FRAME(20)#                     Frames to be plotted             PV   130
INTEGER IBRDR#                         Flag for drawing border          PV   131
INTEGER ICENTR#                        Flag for auto centering          PV   132
INTEGER ICOL#                          Flag to apply color              PV   133
INTEGER IFRAM#                         Count of frames                  PV   134
INTEGER IP#                            Pointer to coord buffer          PV   135
INTEGER IPND#                          End of section of coord buffer   PV   136
INTEGER ISEG#                          Count of segments                PV   137
INTEGER JP#                            Pointer to filee buffer          PV   138
INTEGER IBAK#                          Background flag 1 to blank       PV   139
INTEGER ICHR#                          Output buffer pointer px02       PV   140
INTEGER IPLOT#                         Count of plots on file           PV   141
INTEGER ISCALE#                        Flag for auto scaling            PV   142
INTEGER MARK#                          Start of coord buffer            PV   143
INTEGER MAXCOL#                        Number of open color cells       PV   144
INTEGER MINCOL#                        Minimum available color          PV   145
INTEGER MXCOL#                         Current number of color cells    PV   146
INTEGER MESS#                          Message segment number           PV   147
INTEGER NBUF#                          Max size of one coord buffer     PV   148
INTEGER NCOL#                          Number colour index              PV   149
INTEGER NCOLS#                         Number columns in line           PV   150
INTEGER NDEV#                          Device number                    PV   151
INTEGER NDIS#                          Display identifier               PV   152
INTEGER NEW#                           New colour coming flag           PV   153
INTEGER NF#                            Function number                  PV   154
INTEGER NCC#                           Count pen up movements           PV   155
INTEGER NLINE#                         Number lines per plot page       PV   156
INTEGER NP#                            Number of points in buffer       PV   157
INTEGER NPLOT#                         Plot number                      PV   158
INTEGER NPT#                           Count pen down movements         PV   159
INTEGER NSKIP#                         Column count +1                  PV   160
INTEGER OLDPLT#                        Backwards compatability          PV   161
INTEGER PENCOL#                        Pen colour                       PV   162
INTEGER PENSTY#                        Atom outline style               PV   163
INTEGER PLTINS#                        Plot instruction number          PV   164
INTEGER VTC#                           Vector text color                PV   165
INTEGER DBUF#                          Double buffer flag               PV   166
INTEGER RETRACE#                       Black border on all regions?     PV   167
INTEGER WIGLEV#                                                         PV   168
pointer: WIN,WI#                       Tk window pointers               PV   169
REAL AHIGH#                            Plot height                      PV   170
REAL AWIDE#                            Plot width                       PV   171
REAL OMAG#                             Magnification factor             PV   172
REAL RESL#                             Resolution                       PV   173
REAL SCALX,SCALY#                      Scale to output frame            PV   174
REAL TEXTSC#                           Text char scale                  PV   175
REAL XCEN,YCEN#                        X,y coord of center              PV   176
REAL XLST,YLST#                        X,y last pen position            PV   177
REAL XOFF,YOFF#                        X,y output offset                PV   178
REAL XPIX,YPIX#                        X,y pixels per unit              PV   179
REAL XOLD,YOLD,XINIT,YINIT#            Coords of mouse drag             PV   180
#                                                                       PV   181
#                                                                       PV   182
COMMON/COMFPV/$#                                                        PV   183
AHIGH,AWIDE,OMAG,RESL,SCALX,SCALY,TEXTSC,#                              PV   184
XCEN,YCEN,XLST,YLST,XOFF,YOFF,XPIX,YPIX,XOLD,YOLD,XINIT,YINIT#          PV   185
#                                                                       PV   186
COMMON/COMIPV/$#                                                        PV   187
BCOL,CCOL,COLOR,COLR,CONTUR,FILL,FIRSTT,IBRDR,ICENTR,IFRAM,#            PV   188
FRAME,IBAK,IPLOT,ISCALE,NCOL,NDEV,NDIS,NPT,NPLOT,NCC,PENCOL,#           PV   189
ICHR,IP,JP,FULL,MARK,NBUF,NEW,NLINE,NCOLS,NP,ICOL,NSKIP,NF,FILLUP,#     PV   190
AREAOT,IPND,ALIN,PENSTY,ISEG,VTC,MESS,PLTINS,DBUF,MAXCOL,MXCOL,#        PV   191
MINCOL, RETRACE,OLDPLT,WIGLEV#                                          PV   192
#                                                                       PV   193
COMMON/COMPPV/WIN,WI#                  Pointers to windows              PV   194
#                                                                       PV   195
endext:#                                                                PV   196
#                                                                       PV   197
systemheader:(PV00)#                   Main plot sequence routine       PV00   1
####################################################################    PV00   2
#                                                                  #    PV00   3
#                                PV00                              #    PV00   4
#                                                                  #    PV00   5
####################################################################    PV00   6
SUBROUTINE PV00#                       S.r. hall july 88                PV00   7
include:(AACOMN)#                      V. streltsov jun 93              PV00   8
include:(PVCOMN)#                                                       PV00   9
#                                                                       PV00  10
#---------------------------------------------------------------        PV00  11
#                                                                       PV00  12
## >>>>>>>>>>>>>>> Contents of Plot File   <<<<<<<<<<<<<<<<<<<<<<       PV00  13
## >>>>>>>>>>>>>>> input as 7-word packets <<<<<<<<<<<<<<<<<<<<<<       PV00  14
#                                                                       PV00  15
## FUNCTION CODE (in word 7 of each packet)                             PV00  16
#        1       START OF PLOT                                          PV00  17
#        2       FRAME ADVANCE SIGNAL                                   PV00  18
#        3       PEN MOVEMENT                                           PV00  19
#        4       DRAW NUMBER                                            PV00  20
#        5       DRAW CHARACTER STRING                                  PV00  21
#        6       AUTO CENTER AND SCALE                                  PV00  22
#        7       COLOR MAP ENTRY                                        PV00  23
#       10       END OF PLOT                                            PV00  24
#                                                                       PV00  25
# PEN MOVEMENT (3)                                                      PV00  26
#     WORD 1       DX PLOT MOVEMENT                                     PV00  27
#     WORD 2       DY PLOT MOVEMENT                                     PV00  28
#     WORD 3       X  PLOT MOVEMENT                                     PV00  29
#     WORD 4       Y  PLOT MOVEMENT                                     PV00  30
#     WORD 5       SUBJECT (COLOR) INDEX                                PV00  31
#     WORD 6       PEN UP/DOWN FLAG (3/2)                               PV00  32
#     WORD 7       FUNCTION CODE (=3)                                   PV00  33
#                                                                       PV00  34
#-----------------------------------------------------------------      PV00  35
#                                                                       PV00  36
INTEGER KP#                                                             PV00  37
INTEGER NPEN#                          Pen up/down                      PV00  38
INTEGER PSIZE#                         Packet size                      PV00  39
INTEGER SINDX#                         Subject index                    PV00  40
REAL    X,Y#                           X & y coordinates                PV00  41
REAL    PCOM(7)#                       Plot command                     PV00  42
datastuff:#                                                             PV00  43
#                                                                       PV00  44
CALL PV11#                             ************ read controls       PV00  45
#                                                                       PV00  46
REPEAT#                                Loop over plot commands          PV00  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV00  48
readwpkt:(5,23,PSIZE,JP,0)#            Read packet input plot data      PV00  49
IF(JP<=0) iquit:(PV0001)#              Unexpected end of plot file      PV00  50
#                                                                       PV00  51
NF=NINT(QX(JP+7))#                     Extract plot function id         PV00  52
IF(NF<=2\NF==10)     CALL PV31#        Start or end plot frame          PV00  53
IF(NF!=4&NF!=5)#                       Copy all non-char/numb data      PV00  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV00  55
writepkt:(4,23,PSIZE,KP)#              Write the packet                 PV00  56
movereal:(QX,JP+1,QX,KP+1,PSIZE,1)#    Transfer data ip to op           PV00  57
PLTINS=PLTINS+1#                       Count pen movements              PV00  58
movereal:(QX,JP+1,PCOM,1,7,0)#         Copy plot command                PV00  59
writedac:(ioda2:,,PLTINS,PCOM)#        Save record in direct access     PV00  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV00  61
IF(NF==10)           BREAK#            ************* end plot           PV00  62
IF(IPLOT!=NPLOT)     NEXT#             Skip unwanted frames             PV00  63
#                                                                       PV00  64
IF(NF==3)#                             ************** plot point        PV00  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PV00  66
X=QX(JP+1)+QX(JP+3)#                   X coordinate                     PV00  67
Y=QX(JP+2)+QX(JP+4)#                   Y coordinate                     PV00  68
SINDX=NINT(QX(JP+5))#                  Subject index                    PV00  69
NPEN= NINT(QX(JP+6))#                  Pen up=3 /pen down=2             PV00  70
CALL PV01(X,Y,NPEN,SINDX)#             Execute plot command             PV00  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PV00  72
ELSE IF(NF==4\NF==5) CALL PV41#        ************* store numb/chars   PV00  73
ELSE IF(NF==6)       CALL PV51#        ************* centre/scale       PV00  74
ELSE IF(NF==7)       CALL PV52#        ************* color map          PV00  75
ELSE IF(NF==11)#                       Draw designated markers          PV00  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PV00  77
markcolr:(NINT(QX(JP+5)))#             Set the marker color             PV00  78
marksize:(QX(JP+3))#                   Scale the markers                PV00  79
marktype:(NINT(QX(JP+3)))#             Ignored currently                PV00  80
markdraw:(1,QX(JP+1),QX(JP+2))#        Polymarker                       PV00  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PV00  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV00  83
CALL PV61#                             Finish the plot                  PV00  84
#                                                                       PV00  85
RETURN#                                                                 PV00  86
END#                                                                    PV00  87
systemheader:(PV01)#                   Plot a point on surface          PV01   1
####################################################################    PV01   2
#                                                                  #    PV01   3
#                             PV01                                 #    PV01   4
#                                                                  #    PV01   5
####################################################################    PV01   6
SUBROUTINE PV01(X,Y,PEN,SINDX)#                                         PV01   7
include:(AACOMN)#                                                       PV01   8
include:(PVCOMN)#                                                       PV01   9
#                                                                       PV01  10
INTEGER COL#                           Color code for atom interior     PV01  11
INTEGER STYL#                          Code for atom line style         PV01  12
INTEGER I#                             Indices                          PV01  13
INTEGER PEN#                           Move/draw flag                   PV01  14
INTEGER SINDX#                         Color index                      PV01  15
INTEGER IPST#                          Start point of line output       PV01  16
INTEGER BFULL#                         Flag that buffer is full         PV01  17
REAL DX, DY#                           Change in x or y                 PV01  18
REAL X, Y#                             X & y coords. (units)            PV01  19
REAL X1,Y1#                            X & y coords. (scaled)           PV01  20
#                                                                       PV01  21
#  PROCESS COLOR COMMANDS                                               PV01  22
#  ----------------------                                               PV01  23
#                                                                       PV01  24
BFULL=no:#                             Initialise buffer flag           PV01  25
IF(NEW==yes:)#                         New color for new subject?       PV01  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV01  27
FILLUP=no:;STYL=1#                     Don't area fill this item        PV01  28
IF(SINDX>-1000) FILLUP=FILL#           Fill it if requested             PV01  29
IF     (SINDX==1000) COL=BCOL#         Bond color                       PV01  30
ELSE IF(SINDX>-1000)#                  Atom or contur                   PV01  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV01  32
I=MIN0(IABS(SINDX),10)#                Get pointer to color index       PV01  33
IF(I==0) COL=BCOL#                     Bond color                       PV01  34
ELSE     COL=COLR(I)#                  Interior atom or contur color    PV01  35
IF(I!=0) STYL=ALIN(I)#                 Atom line style                  PV01  36
#IF(I==8) COL=0#                       BLACK COLOR                      PV01  37
IF(MXCOL>7&SINDX<-7)#                                                   PV01  38
$(COL=IABS(SINDX);STYL=1$)#            Use the specific color           PV01  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV01  40
ELSE IF(SINDX==-4000) COL=NCOL#        Numb color                       PV01  41
ELSE IF(SINDX==-5000) COL=CCOL#        Char color                       PV01  42
ELSE IF(SINDX==-6000) COL=BCOL#        Bord color                       PV01  43
IF(COL!=PENCOL) ICOL=yes:#             New color                        PV01  44
IF(STYL!=PENSTY) ICOL=yes:#            New atom line style              PV01  45
NEW=no:#                               Reset new subject flag           PV01  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV01  47
IF(SINDX==0 & COLOR!=0) NEW=yes:#      Start new subject                PV01  48
#                                                                       PV01  49
#                                                                       PV01  50
#                                                                       PV01  51
#  PROCESS DRAW COMMANDS   (PEN UP = 3 OR BUFFER FULL)                  PV01  52
#  ---------------------                                                PV01  53
#                                                                       PV01  54
X1=OMAG*(X+XOFF);  Y1=OMAG*(Y+YOFF)#   Scaled x,y coordinate            PV01  55
DX=ABS(X1-XLST);   DY=ABS(Y1-YLST)#    Change in x,y coordinate         PV01  56
#                                                                       PV01  57
IF(DX+DY>RESL\PEN==3\ICOL==yes:)#      Test if point needed             PV01  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PV01  59
IF(NBUF==1)#                           Always plot single buffer        PV01  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PV01  61
NP=1;         IPST=IP#                 Plot one point                   PV01  62
QX(IP)=X1;    QX(IP+1)=Y1#             Store the current position       PV01  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PV01  64
ELSE#                                                                   PV01  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PV01  66
IF((IP==FULL)\(PEN==3&NEW==yes:))#     Lookahead plot test              PV01  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PV01  68
IF(IP==FULL) BFULL=yes:#               Flag full buffer                 PV01  69
NP=IP-IPND; IPST=IPND+1#               Reset the buffer pointers        PV01  70
AREAOT=IP-MARK; IP=MARK#               Reset the buffer pointers        PV01  71
IPND=IP#                               Reset the buffer pointers        PV01  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PV01  73
ELSE IF(PEN==3)#                       Lookahead plot test              PV01  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PV01  75
NP=IP-IPND; IPST=IPND+1#               Reset the buffer pointers        PV01  76
IPND=IP#                               Reset the buffer pointers        PV01  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PV01  78
IP=IP+1#                               Incr the buffer pointer          PV01  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PV01  80
#                                                                       PV01  81
#    APPLY THE COLOUR COMMANDS                                          PV01  82
#    -------------------------                                          PV01  83
#                                                                       PV01  84
IF(ICOL==yes:)#                        If color change required         PV01  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PV01  86
nupen:(COL,STYL)#                      Change color on this device      PV01  87
ICOL=no:;   NCC=NCC+1#                 Reset and count changes          PV01  88
PENCOL=COL;PENSTY=STYL#                Change the current color         PV01  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PV01  90
#                                                                       PV01  91
#    APPLY THE MOVE COMMANDS                                            PV01  92
#    -----------------------                                            PV01  93
#                                                                       PV01  94
IF(NP>0)#                              If new points required           PV01  95
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PV01  96
#                                                                       PV01  97
IF(FILLUP==yes:&AREAOT>0)#             Empty area buffer?               PV01  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PV01  99
areap:(AREAOT,MARK+1,PEN,COL)#         Plot points in buffer            PV01 100
IF(RETRACE==yes:)#                                                      PV01 101
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PV01 102
nupen:(0,1)#                           Change color on this device      PV01 103
plotp:(AREAOT,MARK+1,PEN,0)#           Plot np points in the buffer     PV01 104
nupen:(COL,STYL)#                      Change color on this device      PV01 105
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PV01 106
AREAOT=0#                                                               PV01 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PV01 108
#                                                                       PV01 109
ELSE plotp:(NP,IPST,PEN,COL)#          Plot np points in the buffer     PV01 110
#                                                                       PV01 111
IF(BFULL==yes:&PEN!=3)#                If buffer full & not move        PV01 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PV01 113
QX(MARK+1)     =QX(MARK+NBUF)#         Push down last x                 PV01 114
QX(MARK+1+NBUF)=QX(MARK+NBUF+NBUF)#    Push down last y                 PV01 115
IP=MARK+2#                             Incr buffer pointer              PV01 116
BFULL=no:#                             Reset buffer full flag           PV01 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PV01 118
NPT=NPT+NP;     NP=0#                  Reset and count moves            PV01 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PV01 120
#                                                                       PV01 121
#   STORE THE NEXT BUFFERED PRINT                                       PV01 122
#   -----------------------------                                       PV01 123
#                                                                       PV01 124
IF(NBUF>1)#                            Store the current value          PV01 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PV01 126
QX(IP)=X1;    QX(IP+NBUF)=Y1#          Store the current position       PV01 127
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PV01 128
XLST=X1;           YLST=Y1#            Remember last point plotted      PV01 129
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PV01 130
#                                                                       PV01 131
RETURN#                                                                 PV01 132
END#                                                                    PV01 133
systemheader:(PV02)#                   Put text line to message panel   PV02   1
####################################################################### PV02   2
#                                                                     # PV02   3
#                          PV02                                       # PV02   4
#                                                                     # PV02   5
####################################################################### PV02   6
SUBROUTINE PV02(MESS1,MESS2)#                                           PV02   7
include:(PVCOMN)#                                                       PV02   8
#                                                                       PV02   9
string:(MESS1,*);string:(MESS2,*)#                                      PV02  10
realdata:(PANX,[.360,.360,.790,.790,.360])# Message panel x             PV02  11
realdata:(PANY,[.935,.998,.998,.935,.935])# Message panel y             PV02  12
datastuff:#                                                             PV02  13
#                                                                       PV02  14
fillcolr:(0)#                          Set colour to black              PV02  15
fillarea:(5,PANX,PANY)#                Blank out message area           PV02  16
IF(MESS>0) segdelet:(MESS)#            Delete old message segment       PV02  17
segcreat:(MESS)#                       Create new message segment       PV02  18
CALL PV05(0.380,0.975,MESS1,5)#        Insert message 1 into panel      PV02  19
CALL PV05(0.380,0.945,MESS2,5)#        Insert message 2 into panel      PV02  20
segclose:#                             Close message segment            PV02  21
swapbuff:#                                                              PV02  22
#                                                                       PV02  23
RETURN#                                                                 PV02  24
END#                                                                    PV02  25
systemheader:(PV05)#                   Count and print characters       PV05   1
####################################################################### PV05   2
#                                                                     # PV05   3
#                          PV05                                       # PV05   4
#                                                                     # PV05   5
####################################################################### PV05   6
SUBROUTINE PV05(X,Y,TEXT,COL)#         Carolyn wasikowski               PV05   7
include:(PVCOMN)#                                                       PV05   8
string:(CBUF,80)#                                                       PV05   9
INTEGER J,COL#                                                          PV05  10
REAL X,Y#                                                               PV05  11
INTEGER KFILL#                                                          PV05  12
CHARACTER*(*) TEXT#                                                     PV05  13
#                                                                       PV05  14
KFILL=FILL;FILL=no:#                   Save state                       PV05  15
CBUF=' '; CBUF=TEXT#                   Transfer the string              PV05  16
DO J=80,2,-1; IF(CBUF(J^J)!=' ')BREAK# Find last non-blank char         PV05  17
drawtext:(X,Y,0.0,COL,.0125,J,CBUF)#   Output text                      PV05  18
FILL=KFILL#                            Restore state                    PV05  19
RETURN#                                                                 PV05  20
END#                                                                    PV05  21
#                                                                       PV05  22
systemheader:(PV11)#                   Input control lines              PV11   1
####################################################################    PV11   2
#                                                                  #    PV11   3
#                                PV11                              #    PV11   4
#                                                                  #    PV11   5
####################################################################    PV11   6
SUBROUTINE PV11#                                                        PV11   7
include:(AACOMN)#                                                       PV11   8
include:(PVCOMN)#                                                       PV11   9
#                                                                       PV11  10
INTEGER ANSWER#                                                         PV11  11
INTEGER I,J,K,M,N#                     Local indices                    PV11  12
INTEGER KEY,COLO#                      Signal for character checkin     PV11  13
INTEGER CURLC#                                                          PV11  14
#                                                                       PV11  15
chardata:(PV110, PARAMS COLOR FRAMES END )#                             PV11  16
chardata:(PV112,FILL  NOFIL BOND  CHAR  NUMB  CONT  NOCOL $#            PV11  17
ATLIN SHADE )#                                                          PV11  18
chardata:(PV113,OLD )#                                                  PV11  19
datastuff:#                                                             PV11  20
#                                                                       PV11  21
FILEXT(IOUNIT(4))='pre'#               Output file extension            PV11  22
FILEXT(IOUNIT(5))='ort'#               Default ip file is ortep file    PV11  23
FILEXT(ioda1:)   ='xx8'#               Direct access binary file        PV11  24
FILEXT(ioda2:)   ='xxa'#               Direct access binary file        PV11  25
IOMARK(4)=QXSTR#                       Start of output buffer           PV11  26
IOMARK(5)=QXSTR+bdfbuf:#               Start of input  buffer           PV11  27
incrqx:(MARK,IOMARK(5)+bdfbuf:,PV1111)# Start of map                    PV11  28
#                                                                       PV11  29
#  SET DEFAULT PLOTTER CHARACTERISTICS                                  PV11  30
#  -----------------------------------                                  PV11  31
#                                                                       PV11  32
ISEG=0; TEXTSC=1.0#                    Set a segment number             PV11  33
IBAK=yes:#                             Background will be blanked       PV11  34
IPLOT=0;      NPLOT=-1#                Set ip & op plot count           PV11  35
NBUF=0;       IFRAM=0#                 Set bufsize & frame cnt          PV11  36
CONTUR=no:;   FILL=no:#                Indicate plot type               PV11  37
BCOL=7;       CCOL=5;        NCOL=6#   Set color bond/char/numb         PV11  38
COLO=color:#                           Set color switch                 PV11  39
DO I=1,10;    COLR(I)=MOD(I-1,7)+1#    Default colours                  PV11  40
DO I=1,10;    ALIN(I)=1#               Default line styles              PV11  41
AWIDE=0.;           AHIGH=0.#          Start plot dimensions            PV11  42
XCEN =99999.;       YCEN =99999.#      Start plot centre                PV11  43
OMAG =0.0000;       RESL =99999.#      Magnification is auto            PV11  44
ISCALE=no:;         ICENTR=no:#        No auto scale/centre             PV11  45
XOFF=0.00000;       YOFF=0.00000#      X,y plot offset                  PV11  46
XLST=-99999.;       YLST=-99999.#      X,y last pen position            PV11  47
PENCOL=-99999; FILLUP=no:#             Reset colour flags               PV11  48
PENSTY=-99999#                         Reset colour flags               PV11  49
ICOL=no:;          NEW=yes:#           New subject color flag           PV11  50
IBRDR=no:;          COLOR=-1#          Default border not drawn         PV11  51
NPT=0;      NP=0;       NCC=0#         Reset point & color counts       PV11  52
IP=MARK;   IF(NBUF==1) IP=IP+1#        Reset buffer pointer             PV11  53
AREAOT=0;  IPND=IP#                    Reset buffer pointers            PV11  54
DO I=1,20; FRAME(I)=0#                 Zero frames requested            PV11  55
DBUF=no:#                              No double buffering              PV11  56
MXCOL=7#                               Initialize for standard colmap   PV11  57
RETRACE=no:#                           No overlay of black boundary     PV11  58
OLDPLT=no:#                            Not an old plot                  PV11  59
#                                                                       PV11  60
#                                                                       PV11  61
#   PROCESS CONTROL LINES                                               PV11  62
#   ---------------------                                               PV11  63
#                                                                       PV11  64
#                                                                       PV11  65
ifch:(BUFIN(1))#                       Get plot input file              PV11  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV11  67
IF(BUFIN(1)>voidflg:) iquit:(PV1102)#  Numeric file ext illegal         PV11  68
stringlim:(1,M,N)#                     Get file extension limits        PV11  69
IF(CHRIN(M^M+2)=='PRE') iquit:(PV1104)# Cannot read output file!        PV11  70
FILEXT(IOUNIT(5))=CHRIN(M^M+2)#        Store file extension             PV11  71
IF(CHRIN(M^M+2)=='CON')RETRACE=yes:#                                    PV11  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV11  73
ELSE ifnm:(BUFIN(1)) iquit:(PV1102)#   Numeric file ext illegal         PV11  74
#                                                                       PV11  75
FOR(I=2;BUFIN(I)!=voidflg:;I=I+1)#     Loop over input options          PV11  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV11  77
stringlim:(I,J,K)#                     Get string limits                PV11  78
compchar:(CHRIN,J,PV113,1,3,4,NPV113,K)# Search for match               PV11  79
IF(K==0) iquit:(PV1103)#               Unknown option                   PV11  80
IF(K==1) OLDPLT=yes:#                  Use original centre definition   PV11  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV11  82
copyfile:(5,4,1,22)#                   Copy plot file to .pre           PV11  83
#                                                                       PV11  84
#      PROCESS CONTROL LINES                                            PV11  85
#      ---------------------                                            PV11  86
#                                                                       PV11  87
REPEAT#                                Loop over input lines            PV11  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PV11  89
readline:(PV110,NPV110)#               Read next input line             PV11  90
#                                                                       PV11  91
IF(LINID==1)#                          *********** params line          PV11  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PV11  93
IF(BUFIN(1)>0.0) AWIDE=BUFIN(1)#       Plot width                       PV11  94
IF(BUFIN(2)>0.0) AHIGH=BUFIN(2)#       Plot height                      PV11  95
IF(BUFIN(3)>0.0) OMAG= BUFIN(3)#       Magnification                    PV11  96
ifnv:(BUFIN(4))  XCEN= BUFIN(4)#       Plot center                      PV11  97
ifnv:(BUFIN(5))  YCEN= BUFIN(5)#       Plot center                      PV11  98
ifnv:(BUFIN(6))  IBRDR=yes:#           Plot the border                  PV11  99
IF(BUFIN(7)>0.0) RESL= BUFIN(7)#       Resolution in units              PV11 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PV11 101
#                                                                       PV11 102
ELSE IF(LINID==2)#                     *********** color line           PV11 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PV11 104
COLOR=1#                               Color and new subject flag       PV11 105
FOR(J=1;J>0;J=J+1)#                    Loop over input fields           PV11 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PV11 107
ifvo:(BUFIN(J)) BREAK#                 Exit on first void               PV11 108
ifnm:(BUFIN(J)) iquit:(PV1103)#        Illegal input number             PV11 109
stringlim:(J,M,N)#                     Extract char string              PV11 110
compchar:(CHRIN,M,PV112,1,3,6,NPV112,KEY)# Identify string              PV11 111
IF(KEY<=0) iquit:(PV1103)#             Not recognized                   PV11 112
#  FILL   NOFILL CONT   ATLIN  SHADE                                    PV11 113
IF(KEY==1\KEY==2\KEY==6\KEY==8\KEY==9)#                                 PV11 114
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PV11 115
IF(KEY==1) FILL=yes:#                  Fill atoms                       PV11 116
IF(KEY==2) FILL=no:#                   No fill atoms                    PV11 117
IF(KEY==6) CONTUR=yes:#                If contour then flag as such     PV11 118
IF(KEY==6) FILL=no:#                   No fill conturs                  PV11 119
IF(KEY==9) COLOR=2#                    Black/white shading              PV11 120
IF(KEY==9) FILL=yes:#                  Fill atoms/bonds                 PV11 121
DO I=1,10#                             Loop over additional fields      PV11 122
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PV11 123
IF(BUFIN(J+1)<=voidflg:) BREAK#        Exit if alpha or void            PV11 124
J=J+1#                                 Incr field counter               PV11 125
IF (KEY==8) ALIN(I)=NINT(BUFIN(J))#    Dot-dash type                    PV11 126
ELSE COLR(I)=NINT(BUFIN(J))#           Get colour index                 PV11 127
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PV11 128
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PV11 129
ELSE IF(KEY<6)#                        Bond/char/numb                   PV11 130
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PV11 131
IF(BUFIN(J+1)<=voidflg:) NEXT#         No colour code given             PV11 132
J=J+1#                                 Incr field counter               PV11 133
IF(KEY==3) BCOL=NINT(BUFIN(J))#        Store bond colour                PV11 134
IF(KEY==4) CCOL=NINT(BUFIN(J))#        Store char colour                PV11 135
IF(KEY==4) NCOL=NINT(BUFIN(J))#        Store numb colour                PV11 136
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PV11 137
ELSE COLOR=0#                          No colour                        PV11 138
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PV11 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PV11 140
#                                                                       PV11 141
ELSE IF(LINID==3)#                     ************** frames line       PV11 142
DO I=1,20#                             Loop over possible frames        PV11 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PV11 144
ifvo:(BUFIN(I)) BREAK#                 Exit when void                   PV11 145
FRAME(I)=NINT(BUFIN(I))#               Store requested frame            PV11 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PV11 147
#                                                                       PV11 148
IF(LINID==4) BREAK#                    ***************** end line       PV11 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PV11 150
#                                                                       PV11 151
#    SET PLOT PARAMETERS                                                PV11 152
#    -------------------                                                PV11 153
#                                                                       PV11 154
ifeq:(AWIDE,0.)  AWIDE=xmaxw:#         Default plot width               PV11 155
ifeq:(AHIGH,0.)  AHIGH=ymaxh:#         Default plot height              PV11 156
IF(XCEN>99998.)  ICENTR=yes:#          Default auto center              PV11 157
IF(YCEN>99998.)  ICENTR=yes:#          Default auto center              PV11 158
IF(OMAG<.00001)  ISCALE=yes:#          Default no magnification         PV11 159
IF(RESL>99998.)#                       Default resolution               PV11 160
RESL=MIN(1./xpixl:,1./ypixl:)#         Default resolution               PV11 161
XPIX=xpixl:; YPIX=ypixl:#              Set pixels per unit              PV11 162
IF(COLOR<0) COLOR=color:#              Set color switch                 PV11 163
#                                                                       PV11 164
#   PLOT BUFFER INITIALIZATION                                          PV11 165
#   --------------------------                                          PV11 166
#                                                                       PV11 167
NBUF=buffr:#                           Set coord buffer size            PV11 168
incrqx:(FULL,MARK+NBUF,PV1105)#        Get x-coord memory               PV11 169
incrqx:(I,FULL+NBUF,PV1105)#           Get y-coord memory               PV11 170
#                                                                       PV11 171
start:#                                Request start up  for device     PV11 172
COLOR=ABS(COLOR)#                      Make sure color is 0 or +ve      PV11 173
linecolr:(0)#                          Initialize draw in black         PV11 174
#                                                                       PV11 175
RETURN#                                                                 PV11 176
END#                                                                    PV11 177
systemheader:(PV30)#                   Draw interactive buttons         PV30   1
####################################################################    PV30   2
#                                                                  #    PV30   3
#                               PV30                               #    PV30   4
#                                                                  #    PV30   5
####################################################################    PV30   6
SUBROUTINE PV30(INIFLG)#                                                PV30   7
include:(AACOMN)#                                                       PV30   8
include:(PVCOMN)#                                                       PV30   9
#                                                                       PV30  10
INTEGER INIFLG,I#                                                       PV30  11
REAL CIRCX(41),CIRCY(41)#                                               PV30  12
string:(BUTTON(6),9)#                                                   PV30  13
realdata:(LABX,[.290,.290,.340,.340,.290])# Label group button x        PV30  14
realdata:(BUTX,[.945,.945,.995,.995,.945])# Trash bin x                 PV30  15
realdata:(BUTY,[.995,.945,.945,.995,.995])# Trash bin y                 PV30  16
realdata:(BEXX,[.002,.055,.055,.002])# Exit button x                    PV30  17
realdata:(BEXY,[.970,.995,.945,.970])# Exit button y                    PV30  18
realdata:(INCX,[.065,.095,.125,.065])# Increase label x                 PV30  19
realdata:(INCY,[.945,.995,.945,.945])# Increase label y                 PV30  20
realdata:(DECX,[.135,.165,.195,.135])# Decrease label x                 PV30  21
realdata:(DECY,[.995,.945,.995,.995])# Decrease label y                 PV30  22
realdata:(CHAX,[.215,.215,.265,.215])# Character input x                PV30  23
realdata:(CHAY,[.945,.995,.970,.945])# Character input y                PV30  24
datastuff:#                                                             PV30  25
DATA BUTTON(1)/'Junk'/#                Seg 2                            PV30  26
DATA BUTTON(2)/'Inpt'/#                Seg 3                            PV30  27
DATA BUTTON(3)/'Incr'/#                Seg 4                            PV30  28
DATA BUTTON(4)/'Decr'/#                Seg 5                            PV30  29
DATA BUTTON(5)/'Exit'/#                Seg 6                            PV30  30
DATA BUTTON(6)/'Group'/#               Seg 7                            PV30  31
#                                                                       PV30  32
IF (INIFLG==no:)#                      Not the initial run              PV30  33
DO I=2,MESS;segdelet:(I)#              Destroy before recreating        PV30  34
#                                                                       PV30  35
#    DRAW BUTTONS                                                       PV30  36
#    ------------                                                       PV30  37
#                                                                       PV30  38
segcreat:(2)#                          Create junk bin segment          PV30  39
fillcolr:(1)#                          Set button colour                PV30  40
fillarea:(5,BUTX,BUTY)#                Draw button                      PV30  41
CALL PV05(0.950,0.965,BUTTON(1),7)#    Insert title 1 into panel        PV30  42
segclose:#                             Close segment                    PV30  43
#                                                                       PV30  44
segcreat:(3)#                          Create insert segment            PV30  45
fillcolr:(2)#                          Set button colour                PV30  46
fillarea:(4,CHAX,CHAY)#                Draw character input button      PV30  47
CALL PV05(0.215,0.965,BUTTON(2),1)#    Insert title 2 into panel        PV30  48
segclose:#                             Close segment                    PV30  49
#                                                                       PV30  50
segcreat:(4)#                          Create incr segment              PV30  51
fillcolr:(2)#                          Set button colour                PV30  52
fillarea:(4,INCX,INCY)#                Draw incr button                 PV30  53
CALL PV05(0.075,0.950,BUTTON(3),1)#    Insert title 3 into panel        PV30  54
segclose:#                             Close segment                    PV30  55
#                                                                       PV30  56
segcreat:(5)#                          Create decr segment              PV30  57
fillcolr:(2)#                          Set button colour                PV30  58
fillarea:(4,DECX,DECY)#                Draw decr button                 PV30  59
CALL PV05(0.145,0.980,BUTTON(4),1)#    Insert title 4 into panel        PV30  60
segclose:#                             Close segment                    PV30  61
#                                                                       PV30  62
segcreat:(6)#                          Create exit segment              PV30  63
fillcolr:(1)#                          Set button colour                PV30  64
fillarea:(4,BEXX,BEXY)#                Draw exit button                 PV30  65
CALL PV05(0.015,0.965,BUTTON(5),7)#    Insert title 5 into panel        PV30  66
segclose:#                             Close segment                    PV30  67
#                                                                       PV30  68
segcreat:(7)#                          Create label group button        PV30  69
fillcolr:(2)#                          Set button colour                PV30  70
fillarea:(5,LABX,BUTY)#                Draw button                      PV30  71
CALL PV05(0.29,0.965,BUTTON(6),1)#     Insert title 5 into panel        PV30  72
segclose:#                             Close segment                    PV30  73
#                                                                       PV30  74
segcreat:(8)#                          Create shrink button             PV30  75
DO I=1,41#                             Cycle over the points            PV30  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV30  77
CIRCX(I)=COS(FLOAT(I-1)/40.*6.283185)*.017+.83# Circle xcoords          PV30  78
CIRCY(I)=SIN(FLOAT(I-1)/40.*6.283185)*.017+.97# Circle ycoords          PV30  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV30  80
fillcolr:(2)#                          Set button colour                PV30  81
fillarea:(41,CIRCX,CIRCY)#             Draw exit button                 PV30  82
segclose:#                             Close segment                    PV30  83
#                                                                       PV30  84
segcreat:(9)#                          Create magnify button            PV30  85
DO I=1,41#                             Cycle over the points            PV30  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV30  87
CIRCX(I)=COS(FLOAT(I-1)/40.*6.283185)*.026+.90# Circle xcoords          PV30  88
CIRCY(I)=SIN(FLOAT(I-1)/40.*6.283185)*.026+.97# Circle ycoords          PV30  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV30  90
fillcolr:(2)#                          Set button colour                PV30  91
fillarea:(41,CIRCX,CIRCY)#             Draw button                      PV30  92
segclose:#                             Close segment                    PV30  93
#                                                                       PV30  94
segcreat:(MESS)#                       Create null message segment      PV30  95
segclose:#                             Close segment                    PV30  96
#                                                                       PV30  97
RETURN#                                                                 PV30  98
END#                                                                    PV30  99
systemheader:(PV31)#                   Advance plot frame               PV31   1
####################################################################    PV31   2
#                                                                  #    PV31   3
#                               PV31                               #    PV31   4
#                                                                  #    PV31   5
####################################################################    PV31   6
SUBROUTINE PV31#                                                        PV31   7
include:(AACOMN)#                                                       PV31   8
include:(PVCOMN)#                                                       PV31   9
#                                                                       PV31  10
EXTERNAL PV71,PV72,PV73,PV74,PV75,PV76#                                 PV31  11
INTEGER I,IJ,IS,J,KP,NC,NPEN,SINDX,NFF,GROUP#                           PV31  12
REAL TEM1,TEM2,TEM3,TEM4#              X,y corners of border            PV31  13
REAL QQ(28),X,Y,PCOM(7)#                                                PV31  14
string:(NCAR,72)#                      Character string to be input     PV31  15
realdata:(DISPX,[0.0,1.0,1.0,0.0,0.0])# Display window x                PV31  16
realdata:(DISPY,[0.0,0.0,1.0,1.0,0.0])# Display window x                PV31  17
chardata:(PV1,'Click LEFT mouse to select a control')#                  PV31  18
chardata:(PV2,'Or a label to move or delete')#                          PV31  19
chardata:(PV3,'Click LEFT mouse on new position')#                      PV31  20
chardata:(PV4,'Type label then ENTER')#                                 PV31  21
chardata:(PV5,'GROUP mode. Select labels to group.')#                   PV31  22
chardata:(PV6,'Select Incr or Decr or Group to cancel.')#               PV31  23
datastuff:#                                                             PV31  24
#                                                                       PV31  25
#   DRAW BORDER IF REQUESTED                                            PV31  26
#   ------------------------                                            PV31  27
#                                                                       PV31  28
IF(IBRDR==yes:&NF>1)#                  Check for border request         PV31  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV31  30
TEM1=+XOFF+2.*XCEN#                    Right boundary                   PV31  31
TEM2=+YOFF+2.*YCEN#                    Upper boundary                   PV31  32
TEM3=-XOFF#                            Left boundary                    PV31  33
TEM4=-YOFF#                            Lower boundary                   PV31  34
CALL PV01(TEM3,TEM4,3,0)#              Start border                     PV31  35
CALL PV01(TEM3,TEM2,2,-6000)#          Draw border with color           PV31  36
CALL PV01(TEM1,TEM2,2,-6000)#          Draw border with color           PV31  37
CALL PV01(TEM1,TEM4,2,-6000)#          Draw border with color           PV31  38
CALL PV01(TEM3,TEM4,2,-6000)#          Complete the loop                PV31  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV31  40
#                                                                       PV31  41
MESS=10#                               Message segment number           PV31  42
IF(ISEG>0)#                            Start interactive commands       PV31  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV31  44
CALL PV01(0.,0.,3,0)#                  Flush the buffer                 PV31  45
segclose:#                             Close first segment              PV31  46
ifeq:(OMAG,0.0)OMAG=0.1#               Default if no observed instrun   PV31  47
CALL PV30(yes:)#                       Draw buttons                     PV31  48
swapbuff:#                             Copy back buffer to front        PV31  49
#                                                                       PV31  50
#    DRAW LABELS                                                        PV31  51
#    -----------                                                        PV31  52
#                                                                       PV31  53
DO I=MESS+1,ISEG#                      Loop over stored labels          PV31  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PV31  55
readdac:(ioda1:,,I,QQ)#                Read label from temp file        PV31  56
segcreat:(I)#                          Creat new segment                PV31  57
CALL PV32(QQ,1)#                       Draw labels first time           PV31  58
segclose:#                             Close segment                    PV31  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PV31  60
#                                                                       PV31  61
#    ADJUST LABELS                                                      PV31  62
#    -------------                                                      PV31  63
#                                                                       PV31  64
REPEAT#                                Loop label movements             PV31  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PV31  66
DO I=3,ISEG; segdetec:(I)#             Open detectability of segments   PV31  67
mess:(PV1,PV2)#                        Select a control message         PV31  68
REPEAT#                                Request to pick a segment        PV31  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PV31  70
requpick:(IS)#                         Request pick selection           PV31  71
IF(IS>0)BREAK#                         Segment found                    PV31  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PV31  73
DO I=3,ISEG; segundet:(I)#             Close detectability of button    PV31  74
IF(IS==6) BREAK#                       Pick up exit button              PV31  75
#                                                                       PV31  76
IF(IS==4\IS==5)#                       Pick up label size request       PV31  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PV31  78
DO I=MESS+1,ISEG#                      Loop over all labels             PV31  79
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PV31  80
readdac:(ioda1:,,I,QQ)#                Read label from temp file        PV31  81
IF (QQ(7)<0.) NEXT#                    Label is flagged as trashed      PV31  82
segdelet:(I)#                          Delete segment                   PV31  83
CALL PV32(QQ,8)#                       Blackout the characters          PV31  84
IF(IS==4) QQ(3)=QQ(3)*1.1#             Increase label size by 10%       PV31  85
ELSE      QQ(3)=QQ(3)/1.1#             Decrease label size by 10%       PV31  86
segcreat:(I)#                          Creat new segment                PV31  87
CALL PV32(QQ,1)#                       Draw resized labels              PV31  88
segclose:#                             Close segment                    PV31  89
writedac:(ioda1:,,I,QQ)#               Write new label sizes            PV31  90
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PV31  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PV31  92
#                                                                       PV31  93
ELSE IF(IS==3)#                        Pick up input label request      PV31  94
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PV31  95
readdac:(ioda1:,,ISEG,QQ)#             Read last label from temp        PV31  96
mess:(PV3,' ')#                        Select new position message      PV31  97
IF (QQ(3)<=0.0) QQ(3)=0.05#            Default as no previous labels    PV31  98
requlocr:(X,Y)#                        New location                     PV31  99
QQ(1)=X/OMAG-XOFF#                     Transformation of new x          PV31 100
QQ(2)=Y/OMAG-YOFF#                     Transformation of new y          PV31 101
NCAR=' '#                              Reset character string           PV31 102
mess:(PV4,' ')#                        Type in chars message            PV31 103
requstrg:(NC,NCAR)#                    Request string from keyboard     PV31 104
QQ(5)=FLOAT(NC)#                       Store the number of characters   PV31 105
QQ(7)=5.#                              It is a character string         PV31 106
movector:(NCAR,1,QQ(8),1,NC,0)#        Store character string           PV31 107
ISEG=ISEG+1#                           Create a new segment             PV31 108
writedac:(ioda1:,,ISEG,QQ)#            Write new coordinaters           PV31 109
segcreat:(ISEG)#                       Creat new segment                PV31 110
CALL PV32(QQ,1)#                       Put characters at the new posi   PV31 111
segclose:#                             Close segment                    PV31 112
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PV31 113
#                                                                       PV31 114
ELSE IF(IS==7)#                        **********complex labelling      PV31 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PV31 116
DO I=MESS+1,ISEG; segdetec:(I)#        Open detectability of segments   PV31 117
segdetec:(4);segdetec:(5);segdetec:(7)# Make buttons detectable         PV31 118
registercbs1:#                         Register click drag call backs   PV31 119
mess:(PV5,PV6)#                        Group control message            PV31 120
REPEAT#                                Group labels                     PV31 121
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PV31 122
swapbuff:#                             Copy back buffer to front        PV31 123
requpick:(IS)#                         Request pick selection           PV31 124
#                                                                       PV31 125
IF(IS==4\IS==5)#                       Pick up label size request       PV31 126
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PV31 127
DO I=MESS+1,ISEG#                      Loop over all labels             PV31 128
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PV31 129
readdac:(ioda1:,,I,QQ)#                Read label from temp file        PV31 130
IF (QQ(7)<10.) NEXT#                   Label is ungrouped or  trashed   PV31 131
QQ(7)=QQ(7)-10.#                       Reset for printing               PV31 132
segdelet:(I)#                          Delete segment                   PV31 133
CALL PV32(QQ,8)#                       Blackout the old characters      PV31 134
IF(IS==4) QQ(3)=QQ(3)*1.1#             Increase label size by 10%       PV31 135
ELSE      QQ(3)=QQ(3)/1.1#             Decrease label size by 10%       PV31 136
segcreat:(I)#                          Creat new segment                PV31 137
CALL PV32(QQ,-2)#                      Draw resized labels              PV31 138
segclose:#                             Close segment                    PV31 139
segdetec:(I)#                          Reset new seg as detectable      PV31 140
QQ(7)=QQ(7)+10.#                       Reset for further adjustment     PV31 141
writedac:(ioda1:,,I,QQ)#               Write new label sizes            PV31 142
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PV31 143
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PV31 144
#                                                                       PV31 145
ELSEIF(IS==7)#                         Ungroup all labels               PV31 146
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PV31 147
DO I=MESS+1,ISEG#                      Loop over all labels             PV31 148
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PV31 149
readdac:(ioda1:,,I,QQ)#                Read label from temp file        PV31 150
IF  (QQ(7)<10.) NEXT#                  Label is ungrouped or  trashed   PV31 151
QQ(7)=QQ(7)-10.#                       Ungroup labels                   PV31 152
segdelet:(I)#                          Delete segment                   PV31 153
CALL PV32(QQ,8)#                       Blackout the characters          PV31 154
segcreat:(I)#                          Creat new segment                PV31 155
CALL PV32(QQ,1)#                       Redraw  in correct color         PV31 156
segclose:#                             Close segment                    PV31 157
segdetec:(I)#                          Reset new seg as detectable      PV31 158
writedac:(ioda1:,,I,QQ)#               Write new label sizes            PV31 159
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PV31 160
BREAK#                                 Break from group control         PV31 161
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PV31 162
#                                                                       PV31 163
ELSE#                                  Add or delete label from group   PV31 164
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PV31 165
GROUP=no:#                             Label is not in group            PV31 166
readdac:(ioda1:,,IS,QQ)#               Read label from temp             PV31 167
IF  (QQ(7)<0.) NEXT#                   Skip trashed labels              PV31 168
IF  (QQ(7)<10.) GROUP=yes:#            Was ungrouped, now grouped       PV31 169
ELSE QQ(7)=QQ(7)-10.#                  Was grouped, now ungrouped       PV31 170
CALL PV32(QQ,8)#                       Blackout the characters          PV31 171
segdelet:(IS)#                         Delete segment                   PV31 172
segcreat:(IS)#                         Creat new segment                PV31 173
IF (GROUP==yes:)CALL PV32(QQ,-2)#      Put characters in new color      PV31 174
ELSE            CALL PV32(QQ, 1)#      Put characters in normal color   PV31 175
segclose:#                             Close segment                    PV31 176
segdetec:(IS)#                         Reset new seg as detectable      PV31 177
IF (GROUP==yes:) QQ(7)=QQ(7)+10.#      Flag as in group                 PV31 178
writedac:(ioda1:,,IS,QQ)#              Save new settings                PV31 179
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PV31 180
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PV31 181
DO I=MESS+1,ISEG; segundet:(I)#        Close detectability of segment   PV31 182
segundet:(4);segundet:(5);segundet:(7)# Make buttons detectable         PV31 183
deregistercbs:#                        Deregister click drag call bac   PV31 184
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PV31 185
#                                                                       PV31 186
ELSE IF(IS==8\IS==9)#                  *********** magnify command      PV31 187
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PV31 188
IF (IS==8) OMAG=OMAG/1.1#              Shrink the plot                  PV31 189
ELSE       OMAG=OMAG*1.1#              Magnify the plot                 PV31 190
XOFF=0.5*AWIDE/OMAG-XCEN#              Recalc x offset                  PV31 191
YOFF=0.5*AHIGH/OMAG-YCEN#              Recalc y offset                  PV31 192
XLST=-99999.;       YLST=-99999.#      X,y last pen position            PV31 193
NPT=0;      NP=0#                      Reset point & color counts       PV31 194
IP=MARK;   IF(NBUF==1) IP=IP+1#        Reset buffer pointer             PV31 195
I=1#                                                                    PV31 196
segdelet:(I)#                          Delete the plot                  PV31 197
fillcolr:(0)#                          Set button colour                PV31 198
fillarea:(5,DISPX,DISPY)#              Blank display area               PV31 199
CALL PV30(no:)#                        Redraw buttons                   PV31 200
#                                                                       PV31 201
segcreat:(I)#                          Make frame a segment             PV31 202
DO I=1,PLTINS#                         Loop over plot commands          PV31 203
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PV31 204
readdac:(ioda2:,,I,PCOM)#              Read plot command from temp fi   PV31 205
NFF=NINT(PCOM(7))#                     Extract plot command id          PV31 206
IF (NFF==3)#                           Got the right plot and instruc   PV31 207
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PV31 208
X=PCOM(1)+PCOM(3)#                     X coordinate                     PV31 209
Y=PCOM(2)+PCOM(4)#                     Y coordinate                     PV31 210
SINDX=NINT(PCOM(5))#                   Subject index                    PV31 211
NPEN= NINT(PCOM(6))#                   Pen up=3 /pen down=2             PV31 212
CALL PV01(X,Y,NPEN,SINDX)#             Execute plot command             PV31 213
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PV31 214
ELSE IF(NFF==11)#                      Draw designated markers          PV31 215
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PV31 216
markcolr:(NINT(PCOM(5)))#                                               PV31 217
marksize:(PCOM(3))#                                                     PV31 218
marktype:(NINT(PCOM(6)))#                                               PV31 219
markdraw:(1,PCOM(1),PCOM(2))#          Polymarker                       PV31 220
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PV31 221
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PV31 222
CALL PV01(0.,0.,3,0)#                  Flush the buffer                 PV31 223
segclose:#                             Finish off the plot segment      PV31 224
DO I=MESS+1,ISEG#                      Add all of the text strings      PV31 225
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PV31 226
readdac:(ioda1:,,I,QQ)#                Read label from temp             PV31 227
segdelet:(I)#                          Delete segment                   PV31 228
segcreat:(I)#                          Creat new segment                PV31 229
IF (QQ(7)>=0.0) CALL PV32(QQ,1)#       Redraw characters                PV31 230
segclose:#                             Close segment                    PV31 231
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PV31 232
#######CALL XSETFS(2)#                        ensure solid fill         PV31 233
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PV31 234
#                                                                       PV31 235
ELSE#                                  Pick up label shift request      PV31 236
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PV31 237
readdac:(ioda1:,,IS,QQ)#               Read label from temp             PV31 238
CALL PV32(QQ,8)#                       Blackout the characters          PV31 239
requlocr:(X,Y)#                        New location                     PV31 240
QQ(1)=X/OMAG-XOFF#                     Transformation of new x          PV31 241
QQ(2)=Y/OMAG-YOFF#                     Transformation of new y          PV31 242
X=.94/OMAG-XOFF; Y=.94/OMAG-YOFF#      Get trash limits                 PV31 243
IF(QQ(1)>X&QQ(2)>Y) QQ(7)=-QQ(7)#      Flag as trashed labels           PV31 244
segdelet:(IS)#                         Delete segment                   PV31 245
segcreat:(IS)#                         Creat new segment                PV31 246
IF(QQ(7)>0.)CALL PV32(QQ,1)#           Put characters at the new posi   PV31 247
ELSE CALL PV01(0.,0.,3,0)#             Flush the buffer                 PV31 248
segclose:#                             Close segment                    PV31 249
writedac:(ioda1:,,IS,QQ)#              Write new coordinaters           PV31 250
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PV31 251
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PV31 252
#                                                                       PV31 253
#   OUTPUT NEW COORDINATE DATA TO .PRE                                  PV31 254
#   ---------------------------------                                   PV31 255
#                                                                       PV31 256
DO I=MESS+1,ISEG#                      Loop over plot labels            PV31 257
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PV31 258
readdac:(ioda1:,,I,QQ)#                Read label from temp file        PV31 259
IF(QQ(7)<0.)NEXT#                      Skip a trashed label             PV31 260
IF(NINT(QQ(7))==4) IJ=0#               For numbers                      PV31 261
ELSE IJ=NINT(QQ(5)-1.)/arith:(7,*,mxchwd:)+1# Count number of packets   PV31 262
DO J=0,IJ#                             Loop over packets                PV31 263
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 PV31 264
writepkt:(4,23,7,KP)#                  Write the packet                 PV31 265
movereal:(QQ,J*7+1,QX,KP+1,7,0)#       Transfer data ip to op           PV31 266
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 PV31 267
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PV31 268
closedac:(ioda1:)#                     Close down the temp file         PV31 269
closedac:(ioda2:)#                     Close down the temp file         PV31 270
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV31 271
#                                                                       PV31 272
DO I=1,ISEG; segdelet:(I)#             Clear segment table              PV31 273
IF(NPLOT==IPLOT) frame:#               This frame is requested          PV31 274
segcreat:(1)#                          Make next frame a segment        PV31 275
ISEG=MESS ; PLTINS=0#                  Initialise plot and segments     PV31 276
opendac:(ioda1:,3,120,' ')#            Open direct access file          PV31 277
opendac:(ioda2:,3,arith:(7,*,mxchwd:),' ')# Open temp plot file         PV31 278
DO I=1,MESS;writedac:(ioda1:,,I,)#     Write initial null labels        PV31 279
#                                                                       PV31 280
IPLOT=IPLOT+1#                         Count the next plot frame        PV31 281
IF(FRAME(1)==0) NPLOT=IPLOT#           All plot frames requested        PV31 282
ELSE IF(NPLOT<IPLOT)#                  Is request passed                PV31 283
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 PV31 284
IFRAM=IFRAM+1#                         Count the next request           PV31 285
NPLOT=FRAME(IFRAM)#                    Set next requested plot          PV31 286
IF(NPLOT==0) NF=10#                    Cause plot to end                PV31 287
ELSE IF(NPLOT<IPLOT) iquit:(PV3101)#   Plots out of order               PV31 288
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 PV31 289
#                                                                       PV31 290
RETURN#                                                                 PV31 291
END#                                                                    PV31 292
#                                                                       PV31 293
systemheader:(PV32)#                   Process interactive commands     PV32   1
####################################################################    PV32   2
#                                                                  #    PV32   3
#                               PV32                               #    PV32   4
#                                                                  #    PV32   5
####################################################################    PV32   6
SUBROUTINE PV32(QQ,ISNDX)#                                              PV32   7
include:(PVCOMN)#                                                       PV32   8
# -----------------------------------------------------------------     PV32   9
# INPUT PACKET CONTENTS                                                 PV32  10
#                                                                       PV32  11
# DRAW NUMBER  (4)                                                      PV32  12
#     WORD 1       X START OF NUMBER STRING                             PV32  13
#     WORD 2       Y START OF NUMBER STRING                             PV32  14
#     WORD 3       HEIGHT OF SYMBOLS IN INCHES                          PV32  15
#     WORD 4       NUMBER                                               PV32  16
#     WORD 5       ANGLE TO X-AXIS IN DEGREES                           PV32  17
#     WORD 6       NUMBER OF DIGITS AFTER DECIMAL AN.                   PV32  18
#                                                                       PV32  19
# DRAW CHARACTER (5)                                                    PV32  20
#     WORD 1       X START OF CHARACTER STRING                          PV32  21
#     WORD 2       Y START OF CHARACTER STRING                          PV32  22
#     WORD 3       HEIGHT OF SYMBOLS IN INCHES                          PV32  23
#     WORD 4       ANGLE TO X-AXIS IN DEGREES                           PV32  24
#     WORD 5       NUMBER OF CHARACTERS IN STRING (<73)                 PV32  25
#     WORD 6       DRAW OR SKIP BLANKS                                  PV32  26
#                                                                       PV32  27
# ---------------------------------------------------------------       PV32  28
#                                                                       PV32  29
REAL    FMT#                           Format                           PV32  30
REAL    HT#                            Char/numb heigth                 PV32  31
INTEGER ISNDX,MF#                                                       PV32  32
string:(NCAR,72)#                      Character string to be plotted   PV32  33
INTEGER NS#                            Number of char in string         PV32  34
INTEGER SINDX#                         Subject index                    PV32  35
REAL    TH#                            Angle to x-axis in degrees       PV32  36
REAL    X,Y#                                                            PV32  37
REAL    QQ(28)#                                                         PV32  38
#                                                                       PV32  39
#   PROCESS CHAR AND NUMB PACKETS                                       PV32  40
#   -----------------------------                                       PV32  41
#                                                                       PV32  42
MF=NINT(QQ(7))#                        Extract function code            PV32  43
#                                                                       PV32  44
NCAR=' '#                              Initialise character array       PV32  45
IF(MF==4)#                             ************* process number     PV32  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV32  47
IF    (ISNDX==8)SINDX=0#               Set colour as black              PV32  48
ELSEIF(ISNDX <0)SINDX=ABS(ISNDX)#      Group labl color change flag     PV32  49
ELSE            SINDX=NCOL#            Set colour index                 PV32  50
TH=QQ(5)#                              Extract angle to x-axis          PV32  51
ifne:(QQ(6),0.) FMT=QQ(6)#             Format the number                PV32  52
ELSE            FMT=101003.#           Format the number                PV32  53
ncodefld:(QQ,4,NCAR,FMT,1)#            Store number as chars            PV32  54
NS=MOD(NINT(FMT)/100,100)#             Number of chars                  PV32  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV32  56
#                                                                       PV32  57
ELSE IF(MF==5)#                        ************* process string     PV32  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV32  59
IF    (ISNDX==8)SINDX=0#               Set colour as black              PV32  60
ELSEIF(ISNDX <0)SINDX=ABS(ISNDX)#      Group labl color change flag     PV32  61
ELSE            SINDX=CCOL#            Set colour index                 PV32  62
TH=QQ(4)#                              Extract angle to x-axis          PV32  63
NS=MAX(NINT(QQ(5)),1)#                 Extract char string length       PV32  64
movertoc:(QQ(8),1,NCAR,1,NS,0)#        Extract char string              PV32  65
WHILE(NS>1&NCAR(NS^NS)==' ') NS=NS-1#  Loop over trailing blanks        PV32  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV32  67
X=OMAG*(QQ(1)+XOFF);Y=OMAG*(QQ(2)+YOFF)#                                PV32  68
HT=QQ(3)*OMAG#                         Extract char height              PV32  69
drawtext:(X,Y,TH,SINDX,HT,NS,NCAR)#                                     PV32  70
RETURN#                                                                 PV32  71
END#                                                                    PV32  72
#                                                                       PV32  73
systemheader:(PV41)#                   Draw characters                  PV41   1
####################################################################    PV41   2
#                                                                  #    PV41   3
#                               PV41                               #    PV41   4
#                                                                  #    PV41   5
####################################################################    PV41   6
SUBROUTINE PV41#                                                        PV41   7
#                                                                       PV41   8
include:(AACOMN)#                                                       PV41   9
include:(PVCOMN)#                                                       PV41  10
INTEGER I,IJ,NS#                                                        PV41  11
INTEGER PSIZE#                         Packet size                      PV41  12
REAL    QQ(28)#                                                         PV41  13
#                                                                       PV41  14
#   STORE CHAR AND NUMB PACKETS                                         PV41  15
#   ---------------------------                                         PV41  16
#                                                                       PV41  17
DO I=1,7; QQ(I)=QX(JP+I)#              Store initial packet             PV41  18
IF(NF==5)#                             ************* process string     PV41  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV41  20
NS=MAX(NINT(QX(JP+5)),1)#              Extract char string length       PV41  21
DO IJ=1,100#                           Loop over char packets           PV41  22
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV41  23
readwpkt:(5,23,PSIZE,JP,0)#            Read a packet of characters      PV41  24
movereal:(QX,JP+1,QQ,IJ*7+1,7,0)#      Transfer char data to buffer     PV41  25
IF(IJ*arith:(7,*,mxchwd:)>=NS) BREAK#  Loop over char string            PV41  26
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV41  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV41  28
ISEG=ISEG+1#                           Count segments                   PV41  29
writedac:(ioda1:,,ISEG,QQ)#            Save record in direct access     PV41  30
#                                                                       PV41  31
RETURN#                                                                 PV41  32
END#                                                                    PV41  33
systemheader:(PV51)#                   Auto center and scale            PV51   1
####################################################################    PV51   2
#                                                                  #    PV51   3
#                                PV51                              #    PV51   4
#                                                                  #    PV51   5
####################################################################    PV51   6
SUBROUTINE PV51#                                                        PV51   7
include:(AACOMN)#                                                       PV51   8
include:(PVCOMN)#                                                       PV51   9
# ------------------------------------------------------------------    PV51  10
# INPUT PACKET -- AUTO CENTER AND SCALE (6)                             PV51  11
#                                                                       PV51  12
#     WORD 1       FRAME WIDTH                                          PV51  13
#     WORD 2       FRAME HEIGHT                                         PV51  14
#     WORD 3       STEREO FLAG (2=YES 1=NO)                             PV51  15
#     WORD 4       INTERNAL SCALE                                       PV51  16
#     WORD 5       MAXIMUM X-SPAN OF SUBJECT                            PV51  17
#     WORD 6       MAXIMUM Y-SPAN OF SUBJECT                            PV51  18
#                                                                       PV51  19
# ------------------------------------------------------------------    PV51  20
#                                                                       PV51  21
INTEGER I#                                                              PV51  22
chardata:(PV510," PREVUE Control Parameters")#                          PV51  23
chardata:(PV513,[" Plot max dimn. in  x,y                     "])#      PV51  24
chardata:(PV514,[" Plot max dimn. out x,y                     "])#      PV51  25
chardata:(PV515,[" Plot pixels/unit   x,y                     "])#      PV51  26
chardata:(PV516,[" Plot center        x,y                     "])#      PV51  27
chardata:(PV517,[" Plot scale applied                         "])#      PV51  28
chardata:(PV518,-)#                                                     PV51  29
chardata:(PV51A,[" Color bond,char,numb                       "])#      PV51  30
chardata:(PV51B,[" Color atoms                                    "])#  PV51  31
chardata:(PV51C,[" Color contours                             "])#      PV51  32
realdata:(FMT,[300313.,330313.,360313.,390313.,#                        PV51  33
420313.,450313.,480313.,510313.,#                                       PV51  34
540313.,570313.,600313.,630313.,#                                       PV51  35
660313.,690313.,720313.,750313.])#                                      PV51  36
datastuff:#                                                             PV51  37
#                                                                       PV51  38
#   APPLY CENTRE VALUES                                                 PV51  39
#   -------------------                                                 PV51  40
#                                                                       PV51  41
IF(ICENTR==yes:)#                      Auto centering necessary         PV51  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV51  43
ifeq:(QX(JP+1),QX(JP+5),0.1)OLDPLT=yes:# Flag as an old style plot      PV51  44
ifeq:(QX(JP+2),QX(JP+6),0.1)OLDPLT=yes:# Flag as an old style plot      PV51  45
IF(OLDPLT==yes:)#                      Use the old scale mechanism      PV51  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV51  47
XCEN=QX(JP+1)*0.5#                     Get x-coord of center            PV51  48
YCEN=QX(JP+2)*0.5#                     Get y-coord of center            PV51  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV51  50
ELSE#                                  Use the new scale mechanism      PV51  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PV51  52
XCEN=QX(JP+5)+QX(JP+1)*0.5#            Get x-coord of center            PV51  53
YCEN=QX(JP+6)+QX(JP+2)*0.5#            Get y-coord of center            PV51  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PV51  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV51  56
#                                                                       PV51  57
#    SET SCALING TERMS                                                  PV51  58
#    -----------------                                                  PV51  59
#                                                                       PV51  60
IF(ISCALE==yes:)#                      Auto scaling necessary           PV51  61
OMAG=AMIN1(AWIDE/QX(JP+1),AHIGH/QX(JP+2))# Scale op device         pv   PV51  62
XOFF=0.5*AWIDE/OMAG-XCEN#              Calc x offset                    PV51  63
YOFF=0.5*AHIGH/OMAG-YCEN#              Calc y offset                    PV51  64
#                                                                       PV51  65
#   PRINT PLOT PARAMETERS                                               PV51  66
#   ---------------------                                               PV51  67
#                                                                       PV51  68
movechar:(PV518,1,CHROT,2,NPV510-1,2)# Insert underline                 PV51  69
writeline:(1,PV510,NPV510,2,3)#        Print header                     PV51  70
ncodefld:(QX,JP+1,PV513,330512.,1)#    Format input max x               PV51  71
ncodefld:(QX,JP+2,PV513,430512.,1)#    Format input max y               PV51  72
writeline:(0,PV513,NPV513,3,3)#        Print x,y                        PV51  73
ncodefld:(XCEN,1,PV516,330522.,1)#     Format centre x                  PV51  74
ncodefld:(YCEN,1,PV516,430522.,1)#     Format centre y                  PV51  75
writeline:(0,PV516,NPV516,3,3)#        Print centre x,y                 PV51  76
ncodefld:(OMAG,1,PV517,330842.,1)#     Format scale                     PV51  77
writeline:(0,PV517,NPV517,3,3)#        Print scale                      PV51  78
ncodefld:(AWIDE,1,PV514,330512.,1)#    Format output max x              PV51  79
ncodefld:(AHIGH,1,PV514,430512.,1)#    Format output max y              PV51  80
writeline:(0,PV514,NPV514,3,3)#        Print x,y                        PV51  81
ncodefld:(XPIX,1,PV515,330612.,1)#     Format pix/in x                  PV51  82
ncodefld:(YPIX,1,PV515,430612.,1)#     Format pix/in y                  PV51  83
writeline:(0,PV515,NPV515,3,3)#        Print pixels x,y                 PV51  84
#                                                                       PV51  85
#   PRINT COLOR PARAMETERS                                              PV51  86
#   ----------------------                                              PV51  87
#                                                                       PV51  88
IF(COLOR!=0)#                          If color graphics                PV51  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PV51  90
DO I=1,6; BUFOT(I)=FLOAT(COLR(I))#     Float atom colour indices        PV51  91
IF(CONTUR==yes:)#                      Output for contour plot          PV51  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PV51  93
ncodefld:(BUFOT,1,PV51C,FMT,5)#        Format contour indices           PV51  94
ncodefld:(FLOAT(CCOL),1,PV51C,FMT(6),1)# Load char colour               PV51  95
writeline:(0,PV51C,NPV51C,3,3)#        Output char colour message       PV51  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PV51  97
ELSE#                                  This is an atom plot             PV51  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PV51  99
ncodefld:(FLOAT(BCOL),1,PV51A,300313.,1)# Load bond colour              PV51 100
ncodefld:(FLOAT(CCOL),1,PV51A,330313.,1)# Load char colour              PV51 101
ncodefld:(FLOAT(NCOL),1,PV51A,360313.,1)# Load numb colour              PV51 102
writeline:(0,PV51A,NPV51A,3,3)#        Output numb colour message       PV51 103
ncodefld:(BUFOT,1,PV51B,FMT,6)#        Load atom colours                PV51 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PV51 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PV51 106
#                                                                       PV51 107
RETURN#                                                                 PV51 108
END#                                                                    PV51 109
#                                                                       PV51 110
systemheader:(PV52)#                   Add colormap entry               PV52   1
####################################################################    PV52   2
#                                                                  #    PV52   3
#                               PV52                               #    PV52   4
#                                                                  #    PV52   5
####################################################################    PV52   6
SUBROUTINE PV52#                                                        PV52   7
#                                                                       PV52   8
include:(AACOMN)#                                                       PV52   9
include:(PVCOMN)#                                                       PV52  10
REAL RED,GREEN,BLUE#                                                    PV52  11
INTEGER IDX,C1,C2,C3,COL#                                               PV52  12
#                                                                       PV52  13
intunpak:(QX(JP+5),COL,0,24)#          Rescue rgb hex packed color      PV52  14
IDX = NINT(QX(JP+6))#                  Color index                      PV52  15
C1=MOD(COL,256)#                       Get last  8 bits                 PV52  16
C2=MOD(COL-C1,65536)#                  Get second 8 bits                PV52  17
C3=MOD(COL-C1-C2,16777216)#            Get third 8 bits                 PV52  18
RED=FLOAT(C3)/16777215.#               Convert to range 0.0-1.0         PV52  19
GREEN=FLOAT(C2)/65535.#                Convert to range 0.0-1.0         PV52  20
BLUE=FLOAT(C1)/255.#                   Convert to range 0.0-1.0         PV52  21
IF(IDX<MAXCOL) setcolor:(IDX,RED,GREEN,BLUE)#                           PV52  22
MXCOL=MAX(IDX,7)#                                                       PV52  23
#                                                                       PV52  24
RETURN#                                                                 PV52  25
END#                                                                    PV52  26
systemheader:(PV61)#                   Finish off the plot              PV61   1
####################################################################    PV61   2
#                                                                  #    PV61   3
#                               PV61                               #    PV61   4
#                                                                  #    PV61   5
####################################################################    PV61   6
SUBROUTINE PV61#                                                        PV61   7
#                                                                       PV61   8
include:(AACOMN)#                                                       PV61   9
include:(PVCOMN)#                                                       PV61  10
INTEGER KP#                                                             PV61  11
chardata:(PV611," Number of points plotted         ")#                  PV61  12
chardata:(PV612," Number of colors changed         ")#                  PV61  13
datastuff:#                                                             PV61  14
#                                                                       PV61  15
#   PRINT SUMMARY OF MOVES                                              PV61  16
#   ----------------------                                              PV61  17
#                                                                       PV61  18
ncodefld:(FLOAT(NPT),1,PV611,330613.,1)# Format points plotted          PV61  19
writeline:(0,PV611,NPV611,3,3)#        Print summary                    PV61  20
ncodefld:(FLOAT(NCC),1,PV612,330613.,1)# Format colours changed         PV61  21
IF(COLOR!=0) writeline:(0,PV612,NPV612,3,3)# Print summary              PV61  22
#                                                                       PV61  23
#  FINISH OFF THE PLOTS                                                 PV61  24
#  --------------------                                                 PV61  25
#                                                                       PV61  26
CALL PV01(0.,0.,3,0)#                  Flush buffer & return            PV61  27
segclose:#                             Close last segment               PV61  28
frame:#                                Another frame                    PV61  29
CALL PV62#                                                              PV61  30
finis:#                                Close down the device            PV61  31
writepkt:(4,23,7,KP)#                  Prepare out file for inst 10     PV61  32
movereal:(QX,JP+1,QX,KP+1,7,1)#        Transfer terminal plot inst      PV61  33
copyfile:(5,4,24,endrecord:)#          Close down the files             PV61  34
closedac:(ioda1:)#                     Close down the temp file         PV61  35
closedac:(ioda2:)#                     Close down the temp file         PV61  36
#                                                                       PV61  37
RETURN#                                                                 PV61  38
END#                                                                    PV61  39
systemheader:(PV62)#                   Draw a simple plotx menu         PV62   1
####################################################################    PV62   2
#                                                                       PV62   3
#                                                                       PV62   4
#                                                                       PV62   5
####################################################################    PV62   6
SUBROUTINE PV62#                                                        PV62   7
include:(AACOMN)#                                                       PV62   8
include:(PVCOMN)#                                                       PV62   9
#                                                                       PV62  10
CHARACTER*12 KEYB(13)#                                                  PV62  11
INTEGER LSEG,JSEG#                                                      PV62  12
INTEGER I,J,K#                                                          PV62  13
INTEGER CURLC#                                                          PV62  14
INTEGER LC#                                                             PV62  15
REAL U(5),V(5),AA,BB#                                                   PV62  16
string:(TEMP,80)#                                                       PV62  17
chardata:(PV620,"Print to plot file ?")#                                PV62  18
chardata:(PV621,"YESNO ")#                                              PV62  19
realdata:(ATMXB,[-.064,+.064,+.064,-.064,-.064])#                       PV62  20
realdata:(ATMYB,[-.017,-.017,+.017,+.017,-.017])#                       PV62  21
intdata:(NUM,[2,2,2,6,1])#                                              PV62  22
intdata:(DFLT,[1,3,5,7])#              Default buttons                  PV62  23
realdata:(XOSET,[0.25,0.4,0.55,0.70,0.5])#                              PV62  24
realdata:(YOSET,[0.95,0.95,0.95,0.95,0.6])#                             PV62  25
realdata:(AREA1X,[0.05,0.40,0.40,0.05,0.05])#                           PV62  26
realdata:(AREA1Y,[0.90,0.90,0.98,0.98,0.90])#                           PV62  27
realdata:(AREA2X,[0.175,0.325,0.325,0.175,0.175])#                      PV62  28
realdata:(AREA2Y,[0.825,0.825,0.925,0.925,0.825])#                      PV62  29
realdata:(AREA3X,[0.325,0.475,0.475,0.325,0.325])#                      PV62  30
realdata:(AREA3Y,[0.825,0.825,0.925,0.925,0.825])#                      PV62  31
realdata:(AREA4X,[0.475,0.625,0.625,0.475,0.475])#                      PV62  32
realdata:(AREA4Y,[0.825,0.825,0.925,0.925,0.825])#                      PV62  33
realdata:(AREA5X,[0.625,0.775,0.775,0.625,0.625])#                      PV62  34
realdata:(AREA5Y,[0.625,0.625,0.925,0.925,0.625])#                      PV62  35
realdata:(AREA6X,[0.15,0.80,0.80,0.15,0.15])#                           PV62  36
realdata:(AREA6Y,[0.5,0.5,0.95,0.95,0.5])#                              PV62  37
datastuff:#                                                             PV62  38
DATA KEYB/$#                                                            PV62  39
' postscript ','   hpgl     ',$#                                        PV62  40
' landscape  ','  portrait  ',$#                                        PV62  41
'   color    ','   B and W  ',$#                                        PV62  42
'     A4     ','     A3     ','     A5     ',$#                         PV62  43
'  US Letter ','  US Legal  ','US Executive',$#                         PV62  44
'   OK       '/#                                                        PV62  45
#                                                                       PV62  46
#                                                                       PV62  47
LSEG=0#                                                                 PV62  48
segcreat:(LSEG)#                                                        PV62  49
linecolr:(1)#                          Draw in red                      PV62  50
linedraw:(5,AREA1X,AREA1Y)#            Draw button                      PV62  51
linecolr:(7)#                          Draw in red                      PV62  52
CALL PV05(0.10,0.963,PV620,7)#         Do we want to plot ?             PV62  53
segclose:#                             Close segment                    PV62  54
AA=0.0#                                                                 PV62  55
BB=0.93#                                                                PV62  56
DO J=1,2#                                                               PV62  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV62  58
LSEG=LSEG+1#                                                            PV62  59
segcreat:(LSEG)#                                                        PV62  60
AA=AA+0.147#                           Incr to next box position        PV62  61
DO K=1,5; U(K)=ATMXB(K)+AA#            Position atom x                  PV62  62
DO K=1,5; V(K)=ATMYB(K)+BB#            Position atom y                  PV62  63
IF(LSEG==2) fillcolr:(1)#              Red - danger/danger              PV62  64
ELSE        fillcolr:(3)#              Normal is blue                   PV62  65
fillarea:(5,U,V)#                      Draw button                      PV62  66
linecolr:(7)#                          Set characters to white          PV62  67
CALL PV05(AA-.061,BB-.005,PV621(J*3-2^J*3),7)# Insert characters        PV62  68
segclose:#                             Close segment                    PV62  69
segdetec:(LSEG)#                                                        PV62  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV62  71
#                                                                       PV62  72
REPEAT#                                                                 PV62  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV62  74
swapbuff:#                                                              PV62  75
requpick:(JSEG)#                       Request pick selection           PV62  76
IF(JSEG==1\JSEG==2)BREAK#                                               PV62  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV62  78
segdelet:(0)#                                                           PV62  79
segdelet:(1)#                                                           PV62  80
segdelet:(2)#                                                           PV62  81
IF(JSEG==2)RETURN#                     No print so do nothing           PV62  82
frame:#                                Erase screen                     PV62  83
#                                                                       PV62  84
#  SETUP PRINT OPTIONS                                                  PV62  85
#  -------------------                                                  PV62  86
#                                                                       PV62  87
LSEG=0#                                                                 PV62  88
segcreat:(LSEG)#                       Create menu segment              PV62  89
linecolr:(1)#                          Draw in red                      PV62  90
linedraw:(5,AREA2X,AREA2Y)#            Draw button                      PV62  91
linedraw:(5,AREA3X,AREA3Y)#            Draw button                      PV62  92
linedraw:(5,AREA4X,AREA4Y)#            Draw button                      PV62  93
linedraw:(5,AREA5X,AREA5Y)#            Draw button                      PV62  94
linedraw:(5,AREA6X,AREA6Y)#            Draw button                      PV62  95
segclose:#                             Close segment                    PV62  96
#                                                                       PV62  97
REPEAT#                                Redraw button each time          PV62  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PV62  99
LSEG=1#                                                                 PV62 100
DO I=1,5#                                                               PV62 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PV62 102
AA=XOSET(I)#                                                            PV62 103
BB=YOSET(I)#                                                            PV62 104
DO J=1,NUM(I)#                                                          PV62 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PV62 106
segcreat:(LSEG)#                                                        PV62 107
BB=BB-0.05#                            Incr to next box position        PV62 108
DO K=1,5; U(K)=ATMXB(K)+AA#            Position atom x                  PV62 109
DO K=1,5; V(K)=ATMYB(K)+BB#            Position atom y                  PV62 110
IF(I>4)              fillcolr:(1)#     Red - danger/danger              PV62 111
ELSEIF(LSEG==DFLT(I))fillcolr:(3)#     Defaults are dark blue           PV62 112
ELSE                 fillcolr:(5)#     Options are cyan                 PV62 113
fillarea:(5,U,V)#                      Draw button                      PV62 114
IF(I>4)              LC=7#             White text                       PV62 115
ELSEIF(LSEG==DFLT(I))LC=7#             White text                       PV62 116
ELSE                 LC=3#             Dark blue  text                  PV62 117
CALL PV05(AA-.061,BB-.005,KEYB(LSEG),LC)# The 7 is ignored              PV62 118
segclose:#                             Close segment                    PV62 119
segdetec:(LSEG)#                                                        PV62 120
LSEG=LSEG+1#                                                            PV62 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PV62 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PV62 123
LSEG=LSEG-1#                                                            PV62 124
swapbuff:#                                                              PV62 125
requpick:(JSEG)#                       Request pick selection           PV62 126
IF(JSEG==13) BREAK#                                                     PV62 127
#                                                                       PV62 128
K=0#                                                                    PV62 129
DO I=1,4#                                                               PV62 130
DO J=1,NUM(I)#                                                          PV62 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PV62 132
K=K+1#                                                                  PV62 133
IF(K==JSEG) DFLT(I)=JSEG#                                               PV62 134
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PV62 135
DO I=1,LSEG;segdelet:(I)#              Erase all buttons                PV62 136
#                                                                       PV62 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PV62 138
DO I=0,LSEG;segdelet:(I)#              Erase all buttons                PV62 139
#                                                                       PV62 140
FILEXT(iofm1:)='PV0'#                  Re-entrant plotx fmt file        PV62 141
openfmt:(iofm1:,' ')#                  Open the file                    PV62 142
TEMP='PLOTX post   pre                  '#                              PV62 143
IF(DFLT(1)==1)#                        For postscript                   PV62 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PV62 145
IF(DFLT(2)==3)TEMP(11^11)='l'#         Landscape                        PV62 146
ELSE          TEMP(11^11)='p'#         Portrait                         PV62 147
IF(DFLT(3)==5)TEMP(12^12)='c'#         Color                            PV62 148
ELSE          TEMP(12^12)=' '#         Black and white                  PV62 149
IF    (DFLT(4)== 7)TEMP(18^21)='A4  '# A4 paper size                    PV62 150
ELSEIF(DFLT(4)== 8)TEMP(18^21)='A3  '# A3 paper size                    PV62 151
ELSEIF(DFLT(4)== 9)TEMP(18^21)='A5  '# A3 paper size                    PV62 152
ELSEIF(DFLT(4)==10)TEMP(18^21)='LET '# Us letter                        PV62 153
ELSEIF(DFLT(4)==11)TEMP(18^21)='LEG '# Us legal                         PV62 154
ELSEIF(DFLT(4)==12)TEMP(18^21)='EXE '# Us executive                     PV62 155
IF(RETRACE==yes:)  TEMP(22^25)='RET '# Retrace option for contours      PV62 156
IF(OLDPLT==yes:)IF(DFLT(4)==7)TEMP(26^29)=' old'#                       PV62 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PV62 158
ELSE#                                  For hpgl                         PV62 159
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PV62 160
TEMP(7^10)='hpgl'#                                                      PV62 161
IF(DFLT(4)==7)TEMP(11^12)='a4'#                                         PV62 162
IF(OLDPLT==yes:)TEMP(13^16)=' old'#                                     PV62 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PV62 164
writefmt:(iofm1:,'(A)',TEMP)#                                           PV62 165
IF(FILL==yes:) writefmt:(iofm1:,'(A)','color fill')# Propagate also     PV62 166
LINFLG=1#                              Ensure another line is read      PV62 167
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  Next inpt line isn't end or eo   PV62 168
writefmt:(iofm1:,'(A)',CHRIP(1^80))#   Write header to file             PV62 169
closefmt:(iofm1:)#                                                      PV62 170
linestream:('PV0')#                                                     PV62 171
#   IF THIS PROGRAM WAS INVOKED ON THE FLY FROM PIG, THEN AT THIS       PV62 172
#   POINT WE HAVE LOST ALL TRACE OF OUR ORIGINAL INPUT FILE!            PV62 173
#                                                                       PV62 174
#                                                                       PV62 175
RETURN#                                                                 PV62 176
END#                                                                    PV62 177
####################################################################    PV62 178
#                                                                       PV62 179
#      BEGINING  OF CALL BACK ROUTINES                                  PV62 180
#                                                                       PV62 181
####################################################################    PV62 182
systemheader:(PV71)## record Right click position######                 PV71   1
SUBROUTINE PV71(X,Y)#                                                   PV71   2
include:(AACOMN)#                                                       PV71   3
include:(PVCOMN)#                                                       PV71   4
REAL X,Y#                                                               PV71   5
XINIT=X;YINIT=Y#                       Record initial value             PV71   6
XOLD=XINIT;YOLD=YINIT#                 Record previous value            PV71   7
RETURN#                                                                 PV71   8
END#                                                                    PV71   9
systemheader:(PV72)## RIght drag -Draw enclosing rectangle#####         PV72   1
SUBROUTINE PV72(X,Y)#                                                   PV72   2
include:(AACOMN)#                                                       PV72   3
include:(PVCOMN)#                                                       PV72   4
REAL X,Y#                                                               PV72   5
REAL XX(5),YY(5)#                                                       PV72   6
REAL XOMIN,XOMAX,YOMIN,YOMAX#                                           PV72   7
REAL XNMIN,XNMAX,YNMIN,YNMAX#                                           PV72   8
INTEGER PTS,CURLC,I,GROUP#                                              PV72   9
REAL QQ(28)#                                                            PV72  10
#                                                                       PV72  11
setgcxor:#                             Set color context to xor         PV72  12
linecolr:(5)#                          Set color to white               PV72  13
PTS=5#                                 5 rectangle vertices             PV72  14
XX(1)=XINIT;XX(2)=XOLD ;XX(3)=XOLD;XX(4)=XINIT;XX(5)=XINIT#             PV72  15
YY(1)=YINIT;YY(2)=YINIT;YY(3)=YOLD;YY(4)=YOLD ;YY(5)=YINIT#             PV72  16
linedraw:(PTS,XX,YY)#                  Erase old rectangle              PV72  17
XX(1)=XINIT;XX(2)=X;    XX(3)=X;XX(4)=XINIT;XX(5)=XINIT#                PV72  18
YY(1)=YINIT;YY(2)=YINIT;YY(3)=Y;YY(4)=Y;    YY(5)=YINIT#                PV72  19
linedraw:(PTS,XX,YY)#                  Draw new rectangle               PV72  20
setgcxcopy:#                           Set color context to  xcopy (n   PV72  21
#                                                                       PV72  22
XOMIN=MIN(XINIT,XOLD)#                 Old region                       PV72  23
XOMAX=MAX(XINIT,XOLD)#                                                  PV72  24
YOMIN=MIN(YINIT,YOLD)#                                                  PV72  25
YOMAX=MAX(YINIT,YOLD)#                                                  PV72  26
#                                                                       PV72  27
XNMIN=MIN(XINIT,X)#                    New region                       PV72  28
XNMAX=MAX(XINIT,X)#                                                     PV72  29
YNMIN=MIN(YINIT,Y)#                                                     PV72  30
YNMAX=MAX(YINIT,Y)#                                                     PV72  31
XOLD=X ; YOLD=Y#                       Save coords to erase next time   PV72  32
#                                                                       PV72  33
#  CHECK ALL LABELS TO SEE -                                            PV72  34
DO I=MESS+1,ISEG#                      Loop over stored labels          PV72  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV72  36
readdac:(ioda1:,,I,QQ)#                Read label from temp file        PV72  37
IF (QQ(7)<0.) NEXT#                    Trashed label                    PV72  38
X=OMAG*(QQ(1)+XOFF)#                   Convert  x coords to screen      PV72  39
Y=OMAG*(QQ(2)+YOFF)#                   Convert y coords to screen       PV72  40
## if not in old but now in new   or  in old but not in new then toggle PV72  41
IF(( (XOMIN<X&XOMAX>X&YOMIN<Y&YOMAX>Y)&# Label coords in old rect       PV72  42
!(XNMIN<X&XNMAX>X&YNMIN<Y&YNMAX>Y) )\# Label coords not in new rect     PV72  43
( (XNMIN<X&XNMAX>X&YNMIN<Y&YNMAX>Y)&#  Label coords in new rect         PV72  44
!(XOMIN<X&XOMAX>X&YOMIN<Y&YOMAX>Y) ))# Label coords not in old rect     PV72  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV72  46
#                                      Toggle group settings            PV72  47
GROUP=no:#                                                              PV72  48
segdelet:(I)#                          Delete segment                   PV72  49
CALL PV32(QQ,8)#                       Blackout the characters          PV72  50
IF  (QQ(7)<10.) GROUP=yes:#            Was ungrouped, now grouped       PV72  51
ELSE QQ(7)=QQ(7)-10.#                  Was grouped, now ungrouped       PV72  52
segcreat:(I)#                          Creat new segment                PV72  53
IF (GROUP==yes:)CALL PV32(QQ,-2)#      Put characters in new color      PV72  54
ELSE            CALL PV32(QQ, 1)#      Put characters in normal color   PV72  55
segclose:#                             Close segment                    PV72  56
segdetec:(I)#                          Reset new seg as detectable      PV72  57
IF (GROUP==yes:) QQ(7)=QQ(7)+10.#      Flag as in group                 PV72  58
writedac:(ioda1:,,I,QQ)#               Save new settings                PV72  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV72  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV72  61
#SWAPBUFF:                                                              PV72  62
RETURN#                                                                 PV72  63
END#                                                                    PV72  64
#                                                                       PV72  65
systemheader:(PV73)## right release -erase rectangle #######            PV73   1
SUBROUTINE PV73(X,Y)#                                                   PV73   2
include:(PVCOMN)#                                                       PV73   3
REAL X,Y#                                                               PV73   4
INTEGER PTS,CURLC#                                                      PV73   5
REAL XX(5),YY(5)#                                                       PV73   6
#                                                                       PV73   7
setgcxor:#                             Set color context to xor         PV73   8
linecolr:(5)#                          Set color to white               PV73   9
PTS=5#                                 5 rectangle vertices             PV73  10
XX(1)=XINIT;XX(2)=XOLD ;XX(3)=XOLD;XX(4)=XINIT;XX(5)=XINIT#             PV73  11
YY(1)=YINIT;YY(2)=YINIT;YY(3)=YOLD;YY(4)=YOLD ;YY(5)=YINIT#             PV73  12
linedraw:(PTS,XX,YY)#                  Draw rectangle                   PV73  13
setgcxcopy:#                           Set color context to  xcopy (n   PV73  14
RETURN#                                                                 PV73  15
END#                                                                    PV73  16
systemheader:(PV74)## record Right click position######                 PV74   1
SUBROUTINE PV74(X,Y)#                                                   PV74   2
include:(AACOMN)#                                                       PV74   3
include:(PVCOMN)#                                                       PV74   4
REAL X,Y#                                                               PV74   5
REAL QQ(28)#                                                            PV74   6
INTEGER I#                                                              PV74   7
#                                                                       PV74   8
XINIT=X;YINIT=Y#                       Record initial value             PV74   9
XOLD=XINIT;YOLD=YINIT#                 Record previous value            PV74  10
#                                                                       PV74  11
# DELETE SEGMENT RECORDS                                                PV74  12
DO I=MESS+1,ISEG#                      Loop over stored labels          PV74  13
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV74  14
readdac:(ioda1:,,I,QQ)#                Read label from temp file        PV74  15
IF (QQ(7)<10.) NEXT#                   Not in group                     PV74  16
segdelet:(I)#                          Delete the old segment           PV74  17
#                                      Blackout original                PV74  18
QQ(7)=QQ(7)-10.#                       Toggle group settings            PV74  19
setgcxcopy:#                           Set color context to xcopy nor   PV74  20
CALL PV32(QQ,8)#                       Blackout the characters          PV74  21
setgcxor:#                             Set color context to xor         PV74  22
CALL PV32(QQ,-2)#                      Rewrite labels characters        PV74  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV74  24
#                                                                       PV74  25
RETURN#                                                                 PV74  26
END#                                                                    PV74  27
systemheader:(PV75)## left drag -move grouped labels#######             PV75   1
SUBROUTINE PV75(X,Y)#                                                   PV75   2
include:(AACOMN)#                                                       PV75   3
include:(PVCOMN)#                                                       PV75   4
REAL X,Y#                                                               PV75   5
REAL DX,DY#                                                             PV75   6
REAL QQ(28)#                                                            PV75   7
INTEGER I#                                                              PV75   8
#                                                                       PV75   9
DX=X-XOLD;#                                                             PV75  10
DY=Y-YOLD;#                                                             PV75  11
XOLD=X ;YOLD=Y#                                                         PV75  12
#     GRAPHICS CONTEXT SHOULD BE XOR                                    PV75  13
DO I=MESS+1,ISEG#                      Loop over stored labels          PV75  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV75  15
readdac:(ioda1:,,I,QQ)#                Read label from temp file        PV75  16
IF (QQ(7)<10.) NEXT#                   Not in group                     PV75  17
QQ(7)=QQ(7)-10.#                       Toggle group settings            PV75  18
CALL PV32(QQ,-2)#                      Overwrite (xor) old label char   PV75  19
QQ(1)=QQ(1)+DX/OMAG#                   Get new x coords                 PV75  20
QQ(2)=QQ(2)+DY/OMAG#                   Get new y coords                 PV75  21
CALL PV32(QQ,-2)#                      Write (xor) new pos label char   PV75  22
QQ(7)=QQ(7)+10.#                       Reset group flag                 PV75  23
writedac:(ioda1:,,I,QQ)#               Save new settings                PV75  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV75  25
xflush:#                                                                PV75  26
#                                                                       PV75  27
RETURN#                                                                 PV75  28
END#                                                                    PV75  29
systemheader:(PV76)## left release - check for bin #########            PV76   1
SUBROUTINE PV76(X,Y)#                                                   PV76   2
include:(AACOMN)#                                                       PV76   3
include:(PVCOMN)#                                                       PV76   4
INTEGER BIN#                                                            PV76   5
REAL X,Y#                                                               PV76   6
REAL QQ(28)#                                                            PV76   7
INTEGER I#                                                              PV76   8
BIN=no:#                                                                PV76   9
IF(X>0.94 &Y>0.94)BIN=yes:#            Grouped labels dropped in bin    PV76  10
IF(BIN==yes:) setgcxor:#               Set color context to xor         PV76  11
ELSE          setgcxcopy:#                                              PV76  12
DO I=MESS+1,ISEG#                      Loop over stored labels          PV76  13
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PV76  14
readdac:(ioda1:,,I,QQ)#                Read label from temp file        PV76  15
IF (QQ(7)<10.) NEXT#                   Not in group                     PV76  16
QQ(7)=QQ(7)-10.#                                                        PV76  17
segcreat:(I)#                          Creat new dummy segment          PV76  18
IF(BIN==yes:)#                         Grouped labels dropped in bin    PV76  19
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PV76  20
segclose:#                             Close dummy segment              PV76  21
CALL PV32(QQ,-2)#                      Write new pos label characters   PV76  22
QQ(7)=-QQ(7)#                          Flag as trashed labels           PV76  23
QQ(1)=0.97/OMAG-XOFF#                  Get new x coords                 PV76  24
QQ(2)=0.97/OMAG-YOFF#                  Get new y coords                 PV76  25
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PV76  26
ELSE#                                  Not dropped in bin               PV76  27
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PV76  28
CALL PV32(QQ,-2)#                      Write new pos label characters   PV76  29
segclose:#                             Close segment                    PV76  30
segdetec:(I)#                          Reset new seg as detectable      PV76  31
QQ(7)=QQ(7)+10.#                       Ensure flagged as group          PV76  32
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PV76  33
writedac:(ioda1:,,I,QQ)#               Save new settings                PV76  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PV76  35
setgcxcopy:#                           Set color context to  xcopy (n   PV76  36
RETURN#                                                                 PV76  37
END#                                                                    PV76  38
pmacro:([no:])#                                                         PV76  39
