systemheader:(SL    )#                                                  SL     1
####################################################################### SL     2
##      Copyright (C) 2000, The Xtal System, The University of        # SL     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # SL     4
## Distributed under the GNU General Public Licence as published by   # SL     5
## the Free Software Foundation, in the hope that it will be useful   # SL     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # SL     7
## for more details.                                                  # SL     8
#                                                                       SL     9
#                           *** SLANT ***                               SL    10
#                                                                       SL    11
#   THE PROGRAM SLANT READS A FOURIER MAP AND PRODUCES A NEW MAP        SL    12
#   IN A SECOND COORDINATE SYSTEM, THE RELATIONSHIP OF WHICH TO THE     SL    13
#   ORIGINAL (CRYSTALLOGRAPHIC) COORDINATE SYSTEM MUST BE DESCRIBED     SL    14
#   IN THE INPUT DATA                                                   SL    15
#                                                                       SL    16
####################################################################### SL    17
#                                                                       SL    18
include:(XMACRO)#                                                       SL    19
#                                                                       SL    20
macro:(pmv:,[SL04($1,$2,$3)])#         Matrix-vector product            SL    21
macro:(pvmv:,[SL02($1,$2,$3)])#        Vector-matrix-vector             SL    22
macro:(ucross:,[SL32($1,$2,$3)])#      Normalized cross product         SL    23
macro:(unitvec:,[SL01($1)])#           Normalize vector                 SL    24
macro:(atname:,incr:(arith:(23,/,mxchwd:)))# Words for label            SL    25
#                                                                       SL    26
extrude:(SLCOMN)#                                                       SL    27
INTEGER DELTAY#                        Storage locations between ea     SL    28
INTEGER DELTAZ#                        Z in qx array holding input      SL    29
INTEGER HEX#                           = yes:, if a hexagonal grid      SL    30
INTEGER INCS(3)#                       Axial grid increments in sca     SL    31
INTEGER INCX(3)#                       In    xyz   order                SL    32
INTEGER IORGS(3)#                      Grid origin in scanning orde     SL    33
INTEGER IORGX(3)#                      In    xyz   order                SL    34
INTEGER IPROP#                         Number of components             SL    35
INTEGER PTYPE#                         Input property type              SL    36
INTEGER IPT#                           Input packet pointer             SL    37
INTEGER ISUM1#                         Indicates first sum axis         SL    38
INTEGER ISUM2#                         Second                           SL    39
INTEGER ISUM3#                         Third                            SL    40
INTEGER IX(3)#                         Current point being looked u     SL    41
INTEGER JPT#                           Output packet pointer            SL    42
INTEGER JSUM1#                         Summation order permutation      SL    43
INTEGER JSUM2#                                                          SL    44
INTEGER JSUM3#                                                          SL    45
INTEGER MAPEND(3)#                     Last grid points for each ax     SL    46
INTEGER MAPORG(3)#                     Origin grid points for each      SL    47
INTEGER MARKS#                         Pointer to symops in qx          SL    48
INTEGER MARK2#                         Pointer to input map in qx       SL    49
INTEGER MARKT#                         Pointer to atoms list            SL    50
INTEGER MARK3#                         Pointer to atoms list            SL    51
INTEGER MARK4#                         Pointer to third sum grid ax     SL    52
INTEGER NCOLM#                         Number of printer columns pe     SL    53
INTEGER NEWX(3)#                       Symopped value of current gr     SL    54
INTEGER NGS(3)#                        Grid divisions per unit cell     SL    55
INTEGER NGX(3)#                        Xyz   order                      SL    56
INTEGER NPTS(3)#                       Number of grid points in map     SL    57
INTEGER NPTOT#                         Total number of grid points      SL    58
INTEGER NPTX(3)#                       Xyz   order                      SL    59
INTEGER STEPS#                                                          SL    60
INTEGER STEP3#                                                          SL    61
INTEGER STOP2#                                                          SL    62
INTEGER STOP3#                                                          SL    63
INTEGER STOP4#                                                          SL    64
INTEGER PASSES#                        Number of fourier passes (fr     SL    65
INTEGER PATSIG#                        = 0, if a fourier; =3, if a      SL    66
INTEGER PHSOUR#                        Phase source (from lr21)         SL    67
INTEGER PRINT#                         1/0, print/do not print outp     SL    68
INTEGER PSIZE#                         Logical record packet size       SL    69
INTEGER SFILE#                         1/2, no output bdf/output bd     SL    70
INTEGER SHEETS#                        If printing output, number o     SL    71
INTEGER SPACE#                         Number of blank lines betwee     SL    72
INTEGER SPACGP#                        Integer equivalent of the sp     SL    73
INTEGER SPL#                           Spline type                      SL    74
REAL AXES(3,3)#                        Skew to crystal transformat      SL    75
REAL CONT(3,3)#                        Contour axes                     SL    76
REAL GINCS(3,3)#                       Increments between successiv     SL    77
REAL TRANS(3,3)#                       Transformation skew to cryst     SL    78
REAL LOLIM#                            Values greater than lolim an     SL    79
REAL R(3,3)#                           Metric tensor                    SL    80
REAL RI(3,3)#                          Inverse metric tensor            SL    81
REAL SKAL#                             Scale to be applied to input     SL    82
REAL SKPTS(3,3)#                       Defining points for skew pla     SL    83
REAL UPLIM#                                                             SL    84
#                                                                       SL    85
COMMON/COMISL/DELTAY,DELTAZ,HEX,INCS,INCX,IORGS,IORGX,#                 SL    86
PTYPE,IPROP,IPT,ISUM1,ISUM2,ISUM3,IX,JPT,#                              SL    87
JSUM1,JSUM2,JSUM3,MAPEND,MAPORG,MARKS,MARK2,MARKT,#                     SL    88
MARK3,MARK4,NCOLM,NEWX,NGS,NGX,#                                        SL    89
NPTS,NPTOT,NPTX,STEPS,STEP3,STOP2,#                                     SL    90
STOP3,STOP4,PASSES,PATSIG,PHSOUR,PRINT,#                                SL    91
PSIZE,SFILE,SHEETS,SPACE,SPACGP,SPL#                                    SL    92
#                                                                       SL    93
COMMON/COMFSL/AXES,CONT,GINCS,LOLIM,TRANS,R,RI,SKAL,#                   SL    94
SKPTS,UPLIM#                                                            SL    95
endext:#                                                                SL    96
#                                                                       SL    97
systemheader:(SL00)#                   Slant fourier calc.              SL00   1
# ################################################################## #  SL00   2
#                                                                    #  SL00   3
#                               SL00                                 #  SL00   4
#                                                                    #  SL00   5
# ################################################################## #  SL00   6
SUBROUTINE SL00#                       N.spadaccini 1984                SL00   7
include:(AACOMN)#                      Include aa common                SL00   8
include:(SLCOMN)#                      Include sl common                SL00   9
#                                                                       SL00  10
FILEXT(IOUNIT(3))='MAP'#               Extension for ip fourr map       SL00  11
FILEXT(IOUNIT(4))='SLA'#               Extension for op slant map       SL00  12
#                                                                       SL00  13
CALL SL11#                             Process bdf to lratom:           SL00  14
CALL SL21#                             Read & store map in order        SL00  15
CALL SL31#                             Process layout and print         SL00  16
CALL SL41#                             Generate new map                 SL00  17
#                                                                       SL00  18
RETURN#                                                                 SL00  19
END#                                                                    SL00  20
systemheader:(SL01)#                   Normalize a vector               SL01   1
# ################################################################## #  SL01   2
#                                                                    #  SL01   3
#                               SL01 - UNITVEC                       #  SL01   4
#                                                                    #  SL01   5
# ################################################################## #  SL01   6
SUBROUTINE SL01(VEC)#                                                   SL01   7
include:(SLCOMN)#                                                       SL01   8
#                                                                       SL01   9
INTEGER I#                             Loop index                       SL01  10
REAL SL02#                             Vector-matrix-vector multipl     SL01  11
REAL VLEN#                             Length of vector                 SL01  12
REAL VEC(3)#                           Incoming column vector           SL01  13
#                                                                       SL01  14
VLEN = SQRT(SL02(VEC,R,VEC))#          Vector(dot)vector                SL01  15
IF(VLEN < small:)  iquit:(SL0105)#     S                                SL01  16
ELSE#                                                                   SL01  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL01  18
DO I=1,3#                              Normalize the vector             SL01  19
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL01  20
VEC(I) = VEC(I)/VLEN#                                                   SL01  21
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL01  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL01  23
#                                                                       SL01  24
RETURN#                                                                 SL01  25
END#                                                                    SL01  26
systemheader:(SL02)#                   Dot product                      SL02   1
# ################################################################## #  SL02   2
#                                                                    #  SL02   3
#                               SL02 - PVMV                          #  SL02   4
#                                                                    #  SL02   5
# ################################################################## #  SL02   6
REAL FUNCTION SL02(VEC1,MATRIX,VEC2)#                                   SL02   7
INTEGER I#                             Loop index                       SL02   8
INTEGER J#                             Another loop index               SL02   9
REAL MATRIX(3,3)#                      Square matrix, usually a ten     SL02  10
REAL VEC1(3)#                          Pre-multiplication vector        SL02  11
REAL VEC2(3)#                          Post-multiplication vector       SL02  12
#                                                                       SL02  13
SL02 = 0.#                             Clear sum                        SL02  14
DO I=1,3#                              Outer loop                       SL02  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL02  16
DO J=1,3#                              Inner loop                       SL02  17
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL02  18
SL02 = SL02 + VEC1(I)*VEC2(J)*MATRIX(I,J)#                              SL02  19
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL02  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL02  21
#                                                                       SL02  22
RETURN#                                                                 SL02  23
END#                                                                    SL02  24
systemheader:(SL04)#                   Matrix times vector              SL04   1
# ################################################################## #  SL04   2
#                                                                    #  SL04   3
#                               SL04 - PMV                           #  SL04   4
#                                                                    #  SL04   5
# ################################################################## #  SL04   6
SUBROUTINE SL04(MATRIX,VEC1,VEC2)#                                      SL04   7
include:(AACOMN)#                                                       SL04   8
include:(SLCOMN)#                                                       SL04   9
#                                                                       SL04  10
INTEGER I#                             Loop index                       SL04  11
INTEGER J#                             Another loop index               SL04  12
REAL MATRIX(3,3)#                      Incoming matrix                  SL04  13
REAL VEC1(3)#                          Incoming vector                  SL04  14
REAL VEC2(3)#                          Resultant vector                 SL04  15
#                                                                       SL04  16
DO I=1,3#                              Column loop                      SL04  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL04  18
VEC2(I) = 0.#                          Clear each vector                SL04  19
DO J=1,3#                              Row loop                         SL04  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL04  21
VEC2(I) = VEC2(I) + VEC1(J)*MATRIX(I,J)#                                SL04  22
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL04  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL04  24
#                                                                       SL04  25
RETURN#                                                                 SL04  26
END#                                                                    SL04  27
systemheader:(SL11)#                   Read in the cell record          SL11   1
# ################################################################## #  SL11   2
#                                                                    #  SL11   3
#                               SL11                                 #  SL11   4
#                                                                    #  SL11   5
# ################################################################## #  SL11   6
SUBROUTINE SL11#                                                        SL11   7
include:(AACOMN)#                      Include aa common                SL11   8
include:(SLCOMN)#                      Include sl common                SL11   9
#                                                                       SL11  10
INTEGER J,K,M,N#                                                        SL11  11
INTEGER BEGIN#                         Starting column of current f     SL11  12
INTEGER IEND#                          Last   column                    SL11  13
INTEGER FIELD#                         Current field number             SL11  14
INTEGER ICENT#                         Centricity (c=0,nc=1)            SL11  15
INTEGER LATYP#                         Lattice type                     SL11  16
INTEGER MATCH#                         Indicates which character fi     SL11  17
INTEGER NSYM#                          Number of symops on bdf          SL11  18
INTEGER PACKET#                        Current packet number in lr4     SL11  19
INTEGER TOTSYM#                        Mem space for symm ops           SL11  20
#                                                                       SL11  21
chardata:(SL011,FI NO PR NP LI CU )#                                    SL11  22
chardata:(SL012, SLANT CONTROL PARAMETERS)#                             SL11  23
chardata:(SL013, PRINTED MAP OUTPUT          YES  )#                    SL11  24
chardata:(SL014, OUTPUT ON FILE SLA          NO   )#                    SL11  25
chardata:(SL015, INTERPOLATION ROUTINE       LINEAR  )#                 SL11  26
chardata:(SL016, YES NO CUBIC    -)#                                    SL11  27
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              SL11  28
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              SL11  29
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              SL11  30
realdata:(TR21,[.3333333,.5])#                                          SL11  31
realdata:(TR22,[.6666667,0.])#                                          SL11  32
realdata:(TR23,[.6666667,.5])#                                          SL11  33
datastuff:#                                                             SL11  34
#                                                                       SL11  35
# SET SOME DEFAULTS                                                     SL11  36
#                                                                       SL11  37
STEPS=12#                              Number of items of symop         SL11  38
SFILE = 1#                             Don't write a new bdf            SL11  39
SPL=1#                                 Linear spline fit                SL11  40
PRINT = yes:#                          Do print map                     SL11  41
SKAL = 1.#                             No map scaling                   SL11  42
UPLIM = -1.#                           Don't blank out                  SL11  43
LOLIM =  0.#                           Any map points.                  SL11  44
#                                                                       SL11  45
FOR(FIELD=1;BUFIN(FIELD)<voidflg:;FIELD=FIELD+1)# Loop over fields      SL11  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL11  47
stringlim:(FIELD,BEGIN,IEND)#          Find field limits                SL11  48
compchar:(CHRIN,BEGIN,SL011,1,2,3,NSL011,MATCH)#                        SL11  49
IF(MATCH == no:)iquit:(SL1105)#        Unrecognized input ..sl1105      SL11  50
IF      (MATCH == 1)  SFILE = 2#       Sf, write new bdf                SL11  51
ELSE  IF(MATCH == 2)  SFILE = 1#       Ns, don't write new bdf          SL11  52
ELSE  IF(MATCH == 3)  PRINT = yes:#    Print map output                 SL11  53
ELSE  IF(MATCH == 4)  PRINT = no:#     No printed output                SL11  54
ELSE  IF(MATCH == 5)  SPL = 1#         Linear spline                    SL11  55
ELSE  IF(MATCH == 6)  SPL = 2#         Cubic spline                     SL11  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL11  57
#                                                                       SL11  58
#     REQUEST MEMORY FOR I/O BUFFERS                                    SL11  59
#                                                                       SL11  60
IOMARK(3) = QXSTR#                     Set up input bdf buffer          SL11  61
incrqx:(MARKS,IOMARK(3)+bdfbuf:,SL1110)# Input buffer ...sl1110         SL11  62
#                                                                       SL11  63
IF(SFILE == 2)#                        If there is an output bdf,       SL11  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL11  65
IOMARK(4) = MARKS#                                                      SL11  66
incrqx:(MARKS,IOMARK(4)+bdfbuf:,SL1115)# Output buffer ...sl1115        SL11  67
copyfile:(3,4,1,3)#                    Copy up to cell record           SL11  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL11  69
#                                                                       SL11  70
PACKET=0#                              Initialize                       SL11  71
REPEAT#                                Read in logical record 4         SL11  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SL11  73
readwpkt:(3,lrcell:,PSIZE,IPT,0)#                                       SL11  74
IF(IPT <= 0)  BREAK#                                                    SL11  75
PACKET = PACKET + 1#                                                    SL11  76
IF(SFILE == 2)#                        Copy out, if necessary           SL11  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SL11  78
writepkt:(4,lrcell:,PSIZE,JPT)#                                         SL11  79
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#                                   SL11  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SL11  81
IF(PACKET == 7)#                       Metric tensor                    SL11  82
movereal:(QX,IPT+1,R,1,9,0)#           Move contents to r array         SL11  83
IF(PACKET==8)#                         Inverse metric tensor            SL11  84
movereal:(QX,IPT+1,RI,1,9,0)#          Move contents to ri array        SL11  85
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SL11  86
#                                                                       SL11  87
#         EXTRACT SYMMETRY INFORMATION FROM BDF                         SL11  88
#                                                                       SL11  89
readwpkt:(3,lrsymm:,PSIZE,IPT,0)#      Read first packet lrsymm.        SL11  90
IF(IPT<=0) iquit:(SL1120)#             Non-existant ...sl1120           SL11  91
LATYP=NINT(QX(IPT+1))#                 Lattice type                     SL11  92
IF(LATYP>7) LATYP=LATYP-7#             Remove centricity                SL11  93
ICENT=NINT(QX(IPT+2))#                 Centre flag (c=0,nc=1)           SL11  94
NSYM=NINT(QX(IPT+4))#                  Number of matrices on bdf        SL11  95
TOTSYM=NINT(QX(IPT+3))*STEPS#          Memory requirements              SL11  96
incrqx:(M,MARKS+TOTSYM,SL1125)#        Symops memory ...sl1125          SL11  97
IF(SFILE==2)#                          Copy out if required             SL11  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SL11  99
writepkt:(4,lrsymm:,PSIZE,JPT)#                                         SL11 100
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#                                   SL11 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SL11 102
#                                                                       SL11 103
#       READ IN SYMOPS                                                  SL11 104
#                                                                       SL11 105
FOR(J=MARKS;J>0;J=J+STEPS)#            Loop over symops                 SL11 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SL11 107
readwpkt:(3,lrsymm:,PSIZE,IPT,0)#      Read in matrix                   SL11 108
IF(IPT<=0) BREAK#                      End of symops                    SL11 109
movereal:(QX,IPT+1,QX,J+1,PSIZE,1)#    Move contents                    SL11 110
IF(SFILE==2)#                          Output if required               SL11 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SL11 112
writepkt:(4,lrsymm:,PSIZE,JPT)#                                         SL11 113
movereal:(QX,IPT+1,QX,JPT+1,PSIZE,1)#                                   SL11 114
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SL11 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SL11 116
#                                                                       SL11 117
#     EXPAND SYMOP TABLE TO ALL OPERATIONS                              SL11 118
#                                                                       SL11 119
K=MARKS+NSYM*STEPS ; N=K#              Point to end of symops           SL11 120
IF(ICENT==0)#                          If centrosymmetric               SL11 121
FOR(J=MARKS;J<N;J=J+1)#                Loop over input symops           SL11 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SL11 123
K=K+1#                                 Increment pointer                SL11 124
QX(K)=-QX(J+1)#                        Store inverse                    SL11 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SL11 126
N=K#                                   Store new end marker             SL11 127
IF(LATYP>1)#                           Centering translations           SL11 128
FOR(J=MARKS;J<N;J=J+STEPS)#            Loop over input symops           SL11 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SL11 130
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            SL11 131
QX(K+10)=QX(J+10)+TR11(LATYP-1)#       Transfer t1                      SL11 132
QX(K+11)=QX(J+11)+TR12(LATYP-1)#       Transfer t2                      SL11 133
QX(K+12)=QX(J+12)+TR13(LATYP-1)#       Transfer t3                      SL11 134
K=K+STEPS#                             Incr storage pointer             SL11 135
IF((LATYP==2)\(LATYP>4)) NEXT#         Skip if not r or f               SL11 136
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            SL11 137
QX(K+10)=QX(J+10)+TR21(LATYP-2)#       Transfer t1                      SL11 138
QX(K+11)=QX(J+11)+TR22(LATYP-2)#       Transfer t2                      SL11 139
QX(K+12)=QX(J+12)+TR23(LATYP-2)#       Transfer t3                      SL11 140
K=K+STEPS#                             Incr storage pointer             SL11 141
IF(LATYP!=4) NEXT#                     Skip if not f-centre             SL11 142
movereal:(QX,J+1,QX,K+1,9,1)#          Transfer rot elements            SL11 143
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      SL11 144
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      SL11 145
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      SL11 146
K=K+STEPS#                             Incr storage pointer             SL11 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SL11 148
MARK2=K#                               Symops end marker                SL11 149
IF(SFILE == 2)#                                                         SL11 150
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SL11 151
copyfile:(3,4,incr:(lrsymm:),incr:(lratom:))# Copy symop and            SL11 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SL11 153
#                                                                       SL11 154
#           OUTPUT SLANT CONTROLS                                       SL11 155
#                                                                       SL11 156
movechar:(SL016,NSL016,CHROT,2,NSL012-1,2)# Underline heading           SL11 157
writeline:(1,SL012,NSL012,2,3)#        Output heading                   SL11 158
IF(PRINT==no:)#                                                         SL11 159
movechar:(SL016,6,SL013,30,3,0)#       Yes, print wanted                SL11 160
writeline:(0,SL013,NSL013,3,3)#                                         SL11 161
IF(SFILE==2)#                                                           SL11 162
movechar:(SL016,2,SL014,30,3,0)#       Yes, bdf written                 SL11 163
writeline:(0,SL014,NSL014,3,3)#                                         SL11 164
IF(SPL==2)#                                                             SL11 165
movechar:(SL016,9,SL015,30,8,0)#       Yes, cubic spline                SL11 166
writeline:(0,SL015,NSL015,3,3)#                                         SL11 167
#                                                                       SL11 168
RETURN#                                                                 SL11 169
END#                                                                    SL11 170
systemheader:(SL21)#                   Process lr21 & lr22              SL21   1
# ################################################################## #  SL21   2
#                                                                    #  SL21   3
#                               SL21                                 #  SL21   4
#                                                                    #  SL21   5
# ################################################################## #  SL21   6
SUBROUTINE SL21#                                                        SL21   7
include:(AACOMN)#                      Include aa common                SL21   8
include:(SLCOMN)#                      Include sl common                SL21   9
#                                                                       SL21  10
INTEGER I#                             Loop index                       SL21  11
REAL TOTPTS#                           Total number of points in        SL21  12
chardata:(SL211, ELECTRON DENSITY   ELECTRIC POTENTIAL$#                SL21  13
 ELECTRIC FIELD     ELECTRIC GRADIENT )#                                SL21  14
chardata:(SL212, MAP PROPERTIES                                )# @     SL21  15
datastuff:#                                                             SL21  16
#                                                                       SL21  17
readwpkt:(3,21,PSIZE,IPT,0)#           Reads logical record 21          SL21  18
DO I=1,3#                              All items are in scanning        SL21  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL21  20
IORGS(I) = NINT(QX(IPT+1))#            Origins                          SL21  21
INCS(I)  = NINT(QX(IPT+4))#            Increments                       SL21  22
IF(INCS(I) != 1)  iquit:(SL2105)#      Unit increments...sl2105         SL21  23
NGS(I)   = NINT(QX(IPT+7))#            Grids                            SL21  24
NPTS(I)  = NINT(QX(IPT+10))#           Points along axes                SL21  25
IPT = IPT + 1#                                                          SL21  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL21  27
ISUM1 = NINT(QX(IPT+10))#              Summation order indices          SL21  28
ISUM2 = NINT(QX(IPT+11))#                                               SL21  29
ISUM3 = NINT(QX(IPT+12))#                                               SL21  30
JSUM1 = NINT(QX(IPT+13))#              Summation order permutation      SL21  31
JSUM2 = NINT(QX(IPT+14))#              Indices.                         SL21  32
JSUM3 = NINT(QX(IPT+15))#                                               SL21  33
PATSIG =NINT(QX(IPT+18))#              Fourr type code                  SL21  34
PHSOUR =NINT(QX(IPT+19))#              Source of phases                 SL21  35
PASSES =NINT(QX(IPT+20))#              Number of passes required        SL21  36
PTYPE  =NINT(QX(IPT+37))#              Property type                    SL21  37
IPROP  =NINT(QX(IPT+38))#              Number of components             SL21  38
#                                                                       SL21  39
movechar:(SL211,PTYPE*19+1,SL212,29,19,0)# Store property type          SL21  40
writeline:(0,SL212,NSL212,3,3)#        Electric field map               SL21  41
#                                                                       SL21  42
NGX(1) = NGS(ISUM1)#                   Get grids in xyz order           SL21  43
NGX(2) = NGS(ISUM2)#                                                    SL21  44
NGX(3) = NGS(ISUM3)#                                                    SL21  45
NPTOT =  NPTS(1)*NPTS(2)*NPTS(3)#      Number of points/input map       SL21  46
TOTPTS = FLOAT(NPTOT*IPROP)#           Total number of points           SL21  47
STOP2 = MARK2 + NINT(TOTPTS)#          End of map                       SL21  48
incrqx:(I,STOP2+1,SL2110)#             Request enough room to store     SL21  49
#                                                                       SL21  50
# THE ENTIRE INPUT MAP WILL BE STORED BY THE ROUTINE SL11.  IT WILL     SL21  51
# ALWAYS BE STORED IN ZYX (WVU) ORDER.  THAT IS, EACH X VALUE WILL      SL21  52
# BE SEPARATED BY ONE STORAGE UNIT, EACH Y BY THE NUMBER OF X POINTS    SL21  53
# ACROSS LINE, AND EACH Z BY THE NUMBER OF POINTS ON A PAGE.            SL21  54
#                                                                       SL21  55
CALL SL22#                                                              SL21  56
#                                                                       SL21  57
RETURN#                                                                 SL21  58
END#                                                                    SL21  59
systemheader:(SL22)#                   Store the input map & order      SL22   1
# ################################################################## #  SL22   2
#                                                                    #  SL22   3
#                               SL22                                 #  SL22   4
#                                                                    #  SL22   5
# ################################################################## #  SL22   6
SUBROUTINE SL22#                                                        SL22   7
include:(AACOMN)#                      Include aa common                SL22   8
include:(SLCOMN)#                      Include sl common                SL22   9
#                                                                       SL22  10
INTEGER DELTA(3)#                      Number of storage locations      SL22  11
INTEGER I#                             Third scanning order loop in     SL22  12
INTEGER IPTR#                          Pointer to next point on inp     SL22  13
INTEGER J#                             Second scanning order loop i     SL22  14
INTEGER K,L#                           First scanning order loop in     SL22  15
INTEGER LOC1#                          Pointer to location where        SL22  16
INTEGER LOC2#                          Same for next line               SL22  17
INTEGER LOC3#                          Same for next point              SL22  18
INTEGER LOC4#                          Same for next component of pro   SL22  19
INTEGER MAPPTS(3)#                     Number of grid points for ea     SL22  20
INTEGER NP1#                           Number of input sections         SL22  21
INTEGER NP2#                           Number of points in 2nd          SL22  22
INTEGER NP3#                           Same for the 3rd summation       SL22  23
#                                                                       SL22  24
intdata:(IPR,[0,1,1])#                                                  SL22  25
datastuff:#                                                             SL22  26
#                                                                       SL22  27
DELTA(ISUM1) = 1#                      Calculate the separations        SL22  28
DELTA(ISUM2) = NPTS(ISUM1)#                                             SL22  29
DELTA(ISUM3) = NPTS(ISUM1)*NPTS(ISUM2)#                                 SL22  30
NP1 = NPTS(1)#                         Number of sections               SL22  31
NP2 = NPTS(2)#                         Number of points in 2nd and      SL22  32
NP3 = NPTS(3)#                         3rd summation directions.        SL22  33
LOC4 = MARK2 + 1#                      Pointer to start of stored       SL22  34
LOC3 = LOC4#                           Map.                             SL22  35
LOC2 = LOC3#                                                            SL22  36
LOC1 = LOC2#                                                            SL22  37
#                                                                       SL22  38
DO K=1,NP1#                            Loop over input sections         SL22  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL22  40
DO J=1,NP2#                            Loop over input lines            SL22  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL22  42
readwpkt:(3,22,PSIZE,IPT,0)#           Read in a line                   SL22  43
IF(IPT == 0)  BREAK#                                                    SL22  44
DO I=1,NP3#                            Loop over points                 SL22  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SL22  46
IPTR = IPT + (I-1)*IPROP#                                               SL22  47
DO L=1,IPROP#                          Loop over property components    SL22  48
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SL22  49
LOC4 = LOC4 + NPTOT*IPR(L)#            Increment component pointer      SL22  50
QX(LOC4) = QX(IPTR+L)#                 Store point                      SL22  51
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SL22  52
LOC3 = LOC3 + DELTA(3)#                Increment storage pointer        SL22  53
LOC4 = LOC3#                                                            SL22  54
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SL22  55
LOC2 = LOC2 + DELTA(2)#                Increment line pointer           SL22  56
LOC3 = LOC2#                                                            SL22  57
LOC4 = LOC3#                                                            SL22  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL22  59
LOC1 = LOC1 + DELTA(1)#                Increment section pointer        SL22  60
LOC2 = LOC1#                                                            SL22  61
LOC3 = LOC2#                                                            SL22  62
LOC4 = LOC3#                                                            SL22  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL22  64
#                                                                       SL22  65
MAPORG(1) = IORGS(ISUM1)#              Get map origins in xyz order     SL22  66
MAPORG(2) = IORGS(ISUM2)#                                               SL22  67
MAPORG(3) = IORGS(ISUM3)#                                               SL22  68
#                                                                       SL22  69
MAPPTS(1) = NPTS(ISUM1)#               Get number of points in xyz      SL22  70
MAPPTS(2) = NPTS(ISUM2)#               Order.                           SL22  71
MAPPTS(3) = NPTS(ISUM3)#                                                SL22  72
#                                                                       SL22  73
DO I=1,3#                              Get map termini in xyz order     SL22  74
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SL22  75
MAPEND(I) = MAPORG(I) + MAPPTS(I) - 1#                                  SL22  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SL22  77
#                                                                       SL22  78
DELTAY = MAPPTS(1)#                    Number of points in x and        SL22  79
DELTAZ = MAPPTS(1)*MAPPTS(2)#          Y directions.                    SL22  80
#                                                                       SL22  81
RETURN#                                                                 SL22  82
END#                                                                    SL22  83
systemheader:(SL31)#                   Process the input images         SL31   1
# ################################################################## #  SL31   2
#                                                                    #  SL31   3
#                               SL31                                 #  SL31   4
#                                                                    #  SL31   5
# ################################################################## #  SL31   6
SUBROUTINE SL31#                                                        SL31   7
include:(AACOMN)#                      Include aa common                SL31   8
include:(SLCOMN)#                      Include sl common                SL31   9
#                                                                       SL31  10
INTEGER ATMR#                          Read bdf for atom coord y/n      SL31  11
INTEGER ATTR#                          Transform coord y/n              SL31  12
INTEGER BEGIN#                         Start of character field         SL31  13
INTEGER IEND#                          End of character field           SL31  14
INTEGER FIELD#                         Current field being process      SL31  15
INTEGER I#                             Loop index                       SL31  16
INTEGER IWNT(4)#                       Array of requested items         SL31  17
INTEGER IREL(4)#                       Array of pointers to items       SL31  18
INTEGER IR1,IR2,IR3,IR4#               Pointers to items                SL31  19
INTEGER SIGNAL(4)#                     Indexpkt keys                    SL31  20
INTEGER ISPACE#                        Number of lines per pt           SL31  21
INTEGER IENDGX,JPTR,JJ,KJ#                                              SL31  22
INTEGER J#                             Another loop index               SL31  23
INTEGER K#                             Scratch location                 SL31  24
INTEGER LAYOUT#                        =yes:,if layout line             SL31  25
INTEGER M#                                                              SL31  26
INTEGER MATCH#                         Points to field match            SL31  27
INTEGER N#                                                              SL31  28
INTEGER REV(3)#                        Same as the jsums                SL31  29
INTEGER SKEW#                          =yes:,if defpln line             SL31  30
string:(NAME1,24)#                     Character array                  SL31  31
string:(NAME2,24)#                     Ditto                            SL31  32
REAL POINTP(3)#                        Plane defining point             SL31  33
REAL POS(3)#                           Frac to grid factor              SL31  34
REAL STEP(3)#                          Distance between output pt       SL31  35
REAL RES#                              Average input resolution         SL31  36
#REAL CONT(3,3)#                       CONTOUR AXES                     SL31  37
REAL MESH(3)#                                                           SL31  38
#                                                                       SL31  39
chardata:(SL031,LA DO AC FR GR )#                                       SL31  40
chardata:(SL032, MAPRES DEFPLN LAYOUT PRINT SITE SITEG END )#           SL31  41
chardata:(SL033,[ PLANE DEFINING POINTS (IN CRYSTALLOGRAPHIC $#         SL31  42
GRID UNITS)])#                                                          SL31  43
chardata:(SL034,[ ORIGIN   POINT(2) POINT(3)])#                         SL31  44
chardata:(SL035,[ -(CALC) ORIENTATION    -----     GRID INT$#           SL31  45
ERVAL        (ANGSTROM)])#                                              SL31  46
chardata:(SL036,LAYER DOWN  ACROSS XYZ)#                                SL31  47
chardata:(SL037,[ MAP BOUNDARY IN -(CALC) GRID       TO       $#        SL31  48
INCR])#                                                                 SL31  49
chardata:(SL038, PRINTER DENSITY LIMITS)#                               SL31  50
chardata:(SL039, PRINTER DENSITY SCALE)#                                SL31  51
chardata:(SL03A, PRINTER   COL/PT  LINE/PT)#                            SL31  52
realdata:(FMT031,[340413.,430413.,530413.])#                            SL31  53
realdata:(FMT032,[540742.,410812.,610832.])#                            SL31  54
realdata:(FMT033,[300722.,390722.,480722.])#                            SL31  55
datastuff:#                                                             SL31  56
#                                                                       SL31  57
#     SET DEFAULTS                                                      SL31  58
#                                                                       SL31  59
RES=0.0#                               Initialize                       SL31  60
DO I=1,3#                              Average resolution               SL31  61
RES=RES+(SQRT(R(I,I))/FLOAT(NGX(I)))/3.#                                SL31  62
DO I=1,3#                                                               SL31  63
STEP(I)=RES#                           Default resolution               SL31  64
DO J=1,3#                              Initialize output layout..       SL31  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL31  66
INCX(J) = 1#                           Increments                       SL31  67
IORGX(J) = 0#                          Origins                          SL31  68
NPTX(J) = 0#                           Numbers of points                SL31  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL31  70
ATMR=no:#                              Don't read bdf for coords        SL31  71
ATTR=no:#                              Don't transform coords           SL31  72
ISUM1 = 3#                             Output summation order           SL31  73
ISUM2 = 1#                                                              SL31  74
ISUM3 = 2#                                                              SL31  75
ISPACE=(prtlpin:+1)/3#                 Get line spacing                 SL31  76
NCOLM = 4#                             4 columns per point              SL31  77
SKEW = no:#                            No defpln                        SL31  78
LAYOUT = no:#                          Or layout lines yet.             SL31  79
MARK3=STOP2+1;  STEP3=3+atname:#       Mark begin of atoms              SL31  80
MARKT=MARK3#                           Mark end of atom list            SL31  81
#                                                                       SL31  82
#  LOOP OVER CONTROL LINES                                              SL31  83
#  -----------------------                                              SL31  84
#                                                                       SL31  85
REPEAT#                                Loop over input lines            SL31  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL31  87
readline:(SL032,NSL032)#               Read the next line               SL31  88
#                                                                       SL31  89
IF(LINID == 1)#                        ********** mapres ***********    SL31  90
DO J=1,3#                              Loop over grid specs             SL31  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SL31  92
ifnv:(BUFIN(J))  STEP(J) = BUFIN(J)#                                    SL31  93
ELSE iquit:(SL3105)#                   Mandatory items                  SL31  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SL31  95
#                                                                       SL31  96
ELSE  IF(LINID == 2)#                  ********* defpln ***********     SL31  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SL31  98
IF(BUFIN(1)>voidflg:) iquit:(SL3106)#  Alpha expected....sl3106.        SL31  99
stringlim:(1,BEGIN,IEND)#              Limits of first field            SL31 100
compchar:(CHRIN,BEGIN,SL031,10,2,3,15,MATCH)#                           SL31 101
IF(MATCH==1)#                          Fractional coords                SL31 102
DO I=1,3; POS(I)=NGX(I)#                                                SL31 103
ELSE IF(MATCH==2)#                     Grid coords                      SL31 104
DO I=1,3; POS(I)=1.0#                                                   SL31 105
FIELD = 1#                                                              SL31 106
DO I=1,3; DO J=1,3#                                                     SL31 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SL31 108
FIELD = FIELD + 1#                     Increment field counter          SL31 109
ifvo:(BUFIN(FIELD))  iquit:(SL3110)#   S                                SL31 110
SKPTS(J,I) = BUFIN(FIELD)*POS(J)#                                       SL31 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SL31 112
SKEW = yes:#                                                            SL31 113
writeline:(1,SL033,NSL033,3,3)#                                         SL31 114
KJ=1#                                                                   SL31 115
DO K=1,3#                                                               SL31 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SL31 117
movechar:(SL034,KJ,CHROT,1,9,0)#                                        SL31 118
ncodefld:(SKPTS(1,K),1,CHROT,FMT033,3)#                                 SL31 119
writeline:(0,0,0,1,3)#                                                  SL31 120
KJ=KJ+9#                                                                SL31 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SL31 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SL31 123
#                                                                       SL31 124
ELSE  IF(LINID == 3)#                  ******** layout *************    SL31 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SL31 126
LAYOUT = yes:#                                                          SL31 127
DO J=1,3#                                                               SL31 128
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SL31 129
IF(BUFIN(J)>voidflg:) iquit:(SL3115)## Alpha expected ...SL3115.        SL31 130
stringlim:(J,BEGIN,IEND)#              Limits of field                  SL31 131
compchar:(CHRIN,BEGIN,SL031,1,2,3,9,MATCH)#                             SL31 132
IF(MATCH==0) iquit:(SL3120)#           Unrecognized  ....sl3120.        SL31 133
IF(J==1) ISUM1=MATCH#                  X' direction                     SL31 134
IF(J==2) ISUM2=MATCH#                  Y' direction                     SL31 135
IF(J==3) ISUM3=MATCH#                  Z' direction                     SL31 136
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SL31 137
K = 4#                                                                  SL31 138
DO J=1,3#                              Bring in number of points,       SL31 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SL31 140
IF(BUFIN(K)   > voidflg:)  NPTX(J)  = NINT(BUFIN(K))#                   SL31 141
IF(BUFIN(K+3) > voidflg:)  IORGX(J) = NINT(BUFIN(K+3))#                 SL31 142
IF(BUFIN(K+6) > voidflg:)  INCX(J)  = NINT(BUFIN(K+6))#                 SL31 143
K = K + 1#                                                              SL31 144
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SL31 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SL31 146
#                                                                       SL31 147
ELSE IF(LINID == 4)#                   ********* print ************     SL31 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SL31 149
IF(BUFIN(1) > voidflg:)  SKAL=BUFIN(1)# Map density scale               SL31 150
IF(BUFIN(2) > (voidflg:))#             Upper limit                      SL31 151
UPLIM = BUFIN(2)#                                                       SL31 152
IF(BUFIN(3) > (voidflg:))#             Lower limit                      SL31 153
LOLIM = BUFIN(3)#                                                       SL31 154
IF((BUFIN(4) > 0.)&(BUFIN(4) <= 5.))  NCOLM = NINT(BUFIN(4))#           SL31 155
IF((BUFIN(5) > 0.)&(BUFIN(5) <= 3.))  ISPACE = NINT(BUFIN(5))#          SL31 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SL31 157
#                                                                       SL31 158
ELSE IF(LINID==5\LINID==6)#            ******** site/siteg *********    SL31 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SL31 160
IF(BUFIN(1)==voidflg:) iquit:(SL3125)# Atom name missing ..sl3125.      SL31 161
ATTR=yes:#                             Co-ord. transformation           SL31 162
stringlim:(1,N,M)#                     Limits of field(1)               SL31 163
NAME1=CHRIP(N^M)#                      Store atom name                  SL31 164
JJ=MARKT; incrqx:(MARKT,JJ+STEP3,SL3101)# Get memory for atom list      SL31 165
IF(BUFIN(2)==voidflg:) QX(JJ+1)=voidflg:# X coord void                  SL31 166
ELSE IF(LINID==5)#                     ********** site card             SL31 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SL31 168
QX(JJ+1)=BUFIN(2)*FLOAT(NGX(1))#       X in grids                       SL31 169
QX(JJ+2)=BUFIN(3)*FLOAT(NGX(2))#       Y in grids                       SL31 170
QX(JJ+3)=BUFIN(4)*FLOAT(NGX(3))#       Z in grids                       SL31 171
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SL31 172
ELSE#                                  ********** siteg card            SL31 173
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SL31 174
QX(JJ+1)=BUFIN(2)#                     X in grids                       SL31 175
QX(JJ+2)=BUFIN(3)#                     Y in grids                       SL31 176
QX(JJ+3)=BUFIN(4)#                     Z in grids                       SL31 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SL31 178
movector:(NAME1,1,QX(JJ+4),1,24,0)#    Store atom name                  SL31 179
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SL31 180
#                                                                       SL31 181
ELSE  BREAK#                           *********** end *************    SL31 182
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL31 183
#                                                                       SL31 184
IF(PRINT==no: & SFILE !=2) iquit:(SL3130)# No output                    SL31 185
IF(SKEW == no:)  iquit:(SL3135)#       S                                SL31 186
#                                                                       SL31 187
#     PLANE DEFINING VECTORS                                            SL31 188
#                                                                       SL31 189
DO I=1,3#                              Get skew plane defining          SL31 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SL31 191
POINTP(I) = (SKPTS(I,3)-SKPTS(I,1))/FLOAT(NGX(I))#                      SL31 192
AXES(I,1) = (SKPTS(I,2)-SKPTS(I,1))/FLOAT(NGX(I))#                      SL31 193
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SL31 194
CALL unitvec:(AXES(1,1))#              Get skew x-axis                  SL31 195
CALL ucross:(AXES(1,1),POINTP,AXES(1,2))# Y-axis                        SL31 196
CALL ucross:(AXES(1,1),AXES(1,2),AXES(1,3))# Z-axis                     SL31 197
SPACE = ISPACE - 1#                                                     SL31 198
IF(ISUM1+ISUM2+ISUM3 != 6)  iquit:(SL3140)# S                           SL31 199
IF(ISUM1*ISUM2*ISUM3 != 6)  iquit:(SL3140)# S                           SL31 200
#                                                                       SL31 201
#     RE-ORDER VECTORS FROM (X(CALC),Y(CALC),Z(CALC))                   SL31 202
#     TO (LAYER,DOWN,ACROSS).                                           SL31 203
#                                                                       SL31 204
REV(ISUM1) = 1#                        Get summation order              SL31 205
REV(ISUM2) = 2#                        Permutation indices.             SL31 206
REV(ISUM3) = 3#                                                         SL31 207
JSUM1 = REV(1)#                                                         SL31 208
JSUM2 = REV(2)#                                                         SL31 209
JSUM3 = REV(3)#                                                         SL31 210
DO I=1,3#                              Get crystallographic             SL31 211
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SL31 212
DO J=1,3#                              One skew point to another.       SL31 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SL31 214
K = REV(J)#                                                             SL31 215
GINCS(I,J) = AXES(I,K)*FLOAT(INCX(K))*FLOAT(NGX(I))*STEP(K)#            SL31 216
TRANS(I,J) = AXES(I,K)*FLOAT(NGX(I))*STEP(K)#                           SL31 217
CONT(I,J)=AXES(I,K)#                                                    SL31 218
MESH(J)=STEP(K)#                                                        SL31 219
NGS(J) = NGX(K)#                       And grids.                       SL31 220
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SL31 221
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SL31 222
#                                                                       SL31 223
#     DETERMINE DEFAULT LAYOUT MAP                                      SL31 224
#                                                                       SL31 225
IF(LAYOUT==no:) CALL SL33(TRANS,SKPTS(1,1),0)#                          SL31 226
#                                                                       SL31 227
DO J=1,3#                              Create output scanning order     SL31 228
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SL31 229
K = REV(J)#                                                             SL31 230
NPTS(J) = NPTX(K)#                     Points,                          SL31 231
IORGS(J) = IORGX(K)#                   Origins,                         SL31 232
INCS(J) = INCX(K)#                     Increments,                      SL31 233
NGS(J) = NGX(K)#                       And grids.                       SL31 234
IF(INCX(K) <= 0)  iquit:(SL3145)#      S                                SL31 235
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SL31 236
#                                                                       SL31 237
#     READ SITE COORDS FROM BDF                                         SL31 238
#                                                                       SL31 239
IF(ATMR==yes:)#                        Read cords form bdf              SL31 240
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SL31 241
rewindbdf:(3)#                         Rewind lu 3                      SL31 242
IWNT(1)=1 ; IWNT(2)=2#                 X & y cords                      SL31 243
IWNT(3)=3 ; IWNT(4)=14#                Z & atom name                    SL31 244
SIGNAL(1)=4 ; SIGNAL(2)=0#             All mandatory                    SL31 245
SIGNAL(3)=0 ; SIGNAL(4)=0#                                              SL31 246
indexpkt:(3,lratom:,PSIZE,IPT,0,SIGNAL,IWNT,IREL)# Find items           SL31 247
IF(IPT<=0) iquit:(SL3150)#             Atom lr non-existant             SL31 248
IF(SIGNAL(4)<=0) iquit:(SL3155)#       Mandatory item missing           SL31 249
IR1=IREL(1) ; IR2=IREL(2)#                                              SL31 250
IR3=IREL(3) ; IR4=IREL(4)#                                              SL31 251
REPEAT#                                                                 SL31 252
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SL31 253
readwpkt:(3,lratom:,PSIZE,IPT,0)#      Read atoms list                  SL31 254
IF(IPT<=0) BREAK#                      End of atom record               SL31 255
M=IPT+IREL(4)#                         Point to atom name in  buffe     SL31 256
movertoc:(QX(M),1,NAME1,1,24,0)#       Insert bdf atom name             SL31 257
FOR(J=MARK3;J<MARKT;J=J+STEP3)#        Loop over atoms                  SL31 258
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SL31 259
IF(QX(J+1)!=voidflg:) NEXT#            Coords already there             SL31 260
movertoc:(QX(J+4),1,NAME2,1,24,0)#     Insert requested atom            SL31 261
IF(NAME1==NAME2) BREAK#                Exit if match found              SL31 262
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SL31 263
IF(J>=MARKT) NEXT#                     Skip if no match                 SL31 264
QX(J+1)=QX(IPT+IR1)*FLOAT(NGX(1))#     X in grids                       SL31 265
QX(J+2)=QX(IPT+IR2)*FLOAT(NGX(2))#     Y in grids                       SL31 266
QX(J+3)=QX(IPT+IR3)*FLOAT(NGX(3))#     Z in grids                       SL31 267
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SL31 268
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SL31 269
#                                                                       SL31 270
#    OUTPUT NEW MAP INFO TO LR21                                        SL31 271
#                                                                       SL31 272
IF(SFILE == 2)#                        Make new lr21 corresponding      SL31 273
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SL31 274
writepkt:(4,21,41,JPT)#                                                 SL31 275
DO J=1,3#                                                               SL31 276
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SL31 277
JPTR = JPT + J#                                                         SL31 278
QX(JPTR) = FLOAT(IORGS(J))#                                             SL31 279
QX(JPTR+3) = FLOAT(INCS(J))#                                            SL31 280
QX(JPTR+6) = 100.#                                                      SL31 281
QX(JPTR+9) = FLOAT(NPTS(J))#                                            SL31 282
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SL31 283
QX(JPT+13) = FLOAT(ISUM1)#                                              SL31 284
QX(JPT+14) = FLOAT(ISUM2)#                                              SL31 285
QX(JPT+15) = FLOAT(ISUM3)#                                              SL31 286
QX(JPT+16) = FLOAT(JSUM1)#                                              SL31 287
QX(JPT+17) = FLOAT(JSUM2)#                                              SL31 288
QX(JPT+18) = FLOAT(JSUM3)#                                              SL31 289
QX(JPT+19) = UPLIM#                                                     SL31 290
QX(JPT+20) = LOLIM#                                                     SL31 291
QX(JPT+21) = FLOAT(PATSIG)#                                             SL31 292
QX(JPT+22) = PHSOUR#                                                    SL31 293
QX(JPT+23) = PASSES#                                                    SL31 294
QX(JPT+24)=0.#                                                          SL31 295
QX(JPT+25)=MESH(1)#                                                     SL31 296
QX(JPT+26)=MESH(2)#                                                     SL31 297
QX(JPT+27)=MESH(3)#                                                     SL31 298
#                                                                       SL31 299
QX(JPT+28)=SKPTS(1,1)/FLOAT(NGX(1))#                                    SL31 300
QX(JPT+29)=SKPTS(2,1)/FLOAT(NGX(2))#                                    SL31 301
QX(JPT+30)=SKPTS(3,1)/FLOAT(NGX(3))#                                    SL31 302
#                                                                       SL31 303
QX(JPT+31)=CONT(1,1)#                                                   SL31 304
QX(JPT+32)=CONT(2,1)#                                                   SL31 305
QX(JPT+33)=CONT(3,1)#                                                   SL31 306
#                                                                       SL31 307
QX(JPT+34)=CONT(1,2)#                                                   SL31 308
QX(JPT+35)=CONT(2,2)#                                                   SL31 309
QX(JPT+36)=CONT(3,2)#                                                   SL31 310
#                                                                       SL31 311
QX(JPT+37)=CONT(1,3)#                                                   SL31 312
QX(JPT+38)=CONT(2,3)#                                                   SL31 313
QX(JPT+39)=CONT(3,3)#                                                   SL31 314
#                                                                       SL31 315
QX(JPT+40)=FLOAT(PTYPE)#                                                SL31 316
QX(JPT+41)=FLOAT(IPROP)#                                                SL31 317
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SL31 318
#                                                                       SL31 319
#     TELL USER EVERYTHING                                              SL31 320
#                                                                       SL31 321
DO I=1,3#                                                               SL31 322
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SL31 323
movechar:(SL035,1,CHROT,1,NSL035,0)#                                    SL31 324
IF(I==1) J= 5*(ISUM1-1) + ISUM1#                                        SL31 325
IF(I==2) J= 5*(ISUM2-1) + ISUM2#                                        SL31 326
IF(I==3) J= 5*(ISUM3-1) + ISUM3#                                        SL31 327
movechar:(SL036,19+I,CHROT,2,1,0)#                                      SL31 328
movechar:(SL036,J,CHROT,25,6,0)#                                        SL31 329
ncodefld:(STEP(I),1,CHROT,FMT032(1),1)#                                 SL31 330
writeline:(0,0,0,1,3)#                                                  SL31 331
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SL31 332
#                                                                       SL31 333
DO I=1,3#                                                               SL31 334
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SL31 335
movechar:(SL037,1,CHROT,1,NSL037,0)#                                    SL31 336
movechar:(SL036,19+I,CHROT,18,1,0)#                                     SL31 337
IENDGX=IORGX(I)+NPTX(I)*INCX(I)-1#                                      SL31 338
ncodefld:(FLOAT(IORGX(I)),1,CHROT,FMT031(1),1)#                         SL31 339
ncodefld:(FLOAT(IENDGX),1,CHROT,FMT031(2),1)#                           SL31 340
ncodefld:(FLOAT(INCX(I)),1,CHROT,FMT031(3),1)#                          SL31 341
writeline:(0,0,0,1,3)#                                                  SL31 342
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SL31 343
IF(PRINT==yes:)#                                                        SL31 344
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SL31 345
movechar:(SL038,1,CHROT,1,NSL038,0)#                                    SL31 346
ncodefld:(LOLIM,1,CHROT,FMT031(2),1)#                                   SL31 347
ncodefld:(UPLIM,1,CHROT,FMT031(1),1)#                                   SL31 348
writeline:(0,0,0,1,3)#                                                  SL31 349
#                                                                       SL31 350
movechar:(SL039,1,CHROT,1,NSL039,0)#                                    SL31 351
ncodefld:(SKAL,1,CHROT,FMT032(2),1)#                                    SL31 352
writeline:(0,0,0,1,3)#                                                  SL31 353
#                                                                       SL31 354
movechar:(SL03A,1,CHROT,1,NSL03A,0)#   Printer format                   SL31 355
ncodefld:(FLOAT(NCOLM),1,CHROT,FMT031(1),1)#                            SL31 356
ncodefld:(FLOAT(ISPACE),1,CHROT,FMT031(2),1)#                           SL31 357
writeline:(0,0,0,1,3)#                                                  SL31 358
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SL31 359
#                                                                       SL31 360
UPLIM=UPLIM/SKAL#                      In electrons                     SL31 361
LOLIM=LOLIM/SKAL#                      In electrons                     SL31 362
#                                                                       SL31 363
#                                                                       SL31 364
#     TRANSFORM ATOM COORDS                                             SL31 365
#                                                                       SL31 366
IF(ATTR==yes:)#                        Transform grid cords             SL31 367
CALL SL33(TRANS,SKPTS(1,1),1)#                                          SL31 368
#                                                                       SL31 369
RETURN#                                                                 SL31 370
END#                                                                    SL31 371
systemheader:(SL32)#                   Generalized cross product        SL32   1
# ################################################################## #  SL32   2
#                                                                    #  SL32   3
#                               SL32 - UCROSS                        #  SL32   4
#                                                                    #  SL32   5
# ################################################################## #  SL32   6
SUBROUTINE SL32(VEC1,VEC2,VEC3)#                                        SL32   7
include:(SLCOMN)#                      Shut off listing of commons      SL32   8
#                                                                       SL32   9
INTEGER I#                             Loop index                       SL32  10
INTEGER I1#                            Index modifier                   SL32  11
INTEGER I2#                            Another index modifier           SL32  12
REAL VEC1(3)#                          Input vector 1                   SL32  13
REAL VEC2(3)#                          Input vector 2                   SL32  14
REAL VEC3(3)#                          Resulting normalized vector      SL32  15
REAL VECT(3)#                          Reciprocal vector product        SL32  16
#                                                                       SL32  17
DO I=1,3#                              Compute generalized              SL32  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL32  19
I1 = MOD(I+3,3) + 1#                                                    SL32  20
I2 = MOD(I+1,3) + 1#                                                    SL32  21
VECT(I) = VEC1(I1)*VEC2(I2) - VEC1(I2)*VEC2(I1)#                        SL32  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL32  23
#                                                                       SL32  24
#     CHANGE CROSS PRODUCT VECTOR FROM                                  SL32  25
#     RECIPROCAL SYSTEM BACK TO NORMAL                                  SL32  26
#     BASE SET.                                                         SL32  27
#                                                                       SL32  28
CALL SL04(RI,VECT,VEC3)#                                                SL32  29
#                                                                       SL32  30
CALL SL01(VEC3)#                       Normalize                        SL32  31
#                                                                       SL32  32
RETURN#                                                                 SL32  33
END#                                                                    SL32  34
systemheader:(SL33)#                   Transforms coords if reqd.       SL33   1
# ################################################################## #  SL33   2
#                                                                    #  SL33   3
#                               SL33                                 #  SL33   4
#                                                                    #  SL33   5
# ################################################################## #  SL33   6
SUBROUTINE SL33(A,OR,FL)#                                               SL33   7
include:(AACOMN)#                      Include aa common                SL33   8
include:(SLCOMN)#                      Include sl common                SL33   9
#                                                                       SL33  10
INTEGER I,J,K,L,M#                     Indices                          SL33  11
INTEGER FL#                            Flag                             SL33  12
REAL A(3,3)#                           Basis transformation             SL33  13
REAL B(3,3)#                           Cords transformation             SL33  14
REAL DETERM#                           Determinant                      SL33  15
REAL NXX(3)#                           New "x", "y", "z"                SL33  16
REAL XX(3)#                            Translated grid points           SL33  17
REAL OR(3)#                            Origin of map                    SL33  18
REAL XSMA(3)#                          Smallest grid value la,do,a      SL33  19
REAL XLAR(3)#                          Largest grid value la,do,ac      SL33  20
#                                                                       SL33  21
chardata:(SL261,            CRYSTALLOGRAPHIC GRID COORD       $#        SL33  22
CALCULATED GRID COORD)#                                                 SL33  23
chardata:(SL262, ATOM          GRIDX  GRIDY  GRIDZ   GRIDX  GRI$#       SL33  24
DY  GRIDZ)#                                                             SL33  25
realdata:(FMT261,[200612.,270612.,340612.])#                            SL33  26
realdata:(FMT262,[530612.,600612.,670612.])#                            SL33  27
datastuff:#                                                             SL33  28
#                                                                       SL33  29
DO I=1,3#                                                               SL33  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL33  31
XSMA(I)=0.0 ; XLAR(I)=0.0 ; XX(I)=0.0#                                  SL33  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL33  33
#                                                                       SL33  34
#    CALCULATE TRANSFORM MATRIX                                         SL33  35
#                                                                       SL33  36
DETERM=A(1,1)*A(2,2)*A(3,3)-A(1,1)*A(2,3)*A(3,2)+$#                     SL33  37
A(1,3)*A(2,1)*A(3,2)-A(1,3)*A(2,2)*A(3,1)+$#                            SL33  38
A(1,2)*A(2,3)*A(3,1)-A(1,2)*A(2,1)*A(3,3)#                              SL33  39
#                                                                       SL33  40
B(1,1)=(A(2,2)*A(3,3)-A(3,2)*A(2,3))/DETERM#                            SL33  41
B(1,2)=-(A(1,2)*A(3,3)-A(3,2)*A(1,3))/DETERM#                           SL33  42
B(1,3)=(A(1,2)*A(2,3)-A(2,2)*A(1,3))/DETERM#                            SL33  43
B(2,1)=-(A(2,1)*A(3,3)-A(3,1)*A(2,3))/DETERM#                           SL33  44
B(2,2)=(A(1,1)*A(3,3)-A(3,1)*A(1,3))/DETERM#                            SL33  45
B(2,3)=-(A(1,1)*A(2,3)-A(2,1)*A(1,3))/DETERM#                           SL33  46
B(3,1)=(A(2,1)*A(3,2)-A(3,1)*A(2,2))/DETERM#                            SL33  47
B(3,2)=-(A(1,1)*A(3,2)-A(3,1)*A(1,2))/DETERM#                           SL33  48
B(3,3)=(A(1,1)*A(2,2)-A(2,1)*A(1,2))/DETERM#                            SL33  49
#                                                                       SL33  50
#     DETERMINE DEFAULT LAYOUT                                          SL33  51
#                                                                       SL33  52
IF(FL==0)#                                                              SL33  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL33  54
DO I=1,3#                                                               SL33  55
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SL33  56
DO J=1,3#                                                               SL33  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SL33  58
XX(J)=SKPTS(J,I)-OR(J)#                                                 SL33  59
NXX(J)=0.0#                                                             SL33  60
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SL33  61
DO K=1,3#                                                               SL33  62
DO L=1,3#                                                               SL33  63
NXX(K)=NXX(K)+B(K,L)*XX(L)#                                             SL33  64
DO M=2,3#                                                               SL33  65
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SL33  66
IF(NXX(M)<XSMA(M)) XSMA(M)=NXX(M)#                                      SL33  67
IF(NXX(M)>XLAR(M)) XLAR(M)=NXX(M)#                                      SL33  68
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SL33  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SL33  70
IORGX(2)=0#                            One layer only                   SL33  71
NPTX(2)=1#                             One layer only                   SL33  72
INCX(2)=1#                             One layer only                   SL33  73
IORGX(1)=NINT(XSMA(3))-3#              Start from lowest grid           SL33  74
NPTX(1)=IABS(NINT(XLAR(3)-XSMA(3)))+7# Enough pts to hi grid            SL33  75
INCX(1)=1#                             Increment at 1                   SL33  76
IORGX(3)=NINT(XSMA(2))-3#              Ditto                            SL33  77
NPTX(3)=IABS(NINT(XLAR(2)-XSMA(2)))+7# Ditto                            SL33  78
INCX(2)=1#                             Ditto                            SL33  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL33  80
#                                                                       SL33  81
#     TRANSFORM ATOM COORDS                                             SL33  82
#                                                                       SL33  83
ELSE IF(FL==1)#                                                         SL33  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SL33  85
writeline:(1,SL261,NSL261,3,3)#                                         SL33  86
movechar:(SL262,1,CHROT,1,36,0)#                                        SL33  87
movechar:(SL262,37,CHROT,48,20,0)#                                      SL33  88
writeline:(0,0,0,1,3)#                                                  SL33  89
#                                                                       SL33  90
FOR(J=MARK3;J<MARKT;J=J+3+STEP3)#                                       SL33  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SL33  92
DO I=1,3#                                                               SL33  93
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SL33  94
XX(I)=QX(J+I)-OR(I)#                                                    SL33  95
NXX(I)=0.0#                                                             SL33  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SL33  97
DO K=1,3; DO L=1,3; NXX(K)=NXX(K)+B(K,L)*XX(L)#                         SL33  98
movertoc:(QX(J+4),1,CHROT,2,24,0)#                                      SL33  99
ncodefld:(QX,J+1,CHROT,FMT261,3)#                                       SL33 100
ncodefld:(NXX(ISUM1),1,CHROT,FMT262(1),1)#                              SL33 101
ncodefld:(NXX(ISUM2),1,CHROT,FMT262(2),1)#                              SL33 102
ncodefld:(NXX(ISUM3),1,CHROT,FMT262(3),1)#                              SL33 103
writeline:(0,0,0,1,3)#                                                  SL33 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SL33 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SL33 106
#                                                                       SL33 107
RETURN#                                                                 SL33 108
END#                                                                    SL33 109
systemheader:(SL41)#                   Generate a new map               SL41   1
# ################################################################## #  SL41   2
#                                                                    #  SL41   3
#                               SL41                                 #  SL41   4
#                                                                    #  SL41   5
# ################################################################## #  SL41   6
SUBROUTINE SL41#                                                        SL41   7
include:(AACOMN)#                      Include aa common                SL41   8
include:(SLCOMN)#                      Include sl common                SL41   9
#                                                                       SL41  10
INTEGER I#                             First scanning order index       SL41  11
INTEGER J#                             Second scanning order index      SL41  12
INTEGER K#                             Third scanning order index       SL41  13
INTEGER L#                             Loop index                       SL41  14
INTEGER NLPS#                          Number of lines per section      SL41  15
INTEGER NPPL#                          Maximum number of points per     SL41  16
INTEGER NPTR#                          Pointer to density value on      SL41  17
INTEGER NSECTS#                        Number of sections to output     SL41  18
INTEGER QXPTR#                         Pointer to storage location      SL41  19
INTEGER WIDTH#                         Number of points per line        SL41  20
INTEGER WIDTV#                         Number of values per line        SL41  21
REAL DEN(3)#                           Density of current point         SL41  22
REAL EMAX#                             Maximum electron density on      SL41  23
REAL EMIN#                             Minimum                          SL41  24
REAL FORG(3)#                          Origin in scanning order         SL41  25
REAL GINC1(3)#                         Crystallographic increments      SL41  26
REAL GINC2(3)#                         A point in the skew plane ma     SL41  27
REAL GINC3(3)#                         Adjacent point in each of th     SL41  28
REAL LNORG(3)#                         The origin of current output     SL41  29
REAL PGORG(3)#                         The origin an output map pag     SL41  30
REAL POINTX(3)#                        Skew plane point                 SL41  31
REAL TEMP#                                                              SL41  32
REAL VALUE(3)#                         Property of current point        SL41  33
#                                                                       SL41  34
chardata:(SL041,[ LOWEST VALUE          , HIGHEST VALUE])#              SL41  35
realdata:(FMT041,[230942.,470942.])#                                    SL41  36
datastuff:#                                                             SL41  37
#                                                                       SL41  38
EMAX = voidflg:#                       Default max density              SL41  39
EMIN = ABS(voidflg:)#                  Default min density              SL41  40
movereal:(GINCS(1,1),1,GINC1,1,3,0)#   Equivalence                      SL41  41
movereal:(GINCS(1,2),1,GINC2,1,3,0)#   Ditto                            SL41  42
movereal:(GINCS(1,3),1,GINC3,1,3,0)#   Ditto                            SL41  43
MARK3 = STOP2 + 1#                     Point to start of output         SL41  44
STEP3 = NPTS(3)#                                                        SL41  45
STOP3 = MARK3 + NPTS(3)*NPTS(2)#                                        SL41  46
incrqx:(I,STOP3+1,SL4105)#             Get memory for one section       SL41  47
#                                                                       SL41  48
NPPL = NINT(prtcmax:-7.)/NCOLM#                                         SL41  49
SHEETS = (NPTS(3)-1)/NPPL + 1#                                          SL41  50
#                                                                       SL41  51
DO I=1,3; FORG(I) = FLOAT(IORGS(I))#   Coordinates origin               SL41  52
CALL pmv:(TRANS,FORG,PGORG)#           Map origin in crystal coord      SL41  53
#                                                                       SL41  54
DO I=1,3#                                                               SL41  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL41  56
PGORG(I) = PGORG(I) + SKPTS(I,1)#                                       SL41  57
LNORG(I) = PGORG(I)#                                                    SL41  58
POINTX(I) = LNORG(I)#                                                   SL41  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL41  60
IF(IPROP>1)#                           Test if properties               SL41  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL41  62
DO I=1,3#                              Get normalized transf matrix     SL41  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SL41  64
TEMP=0.#                               Clear sum                        SL41  65
DO J=1,3; TEMP=TEMP+CONT(I,J)*CONT(I,J)# Get sum                        SL41  66
TEMP=SQRT(RI(I,I)/TEMP)#               Get vector length                SL41  67
IF(TEMP < small:) iquit:(SL0105)#      Check small length               SL41  68
DO J=1,3; TRANS(J,I)=CONT(I,J)*TEMP#   Normalize and trasnpose matrix   SL41  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SL41  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL41  71
#                                                                       SL41  72
#     INITIALIZE THE PRINTING ROUTINE                                   SL41  73
#                                                                       SL41  74
IF(PRINT == yes:)  CALL SL42(0)#                                        SL41  75
NSECTS = NPTS(1)#                      Number of sections,              SL41  76
NLPS = NPTS(2)#                        Lines per section,               SL41  77
WIDTH = NPTS(3)#                       And points per line.             SL41  78
WIDTV = NPTS(3)*IPROP#                 And values per line.             SL41  79
#                                                                       SL41  80
DO I=1,NSECTS#                         Loop over the sections           SL41  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SL41  82
QXPTR = MARK3#                         Point to start of output pag     SL41  83
NPTR = QXPTR#                                                           SL41  84
DO J=1,NLPS#                           Loop over the lines              SL41  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SL41  86
DO K=1,WIDTH#                          Loop over the points per lin     SL41  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SL41  88
CALL SL43(POINTX,DEN)#                 Routine to locate interpolat     SL41  89
IF(IPROP>1)#                           Test if properties               SL41  90
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SL41  91
CALL pmv:(TRANS,DEN,VALUE)#            Transformation to plane axes     SL41  92
TEMP=SQRT(VALUE(1)*VALUE(1)+VALUE(2)*VALUE(2)+VALUE(3)*VALUE(3))#       SL41  93
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SL41  94
DO L=1,IPROP#                          Loop over components of functi   SL41  95
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SL41  96
IF(IPROP==1) VALUE(L) = DEN(L)#        Get the scaled density           SL41  97
QXPTR = QXPTR + 1#                     Increment the storage pointer    SL41  98
QX(QXPTR) = VALUE(L)#                                                   SL41  99
IF(IPROP>1) VALUE(1)=TEMP#                                              SL41 100
IF(VALUE(1)>EMAX)  EMAX=VALUE(1)#      Keep track of maximum            SL41 101
IF(VALUE(1)<EMIN)  EMIN=VALUE(1)#      And minimum.                     SL41 102
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SL41 103
#                                                                       SL41 104
DO L=1,3#                              Get the next point               SL41 105
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SL41 106
POINTX(L) = POINTX(L) + GINC3(L)#                                       SL41 107
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SL41 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SL41 109
IF(SFILE == 2)#                        If requested, put the line       SL41 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SL41 111
writepkt:(4,22,WIDTV,JPT)#                                              SL41 112
movereal:(QX,NPTR+1,QX,JPT+1,WIDTV,0)#                                  SL41 113
NPTR = QXPTR#                                                           SL41 114
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SL41 115
DO L=1,3#                              Get the next line origin         SL41 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SL41 117
LNORG(L) = LNORG(L) + GINC2(L)#                                         SL41 118
POINTX(L) = LNORG(L)#                                                   SL41 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SL41 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SL41 121
#                                                                       SL41 122
#     SECTION IS COMPLETE. PRINT, IF REQUIRED                           SL41 123
#                                                                       SL41 124
IF(PRINT == yes:)  CALL SL42(1)#                                        SL41 125
#                                                                       SL41 126
DO L=1,3#                              Get the next section origin      SL41 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SL41 128
PGORG(L) = PGORG(L) + GINC1(L)#                                         SL41 129
LNORG(L) = PGORG(L)#                                                    SL41 130
POINTX(L) = LNORG(L)#                                                   SL41 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SL41 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SL41 133
#                                                                       SL41 134
#     ALL SECTIONS COMPLETED                                            SL41 135
#                                                                       SL41 136
movechar:(SL041,1,CHROT,1,NSL041,0)#                                    SL41 137
ncodefld:(EMIN*SKAL,1,CHROT,FMT041(1),1)##                              SL41 138
ncodefld:(EMAX*SKAL,1,CHROT,FMT041(2),1)##                              SL41 139
writeline:(1,0,0,1,3)#                                                  SL41 140
#                                                                       SL41 141
readwpkt:(3,endrecord:,PSIZE,IPT,0)#                                    SL41 142
IF(SFILE == 2)  writepkt:(4,endrecord:,1,JPT)#                          SL41 143
#                                                                       SL41 144
RETURN#                                                                 SL41 145
END#                                                                    SL41 146
systemheader:(SL42)#                   Routine to print the output      SL42   1
# ################################################################## #  SL42   2
#                                                                    #  SL42   3
#                               SL42                                 #  SL42   4
#                                                                    #  SL42   5
# ################################################################## #  SL42   6
SUBROUTINE SL42(FLAG)#                                                  SL42   7
include:(AACOMN)#                      Include aa common                SL42   8
include:(SLCOMN)#                      Include sl common                SL42   9
#                                                                       SL42  10
INTEGER AXIS#                          Axis pointer                     SL42  11
INTEGER COLM#                          Pointer to next heading colu     SL42  12
INTEGER FLAG#                          If == 0, initialize routine      SL42  13
INTEGER HED#                           A column heading                 SL42  14
INTEGER I#                             Loop index                       SL42  15
INTEGER IPTS3#                         Number of points across a se     SL42  16
INTEGER J#                             Loop index down a sheet          SL42  17
INTEGER K#                             Loop index across a sheet        SL42  18
INTEGER LINE#                          Current line number              SL42  19
INTEGER NCHARS#                        Number of characters needed      SL42  20
INTEGER NP3#                           No. of pts in third sum dire     SL42  21
INTEGER NWORDS#                        Number of words to hold ncha     SL42  22
INTEGER PTR#                           Pointer to current start of      SL42  23
INTEGER QXPTR#                         Pointer to current point bei     SL42  24
INTEGER STARTL#                        Pointer to start of stored l     SL42  25
INTEGER STARTS#                        Pointer start of sheet           SL42  26
INTEGER WIDTH#                         Number of points across the      SL42  27
REAL FMT131#                           Dynamic format code              SL42  28
#                                                                       SL42  29
chardata:(COL,     )#                                                   SL42  30
chardata:(HEDNG,                                     $#                 SL42  31
                               )#                                       SL42  32
chardata:(SL131,     -------       ------- ACROSS        $#             SL42  33
------- LAYER=     )#                                                   SL42  34
chardata:(SL132,[ X(CALC) Y(CALC) Z(CALC) ])#                           SL42  35
intdata:(IPTS2,0); intdata:(DELTA,0); intdata:(SECT,0)#                 SL42  36
realdata:(STARTF,0); realdata:(INCF,0)#                                 SL42  37
realdata:(FMT132,[600413.,40313.])#                                     SL42  38
datastuff:#                                                             SL42  39
#                                                                       SL42  40
IF(FLAG == 0)#                                                          SL42  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL42  42
#                                                                       SL42  43
#     NUMBER OF POINTS NEEDED TO ACCOMODATE                             SL42  44
#     THE ENTIRE COLUMN HEADING                                         SL42  45
#                                                                       SL42  46
NCHARS = NPTS(3)*NCOLM#                                                 SL42  47
MARK4 = STOP3 + 1#                     Pointer to heading location      SL42  48
NWORDS = (NCHARS-1)/mxchwd: + 1#                                        SL42  49
NCHARS = NWORDS*mxchwd:#                                                SL42  50
incrqx:(STOP4,MARK4+NWORDS,SL4205)#    Get memory for header            SL42  51
movector:(BLANK,1,QX(MARK4+1),1,NCHARS,1)#                              SL42  52
FMT131 = FLOAT(NCOLM)*10100. + 13.#                                     SL42  53
HED = IORGS(3) - INCS(3)#                                               SL42  54
COLM = 1#                                                               SL42  55
NP3 = NPTS(3)#                                                          SL42  56
DO I=1,NP3#                            Create the column heading        SL42  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL42  58
HED = HED + INCS(3)#                                                    SL42  59
movechar:(BLANK,1,COL,1,NCOLM,1)#                                       SL42  60
ncodefld:(FLOAT(HED),1,COL,FMT131,1)#                                   SL42  61
movector:(COL,1,QX(MARK4+1),COLM,NCOLM,0)#                              SL42  62
COLM = COLM + NCOLM#                                                    SL42  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL42  64
#                                                                       SL42  65
movechar:(SL131,1,HEDNG,1,NSL131,0)#   Pick up the bare sheet headi     SL42  66
#                                                                       SL42  67
#     NOW GET THE PROPER AXIS NAMES                                     SL42  68
#                                                                       SL42  69
AXIS=(JSUM1-1)*8+2#                    Point to layer axis              SL42  70
movechar:(SL132,AXIS,HEDNG,42,7,0)#    Otherwise xyz.                   SL42  71
AXIS=(JSUM2-1)*8+2#                    Point to down axis               SL42  72
movechar:(SL132,AXIS,HEDNG,6,7,0)#                                      SL42  73
AXIS=(JSUM3-1)*8+2#                    Point to across axis             SL42  74
movechar:(SL132,AXIS,HEDNG,20,7,0)#                                     SL42  75
#                                                                       SL42  76
IPTS2 = NPTS(2)#                       Number of lines per sheet        SL42  77
DELTA = NPTS(3)#                       Number of points per section     SL42  78
STARTF = FLOAT(NCOLM)*100. + 70013.#   Initialize format                SL42  79
INCF = FLOAT(NCOLM)*10000.#            Format incrementer               SL42  80
SECT = IORGS(1) - INCS(1)#             Initialize section number        SL42  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL42  82
#                                                                       SL42  83
ELSE#                                  Process a section                SL42  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SL42  85
IPTS3 = NPTS(3)#                       Number of points per section     SL42  86
PTR = 1#                               Initialize column heading pt     SL42  87
STARTL = MARK3#                        Start of section in qx           SL42  88
STARTS = MARK3#                        Start of qx for sheet            SL42  89
SECT = SECT + INCS(1)#                 Create section number            SL42  90
#                                                                       SL42  91
#     BLANK OUT THEN ENCODE THE SECTION NUMBER                          SL42  92
#                                                                       SL42  93
movechar:(BLANK,1,HEDNG,56,4,1)#                                        SL42  94
ncodefld:(FLOAT(SECT),1,HEDNG,FMT132(1),1)#                             SL42  95
#                                                                       SL42  96
FOR(I=SHEETS; I > 0; I=I-1)#           Loop over the sheets             SL42  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SL42  98
LINE = IORGS(2) - INCS(2)#             Initialize line number           SL42  99
WIDTH = (IPTS3-1)/I + 1#               Number of points on this lin     SL42 100
LINRM=MIN0((SPACE+1)*IPTS2+4,INT(prtlmax:-4.))# Force a new sheet       SL42 101
writeline:(1,HEDNG,NSL131,3,3)#        Write first heading              SL42 102
#                                                                       SL42 103
#     NUMBER OF CHARACTERS IN THE CURRENT COLUMN HEADING                SL42 104
#                                                                       SL42 105
NCHARS = WIDTH*NCOLM#                                                   SL42 106
movertoc:(QX(MARK4+1),PTR,CHROT,8,NCHARS,0)#                            SL42 107
writeline:(1,0,0,1,3)#                 Column heading                   SL42 108
#                                                                       SL42 109
DO J=1,IPTS2#                          Loop over lines per sheet        SL42 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SL42 111
LINE = LINE + INCS(2)#                 Current line number              SL42 112
ncodefld:(FLOAT(LINE),1,CHROT,FMT132(2),1)#                             SL42 113
FMT131 = STARTF#                       Initialize format                SL42 114
QXPTR = STARTL#                        Point to 1st point on line       SL42 115
DO K=1,WIDTH#                          Loop over points                 SL42 116
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SL42 117
QXPTR = QXPTR + 1#                     Increment storage pointer        SL42 118
FMT131 = FMT131 + INCF#                And format.                      SL42 119
#                                                                       SL42 120
#     ENCODE THE VALUE UNLESS BLANKING HAS BEE REQUESTED                SL42 121
#                                                                       SL42 122
IF(QX(QXPTR) > UPLIM \ QX(QXPTR) < LOLIM)#                              SL42 123
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SL42 124
QX(QXPTR)=QX(QXPTR)*SKAL#                                               SL42 125
ncodefld:(QX,QXPTR,CHROT,FMT131,1)#                                     SL42 126
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SL42 127
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SL42 128
writeline:(SPACE,0,0,1,3)#             Write the line                   SL42 129
STARTL = STARTL + DELTA#                                                SL42 130
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SL42 131
PTR = PTR + NCHARS#                                                     SL42 132
STARTS=STARTS+WIDTH#                   First item on next sheet         SL42 133
STARTL = STARTS#                                                        SL42 134
IPTS3 = IPTS3 - WIDTH#                                                  SL42 135
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SL42 136
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SL42 137
RETURN#                                                                 SL42 138
END#                                                                    SL42 139
systemheader:(SL43)#                                                    SL43   1
#                                                                       SL43   2
# ################################################################## #  SL43   3
#                                                                    #  SL43   4
#                               SL43                                 #  SL43   5
#                                                                    #  SL43   6
# ################################################################## #  SL43   7
SUBROUTINE SL43(POINT,DN)#                                              SL43   8
include:(SLCOMN)#                                                       SL43   9
#                                                                       SL43  10
INTEGER I#                             Loop index                       SL43  11
INTEGER INTX(3,4)#                     Holds 6 or 12 coord in grid      SL43  12
INTEGER J#                             Another loop index               SL43  13
INTEGER K,L#                           Likewise                         SL43  14
INTEGER NPT#                           Counts grid points processed     SL43  15
INTEGER X#                             Temporary storage holding mi     SL43  16
REAL DELX#                             Grid distances to intx(i,1)      SL43  17
REAL DELY#                                                              SL43  18
REAL DELZ#                                                              SL43  19
REAL DEN(8,3)#                         Electron density at corner p     SL43  20
REAL DN(3)#                                                             SL43  21
REAL DX(3)#                                                             SL43  22
REAL F(4,4,4,3)#                       Density values of 64 points      SL43  23
REAL FUNC#                             Dens value of cubic spline       SL43  24
REAL P#                                                                 SL43  25
REAL POINT(3)#                         Input point in grid coordina     SL43  26
REAL PP(3,4)#                          Vectors of cubic spline eq       SL43  27
REAL Q#                                                                 SL43  28
REAL S#                                                                 SL43  29
REAL T#                                                                 SL43  30
REAL TEMPX#                            Temporarily holds coordinate     SL43  31
#                                                                       SL43  32
IF(SPL==2)#                                                             SL43  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL43  34
DO I=1,3#                                                               SL43  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL43  36
TEMPX=POINT(I)#                                                         SL43  37
X=INT(TEMPX)#                                                           SL43  38
IF(TEMPX<0.) X=X-1#                                                     SL43  39
INTX(I,1)=X-1#                                                          SL43  40
INTX(I,2)=X#                                                            SL43  41
INTX(I,3)=X+1#                                                          SL43  42
INTX(I,4)=X+2#                                                          SL43  43
DX(I)=TEMPX-FLOAT(INTX(I,2))#                                           SL43  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL43  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL43  46
ELSE#                                                                   SL43  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SL43  48
DO I=1,3#                              Get coordinates of grid box      SL43  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SL43  50
TEMPX = POINT(I)#                                                       SL43  51
X = INT(TEMPX)#                        Find next lower grid point       SL43  52
IF(TEMPX < 0.)  X = X - 1#                                              SL43  53
INTX(I,1) = X#                         Get six corners of the box       SL43  54
INTX(I,2) = X + 1#                                                      SL43  55
DX(I) = TEMPX - FLOAT(INTX(I,1))#      Find grid distances to corne     SL43  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SL43  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SL43  58
#                                                                       SL43  59
movereal:(DX(1),1,DELX,1,1,0)#         Equivalence                      SL43  60
movereal:(DX(2),1,DELY,1,1,0)#         Equivalence                      SL43  61
movereal:(DX(3),1,DELZ,1,1,0)#         Ditto                            SL43  62
#                                                                       SL43  63
#     8-POINT LINEAR INTERPOLATION                                      SL43  64
#                                                                       SL43  65
IF(SPL==1)#                                                             SL43  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SL43  67
NPT = 0#                                                                SL43  68
DO K=1,2#                                                               SL43  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SL43  70
IX(3) = INTX(3,K)#                                                      SL43  71
DO J=1,2#                                                               SL43  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SL43  73
IX(2) = INTX(2,J)#                                                      SL43  74
DO I=1,2#                                                               SL43  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SL43  76
NPT = NPT + 1#                                                          SL43  77
IX(1) = INTX(1,I)#                                                      SL43  78
CALL SL44(DN)#                                                          SL43  79
DO L=1,IPROP#                                                           SL43  80
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SL43  81
DEN(NPT,L) = DN(L)#                                                     SL43  82
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SL43  83
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SL43  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SL43  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SL43  86
#                                                                       SL43  87
DO I=1,IPROP#                                                           SL43  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SL43  89
P =  DEN(5,I) - DEN(1,I)#                                               SL43  90
Q = -DEN(6,I) + DEN(2,I)#                                               SL43  91
S = -DEN(7,I) + DEN(3,I)#                                               SL43  92
T =  DEN(1,I) - DEN(2,I)#                                               SL43  93
#                                                                       SL43  94
DN(I) = (P+Q+S+DEN(8,I)-DEN(4,I))*DELX*DELY*DELZ $#                     SL43  95
+ (T-DEN(3,I)+DEN(4,I))*DELX*DELY    $#                                 SL43  96
- (Q+P)*DELX*DELZ - (S+P)*DELY*DELZ  $##                                SL43  97
- T*DELX + (DEN(3,I)-DEN(1,I))*DELY + P*DELZ + DEN(1,I)#                SL43  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SL43  99
#                                                                       SL43 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SL43 101
#                                                                       SL43 102
#     64-POINT CUBIC INTERPOLATION                                      SL43 103
#                                                                       SL43 104
ELSE IF(SPL==2)#                                                        SL43 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SL43 106
DO I=1,3#                                                               SL43 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SL43 108
PP(I,1)=(-(DX(I))**3)/6. + ((DX(I))**2)/2. - (DX(I))/3.#                SL43 109
PP(I,2)=((DX(I))**3)/2. - (DX(I))**2 - (DX(I))/2. + 1.#                 SL43 110
PP(I,3)=(-(DX(I))**3)/2. + ((DX(I))**2)/2. + DX(I)#                     SL43 111
PP(I,4)=((DX(I))**3)/6. - (DX(I))/6.#                                   SL43 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SL43 113
DO K=1,4#                                                               SL43 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SL43 115
IX(3)=INTX(3,K)#                                                        SL43 116
DO J=1,4#                                                               SL43 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SL43 118
IX(2)=INTX(2,J)#                                                        SL43 119
DO I=1,4#                                                               SL43 120
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SL43 121
IX(1)=INTX(1,I)#                                                        SL43 122
CALL SL44(DN)#                                                          SL43 123
DO L=1,IPROP#                                                           SL43 124
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SL43 125
F(I,J,K,L)=DN(L)#                                                       SL43 126
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SL43 127
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SL43 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SL43 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SL43 130
DO L=1,IPROP#                                                           SL43 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SL43 132
FUNC=0.#                                                                SL43 133
DO K=1,4#                                                               SL43 134
DO J=1,4#                                                               SL43 135
DO I=1,4#                                                               SL43 136
FUNC=FUNC+F(I,J,K,L)*PP(1,I)*PP(2,J)*PP(3,K)#                           SL43 137
DN(L)=FUNC#                                                             SL43 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SL43 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SL43 140
RETURN#                                                                 SL43 141
END#                                                                    SL43 142
systemheader:(SL44)#                                                    SL44   1
# ################################################################## #  SL44   2
#                               SL44                                 #  SL44   3
#                                                                    #  SL44   4
# ################################################################## #  SL44   5
SUBROUTINE SL44(DEN)#                                                   SL44   6
include:(AACOMN)#                                                       SL44   7
include:(SLCOMN)#                                                       SL44   8
#                                                                       SL44   9
INTEGER DENPTR#                        Pointer to current density i     SL44  10
INTEGER GRID#                          Grid size                        SL44  11
INTEGER SL31#                          Point found=yes:, else=no:       SL44  12
INTEGER TEST#                          Unit translated point            SL44  13
INTEGER I,J,L,LL#                      Indices                          SL44  14
REAL FX(3)#                                                             SL44  15
REAL FGX(3)#                                                            SL44  16
REAL DEN(3)#                                                            SL44  17
REAL DENX(3)#                                                           SL44  18
#                                                                       SL44  19
DO I=1,3#                                                               SL44  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SL44  21
FX(I)=FLOAT(IX(I))#                    Float grid co-ord                SL44  22
FGX(I)=FLOAT(NGX(I))#                  Float number of grids            SL44  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SL44  24
FOR(J=MARKS;J<MARK2;J=J+STEPS)#        Loop over symops                 SL44  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SL44  26
NEWX(1)=INT(QX(J+1)*FX(1)+QX(J+4)*FX(2)+QX(J+7)*FX(3)+QX(J+10)*FGX(1))# SL44  27
NEWX(2)=INT(QX(J+2)*FX(1)+QX(J+5)*FX(2)+QX(J+8)*FX(3)+QX(J+11)*FGX(2))# SL44  28
NEWX(3)=INT(QX(J+3)*FX(1)+QX(J+6)*FX(2)+QX(J+9)*FX(3)+QX(J+12)*FGX(3))# SL44  29
SL31 = yes:#                           Presume it will be found         SL44  30
#                                                                       SL44  31
DO I=1,3#                              Loop over x, y, and z            SL44  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SL44  33
TEST = NEWX(I)#                        Save point                       SL44  34
GRID = NGX(I)#                         Pick up grid                     SL44  35
#                                                                       SL44  36
#     TRY TO SHIFT THE POINT INTO THE MAP VOLUME STORED                 SL44  37
#                                                                       SL44  38
FOR( ; TEST < MAPORG(I); TEST=TEST+GRID)#                               SL44  39
;#                                                                      SL44  40
FOR( ; TEST > MAPEND(I); TEST=TEST-GRID)#                               SL44  41
;#                                                                      SL44  42
IF(TEST < MAPORG(I))#                  If it can't be found,            SL44  43
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SL44  44
SL31 = no:#                                                             SL44  45
BREAK#                                                                  SL44  46
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SL44  47
NEWX(I) = TEST#                        Re-set the coordinate            SL44  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SL44  49
IF(SL31==yes:) BREAK#                  Point found                      SL44  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SL44  51
IF(SL31==no:) iquit:(SL4405)#          Point not there                  SL44  52
DENPTR = MARK2 + (NEWX(1)-MAPORG(1)) $##                                SL44  53
+ (NEWX(2)-MAPORG(2))*DELTAY $#                                         SL44  54
+ (NEWX(3)-MAPORG(3))*DELTAZ + 1#                                       SL44  55
#                                                                       SL44  56
DO L=1,IPROP#                          Loop over property components    SL44  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SL44  58
LL=(L-1)*NPTOT#                                                         SL44  59
DEN(L) = QX(DENPTR+LL)#                                                 SL44  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SL44  61
#                                                                       SL44  62
IF(IPROP>1)#                           Inverse symmerty transformatio   SL44  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SL44  64
DENX(1)=QX(J+1)*DEN(1)+QX(J+2)*DEN(2)+QX(J+3)*DEN(3)#                   SL44  65
DENX(2)=QX(J+4)*DEN(1)+QX(J+5)*DEN(2)+QX(J+6)*DEN(3)#                   SL44  66
DENX(3)=QX(J+7)*DEN(1)+QX(J+8)*DEN(2)+QX(J+9)*DEN(3)#                   SL44  67
DO I=1,3; DEN(I)=DENX(I)#              Store components after trans     SL44  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SL44  69
#                                                                       SL44  70
RETURN#                                                                 SL44  71
END#                                                                    SL44  72
pmacro:([no:])#                                                         SL44  73
