systemheader:(SPMA,*)#                                                  SPMA   1
####################################################################### SPMA   2
##      Copyright (C) 2000, The Xtal System, The University of        # SPMA   3
##            Western Australia, xtal@crystal.uwa.edu.au.             # SPMA   4
## Distributed under the GNU General Public Licence as published by   # SPMA   5
## the Free Software Foundation, in the hope that it will be useful   # SPMA   6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # SPMA   7
## for more details.                                                  # SPMA   8
#                                                                     # SPMA   9
#                            *** SHAPE  ***                           # SPMA  10
#                                                                     # SPMA  11
####################################################################### SPMA  12
## Michael A. Estermann, ETH Zuerich, Switzerland, XTAL3.4 Version      SPMA  13
#                                                                       SPMA  14
# ORGANIZATION OF QX ARRAY                                              SPMA  15
# ========================                                              SPMA  16
#                                                                       SPMA  17
# QX(M0+1), ..., QX(M2) SYMM.MATRICES: SPACE GROUP, PATTERSON, HARKER   SPMA  18
# QX(M2+1), ..., QX(M3) HISTOGRAM                                       SPMA  19
# QX(M3+1), ..., QX(M4) SUM HISTOGRAM                                   SPMA  20
# QX(M4+1), ..., QX(M5) ELECTRON OR PATTERSON DENS. IF NECESSARY        SPMA  21
# QX(M5+1), ..., QX(M6) CROSS VECTOR TABLE                              SPMA  22
#                                                                       SPMA  23
# MACRO DEFINITIONS                                                     SPMA  24
# -----------------                                                     SPMA  25
#                                                                       SPMA  26
include:(XMACRO)#        ## Read XTAL macros from file XMACRO           SPMA  27
#                                                                       SPMA  28
macro:(author:,' Michael A. Estermann / ETH / Zurich / Switzerland')#   SPMA  29
#                                                                       SPMA  30
macro:(ib:,NINT(BUFIN($1)))#                                            SPMA  31
macro:(bf:,BUFIN($1))#                                                  SPMA  32
#                                                                       SPMA  33
macro:(hist:,QX(M2+$1))#                                                SPMA  34
macro:(shist:,QX(M3+$1))#                                               SPMA  35
macro:(density:,QX(M4+$1))#                                             SPMA  36
macro:(patterson:,QX(M4+$1))#                                           SPMA  37
#                                                                       SPMA  38
# COMMON BLOCKS                                                         SPMA  39
# -------------                                                         SPMA  40
#                                                                       SPMA  41
systemheader:(SPCM,*)#                                                  SPCM   1
extrude:(SPCOMN)#                                                       SPCM   2
#                                                                       SPCM   3
# QX STARTS AND ENDS                                                    SPCM   4
#                                                                       SPCM   5
INTEGER M0#          ## start-1 of symmetry matrices, primitive         SPCM   6
INTEGER STEPS#       ## increment to M0                                 SPCM   7
INTEGER M1#          ## start-1 of symmetry matrices, centered          SPCM   8
INTEGER M1A#         ## start-1 of symmetry matrices, centered          SPCM   9
INTEGER M1B#         ## start-1 of symmetry matrices, centered          SPCM  10
INTEGER M1C#         ## start-1 of symmetry matrices, centered          SPCM  11
INTEGER M1D#         ## start-1 of symmetry matrices, centered          SPCM  12
INTEGER M1E#         ## start-1 of symmetry matrices, centered          SPCM  13
INTEGER M2#          ## start-1 of histogram table                      SPCM  14
INTEGER M3#          ## start-1 of sum histogram table                  SPCM  15
INTEGER M4#          ## start-1 of el. dens. map                        SPCM  16
INTEGER M5#          ## end of QX array                                 SPCM  17
#                                                                       SPCM  18
# MAP PARAMETERS AND LAYOUT LR21                                        SPCM  19
#                                                                       SPCM  20
INTEGER IN(3)#       ## Grid point increment on input map               SPCM  21
INTEGER ISUM(3)#     ## Summation order correlation between             SPCM  22
INTEGER JSUM(3)#     ## Crystal axes and map axes                       SPCM  23
INTEGER NG(3)#       ## Number of grid points in map                    SPCM  24
INTEGER NP(3)#       ## Actual number of points in map                  SPCM  25
INTEGER OR(3)#       ## Origins in grid points                          SPCM  26
INTEGER ILAY,NLAY,MLAY#                                                 SPCM  27
INTEGER ILIN,NLIN,MLIN#                                                 SPCM  28
INTEGER IPNT,NPNT,MPNT#                                                 SPCM  29
REAL    MAPTYP#                                                         SPCM  30
REAL    XMINMAP,XMAXMAP,YMINMAP,YMAXMAP,ZMINMAP,ZMAXMAP#                SPCM  31
#                                                                       SPCM  32
# PARAMETERS SHAPE  LINE                                                SPCM  33
#                                                                       SPCM  34
INTEGER NORM#        ## yes:/no: normalize density                      SPCM  35
INTEGER SQUAR#       ## yes:/no: squaring                               SPCM  36
INTEGER EXPON#       ## yes:/no: exponentiation                         SPCM  37
INTEGER INACV#       ## yes:/no: inacccessable volumes                  SPCM  38
INTEGER CHEMX#       ## 0/1 (not access/access) volumes to chemx        SPCM  39
INTEGER MAXDE#       ## Indicates the use of 1/max(density) as beta     SPCM  40
INTEGER NSLOTS#      ## Number of slots for histogramm                  SPCM  41
INTEGER IHIST#       ## Do histogramm                                   SPCM  42
INTEGER BIOSYM#      ## yes:/no: write electron density for BIOSYM      SPCM  43
INTEGER ISHAPE#      ##                                                 SPCM  44
INTEGER ISMF#        ## symmetry minimum function                       SPCM  45
INTEGER ISMFW#       ## use weight for symmetry minimum function        SPCM  46
INTEGER IIMF#        ## seek images of vertices with minimum function   SPCM  47
INTEGER INEGMAP#     ## use inverted map (-density) for IMF             SPCM  48
INTEGER ICVS#        ## second-order symmetry minimum function          SPCM  49
INTEGER NTRIAL#      ## number of trial atomic positions                SPCM  50
INTEGER IDUMLAY#     ## dump layer to file                              SPCM  51
INTEGER LAYNUM#      ## layer number                                    SPCM  52
INTEGER IRDMAP#      ## read map from external file in wifd format      SPCM  53
INTEGER IADDCON#     ## add constant value to map                       SPCM  54
INTEGER IMULDEN#     ## multiply electron density with factor           SPCM  55
CHARACTER*6 CTRIAL(1000)# ## atom name                                  SPCM  56
REAL    TRIAL(1000,5)# ## trial atomic positions                        SPCM  57
REAL    ALPHA#       ## Lagrange Multiplayer in exp function            SPCM  58
REAL    BETA#        ## Lagrange Multiplayer in exp function            SPCM  59
REAL    RBETA#       ## Lagrange Multiplayer in exp function            SPCM  60
REAL    MINBOND#     ## minimal bond length                             SPCM  61
REAL    DELTA#       ## tolerance for equal test                        SPCM  62
REAL    F000#        ## (0,0,0) fourier coefficient                     SPCM  63
REAL    ADDCON#      ## value added to map                              SPCM  64
REAL    LAYTOL#      ## number of layer of within atoms are printed     SPCM  65
REAL    MULDEN#      ## factor to multiply el. dens with                SPCM  66
#                                                                       SPCM  67
COMMON/COMFSP/$#                       Common float                     SPCM  68
ALPHA  ,BETA   ,RBETA  ,MINBOND,DELTA  ,F000   ,TRIAL  ,ADDCON ,#       SPCM  69
LAYTOL ,MULDEN#                                                         SPCM  70
COMMON/COMISP/$#                       Common integer                   SPCM  71
SQUAR  ,EXPON  ,MAXDE  ,IHIST  ,NSLOTS ,M0     ,M1     ,M1A    ,#       SPCM  72
M1B    ,M1C    ,M1D    ,M1E    ,M2     ,M3     ,M4     ,M5     ,#       SPCM  73
INACV  ,STEPS  ,CHEMX  ,NORM   ,BIOSYM ,NTRIAL ,IIMF   ,ISMF   ,#       SPCM  74
IDUMLAY,LAYNUM ,ISHAPE ,ICVS   ,ISMFW  ,IRDMAP ,INEGMAP,IADDCON,#       SPCM  75
IMULDEN#                                                                SPCM  76
COMMON/COMCSP/$#                       Common character                 SPCM  77
CTRIAL#                                                                 SPCM  78
COMMON/COMMSP/$#                       Common map parameters            SPCM  79
IN     ,ISUM   ,JSUM   ,NG     ,NP     ,OR     ,ILAY   ,NLAY   ,#       SPCM  80
MLAY   ,ILIN   ,NLIN   ,MLIN   ,IPNT   ,NPNT   ,MPNT   ,MAPTYP ,#       SPCM  81
XMINMAP,XMAXMAP,YMINMAP,YMAXMAP,ZMINMAP,ZMAXMAP#                        SPCM  82
endext:#                                                                SPCM  83
#                                                                       SPCM  84
systemheader:(SP00)#                                                    SP00   1
######################################################################  SP00   2
#                                                                    #  SP00   3
#                               SP00                                 #  SP00   4
#                                                                    #  SP00   5
######################################################################  SP00   6
SUBROUTINE SP00#                                                        SP00   7
include:(AACOMN)#                                                       SP00   8
include:(SPCOMN)#                                                       SP00   9
#                                                                       SP00  10
CHROT(1^)=author: ; writeline:(1,0,0,1,3)#                              SP00  11
#                                                                       SP00  12
CALL SP10#                             Read line input                  SP00  13
#                                                                       SP00  14
IF(ISHAPE==yes:)  CALL SP20#           Shape el.density                 SP00  15
IF(ISMF==yes: \ $#                                                      SP00  16
   IIMF==yes: \ $#                                                      SP00  17
   ICVS==yes:)    CALL SP30#           Seek image in patterson          SP00  18
IF(IDUMLAY==1 \ $#                                                      SP00  19
   IDUMLAY==2)    CALL SP50#           Dump layer to ascii file         SP00  20
IF(IRDMAP==yes:)  CALL SP60#           Read external map                SP00  21
#                                                                       SP00  22
RETURN#                                                                 SP00  23
END#                                                                    SP00  24
systemheader:(SP10)#                   Read  line input                 SP10   1
######################################################################  SP10   2
#                                                                    #  SP10   3
#                               SP10                                 #  SP10   4
#                                                                    #  SP10   5
######################################################################  SP10   6
SUBROUTINE SP10#                                                        SP10   7
include:(AACOMN)#                                                       SP10   8
include:(SPCOMN)#                                                       SP10   9
#                                                                       SP10  10
INTEGER I,J,K#                         Local counter                    SP10  11
REAL    X,Y,Z#                                                          SP10  12
REAL    FMT#                                                            SP10  13
chardata:(SPIA, END EXPON  SQUAR  HISTO  INACV  NORM   CHEMX   $#       SP10  14
BIOSYM SMF IMF DUMLAY CVS RDMAP ADDCON MULDEN )#                        SP10  15
chardata:(SPIB,PR)#                                                     SP10  16
#                                                                       SP10  17
chardata:(SP10C,[$#                                                     SP10  18
RHO(NEW) = EXP( BETA * { RHO(OLD)+ALPHA } )])# <<<1                <<<1 SP10  19
chardata:(SP10D,[$#                                                     SP10  20
               ALPHA                BETA              1/BETA])#         SP10  21
chardata:(SP10E,[$#                                                     SP10  22
RHO(NEW)=RHO(OLD)**2                       ])#                          SP10  23
chardata:(SP10F,[$#                                                     SP10  24
RHO(NEW)=0/1 (VOLUME NOT ACCESSIBLE/ACCESSIBLE)        ])#              SP10  25
chardata:(SP10G,[$#                                                     SP10  26
WRITE POSITIONS OF PIXELS(=0) TO CHEMX SURFACE FILE     ])#             SP10  27
chardata:(SP10H,[$#                                                     SP10  28
WRITE POSITIONS OF PIXELS(!=0) TO CHEMX SURFACE FILE     ])#            SP10  29
chardata:(SP10I,[$#                                                     SP10  30
NORMALIZE THE SUM OF ALL PIXELS : (0,0,0) FOURIER COEFF])#              SP10  31
chardata:(SP10K,[$#                                                     SP10  32
WRITE =MAP OF DENSITY= IN CHEMX FORMAT TO FILE CHEMXMAP.DAT])#          SP10  33
chardata:(SP10L,[$#                                                     SP10  34
WRITE =SLANT OF DENSITY= IN CHEMX FORMAT TO FILE CHEMXMAP.DAT])#        SP10  35
chardata:(SP10M,[$#                                                     SP10  36
WRITE DENSITY FILE *BIOSYM.GRD* FOR BIOSYM CONTOUR UTILITY])#           SP10  37
#                                                                       SP10  38
datastuff:#                                                             SP10  39
#                                                                       SP10  40
#  SET DEFAULT PARAMETERS                                               SP10  41
#  ----------------------                                               SP10  42
#                                                                       SP10  43
SQUAR = no:#                                                            SP10  44
EXPON = no: ; ALPHA=0.0; BETA=1.0/10000.; RBETA=1/BETA; MAXDE=no:#      SP10  45
IHIST = no: ; NSLOTS=100#                                               SP10  46
INACV = no: ; MINBOND=1.6;  DELTA=0.1#                                  SP10  47
BIOSYM= no:#                                                            SP10  48
CHEMX = 0#                                                              SP10  49
NORM  = no: ; F000=1.0#                                                 SP10  50
ISMF  = no: ; ISMFW=yes: ; IIMF=no:; NTRIAL=0; ICVS=no:#                SP10  51
IDUMLAY=no: ; LAYNUM=0   ; LAYTOL=0.5#                                  SP10  52
ISHAPE=no:#                                                             SP10  53
IRDMAP=no:#                                                             SP10  54
INEGMAP=no:#                                                            SP10  55
IADDCON=no: ; ADDCON=0.0#                                               SP10  56
IMULDEN=no: ; MULDEN=1.0#                                               SP10  57
#                                                                       SP10  58
# EXTRACT OPTIONS FROM SHAPE LINE                                       SP10  59
# -------------------------------                                       SP10  60
#                                                                       SP10  61
FOR(K=2;K<mxfdim:;K=K+1)#              Loop over input fields           SP10  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP10  63
ifvo:(BUFIN(K)) BREAK#                 Go to first non-alpha field      SP10  64
stringlim:(K,I,J)#                     Find characters in input         SP10  65
compchar:(CHRIN,I,SPIB,1,2,3,NSPIB,J)# Search list of options           SP10  66
IF(J==0) BREAK#                        It must be valid                 SP10  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP10  68
#                                                                       SP10  69
# TAKE IN ANY OTHER INPUT LINES                                         SP10  70
# -----------------------------                                         SP10  71
#                                                                       SP10  72
REPEAT#                                Loop over lines                  SP10  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP10  74
readline:(SPIA,NSPIA)#                 Enter next input line            SP10  75
IF(LINID==1) BREAK#                    ****** end   *****************   SP10  76
IF(LINID==2)#                          ****** expon *****************   SP10  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SP10  78
ISHAPE=yes:#                                                            SP10  79
EXPON=yes:#                                                             SP10  80
ifnv:(BUFIN(1)) RBETA = BUFIN(1)#                                       SP10  81
ifnv:(BUFIN(1)) BETA  = 1/BUFIN(1)#                                     SP10  82
ifnv:(BUFIN(2)) BETA  = BUFIN(2)#                                       SP10  83
ifnv:(BUFIN(2)) RBETA = 1/BUFIN(2)#                                     SP10  84
ifnv:(BUFIN(3)) ALPHA = BUFIN(3)#                                       SP10  85
ifnv:(BUFIN(4)) MAXDE = yes:#                                           SP10  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SP10  87
IF(LINID==3)#                          ****** squar *****************   SP10  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SP10  89
ISHAPE=yes:#                                                            SP10  90
SQUAR=yes:#                                                             SP10  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SP10  92
IF(LINID==4)#                          ****** histo *****************   SP10  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SP10  94
ISHAPE=yes:#                                                            SP10  95
IHIST=yes:#                                                             SP10  96
ifnv:(BUFIN(1)) NSLOTS=NINT(BUFIN(1))#                                  SP10  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SP10  98
IF(LINID==5)#                          ****** inacv *****************   SP10  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SP10 100
ISHAPE=yes:#                                                            SP10 101
INACV=yes:#                                                             SP10 102
ifnv:(BUFIN(1)) MINBOND=BUFIN(1)#                                       SP10 103
ifnv:(BUFIN(2)) DELTA=BUFIN(2)#                                         SP10 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SP10 105
IF(LINID==6)#                          ****** norm  *****************   SP10 106
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SP10 107
ISHAPE=yes:#                                                            SP10 108
NORM=yes:#                                                              SP10 109
ifnv:(BUFIN(1)) F000=BUFIN(1)#                                          SP10 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SP10 111
IF(LINID==7)#                          ****** chemx *****************   SP10 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SP10 113
ISHAPE=yes:#                                                            SP10 114
IF(bf:(1)<voidflg:)#                                                    SP10 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SP10 116
CHEMX=3#                                                                SP10 117
stringlim:(1,I,J,); J=J-1#                                              SP10 118
IF(CHRIN(I^J)=='NOTACC') CHEMX=1#      Not accesible volumes to chemx   SP10 119
IF(CHRIN(I^J)=='ACC')    CHEMX=2#      Accesible volumes to chemx       SP10 120
IF(CHRIN(I^J)=='MAP')    CHEMX=3#      Density map to chemx file        SP10 121
IF(CHRIN(I^J)=='SLA')    CHEMX=4#      Density sla to chemx file        SP10 122
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SP10 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SP10 124
IF(LINID==8)#                          ****** biosym ****************   SP10 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SP10 126
ISHAPE=yes:#                                                            SP10 127
BIOSYM=yes:#                                                            SP10 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SP10 129
IF(LINID==9)#                                                           SP10 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SP10 131
ISMF=yes:#                             ****** smf    ****************   SP10 132
ifnv:(BUFIN(1)) ISMFW=no:#                                              SP10 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SP10 134
IF(LINID==10)#                         ****** iimf   ****************   SP10 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SP10 136
IIMF=yes:#                                                              SP10 137
NTRIAL=NTRIAL+1#                                                        SP10 138
TRIAL(NTRIAL,1)=BUFIN(1)#                                               SP10 139
TRIAL(NTRIAL,2)=BUFIN(2)#                                               SP10 140
TRIAL(NTRIAL,3)=BUFIN(3)#                                               SP10 141
TRIAL(NTRIAL,4)=1.0;ifnv:(BUFIN(4))TRIAL(NTRIAL,4)=BUFIN(4)#            SP10 142
TRIAL(NTRIAL,5)=FLOAT(NTRIAL)#                                          SP10 143
IF(bf:(5)<voidflg:)#                                                    SP10 144
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SP10 145
stringlim:(5,I,J,); J=J-1#                                              SP10 146
IF(CHRIN(I^J)=='NEGMAP') INEGMAP=yes:#                                  SP10 147
IF(INEGMAP==yes:)WRITE(6,*)' *** NEGMAP ***'#                           SP10 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SP10 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SP10 150
IF(LINID==11)#                         ****** dumlay  ***************   SP10 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SP10 152
IDUMLAY=1#                                                              SP10 153
ifnv:(BUFIN(1)) LAYNUM=NINT(BUFIN(1))#                                  SP10 154
IF(bf:(2)<voidflg:)#                                                    SP10 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SP10 156
stringlim:(2,I,J,); J=J-1#                                              SP10 157
IF(CHRIN(I^J)=='MAP')IDUMLAY=1#                                         SP10 158
IF(CHRIN(I^J)=='SLA')IDUMLAY=2#                                         SP10 159
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SP10 160
ifnv:(BUFIN(3)) LAYTOL=BUFIN(3)#                                        SP10 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SP10 162
IF(LINID==12)#                         ****** cvs     ***************   SP10 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SP10 164
ICVS=yes:#                                                              SP10 165
NTRIAL=NTRIAL+1#                                                        SP10 166
stringlim:(1,I,J,); J=J-1#             Buffer 1, atom name              SP10 167
CTRIAL(NTRIAL)=CHRIN(I^J)#                                              SP10 168
TRIAL(NTRIAL,1)=BUFIN(2)#              Buffer 2, x                      SP10 169
TRIAL(NTRIAL,2)=BUFIN(3)#              Buffer 3, y                      SP10 170
TRIAL(NTRIAL,3)=BUFIN(4)#              Buffer 4, z                      SP10 171
TRIAL(NTRIAL,4)=0.0#                                                    SP10 172
TRIAL(NTRIAL,5)=FLOAT(NTRIAL)#                                          SP10 173
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SP10 174
IF(LINID==13)IRDMAP=yes:#              ****** rdmap   ***************   SP10 175
IF(LINID==14)#                         ****** addcon  ***************   SP10 176
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SP10 177
ISHAPE=yes:#                                                            SP10 178
IADDCON=yes:#                                                           SP10 179
ifnv:(BUFIN(1)) ADDCON=BUFIN(1)#                                        SP10 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SP10 181
IF(LINID==15)#                         ****** mulden  ***************   SP10 182
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SP10 183
IMULDEN=yes:#                                                           SP10 184
ifnv:(BUFIN(1)) MULDEN=BUFIN(1)#                                        SP10 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SP10 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP10 187
#                                                                       SP10 188
# REPORT INPUT PARAMETERS                                               SP10 189
# -----------------------                                               SP10 190
#                                                                       SP10 191
IF(EXPON==yes:)#                                                        SP10 192
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SP10 193
writeline:(1,SP10C,NSP10C,3,3)#                                         SP10 194
FMT=201571. ;ncodefld:(ALPHA,1,CHROT,FMT,1)#                            SP10 195
IF(MAXDE==no:)#                        Normal input                     SP10 196
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SP10 197
FMT=401571. ;ncodefld:(BETA ,1,CHROT,FMT,1)#                            SP10 198
FMT=601571. ;ncodefld:(RBETA,1,CHROT,FMT,1)#                            SP10 199
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SP10 200
IF(MAXDE==yes:)#                       Use rhomax as 1/beta             SP10 201
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SP10 202
CHROT(33^40)='1/RHOMAX'#                                                SP10 203
CHROT(55^60)='RHOMAX'#                                                  SP10 204
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SP10 205
writeline:(1,SP10D,NSP10D,2,3)#                                         SP10 206
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SP10 207
IF(IADDCON==yes:)#                     Add constant to map              SP10 208
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SP10 209
CHROT(1^28)=' Add constant value to map :'#                             SP10 210
FMT=501571. ;ncodefld:(ADDCON,1,CHROT,FMT,1)#                           SP10 211
writeline:(1,0,0,1,3)#                                                  SP10 212
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SP10 213
IF(IMULDEN==yes:)#                     Add constant to map              SP10 214
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SP10 215
CHROT(1^28)=' Multiply map with constant:'#                             SP10 216
FMT=501571. ;ncodefld:(MULDEN,1,CHROT,FMT,1)#                           SP10 217
writeline:(1,0,0,1,3)#                                                  SP10 218
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SP10 219
#                                                                       SP10 220
IF(INACV==yes:) writeline:(1,SP10F,NSP10F,3,3)#                         SP10 221
IF(CHEMX==1)    writeline:(1,SP10G,NSP10G,3,3)#                         SP10 222
IF(CHEMX==2)    writeline:(1,SP10H,NSP10H,3,3)#                         SP10 223
IF(CHEMX==3)    writeline:(1,SP10K,NSP10K,3,3)#                         SP10 224
IF(CHEMX==4)    writeline:(1,SP10L,NSP10L,3,3)#                         SP10 225
IF(NORM==yes:)  writeline:(1,SP10I,NSP10I,3,3)#                         SP10 226
IF(BIOSYM==yes:)writeline:(1,SP10M,NSP10M,3,3)#                         SP10 227
#                                                                       SP10 228
IF(SQUAR+EXPON+INACV+NORM>1) iquit:(SP1001)# Only one option            SP10 229
IF(CHEMX!=0 & BIOSYM!=0)     iquit:(SP1002)# Only one option            SP10 230
#                                                                       SP10 231
RETURN#                                                                 SP10 232
END#                                                                    SP10 233
systemheader:(SP20)#                   Shape density                    SP20   1
######################################################################  SP20   2
#                                                                    #  SP20   3
#                               SP20                                 #  SP20   4
#                                                                    #  SP20   5
######################################################################  SP20   6
SUBROUTINE SP20#                                                        SP20   7
#                                                                       SP20   8
include:(AACOMN)#                                                       SP20   9
include:(SPCOMN)#                                                       SP20  10
#                                                                       SP20  11
# LRCELL: RECORD                                                        SP20  12
#                                                                       SP20  13
REAL    DIRCEL(6)#        ## direct cell                                SP20  14
REAL    G1#               ## metric tensor                              SP20  15
REAL    G2#               ## metric tensor                              SP20  16
REAL    G3#               ## metric tensor                              SP20  17
REAL    G5#               ## metric tensor                              SP20  18
REAL    G6#               ## metric tensor                              SP20  19
REAL    G9#               ## metric tensor                              SP20  20
REAL    VOL,SCALE#                                                      SP20  21
#                                                                       SP20  22
# LRSYMM: RECORD                                                        SP20  23
#                                                                       SP20  24
INTEGER ICNT#             ## Centricity ac=0  c=1                       SP20  25
INTEGER LTYP#             ## Lattice code                               SP20  26
INTEGER NSYM#             ## Total symmetry matrices                    SP20  27
INTEGER NROT#             ## Limit of rotation matrices                 SP20  28
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              SP20  29
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              SP20  30
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              SP20  31
realdata:(TR21,[.3333333,.5])#                                          SP20  32
realdata:(TR22,[.6666667,0.])#                                          SP20  33
realdata:(TR23,[.6666667,.5])#                                          SP20  34
#                                                                       SP20  35
# LR21                                                                  SP20  36
#                                                                       SP20  37
REAL    ZADIV#       ## angstroem/div in z-direction                    SP20  38
REAL    YADIV#       ## angstroem/div in y-direction                    SP20  39
REAL    XADIV#       ## angstroem/div in x-direction                    SP20  40
#                                                                       SP20  41
chardata:(SP20D,XYZ)#                                                   SP20  42
chardata:(SP20E, MAP TRANSFORMATION    X FIRST Y SEC Z THIRD )#         SP20  43
#                                                                       SP20  44
INTEGER LAY,LIN,PNT#                                                    SP20  45
INTEGER LT#                                                             SP20  46
REAL    X,Y,Z,XX,YY,ZZ,XS,YS,ZS,U,V,W,DX,DY,DZ#                         SP20  47
REAL    ALAY,ALIN,APNT#                                                 SP20  48
REAL    A,B,C,D,AA,DD,FMT#                                              SP20  49
REAL    P(3)#                                                           SP20  50
#                                                                       SP20  51
INTEGER IWNT(24)#                      Wanted items for indexpkt:       SP20  52
INTEGER IREL(25)#                      Pointers for qx                  SP20  53
INTEGER KEY(4)#                        Flag for indexpkt:               SP20  54
INTEGER I,II,IIP,IPIX,JJP,IS,K,J,IZ,IY,ISTA,IEND,NCOLS,IPOS#            SP20  55
INTEGER IP,JP,PSIZ#                                                     SP20  56
#                                                                       SP20  57
REAL    OLDMIN,OLDMAX,OLDENT,OLDSUM,OLDRHO#                             SP20  58
REAL    NEWMIN,NEWMAX,NEWENT,NEWSUM,NEWRHO#                             SP20  59
INTEGER SLOT#                                                           SP20  60
REAL    MXHIS,MNHIS,MXSHIS,MNSHIS#                                      SP20  61
INTEGER LINE,PRLIN,NLINES#                                              SP20  62
#                                                                       SP20  63
chardata:(SP20A,[$#                                                     SP20  64
    MIN DENSITY         MAX DENSITY         SUM DENSITY      ])#        SP20  65
#                                                                       SP20  66
REAL*4 XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX#                                   SP20  67
#                                                                       SP20  68
datastuff:#                                                             SP20  69
#                                                                       SP20  70
# ASSIGN MEMORY FOR FILE BUFFERS                                        SP20  71
# ------------------------------                                        SP20  72
#                                                                       SP20  73
FILEXT(IOUNIT(3))='MAP'#               Input density map                SP20  74
IF(CHEMX==4)FILEXT(IOUNIT(3))='SLA'#   Input slant of density           SP20  75
FILEXT(IOUNIT(4))='SHA'#               Output density map               SP20  76
#                                                                       SP20  77
IOMARK(1) = QXSTR#                     Start i/o buffer file a          SP20  78
IOMARK(3) = IOMARK(1)+bdfbuf:#         Start i/o buffer file c          SP20  79
IOMARK(4) = IOMARK(3)+bdfbuf:#         Start i/o buffer file d          SP20  80
M0        = IOMARK(4)+bdfbuf:#         Start-1 of symop table           SP20  81
incrqx:(M1,M0,SP2001)#                 Expand qx                        SP20  82
#                                                                       SP20  83
# LRCELL: METRIC TENSOR                                                 SP20  84
# ---------------------                                                 SP20  85
#                                                                       SP20  86
K=0#                                   Prepare to get needed cell i     SP20  87
REPEAT#                                Loop over lrcell packets         SP20  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP20  89
K=K+1#                                 Count packets as they come i     SP20  90
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read in cell record              SP20  91
IF(IP<=0) BREAK#                       Exit after last record           SP20  92
IF(K==1)#                              Direct cell                      SP20  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP20  94
DIRCEL(1)=QX(IP+1)#                    (a)                              SP20  95
DIRCEL(2)=QX(IP+2)#                    (b)                              SP20  96
DIRCEL(3)=QX(IP+3)#                    (c)                              SP20  97
DIRCEL(4)=QX(IP+7)*360.0#              (alpha)                          SP20  98
DIRCEL(5)=QX(IP+8)*360.0#              (beta)                           SP20  99
DIRCEL(6)=QX(IP+9)*360.0#              (gamma)                          SP20 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP20 101
IF(K==6) VOL=QX(IP+1)#                 Cell volume                      SP20 102
IF(K==7)#                              Metric tensor                    SP20 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP20 104
G1=QX(IP+1)#                           (a)**2                           SP20 105
G2=QX(IP+2)#                           (a)*(b)*cos(g)                   SP20 106
G3=QX(IP+3)#                           (a)*(c)*cos(b)                   SP20 107
G5=QX(IP+5)#                           (b)**2                           SP20 108
G6=QX(IP+6)#                           (b)*(c)*cos(a)                   SP20 109
G9=QX(IP+9)#                           (c)**2                           SP20 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP20 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP20 112
#                                                                       SP20 113
# LRSYMM: CENTRICITY AND LATTICE CODE AND SYMMETRY MATR.                SP20 114
# ------------------------------------------------------                SP20 115
#                                                                       SP20 116
STEPS=14#                                                               SP20 117
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read packet                      SP20 118
IF(IP<=0) iquit:(SP2002)#              Quit if pkt not there            SP20 119
ICNT=1-NINT(QX(IP+2))#                 Centricity a=0   c=1             SP20 120
LTYP=NINT(QX(IP+1))-7*ICNT#            Lattice code, 1...7              SP20 121
NSYM=NINT(QX(IP+3))#                   Total symmetry matrices          SP20 122
NROT=NINT(QX(IP+4))#                   Limit of rotation matrices       SP20 123
#                                                                       SP20 124
# GET SYMMETRY EQUIVALENT POSITIONS                                     SP20 125
#                                                                       SP20 126
incrqx:(M2,M0+NSYM*STEPS,SP2001)#      Request memory all symops        SP20 127
DO I=M0+1,M2; QX(I)=0.0#               Clear out symops data            SP20 128
M1=M0+NROT*STEPS#                      Limit of rotation matrices       SP20 129
FOR(II=M0;II<M1;II=II+STEPS)#          Loop over symmetry matrices      SP20 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SP20 131
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read packet                      SP20 132
IF(IP<=0) BREAK#                       Break at end                     SP20 133
movereal:(QX,IP+1,QX,II+1,12,1)#       Transfer packet                  SP20 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SP20 135
IF(ICNT==1)#                           If centrosymmetric               SP20 136
DO I=1,NROT*STEPS; QX(M1+I)=-QX(M0+I)# Store inverse matrix             SP20 137
#                                                                       SP20 138
# EXPAND SYMOP TABLE FOR CENTRES                                        SP20 139
#                                                                       SP20 140
M1=M0+NROT*STEPS+ICNT*NROT*STEPS#      Store primitive marker with ce   SP20 141
II=M1#                                                                  SP20 142
IF(LTYP>1)#                            Test if sg centered              SP20 143
FOR(J=M0;J<M1;J=J+STEPS)#              Loop over symm matrices          SP20 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SP20 145
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            SP20 146
QX(II+10)=QX(J+10)+TR11(LTYP-1)#       Transfer t1                      SP20 147
QX(II+11)=QX(J+11)+TR12(LTYP-1)#       Transfer t2                      SP20 148
QX(II+12)=QX(J+12)+TR13(LTYP-1)#       Transfer t3                      SP20 149
II=II+STEPS#                           Incr storage pointer             SP20 150
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               SP20 151
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            SP20 152
QX(II+10)=QX(J+10)+TR21(LTYP-2)#       Transfer t1                      SP20 153
QX(II+11)=QX(J+11)+TR22(LTYP-2)#       Transfer t2                      SP20 154
QX(II+12)=QX(J+12)+TR23(LTYP-2)#       Transfer t3                      SP20 155
II=II+STEPS#                           Incr storage pointer             SP20 156
IF(LTYP!=4) NEXT#                      Skip if not f-centre             SP20 157
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            SP20 158
QX(II+10)=QX(J+10)+0.5#                Transfer t1                      SP20 159
QX(II+11)=QX(J+11)+0.5#                Transfer t2                      SP20 160
QX(II+12)=QX(J+12)+0.0#                Transfer t3                      SP20 161
II=II+STEPS#                           Incr storage pointer             SP20 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SP20 163
M2 = II#                               End of symmetry matrices and     SP20 164
##                                     start-1 of histogram             SP20 165
M3 = M2 + NSLOTS#                      Start-1 of sum histogram         SP20 166
incrqx:(M4,M3+NSLOTS,SP2001)#          Expand qx                        SP20 167
readwpkt:(1,endrecord:,PSIZ,IP,0)#     Close file a                     SP20 168
#                                                                       SP20 169
# LR 21: RETRIEVE THE MAP PARAMETERS                                    SP20 170
# ----------------------------------                                    SP20 171
#                                                                       SP20 172
readwpkt:(3,21,PSIZ,IP,0)#                                              SP20 173
DO K=1,3#                                                               SP20 174
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SP20 175
IIP=IP+K#                                                               SP20 176
OR(K)=NINT(QX(IIP))#                   Pick up origins                  SP20 177
IN(K)=NINT(QX(IIP+3))#                 Increments along axes            SP20 178
NG(K)=NINT(QX(IIP+6))#                 No. of grid points               SP20 179
NP(K)=NINT(QX(IIP+9))#                 Calculated points                SP20 180
ISUM(K)=NINT(QX(IIP+12))#              Correlations between crystal     SP20 181
JSUM(K)=NINT(QX(IIP+15))#              Axes and calculation axes        SP20 182
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SP20 183
IF(CHEMX==4)#                          Slant file                       SP20 184
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SP20 185
ZADIV=QX(IP+25)#                       Angstroem/div z-direction        SP20 186
YADIV=QX(IP+26)#                       Angstroem/div y-direction        SP20 187
XADIV=QX(IP+27)#                       Angstroem/div x-direction        SP20 188
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SP20 189
#                                                                       SP20 190
#----TO DESCRIBE PERMUTATIONS BETWEEN XTAL AXES AND COMPUTATIONAL AXES, SP20 191
#     TWO PERMUTATION VECTORS ARE DEFINED.       THE ISUM'S AND JSUM'S  SP20 192
#                                                                       SP20 193
#----THE ISUM'S GIVE COMPUTATIONAL VARIABLES CORRESPONDING TO THE XTAL  SP20 194
#     VARIABLES.  THE JSUM'S GIVE XTAL VARIABLES CORRESPONDING TO THE   SP20 195
#     COMPUTATIONAL VARIABLES.                                          SP20 196
#                                                                       SP20 197
#----THUS, FOR ALL POSSIBLE PERMUTATIONS                                SP20 198
#                                                                       SP20 199
#        LAYER  DOWN  ACROSS  ISUM1  ISUM2  ISUM3  JSUM1  JSUM2  JSUM3  SP20 200
#          X      Y     Z       1      2      3      1      2      3    SP20 201
#          X      Z     Y       1      3      2      1      3      2    SP20 202
#          Y      X     Z       2      1      3      2      1      3    SP20 203
#          Y      Z     X       3      1      2      2      3      1    SP20 204
#          Z      Y     X       3      2      1      3      2      1    SP20 205
#          Z      X     Y       2      3      1      3      1      2    SP20 206
#                                                                       SP20 207
#     CHEMX MAP, TESTS                                                  SP20 208
#     ----------------                                                  SP20 209
#                                                                       SP20 210
IF(CHEMX==3 \ CHEMX==4 \ BIOSYM==yes:)#                                 SP20 211
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SP20 212
IF(ISUM(1)!=3 \ ISUM(2)!=2 \ ISUM(3)!=1 \ $# Invalid layout             SP20 213
   JSUM(1)!=3 \ JSUM(2)!=2 \ JSUM(3)!=1   ) iquit:(SP2003)#             SP20 214
incrqx:(M5,M4+NP(1)*NP(2)*NP(3),SP2004)# Expand qx                      SP20 215
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SP20 216
#                                                                       SP20 217
#     PREPARE TO ENTER FOURR MAP                                        SP20 218
#     --------------------------                                        SP20 219
#                                                                       SP20 220
ILAY=OR(1); NLAY=IN(1); MLAY=(NP(1)-1)*NLAY+ILAY# Set map limits        SP20 221
ILIN=OR(2); NLIN=IN(2); MLIN=(NP(2)-1)*NLIN+ILIN# Set map limits        SP20 222
IPNT=OR(3); NPNT=IN(3); MPNT=NP(3)#    Set map limits                   SP20 223
IF(CHEMX==3 \ CHEMX==4 \ BIOSYM==yes:) IPIX=0#                          SP20 224
#                                                                       SP20 225
#    ENTER FOURR MAP FROM FILE 3                                        SP20 226
#    ---------------------------                                        SP20 227
#                                                                       SP20 228
OLDMIN=1.0E36; OLDMAX=-1.0E36; OLDSUM=0.0#                              SP20 229
FOR(LAY=ILAY;LAY<=MLAY;LAY=LAY+NLAY)#  Loop over map sections           SP20 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SP20 231
FOR(LIN=ILIN;LIN<=MLIN;LIN=LIN+NLIN)#  Loop over lines per layer        SP20 232
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SP20 233
readwpkt:(3,22,PSIZ,IP,0)#             Read in next line of layer       SP20 234
IF(IP==0) BREAK#                       Exit when map complete           SP20 235
DO PNT=1,MPNT#                         Loop over points per line        SP20 236
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SP20 237
IIP=IP+PNT; AA=QX(IIP)#                Pick up pixel value              SP20 238
OLDMIN=MIN(OLDMIN,AA); OLDMAX=MAX(OLDMAX,AA); OLDSUM=OLDSUM+AA#         SP20 239
IF(CHEMX==3 \ CHEMX==4 \ BIOSYM==yes:)#                                 SP20 240
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SP20 241
IPIX=IPIX+1#                                                            SP20 242
density:(IPIX)=AA#                                                      SP20 243
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SP20 244
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SP20 245
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SP20 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SP20 247
readwpkt:(3,endrecord:,PSIZ,IP,0)#     Close file c                     SP20 248
IF(MAXDE==yes:)BETA=1/OLDMAX#          Use 1/dens as beta               SP20 249
IF(NORM==yes:)$#                                                        SP20 250
SCALE=(F000*FLOAT(NG(1))*FLOAT(NG(2))*FLOAT(NG(3)))/(OLDSUM*VOL)#       SP20 251
#                                                                       SP20 252
# WRITE CHEMX FILES                                                     SP20 253
# -----------------                                                     SP20 254
#                                                                       SP20 255
IF(CHEMX==1 \ CHEMX==2)#               Write surface file               SP20 256
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SP20 257
OPEN(UNIT=99,FILE='SURFACE.DAT',ACCESS='SEQUENTIAL',$#                  SP20 258
FORM='FORMATTED',STATUS='UNKNOWN')#                                     SP20 259
WRITE(99,'(2I5)')0,99999#                                               SP20 260
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SP20 261
#                                                                       SP20 262
IF(CHEMX==3 \ CHEMX==4 \ BIOSYM==yes:)#                                 SP20 263
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SP20 264
IF(IPIX!=NP(1)*NP(2)*NP(3))iquit:(SP2005)# Sp                           SP20 265
XMIN=1000000.0; XMAX=-1000000.0#                                        SP20 266
YMIN=1000000.0; YMAX=-1000000.0#                                        SP20 267
ZMIN=1000000.0; ZMAX=-1000000.0#                                        SP20 268
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SP20 269
#                                                                       SP20 270
#                                                                       SP20 271
# HISTOGRAMM                                                            SP20 272
# ----------                                                            SP20 273
#                                                                       SP20 274
DO SLOT=1,NSLOTS; hist:(SLOT)=0.0#     Initialize histogram             SP20 275
NEWMIN=1.0E36; NEWMAX=-1.0E36; NEWSUM=0.0#                              SP20 276
MINBOND=MINBOND**2; DELTA=DELTA**2#                                     SP20 277
#                                                                       SP20 278
# WRITE LOGICAL RECORD 22 ON FILE D                                     SP20 279
# ---------------------------------                                     SP20 280
#                                                                       SP20 281
copyfile:(3,4,1,21)#                   Copy up to lr21                  SP20 282
FOR(LAY=ILAY;LAY<=MLAY;LAY=LAY+NLAY)#  Loop over map sections           SP20 283
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SP20 284
ALAY=FLOAT(LAY)#                       Float layer number               SP20 285
FOR(LIN=ILIN;LIN<=MLIN;LIN=LIN+NLIN)#  Loop over lines per layer        SP20 286
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SP20 287
ALIN=FLOAT(LIN)#                       Float line number                SP20 288
readwpkt:(3,22,PSIZ,IP,0)#             Read in next line of layer       SP20 289
writepkt:(4,22,PSIZ,JP)#               Write next line                  SP20 290
#                                                                       SP20 291
DO PNT=1,MPNT#                         Loop over points per line        SP20 292
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SP20 293
APNT=FLOAT((PNT-1)*NPNT+IPNT)#         Float point index                SP20 294
P(3)=APNT/FLOAT(NG(3))#                Convert across to fractions      SP20 295
P(2)=ALIN/FLOAT(NG(2))#                Convert down   to fractions      SP20 296
P(1)=ALAY/FLOAT(NG(1))#                Convert layer  to fractions      SP20 297
X=P(ISUM(1))#                          Convert to crystal axes          SP20 298
Y=P(ISUM(2))#                                                           SP20 299
Z=P(ISUM(3))#                                                           SP20 300
#                                                                       SP20 301
IF(CHEMX==3)#                          Density map                      SP20 302
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SP20 303
P(3)=APNT/FLOAT(NG(3))#                Convert across to fractions      SP20 304
P(2)=ALIN/FLOAT(NG(2))#                Convert down   to fractions      SP20 305
P(1)=ALAY/FLOAT(NG(1))#                Convert layer  to fractions      SP20 306
X=P(ISUM(1))*SQRT(G1)#                 Convert to crystal axes in       SP20 307
Y=P(ISUM(2))*SQRT(G5)#                 Angstroem                        SP20 308
Z=P(ISUM(3))*SQRT(G9)#                                                  SP20 309
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SP20 310
IF(CHEMX==4)#                          Slant map                        SP20 311
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SP20 312
P(3)=APNT#                             Convert across to points         SP20 313
P(2)=ALIN#                             Convert down   to points         SP20 314
P(1)=ALAY#                             Convert layer  to points         SP20 315
X=P(ISUM(1))*XADIV#                    Convert to crystal axes in       SP20 316
Y=P(ISUM(2))*YADIV#                    Angstroem                        SP20 317
Z=P(ISUM(3))*ZADIV#                                                     SP20 318
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SP20 319
IF(BIOSYM==yes:)#                      Density map                      SP20 320
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SP20 321
P(3)=APNT/FLOAT(NG(3))#                Convert across to fractions      SP20 322
P(2)=ALIN/FLOAT(NG(2))#                Convert down   to fractions      SP20 323
P(1)=ALAY/FLOAT(NG(1))#                Convert layer  to fractions      SP20 324
X=P(ISUM(1))#                          Convert to crystal axes in       SP20 325
Y=P(ISUM(2))#                                                           SP20 326
Z=P(ISUM(3))#                                                           SP20 327
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SP20 328
#                                                                       SP20 329
JJP=JP+PNT#                            Point to i/o buffer              SP20 330
IIP=IP+PNT#                            Point to i/o buffer              SP20 331
OLDRHO=QX(IIP)#                        Pick it up                       SP20 332
NEWRHO=OLDRHO#                                                          SP20 333
#                                                                       SP20 334
# WRITE CHEMX FILE                                                      SP20 335
# ----------------                                                      SP20 336
#                                                                       SP20 337
IF( (OLDRHO==0.0 & CHEMX==1) \ (OLDRHO!=1.0 & CHEMX==2) )$#             SP20 338
WRITE(99,'(2I10,3F20.10)')$#                                            SP20 339
1,2,X*SQRT(G1),Y*SQRT(G5),Z*SQRT(G9)#  Write chemx surface file         SP20 340
#                                                                       SP20 341
IF(CHEMX==3 \ CHEMX==4 \ BIOSYM==yes:)#                                 SP20 342
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SP20 343
XMIN=MIN(XMIN,X); XMAX=MAX(XMAX,X)#                                     SP20 344
YMIN=MIN(YMIN,Y); YMAX=MAX(YMAX,Y)#                                     SP20 345
ZMIN=MIN(ZMIN,Z); ZMAX=MAX(ZMAX,Z)#                                     SP20 346
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SP20 347
#                                                                       SP20 348
# INACCESSIBLE VOLUMES                                                  SP20 349
#                                                                       SP20 350
IF(INACV==yes:)#                                                        SP20 351
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SP20 352
NEWRHO=0.0#                            Assume point inaccessible        SP20 353
FOR(IS=M0;IS<M2;IS=IS+STEPS)#          Loop over all symops             SP20 354
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SP20 355
U=QX(IS+1)*X+QX(IS+4)*Y+QX(IS+7)*Z+QX(IS+10)# X'                        SP20 356
V=QX(IS+2)*X+QX(IS+5)*Y+QX(IS+8)*Z+QX(IS+11)# Y'                        SP20 357
W=QX(IS+3)*X+QX(IS+6)*Y+QX(IS+9)*Z+QX(IS+12)# Z'                        SP20 358
XS=4.;  YS=4.;  ZS=4.#                 Set initial shifts               SP20 359
DO LT=1,125#                           Loop cell shifts (2 deep)        SP20 360
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SP20 361
XS=AMOD(XS+1.,5.)#                     Incr x cell shift                SP20 362
IF(XS   <0.5) YS=AMOD(YS+1.,5.)#       Incr y cell shift                SP20 363
IF(XS+YS<0.5) ZS=AMOD(ZS+1.,5.)#       Incr z cell shift                SP20 364
XX=U+XS-2.;  YY=V+YS-2.;  ZZ=W+ZS-2.#  Get transformed coord            SP20 365
DX=X-XX;  DY=Y-YY;  DZ=Z-ZZ#           Get coord difference             SP20 366
DD = G1*DX*DX +    G5*DY*DY +    G9*DZ*DZ$# Calc distance**2            SP20 367
+ 2.*G2*DX*DY + 2.*G3*DX*DZ + 2.*G6*DY*DZ# Calc distance**2             SP20 368
IF(DELTA<DD & DD<=MINBOND) GOTO 100#   Not equal, but too close         SP20 369
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SP20 370
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SP20 371
NEWRHO=1.0#                            Point accessible                 SP20 372
100 CONTINUE#                          Branch in from not accessible    SP20 373
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SP20 374
#                                                                       SP20 375
# HISTOGRAM                                                             SP20 376
#                                                                       SP20 377
IF(IHIST==yes:)#                                                        SP20 378
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SP20 379
SLOT=NINT(((OLDRHO-OLDMIN)/(OLDMAX-OLDMIN))*FLOAT(NSLOTS-1) + 1.0)#     SP20 380
hist:(SLOT)=hist:(SLOT)+1.0#                                            SP20 381
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SP20 382
#                                                                       SP20 383
# DENSITY MODIFICATION                                                  SP20 384
#                                                                       SP20 385
IF(SQUAR==yes:)    NEWRHO = OLDRHO**2#                                  SP20 386
IF(EXPON==yes:)    NEWRHO = EXP(BETA*(OLDRHO+ALPHA))#                   SP20 387
IF(NORM==yes:)     NEWRHO = OLDRHO*SCALE#                               SP20 388
IF(IADDCON==yes:)  NEWRHO = OLDRHO+ADDCON#                              SP20 389
IF(IMULDEN==yes:)  NEWRHO = OLDRHO*MULDEN#                              SP20 390
#                                                                       SP20 391
QX(JJP)=NEWRHO#                        Back to i/o buf                  SP20 392
A=NEWRHO#                              Pick up pixel value              SP20 393
NEWMIN=MIN(NEWMIN,A); NEWMAX=MAX(NEWMAX,A); NEWSUM=NEWSUM+A#            SP20 394
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SP20 395
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SP20 396
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SP20 397
copyfile:(3,4,23,endrecord:)#          Copy the endrecord:              SP20 398
#                                                                       SP20 399
# WRITE CHEMX FILE                                                      SP20 400
# ----------------                                                      SP20 401
#                                                                       SP20 402
IF(CHEMX==3 \ CHEMX==4)#                                                SP20 403
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SP20 404
ifsel:(MAC)#                                                            SP20 405
OPEN(UNIT=99,FILE='CHEMXMAP.DAT',STATUS='REPLACE',FORM='UNFORMATTED',$# SP20 406
     ACCESS='SEQUENTIAL')#                                              SP20 407
ifsel:#                                                                 SP20 408
OPEN(UNIT=99,FILE='CHEMXMAP.DAT',STATUS='NEW',FORM='UNFORMATTED',$#     SP20 409
     ACCESS='SEQUENTIAL')#                                              SP20 410
endsel:#                                                                SP20 411
WRITE(99)2,NP(ISUM(1)),NP(ISUM(2)),NP(ISUM(3)),11#                      SP20 412
WRITE(99)XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX#                                 SP20 413
WRITE(99)(density:(I),I=1,IPIX)#                                        SP20 414
CLOSE(99)#                                                              SP20 415
#                                                                       SP20 416
CHROT(1^65)=$#                                                          SP20 417
'Orthogonal coordinate system X, Y, Z ---------------------'#           SP20 418
writeline:(1,0,0,1,3)#                                                  SP20 419
CHROT(1^65)=$#                                                          SP20 420
'Angstroem        MIN            MAX            NP         '#           SP20 421
writeline:(1,0,0,1,3)#                                                  SP20 422
CHROT(1^1)='X'#                                                         SP20 423
FMT=201571. ;ncodefld:(XMIN,1,CHROT,FMT,1)#                             SP20 424
FMT=351571. ;ncodefld:(XMAX,1,CHROT,FMT,1)#                             SP20 425
FMT=501513. ;ncodefld:(FLOAT(NP(ISUM(1))),1,CHROT,FMT,1)#               SP20 426
writeline:(0,0,0,1,3)#                                                  SP20 427
CHROT(1^1)='Y'#                                                         SP20 428
FMT=201571. ;ncodefld:(YMIN,1,CHROT,FMT,1)#                             SP20 429
FMT=351571. ;ncodefld:(YMAX,1,CHROT,FMT,1)#                             SP20 430
FMT=501513. ;ncodefld:(FLOAT(NP(ISUM(2))),1,CHROT,FMT,1)#               SP20 431
writeline:(0,0,0,1,3)#                                                  SP20 432
CHROT(1^1)='Z'#                                                         SP20 433
FMT=201571. ;ncodefld:(ZMIN,1,CHROT,FMT,1)#                             SP20 434
FMT=351571. ;ncodefld:(ZMAX,1,CHROT,FMT,1)#                             SP20 435
FMT=501513. ;ncodefld:(FLOAT(NP(ISUM(3))),1,CHROT,FMT,1)#               SP20 436
writeline:(0,0,0,1,3)#                                                  SP20 437
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SP20 438
IF(CHEMX==1 \ CHEMX==2) CLOSE(99)#                                      SP20 439
#                                                                       SP20 440
# WRITE BIOSYM FILE                                                     SP20 441
# -----------------                                                     SP20 442
##                                                                      SP20 443
## InsightII, Version 2.1.0, March 1992                                 SP20 444
## REFERENCE GUIDE, PART 3, p. 8-5                                      SP20 445
#                                                                       SP20 446
IF(BIOSYM==yes:)#                                                       SP20 447
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SP20 448
ifsel:(MAC)#                                                            SP20 449
OPEN(UNIT=77,FILE='IDL.MAP',STATUS='REPLACE')#                          SP20 450
OPEN(UNIT=98,FILE='BIOSYM.grd',STATUS='REPLACE',FORM='UNFORMATTED',$#   SP20 451
     ACCESS='SEQUENTIAL')#                                              SP20 452
ifsel:#                                                                 SP20 453
OPEN(UNIT=77,FILE='IDL.MAP',STATUS='NEW')#                              SP20 454
OPEN(UNIT=98,FILE='BIOSYM.grd',STATUS='NEW',FORM='UNFORMATTED',$#       SP20 455
     ACCESS='SEQUENTIAL')#                                              SP20 456
endsel:#                                                                SP20 457
WRITE(98)TITLE#                                                         SP20 458
WRITE(98)0,4,0,#                                                        SP20 459
DIRCEL(1),DIRCEL(2),DIRCEL(3),DIRCEL(4),DIRCEL(5),DIRCEL(6),#           SP20 460
XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,#                                         SP20 461
NP(ISUM(1))-1,NP(ISUM(2))-1,NP(ISUM(3))-1#                              SP20 462
FOR(IZ=1;IZ<=NP(ISUM(3));IZ=IZ+1)#                                      SP20 463
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SP20 464
FOR(IY=1;IY<=NP(ISUM(2));IY=IY+1)#                                      SP20 465
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 SP20 466
ISTA=(IZ-1)*NP(ISUM(2))*NP(ISUM(1))+(IY-1)*NP(ISUM(1))+1#               SP20 467
IEND=ISTA+NP(ISUM(1))-1#                                                SP20 468
WRITE(98)(density:(I),I=ISTA,IEND)#                                     SP20 469
DO I=ISTA,IEND;WRITE(77,*)density:(I)#                                  SP20 470
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 SP20 471
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SP20 472
CLOSE(98)#                                                              SP20 473
CLOSE(77)#                                                              SP20 474
#                                                                       SP20 475
CHROT(1^65)=$#                                                          SP20 476
'Coordinate system X, Y, Z --------------------------------'#           SP20 477
writeline:(1,0,0,1,3)#                                                  SP20 478
CHROT(1^65)=$#                                                          SP20 479
'Fractional       MIN            MAX            NP         '#           SP20 480
writeline:(1,0,0,1,3)#                                                  SP20 481
CHROT(1^1)='X'#                                                         SP20 482
FMT=200842. ;ncodefld:(XMIN,1,CHROT,FMT,1)#                             SP20 483
FMT=350842. ;ncodefld:(XMAX,1,CHROT,FMT,1)#                             SP20 484
FMT=501513. ;ncodefld:(FLOAT(NP(ISUM(1))),1,CHROT,FMT,1)#               SP20 485
writeline:(0,0,0,1,3)#                                                  SP20 486
CHROT(1^1)='Y'#                                                         SP20 487
FMT=200842. ;ncodefld:(YMIN,1,CHROT,FMT,1)#                             SP20 488
FMT=350842. ;ncodefld:(YMAX,1,CHROT,FMT,1)#                             SP20 489
FMT=501513. ;ncodefld:(FLOAT(NP(ISUM(2))),1,CHROT,FMT,1)#               SP20 490
writeline:(0,0,0,1,3)#                                                  SP20 491
CHROT(1^1)='Z'#                                                         SP20 492
FMT=200842. ;ncodefld:(ZMIN,1,CHROT,FMT,1)#                             SP20 493
FMT=350842. ;ncodefld:(ZMAX,1,CHROT,FMT,1)#                             SP20 494
FMT=501513. ;ncodefld:(FLOAT(NP(ISUM(3))),1,CHROT,FMT,1)#               SP20 495
writeline:(0,0,0,1,3)#                                                  SP20 496
CHROT(1^65)=$#                                                          SP20 497
'----------------------------------------------------------'#           SP20 498
writeline:(0,0,0,1,3)#                                                  SP20 499
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SP20 500
#                                                                       SP20 501
# SUM HISTOGRAM                                                         SP20 502
#                                                                       SP20 503
IF(IHIST==yes:)#                                                        SP20 504
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 SP20 505
shist:(1)=hist:(1)#                                                     SP20 506
DO SLOT=2,NSLOTS; shist:(SLOT)=shist:(SLOT-1)+hist:(SLOT)#              SP20 507
MXHIS=hist:(1); MNHIS=hist:(1); MXSHIS=shist:(1); MNSHIS=shist:(1)# S   SP20 508
DO SLOT=1,NSLOTS#                      Min/max                          SP20 509
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 SP20 510
MXHIS =MAX(MXHIS,hist:(SLOT));   MNHIS =MIN(MNHIS,hist:(SLOT))#         SP20 511
MXSHIS=MAX(MXSHIS,shist:(SLOT)); MNSHIS=MIN(MNSHIS,shist:(SLOT))#       SP20 512
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 SP20 513
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 SP20 514
#                                                                       SP20 515
# PRINT HISTOGRAMS                                                      SP20 516
#                                                                       SP20 517
IF(IHIST==yes:)#                                                        SP20 518
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 SP20 519
#                                                                       SP20 520
# HISTOGRAM                                                             SP20 521
# ---------                                                             SP20 522
#                                                                       SP20 523
NLINES=50#                             No. of lines for plot            SP20 524
NCOLS=100#                             No. of colums                    SP20 525
LINRM=54#                              Need at least that many lines    SP20 526
#                                                                       SP20 527
CHROT(1^9)='HISTOGRAM'; writeline:(1,0,0,1,3)#                          SP20 528
CHROT(1^9)='    N    '; writeline:(1,0,0,1,3)#                          SP20 529
FOR(LINE=NLINES;LINE>=0;LINE=LINE-1)#                                   SP20 530
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 SP20 531
DO SLOT=1,NSLOTS#                      Search for line                  SP20 532
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 SP20 533
PRLIN=NINT(((hist:(SLOT)-MNHIS)/(MXHIS-MNHIS))*FLOAT(NLINES-1))+1#      SP20 534
IF(PRLIN==LINE)#                                                        SP20 535
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 SP20 536
IPOS=NINT( (FLOAT(SLOT-1)/FLOAT(NSLOTS-1))*FLOAT(NCOLS-1) )+1#          SP20 537
CHROT(5+IPOS^5+IPOS)='*'#                                               SP20 538
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 SP20 539
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 SP20 540
CHROT(5^5)='.'#                                                         SP20 541
IF(LINE==NINT(1.0*FLOAT(NLINES-1))+1) CHROT(2^5)='1.0-'#                SP20 542
IF(LINE==NINT(0.8*FLOAT(NLINES-1))+1) CHROT(2^5)='0.8-'#                SP20 543
IF(LINE==NINT(0.6*FLOAT(NLINES-1))+1) CHROT(2^5)='0.6-'#                SP20 544
IF(LINE==NINT(0.4*FLOAT(NLINES-1))+1) CHROT(2^5)='0.4-'#                SP20 545
IF(LINE==NINT(0.2*FLOAT(NLINES-1))+1) CHROT(2^5)='0.2-'#                SP20 546
IF(LINE==NINT(0.0*FLOAT(NLINES-1))+1) CHROT(2^5)='0.0-'#                SP20 547
#                                                                       SP20 548
writeline:(0,0,0,1,3)#                                                  SP20 549
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 SP20 550
#                                                                       SP20 551
# Y-AXIS                                                                SP20 552
#                                                                       SP20 553
DO I=5,105; CHROT(I^I)='.'#                                             SP20 554
DO IPOS=1,NCOLS#                       Loop over cols                   SP20 555
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 SP20 556
IF(IPOS==NINT( 1.0*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 557
IF(IPOS==NINT( 0.8*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 558
IF(IPOS==NINT( 0.6*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 559
IF(IPOS==NINT( 0.4*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 560
IF(IPOS==NINT( 0.2*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 561
IF(IPOS==NINT( 0.0*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 562
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 SP20 563
writeline:(0,0,0,1,3)#                                                  SP20 564
DO IPOS=1,NCOLS#                       Loop over cols                   SP20 565
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 SP20 566
IF(IPOS==NINT( 1.0*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='1.0'#      SP20 567
IF(IPOS==NINT( 0.8*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='0.8'#      SP20 568
IF(IPOS==NINT( 0.6*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='0.6'#      SP20 569
IF(IPOS==NINT( 0.4*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='0.4'#      SP20 570
IF(IPOS==NINT( 0.2*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='0.2'#      SP20 571
IF(IPOS==NINT( 0.0*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='0.0'#      SP20 572
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 SP20 573
writeline:(0,0,0,1,3)#                                                  SP20 574
CHROT(5^5+2)='MIN'; CHROT(NCOLS+5-1^NCOLS+5+1)='MAX'#                   SP20 575
writeline:(0,0,0,1,3)#                                                  SP20 576
CHROT(1^20)='NO. OF SLOTS        '#                                     SP20 577
FMT=301013. ;ncodefld:(FLOAT(NSLOTS),1,CHROT,FMT,1)#                    SP20 578
writeline:(0,0,0,1,3)#                                                  SP20 579
CHROT(1^20)='MAX NUMBER / SLOT   '#                                     SP20 580
FMT=301013. ;ncodefld:(MXHIS,1,CHROT,FMT,1)#                            SP20 581
writeline:(0,0,0,1,3)#                                                  SP20 582
#                                                                       SP20 583
# SUM HISTOGRAM                                                         SP20 584
# -------------                                                         SP20 585
#                                                                       SP20 586
NLINES=50#                             No. of lines for plot            SP20 587
NCOLS=100#                             No. of colums                    SP20 588
LINRM=54#                              Need at least that many lines    SP20 589
#                                                                       SP20 590
CHROT(1^13)='SUM HISTOGRAM'; writeline:(1,0,0,1,3)#                     SP20 591
CHROT(1^9)='    N    '; writeline:(1,0,0,1,3)#                          SP20 592
FOR(LINE=NLINES;LINE>=0;LINE=LINE-1)#                                   SP20 593
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 SP20 594
DO SLOT=1,NSLOTS#                      Search for line                  SP20 595
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 SP20 596
PRLIN=NINT(((shist:(SLOT)-MNSHIS)/(MXSHIS-MNSHIS))*$#                   SP20 597
FLOAT(NLINES-1))+1#                                                     SP20 598
IF(PRLIN==LINE)#                                                        SP20 599
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 SP20 600
IPOS=NINT( (FLOAT(SLOT-1)/FLOAT(NSLOTS-1))*FLOAT(NCOLS-1) )+1#          SP20 601
CHROT(5+IPOS^5+IPOS)='*'#                                               SP20 602
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 SP20 603
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 SP20 604
CHROT(5^5)='.'#                                                         SP20 605
IF(LINE==NINT(1.0*FLOAT(NLINES-1))+1) CHROT(2^5)='1.0-'#                SP20 606
IF(LINE==NINT(0.8*FLOAT(NLINES-1))+1) CHROT(2^5)='0.8-'#                SP20 607
IF(LINE==NINT(0.6*FLOAT(NLINES-1))+1) CHROT(2^5)='0.6-'#                SP20 608
IF(LINE==NINT(0.4*FLOAT(NLINES-1))+1) CHROT(2^5)='0.4-'#                SP20 609
IF(LINE==NINT(0.2*FLOAT(NLINES-1))+1) CHROT(2^5)='0.2-'#                SP20 610
IF(LINE==NINT(0.0*FLOAT(NLINES-1))+1) CHROT(2^5)='0.0-'#                SP20 611
#                                                                       SP20 612
writeline:(0,0,0,1,3)#                                                  SP20 613
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 SP20 614
#                                                                       SP20 615
# Y-AXIS                                                                SP20 616
#                                                                       SP20 617
DO I=5,105; CHROT(I^I)='.'#                                             SP20 618
DO IPOS=1,NCOLS#                       Loop over cols                   SP20 619
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 SP20 620
IF(IPOS==NINT( 1.0*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 621
IF(IPOS==NINT( 0.8*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 622
IF(IPOS==NINT( 0.6*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 623
IF(IPOS==NINT( 0.4*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 624
IF(IPOS==NINT( 0.2*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 625
IF(IPOS==NINT( 0.0*FLOAT(NCOLS-1) )+1) CHROT(5+IPOS^5+IPOS)='|'#        SP20 626
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 SP20 627
writeline:(0,0,0,1,3)#                                                  SP20 628
DO IPOS=1,NCOLS#                       Loop over cols                   SP20 629
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 SP20 630
IF(IPOS==NINT( 1.0*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='1.0'#      SP20 631
IF(IPOS==NINT( 0.8*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='0.8'#      SP20 632
IF(IPOS==NINT( 0.6*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='0.6'#      SP20 633
IF(IPOS==NINT( 0.4*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='0.4'#      SP20 634
IF(IPOS==NINT( 0.2*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='0.2'#      SP20 635
IF(IPOS==NINT( 0.0*FLOAT(NCOLS-1) )+1) CHROT(4+IPOS^6+IPOS)='0.0'#      SP20 636
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 SP20 637
writeline:(0,0,0,1,3)#                                                  SP20 638
CHROT(5^5+2)='MIN'; CHROT(NCOLS+5-1^NCOLS+5+1)='MAX'#                   SP20 639
writeline:(0,0,0,1,3)#                                                  SP20 640
CHROT(1^20)='NO. OF SLOTS        '#                                     SP20 641
FMT=301013. ;ncodefld:(FLOAT(NSLOTS),1,CHROT,FMT,1)#                    SP20 642
writeline:(0,0,0,1,3)#                                                  SP20 643
CHROT(1^20)='MAX NUMBER / SLOT   '#                                     SP20 644
FMT=301013. ;ncodefld:(MXSHIS,1,CHROT,FMT,1)#                           SP20 645
writeline:(0,0,0,1,3)#                                                  SP20 646
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 SP20 647
#                                                                       SP20 648
CHROT(1^65)=$#                                                          SP20 649
'Pixel values of density ----------------------------------'#           SP20 650
writeline:(1,0,0,1,3)#                                                  SP20 651
CHROT(1^65)=$#                                                          SP20 652
'                 MIN            MAX            SUM        '#           SP20 653
writeline:(1,0,0,1,3)#                                                  SP20 654
CHROT(1^3)='OLD'#                                                       SP20 655
FMT=201571. ;ncodefld:(OLDMIN,1,CHROT,FMT,1)#                           SP20 656
FMT=351571. ;ncodefld:(OLDMAX,1,CHROT,FMT,1)#                           SP20 657
FMT=501571. ;ncodefld:(OLDSUM,1,CHROT,FMT,1)#                           SP20 658
writeline:(0,0,0,1,3)#                                                  SP20 659
CHROT(1^3)='NEW'#                                                       SP20 660
FMT=201571. ;ncodefld:(NEWMIN,1,CHROT,FMT,1)# S                         SP20 661
FMT=351571. ;ncodefld:(NEWMAX,1,CHROT,FMT,1)# S                         SP20 662
FMT=501571. ;ncodefld:(NEWSUM,1,CHROT,FMT,1)#                           SP20 663
writeline:(0,0,0,1,3)#                                                  SP20 664
#                                                                       SP20 665
RETURN#                                                                 SP20 666
END#                                                                    SP20 667
systemheader:(SP30)#                   Image seeking function           SP30   1
######################################################################  SP30   2
#                                                                    #  SP30   3
#                               SP30                                 #  SP30   4
#                                                                    #  SP30   5
######################################################################  SP30   6
SUBROUTINE SP30#                                                        SP30   7
include:(AACOMN)#                                                       SP30   8
include:(SPCOMN)#                                                       SP30   9
datastuff:#                                                             SP30  10
#                                                                       SP30  11
# PRACTICAL HINTS                                                       SP30  12
# ---------------                                                       SP30  13
#                                                                       SP30  14
# ASYMMETRIC UNITS OF THE MAPS                                          SP30  15
#                                                                       SP30  16
# THE SIZE OF THE INPUT PATTERSON MAP DEFINES THE SIZE OF THE OUTPUT    SP30  17
# MAP. THIS MAY LEAD TO CONFUSION IF THE ASU OF THE PATTERSON MAP IS    SP30  18
# NOT THE SAME AS THE ASU OF THE IMF. IN THIS CASE USE THE FULL OPTION  SP30  19
# IN PROGRAM FOURR.                                                     SP30  20
#                                                                       SP30  21
# GRIDDING OF THE MAPS                                                  SP30  22
#                                                                       SP30  23
# FOR OPTIMAL MAPS USE MULTIPLES OF 2, 3, 4, 6 AS GRID DIVISIONS        SP30  24
#                                                                       SP30  25
#                                                                       SP30  26
# ASSIGN MEMORY FOR FILE BUFFERS                                        SP30  27
# ------------------------------                                        SP30  28
#                                                                       SP30  29
IOMARK(1) = QXSTR#                     Start i/o buffer file a          SP30  30
IOMARK(3) = IOMARK(1)+bdfbuf:#         Start i/o buffer file c          SP30  31
IOMARK(4) = IOMARK(3)+bdfbuf:#         Start i/o buffer file d          SP30  32
M0        = IOMARK(4)+bdfbuf:#         Start-1 of symop table           SP30  33
incrqx:(M1,M0,SP2001)#                 Expand qx                        SP30  34
#                                                                       SP30  35
CALL SP31(1)#                          Read symmetry operators          SP30  36
IF(ISMF==yes:)CALL SP32#               Symmetry minimum function        SP30  37
IF(IIMF==yes:)CALL SP33#               Minimum function                 SP30  38
IF(ICVS==yes:)CALL SP34#               Second-order symmetry minimum    SP30  39
#                                                                       SP30  40
RETURN#                                                                 SP30  41
END#                                                                    SP30  42
systemheader:(SP31)#                   Read lrsymm record               SP31   1
######################################################################  SP31   2
#                                                                    #  SP31   3
#                               SP31                                 #  SP31   4
#                                                                    #  SP31   5
######################################################################  SP31   6
SUBROUTINE SP31(ILIST)#                                                 SP31   7
include:(AACOMN)#                                                       SP31   8
include:(SPCOMN)#                                                       SP31   9
#                                                                       SP31  10
# QX(M0+1), ..., QX(M1A) SYMMETRY MATRICES WITHOUT LATTICE CENTERING    SP31  11
# QX(M1A+1), ...,QX(M1B) ADDITIONAL MATRICES FOR CENTERING              SP31  12
# QX(M1B+1), ...,QX(M1C) PATTERSON SYMMETRY OPERATOR, NO CENTERING      SP31  13
# QX(M1C+1), ...,QX(M1D) PATTERSON SYMMETRY OPERATOR, CENTERING         SP31  14
# QX(M1D+1), ...,QX(M1E) HARKER OPERATORS                               SP31  15
# QX(M1E+1), ...,QX(M2)  UNIQUE HARKER OPERATORS                        SP31  16
#                                                                       SP31  17
INTEGER ILIST#            ## 1=list, 0=do not list                      SP31  18
#                                                                       SP31  19
INTEGER ICNT#             ## Centricity ac=0  c=1                       SP31  20
INTEGER LTYP#             ## Lattice code                               SP31  21
INTEGER NSYM#             ## Total symmetry matrices                    SP31  22
INTEGER NROT#             ## Limit of rotation matrices                 SP31  23
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              SP31  24
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              SP31  25
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              SP31  26
realdata:(TR21,[.3333333,.5])#                                          SP31  27
realdata:(TR22,[.6666667,0.])#                                          SP31  28
realdata:(TR23,[.6666667,.5])#                                          SP31  29
#                                                                       SP31  30
INTEGER IP,PSIZ,I,II,J,JH,J1,J2,JJ,IANS,IH,IS,IMATCH#                   SP31  31
INTEGER A(4,4),B(4,4),C(4,4),D(4,4)#                                    SP31  32
#                                                                       SP31  33
REAL EPSILON#                                                           SP31  34
#                                                                       SP31  35
datastuff:#                                                             SP31  36
#                                                                       SP31  37
STEPS=14#                                                               SP31  38
EPSILON=0.001#                                                          SP31  39
#                                                                       SP31  40
# SPACE GROUP SYMMETRY                                                  SP31  41
# --------------------                                                  SP31  42
#                                                                       SP31  43
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read packet                      SP31  44
IF(IP<=0) iquit:(SP3002)#              Quit if pkt not there            SP31  45
ICNT=1-NINT(QX(IP+2))#                 Centricity a=0   c=1             SP31  46
LTYP=NINT(QX(IP+1))-7*ICNT#            Lattice code, 1...7              SP31  47
NSYM=NINT(QX(IP+3))#                   Total symmetry matrices          SP31  48
NROT=NINT(QX(IP+4))#                   Limit of rotation matrices       SP31  49
#                                                                       SP31  50
# GET SYMMETRY EQUIVALENT POSITIONS                                     SP31  51
#                                                                       SP31  52
incrqx:(M1B,M0+NSYM*STEPS,SP2001)#     Request memory all symops        SP31  53
DO I=M0+1,M1B; QX(I)=0.0#              Clear out symops data            SP31  54
M1A=M0+NROT*STEPS#                     Limit of rotation matrices       SP31  55
FOR(II=M0;II<M1A;II=II+STEPS)#         Loop over symmetry matrices      SP31  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP31  57
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read packet                      SP31  58
IF(IP<=0) BREAK#                       Break at end                     SP31  59
movereal:(QX,IP+1,QX,II+1,12,1)#       Transfer packet                  SP31  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP31  61
IF(ICNT==1)#                           If centrosymmetric               SP31  62
DO I=1,NROT*STEPS; QX(M1A+I)=-QX(M0+I)# Store inverse matrix            SP31  63
#                                                                       SP31  64
# EXPAND SYMOP TABLE FOR CENTRES                                        SP31  65
#                                                                       SP31  66
M1A=M0+NROT*STEPS+ICNT*NROT*STEPS#     Store primitive marker with ce   SP31  67
II=M1A#                                                                 SP31  68
IF(LTYP>1)#                            Test if sg centered              SP31  69
FOR(J=M0;J<M1A;J=J+STEPS)#             Loop over symm matrices          SP31  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP31  71
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            SP31  72
QX(II+10)=QX(J+10)+TR11(LTYP-1)#       Transfer t1                      SP31  73
QX(II+11)=QX(J+11)+TR12(LTYP-1)#       Transfer t2                      SP31  74
QX(II+12)=QX(J+12)+TR13(LTYP-1)#       Transfer t3                      SP31  75
II=II+STEPS#                           Incr storage pointer             SP31  76
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               SP31  77
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            SP31  78
QX(II+10)=QX(J+10)+TR21(LTYP-2)#       Transfer t1                      SP31  79
QX(II+11)=QX(J+11)+TR22(LTYP-2)#       Transfer t2                      SP31  80
QX(II+12)=QX(J+12)+TR23(LTYP-2)#       Transfer t3                      SP31  81
II=II+STEPS#                           Incr storage pointer             SP31  82
IF(LTYP!=4) NEXT#                      Skip if not f-centre             SP31  83
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            SP31  84
QX(II+10)=QX(J+10)+0.5#                Transfer t1                      SP31  85
QX(II+11)=QX(J+11)+0.5#                Transfer t2                      SP31  86
QX(II+12)=QX(J+12)+0.0#                Transfer t3                      SP31  87
II=II+STEPS#                           Incr storage pointer             SP31  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP31  89
readwpkt:(1,endrecord:,PSIZ,IP,0)#     Close file a                     SP31  90
M1B=II#                                End of space group symmetry      SP31  91
#                                                                       SP31  92
# KEEP TRANSLATIONAL PART OF SPACE GROUP SYMOPS IN [0,1] INTERVALL      SP31  93
#                                                                       SP31  94
FOR(JH=M0;JH<M1B;JH=JH+STEPS)#         All space group operators        SP31  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP31  96
QX(JH+10)=AMOD(QX(JH+10)+10.,1.)#                                       SP31  97
QX(JH+11)=AMOD(QX(JH+11)+10.,1.)#                                       SP31  98
QX(JH+12)=AMOD(QX(JH+12)+10.,1.)#                                       SP31  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP31 100
#                                                                       SP31 101
# PATTERSON SYMMETRY                                                    SP31 102
# ------------------                                                    SP31 103
#                                                                       SP31 104
IF(ICNT==1)#                           Centrosymmetric                  SP31 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SP31 106
incrqx:(M1D,M1B+NSYM*STEPS,SP2001)#    Expand mem for all ops           SP31 107
M1C=M1B+(M1A-M0)#                      Primitive patterson ops          SP31 108
DO I=1,M1A-M0; QX(M1B+I)=QX(M0+I)#     Move symops                      SP31 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SP31 110
IF(ICNT==0)#                           Non-centrosymmetric              SP31 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SP31 112
incrqx:(M1D,M1B+2*NSYM*STEPS,SP2001)#  Expand mem for all ops           SP31 113
M1C=M1B+2*(M1A-M0)#                    Primitive patterson ops          SP31 114
DO I=1,M1A-M0; QX(M1B+I)        =  QX(M0+I)# Move symops                SP31 115
DO I=1,M1A-M0; QX(M1B+M1A-M0+I) = -QX(M0+I)# Add center of symmetry     SP31 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SP31 117
#                                                                       SP31 118
# REMOVE TRANSLATIONS                                                   SP31 119
#                                                                       SP31 120
FOR(I=M1B;I<M1C;I=I+STEPS)#            Loop over symm matrices          SP31 121
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SP31 122
QX(I+10)=0.0; QX(I+11)=0.0; QX(I+12)=0.0#                               SP31 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SP31 124
#                                                                       SP31 125
# ADD CENTERING                                                         SP31 126
#                                                                       SP31 127
II=M1C#                                                                 SP31 128
IF(LTYP>1)#                            Test if sg centered              SP31 129
FOR(J=M1B;J<M1C;J=J+STEPS)#            Loop over symm matrices          SP31 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SP31 131
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            SP31 132
QX(II+10)=QX(J+10)+TR11(LTYP-1)#       Transfer t1                      SP31 133
QX(II+11)=QX(J+11)+TR12(LTYP-1)#       Transfer t2                      SP31 134
QX(II+12)=QX(J+12)+TR13(LTYP-1)#       Transfer t3                      SP31 135
II=II+STEPS#                           Incr storage pointer             SP31 136
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               SP31 137
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            SP31 138
QX(II+10)=QX(J+10)+TR21(LTYP-2)#       Transfer t1                      SP31 139
QX(II+11)=QX(J+11)+TR22(LTYP-2)#       Transfer t2                      SP31 140
QX(II+12)=QX(J+12)+TR23(LTYP-2)#       Transfer t3                      SP31 141
II=II+STEPS#                           Incr storage pointer             SP31 142
IF(LTYP!=4) NEXT#                      Skip if not f-centre             SP31 143
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            SP31 144
QX(II+10)=QX(J+10)+0.5#                Transfer t1                      SP31 145
QX(II+11)=QX(J+11)+0.5#                Transfer t2                      SP31 146
QX(II+12)=QX(J+12)+0.0#                Transfer t3                      SP31 147
II=II+STEPS#                           Incr storage pointer             SP31 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SP31 149
M1D=II#                                                                 SP31 150
#                                                                       SP31 151
# HARKER OPERATORS                                                      SP31 152
# ----------------                                                      SP31 153
#                                                                       SP31 154
II=M1D; M1E=M1D#                                                        SP31 155
FOR(J1=M0;J1<M1A;J1=J1+STEPS)#         Symops, no centering             SP31 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SP31 157
FOR(J2=M0;J2<M1B;J2=J2+STEPS)#         Symops incl. centering           SP31 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SP31 159
incrqx:(M1E,M1E+STEPS,SP2001)#         Expand mem                       SP31 160
#                                                                       SP31 161
DO JJ=1,12; QX(II+JJ)=QX(J1+JJ)-QX(J2+JJ)# Harker = symop1 - symop2     SP31 162
QX(II+10)=AMOD(QX(II+10)+10.,1.)#                                       SP31 163
QX(II+11)=AMOD(QX(II+11)+10.,1.)#                                       SP31 164
QX(II+12)=AMOD(QX(II+12)+10.,1.)#                                       SP31 165
#                                                                       SP31 166
# OCCURRENCE OF HARKER VECTOR                                           SP31 167
#                                                                       SP31 168
QX(II+13)=1.0#                         Occurrence of harker vector      SP31 169
IF(ISMFW==yes:)#                                                        SP31 170
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SP31 171
FOR(JH=M1D;JH<M1E-STEPS;JH=JH+STEPS)#  All but current harker vector    SP31 172
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SP31 173
IANS=yes:#                                                              SP31 174
DO JJ=1,12; IF( ABS(QX(II+JJ)-QX(JH+JJ)) > EPSILON )IANS=no:# No matc   SP31 175
IF(IANS==yes:)#                        Harker vector already present    SP31 176
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SP31 177
QX(JH+13)=QX(JH+13)+1.0#               Update occurrence of old harke   SP31 178
M1E=M1E-STEPS#                         Reject new harker vector         SP31 179
II=II-STEPS#                           Reset counters                   SP31 180
BREAK#                                                                  SP31 181
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SP31 182
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SP31 183
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SP31 184
II=II+STEPS#                           Incr storage pointer             SP31 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SP31 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SP31 187
M1E=II#                                                                 SP31 188
#                                                                       SP31 189
# UNIQUE HARKER VECTORS                                                 SP31 190
# ---------------------                                                 SP31 191
#                                                                       SP31 192
II=M1E#                                Start-1 of unique harker opera   SP31 193
M2=M1E#                                End of unique harker operators   SP31 194
FOR(IH=M1D;IH<M1E;IH=IH+STEPS)#        Harker operators                 SP31 195
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SP31 196
IANS=no:#                                                               SP31 197
FOR(JH=M1E;JH<M2;JH=JH+STEPS)#         Unique harker operators          SP31 198
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SP31 199
FOR(IS=M1B;IS<M1D;IS=IS+STEPS)#        Loop over patterson operators    SP31 200
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SP31 201
CALL SP45(A,IH)#                       Ih-th harker operator            SP31 202
CALL SP45(B,IS)#                       Is-th patterson operator         SP31 203
CALL SP48(A,B,C)#                      C=b*a, patterson*harker          SP31 204
CALL SP45(D,JH)#                       Jh-th harker operator            SP31 205
IMATCH=0#                                                               SP31 206
DO I=1,4; DO J=1,4; IF( ABS(C(I,J)-D(I,J)) < EPSILON)IMATCH=IMATCH+1#   SP31 207
IF(IMATCH==16)BREAK#                   Match found jump out             SP31 208
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SP31 209
IF(IMATCH==16)BREAK#                   Match found jump out             SP31 210
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SP31 211
IF(IMATCH!=16)#                        No match found new unique hark   SP31 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SP31 213
incrqx:(M2,M2+STEPS,SP2001)#                                            SP31 214
movereal:(QX,IH+1,QX,II+1,STEPS,0)#    Current harker vector            SP31 215
II=II+STEPS#                                                            SP31 216
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SP31 217
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SP31 218
M2=II#                                                                  SP31 219
#                                                                       SP31 220
IF(ILIST==1)#                                                           SP31 221
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SP31 222
CHROT(1^25)='Space     group operators'; writeline:(1,0,0,1,3)#         SP31 223
FOR(JH=M0;JH<M1B;JH=JH+STEPS)#         List space group operators       SP31 224
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SP31 225
CALL SP37(JH,0)#                                                        SP31 226
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SP31 227
#                                                                       SP31 228
CHROT(1^25)='Patterson group operators'; writeline:(1,0,0,1,3)#         SP31 229
FOR(JH=M1B;JH<M1D;JH=JH+STEPS)#        List patte group operators       SP31 230
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SP31 231
CALL SP37(JH,0)#                                                        SP31 232
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SP31 233
#                                                                       SP31 234
# ## CHROT(1^25)='Harker          operators'; writeline:(1,0,0,1,3)#    SP31 235
# ## FOR(JH=M1D;JH<M1E;JH=JH+STEPS)#        List harker group operators SP31 236
# ## $(#                                                                SP31 237
# ## CALL SP37(JH,1)#                                                   SP31 238
# ## $)#                                                                SP31 239
#                                                                       SP31 240
CHROT(1^25)='Unique harker   operators'; writeline:(1,0,0,1,3)#         SP31 241
FOR(JH=M1E;JH<M2;JH=JH+STEPS)#         Unique harker operat   sp31 18   SP31 242
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SP31 243
CALL SP37(JH,1)#                                                        SP31 244
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SP31 245
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SP31 246
#                                                                       SP31 247
##                                     start-1 of histogram             SP31 248
M3 = M2#                               Dummy histogram, can be change   SP31 249
M4 = M3#                               Dummy histogram, can be change   SP31 250
RETURN#                                                                 SP31 251
END#                                                                    SP31 252
systemheader:(SP32)#                   Symmetry minimum function        SP32   1
######################################################################  SP32   2
#                                                                    #  SP32   3
#                               SP32                                 #  SP32   4
#                                                                    #  SP32   5
######################################################################  SP32   6
SUBROUTINE SP32#                                                        SP32   7
include:(AACOMN)#                                                       SP32   8
include:(SPCOMN)#                                                       SP32   9
#                                                                       SP32  10
INTEGER LAY,LIN,PNT#                                                    SP32  11
INTEGER LT#                                                             SP32  12
REAL    X,Y,Z,XX,YY,ZZ#                                                 SP32  13
REAL    ALAY,ALIN,APNT#                                                 SP32  14
REAL    A,B,C,D,AA,DD#                                                  SP32  15
REAL    P(3)#                                                           SP32  16
#                                                                       SP32  17
INTEGER IWNT(24)#                      Wanted items for indexpkt:       SP32  18
INTEGER IREL(25)#                      Pointers for qx                  SP32  19
INTEGER KEY(4)#                        Flag for indexpkt:               SP32  20
INTEGER I,K,J,IPA,IPB,JJP,IIP,IH#                                       SP32  21
INTEGER IP,JP,PSIZ#                                                     SP32  22
#                                                                       SP32  23
REAL    OLDDEN,MINDEN,PATMIN,PATMAX,SMFMIN,SMFMAX,WEIGHT,DENS#          SP32  24
#                                                                       SP32  25
chardata:(S01," Patterson function        : min/max")#                  SP32  26
chardata:(S02," Symmetry Minimum Function : min/max")#                  SP32  27
realdata:(FMT,[1552.,1552.])#                                           SP32  28
#                                                                       SP32  29
datastuff:#                                                             SP32  30
#                                                                       SP32  31
FILEXT(IOUNIT(3))='MAP'#               Input density map                SP32  32
FILEXT(IOUNIT(4))='SMF'#               Output density map               SP32  33
#                                                                       SP32  34
CALL SP35#                             Lr 21: read map parameters       SP32  35
IF(MAPTYP>3)iquit:(SP3003)#            Only patterson type maps         SP32  36
incrqx:(M5,M4+NP(1)*NP(2)*NP(3),SP2004)# Expand qx                      SP32  37
CALL SP36#                             Lr 22: read map                  SP32  38
#                                                                       SP32  39
# MIN/MAX PATTERSON MAP                                                 SP32  40
#                                                                       SP32  41
PATMIN=patterson:(1); PATMAX=patterson:(1)#                             SP32  42
DO I=1,NP(1)*NP(2)*NP(3); PATMIN=MIN(PATMIN,patterson:(I))#             SP32  43
DO I=1,NP(1)*NP(2)*NP(3); PATMAX=MAX(PATMAX,patterson:(I))#             SP32  44
SMFMIN=1.0E37; SMFMAX=-1.0E37#         Initialize min/max               SP32  45
#                                                                       SP32  46
# WRITE MINIMUM MAP                                                     SP32  47
# -----------------                                                     SP32  48
#                                                                       SP32  49
# LR21                                                                  SP32  50
#                                                                       SP32  51
##    COEFF PATT EPAT VECT EMAP FOBS FDIF FCAL WFOB WDIF                SP32  52
##      0    1    2    3    4    5    6    7    8    9                  SP32  53
#                                                                       SP32  54
copyfile:(3,4,1,20)#                   Copy up to lr20                  SP32  55
readwpkt:(3,21,PSIZ,IPA,0)#                                             SP32  56
writepkt:(4,21,PSIZ,IPB)#              Output packet                    SP32  57
movereal:(QX,IPA+1,QX,IPB+1,PSIZ,1)#   Copy old stuff across            SP32  58
QX(IPB+21)=5.0#                        Change calc type to frel         SP32  59
#                                                                       SP32  60
# LR22                                                                  SP32  61
#                                                                       SP32  62
FOR(LAY=ILAY;LAY<=MLAY;LAY=LAY+NLAY)#  Loop over map sections           SP32  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP32  64
FOR(LIN=ILIN;LIN<=MLIN;LIN=LIN+NLIN)#  Loop over lines per layer        SP32  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP32  66
readwpkt:(3,22,PSIZ,IP,0)#             Read in next line of layer       SP32  67
writepkt:(4,22,PSIZ,JP)#               Write next line                  SP32  68
#                                                                       SP32  69
FOR(PNT=IPNT;PNT<=MPNT;PNT=PNT+NPNT)#  Loop over points per layer       SP32  70
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP32  71
P(1)=FLOAT(LAY)/FLOAT(NG(1))#          Convert layer  to fractions      SP32  72
P(2)=FLOAT(LIN)/FLOAT(NG(2))#          Convert down   to fractions      SP32  73
P(3)=FLOAT(PNT)/FLOAT(NG(3))#          Convert acros                    SP32  74
#                                                                       SP32  75
X=P(ISUM(1))#                          Convert to crystal axes          SP32  76
Y=P(ISUM(2))#                                                           SP32  77
Z=P(ISUM(3))#                                                           SP32  78
#                                                                       SP32  79
JJP=JP+(PNT-IPNT+1)#                   Point to qx, i/o                 SP32  80
IIP=IP+(PNT-IPNT+1)#                   Point to qx, i/o                 SP32  81
OLDDEN=QX(IIP)#                        Pick it up                       SP32  82
#                                                                       SP32  83
# SYMMETRY MINIMUM FUNCTION                                             SP32  84
# -------------------------                                             SP32  85
#                                                                       SP32  86
# SMF(X) = MIN P( H(X,S) ); H(X,S) = (I-R(S))X + T(S); HARKER VECTOR    SP32  87
#           S                                                           SP32  88
# R(S)=ROTATIONAL AND T(S)=TRANSLATIONAL PART OF SPACE GROUP OPERATORS  SP32  89
# WITHOUT LATTICE CENTERING                                             SP32  90
#                                                                       SP32  91
MINDEN=PATMAX#                         Initialize minimum function      SP32  92
FOR(IH=M1E+STEPS;IH<M2;IH=IH+STEPS)#   Unique harker vector, no 0 0 0   SP32  93
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SP32  94
XX = QX(IH+1)*X + QX(IH+4)*Y + QX(IH+7)*Z + QX(IH+10)# X' harker        SP32  95
YY = QX(IH+2)*X + QX(IH+5)*Y + QX(IH+8)*Z + QX(IH+11)# Y' harker        SP32  96
ZZ = QX(IH+3)*X + QX(IH+6)*Y + QX(IH+9)*Z + QX(IH+12)# Z' harker        SP32  97
CALL SP38(XX,YY,ZZ,DENS)#              Get density(x,y,z)               SP32  98
WEIGHT=QX(IH+13)#                      Multiplicity of harker peak      SP32  99
MINDEN=MIN(MINDEN,DENS/WEIGHT)#                                         SP32 100
QX(IH+14)=QX(IH+14)+DENS#              Sum up harker section, lines     SP32 101
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SP32 102
#                                                                       SP32 103
QX(JJP)=MINDEN#                        Back to i/o buf                  SP32 104
SMFMIN=MIN(SMFMIN,MINDEN); SMFMAX=MAX(SMFMAX,MINDEN)#                   SP32 105
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP32 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP32 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP32 108
copyfile:(3,4,23,endrecord:)#          Copy the endrecord:              SP32 109
#                                                                       SP32 110
# REPORT                                                                SP32 111
#                                                                       SP32 112
movechar:(S01,1,CHROT,1,NS01,0)#                                        SP32 113
BUFOT(1)=PATMIN;BUFOT(2)=PATMAX#                                        SP32 114
LCHROT=40; ncodefld:(BUFOT,1,CHROT,FMT,2); writeline:(1,0,0,1,3)#       SP32 115
CHROT(1^29)=' Map is read from          : '#                            SP32 116
CHROT(30^39)=FILENM(IOUNIT(3))#                                         SP32 117
writeline:(0,0,0,1,3)#                                                  SP32 118
movechar:(S02,1,CHROT,1,NS02,0)#                                        SP32 119
BUFOT(1)=SMFMIN;BUFOT(2)=SMFMAX#                                        SP32 120
LCHROT=40; ncodefld:(BUFOT,1,CHROT,FMT,2); writeline:(1,0,0,1,3)# S     SP32 121
CHROT(1^29)=' Map is written to         : '#                            SP32 122
CHROT(30^39)=FILENM(IOUNIT(4))#                                         SP32 123
writeline:(0,0,0,1,3)#                                                  SP32 124
#                                                                       SP32 125
RETURN#                                                                 SP32 126
END#                                                                    SP32 127
systemheader:(SP33)#                   Image seeking minimum function   SP33   1
######################################################################  SP33   2
#                                                                    #  SP33   3
#                               SP33                                 #  SP33   4
#                                                                    #  SP33   5
######################################################################  SP33   6
SUBROUTINE SP33#                                                        SP33   7
include:(AACOMN)#                                                       SP33   8
include:(SPCOMN)#                                                       SP33   9
#                                                                       SP33  10
INTEGER LAY,LIN,PNT#                                                    SP33  11
INTEGER LT#                                                             SP33  12
REAL    X,Y,Z,XX,YY,ZZ,DX,DY,DZ#                                        SP33  13
REAL    ALAY,ALIN,APNT#                                                 SP33  14
REAL    A,B,C,D,AA,DD#                                                  SP33  15
REAL    P(3)#                                                           SP33  16
#                                                                       SP33  17
INTEGER IWNT(24)#                      Wanted items for indexpkt:       SP33  18
INTEGER IREL(25)#                      Pointers for qx                  SP33  19
INTEGER KEY(4)#                        Flag for indexpkt:               SP33  20
INTEGER I,K,J,IPA,IPB,JJP,IIP,IS#                                       SP33  21
INTEGER IP,JP,PSIZ#                                                     SP33  22
#                                                                       SP33  23
REAL    OLDDEN,MINDEN,PATMIN,PATMAX,SMFMIN,SMFMAX#                      SP33  24
REAL    IMFMIN,IMFMAX,WEIGHT,DENS#                                      SP33  25
#                                                                       SP33  26
chardata:(S01," Patterson        Function      : min/max")#             SP33  27
chardata:(S03," Image Seeking Minimum Function : min/max")#             SP33  28
chardata:(S04," Trial atom position(s)")#                               SP33  29
chardata:(S05,"                   x              y              z $#    SP33  30
              weight")#                                                 SP33  31
realdata:(FMT,[1552.,1552.])#                                           SP33  32
realdata:(FMTA,[903.,1552.,1552.,1552.,1552.])#                         SP33  33
#                                                                       SP33  34
datastuff:#                                                             SP33  35
#                                                                       SP33  36
writeline:(1,S04,NS04,3,3)#                                             SP33  37
writeline:(0,S05,NS05,3,3)#                                             SP33  38
DO I=1,NTRIAL#                                                          SP33  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP33  40
BUFOT(1)=FLOAT(I);  BUFOT(2)=TRIAL(I,1); BUFOT(3)=TRIAL(I,2)#           SP33  41
BUFOT(4)=TRIAL(I,3);BUFOT(5)=TRIAL(I,4)#                                SP33  42
LCHROT=1; ncodefld:(BUFOT,1,CHROT,FMTA,5)#                              SP33  43
writeline:(0,0,0,1,3)#                                                  SP33  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP33  45
#                                                                       SP33  46
FILEXT(IOUNIT(3))='MAP'#               Input density map                SP33  47
FILEXT(IOUNIT(4))='IMF'#               Output density map               SP33  48
#                                                                       SP33  49
CALL SP35#                             Lr 21: read map parameters       SP33  50
IF(MAPTYP>3)iquit:(SP3003)#            Only patterson type maps         SP33  51
incrqx:(M5,M4+NP(1)*NP(2)*NP(3),SP2004)# Expand qx                      SP33  52
CALL SP36#                             Lr 22: read map                  SP33  53
#                                                                       SP33  54
# USE ONLY NEGATIVE PART OF MAP, AND INVERT IT                          SP33  55
#                                                                       SP33  56
IF(INEGMAP==yes:)#                                                      SP33  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP33  58
DO I=1,NP(1)*NP(2)*NP(3); patterson:(I)=-patterson:(I)# Invert it       SP33  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP33  60
#                                                                       SP33  61
# MIN/MAX PATTERSON MAP                                                 SP33  62
#                                                                       SP33  63
PATMIN=patterson:(1); PATMAX=patterson:(1)#                             SP33  64
DO I=1,NP(1)*NP(2)*NP(3); PATMIN=MIN(PATMIN,patterson:(I))#             SP33  65
DO I=1,NP(1)*NP(2)*NP(3); PATMAX=MAX(PATMAX,patterson:(I))#             SP33  66
IMFMIN=PATMAX; IMFMAX=PATMIN#          Initialize min/max               SP33  67
#                                                                       SP33  68
# WRITE MINIMUM MAP                                                     SP33  69
# -----------------                                                     SP33  70
#                                                                       SP33  71
# LR21                                                                  SP33  72
#                                                                       SP33  73
#                                                                       SP33  74
copyfile:(3,4,1,20)#                   Copy up to lr20                  SP33  75
readwpkt:(3,21,PSIZ,IPA,0)#                                             SP33  76
writepkt:(4,21,PSIZ,IPB)#              Output packet                    SP33  77
movereal:(QX,IPA+1,QX,IPB+1,PSIZ,1)#   Copy old stuff across            SP33  78
QX(IPB+21)=5.0#                        Change calc type to frel         SP33  79
#                                                                       SP33  80
# LR22                                                                  SP33  81
#                                                                       SP33  82
FOR(LAY=ILAY;LAY<=MLAY;LAY=LAY+NLAY)#  Loop over map sections           SP33  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP33  84
FOR(LIN=ILIN;LIN<=MLIN;LIN=LIN+NLIN)#  Loop over lines per layer        SP33  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SP33  86
readwpkt:(3,22,PSIZ,IP,0)#             Read in next line of layer       SP33  87
writepkt:(4,22,PSIZ,JP)#               Write next line                  SP33  88
#                                                                       SP33  89
FOR(PNT=IPNT;PNT<=MPNT;PNT=PNT+NPNT)#  Loop over points per layer       SP33  90
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SP33  91
P(1)=FLOAT(LAY)/FLOAT(NG(1))#          Convert layer  to fractions      SP33  92
P(2)=FLOAT(LIN)/FLOAT(NG(2))#          Convert down   to fractions      SP33  93
P(3)=FLOAT(PNT)/FLOAT(NG(3))#          Convert acros                    SP33  94
#                                                                       SP33  95
X=P(ISUM(1))#                          Convert to crystal axes          SP33  96
Y=P(ISUM(2))#                                                           SP33  97
Z=P(ISUM(3))#                                                           SP33  98
#                                                                       SP33  99
JJP=JP+(PNT-IPNT+1)#                   Point to qx, i/o                 SP33 100
IIP=IP+(PNT-IPNT+1)#                   Point to qx, i/o                 SP33 101
OLDDEN=QX(IIP)#                        Pick it up                       SP33 102
#                                                                       SP33 103
# MINIMUM FUNCTION                                                      SP33 104
# ----------------                                                      SP33 105
#                                                                       SP33 106
# IMF(X) = MIN P( X-C(S)V ); C(S)V = R(S)V + T(S); V TRIAL ATOM POS     SP33 107
#           S                                                           SP33 108
#                                                                       SP33 109
MINDEN=PATMAX#                         Initialize minimum function      SP33 110
DO I=1,NTRIAL#                         Loop over trial atom positions   SP33 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SP33 112
WEIGHT=TRIAL(I,4)#                                                      SP33 113
FOR(IS=M0;IS<M1A;IS=IS+STEPS)#         Symops, no centering             SP33 114
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SP33 115
DX=TRIAL(I,1);   DY=TRIAL(I,2); DZ=TRIAL(I,3)#                          SP33 116
XX = QX(IS+1)*DX + QX(IS+4)*DY + QX(IS+7)*DZ + QX(IS+10)# X'            SP33 117
YY = QX(IS+2)*DX + QX(IS+5)*DY + QX(IS+8)*DZ + QX(IS+11)# Y'            SP33 118
ZZ = QX(IS+3)*DX + QX(IS+6)*DY + QX(IS+9)*DZ + QX(IS+12)# Z'            SP33 119
XX=XX-X; YY=YY-Y; ZZ=ZZ-Z#                                              SP33 120
CALL SP39(XX,YY,ZZ,DENS)#              Interpolated density(x,y,z)      SP33 121
MINDEN=MIN(MINDEN,DENS/WEIGHT)#                                         SP33 122
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SP33 123
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SP33 124
#                                                                       SP33 125
QX(JJP)=MINDEN#                        Back to i/o buf                  SP33 126
IMFMIN=MIN(IMFMIN,MINDEN); IMFMAX=MAX(IMFMAX,MINDEN)#                   SP33 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SP33 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SP33 129
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP33 130
copyfile:(3,4,23,endrecord:)#          Copy the endrecord:              SP33 131
#                                                                       SP33 132
# REPORT                                                                SP33 133
#                                                                       SP33 134
movechar:(S01,1,CHROT,1,NS01,0)#                                        SP33 135
BUFOT(1)=PATMIN;BUFOT(2)=PATMAX#                                        SP33 136
LCHROT=45; ncodefld:(BUFOT,1,CHROT,FMT,2); writeline:(1,0,0,1,3)#       SP33 137
CHROT(1^34)=' Map is read from               : '#                       SP33 138
CHROT(35^44)=FILENM(IOUNIT(3))#                                         SP33 139
writeline:(0,0,0,1,3)#                                                  SP33 140
movechar:(S03,1,CHROT,1,NS03,0)#                                        SP33 141
BUFOT(1)=IMFMIN;BUFOT(2)=IMFMAX#                                        SP33 142
LCHROT=45; ncodefld:(BUFOT,1,CHROT,FMT,2); writeline:(1,0,0,1,3)# S     SP33 143
CHROT(1^34)=' Map is read from               : '#                       SP33 144
CHROT(35^44)=FILENM(IOUNIT(4))#                                         SP33 145
writeline:(0,0,0,1,3)#                                                  SP33 146
CHROT(1^32)='  8-point interpolation was used'#                         SP33 147
writeline:(0,0,0,1,3)#                                                  SP33 148
#                                                                       SP33 149
RETURN#                                                                 SP33 150
END#                                                                    SP33 151
systemheader:(SP34)#                   Cross vector search for pairs    SP34   1
######################################################################  SP34   2
#                                                                    #  SP34   3
#                               SP34                                 #  SP34   4
#                                                                    #  SP34   5
######################################################################  SP34   6
SUBROUTINE SP34#                                                        SP34   7
include:(AACOMN)#                                                       SP34   8
include:(SPCOMN)#                                                       SP34   9
#                                                                       SP34  10
CHARACTER*10 ATNAM#  ## atnsm                                           SP34  11
#                                                                       SP34  12
INTEGER LAY,LIN,PNT#                                                    SP34  13
REAL    X,Y,Z,XX,YY,ZZ,XXX,YYY,ZZZ,DX,DY,DZ#                            SP34  14
REAL    ALAY,ALIN,APNT#                                                 SP34  15
REAL    A,B,C,D,AA,DD,DDMIN,X1,Y1,Z1,X2,Y2,Z2,XX1,YY1,ZZ1#              SP34  16
REAL    P(3)#                                                           SP34  17
#                                                                       SP34  18
INTEGER IWNT(24)#                      Wanted items for indexpkt:       SP34  19
INTEGER IREL(25)#                      Pointers for qx                  SP34  20
INTEGER KEY(4)#                        Flag for indexpkt:               SP34  21
INTEGER I,K,J,L,M,NN,II,NCROSS,IT1,IT2,IS1,IX,IY,IZ#                    SP34  22
INTEGER IP,JP,PSIZ#                                                     SP34  23
#                                                                       SP34  24
REAL    G1,G2,G3,G5,G6,G9#             Metric tensor                    SP34  25
#                                                                       SP34  26
REAL    MINFUN,SUMIMF,T,PATMIN,PATMAX,DENS#                             SP34  27
#                                                                       SP34  28
datastuff:#                                                             SP34  29
#                                                                       SP34  30
# LRCELL: METRIC TENSOR                                                 SP34  31
# ---------------------                                                 SP34  32
#                                                                       SP34  33
K=0#                                   Prepare to get needed cell i     SP34  34
REPEAT#                                Loop over lrcell packets         SP34  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP34  36
K=K+1#                                 Count packets as they come i     SP34  37
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read in cell record              SP34  38
IF(IP<=0) BREAK#                       Exit after last record           SP34  39
IF(K==7)#                              Metric tensor                    SP34  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP34  41
G1=QX(IP+1)#                           (a)**2                           SP34  42
G2=QX(IP+2)#                           (a)*(b)*cos(g)                   SP34  43
G3=QX(IP+3)#                           (a)*(c)*cos(b)                   SP34  44
G5=QX(IP+5)#                           (b)**2                           SP34  45
G6=QX(IP+6)#                           (b)*(c)*cos(a)                   SP34  46
G9=QX(IP+9)#                           (c)**2                           SP34  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP34  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP34  49
readwpkt:(1,endrecord:,PSIZ,IP,0)#     Close file a                     SP34  50
#                                                                       SP34  51
FILEXT(IOUNIT(3))='MAP'#               Input density map                SP34  52
CALL SP35#                             Lr 21: map parameters            SP34  53
IF(MAPTYP>3)iquit:(SP3003)#            Only patterson type maps         SP34  54
incrqx:(M5,M4+NP(1)*NP(2)*NP(3),SP2004)# Expand qx                      SP34  55
CALL SP36#                             Lr 22: read map                  SP34  56
#                                                                       SP34  57
# MIN/MAX PATTERSON MAP                                                 SP34  58
#                                                                       SP34  59
PATMIN=patterson:(1); PATMAX=patterson:(1)#                             SP34  60
DO I=1,NP(1)*NP(2)*NP(3); PATMIN=MIN(PATMIN,patterson:(I))#             SP34  61
DO I=1,NP(1)*NP(2)*NP(3); PATMAX=MAX(PATMAX,patterson:(I))#             SP34  62
#                                                                       SP34  63
# CROSS VECTOR TABLE                                                    SP34  64
# ------------------                                                    SP34  65
#                                                                       SP34  66
ifsel:(MAC)#                                                            SP34  67
OPEN(UNIT=99,FILE='CROSSWORD.DAT',FORM='FORMATTED',STATUS='REPLACE')#   SP34  68
ifsel:#                                                                 SP34  69
OPEN(UNIT=99,FILE='CROSSWORD.DAT',STATUS='NEW',FORM='FORMATTED')#       SP34  70
endsel:#                                                                SP34  71
DO IT1=1,NTRIAL#                       Trial positions                  SP34  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP34  73
X1=TRIAL(IT1,1)#                                                        SP34  74
Y1=TRIAL(IT1,2)#                                                        SP34  75
Z1=TRIAL(IT1,3)#                                                        SP34  76
FOR(IT2=IT1;IT2>=1;IT2=IT2-1)#         Trial positions                  SP34  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SP34  78
X2=TRIAL(IT2,1)#                                                        SP34  79
Y2=TRIAL(IT2,2)#                                                        SP34  80
Z2=TRIAL(IT2,3)#                                                        SP34  81
#                                                                       SP34  82
#                                                                       SP34  83
#                                                                       SP34  84
MINFUN=1.0E36#                         Initialize minimum function      SP34  85
DDMIN=10000.0#                         Initialize min distance**2       SP34  86
FOR(IS1=M0;IS1<M1B;IS1=IS1+STEPS)#     Space group operators            SP34  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SP34  88
XX1 = QX(IS1+1)*X1 + QX(IS1+4)*Y1 + QX(IS1+7)*Z1 + QX(IS1+10)# X'       SP34  89
YY1 = QX(IS1+2)*X1 + QX(IS1+5)*Y1 + QX(IS1+8)*Z1 + QX(IS1+11)# Y'       SP34  90
ZZ1 = QX(IS1+3)*X1 + QX(IS1+6)*Y1 + QX(IS1+9)*Z1 + QX(IS1+12)# Z'       SP34  91
XXX=XX1-X2; YYY=YY1-Y2; ZZZ=ZZ1-Z2#                                     SP34  92
#                                                                       SP34  93
# MINIMUM PATTERSON VALUE                                               SP34  94
#                                                                       SP34  95
CALL SP39(XXX,YYY,ZZZ,DENS)#           Interpolated density(x,y,z)      SP34  96
MINFUN=MIN(MINFUN,DENS)#                                                SP34  97
#                                                                       SP34  98
# MINIMUM DISTANCE                                                      SP34  99
#                                                                       SP34 100
DO IX=-2,2#                                                             SP34 101
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SP34 102
DO IY=-2,2#                                                             SP34 103
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SP34 104
DO IZ=-2,2#                                                             SP34 105
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SP34 106
DX=XXX+FLOAT(IX); DY=YYY+FLOAT(IY); DZ=ZZZ+FLOAT(IZ)#                   SP34 107
DD = G1*DX*DX +    G5*DY*DY +    G9*DZ*DZ$# Calc distance**2            SP34 108
+ 2.*G2*DX*DY + 2.*G3*DX*DZ + 2.*G6*DY*DZ# Calc distance**2             SP34 109
IF(IT1==IT2 & DD==0.0)NEXT#                                             SP34 110
DDMIN=MIN(DDMIN,DD)#                                                    SP34 111
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SP34 112
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SP34 113
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SP34 114
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SP34 115
#                                                                       SP34 116
WRITE(99,FMT=1000)IT1,CTRIAL(IT1),IT2,CTRIAL(IT2),MINFUN,SQRT(DDMIN)#   SP34 117
1000 FORMAT(2(I3,1X,A10,1X),2(F10.2,1X))#                               SP34 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SP34 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP34 120
CLOSE(99)#                                                              SP34 121
#                                                                       SP34 122
# REPORT                                                                SP34 123
#                                                                       SP34 124
CHROT(1^29)=' Map is read from  xxxxxx.MAP'#                            SP34 125
movechar:(COMPID,1,CHROT,20,6,0); writeline:(1,0,0,1,3)#                SP34 126
#                                                                       SP34 127
RETURN#                                                                 SP34 128
END#                                                                    SP34 129
systemheader:(SP35)#                   Read record 21, map parameters   SP35   1
######################################################################  SP35   2
#                                                                    #  SP35   3
#                               SP35                                 #  SP35   4
#                                                                    #  SP35   5
######################################################################  SP35   6
SUBROUTINE SP35#                                                        SP35   7
include:(AACOMN)#                                                       SP35   8
include:(SPCOMN)#                                                       SP35   9
INTEGER PSIZ,IP,K,IIP#                                                  SP35  10
datastuff:#                                                             SP35  11
#                                                                       SP35  12
readwpkt:(3,21,PSIZ,IP,0)#             Lr 21: map parameters            SP35  13
DO K=1,3#                                                               SP35  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP35  15
IIP=IP+K#                                                               SP35  16
OR(K)=NINT(QX(IIP))#                   Pick up origins                  SP35  17
IN(K)=NINT(QX(IIP+3))#                 Increments along axes            SP35  18
NG(K)=NINT(QX(IIP+6))#                 No. of grid points               SP35  19
NP(K)=NINT(QX(IIP+9))#                 Calculated points                SP35  20
ISUM(K)=NINT(QX(IIP+12))#              Correlations between crystal     SP35  21
JSUM(K)=NINT(QX(IIP+15))#              Axes and calculation axes        SP35  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP35  23
#                                                                       SP35  24
##    COEFF PATT EPAT VECT EMAP FOBS FDIF FCAL WFOB WDIF                SP35  25
##      0    1    2    3    4    5    6    7    8    9                  SP35  26
#                                                                       SP35  27
MAPTYP=NINT(QX(IP+21))#                                                 SP35  28
#                                                                       SP35  29
ILAY=OR(1); NLAY=IN(1); MLAY=(NP(1)-1)*NLAY+ILAY# Set map limits        SP35  30
ILIN=OR(2); NLIN=IN(2); MLIN=(NP(2)-1)*NLIN+ILIN# Set map limits        SP35  31
IPNT=OR(3); NPNT=IN(3); MPNT=(NP(3)-1)*NPNT+IPNT# Set map limits        SP35  32
#                                                                       SP35  33
RETURN#                                                                 SP35  34
END#                                                                    SP35  35
systemheader:(SP36)#                   Read record 22, map              SP36   1
######################################################################  SP36   2
#                                                                    #  SP36   3
#                               SP36                                 #  SP36   4
#                                                                    #  SP36   5
######################################################################  SP36   6
SUBROUTINE SP36#                                                        SP36   7
include:(AACOMN)#                                                       SP36   8
include:(SPCOMN)#                                                       SP36   9
INTEGER IIP,IPIX,PSIZ,IP,LAY,LIN,PNT#                                   SP36  10
REAL    X,Y,Z,P(3)#                                                     SP36  11
datastuff:#                                                             SP36  12
#                                                                       SP36  13
XMINMAP=1000. ;YMINMAP=1000. ;ZMINMAP=1000.#                            SP36  14
XMAXMAP=-1000.;YMAXMAP=-1000.;ZMAXMAP=-1000.#                           SP36  15
#                                                                       SP36  16
IPIX=0#                                                                 SP36  17
FOR(LAY=ILAY;LAY<=MLAY;LAY=LAY+NLAY)#  Loop over map sections           SP36  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP36  19
FOR(LIN=ILIN;LIN<=MLIN;LIN=LIN+NLIN)#  Loop over lines per layer        SP36  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP36  21
readwpkt:(3,22,PSIZ,IP,0)#             Read in next line of layer       SP36  22
IF(IP==0) BREAK#                       Exit when map complete           SP36  23
FOR(PNT=IPNT;PNT<=MPNT;PNT=PNT+NPNT)#  Loop over points per layer       SP36  24
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP36  25
P(1)=FLOAT(LAY)/FLOAT(NG(1))#          Convert layer  to fractions      SP36  26
P(2)=FLOAT(LIN)/FLOAT(NG(2))#          Convert down   to fractions      SP36  27
P(3)=FLOAT(PNT)/FLOAT(NG(3))#          Convert acros                    SP36  28
#                                                                       SP36  29
X=P(ISUM(1))#                          Convert to crystal axes          SP36  30
Y=P(ISUM(2))#                                                           SP36  31
Z=P(ISUM(3))#                                                           SP36  32
#                                                                       SP36  33
XMINMAP=MIN(XMINMAP,X); XMAXMAP=MAX(XMAXMAP,X)# Fractional limits       SP36  34
YMINMAP=MIN(YMINMAP,Y); YMAXMAP=MAX(YMAXMAP,Y)#                         SP36  35
ZMINMAP=MIN(ZMINMAP,Z); ZMAXMAP=MAX(ZMAXMAP,Z)#                         SP36  36
#                                                                       SP36  37
IPIX=IPIX+1#                           Point to qx, patterson           SP36  38
IIP=IP+(PNT-IPNT+1)#                   Point to qx, i/o                 SP36  39
density:(IPIX)=QX(IIP)#                Pick up pixel value              SP36  40
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP36  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP36  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP36  43
readwpkt:(3,endrecord:,PSIZ,IP,0)#     Close file c                     SP36  44
IF(IPIX!=NP(1)*NP(2)*NP(3))iquit:(SP2005)#                              SP36  45
#                                                                       SP36  46
RETURN#                                                                 SP36  47
END#                                                                    SP36  48
systemheader:(SP37)#                   List  symops                     SP37   1
######################################################################  SP37   2
#                                                                    #  SP37   3
#                               SP37                                 #  SP37   4
#                                                                    #  SP37   5
######################################################################  SP37   6
SUBROUTINE SP37(JH,IFLAG)#                                              SP37   7
include:(AACOMN)#                                                       SP37   8
#                                                                       SP37   9
INTEGER I,J,JH,IFLAG#                                                   SP37  10
INTEGER R11,R12,R13,R21,R22,R23,R31,R32,R33,MULT#                       SP37  11
REAL    T1,T2,T3#                                                       SP37  12
REAL    HARKER#                                                         SP37  13
#                                                                       SP37  14
datastuff:#                                                             SP37  15
#                                                                       SP37  16
#  IFLAG=0     DO LIST X,Y,Z                                            SP37  17
#  IFLAG=1     DO LIST X,Y,Z,OCCURENCE                                  SP37  18
#  IFLAG=2     DO LIST X,Y,Z,OCCURENCE,HARKER SUM                       SP37  19
#                                                                       SP37  20
## +2x+2y+2z+0.166, +2x+2y+2z+1/2, +2x+2y+2z+1/2, mult  4               SP37  21
## 123456789a123456789b123456789c123456789d123456789e123456789f         SP37  22
#                                                                       SP37  23
R11=NINT(QX(JH+1)); R12=NINT(QX(JH+4)); R13=NINT(QX(JH+7))#             SP37  24
T1=QX(JH+10)#                                                           SP37  25
R21=NINT(QX(JH+2)); R22=NINT(QX(JH+5)); R23=NINT(QX(JH+8))#             SP37  26
T2=QX(JH+11)#                                                           SP37  27
R31=NINT(QX(JH+3)); R32=NINT(QX(JH+6)); R33=NINT(QX(JH+9))#             SP37  28
T3=QX(JH+12)#                                                           SP37  29
MULT=NINT(QX(JH+13))#                                                   SP37  30
HARKER=QX(JH+14)#                                                       SP37  31
#                                                                       SP37  32
WRITE(CHROT,FMT=999)$#                                                  SP37  33
R11,'x',R12,'y',R13,'z',T1,', ',#                                       SP37  34
R21,'x',R22,'y',R23,'z',T2,', ',#                                       SP37  35
R31,'x',R32,'y',R33,'z',T3,', ',#                                       SP37  36
'occurrence ',MULT,' harker sum ',HARKER#                               SP37  37
999 FORMAT( 3(3((SP,I2),A),(SP,F6.3),A),A,I3,A,E12.6 )#                 SP37  38
DO I=1,3#                                                               SP37  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP37  40
J=INDEX(CHROT,'+0x'); IF(J!=0)CHROT(J^J+2)='   '#                       SP37  41
J=INDEX(CHROT,'+0y'); IF(J!=0)CHROT(J^J+2)='   '#                       SP37  42
J=INDEX(CHROT,'+0z'); IF(J!=0)CHROT(J^J+2)='   '#                       SP37  43
J=INDEX(CHROT,'+1x'); IF(J!=0)CHROT(J^J+2)=' +x'#                       SP37  44
J=INDEX(CHROT,'+1z'); IF(J!=0)CHROT(J^J+2)=' +z'#                       SP37  45
J=INDEX(CHROT,'+1y'); IF(J!=0)CHROT(J^J+2)=' +y'#                       SP37  46
J=INDEX(CHROT,'-1x'); IF(J!=0)CHROT(J^J+2)=' -x'#                       SP37  47
J=INDEX(CHROT,'-1y'); IF(J!=0)CHROT(J^J+2)=' -y'#                       SP37  48
J=INDEX(CHROT,'-1z'); IF(J!=0)CHROT(J^J+2)=' -z'#                       SP37  49
J=INDEX(CHROT,'+0.000'); IF(J!=0)CHROT(J^J+5)='      '#                 SP37  50
J=INDEX(CHROT,'+0.500'); IF(J!=0)CHROT(J^J+5)='  +1/2'#                 SP37  51
J=INDEX(CHROT,'-0.500'); IF(J!=0)CHROT(J^J+5)='  -1/2'#                 SP37  52
J=INDEX(CHROT,'+0.333'); IF(J!=0)CHROT(J^J+5)='  +1/3'#                 SP37  53
J=INDEX(CHROT,'-0.333'); IF(J!=0)CHROT(J^J+5)='  -1/3'#                 SP37  54
J=INDEX(CHROT,'+0.667'); IF(J!=0)CHROT(J^J+5)='  +2/3'#                 SP37  55
J=INDEX(CHROT,'-0.667'); IF(J!=0)CHROT(J^J+5)='  -2/3'#                 SP37  56
J=INDEX(CHROT,'+0.250'); IF(J!=0)CHROT(J^J+5)='  +1/4'#                 SP37  57
J=INDEX(CHROT,'-0.250'); IF(J!=0)CHROT(J^J+5)='  -1/4'#                 SP37  58
J=INDEX(CHROT,'+0.750'); IF(J!=0)CHROT(J^J+5)='  +3/4'#                 SP37  59
J=INDEX(CHROT,'-0.750'); IF(J!=0)CHROT(J^J+5)='  -3/4'#                 SP37  60
J=INDEX(CHROT,'+0.166'); IF(J!=0)CHROT(J^J+5)='  +1/6'#                 SP37  61
J=INDEX(CHROT,'-0.166'); IF(J!=0)CHROT(J^J+5)='  -1/6'#                 SP37  62
J=INDEX(CHROT,'+0.833'); IF(J!=0)CHROT(J^J+5)='  +5/6'#                 SP37  63
J=INDEX(CHROT,'-0.833'); IF(J!=0)CHROT(J^J+5)='  -5/6'#                 SP37  64
J=INDEX(CHROT,'+1.000'); IF(J!=0)CHROT(J^J+5)='    +1'#                 SP37  65
J=INDEX(CHROT,'-1.000'); IF(J!=0)CHROT(J^J+5)='    -1'#                 SP37  66
J=INDEX(CHROT,'               ,')#                                      SP37  67
IF(J!=0)CHROT(J^J+15)='              0,'#                               SP37  68
IF(IFLAG==0)#                          Wipe out multiplicity output     SP37  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP37  70
J=INDEX(CHROT,' occurrence')#                                           SP37  71
IF(J!=0)CHROT(J-1^J+40)='                                          '#   SP37  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP37  73
IF(IFLAG==1)#                          Wipe out harker output           SP37  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP37  75
J=INDEX(CHROT,' harker sum')#                                           SP37  76
IF(J!=0)CHROT(J^J+40)='                                         '#      SP37  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP37  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP37  79
writeline:(0,0,0,1,3)#                                                  SP37  80
#                                                                       SP37  81
RETURN#                                                                 SP37  82
END#                                                                    SP37  83
systemheader:(SP38)#                   Find pointer for el. dens        SP38   1
######################################################################  SP38   2
#                                                                    #  SP38   3
#                               SP38                                 #  SP38   4
#                                                                    #  SP38   5
######################################################################  SP38   6
SUBROUTINE SP38(X,Y,Z,DENS)#                                            SP38   7
include:(AACOMN)#                                                       SP38   8
include:(SPCOMN)#                                                       SP38   9
#                                                                       SP38  10
REAL    X,Y,Z,DENS#                                                     SP38  11
REAL    P(3)#                                                           SP38  12
INTEGER III,JLAY,JLIN,JPNT#                                             SP38  13
datastuff:#                                                             SP38  14
#                                                                       SP38  15
# MAP INTO ASYMMETRIC UNIT                                              SP38  16
#                                                                       SP38  17
CALL SP40(X,Y,Z)#                                                       SP38  18
#                                                                       SP38  19
# TRANSFORM TO LAYER, DOWN, ACROSS                                      SP38  20
#                                                                       SP38  21
P(ISUM(1))=X; P(ISUM(2))=Y; P(ISUM(3))=Z#                               SP38  22
#                                                                       SP38  23
# FIND NEAREST GRID POINT                                               SP38  24
#                                                                       SP38  25
JLAY=NINT(P(1)*FLOAT(NG(1)))#                                           SP38  26
JLIN=NINT(P(2)*FLOAT(NG(2)))#                                           SP38  27
JPNT=NINT(P(3)*FLOAT(NG(3)))#                                           SP38  28
#                                                                       SP38  29
# ADRESS IN DENSITY MACRO FOR GIVEN GRID POINT                          SP38  30
#                                                                       SP38  31
III= ((JLAY-ILAY)/NLAY)*NP(2)*NP(3)$#                                   SP38  32
    +((JLIN-ILIN)/NLIN)*NP(3)$#                                         SP38  33
    +((JPNT-IPNT)/NPNT)$#                                               SP38  34
    +1#                                                                 SP38  35
#                                                                       SP38  36
DENS=density:(III)#                                                     SP38  37
#                                                                       SP38  38
RETURN#                                                                 SP38  39
END#                                                                    SP38  40
systemheader:(SP39)#                   Interpolate density              SP39   1
######################################################################  SP39   2
#                                                                    #  SP39   3
#                               SP39                                 #  SP39   4
#                                                                    #  SP39   5
######################################################################  SP39   6
SUBROUTINE SP39(X,Y,Z,DENS)#                                            SP39   7
include:(AACOMN)#                                                       SP39   8
include:(SPCOMN)#                                                       SP39   9
#                                                                       SP39  10
REAL    X,Y,Z,DENS#                                                     SP39  11
REAL    P(3)#                                                           SP39  12
INTEGER JLAY,JLIN,JPNT#                                                 SP39  13
REAL    RLAY,RLIN,RPNT,PP,QQ,RR#                                        SP39  14
INTEGER IPLAY(4),IPLIN(4),IPPNT(4)#                                     SP39  15
REAL    VLAY(4),VLIN(4),VPNT(4)#                                        SP39  16
REAL    F(4,4,4)#                                                       SP39  17
INTEGER I,J,K,III#                                                      SP39  18
datastuff:#                                                             SP39  19
#                                                                       SP39  20
# MAP INTO ASYMMETRIC UNIT                                              SP39  21
#                                                                       SP39  22
CALL SP40(X,Y,Z)#                                                       SP39  23
#                                                                       SP39  24
# TRANSFORM TO LAYER, DOWN, ACROSS                                      SP39  25
#                                                                       SP39  26
P(ISUM(1))=X; P(ISUM(2))=Y; P(ISUM(3))=Z#                               SP39  27
#                                                                       SP39  28
# EXTACT POSITION IN FRACTIONAL GRID POINTS                             SP39  29
#                                                                       SP39  30
RLAY=P(1)*FLOAT(NG(1));RLIN=P(2)*FLOAT(NG(2));RPNT=P(3)*FLOAT(NG(3))#   SP39  31
#                                                                       SP39  32
# NEAREST DISTANCE TO GRID POINT                                        SP39  33
#                                                                       SP39  34
PP=RLAY-INT(RLAY); QQ=RLIN-INT(RLIN); RR=RPNT-INT(RPNT)#                SP39  35
#                                                                       SP39  36
# 8-POINT LINEAR INTERPOLATION                                          SP39  37
# ++++++++++++++++++++++++++++                                          SP39  38
#                                                                       SP39  39
VLAY(1)=1.0-PP; VLAY(2)=PP#                                             SP39  40
VLIN(1)=1.0-QQ; VLIN(2)=QQ#                                             SP39  41
VPNT(1)=1.0-RR; VPNT(2)=RR#                                             SP39  42
#                                                                       SP39  43
IPLAY(1)=INT(RLAY); IPLAY(2)=INT(RLAY)+1#                               SP39  44
IPLIN(1)=INT(RLIN); IPLIN(2)=INT(RLIN)+1#                               SP39  45
IPPNT(1)=INT(RPNT); IPPNT(2)=INT(RPNT)+1#                               SP39  46
#                                                                       SP39  47
DO I=1,2#                                                               SP39  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP39  49
DO J=1,2#                                                               SP39  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP39  51
DO K=1,2#                                                               SP39  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP39  53
JLAY=IPLAY(I); JLIN=IPLIN(J); JPNT=IPPNT(K)#                            SP39  54
#                                                                       SP39  55
# ADRESS IN DENSITY MACRO FOR GIVEN GRID POINT                          SP39  56
#                                                                       SP39  57
III= ((JLAY-ILAY)/NLAY)*NP(2)*NP(3)$#  Output                           SP39  58
    +((JLIN-ILIN)/NLIN)*NP(3)$#                                         SP39  59
    +((JPNT-IPNT)/NPNT)$#                                               SP39  60
    +1#                                                                 SP39  61
#                                                                       SP39  62
# READ FUNCTION VALUE OF THE 8 GRID NEIGHBOURS                          SP39  63
#                                                                       SP39  64
F(I,J,K)=density:(III)#                                                 SP39  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP39  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP39  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP39  68
#                                                                       SP39  69
DENS=0.0#                                                               SP39  70
DO I=1,2#                                                               SP39  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SP39  72
DO J=1,2#                                                               SP39  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SP39  74
DO K=1,2#                                                               SP39  75
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SP39  76
DENS=DENS+F(I,J,K)*VLAY(I)*VLIN(J)*VPNT(K)#                             SP39  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SP39  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SP39  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SP39  80
#                                                                       SP39  81
RETURN#                                                                 SP39  82
END#                                                                    SP39  83
systemheader:(SP40)#                   Map x,y,z into patt asym unit    SP40   1
######################################################################  SP40   2
#                                                                    #  SP40   3
#                               SP40                                 #  SP40   4
#                                                                    #  SP40   5
######################################################################  SP40   6
SUBROUTINE SP40(X,Y,Z)#                                                 SP40   7
include:(AACOMN)#                                                       SP40   8
include:(SPCOMN)#                                                       SP40   9
#                                                                       SP40  10
REAL    X,Y,Z,X1,Y1,Z1,X2,Y2,Z2#                                        SP40  11
INTEGER IS,IX,IY,IZ,IFL,IFLX,IFLY,IFLZ#                                 SP40  12
datastuff:#                                                             SP40  13
#                                                                       SP40  14
# KEEP WITHIN ONE UNIT CELL                                             SP40  15
#                                                                       SP40  16
WHILE(X<0)X=X+1.0; WHILE(X>1.0)X=X-1.0#                                 SP40  17
WHILE(Y<0)Y=Y+1.0; WHILE(Y>1.0)Y=Y-1.0#                                 SP40  18
WHILE(Z<0)Z=Z+1.0; WHILE(Z>1.0)Z=Z-1.0#                                 SP40  19
#                                                                       SP40  20
# APPLY PATTERSON GROUP OPERATORS AND UNIT CELL SHIFTS                  SP40  21
#                                                                       SP40  22
IFL=no:#                               No equiv. point in asym unit     SP40  23
FOR(IS=M1B;IS<M1D;IS=IS+STEPS)#        Patterson group operators        SP40  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP40  25
X1 = QX(IS+1)*X + QX(IS+4)*Y + QX(IS+7)*Z + QX(IS+10)# X'               SP40  26
Y1 = QX(IS+2)*X + QX(IS+5)*Y + QX(IS+8)*Z + QX(IS+11)# Y'               SP40  27
Z1 = QX(IS+3)*X + QX(IS+6)*Y + QX(IS+9)*Z + QX(IS+12)# Z'               SP40  28
#                                                                       SP40  29
IFLX=no:#                                                               SP40  30
DO IX=-1,1#                            Try x shifts                     SP40  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP40  32
X2=X1+FLOAT(IX)#                       Apply shift                      SP40  33
IF(X2<XMINMAP \ XMAXMAP<X2)NEXT#       Outside limits, next shift       SP40  34
IFLX=yes: ; BREAK#                     Equiv. point in asym unit        SP40  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP40  36
IF(IFLX==no:)NEXT#                     No shift, next symop             SP40  37
#                                                                       SP40  38
IFLY=no:#                                                               SP40  39
DO IY=-1,1#                                                             SP40  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP40  41
Y2=Y1+FLOAT(IY)#                                                        SP40  42
IF(Y2<YMINMAP \ YMAXMAP<Y2)NEXT#                                        SP40  43
IFLY=yes: ; BREAK#                                                      SP40  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP40  45
IF(IFLY==no:)NEXT#                                                      SP40  46
#                                                                       SP40  47
IFLZ=no:#                                                               SP40  48
DO IZ=-1,1#                                                             SP40  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SP40  50
Z2=Z1+FLOAT(IZ)#                                                        SP40  51
IF(Z2<ZMINMAP \ ZMAXMAP<Z2)NEXT#                                        SP40  52
IFLZ=yes: ; BREAK#                                                      SP40  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SP40  54
IF(IFLZ==no:)NEXT#                                                      SP40  55
#                                                                       SP40  56
IFL=yes:; BREAK#                       X,y,z shifts found               SP40  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP40  58
#                                                                       SP40  59
IF(IFL==no:)#                          No point available               SP40  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SP40  61
WRITE(6,*)' '#                                                          SP40  62
WRITE(6,*)' limits of map',$#                                           SP40  63
'                                     point out of range'#              SP40  64
WRITE(6,*)' xmin/xmax     ',XMINMAP,XMAXMAP,X#                          SP40  65
WRITE(6,*)' ymin/ymax     ',YMINMAP,YMAXMAP,Y#                          SP40  66
WRITE(6,*)' zmin/zmax     ',ZMINMAP,ZMAXMAP,Z#                          SP40  67
iquit:(SP4001)#                                                         SP40  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SP40  69
X=X2; Y=Y2; Z=Z2#                      Ok                               SP40  70
#                                                                       SP40  71
RETURN#                                                                 SP40  72
END#                                                                    SP40  73
systemheader:(SP45)#                   Loads symdata into 4*4 matrix    SP45   1
# ################################################################## #  SP45   2
#                                                                    #  SP45   3
#                               SP45                                 #  SP45   4
#                                                                    #  SP45   5
# ################################################################## #  SP45   6
SUBROUTINE SP45(A,IP)#                                                  SP45   7
include:(AACOMN)#                                                       SP45   8
#                                                                       SP45   9
INTEGER A(4,4)#                        4*4 matrix                       SP45  10
INTEGER IP#                            Pointer to qx array              SP45  11
REAL    S(4,4)#                                                         SP45  12
INTEGER I,J#                                                            SP45  13
#                                                                       SP45  14
datastuff:#                                                             SP45  15
#                                                                       SP45  16
# R11 R12 R13 T1                                                        SP45  17
# R21 R22 R23 T2                                                        SP45  18
# R31 R32 R33 T3                                                        SP45  19
#   0   0   0  1                                                        SP45  20
#                                                                       SP45  21
# R11 R21 R31 R12 R22 R32 R13 R23 R33 T1 T2 T3                          SP45  22
#   1   2   3   4   5   6   7   8   9 10 11 12     QX(IP+...)           SP45  23
#                                                                       SP45  24
S(1,1)=QX(IP+ 1);S(1,2)=QX(IP+ 4);S(1,3)=QX(IP+ 7);S(1,4)=QX(IP+10)#    SP45  25
S(2,1)=QX(IP+ 2);S(2,2)=QX(IP+ 5);S(2,3)=QX(IP+ 8);S(2,4)=QX(IP+11)#    SP45  26
S(3,1)=QX(IP+ 3);S(3,2)=QX(IP+ 6);S(3,3)=QX(IP+ 9);S(3,4)=QX(IP+12)#    SP45  27
S(4,1)=0.0      ;S(4,2)=0.0      ;S(4,3)=0.0      ;S(4,4)=1.0#          SP45  28
#                                                                       SP45  29
DO I=1,4; DO J=1,4; A(I,J)=NINT(S(I,J)*12.0)# Convert into twelfths     SP45  30
#                                                                       SP45  31
RETURN#                                                                 SP45  32
END#                                                                    SP45  33
systemheader:(SP46)#                   Multiply matrice*(x,y,z)         SP46   1
# ################################################################## #  SP46   2
#                                                                    #  SP46   3
#                               SP46                                 #  SP46   4
#                                                                    #  SP46   5
# ################################################################## #  SP46   6
SUBROUTINE SP46(X,S,R)#                                                 SP46   7
#                                                                       SP46   8
INTEGER S(4,4)#                        Symmetry matrix in twelfths      SP46   9
REAL    X(3),XX(4)#                    (h,k,l,d)                        SP46  10
REAL    R(3),RR(4)#                    Result vector                    SP46  11
INTEGER I,J#                           Indices                          SP46  12
#                                                                       SP46  13
DO I=1,3; XX(I)=X(I)#                                                   SP46  14
XX(4)=1.0#                                                              SP46  15
#                                                                       SP46  16
DO I=1,4#                                                               SP46  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP46  18
RR(I)=0.0#                             D                                SP46  19
DO J=1,4; RR(I)=RR(I)+FLOAT(S(I,J))*XX(I)#                              SP46  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP46  21
DO I=1,4; RR(I)=RR(I)/12.0#            From twelfths                    SP46  22
#                                                                       SP46  23
DO I=1,3; R(I)=RR(I)#                                                   SP46  24
#                                                                       SP46  25
RETURN#                                                                 SP46  26
END#                                                                    SP46  27
systemheader:(SP47)#                   Multiply (h,k,l,d)*matrice       SP47   1
# ################################################################## #  SP47   2
#                                                                    #  SP47   3
#                               SP47                                 #  SP47   4
#                                                                    #  SP47   5
# ################################################################## #  SP47   6
SUBROUTINE SP47(H,S,R)#                                                 SP47   7
#                                                                       SP47   8
INTEGER S(4,4)#                        Symmetry matrix in twelfths      SP47   9
REAL    H(4)#                          (h,k,l,d)                        SP47  10
REAL    R(4)#                          Result vector                    SP47  11
INTEGER I,J#                           Indices                          SP47  12
#                                                                       SP47  13
DO I=1,4#                                                               SP47  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP47  15
R(I)=0.0#                              D                                SP47  16
DO J=1,4; R(I)=R(I)+H(J)*FLOAT(S(J,I))#                                 SP47  17
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP47  18
DO I=1,4; R(I)=R(I)/12.0#              From twelfths                    SP47  19
#                                                                       SP47  20
RETURN#                                                                 SP47  21
END#                                                                    SP47  22
systemheader:(SP48)#                   Multiply 4*4 matrices            SP48   1
# ################################################################## #  SP48   2
#                                                                    #  SP48   3
#                               SP48                                 #  SP48   4
#                                                                    #  SP48   5
# ################################################################## #  SP48   6
SUBROUTINE SP48(A,B,C)#                                                 SP48   7
#                                                                       SP48   8
INTEGER A(4,4)#                        4*4 matrix in twelfths           SP48   9
INTEGER B(4,4)#                        4*4 matrix in twelfths           SP48  10
INTEGER C(4,4)#                        4*4 matrix in twelfths           SP48  11
INTEGER I,J,L#                         Indices                          SP48  12
#                                                                       SP48  13
DO J=1,4#                                                               SP48  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP48  15
DO I=1,4#                                                               SP48  16
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP48  17
C(I,J)=0#                                                               SP48  18
DO L=1,4; C(I,J)=C(I,J)+B(I,L)*A(L,J)#                                  SP48  19
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP48  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP48  21
DO I=1,4; DO J=1,4; C(I,J)=C(I,J)/12#  Twelfths                         SP48  22
DO I=1,3; IF(C(I,4)<0) C(I,4)=C(I,4)+12# Make positive                  SP48  23
#                                                                       SP48  24
RETURN#                                                                 SP48  25
END#                                                                    SP48  26
systemheader:(SP50)#                   Dump layer to ascii file         SP50   1
######################################################################  SP50   2
#                                                                    #  SP50   3
#                               SP50                                 #  SP50   4
#                                                                    #  SP50   5
######################################################################  SP50   6
SUBROUTINE SP50#                                                        SP50   7
include:(AACOMN)#                                                       SP50   8
include:(SPCOMN)#                                                       SP50   9
#                                                                       SP50  10
REAL    DOTT#                          Function returning real          SP50  11
INTEGER LAY,LIN,PNT#                                                    SP50  12
INTEGER LT#                                                             SP50  13
REAL    X,Y,Z,XX,YY,ZZ#                                                 SP50  14
REAL    A,B,C,ALF,BET,GAM,D,AA,DD#                                      SP50  15
REAL    P(3),G(3,3)#                                                    SP50  16
REAL    LAYMIN,LAYMAX,LINMIN,LINMAX,PNTMIN,PNTMAX#                      SP50  17
#                                                                       SP50  18
INTEGER IWNT(24)#                      Wanted items for indexpkt:       SP50  19
INTEGER IREL(25)#                      Pointers for qx                  SP50  20
INTEGER KEY(4)#                        Flag for indexpkt:               SP50  21
INTEGER II,I,K,J,IX,IY,IZ,L,IIP,III#                                    SP50  22
INTEGER IP,JP,PSIZ#                                                     SP50  23
#                                                                       SP50  24
CHARACTER*1 AXIS(3)#                                                    SP50  25
#                                                                       SP50  26
REAL    OLDDEN,MINDEN,PATMIN,PATMAX,SMFMIN,SMFMAX,WEIGHT#               SP50  27
REAL    DIRCEL(6)#                                                      SP50  28
REAL    ANGLE,COSANG,SINANG,DOWN,ACROSS#                                SP50  29
REAL    MESH(3),SLAY(3),SLIN(3),SPNT(3),SOR(3),VEC(3)#                  SP50  30
REAL    VLAY(3),VLIN(3),VPNT(3)#                                        SP50  31
#                                                                       SP50  32
INTEGER MARKA,MARK1,MARKT,STEPA#                                        SP50  33
REAL    XF(3),XFP(3),XFS(3),LALO,LAHI#                                  SP50  34
#                                                                       SP50  35
string:(NAME,24)#                                                       SP50  36
#                                                                       SP50  37
datastuff:#                                                             SP50  38
#                                                                       SP50  39
IOMARK(1) = QXSTR#                     Start i/o buffer file a          SP50  40
IOMARK(3) = IOMARK(1)+bdfbuf:#         Start i/o buffer file c          SP50  41
IOMARK(4) = IOMARK(3)+bdfbuf:#         Start i/o buffer file d          SP50  42
M0        = IOMARK(4)+bdfbuf:#         Start-1 of symop table           SP50  43
incrqx:(M1,M0,SP2001)#                 Expand qx                        SP50  44
#                                                                       SP50  45
CALL SP31(0)#                          Read symmetry operators          SP50  46
## M2=M3=M4 current max of QX                                           SP50  47
#                                                                       SP50  48
# LRCELL: METRIC TENSOR                                                 SP50  49
# ---------------------                                                 SP50  50
#                                                                       SP50  51
K=0#                                   Prepare to get needed cell i     SP50  52
REPEAT#                                Loop over lrcell packets         SP50  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP50  54
K=K+1#                                 Count packets as they come i     SP50  55
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read in cell record              SP50  56
IF(IP<=0) BREAK#                       Exit after last record           SP50  57
IF(K==1)#                              Direct cell                      SP50  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP50  59
A=QX(IP+1)#                            (a)                              SP50  60
B=QX(IP+2)#                            (b)                              SP50  61
C=QX(IP+3)#                            (c)                              SP50  62
ALF=QX(IP+7)*360.0#                    (alpha)                          SP50  63
BET=QX(IP+8)*360.0#                    (beta)                           SP50  64
GAM=QX(IP+9)*360.0#                    (gamma)                          SP50  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP50  66
IF(K==7)#                              Metric tensor                    SP50  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP50  68
II=0#                                                                   SP50  69
DO I=1,3; DO J=1,3#                                                     SP50  70
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SP50  71
II=II+1; G(I,J)=QX(IP+II)#                                              SP50  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SP50  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP50  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP50  75
#                                                                       SP50  76
# LRATOM: ATOM PARAMETERS                                               SP50  77
# -----------------------                                               SP50  78
#                                                                       SP50  79
MARKA=M2#                              Start atom list                  SP50  80
MARK1=MARKA#                           Pointer to grid points           SP50  81
STEPA=10#                              Step size for atom list          SP50  82
IWNT(1)=1; IWNT(2)=2; IWNT(3)=3; IWNT(4)=14# Set iwnt idnums            SP50  83
KEY(1)=0; KEY(2)=4; KEY(3)=0; KEY(4)=0# Set keya                    c   SP50  84
indexpkt:(1,lratom:,PSIZ,IP,0,KEY,IWNT,IREL)# Search for idnums         SP50  85
IF(KEY(4)>0)#                          Is anything there?               SP50  86
REPEAT#                                Loop over atom packets           SP50  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SP50  88
readwpkt:(1,lratom:,PSIZ,IP,0)#        Point to next atom packet        SP50  89
IF(IP<=0) BREAK#                       Exit after last packet           SP50  90
DO J=1,3; XF(J)=QX(IP+IREL(J))#        Get fractional coords            SP50  91
MARKT=MARK1#                           Set bottom of atom-type          SP50  92
FOR(I=M0; I<M1B; I=I+STEPS)#           Loop over symm matrices          SP50  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SP50  94
DO J=1,3#                              Loop over x,y,z                  SP50  95
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SP50  96
K=I+J-1#                               Point to matrix elements         SP50  97
XFP(J)=XF(1)*QX(K+1)+XF(2)*QX(K+4)+XF(3)*QX(K+7)+QX(K+10)# Transform    SP50  98
XFP(J)=AMOD(XFP(J)+10.,1.)#                                             SP50  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SP50 100
FOR(IX=-2; IX<=2; IX=IX+1)#            Loop over x moves                SP50 101
FOR(IY=-2; IY<=2; IY=IY+1)#            Loop over y moves                SP50 102
FOR(IZ=-2; IZ<=2; IZ=IZ+1)#            Loop over z moves                SP50 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SP50 104
XFS(1)=XFP(1)+FLOAT(IX)#                                                SP50 105
XFS(2)=XFP(2)+FLOAT(IY)#                                                SP50 106
XFS(3)=XFP(3)+FLOAT(IZ)#                                                SP50 107
FOR(J=MARKT; J<MARK1; J=J+STEPA)#      Compare with rest of type        SP50 108
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SP50 109
IF(ABS(XFS(1)-QX(J+1))>0.001) NEXT#    X-coords differ                  SP50 110
IF(ABS(XFS(2)-QX(J+2))>0.001) NEXT#    Y-coords differ                  SP50 111
IF(ABS(XFS(3)-QX(J+3))>0.001) NEXT#    Z-coords differ                  SP50 112
BREAK#                                 No difference found-same ato     SP50 113
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SP50 114
IF(J!=MARK1) NEXT#                     Match found-dont store           SP50 115
incrqx:(MARK1,MARK1+STEPA,CN1113)#     Incrqx.......131113              SP50 116
QX(J+1)=XFS(1)#                        Store x-coord                    SP50 117
QX(J+2)=XFS(2)#                        Store y-coord                    SP50 118
QX(J+3)=XFS(3)#                        Store z-coord                    SP50 119
movertoc:(QX(IP+IREL(4)),1,NAME,1,24,0)# Store atom name                SP50 120
label:(NAME,K,L)#                      Store max label length           SP50 121
movector:(NAME,1,QX(J+5),1,24,0)#      Store atom name in atom list     SP50 122
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SP50 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SP50 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SP50 125
readwpkt:(1,endrecord:,PSIZ,IP,0)#     Close file a                     SP50 126
M4=MARK1# ## M4=MARK1 current max of QX                                 SP50 127
#                                                                       SP50 128
IF(IDUMLAY==1)FILEXT(IOUNIT(3))='MAP'# Input density map                SP50 129
IF(IDUMLAY==2)FILEXT(IOUNIT(3))='SLA'# Input density map                SP50 130
#                                                                       SP50 131
readwpkt:(3,21,PSIZ,IP,0)#             Lr 21: map parameters            SP50 132
DO K=1,3#                                                               SP50 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SP50 134
IIP=IP+K#                                                               SP50 135
OR(K)=NINT(QX(IIP))#                   Pick up origins                  SP50 136
IN(K)=NINT(QX(IIP+3))#                 Increments along axes            SP50 137
NG(K)=NINT(QX(IIP+6))#                 No. of grid points               SP50 138
NP(K)=NINT(QX(IIP+9))#                 Calculated points                SP50 139
ISUM(K)=NINT(QX(IIP+12))#              Correlations between crystal     SP50 140
JSUM(K)=NINT(QX(IIP+15))#              Axes and calculation axes        SP50 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SP50 142
IF(IDUMLAY==2)#                        Slant file                       SP50 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SP50 144
MESH(1)=QX(IP+25); MESH(2)=QX(IP+26); MESH(3)=QX(IP+27)# Angstroem/di   SP50 145
SOR(1)=QX(IP+28);  SOR(2)=QX(IP+29);  SOR(3)=QX(IP+30)# Slant origen    SP50 146
VLAY(1)=QX(IP+31); VLAY(2)=QX(IP+32); VLAY(3)=QX(IP+33)#                SP50 147
VLIN(1)=QX(IP+34); VLIN(2)=QX(IP+35); VLIN(3)=QX(IP+36)#                SP50 148
VPNT(1)=QX(IP+37); VPNT(2)=QX(IP+38); VPNT(3)=QX(IP+39)#                SP50 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SP50 150
#                                                                       SP50 151
ILAY=OR(1); NLAY=IN(1); MLAY=(NP(1)-1)*NLAY+ILAY# Set map limits        SP50 152
ILIN=OR(2); NLIN=IN(2); MLIN=(NP(2)-1)*NLIN+ILIN# Set map limits        SP50 153
IPNT=OR(3); NPNT=IN(3); MPNT=(NP(3)-1)*NPNT+IPNT# Set map limits        SP50 154
#                                                                       SP50 155
IF(IDUMLAY==1)#                                                         SP50 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SP50 157
LAYMIN=FLOAT(ILAY)/FLOAT(NG(1)); LAYMAX=FLOAT(MLAY)/FLOAT(NG(1))#       SP50 158
LINMIN=FLOAT(ILIN)/FLOAT(NG(2)); LINMAX=FLOAT(MLIN)/FLOAT(NG(2))#       SP50 159
PNTMIN=FLOAT(IPNT)/FLOAT(NG(3)); PNTMAX=FLOAT(MPNT)/FLOAT(NG(3))#       SP50 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SP50 161
IF(IDUMLAY==2)#                                                         SP50 162
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SP50 163
LAYMIN=FLOAT(ILAY)*MESH(1); LAYMAX=FLOAT(MLAY)*MESH(1)#                 SP50 164
LINMIN=FLOAT(ILIN)*MESH(2); LINMAX=FLOAT(MLIN)*MESH(2)#                 SP50 165
PNTMIN=FLOAT(IPNT)*MESH(3); PNTMAX=FLOAT(MPNT)*MESH(3)#                 SP50 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SP50 167
#                                                                       SP50 168
incrqx:(M5,M4+NP(1)*NP(2)*NP(3),SP2004)# Expand qx                      SP50 169
CALL SP36#                             Lr 22: read map                  SP50 170
#                                                                       SP50 171
# WRITE LAYER                                                           SP50 172
# -----------                                                           SP50 173
#                                                                       SP50 174
FOR(LAY=ILAY;LAY<=MLAY;LAY=LAY+NLAY)#  Loop over map sections           SP50 175
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SP50 176
IF(LAYNUM==LAY)#                       Layer found                      SP50 177
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SP50 178
#                                                                       SP50 179
P(1)=A; P(2)=B; P(3)=C#                Xyz->layer,down,across           SP50 180
DOWN=P(JSUM(2)); ACROSS=P(JSUM(3))#                                     SP50 181
P(1)=ALF; P(2)=BET; P(3)=GAM; ANGLE=P(JSUM(1))# Xyz->layer,down,acros   SP50 182
COSANG=57.2957795131*COS((180.0-ANGLE)*0.0174532925199)#                SP50 183
SINANG=57.2957795131*SIN((180.0-ANGLE)*0.0174532925199)#                SP50 184
AXIS(1)='x'; AXIS(2)='y'; AXIS(3)='z'#                                  SP50 185
P(1)=FLOAT(LAY)/FLOAT(NG(1))#          Convert layer  to fractions      SP50 186
#                                                                       SP50 187
ifsel:(MAC)#                                                            SP50 188
OPEN(99,FILE='LAYER.DAT',STATUS='REPLACE',FORM='FORMATTED')#            SP50 189
ifsel:#                                                                 SP50 190
OPEN(99,FILE='LAYER.DAT',STATUS='NEW',FORM='FORMATTED')#                SP50 191
endsel:#                                                                SP50 192
WRITE(99,FMT='(A)')        'TITLE'#                                     SP50 193
WRITE(99,FMT='(A)')         TITLE(57^130)#                              SP50 194
WRITE(99,FMT='(A)')        'LAYER'#                                     SP50 195
WRITE(99,FMT='(A,F10.4)')   AXIS(JSUM(1)),P(1)# Xyz->layer,down,acros   SP50 196
WRITE(99,FMT='(A)')        'DOWN'#                                      SP50 197
WRITE(99,FMT='(A,F10.4)')   AXIS(JSUM(2)),DOWN# Xyz->layer,down,acros   SP50 198
WRITE(99,FMT='(A,F10.4)')  'ACROSS'#                                    SP50 199
WRITE(99,FMT='(A,F10.4)')   AXIS(JSUM(3)),ACROSS# Xyz->layer,down,acr   SP50 200
#                                                                       SP50 201
IF(IDUMLAY==1)#                                                         SP50 202
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SP50 203
P(1)=FLOAT(LAY)/FLOAT(NG(1))#          Convert layer  to fractions      SP50 204
LALO=P(1)-LAYTOL*FLOAT(NLAY)/FLOAT(NG(1))# Half a layer                 SP50 205
LAHI=P(1)+LAYTOL*FLOAT(NLAY)/FLOAT(NG(1))# Half a layer                 SP50 206
FOR(J=MARKA; J<MARK1; J=J+STEPA)#      Compare with rest of type        SP50 207
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SP50 208
P(ISUM(1))=QX(J+1)#                    X->layer,down,across             SP50 209
P(ISUM(2))=QX(J+2)#                    Y->layer,down,across             SP50 210
P(ISUM(3))=QX(J+3)#                    Z->layer,down,across             SP50 211
IF(P(1)<LALO   \ LAHI<P(1))NEXT#       Atom outside neighbour layer     SP50 212
IF(P(2)<LINMIN \ LINMAX<P(2))NEXT#     Atom outside line                SP50 213
IF(P(3)<PNTMIN \ PNTMAX<P(3))NEXT#     Atom outside points              SP50 214
movertoc:(QX(J+5),1,NAME,1,LABMAX,0)#  Stuff atom name                  SP50 215
WRITE(99,FMT='(A)')        'ATOM'#                                      SP50 216
WRITE(99,FMT='(A,2F10.4)')  NAME,P(3)*ACROSS-P(2)*DOWN*COSANG,$#        SP50 217
-P(2)*DOWN*SINANG#                                                      SP50 218
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SP50 219
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SP50 220
IF(IDUMLAY==2)#                                                         SP50 221
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SP50 222
LALO=FLOAT(LAY)*MESH(1)-LAYTOL*MESH(1)# Half a layer                    SP50 223
LAHI=FLOAT(LAY)*MESH(1)+LAYTOL*MESH(1)# Half a layer                    SP50 224
FOR(J=MARKA; J<MARK1; J=J+STEPA)#      Compare with rest of type        SP50 225
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SP50 226
VEC(1)=QX(J+1)-SOR(1)#                 X fractional                     SP50 227
VEC(2)=QX(J+2)-SOR(2)#                 Y fractional                     SP50 228
VEC(3)=QX(J+3)-SOR(3)#                 Z fractional                     SP50 229
P(1)=DOTT(VEC,G,VLAY)#                 Layer slant                      SP50 230
P(2)=DOTT(VEC,G,VLIN)#                 Line  slant                      SP50 231
P(3)=DOTT(VEC,G,VPNT)#                 Point slant                      SP50 232
IF(P(1)<=LALO   \ LAHI<=P(1))NEXT#     Atom outside neighbour layer     SP50 233
IF(P(2)<=LINMIN \ LINMAX<=P(2))NEXT#   Atom outside line                SP50 234
IF(P(3)<=PNTMIN \ PNTMAX<=P(3))NEXT#   Atom outside points              SP50 235
movertoc:(QX(J+5),1,NAME,1,LABMAX,0)#  Stuff atom name                  SP50 236
WRITE(99,FMT='(A)')        'ATOM'#                                      SP50 237
WRITE(99,FMT='(A,2F10.4)')  NAME,P(3),-P(2)#                            SP50 238
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SP50 239
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SP50 240
#                                                                       SP50 241
WRITE(99,FMT='(A)')        'MAP'#                                       SP50 242
FOR(LIN=ILIN;LIN<=MLIN;LIN=LIN+NLIN)#  Loop over lines per layer        SP50 243
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SP50 244
FOR(PNT=IPNT;PNT<=MPNT;PNT=PNT+NPNT)#  Loop over points per layer       SP50 245
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SP50 246
III= ((LAY-ILAY)/NLAY)*NP(2)*NP(3)$#                                    SP50 247
    +((LIN-ILIN)/NLIN)*NP(3)$#                                          SP50 248
    +((PNT-IPNT)/NPNT)$#                                                SP50 249
    +1#                                                                 SP50 250
IF(IDUMLAY==1)#                        Map file                         SP50 251
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SP50 252
P(1)=FLOAT(LAY)/FLOAT(NG(1))#          Convert layer  to fractions      SP50 253
P(2)=FLOAT(LIN)/FLOAT(NG(2))#          Convert down   to fractions      SP50 254
P(3)=FLOAT(PNT)/FLOAT(NG(3))#          Convert acros                    SP50 255
WRITE(99,*)(PNT-IPNT)/NPNT+1,(LIN-ILIN)/NLIN+1,$#                       SP50 256
P(3)*ACROSS-P(2)*DOWN*COSANG,-P(2)*DOWN*SINANG,density:(III)#           SP50 257
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SP50 258
IF(IDUMLAY==2)#                        Slant file                       SP50 259
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SP50 260
P(1)=FLOAT(LAY)#                       Convert layer  to fractions      SP50 261
P(2)=FLOAT(LIN)#                       Convert down   to fractions      SP50 262
P(3)=FLOAT(PNT)#                       Convert acros                    SP50 263
P(1)=P(1)*MESH(1)#                     Convert to angstroem             SP50 264
P(2)=P(2)*MESH(2)#                     Convert to angstroem             SP50 265
P(3)=P(3)*MESH(3)#                     Convert to angstroem             SP50 266
WRITE(99,*)(PNT-IPNT)/NPNT+1,(LIN-ILIN)/NLIN+1,# $                      SP50 267
P(3),-P(2),density:(III)#                                               SP50 268
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SP50 269
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SP50 270
#                                                                       SP50 271
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SP50 272
CLOSE(99)#                             Layer found                      SP50 273
#                                                                       SP50 274
IF(IDUMLAY==1)CHROT(1^29)=' Read layer from xxxxxx.MAP'#                SP50 275
IF(IDUMLAY==2)CHROT(1^29)=' Read layer from xxxxxx.SLA'#                SP50 276
movechar:(COMPID,1,CHROT,18,6,0)#                                       SP50 277
writeline:(1,0,0,1,3)#                                                  SP50 278
WRITE(6,*)' '#                                                          SP50 279
WRITE(6,FMT='(A,I4,A)')' Layer ',LAYNUM,$#                              SP50 280
' is written in orthogonal Angstroem co-ordinates to LAYER.DAT'#        SP50 281
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SP50 282
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SP50 283
#                                                                       SP50 284
RETURN#                                                                 SP50 285
END#                                                                    SP50 286
systemheader:(DOTT)#                   Dot product with metric tensor   DOTT   1
######################################################################  DOTT   2
#                                                                    #  DOTT   3
#                               DOTT                                 #  DOTT   4
#                                                                    #  DOTT   5
######################################################################  DOTT   6
REAL FUNCTION DOTT(VEC1,G,VEC2)#                                        DOTT   7
REAL VEC1(3),G(3,3),VEC2(3)#                                            DOTT   8
INTEGER I,J#                                                            DOTT   9
DOTT=0.0#                                                               DOTT  10
DO I=1,3; DO J=1,3#                                                     DOTT  11
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DOTT  12
DOTT=DOTT+G(I,J)*VEC1(I)*VEC2(J)#                                       DOTT  13
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DOTT  14
RETURN#                                                                 DOTT  15
END#                                                                    DOTT  16
systemheader:(SP60)#                   Read external map                SP60   1
######################################################################  SP60   2
#                                                                    #  SP60   3
#                               SP60                                 #  SP60   4
#                                                                    #  SP60   5
######################################################################  SP60   6
SUBROUTINE SP60#                                                        SP60   7
include:(AACOMN)#                                                       SP60   8
include:(SPCOMN)#                                                       SP60   9
#                                                                       SP60  10
INTEGER NXPIX,NYPIX,NZPIX#                                              SP60  11
INTEGER LAY,LIN,PNT#                                                    SP60  12
INTEGER LT#                                                             SP60  13
REAL    X,Y,Z,XX,YY,ZZ#                                                 SP60  14
REAL    ALAY,ALIN,APNT#                                                 SP60  15
REAL    A,B,C,D,AA,DD#                                                  SP60  16
REAL    P(3)#                                                           SP60  17
REAL    MINEXTMAP#                                                      SP60  18
REAL    MAXEXTMAP#                                                      SP60  19
#                                                                       SP60  20
INTEGER IWNT(24)#                      Wanted items for indexpkt:       SP60  21
INTEGER IREL(25)#                      Pointers for qx                  SP60  22
INTEGER KEY(4)#                        Flag for indexpkt:               SP60  23
INTEGER I,K,J,IPA,IPB,IIP,IZ,IY,IX#                                     SP60  24
INTEGER IP,JP,PSIZ#                                                     SP60  25
#                                                                       SP60  26
datastuff:#                                                             SP60  27
#                                                                       SP60  28
# REPORT                                                                SP60  29
#                                                                       SP60  30
CHROT(1^51)=' Map is read from external file:         FOR052.DAT'#      SP60  31
writeline:(1,0,0,1,3)#                                                  SP60  32
CHROT(1^51)=' Map grids and map layout are taken from:xxxxxx.MAP'#      SP60  33
movechar:(COMPID,1,CHROT,42,6,0)#                                       SP60  34
writeline:(1,0,0,1,3)#                                                  SP60  35
CHROT(1^51)=' Map is written to:                      xxxxxx.EXT'#      SP60  36
movechar:(COMPID,1,CHROT,42,6,0)#                                       SP60  37
writeline:(0,0,0,1,3)#                                                  SP60  38
#                                                                       SP60  39
# READ NUMBER OF PIXELS IN EXTERNAL MAP                                 SP60  40
# -------------------------------------                                 SP60  41
#                                                                       SP60  42
READ(52) NXPIX,NYPIX,NZPIX#                                             SP60  43
#                                                                       SP60  44
# ASSIGN MEMORY FOR FILE BUFFERS                                        SP60  45
# ------------------------------                                        SP60  46
#                                                                       SP60  47
IOMARK(1) = QXSTR#                     Start i/o buffer file a          SP60  48
IOMARK(3) = IOMARK(1)+bdfbuf:#         Start i/o buffer file c          SP60  49
IOMARK(4) = IOMARK(3)+bdfbuf:#         Start i/o buffer file d          SP60  50
M0        = IOMARK(4)+bdfbuf:#         Start-1 of symop table           SP60  51
incrqx:(M1,M0,SP2001)#                 Expand qx                        SP60  52
#                                                                       SP60  53
FILEXT(IOUNIT(3))='MAP'#               Input density map                SP60  54
FILEXT(IOUNIT(4))='EXT'#               Output density map               SP60  55
#                                                                       SP60  56
copyfile:(3,4,1,20)#                   Copy up to lr20                  SP60  57
#                                                                       SP60  58
##    COEFF PATT EPAT VECT EMAP FOBS FDIF FCAL WFOB WDIF                SP60  59
##      0    1    2    3    4    5    6    7    8    9                  SP60  60
#                                                                       SP60  61
readwpkt:(3,21,PSIZ,IPA,0)#            Lr 21: map parameters            SP60  62
writepkt:(4,21,PSIZ,IPB)#              Output packet                    SP60  63
movereal:(QX,IPA+1,QX,IPB+1,PSIZ,1)#   Copy old stuff across            SP60  64
QX(IPB+21)=1.0#                        Change calc type to fobs         SP60  65
DO K=1,3#                                                               SP60  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SP60  67
IIP=IPA+K#                                                              SP60  68
OR(K)=NINT(QX(IIP))#                   Pick up origins                  SP60  69
IN(K)=NINT(QX(IIP+3))#                 Increments along axes            SP60  70
NG(K)=NINT(QX(IIP+6))#                 No. of grid points               SP60  71
NP(K)=NINT(QX(IIP+9))#                 Calculated points                SP60  72
ISUM(K)=NINT(QX(IIP+12))#              Correlations between crystal     SP60  73
JSUM(K)=NINT(QX(IIP+15))#              Axes and calculation axes        SP60  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SP60  75
#                                                                       SP60  76
# CHECK CONSISTENCY OF XTAL MAP LAYOUT WITH EXTERNAL MAP                SP60  77
# ------------------------------------------------------                SP60  78
#                                                                       SP60  79
#        LAYER  DOWN  ACROSS  ISUM1  ISUM2  ISUM3  JSUM1  JSUM2  JSUM3  SP60  80
#          X      Y     Z       1      2      3      1      2      3    SP60  81
#          X      Z     Y       1      3      2      1      3      2    SP60  82
#          Y      X     Z       2      1      3      2      1      3    SP60  83
#          Y      Z     X       3      1      2      2      3      1    SP60  84
#          Z      Y     X       3      2      1      3      2      1    SP60  85
#          Z      X     Y       2      3      1      3      1      2    SP60  86
#                                                                       SP60  87
IF(ISUM(1)!=3 \ ISUM(2)!=2 \ ISUM(3)!=1 \ $# Invalid layout             SP60  88
   JSUM(1)!=3 \ JSUM(2)!=2 \ JSUM(3)!=1 \ $#                            SP60  89
     NP(3)!=NXPIX \ NP(2)!=NYPIX \ NP(1)!=NZPIX)#                       SP60  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SP60  91
WRITE(6,*)' '#                                                          SP60  92
WRITE(6,*)'*** INVALID LAYOUT OF XTAL TEMPLATE MAP ***'#                SP60  93
WRITE(6,*)'Produce the correct template map [0...1[ first with'#        SP60  94
WRITE(6,*)' '#                                                          SP60  95
WRITE(6,FMT='(A)')'FOURR PATT'#                                         SP60  96
WRITE(6,FMT='(A,3I4)')'GRID ',NXPIX,NYPIX,NZPIX#                        SP60  97
WRITE(6,FMT='(A,3I4,A)')'LAYOUT ACROSS DOWN LAYER ',#                   SP60  98
NXPIX,NYPIX,NZPIX,' 0 0 0 1 1 1'#                                       SP60  99
WRITE(6,FMT='(A)')'END'#                                                SP60 100
WRITE(6,*)' '#                                                          SP60 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SP60 102
MINEXTMAP = +1000000000.0#                                              SP60 103
MAXEXTMAP = -MINEXTMAP#                                                 SP60 104
#                                                                       SP60 105
# LR22                                                                  SP60 106
#                                                                       SP60 107
DO IZ=1,NZPIX#                         Loop over map sections           SP60 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SP60 109
DO IY=1,NYPIX#                         Loop over lines per layer        SP60 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SP60 111
readwpkt:(3,22,PSIZ,IP,0)#             Read in next line of layer       SP60 112
writepkt:(4,22,PSIZ,JP)#               Write next line                  SP60 113
READ(52) (QX(JP+IX),IX=1,NXPIX)#       [0,1[ fractional co-ordinates    SP60 114
DO IX=1,NXPIX#                                                          SP60 115
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SP60 116
MINEXTMAP = MIN (MINEXTMAP, QX(JP+IX))#                                 SP60 117
MAXEXTMAP = MAX (MAXEXTMAP, QX(JP+IX))#                                 SP60 118
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SP60 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SP60 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SP60 121
copyfile:(3,4,23,endrecord:)#          Copy the endrecord:              SP60 122
#                                                                       SP60 123
WRITE(6,*)' '#                                                          SP60 124
WRITE(6,*)'MIN / MAX:',MINEXTMAP, '      ',MAXEXTMAP#                   SP60 125
WRITE(6,*)' '#                                                          SP60 126
#                                                                       SP60 127
RETURN#                                                                 SP60 128
END#                                                                    SP60 129
systemheader:(ERRM)#                                                    ERRM   1
##                                                                      ERRM   2
## ERROR MESSAGES FOR FILE ERRMES                                       ERRM   3
## ------------------------------                                       ERRM   4
##                                                                      ERRM   5
## SP0000 SHAPE-----------------------------------------------------    ERRM   6
## SP1001 Only one option is allowed, do different runs.                ERRM   7
## SP1002 Write either a CHEMX or a BIOSYM file, but not both.          ERRM   8
## SP2001 Insufficient memory is available for the I/O BUFFER for       ERRM   9
## SP2001 FILE A, C, D, symops, histograms or CHEMX files.              ERRM  10
## SP2002 Symops not on bdf.                                            ERRM  11
## SP2003 Invalid LAYOUT of Map for BIOSYM file,                        ERRM  12
## SP2003 recalculate the MAP with program:                             ERRM  13
## SP2003                                                               ERRM  14
## SP2003 FOURR compid                                                  ERRM  15
## SP2003 GRID ...                                                      ERRM  16
## SP2003 LAYOUT ACROSS DOWN LAYER ...                  .               ERRM  17
## SP2004 Insufficient memory is available for buffering the entire     ERRM  18
## SP2004 map into QX array.                                            ERRM  19
## SP2005 Mismatch in number of expected an read pixels.                ERRM  20
## SP3002 Symops not on bdf.                                            ERRM  21
## SP3003 Only Patterson, E-Patterson and Vectormaps allowed as input   ERRM  22
## SP3003 for Image-seeking (minimum) function.                         ERRM  23
## SP4001 Mapping of x,y,z into asymmetric unit failed, use option      ERRM  24
## SP4001 FULL in FOURR.                                                ERRM  25
pmacro:([no:])#                        Purge xtal system macros         ERRM  26
