systemheader:(VU    )#                                                  VU     1
######################################################################  VU     2
##      Copyright (C) 2000, The Xtal System, The University of        # VU     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # VU     4
## Distributed under the GNU General Public Licence as published by   # VU     5
## the Free Software Foundation, in the hope that it will be useful   # VU     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # VU     7
## for more details.                                                  # VU     8
#                                                                    #  VU     9
#                         *** VUBDF ***                              #  VU    10
#                                                                    #  VU    11
#   PROGRAM FOR VIEWING THE CONTENTS OF THE BINARY DATA FILE         #  VU    12
#                                                                    #  VU    13
######################################################################  VU    14
#                                                                       VU    15
include:(XMACRO)#                                                       VU    16
#                                                                       VU    17
systemheader:(VU00)#                   View bdf contents                VU00   1
######################################################################  VU00   2
#                                                                    #  VU00   3
#                             VU00                                   #  VU00   4
#                                                                    #  VU00   5
######################################################################  VU00   6
SUBROUTINE VU00#                       S.r. hall sept 87                VU00   7
include:(AACOMN)#                                                       VU00   8
#                                                                       VU00   9
INTEGER I,II,IR,J,JJ,K,KR,L,M0,M1,NF,NN#                                VU00  10
INTEGER NR1,NR2,NL1,NL2,NP1,NP2#                                        VU00  11
INTEGER IW,JW,LW,NW,MW,NR,IC,MF#                                        VU00  12
INTEGER LMAX,LTYP,LPAK,NTYP,NPAK#                                       VU00  13
REAL WD,FC,FM(500)#                                                     VU00  14
#                                                                       VU00  15
string:(CH,mxchwd:);    string:(TEMP,3)#                                VU00  16
chardata:(VU0, END )#                                                   VU00  17
chardata:(VU1, FI PR LR NP XF)#                                         VU00  18
chardata:(VU2," Print contents of BDF  ------.---")#                    VU00  19
chardata:(VU3,"    Words")#                                             VU00  20
chardata:(VU4,[" >>>>>>>>> Logical record LENGTH  TYPE  PAKLEN  $#      VU00  21
 in physical record"])#                                                 VU00  22
chardata:(VU5,AB-)#                                                     VU00  23
realdata:(FMT1,[310513.,370513.,450413.])#                              VU00  24
datastuff:#                                                             VU00  25
#                                                                       VU00  26
#    SET DEFAULT VALUES                                                 VU00  27
#    ------------------                                                 VU00  28
#                                                                       VU00  29
NR1=1;    NR2=100000#                  Set default phys. rec. limits    VU00  30
NL1=1;    NL2=decr:(endrecord:)#       Set default logl. rec. limits    VU00  31
NP1=1;    NP2=100#                     Set default packet limits        VU00  32
NF=IOUNIT(8)#                          Device number of bdf h           VU00  33
TEMP=FILEXT(NF)#                       Save file ext of bdf h           VU00  34
FILEXT(NF)=FILEXT(IOUNIT(1))#          Default bdf file is a            VU00  35
KR=no:#                                Phys. rec. range not set         VU00  36
MF=yes:#                               Format memory switched on        VU00  37
#                                                                       VU00  38
#    PROCESS VUBDF LINE                                                 VU00  39
#    ------------------                                                 VU00  40
#                                                                       VU00  41
FOR(I=1;I<=20;I=I+1)#                  Loop over input fields           VU00  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  VU00  43
ifvo:(BUFIN(I)) BREAK#                 Exit on first void field         VU00  44
IF(BUFIN(I)>voidflg:) iquit:(VU0001)#  Exit if not alpha field          VU00  45
stringlim:(I,J,K)#                     Extract string limits            VU00  46
compchar:(CHRIN,J,VU1,2,2,3,NVU1,K)#   Identify alpha field             VU00  47
IF(K==0) iquit:(VU0002)#               Unrecognised input string        VU00  48
#                                                                       VU00  49
IF(K==1)#                              Test if 'file' string            VU00  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  VU00  51
I=I+1#                                 Incr field pointer               VU00  52
IF(BUFIN(I)>voidflg:) iquit:(VU0005)#  File name must not be number     VU00  53
stringlim:(I,J,K);     L=0#            Extract string limits            VU00  54
IF(K==J+1)compchar:(CHRIN,J,VU5,1,1,1,2,L)# Identify single char ext    VU00  55
IF(L>0) FILEXT(NF)=FILEXT(IOUNIT(L))#  If either bdf file a or b        VU00  56
ELSE    FILEXT(NF)=CHRIN(J^K-1)#       Store file extension             VU00  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  VU00  58
#                                                                       VU00  59
ELSE IF(K==2)#                         Test for 'prec' string           VU00  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  VU00  61
I=I+1#                                 Incr field pointer               VU00  62
IF(BUFIN(I)<.5) iquit:(VU0010)#        Strange phys. record number      VU00  63
NR1=NINT(BUFIN(I));    KR=yes:#        Store first phys. rec. number    VU00  64
IF(BUFIN(I+1)>.5)#                     Test for last phys. rec. no.     VU00  65
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  VU00  66
I=I+1;   NR2=NINT(BUFIN(I))#           Store last phys. rec. number     VU00  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  VU00  68
ELSE NR2=NR1#                          Only one phys. rec. requested    VU00  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  VU00  70
#                                                                       VU00  71
ELSE IF(K==3)#                         Test for 'lrec' string           VU00  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  VU00  73
I=I+1#                                 Incr field pointer               VU00  74
IF(BUFIN(I)<.5) iquit:(VU0015)#        Strange log. record number       VU00  75
NL1=NINT(BUFIN(I))#                    Store first log. rec. number     VU00  76
IF(BUFIN(I+1)>.5)#                     Test for last log. rec. no.      VU00  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  VU00  78
I=I+1;   NL2=NINT(BUFIN(I))#           Store last log. rec. number      VU00  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  VU00  80
ELSE NL2=NL1#                          Only one log. rec. requested     VU00  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  VU00  82
#                                                                       VU00  83
ELSE IF(K==4)#                         Test for 'npak' string           VU00  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  VU00  85
I=I+1#                                 Incr field pointer               VU00  86
IF(BUFIN(I)<.5) iquit:(VU0017)#        Strange packet number            VU00  87
NP1=NINT(BUFIN(I))#                    Store first packet number        VU00  88
IF(BUFIN(I+1)>.5)#                     Test for last packet no.         VU00  89
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  VU00  90
I=I+1;   NP2=NINT(BUFIN(I))#           Store last packet number         VU00  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  VU00  92
ELSE NP2=NP1#                          Only one packet requested        VU00  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  VU00  94
#                                                                       VU00  95
ELSE IF(K==5) MF=no:#                  Switch off format memory         VU00  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  VU00  97
#                                                                       VU00  98
M0=QXSTR#                              Set start of bdf buffer          VU00  99
incrqx:(M1,M0+bdfbuf:,VU0020)#         Get memory for buffer            VU00 100
bdfreadopen:(NF)#                      Open the requested bdf           VU00 101
readline:(VU0,NVU0)#                   Skip end line                    VU00 102
NTYP=0#                                Set initial log. rec. type       VU00 103
movechar:(VU5,3,CHROT,2,NVU2-1,2)#     Insert header underline          VU00 104
movechar:(FILENM(NF),1,VU2,25,10,0)#   Insert input file name           VU00 105
writeline:(1,VU2,NVU2,2,3)#            Print header                     VU00 106
#                                                                       VU00 107
#   PROCESS BDF PHYSICAL RECORDS                                        VU00 108
#   ============================                                        VU00 109
#                                                                       VU00 110
DO IR=1,NR2#                           Loop thru physical records       VU00 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  VU00 112
NR=IR-1#                               Set bdf record pointer           VU00 113
bdfread:(NF,NR,(QX(I),I=M0+1,M1))#     Read a bdf physical record       VU00 114
IF(KR==yes:&IR<NR1) NEXT#              Skip unwanted records            VU00 115
IF(KR==yes:) NL1=1#                    Override log. rec. limits        VU00 116
#                                                                       VU00 117
#    PROCESS BDF LOGICAL RECORDS                                        VU00 118
#    ---------------------------                                        VU00 119
#                                                                       VU00 120
FOR(NW=M0;NW<M1;NW=NW+LMAX)#           Loop thru logical records        VU00 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 VU00 122
LMAX=NINT(QX(NW+1))#                   Store words in log. record       VU00 123
IF(LMAX<3) BREAK#                      Exit if phys. rec. finished      VU00 124
LTYP=NINT(QX(NW+2))#                   Store log. rec. type             VU00 125
IF(LTYP<NL1) NEXT#                     Skip if log. rec. unwanted       VU00 126
IF(LTYP>NL2) BREAK#                    Exit if log. rec. finished       VU00 127
IF(LTYP!=NTYP) NPAK=0#                 Reset packet count               VU00 128
LPAK=NINT(QX(NW+3))#                   Store packet size                VU00 129
IF(NPAK>NP2) NEXT#                     Exit if packet limit reached     VU00 130
#                                                                       VU00 131
ncodefld:(QX,NW+1,CHROT,FMT1,3)#       Format log. rec. details         VU00 132
ncodefld:(FLOAT(IR),1,CHROT,660413.,1)# Format phys. rec. number        VU00 133
writeline:(1,VU4,NVU4,2,3)#            Print log. rec. header           VU00 134
writeline:(0,VU3,NVU3,3,3)#            Put subheading 'words'           VU00 135
NTYP=LTYP#                             Set the current record type      VU00 136
DO II=1,LPAK; FM(II)=0.#               Reset stored formats             VU00 137
#                                                                       VU00 138
#   PROCESS BDF PACKETS                                                 VU00 139
#   -------------------                                                 VU00 140
#                                                                       VU00 141
DO MW=4,LMAX,LPAK#                     Loop thru lr packets             VU00 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 VU00 143
NPAK=NPAK+1#                           Count the packets                VU00 144
IF(NPAK<NP1) NEXT#                     Skip if outside limits           VU00 145
IF(NPAK>NP2) BREAK#                    Exit if beyond limits            VU00 146
CHROT(11^11)='>'#                      Insert packet start pointer      VU00 147
LW=NW+MW-1;     IC=12;    NN=LW+1#     Start word & char pointers       VU00 148
#                                                                       VU00 149
DO IW=1,LPAK#                          Loop thru words in packet        VU00 150
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 VU00 151
JW=LW+IW;     FC=0.#                   Increment word pointer           VU00 152
movepakwd:(QX(JW),WD)#                 Store current word               VU00 153
#                                                                       VU00 154
ifsel:(VMS)#                                                            VU00 155
intunpak:(WD,II,0,7)#                  Extract vax mantissa part 1      VU00 156
intunpak:(WD,JJ,7,8)#                  Extract vax exponent             VU00 157
intunpak:(WD,KK,15,1)#                 Extract vax sign bit             VU00 158
IF((II>0&JJ==0)\(II+JJ==0&KK==1))FC=889.# Test for legal fp word        VU00 159
CALL VU10(%REF(WD),CH,I)#              Test if word is character        VU00 160
ifsel:(SLPC)#                                                           VU00 161
intunpak:(WD,I,25,6)#                                                   VU00 162
IF(I==0)#                              Not f.p., test for zero          VU00 163
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 VU00 164
intunpak:(WD,I,0,23)#                                                   VU00 165
IF(I==0) FC=413.#                      Zero, define as integer          VU00 166
ELSE     FC=889.#                      Define as packed integer         VU00 167
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 VU00 168
ELSE CALL VU10(WD,CH,I)#               Test if word is character        VU00 169
ifsel:(UNX)#                                                            VU00 170
CALL VU10(WD,CH,I)#                    Test if word is all character    VU00 171
IF(I<=mxchwd:)#                        If not all character             VU00 172
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 VU00 173
intunpak:(WD,II,23,8)#                 Get ieee fp exponent             VU00 174
IF(II==0 \ II==255) FC=889.#           If not ieee fp, set packed for   VU00 175
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 VU00 176
ifsel:#                                                                 VU00 177
CALL VU10(WD,CH,I)#                    Test if word is character        VU00 178
endsel:#                                                                VU00 179
#                                                                       VU00 180
ifeq:(FC,0.)#                          If format not assigned yet       VU00 181
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 VU00 182
IF(I>mxchwd:) FC=1.#                   Test if all bytes characters     VU00 183
#                                                                       VU00 184
ELSE ifvo:(WD) FC=902.#                Test if voidflg:                 VU00 185
#                                                                       VU00 186
ELSE IF(ABS(WD)<9999.&WD==FLOAT(INT(WD))) FC=413.# Test if integer      VU00 187
#                                                                       VU00 188
ELSE IF((WD>voidflg:&WD<-small:)\$#    Test if floating point           VU00 189
        (WD>small:&WD<large:))#        Test if floating point           VU00 190
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 VU00 191
IF(ABS(WD)<1.)      FC=852.#           Set 5 decimal places             VU00 192
ELSE IF(WD>100000.) FC=812.#           Set 1 decimal places             VU00 193
ELSE                FC=832.#           Set 3 decimal places             VU00 194
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 VU00 195
ELSE                FC=889.#           Assume hexadecimal number        VU00 196
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 VU00 197
#                                                                       VU00 198
IF(MF==yes:&ABS(FC-FM(IW))>0.5)#       Test if new op format            VU00 199
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 VU00 200
II=MOD(FC,10.); JJ=MOD(FM(IW),10.)#    Get new/old format types         VU00 201
IF((II==3 & JJ==2)\$#                  New integer / prev floatpt       VU00 202
   (II==1 & JJ==2)\$#                  New char    / prev floatpt       VU00 203
   (II==3 & JJ==9)\$#                  New integer / prev hex           VU00 204
   (II==2 & JJ==9)\$#                  New floatpt / prev hex           VU00 205
   (II==1 & JJ==9)) FC=FM(IW)#         New char    / prev hex use old   VU00 206
ELSE                FM(IW)=FC#         Reset with new format            VU00 207
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 VU00 208
#                                                                       VU00 209
IF(FC>100.)#                           Test if int, hex or fp           VU00 210
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 VU00 211
IC=IC+INT(FC)/100+1#                   Increment character pointer      VU00 212
FC=FLOAT(IC*10000)+FC#                 Construct format                 VU00 213
ncodefld:(WD,1,CHROT,FC,1)#            Format int, hex or fp            VU00 214
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 VU00 215
ELSE IF(FC>0.5)#                       Test if character word           VU00 216
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 VU00 217
movechar:(CH,1,CHROT,IC+2,mxchwd:,0)#  Put characters to op             VU00 218
IC=IC+mxchwd:#                         Increment character pointer      VU00 219
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 VU00 220
#                                                                       VU00 221
IF(IW==LPAK\IC+9>prtcmax:)#            Test if line is full             VU00 222
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 VU00 223
ncodefld:(FLOAT(NN-M0),1,CHROT,50413.,1)# Format first word count       VU00 224
ncodefld:(FLOAT(JW-M0),1,CHROT,100413.,1)# Format last word count       VU00 225
CHROT(6^6)='-'#                        Store span character             VU00 226
writeline:(0,0,0,1,3)#                 Print line of words              VU00 227
NN=JW+1;   IC=12#                      Reset line pointers              VU00 228
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 VU00 229
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 VU00 230
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 VU00 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 VU00 232
IF(LTYP>NL2) BREAK#                    Exit after last log. rec.        VU00 233
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  VU00 234
bdfclose:(NF)#                         Close the input bdf              VU00 235
FILEXT(NF)=TEMP#                       Replace bdf h extension          VU00 236
#                                                                       VU00 237
RETURN#                                                                 VU00 238
END#                                                                    VU00 239
systemheader:(VU10)#                   Test if character word           VU10   1
######################################################################  VU10   2
#                                                                    #  VU10   3
#                            VU10                                    #  VU10   4
#                                                                    #  VU10   5
######################################################################  VU10   6
SUBROUTINE VU10(CHW,CHC,I)#            S.r. hall sept 87                VU10   7
CHARACTER CHC*(*),CH*1#                                                 VU10   8
INTEGER I#                                                              VU10   9
ifsel:(VMS,MAC)#                                                        VU10  10
LOGICAL*1 CHW(*)#                                                       VU10  11
DO I=1,4; CHC(I^I)=CHAR(CHW(I))#       Transfer word to char string     VU10  12
ifsel:(SIE,MSNT)#                                                       VU10  13
REAL CHW#                                                               VU10  14
movertoc:(CHW,1,CHC,1,mxchwd:,1)#      Transfer word to char string     VU10  15
ifsel:#                                                                 VU10  16
CHARACTER CHW*mxchwd:#                                                  VU10  17
CHC(1^mxchwd:)=CHW(1^mxchwd:)#         Transfer word to char string     VU10  18
endsel:#                                                                VU10  19
FOR(I=1;I<=mxchwd:;I=I+1)#             Loop over characters             VU10  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  VU10  21
CH=CHC(I^I)#                           Transfer one character           VU10  22
IF(CH==' ')#                           Test if a blank                  VU10  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  VU10  24
CHC(I^I)='~';       NEXT#              Replace blank with tilde         VU10  25
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  VU10  26
IF(CH>='A'&CH<='I') NEXT#              Accept within limits             VU10  27
IF(CH>='J'&CH<='R') NEXT#              Accept within limits             VU10  28
IF(CH>='S'&CH<='Z') NEXT#              Accept within limits             VU10  29
IF(CH>='a'&CH<='i') NEXT#              Accept within limits             VU10  30
IF(CH>='j'&CH<='r') NEXT#              Accept within limits             VU10  31
IF(CH>='s'&CH<='z') NEXT#              Accept within limits             VU10  32
IF(CH>='0'&CH<='9') NEXT#              Accept within limits             VU10  33
IF(CH=='/')         NEXT#              Accept within limits             VU10  34
IF(CH=='_')         NEXT#              Accept within limits             VU10  35
IF(CH==':')         NEXT#              Accept within limits             VU10  36
IF(CH=='+')         NEXT#              Accept within limits             VU10  37
IF(CH=='-')         NEXT#              Accept within limits             VU10  38
IF(CH=='(')         NEXT#              Accept within limits             VU10  39
IF(CH==')')         NEXT#              Accept within limits             VU10  40
IF(CH=='*')         NEXT#              Accept within limits             VU10  41
IF(CH==',')         NEXT#              Accept within limits             VU10  42
IF(CH=='.')         NEXT#              Accept within limits             VU10  43
IF(CH=='"')         NEXT#              Accept within limits             VU10  44
IF(CH=='''')        NEXT#              Accept within limits             VU10  45
BREAK#                                 Exit as not character            VU10  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  VU10  47
RETURN#                                                                 VU10  48
END#                                                                    VU10  49
pmacro:([no:])#                                                         VU10  50
