systemheader:(BN    )#                                                  BN     1
####################################################################### BN     2
##      Copyright (C) 2000, The Xtal System, The University of        # BN     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # BN     4
## Distributed under the GNU General Public Licence as published by   # BN     5
## the Free Software Foundation, in the hope that it will be useful   # BN     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # BN     7
## for more details.                                                  # BN     8
##                                                                    # BN     9
##                           *** BONDLA ***                           # BN    10
##                                                                    # BN    11
##  BONDLA produces lists of connected atoms; bond lengths & angles;  # BN    12
##  torsion angles and tables of these values for publication.        # BN    13
##                                                                    # BN    14
####################################################################### BN    15
#                                                                       BN    16
include:(XMACRO)#                                                       BN    17
#                                                                       BN    18
macro:(putline:,writepch:(BUF,80);BUF=' ')#                             BN    19
macro:(dp:,ifelse:(mxbtwd:,32,DOUBLE PRECISION ,REAL ))#                BN    20
macro:(sg:,ifelse:(mxbtwd:,32,SNGL($1),$1))#                            BN    21
macro:(db:,ifelse:(mxbtwd:,32,DBLE($1),$1))#                            BN    22
macro:(dsqrt:,ifelse:(mxbtwd:,32,DSQRT($1),SQRT($1)))#                  BN    23
macro:(dsig1:,ifelse:(mxbtwd:,32,DSIGN(1.0D0,$1),SIGN(1.0,$1)))#        BN    24
macro:(dabs1:,ifelse:(mxbtwd:,32,DABS($1)>1.0D0,ABS($1)>1.0))#          BN    25
macro:(dacos:,ifelse:(mxbtwd:,32,DACOS($1),ACOS($1)))#                  BN    26
macro:(dabs:,ifelse:(mxbtwd:,32,DABS($1),ABS($1)))#                     BN    27
macro:(signt:,ifelse:(mxbtwd:,32,IF($1<0.0D0),IF($1<0.0)))#             BN    28
macro:(name:,incr:(arith:(23,/,mxchwd:)))#                              BN    29
#                                                                       BN    30
extrude:(BNCOMN)#                                                       BN    31
REAL G1,G2,G3,G5,G6,G9#                Coefficients for calc. dist.     BN    32
REAL MXBRAD#                           Maximum bonding radius           BN    33
REAL MXCRAD#                           Maximum contact radius           BN    34
INTEGER MARKR,STEPR,STOPR#             Requested quantities             BN    35
INTEGER MARK2,STEP2,STOP2#             Cell information                 BN    36
INTEGER MARK3,STEP3,STOP3#             Symmetry operations              BN    37
INTEGER MARK4,STEP4,STOP4#             Atom types                       BN    38
INTEGER MARK5,STEP5,STOP5#             Input atom coordinates           BN    39
INTEGER MARK6,STEP6,STOP6#             Coordinates of connected set     BN    40
INTEGER MARK7,STEP7,STOP7#             Centroids of groups              BN    41
INTEGER MARK8,STEP8,STOP8#             Atoms for all connections        BN    42
INTEGER MARK9,STEP9,STOP9#             Contact distances                BN    43
INTEGER ANG#                           Angle printing signal            BN    44
INTEGER BDF#                           Op bdf with distances flag       BN    45
INTEGER BRAC#                          Flag for bracket in pch name     BN    46
INTEGER IDH#                           Signal for dihedral angle ta     BN    47
INTEGER KON#                           Signal for contact dist. tab     BN    48
INTEGER LMAX#                          Max length of atom label strin   BN    49
INTEGER FUL#                           Sig full symmetry flag           BN    50
INTEGER DOB#                           Signal for auto bond lengths     BN    51
INTEGER SORT#                          Signal to sort distances         BN    52
INTEGER NATOM#                         No. of atoms                     BN    53
INTEGER NSYM#                          No. of symops applied            BN    54
INTEGER NTYPE#                         No. of atom types                BN    55
INTEGER SUR#                           Index of unit cell search        BN    56
INTEGER SER#                           Index of cluster search          BN    57
INTEGER PSIZ#                          Bdf packet size                  BN    58
INTEGER IPO#                           Output file packet pointer       BN    59
INTEGER IREL(20)#                      Rel. pos pointers output file    BN    60
INTEGER INM(4)#                        Pointers to atom names           BN    61
INTEGER IXY(4)#                        Pointers to atom coords          BN    62
INTEGER HEXAG#                         Hexagonal flag                   BN    63
INTEGER BCHECK#                        Iucr bond check mode             BN    64
#                                                                       BN    65
CHARACTER*200 ATYPE#                                                    BN    66
#                                                                       BN    67
COMMON/COMIBN/MARKR,STEPR,STOPR,MARK2,STEP2,STOP2,#                     BN    68
MARK3,STEP3,STOP3,MARK4,STEP4,STOP4,MARK5,STEP5,#                       BN    69
STOP5,MARK6,STEP6,STOP6,MARK7,STEP7,STOP7,MARK8,#                       BN    70
STEP8,STOP8,MARK9,STEP9,STOP9,NTYPE,NATOM,#                             BN    71
LMAX,KON,IDH,ANG,FUL,DOB,SUR,SER,BCHECK,#                               BN    72
BDF,BRAC,NSYM,PSIZ,IPO,IREL,SORT,INM,IXY,HEXAG#                         BN    73
COMMON/COMFBN/G1,G2,G3,G5,G6,G9,MXCRAD,MXBRAD#                          BN    74
COMMON/COMCBN/ATYPE#                                                    BN    75
endext:#                                                                BN    76
#                                                                       BN    77
systemheader:(BN00)#                   Main bondla caller               BN00   1
# ################################################################## #  BN00   2
#                                                                    #  BN00   3
#                               BN00                                 #  BN00   4
#                                                                    #  BN00   5
# ################################################################## #  BN00   6
SUBROUTINE BN00#                       S.r.hall 1983                    BN00   7
include:(AACOMN)#                      W.dreissig 1986                  BN00   8
include:(BNCOMN)#                                                       BN00   9
##                                                                      BN00  10
##    Atom list pointers.....                                           BN00  11
##                                                                      BN00  12
##       MARK5        MARK6          Contents                           BN00  13
##       +1           -6          atom type                             BN00  14
##       +2 to 4      -5 to -3    input x,y,z                           BN00  15
##       +5 to 7      -2 to  0    input sigma x,y,z                     BN00  16
##       +8 to 10     +1 to +3    connected x,y,z                       BN00  17
##       +11          +4          group list addr                       BN00  18
##       +12 to +14   +5 to +7    sigma x,y,z of connected sites        BN00  19
##       +15          +8          symop number                          BN00  20
##       +16          +9          translation code (base 555)           BN00  21
##       +17 to +22   +10 to +15  u or uij                              BN00  22
##       +23          +16         population                            BN00  23
##       +25          +18         start of atom name                    BN00  24
##                                                                      BN00  25
#                                                                       BN00  26
FILEXT(IOUNIT(3))='XX1'#               Scratch file of bonds only       BN00  27
FILEXT(IOUNIT(4))='XX2'#               Scratch file of bonds & angles   BN00  28
FILEXT(IOUNIT(5))='PEK'#               Pekpik output file               BN00  29
#                                                                       BN00  30
CALL BN11#                             Initialize & enter ip lines      BN00  31
CALL BN21#                             Read symmetry from bdf           BN00  32
CALL BN25#                             Enter addpek & atrad lines       BN00  33
CALL BN31#                             Find connected atom sets         BN00  34
CALL BN35#                             Generate symmetry connection     BN00  35
CALL BN41#                             List spec posns & symops         BN00  36
WHILE(LINID!=6)#                       Loop over all special tasks      BN00  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN00  38
IF     (LINID==2)  CALL BN55#          Process *bond* request           BN00  39
ELSE IF(LINID==3)  CALL BN61#          Process *angle* request          BN00  40
ELSE IF(LINID==4)  CALL BN65#          Process *dihed* request          BN00  41
ELSE IF(LINID==5)  CALL BN71#          Process *nviron* request         BN00  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN00  43
CALL BN45#                             Tabulate distances & angles      BN00  44
CALL BN51#                             List contact distances           BN00  45
CALL BN75#                             List table of dihedral angles    BN00  46
CALL BN80#                             Punch bonds and angles           BN00  47
#                                                                       BN00  48
RETURN#                                                                 BN00  49
END#                                                                    BN00  50
systemheader:(BN03)#                   Calc bond standard deviation     BN03   1
# ################################################################## #  BN03   2
#                                                                    #  BN03   3
#                               BN03                                 #  BN03   4
#                                                                    #  BN03   5
# ################################################################## #  BN03   6
SUBROUTINE BN03(I,J,DIST,SIGMA)#                                        BN03   7
include:(AACOMN)#                                                       BN03   8
include:(BNCOMN)#                                                       BN03   9
#                                                                       BN03  10
INTEGER I,J,K,L,M,N,NN#                                                 BN03  11
REAL DIST#                             Bond distance                    BN03  12
REAL SIGMA, SIG#                       Std. deviation and its squar     BN03  13
REAL DEL(3)#                           Diff in x,y, and z for two a     BN03  14
REAL D(6)#                             Derivatives wrt cell paramet     BN03  15
REAL DD(3)#                            Derivatives wrt coordinates      BN03  16
#                                                                       BN03  17
N=MARK2+2*STEP2#                       Point to cell parameters         BN03  18
DEL(1)=QX(I+1)-QX(J+1)#                Delta x                          BN03  19
DEL(2)=QX(I+2)-QX(J+2)#                Delta y                          BN03  20
DEL(3)=QX(I+3)-QX(J+3)#                Delta z                          BN03  21
DO M=1,3#                              Loop derivatives                 BN03  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN03  23
D(M)=0.0;     NN=N+M#                                                   BN03  24
DO L=1,3#                              Loop matrix elements             BN03  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN03  26
D(M)=D(M)+DEL(M)*DEL(L)*QX(NN)#                                         BN03  27
NN=NN+3#                                                                BN03  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN03  29
D(M)=D(M)/DIST#                                                         BN03  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN03  31
D(4)=QX(N+1)*DEL(1)*QX(N+2)*DEL(2)/DIST# Find derivs wrt cos of angle   BN03  32
D(5)=QX(N+1)*DEL(1)*QX(N+3)*DEL(3)/DIST#                                BN03  33
D(6)=QX(N+2)*DEL(2)*QX(N+3)*DEL(3)/DIST#                                BN03  34
K=MARK2#                               Find derivs wrt coordinates      BN03  35
DD(1)=(G1*DEL(1)+QX(K+2)*DEL(2)+QX(K+3)*DEL(3))/DIST#                   BN03  36
DD(2)=(QX(K+2)*DEL(1)+G5*DEL(2)+QX(K+6)*DEL(3))/DIST#                   BN03  37
DD(3)=(QX(K+3)*DEL(1)+QX(K+6)*DEL(2)+G9*DEL(3))/DIST#                   BN03  38
#                                                                       BN03  39
# ADD UP ALL THE CONTRIBUTIONS TO THE VARIANCE.                         BN03  40
#                                                                       BN03  41
SIG=0.0#                                                                BN03  42
N=N+STEP2#                             Pointer to cell sigmas           BN03  43
DO M=1,6#                              Loop derivatives                 BN03  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN03  45
NN=N+M#                                                                 BN03  46
ifne:(D(M),0.) SIG=SIG+(QX(NN)*D(M))**2#                                BN03  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN03  48
L=I+4;    NN=J+4#                      Pointers to coordinate sigma     BN03  49
DO M=1,3#                              Loop matrix elements             BN03  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN03  51
L=L+1;   NN=NN+1#                      Incr pointers                    BN03  52
ifne:(DD(M),0.) SIG=SIG+(QX(NN)*DD(M))**2+(QX(L)*DD(M))**2#             BN03  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN03  54
IF(HEXAG==yes:)#                       Add hexagonal correlation term   BN03  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN03  56
SIG=SIG+QX(I+5)*DD(1)*DD(2)*QX(I+6)#   Atom i sigx,y correlation (x2?   BN03  57
SIG=SIG+QX(J+5)*DD(1)*DD(2)*QX(J+6)#   Atom j sigx,y correlation (x2?   BN03  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN03  59
SIGMA=SQRT(SIG)#                                                        BN03  60
#                                                                       BN03  61
RETURN#                                                                 BN03  62
END#                                                                    BN03  63
systemheader:(BN04)#                   Calc angle and sigma             BN04   1
# ################################################################## #  BN04   2
#                                                                    #  BN04   3
#                               BN04                                 #  BN04   4
#                                                                    #  BN04   5
# ################################################################## #  BN04   6
SUBROUTINE BN04(I,J,K,ANGLE,SIGMA)#                                     BN04   7
include:(AACOMN)#                                                       BN04   8
include:(BNCOMN)#                                                       BN04   9
#                                                                       BN04  10
INTEGER I,J,K,L,M,N#                                                    BN04  11
INTEGER KK,KL,LK,NK#                                                    BN04  12
REAL A(9)#                             Coordinates of 3 bonded atom     BN04  13
REAL B(9)#                             Sigmas for coordinates           BN04  14
REAL ANGLE#                            Included angle in degrees        BN04  15
REAL SIGMA#                            Sigma of angle                   BN04  16
REAL VAR#                              Variance of angle                BN04  17
REAL ANGR#                             Angle in radians                 BN04  18
REAL ANGP#                             Perturbed angle                  BN04  19
REAL SAVE(6)#                          Temporary holding place for      BN04  20
REAL AB,AC,BC#                         Cell dimension products          BN04  21
REAL ADIM,BDIM,CDIM#                   Cell dimensions                  BN04  22
realdata:(IP1,[$#                                                       BN04  23
0.01,.01,.01,0.,0.,0.,0.,.01,0.,.01,.01,0.,0.,0.,.01,0.,.01,.01])#      BN04  24
intdata:(IP2,[4,2,0])#                                                  BN04  25
realdata:(IP3,[.01,0.,0.,0.,.01,0.,0.,0.,.01])#                         BN04  26
datastuff:#                                                             BN04  27
#                                                                       BN04  28
#    PUT COORDS & SIGMAS IN LOCAL                                       BN04  29
#    ----------------------------                                       BN04  30
#                                                                       BN04  31
A(1)=QX(I+1) ; B(1)=QX(I+5)#           Transfer coords and sigmas t     BN04  32
A(2)=QX(I+2) ; B(2)=QX(I+6)#           Local storage                    BN04  33
A(3)=QX(I+3) ; B(3)=QX(I+7)#                                            BN04  34
A(4)=QX(J+1) ; B(4)=QX(J+5)#                                            BN04  35
A(5)=QX(J+2) ; B(5)=QX(J+6)#                                            BN04  36
A(6)=QX(J+3) ; B(6)=QX(J+7)#                                            BN04  37
A(7)=QX(K+1) ; B(7)=QX(K+5)#                                            BN04  38
A(8)=QX(K+2) ; B(8)=QX(K+6)#                                            BN04  39
A(9)=QX(K+3) ; B(9)=QX(K+7)#                                            BN04  40
CALL BN05(A(1),A(4),A(7),ANGR)#        Calculate the angle              BN04  41
ANGLE=57.29578*ANGR#                   Convert radians to degrees       BN04  42
#                                                                       BN04  43
#   ALLOW FOR ANGLE OF PI                                               BN04  44
#   ---------------------                                               BN04  45
#                                                                       BN04  46
IF ((ANGR<=0.0050)\(ANGR>3.13659))#    0 or 180 degrees                 BN04  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN04  48
L=0#                                   Initialize counter               BN04  49
DO M=1,3;ifeq:(B(3+M),0.0)L=L+1#       Central atom special pos test    BN04  50
IF(L>1)#                               Exclude mirrors                  BN04  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN04  52
SIGMA =0.0#                            2-fold or -1 symmetry            BN04  53
GOTO 100#                              Skip sigma calculations          BN04  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN04  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN04  56
L=0#                                   Initialize shift counter         BN04  57
WHILE ((ANGR<=0.0050)\(ANGR>3.13659))#                                  BN04  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN04  59
L=L+1#                                                                  BN04  60
IF(L>1000) BREAK#                                                       BN04  61
A(7)=A(7)+0.00001#                                                      BN04  62
A(8)=A(8)+0.00001#                                                      BN04  63
A(9)=A(9)+0.00001#                                                      BN04  64
CALL BN05(A(1),A(4),A(7),ANGR)#                                         BN04  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN04  66
#                                                                       BN04  67
#                                                                       BN04  68
#    CALCULATE SIGMA OF ANGLE                                           BN04  69
#    ------------------------                                           BN04  70
#                                                                       BN04  71
#IF(SIGMA<(-.5)) SIGMA=0.#              NO SIGMA REQUESTED              BN04  72
#ELSE#                                  CALCULATE SIGMA OF ANGLE        BN04  73
#$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>>   BN04  74
# # ************* COORD SIGMAS                                          BN04  75
VAR=0.0#                               Initialize the variance          BN04  76
DO L=1,9#                              Derivs wrt coords of three a     BN04  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN04  78
SAVE(1)=A(L)#                          Reserve real coordinate          BN04  79
A(L)=A(L)+0.01*B(L)#                   Add a shift                      BN04  80
CALL BN05(A(1),A(4),A(7),ANGP)#        Calc. perturbed angle            BN04  81
VAR=VAR+(ANGP-ANGR)**2#                Add contribution to variance     BN04  82
A(L)=SAVE(1)#                          Restore coordinate               BN04  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN04  84
N=MARK2+2*STEP2#                       Set pointers for cell coeff.     BN04  85
L=MARK2+3*STEP2#                       And sigmas                       BN04  86
SAVE(1)=G1#                                                             BN04  87
SAVE(2)=G2#                                                             BN04  88
SAVE(3)=G3#                                                             BN04  89
SAVE(4)=G5#                                                             BN04  90
SAVE(5)=G6#                                                             BN04  91
SAVE(6)=G9#                                                             BN04  92
#                                                                       BN04  93
# # ************ A,B,C SIGMAS                                           BN04  94
ADIM=QX(N+1)#                                                           BN04  95
BDIM=QX(N+5)#                                                           BN04  96
CDIM=QX(N+9)#                                                           BN04  97
AB=ADIM*BDIM#                                                           BN04  98
AC=ADIM*CDIM#                                                           BN04  99
BC=BDIM*CDIM#                                                           BN04 100
KL=0#                                                                   BN04 101
DO KK=1,18,6#                          Derivs wrt a, b, c               BN04 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN04 103
KL=KL+1#                                                                BN04 104
LK=L+KL#                                                                BN04 105
G1=SAVE(1)+IP1(KK)*(2.*ADIM*QX(LK)+QX(LK)**2)#                          BN04 106
NK=N+IP2(KL)#                                                           BN04 107
G2=SAVE(2)+IP1(KK+1)*(QX(NK)*QX(LK))#                                   BN04 108
G3=SAVE(3)+IP1(KK+2)*(QX(NK+3)*QX(LK))##                                BN04 109
G5=SAVE(4)+IP1(KK+3)*(2.*BDIM*QX(LK)+QX(LK)**2)#                        BN04 110
G6=SAVE(5)+IP1(KK+4)*(QX(NK+6)*QX(LK))##                                BN04 111
G9=SAVE(6)+IP1(KK+5)*(2.*CDIM*QX(LK)+QX(LK)**2)#                        BN04 112
CALL BN05(A(1),A(4),A(7),ANGP)#                                         BN04 113
VAR=VAR+(ANGP-ANGR)**2#                                                 BN04 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN04 115
G1=SAVE(1)#                            Restore g's                      BN04 116
G5=SAVE(4)#                                                             BN04 117
G9=SAVE(6)#                                                             BN04 118
#                                                                       BN04 119
# ************* COSINE SIGMAS                                           BN04 120
KL=3#                                                                   BN04 121
DO KK=1,9,3#                                                            BN04 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN04 123
KL=KL+1#                                                                BN04 124
LK=L+KL#                                                                BN04 125
G2=SAVE(2)+IP3(KK)*BC*QX(LK)#                                           BN04 126
G3=SAVE(3)+IP3(KK+1)*AC*QX(LK)#                                         BN04 127
G6=SAVE(5)+IP3(KK+2)*AB*QX(LK)#                                         BN04 128
CALL BN05(A(1),A(4),A(7),ANGP)#                                         BN04 129
VAR=VAR+(ANGP-ANGR)**2#                                                 BN04 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN04 131
G2=SAVE(2)#                                                             BN04 132
G3=SAVE(3)#                                                             BN04 133
G6=SAVE(5)#                                                             BN04 134
SIGMA=5729.58*SQRT(VAR)#                                                BN04 135
#$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<    BN04 136
#                                                                       BN04 137
100 CONTINUE#                                                           BN04 138
RETURN#                                                                 BN04 139
END#                                                                    BN04 140
systemheader:(BN05)#                   Calculate the included angle     BN05   1
# ################################################################## #  BN05   2
#                                                                    #  BN05   3
#                               BN05                                 #  BN05   4
#                                                                    #  BN05   5
# ################################################################## #  BN05   6
SUBROUTINE BN05(A,B,C,ANGP)#           I-j-k  doherty 1-80              BN05   7
include:(AACOMN)#                                                       BN05   8
include:(BNCOMN)#                                                       BN05   9
#                                                                       BN05  10
REAL A(3),B(3),C(3)#                   Coordinates of three atoms       BN05  11
REAL ANGP#                             Included angle                   BN05  12
dp: U,V,W#                             Distances between atoms          BN05  13
REAL COSN#                             Cosine of included angle         BN05  14
dp: D1,D2,D3#                                                           BN05  15
dp: Q1,Q2,Q3,Q5,Q6,Q9#                                                  BN05  16
#                                                                       BN05  17
Q1=db:(G1); Q2=db:(G2); Q3=db:(G3)#    Convert metric to d.p.           BN05  18
Q5=db:(G5); Q6=db:(G6); Q9=db:(G9)#                                     BN05  19
D1=db:(A(1)-B(1))#                     Get delta x in d.p.              BN05  20
D2=db:(A(2)-B(2))#                     Delta y                          BN05  21
D3=db:(A(3)-B(3))#                     And delta z                      BN05  22
#                                                                       BN05  23
U=Q1*D1*D1+Q5*D2*D2+Q9*D3*D3+$#        Calc distance squared            BN05  24
  Q2*D1*D2+Q3*D1*D3+Q6*D2*D3#                                           BN05  25
#                                                                       BN05  26
D1=db:(A(1)-C(1))#                     Get delta x in d.p.              BN05  27
D2=db:(A(2)-C(2))#                     Delta y                          BN05  28
D3=db:(A(3)-C(3))#                     And delta z                      BN05  29
#                                                                       BN05  30
V=Q1*D1*D1+Q5*D2*D2+Q9*D3*D3+$#        Calc distance squared            BN05  31
  Q2*D1*D2+Q3*D1*D3+Q6*D2*D3#                                           BN05  32
#                                                                       BN05  33
D1=db:(C(1)-B(1))#                     Get delta x in d.p.              BN05  34
D2=db:(C(2)-B(2))#                     Delta y                          BN05  35
D3=db:(C(3)-B(3))#                     And delta z                      BN05  36
#                                                                       BN05  37
W=Q1*D1*D1+Q5*D2*D2+Q9*D3*D3+$#        Calc distance squared            BN05  38
  Q2*D1*D2+Q3*D1*D3+Q6*D2*D3#                                           BN05  39
#                                                                       BN05  40
#   CALCULATE INCLUDED ANGLE                                            BN05  41
#   ------------------------                                            BN05  42
#                                                                       BN05  43
COSN=sg:((V-U-W)/(-2.*dsqrt:(U*W)))#   Find the cosine of angle 1-2     BN05  44
IF(ABS(COSN)<=0.999999) ANGP=ACOS(COSN)# Calc angle in radians          BN05  45
ELSE IF(COSN>0.0)       ANGP=0.0#      Set to 0 deg                     BN05  46
ELSE                    ANGP=3.1415927## Set to 180 deg                 BN05  47
#                                                                       BN05  48
RETURN#                                                                 BN05  49
END#                                                                    BN05  50
systemheader:(BN06)#                   Calc dihedral angle & sigma      BN06   1
# ################################################################## #  BN06   2
#                                                                    #  BN06   3
#                               BN06                                 #  BN06   4
#                                                                    #  BN06   5
# ################################################################## #  BN06   6
SUBROUTINE BN06(J1,J2,J3,J4,ANGLE,SIGMA)# R.doherty 1980                BN06   7
include:(AACOMN)#                      S.r. hall 1983                   BN06   8
include:(BNCOMN)#                      W.dreissig 1986                  BN06   9
#                                                                       BN06  10
dp: A(4,3)#                            Coords of atoms in orthog co     BN06  11
dp: V1,V2,V3,V4,V5,V6,V7,V8,V9#        Interatomic vectors              BN06  12
dp: C1,C2,C3,C4,C5,C6#                 Cross product vectors            BN06  13
dp: COSD#                              Cosine of dihedral angle         BN06  14
REAL ANGLE,TEST,T#                     Dihedral angle                   BN06  15
REAL SIGMA#                                                             BN06  16
INTEGER I,J,K,L,M,MARK,N#                                               BN06  17
INTEGER J1,J2,J3,J4,IATOM(4)#                                           BN06  18
#                                                                       BN06  19
#    LOOP OVER TRANSFORMATION MATRICES                                  BN06  20
#    ---------------------------------                                  BN06  21
#                                                                       BN06  22
IATOM(1)=J1;IATOM(2)=J2;IATOM(3)=J3;IATOM(4)=J4# Store addresses        BN06  23
SIGMA=0.#                              Zero initial sigma               BN06  24
MARK=MARK2+STEP2*4#                    Point to start transf matrix     BN06  25
FOR(K=MARK;K<STOP2;K=K+STEP2)#         Loop over transf matrices        BN06  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN06  27
#                                                                       BN06  28
DO I=1,4#                              Loop over four atoms             BN06  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN06  30
J=IATOM(I)#                            Get atom address                 BN06  31
A(I,1)=db:(QX(K+1)*QX(J+1))#           Calc x'                          BN06  32
A(I,2)=db:(QX(K+2)*QX(J+1)+QX(K+5)*QX(J+2))# Calc y'                    BN06  33
A(I,3)=db:(QX(K+3)*QX(J+1)+QX(K+6)*QX(J+2)+QX(K+9)*QX(J+3))# Calc z'    BN06  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN06  35
#                                                                       BN06  36
V1=A(1,1)-A(2,1)#                      Vector 2-1                       BN06  37
V2=A(1,2)-A(2,2)#                                                       BN06  38
V3=A(1,3)-A(2,3)#                                                       BN06  39
V4=A(2,1)-A(3,1)#                      Vector 2-3                       BN06  40
V5=A(2,2)-A(3,2)#                                                       BN06  41
V6=A(2,3)-A(3,3)#                                                       BN06  42
V7=A(3,1)-A(4,1)#                      Vector 3-4                       BN06  43
V8=A(3,2)-A(4,2)#                                                       BN06  44
V9=A(3,3)-A(4,3)#                                                       BN06  45
C1=V2*V6-V3*V5#                        2-1 x 2-3                        BN06  46
C2=V3*V4-V1*V6#                                                         BN06  47
C3=V1*V5-V2*V4#                                                         BN06  48
C4=V6*V8-V5*V9#                        3-4 x 2-3                        BN06  49
C5=V4*V9-V6*V7#                                                         BN06  50
C6=V5*V7-V4*V8#                                                         BN06  51
COSD=dsqrt:((C1*C1$+C2*C2+C3*C3)*(C4*C4+C5*C5+C6*C6))# Norm factor      BN06  52
IF(COSD==0.0) COSD=1.0#                Protect collinear                BN06  53
COSD=(C1*C4+C2*C5+C3*C6)/COSD#         Cosine of dihedral angle         BN06  54
IF(dabs1:(COSD)) COSD=dsig1:(COSD)#                                     BN06  55
TEST=180.-57.2958*sg:(dacos:(COSD))#   Calc dihedral angle degr         BN06  56
IF(K==MARK) ANGLE=TEST#                Store dihedral angle             BN06  57
ELSE SIGMA=SIGMA+(ANGLE-TEST)**2#      Sum diff squared                 BN06  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN06  59
#                                                                       BN06  60
#    ADD COORD SIGMA CONTRIBUTION                                       BN06  61
#    ----------------------------                                       BN06  62
#                                                                       BN06  63
K=MARK2+STEP2*4#                       Point to transf matrix           BN06  64
DO N=1,4#                              Loop over four atoms             BN06  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN06  66
DO M=1,3#                              Loop over x,y,z                  BN06  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN06  68
L=IATOM(N)+M;   T=QX(L)#               Point to coordinate              BN06  69
QX(L)=QX(L)+0.01*QX(L+4)#              Shift coord by sigma/100         BN06  70
#                                                                       BN06  71
DO I=1,4#                              Loop over four atoms             BN06  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN06  73
J=IATOM(I)#                            Get atom address                 BN06  74
A(I,1)=db:(QX(K+1)*QX(J+1))#           Calc x'                          BN06  75
A(I,2)=db:(QX(K+2)*QX(J+1)+QX(K+5)*QX(J+2))# Calc y'                    BN06  76
A(I,3)=db:(QX(K+3)*QX(J+1)+QX(K+6)*QX(J+2)+QX(K+9)*QX(J+3))# Calc z'    BN06  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN06  78
QX(L)=T#                               Reset original coord             BN06  79
#                                                                       BN06  80
V1=A(1,1)-A(2,1)#                      Vector 2-1                       BN06  81
V2=A(1,2)-A(2,2)#                                                       BN06  82
V3=A(1,3)-A(2,3)#                                                       BN06  83
V4=A(2,1)-A(3,1)#                      Vector 2-3                       BN06  84
V5=A(2,2)-A(3,2)#                                                       BN06  85
V6=A(2,3)-A(3,3)#                                                       BN06  86
V7=A(3,1)-A(4,1)#                      Vector 3-4                       BN06  87
V8=A(3,2)-A(4,2)#                                                       BN06  88
V9=A(3,3)-A(4,3)#                                                       BN06  89
C1=V2*V6-V3*V5#                        2-1 x 2-3                        BN06  90
C2=V3*V4-V1*V6#                                                         BN06  91
C3=V1*V5-V2*V4#                                                         BN06  92
C4=V6*V8-V5*V9#                        3-4 x 2-3                        BN06  93
C5=V4*V9-V6*V7#                                                         BN06  94
C6=V5*V7-V4*V8#                                                         BN06  95
COSD=dsqrt:((C1*C1$+C2*C2+C3*C3)*(C4*C4+C5*C5+C6*C6))# Normalisation    BN06  96
IF(COSD==0.0) COSD=1.0#                Protect collinear                BN06  97
COSD=(C1*C4+C2*C5+C3*C6)/COSD#         Cosine of dihedral angle         BN06  98
IF(dabs1:(COSD)) COSD=dsig1:(COSD)#                                     BN06  99
TEST=180.-57.2958*sg:(dacos:(COSD))#   Calc dihedral angle degr         BN06 100
SIGMA=SIGMA+(ANGLE-TEST)**2#           Sum diff squared                 BN06 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN06 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN06 103
SIGMA=SQRT(SIGMA)*100.#                Calculate sigma                  BN06 104
#                                                                       BN06 105
#   PLACE ANGLE IN PROPER QUADRANT                                      BN06 106
#   ------------------------------                                      BN06 107
#                                                                       BN06 108
COSD=(C2*C6-C3*C5)*V4+(C3*C4-C1*C6)*V5+(C1*C5-C2*C4)*V6# Calc cosine    BN06 109
signt:(COSD)   ANGLE=-ANGLE#           Reverse angle if cos negative    BN06 110
IF(ANGLE>180.) ANGLE=ANGLE-360.#       Angles > pi are -ve              BN06 111
#                                                                       BN06 112
RETURN#                                                                 BN06 113
END#                                                                    BN06 114
systemheader:(BN07)#     ## Process bond/angle/dihed/nviron line data   BN07   1
# ################################################################## #  BN07   2
#                                                                    #  BN07   3
#                               BN07                                 #  BN07   4
#                                                                    #  BN07   5
# ################################################################## #  BN07   6
SUBROUTINE BN07(NATM,IP)#              S.r.hall 1989                    BN07   7
include:(AACOMN)#                                                       BN07   8
include:(BNCOMN)#                                                       BN07   9
#                                                                       BN07  10
INTEGER I,J,K,L,M,N,IP,NATM#                                            BN07  11
string:(NAME,24)#                                                       BN07  12
string:(TEST,24)#                                                       BN07  13
datastuff:#                                                             BN07  14
#                                                                       BN07  15
IP=STOPR#                              Start the atom list              BN07  16
DO I=1,NATM#                           Loop over atom sites             BN07  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN07  18
L=STOPR#                               Start the atom array             BN07  19
incrqx:(STOPR,STOPR+STEPR,BN0702)#     Start the atom array             BN07  20
IF(BUFIN(I)>=voidflg:) iquit:(BN0701)# Atom name is missing             BN07  21
stringlim:(I,M,N)#                     Get ip name limit                BN07  22
NAME=CHRIP(M^N)#                       Get atom label                   BN07  23
FOR(J=MARK6;J<STOP6;J=J+STEP6)#        Loop over transf atom list       BN07  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN07  25
movertoc:(QX(J+18),1,TEST,1,24,0)#     Extract atom name                BN07  26
IF(NAME==TEST) BREAK#                  Exit when names match            BN07  27
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN07  28
IF(J>=STOP6) iquit:(BN0703)#           Atom name not recognised         BN07  29
movereal:(QX,J-5,QX,L+1,3,1)#          Transfer ip atom coords          BN07  30
movereal:(QX,J-2,QX,L+5,3,1)#          Transfer ip atom sigmas          BN07  31
movector:(NAME,1,QX(L+10),1,24,0)#     Transfer atom name into array    BN07  32
IF(BUFIN(I+NATM)>1.)#                  Has symop been entered           BN07  33
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN07  34
K=MARK3+NINT(BUFIN(I+NATM)-1.)*STEP3#  Setup the symop pointer          BN07  35
QX(L+1)=QX(K+1)*QX(J-5)+QX(K+4)*QX(J-4)+QX(K+7)*QX(J-3)+QX(K+10)# X'    BN07  36
QX(L+2)=QX(K+2)*QX(J-5)+QX(K+5)*QX(J-4)+QX(K+8)*QX(J-3)+QX(K+11)# Y'    BN07  37
QX(L+3)=QX(K+3)*QX(J-5)+QX(K+6)*QX(J-4)+QX(K+9)*QX(J-3)+QX(K+12)# Z'    BN07  38
QX(L+5)=ABS(QX(K+1)*QX(J-2))+ABS(QX(K+4)*QX(J-1))+ABS(QX(K+7)*QX(J))#   BN07  39
QX(L+6)=ABS(QX(K+2)*QX(J-2))+ABS(QX(K+5)*QX(J-1))+ABS(QX(K+8)*QX(J))#   BN07  40
QX(L+7)=ABS(QX(K+3)*QX(J-2))+ABS(QX(K+6)*QX(J-1))+ABS(QX(K+9)*QX(J))#   BN07  41
QX(L+8)=BUFIN(I+NATM)#                 Store symop number               BN07  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN07  43
ELSE QX(L+8)=0.#                       No symop applied                 BN07  44
IF(BUFIN(I+NATM+NATM)>0.)#             Has transln been entered         BN07  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN07  46
K=NINT(BUFIN(I+NATM+NATM))#            Store translation                BN07  47
QX(L+1)=QX(L+1)+FLOAT(K/100-5)#        Apply x translation              BN07  48
QX(L+2)=QX(L+2)+FLOAT(MOD(K,100)/10-5)# Apply y translation             BN07  49
QX(L+3)=QX(L+3)+FLOAT(MOD(K,10)-5)#    Apply z translation              BN07  50
QX(L+9)=BUFIN(I+NATM+NATM)#            Store translation                BN07  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN07  52
ELSE QX(L+9)=0.#                       No translation applied           BN07  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN07  54
RETURN#                                                                 BN07  55
END#                                                                    BN07  56
systemheader:(BN09)#        ## store bond and angle data on scratch     BN09   1
# ################################################################## #  BN09   2
#                                                                    #  BN09   3
#                               BN09                                 #  BN09   4
#                                                                    #  BN09   5
# ################################################################## #  BN09   6
SUBROUTINE BN09(KEY,VALUE,SIGMA)#      S.r.hall 1989                    BN09   7
include:(AACOMN)#                                                       BN09   8
include:(BNCOMN)#                                                       BN09   9
INTEGER I,KEY,IP#                                                       BN09  10
REAL VALUE,SIGMA#                                                       BN09  11
#                                                                       BN09  12
writepkt:(4,77,11,IP)#                 Get op packet pointer            BN09  13
QX(IP+1)=FLOAT(KEY)#                   Store parameter type             BN09  14
QX(IP+2)=VALUE#                        Store parameter                  BN09  15
QX(IP+3)=SIGMA#                        Store parameter sigma            BN09  16
DO I=1,4; QX(IP+I+3)=FLOAT(INM(I))#    Store atom name pointers         BN09  17
DO I=1,4; QX(IP+I+7)=FLOAT(IXY(I))#    Store atom coord pointers        BN09  18
RETURN#                                                                 BN09  19
END#                                                                    BN09  20
systemheader:(BN11)#                   Read cell parameters             BN11   1
# ################################################################## #  BN11   2
#                                                                    #  BN11   3
#                               BN11                                 #  BN11   4
#                                                                    #  BN11   5
# ################################################################## #  BN11   6
SUBROUTINE BN11#                       S.r.hall 1983                    BN11   7
include:(AACOMN)#                      W.dreissig 1986                  BN11   8
include:(BNCOMN)#                                                       BN11   9
#                                                                       BN11  10
INTEGER I,J,K,KK#                                                       BN11  11
chardata:(B032," Bondla Control Parameters-")#                          BN11  12
chardata:(B037,BOND NBON ANGL NANG CONT NCON DIHE NDIH $#               BN11  13
CLUS NCLU SYMM NSYM SORT NSOR BRAC CELL NBDF CHEK )#                    BN11  14
chardata:(B038,YES NO)#                                                 BN11  15
chardata:(B044," Use full symmetry in searches       YES")#             BN11  16
chardata:(B045," Use reclustered sites in searches   YES")#             BN11  17
chardata:(B046," Use extra unit cells in searches       ")#             BN11  18
chardata:(B050," Sort bond and contact distances      NO")#             BN11  19
realdata:(SURREP,[1.,27.,125.])#                                        BN11  20
datastuff:#                                                             BN11  21
#                                                                       BN11  22
# THE BONDLA LINE CONTAINS CODES WHICH DIRECT THE SETTING OF THE        BN11  23
# FOLLOWING VARIABLES                                                   BN11  24
#                                                                       BN11  25
# VARIABLE  IP CODE    DEFAULT  MEANING                                 BN11  26
#                                                                       BN11  27
#  DOB        BOND          *   CALCULATE BOND DISTANCES                BN11  28
#             NBOND             NO BOND DISTANCES                       BN11  29
#  ANG        ANGLE         *   CALCULATE BOND ANGLES                   BN11  30
#             NANGLE            NO BOND ANGLES                          BN11  31
#  KON        NCONT         *   NO CONTACT DISTANCES                    BN11  32
#             CONT              CALCULATE CONTACT DISTANCES             BN11  33
#  IDH        NDIH          *   NO DIHEDRAL ANGLES                      BN11  34
#             DIHED             CALCULATE DIHEDRAL ANGLES               BN11  35
#  FUL        SYMM          *   USE THE GENERAL SYMOPS OF SPACE GROUP   BN11  36
#             NSYM              RESTRICT SEARCH TO SYMMETRY IDENTITY    BN11  37
#  SER        CLUS          *   CLUSTER INPUT ATOM SITES IN SEARCH      BN11  38
#             NCLUS             USE INPUT ATOM SITES IN SEARCH          BN11  39
#  SORT       NSORT         *   DO NOT SORT BOND AND CONTACT DISTANCES  BN11  40
#             SORT              SORT BONT AND CONTACT DISTANCES         BN11  41
#  BRAC       BRAC              PLACE BRACKETS IN PUNCHED ATOM NAMES    BN11  42
#                           *   PUNCH NAMES AS IN BDF                   BN11  43
#  SUR        CELL       1      SEARCH ONLY ONE UNIT CELL               BN11  44
#                        2      SEARCH 27 UNIT CELLS                    BN11  45
#                        3  *   SEARCH 125 UNIT CELLS (DEFAULT)         BN11  46
#                                                                       BN11  47
#    SET INITIAL PARAMETERS                                             BN11  48
#    ----------------------                                             BN11  49
#                                                                       BN11  50
ANG=yes:#                              Default angles is yes            BN11  51
KON=no:#                               Default contacts is no           BN11  52
IDH=no:#                               Default dihedral angles no       BN11  53
FUL=yes:#                              Use all symops in search         BN11  54
BDF=yes:#                              Do op bond dist to bdf           BN11  55
DOB=yes:#                              Do automatic bond length cal     BN11  56
SER=yes:#                              Search cluster on input list     BN11  57
BRAC=no:#                              No brackets in pch atom name     BN11  58
SUR=3#                                 Search 125 unit cells            BN11  59
SORT=no:#                              Default no sort of lengths       BN11  60
NTYPE=0#                               Zero count of atom types         BN11  61
NATOM=0#                               Zero count of atoms              BN11  62
BCHECK=no:#                            Not iucr bond check mode         BN11  63
#                                                                       BN11  64
#   PROCESS *BONDLA* FIELDS                                             BN11  65
#   -----------------------                                             BN11  66
#                                                                       BN11  67
FOR(K=1;K<=30;K=K+1)#                  Loop over bondla fields          BN11  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN11  69
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               BN11  70
stringlim:(K,I,J)#                     Find string limits               BN11  71
compchar:(CHRIN,I,B037,1,4,5,NB037,KK)# Search for match                BN11  72
IF(KK==0) iquit:(BN1101,K)#            No match.......bn1101            BN11  73
ELSE IF(KK==2)  DOB=no:#               Shut off bond lengths            BN11  74
ELSE IF(KK==4)  ANG=no:#               Switch off angles                BN11  75
ELSE IF(KK==5)  KON=yes:#              Contact distances requested      BN11  76
ELSE IF(KK==7)  IDH=yes:#              Dihedral angles requested        BN11  77
ELSE IF(KK==10) SER=no:#               No cluster search applied        BN11  78
ELSE IF(KK==12) FUL=no:#               Use identity symop only          BN11  79
ELSE IF(KK==13) SORT=yes:#             Sort bond & contact              BN11  80
ELSE IF(KK==15) BRAC=yes:#             Place brackets in pch names      BN11  81
ELSE IF(KK==16)#                       Set surrounding cell             BN11  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN11  83
IF(BUFIN(K+1)<=voidflg:) NEXT#         See if number stated             BN11  84
SUR=NINT(BUFIN(K+1))#                  Pick up cell index               BN11  85
SUR=MIN0(MAX0(SUR,1),3)#               Protect own foot                 BN11  86
K=K+1#                                 Swallow field                    BN11  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN11  88
ELSE IF(KK==17) BDF=no:#               No dist to op bdf                BN11  89
ELSE IF(KK==18) BCHECK=yes:#           No symop mods                    BN11  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN11  91
#                                                                       BN11  92
#    ASSIGN I/O BUFFERS FOR BDF & SCRATCH                               BN11  93
#    ------------------------------------                               BN11  94
#                                                                       BN11  95
IOMARK(1)=QXSTR#                       Define start buffer a            BN11  96
IOMARK(2)=IOMARK(1)+bdfbuf:#           Define start buffer b            BN11  97
IOMARK(3)=IOMARK(2)+bdfbuf:#           Define start scratch file        BN11  98
IOMARK(4)=IOMARK(3)+bdfbuf:#           Define start scratch file        BN11  99
IOMARK(5)=IOMARK(4)+bdfbuf:#           Define start pekpik file         BN11 100
MARK2=IOMARK(5)+bdfbuf:;    STEP2=9#   Set cell storage                 BN11 101
incrqx:(STOP2,MARK2+199,BN1105)#       No mem.........bn1105            BN11 102
readwpkt:(1,lrlabl:,I,J,0)#            Read the bdf header data         BN11 103
#                                                                       BN11 104
#   REPORT OUT THE VARIOUS STATUS FLAGS                                 BN11 105
#   -----------------------------------                                 BN11 106
#                                                                       BN11 107
LINRM=4#                               Ensure sufficient space          BN11 108
movechar:(B032,NB032,CHROT,2,NB032-2,2)# Insert underline               BN11 109
writeline:(1,B032,NB032-1,2,3)#        Print bondla header              BN11 110
IF(FUL==no:)movechar:(B038,4,B044,NB044-2,3,0)# Say no symmetry         BN11 111
writeline:(0,B044,NB044,3,3)#          Report symmetry search           BN11 112
IF(SER==no:)movechar:(B038,4,B045,NB045-2,3,0)# Say no regroup          BN11 113
writeline:(0,B045,NB045,3,3)#          Report regroup search            BN11 114
ncodefld:(SURREP,SUR,B046,400313.,1)#  Encode cell search no.           BN11 115
writeline:(0,B046,NB046,3,3)#          Report to user                   BN11 116
IF(SORT==yes:)movechar:(B038,1,B050,NB050-2,3,0)# Say yes               BN11 117
writeline:(0,B050,NB050,3,3)#          Report on sort lengths           BN11 118
#                                                                       BN11 119
RETURN#                                                                 BN11 120
END#                                                                    BN11 121
systemheader:(BN21)#                   Read bdf for symop & atoms       BN21   1
# ################################################################## #  BN21   2
#                                                                    #  BN21   3
#                               BN21                                 #  BN21   4
#                                                                    #  BN21   5
# ################################################################## #  BN21   6
SUBROUTINE BN21#                       S.r.hall 1983                    BN21   7
include:(AACOMN)#                      W.dreissig 1986                  BN21   8
include:(BNCOMN)#                                                       BN21   9
#                                                                       BN21  10
REAL TEST#                                                              BN21  11
REAL CODE,VAL#                                                          BN21  12
INTEGER I,J,JJ,K,L,LS,M,N#                                              BN21  13
INTEGER IP,ICNT,KTF,LTYP#                                               BN21  14
INTEGER KEY(4)#                                                         BN21  15
INTEGER IWNT(18)#                                                       BN21  16
string:(NAME,24)#                                                       BN21  17
chardata:(B116," Symop      ")#                                         BN21  18
chardata:(B117," Symmetry operations available are ...")#               BN21  19
chardata:(FRAC,      1/61/41/3   1/2   2/33/45/6      )#                BN21  20
intdata:(DENOM,[12,6,4,3,12,2,12,3,4,6,12, 1])#                         BN21  21
chardata:(XYZ,'-x-y-z+x+y+z')#                                          BN21  22
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              BN21  23
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              BN21  24
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              BN21  25
realdata:(TR21,[.3333333,.5])#                                          BN21  26
realdata:(TR22,[.6666667,0.])#                                          BN21  27
realdata:(TR23,[.6666667,.5])#                                          BN21  28
datastuff:#                                                             BN21  29
#                                                                       BN21  30
#   GET CELL PARAMETERS FROM LRCELL                                     BN21  31
#   -------------------------------                                     BN21  32
#                                                                       BN21  33
DO K=1,8#                              Loop over cell packets           BN21  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN21  35
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Point to next lrcell pkt         BN21  36
IF(IP<=0) iquit:(BN2101)#              Exit if missing                  BN21  37
#                                                                       BN21  38
IF(K==1)#                              Test for cell parameters         BN21  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN21  40
I=MARK2+STEP2#                         Point to place in list           BN21  41
movereal:(QX,IP+1,QX,I+1,9,1)#         Store in table 2                 BN21  42
QX(I+7)=QX(I+7)*360.#                  Store alpha in deg               BN21  43
QX(I+8)=QX(I+8)*360.#                  Store beta  in deg               BN21  44
QX(I+9)=QX(I+9)*360.#                  Store gamma in deg               BN21  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN21  46
#                                                                       BN21  47
IF(K==2)#                              Test for stand. dev. packet      BN21  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN21  49
I=MARK2+3*STEP2#                       Point to place in list           BN21  50
movereal:(QX,IP+1,QX,I+1,9,0)#         Store values in list 2           BN21  51
QX(I+7)=QX(I+7)*360.#                  Store alpha in deg               BN21  52
QX(I+8)=QX(I+8)*360.#                  Store beta  in deg               BN21  53
QX(I+9)=QX(I+9)*360.#                  Store gamma in deg               BN21  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN21  55
#                                                                       BN21  56
IF(K==7)#                              Test for metric tensor pkt       BN21  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN21  58
I=MARK2#                               Point to place in list           BN21  59
movereal:(QX,IP+1,QX,I+1,9,0)#         Store metric tensor in list      BN21  60
G1=QX(I+1); G5=QX(I+5); G9=QX(I+9)#    Store metric terms in common     BN21  61
G2=2.*QX(I+2)#                         Store metric terms in common     BN21  62
G3=2.*QX(I+3)#                         Store metric terms in common     BN21  63
G6=2.*QX(I+6)#                         Store metric terms in common     BN21  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN21  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN21  66
ifeq:(QX(MARK2+STEP2+6),-0.5,0.0001)HEXAG=yes:# Lattice is hexagonal    BN21  67
ELSE HEXAG=no:#                        Lattice not hexagonal            BN21  68
#                                                                       BN21  69
# ENTER SYMMETRY DATA FROM LRSYMM                                       BN21  70
# -------------------------------                                       BN21  71
#                                                                       BN21  72
MARK3=STOP2;       STEP3=12#           Mark symop table                 BN21  73
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read first sym packet            BN21  74
IF(IP<=0) iquit:(BN2102)#              Exit if missing                  BN21  75
LTYP=NINT(QX(IP+1))#                   Lattice flag                     BN21  76
ICNT=NINT(QX(IP+2))#                   Centre flag (c=0;nc=1)           BN21  77
NSYM=NINT(QX(IP+3))#                   Number of matrices on bdf        BN21  78
incrqx:(STOP3,MARK3+NSYM*12,BN2104)#   End of full symop table          BN21  79
FOR(J=MARK3;J>0;J=J+STEP3)#            Loop over sym matrices           BN21  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN21  81
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Point next matrix                BN21  82
IF(IP<=0) BREAK#                       Exit when no more                BN21  83
movereal:(QX,IP+1,QX,J+1,PSIZ,1)#      Store matrix in table 2          BN21  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN21  85
N=J#                                   Store limit of input matrices    BN21  86
IF(ICNT==0)#                           If centrosymmetric               BN21  87
FOR(K=MARK3;K<N;K=K+STEP3)#            Loop over input matrices         BN21  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN21  89
DO I=1,12; QX(J+I)=-QX(K+I)#           Store inverse element            BN21  90
J=J+STEP3#                             Incr storage pointer             BN21  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN21  92
IF(LTYP>7) LTYP=LTYP-7#                Remove centric part              BN21  93
N=J;  K=J#                             Store temp end marker            BN21  94
IF(LTYP>1)#                            Test if sg centered              BN21  95
FOR(J=MARK3;J<N;J=J+STEP3)#            Loop over symm matrices          BN21  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BN21  97
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            BN21  98
QX(K+10)=QX(J+10)+TR11(LTYP-1)#        Transfer t1                      BN21  99
QX(K+11)=QX(J+11)+TR12(LTYP-1)#        Transfer t2                      BN21 100
QX(K+12)=QX(J+12)+TR13(LTYP-1)#        Transfer t3                      BN21 101
K=K+STEP3#                             Incr storage pointer             BN21 102
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               BN21 103
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            BN21 104
QX(K+10)=QX(J+10)+TR21(LTYP-2)#        Transfer t1                      BN21 105
QX(K+11)=QX(J+11)+TR22(LTYP-2)#        Transfer t2                      BN21 106
QX(K+12)=QX(J+12)+TR23(LTYP-2)#        Transfer t3                      BN21 107
K=K+STEP3#                             Incr storage pointer             BN21 108
IF(LTYP!=4) NEXT#                      Skip if not f-centre             BN21 109
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            BN21 110
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      BN21 111
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      BN21 112
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      BN21 113
K=K+STEP3#                             Incr storage pointer             BN21 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BN21 115
IF(BCHECK==no:)FOR(J=MARK3;J<STOP3;J=J+STEP3)# Loop over symmetry mat   BN21 116
DO I=10,12; QX(J+I)=MOD(5.+QX(J+I),1.)# Store translation modulo 1.     BN21 117
#                                                                       BN21 118
#    PRINT SYMOPS AVAILABLE                                             BN21 119
#    ----------------------                                             BN21 120
#                                                                       BN21 121
LINRM=5#                               Ensure sufficient space          BN21 122
writeline:(1,B117,NB117,3,3)#          Write symop header               BN21 123
FOR(LS=MARK3;LS<STOP3;LS=LS+STEP3)#    Loop over symops                 BN21 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BN21 125
TEST=FLOAT((LS-MARK3)/STEP3+1)#        Float the symop number           BN21 126
ncodefld:(TEST,1,B116,110313.,1)#      Format symop number              BN21 127
movechar:(B116,1,CHROT,1,11,0)#        Insert symop header              BN21 128
DO L=1,3#                              Loop over symop matrix           BN21 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BN21 130
I=LS+L;    K=L*10+7#                   Point to row pointer             BN21 131
#J=NINT(QX(I+9)*12.)*3#                GET TRANSLN ELEMENT              BN21 132
#IF(J>0) CHROT(K^K+2)=FRAC(J+1^J+3)#   STORE TRANSL FRACTION            BN21 133
M=NINT(QX(I+9)*12.)#                   Get symop translation            BN21 134
J=MOD(M+3600,12)#                      Get transln element              BN21 135
CODE=FLOAT(K+2)*10000.+213.#           Write denominator                BN21 136
VAL=FLOAT(M/12)#                       Default value                    BN21 137
IF(J>0)#                               Non-integral                     BN21 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BN21 139
ncodefld:(FLOAT(DENOM(J)),1,CHROT,CODE,1)# Integral                     BN21 140
CHROT(K+1^K+1)='/'#                    Write division                   BN21 141
VAL=FLOAT(M*DENOM(J)/12)#              Add fractional num of denoms     BN21 142
CODE=FLOAT(K)*10000.+513.#             Dont' overwrite fraction         BN21 143
ncodefld:(VAL,1,CHROT,CODE,1)#         Encode the total number          BN21 144
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BN21 145
ELSEIF(M!=0) ncodefld:(VAL,1,CHROT,CODE,1)# Integral                    BN21 146
K=K+3#                                 Incr op pointer                  BN21 147
DO M=1,3#                              Loop along row elements          BN21 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BN21 149
J=NINT(QX(I+M*3-3))#                   Point to next element            BN21 150
IF(J==0) NEXT#                         Skip zero elements               BN21 151
CHROT(K^K+1)=XYZ(J*3+2+M*2^); K=K+2#   Extract xyz string               BN21 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BN21 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BN21 154
writeline:(0,0,0,1,3)#                 Print the symmetry position      BN21 155
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BN21 156
#                                                                       BN21 157
#  ENTER FF TYPES FROM LRSCAT                                           BN21 158
#  --------------------------                                           BN21 159
#                                                                       BN21 160
MARK4=STOP3;          STEP4=3#         Start/step ff table 4            BN21 161
IWNT(1)=11; IWNT(2)=5; IWNT(3)=6#      Ff name, bond & cont radius      BN21 162
KEY(1)=1; KEY(2)=3; KEY(3)=0; KEY(4)=0# Search parameters               BN21 163
indexpkt:(1,lrscat:,PSIZ,IP,0,KEY,IWNT,IREL)# Search ff parameters      BN21 164
IF(KEY(1)<=0) iquit:(BN2105)#          No ff........bn2105              BN21 165
FOR(J=MARK4;J>0;J=STOP4)#              Loop over ff table               BN21 166
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BN21 167
readwpkt:(1,lrscat:,PSIZ,IP,0)#        Read next ff packet              BN21 168
IF(IP<=0) BREAK#                       Exit if no more                  BN21 169
incrqx:(STOP4,J+STEP4,BN2104)#         Get memory for ff table          BN21 170
NTYPE=NTYPE+1#                         Count ff types                   BN21 171
K=IP+IREL(1)#                          Point ff name                    BN21 172
movertoc:(QX(K),1,ATYPE,NTYPE*8-7,8,0)# Store ff name                   BN21 173
K=IP+IREL(2); IF(K>IP) QX(J+2)=QX(K)+.1# Get max bond radius            BN21 174
K=IP+IREL(3); IF(K>IP) QX(J+1)=QX(K)+.2# Get max contact radius         BN21 175
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BN21 176
#                                                                       BN21 177
#  ENTER ATOM DATA FROM LRATOM                                          BN21 178
#  ---------------------------                                          BN21 179
#                                                                       BN21 180
MARK5=STOP4;     STEP5=30#             Start/step atom table 5          BN21 181
IWNT(1)=14;      IWNT(2)=22#           Request name and sfnum           BN21 182
DO I=1,10;  IWNT(I+ 2)=I#              Request x,y,z,u,uij              BN21 183
DO I=1,3;   IWNT(I+12)=I+100#          Request sigma x,y,z              BN21 184
IWNT(16)=23; IWNT(17)=11; IWNT(18)=21# Request dp-switch, pp, mult      BN21 185
KEY(1)=5; KEY(2)=18; KEY(3)=0; KEY(4)=0# Search parameters              BN21 186
indexpkt:(1,lratom:,PSIZ,IP,0,KEY,IWNT,IREL)# Search atom record        BN21 187
IF(KEY(4)<0\IP<0) iquit:(BN2103)#      Atom record missing              BN21 188
FOR(J=MARK5;J>0;J=STOP5)#              Loop over atom record            BN21 189
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BN21 190
readwpkt:(1,lratom:,PSIZ,IP,0)#        Read next atom record            BN21 191
IF(IP<=0) BREAK#                       Exit if no more                  BN21 192
incrqx:(STOP5,J+STEP5,BN2104)#         No mem........bn2104             BN21 193
NATOM=NATOM+1#                         Increment atom count             BN21 194
K=IP+IREL(1)#                          Get pointer to atom name         BN21 195
movertoc:(QX(K),1,NAME,1,24,0)#        Store atom name                  BN21 196
movector:(NAME,1,QX(J+25),1,24,0)#     Store atom name                  BN21 197
label:(NAME,K,L)#                      Get name length & set max        BN21 198
K=IP+IREL(2)#                          Get ff index number              BN21 199
QX(J+1)=FLOAT(MARK4+NINT(QX(K)-1.)*STEP4)# Store table4 pointer         BN21 200
K=IP+IREL(3); QX(J+2)=QX(K)#           Store x                          BN21 201
K=IP+IREL(4); QX(J+3)=QX(K)#           Store y                          BN21 202
K=IP+IREL(5); QX(J+4)=QX(K)#           Store z                          BN21 203
K=IP+IREL(6); IF(K>IP) QX(J+17)=QX(K)# Store u                          BN21 204
K=IP+IREL(13);IF(K>IP) QX(J+5)=QX(K)#  Store sigx                       BN21 205
K=IP+IREL(14);IF(K>IP) QX(J+6)=QX(K)#  Store sigy                       BN21 206
K=IP+IREL(15);IF(K>IP) QX(J+7)=QX(K)#  Store sigz                       BN21 207
K=IP+IREL(16);IF(K>IP) KTF=NINT(QX(K))# Extract dp-switch               BN21 208
K=IP+IREL(17);IF(K>IP) QX(J+23)=QX(K)# Store pop param                  BN21 209
ELSE                   QX(J+23)=1.#    Def pop is one                   BN21 210
IF(KTF==2)#                            Anisotropic dp                   BN21 211
DO JJ=1,6#                             Loop over elements               BN21 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BN21 213
K=IP+IREL(JJ+6)#                       Address uij                      BN21 214
QX(J+16+JJ)=QX(K)#                     Store uij                        BN21 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BN21 216
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BN21 217
STOP5=J#                               End of atom table                BN21 218
#                                                                       BN21 219
RETURN#                                                                 BN21 220
END#                                                                    BN21 221
systemheader:(BN25)#                   Enter addpek & atrad lines       BN25   1
# ################################################################## #  BN25   2
#                                                                    #  BN25   3
#                               BN25                                 #  BN25   4
#                                                                    #  BN25   5
# ################################################################## #  BN25   6
SUBROUTINE BN25#                       S.r.hall 1983                    BN25   7
include:(AACOMN)#                      W.dreissig 1986                  BN25   8
include:(BNCOMN)#                                                       BN25   9
#                                                                       BN25  10
INTEGER I,J,K,L,M,N#                                                    BN25  11
INTEGER LIMP(9),NFF(9),NCH(9)#                                          BN25  12
INTEGER NC,NF,MAXP,NPA#                                                 BN25  13
INTEGER IP,IR1,IR2,IR5,IR9,IR16,IR17,IR18,NADD#                         BN25  14
REAL    COSG,FM,SINA,SINB,SING,TFP(9),TF#                               BN25  15
#                                                                       BN25  16
string:(TEMP,8)#                                                        BN25  17
string:(NAME,24)#                                                       BN25  18
string:(LABL,24)#                                                       BN25  19
chardata:(B061, ADDPEK ATRAD BOND ANGLE DIHED NVIRON END SITE )#        BN25  20
chardata:(B062," Input Atom Coordinates-")#                             BN25  21
chardata:(B063,"  x/a      y/b      z/c     sigx     sigy     sigz")#   BN25  22
chardata:(B064," Peaks added to the atoms list          ")#             BN25  23
chardata:(B067," Radii      contact   max bond   min bond")#            BN25  24
realdata:(FMT,[952.,952.,952.,952.,952.,952.])#                         BN25  25
realdata:(FORM,[180532.,280532.,390532.])#                              BN25  26
realdata:(A,0.)#                                                        BN25  27
datastuff:#                                                             BN25  28
#                                                                       BN25  29
#    LOOP OVER INPUT LINES                                              BN25  30
#    ----------------------                                             BN25  31
#                                                                       BN25  32
NADD=0#                                Zero addpek count                BN25  33
REPEAT#                                Loop over input lines            BN25  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN25  35
readline:(B061,NB061)#                 Read next input line             BN25  36
LINID=LINID-1#                         Align with later reads           BN25  37
#                                                                       BN25  38
IF(LINID==0)#                          ********** addpek ***********    BN25  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN25  40
NADD=NADD+1#                           One more addpek line             BN25  41
IF(NADD>9) iquit:(BN2509)#             Addpek limit exceeded            BN25  42
IF(BUFIN(1)<=voidflg:)#                Test for atom type               BN25  43
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN25  44
stringlim:(1,I,J)#                     Get atom string limits           BN25  45
TEMP=CHRIN(I^J)#                       Get ff-name                      BN25  46
NCH(NADD)=J-I#                         Store ff name length             BN25  47
label:(TEMP,I,J,ATYPE,K)#              Identify atom type               BN25  48
IF(K==0) iquit:(BN2508)#               No match with ff                 BN25  49
I=MARK4+(K-1)*STEP4#                   Point to scatt radii table       BN25  50
NFF(NADD)=K#                           Store ff name addr               BN25  51
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN25  52
ELSE iquit:(BN2507)#                   Atom type name missing           BN25  53
IF(BUFIN(2)>0.) LIMP(NADD)=NINT(BUFIN(2))# Store number of peaks        BN25  54
ELSE            LIMP(NADD)=1#          Default is one peak              BN25  55
IF(BUFIN(3)>0.) QX(I+1)=BUFIN(3)#      Insert max. contact radius       BN25  56
IF(BUFIN(4)>0.) QX(I+2)=BUFIN(4)#      Insert max. bond radius          BN25  57
IF(BUFIN(5)>0.) QX(I+3)=BUFIN(5)#      Insert min. bond radius          BN25  58
IF(BUFIN(6)>0.) TFP(NADD)=BUFIN(6)#    Temp. factor for peaks           BN25  59
ELSE            TFP(NADD)=0.035#       Default tdp                      BN25  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN25  61
#                                                                       BN25  62
ELSE IF(LINID==1)#                     ********* atrad ************     BN25  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN25  64
movechar:(BLANK,1,TEMP,1,8,1)#         Blank out ff name                BN25  65
stringlim:(1,M,N)#                     Pick up atom type                BN25  66
movechar:(CHRIN,M,TEMP,1,N-M,0)#       Store ff name                    BN25  67
label:(TEMP,I,J,ATYPE,K)#              Identify atom type               BN25  68
IF(K==0) iquit:(BN2503)#               No match with ff                 BN25  69
I=MARK4+(K-1)*STEP4#                   Point to ff table                BN25  70
ifnv:(BUFIN(2)) QX(I+1)=BUFIN(2)#      Store contact radius             BN25  71
ifnv:(BUFIN(3)) QX(I+2)=BUFIN(3)#      Store bond radius                BN25  72
ifnv:(BUFIN(4)) QX(I+3)=BUFIN(4)#      Store min bond radius            BN25  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN25  74
#                                                                       BN25  75
ELSE IF(LINID==7)#                     *********** site ***********     BN25  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN25  77
ifnm:(BUFIN(1)) iquit:(BN2501)#        Atom label missing               BN25  78
stringlim:(1,I,J)#                     Get atom string limits           BN25  79
NAME=CHRIP(I^J)#                       Get ff-name                      BN25  80
label:(NAME,I,J,ATYPE,K)#              Identify atom type               BN25  81
IF(K==0) iquit:(BN2508)#               No match with ff                 BN25  82
FOR(J=MARK5;J<STOP5;J=J+STEP5)#        Compare with existing atoms      BN25  83
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN25  84
movertoc:(QX(J+25),1,LABL,1,24,0)#     Get atom label                   BN25  85
IF(LABL==NAME) BREAK#                  Test if already present          BN25  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN25  87
IF(J==STOP5)#                          This is a new atom label         BN25  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BN25  89
incrqx:(STOP5,J+STEP5,BN2504)#         Expand atom list                 BN25  90
NATOM=NATOM+1#                         Increment atom count             BN25  91
movector:(NAME,1,QX(J+25),1,24,0)#     Store atom name                  BN25  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BN25  93
QX(J+1)=FLOAT(MARK4+(K-1)*STEP4)#      Store table4 pointer             BN25  94
DO I=1,3; ifnm:(BUFIN(I+1)) QX(J+I+1)=BUFIN(I+1)# Store x, y, z         BN25  95
ifnm:(BUFIN(5)) QX(J+17)=BUFIN(5)#     Store u                          BN25  96
ELSE            QX(J+17)=0.035#        Store default u                  BN25  97
ifnm:(BUFIN(6)) QX(J+23)=BUFIN(6)#     Store pop param                  BN25  98
ELSE            QX(J+23)=1.00#         Store default pop param          BN25  99
DO I=1,3; ifnm:(BUFIN(I+6)) QX(J+I+4)=BUFIN(I+6)# Store sig x, y, z     BN25 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN25 101
#                                                                       BN25 102
ELSE  BREAK#                           ******* bond,angle,dihed,end     BN25 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN25 104
#                                                                       BN25 105
#   INPUT PEAKS FROM FILEE IF ADDPEK LINES ENTERED                      BN25 106
#   ----------------------------------------------                      BN25 107
#                                                                       BN25 108
IF(NADD>0)#                            Signals addpek-line              BN25 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BN25 110
DO I=NADD,1,-1; LIMP(I+1)=LIMP(I)#     Shift down peak limits           BN25 111
LIMP(1)=0#                             Reset first as a flag            BN25 112
DO I=2,NADD+1; LIMP(I)=LIMP(I)+LIMP(I-1)# Accumulate peak limits        BN25 113
MAXP=LIMP(NADD+1);   NPA=1;    L=0#    Set max peaks requested          BN25 114
readwpkt:(5,21,PSIZ,IP,0)#             Read peak record                 BN25 115
IF(IP<=0) iquit:(BN2510)#              File e is missing                BN25 116
IR1=IREL(1); IR2=IREL(2); IR5=IREL(5)# Set bdf pointers                 BN25 117
IR9=IREL(9); IR16=IREL(16); IR17=IREL(17)# Set bdf pointers             BN25 118
IR18=IREL(18)#                         Set bdf pointers                 BN25 119
#                                                                       BN25 120
FOR(N=1;N<=MAXP;N=N+1)#                Loop over peak packets           BN25 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BN25 122
readwpkt:(5,22,PSIZ,IP,0)#             Read peak packet                 BN25 123
IF(IP<=0) BREAK#                       Exit on last packet              BN25 124
IF(QX(IP+4)>900000.)#                  Skip if overlapped site          BN25 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BN25 126
N=N-1;   NEXT#                         Skip if overlapped site          BN25 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BN25 128
IF(N>LIMP(NPA))#                       Test if new form factor          BN25 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BN25 130
NF=NFF(NPA);  NC=NCH(NPA)#             Get ff addr and length           BN25 131
TF=TFP(NPA)#                           Get atom temp factor             BN25 132
NPA=NPA+1;    M=1#                     Incr ff pointer; reset atnum     BN25 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BN25 134
incrqx:(K,STOP5+STEP5,BN2504)#         Memory for additional peaks      BN25 135
#                                                                       BN25 136
REPEAT#                                Loop to store atom name          BN25 137
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BN25 138
IF     (M<10)  I=1#                    Number in units                  BN25 139
ELSE IF(M<100) I=2#                    Number in tens                   BN25 140
ELSE           I=3#                    Number in hundreds               BN25 141
FM=FLOAT(NC+I)*10000.+FLOAT(I*100)+13.# Set format                      BN25 142
TEMP=ATYPE(NF*8-7^NF*8)#               Insert ff name                   BN25 143
ncodefld:(FLOAT(M),1,TEMP,FM,1)#       Insert atom seq number           BN25 144
LABMAX=MAX(LABMAX,NC+I)#               Get max name length              BN25 145
FOR(J=MARK5;J<STOP5;J=J+STEP5)#        Compare with existing atoms      BN25 146
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BN25 147
movertoc:(QX(J+25),1,NAME,1,24,0)#     Get atom label                   BN25 148
IF(TEMP==NAME(1^8)) BREAK#             Test if already present          BN25 149
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BN25 150
IF(J<STOP5) M=M+1#                     Incr atnum and try again         BN25 151
ELSE        BREAK#                     Stop repeat when no match        BN25 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BN25 153
#                                                                       BN25 154
NATOM=NATOM+1;    L=L+1#               Increment no.  atoms             BN25 155
QX(STOP5+1)=FLOAT(MARK4+(NF-1)*STEP4)# Store ff-pointer                 BN25 156
movereal:(QX,IP+1,QX,STOP5+2,3,1)#     Store xyz                        BN25 157
movereal:(0.,1,QX,STOP5+5,20,2)#       Clear remaining words            BN25 158
movector:(BLANK,1,QX(STOP5+25),1,24,1)# Blank name                      BN25 159
movector:(TEMP,1,QX(STOP5+25),1,8,0)#  Store name                       BN25 160
QX(STOP5+17)=TF#                       Store isotropic tf               BN25 161
QX(STOP5+23)=1.#                       Store default population         BN25 162
STOP5=K#                               Reset atom list limit            BN25 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BN25 164
ncodefld:(FLOAT(L),1,B064,400313.,1)#  Insert no. peaks added           BN25 165
writeline:(1,B064,NB064,3,3)#          Print pekpik peak info           BN25 166
readwpkt:(5,endrecord:,PSIZ,IPO,0)#    Close file e                     BN25 167
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BN25 168
IF(BDF==no:) readwpkt:(1,endrecord:,PSIZ,IP,0)# Close file a            BN25 169
IF(STOP5==MARK5) iquit:(BN2506)#       No atom data entered             BN25 170
#                                                                       BN25 171
#   PRINT BOND, CONTACT RADII                                           BN25 172
#   -------------------------                                           BN25 173
#                                                                       BN25 174
writeline:(1,B067,NB067,3,3)#          Radii to be used.                BN25 175
MXBRAD=0.0;  MXCRAD=0.0#               Zero max radii                   BN25 176
FOR(L=MARK4;L<STOP4;L=L+STEP4)#        Loop over all atom types         BN25 177
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BN25 178
IF(QX(L+1)<=small:) QX(L+1)=1.25#      Default contact radius           BN25 179
IF(QX(L+2)<=small:) QX(L+2)=0.90#      Default bond radius              BN25 180
IF(QX(L+3)<=small:) QX(L+3)=0.015#     Default min. bond radius         BN25 181
MXCRAD=AMAX1(MXCRAD,QX(L+1))#          Find max contact                 BN25 182
MXBRAD=AMAX1(MXBRAD,QX(L+2))#          Find max bond                    BN25 183
I=8*(L-MARK4)/STEP4#                   Point to atom type number        BN25 184
CHROT(7^14)=ATYPE(I+1^I+8)#            Insert atom type code            BN25 185
ncodefld:(QX,L+1,CHROT,FORM,3)#        Move radii to output line        BN25 186
writeline:(0,0,0,1,3)#                 Print radii                      BN25 187
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BN25 188
#                                                                       BN25 189
#    PRINT INPUT ATOMS LIST                                             BN25 190
#    ----------------------                                             BN25 191
#                                                                       BN25 192
LINRM=6#                               Force first header               BN25 193
movechar:(B062,NB062,CHROT,2,NB062-2,2)# Insert underline               BN25 194
writeline:(1,B062,NB062-1,2,3)#        Print input atoms header         BN25 195
HEADOT=' '; HEADOT(LABMAX+5^)=B063#    Store the header                 BN25 196
LINRM=6#                               Force xyz header                 BN25 197
FOR(J=MARK5;J<STOP5;J=J+STEP5)#        Loop over atoms table            BN25 198
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BN25 199
LCHROT=LABMAX+1#                       Set last chr in chrot            BN25 200
movertoc:(QX(J+25),1,CHROT,2,LABMAX,0)# Extract atom name               BN25 201
ncodefld:(QX,J+2,CHROT,FMT,6)#         Format xyz,sigxyz                BN25 202
writeline:(0,HEADOT,100,1,3)#          Print atom parameters            BN25 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BN25 204
incrqx:(I,STOP5+16*NATOM+6,BN2504)#    No mem........bn2504             BN25 205
#                                                                       BN25 206
#   EXPAND CELL DATA FOR ERROR CALCULATIONS                             BN25 207
#   ---------------------------------------                             BN25 208
#                                                                       BN25 209
J=MARK2+STEP2;   K=J+STEP2#            Point to abc & new posn          BN25 210
QX(K+1)=QX(J+1)#                       A                                BN25 211
QX(K+2)=QX(J+1)*QX(J+6)#               A*cos gamma                      BN25 212
QX(K+3)=QX(J+1)*QX(J+5)#               A*cos beta                       BN25 213
QX(K+4)=QX(J+2)*QX(J+6)#               B*cos gamma                      BN25 214
QX(K+5)=QX(J+2)#                       B                                BN25 215
QX(K+6)=QX(J+2)*QX(J+4)#               B*cos alpha                      BN25 216
QX(K+7)=QX(J+3)*QX(J+5)#               C*cos beta                       BN25 217
QX(K+8)=QX(J+3)*QX(J+4)#               C*cos alpha                      BN25 218
QX(K+9)=QX(J+3)#                       C                                BN25 219
#                                                                       BN25 220
#   STORE FRACT-TO-ORTHOG TRANSF. MATRIX                                BN25 221
#   ------------------------------------                                BN25 222
#                                                                       BN25 223
M=MARK2+STEP2#                         Point to cell parameters         BN25 224
N=MARK2+STEP2*3#                       Point to cell sigmas             BN25 225
L=MARK2+STEP2*4#                       Point to transf matrix           BN25 226
FOR(I=0;I<7;I=I+1)#                    Loop over transf matrices        BN25 227
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BN25 228
IF(I>0)#                               Test for sigma calculation       BN25 229
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BN25 230
J=M+I;   K=N+I;    A=QX(J)#            Point to cell & sigmas           BN25 231
QX(J)=QX(J)+0.01*QX(K)#                Incr cell by sigma/100           BN25 232
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BN25 233
SINA=SQRT(1.-QX(M+4)**2)#              Calc sine alpha                  BN25 234
SINB=SQRT(1.-QX(M+5)**2)#              Calc sine beta                   BN25 235
COSG=(QX(M+6)-QX(M+4)*QX(M+5))/(SINA*SINB)# Calc cos gamma star         BN25 236
SING=SQRT(1.-COSG**2)#                 Calc sin gamma star              BN25 237
QX(L+1)=QX(M+1)*SINB*SING#             Store a*sinb*singstar            BN25 238
QX(L+2)=QX(M+1)*SINB*COSG#             Store a*sinb*cosgstar            BN25 239
QX(L+3)=QX(M+1)*QX(M+5)#               Store a*cosb                     BN25 240
QX(L+5)=QX(M+2)*SINA#                  Store b*sina                     BN25 241
QX(L+6)=QX(M+2)*QX(M+4)#               Store b*cosa                     BN25 242
QX(L+9)=QX(M+3)#                       Store c                          BN25 243
L=L+STEP2#                             Incr transf matrix pointer       BN25 244
IF(I>0) QX(J)=A#                       Reset cell parameter             BN25 245
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BN25 246
STOP2=L#                               End of transf tables             BN25 247
#                                                                       BN25 248
RETURN#                                                                 BN25 249
END#                                                                    BN25 250
systemheader:(BN31)#                   Find groups connected atoms      BN31   1
# ################################################################## #  BN31   2
#                                                                    #  BN31   3
#                               BN31                                 #  BN31   4
#                                                                    #  BN31   5
# ################################################################## #  BN31   6
SUBROUTINE BN31#                       S.r.hall 1983                    BN31   7
include:(AACOMN)#                      W.dreissig 1986                  BN31   8
include:(BNCOMN)#                                                       BN31   9
#                                                                       BN31  10
INTEGER I,J,K,L,LN,N,IP,LS,NC,NEW,NCONN#                                BN31  11
INTEGER II,JJ,SYMLIM#                                                   BN31  12
REAL CX,CY,CZ,D1,D2,DD,DIST,DISTMN,DMAX,SX,SY,SZ,TM(3),CN#              BN31  13
REAL X,Y,Z,A,B,C#                                                       BN31  14
REAL U,V,W,P,Q,R#                                                       BN31  15
REAL CP(3)#                                                             BN31  16
chardata:(B081," Clustered Atoms in Groups-")#                          BN31  17
chardata:(B082," Group   ")#                                            BN31  18
chardata:(B083," x/a      y/b      z/c    sym trn")#                    BN31  19
realdata:(FMTX,[952.,952.,952.])#                                       BN31  20
realdata:(FMTS,[503.,503.])#                                            BN31  21
realdata:(FMTP,[852.,852.,852.,852.,852.,852.,852.,852.])#              BN31  22
datastuff:#                                                             BN31  23
#                                                                       BN31  24
#  INITIALIZE TRANSFORMED COORD TABLE                                   BN31  25
#  ----------------------------------                                   BN31  26
#                                                                       BN31  27
MARK6=MARK5+7; STEP6=STEP5; STOP6=STOP5# Table6 is part of table5       BN31  28
MARK7=STOP6;   STEP7=6;     STOP7=MARK7# Set group list 7               BN31  29
IF(FUL==no:) SYMLIM=MARK3+STEP3#       Symmetry not applied             BN31  30
ELSE         SYMLIM=STOP3#             Set all symops to be used        BN31  31
FOR(I=MARK6;I<STOP6;I=I+STEP6)#        Loop over atom list              BN31  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN31  33
movereal:(QX,I-5,QX,I+1,3,1)#          Transfer input coords            BN31  34
movereal:(QX,I-2,QX,I+5,3,1)#          Transfer input sigmas            BN31  35
QX(I+4)=0.#                            Zero group number                BN31  36
QX(I+8)=0.#                            Zero symop number                BN31  37
QX(I+9)=0.#                            Zero translation flag            BN31  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN31  39
NEW=no:#                               Set no new coords                BN31  40
IF(SER==yes:)#                         Apply if requested               BN31  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN31  42
#                                                                       BN31  43
#   REGROUP INPUT ATOMS AROUND BODY CENTRE                              BN31  44
#   --------------------------------------                              BN31  45
#                                                                       BN31  46
REPEAT#                                Loop until atoms grouped         BN31  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN31  48
NCONN=yes:;    DISTMN=100000.#         Setup min distance               BN31  49
#                                                                       BN31  50
FOR(J=MARK6;J<STOP6;J=J+STEP6)#        Loop over atom list              BN31  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN31  52
IF(QX(J+4)>0.5) NEXT#                  Skip if assigned                 BN31  53
X=QX(J+1);  Y=QX(J+2);  Z=QX(J+3)#     Pickup coordinates               BN31  54
FOR(LS=MARK3;LS<SYMLIM;LS=LS+STEP3)#   Loop over symops                 BN31  55
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN31  56
A=QX(LS+1)*X+QX(LS+4)*Y+QX(LS+7)*Z+QX(LS+10)# Get symoped x             BN31  57
B=QX(LS+2)*X+QX(LS+5)*Y+QX(LS+8)*Z+QX(LS+11)# Get symoped y             BN31  58
C=QX(LS+3)*X+QX(LS+6)*Y+QX(LS+9)*Z+QX(LS+12)# Get symoped z             BN31  59
A=MOD(99.+A,1.)-0.5#                   Get closest to body centre       BN31  60
B=MOD(99.+B,1.)-0.5#                   Get closest to body centre       BN31  61
C=MOD(99.+C,1.)-0.5#                   Get closest to body centre       BN31  62
DIST=G1*A*A+G5*B*B+G9*C*C+G2*A*B+G3*A*C+G6*B*C# Dist**2                 BN31  63
IF(DIST>=DISTMN) NEXT#                 Skip if not smallest             BN31  64
DISTMN=DIST-0.01;  I=J#                Save distance and pointer        BN31  65
U=A+.5; V=B+.5; W=C+.5#                Save coordinates                 BN31  66
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN31  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN31  68
IF(DISTMN>99999.) BREAK#               Exit when all asigned            BN31  69
#                                                                       BN31  70
QX(I+1)=U; QX(I+2)=V; QX(I+3)=W#       Store closest point              BN31  71
QX(I+4)=FLOAT(STOP7); STOP7=STOP7+STEP7# Store group list addr          BN31  72
#                                                                       BN31  73
WHILE(NCONN==yes:)#                    Loop until no connects           BN31  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN31  75
NCONN=no:#                             Reset connect flag               BN31  76
#                                                                       BN31  77
FOR(J=MARK6;J<STOP6;J=J+STEP6)#        Loop over atoms list             BN31  78
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BN31  79
ifne:(QX(I+4),QX(J+4)) NEXT#           Skip unless current group        BN31  80
II=NINT(QX(J-6)); D1=QX(II+2)#         Extract bond radii               BN31  81
P=QX(J+1);  Q=QX(J+2);  R=QX(J+3)#     Extract atom coords              BN31  82
#                                                                       BN31  83
FOR(K=MARK6;K<STOP6;K=K+STEP6)#        Loop over unassigned atoms       BN31  84
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BN31  85
IF(QX(K+4)>0.5) NEXT#                  Skip assigned atoms              BN31  86
JJ=NINT(QX(K-6)); D2=(QX(JJ+2)+D1)**2# Extract bond distance**2         BN31  87
X=QX(K+1);  Y=QX(K+2);  Z=QX(K+3)#     Extract input coords             BN31  88
U=QX(K+5);  V=QX(K+6);  W=QX(K+7)#     Extract input sigmas             BN31  89
#                                                                       BN31  90
FOR(LS=MARK3;LS<SYMLIM;LS=LS+STEP3)#   Begin loop over symops           BN31  91
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BN31  92
A=QX(LS+1)*X+QX(LS+4)*Y+QX(LS+7)*Z+QX(LS+10)# Get x'                    BN31  93
B=QX(LS+2)*X+QX(LS+5)*Y+QX(LS+8)*Z+QX(LS+11)# Get y'                    BN31  94
C=QX(LS+3)*X+QX(LS+6)*Y+QX(LS+9)*Z+QX(LS+12)# Get z'                    BN31  95
A=MOD(99.5+A-P,1.)-0.5#                Get closest to origin            BN31  96
B=MOD(99.5+B-Q,1.)-0.5#                Get closest to origin            BN31  97
C=MOD(99.5+C-R,1.)-0.5#                Get closest to origin            BN31  98
DIST=G1*A*A+G5*B*B+G9*C*C+G2*A*B+G3*A*C+G6*B*C# Dist**2                 BN31  99
IF(DIST<=D2) GOTO 100#                 Exit if connected                BN31 100
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BN31 101
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BN31 102
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BN31 103
NEXT#                                  Get next unassigned atom         BN31 104
#                                                                       BN31 105
100 NCONN=yes:#                        Flag a connection                BN31 106
QX(K+1)=A+P#                           Store new x'                     BN31 107
QX(K+2)=B+Q#                           Store new y'                     BN31 108
QX(K+3)=C+R#                           Store new z'                     BN31 109
QX(K+4)=QX(J+4)#                       Set group id                     BN31 110
#                                                                       BN31 111
#   TRANSFORM COORDINATE SIGMAS                                         BN31 112
#   ---------------------------                                         BN31 113
#                                                                       BN31 114
#QX(K+5)=ABS(QX(LS+1)*U)+ABS(QX(LS+4)*V)+ABS(QX(LS+7)*W)#               BN31 115
#QX(K+6)=ABS(QX(LS+2)*U)+ABS(QX(LS+5)*V)+ABS(QX(LS+8)*W)#               BN31 116
#QX(K+7)=ABS(QX(LS+3)*U)+ABS(QX(LS+6)*V)+ABS(QX(LS+9)*W)#               BN31 117
## The above actually equates to the following                          BN31 118
QX(K+5)=(QX(LS+1)*U)**2+(QX(LS+4)*V)**2+(QX(LS+7)*W)**2# Sig x          BN31 119
QX(K+6)=(QX(LS+2)*U)**2+(QX(LS+5)*V)**2+(QX(LS+8)*W)**2# Sig y          BN31 120
QX(K+7)=(QX(LS+3)*U)**2+(QX(LS+6)*V)**2+(QX(LS+9)*W)**2# Sig z          BN31 121
## Although the above three lines transform sigma in most cases,        BN31 122
## they fail for Hexagonal symmetry if the new coord is +-x+-y          BN31 123
## However it appears that in a hexagonal system correlation cannot     BN31 124
## be neglected. (only x and y are correlated )                         BN31 125
## But where does the times 2 multiplier disappear to?                  BN31 126
#QX(K+5)=ABS(QX(K+5)+2.*QX(LS+1)*QX(LS+4)*U*V)#                         BN31 127
#QX(K+6)=ABS(QX(K+6)+2.*QX(LS+2)*QX(LS+5)*U*V)#                         BN31 128
QX(K+5)=ABS(QX(K+5)+QX(LS+1)*QX(LS+4)*U*V)#                             BN31 129
QX(K+6)=ABS(QX(K+6)+QX(LS+2)*QX(LS+5)*U*V)#                             BN31 130
## Convert the variance to standard uncertainty                         BN31 131
QX(K+5)=SQRT(QX(K+5))#                 Sig x                            BN31 132
QX(K+6)=SQRT(QX(K+6))#                 Sig y                            BN31 133
QX(K+7)=SQRT(QX(K+7))#                 Sig z                            BN31 134
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN31 135
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN31 136
#                                                                       BN31 137
#   PACK CENTRES OF CLUSTERS CLOSE TOGETHER                             BN31 138
#   ---------------------------------------                             BN31 139
#                                                                       BN31 140
DO I=1,3; CP(I)=0.;   CN=0.#           Zero total coord sums            BN31 141
FOR(NC=MARK7;NC<STOP7;NC=NC+STEP7)#    Loop over groups                 BN31 142
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BN31 143
IF(CN>0.)#                             Calc centroid of all sites       BN31 144
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BN31 145
CX=CP(1)/CN; CY=CP(2)/CN; CZ=CP(3)/CN# Centre of all clusters           BN31 146
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BN31 147
DO I=1,4; QX(NC+I)=0.#                 Zero centre sums                 BN31 148
FOR(IP=MARK6;IP<STOP6;IP=IP+STEP6)#    Loop over all sites              BN31 149
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BN31 150
IF(NINT(QX(IP+4))!=NC) NEXT#           Skip if not in this group        BN31 151
QX(NC+4)=QX(NC+4)+1.#                  Count contributions              BN31 152
DO I=1,3; QX(NC+I)=QX(NC+I)+QX(IP+I)#  Sum coords                       BN31 153
DO I=1,3; CP(I)=CP(I)+QX(IP+I)#        Sum all coords                   BN31 154
CN=CN+1.#                              Sum members                      BN31 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BN31 156
DO I=1,3; QX(NC+I)=QX(NC+I)/QX(NC+4)#  Store centre of group            BN31 157
SX=QX(NC+1); SY=QX(NC+2); SZ=QX(NC+3)# Save centre other groups         BN31 158
IF(NC==MARK7) NEXT#                    Skip if first group              BN31 159
#                                                                       BN31 160
DIST=99999999.#                        Set initial vector               BN31 161
FOR(K=MARK3;K<STOP3;K=K+STEP3)#        Loop over all symops             BN31 162
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BN31 163
X=SX*QX(K+1)+SY*QX(K+4)+SZ*QX(K+7)+QX(K+10)# Generate equivalent x      BN31 164
Y=SX*QX(K+2)+SY*QX(K+5)+SZ*QX(K+8)+QX(K+11)# Generate equivalent y      BN31 165
Z=SX*QX(K+3)+SY*QX(K+6)+SZ*QX(K+9)+QX(K+12)# Generate equivalent z      BN31 166
P=X-CX;  Q=Y-CY;  R=Z-CZ#              Get diff with centre 1           BN31 167
A=MOD(99.5+P,1.)-0.5#                  Ensure x' close to centre 1      BN31 168
B=MOD(99.5+Q,1.)-0.5#                  Ensure y' close to centre 1      BN31 169
C=MOD(99.5+R,1.)-0.5#                  Ensure z' close to centre 1      BN31 170
DD=G1*A*A+G5*B*B+G9*C*C+G2*A*B+G3*A*C+G6*B*C# Dist**2                   BN31 171
IF(DD>=DIST) NEXT#                     Skip if not smallest             BN31 172
U=P-A; V=Q-B; W=R-C; J=K; DIST=DD-0.01# Closest to centre 1             BN31 173
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BN31 174
#                                                                       BN31 175
FOR(IP=MARK6;IP<STOP6;IP=IP+STEP6)#    Loop over all sites              BN31 176
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BN31 177
IF(NINT(QX(IP+4))!=NC) NEXT#           Skip if not in this group        BN31 178
P=QX(IP+1);  Q=QX(IP+2);  R=QX(IP+3)#  Extract atom coords              BN31 179
X=P*QX(J+1)+Q*QX(J+4)+R*QX(J+7)+QX(J+10)# Generate  x                   BN31 180
Y=P*QX(J+2)+Q*QX(J+5)+R*QX(J+8)+QX(J+11)# Generate  y                   BN31 181
Z=P*QX(J+3)+Q*QX(J+6)+R*QX(J+9)+QX(J+12)# Generate  z                   BN31 182
QX(IP+1)=X-U#                          Move x to new centre             BN31 183
QX(IP+2)=Y-V#                          Move y to new centre             BN31 184
QX(IP+3)=Z-W#                          Move z to new centre             BN31 185
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BN31 186
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BN31 187
#                                                                       BN31 188
#    ENSURE CENTRE OF COMBINED CLUSTERS INSIDE CELL                     BN31 189
#    ----------------------------------------------                     BN31 190
#                                                                       BN31 191
DO I=1,3; TM(I)=0.;    CN=0.#          Set centre sums to zero          BN31 192
FOR(IP=MARK6;IP<STOP6;IP=IP+STEP6)#    Loop over all sites              BN31 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BN31 194
CN=CN+1.#                              Count contributions              BN31 195
DO I=1,3; TM(I)=TM(I)+QX(IP+I)#        Sum all coords                   BN31 196
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BN31 197
DO I=1,3#                              Loop over coords                 BN31 198
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BN31 199
TM(I)=TM(I)/CN#                        Get average coord                BN31 200
IF     (TM(I)<0.) TM(I)=+1.#           Centre out of cell               BN31 201
ELSE IF(TM(I)>1.) TM(I)=-1.#           Centre out of cell               BN31 202
ELSE              TM(I)= 0.#           Centre in cell                   BN31 203
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BN31 204
#                                                                       BN31 205
#    GET FINAL SYMOP AND CELL TRANSLATION PER SITE                      BN31 206
#    ---------------------------------------------                      BN31 207
#                                                                       BN31 208
FOR(IP=MARK6;IP<STOP6;IP=IP+STEP6)#    Loop over all sites              BN31 209
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BN31 210
DO I=1,3; QX(IP+I)=QX(IP+I)+TM(I)#     Move to new centre               BN31 211
P=QX(IP+1);  Q=QX(IP+2);  R=QX(IP+3)#  Extract new coords               BN31 212
X=QX(IP-5);  Y=QX(IP-4);  Z=QX(IP-3)#  Extract input coords             BN31 213
QX(IP+9)=0.#                           Flag as zero translation         BN31 214
#                                                                       BN31 215
FOR(LS=MARK3;LS<SYMLIM;LS=LS+STEP3)#   Begin loop over symops           BN31 216
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BN31 217
A=QX(LS+1)*X+QX(LS+4)*Y+QX(LS+7)*Z+QX(LS+10)# Get x'                    BN31 218
B=QX(LS+2)*X+QX(LS+5)*Y+QX(LS+8)*Z+QX(LS+11)# Get y'                    BN31 219
C=QX(LS+3)*X+QX(LS+6)*Y+QX(LS+9)*Z+QX(LS+12)# Get z'                    BN31 220
IF(ABS(A-P)<.001&ABS(B-Q)<.001&ABS(C-R)<.001) GOTO150# Exit if =        BN31 221
U=MOD(99.5+A-P,1.)-0.5#                Get smallest difference          BN31 222
V=MOD(99.5+B-Q,1.)-0.5#                Get smallest difference          BN31 223
W=MOD(99.5+C-R,1.)-0.5#                Get smallest difference          BN31 224
IF(ABS(U)<.001&ABS(V)<.001&ABS(W)<.001) BREAK# Exit if =                BN31 225
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BN31 226
NEW=yes:#                              Translation is applied           BN31 227
QX(IP+9)=555.+(P-A)*100.+(Q-B)*10.+(R-C)# Store lattice translations    BN31 228
150 QX(IP+8)=FLOAT((LS-MARK3)/STEP3+1)# Store symop number              BN31 229
IF(LS==MARK3) QX(IP+8)=0.#             Switch off identity matrix       BN31 230
ELSE          NEW=yes:#                Signal there are input changes   BN31 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BN31 232
#                                                                       BN31 233
#     PRINT GROUP SUMMARY                                               BN31 234
#     -------------------                                               BN31 235
#                                                                       BN31 236
IF(NEW==yes:\STOP7>MARK7+STEP7)#       Print coords if >1 groups        BN31 237
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BN31 238
LINRM=5#                               Ensure sufficient space          BN31 239
movechar:(B081,NB081,CHROT,2,NB081-2,2)# Insert header underline        BN31 240
writeline:(1,B081,NB081-1,2,3)#        Atom list header                 BN31 241
HEADOT=' '; HEADOT(LABMAX+6^)=B083#    Store atom list header           BN31 242
FOR(LN=MARK7;LN<STOP7;LN=LN+STEP7)#    Loop over group table            BN31 243
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 BN31 244
IF(LN>MARK7) writeline:(0,0,0,1,3)#    Insert spacer                    BN31 245
BUFOT(1)=FLOAT((LN-MARK7)/STEP7+1)#    Get group number                 BN31 246
ncodefld:(BUFOT,1,B082,80213.,1)#      Format group number              BN31 247
writeline:(0,B082,NB082,3,3)#          Print atom coords                BN31 248
LINRM=5#                               Force first header               BN31 249
FOR(J=MARK6;J<STOP6;J=J+STEP6)#        Loop over atoms table            BN31 250
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 BN31 251
IF(NINT(QX(J+4))!=LN) NEXT#            Select only those in group       BN31 252
movertoc:(QX(J+18),1,CHROT,2,LABMAX,0)# Insert atom name                BN31 253
LCHROT=LABMAX+1#                       Point to last char chrin         BN31 254
ncodefld:(QX,J+1,CHROT,FMTX,3)#        Format coords                    BN31 255
ncodefld:(QX,J+8,CHROT,FMTS,2)#        Format translation symmetry      BN31 256
writeline:(0,HEADOT,100,1,3)#          Print atom coords                BN31 257
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 BN31 258
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 BN31 259
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BN31 260
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN31 261
ELSE STOP7=MARK7+STEP7#                Assume only one group            BN31 262
#                                                                       BN31 263
#   PUNCH OUT CONNECTED ATOM SET                                        BN31 264
#   ----------------------------                                        BN31 265
#                                                                       BN31 266
FOR(K=MARK6;K<STOP6;K=K+STEP6)#        Loop over the atoms              BN31 267
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 BN31 268
CHROT='ATOM'#                          Prepare punch buffer             BN31 269
movertoc:(QX(K+18),1,CHROT,6,LABMAX,0)# Insert atom name                BN31 270
LCHROT=LABMAX+6#                       Set start of format              BN31 271
DO I=1,3; BUFOT(I  )=QX(K+I)#          Store x,y,z                      BN31 272
DO I=1,3; BUFOT(I+5)=QX(K+I+4)#        Store sigma x,y,z                BN31 273
ifeq:(QX(K+11),0.) BUFOT(4)=QX(K+10)#  Store iso u                      BN31 274
ELSE BUFOT(4)=(QX(K+10)+QX(K+11)+QX(K+12))/3.# Store average u          BN31 275
BUFOT(5)=QX(K+16)#                     Store pop param                  BN31 276
ncodefld:(BUFOT,1,CHROT,FMTP,8)#       Format atom data                 BN31 277
writepch:(CHROT,80)#                   Punch atom line                  BN31 278
ifeq:(QX(K+11),0.) NEXT#               Skip uij if only iso             BN31 279
CHROT='UIJ '#                          Prepare punch buffer             BN31 280
N=NINT(QX(K+8))#                       Extract the symop number         BN31 281
IF(N>0)#                               If corrds transformed            BN31 282
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 BN31 283
N=MARK3+(N-1)*STEP3#                   Point to symop elements          BN31 284
BUFOT(1)=  QX(N+1)*QX(N+1)*QX(K+10) $#                                  BN31 285
+          QX(N+4)*QX(N+4)*QX(K+11) $#                                  BN31 286
+          QX(N+7)*QX(N+7)*QX(K+12) $#                                  BN31 287
+      2.*(QX(N+1)*QX(N+4)*QX(K+13) $#                                  BN31 288
+          QX(N+1)*QX(N+7)*QX(K+14) $#                                  BN31 289
+          QX(N+4)*QX(N+7)*QX(K+15))#                                   BN31 290
BUFOT(2)=  QX(N+2)*QX(N+2)*QX(K+10) $#                                  BN31 291
+          QX(N+5)*QX(N+5)*QX(K+11) $#                                  BN31 292
+          QX(N+8)*QX(N+8)*QX(K+12) $#                                  BN31 293
+      2.*(QX(N+2)*QX(N+5)*QX(K+13) $#                                  BN31 294
+          QX(N+2)*QX(N+8)*QX(K+14) $#                                  BN31 295
+          QX(N+5)*QX(N+8)*QX(K+15))#                                   BN31 296
BUFOT(3)=  QX(N+3)*QX(N+3)*QX(K+10) $#                                  BN31 297
+          QX(N+6)*QX(N+6)*QX(K+11) $#                                  BN31 298
+          QX(N+9)*QX(N+9)*QX(K+12) $#                                  BN31 299
+      2.*(QX(N+3)*QX(N+6)*QX(K+13) $#                                  BN31 300
+          QX(N+3)*QX(N+9)*QX(K+14) $#                                  BN31 301
+          QX(N+6)*QX(N+9)*QX(K+15))#                                   BN31 302
BUFOT(4)=  QX(N+1)*QX(N+2)*QX(K+10) $#                                  BN31 303
+          QX(N+4)*QX(N+5)*QX(K+11) $#                                  BN31 304
+          QX(N+7)*QX(N+8)*QX(K+12) $#                                  BN31 305
+         (QX(N+2)*QX(N+4)+QX(N+1)*QX(N+5))*QX(K+13)$#                  BN31 306
+         (QX(N+2)*QX(N+7)+QX(N+1)*QX(N+8))*QX(K+14)$#                  BN31 307
+         (QX(N+5)*QX(N+7)+QX(N+4)*QX(N+8))*QX(K+15)#                   BN31 308
BUFOT(5)=  QX(N+1)*QX(N+3)*QX(K+10) $#                                  BN31 309
+          QX(N+4)*QX(N+6)*QX(K+11) $#                                  BN31 310
+          QX(N+7)*QX(N+9)*QX(K+12) $#                                  BN31 311
+         (QX(N+3)*QX(N+4)+QX(N+1)*QX(N+6))*QX(K+13)$#                  BN31 312
+         (QX(N+3)*QX(N+7)+QX(N+1)*QX(N+9))*QX(K+14)$#                  BN31 313
+         (QX(N+6)*QX(N+7)+QX(N+4)*QX(N+9))*QX(K+15)#                   BN31 314
BUFOT(6)=  QX(N+2)*QX(N+3)*QX(K+10) $#                                  BN31 315
+          QX(N+5)*QX(N+6)*QX(K+11) $#                                  BN31 316
+          QX(N+8)*QX(N+9)*QX(K+12) $#                                  BN31 317
+         (QX(N+3)*QX(N+5)+QX(N+2)*QX(N+6))*QX(K+13)$#                  BN31 318
+         (QX(N+3)*QX(N+8)+QX(N+2)*QX(N+9))*QX(K+14)$#                  BN31 319
+         (QX(N+6)*QX(N+8)+QX(N+5)*QX(N+9))*QX(K+15)#                   BN31 320
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 BN31 321
ELSE movereal:(QX,K+10,BUFOT,1,6,0)#   Insert uij's into op buffer      BN31 322
movertoc:(QX(K+18),1,CHROT,6,LABMAX,0)# Insert atom label               BN31 323
LCHROT=LABMAX+6#                       Set start of format              BN31 324
ncodefld:(BUFOT,1,CHROT,FMTP,6)#       Format uij data                  BN31 325
writepch:(CHROT,80)#                   Punch atom line                  BN31 326
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 BN31 327
CHROT=' '#                             Blank line op buffer             BN31 328
#                                                                       BN31 329
#  GET MAX CENTROID-ATOM DISTANCE IN EACH GROUP                         BN31 330
#  --------------------------------------------                         BN31 331
#                                                                       BN31 332
FOR(L=MARK7;L<STOP7;L=L+STEP7)#        Loop over atom groups            BN31 333
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 BN31 334
DMAX=0.0#                              Reset max distance               BN31 335
DO I=1,4; QX(L+I)=0.#                  Zero all coords                  BN31 336
FOR(IP=MARK6;IP<STOP6;IP=IP+STEP6)#    Loop over all sites              BN31 337
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 BN31 338
ifeq:(QX(IP+4),0.) QX(IP+4)=FLOAT(MARK7)# Unset groups are in one       BN31 339
IF(NINT(QX(IP+4))!=L) NEXT#            Skip if not correct group        BN31 340
DO I=1,3; QX(L+I)=QX(L+I)+QX(IP+I)#    Sum all coords                   BN31 341
QX(L+4)=QX(L+4)+1.#                    Count sites in group             BN31 342
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 BN31 343
DO I=1,3; QX(L+I)=QX(L+I)/QX(L+4)#     Mean of all coords               BN31 344
FOR(K=MARK6;K<STOP6;K=K+STEP6)#        Loop over the atoms              BN31 345
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 BN31 346
IF(NINT(QX(K+4))!=L) NEXT#             Skip if no match                 BN31 347
X=QX(L+1)-QX(K+1)#                     X diff centroid & transl         BN31 348
Y=QX(L+2)-QX(K+2)#                     Y diff centroid & transl         BN31 349
Z=QX(L+3)-QX(K+3)#                     Z diff centroid & transl         BN31 350
DIST=G1*X*X+G5*Y*Y+G9*Z*Z+G2*X*Y+G3*X*Z+G6*Y*Z# Calc distance **2       BN31 351
DMAX=AMAX1(DIST,DMAX)#                 Store maximum distance           BN31 352
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 BN31 353
QX(L+5)=SQRT(DMAX)+MXBRAD#             Store maximum distance           BN31 354
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 BN31 355
#                                                                       BN31 356
RETURN#                                                                 BN31 357
END#                                                                    BN31 358
systemheader:(BN35)#                   Make connected atom table        BN35   1
# ################################################################## #  BN35   2
#                                                                    #  BN35   3
#                               BN35                                 #  BN35   4
#                                                                    #  BN35   5
# ################################################################## #  BN35   6
SUBROUTINE BN35#                       S.r. hall 1983                   BN35   7
include:(AACOMN)#                      W.dreissig 1986                  BN35   8
include:(BNCOMN)#                                                       BN35   9
#                                                                       BN35  10
INTEGER M8,L8,LI,N8,LS,J8,IR,JR,K8,I8#                                  BN35  11
INTEGER LT,II,JJ,KK,LN,SYMLIM,TRNLIM#                                   BN35  12
REAL BNRAD,BNDIST,DIST#                                                 BN35  13
REAL A,B,C,X,Y,Z,U,V,W,DX,DY,DZ#       Coordinates                      BN35  14
REAL D,E,F,P,Q,R#                                                       BN35  15
REAL TR1(125),TR2(125),TR3(125)#       Cell translations                BN35  16
REAL S1,S2,S3#                         Cell translation generators      BN35  17
REAL XD,YD,ZD#                         New atom site                    BN35  18
#                                                                       BN35  19
realdata:(SMALL,0.0009)#                                                BN35  20
intdata:(SURLIM,[1,3,5])#                                               BN35  21
datastuff:#                                                             BN35  22
#                                                                       BN35  23
#     SET UP THE UNIT CELL TRANSLATION TABLE                            BN35  24
#     --------------------------------------                            BN35  25
#                                                                       BN35  26
LN=SURLIM(SUR)#                        Set extent of translations       BN35  27
TRNLIM=0 ; S1=FLOAT(-SUR)#             Set starting count and cell      BN35  28
DO II=1,LN#                            Loop over x translations         BN35  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN35  30
S2=FLOAT(-SUR) ; S1=S1+1.0#            Set up y, increment x            BN35  31
DO JJ=1,LN#                            Loop over y translations         BN35  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN35  33
S3=FLOAT(-SUR) ; S2=S2+1.0#            Set up z, increment y            BN35  34
DO KK=1,LN#                            Loop over z translations         BN35  35
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN35  36
S3=S3+1.0 ; TRNLIM=TRNLIM+1#           Increment z and count            BN35  37
TR1(TRNLIM)=S1;TR2(TRNLIM)=S2#         Set up table                     BN35  38
TR3(TRNLIM)=S3#                        Of translation vectors.          BN35  39
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN35  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN35  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN35  42
#                                                                       BN35  43
#   FORM ATOM COORD SEARCH LIST                                         BN35  44
#   ---------------------------                                         BN35  45
#                                                                       BN35  46
MARK8=STOP7;  STEP8=9;  STOP8=MARK8#   Start table8 pointer             BN35  47
IF(FUL==no:)SYMLIM=MARK3+STEP3#        Or limit search to identity      BN35  48
ELSE        SYMLIM=STOP3#              Use all symops                   BN35  49
FOR(LN=MARK7;LN<STOP7;LN=LN+STEP7)#    Loop over group n                BN35  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN35  51
M8=STOP8;    L8=STOP8#                 Set current limit of table8      BN35  52
BNRAD=4.*QX(LN+5)**2#                  Get bond radius of centroid      BN35  53
P=QX(LN+1);  Q=QX(LN+2);  R=QX(LN+3)#  Extract centroid coords          BN35  54
#                                                                       BN35  55
FOR(LI=MARK6;LI<STOP6;LI=LI+STEP6)#    Loop over atoms group n          BN35  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN35  57
IF(NINT(QX(LI+4))!=LN) NEXT#           Skip if not in group             BN35  58
incrqx:(N8,L8+STEP8,BN3501)#           No mem...........bn3501          BN35  59
movereal:(QX,LI+1,QX,L8+1,8,1)#        Transfer atom coords             BN35  60
QX(L8+4)=FLOAT(LI)#                    Store pointer to atoms list      BN35  61
L8=N8#                                 Incr table8 pointer              BN35  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN35  63
QX(LN+4)=FLOAT(N8);  STOP8=N8#         Mark start of added atoms        BN35  64
#                                                                       BN35  65
FOR(LS=MARK3;LS<SYMLIM;LS=LS+STEP3)#   Loop over symops                 BN35  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN35  67
D=QX(LS+1)*P+QX(LS+4)*Q+QX(LS+7)*R+QX(LS+10)# Get coord                 BN35  68
E=QX(LS+2)*P+QX(LS+5)*Q+QX(LS+8)*R+QX(LS+11)# Get coord                 BN35  69
F=QX(LS+3)*P+QX(LS+6)*Q+QX(LS+9)*R+QX(LS+12)# Get coord                 BN35  70
#                                                                       BN35  71
DO LT=1,TRNLIM#                        Loop over cell transl            BN35  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BN35  73
DX=D-P+TR1(LT)#                        Get transformed x                BN35  74
DY=E-Q+TR2(LT)#                        Get transformed y                BN35  75
DZ=F-R+TR3(LT)#                        Get transformed z                BN35  76
DIST=G1*DX*DX+G5*DY*DY+G9*DZ*DZ$#      Calc distance**2                 BN35  77
+    G2*DX*DY+G3*DX*DZ+G6*DY*DZ#       Calc distance**2                 BN35  78
IF(DIST>BNRAD) NEXT#                   If two centroids not close       BN35  79
#                                                                       BN35  80
#     ATOMS IN CLOSE GROUP                                              BN35  81
#     --------------------                                              BN35  82
#                                                                       BN35  83
FOR(I8=M8;I8<L8;I8=I8+STEP8)#          Loop over atom group             BN35  84
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BN35  85
U=QX(I8+1);  V=QX(I8+2);  W=QX(I8+3)#  Extract atom coords              BN35  86
X=QX(I8+5);  Y=QX(I8+6);  Z=QX(I8+7)#  Extract coord sigmas             BN35  87
A=QX(LS+1)*U+QX(LS+4)*V+QX(LS+7)*W+QX(LS+10)# Generate coord            BN35  88
B=QX(LS+2)*U+QX(LS+5)*V+QX(LS+8)*W+QX(LS+11)# Generate coord            BN35  89
C=QX(LS+3)*U+QX(LS+6)*V+QX(LS+9)*W+QX(LS+12)# Generate coord            BN35  90
DX=A-U+TR1(LT)#                        Get transformed x                BN35  91
DY=B-V+TR2(LT)#                        Get transformed y                BN35  92
DZ=C-W+TR3(LT)#                        Get transformed z                BN35  93
DIST=G1*DX*DX+G5*DY*DY+G9*DZ*DZ$#      Calc distance**2                 BN35  94
+    G2*DX*DY+G3*DX*DZ+G6*DY*DZ#       Calc distance**2                 BN35  95
IF(DIST<=SMALL) QX(I8+9)=QX(I8+9)+1.#  Test if sites overlapped         BN35  96
ELSE#                                  Else sites not overlapped        BN35  97
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BN35  98
II=NINT(QX(I8+4))#                     Extract pointer atoms list       BN35  99
IR=NINT(QX(II-6))#                     Pointer to radii list            BN35 100
#                                                                       BN35 101
FOR(J8=M8;J8<L8;J8=J8+STEP8)#          Loop over group of atoms         BN35 102
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BN35 103
DX=A-QX(J8+1)+TR1(LT)#                 Get transformed x                BN35 104
DY=B-QX(J8+2)+TR2(LT)#                 Get transformed y                BN35 105
DZ=C-QX(J8+3)+TR3(LT)#                 Get transformed z                BN35 106
DIST=G1*DX*DX+G5*DY*DY+G9*DZ*DZ$#      Calc distance**2                 BN35 107
+    G2*DX*DY+G3*DX*DZ+G6*DY*DZ#       Calc distance**2                 BN35 108
JJ=NINT(QX(J8+4))#                     Extract pointer atoms list       BN35 109
JR=NINT(QX(JJ-6))#                     Extract radii table pointer      BN35 110
BNDIST=(QX(IR+2)+QX(JR+2))**2#         Calc max bond distance           BN35 111
IF(DIST<=BNDIST) BREAK#                Exit if atoms bonded             BN35 112
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BN35 113
IF(J8==L8) NEXT#                       Skip to next atom if unbonded    BN35 114
XD=DX+QX(J8+1);YD=DY+QX(J8+2);ZD=DZ+QX(J8+3)# Store new atom site       BN35 115
FOR(K8=M8;K8<N8;K8=K8+STEP8)#          Is new site unique?              BN35 116
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BN35 117
ifne:(XD,QX(K8+1),0.001) NEXT#         Skip if diff x                   BN35 118
ifne:(YD,QX(K8+2),0.001) NEXT#         Skip if diff y                   BN35 119
ifeq:(ZD,QX(K8+3),0.001) BREAK#        Skip if diff z                   BN35 120
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BN35 121
IF(K8<N8) NEXT#                        Skip if overlap found            BN35 122
#                                                                       BN35 123
incrqx:(STOP8,N8+STEP8,BN3501)#        No mem............bn3501         BN35 124
QX(N8+1)=XD#                           Store new x                      BN35 125
QX(N8+2)=YD#                           Store new x                      BN35 126
QX(N8+3)=ZD#                           Store new z                      BN35 127
QX(N8+4)=QX(I8+4)#                     Store atom list pointer          BN35 128
#                                                                       BN35 129
#   TRANSFORM COORDINATE SIGMAS                                         BN35 130
#   ---------------------------                                         BN35 131
#                                                                       BN35 132
#QX(N8+5)=ABS(QX(LS+1)*X)+ABS(QX(LS+4)*Y)+ABS(QX(LS+7)*Z)# SIG X        BN35 133
#QX(N8+6)=ABS(QX(LS+2)*X)+ABS(QX(LS+5)*Y)+ABS(QX(LS+8)*Z)# SIG Y        BN35 134
#QX(N8+7)=ABS(QX(LS+3)*X)+ABS(QX(LS+6)*Y)+ABS(QX(LS+9)*Z)# SIG Z        BN35 135
## The above actually equates to the following                          BN35 136
QX(N8+5)=(QX(LS+1)*X)**2+(QX(LS+4)*Y)**2+(QX(LS+7)*Z)**2# Sig x         BN35 137
QX(N8+6)=(QX(LS+2)*X)**2+(QX(LS+5)*Y)**2+(QX(LS+8)*Z)**2# Sig y         BN35 138
QX(N8+7)=(QX(LS+3)*X)**2+(QX(LS+6)*Y)**2+(QX(LS+9)*Z)**2# Sig z         BN35 139
## Although the above three lines transform sigma in most cases         BN35 140
## they fail for Hexagonal symmetry if the new coord is +-x+-y          BN35 141
## It appears that in a hexagonal system correlation cannot             BN35 142
## always be neglected. (only x and y are correlated )                  BN35 143
## there is a factor of 2 that apparently disappears?                   BN35 144
## Ordinarily the following  line has no effect                         BN35 145
QX(N8+5)=QX(N8+5)+QX(LS+1)*QX(LS+4)*X*Y#                                BN35 146
QX(N8+6)=QX(N8+6)+QX(LS+2)*QX(LS+5)*X*Y#                                BN35 147
## Convert the variance to standard uncertainty                         BN35 148
QX(N8+5)=SQRT(QX(N8+5))#               Sig x                            BN35 149
QX(N8+6)=SQRT(QX(N8+6))#               Sig y                            BN35 150
QX(N8+7)=SQRT(QX(N8+7))#               Sig z                            BN35 151
N8=STOP8#                              Incr table 8 pointer             BN35 152
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BN35 153
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BN35 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BN35 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN35 156
QX(LN+6)=FLOAT(STOP8)#                 Number added to group list       BN35 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN35 158
#                                                                       BN35 159
RETURN#                                                                 BN35 160
END#                                                                    BN35 161
systemheader:(BN41)#                   List spec posns & symops         BN41   1
# ****************************************************************** #  BN41   2
#                                                                    #  BN41   3
#                               BN41                                 #  BN41   4
#                                                                    #  BN41   5
# ****************************************************************** #  BN41   6
SUBROUTINE BN41#                       S.r.hall 1983                    BN41   7
include:(BNCOMN)#                      W.dreissig 1986                  BN41   8
include:(AACOMN)#                                                       BN41   9
#                                                                       BN41  10
REAL A,B,C,P,Q,R,TEST,U,V,W,X,Y,Z#                                      BN41  11
REAL CODE,VAL#                                                          BN41  12
INTEGER I,J,JJ,K,L,M,SYMLIM#                                            BN41  13
INTEGER L8,LS,NTOT#                                                     BN41  14
chardata:(B111," Atoms at special positions are...")#                   BN41  15
chardata:(B113,"   mult  (max =   )")#                                  BN41  16
chardata:(B116,"   Symop      ")#                                       BN41  17
chardata:(B117," Symmetry operations applied are...")#                  BN41  18
chardata:(FRAC,      1/61/41/3   1/2   2/33/45/6      )#                BN41  19
intdata:(DENOM,[12,6,4,3,12,2,12,3,4,6,12, 1])#                         BN41  20
chardata:(XYZ,'-x-y-z+x+y+z')#                                          BN41  21
datastuff:#                                                             BN41  22
#                                                                       BN41  23
#    LIST ANY SPECIAL POSITIONS                                         BN41  24
#    --------------------------                                         BN41  25
#                                                                       BN41  26
NTOT=0;    NSYM=no:#                   Set header flag                  BN41  27
IF(FUL==no:)SYMLIM=MARK3+STEP3#        Or restrict to identity          BN41  28
ELSE        SYMLIM=STOP3#              Set usual search                 BN41  29
FOR(L8=MARK8;L8<STOP8;L8=L8+STEP8)#    Loop over all stored sites       BN41  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN41  31
JJ=NINT(QX(L8+4))#                     Extract atom list pointer        BN41  32
IF(QX(L8+9)>1.5)#                      Test symop not xyz               BN41  33
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN41  34
IF(NTOT==0)#                           Test if first occurence          BN41  35
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN41  36
LINRM=8#                               Ensure sufficient space          BN41  37
writeline:(1,B111,NB111,3,3)#          Print spec posn header           BN41  38
BUFOT(1)=FLOAT((SYMLIM-MARK3)/STEP3)#  Number general positions         BN41  39
ncodefld:(BUFOT,1,B113,180313.,1)#     Insert general site mult         BN41  40
HEADOT=' '; HEADOT(LABMAX+2^)=B113#    Store header                     BN41  41
writeline:(0,HEADOT,100,3,3)#          Print subheading                 BN41  42
NTOT=1#                                Flag that heading printed        BN41  43
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN41  44
movertoc:(QX(JJ+18),1,CHROT,2,24,0)#   Insert atom name                 BN41  45
BUFOT(2)=BUFOT(1)/QX(L8+9)#            Get number spec posn             BN41  46
LCHROT=LABMAX+3#                       Start format position            BN41  47
ncodefld:(BUFOT,2,CHROT,313.,1)#       Format site multiplicities       BN41  48
writeline:(0,0,0,1,3)#                 Print site data                  BN41  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN41  50
#                                                                       BN41  51
P=QX(L8+1);  Q=QX(L8+2);  R=QX(L8+3)#  Extract new coords               BN41  52
X=QX(JJ-5);  Y=QX(JJ-4);  Z=QX(JJ-3)#  Extract input coords             BN41  53
QX(L8+9)=0.#                           Flag as zero translation         BN41  54
#                                                                       BN41  55
FOR(LS=MARK3;LS<SYMLIM;LS=LS+STEP3)#   Begin loop over symops           BN41  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN41  57
A=QX(LS+1)*X+QX(LS+4)*Y+QX(LS+7)*Z+QX(LS+10)# Get x'                    BN41  58
B=QX(LS+2)*X+QX(LS+5)*Y+QX(LS+8)*Z+QX(LS+11)# Get y'                    BN41  59
C=QX(LS+3)*X+QX(LS+6)*Y+QX(LS+9)*Z+QX(LS+12)# Get z'                    BN41  60
IF(ABS(A-P)<.001&ABS(B-Q)<.001&ABS(C-R)<.001) GOTO150# Exit if =        BN41  61
U=MOD(99.5+A-P,1.)-0.5#                Get closest to origin            BN41  62
V=MOD(99.5+B-Q,1.)-0.5#                Get closest to origin            BN41  63
W=MOD(99.5+C-R,1.)-0.5#                Get closest to origin            BN41  64
IF(ABS(U)<.001&ABS(V)<.001&ABS(W)<.001) BREAK# Exit if =                BN41  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN41  66
NSYM=yes:#                             Translation is applied           BN41  67
QX(L8+9)=555.+(P-A)*100.+(Q-B)*10.+(R-C)# Store lattice translations    BN41  68
150 QX(L8+8)=FLOAT((LS-MARK3)/STEP3+1)# Store symop number              BN41  69
IF(LS==MARK3) QX(L8+8)=0.#             Switch off identity matrix       BN41  70
ELSE          NSYM=yes:#               Symops are applied               BN41  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN41  72
#                                                                       BN41  73
#    PRINT SYMOPS TO BE APPLIED                                         BN41  74
#    --------------------------                                         BN41  75
#                                                                       BN41  76
LINRM=5;  NTOT=0#                      Ensure sufficient space          BN41  77
FOR(LS=MARK3+STEP3;LS<SYMLIM;LS=LS+STEP3)# Loop over symops             BN41  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN41  79
TEST=FLOAT((LS-MARK3)/STEP3+1)#        Float the symop number           BN41  80
FOR(L8=MARK8;L8<STOP8;L8=L8+STEP8)#    Loop over all atom sites         BN41  81
ifeq:(TEST,QX(L8+8)) BREAK#            Exit if matched                  BN41  82
IF(L8==STOP8) NEXT#                    Skip if no symop match           BN41  83
IF(NTOT==0)writeline:(1,B117,NB117,3,3)# Write symop header             BN41  84
ncodefld:(TEST,1,B116,110313.,1)#      Format symop number              BN41  85
movechar:(B116,1,CHROT,1,11,0)#        Insert symop header              BN41  86
DO L=1,3#                              Loop over symop matrix           BN41  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN41  88
I=LS+L;    K=L*10+7#                   Point to row pointer             BN41  89
#J=NINT(QX(I+9)*12.)*3#                GET TRANSLN ELEMENT              BN41  90
#IF(J>0) CHROT(K^K+2)=FRAC(J+1^J+3)#   STORE TRANSL FRACTION            BN41  91
M=NINT(QX(I+9)*12.)#                   Get symop translation            BN41  92
J=MOD(M+3600,12)#                      Get transln element              BN41  93
CODE=FLOAT(K+2)*10000.+213.#           Write denominator                BN41  94
VAL=FLOAT(M/12)#                       Default value                    BN41  95
IF(J>0)#                               Non-integral                     BN41  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BN41  97
ncodefld:(FLOAT(DENOM(J)),1,CHROT,CODE,1)# Integral                     BN41  98
CHROT(K+1^K+1)='/'#                    Write division                   BN41  99
VAL=FLOAT(M*DENOM(J)/12)#              Add fractional num of denoms     BN41 100
CODE=FLOAT(K)*10000.+513.#             Dont' overwrite fraction         BN41 101
ncodefld:(VAL,1,CHROT,CODE,1)#         Encode the total number          BN41 102
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BN41 103
ELSEIF(M!=0) ncodefld:(VAL,1,CHROT,CODE,1)# Integral                    BN41 104
K=K+3#                                 Incr op pointer                  BN41 105
DO M=1,3#                              Loop along row elements          BN41 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BN41 107
J=NINT(QX(I+M*3-3))#                   Point to next element            BN41 108
IF(J==0) NEXT#                         Skip zero elements               BN41 109
CHROT(K^K+1)=XYZ(J*3+2+M*2^); K=K+2#   Extract xyz string               BN41 110
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BN41 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN41 112
writeline:(0,0,0,1,3);   NTOT=1#       Print the symmetry position      BN41 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN41 114
MARKR=STOP8; STEPR=15; STOPR=MARKR#    Set for input requests           BN41 115
#                                                                       BN41 116
RETURN#                                                                 BN41 117
END#                                                                    BN41 118
systemheader:(BN45)#                   Search bonds and angles          BN45   1
# ################################################################## #  BN45   2
#                                                                    #  BN45   3
#                               BN45                                 #  BN45   4
#                                                                    #  BN45   5
# ################################################################## #  BN45   6
SUBROUTINE BN45#                       S.r.hall 1983                    BN45   7
include:(AACOMN)#                      W.dreissig 1986                  BN45   8
include:(BNCOMN)#                                                       BN45   9
#                                                                       BN45  10
INTEGER I,J,K,L#                                                        BN45  11
INTEGER II,JJ,KK,LI,LJ,IR,JR,MM,NBON,LAST,LN,L8,M8,N8#                  BN45  12
INTEGER ATOM(100)#                                                      BN45  13
INTEGER IPT#                           Pointer to scratch file          BN45  14
REAL BMINI#                                                             BN45  15
REAL BRADI#                                                             BN45  16
REAL BNMAX#                            Max acceptable bond dist.        BN45  17
REAL BNMIN#                                                             BN45  18
REAL DIST#                             Distance between two points      BN45  19
REAL DX,DY,DZ#                                                          BN45  20
REAL BOND(100)#                                                         BN45  21
REAL SIGMA#                                                             BN45  22
REAL ANGLE#                                                             BN45  23
#                                                                       BN45  24
chardata:(UNDRL,-)#                                                     BN45  25
chardata:(B121," Bond distances and angles for Group  ")#               BN45  26
chardata:(B122," *** Listing of angles suppressed ***")#                BN45  27
chardata:(B123," MAX bonds per atom is 100. Exceeded by")#              BN45  28
chardata:(B124,"  dist/ang  sig   sym trn    x/a     y/b     z/c")#     BN45  29
chardata:(B125,"    *** Atom does not bond for set radii ***")#         BN45  30
realdata:(FMTS,[503.,503.])#                                            BN45  31
realdata:(FMTX,[842.,842.,842.])#                                       BN45  32
intdata:(MBON,100)#                                                     BN45  33
intdata:(PSIZS,18)#                                                     BN45  34
datastuff:#                                                             BN45  35
#                                                                       BN45  36
#    PROCESS ATOMS IN GROUPS                                            BN45  37
#    -----------------------                                            BN45  38
#                                                                       BN45  39
IF(DOB==yes:\IDH==yes:)#               Are bond dists needed?           BN45  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN45  41
M8=MARK8;   LAST=3*(LABMAX+1)+1#       Start table8                     BN45  42
HEADOT=' '; HEADOT(LAST+1^)=B124#      Store the header line            BN45  43
IF(NSYM==0) HEADOT(LAST+17^)=' '#      Blank off symop header           BN45  44
FOR(LN=MARK7;LN<STOP7;LN=LN+STEP7)#    Loop over group table 7          BN45  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN45  46
L8=M8#                                 Reset list 8 pointer             BN45  47
N8=NINT(QX(LN+4))#                     Mark end connected group         BN45  48
M8=NINT(QX(LN+6))#                     Mark end of total group          BN45  49
LINRM=8#                               Ensure sufficient room           BN45  50
BUFOT(1)=FLOAT((LN-MARK7)/STEP7+1)#    Get group number                 BN45  51
ncodefld:(BUFOT,1,B121,380213.,1)#     Format group number              BN45  52
movechar:(UNDRL,1,CHROT,2,37,1)#       Underline header                 BN45  53
writeline:(1,B121,NB121,1,3)#          Print main header                BN45  54
IF(ANG==no:) writeline:(1,B122,NB122,3,3)# Tell no angles searched      BN45  55
LINRM=2#                               Force first header               BN45  56
IF(IDH==yes:) MM=M8#                   Full search if dihedrals         BN45  57
ELSE          MM=N8#                   Otherwise parents only           BN45  58
#                                                                       BN45  59
#     PROCESS ATOMS IN GROUPS                                           BN45  60
#     -----------------------                                           BN45  61
#                                                                       BN45  62
FOR(LI=L8;LI<MM;LI=LI+STEP8)#          Loop over atoms group i          BN45  63
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN45  64
II=NINT(QX(LI+4))#                     Extract pointer atoms list       BN45  65
IR=NINT(QX(II-6))#                     Extract pointer radii list       BN45  66
BMINI=QX(IR+3)#                        Pick up min bond radius          BN45  67
BRADI=QX(IR+2)#                        Pick up max bond radius          BN45  68
NBON=0#                                Bonds per atom counter           BN45  69
#                                                                       BN45  70
FOR(LJ=L8;LJ<M8;LJ=LJ+STEP8)#          Loop over atoms group j          BN45  71
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN45  72
IF(LJ==LI) NEXT#                       Skip identical atoms             BN45  73
JJ=NINT(QX(LJ+4))#                     Extract pointer atoms list       BN45  74
JR=NINT(QX(JJ-6))#                     Extract pointer radii list       BN45  75
BNMAX=BRADI+QX(JR+2)#                  Sum max bond radius              BN45  76
BNMIN=BMINI+QX(JR+3)#                  Sum min bond radius              BN45  77
DX=QX(LI+1)-QX(LJ+1)#                  Calc delta x                     BN45  78
DY=QX(LI+2)-QX(LJ+2)#                  Calc delta y                     BN45  79
DZ=QX(LI+3)-QX(LJ+3)#                  Calc delta z                     BN45  80
DIST=SQRT(G1*DX*DX+G5*DY*DY+G9*DZ*DZ$# Calc distance                    BN45  81
+         G2*DX*DY+G3*DX*DZ+G6*DY*DZ)# Calc distance                    BN45  82
IF(DIST>BNMAX\DIST<BNMIN) NEXT#        Skip if outside limits           BN45  83
#                                                                       BN45  84
NBON=NBON+1#                           Count bond this atom             BN45  85
IF(NBON>MBON)#                         Test if bonds/atom reached       BN45  86
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN45  87
movechar:(B123,1,CHROT,1,NB123,0)#     Print max bonds per atom         BN45  88
movertoc:(QX(II+18),1,CHROT,41,24,0)#  Print max bonds per atom         BN45  89
writeline:(1,0,0,1,3)#                 Print max bonds per atom         BN45  90
LINRM=3;    NBON=MBON#                 Reset line room & bond numb      BN45  91
BREAK#                                 Exit from search loop            BN45  92
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN45  93
FOR(I=NBON;I>1;I=I-1)#                 Loop over existing bonds         BN45  94
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN45  95
IF(SORT==no:) BREAK#                   Exit if sort not requested       BN45  96
IF(DIST>BOND(I-1)) BREAK#              Exit to store new bond           BN45  97
ATOM(I)=ATOM(I-1)#                     Shuffle atom no. along           BN45  98
BOND(I)=BOND(I-1)#                     Shuffle bond dis along           BN45  99
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN45 100
ATOM(I)=LJ#                            Save list 8 address              BN45 101
BOND(I)=DIST#                          Save bond distance               BN45 102
IF(IDH==no:) NEXT#                     Is scratch file needed later     BN45 103
writepkt:(3,2,PSIZS,IPT)#              Point to output packet           BN45 104
movereal:(QX,LI+1,QX,IPT+ 1,9,1)#      Store origin atom data           BN45 105
movereal:(QX,LJ+1,QX,IPT+10,9,1)#      Store target atom data           BN45 106
QX(IPT+4)=FLOAT(LI); QX(IPT+13)=FLOAT(LJ)# Save the list 8 addresses^   BN45 107
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN45 108
IF(LI>=N8) NEXT#                       Skip printing of symm sites      BN45 109
#                                                                       BN45 110
#    LIST BOND DISTANCES                                                BN45 111
#    -------------------                                                BN45 112
#                                                                       BN45 113
CHROT(LABMAX+2^)='-'#                  Insert central atom highlight    BN45 114
movertoc:(QX(II+18),1,CHROT,LABMAX+3,24,0)# Insert central atom name    BN45 115
CHROT(LABMAX*2+3^)='-'#                Insert central atom highlight    BN45 116
IF(QX(LI+8)+QX(LI+9)>0.5)#             Test if symops applied           BN45 117
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BN45 118
LCHROT=LAST+15#                        Set op buffer pointer            BN45 119
ncodefld:(QX,LI+8,CHROT,FMTS,2)#       Insert symop number              BN45 120
ncodefld:(QX,LI+1,CHROT,FMTX,3)#       Format central xyz               BN45 121
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BN45 122
writeline:(1,HEADOT,100,1,3)#          Print central atom               BN45 123
IF(NBON==0) writeline:(1,B125,NB125,3,3)# Print message                 BN45 124
ELSE#                                                                   BN45 125
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BN45 126
DO K=1,NBON#                           Loop over bonds                  BN45 127
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BN45 128
CALL BN03(LI,ATOM(K),BOND(K),SIGMA)#   Calculate sigma for bond         BN45 129
J=ATOM(K);  JJ=NINT(QX(J+4))#          Extract pointer atoms list       BN45 130
movertoc:(QX(JJ+18),1,CHROT,LABMAX*2+4,LABMAX,0)# Insert atom name      BN45 131
LCHROT=LAST#                           Set op buffer pointer            BN45 132
ncodefld:(BOND ,K,CHROT,842.,1)#       Format bond items                BN45 133
ncodefld:(SIGMA,1,CHROT,742.,1)#       Format bond items                BN45 134
ncodefld:(QX,J+8 ,CHROT,FMTS,2)#       Insert symop number & transl     BN45 135
IF(QX(J+8)+QX(J+9)>0.5)#               If not input sites               BN45 136
ncodefld:(QX,J+1 ,CHROT,FMTX,3)#       Format bonded atom xyz           BN45 137
writeline:(0,HEADOT,100,1,3)#          Print atom bond                  BN45 138
INM(1)=II+18; INM(2)=JJ+18#            Set name pointers                BN45 139
IXY(1)=II+ 1; IXY(2)=J+  1#            Set xyz  pointers                BN45 140
IF(II<=JJ)CALL BN09(1,BOND(K),SIGMA)#  Punch bond distance              BN45 141
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BN45 142
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BN45 143
#                                                                       BN45 144
#    SEARCH FOR ANGLES BETWEEN BONDS                                    BN45 145
#    -------------------------------                                    BN45 146
#                                                                       BN45 147
IF((NBON<2)\(ANG==no:)) NEXT#          Skip if no angles                BN45 148
DO J=1,NBON-1#                         Loop over atom bonds             BN45 149
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BN45 150
DO K=J+1,NBON#                         Loop over atom bonds             BN45 151
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BN45 152
CALL BN04(ATOM(J),LI,ATOM(K),ANGLE,SIGMA)# Find angle and sigma         BN45 153
I=ATOM(J);    JJ=NINT(QX(I+4))#        Point to atom 2                  BN45 154
L=ATOM(K);    KK=NINT(QX(L+4))#        Point to atoms array             BN45 155
movertoc:(QX(JJ+18),1,CHROT,2,24,0)#   Insert atom name                 BN45 156
movertoc:(QX(KK+18),1,CHROT,LABMAX*2+4,24,0)# Insert atom name          BN45 157
LCHROT=LAST#                           Set op buffer pointer            BN45 158
ncodefld:(ANGLE,1,CHROT,822.,1)#       Format angle items               BN45 159
ncodefld:(SIGMA,1,CHROT,722.,1)#       Format angle items               BN45 160
ncodefld:(QX,I+8 ,CHROT,FMTS,2)#       Insert symop number & transl     BN45 161
ncodefld:(QX,L+8 ,CHROT,FMTS,2)#       Insert symop number & transl     BN45 162
writeline:(0,HEADOT,100,1,3)#          Print angle                      BN45 163
INM(1)=JJ+18; INM(2)=II+18; INM(3)=KK+18# Set name pointers             BN45 164
IXY(1)=I + 1; IXY(2)=II+ 1; IXY(3)=L + 1# Set xyz  pointers             BN45 165
CALL BN09(3,ANGLE,SIGMA)#              Punch bond angle                 BN45 166
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BN45 167
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BN45 168
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN45 169
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN45 170
IF(IDH==yes:) writepkt:(3,endrecord:,1,IPT)#                            BN45 171
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN45 172
#                                                                       BN45 173
RETURN#                                                                 BN45 174
END#                                                                    BN45 175
systemheader:(BN51)#                   Calc contact distances           BN51   1
# ################################################################## #  BN51   2
#                                                                    #  BN51   3
#                               BN51                                 #  BN51   4
#                                                                    #  BN51   5
# ################################################################## #  BN51   6
SUBROUTINE BN51#                       S.r.hall 1983                    BN51   7
include:(AACOMN)#                      W.dreissig 1986                  BN51   8
include:(BNCOMN)#                                                       BN51   9
#                                                                       BN51  10
INTEGER ISOR#                                                           BN51  11
INTEGER I,J,K,L,N,M#                                                    BN51  12
INTEGER II,JJ,LM,LN#                                                    BN51  13
INTEGER M8,N8,NT,MT#                                                    BN51  14
INTEGER MARK10,STOP10#                                                  BN51  15
INTEGER ISYM(200)#                                                      BN51  16
INTEGER IHEAD,IR,I9,JM,JN,JR,KS,LS,LT,MM,NCON,NHEAD,NN#                 BN51  17
REAL A,B,C,AA,BB,CC,BR,CR,DX,DY,DZ,P,Q,R,SCALE#                         BN51  18
REAL SIGMA,SS,SX,SY,SZ,TT,U,V,W,X,Y,Z,X1,Y1,Z1,XN,YN,ZN#                BN51  19
REAL CDIST#                                                             BN51  20
REAL CONDIS,BONDIS#                                                     BN51  21
REAL BTOC#                                                              BN51  22
REAL CRADN#                                                             BN51  23
REAL DIST#                                                              BN51  24
REAL XX,YY,ZZ,XS,YS,ZS#                                                 BN51  25
REAL CODE,VAL#                                                          BN51  26
#                                                                       BN51  27
chardata:(B161," Table of Contact Distances-")#                         BN51  28
chardata:(B162,"   Symop      ")#                                       BN51  29
chardata:(B163," Symmetry operations applied are...")#                  BN51  30
chardata:(B165," *** No contacts found for set radii ***")#             BN51  31
chardata:(B166," Insufficient memory to sort contact distances")#       BN51  32
chardata:(B167," dist   sigma  sym trn   x/a    y/b    z/c    $#        BN51  33
sym trn   x/a    y/b    z/c")#                                          BN51  34
chardata:(FRAC,      1/61/41/3   1/2   2/33/45/6      )#                BN51  35
intdata:(DENOM,[12,6,4,3,12,2,12,3,4,6,12, 1])#                         BN51  36
chardata:(XYZ,'-x-y-z+x+y+z')#                                          BN51  37
realdata:(FMTD,[742.,642.])#                                            BN51  38
realdata:(FMTX,[742.,742.,742.])#                                       BN51  39
realdata:(FMTS,[503.,503.])#                                            BN51  40
datastuff:#                                                             BN51  41
#                                                                       BN51  42
#                                                                       BN51  43
MARK9=STOPR; STEP9=10; STOP9=MARK9#    Initialize contact table         BN51  44
IF(KON==yes:)#                         Execute if contacts requested    BN51  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN51  46
#                                                                       BN51  47
#    PRINT CONTACT DISTANCE HEADERS                                     BN51  48
#    ------------------------------                                     BN51  49
#                                                                       BN51  50
LINRM=10; NHEAD=(LABMAX+2)*2; IHEAD=0# Get heading all on one page      BN51  51
movechar:(B161,NB161,CHROT,2,NB161-2,2)# Insert contact header          BN51  52
writeline:(2,B161,NB161-1,2,3)#        Print contact header             BN51  53
HEADOT=' '; HEADOT(NHEAD+2^)=B167#     Store main header line           BN51  54
BTOC=MXCRAD-MXBRAD;    NN=MARK8#       Diff between bond and contac     BN51  55
DO I=1,200; ISYM(I)=0#                 Zero symmetry number array       BN51  56
SCALE=FLOAT((STOP5-MARK5)/STEP5+10)#   Form scale for sorting           BN51  57
#                                                                       BN51  58
#  ARE GROUPS WITHIN CONTACT DISTANCE                                   BN51  59
#  ----------------------------------                                   BN51  60
#                                                                       BN51  61
FOR(LN=MARK7;LN<STOP7;LN=LN+STEP7)#    Loop over each group (n)         BN51  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN51  63
N8=NN; NT=NINT(QX(LN+4)); NN=NINT(QX(LN+6))# Point to list8             BN51  64
CRADN=QX(LN+5)+BTOC+BTOC#              Find contact radius of group     BN51  65
X=QX(LN+1);  Y=QX(LN+2); Z=QX(LN+3)#   Store centroid coords            BN51  66
#                                                                       BN51  67
FOR(LS=MARK3;LS<STOP3;LS=LS+STEP3)#    Loop over symops                 BN51  68
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN51  69
U=QX(LS+1)*X+QX(LS+4)*Y+QX(LS+7)*Z+QX(LS+10)# Get atom x'               BN51  70
V=QX(LS+2)*X+QX(LS+5)*Y+QX(LS+8)*Z+QX(LS+11)# Get atom y'               BN51  71
W=QX(LS+3)*X+QX(LS+6)*Y+QX(LS+9)*Z+QX(LS+12)# Get atom z'               BN51  72
XS=4.;  YS=4.;  ZS=4.#                 Set initial shifts               BN51  73
#                                                                       BN51  74
DO LT=1,125#                           Loop cell shifts (2 deep)        BN51  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN51  76
XS=AMOD(XS+1.,5.)#                     Incr x cell shift                BN51  77
IF(XS   <0.5) YS=AMOD(YS+1.,5.)#       Incr y cell shift                BN51  78
IF(XS+YS<0.5) ZS=AMOD(ZS+1.,5.)#       Incr z cell shift                BN51  79
XX=XS-2.;  YY=YS-2.;  ZZ=ZS-2.#        Set true shifts                  BN51  80
P=U+XX;   Q=V+YY;   R=W+ZZ#            Shift centroid coords            BN51  81
MM=N8#                                 Reset list 8 pointer             BN51  82
#                                                                       BN51  83
FOR(LM=LN;LM<STOP7;LM=LM+STEP7)#       Loop over each group (m)         BN51  84
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN51  85
M8=MM; MT=NINT(QX(LM+4)); MM=NINT(QX(LM+6))# Point to list8             BN51  86
DX=P-QX(LM+1); DY=Q-QX(LM+2); DZ=R-QX(LM+3)# Centroid coord diff        BN51  87
DIST=G1*DX*DX+G5*DY*DY+G9*DZ*DZ$#      Calc distance**2                 BN51  88
+    G2*DX*DY+G3*DX*DZ+G6*DY*DZ#       Calc distance**2                 BN51  89
CDIST=(QX(LM+5)+CRADN)**2#             Square of contact distanc        BN51  90
IF(DIST>CDIST) NEXT#                   Skip if outside range            BN51  91
#                                                                       BN51  92
#   SEARCH FOR CONTACTS BETWEEN CLOSE GROUPS                            BN51  93
#   ----------------------------------------                            BN51  94
#                                                                       BN51  95
FOR(JN=N8;JN<NT;JN=JN+STEP8)#          Loop over atoms list (n)         BN51  96
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN51  97
JJ=NINT(QX(JN+4))#                     Extract pointer atoms list       BN51  98
JR=NINT(QX(JJ-6))#                     Extract pointer radii list       BN51  99
CR=QX(JR+1); BR=QX(JR+2)#              Extract contact & bond rad       BN51 100
XN=QX(JN+1); YN=QX(JN+2); ZN=QX(JN+3)# Extract atom coords              BN51 101
SX=QX(JN+5); SY=QX(JN+6); SZ=QX(JN+7)# Store atom signa                 BN51 102
A=QX(LS+1)*XN+QX(LS+4)*YN+QX(LS+7)*ZN+QX(LS+10)+XX# Get atom x'         BN51 103
B=QX(LS+2)*XN+QX(LS+5)*YN+QX(LS+8)*ZN+QX(LS+11)+YY# Get atom y'         BN51 104
C=QX(LS+3)*XN+QX(LS+6)*YN+QX(LS+9)*ZN+QX(LS+12)+ZZ# Get atom z'         BN51 105
#                                                                       BN51 106
X1=QX(JJ-5); Y1=QX(JJ-4); Z1=QX(JJ-3); TT=0.# Extract input coords      BN51 107
FOR(KS=MARK3;KS<STOP3;KS=KS+STEP3)#    Begin loop over symops           BN51 108
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BN51 109
AA=QX(KS+1)*X1+QX(KS+4)*Y1+QX(KS+7)*Z1+QX(KS+10)# Get x'                BN51 110
BB=QX(KS+2)*X1+QX(KS+5)*Y1+QX(KS+8)*Z1+QX(KS+11)# Get y'                BN51 111
CC=QX(KS+3)*X1+QX(KS+6)*Y1+QX(KS+9)*Z1+QX(KS+12)# Get z'                BN51 112
IF(ABS(AA-A)<.001&ABS(BB-B)<.001&ABS(CC-C)<.001) GOTO50# Exit if        BN51 113
IF(ABS(MOD(99.5+AA-A,1.)-0.5)>.001) NEXT# Get closest to origin         BN51 114
IF(ABS(MOD(99.5+BB-B,1.)-0.5)>.001) NEXT# Get closest to origin         BN51 115
IF(ABS(MOD(99.5+CC-C,1.)-0.5)<.001) BREAK# Get closest to origin        BN51 116
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BN51 117
TT=555.+(A-AA)*100.+(B-BB)*10.+(C-CC)# Store lattice translations       BN51 118
50 SS=FLOAT((KS-MARK3)/STEP3+1)#       Store symop number               BN51 119
IF(KS==MARK3) SS=0.#                   Cancel identity symop            BN51 120
#                                                                       BN51 121
FOR(JM=M8;JM<MT;JM=JM+STEP8)#          Loop over atoms list             BN51 122
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BN51 123
II=NINT(QX(JM+4))#                     Extract pointer atoms list       BN51 124
IR=NINT(QX(II-6))#                     Extract pointer radii list       BN51 125
CONDIS=CR+QX(IR+1)#                    Calc contact limit               BN51 126
BONDIS=BR+QX(IR+2)#                    Calc bond limit                  BN51 127
DX=A-QX(JM+1); DY=B-QX(JM+2); DZ=C-QX(JM+3)# Get coord difference       BN51 128
DIST=SQRT(G1*DX*DX+G5*DY*DY+G9*DZ*DZ$# Calc distance                    BN51 129
+         G2*DX*DY+G3*DX*DZ+G6*DY*DZ)# Calc distance                    BN51 130
IF((DIST>CONDIS)\(DIST<=BONDIS)) NEXT# Skip if outside range            BN51 131
#                                                                       BN51 132
FOR(I9=MARK9;I9<STOP9;I9=I9+STEP9)#    Loop over contact list           BN51 133
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BN51 134
IF(NINT(QX(I9+4))!=JM) NEXT#           Skip if diff target atom         BN51 135
IF(NINT(QX(I9+5))!=JN) NEXT#           Skip if diff target atom         BN51 136
IF(ABS(A-QX(I9+1))>0.001) NEXT#        Skip if diff coordinate          BN51 137
IF(ABS(B-QX(I9+2))>0.001) NEXT#        Skip if diff coordinate          BN51 138
IF(ABS(C-QX(I9+3))>0.001) NEXT#        Skip if diff coordinate          BN51 139
GOTO 100#                              Skip as redundant atom site      BN51 140
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BN51 141
incrqx:(STOP9,I9+STEP9,BN5101)#        No mem............bn5101         BN51 142
QX(I9+1)=A#                            Store transformed coord          BN51 143
QX(I9+2)=B#                            Store transformed coord          BN51 144
QX(I9+3)=C#                            Store transformed coord          BN51 145
QX(I9+5)=ABS(QX(LS+1)*SX)+ABS(QX(LS+4)*SY)+ABS(QX(LS+7)*SZ)# Sig x      BN51 146
QX(I9+6)=ABS(QX(LS+2)*SX)+ABS(QX(LS+5)*SY)+ABS(QX(LS+8)*SZ)# Sig y      BN51 147
QX(I9+7)=ABS(QX(LS+3)*SX)+ABS(QX(LS+6)*SY)+ABS(QX(LS+9)*SZ)# Sig z      BN51 148
CALL BN03(JM,I9,DIST,SIGMA)#           Calc standard deviations         BN51 149
QX(I9+4)=FLOAT(JM)#                    Store atom list8 pointer         BN51 150
QX(I9+5)=FLOAT(JN)#                    Store atom list8 pointer         BN51 151
QX(I9+6)=DIST#                         Store contact distance           BN51 152
QX(I9+7)=SIGMA#                        Store contact std dev            BN51 153
QX(I9+8)=SS#                           Store symop number               BN51 154
QX(I9+9)=TT#                           Store translation shift          BN51 155
QX(I9+10)=FLOAT((II-MARK6)/STEP6)$#    Store sort word                  BN51 156
         +FLOAT((JJ-MARK6)/STEP6)/SCALE# Store sort word                BN51 157
#                                                                       BN51 158
IF(SS<0.5) NEXT#                       Skip if identity symop           BN51 159
ISYM(1)=yes:;  ISYM(NINT(SS))=yes:#    Store which symop used           BN51 160
100 CONTINUE#                          Loop break point                 BN51 161
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BN51 162
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN51 163
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN51 164
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN51 165
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN51 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN51 167
#                                                                       BN51 168
#   CHECK ON WHICH SYMOP USED                                           BN51 169
#   -------------------------                                           BN51 170
#                                                                       BN51 171
IF(ISYM(1)==yes:)#                     Are symops applied               BN51 172
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BN51 173
LINRM=6#                               Flag header output               BN51 174
writeline:(1,B163,NB163,3,3)#          Print general header             BN51 175
DO II=2,200#                           Loop over symmetry numbers       BN51 176
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BN51 177
IF(ISYM(II)==no:) NEXT#                Skip if symmetry not used        BN51 178
LS=MARK3+(II-1)*STEP3#                 Point to symop list              BN51 179
ncodefld:(FLOAT(II),1,B162,110313.,1)# Format symop number              BN51 180
movechar:(B162,1,CHROT,1,11,0)#        Insert symop header              BN51 181
DO L=1,3#                              Loop over symop matrix           BN51 182
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BN51 183
I=LS+L;    K=L*10+7#                   Point to row pointer             BN51 184
J=NINT(QX(I+9)*12.)*3#                 Get transln element              BN51 185
IF(J>0) CHROT(K^K+2)=FRAC(J+1^J+3)#    Store transl fraction            BN51 186
M=NINT(QX(I+9)*12.)#                   Get symop translation            BN51 187
J=MOD(M+3600,12)#                      Get transln element              BN51 188
CODE=FLOAT(K+2)*10000.+213.#           Write denominator                BN51 189
VAL=FLOAT(M/12)#                       Default value                    BN51 190
IF(J>0)#                               Non-integral                     BN51 191
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BN51 192
ncodefld:(FLOAT(DENOM(J)),1,CHROT,CODE,1)# Integral                     BN51 193
CHROT(K+1^K+1)='/'#                    Write division                   BN51 194
VAL=FLOAT(M*DENOM(J)/12)#              Add fractional num of denoms     BN51 195
CODE=FLOAT(K)*10000.+513.#             Dont' overwrite fraction         BN51 196
ncodefld:(VAL,1,CHROT,CODE,1)#         Encode the total number          BN51 197
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BN51 198
ELSEIF(M!=0) ncodefld:(VAL,1,CHROT,CODE,1)# Integral                    BN51 199
K=K+3#                                 Incr op pointer                  BN51 200
DO M=1,3#                              Loop along row elements          BN51 201
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BN51 202
J=NINT(QX(I+M*3-3))#                   Point to next element            BN51 203
IF(J==0) NEXT#                         Skip zero elements               BN51 204
CHROT(K^K+1)=XYZ(J*3+2+M*2^); K=K+2#   Extract xyz string               BN51 205
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BN51 206
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BN51 207
writeline:(0,0,0,1,3)#                 Print the symmetry position      BN51 208
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BN51 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BN51 210
#                                                                       BN51 211
#   CAN CONTACT DISTANCES BE SORTED                                     BN51 212
#   -------------------------------                                     BN51 213
#                                                                       BN51 214
IF(STOP9==MARK9) writeline:(1,B165,NB165,3,3)# Tell user none found     BN51 215
ELSE#                                  Else list contacts found         BN51 216
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BN51 217
ISOR=no:#                              Reset no sort flag               BN51 218
NCON=(STOP9-MARK9)/STEP9#              Get number of contacts           BN51 219
MARK10=STOP9;   STOP10=MARK10+NCON#    Get length of sort list          BN51 220
IF(STOP10<=QXMAX )#                    If memory available              BN51 221
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BN51 222
qxmemory:(STOP10); ISOR=yes:#          Yes distances sorted             BN51 223
DO I=1,NCON#                           Loop over sort list              BN51 224
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BN51 225
J=MARK9+(I-1)*STEP9#                   Store contact list addr          BN51 226
IF(SORT==yes:) QX(MARK10+I)=FLOAT(J+6)# Store contact dist addr         BN51 227
ELSE           QX(MARK10+I)=FLOAT(J+10)# Store contact addr addr        BN51 228
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BN51 229
#                                                                       BN51 230
#   'SHELL' SORT CONTACT DISTANCES                                      BN51 231
#   ------------------------------                                      BN51 232
#                                                                       BN51 233
FOR(I=NCON/2;I!=0;I=I/2)#              Loop over diminishing blocks     BN51 234
FOR(J=MARK10+I+1;J<=STOP10;J=J+1)#     Loop over elements               BN51 235
FOR(K=J-I;K>MARK10;K=K-I)#             Back loop over blocks            BN51 236
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BN51 237
L=K+I#                                 Point to sort element            BN51 238
M=NINT(QX(K));   N=NINT(QX(L))#        Point to contact distances       BN51 239
IF(QX(M)<QX(N)) BREAK#                 Exit inner loop                  BN51 240
A=QX(K); QX(K)=QX(L); QX(L)=A#         Swap sort addresses              BN51 241
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BN51 242
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BN51 243
ELSE writeline:(1,B166,NB166,3,3)#     Tell user dist not sorted        BN51 244
#                                                                       BN51 245
#    LIST CONTACT DISTANCES                                             BN51 246
#    ----------------------                                             BN51 247
#                                                                       BN51 248
writeline:(0,0,0,1,3);   LINRM=5#      Force first header               BN51 249
FOR(I=MARK10;I<STOP10;I=I+1)#          Loop over sort list              BN51 250
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BN51 251
IF(ISOR==no:) N=MARK9+(I-MARK10)*STEP9# Point for no sort               BN51 252
ELSE IF(SORT==yes:) N=NINT(QX(I+1))-6# Point to sorted list             BN51 253
ELSE                N=NINT(QX(I+1))-10# Point to sorted list            BN51 254
J=NINT(QX(N+4));  K=NINT(QX(N+5))#     Point to atoms list8             BN51 255
L=NINT(QX(J+4));  K=NINT(QX(K+4))#     Point to atoms list6             BN51 256
movertoc:(QX(L+18),1,CHROT,2,LABMAX,0)# Extract atom1 name              BN51 257
movertoc:(QX(K+18),1,CHROT,LABMAX+3,24,0)# Extract atom2 name           BN51 258
LCHROT=NHEAD#                          Start of dist format             BN51 259
ncodefld:(QX,N+6,CHROT,FMTD,2)#        Format dist and sigma            BN51 260
ncodefld:(QX,J+8,CHROT,FMTS,2)#        Format atom1 symop numbers       BN51 261
IF(QX(J+8)+QX(J+9)>.5)#                If not input coords              BN51 262
ncodefld:(QX,J+1,CHROT,FMTX,3)#        Format atom1 coords              BN51 263
LCHROT=NHEAD+44#                       Start of dist format             BN51 264
ncodefld:(QX,N+8,CHROT,FMTS,2)#        Format atom2 symop numbers       BN51 265
IF(QX(N+8)+QX(N+9)>.5)#                If not input coords              BN51 266
ncodefld:(QX,N+1,CHROT,FMTX,3)#        Format atom2 x,y,z               BN51 267
writeline:(0,HEADOT,120,1,3)#          Print contact distance           BN51 268
INM(1)=L+18; INM(2)=K+18#              Set name pointers                BN51 269
IXY(1)=J+ 1; IXY(2)=N+ 1#              Set xyz  pointers                BN51 270
IF(L<=K)CALL BN09(2,QX(N+6),QX(N+7))#  Punch contact distance           BN51 271
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BN51 272
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BN51 273
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN51 274
#                                                                       BN51 275
RETURN#                                                                 BN51 276
END#                                                                    BN51 277
systemheader:(BN55)#                   Process *bond* lines             BN55   1
# ################################################################## #  BN55   2
#                                                                    #  BN55   3
#                               BN55                                 #  BN55   4
#                                                                    #  BN55   5
# ################################################################## #  BN55   6
SUBROUTINE BN55#                       S.r.hall 1983                    BN55   7
include:(AACOMN)#                      W.dreissig 1986                  BN55   8
include:(BNCOMN)#                                                       BN55   9
#                                                                       BN55  10
INTEGER J1,J2#                                                          BN55  11
INTEGER NHEAD#                                                          BN55  12
REAL DX,DY,DZ#                                                          BN55  13
REAL DIST,SIGMA#                                                        BN55  14
chardata:(B190, ATRAD BOND ANGLE DIHED NVIRON END )#                    BN55  15
chardata:(B191," Distances requested with BOND lines-")#                BN55  16
chardata:(B192," dist   sigma  sym trn   sym trn")#                     BN55  17
realdata:(FMTS,[503.,503.])#                                            BN55  18
intdata:(FIRST,yes:)#                                                   BN55  19
datastuff:#                                                             BN55  20
#                                                                       BN55  21
#    LOOP OVER ALL -BOND- LINES                                         BN55  22
#    --------------------------                                         BN55  23
#                                                                       BN55  24
NHEAD=(LABMAX+2)*2#                    Chars for atom names             BN55  25
HEADOT=' '; HEADOT(NHEAD+2^)=B192#     Store the bond header            BN55  26
WHILE(LINID==2)#                       Test next line is -bond-         BN55  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN55  28
CALL BN07(2,J1)#                       Process atom data on line        BN55  29
J2=J1+STEPR#                           Get atom addresses               BN55  30
#                                                                       BN55  31
#    CALCULATE REQUESTED DISTANCE                                       BN55  32
#    ----------------------------                                       BN55  33
#                                                                       BN55  34
DX=QX(J1+1)-QX(J2+1)#                  Get x difference                 BN55  35
DY=QX(J1+2)-QX(J2+2)#                  Get y difference                 BN55  36
DZ=QX(J1+3)-QX(J2+3)#                  Get z difference                 BN55  37
DIST=SQRT(G1*DX*DX+G5*DY*DY+G9*DZ*DZ$# Calculate distance               BN55  38
+         G2*DX*DY+G3*DX*DZ+G6*DY*DZ)# Calculate distance               BN55  39
CALL BN03(J1,J2,DIST,SIGMA)#           Calculate dist sigma             BN55  40
#                                                                       BN55  41
IF(FIRST==yes:)#                       Test if first bond op            BN55  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN55  43
LINRM=10#                              Ensure sufficient room           BN55  44
movechar:(B191,NB191,CHROT,2,NB191-2,1)# Insert underline               BN55  45
ifnm:(BUFIN(7)) HEADOT(NHEAD+NB192+4^)='   diff'#                       BN55  46
writeline:(1,B191,NB191-1,2,3)#        Print header                     BN55  47
writeline:(0,0,0,1,3)#                 Insert space                     BN55  48
FIRST =no:;   LINRM=6#                 Force top header                 BN55  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN55  50
movertoc:(QX(J1+10),1,CHROT, 2,24,0)#  Insert atom name 1               BN55  51
movertoc:(QX(J2+10),1,CHROT,LABMAX+3,24,0)# Insert atom name 2          BN55  52
LCHROT=NHEAD#                          Start format pointer             BN55  53
ncodefld:(DIST ,1,CHROT,742.,1)#       Format distance                  BN55  54
ncodefld:(SIGMA,1,CHROT,642.,1)#       Format sigma                     BN55  55
ncodefld:(QX,J1+8,CHROT,FMTS,2)#       Format symops                    BN55  56
ncodefld:(QX,J2+8,CHROT,FMTS,2)#       Format symops                    BN55  57
ifnm:(BUFIN(7))ncodefld:(DIST-BUFIN(7),1,CHROT,942.,1)# Format diff     BN55  58
writeline:(0,HEADOT,120,1,3)#          Print bond distance              BN55  59
INM(1)=J1+10; INM(2)=J2+10#            Store atom name pointers         BN55  60
IXY(1)=J1+ 1; IXY(2)=J2+ 1#            Store atom name pointers         BN55  61
CALL BN09(1,DIST,SIGMA)#               Punch requested bond distance    BN55  62
#                                                                       BN55  63
readline:(B190,NB190)#                 Read next ip line                BN55  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN55  65
RETURN#                                                                 BN55  66
END#                                                                    BN55  67
systemheader:(BN61)#                   Process *angle* lines            BN61   1
# ################################################################## #  BN61   2
#                                                                    #  BN61   3
#                               BN61                                 #  BN61   4
#                                                                    #  BN61   5
# ################################################################## #  BN61   6
SUBROUTINE BN61#                       S.r.hall 1983                    BN61   7
include:(AACOMN)#                      W.dreissig 1986                  BN61   8
include:(BNCOMN)#                                                       BN61   9
#                                                                       BN61  10
INTEGER NHEAD#                                                          BN61  11
INTEGER J1,J2,J3#                                                       BN61  12
REAL ANGLE,SIGMA#                                                       BN61  13
chardata:(B190, ATRAD BOND ANGLE DIHED NVIRON END )#                    BN61  14
chardata:(B191," Angles requested with ANGLE lines-")#                  BN61  15
chardata:(B192," angle  sigma  sym trn   sym trn   sym trn")#           BN61  16
realdata:(FMTS,[503.,503.])#                                            BN61  17
intdata:(FIRST,yes:)#                                                   BN61  18
datastuff:#                                                             BN61  19
#                                                                       BN61  20
#    LOOP OVER ALL -ANGLE- LINES                                        BN61  21
#    --------------------------                                         BN61  22
#                                                                       BN61  23
NHEAD=(LABMAX+2)*3#                    Chars for atom names             BN61  24
HEADOT=' '; HEADOT(NHEAD+2^)=B192#     Store the bond header            BN61  25
WHILE(LINID==3)#                       Test next line is -angle-        BN61  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN61  27
CALL BN07(3,J1)#                       Process atom data on line        BN61  28
J2=J1+STEPR; J3=J2+STEPR#              Store atom list addressses       BN61  29
#                                                                       BN61  30
#    CALCULATE REQUESTED ANGLE                                          BN61  31
#    -------------------------                                          BN61  32
#                                                                       BN61  33
CALL BN04(J1,J2,J3,ANGLE,SIGMA)#       Get angle and sigma              BN61  34
IF(FIRST==yes:)#                       Test if first bond op            BN61  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN61  36
LINRM=10#                              Ensure sufficient room           BN61  37
movechar:(B191,NB191,CHROT,2,NB191-2,1)# Insert underline               BN61  38
ifnm:(BUFIN(7)) HEADOT(NHEAD+NB192+4^)='   diff'#                       BN61  39
writeline:(1,B191,NB191-1,2,3)#        Print header                     BN61  40
writeline:(0,0,0,1,3)#                 Insert space                     BN61  41
FIRST =no:;   LINRM=6#                 Force top header                 BN61  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN61  43
movertoc:(QX(J1+10),1,CHROT, 2,24,0)#  Insert atom name 1               BN61  44
movertoc:(QX(J2+10),1,CHROT,LABMAX+3,24,0)# Insert atom name 2          BN61  45
movertoc:(QX(J3+10),1,CHROT,LABMAX*2+4,24,0)# Insert atom name 3        BN61  46
LCHROT=NHEAD#                          Start format pointer             BN61  47
ncodefld:(ANGLE,1,CHROT,722.,1)#       Format angle                     BN61  48
ncodefld:(SIGMA,1,CHROT,622.,1)#       Format sigma                     BN61  49
ncodefld:(QX,J1+8,CHROT,FMTS,2)#       Format symops                    BN61  50
ncodefld:(QX,J2+8,CHROT,FMTS,2)#       Format symops                    BN61  51
ncodefld:(QX,J3+8,CHROT,FMTS,2)#       Format symops                    BN61  52
ifnm:(BUFIN(10))ncodefld:(ANGLE-BUFIN(10),1,CHROT,942.,1)# Format dif   BN61  53
writeline:(0,HEADOT,120,1,3)#          Print bond distance              BN61  54
INM(1)=J1+10; INM(2)=J2+10; INM(3)=J3+10# Store atom name pointers      BN61  55
IXY(1)=J1+ 1; IXY(2)=J2+ 1; IXY(3)=J3+ 1# Store atom xyz  pointers      BN61  56
CALL BN09(3,ANGLE,SIGMA)#              Punch requested bond angle       BN61  57
#                                                                       BN61  58
readline:(B190,NB190)#                 Read next ip line                BN61  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN61  60
RETURN#                                                                 BN61  61
END#                                                                    BN61  62
systemheader:(BN65)#                   Process *dihed* lines            BN65   1
# ################################################################## #  BN65   2
#                                                                    #  BN65   3
#                               BN65                                 #  BN65   4
#                                                                    #  BN65   5
# ################################################################## #  BN65   6
SUBROUTINE BN65#                       S.r.hall 1983                    BN65   7
include:(AACOMN)#                      W.dreissig 1986                  BN65   8
include:(BNCOMN)#                                                       BN65   9
#                                                                       BN65  10
INTEGER NHEAD#                                                          BN65  11
INTEGER J1,J2,J3,J4#                                                    BN65  12
REAL ANGLE,SIGMA#                                                       BN65  13
chardata:(B190, ATRAD BOND ANGLE DIHED NVIRON END )#                    BN65  14
chardata:(B191," Angles requested with DIHED lines-")#                  BN65  15
chardata:(B192," angle  sigma  sym trn   sym trn   $#                   BN65  16
sym trn   sym trn")#                                                    BN65  17
realdata:(FMTS,[503.,503.])#                                            BN65  18
intdata:(FIRST,yes:)#                                                   BN65  19
datastuff:#                                                             BN65  20
#                                                                       BN65  21
#    LOOP OVER ALL -DIHED- LINES                                        BN65  22
#    --------------------------                                         BN65  23
#                                                                       BN65  24
NHEAD=(LABMAX+2)*4#                    Chars for atom names             BN65  25
HEADOT=' '; HEADOT(NHEAD+2^)=B192#     Store the bond header            BN65  26
WHILE(LINID==4)#                       Test next line is -dihed-        BN65  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN65  28
CALL BN07(4,J1)#                       Process atom data on line        BN65  29
J2=J1+STEPR; J3=J2+STEPR; J4=J3+STEPR# Store atom addresses             BN65  30
#                                                                       BN65  31
#    CALCULATE REQUESTED ANGLE                                          BN65  32
#    -------------------------                                          BN65  33
#                                                                       BN65  34
CALL BN06(J1,J2,J3,J4,ANGLE,SIGMA)#    Get dihedral angle & sigma       BN65  35
IF(FIRST==yes:)#                       Test if first bond op            BN65  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN65  37
LINRM=10#                              Ensure sufficient room           BN65  38
movechar:(B191,NB191,CHROT,2,NB191-2,1)# Insert underline               BN65  39
ifnm:(BUFIN(7)) HEADOT(NHEAD+NB192+4^)='   diff'#                       BN65  40
writeline:(1,B191,NB191-1,2,3)#        Print header                     BN65  41
writeline:(0,0,0,1,3)#                 Insert space                     BN65  42
FIRST =no:;   LINRM=6#                 Force top header                 BN65  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN65  44
movertoc:(QX(J1+10),1,CHROT, 2,24,0)#  Insert atom name 1               BN65  45
movertoc:(QX(J2+10),1,CHROT,LABMAX+3,24,0)# Insert atom name 2          BN65  46
movertoc:(QX(J3+10),1,CHROT,LABMAX*2+4,24,0)# Insert atom name 3        BN65  47
movertoc:(QX(J4+10),1,CHROT,LABMAX*3+5,24,0)# Insert atom name 4        BN65  48
LCHROT=NHEAD#                          Start format pointer             BN65  49
ncodefld:(ANGLE,1,CHROT,722.,1)#       Format angle                     BN65  50
ncodefld:(SIGMA,1,CHROT,622.,1)#       Format sigma                     BN65  51
ncodefld:(QX,J1+8,CHROT,FMTS,2)#       Format symops                    BN65  52
ncodefld:(QX,J2+8,CHROT,FMTS,2)#       Format symops                    BN65  53
ncodefld:(QX,J3+8,CHROT,FMTS,2)#       Format symops                    BN65  54
ncodefld:(QX,J4+8,CHROT,FMTS,2)#       Format symops                    BN65  55
ifnm:(BUFIN(13))ncodefld:(ANGLE-BUFIN(13),1,CHROT,942.,1)# Format dif   BN65  56
writeline:(0,HEADOT,120,1,3)#          Print dihedral angle             BN65  57
INM(1)=J1+10; INM(2)=J2+10; INM(3)=J3+10; INM(4)=J4+10# Name point      BN65  58
IXY(1)=J1+ 1; IXY(2)=J2+ 1; IXY(3)=J3+ 1; IXY(4)=J4+ 1# Xyz  point      BN65  59
CALL BN09(4,ANGLE,SIGMA)#              Punch dihedral angle             BN65  60
#                                                                       BN65  61
readline:(B190,NB190)#                 Read next ip line                BN65  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN65  63
RETURN#                                                                 BN65  64
END#                                                                    BN65  65
systemheader:(BN71)#                   Calc *nviron* distances          BN71   1
# ################################################################## #  BN71   2
#                                                                    #  BN71   3
#                               BN71                                 #  BN71   4
#                                                                    #  BN71   5
# ################################################################## #  BN71   6
SUBROUTINE BN71#                       S.r.hall 1983                    BN71   7
include:(AACOMN)#                      W.dreissig 1986                  BN71   8
include:(BNCOMN)#                                                       BN71   9
#                                                                       BN71  10
INTEGER ISOR#                                                           BN71  11
INTEGER I,J,K,L,N,M#                                                    BN71  12
INTEGER II#                                                             BN71  13
INTEGER MARK10,STOP10#                                                  BN71  14
INTEGER ISYM(200)#                                                      BN71  15
INTEGER I9,J1,KS,LS,LT,NCON,NHEAD#                                      BN71  16
REAL A,B,C,AA,BB,CC,DX,DY,DZ,P,Q,R,SIGMA,SS,TT,U,V,W,X,Y,Z,X1,Y1,Z1#    BN71  17
REAL CDIST,DIST#                                                        BN71  18
REAL XX,YY,ZZ,XS,YS,ZS#                                                 BN71  19
REAL CODE,VAL#                                                          BN71  20
#                                                                       BN71  21
chardata:(B160, ATRAD BOND ANGLE DIHED NVIRON END )#                    BN71  22
chardata:(B161," Distances requested from NVIRON lines-")#              BN71  23
chardata:(B162,"   Symop      ")#                                       BN71  24
chardata:(B163," Symmetry operations applied are...")#                  BN71  25
chardata:(B165," *** No distances found for set radius ***")#           BN71  26
chardata:(B166," Insufficient memory to sort distances")#               BN71  27
chardata:(B167," dist   sigma  sym trn   x/a    y/b    z/c")#           BN71  28
chardata:(FRAC,      1/61/41/3   1/2   2/33/45/6      )#                BN71  29
intdata:(DENOM,[12,6,4,3,12,2,12,3,4,6,12, 1])#                         BN71  30
chardata:(XYZ,'-x-y-z+x+y+z')#                                          BN71  31
realdata:(FMTD,[742.,642.])#                                            BN71  32
realdata:(FMTX,[742.,742.,742.])#                                       BN71  33
realdata:(FMTS,[503.,503.])#                                            BN71  34
datastuff:#                                                             BN71  35
#                                                                       BN71  36
#    PRINT NVIRON HEADERS                                               BN71  37
#    --------------------                                               BN71  38
#                                                                       BN71  39
LINRM=10;    NHEAD=(LABMAX+2)*2#       Get heading all on one page      BN71  40
movechar:(B161,NB161,CHROT,2,NB161-2,2)# Insert contact header          BN71  41
writeline:(2,B161,NB161-1,2,3)#        Print contact header             BN71  42
HEADOT=' '; HEADOT(NHEAD+2^)=B167#     Store main header line           BN71  43
#                                                                       BN71  44
#   LOOP OVER NVIRON LINES                                              BN71  45
#   ----------------------                                              BN71  46
#                                                                       BN71  47
WHILE(LINID==5)#                       If *nviron* line entered         BN71  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN71  49
CALL BN07(1,J1)#                       Process atom data on line        BN71  50
IF(BUFIN(4)>0.) CDIST=BUFIN(4)#        Get input search radius          BN71  51
ELSE            CDIST=3.#              Default is 3 angstroms           BN71  52
CDIST=CDIST*CDIST#                     Get squared distance             BN71  53
P=QX(J1+1); Q=QX(J1+2); R=QX(J1+3)#    Get atom coords                  BN71  54
MARK9=STOPR; STEP9=9; I9=MARK9#        Start new coords list            BN71  55
STOP9=MARK9#                           Reset start of coords list       BN71  56
DO I=1,200; ISYM(I)=0#                 Zero symmetry number array       BN71  57
#                                                                       BN71  58
#  LOOP OVER ATOMS LIST                                                 BN71  59
#  --------------------                                                 BN71  60
#                                                                       BN71  61
FOR(LS=MARK3;LS<STOP3;LS=LS+STEP3)#    Loop over symops                 BN71  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN71  63
FOR(L=MARK6;L<STOP6;L=L+STEP6)#        Loop over atom list              BN71  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN71  65
X=QX(L+1);  Y=QX(L+2);  Z=QX(L+3)#     Get atom coords                  BN71  66
A=QX(L+5);  B=QX(L+6);  C=QX(L+7)#     Get atom sigmas                  BN71  67
#                                                                       BN71  68
U=QX(LS+1)*X+QX(LS+4)*Y+QX(LS+7)*Z+QX(LS+10)# Get atom x'               BN71  69
V=QX(LS+2)*X+QX(LS+5)*Y+QX(LS+8)*Z+QX(LS+11)# Get atom y'               BN71  70
W=QX(LS+3)*X+QX(LS+6)*Y+QX(LS+9)*Z+QX(LS+12)# Get atom z'               BN71  71
XS=4.;  YS=4.;  ZS=4.#                 Set initial shifts               BN71  72
#                                                                       BN71  73
DO LT=1,125#                           Loop cell shifts (2 deep)        BN71  74
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN71  75
XS=AMOD(XS+1.,5.)#                     Incr x cell shift                BN71  76
IF(XS   <0.5) YS=AMOD(YS+1.,5.)#       Incr y cell shift                BN71  77
IF(XS+YS<0.5) ZS=AMOD(ZS+1.,5.)#       Incr z cell shift                BN71  78
XX=U+XS-2.;  YY=V+YS-2.;  ZZ=W+ZS-2.#  Set true shifts                  BN71  79
DX=P-XX;     DY=Q-YY;     DZ=R-ZZ#     Centroid coord diff              BN71  80
DIST=G1*DX*DX+G5*DY*DY+G9*DZ*DZ$#      Calc distance**2                 BN71  81
+    G2*DX*DY+G3*DX*DZ+G6*DY*DZ#       Calc distance**2                 BN71  82
IF(DIST<.01\DIST>CDIST) NEXT#          Skip if outside range            BN71  83
DIST=SQRT(DIST)#                       Calculate distance               BN71  84
#                                                                       BN71  85
X1=QX(L-5); Y1=QX(L-4); Z1=QX(L-3); TT=0.# Extract input coords         BN71  86
FOR(KS=MARK3;KS<STOP3;KS=KS+STEP3)#    Begin loop over symops           BN71  87
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN71  88
AA=QX(KS+1)*X1+QX(KS+4)*Y1+QX(KS+7)*Z1+QX(KS+10)# Get x'                BN71  89
BB=QX(KS+2)*X1+QX(KS+5)*Y1+QX(KS+8)*Z1+QX(KS+11)# Get y'                BN71  90
CC=QX(KS+3)*X1+QX(KS+6)*Y1+QX(KS+9)*Z1+QX(KS+12)# Get z'                BN71  91
IF(ABS(AA-XX)<.001&ABS(BB-YY)<.001&ABS(CC-ZZ)<.001) GOTO50# Exit if     BN71  92
IF(ABS(MOD(99.5+AA-XX,1.)-0.5)>.001) NEXT# Get closest to origin        BN71  93
IF(ABS(MOD(99.5+BB-YY,1.)-0.5)>.001) NEXT# Get closest to origin        BN71  94
IF(ABS(MOD(99.5+CC-ZZ,1.)-0.5)<.001) BREAK# Get closest to origin       BN71  95
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN71  96
TT=555.+(XX-AA)*100.+(YY-BB)*10.+(ZZ-CC)# Store lattice translations    BN71  97
50 SS=FLOAT((KS-MARK3)/STEP3+1)#       Store symop number               BN71  98
IF(KS==MARK3) SS=0.#                   Cancel identity symop            BN71  99
#                                                                       BN71 100
incrqx:(STOP9,I9+STEP9,BN5101)#        No mem............bn5101         BN71 101
QX(I9+1)=XX#                           Store transformed coord          BN71 102
QX(I9+2)=YY#                           Store transformed coord          BN71 103
QX(I9+3)=ZZ#                           Store transformed coord          BN71 104
QX(I9+5)=ABS(QX(LS+1)*A)+ABS(QX(LS+4)*B)+ABS(QX(LS+7)*C)# Sig x         BN71 105
QX(I9+6)=ABS(QX(LS+2)*A)+ABS(QX(LS+5)*B)+ABS(QX(LS+8)*C)# Sig y         BN71 106
QX(I9+7)=ABS(QX(LS+3)*A)+ABS(QX(LS+6)*B)+ABS(QX(LS+9)*C)# Sig z         BN71 107
CALL BN03(J1,I9,DIST,SIGMA)#           Calc standard deviations         BN71 108
QX(I9+4)=FLOAT(J1)#                    Store atom list8 pointer         BN71 109
QX(I9+5)=FLOAT(L)#                     Store atom list8 pointer         BN71 110
QX(I9+6)=DIST#                         Store contact distance           BN71 111
QX(I9+7)=SIGMA#                        Store contact std dev            BN71 112
QX(I9+8)=SS#                           Store symop number               BN71 113
QX(I9+9)=TT#                           Store translation shift          BN71 114
I9=STOP9#                              Reset list pointer               BN71 115
#                                                                       BN71 116
IF(SS<0.5) NEXT#                       Skip if identity used            BN71 117
ISYM(1)=yes:;  ISYM(NINT(SS))=yes:#    Flag symop used                  BN71 118
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN71 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN71 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN71 121
#                                                                       BN71 122
#   CHECK ON WHICH SYMOP USED                                           BN71 123
#   -------------------------                                           BN71 124
#                                                                       BN71 125
IF(ISYM(1)==yes:)#                     Are symops applied               BN71 126
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN71 127
LINRM=6#                               Flag header output               BN71 128
writeline:(1,B163,NB163,3,3)#          Print general header             BN71 129
DO II=2,200#                           Loop over symmetry numbers       BN71 130
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BN71 131
IF(ISYM(II)==no:) NEXT#                Skip if not used                 BN71 132
LS=MARK3+(II-1)*STEP3#                 Point to symop list              BN71 133
ncodefld:(FLOAT(II),1,B162,110313.,1)# Format symop number              BN71 134
movechar:(B162,1,CHROT,1,11,0)#        Insert symop header              BN71 135
DO L=1,3#                              Loop over symop matrix           BN71 136
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BN71 137
I=LS+L;    K=L*10+7#                   Point to row pointer             BN71 138
#J=NINT(QX(I+9)*12.)*3#                GET TRANSLN ELEMENT              BN71 139
#IF(J>0) CHROT(K^K+2)=FRAC(J+1^J+3)#   STORE TRANSL FRACTION            BN71 140
M=NINT(QX(I+9)*12.)#                   Get symop translation            BN71 141
J=MOD(M+3600,12)#                      Get transln element              BN71 142
CODE=FLOAT(K+2)*10000.+213.#           Write denominator                BN71 143
VAL=FLOAT(M/12)#                       Default value                    BN71 144
IF(J>0)#                               Non-integral                     BN71 145
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BN71 146
ncodefld:(FLOAT(DENOM(J)),1,CHROT,CODE,1)# Integral                     BN71 147
CHROT(K+1^K+1)='/'#                    Write division                   BN71 148
VAL=FLOAT(M*DENOM(J)/12)#              Add fractional num of denoms     BN71 149
CODE=FLOAT(K)*10000.+513.#             Dont' overwrite fraction         BN71 150
ncodefld:(VAL,1,CHROT,CODE,1)#         Encode the total number          BN71 151
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BN71 152
ELSEIF(M!=0) ncodefld:(VAL,1,CHROT,CODE,1)# Integral                    BN71 153
K=K+3#                                 Incr op pointer                  BN71 154
DO M=1,3#                              Loop along row elements          BN71 155
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BN71 156
J=NINT(QX(I+M*3-3))#                   Point to next element            BN71 157
IF(J==0) NEXT#                         Skip zero elements               BN71 158
CHROT(K^K+1)=XYZ(J*3+2+M*2^); K=K+2#   Extract xyz string               BN71 159
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BN71 160
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BN71 161
writeline:(0,0,0,1,3)#                 Print the symmetry position      BN71 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BN71 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN71 164
#                                                                       BN71 165
#   CAN NVIRON DISTANCES BE SORTED                                      BN71 166
#   -------------------------------                                     BN71 167
#                                                                       BN71 168
IF(STOP9==MARK9) writeline:(1,B165,NB165,3,3)# Tell user none found     BN71 169
ELSE#                                  Else list contacts found         BN71 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BN71 171
ISOR=no:#                              Reset no sort flag               BN71 172
NCON=(STOP9-MARK9)/STEP9#              Get number of contacts           BN71 173
MARK10=STOP9;   STOP10=MARK10+NCON#    Get length of sort list          BN71 174
IF(SORT==yes:)#                        Is the sort requested            BN71 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BN71 176
IF(STOP10<=QXMAX )#                    If memory available              BN71 177
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BN71 178
qxmemory:(STOP10)#                     Request necessary memory         BN71 179
ISOR=yes:#                             Yes distances sorted             BN71 180
FOR(I=MARK10;I<STOP10;I=I+1)#          Loop over sort list              BN71 181
QX(I+1)=FLOAT(MARK9+(I-MARK10)*STEP9)+6# Store contact list addr        BN71 182
#                                                                       BN71 183
#   'SHELL' SORT DISTANCES                                              BN71 184
#   ----------------------                                              BN71 185
#                                                                       BN71 186
FOR(I=NCON/2;I!=0;I=I/2)#              Loop over diminishing blocks     BN71 187
FOR(J=MARK10+I+1;J<=STOP10;J=J+1)#     Loop over elements               BN71 188
FOR(K=J-I;K>MARK10;K=K-I)#             Back loop over blocks            BN71 189
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BN71 190
L=K+I#                                 Point to sort element            BN71 191
M=NINT(QX(K));   N=NINT(QX(L))#        Point to contact distances       BN71 192
IF(QX(M)<QX(N)) BREAK#                 Exit inner loop                  BN71 193
A=QX(K); QX(K)=QX(L); QX(L)=A#         Swap sort addresses              BN71 194
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BN71 195
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BN71 196
ELSE writeline:(1,B166,NB166,3,3)#     Tell user dist not sorted        BN71 197
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BN71 198
#                                                                       BN71 199
#    LIST NVIRON DISTANCES                                              BN71 200
#    ----------------------                                             BN71 201
#                                                                       BN71 202
LINRM=5#                               Force first header               BN71 203
movertoc:(QX(J1+10),1,CHROT,2,LABMAX,0)# Extract atom1 name             BN71 204
LCHROT=NHEAD+13#                       Start op formats                 BN71 205
ncodefld:(QX,J1+8,CHROT,FMTS,2)#       Format atom1 symop numbers       BN71 206
IF(QX(J1+8)+QX(J1+9)>.5)#              If not input coords              BN71 207
ncodefld:(QX,J1+1,CHROT,FMTX,3)#       Format atom1 coords              BN71 208
writeline:(1,HEADOT,120,1,3)#          Print nviron  distance           BN71 209
#                                                                       BN71 210
FOR(I=MARK10;I<STOP10;I=I+1)#          Loop over sort list              BN71 211
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BN71 212
IF(ISOR==no:) N=MARK9+(I-MARK10)*STEP9# Point for no sort               BN71 213
ELSE          N=NINT(QX(I+1))-6#       Point to sorted list             BN71 214
K=NINT(QX(N+5))#                       Point to atoms list8             BN71 215
movertoc:(QX(K+18),1,CHROT,LABMAX+3,24,0)# Extract atom2 name           BN71 216
LCHROT=NHEAD#                          Start of dist format             BN71 217
ncodefld:(QX,N+6,CHROT,FMTD,2)#        Format dist and sigma            BN71 218
ncodefld:(QX,N+8,CHROT,FMTS,2)#        Format atom2 symop numbers       BN71 219
IF(QX(N+8)+QX(N+9)>.5)#                If not input coords              BN71 220
ncodefld:(QX,N+1,CHROT,FMTX,3)#        Format atom2 x,y,z               BN71 221
writeline:(0,HEADOT,120,1,3)#          Print nviron  distance           BN71 222
INM(1)=J1+10; INM(2)=K+18#             Store atom name pointers         BN71 223
IXY(1)=J1+ 1; IXY(2)=K+ 1#             Store atom xyz  pointers         BN71 224
CALL BN09(2,QX(N+6),QX(N+7))#          Punch nviron distance            BN71 225
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BN71 226
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BN71 227
#                                                                       BN71 228
readline:(B160,NB160)#                 Read next input line             BN71 229
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN71 230
RETURN#                                                                 BN71 231
END#                                                                    BN71 232
systemheader:(BN75)#                   Generate dihedral angles         BN75   1
# ################################################################## #  BN75   2
#                                                                    #  BN75   3
#                               BN75                                 #  BN75   4
#                                                                    #  BN75   5
# ################################################################## #  BN75   6
SUBROUTINE BN75#                       S.r.hall 1983                    BN75   7
include:(AACOMN)#                      W.dreissig 1986                  BN75   8
include:(BNCOMN)#                                                       BN75   9
#                                                                       BN75  10
INTEGER I,J,K,M,N#                                                      BN75  11
INTEGER J1,J2,J3,J4#                                                    BN75  12
INTEGER MARK,STEP,STOP#                                                 BN75  13
INTEGER MARKA,STEPA,STOPA#                                              BN75  14
INTEGER I1,I2,I3,I4,IP,K2,NOW,NEW,NHEAD#                                BN75  15
REAL ANGLE,SIGMA#                                                       BN75  16
#                                                                       BN75  17
chardata:(B280," Table of Dihedral Angles-")#                           BN75  18
chardata:(B282,"   angle  sigma  sym trn   sym trn")#                   BN75  19
realdata:(FMTS,[503.,503.])#                                            BN75  20
datastuff:#                                                             BN75  21
#                                                                       BN75  22
#                                                                       BN75  23
IF(IDH==yes:)#                         Do it if requested               BN75  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN75  25
#                                                                       BN75  26
#    PRINT DIHEDRAL ANGLE HEADERS                                       BN75  27
#    ----------------------------                                       BN75  28
#                                                                       BN75  29
LINRM=10#                              Get heading all on one page      BN75  30
movechar:(B280,NB280,CHROT,2,NB280-2,2)# Insert contact header          BN75  31
writeline:(2,B280,NB280-1,2,3)#        Print contact header             BN75  32
LINRM=6;    NHEAD=(LABMAX+1)*4#        Force first subheading           BN75  33
HEADOT=' '; HEADOT(NHEAD+2^)=B282#     Store main header line           BN75  34
#                                                                       BN75  35
#   COMPRESS LIST5 TO ADDR + NAME                                       BN75  36
#   -----------------------------                                       BN75  37
#                                                                       BN75  38
MARKA=STOP9; STEPA=8; STOPA=MARKA#     Set start & step of list         BN75  39
FOR(J=MARK8;J<STOP8;J=J+STEP8)#        Loop over atoms list             BN75  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN75  41
incrqx:(K,STOPA+STEPA,BN7501)#         Get more memory                  BN75  42
QX(STOPA+1)=0.;    QX(STOPA+2)=0.#     Zero atom addresses              BN75  43
I=NINT(QX(J+4))#                       Point to atom list               BN75  44
movereal:(QX,I+18,QX,STOPA+3,6,1)#     Transfer atom name               BN75  45
STOPA=K#                               Incr new list pointer            BN75  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN75  47
QX(MARKA+1)=FLOAT(STOPA)#              Store start of bond list         BN75  48
NOW=MARKA;    STEP=18;   MARK=STOPA#   Set step for bond pairs          BN75  49
#                                                                       BN75  50
#    READ BONDED ATOMS FROM SCRATCH FILE                                BN75  51
#    -----------------------------------                                BN75  52
#                                                                       BN75  53
FOR(J=STOPA;J>0;J=STOP)#               Loop over bond pairs             BN75  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN75  55
readwpkt:(3,2,I,IP,0)#                 Point to next ip pkt             BN75  56
IF(IP<=0) BREAK#                       Exit if last packet              BN75  57
incrqx:(STOP,J+STEP,BN7501)#           No mem......bn7501               BN75  58
movereal:(QX,IP+1,QX,J+1,STEP,1)#      Store two bond atoms             BN75  59
M=NINT(QX(J+4))#                       Extract atom list5 addr          BN75  60
N=NINT(QX(J+13))#                      Extract atom list5 addr          BN75  61
M=MARKA+((M-MARK8)/STEP8)*STEPA#       Point to new lista               BN75  62
N=MARKA+((N-MARK8)/STEP8)*STEPA#       Point to new lista               BN75  63
QX(J+ 4)=FLOAT(M)#                     Store list a pointer             BN75  64
QX(J+13)=FLOAT(N)#                     Store list a pointer             BN75  65
IF(M==NOW) NEXT#                       Skip if atom1 unchanged          BN75  66
QX(M  +1)=FLOAT(J)#                    Store start of new atom          BN75  67
QX(NOW+2)=FLOAT(J)#                    Store end of new atom            BN75  68
NOW=M#                                 Reset current atom1 addr         BN75  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN75  70
readwpkt:(3,endrecord:,I,I,0)#         Rewind & close file c            BN75  71
QX(NOW+2)=FLOAT(STOP)#                 Store last end address           BN75  72
K2=MARK#                               Start of bond list               BN75  73
#                                                                       BN75  74
#    GENERATE DIHEDRAL ANGLES FROM BOND LIST                            BN75  75
#    ---------------------------------------                            BN75  76
#                                                                       BN75  77
FOR(I2=MARKA;I2<STOPA;I2=I2+STEPA)#    Loop over atoms list             BN75  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN75  79
J2=NINT(QX(I2+1)); K=NINT(QX(I2+2))#   Start/stop bond pointers         BN75  80
#                                                                       BN75  81
FOR(J3=J2+9;J3<K;J3=J3+STEP)#          Loop over atom2 bond block       BN75  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN75  83
I3=NINT(QX(J3+4))#                     Point to atom lista              BN75  84
IF(I3<I2) NEXT#                        Skip if redundant                BN75  85
M=NINT(QX(I3+1));  N=NINT(QX(I3+2))#   Start/stop of atom3 block        BN75  86
NEW=yes:#                              Store atom3 bond addr            BN75  87
#                                                                       BN75  88
FOR(J1=J2+9;J1<K;J1=J1+STEP)#          Loop over atom2 block            BN75  89
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN75  90
I1=NINT(QX(J1+4))#                     Point to atom lista              BN75  91
IF(I1==I3) NEXT#                       Ignore same atoms                BN75  92
#                                                                       BN75  93
FOR(J4=M+9;J4<N;J4=J4+STEP)#           Loop over atom 3 block           BN75  94
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BN75  95
I4=NINT(QX(J4+4))#                     Point to atom list a             BN75  96
IF(I2==I4) NEXT#                       Ignore same atoms                BN75  97
#                                                                       BN75  98
#    CALCULATE & PRINT DIHEDRAL ANGLES                                  BN75  99
#    ---------------------------------                                  BN75 100
#                                                                       BN75 101
CALL BN06(J1,J2,J3,J4,ANGLE,SIGMA)#    Calc angle and sigma             BN75 102
IF(NEW==yes:)#                         Test if new atom2-3 block        BN75 103
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BN75 104
movertoc:(QX(I2+3),1,CHROT,LABMAX+3,24,0)# Store atom name 2            BN75 105
movertoc:(QX(I3+3),1,CHROT,LABMAX*2+4,24,0)# Store atom name 3          BN75 106
LCHROT=NHEAD+15#                       Start format marker              BN75 107
ncodefld:(QX,J2+8,CHROT,FMTS,2)#       Format symop and translation     BN75 108
ncodefld:(QX,J3+8,CHROT,FMTS,2)#       Format symop and translation     BN75 109
writeline:(1,HEADOT,120,1,3)#          Print atom names 2 & 3           BN75 110
NEW=no:#                               Reset new 2-3 block flag         BN75 111
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BN75 112
movertoc:(QX(I1+3),1,CHROT,2,24,0)#    Store atom name 1                BN75 113
movertoc:(QX(I4+3),1,CHROT,LABMAX*3+5,24,0)# Store atom name 4          BN75 114
LCHROT=NHEAD+2#                        Start format marker              BN75 115
ncodefld:(ANGLE,1,CHROT,722.,1)#       Format angle                     BN75 116
ncodefld:(SIGMA,1,CHROT,622.,1)#       Format sigma                     BN75 117
ncodefld:(QX,J1+8,CHROT,FMTS,2)#       Format symop and translation     BN75 118
ncodefld:(QX,J4+8,CHROT,FMTS,2)#       Format symop and translation     BN75 119
writeline:(0,HEADOT,120,1,3)#          Print atoms 1,4 & ang/sig        BN75 120
INM(1)=I1+3; INM(2)=I2+3; INM(3)=I3+3; INM(4)=I4+3# Name pointer        BN75 121
IXY(1)=J1+1; IXY(2)=J2+1; IXY(3)=J3+1; IXY(4)=J4+1# Xyz  point          BN75 122
CALL BN09(4,ANGLE,SIGMA)#              Punch dihed angle                BN75 123
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BN75 124
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN75 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN75 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN75 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN75 128
#                                                                       BN75 129
RETURN#                                                                 BN75 130
END#                                                                    BN75 131
systemheader:(BN80)#                   Punch bonds and angles           BN80   1
# ################################################################## #  BN80   2
#                                                                    #  BN80   3
#                               BN80                                 #  BN80   4
#                                                                    #  BN80   5
# ################################################################## #  BN80   6
SUBROUTINE BN80#                       S.r.hall 1989                    BN80   7
include:(AACOMN)#                                                       BN80   8
include:(BNCOMN)#                                                       BN80   9
#                                                                       BN80  10
INTEGER IC,IP,II,I,I1,I2,I3,I4,J,J1,J2,J3,J4,JP,L,LPAK#                 BN80  11
CHARACTER NAME*30,BUF*80#                                               BN80  12
chardata:(HED1," Bond Distances     (Angstroms)")#                      BN80  13
chardata:(HED2," Contact Distances  (Angstroms)")#                      BN80  14
chardata:(HED3," Bond Angles        (degrees)")#                        BN80  15
chardata:(HED4," Dihedral Angles    (degrees)")#                        BN80  16
datastuff:#                                                             BN80  17
#                                                                       BN80  18
#     OUTPUT DATA TO PUNCH FILE                                         BN80  19
#     -------------------------                                         BN80  20
#                                                                       BN80  21
BUF=' '#                               Zero punch buffer                BN80  22
writepkt:(4,78,11,IP)#                 Store dummy packet               BN80  23
writepkt:(4,endrecord:,4,I)#           Finish off the scratch file      BN80  24
DO II=1,4#                             Loop dist,cont,ang,dihed         BN80  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN80  26
putline:; putline:#                    Insert two spacers               BN80  27
IF(II==1) BUF=HED1#                    Insert header                    BN80  28
IF(II==2) BUF=HED2#                    Insert header                    BN80  29
IF(II==3) BUF=HED3#                    Insert header                    BN80  30
IF(II==4) BUF=HED4#                    Insert header                    BN80  31
putline:; putline:#                    Header plus spacer               BN80  32
REPEAT#                                Loop over scratch packets        BN80  33
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN80  34
readwpkt:(4,77,PSIZ,IP,0)#             Point to next packet             BN80  35
IF(IP<=0) BREAK#                       Exit after last packet           BN80  36
IF(II!=NINT(QX(IP+1))) NEXT#           Skip inapproriate packets        BN80  37
#                                                                       BN80  38
IC=2#                                  Reset character pointer          BN80  39
CALL BN81(IP+4,NAME,I)#                Format atom name 1               BN80  40
BUF(IC^IC+I)=NAME(1^I);  IC=IC+I#      Insert atom name 1               BN80  41
CALL BN81(IP+5,NAME,I)#                Format atom name 2               BN80  42
IF(II<3)#                              For bond distances               BN80  43
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BN80  44
BUF(IC^IC+I)=NAME(1^I-1)#              Insert atom name 2               BN80  45
CALL BN82(QX(IP+2),QX(IP+3),NAME)#     Format value + sigma             BN80  46
BUF(LABMAX*2+8^)=NAME#                 Insert value + sigma             BN80  47
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BN80  48
ELSE IF(II<4)#                         For bond angles                  BN80  49
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BN80  50
BUF(IC^IC+I)=NAME(1^I);  IC=IC+I#      Insert atom name 2               BN80  51
CALL BN81(IP+6,NAME,I)#                Format atom name 3               BN80  52
BUF(IC^IC+I)=NAME(1^I-1)#              Insert atom name 3               BN80  53
CALL BN82(QX(IP+2),QX(IP+3),NAME)#     Format value + sigma             BN80  54
BUF(LABMAX*3+12^)=NAME#                Insert value + sigma             BN80  55
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BN80  56
ELSE#                                  For dihedral angles              BN80  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BN80  58
BUF(IC^IC+I)=NAME(1^I);  IC=IC+I#      Insert atom name 2               BN80  59
CALL BN81(IP+6,NAME,I)#                Format atom name 3               BN80  60
BUF(IC^IC+I)=NAME(1^I);  IC=IC+I#      Insert atom name 3               BN80  61
CALL BN81(IP+7,NAME,I)#                Format atom name 4               BN80  62
BUF(IC^IC+I)=NAME(1^I-1)#              Insert atom name 4               BN80  63
CALL BN82(QX(IP+2),QX(IP+3),NAME)#     Format value + sigma             BN80  64
BUF(LABMAX*4+16^)=NAME#                Insert value + sigma             BN80  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BN80  66
putline:#                              Output punch line                BN80  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN80  68
rewindbdf:(4)#                         Rewind the scratch file          BN80  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN80  70
#                                                                       BN80  71
#     STORE DATA IN BDF                                                 BN80  72
#     -----------------                                                 BN80  73
#                                                                       BN80  74
IF(BDF==yes:)#                         Is bdf to be op                  BN80  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BN80  76
rewindbdf:(1)#                         Rewind the input bdf             BN80  77
copyfile:(1,2,1,decr:(lrbond:))#       Copy bdf up to distances         BN80  78
DO II=1,4#                             Loop dist,cont,ang,dihed         BN80  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BN80  80
LPAK=MAX(II,2)*arith:(name:,+,5)+2#    Get packet size                  BN80  81
writepkt:(2,II+decr:(lrbond:),LPAK,IP)# Get op packet pointer           BN80  82
J=IP;      DO I=1,name:; QX(I+J)=11.#  Insert idn label atom 1          BN80  83
J=J+name:; DO I=1,5; QX(I+J)=FLOAT(I+11)# Insert idn coords atom 1      BN80  84
J=J+5;     DO I=1,name:; QX(I+J)=21.#  Insert idn label atom 2          BN80  85
J=J+name:; DO I=1,5; QX(I+J)=FLOAT(I+21)# Insert idn coords atom 2      BN80  86
IF(II>2)#                              If an angle                      BN80  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BN80  88
J=J+5;     DO I=1,name:; QX(I+J)=31.#  Insert idn label atom 3          BN80  89
J=J+name:; DO I=1,5; QX(I+J)=FLOAT(I+31)# Insert idn coords atom 3      BN80  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BN80  91
IF(II>3)#                              If a torsion angle               BN80  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BN80  93
J=J+5;     DO I=1,name:; QX(I+J)=41.#  Insert idn label atom 4          BN80  94
J=J+name:; DO I=1,5; QX(I+J)=FLOAT(I+41)# Insert idn coords atom 4      BN80  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BN80  96
J=J+5;     DO I=1,2; QX(I+J)=FLOAT(I+90)# Insert idn value sigma        BN80  97
#                                                                       BN80  98
REPEAT#                                Loop over scratch packets        BN80  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BN80 100
readwpkt:(4,77,PSIZ,IP,0)#             Point to next packet             BN80 101
IF(IP<=0) BREAK#                       Exit after last packet           BN80 102
IF(II!=NINT(QX(IP+1))) NEXT#           Skip inapproriate packets        BN80 103
#                                                                       BN80 104
I1=NINT(QX(IP+4));  I2=NINT(QX(IP+5))# Get atom name pointers           BN80 105
I3=NINT(QX(IP+6));  I4=NINT(QX(IP+7))# Get atom name pointers           BN80 106
J1=NINT(QX(IP+8));  J2=NINT(QX(IP+9))# Get atom xyz  pointers           BN80 107
J3=NINT(QX(IP+10)); J4=NINT(QX(IP+11))# Get atom xyz  pointers          BN80 108
#                                                                       BN80 109
writepkt:(2,II+decr:(lrbond:),LPAK,JP)# Get op packet pointer           BN80 110
L=JP+1;    movereal:(QX,I1  ,QX,L,name:,0)# Insert label atom 1         BN80 111
L=L+name:; movereal:(QX,J1  ,QX,L,3,0)# Insert coords atom 1            BN80 112
L=L+3;     movereal:(QX,J1+7,QX,L,2,0)# Insert symop and translation    BN80 113
L=L+2;     movereal:(QX,I2  ,QX,L,name:,0)# Insert label atom 2         BN80 114
L=L+name:; movereal:(QX,J2  ,QX,L,3,0)# Insert coords atom 2            BN80 115
L=L+3;     movereal:(QX,J2+7,QX,L,2,0)# Insert symop and translation    BN80 116
IF(II>2)#                              If an angle                      BN80 117
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BN80 118
L=L+2;     movereal:(QX,I3  ,QX,L,name:,0)# Insert label atom 3         BN80 119
L=L+name:; movereal:(QX,J3  ,QX,L,3,0)# Insert coords atom 3            BN80 120
L=L+3;     movereal:(QX,J3+7,QX,L,2,0)# Insert symop and translation    BN80 121
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BN80 122
IF(II>3)#                              If a torsion angle               BN80 123
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BN80 124
L=L+2;     movereal:(QX,I4  ,QX,L,name:,0)# Insert label atom 4         BN80 125
L=L+name:; movereal:(QX,J4  ,QX,L,3,0)# Insert coords atom 4            BN80 126
L=L+3;     movereal:(QX,J4+7,QX,L,2,0)# Insert symop and translation    BN80 127
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BN80 128
QX(L+2)=QX(IP+2);  QX(L+3)=QX(IP+3)#   Insert value and esd             BN80 129
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BN80 130
rewindbdf:(4)#                         Rewind the scratch file          BN80 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BN80 132
copyfile:(1,2,incr:(lrdihe:),endrecord:)# Finish of files a and b       BN80 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BN80 134
readwpkt:(4,endrecord:,I,I,0)#         Finish off the scratch file      BN80 135
#                                                                       BN80 136
RETURN#                                                                 BN80 137
END#                                                                    BN80 138
systemheader:(BN81)#                   Store label with/out brackets    BN81   1
# ################################################################## #  BN81   2
#                                                                    #  BN81   3
#                               BN81                                 #  BN81   4
#                                                                    #  BN81   5
# ################################################################## #  BN81   6
SUBROUTINE BN81(IP,NAME,IC)#           S.r.hall 1989                    BN81   7
include:(AACOMN)#                                                       BN81   8
include:(BNCOMN)#                                                       BN81   9
#                                                                       BN81  10
INTEGER IC,IP,JP,I,J#                                                   BN81  11
CHARACTER TEMP*24,NAME*30#                                              BN81  12
#                                                                       BN81  13
JP=NINT(QX(IP))#                       Extract atom name pointer        BN81  14
movertoc:(QX(JP),1,TEMP,1,24,0)#       Store atom name                  BN81  15
label:(TEMP,I,J);   IC=I+1#            Get length of name & at symbol   BN81  16
IF(BRAC==yes:&I!=J)#                   Are brackets requested           BN81  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN81  18
NAME=TEMP(1^J)//'('//TEMP(J+1^I)//')-'# Transfer atom type symbol       BN81  19
IC=I+3;#                               Insert number bracket            BN81  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN81  21
ELSE NAME=TEMP(1^I)//'-'#              Store atom name                  BN81  22
RETURN#                                                                 BN81  23
END#                                                                    BN81  24
systemheader:(BN82)#                   Format value and sigma           BN82   1
####################################################################    BN82   2
#                                                                       BN82   3
#                        BN82                                           BN82   4
#                                                                       BN82   5
####################################################################    BN82   6
SUBROUTINE BN82(VAL,SIG,NAME)#                                          BN82   7
include:(AACOMN)#                                                       BN82   8
include:(BNCOMN)#                                                       BN82   9
#                                                                       BN82  10
REAL VAL,SIG,S,FMT#                                                     BN82  11
INTEGER J#                                                              BN82  12
CHARACTER NAME*12#                                                      BN82  13
#                                                                       BN82  14
NAME=' '#                              Blank out the name               BN82  15
IF(SIG>.000001)#                       If sigma significant             BN82  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BN82  17
J=MAX(0,MIN(4,INT(-LOG10(SIG))+1))#    Get precision of sigma           BN82  18
S=SIG*FLOAT(10**J)#                    Get most significant digit       BN82  19
IF(J>0&S>9.49999)#                     Test if rounded up to 10         BN82  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BN82  21
S=MAX(1.,S*0.1);    J=J-1#             Reduce precision by one          BN82  22
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BN82  23
IF(J==0) J=-1#                         Remove decimal point             BN82  24
NAME(J+6^J+8)='( )'#                   Insert parentheses               BN82  25
ncodefld:(S,1,NAME,FLOAT((J+7)*10000+113),1)# Insert sigma digit        BN82  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BN82  27
ELSE J=4#                              Default precision is 5           BN82  28
IF(J>0)FMT=FLOAT((J+5)*10100+J*10+2)#  Set real format                  BN82  29
ELSE   FMT=40413.#                     Set integer format               BN82  30
ncodefld:(VAL,1,NAME,FMT,1)#           Format parameter                 BN82  31
#                                                                       BN82  32
RETURN#                                                                 BN82  33
END#                                                                    BN82  34
pmacro:([no:])#                                                         BN82  35
