systemheader:(CL    )#                                                  CL     1
######################################################################  CL     2
##      Copyright (C) 2000, The Xtal System, The University of        # CL     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # CL     4
## Distributed under the GNU General Public Licence as published by   # CL     5
## the Free Software Foundation, in the hope that it will be useful   # CL     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # CL     7
## for more details.                                                  # CL     8
##                                                                   #  CL     9
##                           *** CRILSQ ***                          #  CL    10
##    THE PROGRAM CRILSQ REFINES ATOMIC PARAMETERS BY MEANS OF A     #  CL    11
##    STRUCTURE FACTOR LEAST SQUARES PROCEDURE.                      #  CL    12
##                                       R. OLTHOF  JANUARI 1999     #  CL    13
##                                                                   #  CL    14
######################################################################  CL    15
##                                                                      CL    16
#                                                                       CL    17
include:(XMACRO)#                                                       CL    18
#                                                                       CL    19
macro:(utob:,78.95684)#                                                 CL    20
macro:(setflg:,IF(I==0)$2=$3;ELSEIF(CHRIN(J^J+1)=="$1")$2=ABS($3-1))#   CL    21
macro:(setint:,IF(I==0)$2=$3;ELSEIF(CHRIN(J^J+1)=="$1")#                CL    22
$(ifnm:(BUFIN(I+1))$($2=NINT(BUFIN(I+1));I=I+1$);ELSE $2=$4$))#         CL    23
macro:(setval:,IF(I==0)$2=$3;ELSEIF(CHRIN(J^J+1)=="$1")#                CL    24
$(ifnm:(BUFIN(I+1))$($2=BUFIN(I+1);I=I+1$);ELSE $2=$4$))#               CL    25
macro:(setkey:,KEY(1)=$1;KEY(2)=$2;KEY(3)=$3;KEY(4)=$4)#                CL    26
macro:(swap:,$(Q1=QX($1);QX($1)=QX($2);QX($2)=Q1$))#                    CL    27
#                                                                       CL    28
#                                                                       CL    29
macro:(atom:,[ifelse:($1,,IA,$1)])#    Define gen list pointer          CL    30
macro:(ml:,[QX(atom:($1)+ 2)])#        Define multiplicity     +2       CL    31
macro:(sf:,[QX(atom:($1)+ 3)])#        Define scat fact num    +3       CL    32
macro:(dp:,[QX(atom:($1)+ 4)])#        Define thermal dptype   +4       CL    33
macro:(dr:,[QX(atom:($1)+ 5)])#        Define disp f' real     +5       CL    34
macro:(di:,[QX(atom:($1)+ 6)])#        Define disp f" imag     +6       CL    35
macro:(xf:,[QX(atom:($1)+ 7)])#        Define fractional x     +7       CL    36
macro:(yf:,[QX(atom:($1)+ 8)])#        Define fractional y     +8       CL    37
macro:(zf:,[QX(atom:($1)+ 9)])#        Define fractional z     +9       CL    38
macro:(ub:,[QX(atom:($1)+10)])#        Define isotropic  u/b   +10      CL    39
macro:(pp:,[QX(atom:($1)+17)])#        Define population pp    +17      CL    40
macro:(si:,[QX(atom:($1)+18)])#        Define start of sigma's +18      CL    41
macro:(na:,[QX(atom:($1)+29)])#        Define atom label       +29      CL    42
#                                                                       CL    43
macro:(w8c:,incr:(arith:(7,/,mxchwd:)))#                                CL    44
macro:(w24c:,incr:(arith:(23,/,mxchwd:)))#                              CL    45
macro:(w40c:,incr:(arith:(39,/,mxchwd:)))#                              CL    46
#                                                                       CL    47
extrude:(CLCOMN)#                                                       CL    48
#                                                                       CL    49
INTEGER$#                                                               CL    50
APPABS,#      ## Apply absolute structure parameter                     CL    51
APPDSP,#      ## Apply dispersion corr signal                           CL    52
APPEXT,#      ## Apply extinction parameter(s)                          CL    53
APPUOV,#      ## Apply overall therm. disp. parameter                   CL    54
HKLPAK,#      ## Reflection record, lrrefl:, o/p packet size            CL    55
IP,#          ## Bdf pointer                                            CL    56
IREFL,#       ## Current pointer of sorted reflection list              CL    57
IREL(101),#   ## Relative pointers for io packet                        CL    58
IWNT(100),#   ## To specify wanted items in directory packets           CL    59
KEY(4),#      ## Group codes for indexpkt:                              CL    60
LISTMX,#      ## List matrix and vector after last cycle (no/yes)       CL    61
LISTRF,#      ## List n reflections after last cycle                    CL    62
LTMTRX,#      ## Less-than reflections do not/do contribute to matrix   CL    63
MMHKL(6),#    ## Min and max of h,k,l                                   CL    64
MATOM,NATOM,LATOM,# ## Atom data                                        CL    65
MCALC,NCALC,LCALC,# ## Calculated structure factor data                 CL    66
MCCAT,NCCAT,LCCAT,# ## Calcat data                                      CL    67
MCONS,NCONS,LCONS,# ## Constraints data                                 CL    68
MEXTI,NEXTI,LEXTI,# ## Extinction data                                  CL    69
MFLAG,NFLAG,LFLAG,# ## Refinement flags                                 CL    70
MSCAT,NSCAT,LSCAT,# ## Scattering factor data                           CL    71
MSYMM,NSYMM,LSYMM,# ## Symmetry data                                    CL    72
MTWIN,NTWIN,LTWIN,# ## Twinning data; ntwin is number of twin fractio   CL    73
MDMATX,LDMATX,# ## Start/end of derivative matrix area                  CL    74
MDTEMP,NDTEMP,LDTEMP,# ## Start/end of derivative temporary area        CL    75
MDVECT,LDVECT,# ## Start/end of derivative vector area                  CL    76
MREFL,#       ## Number of reflections on direct acccess file           CL    77
NCY,#         ## Number of current refinement cycle                     CL    78
NCYCLE,#      ## Number of refinement cycles                            CL    79
NEWM,#        ## New end of defined memory marker                       CL    80
NF,#          ## Number of derivative components                        CL    81
NREFL,#       ## Total number of reflections in all phases              CL    82
NSCF,#        ## Number of scattering factors                           CL    83
NSKIP,#       ## Number of reflection skipped in refinement             CL    84
PACK,#        ## Packet size of bdf record                              CL    85
PUNCH,#       ## Flag to write updated parameters to file PCH           CL    86
RADTYP,#      ## Radiation: 1=neutron,2=electron,3=xray                 CL    87
REFABS,#      ## overall ref flag abs. conf. (Flack parameter) (no/ye   CL    88
REFEXT,#      ## overall ref flag extinction parameters (no/yes)        CL    89
REFPOP,#      ## overall ref flag site population (no/yes)              CL    90
REFRID,#      ## overall ref flag riding atoms (no/yes)                 CL    91
REFSKF,#      ## overall ref flag scale factors  (no/yes)               CL    92
REFTWI,#      ## overall ref flag twin fractions (no/yes)               CL    93
REFUOV,#      ## overall ref flag overall thermal displ par (no/yes)    CL    94
TERMNT,#      ## Stop refinement: 0=no;1=when decrease in R<.01         CL    95
VARGEN,#      ## Number of general variables refined                    CL    96
VARTOT,#      ## Total number of variables refined                      CL    97
WTSCHM#       ## Step weight option (0/1/2 = unit/file/variance-1)      CL    98
#                                                                       CL    99
REAL$#                                                                  CL   100
BUF(100),#    ## Reflection record buffer / cell esd calc scratch       CL   101
CELL(36),#    ## Cell data                                              CL   102
CC,#          ## Start of first constraint list                         CL   103
CONV(6),#     ## Conversion u to b and vv.                              CL   104
DAMPST,#      ## Structure shift damping factor                         CL   105
DATSET,#      ## Data set number                                        CL   106
DEREXT,#      ## Extinction derivative multiplier                       CL   107
DSCF,#        ## Sine theta over lambda interval for s.f.               CL   108
G(9),#        ## Inverse metric tensor                                  CL   109
GOF,#         ## Goodness of fit                                        CL   110
LAMBDA,#      ## Radiation wavelength                                   CL   111
LISTCM,#      ## List correlation matrix elements > q                   CL   112
LISTPR,#      ## List poor reflns with wY > q                           CL   113
MAXHKL(5),#   ##                                                        CL   114
RFMTRX,#      ## Contribute refl. to ls if w * dy < rfmtrx              CL   115
RSTORE(100),# ## Summary of refinement index values (10 cycles)         CL   116
RSUMS(11),#   ## R factor sums                                          CL   117
SOEAVE,#      ## shift/error average per cycle                          CL   118
SOEMAX,#      ## shift/error maximum per cycle                          CL   119
SKF,#         ## 1./scale factor (in output); 1./scale**2 in program    CL   120
T(9),#        ## Coefficients to calculate distances                    CL   121
UOV,#         ## Overall thermal displacement factors                   CL   122
VOL,#         ## Cell volume                                            CL   123
WEIGHT,#      ## Weight                                                 CL   124
XABS,#        ## Flack parameter                                        CL   125
YEXT#         ## Extinction factor                                      CL   126
#                                                                       CL   127
COMMON/COMICL/APPABS,APPDSP,APPEXT,APPUOV,HKLPAK,IP,IREFL,IREL,IWNT,#   CL   128
KEY,LISTMX,LISTRF,LTMTRX,MMHKL,MATOM,NATOM,LATOM,#                      CL   129
MCALC,LCALC,NCALC,MCCAT,NCCAT,LCCAT,#                                   CL   130
MCONS,NCONS,LCONS,MEXTI,NEXTI,LEXTI,MFLAG,NFLAG,LFLAG,#                 CL   131
MSCAT,NSCAT,LSCAT,MSYMM,NSYMM,LSYMM,MTWIN,NTWIN,LTWIN,#                 CL   132
MDMATX,LDMATX,MDVECT,LDVECT,MDTEMP,NDTEMP,LDTEMP,MREFL,#                CL   133
NCY,NCYCLE,NEWM,NF,NREFL,NSCF,NSKIP,PACK,PUNCH,RADTYP,#                 CL   134
REFABS,REFEXT,REFPOP,REFRID,REFSKF,REFTWI,REFUOV,#                      CL   135
TERMNT,VARGEN,VARTOT,WTSCHM#                                            CL   136
#                                                                       CL   137
COMMON/COMFCL/BUF,CC,CELL,CONV,DAMPST,DATSET,DEREXT,DSCF,G,GOF,#        CL   138
LAMBDA,LISTCM,LISTPR,MAXHKL,RFMTRX,RSTORE,RSUMS,SOEAVE,SOEMAX,#         CL   139
SKF,T,UOV,VOL,WEIGHT,XABS,YEXT#                                         CL   140
#                                                                       CL   141
endext:#                                                                CL   142
#                                                                       CL   143
systemheader:(CL00)#                   Least squares main program       CL00   1
######################################################################  CL00   2
#                                                                    #  CL00   3
#                                CL00                                #  CL00   4
#                                                                    #  CL00   5
######################################################################  CL00   6
SUBROUTINE CL00#                                                        CL00   7
#                                                                       CL00   8
include:(AACOMN)#                                                       CL00   9
include:(CLCOMN)#                                                       CL00  10
#                                                                       CL00  11
CALL CL10#                             Read/write crylsq line options   CL00  12
CALL CL20#                             Bdf: cell,symm,scat,expl,dset    CL00  13
CALL CL21#                             Bdf: atom,constr                 CL00  14
CALL CL30#                             Enter input lines                CL00  15
CALL CL31#                             Process riding atom data         CL00  16
CALL CL32#                             Convert data to refine flags     CL00  17
CALL CL40#                             Print parameter summary          CL00  18
FOR(NCY=1;NCY<=NCYCLE+1;NCY=NCY+1)#    Loop over refinement cycles      CL00  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL00  20
IF(REFRID==yes:) CALL CL42#            Generate riding atom parameter   CL00  21
IF(NCY==NCYCLE+1&NCYCLE>0) CALL CL48#  Update bdf & punch atom param    CL00  22
CALL CL50#                             Process reflection data          CL00  23
REPEAT#                                Loop over the reflections        CL00  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL00  25
CALL CL51#                             Calculate sf and atom derivati   CL00  26
IF(IREFL>NREFL) BREAK#                 Break after last reflection      CL00  27
IF(NINT(BUF(30))!=NCY) CALL CL52#      Derivatives for main refl.       CL00  28
IF(BUF(30)>-.5) CALL CL53#             Output, statistics               CL00  29
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL00  30
CALL CL60#                             Treat restraint observations     CL00  31
CALL CL70#                             Output of sums and discrepanci   CL00  32
IF(NCY>NCYCLE) BREAK#                  Break after last cycle           CL00  33
CALL CL80#                             Matrix inversion                 CL00  34
CALL CL90#                             Update/print general params      CL00  35
CALL CL91#                             Update/print atom parameters     CL00  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL00  37
CALL CL99#                             Write o/p bdf's & quit           CL00  38
#                                                                       CL00  39
RETURN#                                                                 CL00  40
END#                                                                    CL00  41
systemheader:(CL01)#                   Read index packets               CL01   1
######################################################################  CL01   2
#                                                                    #  CL01   3
#                               CL01                                 #  CL01   4
#                                                                    #  CL01   5
######################################################################  CL01   6
SUBROUTINE CL01(LRTYPE)#                                                CL01   7
include:(AACOMN)#                                                       CL01   8
include:(CLCOMN)#                                                       CL01   9
#                                                                       CL01  10
INTEGER HPAK#           ## Words in direct access file, read from bdf   CL01  11
INTEGER I,J#            ## Loop indices                                 CL01  12
INTEGER M#              ## Data set bias for idnums                     CL01  13
INTEGER LRTYPE#         ## Logical record type                          CL01  14
#                                                                       CL01  15
M=NINT(DATSET)#                        Data set  number                 CL01  16
#                                                                       CL01  17
IF(LRTYPE==lrscat:)#                   Read lrscat                      CL01  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL01  19
IWNT(1)=11;IWNT(2)=11;IWNT(3)=1#       At name & nr of atoms            CL01  20
IWNT(4)=M+20;IWNT(5)=M+60#             Set real & imag disp             CL01  21
IWNT(6)=10#                            Set neut ff                      CL01  22
IWNT(7)=100#                           Atomic scat.fact. at s=0.00      CL01  23
setkey:(1,7,0,0)#                      Set search signals               CL01  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL01  25
#                                                                       CL01  26
ELSE IF(LRTYPE==lrexpl:)#              Read lrexpl:                     CL01  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL01  28
IWNT(1)=1;IWNT(2)=101;IWNT(3)=2#       Set datset, scale and lambda     CL01  29
IWNT(4)=94#                            Radiation type                   CL01  30
IWNT(5)=52#                            Set perp. polarization ratio     CL01  31
setkey:(5,3,2,0)#                      Set search signals               CL01  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL01  33
#                                                                       CL01  34
ELSE IF(LRTYPE==lrdset:)#              Read lrdset:                     CL01  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL01  36
IWNT(1)=1;IWNT(2)=2#                   Dat set number; request uov      CL01  37
DO I=1,5 ;IWNT(I+2)=I+10#              Request max /h/ etc.             CL01  38
DO I=1,17;IWNT(I+7)=I+100#             Request extinction parameters    CL01  39
IWNT(25)=3#                            Request flack param              CL01  40
DO I=1,6;IWNT(25+I)=70+I#              Hkl(min) and max                 CL01  41
setkey:(31,0,2,0)#                     Set search signals               CL01  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL01  43
#                                                                       CL01  44
ELSE IF(LRTYPE==lratom:)#              Read lratom:                     CL01  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL01  46
IWNT(1)=17#                            Request dataset pointer          CL01  47
IWNT(2)=21#                            Request atom multiplicity        CL01  48
IWNT(3)=22#                            Request scat fact number         CL01  49
IWNT(4)=23#                            Request thermal dptype           CL01  50
IWNT(5)=24#                            Request atom group key           CL01  51
IWNT(6)=25#                            Model key                        CL01  52
DO I=1,11;    IWNT(I+ 6)=I#            Request x y z u uij pop          CL01  53
DO I=1,11;    IWNT(I+17)=100+I#        Request sigma's                  CL01  54
DO I=1,w24c:; IWNT(I+28)=14#           Request atom label               CL01  55
M=28+w24c:#                            End of lratom data               CL01  56
DO I=1,w8c:;IWNT(M+I)=300#             Riding h atoms data              CL01  57
M=M+w8c:#                              Point to next item               CL01  58
DO I=1,3;     IWNT(M+ I)=300+I#        Request calcat constr,d,a1,a2    CL01  59
M=M+3#                                 Pnt to next item                 CL01  60
DO I=1,4#                              Loop over input atoms            CL01  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL01  62
DO J=1,w24c:;IWNT(M+J)=308+2*I#        Request input atom label         CL01  63
M=M+incr:(w24c:)#                      Incr pointer                     CL01  64
IWNT(M)=310+I#                         Request trans+symop              CL01  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL01  66
DO I=1,4#                              Loop over output atoms           CL01  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL01  68
DO J=1,w24c:;IWNT(M+J)=319+I#          Request output atom label        CL01  69
M=M+w24c:#                             Pnt to next item                 CL01  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL01  71
setkey:(0,M,0,0)#                      Set search signals               CL01  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL01  73
#                                                                       CL01  74
ELSE IF(LRTYPE==lrcons:)#              Read lrcons:                     CL01  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL01  76
DO I=1,3; IWNT(I  )=I#                 Subj labl/par/mul                CL01  77
DO I=1,3; IWNT(I+3)=I+10#              Ref  labl/par/mul                CL01  78
DO I=1,2; IWNT(I+6)=I+3#               Constant q & type                CL01  79
setkey:(8,0,0,0)#                      Set search signals               CL01  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL01  81
#                                                                       CL01  82
ELSE IF(LRTYPE==lrrefl:)#              Read lrrefl:                     CL01  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL01  84
M=M*1000#                              Data set bias for idnums         CL01  85
IF(NCY==1)#                            If first cycle                   CL01  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CL01  87
DO I=1,3; IWNT(I)=1#                   Hkl; spares for h,k,l            CL01  88
IWNT(4)=2#                             Sin theta/lambda                 CL01  89
IWNT(5)=M+308#                         Rcode                            CL01  90
DO I=1,2;IWNT(5+I)=M+301+I#            F2obs,sig(f2obs)                 CL01  91
DO I=1,2;IWNT(7+I)=IWNT(5+I)+10#       F2obs,sig(f2obs) - friedel       CL01  92
IWNT(10)=M+900#                        Weighting scheme                 CL01  93
IWNT(11)=3#                            Multiplicity                     CL01  94
IWNT(12)=1200#                         Tbar                             CL01  95
DO I=1,NSCF; IWNT(12+I)=I+500#         Ask for scat factors             CL01  96
HPAK=13+NSCF#                          Words in dir access file         CL01  97
IWNT(HPAK)=M+318#                      Rcode for friedel reflection     CL01  98
setkey:(6,HPAK,0,0)#                   Set search signals               CL01  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CL01 100
IF(NCY>NCYCLE)#                        If last cycle                    CL01 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CL01 102
DO I=1,3;IWNT(I)=I#                    Hkl,sin/lambda,mult              CL01 103
IWNT(4)=M+700;IWNT(5)=M+701#           Phase,frel (no disp; no ext)     CL01 104
IWNT(6)=M+800#                         Fcalc (no disp; no ext)          CL01 105
IWNT(7)=M+801;IWNT(8)=M+802#           Acalc,bcalc (no disp; no ext)    CL01 106
IWNT(9)=M+805;IWNT(10)=M+806#          Acalc,bcalc (disp and extinc)    CL01 107
setkey:(3,3,10,0)#                     Set search signals               CL01 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CL01 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL01 110
#                                                                       CL01 111
M=IABS(IORWFL(1))#                                                      CL01 112
indexpkt:(1,LRTYPE,PACK,IP,M,KEY,IWNT,IREL)# Search directory           CL01 113
#                                                                       CL01 114
RETURN#                                                                 CL01 115
END#                                                                    CL01 116
systemheader:(CL02)#                   Calculate u(equivalent)          CL02   1
######################################################################  CL02   2
#                                                                    #  CL02   3
#                               CL02                                 #  CL02   4
#                                                                    #  CL02   5
######################################################################  CL02   6
SUBROUTINE CL02(IU,UEQ)#                                                CL02   7
#                                                                       CL02   8
include:(AACOMN)#                                                       CL02   9
include:(CLCOMN)#                                                       CL02  10
#                                                                       CL02  11
INTEGER IU,I#           ## Uij index                                    CL02  12
REAL UEQ#               ## Ueq                                          CL02  13
#                                                                       CL02  14
UEQ=0.#                                Set to zero                      CL02  15
DO I=1,3;UEQ=UEQ+QX(IU+I)*CONV(I)#     Sum uii                          CL02  16
UEQ=UEQ/3.#                            Mean value                       CL02  17
#                                                                       CL02  18
RETURN#                                                                 CL02  19
END#                                                                    CL02  20
systemheader:(CL10)#                   Read/write crylsq line options   CL10   1
######################################################################  CL10   2
#                                                                    #  CL10   3
#                               CL10                                 #  CL10   4
#                                                                    #  CL10   5
######################################################################  CL10   6
SUBROUTINE CL10#                                                        CL10   7
#                                                                       CL10   8
include:(AACOMN)#                                                       CL10   9
include:(CLCOMN)#                                                       CL10  10
#                                                                       CL10  11
INTEGER    I,J,K#       ## General indices                              CL10  12
#                                                                       CL10  13
chardata:(CL0,' noyes')#                                                CL10  14
chardata:(CL1,' CRYLSQ Control Parameters-')#                           CL10  15
chardata:(CL2,' Number of refinement cycles              ')#            CL10  16
chardata:(CL3,' Apply dispersion parameters              ')#            CL10  17
chardata:(CL5,' Apply overall thermal displ pars         ')#            CL10  18
chardata:(CL6,' Apply extinction parameters              ')#            CL10  19
chardata:(CL7,' Apply Flack paramater                    ')#            CL10  20
chardata:(CL8,' Apply indiv thermal displ pars           ')#            CL10  21
chardata:(CL9,' Refine occupancy (population)            ')#            CL10  22
chardata:(CLA,' Reflection skip value                    ')#            CL10  23
chardata:(CLB,' Weight option                            ')#            CL10  24
chardata:(CLC,' Contribute to ls only if w|dY| <         ')#            CL10  25
chardata:(CLD,' Shift damping factor overall             ')#            CL10  26
chardata:(CLE,' Terminate refinement if convergence      ')#            CL10  27
chardata:(CLF,' List n reflections after last cycle;     ')#            CL10  28
chardata:(CLG,' List poor reflections; w|dY|   >         ')#            CL10  29
chardata:(CLH,' List matrix after last cycle             ')#            CL10  30
chardata:(CLI,' List correlations matrix; el.  >         ')#            CL10  31
chardata:(CLJ,' Punch new params after last cycle        ')#            CL10  32
chardata:(CLK,' Exclude rcode=2 refl.from ls             ')#            CL10  33
datastuff:#                                                             CL10  34
#                                                                       CL10  35
#     EXTRACT DATA FROM CRYLSQ LINE AND SET DEFAULT VALUES              CL10  36
#     ----------------------------------------------------              CL10  37
#                                                                       CL10  38
FOR(I=0;I>=0;I=I+1)#                   Loop over input fields           CL10  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL10  40
stringlim:(I,J,K)#                     Get string limits                CL10  41
#                                                                       CL10  42
setflg:(ND,APPDSP,yes:)#               No application dispersion        CL10  43
setflg:(NS,REFSKF,yes:)#               No refinement of sf scales       CL10  44
setflg:(OV,APPUOV,no:)#                Refinement of overall tdp        CL10  45
setflg:(EX,APPEXT,no:)#                Application extinction           CL10  46
setflg:(AB,APPABS,no:)#                Application abs.-struct. param   CL10  47
setflg:(RO,REFPOP,no:)#                Refinement of occupancy (pop)    CL10  48
setflg:(ML,LTMTRX,no:)#                Include rcode=2 refl in matrix   CL10  49
setflg:(TC,TERMNT,no:)#                Terminate if convergence reach   CL10  50
setflg:(LM,LISTMX,no:)#                List matrix after last cycle     CL10  51
setflg:(PC,PUNCH,no:)#                 Punch new pars after last cycl   CL10  52
#                                                                       CL10  53
setint:(CY,NCYCLE,1,1)#                Max ls cycles                    CL10  54
setint:(SK,NSKIP ,1,2)#                Reflection skip factor           CL10  55
setint:(WT,WTSCHM,3,3)#                Select step weight option        CL10  56
setint:(LI,LISTRF,0,99999)#            List reflns after last cycle     CL10  57
#                                                                       CL10  58
setval:(MR,RFMTRX,1.E8, 100.)#         Matrix refln inclusion <q        CL10  59
setval:(SD,DAMPST, 1.0,  0.5)#         Structure damping factor         CL10  60
setval:(LR,LISTPR,1.E8,  10.)#         List poor reflections if >q      CL10  61
setval:(LC,LISTCM,1.E8,  0.0)#         List corr matrix if >q           CL10  62
#                                                                       CL10  63
ifvo:(BUFIN(I+1)) BREAK#               Exit when field void             CL10  64
ifnm:(BUFIN(I+1)) iquit:(CL1001,I+1)#  Must be char string              CL10  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL10  66
REFUOV=APPUOV;REFEXT=APPEXT#           Init refinement flags            CL10  67
REFABS=APPABS;REFTWI=yes:;REFRID=no:#                                   CL10  68
#                                                                       CL10  69
#        PRINT CONTROL PARAMETERS                                       CL10  70
#        ------------------------                                       CL10  71
#                                                                       CL10  72
LINRM=12#                              Ensure print space 12 lines      CL10  73
movechar:(CL1,NCL1,CHROT,2,NCL1-2,1)#  Insert header underline          CL10  74
writeline:(1,CL1,NCL1-1,2,3)#          Print header                     CL10  75
ncodefld:(FLOAT(NCYCLE),1,CL2,400513.,1)# Format refine cycles          CL10  76
writeline:(0,CL2,NCL2,3,3)#            Print refine cycles              CL10  77
movechar:(CL0,APPDSP*3+1,CL3,38,3,0)#  Insert apply disp flag           CL10  78
writeline:(0,CL3,NCL3,3,3)#            Print apply disp flag            CL10  79
movechar:(CL0,APPUOV*3+1,CL5,38,3,0)#  Insert refine uov                CL10  80
IF(APPUOV==yes:) writeline:(0,CL5,NCL5,3,3)# Print refine uov           CL10  81
movechar:(CL0,APPEXT*3+1,CL6,38,3,0)#  Insert refine extinction param   CL10  82
writeline:(0,CL6,NCL6,3,3)#            Print refine extinction params   CL10  83
movechar:(CL0,IABS(APPABS*3)+1,CL7,38,3,0)# Insert refine flack param   CL10  84
writeline:(0,CL7,NCL7,3,3)#            Print refine flack parameter     CL10  85
movechar:(CL0,REFPOP*3+1,CL9,38,3,0)#  Insert refine population         CL10  86
writeline:(0,CL9,NCL9,3,3)#            Print refine population          CL10  87
ncodefld:(FLOAT(NSKIP),1,CLA,400613.,1)# Format reflection skip value   CL10  88
IF(NSKIP>1) writeline:(0,CLA,NCLA,3,3)# Print reflection skip value     CL10  89
ncodefld:(FLOAT(WTSCHM),1,CLB,400613.,1)# Format weighting scheme       CL10  90
writeline:(0,CLB,NCLB,3,3)#            Print weighting scheme           CL10  91
ncodefld:(RFMTRX,1,CLC,400702.,1)#     Format contribute ls             CL10  92
IF(RFMTRX<1.E7)writeline:(0,CLC,NCLC,3,3)# Print contribute ls          CL10  93
movechar:(CL0,LTMTRX*3+1,CLK,38,3,0)#  Insert include rcode2 refl.      CL10  94
writeline:(0,CLK,NCLK,3,3)#            Print include rcode2 refl.       CL10  95
ncodefld:(DAMPST,1,CLD,400612.,1)#     Format damping structure         CL10  96
writeline:(0,CLD,NCLD,3,3)#            Print terminate refinement       CL10  97
movechar:(CL0,TERMNT*3+1,CLE,38,3,0)#  Insert terminate refinement      CL10  98
IF(TERMNT==yes:) writeline:(0,CLE,NCLE,3,3)# Print terminate refineme   CL10  99
ncodefld:(FLOAT(LISTRF),1,CLF,400613.,1)# Format list reflections       CL10 100
IF(LISTRF>0) writeline:(0,CLF,NCLF,3,3)# Print list reflections         CL10 101
LISTRF=-LISTRF#                        No print before last cycle       CL10 102
ncodefld:(LISTPR,1,CLG,400612.,1)#     Format list poor reflection      CL10 103
IF(LISTPR<99999.) writeline:(0,CLG,NCLG,3,3)# Print list poor reflect   CL10 104
movechar:(CL0,LISTMX*3+1,CLH,38,3,0)#  Insert list matx after last cy   CL10 105
IF(LISTMX==yes:) writeline:(0,CLH,NCLH,3,3)# Print list matx after lc   CL10 106
ncodefld:(LISTCM,1,CLI,400612.,1)#     Format list  corr. matrix        CL10 107
IF(LISTCM<=1.0) writeline:(0,CLI,NCLI,3,3)# Print list corr. matrix     CL10 108
movechar:(CL0,PUNCH*3+1,CLJ,38,3,0)#   Insert punch new params          CL10 109
IF(PUNCH==yes:) writeline:(0,CLJ,NCLJ,3,3)# Print punch new params      CL10 110
#                                                                       CL10 111
RETURN#                                                                 CL10 112
END#                                                                    CL10 113
systemheader:(CL20)#                   Bdf: cell to dset                CL20   1
######################################################################  CL20   2
#                                                                    #  CL20   3
#                               CL20                                 #  CL20   4
#                                                                    #  CL20   5
######################################################################  CL20   6
SUBROUTINE CL20#                                                        CL20   7
#                                                                       CL20   8
include:(AACOMN)#                                                       CL20   9
include:(CLCOMN)#                                                       CL20  10
#                                                                       CL20  11
#REAL    CELL(36)#      ## Direct and rec. cell data                    CL20  12
REAL    COMP#           ## Parallel polarization                        CL20  13
INTEGER I,J#            ## Indices and pointers                         CL20  14
INTEGER ISCF#           ## Scattering factors count                     CL20  15
INTEGER MARK#           ## Ponter in current qx-buffer                  CL20  16
INTEGER LPAK#           ##                                              CL20  17
REAL    PPFAC#          ## Perp. polarization fraction                  CL20  18
realdata:(DEFTWN,[1.,0.,0.,0.,1.,0.,0.,0.,1.,1.,0.,0.,0.])#             CL20  19
datastuff:#                                                             CL20  20
#                                                                       CL20  21
#                                                                       CL20  22
#    STORE DEFAULT PARAMETERS                                           CL20  23
#    ------------------------                                           CL20  24
#                                                                       CL20  25
DATSET=1.#                             Default data set number          CL20  26
#                                                                       CL20  27
#    SET UP AND REQUEST FILE BUFFERS / OPEN APPROPRIATE ARCHIVE BDF     CL20  28
#    --------------------------------------------------------------     CL20  29
#                                                                       CL20  30
FILEXT(ioda1:)='XXB'#                  Scratch unsorted refln data      CL20  31
IOMARK(1)=QXSTR#                       Buffer inpu1 archive bdf(s)      CL20  32
IOMARK(2)=IOMARK(1)+bdfbuf:#           Buffer output archive bdf(s)     CL20  33
incrqx:(NEWM,IOMARK(2)+bdfbuf:,CL105)# Start of qx data                 CL20  34
readwpkt:(1,lrlabl:,PACK,IP,0)#        Enter bdf history                CL20  35
#                                                                       CL20  36
#    READ LRCELL: DATA                                                  CL20  37
#    -----------------                                                  CL20  38
#                                                                       CL20  39
DO I=1,8#                              Loop over cell packets           CL20  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL20  41
readwpkt:(1,lrcell:,PACK,IP,0)#        Cell information                 CL20  42
IF(IP<=0) iquit:(CL2001)#              Insufficient cell packets        CL20  43
IF(I==1) movereal:(QX,IP+1,CELL, 1,9,0)# Direct cell parameters         CL20  44
IF(I==3) movereal:(QX,IP+1,CELL,10,9,0)# Reciprocal cell parameters     CL20  45
IF(I==4) movereal:(QX,IP+1,CELL,19,9,0)# Transformation fract to cart   CL20  46
IF(I==5) movereal:(QX,IP+1,CELL,28,9,0)# Transformation cart to fract   CL20  47
IF(I==6) VOL=QX(IP+1)#                 Cell volume                      CL20  48
IF(I==7) movereal:(QX,IP+1,T,1,9,0)#   Metric tensor                    CL20  49
IF(I==8) movereal:(QX,IP+1,G,1,9,0)#   Inverse metric tensor            CL20  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL20  51
T(2)=2.*T(2);T(3)=2.*T(3);T(6)=2.*T(6)# Coeff. to calc dist             CL20  52
T(4)=T(2);T(7)=T(3);T(8)=T(6)#                                          CL20  53
DO I=1,3#                              Loop over axes                   CL20  54
CONV(I)=.0506606/CELL(I+9)**2#         Conversion beta to u             CL20  55
CONV(4)=.0506606/(CELL(10)*CELL(11))#  Conversion beta to u             CL20  56
CONV(5)=.0506606/(CELL(10)*CELL(12))#  Conversion beta to u             CL20  57
CONV(6)=.0506606/(CELL(11)*CELL(12))#  Conversion beta to u             CL20  58
#                                                                       CL20  59
#     READ LRSYMM: DATA                                                 CL20  60
#     -----------------                                                 CL20  61
#                                                                       CL20  62
MSYMM=NEWM;NSYMM=12#                   Start of symmetry packets        CL20  63
FOR(MARK=MSYMM;MARK>0;MARK=NEWM)#      Loop over rot. matrices          CL20  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL20  65
readwpkt:(1,lrsymm:,PACK,IP,0)#        Read next symmetry packet        CL20  66
IF(IP<=0) BREAK#                       Exit after last packet           CL20  67
incrqx:(NEWM,MARK+NSYMM,CL2004)#       Get memory                       CL20  68
movereal:(QX,IP+1,QX,MARK+1,12,0)#     Move rotation matrix+vector      CL20  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL20  70
LSYMM=NEWM#                            Save end of symm factors         CL20  71
#                                                                       CL20  72
#     READ LRTWIN: DATA                                                 CL20  73
#     -----------------                                                 CL20  74
#                                                                       CL20  75
MTWIN=NEWM;NTWIN=0;LTWIN=MTWIN#        Save start/number twin data      CL20  76
REPEAT#                                Loop over twin fractions         CL20  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL20  78
readwpkt:(1,lrtwin:,PACK,IP,0)#        Read lrtwin:                     CL20  79
IF(IP<=0) BREAK#                       Last fraction read               CL20  80
incrqx:(NEWM,LTWIN+13,CL2008)#         Get packet memory                CL20  81
movereal:(QX,IP+1,QX,LTWIN+1,13,0)#    Move rotation matrix             CL20  82
IF(APPABS==yes:) QX(LTWIN+10)=QX(LTWIN+10)+QX(LTWIN+12)# Sum flack fr   CL20  83
NTWIN=NTWIN+1;LTWIN=NEWM#              Count twin fractions             CL20  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL20  85
IF(NTWIN==0)#                          If no twin info in bdf           CL20  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL20  87
incrqx:(NEWM,LTWIN+13,CL2008)#         Get packet memory                CL20  88
movereal:(DEFTWN,1,QX,MTWIN+1,13,1)#   Default twin data                CL20  89
NTWIN=1#                                                                CL20  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL20  91
LTWIN=MTWIN+13*NTWIN#                  End of twin data                 CL20  92
#                                                                       CL20  93
#     READ LRSCAT: DATA                                                 CL20  94
#     -----------------                                                 CL20  95
#                                                                       CL20  96
MARK=NEWM;MSCAT=MARK#                  Start of scat factors            CL20  97
CALL CL01(lrscat:)#                    Read index packet                CL20  98
IF(IP<=0) iquit:(CL2002)#              No lrscat packet there           CL20  99
#                                                                       CL20 100
FOR(I=IP+IREL(7);I<=IP+PACK;I=I+1)#    Loop over ff list                CL20 101
IF((QX(I)<99.5)\(QX(I)>299.5)) BREAK#  Exit after last ff               CL20 102
IF(IREL(7)>0) ISCF=I-IP-IREL(3)#       Count contiguous ff              CL20 103
ELSE          ISCF=0#                  Ff table not present             CL20 104
IF(IREL(6)>0) ISCF=1#                  Count neutron ff                 CL20 105
IF(IREL(7)>0) DSCF=(QX(I-1)-QX(I-2))*.01# Set st/l interval             CL20 106
NSCAT=ISCF+5;NSCF=0#                   Set stored packet size           CL20 107
#                                                                       CL20 108
FOR(J=MARK;J>0;J=NEWM)#                Loop over each atom type         CL20 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL20 110
readwpkt:(1,lrscat:,LPAK,IP,0)#        Get packet pointer               CL20 111
IF(IP<=0) BREAK#                       Exit after last packet           CL20 112
incrqx:(NEWM,J+NSCAT,CL2008)#          Get packet memory                CL20 113
movereal:(QX(IP+IREL(1)),1,QX,J+1,2,0)# Store scat fac name             CL20 114
I=IP+IREL(3); IF(I>IP) ifnv:(QX(I)) QX(J+3)=QX(I)# Get atoms/cell       CL20 115
I=IP+IREL(4); IF(I>IP) ifnv:(QX(I)) QX(J+4)=QX(I)# Get real disp        CL20 116
I=IP+IREL(5); IF(I>IP) ifnv:(QX(I)) QX(J+5)=QX(I)# Get imag disp        CL20 117
I=IP+IREL(6); IF(I>IP) ifnv:(QX(I)) QX(J+6)=QX(I)# Store neutron ff     CL20 118
IF(ISCF>1)DO I=1,ISCF; QX(J+I+5)=QX(IP+IREL(7)+I-1)# Store scat fact    CL20 119
NSCF=NSCF+1#                           Count atom types                 CL20 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL20 121
LSCAT=NEWM#                            Save end of scat factors         CL20 122
#                                                                       CL20 123
#     READ LREXPL: DATA                                                 CL20 124
#     -----------------                                                 CL20 125
#                                                                       CL20 126
CALL CL01(lrexpl:)#                    Call indexp  packet              CL20 127
IF(IP<=0) iquit:(CL2003)#              Lrexpl: not there                CL20 128
REPEAT#                                Loop over lrexpl pkts            CL20 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL20 130
readwpkt:(1,lrexpl:,PACK,IP,0)#        Read lrexpl: packet              CL20 131
IF(IP<=0) BREAK#                       Lr ended too soon                CL20 132
ifne:(DATSET,QX(IP+IREL(1))) NEXT#     Skip incorrect datasets          CL20 133
SKF=1./QX(IP+IREL(2))**2#              Get 1./scale                     CL20 134
LAMBDA=QX(IP+IREL(3))#                 Get lambda                       CL20 135
RADTYP=NINT(QX(IP+IREL(4)))#           Store rad (1=neu,2=el;3=xray)    CL20 136
IF(IREL(5)>0) PPFAC=QX(IP+IREL(5))#    Perp. polarization fraction      CL20 137
ELSE          PPFAC=.5#                Default value                    CL20 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL20 139
#                                                                       CL20 140
#     READ LRDSET: DATA                                                 CL20 141
#     -----------------                                                 CL20 142
#                                                                       CL20 143
MEXTI=NEWM;NEXTI=26;YEXT=1.#           Start of extinction parameters   CL20 144
CALL CL01(lrdset:)#                    Read index packet                CL20 145
IF(IP<=0) iquit:(CL2004)#              Lrdset: not there                CL20 146
REPEAT#                                Loop over lrdset pkts            CL20 147
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL20 148
readwpkt:(1,lrdset:,PACK,IP,0)#        Read lrdset: packet              CL20 149
IF(IP<=0) BREAK#                       Lr ended too soon                CL20 150
ifne:(DATSET,QX(IP+IREL(1))) NEXT#     Skip incorrect datasets          CL20 151
UOV=QX(IP+IREL(2))#                    Store uov                        CL20 152
DO I=1,5#                                                               CL20 153
IF(IREL(I+2)>0) MAXHKL(I)=QX(IP+IREL(I+2))#                             CL20 154
incrqx:(NEWM,NEWM+NEXTI,CL2008)#       Get packet memory                CL20 155
DO I=1,17; IF(IREL(I+7)>0)#            Loop over requested atom data    CL20 156
QX(MEXTI+I)=QX(IP+IREL(I+7))#          Store extinction params          CL20 157
DO I=3,16;QX(MEXTI+I)=QX(MEXTI+I)/10000.# Divide extinc par by 10000    CL20 158
ifeq:(QX(MEXTI+17),0.)#                                                 CL20 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL20 160
IF(RADTYP>=3) QX(MEXTI+17)=0.3#        Default tbar in mm for xray      CL20 161
IF(RADTYP==1) QX(MEXTI+17)=1.5#        Default tbar in mm for neut      CL20 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL20 163
QX(MEXTI+20)=PPFAC#                    Perp. polarization fraction      CL20 164
IF(IREL(25)>0) XABS=QX(IP+IREL(25))#   Set flack param                  CL20 165
ELSE           XABS=0.#                Default                          CL20 166
IF(APPABS==no:) XABS=0.#               Set to zero                      CL20 167
DO I=1,5,2#                                                             CL20 168
IF(IREL(25+I)>0) MMHKL((I+1)/2)=QX(IP+IREL(25+I))# Min & max hkl        CL20 169
DO I=2,6,2; IF(IREL(25+I)>0) MMHKL((I+6)/2)=QX(IP+IREL(25+I))# Min &    CL20 170
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL20 171
LEXTI=NEWM#                            Save end of extinction params    CL20 172
#                                                                       CL20 173
RETURN#                                                                 CL20 174
END#                                                                    CL20 175
systemheader:(CL21)#                   Bdf: atom,constr                 CL21   1
######################################################################  CL21   2
#                                                                    #  CL21   3
#                               CL21                                 #  CL21   4
#                                                                    #  CL21   5
######################################################################  CL21   6
SUBROUTINE CL21#                                                        CL21   7
include:(AACOMN)#                                                       CL21   8
include:(CLCOMN)#                                                       CL21   9
#                                                                       CL21  10
INTEGER I,IA,ID,J#      ## Indices and pointers                         CL21  11
INTEGER MARK#           ## Pointer in qx-buffer                         CL21  12
#                                                                       CL21  13
string:(NAME1,24)#                                                      CL21  14
string:(NAME2,24)#                                                      CL21  15
string:(LABEL,24)#                                                      CL21  16
#                                                                       CL21  17
#    READ LRATOM: DATA                                                  CL21  18
#    -----------------                                                  CL21  19
#                                                                       CL21  20
MARK=NEWM;MATOM=MARK;NATOM=w24c:+28#   Start of atom packets            CL21  21
CALL CL01(lratom:)#                    Read index packet                CL21  22
IF(IREL(NATOM+1)>0)#                   If riding atom data on bdf       CL21  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL21  24
NATOM=NATOM+57;REFRID=yes:#            Do refine riding atom data       CL21  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL21  26
#                                                                       CL21  27
FOR(IA=MATOM;IA>0;IA=IA+NATOM)#        Loop over atom packets           CL21  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL21  29
readwpkt:(1,lratom:,PACK,IP,0)#        Read an atom packet              CL21  30
IF(IP<=0) BREAK#                       End of logical record            CL21  31
IF(IREL(1)>0) ifne:(DATSET,QX(IP+IREL(1))) NEXT# Check dataset          CL21  32
MARK=NEWM#                             Start of new memory              CL21  33
incrqx:(NEWM,MARK+NATOM,CL2130)#       Get atom packet memory           CL21  34
DO I=1,NATOM; IF(IREL(I)>0)#           Loop over requested atom data    CL21  35
movereal:(QX,IP+IREL(I),QX,IA+I,1,0)#  Store atom data word             CL21  36
ID=MSCAT+NSCAT*(NINT(sf:)-1)+4#        Point to scat factor table       CL21  37
dr:=QX(ID);di:=QX(ID+1)#               Store dispersion terms           CL21  38
IF(REFUOV==yes:) dp:=0#                Set tdp type to uov              CL21  39
ifne:(dp:,1.)#                         If not iso                       CL21  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL21  41
ub:=voidflg:#                          Void uiso                        CL21  42
ub:(IA+11)=voidflg:#                   Void sigma(uiso)                 CL21  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL21  44
ifne:(dp:,2.)#                         If not aniso                     CL21  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL21  46
DO I=1,6;ub:(IA+I)=voidflg:#           Void uij                         CL21  47
DO I=1,6;ub:(IA+11+I)=voidflg:#        Void sigma(uij)                  CL21  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL21  49
LATOM=IA+NATOM#                        Save end of atom array           CL21  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL21  51
#                                                                       CL21  52
#    INPUT CONSTRAINTS FROM LRCONS:                                     CL21  53
#    ------------------------------                                     CL21  54
#                                                                       CL21  55
MARK=NEWM;MCONS=NEWM;NCONS=8#          Start of constraints data        CL21  56
CC=FLOAT(MCONS-1)#                     Set start of first constraint    CL21  57
CALL CL01(lrcons:)#                    Read index packet                CL21  58
IF(IP>0)#                              If constraints present           CL21  59
FOR(J=MARK;J>0;J=NEWM)#                Loop all the packets             CL21  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL21  61
readwpkt:(1,lrcons:,PACK,IP,0)#        Read next constraint pkt         CL21  62
IF(IP<=0) BREAK#                       End of logical record            CL21  63
incrqx:(NEWM,J+8,CL2130)#              Get constraints packet           CL21  64
DO I=1,8; movereal:(QX,IP+IREL(I),QX,J+I,1,0)# Store constraints        CL21  65
IF(QX(J+2)>3.) QX(J+2)=QX(J+2)+1.#     Shift uij 4-9 to 5-10            CL21  66
IF(QX(J+5)>3.) QX(J+5)=QX(J+5)+1.#     Shift uij 4-9 to 5-10            CL21  67
movertoc:(QX(IP+IREL(1)),1,NAME1,1,24,0)# Store subj atom name          CL21  68
movertoc:(QX(IP+IREL(4)),1,NAME2,1,24,0)# Store ref  atom name          CL21  69
I=0#                                   Reset atom count                 CL21  70
FOR(IA=MATOM;IA<LATOM;IA=IA+NATOM)#    Loop atoms                       CL21  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL21  72
I=I+1#                                 Count atoms                      CL21  73
movertoc:(na:,1,LABEL,1,24,0)#         Store atom label                 CL21  74
IF(NAME1==LABEL) QX(J+1)=FLOAT(I)#     Store atom pointer               CL21  75
IF(NAME2==LABEL) QX(J+4)=FLOAT(I)#     Store atom pointer               CL21  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL21  77
ifeq:(QX(J+8),3.) QX(J+5)=QX(J+2)#     Set parameters same for noref    CL21  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL21  79
LCONS=NEWM#                            Save end of constraints array    CL21  80
#                                                                       CL21  81
RETURN#                                                                 CL21  82
END#                                                                    CL21  83
systemheader:(CL30)#                   Enter input lines                CL30   1
######################################################################  CL30   2
#                                                                    #  CL30   3
#                              CL30                                  #  CL30   4
#                                                                    #  CL30   5
######################################################################  CL30   6
SUBROUTINE CL30#                                                        CL30   7
#                                                                       CL30   8
include:(AACOMN)#                                                       CL30   9
include:(CLCOMN)#                                                       CL30  10
#                                                                       CL30  11
INTEGER I,J,K,L#        ## General indices                              CL30  12
INTEGER IA,IA1,IA2#     ## Pointers in atom array                       CL30  13
INTEGER IC#             ## Constraint pointer                           CL30  14
INTEGER JC#             ## Character pointer                            CL30  15
INTEGER M,N#            ## String limits                                CL30  16
INTEGER NA,NP#          ## Atom and parameter counts                    CL30  17
INTEGER I1,I2#                                                          CL30  18
string:(C,1)#                                                           CL30  19
string:(LABEL,24)#                                                      CL30  20
string:(NAME1,24)#                                                      CL30  21
string:(NAME2,24)#                                                      CL30  22
string:(SFT,128)#                                                       CL30  23
#                                                                       CL30  24
chardata:(CL1, SCALE  MAXHKL RESTR  CONSTR NOREF  TWIN   CALCAT $#      CL30  25
END   )#                                                                CL30  26
chardata:(CL2,X  Y  Z  U  U11U22U33U12U13U23POPUIJ )#                   CL30  27
chardata:(CL3,SKFUOVEXTABSTWIRID)#                                      CL30  28
datastuff:#                                                             CL30  29
#                                                                       CL30  30
#    STORE SCAT FACTOR TABLE                                            CL30  31
#    -----------------------                                            CL30  32
#                                                                       CL30  33
J=1;movechar:(BLANK,1,SFT,1,128,2)#    Start scat factor info           CL30  34
FOR(I=MSCAT;I<LSCAT;I=I+NSCAT)#        Loop over scat factors           CL30  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL30  36
movertoc:(QX(I+1),1,SFT,J,8,0)#        Form scat fact table             CL30  37
J=J+8#                                 Incr scat factor pointer         CL30  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL30  39
#                                                                       CL30  40
#   LOOP OVER INPUT LINES                                               CL30  41
#   ---------------------                                               CL30  42
#                                                                       CL30  43
readline:(CL1,-NCL1)#                  Read next input line             CL30  44
REPEAT#                                Loop over input lines            CL30  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL30  46
IF(LINID==0) iquit:(CL3001)#           Quit when not recognised         CL30  47
IF(LINID>5) BREAK#                     Exit when twin,calcat or end     CL30  48
#                                                                       CL30  49
IF(LINID==1)#                          ******** scale **************    CL30  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL30  51
ifnm:(BUFIN(1)) SKF=1./BUFIN(1)**2#    Reciprocal scale factor          CL30  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL30  53
#                                                                       CL30  54
ELSE IF(LINID==2)#                     ******** maxhkl *************    CL30  55
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL30  56
DO I=1,5#                              Hmax,kmax,lmax,sintlmin,sintlm   CL30  57
ifnm:(BUFIN(I)) MAXHKL(I)=BUFIN(I)#    Set to value on line             CL30  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL30  59
#                                                                       CL30  60
ELSE IF(LINID==3)#                     ******** restr **************    CL30  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL30  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL30  63
#                                                                       CL30  64
ELSE IF(LINID==4)#                     ******** constr *************    CL30  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL30  66
#                                                                       CL30  67
##  Example: X(C3)=1.+.5*X(C1)                                          CL30  68
##           subpar(subatm)=Q+refmul*refpar(refatm)                     CL30  69
#    QX()      +2     +1   +7   +6    +5      +4                        CL30  70
#                                                                       CL30  71
IC=NEWM;JC=7;CHRIN='constr  '#         Initializations                  CL30  72
FOR(I=7;I<=CHRMAX;I=I+1)#              Scan the constr line             CL30  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL30  74
C=CHRIP(I^I)#                          Extract the character            CL30  75
IF(C==' ') NEXT#                       Skip blanks                      CL30  76
IF(C==':') BREAK#                      Exit if colon encountered        CL30  77
JC=JC+1#                               Incr output char pointer         CL30  78
IF(C=='(')#                            Test start of atom part          CL30  79
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL30  80
FOR(J=I+1;CHRIP(J^J)!=')'&J<=CHRMAX;J=J+1)# Loop over atom label        CL30  81
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CL30  82
JC=JC+1;CHRIN(JC^JC)=CHRIP(J^J)#       Transfer label char              CL30  83
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CL30  84
JC=JC+1;I=J#                           Incr output char pointer         CL30  85
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL30  86
ELSE IF(C=='-'\C=='+')#                For '-' and '+' sign character   CL30  87
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CL30  88
JC=JC+1;CHRIN(JC^JC)=C#                Transfer ' -' sign               CL30  89
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CL30  90
ELSE IF(C=='='\C=='*');#               For operator character           CL30  91
ELSE CHRIN(JC^JC)=C#                   Transfer character               CL30  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL30  93
#                                                                       CL30  94
CHRIP=CHRIN#                           Transfer stripped constr to bu   CL30  95
upcase:(CHRIP,CHRIN,CHRMAX); dcodefld:# Restore and apply decode        CL30  96
incrqx:(NEWM,IC+NCONS,CL3010)#         One more constraint packet       CL30  97
QX(IC+8)=1.0#                          Flag as constraint packet        CL30  98
#                                                                       CL30  99
ifnm:(BUFIN(1)) iquit:(CL3002)#        Not param code                   CL30 100
stringlim:(1,M,N)#                     Subject parameter                CL30 101
compchar:(CHRIN,M,CL2,1,N-M,3,NCL2,K)# Identify                         CL30 102
IF(K==0) iquit:(CL3002)#               Param not in list                CL30 103
QX(IC+2)=FLOAT(K)#                     Store parameter number           CL30 104
#                                                                       CL30 105
ifnm:(BUFIN(2)) iquit:(CL3003)#        Not atom label                   CL30 106
stringlim:(2,M,N)#                     Subject atom label               CL30 107
NAME1=CHRIP(M^N-1)#                    Store subj atom label            CL30 108
#                                                                       CL30 109
ifch:(BUFIN(3)) iquit:(CL3004)#        Not constaint constant q         CL30 110
QX(IC+7)=BUFIN(3)#                     Constraint constant q            CL30 111
#                                                                       CL30 112
ifch:(BUFIN(4)) iquit:(CL3005)#        Not de constraint multiplier     CL30 113
QX(IC+6)=BUFIN(4)#                     Constraint ref multiplier        CL30 114
#                                                                       CL30 115
ifnm:(BUFIN(5)) iquit:(CL3006)#        Not param code                   CL30 116
stringlim:(5,M,N)#                     Reference parameter              CL30 117
compchar:(CHRIN,M,CL2,1,N-M,3,NCL2,K)# Identify                         CL30 118
IF(K==0) iquit:(CL3006)#               Param not in list                CL30 119
QX(IC+5)=FLOAT(K)#                     Store parameter number           CL30 120
#                                                                       CL30 121
ifnm:(BUFIN(6)) iquit:(CL3007)#        Not atom label                   CL30 122
stringlim:(6,M,N)#                     Reference atom label             CL30 123
NAME2=CHRIP(M^N-1)#                    Store ref atom label             CL30 124
#                                                                       CL30 125
J=0;K=0;IA1=0;IA2=0#                   Set atom count                   CL30 126
FOR(IA=MATOM;IA<LATOM;IA=IA+NATOM)#    Loop atoms list                  CL30 127
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CL30 128
J=J+1#                                 Set atom count                   CL30 129
movertoc:(na:,1,LABEL,1,24,0)#         Store atom label                 CL30 130
IF(NAME1==LABEL)#                                                       CL30 131
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CL30 132
QX(IC+1)=FLOAT(J);IA1=IA;K=K+1#        Store subj atom pointer          CL30 133
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CL30 134
IF(NAME2==LABEL)#                                                       CL30 135
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CL30 136
QX(IC+4)=FLOAT(J);IA2=IA;K=K+1#        Store ref atom pointer           CL30 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CL30 138
IF(K>=2) BREAK#                        Two atoms hit                    CL30 139
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CL30 140
IF(K<2) iquit:(CL3008)#                Atom label(s) not in list        CL30 141
I1=IA1+6+NINT(QX(IC+2))#                                                CL30 142
I2=IA2+6+NINT(QX(IC+5))#                                                CL30 143
QX(I1)=QX(IC+7)+QX(IC+6)*QX(I2)#                                        CL30 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL30 145
#                                                                       CL30 146
ELSE IF(LINID==5)#                     ******** noref *************     CL30 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CL30 148
#                                                                       CL30 149
##   Examples: NOREF C C1 X(C) X(C1) (X/Z)(C1/C10) POP(Ni) :            CL30 150
#                                                                       CL30 151
stringlim:(1,N,M)#                     Get first string limits          CL30 152
FOR(NF=1;BUFIN(NF)<voidflg:;NF=NF+1)#  Loop over line fields            CL30 153
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CL30 154
JC=0;NA=0;NP=0;IC=NEWM#                Set char and param counts        CL30 155
stringlim:(NF,N,M)#                    Take first 3 chars in field      CL30 156
IF(CHRIN(N^N)==':') BREAK#             Exit if ':' encountered          CL30 157
compchar:(CHRIN,N,CL3,1,3,3,NCL3,K)#   Look for skf uov                 CL30 158
IF(K>0)#                               Found general param name         CL30 159
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CL30 160
IF(K==1) REFSKF=no:#                   Noref skf                        CL30 161
IF(K==2) REFUOV=no:#                   Noref uov                        CL30 162
IF(K==3) REFEXT=no:#                   Noref extinction                 CL30 163
IF(K==4) REFABS=no:#                   Noref absolute struct. param     CL30 164
IF(K==5) REFTWI=no:#                   Noref twinning parameters        CL30 165
IF(K==6) REFRID=no:#                   Noref riding atom parameters     CL30 166
NEXT#                                                                   CL30 167
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CL30 168
incrqx:(NEWM,IC+NCONS,CL2210)#         One more constraint packet       CL30 169
QX(IC+8)=3.#                           Signal noref                     CL30 170
FOR(I=N;I<M;I=I+1)#                    Loop chars in string             CL30 171
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CL30 172
IF(CHRIP(I^I)=='(') NEXT#              Skip leading parenthesis         CL30 173
JC=JC+1;IF(JC==1) J=I#                 Store 1st char position          CL30 174
C=CHRIP(I+1^I+1)#                      Get next character               CL30 175
IF(C!='('&C!=')'&C!='/'&C!=' ') NEXT#  Test for next delimitor          CL30 176
I=I+1#                                 Incr over the delimitor          CL30 177
compchar:(CHRIN,J,CL2,1,I-J,3,NCL2,K)# Look for param names             CL30 178
IF(K>0)#                               Test if a parameter              CL30 179
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CL30 180
NP=NP+1;IF(NP>2) iquit:(CL3009)#       Incr parameter count             CL30 181
QX(IC+NP*3-1)=FLOAT(K)#                Store parameter number x-pp      CL30 182
JC=0;NEXT#                             Skip to next string              CL30 183
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CL30 184
NA=NA+1;IF(NA>2) iquit:(CL3010)#       Count atom labels                CL30 185
NAME1=CHRIP(J^I-1)#                    Store atom label                 CL30 186
FOR(IA=MATOM;IA<LATOM;IA=IA+NATOM)#    Loop atoms                       CL30 187
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CL30 188
movertoc:(na:,1,LABEL,1,24,0)#         Store atom label                 CL30 189
IF(NAME1==LABEL) BREAK#                Exit if match found              CL30 190
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CL30 191
IF(IA<LATOM)#                          Atom label has been matched      CL30 192
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CL30 193
QX(IC+NA*3-2)=FLOAT((IA-MATOM)/NATOM+1)# Store atom number              CL30 194
JC=0;NEXT#                             Skip to next string              CL30 195
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CL30 196
label:(NAME1,K,L,SFT,N)#               Test if a scat factor            CL30 197
IF(K==L&N>0)#                          This is a scat factor only       CL30 198
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CL30 199
QX(IC+1)=FLOAT(N);QX(IC+8)=2.#         Set atom type noref              CL30 200
JC=0;NEXT#                             Skip to next string              CL30 201
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CL30 202
iquit:(CL3011,NF)#                     String not recognised            CL30 203
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CL30 204
ifeq:(QX(IC+4),0.) QX(IC+4)=QX(IC+1)#  Set same atom numbers            CL30 205
ifeq:(QX(IC+2),0.)#                    Was parameter set                CL30 206
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CL30 207
QX(IC+2)=1.;QX(IC+5)=11.#              Assume all parameters            CL30 208
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CL30 209
ELSE ifeq:(QX(IC+2),12.)#                                               CL30 210
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CL30 211
QX(IC+2)=5.;QX(IC+5)=10.#              All aniso tdp's                  CL30 212
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CL30 213
ELSE ifeq:(QX(IC+5),0.) QX(IC+5)=QX(IC+2)# Set same as subj parameter   CL30 214
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CL30 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CL30 216
readline:(CL1,-NCL1)#                  Read next input line             CL30 217
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL30 218
LCONS=NEWM#                            Save end of constraints array    CL30 219
#                                                                       CL30 220
IF(LINID==6)#                          ******** twin  **************    CL30 221
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CL30 222
MTWIN=NEWM;NTWIN=0;LTWIN=NEWM#         New twin array                   CL30 223
REPEAT#                                Loop over twin lines             CL30 224
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CL30 225
incrqx:(NEWM,LTWIN+13,CL3010)#         One more twin packet             CL30 226
DO I=1,13#                             Loop over twin data              CL30 227
ifnm:(BUFIN(I)) QX(LTWIN+I)=BUFIN(I)#  Copy data                        CL30 228
NTWIN=NTWIN+1;LTWIN=LTWIN+13#          Incr number and pntr             CL30 229
readline:(CL1,-NCL1)#                  Read next input line             CL30 230
IF(LINID<6) iquit:(CL3012)#            Wrong order of input lines       CL30 231
IF(LINID>6) BREAK#                     Quit after last twin line        CL30 232
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CL30 233
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CL30 234
LINID=LINID-6#                         Linifd for next routines         CL30 235
#                                                                       CL30 236
RETURN#                                                                 CL30 237
END#                                                                    CL30 238
systemheader:(CL31)#                   Process riding atom data         CL31   1
######################################################################  CL31   2
#                                                                    #  CL31   3
#                            CL31                                    #  CL31   4
#                                                                    #  CL31   5
######################################################################  CL31   6
SUBROUTINE CL31#                                                        CL31   7
include:(AACOMN)#                                                       CL31   8
include:(CLCOMN)#                                                       CL31   9
#                                                                       CL31  10
INTEGER CALTYP#         ## Calcat type                                  CL31  11
INTEGER IA,JA,K,L,N#    ## Indices and pointers                         CL31  12
INTEGER MARK#           ## Pointer in qx-buffer                         CL31  13
INTEGER NUM#            ## Count of output atoms                        CL31  14
INTEGER NUMIN,NUMOT#    ## Number of input/output atoms                 CL31  15
#                                                                       CL31  16
string:(CALCOD,8)#                                                      CL31  17
string:(NAME,24)#                                                       CL31  18
string:(LABEL,24)#                                                      CL31  19
chardata:(CL1, LINEAR TRIGON TETCHN TETERM SQRPLN OCTHED HEXGNL$#       CL31  20
 GENRAL METHYN TRTERM MEDIAN )#                                         CL31  21
intdata:(CALIN,[2,3,3,3,3,3,3,3,4,3,4])#                                CL31  22
intdata:(CALOT,[1,1,2,3,2,4,3,1,1,2,1])#                                CL31  23
datastuff:#                                                             CL31  24
#                                                                       CL31  25
#                                                                       CL31  26
#     PROCES RIDING ATOM DATA                                           CL31  27
#     -----------------------                                           CL31  28
#                                                                       CL31  29
MCCAT=NEWM;NCCAT=14;LCCAT=MCCAT#       Init markers                     CL31  30
IF(REFRID==no:) RETURN#                Exit if no riding atoms presen   CL31  31
K=NATOM-57#                            Number of regular items          CL31  32
NUM=0#                                 Number of output atoms           CL31  33
FOR(IA=MATOM+K;IA<LATOM;IA=IA+NATOM)#  Loop over atoms                  CL31  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL31  35
ifvo:(QX(IA+3)) NEXT#                  Skip is not a riding atom        CL31  36
movertoc:(QX(IA+1),1,CALCOD,1,8,0)#    Move calcat code                 CL31  37
upcase:(CALCOD,CALCOD,8,0)#            Make code upper case             CL31  38
compchar:(CALCOD,1,CL1,2,6,7,NCL1,CALTYP)# Identify calcat type         CL31  39
IF(CALTYP==0) iquit:(CL3101)#          Quit if not identified           CL31  40
NUM=NUM+1;IF(NUM>NUMOT) NUM=1#         Count number of output atoms     CL31  41
IF(NUM>1)#                             Not first access of this calca   CL31  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL31  43
IF(CALTYP!=NINT(QX(MARK+1)))iquit:(CL3102)# Wrong order of atoms        CL31  44
NEXT#                                  Goto next atom                   CL31  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL31  46
MARK=NEWM#                             Pointer in new calcat record     CL31  47
incrqx:(NEWM,MARK+NCCAT,CL0409)#       Get memory                       CL31  48
NUMIN=CALIN(CALTYP);NUMOT=CALOT(CALTYP)# Get atoms in and out           CL31  49
QX(MARK+1)=FLOAT(CALTYP)#              Store calcat type                CL31  50
QX(MARK+2)=QX(IA+3)#                   Store distance                   CL31  51
QX(MARK+3)=FLOAT(NUMIN)#               Store input items                CL31  52
QX(MARK+4)=FLOAT(NUMOT)#               Store output items               CL31  53
QX(MARK+13)=QX(IA+4)#                  Store alpha1                     CL31  54
QX(MARK+14)=QX(IA+5)#                  Store alpha2                     CL31  55
#                                                                       CL31  56
N=4+NUMOT;L=-1#                        Init number and pntr i/o atoms   CL31  57
DO K=1,N#                              Loop over input/output atoms     CL31  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL31  59
IF(K<=5) L=L+7#                        Point to atom name               CL31  60
ELSE     L=L+6#                        Output atom name                 CL31  61
IF(K<5&K>NUMIN) NEXT#                  No more input atoms              CL31  62
movertoc:(QX(IA+L),1,LABEL,1,24,0)#    Move atom label                  CL31  63
FOR(JA=MATOM;JA<LATOM;JA=JA+NATOM)#    Loop over atom list              CL31  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL31  65
movertoc:(na:(JA),1,NAME,1,24,0)#      Extract atom label               CL31  66
IF(LABEL==NAME) BREAK#                 Exit on match                    CL31  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL31  68
IF(JA==LATOM) iquit:(CL3103,K+2)#      Unrecognised atom label          CL31  69
QX(MARK+4+K)=FLOAT(JA)#                Store address of x coord         CL31  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL31  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL31  72
LCCAT=NEWM#                            End of calcat data               CL31  73
#                                                                       CL31  74
RETURN#                                                                 CL31  75
END#                                                                    CL31  76
systemheader:(CL32)#                   Convert constr to refine flags   CL32   1
######################################################################  CL32   2
#                                                                    #  CL32   3
#                             CL32                                   #  CL32   4
#                                                                    #  CL32   5
######################################################################  CL32   6
SUBROUTINE CL32#                                                        CL32   7
include:(AACOMN)#                                                       CL32   8
include:(CLCOMN)#                                                       CL32   9
#                                                                       CL32  10
INTEGER I,J,K,L,M,N#    ## Indices and pointers                         CL32  11
INTEGER IA,JA,JP#       ## Pointers in atom array                       CL32  12
INTEGER IC#             ## Pointer in constraint/calcat array           CL32  13
INTEGER MARK#           ## Pointer in QX-buffer                         CL32  14
INTEGER ICEN#           ##                                              CL32  15
#                                                                       CL32  16
#   DEFINE REFINEMENT FLAGS FOR GENERAL VARIABLES                       CL32  17
#   ---------------------------------------------                       CL32  18
#                                                                       CL32  19
MARK=NEWM#                             End of constraints               CL32  20
MFLAG=MARK;NFLAG=11#                   Start of matrix elements         CL32  21
incrqx:(NEWM,MARK+2*NFLAG,CL3205)#     General param packets            CL32  22
QX(MARK+1)=FLOAT(REFSKF)#              Phase scale refine flag          CL32  23
QX(MARK+2)=FLOAT(REFUOV)#              Uov refine flag                  CL32  24
QX(MARK+3)=FLOAT(REFABS)#              Flack param refine flag          CL32  25
QX(MARK+4)=FLOAT(REFEXT)#              Extinc param refine flags        CL32  26
IF(NTWIN==1) REFTWI=no:#               Do not refine twins              CL32  27
DO I=2,NTWIN#                          Loop over twin fractions         CL32  28
QX(MARK+4+I)=FLOAT(REFTWI)#            Twin farct. refine flags         CL32  29
VARGEN=REFSKF+REFUOV+REFEXT+REFABS#    Number of general variables      CL32  30
IF(REFTWI==yes:) VARGEN=VARGEN+NTWIN-1# Add twin fractions              CL32  31
MARK=NEWM#                             Incr memory pointer              CL32  32
#                                                                       CL32  33
#   DEFINE REFINEMENT FLAGS FOR ATOMIC VARIABLES                        CL32  34
#   --------------------------------------------                        CL32  35
#                                                                       CL32  36
FOR(IA=MATOM;IA<LATOM;IA=IA+NATOM)#    Loop over the atoms              CL32  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL32  38
incrqx:(NEWM,MARK+NFLAG,CL3205)#       Get atom matrix packet           CL32  39
DO I=1,11;    QX(MARK+I)=1.#           Set x,y,z refinements            CL32  40
ifne:(dp:,1.) QX(MARK+4)=0.#           If not isotropic noref u         CL32  41
ifne:(dp:,2.) DO I=5,10; QX(MARK+I)=0.# If not anisotropic noref uij    CL32  42
IF(REFPOP==no:) QX(MARK+11)=0.#        Noref pop if not refined         CL32  43
MARK=NEWM#                             Reset matrix pointer             CL32  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL32  45
LFLAG=NEWM#                            Mark the end of the matrix       CL32  46
#                                                                       CL32  47
#    APPLY CONSTRAINTS TO REFINEMENT FLAGS                              CL32  48
#    -------------------------------------                              CL32  49
#                                                                       CL32  50
FOR(IC=MCONS;IC<LCONS;IC=IC+NCONS)#    Loop over atom constraints       CL32  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL32  52
ifeq:(QX(IC+8),3.)#                    ******* noref atom **********    CL32  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL32  54
IA=NINT(QX(IC+1)); IP=NINT(QX(IC+2))#  Get subj atom and parameter      CL32  55
JA=NINT(QX(IC+4)); JP=NINT(QX(IC+5))#  Get ref atom and parameter       CL32  56
IF(IA==0) IA=1;IF(JA==0) JA=(LATOM-MATOM)/NATOM# Noref all atoms        CL32  57
DO I=IA,JA; DO J=IP,JP; QX(MFLAG+NFLAG+I*NFLAG+J)=0.# Loop noref para   CL32  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL32  59
ELSE ifeq:(QX(IC+8),2.)#               ******* noref type **********    CL32  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL32  61
IP=NINT(QX(IC+2)); JP=NINT(QX(IC+5))#  Get parameter numbers            CL32  62
I=0#                                   Reset atom count                 CL32  63
FOR(IA=MATOM;IA<LATOM;IA=IA+NATOM)#    Loop over the atoms              CL32  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL32  65
I=I+1#                                 Count atoms                      CL32  66
ifne:(sf:,QX(IC+1)) NEXT#              Skip if wrong scat factor        CL32  67
DO J=IP,JP; QX(MFLAG+NFLAG+I*11+J)=0.# Loop noref parameters            CL32  68
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL32  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL32  70
ELSE#                                  ******* constraint *********     CL32  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL32  72
IA=NINT(QX(IC+1))*11; IP=NINT(QX(IC+2))# Get subj atom and parameter    CL32  73
JA=NINT(QX(IC+4))*11; JP=NINT(QX(IC+5))# Get ref atom and parameter     CL32  74
ifeq:(QX(MFLAG+NFLAG+JA+JP),1.)#                                        CL32  75
QX(MFLAG+NFLAG+IA+IP)=FLOAT(IC)#       Addr of constraint pkt           CL32  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL32  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL32  78
#                                                                       CL32  79
#    ADD CALCAT INFORMATION TO REFINEMENT FLAGS                         CL32  80
#    ------------------------------------------                         CL32  81
#                                                                       CL32  82
IF(REFRID==yes:)#                      If riding atoms                  CL32  83
FOR(IC=MCCAT;IC<LCCAT;IC=IC+NCCAT)#    Loop over calcat records         CL32  84
DO I=1,4#                              Loop over output atoms           CL32  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL32  86
ifeq:(QX(IC+8+I),0.) BREAK#            Exit after last output atom      CL32  87
IA=NINT(QX(IC+8+I))#                   Point to atom                    CL32  88
IA=(IA-MATOM)/NATOM+1#                 Atom number                      CL32  89
DO J=1,NFLAG;QX(MFLAG+NFLAG+IA*NFLAG+J)=0.# Make zero                   CL32  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL32  91
#                                                                       CL32  92
#    STORE CONSTR VECTORS                                               CL32  93
#    --------------------                                               CL32  94
#                                                                       CL32  95
M=0;N=0#                               Variable count                   CL32  96
DO J=MFLAG+1,LFLAG#                    Loop over refinement flags       CL32  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL32  98
IF(QX(J)<1.) NEXT#                     Skip if not refined              CL32  99
IF(QX(J)<CC)#                          Not constrained                  CL32 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CL32 101
N=N+1; QX(J)=FLOAT(N)#                 Count active variables           CL32 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CL32 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL32 104
DO J=MFLAG+1,LFLAG#                    Loop over refinement flags       CL32 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CL32 106
IF(QX(J)<1.) NEXT#                     Skip if not refined              CL32 107
IF(QX(J)>CC)#                          Constrained                      CL32 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CL32 109
I=NINT(QX(J))#                         Get address of constraint pack   CL32 110
K=NINT(QX(I+4)); L=NINT(QX(I+5))#      Atom and param numbers           CL32 111
QX(I+3)=QX(MFLAG+(K+1)*NFLAG+L)#       Store vector number in word 3    CL32 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CL32 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CL32 114
#                                                                       CL32 115
#    SETUP DERIVATIVE MATRIX REQUIREMENTS                               CL32 116
#    ------------------------------------                               CL32 117
#                                                                       CL32 118
M=M+N#                                 Total number of variables        CL32 119
VARTOT=M#                              Total nr variables               CL32 120
ICEN=NINT(QX(MSYMM+2));  NF=1#         Number of sf components          CL32 121
IF(ICEN==1\APPDSP==yes:) NF=2#         Real and imag components         CL32 122
IF(APPABS==yes:)         NF=2*NF#      For friedel reflection           CL32 123
MDMATX=NEWM;   LDMATX=MDMATX+M*(M+1)/2# Set deriv matrix marker         CL32 124
MDVECT=LDMATX; LDVECT=MDVECT+M#        Set deriv vector marker          CL32 125
MDTEMP=LDVECT; NDTEMP=VARTOT*NF*NTWIN# Scratch area                     CL32 126
LDTEMP=MDTEMP+2*NDTEMP#                End of scratch area              CL32 127
incrqx:(NEWM,LDTEMP,CL3201)#           Get matrices and scratch area    CL32 128
#                                                                       CL32 129
RETURN#                                                                 CL32 130
END#                                                                    CL32 131
systemheader:(CL40)#                   Print parameter summary          CL40   1
######################################################################  CL40   2
#                                                                    #  CL40   3
#                               CL40                                 #  CL40   4
#                                                                    #  CL40   5
######################################################################  CL40   6
SUBROUTINE CL40#                                                        CL40   7
include:(AACOMN)#                                                       CL40   8
include:(CLCOMN)#                                                       CL40   9
#                                                                       CL40  10
INTEGER EXTTYP#         ## Extinction type                              CL40  11
INTEGER I,IA,IS#        ## General indices                              CL40  12
#                                                                       CL40  13
chardata:(CL1,' Initial Parameters: -')#                                CL40  14
chardata:(CL2,' Scale factor                              ')#           CL40  15
chardata:(CL3,' U overall                                 ')#           CL40  16
chardata:(CL4,' Flack parameter                           ')#           CL40  17
chardata:(CL5,' Extinction parameter                      ')#           CL40  18
chardata:(CL6,' Twin parameters ')#                                     CL40  19
realdata:(FMTA,[300742.,400742.,500742.,600742.,700742.,800742.,$#      CL40  20
900742.,1000742.])#                                                     CL40  21
datastuff:#                                                             CL40  22
#                                                                       CL40  23
#   PRINT START PARAMETERS                                              CL40  24
#   ----------------------                                              CL40  25
#                                                                       CL40  26
LINRM=8#                               Force necessary space            CL40  27
movechar:(CL1,NCL1,CHROT,2,NCL1-1,1)#  Insert underline header          CL40  28
writeline:(1,CL1,NCL1-1,2,3)#          Initial header                   CL40  29
#                                                                       CL40  30
ncodefld:(SQRT(1./SKF),1,CL2,FMTA,1)#  ******** scale *************     CL40  31
IF(REFSKF==yes:) CL2(31^31)=' '#       Flag as ref                      CL40  32
ELSE             CL2(31^31)='n'#       Flag as noref                    CL40  33
writeline:(0,CL2,NCL2,3,3)#            Print scale                      CL40  34
#                                                                       CL40  35
IF(APPUOV==yes:)#                      If uov to be applied             CL40  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL40  37
ncodefld:(UOV,1,CL3,FMTA,1)#           ******** uov *******             CL40  38
IF(REFUOV==yes:) CL3(31^31)=' '#       Flag as ref                      CL40  39
ELSE             CL3(31^31)='n'#       Flag as noref                    CL40  40
writeline:(0,CL3,NCL3,3,3)#            Print uov                        CL40  41
UOV=UOV*utob:#                         Convert to biso                  CL40  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL40  43
#                                                                       CL40  44
IF(APPABS==yes:)#                      If xabs to be applied            CL40  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL40  46
ncodefld:(XABS,1,CL4,FMTA,1)#          ******** xabs *******            CL40  47
IF(REFABS==yes:) CL4(31^31)=' '#       Flag as ref                      CL40  48
ELSE             CL4(31^31)='n'#       Flag as noref                    CL40  49
writeline:(0,CL4,NCL4,3,3)#            Print xabs                       CL40  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL40  51
#                                                                       CL40  52
IF(APPEXT==yes:)#                      If extinction to be applied      CL40  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL40  54
EXTTYP=NINT(ABS(QX(MEXTI+EXTTYP)))#    Extinction type                  CL40  55
ncodefld:(QX(MEXTI+3),1,CL5,FMTA,1)#   ******** exti *******            CL40  56
IF(REFEXT==yes:) CL5(31^31)=' '#       Flag as ref                      CL40  57
ELSE             CL5(31^31)='n'#       Flag as noref                    CL40  58
writeline:(0,CL5,NCL5,3,3)#            Print extinction params          CL40  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL40  60
#                                                                       CL40  61
IF(NTWIN>1)#                           If twin fractions to be applie   CL40  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL40  63
movechar:(CL6,1,CHROT,1,NCL6,0)#       Move line ident                  CL40  64
DO I=1,NTWIN;BUFOT(I)=QX(MTWIN-3+13*I)# Twin fractions                  CL40  65
ncodefld:(BUFOT,1,CHROT,FMTA,NTWIN)#   ******** twins *******           CL40  66
writeline:(0,0,0,1,3)#                 Print twin fractions             CL40  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL40  68
#                                                                       CL40  69
writeline:(0,0,0,1,3)#                 Blank line                       CL40  70
PRVOID=0; LINRM=8; IS=MFLAG+NFLAG#     ********* atom ***********       CL40  71
FOR(IA=MATOM;IA<LATOM;IA=IA+NATOM)#    Loop over the atoms              CL40  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL40  73
IS=IS+NFLAG#                           Incr noref array pointer         CL40  74
CALL CL41(IA,IS)#                      Print op line                    CL40  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL40  76
#                                                                       CL40  77
RETURN#                                                                 CL40  78
END#                                                                    CL40  79
systemheader:(CL41)#                   Print line                       CL41   1
######################################################################  CL41   2
#                                                                    #  CL41   3
#                               CL41                                 #  CL41   4
#                                                                    #  CL41   5
######################################################################  CL41   6
SUBROUTINE CL41(IA,IS)#                                                 CL41   7
include:(AACOMN)#                                                       CL41   8
include:(CLCOMN)#                                                       CL41   9
#                                                                       CL41  10
INTEGER I,J#            ## Loop index, pointer                          CL41  11
INTEGER IA,IS#          ## Pointers in atom and constraints array       CL41  12
#                                                                       CL41  13
chardata:(CL1, ATOM      X/A     Y/B     Z/C     U       $#             CL41  14
U11     U22     U33     U12     U13     U23     POP )#                  CL41  15
realdata:(FMTA,[140742.,220742.,300742.,380742.,460742.,540742.,#       CL41  16
620742.,700742.,780742.,860742.,940742.])#                              CL41  17
datastuff:#                                                             CL41  18
#                                                                       CL41  19
ifvo:(xf:) RETURN#                     Dummy atom                       CL41  20
movertoc:(na:,1,CHROT,2,8,0)#          Insert atom name                 CL41  21
ncodefld:(xf:,1,CHROT,FMTA,11)#        Format atom parameters           CL41  22
ifeq:(dp:,1.) ub:=ub:*utob:#           Convert u to b values            CL41  23
ifeq:(dp:,2)#                          If aniso tdp                     CL41  24
DO I=1,6;ub:(IA+I)=ub:(IA+I)/CONV(I)#  Convert uij to betaij            CL41  25
J=7#                                   Flag pointer                     CL41  26
DO I=1,11#                             Loop parameters x to pop         CL41  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL41  28
J=J+8#                                 Incr flag pointer                CL41  29
ifvo:(xf:(IA+I-1)) NEXT#               Skip void parameters             CL41  30
ifeq:(QX(IS+I),0.)   CHROT(J^J)='n'#   Flag as noref                    CL41  31
ELSE IF(QX(IS+I)>CC) CHROT(J^J)='c'#   Active parameter & constr        CL41  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL41  33
writeline:(0,CL1,NCL1,1,3)#            Print atom line                  CL41  34
#                                                                       CL41  35
RETURN#                                                                 CL41  36
END#                                                                    CL41  37
systemheader:(CL42)#                   Generate riding atom parameter   CL42   1
######################################################################  CL42   2
#                                                                    #  CL42   3
#                               CL42                                 #  CL42   4
#                                                                    #  CL42   5
######################################################################  CL42   6
SUBROUTINE CL42#                                                        CL42   7
#                                                                       CL42   8
include:(AACOMN)#                                                       CL42   9
include:(CLCOMN)#                                                       CL42  10
#                                                                       CL42  11
REAL    ALPHA1,ALPHA2#  ## Rotation angle                               CL42  12
INTEGER CALTYP#         ## Calcat type                                  CL42  13
REAL    CA1,CA2,SA1,SA2## Cos and sin rotation angle                    CL42  14
REAL    DMAT#           ## Matrix value                                 CL42  15
REAL    DP#             ## Scalar product value                         CL42  16
INTEGER I,J#            ## Loop indices                                 CL42  17
INTEGER IA,I1,I2,I3,I4# ## Pointers to input atoms                      CL42  18
INTEGER IC,IS#          ## Pointers in mccat and mflag                  CL42  19
INTEGER J1,J2,J3,J4,J5,J6#             Pointers to output atoms     ^   CL42  20
INTEGER M1,M2,M3,M4,M5,M6,M7#          Pointers to scratch vectors      CL42  21
REAL    UEQ#            ## Equivalent displacement parameter            CL42  22
chardata:(CL1,' Generated riding atom parameters')#                     CL42  23
realdata:(DTOR,.017453)#                                                CL42  24
realdata:(TETFAC,.70717)#                                               CL42  25
datastuff:#                                                             CL42  26
#                                                                       CL42  27
#   CALCULATE PARAMETERS OF RIDING ATOMS                                CL42  28
#   ------------------------------------                                CL42  29
#                                                                       CL42  30
M1=NEWM;    M2=M1+NATOM#               Dummy atom pointers              CL42  31
M3=M2+NATOM;M4=M3+NATOM#               Dummy atom pointers              CL42  32
M5=M4+NATOM;M6=M5+NATOM#               Dummy atom pointers              CL42  33
incrqx:(M7,M1+7*NATOM,CL4209)#         Get memory for dummy atoms       CL42  34
movereal:(0.,1,QX,M1+1,7*NATOM,2)#     Set to zero                      CL42  35
LINRM=5#                               Set number of lines              CL42  36
writeline:(1,CL1,NCL1,2,3)#            Print heading                    CL42  37
#                                                                       CL42  38
FOR(IC=MCCAT;IC<LCCAT;IC=IC+NCCAT)#    Loop over calcat data            CL42  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL42  40
CALTYP=NINT(QX(IC+1))#                 Calcat type                      CL42  41
I1=NINT(QX(IC+ 5));I2=NINT(QX(IC+ 6))# Point to input atoms             CL42  42
I3=NINT(QX(IC+ 7));I4=NINT(QX(IC+ 8))# Point to input atoms             CL42  43
J1=NINT(QX(IC+ 9));J2=NINT(QX(IC+10))# Point to output atoms            CL42  44
J3=NINT(QX(IC+11));J4=NINT(QX(IC+12))# Point to output atoms            CL42  45
J5=NINT(QX(IC+13));J6=NINT(QX(IC+14))# Point to output atoms            CL42  46
IA=I2#                                 Attachment atom                  CL42  47
IF(CALTYP==1)#                         *** linear ***                   CL42  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL42  49
CALL CL43(I1,I2,J1,QX(IC+2),I2)#       Calc new coords                  CL42  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL42  51
ELSE IF(CALTYP==2)#                    *** trigonal ***                 CL42  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL42  53
CALL CL43(I2,I1,M1,1.,M4)#             Calc i1 - i2 - m1                CL42  54
CALL CL43(I3,I2,M2,1.,M4)#             Calc i3 - i2 - m2                CL42  55
CALL CL43(M1,M2,J1,QX(IC+2),I2)#       Calc i2 - j1                     CL42  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL42  57
ELSE IF(CALTYP<=4)#                    *** tetchn & teterm ***          CL42  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL42  59
IF(CALTYP==4)#                         If teterm                        CL42  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL42  61
IA=I3#                                 Attachment atom                  CL42  62
#CALL CL43(I1,I2,J3,QX(IC+2),I3)#       J3 FOR ZERO ROTATION            CL42  63
DO I=0,2;xf:(M1+I)=xf:(I2+I)-xf:(I3+I)#                                 CL42  64
DO I=0,2;xf:(M2+I)=xf:(I2+I)-xf:(I1+I)#                                 CL42  65
CALL CL44(M1,M2,M7)#                                                    CL42  66
CALL CL44(M7,M1,M6)#                                                    CL42  67
CALL CL44(M6,M7,M5)#                                                    CL42  68
DO I=0,2;xf:(M7+I)=QX(IC+2)*(2.828427*xf:(M6+I)-xf:(M5+I))/3.#          CL42  69
DO I=0,2;xf:(J3+I)=xf:(I3+I)+xf:(M7+I)#                                 CL42  70
ALPHA1=QX(IC+13)#                      Get rotation angle               CL42  71
ifne:(ALPHA1,0.0)#                     Make rotation about p2-p3        CL42  72
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL42  73
CA1=COS(ALPHA1);SA1=SIN(ALPHA1)#       Cosine/sine (rotation angle)     CL42  74
CALL CL43(I3,J3,J1,QX(IC+2),M4)#                                        CL42  75
CALL CL43(I2,I3,M1,1.0,M4)#                                             CL42  76
CALL CL45(J1,M1,DP,M4)#                                                 CL42  77
CALL CL43(I2,I3,M2,DP,I3)#                                              CL42  78
DO I=0,2;xf:(J3+I)=xf:(J3+I)-xf:(M2+I)#                                 CL42  79
CALL CL45(J3,J3,DP,M4);DP=SQRT(DP)#                                     CL42  80
CALL CL44(J1,M1,J1)#                                                    CL42  81
CALL CL43(M4,J1,J1,DP,M4)#                                              CL42  82
xf:(J3)=CA1*xf:(J3);yf:(J3)=CA1*yf:(J3);zf:(J3)=CA1*zf:(J3);#           CL42  83
xf:(J1)=SA1*xf:(J1);yf:(J1)=SA1*yf:(J1);zf:(J1)=SA1*zf:(J1);#           CL42  84
CALL CL43(J1,J3,J3,DP,M2)#                                              CL42  85
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL42  86
I1=I2;I2=I3;I3=J3#                     Conformation as in tetchn        CL42  87
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL42  88
CALL CL43(I1,I2,M1,1.,M4)#             Calc i1 - i2 - m1                CL42  89
CALL CL43(I2,I3,M3,1.,M4)#             Calc i3 - i2 - m2                CL42  90
CALL CL43(M1,M3,J1,TETFAC,M4)#         Calc m1 - m2 - j1                CL42  91
CALL CL44(M3,M1,M2)#                   Calc cross product               CL42  92
CALL CL44(M1,M3,M1)#                   Calc cross product               CL42  93
CALL CL43(J1,M2,J2,QX(IC+2),I2)#       Calc i2 - j2                     CL42  94
CALL CL43(J1,M1,J1,QX(IC+2),I2)#       Calc i2 - j1                     CL42  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL42  96
ELSE IF(CALTYP<=6)#                    *** sqrpln & octhed ***          CL42  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL42  98
IF(CALTYP==6)#                         If octhed                        CL42  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL42 100
CALL CL43(I1,I2,M1,1.,M4)#             I1 - i2 - m1                     CL42 101
CALL CL43(I3,I2,M2,1.,M4)#             I3 - i2 - m2                     CL42 102
CALL CL44(M1,M2,M3)#                   Cross product                    CL42 103
CALL CL43(M4,M3,J3,QX(IC+2),I2)#                                        CL42 104
CALL CL43(M3,M4,J4,QX(IC+2),I2)#                                        CL42 105
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL42 106
CALL CL43(I1,I2,J1,QX(IC+2),I2)#                                        CL42 107
CALL CL43(I3,I2,J2,QX(IC+2),I2)#                                        CL42 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL42 109
ELSE IF(CALTYP==7)#                    *** hexgnl ***                   CL42 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CL42 111
CALL CL43(I1,I2,M1,1.0,M4)#            I1 - i2 - m1                     CL42 112
CALL CL43(I2,I3,M2,1.0,M4)#            I3 - i2 - m2                     CL42 113
CALL CL43(M1,M2,J3,QX(IC+2),I1)#       M1 - m2 - j2                     CL42 114
CALL CL43(M1,M2,J2,2.*QX(IC+2),I2)#    M1 - m2 - j3                     CL42 115
CALL CL43(M1,M2,J1,QX(IC+2),I3)#                                        CL42 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CL42 117
ELSE IF(CALTYP==8)#                    *** genral ***                   CL42 118
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CL42 119
ALPHA1=QX(IC+13)*DTOR;ALPHA2=QX(IC+14)*DTOR#                            CL42 120
CA1=-COS(ALPHA1);SA1= SIN(ALPHA1);#                                     CL42 121
CA2= COS(ALPHA2);SA2=-SIN(ALPHA2);#                                     CL42 122
CALL CL43(I1,I2,M1,1.0,M4)#                                             CL42 123
CALL CL43(I2,I3,M2,1.0,M4)#                                             CL42 124
CALL CL44(M1,M2,M3)#                   Cross product in i3              CL42 125
CALL CL44(M2,M3,M1)#                   Cross product in i3              CL42 126
xf:(M1)=SA1*xf:(M1);yf:(M1)=SA1*yf:(M1);zf:(M1)=SA1*zf:(M1)#            CL42 127
xf:(M2)=CA1*xf:(M2);yf:(M2)=CA1*yf:(M2);zf:(M2)=CA1*zf:(M2)#            CL42 128
CALL CL43(M1,M2,M1,1.0,M4)#            Unit vector                      CL42 129
xf:(M1)=CA2*xf:(M1);yf:(M1)=CA2*yf:(M1);zf:(M1)=CA2*zf:(M1)#            CL42 130
xf:(M3)=SA2*xf:(M3);yf:(M3)=SA2*yf:(M3);zf:(M3)=SA2*zf:(M3)#            CL42 131
CALL CL43(M1,M3,J1,QX(IC+2),I2)#                                        CL42 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CL42 133
ELSE IF(CALTYP==9)#                    *** methyn ***                   CL42 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CL42 135
IA=I1#                                 Attachment atom                  CL42 136
CALL CL43(I1,I2,M1,1.0,M4)#                                             CL42 137
CALL CL43(I1,I3,M2,1.0,M4)#                                             CL42 138
CALL CL43(I1,I4,M3,1.0,M4)#                                             CL42 139
xf:(J1)=xf:(M1)+xf:(M2)+xf:(M3)#                                        CL42 140
yf:(J1)=yf:(M1)+yf:(M2)+yf:(M3)#                                        CL42 141
zf:(J1)=zf:(M1)+zf:(M2)+zf:(M3)#                                        CL42 142
CALL CL43(J1,M4,J1,QX(IC+2),I1)#                                        CL42 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CL42 144
ELSE IF(CALTYP==10)#                   *** trterm ***                   CL42 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CL42 146
IA=I3#                                 Attachment atom                  CL42 147
CALL CL43(I1,I2,J1,QX(IC+2),I3)#                                        CL42 148
CALL CL43(I1,I2,M1,1.0,M4)#                                             CL42 149
CALL CL43(I3,I2,M2,1.0,M1)#                                             CL42 150
CALL CL43(M2,M4,J2,QX(IC+2),I3)#                                        CL42 151
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CL42 152
ELSE IF(CALTYP==11)#                   *** median ***                   CL42 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CL42 154
IA=I1#                                 Attachment atom                  CL42 155
CALL CL43(I2,I1,M1,1.0,M4)#                                             CL42 156
CALL CL43(I3,I1,M2,1.0,M4)#                                             CL42 157
CALL CL43(I4,I1,M3,1.0,M4)#                                             CL42 158
xf:(M5)=yf:(M2)*zf:(M3)-yf:(M3)*zf:(M2)# Cross product                  CL42 159
yf:(M5)=zf:(M2)*xf:(M3)-zf:(M3)*xf:(M2)#                                CL42 160
zf:(M5)=xf:(M2)*yf:(M3)-xf:(M3)*yf:(M2)#                                CL42 161
xf:(M6)=yf:(M3)*zf:(M1)-yf:(M1)*zf:(M3)# Cross product                  CL42 162
yf:(M6)=zf:(M3)*xf:(M1)-zf:(M1)*xf:(M3)#                                CL42 163
zf:(M6)=xf:(M3)*yf:(M1)-xf:(M1)*yf:(M3)#                                CL42 164
xf:(M7)=yf:(M1)*zf:(M2)-yf:(M2)*zf:(M1)# Cross product                  CL42 165
yf:(M7)=zf:(M1)*xf:(M2)-zf:(M2)*xf:(M1)#                                CL42 166
zf:(M7)=xf:(M1)*yf:(M2)-xf:(M2)*yf:(M1)#                                CL42 167
DMAT=xf:(M1)*xf:(M5)+xf:(M2)*xf:(M6)+xf:(M3)*xf:(M7)#                   CL42 168
xf:(M1)=(xf:(M5)+xf:(M6)+xf:(M7))/DMAT#                                 CL42 169
yf:(M1)=(yf:(M5)+yf:(M6)+yf:(M7))/DMAT#                                 CL42 170
zf:(M1)=(zf:(M5)+zf:(M6)+zf:(M7))/DMAT#                                 CL42 171
xf:(M2)=xf:(M1)*G(1)+yf:(M1)*G(2)+zf:(M1)*G(3)#                         CL42 172
yf:(M2)=xf:(M1)*G(4)+yf:(M1)*G(5)+zf:(M1)*G(6)#                         CL42 173
zf:(M2)=xf:(M1)*G(7)+yf:(M1)*G(8)+zf:(M1)*G(9)#                         CL42 174
CALL CL43(M4,M2,J1,QX(IC+2),I1)#                                        CL42 175
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CL42 176
#                                                                       CL42 177
#    CALCULATE UB: & PRINT                                              CL42 178
#    ---------------------                                              CL42 179
#                                                                       CL42 180
ifeq:(dp:,0) UEQ=UOV/utob:#            Set equal to uov                 CL42 181
ELSE ifeq:(dp:,1.) UEQ=ub:/utob:#      Set equal to uiso                CL42 182
ELSE CALL CL02(IA+10,UEQ)#             Set equal to ueq                 CL42 183
IF(CALTYP!=4) UEQ=1.25*UEQ#            Mult.factor is 1.25              CL42 184
ELSE          UEQ=1.50*UEQ#            Mult.factor is 1.5               CL42 185
DO I=1,NINT(QX(IC+4))#                 Loop over output atoms           CL42 186
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CL42 187
IA=NINT(QX(IC+8+I));ub:=UEQ#           Point to atom;set u              CL42 188
J=(IA-MATOM)/NATOM+1;IS=MFLAG+(J+1)*NFLAG# Point to constraint          CL42 189
CALL CL41(IA,IS)#                      Print atom line                  CL42 190
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CL42 191
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL42 192
writeline:(1,0,0,1,3)#                 Print blank line                 CL42 193
#                                                                       CL42 194
RETURN#                                                                 CL42 195
END#                                                                    CL42 196
systemheader:(CL43)#                   Locate linear atom               CL43   1
######################################################################  CL43   2
#                                                                    #  CL43   3
#                               CL43                                 #  CL43   4
#                                                                    #  CL43   5
######################################################################  CL43   6
SUBROUTINE CL43(IA,IB,IC,D,IE)#                                         CL43   7
#                                                                       CL43   8
include:(AACOMN)#                                                       CL43   9
include:(CLCOMN)#                                                       CL43  10
#                                                                       CL43  11
REAL D#                                Distance of attachment           CL43  12
REAL DP#                               Distance between a and b         CL43  13
REAL DELX,DELY,DELZ#                   Diff in x,y,z coords             CL43  14
INTEGER IA,IB#                         Pointer to generator atoms       CL43  15
INTEGER IC#                            Pointer to generated atom        CL43  16
INTEGER IE#                            Pointer to attachment atom       CL43  17
#                                                                       CL43  18
DELX=xf:(IB)-xf:(IA)#                  Delta x                          CL43  19
DELY=yf:(IB)-yf:(IA)#                  Delta y                          CL43  20
DELZ=zf:(IB)-zf:(IA)#                  Delta z                          CL43  21
DP=T(1)*DELX**2+T(5)*DELY**2+T(9)*DELZ**2+$#                            CL43  22
T(2)*DELX*DELY+T(3)*DELX*DELZ+T(6)*DELY*DELZ# Distance squared          CL43  23
IF(DP>=small:) DP=SQRT(DP)#            Distance between a and b         CL43  24
ELSE IF(DP<0.0) iquit:(CL4301)#        -ve sqrt check input             CL43  25
ELSE            iquit:(CL4302)#        Generating atoms too close       CL43  26
xf:(IC)=DELX*D/DP+xf:(IE)#             X coord of generated atom        CL43  27
yf:(IC)=DELY*D/DP+yf:(IE)#             Y coord of generated atom        CL43  28
zf:(IC)=DELZ*D/DP+zf:(IE)#             Z coord of generated atom        CL43  29
#                                                                       CL43  30
RETURN#                                                                 CL43  31
END#                                                                    CL43  32
systemheader:(CL44)#                   Get cross product a * b = c      CL44   1
######################################################################  CL44   2
#                                                                    #  CL44   3
#                               CL44                                 #  CL44   4
#                                                                    #  CL44   5
######################################################################  CL44   6
SUBROUTINE CL44(IA,IB,IC)#                                              CL44   7
#                                                                       CL44   8
include:(AACOMN)#                                                       CL44   9
include:(CLCOMN)#                                                       CL44  10
#                                                                       CL44  11
INTEGER IA,IB#         ## Pointer to generator atoms                    CL44  12
INTEGER IC#            ## Pointer to generated atom                     CL44  13
REAL C(3),V(3)#        ## Cross product vector                          CL44  14
REAL DP#               ## Distance between a and b                      CL44  15
INTEGER N#                                                              CL44  16
#                                                                       CL44  17
C(1)=yf:(IA)*zf:(IB)-yf:(IB)*zf:(IA)#  Cross product                    CL44  18
C(2)=zf:(IA)*xf:(IB)-zf:(IB)*xf:(IA)#                                   CL44  19
C(3)=xf:(IA)*yf:(IB)-xf:(IB)*yf:(IA)#                                   CL44  20
DO N=1,3;V(N)=C(1)*G(N)+C(2)*G(N+3)+C(3)*G(N+6)# Inv. m.tensor          CL44  21
#                                                                       CL44  22
DP=T(1)*V(1)**2+T(5)*V(2)**2+T(9)*V(3)**2+$#                            CL44  23
T(2)*V(1)*V(2)+T(3)*V(1)*V(3)+T(6)*V(2)*V(3)# Dist sqr                  CL44  24
IF(DP>=.0001*small:)   DP=SQRT(DP)#    Dist                             CL44  25
ELSE IF(DP<0.0) iquit:(CL4401)#        -ve sqrt check input             CL44  26
ELSE            iquit:(CL4402)#        Generating atoms too close       CL44  27
xf:(IC)=V(1)/DP#                       X coord of cross vector          CL44  28
yf:(IC)=V(2)/DP#                       Y coord of cross vector          CL44  29
zf:(IC)=V(3)/DP#                       Z coord of cross vector          CL44  30
#                                                                       CL44  31
RETURN#                                                                 CL44  32
END#                                                                    CL44  33
systemheader:(CL45)#                   Scalar product (a-e) and (b-e)   CL45   1
######################################################################  CL45   2
#                                                                    #  CL45   3
#                               CL45                                 #  CL45   4
#                                                                    #  CL45   5
######################################################################  CL45   6
SUBROUTINE CL45(IA,IB,D,IE)#                                            CL45   7
#                                                                       CL45   8
include:(AACOMN)#                                                       CL45   9
include:(CLCOMN)#                                                       CL45  10
#                                                                       CL45  11
INTEGER IA,IB,IE#       ## Pointer to generator atoms                   CL45  12
REAL    D#              ## Distance of attachment                       CL45  13
REAL    DELX1,DELY1,DELZ1,DELX2,DELY2,DELZ2# Vector coords              CL45  14
#                                                                       CL45  15
DELX1=xf:(IA)-xf:(IE);DELY1=yf:(IA)-yf:(IE);DELZ1=zf:(IA)-zf:(IE)#      CL45  16
DELX2=xf:(IB)-xf:(IE);DELY2=yf:(IB)-yf:(IE);DELZ2=zf:(IB)-zf:(IE)#      CL45  17
#                                                                       CL45  18
D=T(1)*DELX1*DELX2+T(5)*DELY1*DELY2+T(9)*DELZ1*DELZ2+$#                 CL45  19
0.5*T(2)*(DELX1*DELY2+DELX2*DELY1)+$#                                   CL45  20
0.5*T(3)*(DELX1*DELZ2+DELX2*DELZ1)+$#                                   CL45  21
0.5*T(6)*(DELY1*DELZ2+DELY2*DELZ1)#    Distance                         CL45  22
#                                                                       CL45  23
RETURN#                                                                 CL45  24
END#                                                                    CL45  25
systemheader:(CL46)#                   Convert to tetrahedral angles    CL46   1
######################################################################  CL46   2
#                                                                       CL46   3
#                                CL46                                   CL46   4
#                                                                       CL46   5
######################################################################  CL46   6
SUBROUTINE CL46(IA,IB,IC)#                                              CL46   7
include:(AACOMN)#                                                       CL46   8
include:(CLCOMN)#                                                       CL46   9
#                                                                       CL46  10
# THIS SUBROUTINE TRANSFORMS AN ANGLE P2 - P1 - P3 WITH AN ARBITRARY    CL46  11
# VALUE TO N TETRAHEDRAL ANGLE AND STORES IT IN VECTOR C.               CL46  12
# R.OLTHOF 1999                                                         CL46  13
#                                                                       CL46  14
INTEGER I,J#            ## Index                                        CL46  15
INTEGER IA,IB,IC#       ## Pointers to generating and generated atoms   CL46  16
REAL A(3),B(3),C(3)#    ## Cartesian coords                             CL46  17
REAL COSN1#             ## Cos of initial P2-P1-P3                      CL46  18
REAL DP#                ## Distance between a and b                     CL46  19
REAL D(3)#              ## Diff in x,y, and z coords                    CL46  20
REAL X11,Y11,Z11#       ## Direction cos                                CL46  21
REAL U,V,W#             ## Squared bonds                                CL46  22
realdata:(TANN2,.35353)#                                                CL46  23
datastuff:#                                                             CL46  24
#                                                                       CL46  25
#                                                                       CL46  26
# CONVERT TO CARTESIAN COORDINATES                                      CL46  27
#                                                                       CL46  28
DO I=1,3#                              Loop over axes                   CL46  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL46  30
A(I)=0.;B(I)=0.;C(I)=0.#               Init sums                        CL46  31
DO J=1,3#                              Loop over axes                   CL46  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL46  33
A(I)=A(I)+CELL(15+I+3*J)*xf:(IA+J-1)#  Atom p1                          CL46  34
B(I)=B(I)+CELL(15+I+3*J)*xf:(IB+J-1)#  Atom p2                          CL46  35
C(I)=C(I)+CELL(15+I+3*J)*xf:(IC+J-1)#  Atom p3                          CL46  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL46  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL46  38
#                                                                       CL46  39
# FIND DISTANCES BETWEEN ATOMS                                          CL46  40
#                                                                       CL46  41
DO I=1,3;D(I)=A(I)-B(I)#               Delta a-b                        CL46  42
U=D(1)**2+D(2)**2+D(3)**2#             Dist**2                          CL46  43
DP=SQRT(U)#                            Dist                             CL46  44
X11=D(1)/DP;Y11=D(2)/DP;Z11=D(3)/DP#   Direction cosines                CL46  45
DO I=1,3;D(I)=C(I)-B(I)#               Delta c-b                        CL46  46
W=D(1)**2+D(2)**2+D(3)**2#             Dist**2                          CL46  47
DO I=1,3;D(I)=C(I)-A(I)#               Delta c-a                        CL46  48
V=D(1)**2+D(2)**2+D(3)**2#             Dist**2                          CL46  49
COSN1=(W-U-V)/(-2.*SQRT(U*V))#         Cos initial angle                CL46  50
#                                                                       CL46  51
# CALCULATE PROJECTION ON NORMAL PLANE                                  CL46  52
#                                                                       CL46  53
V=SQRT(V)#                             A-c bondlength                   CL46  54
D(1)=D(1)+X11*COSN1*V#                 X-projection                     CL46  55
D(2)=D(2)+Y11*COSN1*V#                 Y-projection                     CL46  56
D(3)=D(3)+Z11*COSN1*V#                 Z-projection                     CL46  57
DP=SQRT(D(1)**2+D(2)**2+D(3)**2)#                                       CL46  58
#                                                                       CL46  59
# CALCULATE TETRAHEDRAL CONFIGURATION                                   CL46  60
#                                                                       CL46  61
D(1)=D(1)+X11*TANN2*DP#                Tetrahdral x-coord               CL46  62
D(2)=D(2)+Y11*TANN2*DP#                Tetrahdral y-coord               CL46  63
D(3)=D(3)+Z11*TANN2*DP#                Tetrahdral z-coord               CL46  64
DP=SQRT(D(1)**2+D(2)**2+D(3)**2)#                                       CL46  65
#                                                                       CL46  66
# SCALE THE VECTOR D TO DISTANCE V AND ADD TO COORDS OF                 CL46  67
# POINT A TO GIVE COORDS OF THE GENERATED ATOM.                         CL46  68
# TRANSFORM TO FRACTIONAL COORDINATES                                   CL46  69
#                                                                       CL46  70
C(1)= D(1)*V/DP + A(1)#                X                                CL46  71
C(2)= D(2)*V/DP + A(2)#                Y                                CL46  72
C(3)= D(3)*V/DP + A(3)#                Z                                CL46  73
#                                                                       CL46  74
DO I=1,3#                              Loop over axes                   CL46  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL46  76
U=0.#                                  Initialize sum                   CL46  77
DO J=1,3;U=U+CELL(24+3*I+J)*C(J)#      Calculate sum                    CL46  78
xf:(IC+I-1)=U#                         X,y,z coords                     CL46  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL46  80
#                                                                       CL46  81
RETURN#                                                                 CL46  82
END#                                                                    CL46  83
systemheader:(CL48)#                   Update bdf & punch atom params   CL48   1
######################################################################  CL48   2
#                                                                    #  CL48   3
#                               CL48                                 #  CL48   4
#                                                                    #  CL48   5
######################################################################  CL48   6
SUBROUTINE CL48#                                                        CL48   7
include:(AACOMN)#                                                       CL48   8
include:(CLCOMN)#                                                       CL48   9
#                                                                       CL48  10
string:(OUTL,80)#                                                       CL48  11
INTEGER I,J,K#          ## General index                                CL48  12
INTEGER IA#             ## Atom index                                   CL48  13
INTEGER IC#             ## Refinementflag pointer                       CL48  14
INTEGER IPP#            ## Bdf pointer                                  CL48  15
#                                                                       CL48  16
chardata:(CL1, ATOM SUIJ LINK)#                                         CL48  17
realdata:(FMTA,[220742.,300742.,380742.,460742.,540742.,#               CL48  18
620742.,700742.,780742.,860742.,940742.,1020732.])#                     CL48  19
datastuff:#                                                             CL48  20
#                                                                       CL48  21
#                                                                       CL48  22
#    UPDATE BINARY DATA FILE                                            CL48  23
#    -----------------------                                            CL48  24
#                                                                       CL48  25
CALL CL01(lratom:)#                    Index packet                     CL48  26
IC=MFLAG+NFLAG#                        Set constraints pointer          CL48  27
FOR(IA=MATOM;IA<LATOM;IA=IA+NATOM)#    Loop over the atoms              CL48  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL48  29
readwpkt:(1,lratom:,PACK,IP,0)#        Read an atom packet              CL48  30
writepkt:(2,lratom:,KEY(4),IPP)#       Initialize op packet             CL48  31
movereal:(QX,IP+1,QX,IPP+1,PACK,0)#    Copy all data                    CL48  32
ifeq:(dp:,2.) CALL CL02(IA+10,QX(IA+10))# Calculate ueq                 CL48  33
IC=IC+NFLAG#                           Point to next constr             CL48  34
DO J=1,11#                                                              CL48  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL48  36
ifeq:(IREL(6+J),0.) NEXT#              Param not on bdf                 CL48  37
QX(IPP+IREL(6+J))=xf:(IA+J-1)#         Store new param                  CL48  38
ifne:(QX(IC+J),0.) QX(IPP+IREL(17+J))=xf:(IA+J+10)# Store new stdev     CL48  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL48  40
ifeq:(dp:,1.)#                         If iso disp par                  CL48  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL48  42
QX(IPP+IREL(10))=QX(IPP+IREL(10))/utob:# Convert to uiso                CL48  43
QX(IPP+IREL(21))=QX(IPP+IREL(21))/utob:# Convert to sigma(uiso)         CL48  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL48  45
ifeq:(dp:,2.)#                         If aniso disp par                CL48  46
DO J=1,6#                                                               CL48  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL48  48
QX(IPP+IREL(10+J))=QX(IPP+IREL(10+J))*CONV(J)# Convert to uij           CL48  49
QX(IPP+IREL(21+J))=QX(IPP+IREL(21+J))*CONV(J)# Convert to sigma(uij)    CL48  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL48  51
#                                                                       CL48  52
#    PUNCH NEW PARAMETERS                                               CL48  53
#    --------------------                                               CL48  54
#                                                                       CL48  55
IF(PUNCH==yes:)#                       Punch if requested               CL48  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL48  57
movechar:(CL1,1,OUTL,1,80,2)#          Blankout punch buffer            CL48  58
movechar:(CL1,2,OUTL,1,4,0)#           Insert 'atom' string             CL48  59
movertoc:(na:,1,OUTL,6,8,0)#           Insert atom name                 CL48  60
ncodefld:(QX(IPP+IREL( 7)),1,OUTL,FMTA(1),3)# Format atom coords        CL48  61
ncodefld:(QX(IPP+IREL(10)),1,OUTL,FMTA(4),1)# Format uiso               CL48  62
ncodefld:(QX(IPP+IREL(17)),1,OUTL,FMTA(5),1)# Format pop                CL48  63
ncodefld:(QX(IPP+IREL(18)),1,OUTL,FMTA(6),3)# Format stdev. coords      CL48  64
ncodefld:(QX(IPP+IREL(21)),1,OUTL,FMTA(9),1)# Sigma uiso                CL48  65
ncodefld:(QX(IPP+IREL(28)),1,OUTL,FMTA(10),1)# Sigma pop                CL48  66
writepch:(OUTL,80)#                    Punch atom line                  CL48  67
IF(dp:>1.5)#                           For aniso only                   CL48  68
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL48  69
movechar:(CL1,1,OUTL,1,80,2)#          Blankout punch buffer            CL48  70
movechar:(CL1,8,OUTL,1,3,0)#           Insert 'uij' string              CL48  71
movertoc:(na:,1,OUTL,6,8,0)#           Insert atom name                 CL48  72
ncodefld:(QX(IPP+IREL(11)),1,OUTL,FMTA,6)# Format uij                   CL48  73
writepch:(OUTL,80)#                    Punch 'uij'-card                 CL48  74
movechar:(CL1,1,OUTL,1,80,2)#          Blankout punch buffer            CL48  75
movechar:(CL1,7,OUTL,1,4,0)#           Insert 'suij' string             CL48  76
movertoc:(na:,1,OUTL,6,8,0)#           Insert atom name                 CL48  77
ncodefld:(QX(IPP+IREL(22)),1,OUTL,FMTA,6)# Format sigma(uij)            CL48  78
writepch:(OUTL,80)#                    Punch 'suij'-card                CL48  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL48  80
IF(NATOM<57) NEXT#                     No riding atom data              CL48  81
K=IA+NATOM-57#                         Point to riding atom data        CL48  82
ifvo:(QX(K+3)) NEXT#                   This is not a riding atom        CL48  83
movechar:(CL1,1,OUTL,1,80,2)#          Blankout punch buffer            CL48  84
movechar:(CL1,12,OUTL,1,4,0)#          Insert 'link' string             CL48  85
movertoc:(na:,1,OUTL,6,8,0)#           Insert atom name                 CL48  86
movertoc:(QX(K+1),1,OUTL,16,8,0)#                                       CL48  87
ncodefld:(QX(K+3),1,OUTL,FMTA(2),1)#                                    CL48  88
J=32#                                                                   CL48  89
DO I=1,8#                                                               CL48  90
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL48  91
movertoc:(QX(K+6),1,OUTL,J,8,0)#                                        CL48  92
J=J+5#                                                                  CL48  93
IF(I<5) K=K+7#                                                          CL48  94
ELSE    K=K+6#                                                          CL48  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL48  96
K=IA+NATOM-57;J=(J-32)/5#                                               CL48  97
ncodefld:(QX(K+4),1,OUTL,FMTA(J),2)#                                    CL48  98
writepch:(OUTL,80)#                    Punch 'suij'-card                CL48  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL48 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL48 101
#                                                                       CL48 102
copyfile:(1,2,incr:(lratom:),decr:(lrrefl:))# Copy bdf until lrrefl:    CL48 103
#                                                                       CL48 104
RETURN#                                                                 CL48 105
END#                                                                    CL48 106
#                                                                       CL48 107
#                                                                       CL48 108
systemheader:(CL50)#                   Process reflection data          CL50   1
######################################################################  CL50   2
#                                                                    #  CL50   3
#                               CL50                                 #  CL50   4
#                                                                    #  CL50   5
######################################################################  CL50   6
SUBROUTINE CL50#                                                        CL50   7
#                                                                       CL50   8
include:(AACOMN)#                                                       CL50   9
include:(CLCOMN)#                                                       CL50  10
#                                                                       CL50  11
INTEGER I,II,J#         ## Indices                                      CL50  12
INTEGER IDSCF#          ## Index in scattering factor array             CL50  13
REAL BUF7,BUF9,DFF#                                                     CL50  14
INTEGER MARK#                                                           CL50  15
#                                                                       CL50  16
#    SET UP FOR EACH CYCLE                                              CL50  17
#    ---------------------                                              CL50  18
#                                                                       CL50  19
LINRM=6#                               Heading control                  CL50  20
DO I=1,11;RSUMS(I)=0.#                 Clear statistics array           CL50  21
#                                                                       CL50  22
#    SET UP FOR FIRST CYCLE                                             CL50  23
#    ----------------------                                             CL50  24
#                                                                       CL50  25
IF(NCY==1)#                            If first cycle                   CL50  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL50  27
CALL CL01(lrrefl:)#                    Call index packet                CL50  28
IF(KEY(4)<0) iquit:(CL5001.)#          Item is missing from lrrefl:     CL50  29
IF(WTSCHM==2&IREL(10)<=0) iquit:(CL5002.)# No weight on bdf             CL50  30
IF(WTSCHM==3&IREL(7)<=0) iquit:(CL5003.)# No sigma on bdf               CL50  31
IF(REFABS>0&IREL(8)<=0) iquit:(CL5004.)# No friedel refl on bdf         CL50  32
HKLPAK=30+NSCF#                        Words in dir access file         CL50  33
MCALC=NEWM;NCALC=4#                    Pntrs in temp array              CL50  34
IF(APPEXT>0) CALL CL55(0,II)#          Initialize for extinction        CL50  35
opendac:(ioda1:,3,160,' ')#            Open direct access file          CL50  36
#                                                                       CL50  37
## READ/WRITE REFLECTION DATA                                           CL50  38
#                                                                       CL50  39
NREFL=0#                               Count the reflections            CL50  40
REPEAT#                                Loop over lrrefl: packets        CL50  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL50  42
readwpkt:(1,lrrefl:,PACK,IP,0)#        Point to next ip packet          CL50  43
IF(IP<=0) BREAK#                       Seek end of record               CL50  44
NREFL=NREFL+1#                         Count the reflections            CL50  45
DO I=1,HKLPAK;BUF(I)=0.#               Set buf array to zero            CL50  46
gethkl:(IP+IREL(1),BUF)#               Get hkl indices                  CL50  47
DO I=4,12#                             Loop over reflection data        CL50  48
IF(IREL(I)>0)      BUF(I)=QX(IP+IREL(I))# Get required items            CL50  49
IF(APPABS==yes:&IREL(13+NSCF)>0)#      For friedel reflections          CL50  50
BUF(5)=MIN(BUF(5),QX(IP+IREL(13+NSCF)))# Take min value for rcode       CL50  51
IF(WTSCHM==1)      BUF(10)=1.#         Weight=1                         CL50  52
ELSE IF(WTSCHM==2) BUF(10)=QX(IP+IREL(10))# Weight from bdf             CL50  53
ELSE#                                  Weight from sigma                CL50  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL50  55
BUF(10)=2.*SKF/BUF(6)#                 Default weight                   CL50  56
BUF7=BUF(7);ifeq:(BUF(7),0.) BUF7=voidflg:#                             CL50  57
BUF9=BUF(9);ifeq:(BUF(9),0.) BUF9=voidflg:#                             CL50  58
ifnv:(BUF7)      BUF(10)=SKF/BUF(7)#   Weight=1/sigma                   CL50  59
ELSE ifnv:(BUF9) BUF(10)=SKF/BUF(9)#   Use sigma of friedel refl.       CL50  60
IF(BUF(5)==2) ifeq:(BUF(7),1.) BUF(10)=2.*SKF/BUF(6)# Default for rc=   CL50  61
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL50  62
intunpak:(QX(IP+IREL(11)),I,0,5)#      Reflection multiplicity          CL50  63
BUF(11)=FLOAT(I)#                      Store multiplicity               CL50  64
IF(IREL(12)>0) BUF(12)=QX(IP+IREL(12))# Tbar for reflection             CL50  65
ELSE           BUF(12)=QX(MEXTI+17)#   Tbar overall                     CL50  66
DO I=1,NSCF#                           Loop over atom types             CL50  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL50  68
IF(IREL(12+I)>0)#                      Scat.fact on bdf                 CL50  69
BUF(30+I)=QX(IP+IREL(12+I))#           Scat.fact from bdf               CL50  70
ELSE#                                  Scat.fact not on bdf             CL50  71
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL50  72
J=MSCAT+(I-1)*NSCAT+6#                 Point to scat factor table       CL50  73
IF(RADTYP>1)#                          Store electron/xray ff           CL50  74
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL50  75
IDSCF=BUF(4)/DSCF;DFF=AMOD(BUF(4),DSCF)# 2-point interpolation          CL50  76
BUF(30+I)=QX(J+IDSCF)+DFF/DSCF*(QX(J+IDSCF+1)-QX(J+IDSCF))# Ff          CL50  77
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL50  78
ELSE BUF(30+I)=QX(J+1)#                Store neutron ff                 CL50  79
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL50  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL50  81
IF(APPEXT==yes:) CALL CL55(1,II)#      Init for extinction              CL50  82
BUF(29)=FLOAT(NREFL)#                  Reflection number                CL50  83
BUF(30)=0.#                            Use this reflection              CL50  84
DO I=1,3;IF(ABS(BUF(I))>MAXHKL(I)) BUF(30)=-1.# Skip this reflection    CL50  85
IF(BUF(4)<MAXHKL(4)\BUF(4)>MAXHKL(5)) BUF(30)=-1.# Skip this reflec     CL50  86
IF(NTWIN>0)#                           If twin fraction present         CL50  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL50  88
MARK=NEWM#                             Init temporary array             CL50  89
incrqx:(NEWM,MARK+NCALC,CL5002)#       Get memory                       CL50  90
movereal:(BUF,1,QX,MARK+1,3,0)#        Move h,k,l                       CL50  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL50  92
writedac:(ioda1:,,NREFL,(BUF(I),I=1,HKLPAK))# Write direct access fil   CL50  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL50  94
LCALC=NEWM#                            Last position in mcalc           CL50  95
MREFL=NREFL#                           Nr of reflections on dac         CL50  96
IF(NTWIN>1) CALL CL54#                 Initialize for twinning          CL50  97
NCALC=HKLPAK+14;LCALC=MCALC+NTWIN*NCALC# New definition for mcalc arr   CL50  98
incrqx:(NEWM,LCALC,CL5002)#            Get memory                       CL50  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL50 100
#                                                                       CL50 101
#    SET UP FOR LAST CYCLE                                              CL50 102
#    ---------------------                                              CL50 103
#                                                                       CL50 104
IF(NCY>NCYCLE)#                        If last cycle                    CL50 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL50 106
IF(NCYCLE==0)#                         If no refinement                 CL50 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CL50 108
rewindbdf:(1)#                         Rewind input bdf                 CL50 109
copybdf:(1,2,1,decr:(lrrefl:))#        Copy until lrrefl:               CL50 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CL50 111
CALL CL01(lrrefl:)#                    Call index packet                CL50 112
LISTRF=-LISTRF#                        Reset refl list number           CL50 113
NSKIP=1#                               Calculate sf for all refl        CL50 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL50 115
#                                                                       CL50 116
IREFL=0#                               Count reflections                CL50 117
DO I=MDMATX+1,LCALC;QX(I)=0.#          Zero in matrix and vector        CL50 118
writeline:(1,0,0,0,3)#                 Print blank line                 CL50 119
#                                                                       CL50 120
RETURN#                                                                 CL50 121
END#                                                                    CL50 122
systemheader:(CL51)#                   Calculate sf and deriv           CL51   1
######################################################################  CL51   2
#                                                                    #  CL51   3
#                               CL51                                 #  CL51   4
#                                                                    #  CL51   5
######################################################################  CL51   6
SUBROUTINE CL51#                                                        CL51   7
include:(AACOMN)#                                                       CL51   8
include:(CLCOMN)#                                                       CL51   9
#                                                                       CL51  10
REAL    A(4),C,P,S#     ## Structure factor components                  CL51  11
REAL    ACAL(4)#        ## Total structure factors components           CL51  12
REAL    ADIS(4)#        ## Dispersion components of sf                  CL51  13
REAL    AMUL#           ## Sf general multiplicity                      CL51  14
REAL    ANOD(4)#        ## Dispersion free sf components                CL51  15
REAL    AH,AK,AL#       ## Local h,k,l                                  CL51  16
REAL    BH,BK,BL#       ## Deriv h,k,l                                  CL51  17
REAL    DA(4)#          ## Dispersion components/derivative component   CL51  18
REAL    DELA(10)#       ## Real derivative components                   CL51  19
REAL    DELB(10)#       ## Imag derivative components                   CL51  20
REAL    DERFAC#         ## Factor for derivatives                       CL51  21
REAL    DERTMP#         ## Factor for tdp derivative                    CL51  22
REAL    EQV(500)#       ## Space for generated reflections              CL51  23
REAL    FAC#            ## Multiplication factor                        CL51  24
REAL    FAC1,FAC2#      ## Real & imag scattering components            CL51  25
REAL    FF#             ## Form factor                                  CL51  26
INTEGER I,IA,IC,IR,IS,J,JJ,M## General indices                          CL51  27
INTEGER ICALC#          ## Pointer in mcalc array                       CL51  28
INTEGER ICEN#           ## Centro flag (0=cent;1=nonc)                  CL51  29
INTEGER IREF#           ## Number of currect (twin) reflection          CL51  30
INTEGER MEQV#           ## End of parameter array                       CL51  31
REAL    STOL#           ## Sin(theta/lambda)                            CL51  32
REAL    STL2#           ## Sin(theta/lambda) squared                    CL51  33
REAL    SCOS,SSIN#      ## Cos/sin summation of fc                      CL51  34
REAL    U#              ## Anisotropic disp. calculation                CL51  35
INTEGER ITWIN#          ##                                              CL51  36
#                                                                       CL51  37
realdata:(P2,6.28318531); realdata:(PI180,0.01745329252)#               CL51  38
realdata:(YCFR,0.)#                                                     CL51  39
datastuff:#                                                             CL51  40
#                                                                       CL51  41
#    NEW REFLECTION IN ACTIVE LIST                                      CL51  42
#    -----------------------------                                      CL51  43
#                                                                       CL51  44
IREFL=IREFL+NSKIP;IREF=IREFL#          Count the next reflection        CL51  45
ICALC=MCALC#                           Set pointer in scratch array     CL51  46
DO I=MDTEMP+1,LDTEMP; QX(I)=0.#        Initialize derivative matrix     CL51  47
IS=MDTEMP+VARGEN+1#                    Point to derivative area         CL51  48
#                                                                       CL51  49
DO ITWIN=1,NTWIN#                      Loop over twin fractions         CL51  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL51  51
REPEAT#                                Find next refelection            CL51  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL51  53
IF(IREFL>NREFL) BREAK#                 End of reflection input          CL51  54
IF(IREF>MREFL) BREAK#                  End of direct access file        CL51  55
readdac:(ioda1:,,IREF,(BUF(I),I=1,HKLPAK))# Read reflection file        CL51  56
IF(NCY>NCYCLE) BUF(30)=0.#             Use all refl. in last cycle      CL51  57
IF(ITWIN==1) IREFL=IREF#               Save reflection number           CL51  58
IF(BUF(30)>-.5) BREAK#                 Accept this reflection           CL51  59
IF(ITWIN==1) IREF=IREF+1#              Incr reflection count            CL51  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL51  61
IF(BUF(30)==NCY) RETURN#               Quit if dependent twin refl.     CL51  62
AH=BUF(1); AK=BUF(2); AL=BUF(3)#       Store hkl as real variables      CL51  63
STOL=BUF(4);STL2=STOL**2#              Sin(th)/lambda                   CL51  64
AMUL=QX(MSYMM+6)#                      Sf general multiplicity          CL51  65
WEIGHT=BUF(10);DERFAC=2.*WEIGHT#       Factor for derivatives           CL51  66
DERTMP=-STL2*DERFAC#                   For tf derivatives               CL51  67
ICEN=NINT(QX(MSYMM+2))#                Centro flag (0=cent;1=nonc)      CL51  68
IC=MFLAG+NFLAG#                        Point to constraints list        CL51  69
DO J=1,NF;ANOD(J)=0.#                  Zero real fc components          CL51  70
DO J=1,NF;ADIS(J)=0.#                  Zero dispersion components       CL51  71
DO J=1,NF;DA(J)  =0.#                  Zero derivative components       CL51  72
#                                                                       CL51  73
#    GENERATE HKL EQUIVALENTS                                           CL51  74
#    ------------------------                                           CL51  75
#                                                                       CL51  76
J=-10#                                 Set pointer                      CL51  77
FOR(I=MSYMM+NSYMM;I<LSYMM;I=I+NSYMM)#  Loop over symm matrices          CL51  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL51  79
J=J+10#                                Incr parameter array             CL51  80
BH=AH*QX(I+1)+AK*QX(I+2)+AL*QX(I+3)#   Equivalent h                     CL51  81
BK=AH*QX(I+4)+AK*QX(I+5)+AL*QX(I+6)#   Equivalent k                     CL51  82
BL=AH*QX(I+7)+AK*QX(I+8)+AL*QX(I+9)#   Equivalent l                     CL51  83
EQV(J+1)=P2*BH#                        Store h*2pi                      CL51  84
EQV(J+2)=P2*BK#                        Store k*2pi                      CL51  85
EQV(J+3)=P2*BL#                        Store l*2pi                      CL51  86
EQV(J+4)=P2*(AH*QX(I+10)+AK*QX(I+11)+AL*QX(I+12))# Phase shift          CL51  87
EQV(J+5)= BH*BH#                       Store new h**2                   CL51  88
EQV(J+6)= BK*BK#                       Store new k**2                   CL51  89
EQV(J+7)= BL*BL#                       Store new l**2                   CL51  90
EQV(J+8)= BH*BK*2.#                    Store new h*k*2                  CL51  91
EQV(J+9)= BH*BL*2.#                    Store new h*l*2                  CL51  92
EQV(J+10)=BK*BL*2.#                    Store new k*l*2                  CL51  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL51  94
MEQV=J#                                Save last equiv hkl pointer      CL51  95
#                                                                       CL51  96
#    LOOP OVER ALL ATOMS                                                CL51  97
#    -------------------                                                CL51  98
#                                                                       CL51  99
FOR(IA=MATOM;IA<LATOM;IA=IA+NATOM)#    Loop over atoms list             CL51 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL51 101
SCOS=0.;SSIN=0.#                       Zero fc components               CL51 102
DO I=1,10;DELA(I)=0.#                  Zero real deriv sums             CL51 103
DO I=1,10;DELB(I)=0.#                  Zero imag deriv sums             CL51 104
IC=IC+NFLAG#                           Point to constraint list         CL51 105
#                                                                       CL51 106
## EQUIVALENT INDICES                                                   CL51 107
#                                                                       CL51 108
DO J=0,MEQV,10#                        Loop over equivalent indices     CL51 109
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL51 110
P=EQV(J+1)*xf:+EQV(J+2)*yf:+EQV(J+3)*zf:+EQV(J+4)# H*x+k*y+l*z+phi      CL51 111
S=SIN(P);C=COS(P)#                     Sin and cos (hx+ky+lz+phi)       CL51 112
IF(dp:>1.5)#                           Anisotropic temp.fact.           CL51 113
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL51 114
U=0.;DO I=1,6;U=U+EQV(J+I+4)*ub:(IA+I)# Sum h*h*u11 etc.                CL51 115
U=EXP(-U);S=U*S;C=U*C#                 Calc tf*sin tf*cos               CL51 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL51 117
IF(ICEN==1) SSIN=SSIN+S;SCOS=SCOS+C#   Sum real components              CL51 118
#                                                                       CL51 119
## SUM DERIVATIVES                                                      CL51 120
#                                                                       CL51 121
IF(NCY>NCYCLE) NEXT#                   Calc only sf in this cycle       CL51 122
IF(IREF>NREFL) NEXT#                                                    CL51 123
DO I=1,3#                              Loop over x,y,z parameters       CL51 124
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL51 125
IF(QX(IC+I)<0.5) NEXT#                 Skip noref parameter             CL51 126
IF(ICEN==1)#                           Test if noncentrosym             CL51 127
DELB(I)=DELB(I)+EQV(I+J)*C#            Sum real components              CL51 128
DELA(I)=DELA(I)-EQV(I+J)*S#            Sum imag components              CL51 129
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL51 130
ifeq:(dp:,2.) DO I=5,10#               Loop anisotropic uij             CL51 131
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL51 132
IF(QX(IC+I)<0.5) NEXT#                 Skip noref parameter             CL51 133
IF(ICEN==1)#                           Test if noncentrosym             CL51 134
DELB(I)=DELB(I)-EQV(I+J)*S#            Sum imag components              CL51 135
DELA(I)=DELA(I)-EQV(I+J)*C#            Sum real components              CL51 136
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL51 137
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL51 138
#                                                                       CL51 139
## CALC COMPONENTS WHICH ARE SYMMETRY INDEPENDENT                       CL51 140
#                                                                       CL51 141
FAC=ml:*pp:*AMUL#                      Sitemult*pop*cellmul             CL51 142
ifeq:(dp:,0.) FAC=FAC*EXP(-STL2*UOV)#  Apply isotropic tf               CL51 143
ifeq:(dp:,1.) FAC=FAC*EXP(-STL2*ub:)#  Apply isotropic tf               CL51 144
FF=BUF(NINT(sf:)+30)#                  Get form factor this atom        CL51 145
FAC1=FAC*FF;FAC2=0.#                   Disp-free structure factor       CL51 146
A(1)=FAC1*SCOS#                        Form components of fc            CL51 147
A(2)=0.;IF(ICEN==1) A(2)=FAC1*SSIN#                                     CL51 148
A(3)=A(1);A(4)=-A(2)#                                                   CL51 149
DO I=1,NF;ANOD(I)=ANOD(I)+A(I)#        Sum non-dispersion terms         CL51 150
IF(APPDSP==yes:)#                      If dispersion applied            CL51 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CL51 152
FAC1=FAC*(dr:+FF)#                     Calc real scattering             CL51 153
FAC2=FAC*(di:)#                        Calc imag scattering             CL51 154
DA(1)=FAC*(SCOS*dr:-SSIN*di:)#         Calc real disp. contribution     CL51 155
DA(2)=FAC*(SSIN*dr:+SCOS*di:)#         Calc imag disp. contribution     CL51 156
IF(NF>=3)#                                                              CL51 157
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CL51 158
DA(3)=FAC*( SCOS*dr:+SSIN*di:)#        Calc real disp. contribution     CL51 159
DA(4)=FAC*(-SSIN*dr:+SCOS*di:)#        Calc imag disp. contribution     CL51 160
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CL51 161
DO J=1,NF;ADIS(J)=ADIS(J)+DA(J)#       Sum dispersion terms             CL51 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CL51 163
#                                                                       CL51 164
## ACCUMULATE ATOM X,Y,Z,U,PP DERIVATIVES                               CL51 165
#                                                                       CL51 166
IF(NCY>NCYCLE) NEXT#                   Calc sf only in this cycle       CL51 167
IF(IREF>NREFL) NEXT#                                                    CL51 168
FAC1=FAC1*DERFAC;FAC2=FAC2*DERFAC#     Apply derivative factor          CL51 169
DO I=1,11#                             Loop over atom parameters        CL51 170
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CL51 171
IF(QX(IC+I)<0.5) NEXT#                 Skip noref parameter             CL51 172
IF(I==4)#                              If isotropic dp                  CL51 173
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CL51 174
DO J=1,NF;DA(J)=A(J)*DERTMP#           Isotropic dp derivatives         CL51 175
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CL51 176
ELSE IF(I==11)#                        If population parameter          CL51 177
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CL51 178
DO J=1,NF;DA(J)=A(J)*DERFAC/pp:#       Population derivatives           CL51 179
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CL51 180
ELSE#                                  Xyz or anisotropic dp            CL51 181
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CL51 182
DA(1)=FAC1*DELA(I)-FAC2*DELB(I)#       Calc deriv a                     CL51 183
DA(2)=FAC1*DELB(I)+FAC2*DELA(I)#       Calc deriv a                     CL51 184
IF(APPABS==yes:)#                      If flack param applied/refined   CL51 185
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CL51 186
DA(3)= FAC1*DELA(I)+FAC2*DELB(I)#      Calc deriv a                     CL51 187
DA(4)=-FAC1*DELB(I)+FAC2*DELA(I)#      Calc deriv a                     CL51 188
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CL51 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CL51 190
IF(QX(IC+I)>CC)#                       Test if constrained parameter    CL51 191
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CL51 192
JJ=NINT(QX(IC+I))#                     Constraint pkt pointer           CL51 193
IR=NINT(QX(JJ+3))+MDTEMP#              Ref var address                  CL51 194
DO J=1,NF;DA(J)=QX(JJ+6)*DA(J)#        Multiply deriv with factor       CL51 195
M=IR#                                  Point to derivative              CL51 196
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CL51 197
ELSE#                                  Else unconstrained               CL51 198
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CL51 199
M=IS;IS=IS+1#                          Deriv pntr; incr constr pntr     CL51 200
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CL51 201
DO J=1,NF#                             Loop over derivative terms       CL51 202
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CL51 203
QX(M)=QX(M)+DA(J)#                     Sum terms                        CL51 204
M=M+VARTOT#                            Incr constr pntr                 CL51 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CL51 206
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CL51 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL51 208
#                                                                       CL51 209
## CALCULATE STRUCTURE FACTORS                                          CL51 210
#                                                                       CL51 211
DO I=1,NF;ACAL(I)=ANOD(I)+ADIS(I)#     Total sf componnets              CL51 212
movereal:(BUF,1,QX,ICALC+1,HKLPAK,0)#  Copy buf(1:hklpak)               CL51 213
ICALC=ICALC+HKLPAK#                    Incr pointer                     CL51 214
movereal:(ANOD,1,QX,ICALC+1,NF,0)#     Copy anod                        CL51 215
movereal:(ADIS,1,QX,ICALC+5,NF,0)#     Copy adis                        CL51 216
movereal:(ACAL,1,QX,ICALC+9,NF,0)#     Copy acal                        CL51 217
QX(ICALC+13)=ACAL(1)*ACAL(1)+ACAL(2)*ACAL(2)# F2calc                    CL51 218
IF(NF<=2) QX(ICALC+14)=0.#             No friedel requested             CL51 219
ELSE#                                  Friedel requested                CL51 220
QX(ICALC+14)=ACAL(3)*ACAL(3)+ACAL(4)*ACAL(4)# F2calc(friedel)           CL51 221
IREF=IABS(NINT(BUF(29)))#              Number next twin refl.           CL51 222
ICALC=ICALC-HKLPAK+NCALC#              Point to next twin refl.         CL51 223
IS=IS+(NF-1)*VARTOT+VARGEN#            Point to next twin derv. area    CL51 224
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL51 225
#                                                                       CL51 226
RETURN#                                                                 CL51 227
END#                                                                    CL51 228
systemheader:(CL52)#                   Output, statistics,derivatives   CL52   1
######################################################################  CL52   2
#                                                                    #  CL52   3
#                               CL52                                 #  CL52   4
#                                                                    #  CL52   5
######################################################################  CL52   6
SUBROUTINE CL52#                                                        CL52   7
include:(AACOMN)#                                                       CL52   8
include:(CLCOMN)#                                                       CL52   9
#                                                                       CL52  10
REAL    A,B#            ## Correction terms in 'nodisp' calculations    CL52  11
REAL    ADIS,BDIS#      ## Dispersion terms in 'nodisp' calculaions     CL52  12
REAL    FCND#           ## Fcal(no disp; no exti)                       CL52  13
REAL    FOND#           ## Fobs(no disp; no exti)                       CL52  14
REAL    FO2NE#          ## Fobs**2(no exti)                             CL52  15
REAL    EFLACK#         ## Flack coorection term                        CL52  16
INTEGER I,IC,IS,IS1,IS2,IT## Loop parameters                            CL52  17
INTEGER J,JJ,K,L,LL#    ## Loop parameters                              CL52  18
INTEGER ICALC#          ## Pointer in mcalc array                       CL52  19
INTEGER IFRDL,NFRDL#    ## Pntr friedel pairs                           CL52  20
INTEGER IFRST#          ## First loop over friedel reflections          CL52  21
INTEGER IREF#           ## Number of currecnt (twin) reflection         CL52  22
INTEGER ITW,ITWIN#      ## Pointers in loop over twin fractions         CL52  23
INTEGER LM,LV,LT#       ## Pointers in matrix, vector, scratch arrays   CL52  24
INTEGER M#              ## Pointer                                      CL52  25
REAL    WD#             ## Weight*f2dif                                 CL52  26
REAL    YCAL,YCFR#      ## F2cal, refl. & friedel refl.                 CL52  27
REAL    YDIF#           ## Rel-cal difference for i                     CL52  28
REAL    YOBS#           ## F2obs                                        CL52  29
REAL    YTWIN(30)#      ## Sf components, twin fractions applied        CL52  30
#                                                                       CL52  31
chardata:(CL1,   H  K  L SINT/L RC     YOBS    YCALC    $#              CL52  32
 D(Y)   W*D(Y)    ACAL    BCAL    PHI    FOND    FCND   EXTF)#          CL52  33
realdata:(FMT,[40313.,70313.,100313.,170642.,200113.,290812.,380812.,#  CL52  34
470812.,560722.,640722.,720722.,790612.,870622.,950622.,#               CL52  35
1020532.,950313.,1030632.,1100632.,1170632.])#                          CL52  36
realdata:(TWOPI,6.28318531)#                                            CL52  37
datastuff:#                                                             CL52  38
#                                                                       CL52  39
#    CALCULATE YCAL, YOBS, YDIF                                         CL52  40
#    --------------------------                                         CL52  41
#                                                                       CL52  42
NFRDL=IABS(APPABS)+1#                  Number of friedel pairs          CL52  43
IREF=IREFL#                            Number of main twin refl.        CL52  44
ifeq:(YEXT,0.0) YEXT=1.0#              Default                          CL52  45
#                                                                       CL52  46
## APPLY TWIN FRACTIONS                                                 CL52  47
#                                                                       CL52  48
DO ITWIN=1,NTWIN#                      Loop over twin fractions         CL52  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL52  50
ICALC=MCALC+(ITWIN-1)*NCALC#           Point to next twin reflection    CL52  51
movereal:(QX,ICALC+1,BUF,1,HKLPAK,0)#  Move reflection info             CL52  52
IF(IREF>NREFL)#                        If reflection was not observed   CL52  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL52  54
IREF=IABS(NINT(BUF(29)));NEXT#         Goto to next refl.               CL52  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL52  56
ICALC=ICALC+HKLPAK#                    Incr pointer                     CL52  57
IT=MTWIN+10;DO I=1,30;YTWIN(I)=0.#     Initialize                       CL52  58
DO ITW=1,NTWIN#                        Loop over twins                  CL52  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL52  60
DO I=1,12#                             Loop over sf components          CL52  61
YTWIN(I)=YTWIN(I)+QX(IT)*QX(ICALC+I)**2# Apply twin fractions           CL52  62
DO I=13,14#                            F2cal and f2cal(friedel)         CL52  63
YTWIN(I)=YTWIN(I)+QX(IT)*QX(ICALC+I)#  Apply to f2calc                  CL52  64
IF(APPABS==no:) YTWIN(14+ITW)=QX(ICALC+13)# Save f2calc (no twin fr.)   CL52  65
ELSE#                                  If flack param applied           CL52  66
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL52  67
YTWIN(14+ITW)=(1.-XABS)*QX(ICALC+13)+XABS*QX(ICALC+14)# Main refl.      CL52  68
YTWIN(22+ITW)=(1.-XABS)*QX(ICALC+14)+XABS*QX(ICALC+13)# Friedel refl.   CL52  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL52  70
IT=IT+13;ICALC=ICALC+NCALC#            Incr pointers                    CL52  71
IF(ICALC>LCALC) ICALC=MCALC+HKLPAK#    Reset pointer                    CL52  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL52  73
DO I=1,12;YTWIN(I)=SIGN(1.,QX(ICALC+I))*SQRT(YTWIN(I))# Sf comp.        CL52  74
#                                                                       CL52  75
# APPLY FRIEDEL FRACTIONS                                               CL52  76
#                                                                       CL52  77
YCAL=YTWIN(13);YCFR=YTWIN(14)#         F2calc,f2calc(friedel)           CL52  78
IF(APPEXT==yes:)#                                                       CL52  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL52  80
BUF(13)=YCAL#                                                           CL52  81
CALL CL55(2,NINT(QX(MFLAG+4)))#        Calculate ext.corr. and derv.    CL52  82
YCAL=YEXT*YCAL;YCFR=YEXT*YCFR#         Apply ext.corr.                  CL52  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL52  84
IF(APPABS==no:) BUF(13)=YCAL#          Save f2calc                      CL52  85
ELSE#                                                                   CL52  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL52  87
BUF(13)=(1.-XABS)*YCAL+XABS*YCFR#      Save f2calc main refl.           CL52  88
BUF(14)=(1.-XABS)*YCFR+XABS*YCAL#      Save f2calc friedel refl.        CL52  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL52  90
#                                                                       CL52  91
IFRST=yes:#                            First cycle in friedel loop      CL52  92
DO IFRDL=1,NFRDL#                      Loop over friedel pairs          CL52  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL52  94
ifvo:(BUF(4+2*IFRDL)) NEXT#            Skip reflection                  CL52  95
YOBS=BUF(4+2*IFRDL)/SKF#               Yobs/skf                         CL52  96
YDIF=YOBS-BUF(12+IFRDL)#               Delta f2                         CL52  97
WD=BUF(10)*YDIF#                       Weight*delta f2                  CL52  98
#                                                                       CL52  99
#    CALCULATE DATA FOR OUTPUT                                          CL52 100
#    -------------------------                                          CL52 101
#                                                                       CL52 102
IF(LISTRF>0\ABS(WD)>LISTPR\NCY>NCYCLE)# If listing requested            CL52 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL52 104
FCND=SQRT(QX(ICALC+1)**2+QX(ICALC+2)**2)# Fcal(nodisp;noext)            CL52 105
BUF(15)=AMOD(ATAN2(YTWIN(2),YTWIN(1))/TWOPI+1.000001,1.)# Phi in cyc    CL52 106
BUF(16)=YEXT#                                                           CL52 107
DO I=1,NF;BUF(16+I)=YTWIN(8+I)#        Save acal, twin fr.              CL52 108
BUF(21)=FCND#                          Save fc(no disp)                 CL52 109
FO2NE=BUF(6)/YEXT/SKF#                 Fobs**2(noext)#                  CL52 110
IF(APPDSP==no:) FOND=SQRT(AMAX1(0.,FO2NE))# Dispersion not applied      CL52 111
ELSE#                                                                   CL52 112
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CL52 113
A=0.;B=0.;EFLACK=0.#                   Default corr. terms              CL52 114
IF(IFRDL==1)#                          Reflection                       CL52 115
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CL52 116
IF(APPABS==no:)#                       If no xabs available             CL52 117
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CL52 118
ADIS=YTWIN(5);BDIS=YTWIN(6)#           Disp terms                       CL52 119
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CL52 120
ELSE#                                                                   CL52 121
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CL52 122
ADIS=(1.-XABS)*YTWIN(5)+XABS*YTWIN(7)# Disp term a                      CL52 123
BDIS=(1.-XABS)*YTWIN(6)-XABS*YTWIN(8)# Disp term b                      CL52 124
EFLACK=(1.-XABS)*(YTWIN(5)**2+YTWIN(6)**2)+$# Corr. for flack param     CL52 125
XABS *(YTWIN(7)**2+YTWIN(8)**2)-ADIS**2-BDIS**2#                        CL52 126
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CL52 127
A=( ADIS*YTWIN(2)-BDIS*YTWIN(1))/FCND# Corr. term a for refl.           CL52 128
B=( ADIS*YTWIN(1)+BDIS*YTWIN(2))/FCND# Corr. term b for refl.           CL52 129
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CL52 130
ELSE#                                  Friedel reflection               CL52 131
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CL52 132
FO2NE=BUF(8)/YEXT/SKF#                 Fobs**2(noext)#                  CL52 133
IF(APPABS==yes:)#                      If xabs available                CL52 134
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CL52 135
ADIS=SQRT(MAX(0.,YTWIN(7)));BDIS=SQRT(MAX(0.,YTWIN(8)))# Disp terms     CL52 136
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CL52 137
ELSE#                                                                   CL52 138
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CL52 139
ADIS=(1.-XABS)*YTWIN(7)+XABS*YTWIN(5)# Disp term a                      CL52 140
BDIS=(1.-XABS)*YTWIN(8)-XABS*YTWIN(6)# Disp term b                      CL52 141
EFLACK=(1.-XABS)*(YTWIN(7)**2+YTWIN(8)**2)+$# Corr. for flack param     CL52 142
XABS *(YTWIN(5)**2+YTWIN(6)**2)-ADIS**2-BDIS**2#                        CL52 143
A=(-ADIS*YTWIN(2)-BDIS*YTWIN(1))/FCND# Corr. term a for refl.           CL52 144
B=( ADIS*YTWIN(1)-BDIS*YTWIN(2))/FCND# Corr. term b for refl.           CL52 145
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CL52 146
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CL52 147
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CL52 148
FOND=AMAX1(0.,FO2NE-A*A-EFLACK)#       Correction                       CL52 149
FOND=SQRT(FOND)-B;BUF(22)=FOND#        Nodisp fobs value                CL52 150
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL52 151
IF(ITWIN>1) BUF(30)=NCY#               Flag with cycle number           CL52 152
writedac:(ioda1:,,IREF,(BUF(I),I=1,HKLPAK))# Write to direct access f   CL52 153
WEIGHT=BUF(10)#                        Weight for this reflection       CL52 154
IREF=IABS(NINT(QX(ICALC-HKLPAK+29)))#  Number next twin                 CL52 155
IF(ABS(WEIGHT*YDIF)>RFMTRX) NEXT#      Do not use for refinement        CL52 156
IF(LTMTRX==yes:&BUF(5)>1.) NEXT#       Do not use rcode2 refl.          CL52 157
#                                                                       CL52 158
#    SUM GENERAL DERIVATIVES                                            CL52 159
#    -----------------------                                            CL52 160
#                                                                       CL52 161
IF(NCY<=NCYCLE)#                       If not last cycle                CL52 162
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CL52 163
#IS=MDTEMP+NDTEMP+(ITWIN-1)*NF*VARTOT+1# SET DERIV POINTER              CL52 164
IS=MDTEMP+NDTEMP+1#                                                     CL52 165
IF(QX(MFLAG+1)>0.)#                    If scale factor refined          CL52 166
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CL52 167
QX(IS)=2.*BUF(10)*BUF(12+IFRDL)#       Skf deriv = derfac * f2cal       CL52 168
IS=IS+1#                               Incr deriv pointer               CL52 169
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CL52 170
IF(QX(MFLAG+2)>0.)#                    If uov refined                   CL52 171
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CL52 172
QX(IS)=-2.*WEIGHT*BUF(4)*BUF(4)*BUF(12+IFRDL)# Der(uov)=-stl^2*w*fcal   CL52 173
IS=IS+1#                               Incr deriv pointer               CL52 174
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CL52 175
IF(QX(MFLAG+3)>0.)#                    If flack param refined           CL52 176
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CL52 177
IF(IFRDL==1) QX(IS)=(-YCAL+YCFR)*WEIGHT# Xabs deriv                     CL52 178
ELSE         QX(IS)=-QX(IS)#           Xabs deriv for friedel refl      CL52 179
IS=IS+1#                               Incr deriv pointer               CL52 180
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CL52 181
IF(REFEXT==yes:) IS=IS+1#              Deriv. are calculated in cl55    CL52 182
IF(QX(MFLAG+6)>0.)#                    If twin fractions refined        CL52 183
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CL52 184
IT=6+8*IFRDL#                          Point to first twin fraction     CL52 185
DO ITW=2,NTWIN#                        Loop over twin fractions         CL52 186
QX(IS-2+ITW)=WEIGHT*(-YTWIN(IT+1)+YTWIN(IT+ITW))# Derivatives           CL52 187
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CL52 188
#                                                                       CL52 189
#    SUM ATOM DERIVATIVES                                               CL52 190
#    --------------------                                               CL52 191
#                                                                       CL52 192
IS=MDTEMP+NDTEMP#                      Set atom deriv pointer           CL52 193
IT=MTWIN+10;IC=MDTEMP+(ITWIN-1)*NF*VARTOT# Twin & scratch pntrs         CL52 194
IF(IFRST==yes:)#                       First time for refl.             CL52 195
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CL52 196
DO I=IS+VARGEN+1,LDTEMP;QX(I)=0.#      Zero into scratch part           CL52 197
DO ITW=1,NTWIN#                        Loop over twin fractions         CL52 198
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CL52 199
DO I=1,NF#                                                              CL52 200
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CL52 201
IS=IS+VARGEN#                                                           CL52 202
DO J=VARGEN+1,VARTOT#                  Loop over derivatives            CL52 203
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CL52 204
IS=IS+1#                                                                CL52 205
QX(IS)=QX(IS)+QX(IT)*QX(IC+J)#         Sum twin fractions               CL52 206
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CL52 207
IC=IC+VARTOT#                          Reset deriv pntr                 CL52 208
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CL52 209
IT=IT+13#                              Reset twin pntr                  CL52 210
IF(IC>=IS) IC=MDTEMP#                  Goto start of array              CL52 211
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CL52 212
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CL52 213
IS=MDTEMP+NDTEMP#                      Reset pntr                       CL52 214
IS1=IS+VARGEN+1;IS2=IS+VARTOT#         Atom deriv pointers              CL52 215
DO IS=IS1,IS2#                         Loop over deriv                  CL52 216
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CL52 217
IF(IFRDL==1)#                          Main refl.                       CL52 218
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CL52 219
M=IS#                                  Point to first term              CL52 220
DO J=1,NF,2#                           Loop over deriv                  CL52 221
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CL52 222
QX(M+VARTOT)=YTWIN(8+J)*QX(M)+YTWIN(9+J)*QX(M+VARTOT)# Combine real&i   CL52 223
M=M+2*VARTOT#                          Incr deriv pointer               CL52 224
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CL52 225
QX(IS)=(1.-XABS)*QX(IS+VARTOT)+XABS*QX(IS+3*VARTOT)# Final deriv ma.    CL52 226
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CL52 227
ELSE#                                  Friedel refl.                    CL52 228
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CL52 229
QX(IS)=(1.-XABS)*QX(IS+3*VARTOT)+XABS*QX(IS+VARTOT)# Final deriv,fr.    CL52 230
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CL52 231
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CL52 232
#                                                                       CL52 233
#    BUILD DERIVATIVE MATRICES                                          CL52 234
#    -------------------------                                          CL52 235
#                                                                       CL52 236
LM=MDMATX;LV=MDVECT;LT=MDTEMP+NDTEMP#  Start array markers              CL52 237
LL=LT+VARTOT#                          Last variable                    CL52 238
DO K=1,VARTOT#                         Loop over total nr variables     CL52 239
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CL52 240
JJ=LT+1;A=QX(JJ)#                      Get element                      CL52 241
DO L=JJ,LL#                            Loop over core elements          CL52 242
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CL52 243
LM=LM+1;QX(LM)=QX(LM)+A*QX(L)#         Form matrix block                CL52 244
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CL52 245
LV=LV+1;QX(LV)=QX(LV)+A*WD#            Form diff vector                 CL52 246
LT=LT+1#                               Incr temp area pointer           CL52 247
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CL52 248
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CL52 249
IFRST=no:#                             For next friedel loop            CL52 250
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL52 251
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL52 252
IF(NTWIN>1)#                           If twin fraction applied         CL52 253
readdac:(ioda1:,,IREF,(BUF(I),I=1,HKLPAK))# Read main refl.             CL52 254
#                                                                       CL52 255
RETURN#                                                                 CL52 256
END#                                                                    CL52 257
systemheader:(CL53)#                   Output, statistics               CL53   1
######################################################################  CL53   2
#                                                                    #  CL53   3
#                               CL53                                 #  CL53   4
#                                                                    #  CL53   5
######################################################################  CL53   6
SUBROUTINE CL53#                                                        CL53   7
include:(AACOMN)#                                                       CL53   8
include:(CLCOMN)#                                                       CL53   9
#                                                                       CL53  10
REAL    FCAL#           ## Calculated f                                 CL53  11
REAL    FCND#           ## Fcal(no disp; no exti)                       CL53  12
REAL    FOND#           ## Frel(no disp; no exti)                       CL53  13
REAL    FDIF#           ## Rel-cal difference for f                     CL53  14
REAL    FOBS#           ## Integrated peak int reduced to absolute f    CL53  15
INTEGER I,II,IPP,J#     ## Pointers and indices                         CL53  16
INTEGER IFRST#          ## First reflection to bdf                      CL53  17
INTEGER IFRDL,NFRDL#    ## Pntr friedel pairs                           CL53  18
REAL    PHI#            ## Phase in cycles; no disp                     CL53  19
REAL    YCAL,YCFR#      ## F2cal, refl. & friedel refl.                 CL53  20
REAL    YDIF#           ## Rel-cal difference for i                     CL53  21
REAL    YOBS#           ## F2obs                                        CL53  22
REAL    WD#             ##                                              CL53  23
#                                                                       CL53  24
chardata:(CL1,   H  K  L SINT/L RC     YOBS    YCALC    $#              CL53  25
 D(Y)   W*D(Y)    ACAL    BCAL    PHI    FOND    FCND   EXTF)#          CL53  26
realdata:(FMT,[40313.,70313.,100313.,170642.,200113.,290812.,380812.,#  CL53  27
470812.,560722.,640722.,720722.,790612.,870622.,950622.,#               CL53  28
1020532.,950313.,1030632.,1100632.,1170632.])#                          CL53  29
realdata:(TWOPI,6.28318531)#                                            CL53  30
datastuff:#                                                             CL53  31
#                                                                       CL53  32
#    GET YOBS, ETC. CALCULATE FOBS, ETC.                                CL53  33
#    -----------------------------------                                CL53  34
#                                                                       CL53  35
NFRDL=IABS(APPABS+1)#                  Number of friedel pairs          CL53  36
movereal:(BUF,1,BUFOT,1,5,0)#          H,k,l,stl,rc,f2(obs)             CL53  37
IFRST=yes:#                            Write refl to bdf                CL53  38
DO IFRDL=1,NFRDL#                      Loop over friedel pairs          CL53  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL53  40
IF(IFRDL!=1)#                          If not main reflection           CL53  41
DO J=1,3;BUFOT(J)=-BUFOT(J)#           Invert indices                   CL53  42
ifvo:(BUF(4+2*IFRDL)) NEXT#            Skip reflection                  CL53  43
YOBS=BUF(4+2*IFRDL)/SKF#               F2obs                            CL53  44
YCAL=BUF(12+IFRDL)#                    F2calc                           CL53  45
YDIF=YOBS-YCAL#                        Delta                            CL53  46
WEIGHT=BUF(10);WD=WEIGHT*YDIF#         Weight * delta                   CL53  47
IF(YOBS>0.)FOBS=SQRT(YOBS)#            Fobs                             CL53  48
ELSE       FOBS=0.#                    Fobs                             CL53  49
FCAL=SQRT(YCAL)#                       Fcal                             CL53  50
FDIF=FOBS-FCAL#                        Delta f                          CL53  51
PHI=BUF(15);FCND=BUF(21)#              Phi in cycles;fcnd               CL53  52
FOND=BUF(22)#                          Restore fond                     CL53  53
#                                                                       CL53  54
#    LIST REFLECTION DATA IF REQUESTED                                  CL53  55
#    ---------------------------------                                  CL53  56
#                                                                       CL53  57
IF(LISTRF>0\ABS(WD)>LISTPR)#           If listing requested             CL53  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL53  59
BUFOT(6)=YOBS;BUFOT(7)=YCAL#           Put output values in buffer      CL53  60
BUFOT(8)=YDIF;BUFOT(9)=WD#             Put output values in buffer      CL53  61
DO I=1,2;BUFOT(9+I)=BUF(14+I+2*IFRDL)# Acalc,bcalc                      CL53  62
BUFOT(12)=PHI*360.#                    Phi in degrees                   CL53  63
BUFOT(13)=FOND#                        Fobs(nodisp,noext)               CL53  64
BUFOT(14)=FCND#                        Fcal(nodisp,noext)               CL53  65
BUFOT(15)=YEXT#                        Extinction factor                CL53  66
ncodefld:(BUFOT,1,CHROT,FMT,15)#       Format last 15 items             CL53  67
IF(ABS(WD)>RFMTRX) movechar:(CL1,52,CHROT,57,1,0)# Flag not-used        CL53  68
writeline:(0,CL1,NCL1,1,3)#            Print output items               CL53  69
IF(NCY>NCYCLE) LISTRF=LISTRF-1#        Decrement lines printed          CL53  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL53  71
#                                                                       CL53  72
#    SUM FOR STATISTICS                                                 CL53  73
#    __________________                                                 CL53  74
#                                                                       CL53  75
IF(ABS(WD)<=RFMTRX)#                   Bad refl. not used in matrix     CL53  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL53  77
IF(!(LTMTRX==yes:&BUF(5)>1.))#         Rcode2 refl. not used in matri   CL53  78
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL53  79
RSUMS(1)=RSUMS(1)+(WEIGHT*YOBS)**2#    Sum weight * obs f**2            CL53  80
RSUMS(2)=RSUMS(2)+1.#                  Count refl. contributing to ls   CL53  81
RSUMS(3)=RSUMS(3)+WD*WD#               Sum weight * delta f**2          CL53  82
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL53  83
ifeq:(BUF(5),1.) II=0#                 Offset for rcode=1 refl          CL53  84
ELSE             II=4#                 Offset for rcode=2 refl          CL53  85
RSUMS(II+4)=RSUMS(II+4)+FOBS#          Sum obs f                        CL53  86
RSUMS(II+5)=RSUMS(II+5)+FCAL#          Sum cal f                        CL53  87
RSUMS(II+6)=RSUMS(II+6)+ABS(FDIF)#     Sum delta f                      CL53  88
RSUMS(II+7)=RSUMS(II+7)+1.#            Count contributing refl          CL53  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL53  90
#                                                                       CL53  91
#    UPDATE BINARY DATA FILE AFTER LAST CYCLE                           CL53  92
#    ----------------------------------------                           CL53  93
#                                                                       CL53  94
IF(IFRST==no:) BREAK#                  Break if on bdf already          CL53  95
IF(NCY>NCYCLE)#                        Last cycle only                  CL53  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL53  97
readwpkt:(1,lrrefl:,PACK,IP,2)#        Read reflection packet           CL53  98
writepkt:(2,lrrefl:,KEY(4),IPP)#       Write reflection packet          CL53  99
movereal:(QX,IP+1,QX,IPP+1,PACK,0)#    Move all items                   CL53 100
QX(IPP+IREL(4))=PHI#                   Store phi                        CL53 101
QX(IPP+IREL(5))=FOND*SQRT(SKF)#        Store frel(nodisp)               CL53 102
QX(IPP+IREL(6))=FCND#                  Fcal (no disp; no ext)           CL53 103
QX(IPP+IREL(7))=FCND*COS(PHI*TWOPI)#   Acal (no disp; no ext)           CL53 104
QX(IPP+IREL(8))=FCND*SIN(PHI*TWOPI)#   Bcal (no disp; no ext)           CL53 105
QX(IPP+IREL(9))=BUF(17)*SQRT(YEXT)#    Acal (disp; no ext)              CL53 106
QX(IPP+IREL(10))=BUF(18)*SQRT(YEXT)#   Bcal (disp; no ext)              CL53 107
IFRST=no:#                             No more refl to bdf              CL53 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL53 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL53 110
#                                                                       CL53 111
RETURN#                                                                 CL53 112
END#                                                                    CL53 113
systemheader:(CL54)#                   Twin calculations                CL54   1
# ##################################################################### CL54   2
#                                                                       CL54   3
#                               CL54                                    CL54   4
#                                                                       CL54   5
# ##################################################################### CL54   6
SUBROUTINE CL54#                                                        CL54   7
include:(AACOMN)#                                                       CL54   8
include:(CLCOMN)#                                                       CL54   9
#                                                                       CL54  10
INTEGER HKL(3),HKL1(3),HKL2(3)## Reflection indices                     CL54  11
INTEGER I,J#            ## Indices                                      CL54  12
INTEGER ICALC#          ## Index in mcalc array                         CL54  13
INTEGER ITW#            ## Pointer in mtwin array                       CL54  14
INTEGER ITWIN#          ## Index in twin loop                           CL54  15
INTEGER MARK#           ## Index in mcalc array (outer loop)            CL54  16
INTEGER S#              ## Sign of friedel reflections                  CL54  17
#                                                                       CL54  18
## LOOP OVER ALL REFLECTIONS                                            CL54  19
#                                                                       CL54  20
DO MARK=MCALC,LCALC-1,NCALC#           Loop over reflections            CL54  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL54  22
IF(QX(MARK+4)<0.) NEXT#                If indexed already               CL54  23
IREFL=(MARK-MCALC)/NCALC+1#            Refl nr main refl                CL54  24
DO I=1,3;HKL(I)=QX(MARK+I)#            Copy hkl                         CL54  25
#                                                                       CL54  26
## CALCULATE HKL1                                                       CL54  27
#                                                                       CL54  28
DO ITWIN=MTWIN+13,LTWIN,13#            Loop over twin operations        CL54  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL54  30
IF(ITWIN<LTWIN)#                       Search only for twin 2 etc.      CL54  31
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL54  32
DO S=1,-1,-2#                          Loop over friedel pairs          CL54  33
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL54  34
DO I=1,3;HKL1(I)=0#                    Set hkl1 to zero                 CL54  35
DO I=1,3#                              Loop over matrix rows            CL54  36
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL54  37
ITW=ITWIN+3*I-3#                       Point to rotation indices        CL54  38
DO J=1,3;HKL1(I)=HKL1(I)+S*QX(ITW+J)*HKL(J)# Calc new indices           CL54  39
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL54  40
#                                                                       CL54  41
## SEARCH NEW INDICES IN MCALC ARRAY                                    CL54  42
#                                                                       CL54  43
DO ICALC=MARK+NCALC,LCALC,NCALC#       Loop over reflections            CL54  44
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL54  45
DO J=1,3;ifne:(HKL1(J),QX(ICALC+J)) BREAK# Compare hkl                  CL54  46
IF(J==4) BREAK#                        Hkl match                        CL54  47
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL54  48
IF(J==4\S==-1) BREAK#                  Try friedel refl.                CL54  49
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL54  50
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL54  51
#                                                                       CL54  52
## UPDATE BUF(29) IN DIRECT ACCCESS FILE                                CL54  53
#                                                                       CL54  54
IF(IREFL<=NREFL)#                      Former twin reflection in list   CL54  55
readdac:(ioda1:,,IREFL,(BUF(I),I=1,HKLPAK))# Read buffer                CL54  56
ELSE#                                  Former twin refelction was new   CL54  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL54  58
DO I=1,3;BUF(I)=HKL2(I)#               Indices of former twin           CL54  59
BUF(6)=voidflg:;BUF(8)=voidflg:#       F2 values set to void            CL54  60
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL54  61
IF(ICALC<=LCALC)#                      Reflection in list               CL54  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL54  63
BUF(29)=S*FLOAT((ICALC-MCALC)/NCALC+1)# Save pntr to next twin refl.    CL54  64
QX(ICALC+4)=-1.#                       Flag reflection                  CL54  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL54  66
ELSE#                                  No match                         CL54  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CL54  68
MREFL=MREFL+1;BUF(29)=FLOAT(MREFL)#    Incr nr of refl; save nr         CL54  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CL54  70
IF(ITWIN>=LTWIN)#                      Twin 1                           CL54  71
BUF(29)=FLOAT((MARK-MCALC)/NCALC+1)#   Save pntr to first twin refl.    CL54  72
writedac:(ioda1:,,IREFL,(BUF(I),I=1,HKLPAK))# Write buffer              CL54  73
IREFL=NINT(ABS(BUF(29)))#              Next twin refection              CL54  74
IF(IREFL>NREFL)#                       New reflection                   CL54  75
DO I=1,3;HKL2(I)=HKL1(I)#              Save indices                     CL54  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL54  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL54  78
#                                                                       CL54  79
RETURN#                                                                 CL54  80
END#                                                                    CL54  81
systemheader:(CL55)#                   Extinction corrections           CL55   1
# ##################################################################### CL55   2
#                                                                       CL55   3
#                               CL55                                    CL55   4
#                                                                       CL55   5
# ##################################################################### CL55   6
SUBROUTINE CL55(K,II)#                                                  CL55   7
include:(AACOMN)#                                                       CL55   8
include:(CLCOMN)#                                                       CL55   9
#                                                                       CL55  10
INTEGER II#                                                             CL55  11
REAL    COST#      ## COS(THETA)                                        CL55  12
INTEGER EXTTYP#    ## Extinction type (0=Zach; 1-6=Becker-Coppens       CL55  13
REAL    GAMMAS#    ## GAMMA FOR SEC.  EXTINCTION                        CL55  14
INTEGER K#         ## 0=INIT.                                           CL55  15
#                  ## 1=POLZ.                                           CL55  16
#                  ## 2=CORR.  & DERIV.                                 CL55  17
REAL    K2#        ## Cos(2th)**2                                       CL55  18
REAL    POL1#      ## POLARIZATION FACTOR FOR MONOCHROMETER             CL55  19
REAL    POL2#      ## POLARIZATION FACTOR FOR CRYSTAL                   CL55  20
REAL    PSI#       ## DISTRIBUTION FUNCTION                             CL55  21
REAL    PZPER,PZPAR## Total polarization ratios, perp. resp. par.       CL55  22
REAL    SINT#      ## SIN(THETA)                                        CL55  23
REAL    SIN2T#     ## SIN(2THETA)                                       CL55  24
REAL    XS#        ## X(sec.ext.) = gammas*fc2*psi                      CL55  25
REAL    YPER,YPAR# ## Extinction factors, perp and par                  CL55  26
REAL    YSPER,YSPAR## Y(sec.ext.): perpendicular, parallel              CL55  27
REAL    ZSEXT#     ## Derivative factor                                 CL55  28
#                                                                       CL55  29
#         INITIALIZATIONS                                               CL55  30
#         ---------------                                               CL55  31
#                                                                       CL55  32
EXTTYP=NINT(QX(MEXTI+1))#              Extincion type                   CL55  33
#                                                                       CL55  34
IF(K==0)#                              Initializations                  CL55  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL55  36
GAMMAS=LAMBDA**3/VOL**2#               For calc of gamma                CL55  37
IF(RADTYP>=3) GAMMAS=GAMMAS*79.4075#   For xray diffr. t in mm          CL55  38
ELSE          GAMMAS=GAMMAS*10000.#    For neutron diffr.               CL55  39
QX(MEXTI+19)=GAMMAS#                   Save gammas/tbar                 CL55  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL55  41
#                                                                       CL55  42
#         CALCULATION OF POLARIZATION FACTOR                            CL55  43
#         ----------------------------------                            CL55  44
#                                                                       CL55  45
ELSE IF(K==1)#                         Calc. extinction correction      CL55  46
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL55  47
BUF(28)=QX(MEXTI+19)*BUF(12)#          Mult with tbar -> gammas         CL55  48
SINT=BUF(4)*LAMBDA#                    Sin(theta)                       CL55  49
COST=SQRT(1.-SINT*SINT)#               Cos(theta)                       CL55  50
SIN2T=2.*SINT*COST#                    Sin(2theta)                      CL55  51
K2=(COST*COST-SINT*SINT)**2#           Square cos(2theta)               CL55  52
POL1=QX(MEXTI+20)#                     Polarizarion ratio               CL55  53
POL2=(1.-POL1)*K2#                     Polarization factor perpendicu   CL55  54
BUF(25)=POL1/(POL1+POL2)#              Save perp. pol. factor paralle   CL55  55
BUF(26)=SIN2T#                         Save sin(2th)                    CL55  56
BUF(27)=K2#                            Save cos(2th)**2                 CL55  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL55  58
#                                                                       CL55  59
#         CALCULATION OF EXTINCTION CORRECTION & DERIVATIVES            CL55  60
#         --------------------------------------------------            CL55  61
#                                                                       CL55  62
ELSE IF(K==2)#                         Calc. extinction correction      CL55  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL55  64
PSI=QX(MEXTI+3)/BUF(26)#               Psi for for type i =g/sin(2th)   CL55  65
XS=BUF(28)*BUF(13)*PSI#                Gammas*fc2*psi                   CL55  66
K2=BUF(27)#                            Cos(2th)**2                      CL55  67
YSPER=1./SQRT(1.+2.*XS)#               Ys perpendicular                 CL55  68
YSPAR=1./SQRT(1.+2.*K2*XS)#            Ys parallel                      CL55  69
PZPER=BUF(25);PZPAR=1.-PZPER#          Total polarization ratios        CL55  70
YPER=PZPER*YSPER;YPAR=PZPAR*YSPAR#     Ect. factors, perp and par.      CL55  71
YEXT=YPER+YPAR#                        Extinction correction factor     CL55  72
IF(NCY<=NCYCLE)#                       If not last cycle                CL55  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL55  74
ZSEXT=-PZPER*YSPER**3-PZPAR*K2*YSPAR**3# Derivative factor              CL55  75
DEREXT=YEXT+XS*ZSEXT#                  Multiplier for parm derivative   CL55  76
IF(REFEXT==yes:)#                      If extinction refined            CL55  77
QX(MDTEMP+NDTEMP+II)=WEIGHT*BUF(13)**2*ZSEXT*BUF(28)/BUF(26)# G der     CL55  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL55  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL55  80
#                                                                       CL55  81
RETURN#                                                                 CL55  82
END#                                                                    CL55  83
systemheader:(CL60)#                   Treat restraints                 CL60   1
######################################################################  CL60   2
#                                                                    #  CL60   3
#                               CL60                                 #  CL60   4
#                                                                    #  CL60   5
######################################################################  CL60   6
SUBROUTINE CL60#                                                        CL60   7
include:(CLCOMN)#                                                       CL60   8
include:(AACOMN)#                                                       CL60   9
#                                                                       CL60  10
#                                                                       CL60  11
RETURN#                                                                 CL60  12
END#                                                                    CL60  13
systemheader:(CL70)#                   Output of sums and discrepanci   CL70   1
######################################################################  CL70   2
#                                                                    #  CL70   3
#                               CL70                                 #  CL70   4
#                                                                    #  CL70   5
######################################################################  CL70   6
SUBROUTINE CL70#                                                        CL70   7
include:(CLCOMN)#                                                       CL70   8
include:(AACOMN)#                                                       CL70   9
#                                                                       CL70  10
INTEGER I,J,NC,NCHR#    ## Index vars, final prt flg, sum               CL70  11
#                                                                       CL70  12
chardata:(CL1, STRUCTURE FACTOR SUMS BEFORE CYCLE  1)#                  CL70  13
chardata:(CL2, AFTER )#                                                 CL70  14
chardata:(CL3,[ SUM/W*F2OBS/ SUM/FOBS/ SUM/W*DELTAF2/ $#                CL70  15
SUM/DELTAF/ SUM/FCAL/])#                                                CL70  16
chardata:(CL4, R-FACTORS)#                                              CL70  17
chardata:(CL5,NUMBER OF CONTRIBUTING REFLECTIONS)#                      CL70  18
chardata:(CL6,NUMBER OF VARIABLES)#                                     CL70  19
chardata:(CL7,NUMBER OF UNIQUE REFLECTIONS)#                            CL70  20
chardata:(CL8, GOODNESS OF FIT                     )#                   CL70  21
#HARDATA:(CL9, APPLIED TO LEAST SQUARES MATRIX ...)#                    CL70  22
chardata:(CLA,[R2 - W*F**2 R1 - F-values: ALL  REFL. WITH RC=1])#       CL70  23
chardata:(CLI, REFINEMENT TERMINATED - CHECK RWP)#                      CL70  24
#                                                                       CL70  25
realdata:(FMT1,[501022.])#                                              CL70  26
realdata:(FMT2,[501032.,230513])#                                       CL70  27
realdata:(FMT3,[500613.])#                                              CL70  28
datastuff:#                                                             CL70  29
#                                                                       CL70  30
#                                                                       CL70  31
#    PRINT STRUCTURE FACTOR SUMMARY                                     CL70  32
#    ------------------------------                                     CL70  33
#                                                                       CL70  34
NC=NCY;LINRM=16#                       Current cycle number             CL70  35
IF(NCY>1)#                             Final print out                  CL70  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL70  37
NC=NCYCLE#                             After last cycle                 CL70  38
ncodefld:(FLOAT(NCY-1),1,CL1,380213.,1)# Encode cycle nr                CL70  39
movechar:(CL2,2,CL1,24,6,0)#           'after'                          CL70  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL70  41
NC=MIN0(NC,10)#                        Rsums array pointer & limit      CL70  42
J=10*(NC-1)#                           Offset in rstore array           CL70  43
movechar:(CL4,3,CHROT,2,37,1)#         Underline                        CL70  44
writeline:(1,CL1,NCL1,2,1)#            Write heading                    CL70  45
#                                                                       CL70  46
movechar:(CL5,1,CHROT,2,NCL5,0)#       Number of contr. reflections     CL70  47
ncodefld:(RSUMS(2),1,CHROT,FMT3,1)#    Format nr contr. reflections     CL70  48
writeline:(0,0,0,1,1)#                 Number of contr. reflections     CL70  49
#                                                                       CL70  50
movechar:(CL3,2,CHROT,2,12,0)#         Sum /yobs/                       CL70  51
ncodefld:(RSUMS,1,CHROT,FMT1,1)#       Sum /yobs/                       CL70  52
writeline:(0,0,0,1,1)#                 Sum /yobs/                       CL70  53
#                                                                       CL70  54
movechar:(CL3,25,CHROT,2,14,0)#        Sum /deltay/                     CL70  55
ncodefld:(RSUMS,3,CHROT,FMT1,1)#       Sum /deltay/                     CL70  56
writeline:(0,0,0,1,1)#                 Sum /deltay/                     CL70  57
#                                                                       CL70  58
movechar:(CL3,15,CHROT,2,9,0)#         Sum /fobs/                       CL70  59
ncodefld:(RSUMS,4,CHROT,FMT1,1)#       Sum /fobs/                       CL70  60
writeline:(0,0,0,1,1)#                 Sum /fobs/                       CL70  61
#                                                                       CL70  62
movechar:(CL3,52,CHROT,2,9,0)#         Sum /fcal/                       CL70  63
ncodefld:(RSUMS,5,CHROT,FMT1,1)#       Sum /fcal/                       CL70  64
writeline:(0,0,0,1,1)#                 Sum /fcal/                       CL70  65
#                                                                       CL70  66
movechar:(CL3,40,CHROT,2,11,0)#        Sum /deltaf/                     CL70  67
ncodefld:(RSUMS,6,CHROT,FMT1,1)#       Sum /deltaf/                     CL70  68
writeline:(0,0,0,1,1)#                 Sum /deltaf/                     CL70  69
#                                                                       CL70  70
writeline:(1,CL4,NCL4,3,1)#            R-factors heading                CL70  71
BUFOT(1)=0.#                           Set to zero                      CL70  72
movechar:(CLA,1,CHROT,5,11,0)#         R2-factor                        CL70  73
IF(ABS(RSUMS(1))>small:) $#            Sum(yobs)                        CL70  74
BUFOT(1)=SQRT(RSUMS(3)/RSUMS(1))#      R2=s(delta)/s(obs)               CL70  75
RSTORE(J+5)=BUFOT(1)#                  Summarize r2                     CL70  76
ncodefld:(BUFOT,1,CHROT,FMT2,1)#       R2-factor                        CL70  77
writeline:(0,0,0,1,1)#                 R2-factor                        CL70  78
#                                                                       CL70  79
ifeq:(RSUMS(11),0.) NCHR=26#           If no rc=2 refl  present         CL70  80
ELSE                NCHR=35#           If rc=2 refl present             CL70  81
REPEAT#                                Loop over refl. sets rc=1/1&2    CL70  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL70  83
movechar:(CLA,13,CHROT,5,NCHR,0)#      R1-factor                        CL70  84
ncodefld:(RSUMS,7,CHROT,FMT2(2),1)#    Nr of reflections                CL70  85
IF(ABS(RSUMS(4))>small:) $#            Sum(fobs)                        CL70  86
BUFOT(1)=RSUMS(6)/RSUMS(4)#            R1=s(fdelta)/s(fobs)             CL70  87
ncodefld:(BUFOT,1,CHROT,FMT2,1)#       R1-factor                        CL70  88
writeline:(0,0,0,1,1)#                 R1-factor                        CL70  89
IF(NCHR==26) BREAK#                    Break after last set             CL70  90
DO I=1,4;RSUMS(3+I)=RSUMS(3+I)+RSUMS(7+I)# Sum rc=1 and rc=2 refl.      CL70  91
NCHR=26#                               Reset number of char             CL70  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL70  93
RSTORE(J+1)=BUFOT(1)#                  Summarize r1                     CL70  94
#                                                                       CL70  95
movechar:(CL6,1,CHROT,2,NCL6,0)#       Number of variables              CL70  96
ncodefld:(FLOAT(VARTOT),1,CHROT,FMT3,1)# Format nr variables            CL70  97
writeline:(1,0,0,1,1)#                 Number of variables              CL70  98
#                                                                       CL70  99
GOF=SQRT(MAX(.00001,RSUMS(3)/(RSUMS(2)-VARTOT)))# Goodness of fit       CL70 100
movechar:(CL8,1,CHROT,1,NCL8,0)#       Goodness of fit                  CL70 101
ncodefld:(GOF,1,CHROT,FMT2,1)#         Goodness of fit                  CL70 102
writeline:(0,0,0,1,1)#                 Goodness of fit                  CL70 103
RSTORE(J+7)=GOF#                       Summarize goodness of fit        CL70 104
#                                                                       CL70 105
IF(NINT(RSUMS(7))!=NREFL)#             Not all refl. are rcode1         CL70 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL70 107
movechar:(CL7,1,CHROT,2,NCL7,0)#       Number of refl.                  CL70 108
ncodefld:(FLOAT(NREFL),1,CHROT,FMT3,1)# Format nr refl.                 CL70 109
writeline:(1,0,0,1,1)#                 Number of refl.                  CL70 110
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL70 111
#                                                                       CL70 112
IF(TERMNT==yes:)#                      If convergence reached           CL70 113
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL70 114
IF(RSTORE(J+1)<=0.01)#                 Rwp not smaller                  CL70 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL70 116
NCY=NCYCLE#                            Terminate                        CL70 117
writeline:(0,CLI,NCLI,3,1)#            Refinement terminated            CL70 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL70 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL70 120
#                                                                       CL70 121
RETURN#                                                                 CL70 122
END#                                                                    CL70 123
systemheader:(CL80)#                   Matrix inversion                 CL80   1
#####################################################################   CL80   2
#                                                                   #   CL80   3
#                               CL80                                #   CL80   4
#                                                                   #   CL80   5
#####################################################################   CL80   6
SUBROUTINE CL80#                                                        CL80   7
include:(AACOMN)#                                                       CL80   8
include:(CLCOMN)#                                                       CL80   9
#                                                                       CL80  10
INTEGER J,K,P#          ## Indices                                      CL80  11
INTEGER LLM,LLMK,LLMP#  ## Pointers in matrix                           CL80  12
REAL    Q#              ## Multiplier                                   CL80  13
#                                                                       CL80  14
#       MATRIX INVERSION                                                CL80  15
#       ----------------                                                CL80  16
#                                                                       CL80  17
IF(LISTMX==yes:&NCY==NCYCLE) CALL CL81(1)# Prt direct matrix and vect   CL80  18
#                                                                       CL80  19
LLMK=MDMATX#                           Point to start of matrix         CL80  20
DO K=1,VARTOT#                         Loop over all variables          CL80  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL80  22
LLMP=MDMATX#                           Point to start of matrix         CL80  23
FOR(P=1;P<K;P=P+1)#                    Loop over 1 row                  CL80  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL80  25
Q=QX(LLMP+K)*QX(LLMP+P)#               Matrix element                   CL80  26
DO J=K,VARTOT#                                                          CL80  27
QX(LLMK+J)=QX(LLMK+J)-Q*QX(LLMP+J)#    Matrix                           CL80  28
QX(MDVECT+K)=QX(MDVECT+K)-Q*QX(MDVECT+P)# Vector                        CL80  29
LLMP=LLMP+VARTOT-P#                                                     CL80  30
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL80  31
ifne:(QX(LLMK+K),0.) QX(LLMK+K)=1./QX(LLMK+K)#                          CL80  32
LLMK=LLMK+VARTOT-K#                                                     CL80  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL80  34
#                                                                       CL80  35
LLM=LLMK#                                                               CL80  36
FOR(K=VARTOT;K>=1;K=K-1)#                                               CL80  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL80  38
QX(MDVECT+K)=QX(MDVECT+K)*QX(LLMK+K)#                                   CL80  39
LLMP=LLM#                                                               CL80  40
FOR(P=VARTOT;P>K;P=P-1)#                                                CL80  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL80  42
QX(MDTEMP+P)=QX(LLMK+K)*QX(LLMK+P)#                                     CL80  43
QX(MDVECT+K)=QX(MDVECT+K)-QX(MDTEMP+P)*QX(MDVECT+P)#                    CL80  44
IF(NCY!=NCYCLE) NEXT#                  Inversion only in last cycle     CL80  45
QX(LLMK+P)=-QX(MDTEMP+P)*QX(LLMP+P)#                                    CL80  46
FOR(J=P+1;J<=VARTOT;J=J+1)#                                             CL80  47
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL80  48
QX(LLMK+P)=QX(LLMK+P)-QX(MDTEMP+J)*QX(LLMP+J)#                          CL80  49
QX(LLMK+J)=QX(LLMK+J)-QX(MDTEMP+P)*QX(LLMP+J)#                          CL80  50
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL80  51
LLMP=LLMP-VARTOT+P-1#                                                   CL80  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL80  53
IF(NCY==NCYCLE)#                       Invert diag. el. last cycle      CL80  54
FOR(J=K+1;J<=VARTOT;J=J+1)#                                             CL80  55
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL80  56
QX(LLMK+K)=QX(LLMK+K)-QX(MDTEMP+J)*QX(LLMK+J)#                          CL80  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL80  58
LLMK=LLMK-VARTOT+K-1#                                                   CL80  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL80  60
IF(LISTMX==yes:&NCY==NCYCLE) CALL CL81(2)# Prt inverted matrix, shift   CL80  61
IF(LISTCM<=1.0&NCY==NCYCLE) CALL CL81(3)# Prt correlation matrix        CL80  62
#                                                                       CL80  63
#    CALCULATE ST.DEV. AND MOVE INTO MDTEMP-ARRAY                       CL80  64
#    --------------------------------------------                       CL80  65
#                                                                       CL80  66
LLM=MDMATX#                            Point to start of matrix         CL80  67
DO K=1,VARTOT#                         Loop over variables              CL80  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL80  69
QX(MDTEMP+K)=SQRT(ABS(QX(LLM+K)))*GOF# Sqrt(absval*sum(w*dsq)/(n-m))    CL80  70
LLM=LLM+VARTOT-K#                                                       CL80  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL80  72
#                                                                       CL80  73
RETURN#                                                                 CL80  74
END#                                                                    CL80  75
systemheader:(CL81)#                   Print matrix                     CL81   1
#####################################################################   CL81   2
#                                                                       CL81   3
#                               CL81                                    CL81   4
#                                                                       CL81   5
#####################################################################   CL81   6
SUBROUTINE CL81(KK)#                                                    CL81   7
include:(AACOMN)#                                                       CL81   8
include:(CLCOMN)#                                                       CL81   9
#                                                                       CL81  10
INTEGER I,J,K,M#        ## General indices                              CL81  11
REAL    FORM(13)#       ## Output format                                CL81  12
INTEGER KK#             ## Kk=1 direct  kk=2 inveted  kk=3 correlatio   CL81  13
INTEGER LLJ,LLK#        ## List pointers                                CL81  14
INTEGER MW#             ## Max words in line                            CL81  15
#                                                                       CL81  16
chardata:(CL1,DIRECT MATRIX     INVERTED MATRIX   CORRELATION MATRIX $# CL81  17
VECTOR)#                                                                CL81  18
chardata:(CL2, ROW    )#                                                CL81  19
chardata:(CL3, VARIABLE      - VARIABLE    $,  $#                       CL81  20
CORRELATION COEFFICIENT            )#                                   CL81  21
realdata:(FMT,[140413.,300413.,650632.])#                               CL81  22
datastuff:#                                                             CL81  23
#                                                                       CL81  24
#    SET UP PRINT &SAVE PARAMETERS                                      CL81  25
#    -----------------------------                                      CL81  26
#                                                                       CL81  27
MW=prtcmax:/10#                        No of items per line             CL81  28
DO K=1,MW;FORM(K)=FLOAT(K*100000+931)# Generate output format           CL81  29
#                                                                       CL81  30
#    PRINT MATRIX                                                       CL81  31
#    ------------                                                       CL81  32
#                                                                       CL81  33
K=KK*18-17#                            Point to matrix type             CL81  34
movechar:(CL1,K,CHROT,2,18,0)#         Insert matrix type               CL81  35
LINRM=8;writeline:(1,0,0,1,3)#         Print matrix header              CL81  36
writeline:(0,0,0,1,3)#                 Print blankline                  CL81  37
IF(KK==3&LISTCM>0.) KK=4#              Key for large elements only      CL81  38
LLK=MDMATX#                            Element pointer                  CL81  39
#                                                                       CL81  40
DO K=1,VARTOT#                         Loop over elements               CL81  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL81  42
IF(KK<=3)#                             Full matrix requested            CL81  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL81  44
ncodefld:(FLOAT(K),1,CL2,80313.,1)#    Format row                       CL81  45
writeline:(0,CL2,NCL2,3,3)#            Print row header                 CL81  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL81  47
LLJ=LLK+K#                             Element pointer                  CL81  48
DO J=K,VARTOT,MW#                      Loop over elements               CL81  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL81  50
I=MIN0(MW,VARTOT-J+1)#                 Limit length of line             CL81  51
movereal:(QX,LLK+J,BUFOT,1,I,0)#       Move elements                    CL81  52
IF(KK>=3) DO M=1,I#                    Correl. matrix requested         CL81  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL81  54
IF(QX(LLK+K)*QX(LLJ)>0.)$#             Zero or negative num             CL81  55
BUFOT(M)=BUFOT(M)/SQRT(QX(LLK+K)*QX(LLJ))# Correl. element              CL81  56
ELSE BUFOT(M)=0.#                                                       CL81  57
IF(KK==4)#                             If not full matrix               CL81  58
IF(ABS(BUFOT(M))>LISTCM&K!=J-1+M)#     List only values > listcm        CL81  59
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL81  60
BUFOT(I+1)=K;BUFOT(I+2)=J-1+M#         Row and col number               CL81  61
BUFOT(I+3)=BUFOT(M)#                   Corr. coeff.                     CL81  62
ncodefld:(BUFOT,I+1,CL3,FMT,3)#        Format output line               CL81  63
writeline:(0,CL3,NCL3,3,3)#            Print correlation coeff          CL81  64
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL81  65
LLJ=LLJ+VARTOT-J-M+2#                  Update diagonal pointer          CL81  66
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL81  67
IF(KK<=3)#                             Full matrix requested            CL81  68
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL81  69
ncodefld:(BUFOT,1,CHROT,FORM(1),I)#    Format output line               CL81  70
writeline:(0,0,0,1,3)#                 Print output line                CL81  71
$)$#                                                                    CL81  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL81  73
LLK=LLK+VARTOT-K#                      Update diagonal pointer          CL81  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL81  75
#                                                                       CL81  76
#     PRINT VECTOR                                                      CL81  77
#     ------------                                                      CL81  78
#                                                                       CL81  79
IF(KK>=3) RETURN#                      Quit after correlation matrix    CL81  80
movechar:(CL1,56,CHROT,2,6,0)#         Insert vector heading            CL81  81
LINRM=4;writeline:(1,0,0,1,3)#         Print vector heading             CL81  82
FOR(K=MDVECT;K<MDTEMP;K=K+MW)#         Loop over vector elements        CL81  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL81  84
I=MIN0(MW,MDTEMP-K)#                   Limit length of line             CL81  85
ncodefld:(QX,K+1,CHROT,FORM,I,0)#      Format vector line               CL81  86
writeline:(0,0,0,1,3)#                 Print vector line                CL81  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL81  88
#                                                                       CL81  89
RETURN#                                                                 CL81  90
END#                                                                    CL81  91
systemheader:(CL90)#                   Update/print general params      CL90   1
######################################################################  CL90   2
#                                                                    #  CL90   3
#                               CL90                                 #  CL90   4
#                                                                    #  CL90   5
######################################################################  CL90   6
SUBROUTINE CL90#                                                        CL90   7
#                                                                       CL90   8
include:(AACOMN)#                                                       CL90   9
include:(CLCOMN)#                                                       CL90  10
#                                                                       CL90  11
string:(OUTL,80)#                                                       CL90  12
INTEGER I,L#            ## General indices                              CL90  13
INTEGER IPP#            ## Pointer in op bdf                            CL90  14
INTEGER IR#             ## Pointer in mflag                             CL90  15
INTEGER ITW#            ## Indices in twin loop                         CL90  16
INTEGER LI#             ## Line count                                   CL90  17
REAL    R(9)#           ## Twin rotation matriX                         CL90  18
REAL    SCALE#          ## Frel scale factor                            CL90  19
INTEGER NP,NPT,PSIZ#    ## Maximum number of general parameters         CL90  20
#                                                                       CL90  21
chardata:(CL0,[ PARAMETERS AFTER CYCLE    ])#                           CL90  22
chardata:(CL1,                   SKF       UOV   FLACK-P$#              CL90  23
   EXTINCT.   TWIN PARAMETERS)#                                         CL90  24
chardata:(CL2,-OLD SHF NEW ERR S/E)#                                    CL90  25
chardata:(CL3, CUMULATIVE LEAST SQUARES CYCLES = XXXXX)#                CL90  26
chardata:(CL4, REMARK)#                                                 CL90  27
chardata:(CL5, NEW SCALE FACTOR)#                                       CL90  28
chardata:(CL6, UOV)#                                                    CL90  29
chardata:(CL7, XABS)#                                                   CL90  30
chardata:(CL8, EXTINC ZACH IS GAUS )#                                   CL90  31
realdata:(FORM,[220752.,320952.,420952.,520952.,620952.,720952.,#       CL90  32
820952.,920952.,1020952.,1120952.,1220952.,1320952.])#                  CL90  33
datastuff:#                                                             CL90  34
#                                                                       CL90  35
IF(VARGEN==0) RETURN#                                                   CL90  36
#                                                                       CL90  37
#    INITIALIZATIONS                                                    CL90  38
#    ---------------                                                    CL90  39
#                                                                       CL90  40
BUFOT(1)=FLOAT(NCY)#                   Store cycle number               CL90  41
ncodefld:(FLOAT(NCY),1,CL0,260213.,1)# Format cycle number              CL90  42
movechar:(CL2,1,CHROT,2,NCL0-1,1)#     Underline header                 CL90  43
writeline:(1,CL0,NCL0,2,3)#            Parameters after cycle ..        CL90  44
SOEMAX=0.0;SOEAVE=0.#                  Shift/error max & average        CL90  45
NP=4;L=13#                             Max nr of general param          CL90  46
movereal:(voidflg:,1,BUF,1,75,2)#      Zero op field buffer             CL90  47
LINRM=10#                              Set min number of lines          CL90  48
#                                                                       CL90  49
#    UPDATE GENERAL PARAMETERS                                          CL90  50
#    -------------------------                                          CL90  51
#                                                                       CL90  52
BUF(1)=SQRT(SKF);BUF(2)=UOV;BUF(3)=XABS# Old values scale,uov,xabs      CL90  53
DO I=4,NP;BUF(I)=QX(MEXTI+3)#          Extinction (g)                   CL90  54
DO I=1,NTWIN;BUF(NP+I)=QX(MTWIN-3+13*I)# Twin params                    CL90  55
NPT=NP+NTWIN#                          Pointer to twin params           CL90  56
DO I=1,NPT;BUF(75+I)=BUF(I)#           Save for later use               CL90  57
IF(APPUOV==no:) BUF(2)=voidflg:#       Set void field uov               CL90  58
IF(APPABS==no:) BUF(3)=voidflg:#       Set void field xabs              CL90  59
IF(APPEXT==no:)#                       Set void fields                  CL90  60
DO I=4,NP;BUF(I)=voidflg:#             Extinction (g)                   CL90  61
IF(NTWIN==1)#                          Set void fields                  CL90  62
DO I=NP+1,NPT;BUF(I)=voidflg:#         Twin fractions                   CL90  63
DO I=1,NPT#                            Loop over general parameters     CL90  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL90  65
L=L+10;IR=NINT(QX(MFLAG+I))#           Set pntr for ref. flags          CL90  66
IF(IR>0)#                              Refined parameter                CL90  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL90  68
IF(I==1)#                              Scale factor                     CL90  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL90  70
BUF(16)=QX(MDVECT+1)*BUF(1)#           Relative shift                   CL90  71
BUF(46)=QX(MDTEMP+1)*BUF(1)#           Relative stdev                   CL90  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL90  73
ELSE#                                  All other general params         CL90  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL90  75
BUF(15+I)=QX(MDVECT+IR)#               Put shifts in print buffer       CL90  76
BUF(45+I)=QX(MDTEMP+IR)#               Put stdev in print buffer        CL90  77
IF(I>4&DAMPST*BUF(15+I)<-BUF(I))#      No negative twin allowed         CL90  78
BUF(15+I)=-.5*BUF(I)#                  Try half value                   CL90  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL90  80
IF(I==3)#                              Check xabs                       CL90  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL90  82
#IF(DAMPST*BUF(18)<-XABS) BUF(18)=-XABS/DAMPST# ENSURE REALISTIC XABS ^ CL90  83
#IF(DAMPST*BUF(18)>1.-XABS)BUF(18)=(1.-XABS)/DAMPST#                  ^ CL90  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL90  85
IF(I==4)#                              Check extinction param           CL90  86
IF(QX(MEXTI+3)+DAMPST*BUF(19)<0.)#     Ensure positive extinc param     CL90  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL90  88
BUF(19)=0.;BUF(49)=1.#                 Reset shift and esd              CL90  89
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL90  90
BUF(30+I)=BUF(I)+DAMPST*BUF(15+I)#     Calculate new parameters         CL90  91
BUF(60+I)=ABS(BUF(15+I))/MAX(.1E-7,BUF(45+I))# Calc shift/stdev         CL90  92
BUF(75+I)=BUF(30+I)#                   Save for op on bdf & punch       CL90  93
SOEAVE=SOEAVE+BUF(60+I)#               Sum s/e                          CL90  94
SOEMAX=AMAX1(SOEMAX,BUF(60+I))#        Save s/e max                     CL90  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL90  96
ELSE ifnv:(BUF(I)) CHROT(L^L)='n'#     Flag as noref                    CL90  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL90  98
SKF=BUF(76)**2;UOV=BUF(77);XABS=BUF(78)# Store new skf,uov,xabs         CL90  99
DO I=4,NP;QX(MEXTI-1+I)=BUF(75+I)#     Extinction (g)                   CL90 100
IF(NTWIN>1)#                           If twin fractions applied        CL90 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL90 102
IF(REFTWI==yes:)#                                                       CL90 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL90 104
BUF(35)=1.#                            Set sum twin factors             CL90 105
DO ITW=2,NTWIN;BUF(35)=BUF(35)-BUF(34+ITW)# Constrain first twin frac   CL90 106
IF(BUF(35)<0.) iquit:(CL9001)#         Quit if -ve                      CL90 107
BUF(80)=BUF(35);CHROT(63^63)='c'#      Constrained param                CL90 108
DO I=1,NTWIN;QX(MTWIN-3+13*I)=BUF(79+I)# Store new twin fractions       CL90 109
QX(MTWIN+11)=0.#                       Set esd first fraction           CL90 110
DO I=2,NTWIN#                                                           CL90 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CL90 112
ifnv:(BUF(49+I)) QX(MTWIN-2+13*I)=BUF(49+I)# Store esd twin fractions   CL90 113
QX(MTWIN+11)=QX(MTWIN+11)+BUF(49+I)*BUF(49+I)# Esd first fraction       CL90 114
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CL90 115
QX(MTWIN+11)=SQRT(QX(MTWIN+11)/(NTWIN-1))# Std first fraction           CL90 116
BUF(20)=BUF(35)-BUF(5);BUF(50)=QX(MTWIN+11)# Sf & std  first fraction   CL90 117
IF(BUF(50)>0.1E-7)#                    Fudge                            CL90 118
BUF(65)=ABS(BUF(20))/BUF(50)#          S/e first fraction               CL90 119
ELSE BUF(65)=voidflg:#                 Fudge to highlight               CL90 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL90 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL90 122
writeline:(1,CL1,NCL1,3,3)#            Print header                     CL90 123
DO LI=1,5#                             Loop over print lines            CL90 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CL90 125
movechar:(CL2,LI*4-2,CHROT,11,3,0)#    Insert line header               CL90 126
ncodefld:(BUF,LI*15-14,CHROT,FORM(1),NPT)# Format values                CL90 127
writeline:(0,0,0,1,3)#                 Print parameter line             CL90 128
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CL90 129
#                                                                       CL90 130
#    UPDATE BINARY DATA FILE                                            CL90 131
#    -----------------------                                            CL90 132
#                                                                       CL90 133
IF(NCY==NCYCLE)#                       If last cycle                    CL90 134
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CL90 135
rewindbdf:(1)#                         Rewind input bdf                 CL90 136
IF(NTWIN>1)#                           If twin fractions applied        CL90 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CL90 138
copyfile:(1,2,1,decr:(lrtwin:))#       Copy file until lrexpl:          CL90 139
IP=1;DO WHILE(IP>0);readwpkt:(1,lrtwin:,PSIZ,IP,0)# Skip over lrtwin    CL90 140
DO ITW=1,NTWIN#                        Loop over twin fractions         CL90 141
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CL90 142
writepkt:(2,lrtwin:,13,IPP)#           Initialize output packet         CL90 143
movereal:(0.,1,QX(IPP+1),1,13,0)#      Set all values zero              CL90 144
movereal:(QX,MTWIN-12+13*ITW,QX,IPP+1,13,1)# Move new twin data         CL90 145
IF(APPABS==yes:)#                      If flack param applied           CL90 146
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CL90 147
QX(IPP+12)=XABS*QX(IPP+10)#            -ve friedel part of fraction     CL90 148
QX(IPP+13)=XABS*QX(IPP+11)#                                             CL90 149
#QX(IPP+13)=BUF(48)*QX(IPP+12)+QX(IPP+11)*XABS# ESD                     CL90 150
QX(IPP+10)=(1.-XABS)*QX(IPP+10)#       Friedel part of fraction         CL90 151
QX(IPP+11)=(1.-XABS)*QX(IPP+11)#                                        CL90 152
#QX(IPP+11)=QX(IPP+13)#                 ESD                             CL90 153
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CL90 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CL90 155
copyfile:(1,2,incr:(lrtwin:),decr:(lrexpl:))# Copy file until lrexpl:   CL90 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CL90 157
ELSE copyfile:(1,2,1,decr:(lrexpl:))#  Copy file until lrexpl:          CL90 158
CALL CL01(lrexpl:)#                    Read index packet                CL90 159
REPEAT#                                Loop over lrexpl: packets        CL90 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CL90 161
readwpkt:(1,lrexpl:,PACK,IP,2)#        Read lrexpl: packet              CL90 162
IF(IP==0) BREAK#                       Break after last packet          CL90 163
writepkt:(2,lrexpl:,KEY(4),IPP)#       Initialize output packet         CL90 164
movereal:(QX,IP+1,QX,IPP+1,PACK,0)#    Transfer packet                  CL90 165
ifne:(DATSET,QX(IP+IREL(1))) NEXT#     Skip incorrect data sets         CL90 166
SCALE=SQRT(1./SKF)#                    Frel scale factor                CL90 167
QX(IPP+IREL(2))=SCALE#                 Save scale factor                CL90 168
movechar:(CL5,2,CHROT,2,9,0)#          Insert 'new scale'               CL90 169
ncodefld:(QX,IPP+IREL(2),CHROT,FORM(1),1)# Format new scale             CL90 170
writeline:(1,0,0,1,3)#                 Print line                       CL90 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CL90 172
CALL CL01(lrdset:)#                    Read index packet                CL90 173
REPEAT#                                Loop over lrdset packets         CL90 174
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CL90 175
readwpkt:(1,lrdset:,PACK,IP,2)#        Read lrdset: packet              CL90 176
IF(IP==0) BREAK#                       Break after last packet          CL90 177
writepkt:(2,lrdset:,KEY(4),IPP)#       Initialize output packet         CL90 178
movereal:(QX,IP+1,QX,IPP+1,PACK,0)#    Transfer packet                  CL90 179
ifne:(DATSET,QX(IP+IREL(1))) NEXT#     Skip incorrect data sets         CL90 180
IF(REFUOV==yes:) QX(IPP+IREL(2))=UOV#  Save uov                         CL90 181
IF(REFABS==yes:) QX(IPP+IREL(25))=XABS# Save flack parameter            CL90 182
IF(REFEXT==yes:)#                                                       CL90 183
QX(IPP+IREL(10))=QX(MEXTI+3)*10000.#   Save extinction param            CL90 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CL90 185
copyfile:(1,2,incr:(lrdset:),decr:(lratom:))# Copy bdf until lratom:    CL90 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CL90 187
#                                                                       CL90 188
#    PUNCH NEW PARAMETERS                                               CL90 189
#    --------------------                                               CL90 190
#                                                                       CL90 191
IF(PUNCH==yes:&NCY==NCYCLE)#           Punch remark-card if requ.       CL90 192
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CL90 193
movechar:(BLANK,1,OUTL,1,80,1)#        Blank out punch buffer           CL90 194
movechar:(CL4,2,OUTL,1,6,0)#           Insert remark code               CL90 195
movechar:(TITLE,9,OUTL,10,17,0)#       Insert program,comp and date     CL90 196
movechar:(CL3,2,OUTL,30,25,0)#         Insert cycle                     CL90 197
ncodefld:(FLOAT(NCY),1,OUTL,580313.,1)# Insert cycle number             CL90 198
writepch:(OUTL,80)#                    Punch out remark card            CL90 199
movechar:(BLANK,1,OUTL,1,80,1)#        Blank out punch buffer           CL90 200
movechar:(CL5,6,OUTL,1,5,0)#           Insert 'scale factor'            CL90 201
ncodefld:(SCALE,1,OUTL,210941.,1)#     Insert scale                     CL90 202
writepch:(OUTL,80)#                    Punch out remark card            CL90 203
IF(APPUOV==yes:)#                                                       CL90 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CL90 205
movechar:(BLANK,1,OUTL,1,80,1)#        Blank out punch buffer           CL90 206
movechar:(CL6,2,OUTL,1,NCL6-1,0)#      Insert 'over tdp'                CL90 207
ncodefld:(UOV,1,OUTL,210941.,1)#       Insert uov                       CL90 208
writepch:(OUTL,80)#                    Punch out remark card            CL90 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CL90 210
IF(APPABS==yes:)#                      If flack param                   CL90 211
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CL90 212
movechar:(BLANK,1,OUTL,1,80,1)#        Blank out punch buffer           CL90 213
movechar:(CL7,2,OUTL,1,NCL7-1,0)#      Insert 'flack param'             CL90 214
ncodefld:(XABS,1,OUTL,210941.,1)#      Insert flack param               CL90 215
writepch:(OUTL,80)#                    Punch out remark card            CL90 216
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CL90 217
IF(APPEXT==yes:)#                      If extinction                    CL90 218
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CL90 219
movechar:(BLANK,1,OUTL,7,80,1)#        Blank out punch buffer           CL90 220
movechar:(CL8,2,OUTL,1,NCL8-1,0)#      Insert 'extinction'              CL90 221
ncodefld:(QX(MEXTI+3)*10000.,1,OUTL,350941.,1)# Insert extinction       CL90 222
writepch:(OUTL,80)#                    Punch out remark card            CL90 223
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CL90 224
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CL90 225
#                                                                       CL90 226
RETURN#                                                                 CL90 227
END#                                                                    CL90 228
systemheader:(CL91)#                   Update/print atom parameters     CL91   1
######################################################################  CL91   2
#                                                                    #  CL91   3
#                               CL91                                 #  CL91   4
#                                                                    #  CL91   5
######################################################################  CL91   6
SUBROUTINE CL91#                                                        CL91   7
include:(AACOMN)#                                                       CL91   8
include:(CLCOMN)#                                                       CL91   9
#                                                                       CL91  10
INTEGER I,J,K,L#        ## General indices                              CL91  11
INTEGER IA#             ## Atom index                                   CL91  12
INTEGER IC#             ## Constraints index                            CL91  13
INTEGER IR#             ## Constraints pointer                          CL91  14
INTEGER LI,NLI#         ## Number of op lines                           CL91  15
#                                                                       CL91  16
chardata:(CL1," Atom               x/a     y/b     z/c      U$#         CL91  17
     U11     U22     U33     U12     U13     U23     pop")#             CL91  18
chardata:(CL2, OLD SHF NEW ERR S/EATOM)#                                CL91  19
realdata:(FMTA,[220742.,300742.,380742.,460752.,540742.,#               CL91  20
620742.,700742.,780742.,860742.,940742.,1020732.])#                     CL91  21
datastuff:#                                                             CL91  22
#                                                                       CL91  23
#    INITIALIZATIONS                                                    CL91  24
#    ---------------                                                    CL91  25
#                                                                       CL91  26
IC=MFLAG+NFLAG#                        Pointer in noref array           CL91  27
#                                                                       CL91  28
#    UPDATE ATOM PARAMETERS                                             CL91  29
#    ----------------------                                             CL91  30
#                                                                       CL91  31
writeline:(1,0,0,1,3);LINRM=6#         Print blank line                 CL91  32
FOR(IA=MATOM;IA<LATOM;IA=IA+NATOM)#    Loop over the atoms              CL91  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL91  34
movereal:(voidflg:,1,BUF,1,66,2)#      Zero op field buffer             CL91  35
movereal:(xf:,1, BUF,1,11,0)#          X to pop                         CL91  36
movereal:(BUF,1,BUF,56,11,1)#          Set unshifted new values         CL91  37
IC=IC+NFLAG;L=15;NLI=1#                Initialize for this atom         CL91  38
#                                                                       CL91  39
DO I=1,11#                             Loop over parameters             CL91  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL91  41
L=L+8;IR=NINT(QX(IC+I))#               Set pntr for ref. flags          CL91  42
IF(IR==0)#                             Noref parameter                  CL91  43
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL91  44
ifnv:(BUF(I)) CHROT(L^L)='n'#          Flag as noref                    CL91  45
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL91  46
ELSE IF(IR>CC)#                        Constrained parameter            CL91  47
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL91  48
CHROT(L^L)='c'#                        Flag as constrained              CL91  49
J=NINT(QX(IR+3))#                      Get ref vect addr                CL91  50
BUF(11+I)=QX(IR+6)*QX(MDVECT+J)#       Calc shift                       CL91  51
BUF(33+I)=QX(IR+6)*QX(MDTEMP+J)#       Calc stdev                       CL91  52
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL91  53
ELSE#                                  Refined par                      CL91  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL91  55
NLI=5#                                 Number of op lines               CL91  56
BUF(11+I)=QX(MDVECT+IR)#               Put shifts in print buffer       CL91  57
BUF(33+I)=QX(MDTEMP+IR)#               Put stdev. in print buffer       CL91  58
IF(BUF(33+I)<small:) NEXT#             Skip if invariant                CL91  59
BUF(44+I)=ABS(BUF(11+I)/BUF(33+I))#    Calc shift/std dev               CL91  60
SOEAVE=SOEAVE+BUF(44+I)#               Sum s/o                          CL91  61
SOEMAX=AMAX1(SOEMAX,BUF(44+I))#        Save s/e max                     CL91  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL91  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL91  64
DO I=1,11#                             Loop over parameters             CL91  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL91  66
ifeq:(QX(IC+I),0.) NEXT#               Noref param                      CL91  67
BUF(22+I)=BUF(I)+DAMPST*BUF(11+I)#     Calculate new parameters         CL91  68
QX(IA+6+I)=BUF(22+I)#                  Store new values                 CL91  69
QX(IA+17+I)=BUF(33+I)#                 Store stdev.                     CL91  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL91  71
CALL CL92(IA,IC)#                      Test thermal displ params        CL91  72
DO LI=1,NLI#                           Loop over print lines            CL91  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL91  74
I=LI*11-11#                            Set output pntr                  CL91  75
IF(LI==1) movertoc:(na:,1,CHROT,2,8,0)# Insert atom name                CL91  76
movechar:(CL2,LI*4-3,CHROT,10,4,0)#    Insert line header               CL91  77
IF(LI!=5)#                             If not e/s line                  CL91  78
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL91  79
ifeq:(dp:,1.)#                         Id iso tdp's                     CL91  80
ifnv:(BUF(I+4)) BUF(I+4)=BUF(I+4)/utob:# Convert b to u                 CL91  81
ifeq:(dp:,2)#                          If aniso tdp's                   CL91  82
DO K=5,10#                             Loop over aniso tdp's            CL91  83
ifnv:(BUF(K+I)) BUF(I+K)=BUF(I+K)*CONV(K-4)# Convert betaij to uij      CL91  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL91  85
ncodefld:(BUF,I+1,CHROT,FMTA(1),11)#   Format values                    CL91  86
writeline:(0,CL1,NCL1,1,3)#            Print atom line                  CL91  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL91  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL91  89
#                                                                       CL91  90
RETURN#                                                                 CL91  91
END#                                                                    CL91  92
systemheader:(CL92)#                   Test for non-pos. definite       CL92   1
######################################################################  CL92   2
#                                                                       CL92   3
#                               CL92                                    CL92   4
#                                                                       CL92   5
######################################################################  CL92   6
SUBROUTINE CL92(IA,IC)#                                                 CL92   7
include:(AACOMN)#                                                       CL92   8
include:(CLCOMN)#                                                       CL92   9
#                                                                       CL92  10
REAL    FFACT#          ## Multiplacaion factor                         CL92  11
INTEGER I,I1,I2,J#      ## General indices                              CL92  12
INTEGER IA#             ## Pointer in atom array                        CL92  13
INTEGER IC#             ## Pointer in constraints array                 CL92  14
INTEGER IE#             ## Error flag                                   CL92  15
REAL    Q,Q1,Q2,Q3#     ## Determinant and minors                       CL92  16
#                                                                       CL92  17
chardata:(CL3, UIJ MATRIX FOR ATOM          NOT $#                      CL92  18
POSITIVE DEFINITE -- SHIFTS MULTIPLIED BY            )#                 CL92  19
datastuff:#                                                             CL92  20
#                                                                       CL92  21
#       CHECK IF DP POSITIVE DEFINITE                                   CL92  22
#       -----------------------------                                   CL92  23
#                                                                       CL92  24
IE=0#                                  Error flag                       CL92  25
ifeq:(dp:,1.) IF(ub:<0.)#              Negative uios                    CL92  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL92  27
J=-BUF(4)/(DAMPST*BUF(15))*20;FFACT=J*.05# Fudge factor                 CL92  28
ub:=BUF(4)+FFACT*DAMPST*BUF(15)#       Calculate new value              CL92  29
IE=1;I1=0;I2=0#                        Error flag for usio              CL92  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL92  31
ifeq:(dp:,2.)#                         If aniso tdp's                   CL92  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL92  33
DO J=1,20#                             Loop over 20 corrn of .05        CL92  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL92  35
DO I=1,3;IF(ub:(IA+I)<0.) IE=1#        Uii is negative                  CL92  36
IF(IE==0)#                             When positive diag. el.          CL92  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL92  38
Q1=ub:(IA+1)*ub:(IA+2)-ub:(IA+4)*ub:(IA+4)# Minor                       CL92  39
Q2=ub:(IA+1)*ub:(IA+3)-ub:(IA+5)*ub:(IA+5)# Minor                       CL92  40
Q3=ub:(IA+2)*ub:(IA+3)-ub:(IA+6)*ub:(IA+6)# Minor                       CL92  41
IF(Q1<0.\Q2<0.\Q3<0.) Q=0.0#           Minors is negative               CL92  42
ELSE#                                                                   CL92  43
Q=    ub:(IA+1)*ub:(IA+2)*ub:(IA+3) + $# Determinant                    CL92  44
   2.*ub:(IA+4)*ub:(IA+5)*ub:(IA+6) - $#                                CL92  45
      ub:(IA+1)*ub:(IA+6)*ub:(IA+6) - $#                                CL92  46
      ub:(IA+2)*ub:(IA+5)*ub:(IA+5) - $#                                CL92  47
      ub:(IA+3)*ub:(IA+4)*ub:(IA+4)#                                    CL92  48
IF(Q>0.0) BREAK#                       Determinant must be pos.         CL92  49
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL92  50
DO I=1,6#                              Loop over dp                     CL92  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CL92  52
ifeq:(QX(IC+4+I),0.) NEXT#             Skip invariant parameters        CL92  53
ub:(IA+I)=ub:(IA+I)-DAMPST*.05*BUF(15+I)# Adjust dp elements            CL92  54
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CL92  55
IF(J==20) IE=1#                        Error                            CL92  56
ELSE IE=0#                             No error detected                CL92  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL92  58
IF(J>1)#                               If corrections are made          CL92  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CL92  60
FFACT=.05*(21-J)#                      Total adjustment                 CL92  61
I1=1;I2=6#                             Aniso indices                    CL92  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CL92  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL92  64
ifne:(FFACT,0.)#                       Print when fudge factor applie   CL92  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CL92  66
DO I=I1,I2#                            Loop over aniso dp shfts         CL92  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CL92  68
ifeq:(QX(IC+4+I),0.) NEXT#             Skip invariant parameters        CL92  69
BUF(15+I)=BUF(15+I)*FFACT#             Apply fudge to shifts            CL92  70
BUF(26+I)=ub:(IA+I)#                   Store new value                  CL92  71
BUF(48+I)=BUF(15+I)/BUF(37+I)#         Adjust shift/error               CL92  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CL92  73
movertoc:(na:,1,CL3,22,8,0)#           Move at atom name for print      CL92  74
ncodefld:(FFACT,1,CL3,870732.,1)#      Encode fudge factor              CL92  75
writeline:(0,CL3,NCL3,3,3)#            Tell of non-pos. definite        CL92  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CL92  77
#                                                                       CL92  78
RETURN#                                                                 CL92  79
END#                                                                    CL92  80
systemheader:(CL99)#                   Write o/p bdf's & quit           CL99   1
######################################################################  CL99   2
#                                                                    #  CL99   3
#                               CL99                                 #  CL99   4
#                                                                    #  CL99   5
######################################################################  CL99   6
SUBROUTINE CL99#                                                        CL99   7
include:(AACOMN)#                                                       CL99   8
include:(CLCOMN)#                                                       CL99   9
#                                                                       CL99  10
INTEGER EXTTYP#         ## Extinction type                              CL99  11
INTEGER I,J,K#          ## Indices                                      CL99  12
INTEGER JPAC,JP#        ## Output packet                                CL99  13
INTEGER TCYCLE#         ## Total cycle number                           CL99  14
#                                                                       CL99  15
chardata:(SFLS,'sfls:')#                                                CL99  16
chardata:(COEF,'F   FsqdInet')#                                         CL99  17
chardata:(WEIG,' unit calcsigma')#                                      CL99  18
chardata:(MATX,'atomblock     fulluserblock')#                          CL99  19
chardata:(EXTT,'   ZachariasenBecker-Coppens')#                         CL99  20
chardata:(EXTD,'Gaussian  Lorentzian')#                                 CL99  21
chardata:(ABSS,'Flack xabs refined')#                                   CL99  22
chardata:(EXTE,'Eq22 p292 "Cryst. Comp." Munksgaard 1970')#             CL99  23
chardata:(CL1," Refinement History-")#                                  CL99  24
chardata:(CL2," Cycle    R1      R2     GoF    Title")#                 CL99  25
chardata:(CL3," Maximum shift/error          ")#                        CL99  26
chardata:(CL4," Average shift/error          ")#                        CL99  27
chardata:(CL5," ****** QUITTING TIME ******* ")#                        CL99  28
realdata:(FMT,[40413.,120832.,200832.,200832.,280832.])#                CL99  29
datastuff:#                                                             CL99  30
#                                                                       CL99  31
copyfile:(1,2,incr:(lrrefl:),decr:(lrsfls:))#                           CL99  32
#                                                                       CL99  33
#    OUTPUT REFINEMENT DATA                                             CL99  34
#    ----------------------                                             CL99  35
#                                                                       CL99  36
PACK=arith:(arith:(w40c:,*,7),+,20)#   Set new packet length            CL99  37
writepkt:(2,lrsfls:,PACK,JP)#          Point to sfls directory pakt     CL99  38
QX(JP+1)=1.#                           Idn data set number              CL99  39
J=JP+1;    DO I=1,w40c:; QX(J+I)=11.#  Idn's overall refine process     CL99  40
J=J+w40c:; DO I=1,w40c:; QX(J+I)=12.#  Idn's sfls weighting scheme      CL99  41
J=J+w40c:; DO I=1,w40c:; QX(J+I)=13.#  Idn's sfls extinction process    CL99  42
J=J+w40c:; DO I=1,w40c:; QX(J+I)=14.#  Idn's sfls matrix description    CL99  43
J=J+w40c:; DO I=1,w40c:; QX(J+I)=15.#  Idn's sfls treatment hydrogens   CL99  44
J=J+w40c:; DO I=1,w40c:; QX(J+I)=16.#  Idn's sfls absolute structure    CL99  45
J=J+w40c:; DO I=1,w40c:; QX(J+I)=17.#  Idn's sfls extinction equ        CL99  46
J=J+w40c:; DO I=1,14;QX(J+I)=FLOAT(I+20)# Idn's of refinement rfactor   CL99  47
J=J+14;    DO I=1,5; QX(J+I)=FLOAT(I+40)# Idn's of refinement summary   CL99  48
#                                                                       CL99  49
writepkt:(2,lrsfls:,PACK,JP)#          Point to sfls data pakt          CL99  50
J=JP+1; QX(J)=DATSET#                  Store datset number              CL99  51
#                                                                       CL99  52
J=J+1; movector:(BLANK,1,QX(J),1,40,1)# Blank overall refine process    CL99  53
movector:(SFLS,1,QX(J),1,5,0)#         Store overall refine process     CL99  54
movector:(COEF,5,QX(J),7,4,0)#         Store refine coefficient         CL99  55
movector:(WEIG,WTSCHM*5-4,QX(J),12,5,0)# Store refine weight            CL99  56
movector:('weight',1,QX(J),18,6,0)#    Store refine weight              CL99  57
movector:(MATX,10,QX(J),25,9,0)#       Store sfls matrix used           CL99  58
movector:('matrix',1,QX(J),35,6,0)#    Store refine coefficient         CL99  59
#                                                                       CL99  60
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls weighting sche   CL99  61
movector:(WEIG,WTSCHM*5-4,QX(J),1,5,0)# Store sfls weighting scheme     CL99  62
#                                                                       CL99  63
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls extin process    CL99  64
IF(REFEXT==yes:)#                      If extinction applied            CL99  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CL99  66
EXTTYP=NINT(QX(MEXTI+1));I=NINT(QX(MEXTI+2))# Extinc type & distr       CL99  67
EXTTYP=MIN(EXTTYP,1)*14+1;I=MIN(I,1)*10+1# Point to ext.type & distr    CL99  68
movector:(EXTT,EXTTYP,QX(J),1,14,0)#   Store sfls extinction type       CL99  69
IF(EXTTYP>1) movector:(EXTD,I,QX(J),16,10,0)# Store extinction distr    CL99  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CL99  71
ELSE        movector:('none',1,QX(J),1,4,0)# No sfls extinction         CL99  72
#                                                                       CL99  73
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls matrix used      CL99  74
movector:(MATX,10,QX(J),1,9,0)#        Store sfls matrix used           CL99  75
#                                                                       CL99  76
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls hydr treatment   CL99  77
#MOVECTOR:(HYDN,1,QX(J),1,NHYDN,0)# STORE SFLS HYDR TREATMENT           CL99  78
#                                                                       CL99  79
J=J+w40c:;  movector:(BLANK,1,QX(J),1,40,1)# Blank sfls abs structure   CL99  80
IF(REFABS>0)movector:(ABSS,1,QX(J),1,NABSS,0)# Store sfls abs structu   CL99  81
ELSE        movector:('none',1,QX(J),1,4,0)# No sfls abs structure      CL99  82
#                                                                       CL99  83
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls extin equ        CL99  84
IF(QX(MEXTI+1)>0.&QX(MEXTI+2)<1.)#                                      CL99  85
movector:(EXTE,1,QX(J),1,40,0)#        Store extin equ                  CL99  86
#                                                                       CL99  87
J=J+w40c:-1;K=10*(MIN0(NCYCLE,10)-1)#  Reset op & restore pointers      CL99  88
DO I=1,8;QX(J+I)=RSTORE(K+I)#          Store r values                   CL99  89
QX(J+ 9)=SOEMAX;QX(J+10)=SOEAVE/VARTOT# Store max/mean s/d              CL99  90
QX(J+11)=0.#                           Rogers abs config factor         CL99  91
QX(J+12)=XABS#                         Flacks abs config factor         CL99  92
QX(J+13)=QX(MEXTI+3)*10000.#           Extinction g or rho              CL99  93
#                                                                       CL99  94
K=J+14#                                Separate op pointers             CL99  95
QX(K+ 1)=2.#                           Coeff type (2=f**2)              CL99  96
QX(K+ 2)=FLOAT(VARTOT)#                No. of refined parameters        CL99  97
QX(K+ 3)=RSUMS(7)#                     No. reflns used in refinement    CL99  98
QX(K+ 4)=RSUMS(8)#                     No. restrained parameters        CL99  99
QX(K+ 5)=RSUMS(9)#                     No. constrained parameters ???   CL99 100
#                                                                       CL99 101
#    PRINT AND STORE REFINEMENT HISTORY                                 CL99 102
#    ----------------------------------                                 CL99 103
#                                                                       CL99 104
LINRM=8#                               Leave enough space               CL99 105
movechar:(CL1,NCL1,CHROT,2,NCL1-2,2)#  Insert underline                 CL99 106
writeline:(1,CL1,NCL1-1,2,3)#          Print rfac data                  CL99 107
LINRM=2#                               Leave enough space               CL99 108
JPAC=arith:(arith:(39,/,mxchwd:),+,6)# Get lrrfac record length         CL99 109
TCYCLE=0#                              Total cycle number               CL99 110
REPEAT#                                Loop over rfac records           CL99 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CL99 112
readwpkt:(1,lrrfac:,PACK,IP,0)#        Read rfac records                CL99 113
writepkt:(2,lrrfac:,JPAC,JP)#          Point to next op packet          CL99 114
IF(IP>0)#                                                               CL99 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CL99 116
movereal:(QX,IP+1,QX,JP+1,PACK,0)#     Transfer current record          CL99 117
TCYCLE=QX(JP+1)#                       Store total cycle number         CL99 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CL99 119
ELSE#                                  End of previous rfactos          CL99 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CL99 121
J=(MIN0(NCYCLE,10)-1)*10#              Pointer in rstore array          CL99 122
QX(JP+1)=TCYCLE+FLOAT(NCYCLE)#         New total cycle number           CL99 123
QX(JP+2)=RSTORE(J+1)#                  Store rcode=1 r factor           CL99 124
QX(JP+3)=0.#                           Not used                         CL99 125
QX(JP+4)=RSTORE(J+5)#                  Store rcode=1 rw factor          CL99 126
QX(JP+5)=RSTORE(J+7)#                  Store rcode=1 g-o-f value        CL99 127
movector:(TITLE,59,QX(JP+6),1,40,0)#   Store current title              CL99 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CL99 129
ncodefld:(QX,JP+1,CHROT,FMT,5)#        Format rfac data                 CL99 130
movertoc:(QX(JP+6),1,CHROT,32,40,0)#   Store title string               CL99 131
writeline:(0,CL2,NCL2,1,3)#            Print rfac data                  CL99 132
IF(IP<=0) BREAK#                       Exit after last cycle            CL99 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CL99 134
#                                                                       CL99 135
## PRINT MAXIMUM AND AVERAGE SHIFT/ERROR AND CLOSE BDF                  CL99 136
#                                                                       CL99 137
ncodefld:(SOEMAX,1,CL3,301041.,1)#     Encode max shift/error           CL99 138
writeline:(2,CL3,NCL3,3,3)#            Print line                       CL99 139
ncodefld:(SOEAVE/VARTOT,1,CL4,301041.,1)# Encode ave shift/error        CL99 140
writeline:(1,CL4,NCL4,3,3)#            Print line                       CL99 141
#                                                                       CL99 142
copyfile:(1,2,incr:(lrrfac:),endrecord:)# Copy up to eof & close        CL99 143
writeline:(2,CL5,NCL5,3,3)#                                             CL99 144
#                                                                       CL99 145
RETURN#                                                                 CL99 146
END#                                                                    CL99 147
#                                                                       CL99 148
pmacro:([no:])#                        Purge xtal system macros         CL99 149
#                                                                       CL99 150
#                                                                       CL99 151
