systemheader:(GS    )#                                                  GS     1
####################################################################### GS     2
##      Copyright (C) 2000, The Xtal System, The University of        # GS     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # GS     4
## Distributed under the GNU General Public Licence as published by   # GS     5
## the Free Software Foundation, in the hope that it will be useful   # GS     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # GS     7
## for more details.                                                  # GS     8
#                                                                     # GS     9
#                            *** GENSIN ***                           # GS    10
#                                                                     # GS    11
#     THE PROGRAM GENSIN GENERATES TRIPLET AND QUARTET STRUCTURE      # GS    12
#     INVARIANT RELATIONSHIPS INVOLVING UP TO 1000 REFLECTIONS.       # GS    13
#     QUARTETS MAY BE SELECTED ACCORDING TO THEIR CROSS-VECTOR        # GS    14
#     SUMS. SEE ALSO GENEV AND GENTAN.                                # GS    15
#                                                                     # GS    16
####################################################################### GS    17
#                                                                       GS    18
include:(XMACRO)#                                                       GS    19
#                                                                       GS    20
macro:(raiseexception:,$(XCEPT=$1;RETURN$))# Throw an exception         GS    21
macro:(catchexception:,IF(XCEPT!=0)RETURN)# Catch an exception          GS    22
macro:(ib:,NINT(BUFIN($1)))#                                            GS    23
macro:(bf:,BUFIN($1))#                                                  GS    24
macro:(iqx:,NINT(QX($1)))#                                              GS    25
macro:(swapakwd:,$(movepakwd:($1,QIQI);movepakwd:($2,$1)#               GS    26
movepakwd:(QIQI,$2)$))#                                                 GS    27
macro:(swapi:,$(KIK=$1;$1=$2;$2=KIK$))#                                 GS    28
#                                                            Bits       GS    29
macro:(pphaserestr:, intpak:($2,QX($1+1), 0, 4))# 0 -  3                GS    30
macro:(pphisigncode:,intpak:($2,QX($1+1), 4, 3))# 4 -  6                GS    31
macro:(pphiinvshift:,intpak:($2,QX($1+1), 7, 4))# 7 - 10                GS    32
macro:(pphifragment:,intpak:($2,QX($1+1),11, 9))# 11 - 19               GS    33
macro:(pprobfactor:, intpak:($2,QX($1+1),20,bitlen:(20)))# 20 - 31      GS    34
#                                                                       GS    35
macro:(pxvectorsum:, intpak:($2,QX($1+2),10,10))# 10 - 19               GS    36
macro:(pprobfsigma:, intpak:($2,QX($1+2),20,bitlen:(20)))# 20 - 31      GS    37
#                                                                       GS    38
macro:(pgeneratornum:,      QX($1+2+$3)=FLOAT($2))#                     GS    39
#                                                                       GS    40
#                                                            Bits       GS    41
macro:(uphaserestr:, intunpak:(QX($1+1),$2, 0, 4))# 0 -  3              GS    42
macro:(uphisigncode:,intunpak:(QX($1+1),$2, 4, 3))# 4 -  6              GS    43
macro:(uphiinvshift:,intunpak:(QX($1+1),$2, 7, 4))# 7 - 10              GS    44
macro:(uphifragment:,intunpak:(QX($1+1),$2,11, 9))# 11 - 19             GS    45
macro:(uprobfactor:, intunpak:(QX($1+1),$2,20,bitlen:(20)))# 1 20 - 3   GS    46
#                                                                       GS    47
macro:(uxvectorsum:, intunpak:(QX($1+2),$2,10,10))# 10 - 10             GS    48
macro:(uprobfsigma:, intunpak:(QX($1+2),$2,20,bitlen:(20)))# 20 - 31    GS    49
#                                                                       GS    50
macro:(ugeneratornum:,         $2=NINT(QX($1+2+$3)))#                   GS    51
#                                                                       GS    52
macro:(comppakwdone:,compakwd:(QX($1+1),$2,$3,$4))# 1st inv word        GS    53
macro:(plastbitsword:,intpak:($1,$2,20,bitlen:(20)))# Pack pfactor      GS    54
macro:(pstrip:,5)#                     Packet size for triplets         GS    55
macro:(psquar:,6)#                     Packet size for quartets         GS    56
#                                                                       GS    57
extrude:(GSCOMN)#                                                       GS    58
REAL ABCT(3)#                          Preset a,b,cmin for s.i.         GS    59
REAL AH(3)#                            Index storage array              GS    60
REAL AMAX(3)#                          A,b,cmax found for s.i.          GS    61
REAL AMIN(3)#                          Actual a,b,cmin for s.i.         GS    62
REAL APMN#                             A,b,cmin to print s.i.           GS    63
REAL DSNM#                             Data set number                  GS    64
REAL EPSI#                             Maximum psio |e| limit           GS    65
REAL EMIN#                             Minimum |e| value                GS    66
REAL FMUL#                             Sf multiplicity                  GS    67
REAL HEAV#                             Heavy atom factor                GS    68
INTEGER I0,I1,I2#                      Temporary pointers to qx         GS    69
INTEGER ICNT#                          Centre flag nonc=0, cent=1       GS    70
INTEGER IETY#                          |e|-type flag 1 & 2              GS    71
INTEGER IEXT#                          Phi extention (ext=1)            GS    72
INTEGER IFC#                           Fc pointer                       GS    73
INTEGER IFRG(20)#                      Fragment types 1 to 4            GS    74
INTEGER IFSI(3)#                       S.i. search flag (1=yes)#        GS    75
INTEGER IH(3)#                         Gen purpose hkl array            GS    76
INTEGER IM00#                          Centre of h1max-h2h3 table       GS    77
INTEGER INCR#                          H1 increment due to centre       GS    78
INTEGER IP00#                          Centre h1=0 addr-h2h3 table      GS    79
INTEGER IPS#                           Phi pointer & flag               GS    80
INTEGER IS2(4),IS3(4)#                 Possible signs of h2,h3          GS    81
INTEGER IR(22)#                        Pointer to wanted idnums         GS    82
INTEGER IW(21)#                        Array of requested idnums        GS    83
INTEGER IXVF#                          Xvfl(no=0,in=1,all=2,ex=3)       GS    84
INTEGER JD1,JD2,JD3#                   H1,h2,h3 to h,k,l decodes        GS    85
INTEGER JE1,JE2,JE3#                   H,k,l to h1,h2,h3 encodes        GS    86
INTEGER JH(8),JK(8),JL(8)#             H1,h2,h3 sign table              GS    87
INTEGER JS2(8),JS3(8),JS4(8)#          Phi2,3,4 sign table              GS    88
INTEGER KEY(4)#                        Control array for indexpkt       GS    89
INTEGER LTYP#                          Lattice type p,i,r,f,a,b,c       GS    90
INTEGER CSYS#                          Crystal sys: t m o t tr r h c    GS    91
INTEGER MARK#                          Length of parent gen packet      GS    92
INTEGER MAXG#                          Maximum generators               GS    93
INTEGER MAXP#                          Maximum psi0 generators          GS    94
INTEGER MDSI(3)#                       Structure invariant moduli       GS    95
INTEGER MODE#                          Modify e flag                    GS    96
INTEGER MQ#                            End mark of acentric rmats       GS    97
INTEGER MX2L#                          Length of h2 of h2h3 table       GS    98
INTEGER MX4L#                          Twice h2 edge of h2h3 table      GS    99
INTEGER MXIG(3)#                       Preset max s.i./generator        GS   100
INTEGER MXH1,MXH2,MXH3#                Max |h1|,|h2|,|h3|               GS   101
INTEGER MXSI(3)#                       Max no. of trip,quar,quin        GS   102
INTEGER N1PS#                          Min gen n1 to be printed         GS   103
INTEGER N1PE#                          Max gen n1 to be printed         GS   104
INTEGER NNPE#                          Max gen no. to be printed        GS   105
INTEGER NEQV#                          Refln equivalence no. 7-0        GS   106
INTEGER NFRG#                          Qphi flag & frag counter         GS   107
INTEGER NGEN#                          Number of generators             GS   108
INTEGER NODR#                          No. of origin def reflns         GS   109
INTEGER NONR#                          No. of nonrestr. odrs            GS   110
INTEGER NGPT#                          Generator print threshold        GS   111
INTEGER NREF#                          No. of#reflns entered            GS   112
INTEGER NROT#                          No. of rotation matrices         GS   113
INTEGER NRMZ#                          No. of rmat with same 0's        GS   114
INTEGER NSYM#                          Total number symops              GS   115
INTEGER NTOT#                          Total gen (par+eqv) list#        GS   116
REAL OSMX#                             Overall data limit smax          GS   117
REAL PFAC#                             Prob. factor (==n**.5)           GS   118
INTEGER Q0#                            Start-1 of order table           GS   119
INTEGER Q1#                            Start-1 of symop table           GS   120
INTEGER Q2#                            Start-1 of h2h3 tables           GS   121
INTEGER Q3#                            Start-1 of generator list        GS   122
INTEGER QQ#                            Start-1 of psi0 generators       GS   123
INTEGER Q4#                            Start-1 of reflection list       GS   124
INTEGER Q5#                            Start-1 of sin/cos table         GS   125
INTEGER Q6#                            Start-1 of a/pop. table          GS   126
REAL RM(3,3)#                          Trans. matrix hkl to prim.       GS   127
REAL SGET#                             Sigma |e| threshold              GS   128
REAL SIMX(3)#                          Actual invariant counts          GS   129
REAL SIVC(3,3)#                        Structure invariant vectors      GS   130
REAL SMIN#                             Actual st/l minimum              GS   131
REAL SMAX#                             Actual st/l maximum              GS   132
REAL STMN#                             Sin theta/lambda minimum         GS   133
REAL STMX#                             Sin theta/lambda maximum         GS   134
REAL XVMN#                             X-vector |e| minimum             GS   135
REAL XVMX#                             X-vector |e| maximum             GS   136
REAL XSLO#                             X-vector sum lo thresh           GS   137
REAL XSHI#                             X-vector sum hi thresh           GS   138
INTEGER XCEPT#                         Throw an exception               GS   139
#                                                                       GS   140
COMMON /COMIGS/$#                                                       GS   141
I0,I1,I2,ICNT,IETY,IFRG,IFSI,IH,IM00,IP00,#                             GS   142
INCR,IS2,IS3,IR,IW,IXVF,IEXT,IFC,IPS,#                                  GS   143
JD1,JD2,JD3,JE1,JE2,JE3,JH,JK,JL,KEY,#                                  GS   144
JS2,JS3,JS4,LTYP,Q0,Q1,Q2,Q3,QQ,Q4,Q5,Q6,MQ,MAXP,#                      GS   145
MAXG,MDSI,MX2L,MX4L,MXIG,MXH1,MXH2,MXH3,MXSI,#                          GS   146
N1PS,N1PE,NNPE,NEQV,NFRG,NGEN,NODR,NGPT,MARK,#                          GS   147
NONR,NREF,NROT,NRMZ,NTOT,NSYM,MODE,CSYS,XCEPT#                          GS   148
#                                                                       GS   149
COMMON /COMFGS/$#                                                       GS   150
ABCT,AH,AMIN,AMAX,APMN,DSNM,EPSI,EMIN,FMUL,HEAV,#                       GS   151
OSMX,PFAC,SGET,SIMX,STMX,SIVC,STMN,RM,XVMN,XVMX,XSLO,XSHI,#             GS   152
SMIN,SMAX#                                                              GS   153
#                                                                       GS   154
endext:#                                                                GS   155
#                                                                       GS   156
systemheader:(GS00)#                   Generate struct. invariants      GS00   1
####################################################################    GS00   2
#                                                                  #    GS00   3
#                             GS00                                 #    GS00   4
#                                                                  #    GS00   5
####################################################################    GS00   6
SUBROUTINE GS00#                       S.r.hall  apr 81                 GS00   7
include:(AACOMN)#                                                       GS00   8
include:(GSCOMN)#                                                       GS00   9
#                                                                       GS00  10
FILEXT(IOUNIT(3))='XX1'#               Scratch file extension           GS00  11
FILEXT(IOUNIT(4))='INV'#               Invariant file extension         GS00  12
FILEXT(iofm1:)   ='GS0'#               Dump of gensin control lines     GS00  13
FILEXT(iofm2:)   ='GS1'#               Re-entrant fmt file              GS00  14
openfmt:(iofm1:,' ')#                  Open it                          GS00  15
#                                                                       GS00  16
## File structure of invariant file 4 .inv                              GS00  17
##   Record 2   Fixed length 100 words  inv descriptor information      GS00  18
##   Record 3   Var. length  contains   MAXG generators and             GS00  19
##                                      MAXP PSI0 generators            GS00  20
##   Record 4   Var. Invariants for generator 1                         GS00  21
##   Record 5   Var. Invariants for generator 2                         GS00  22
##   Record N   Var. Invariants for generator  N-3  = MAXG              GS00  23
##   Record N+1 Var. Invariants for PSI0 generator 1                    GS00  24
##   Record N+...Var. Invariants for PSI0 generator  1 ...MAXG          GS00  25
##                                                                      GS00  26
CALL GS01#                             Enter control lines and bdf      GS00  27
CALL GS02#                             Prepare symmetry & odr data      GS00  28
CALL GS03#                             Process refln data from bdf      GS00  29
catchexception:#                       Abandon ship ?                   GS00  30
CALL GS04#                             Sort reflns & generator lists    GS00  31
CALL GS05#                             Prepare refln lists & h2h3 tab   GS00  32
IF(IFSI(1)>0) CALL GS06#               Generate triplets                GS00  33
IF(IFSI(2)>0) CALL GS07#               Generate quartets                GS00  34
CALL GS10#                             Sort invariants & list generat   GS00  35
CALL GS11#                             Output invariants on inv file    GS00  36
#                                                                       GS00  37
RETURN#                                                                 GS00  38
END#                                                                    GS00  39
systemheader:(GS01)#                   Enter control lines & bdf        GS01   1
####################################################################    GS01   2
#                                                                  #    GS01   3
#                             GS01                                 #    GS01   4
#                                                                  #    GS01   5
####################################################################    GS01   6
SUBROUTINE GS01#                       S.r.hall  apr 81                 GS01   7
include:(AACOMN)#                                                       GS01   8
include:(GSCOMN)#                                                       GS01   9
#                                                                       GS01  10
INTEGER I,J,K,KIK,L,N,IP,NP#                                            GS01  11
INTEGER MAXGG#                         Arbitrary generator limit        GS01  12
REAL A,B,C,D,HNON,RMAX#                                                 GS01  13
chardata:(SN1, TRIP QUAR QUIN GENER PRINT PSICAL CHANGE END )#          GS01  14
chardata:(SN2, Q N Y X I A E R E )#                                     GS01  15
chardata:(SN3, SM DS ET QP NQ NA )#                                     GS01  16
intdata:(M,0)#                                                          GS01  17
datastuff:#                                                             GS01  18
#                                                                       GS01  19
MQ=0#                                                                   GS01  20
DO I=1,4; IS2(I)=0#                                                     GS01  21
DO I=1,4; IS3(I)=0#                                                     GS01  22
DO I=1,20; IFRG(I)=0#                                                   GS01  23
NFRG=yes:#                             Default q-flag is on             GS01  24
MODE=yes:#                             Default modify |e|'s on          GS01  25
OSMX=2.#                               Default overall st/l max         GS01  26
DSNM=1.#                               Default datsetnum is one         GS01  27
IETY=1#                                Default e-type is one            GS01  28
MAXGG=999999#                          Default generator maximum        GS01  29
XCEPT=0#                               Initialize exception             GS01  30
#                                                                       GS01  31
#    PROCESS PARAMETERS ON GENSIN LINE                                  GS01  32
#    ---------------------------------                                  GS01  33
#                                                                       GS01  34
FOR(I=1;I>0;I=I+1)#                    Loop over input options          GS01  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GS01  36
ifvo:(BUFIN(I)) BREAK#                 Exit on void field               GS01  37
ifnm:(BUFIN(I)) iquit:(GS0105,I)#      Error in options                 GS01  38
stringlim:(I,M,N)#                     Get string boundaries            GS01  39
compchar:(CHRIN,M,SN3,2,2,3,NSN3,N)#   Identify the option              GS01  40
IF(N<4) I=I+1#                         Incr for numeric value           GS01  41
IF(N==0) iquit:(GS0105,I)#             Illegal option on line           GS01  42
IF(N==1) OSMX=bf:(I)#                  Store s max                      GS01  43
IF(N==2) DSNM=bf:(I)#                  Store data set number            GS01  44
IF(N==3) IETY=ib:(I)#                  Store e type used                GS01  45
IF(N==5) NFRG=no:#                     Store fragment as off            GS01  46
IF(N==6) MODE=no:#                     Store modify |e|s off            GS01  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GS01  48
writefmt:(iofm1:,'(A)','GENEV ')#      Add genev to reentrant file      GS01  49
writefmt:(iofm1:,'(A)',CHRIP(1^80))#   Add current gensin line          GS01  50
#                                                                       GS01  51
#   SET DEFAULT CONTROL PARAMETERS                                      GS01  52
#   ------------------------------                                      GS01  53
#                                                                       GS01  54
DO I=1,3#                              Loop invariant orders            GS01  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GS01  56
ABCT(I)=999.;  AMIN(I)=0.#             Set probability thresholds       GS01  57
AMAX(I)=0.;  IFSI(I)=1#                Set amax & print thresh.         GS01  58
SIMX(I)=0.; MXSI(I)=-1; MXIG(I)=500#   Set si count,maxsi,max/gen       GS01  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GS01  60
XVMN=-5.; XVMX=100.; XSLO=-1.; XSHI=-1.# Set x-vector defaults          GS01  61
EMIN=-1.;  MAXG=-1;  MAXP=MAXGG#       Set |e|, maxgen, maxpsi          GS01  62
N1PE=0;  N1PS=0;  NNPE=MAXGG#          Set n1 & nn print limits         GS01  63
STMN=0.;  STMX=2.;  APMN=0.#           Set sin t/l min/max              GS01  64
SGET=0.;   IXVF=1#                     Set sigma|e| fact. & xvecf       GS01  65
NGPT=MAXGG;     IPS=0#                 Set generator print thresh.      GS01  66
#                                                                       GS01  67
#    ENTER CONTROL LINES                                                GS01  68
#    -------------------                                                GS01  69
#                                                                       GS01  70
#                                                                       GS01  71
REPEAT#                                Loop all control lines           GS01  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GS01  73
readline:(SN1,NSN1)#                   Process next control line        GS01  74
#                                                                       GS01  75
IF(LINID>=1&LINID<=3)#                 ********* trip,quar,quin         GS01  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GS01  77
IF(bf:(1)<voidflg:)#                   Test for input char string       GS01  78
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GS01  79
stringlim:(1,M,N)#                     Get string limits fld 1          GS01  80
compchar:(CHRIN,M,SN2,4,1,2,6,N)#      Find string match                GS01  81
IF(N==0) IFSI(LINID)=1#                No match is default yes          GS01  82
ELSE     IFSI(LINID)=N-1#              Translate into yes=1 no=0        GS01  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GS01  84
IF(bf:(2)>voidflg:) ABCT(LINID)=bf:(2)# Get active e-prod min           GS01  85
IF(bf:(3)>voidflg:) MXSI(LINID)=ib:(3)# Get active max s.i.             GS01  86
IF(bf:(4)>voidflg:) MXIG(LINID)=ib:(4)# Get active max si/gen           GS01  87
IF(bf:(5)<voidflg:)#                   Test if xvector flag set         GS01  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GS01  89
stringlim:(5,M,N)#                     Get field limits                 GS01  90
compchar:(CHRIN,M,SN2,8,1,2,NSN2,N)#   Match with noxv or xvec          GS01  91
IXVF=N-1#                              Xvf (0=no,1=in,2=all,3=ex)       GS01  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GS01  93
IF(bf:(6)>voidflg:) XVMN=bf:(6)#       Get active xvec e min            GS01  94
IF(bf:(7)>voidflg:) XVMX=bf:(7)#       Get active xvec e max            GS01  95
IF(bf:(8)>voidflg:) XSLO=AMIN1(2.5,bf:(8))## Get xvec sum lo limit      GS01  96
IF(bf:(9)>voidflg:) XSHI=bf:(9)#       Get xvec sum hi limit            GS01  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GS01  98
#                                                                       GS01  99
ELSE IF(LINID==4)#                     ******** gener line              GS01 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GS01 101
IF(bf:(1)>voidflg:) EMIN=bf:(1)#       Get active emin                  GS01 102
IF(bf:(2)>voidflg:) MAXG=MIN0(ib:(2),MAXGG)# Get active max gens        GS01 103
IF(bf:(3)>voidflg:) STMN=bf:(3)#       Get active min st/l              GS01 104
IF(bf:(4)>voidflg:) STMX=bf:(4)#       Get active max st/l              GS01 105
IF(bf:(5)>voidflg:) SGET=bf:(5)#       Get active sige cutoff           GS01 106
IF(bf:(6)>voidflg:) MAXP=MIN0(ib:(6),MAXGG)# Get active maxpsi0 ref     GS01 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GS01 108
#                                                                       GS01 109
ELSE IF(LINID==5)#                     ********** print line            GS01 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GS01 111
IF(bf:(1)>voidflg:) NGPT=ib:(1)#       Get active gen print limit       GS01 112
IF(bf:(2)>voidflg:) N1PS=ib:(2)#       Get active si n1 print min       GS01 113
IF(bf:(3)>voidflg:) N1PE=ib:(3)#       Get active si n1 print max       GS01 114
IF(bf:(4)>voidflg:) NNPE=ib:(4)#       Get active si nn print max       GS01 115
IF(bf:(5)>voidflg:) APMN=bf:(5)#       Get active si abc list min       GS01 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GS01 117
#                                                                       GS01 118
ELSE IF(LINID==6)#                     ********** psical line           GS01 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GS01 120
NFRG=0;   IEXT=yes:#                   Switch off fragment flag         GS01 121
IF(bf:(1)<voidflg:)#                   Test for input char string       GS01 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GS01 123
stringlim:(1,M,N)#                     Get string limits fld 1          GS01 124
compchar:(CHRIN,M,SN2,16,1,2,18,N)#    Find string match                GS01 125
IF(N==0) iquit:(GS0107)#               No match.....gs0107              GS01 126
ELSE     IEXT=N-1#                     Translate into yes=1 no=0        GS01 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GS01 128
IF(bf:(2)>voidflg:) IPS=ib:(2)#        Store phi idnum                  GS01 129
ELSE                IPS=750#           Default idnum is cal phi         GS01 130
IF(bf:(3)>voidflg:) IFC=ib:(3)#        Store fcal idnum                 GS01 131
ELSE                IFC=751#           Default idnum is cal f           GS01 132
IPS=MOD(IPS,1000); IFC=MOD(IFC,1000)#  Remove datset number             GS01 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GS01 134
#                                                                       GS01 135
ELSE BREAK#                            ******* end,change               GS01 136
writefmt:(iofm1:,'(A)',CHRIP(1^80))#   Add input line                   GS01 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GS01 138
#                                                                       GS01 139
#     ASSIGN IO BUFFER SPACE                                            GS01 140
#     ----------------------                                            GS01 141
#                                                                       GS01 142
IOMARK(1)=QXSTR+1#                     Mark start of file1 buffer       GS01 143
IOMARK(3)=IOMARK(1)+bdfbuf:#           Mark start of file3 buffer       GS01 144
incrqx:(Q0,IOMARK(3)+bdfbuf:,GS0110)#  Expand qx ....... gs01010        GS01 145
#                                                                       GS01 146
#    GET DATA FROM BDF                                                  GS01 147
#    ---------------------                                              GS01 148
#                                                                       GS01 149
readwpkt:(1,lrcell:,NP,IP,0)#          ****** bdf record lrcell:        GS01 150
A=QX(IP+1); B=QX(IP+2); C=QX(IP+3)#    Get cell dimensions              GS01 151
#                                                                       GS01 152
readwpkt:(1,lrsymm:,NP,IP,0)#          ****** bdf record lrsymm:        GS01 153
LTYP=iqx:(IP+1)#                       Get lattice type                 GS01 154
ICNT=IABS(iqx:(IP+2)-1)#               Get centre code(nc=0, c=1)       GS01 155
NSYM=iqx:(IP+3)#                       Get total symops in cell         GS01 156
NROT=iqx:(IP+4)#                       Get no. of rot matrices          GS01 157
NRMZ=iqx:(IP+5)#                       Get no. matrices same zeros      GS01 158
FMUL=QX(IP+6)#                         Get sf mult. factor              GS01 159
CSYS=iqx:(IP+9)#                       Get crystal system               GS01 160
incrqx:(Q1,Q0+NROT*NROT,GS0120)#       Expand qx ........ gs0120        GS01 161
incrqx:(Q2,Q1+NROT*18,GS0125)#         Expand qx ........ gs0125        GS01 162
FOR(I=Q1;I<Q2;I=I+18)#                 Loop symmetry matrices           GS01 163
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GS01 164
readwpkt:(1,lrsymm:,NP,IP,0)#          Point to rotation matrices       GS01 165
movereal:(QX,IP+1,QX,I+1,12,1)#        Store matrices q1 to q2          GS01 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GS01 167
#                                                                       GS01 168
#                                       ********* setup hkl encodes     GS01 169
IF(ICNT==1) LTYP=LTYP-7#               Reduce latt type for centro      GS01 170
JE1=1; JE2=2; JE3=3#                   Set initial hkl encodes          GS01 171
IF(LTYP==5) A=10000000.#               For a-centre force h=h1          GS01 172
IF(LTYP==6) B=10000000.#               For b-centre force k=h1          GS01 173
IF(LTYP==7) C=10000000.#               For c-centre force l=h1          GS01 174
IF(A<B) swapi:(JE1,JE2)#               If a < b swap encodes 1,2        GS01 175
IF(A<C) swapi:(JE1,JE3)#               If a < c swap encodes 1,3        GS01 176
IF(B<C) swapi:(JE2,JE3)#               If b < c swap encodes 2,3        GS01 177
IH(JE1)=1; IH(JE2)=2; IH(JE3)=3#       Set hkl order decodes            GS01 178
JD1=IH(1); JD2=IH(2); JD3=IH(3)#       Set hkl order decodes            GS01 179
#                                                                       GS01 180
#                                       ****** bdf record lrscat        GS01 181
IW(1)=1;    IW(2)=3#                   Want atomic pop. & no.           GS01 182
KEY(1)=2;KEY(2)=0;KEY(3)=0;KEY(4)=0#   Set search delimiters            GS01 183
indexpkt:(1,lrscat:,NP,IP,0,KEY,IW,IR)# Locate wanted idnums            GS01 184
IF(KEY(4)<0) iquit:(GS0130)#           No celcon........ gs0130         GS01 185
HNON=0.;  A=0.;  B=0.;  HEAV=0.#       Zeroize sums                     GS01 186
IF(LTYP<5) PFAC=FLOAT(LTYP)#           Get primitivity factor           GS01 187
ELSE        PFAC=2.#                   Prim. factor =2. for a,b,c       GS01 188
REPEAT#                                Loop all atom types              GS01 189
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GS01 190
readwpkt:(1,lrscat:,NP,IP,0)#          Point to next packet             GS01 191
IF(IP<=0) BREAK#                       If no more exit                  GS01 192
I=IP+IR(1);  C=QX(I)#                  Get atoms per cell               GS01 193
I=IP+IR(2);  D=QX(I)#                  Get atomic number                GS01 194
IF(D>1.5) HNON=HNON+C#                 Count non hydr atoms/cell        GS01 195
C=C/PFAC#                              Convert celcon to primitive      GS01 196
A=A+C*D**2#                            Sum n*z**2                       GS01 197
B=B+C*D**3#                            Sum n*z**3                       GS01 198
HEAV=AMAX1(HEAV,D**2)#                 Get max scat power               GS01 199
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GS01 200
PFAC=B/SQRT(A**3)#                     Calculate prob. factor           GS01 201
HEAV=HEAV/A#                           Calc max scat power ratio        GS01 202
#                                                                       GS01 203
#                                       ******* bdf record lrdset:      GS01 204
L=0;  N=0;  RMAX=1000.#                Reset max frag & counter         GS01 205
IW(1)=10;  IW(2)=15+IETY;  IW(3)=18#   Set frag type and elow           GS01 206
KEY(1)=0;  KEY(2)=3;  KEY(3)=0#        Set search delimiters            GS01 207
indexpkt:(1,lrdset:,NP,IP,0,KEY,IW,IR)# Locate frag idnum               GS01 208
EPSI=0.;  IF(IR(1)==0) NFRG=0#         Reset epsi limit & frag          GS01 209
REPEAT#                                Loop datsetnums                  GS01 210
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GS01 211
readwpkt:(1,lrdset:,NP,IP,0)#          Point to next packet             GS01 212
IF(IP<=0) BREAK#                       If no more exit                  GS01 213
ifne:(DSNM,QX(IP+1))NEXT#              Skip wrong data sets             GS01 214
I=IP+IR(2); IF(I>IP) EPSI=QX(I)#       Get min |e| for psi              GS01 215
I=IP+IR(3); IF(I>IP) RMAX=QX(I)#       Get max number of e values       GS01 216
IF(IR(1)==0) BREAK#                    Exit if no frag data             GS01 217
I=IP+IR(1); movepakwd:(QX(I),A)#       Get packed frag info             GS01 218
IF(NFRG>0) intunpak:(A,NFRG,0,4)#      Get no. of fragments             GS01 219
FOR(I=0;I<NFRG;I=I+1)#                 Loop all frag groups             GS01 220
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GS01 221
intunpak:(A,J,4+I*2,2)#                Get fragment type                GS01 222
IF(J==2) M=NROT#                       If orient get point groups       GS01 223
ELSE     M=1#                          Otherwise only one group sf      GS01 224
FOR(K=1;K<=M;K=K+1)#                   Loop possible groups             GS01 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GS01 226
N=N+1#                                 Count total group s.f.           GS01 227
IF(N>20) iquit:(GS0135)#               Array lim.........gs0135         GS01 228
IFRG(N)=J+1#                           Store fragment type              GS01 229
L=MAX0(L,J)#                           Store max frag type              GS01 230
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GS01 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GS01 232
IF(L<2) NFRG=0#                        Ignore types 1,2 for qphi        GS01 233
ELSE    NFRG=N#                        Store total group s.f.           GS01 234
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GS01 235
#                                                                       GS01 236
#   CALCULATE |E| THRESHOLDS                                            GS01 237
#   ------------------------                                            GS01 238
EPSI=EPSI+0.1*FLOAT(2-ICNT)#           Calc epsi for psi0 triplets      GS01 239
IF(EMIN<0.)#                           Test if |e| gen limit set        GS01 240
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GS01 241
IF(MAXG<1)#                            Test if ngen limit set           GS01 242
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GS01 243
A=4.+FLOAT(ICNT)+1./FLOAT(NROT)#       Calc nonh atom factor            GS01 244
MAXG=MIN0(MAXGG,150+INT(HNON*A)/NSYM)# Calc auto max generators         GS01 245
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GS01 246
EMIN=0.25+3.*(.45-FLOAT(MAXG)/RMAX)#   Approximate hypcentric distr     GS01 247
EMIN=AMAX1(1.,AMIN1(1.5,EMIN))#        Ensure gt one, lt 1.5            GS01 248
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GS01 249
IF(MAXG<0) MAXG=MAXGG#                 Calc max gen if emin set         GS01 250
#                                                                       GS01 251
RETURN#                                                                 GS01 252
END#                                                                    GS01 253
systemheader:(GS02)#                   Prepare symm. & odr data         GS02   1
####################################################################    GS02   2
#                                                                  #    GS02   3
#                             GS02                                 #    GS02   4
#                                                                  #    GS02   5
####################################################################    GS02   6
SUBROUTINE GS02#                       S.r.hall  apr 81                 GS02   7
include:(AACOMN)#                                                       GS02   8
include:(GSCOMN)#                                                       GS02   9
#                                                                       GS02  10
INTEGER I,I3,J,K,L,LAT,M,N,NN#                                          GS02  11
INTEGER ITEM(3),NR(3,3),MM,NT#                                          GS02  12
REAL PMAT(3,3),SMAT(3,3)#                                               GS02  13
realdata:(EMAT,[1.,0.,0.,0.,1.,0.,0.,0.,1.])#                           GS02  14
intdata:(MT,[$#                                                         GS02  15
1,0,0,1,#                              S.i. vector array  h             GS02  16
0,1,0,2,#                              S.i. vector array  k             GS02  17
0,0,1,3,#                              S.i. vector array  l             GS02  18
1,1,0,1,#                              S.i. vector array  h+k           GS02  19
1,-1,0,1,#                             S.i. vector array  h-k           GS02  20
0,1,1,2,#                              S.i. vector array  k+l           GS02  21
0,1,-1,2,#                             S.i. vector array  k-l           GS02  22
1,0,1,2,#                              S.i. vector array  h+l           GS02  23
1,0,-1,2,#                             S.i. vector array  h-l           GS02  24
1,1,1,1,#                              S.i. vector array  h+k+l         GS02  25
1,1,-1,1,#                             S.i. vector array  h+k-l         GS02  26
1,-1,1,1,#                             S.i. vector array  h-k+l         GS02  27
-1,1,1,1,#                             S.i. vector array -h+k+l         GS02  28
2,1,-1,1,#                             S.i. vector array  2h+k-l        GS02  29
2,-1,1,1,#                             S.i. vector array  2h-k+l        GS02  30
-1,2,1,1,#                             S.i. vector array -h+2k+l        GS02  31
1,2,-1,1,#                             S.i. vector array  h+2k-l        GS02  32
-1,1,2,1,#                             S.i. vector array -h+k+2l        GS02  33
1,-1,2,1])#                            S.i. vector array  h-k+2l        GS02  34
realdata:(TM,[$#                                                        GS02  35
+1.,0.,0.,0.,1.,0.,0.,0.,1.,#          Transform hkl p to p             GS02  36
0.,1.,1.,1.,0.,1.,1.,1.,0.,#           Transform hkl p to i             GS02  37
+1.,-1.,0.,0.,1.,-1.,1.,1.,1.,#        Transform hkl p to r             GS02  38
-1.,1.,1.,1.,-1.,1.,1.,1.,-1.,#        Transform hkl p to f             GS02  39
-1.,0.,0.,0.,-1.,1.,0.,1.,+1.,#        Transform hkl p to a             GS02  40
+1.,0.,1.,0.,-1.,0.,1.,0.,-1.,#        Transform hkl p to b             GS02  41
+1.,1.,0.,1.,-1.,0.,0.,0.,-1.])#       Transform hkl p to c             GS02  42
realdata:(TR,[$#                                                        GS02  43
1.,0.,0.,0.,1.,0.,0.,0.,1.,#           Transform hkl p to p             GS02  44
-.5,.5,.5,.5,-.5,.5,.5,.5,-.5,#        Transform hkl i to p             GS02  45
.666667,.333333,.333333,#              Transform r to p                 GS02  46
-.333333,.333333,.333333,#             Transform r to p                 GS02  47
-.333333,-.666667,.333333,#            Transform r to p                 GS02  48
0.,.5,.5,.5,0.,.5,.5,.5,0.,#           Transform hkl f to p             GS02  49
-1.,0.,0.,0.,-.5,.5,0.,.5,.5,#         Transform hkl a to p             GS02  50
.5,0.,.5,0.,-1.,0.,.5,0.,-.5,#         Transform hkl b to p             GS02  51
.5,.5,0.,.5,-.5,0.,0.,0.,-1.])#        Transform hkl c to b             GS02  52
datastuff:#                                                             GS02  53
#                                                                       GS02  54
#   STORE ROT MATRICES IF CENTRO                                        GS02  55
#   ----------------------------                                        GS02  56
#                                                                       GS02  57
MQ=Q2;    LAT=(LTYP-1)*9#              Mark end non-centr. rmats        GS02  58
IF(ICNT>0)#                            Test if centrosymmetric          GS02  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GS02  60
M=Q2#                                  Mark current rmat start          GS02  61
incrqx:(Q2,M+NROT*18,GS0205)#          Expand qx ........ gs0205        GS02  62
movereal:(QX,Q1+1,QX,M+1,Q2-M,1)#      Store rot matrices               GS02  63
FOR(M=M+1;M<=Q2;M=M+1)#                Loop all elements                GS02  64
QX(M)=-QX(M)#                          Reverse signs of elements        GS02  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GS02  66
#                                                                       GS02  67
#    STORE EQUIVALENT SIGN CODES                                        GS02  68
#    ---------------------------                                        GS02  69
#                                                                       GS02  70
DO I=1,NRMZ#                           Loop matrices same zeros         GS02  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GS02  72
N=Q1+(I-1)*18#                         Point to start each matrix       GS02  73
IH(JD1)=iqx:(N+1)#                     Store sign of h                  GS02  74
IH(JD2)=iqx:(N+5)#                     Store sign of k                  GS02  75
IH(JD3)=iqx:(N+9)#                     Store sign of l                  GS02  76
IS2(I)=IH(2);   IS3(I)=IH(3)#          Store signs h2 & h3              GS02  77
IF(IH(1)<0) IS2(I)=-IH(2)#             Reverse sign of h2               GS02  78
IF(IH(1)<0) IS3(I)=-IH(3)#             Reverse sign of h3               GS02  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GS02  80
#                                                                       GS02  81
#    SETUP PHI AND HKL SIGN TABLES                                      GS02  82
#    -----------------------------                                      GS02  83
#                                                                       GS02  84
K=1; L=1; M=1#                         Set initial signs                GS02  85
DO I=1,8#                              Loop possible codes              GS02  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GS02  87
JS2(I)=K;  JS3(I)=L;  JS4(I)=M#        Setup phi sign table             GS02  88
IH(JD3)=K; IH(JD2)=L; IH(JD1)=M#       Setup hkl sign table             GS02  89
K=-K#                                  Reverse sign modulo 1            GS02  90
IF(MOD(I,2)==0) L=-L#                  Reverse sign modulo 2            GS02  91
IF(MOD(I,4)==0) M=-M#                  Reverse sign modulo 4            GS02  92
IF(IH(1)<0)#                           If h1 is negative                GS02  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GS02  94
IH(1)=1; IH(2)=-IH(2); IH(3)=-IH(3)#   Reverse all signs                GS02  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GS02  96
IF(NRMZ==4) IH(2)=1#                   For four equiv. matrices         GS02  97
IF(NRMZ==4) IH(3)=1#                   +h2 = -h2; +h3 = -h3             GS02  98
IF(NRMZ==2)#                           For two equiv matrices           GS02  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GS02 100
IF(IS2(2)<IS3(2)) IH(2)=1#             All +h2 = -h2                    GS02 101
IF(IS2(2)>IS3(2)) IH(3)=1#             All +h3 = -h3                    GS02 102
IF(IS2(2)==IS3(2)&IH(2)<0)#            +h2,+h3 = -h2,-h3                GS02 103
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GS02 104
IH(2)=-IH(2); IH(3)=-IH(3)#            Reverse h2,h3 signs              GS02 105
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GS02 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GS02 107
JH(I)=IH(1); JK(I)=IH(2); JL(I)=IH(3)# Store h1,h2,h3 sign codes        GS02 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GS02 109
#                                                                       GS02 110
#     SPECIFY ORIGIN DEFINITION                                         GS02 111
#     -------------------------                                         GS02 112
#                                                                       GS02 113
#                                       ******* moduli & vectors        GS02 114
DO I=1,3#                              Loop possible conbinations       GS02 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GS02 116
MDSI(I)=1; ITEM(I)=1#                  Set si mod & temp arrays         GS02 117
DO J=1,3#                              Inner si loop                    GS02 118
SIVC(I,J)=0.#                          Zeroize si vector matrix         GS02 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GS02 120
NODR=0;   NONR=0#                      Set number odr & nrestr odr      GS02 121
#                                                                       GS02 122
#                                       ****** find odr conditions      GS02 123
DO NT=1,19#                            Odr specification loop           GS02 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GS02 125
M=-1;     NN=(NT-1)*4#                 Initialize flag                  GS02 126
###write(6,'(//i5)') NT######################                           GS02 127
FOR(MM=Q1;MM<Q2;MM=MM+18)#             Loop rotation matrices           GS02 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GS02 129
movereal:(QX,MM+1,PMAT,1,9,0)#         Move matrix to pmat(3,3)         GS02 130
###write(6,'(/9f5.0)') pmat######################33                     GS02 131
IF(LTYP>1)#                            Test if cell is primitive        GS02 132
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GS02 133
DO J=1,3;  DO K=1,3#                   Matrix element loop              GS02 134
RM(J,K)=TM(J+LAT  )*PMAT(1,K)$#        Premult. transform matrix        GS02 135
+       TM(J+LAT+3)*PMAT(2,K)$#        Premult. transform matrix        GS02 136
+       TM(J+LAT+6)*PMAT(3,K)#         Premult. transform matrix        GS02 137
DO J=1,3;  DO K=1,3#                   Matrix element loop              GS02 138
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GS02 139
I=LAT+(K-1)*3#                         Point to transf. matrix          GS02 140
PMAT(J,K)=RM(J,1)*TR(I+1)$#            Postmultiply matrix              GS02 141
+         RM(J,2)*TR(I+2)$#            Postmultiply matrix              GS02 142
+         RM(J,3)*TR(I+3)#             Postmultiply matrix              GS02 143
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GS02 144
###write(6,'(9f5.0)') pmat######################33                      GS02 145
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GS02 146
#                                                                       GS02 147
#                                       ******* test si moduli          GS02 148
DO J=1,3;  DO K=1,3#                   Matrix element loop              GS02 149
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GS02 150
I=(K-1)*3+J#                           Point to transf. matrix          GS02 151
NR(J,K)=NINT(PMAT(J,K)-EMAT(I))#       Subtract elemental matrix        GS02 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GS02 153
###write(6,'(9I5)') nr######################33                          GS02 154
FOR(J=1;J<=3;J=J+1)#                   Loop vector search               GS02 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GS02 156
N=IABS(MT(1+NN)*NR(J,1)+MT(2+NN)*NR(J,2)+MT(3+NN)*NR(J,3))# Vector      GS02 157
###write(6,'(9I10)') n,m,csys######################33                   GS02 158
IF(N==1) GO TO 100#                    Exit if moduli is one            GS02 159
IF(M>0&N==0) NEXT#                     Skip if mod zero & known         GS02 160
IF(M>0&N!=M) GO TO 100#                Exit if new non-zero mod         GS02 161
M=N#                                   Reset vector flag                GS02 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GS02 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GS02 164
#                                                                       GS02 165
#                                       ********* check moduli found    GS02 166
L=MT(4+NN)#                            Get index position               GS02 167
###write(6,'(9I10)') n,m,l,item(l),nodr######################33         GS02 168
IF(ITEM(L)==0) NEXT#                   Test current vector mod 0        GS02 169
IF(ITEM(L)!=1)#                        Test if modulo set prev.         GS02 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GS02 171
IF(M==ITEM(L))   NEXT#                 Skip if already set              GS02 172
IF(M==3&CSYS!=5) NEXT#                 Skip impossible combination      GS02 173
IF(M==4&CSYS<3)  NEXT#                 Skip impossible combination      GS02 174
IF(M==2)         NEXT#                 Skip other two fold              GS02 175
NODR=NODR-1#                           Else reset odr counter           GS02 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GS02 177
IF(NT>13) NODR=0#                      Can only be one odr now          GS02 178
NODR=NODR+1#                           Count required odr's             GS02 179
ITEM(L)=M; MDSI(NODR)=M#               Store si modulo value            GS02 180
DO J=1,3#                              Loop si vectors                  GS02 181
SIVC(NODR,J)=MT(J+NN)#                 Store si vector values           GS02 182
###write(6,'(7I5,9f5.0)') item,mdsi,nodr,sivc######################33   GS02 183
100 CONTINUE#                          Branch point for new vector      GS02 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GS02 185
IF(LTYP>1)#                            If nonprim transform             GS02 186
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GS02 187
DO J=1,3;  DO K=1,3#                   Loop si vector martix            GS02 188
RM(J,K)=SIVC(J,1)*TR(K+LAT  )$#        Matrix multiply si vector        GS02 189
+       SIVC(J,2)*TR(K+LAT+3)$#        Matrix multiply si vector        GS02 190
+       SIVC(J,3)*TR(K+LAT+6)#         Matrix multiply si vector        GS02 191
movereal:(RM,1,SIVC,1,9,0)#            Store nonprim si matrix          GS02 192
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GS02 193
###write(6,'(7I5,9f5.0)') item,mdsi,nodr,sivc######################33   GS02 194
#                                                                       GS02 195
#   SETUP ROT-MATRIX ORDER TABLE                                        GS02 196
#   ----------------------------                                        GS02 197
#                                                                       GS02 198
IF((NFRG>0)\(IPS>0))#                  Only if frags used for qphi&     GS02 199
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GS02 200
MM=Q0#                                 Set rxr matrix start             GS02 201
FOR(I1=Q1;I1<MQ;I1=I1+18)#             Outer rotation matrix loop       GS02 202
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GS02 203
movereal:(QX,I1+1,SMAT,1,9,0)#         Store matrix in smat(3,3)        GS02 204
FOR(I2=Q1;I2<MQ;I2=I2+18)#             Inner rotation matrix loop       GS02 205
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GS02 206
movereal:(QX,I2+1,PMAT,1,9,0)#         Store matrix in pmat(3,3)        GS02 207
DO L=1,3;  DO M=1,3#                   Form binary product              GS02 208
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GS02 209
I=(M-1)*3+L#                           Point to matrix                  GS02 210
EMAT(I)= SMAT(L,1)*PMAT(1,M)$#         Matrix multiply                  GS02 211
+        SMAT(L,2)*PMAT(2,M)$#         Matrix multiply                  GS02 212
+        SMAT(L,3)*PMAT(3,M)#          Matrix multiply                  GS02 213
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GS02 214
FOR(I3=Q1;I3<Q2;I3=I3+18)#             Locate bin.prod. matrix          GS02 215
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GS02 216
FOR(I=1;I<=9;I=I+1)#                   For each element in matrix       GS02 217
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GS02 218
L=I3+I#                                Point to rot. matrix table       GS02 219
IF(ABS(QX(L)-EMAT(I))>.1) BREAK#       Exit if elements diff.           GS02 220
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GS02 221
IF(I>9) BREAK#                         Exit if matrices match           GS02 222
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GS02 223
IF(I<=9) iquit:(GS0220)#               Matrix err ........ gs0220       GS02 224
MM=MM+1#                               Increment pointer to rxr         GS02 225
QX(MM)=MOD((I3-Q1)/18,NROT)+1#         Store order of rot matrix        GS02 226
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GS02 227
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GS02 228
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GS02 229
###write(6,'(10i10)') jd1,jd2,jd3,je1,je2,je3,nrmz                      GS02 230
###write(6,'(6i10)') (jh(i),jk(i),jl(i),js2(i),js3(i),js4(i),i=1,8)#    GS02 231
#                                                                       GS02 232
RETURN#                                                                 GS02 233
END#                                                                    GS02 234
systemheader:(GS03)#                   Process bdf refln. data          GS03   1
####################################################################    GS03   2
#                                                                  #    GS03   3
#                             GS03                                 #    GS03   4
#                                                                  #    GS03   5
####################################################################    GS03   6
SUBROUTINE GS03#                       S.r.hall  apr 81                 GS03   7
include:(AACOMN)#                                                       GS03   8
include:(GSCOMN)#                                                       GS03   9
#                                                                       GS03  10
INTEGER I,II,IP,J,JJ,JP,K,L,LL,MM,MR,N1,N2,N3,NM,NN,NP#                 GS03  11
INTEGER NPAR,NPSI,NR#                                                   GS03  12
REAL EVAL,OMAX,SIGE,STOL#                                               GS03  13
string:(LINE,80)#                                                       GS03  14
chardata:(SN1, TRIP QUAR QUIN GENER PRINT PSICAL CHANGE END )#          GS03  15
chardata:(SN2, CHANGE              |E|=      SIGE=    )#                GS03  16
chardata:(SN3, SYS. ABSENT REFLN.             OMITTED.)#                GS03  17
realdata:(FMT,[110413.,150413.,190413.,290522.,390512.])#               GS03  18
realdata:(FM2,[230413.,270413.,310413.])#                               GS03  19
realdata:(SHKL,[4.,2.,1.,0.])#                                          GS03  20
realdata:(SHFT,[1.,0.,2.,3.,4.,0.,5.,0.,6.,7.,8.])#                     GS03  21
realdata:(RPHI,[0.,180.,30.,45.,60.,90.,120.,135.,150.,180.])#          GS03  22
realdata:(APHI,0.); intdata:(M,0); intdata:(N,0)#                       GS03  23
chardata:(GS03A," No E-values were present on the input bdf -")#        GS03  24
chardata:(GS03B," spawning GENEV to correct ...")#                      GS03  25
datastuff:#                                                             GS03  26
#                                                                       GS03  27
#  PREPARE TO ENTER BDF **RECORD 20**                                   GS03  28
#  ----------------------------------                                   GS03  29
#                                                                       GS03  30
NTOT=0;  NPAR=0;  NREF=0;  NGEN=0#     Zeroize refln. counters          GS03  31
MXH1=0;  MXH2=0;  MXH3=0#              Zeroize max h1,h2,h3 values      GS03  32
SMIN=2.;  SMAX=0.; NPSI=0#             Initialize smin & smax           GS03  33
I=NINT(DSNM)*1000#                     Set data set number pointer      GS03  34
IW(1)=1;  IW(2)=2;  IW(3)=3#           Set hkl, st/l idnum              GS03  35
IW(4)=I+599+IETY#                      Set e-value pointer              GS03  36
IW(5)=I+601+IETY#                      Set sigma e pointer              GS03  37
IF(IPS>0)#                             Test if phis to be used          GS03  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GS03  39
IW(6)=I+IPS;    IW(7)=I+IFC#           Store phi/fc idnums              GS03  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GS03  41
FOR(J=1;J<=NFRG;J=J+1) IW(J+7)=I+J+605# Point to frag group s.f.        GS03  42
KEY(1)=4; KEY(2)=NFRG+7; KEY(3)=0; KEY(4)=0# Set search delimiters      GS03  43
indexpkt:(1,lrrefl:,NP,IP,0,KEY,IW,IR)# Locate required idnums          GS03  44
IF(KEY(4)<=0)#                         /e/ miss ........gt0240          GS03  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GS03  46
writeline:(2,GS03A,NGS03A,3,2)#        Output message                   GS03  47
writeline:(0,GS03B,NGS03B,3,2)#        Output message                   GS03  48
LINFLG=1#                              Force new read line              GS03  49
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  Next inpt line isn't end or eo   GS03  50
writefmt:(iofm1:,'(A)',CHRIP(1^80))#   Write header to file             GS03  51
rewindbdf:(1)#                         Half read this bdf so rewind     GS03  52
closefmt:(iofm1:)#                     Shut down the line file          GS03  53
openfmt:(iofm1:,' ')#                  Re open .gs0 file                GS03  54
openfmt:(iofm2:,' ')#                  Open the .gs1 file               GS03  55
REPEAT#                                Read until finished              GS03  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GS03  57
readfmt:(iofm1:,'(A80)',150,LINE)#     Read a line of instructions      GS03  58
writefmt:(iofm2:,'(A80)',LINE)#        Add instructions to unused fil   GS03  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GS03  60
150 closefmt:(iofm2:)#                                                  GS03  61
closefmt:(iofm1:)#                                                      GS03  62
linestream:('GS1')#                    Insert file into line stream     GS03  63
XCEPT=1#                               Threw an exception               GS03  64
RETURN#                                Go no further                    GS03  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GS03  66
closefmt:(iofm1:)#                     Close unrequired line file       GS03  67
#                                                                       GS03  68
FOR(J=1;J<=NFRG;J=J+1)#                Loop group sf pointers           GS03  69
IF(IR(J+7)==0) iquit:(GS0316)#         Missing........gs0315            GS03  70
J=MAX(10000,NROT*NROT*4)#              Calc required symop scratch      GS03  71
incrqx:(Q2,MQ+J,GS0310)#               Expand qx ........ gs0310        GS03  72
I1=MQ+1#                               Set symop table pointer          GS03  73
I2=Q2#                                 Set refln. table pointer         GS03  74
MARK=NFRG+5#                           Set length of file3 record       GS03  75
IF(IPS>0)#                             Test if phi used in psi          GS03  76
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GS03  77
IF(IR(6)==0\IR(7)==0) iquit:(GS0317)#  Fc/phi missing.....gs0317        GS03  78
MARK=6#                                Set list length                  GS03  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GS03  80
NM=18*NRMZ#                            Calc length of matrix block      GS03  81
IF(IFSI(2)==0) IXVF=0#                 If no xvec store only gens       GS03  82
OMAX=0.#                               Set overall data limit           GS03  83
#                                                                       GS03  84
#   READ BDF REFLN. RECORD                                              GS03  85
#   ----------------------                                              GS03  86
#                                                                       GS03  87
REPEAT#                                Loop all record 20 's            GS03  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GS03  89
readwpkt:(1,lrrefl:,NP,IP,0)#          Point to next packet             GS03  90
IF(IP<=0) BREAK#                       If no more exit loop             GS03  91
I=IP+IR(2); STOL=QX(I)#                Get st/l value                   GS03  92
IF(STOL>OSMX) NEXT#                    Skip if outside data limit       GS03  93
OMAX=AMAX1(OMAX,STOL)#                 Measure actual data limit        GS03  94
I=IP+IR(4); EVAL=QX(I)#                Get |e| value                    GS03  95
ifvo:(EVAL) NEXT#                      Skip if not determined           GS03  96
IF((IXVF==0)&(EVAL<EMIN)&(EVAL>EPSI))NEXT# Trip gens only required      GS03  97
IF((EVAL>3.3)&(MODE>0))#               Test if large e's reduced        GS03  98
EVAL=3.3+(EVAL-3.3)/EVAL#              Apply progressive reduction      GS03  99
IF(IPS>0)#                             Test if phi & fc used            GS03 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GS03 101
I=IP+IR(6);  J=NINT(QX(I)*360.)#       Extract phi in degrees           GS03 102
IF((IEXT==no:)&(J<0)) NEXT#            If ext skip if no phase          GS03 103
intpak:(J,APHI,0,9)#                   Pack phi into word 6             GS03 104
K=IP+IR(7);  L=NINT(ABS(QX(K)))#       Extract fc value                 GS03 105
intpak:(L,APHI,9,bitlen:(9))#          Pack fc  into word 6             GS03 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GS03 107
I=IP+IR(5); IF(I>IP) SIGE=QX(I)#       Get sigma |e|                    GS03 108
ELSE SIGE=0.1*EVAL#                    Else set sige to 10% of |e|      GS03 109
NR=0;   NEQV=8#                        Set order & equiv counter        GS03 110
NREF=NREF+1#                           Count refln.s processed          GS03 111
I=IP+IR(1); gethkl:(I,AH)#             Get signed h,k,l                 GS03 112
#                                                                       GS03 113
IF(LINID==7)#                          Test if *change* in buffer       GS03 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GS03 115
ifeq:(AH(1),bf:(1))#                   Test for same h                  GS03 116
ifeq:(AH(2),bf:(2))#                   Test for same k                  GS03 117
ifeq:(AH(3),bf:(3))#                   Test for same l                  GS03 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GS03 119
IF(bf:(4)>voidflg:) EVAL=bf:(4)#       Get active |e| value             GS03 120
IF(bf:(5)>voidflg:) SIGE=bf:(5)#       Get active sigma |e|             GS03 121
ncodefld:(BUFIN,1,SN2,FMT,3)#          Format h,k,l                     GS03 122
ncodefld:(EVAL,1,SN2,FMT(4),1)#        Format |e|                       GS03 123
ncodefld:(SIGE,1,SN2,FMT(5),1)#        Format sigma |e|                 GS03 124
writeline:(0,SN2,NSN2,3,3)#            Print 'change' message           GS03 125
readline:(SN1,NSN1)#                   Read next control line           GS03 126
IF(LINID<7) iquit:(GS0315)#            Io order ........gs0315          GS03 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GS03 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GS03 129
#                                                                       GS03 130
#                                       ****** symmetry loop            GS03 131
FOR(MM=Q1;MM<MQ;MM=MM+18)#             Loop symmetry matrices           GS03 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GS03 133
FOR(I=MM+13;I<=MM+18;I=I+1)  QX(I)=0.# Zeroize hkl & code words         GS03 134
DO I=1,4#                              Loop column vectors              GS03 135
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GS03 136
J=MM+(I-1)*3;  K=MM+I+12#              Point to matrix elements         GS03 137
QX(K)=AH(1)*QX(J+1)+AH(2)*QX(J+2)+AH(3)*QX(J+3)# Form equiv indices     GS03 138
IF(QX(K)>(-.5)) NEXT#                  Test sign of new index           GS03 139
QX(MM+17)=QX(MM+17)+SHKL(I)#           Form hkl sign code               GS03 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GS03 141
J=MOD(NINT(QX(MM+16)*12.)+12000,12)#   Calc phase shift in 12ths        GS03 142
QX(MM+16)=SHFT(J+1)#                   Convert to phase shift code      GS03 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GS03 144
#                                                                       GS03 145
FOR(MM=Q1+12;MM<MQ;MM=MM+NM)#          Loop matrix blocks               GS03 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GS03 147
NR=NR+NRMZ#                            Incr rmat order table            GS03 148
###IF(QX(MM+6)>.5) NEXT#               Skip on ident matrix flag        GS03 149
DO I=1,3; IH(I)=NINT(ABS(QX(MM+I)))#   Get |h|,|k|,|l|                  GS03 150
IF(IH(JE1)>255) GO TO 100#             H1 must be < 256                 GS03 151
IF(IH(JE2)>127) GO TO 100#             H2 must be < 128                 GS03 152
IF(IH(JE3)>127) GO TO 100#             H3 must be < 128                 GS03 153
MXH1=MAX(IH(JE1),MXH1)#                Store maximum |h1|               GS03 154
MXH2=MAX(IH(JE2),MXH2)#                Store maximum |h2|               GS03 155
MXH3=MAX(IH(JE3),MXH3)#                Store maximum |h3|               GS03 156
I=NINT(QX(MM+5))#                      Get first sign code              GS03 157
N1=IH(JE1);  N2=IH(JE2);  N3=IH(JE3)#  Form h1,h2,h3 from hkl           GS03 158
IF(JK(I+1)<0) N2=-N2#                  Sign h2 if negative              GS03 159
IF(JL(I+1)<0) N3=-N3#                  Sign h3 if negative              GS03 160
I=NINT(AMIN1(EVAL,8.)*16.)#            Make ie = eval*16                GS03 161
incrqx:(I2,I2+1,GS0320)#               Incr/exp qx ........ gs0320      GS03 162
intpak:(I      ,QX(I2), 0,7)#          Pack eval*16 bits  6- 0          GS03 163
intpak:(N1     ,QX(I2), 7,8)#          Pack h1      bits 14- 7          GS03 164
intpak:(N2+128 ,QX(I2),15,8)#          Pack h2+128  bits 22-15          GS03 165
intpak:(N3+128 ,QX(I2),23,bitlen:(23))# Pack h3+128  bits **-23         GS03 166
###write(6,'(8i6,su,16r,i10)') i2,ih,n1,n2,n3,i,qx(i2)#                 GS03 167
#                                                                       GS03 168
II=I1;   MR=NR-NRMZ#                   Set current symop pointer        GS03 169
IF(IH(1)==0) LL=5#                     Adjust sign test for h=0         GS03 170
ELSE         LL=9#                     Else start with all non 0        GS03 171
IF(IH(2)==0) LL=LL-2#                  Adjust sign test for k=0         GS03 172
IF(IH(3)==0) LL=LL-1#                  Adjust sign test for l=0         GS03 173
FOR(NN=MM;NN<MQ;NN=NN+NM)#             Loop matrix blocks               GS03 174
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GS03 175
L=Q0+MR*NROT;  MR=MR+NRMZ#             Set pointers                     GS03 176
IF(IH(1)!=NINT(ABS(QX(NN+1)))) NEXT#   Test for duplicate |h|           GS03 177
IF(IH(2)!=NINT(ABS(QX(NN+2)))) NEXT#   Test for duplicate |k|           GS03 178
IF(IH(3)!=NINT(ABS(QX(NN+3)))) NEXT#   Test for duplicate |l|           GS03 179
QX(NN+6)=1.#                           Flag matrix as duplicate         GS03 180
FOR(K=NN;K<NN+NM;K=K+18)#              Loop nrmz matrices               GS03 181
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GS03 182
QX(II+1)=QX(K+5)+1.#                   Store hkl sign code              GS03 183
QX(II+2)=QX(K+4)#                      Store phase shift code           GS03 184
QX(II+3)=FLOAT(L)#                     Store rot order pointer          GS03 185
QX(II+4)=8.-QX(K+5)#                   Store -hkl sign code             GS03 186
QX(II+5)=  -QX(K+4)#                   Store -phase shift code          GS03 187
QX(II+6)=-FLOAT(L)#                    Store -rot order pointer         GS03 188
II=II+6;  L=L+NROT#                    Incr matrix pointers             GS03 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GS03 190
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GS03 191
#                                                                       GS03 192
#                                       ******* process generators      GS03 193
IF((EVAL<EMIN)&(EVAL>EPSI)) NEXT#      Test if generator                GS03 194
IF((STOL<STMN)\(STOL>STMX)) NEXT#      Skip if st/l outside limits      GS03 195
SMIN=AMIN1(SMIN,STOL);SMAX=AMAX1(SMAX,STOL)# Find st/l min & max        GS03 196
#                                                                       GS03 197
#                                       ******** find unique symops     GS03 198
JJ=I1+6#                               Set symop pointer                GS03 199
FOR(J=JJ;J<II;J=J+6)#                  Loop current symops              GS03 200
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GS03 201
FOR(K=I1;K<JJ;K=K+6)#                  Inner loop of unique symops      GS03 202
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GS03 203
M=iqx:(J+1)-iqx:(K+1)#                 Difference in sign codes         GS03 204
N=iqx:(J+1)+iqx:(K+1)#                 Combination of sign codes        GS03 205
IF(M==0\N==LL) BREAK#                  Exit if same or inverse          GS03 206
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GS03 207
#                                                                       GS03 208
IF(M==0)#                              ******* test sys. abs refln      GS03 209
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GS03 210
ifeq:(QX(J+2),QX(K+2))NEXT#            Skip if same phi shifts          GS03 211
AH(JE1)=N1;  AH(JE2)=N2;  AH(JE3)=N3#  Form hkl from h1,h2,h3           GS03 212
ncodefld:(AH,1,SN3,FM2,3)#             Format hkl for output            GS03 213
writeline:(0,SN3,NSN3,3,3)#            Print sys abs message            GS03 214
I2=I2-1#                               Decr refln table pointer         GS03 215
BREAK#                                 Skip to next record              GS03 216
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GS03 217
#                                                                       GS03 218
IF(N==LL) NEXT#                        Skip to next symop               GS03 219
movereal:(QX,J+1,QX,JJ+1,6,1)#         Save current symops              GS03 220
JJ=JJ+6#                               Incr symop pointer               GS03 221
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GS03 222
QX(I1)=FLOAT(JJ)#                      Store symop end pointer          GS03 223
intunpak:(QX(IP+IR(3)),N,12,4)#        Get restr phase code             GS03 224
intunpak:(QX(IP+IR(3)),M, 5,7)#        Get symmetry epsilon             GS03 225
QX(JJ+1)=RPHI(N+1)*100.+FLOAT(M)#      Restr in degrees/ epsilon        GS03 226
#                                                                       GS03 227
#                                      ****** check symops unique       GS03 228
FOR(I=MQ+1;I<I1;I=J+2)#                Loop existing symops             GS03 229
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GS03 230
J=iqx:(I)#                             Get symop end pointer            GS03 231
IF(J-I!=JJ-I1) NEXT#                   Skip unless same length          GS03 232
FOR(K=I+1;K<=J+1;K=K+1)#               Loop all equivalents             GS03 233
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GS03 234
L=I1+K-I#                              Point to current symop           GS03 235
ifne:(QX(K),QX(L))BREAK#               Exit if symop different          GS03 236
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GS03 237
IF(K>J+1) BREAK#                       Exit if all symops match         GS03 238
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GS03 239
IF(I>=I1) I1=JJ+2#                     Update symop table pointer       GS03 240
#                                                                       GS03 241
IF((EVAL<EMIN)&(NEQV==8)) NPSI=NPSI+1# Count psi0 generators            GS03 242
ELSE IF(EVAL<EMIN) NEXT#               Skip non parent psi0 gens        GS03 243
NTOT=NTOT+1#                           Count total par+son reflns       GS03 244
NEQV=NEQV-1#                           Reverse count eqv. reflns.       GS03 245
IF(NEQV==7) NGEN=NGEN+1#               Count parents as generators      GS03 246
#                                                                       GS03 247
#                                      ******* o/p gen.s on file3       GS03 248
writepkt:(3,2,MARK,JP)#                Point to next file3 packet       GS03 249
J=NINT(EVAL*1024.)#                    Prepare to pack eval             GS03 250
intpak:(NEQV,QX(JP+1), 0, 4)#          Equiv. hkl code bits  3- 0       GS03 251
intpak:(NGEN,QX(JP+1), 4, 9)#          Gen. seq. no.   bits 12- 4       GS03 252
intpak:(   J,QX(JP+1),13,bitlen:(13))# Eval*1024.      bits **-13       GS03 253
movepakwd:(QX(I2),QX(JP+2))#           Put h3h2h1e in buffer            GS03 254
QX(JP+3)=FLOAT(I)#                     Put symop pointer in buffer      GS03 255
QX(JP+4)=(SIGE/(EVAL+.1))**2#          Put var(e)/e**2 in buffer        GS03 256
QX(JP+5)=FLOAT(NEQV)#                  Put equiv hkl code in buff       GS03 257
IF(IPS>0) movepakwd:(APHI,QX(JP+6))#   Store packed fc/phi as frag      GS03 258
IF(NFRG>0)#                            If fragment info to be used      GS03 259
FOR(I=1;I<=NFRG;I=I+1)#                Loop group s.f.                  GS03 260
movereal:(QX,IP+IR(I+7),QX,JP+I+5,1,1)# Put each group s.f.             GS03 261
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GS03 262
100 CONTINUE#                          Branch point for new refln       GS03 263
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GS03 264
IF(LINID!=8) iquit:(GS0315)#           Must be end line                 GS03 265
OSMX=OMAX#                             Save overall data limit          GS03 266
MAXP=MIN0(MAXP,NPSI)#                  Fix number of psi0 gens          GS03 267
Q1=MQ#                                 Make q1 start of symops          GS03 268
#                                                                       GS03 269
readwpkt:(1,endrecord:,NP,IP,0)#       Rewind file1 bdf & close         GS03 270
###write(6,'(10f10.2)') (qx(iii),iii=mq+1,i1)#                          GS03 271
#                                                                       GS03 272
RETURN#                                                                 GS03 273
END#                                                                    GS03 274
systemheader:(GS04)#                   Sort refln & gener. lists        GS04   1
####################################################################    GS04   2
#                                                                  #    GS04   3
#                             GS04                                 #    GS04   4
#                                                                  #    GS04   5
####################################################################    GS04   6
SUBROUTINE GS04#                       S.r.hall  apr 81                 GS04   7
include:(AACOMN)#                                                       GS04   8
include:(GSCOMN)#                                                       GS04   9
#                                                                       GS04  10
INTEGER I,J,JP,K,L,M,MP,MX3L,N#                                         GS04  11
REAL A,QIQI#                                                            GS04  12
chardata:(SN1, GENSIN CONTROL PARAMETERS)#                              GS04  13
chardata:(SN2, PROCESS BDF DATA SET NUMBER           )#                 GS04  14
chardata:(SN3, NUMBER OF UNIQUE REFLECTIONS          )#                 GS04  15
chardata:(SN4, GENERATOR |E|-TYPE  |E|-MIN        E           )#        GS04  16
chardata:(SN5, GENERATOR SIN THETA/LAM RANGE         TO       )#        GS04  17
chardata:(SN6,[ NUMBER OF PSI(0) GENERATORS           ])#               GS04  18
chardata:(SN7, NUMBER OF GENERATORS ACCEPTED         )#                 GS04  19
chardata:(SN8,[ PROB. FACTOR SIG3/(SIG2)**1.5         ])#               GS04  20
chardata:(SN9, ESTIMATE PSI FROM FRAG. DATA      YES )#                 GS04  21
chardata:(SN10, OVERALL SIN THETA/LAMBDA LIMIT       )#                 GS04  22
chardata:(SN11,INF    2  3  4 HKL +-YES NO)#                            GS04  23
chardata:(SN12, ORIGIN DEFINITION PARAMETERS)#                          GS04  24
chardata:(SN13, MINIMUM NUMBER OF ODR REQUIRED       )#                 GS04  25
chardata:(SN15, STRUCTURE SEMINVARIANT VECTORS                   )#     GS04  26
chardata:(SN16, STRUCTURE SEMINVARIANT MODULI                    )#     GS04  27
chardata:(SN17, ENANTIOMORPH SPECIFICATION REQUIRED)#                   GS04  28
chardata:(SN18, ESTIMATE PSI FROM BDF PHI / FC     YES )#               GS04  29
chardata:(SN23, PRINT GENERATORS WITH NGEN  LE         )#               GS04  30
chardata:(SN24, PRINT INVARIANTS FOR N1 RANGE         TO      )#        GS04  31
chardata:(SN25, PRINT INVARIANTS WITH NGEN  LE       )#                 GS04  32
chardata:(SN26, PRINT INVARIANTS WITH PFAC GE         )#                GS04  33
chardata:(SN27, |E|S GT 3.3 ARE ATTENUATED        YES)# S               GS04  34
chardata:(SN28,YES)#                                                    GS04  35
realdata:(DPHI,[0.,60.,90.,120.,180.,240.,270.,300.])#                  GS04  36
datastuff:#                                                             GS04  37
#                                                                       GS04  38
#   CONVERT SYMOP PHASES TO DEGREES                                     GS04  39
#   -------------------------------                                     GS04  40
#                                                                       GS04  41
FOR(I=Q1+1;I<I1;I=J+2)#                Loop symop sets                  GS04  42
FOR(J=I;J<iqx:(I);J=J+3)#              Loop each symop                  GS04  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GS04  44
K=NINT(ABS(QX(J+2)))#                  Get phase shift code             GS04  45
IF((K==1)\(QX(J+2)>small:))#           For zero & positive shifts       GS04  46
QX(J+2)=DPHI(K)#                       Decode into degrees              GS04  47
ELSE#                                  Else for negative shifts         GS04  48
QX(J+2)=360.-DPHI(K)#                  Decode into degrees              GS04  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GS04  50
#                                                                       GS04  51
#   SORT REFLN. LIST FOR DECREASING H3|H2|H1|E                          GS04  52
#   ----------------------------------------------                      GS04  53
#                                                                       GS04  54
FOR(I=(I2-Q2)/2;I!=0;I=I/2)#           This is a *shell sort*           GS04  55
FOR(J=Q2+I+1;J<=I2;J=J+1)#             Which is very efficient for      GS04  56
FOR(K=J-I;K>Q2;K=K-I)#                 Large lists such as this.        GS04  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GS04  58
L=K+I#                                 Pointer with gap                 GS04  59
compakwd:(QX(K),GT,QX(L),BREAK)#       Compare h3|h2|h1 words           GS04  60
swapakwd:(QX(K),QX(L))#                Exchange packed words            GS04  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GS04  62
###write(6,'(su,16r,10i10)') (qx(i), i=q2+1,i2)##########               GS04  63
#                                                                       GS04  64
#   OUTPUT SORTED REFLN LIST ON FILE3                                   GS04  65
#   ----------------------------------                                  GS04  66
#                                                                       GS04  67
DO  I=Q2+1,I2#                         Loop refln. table                GS04  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GS04  69
writepkt:(3,3,1,JP)#                   Point to next record3 pack       GS04  70
movepakwd:(QX(I),QX(JP+1))#            Put h3|h2|h1|e in buffer         GS04  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GS04  72
writepkt:(3,endrecord:,5,JP)#          Rewind scratch file3             GS04  73
#                                                                       GS04  74
#  SPECIFY SIZE OF H2H3 POINTER TABLES                                  GS04  75
#  -----------------------------------                                  GS04  76
#                                                                       GS04  77
IF(IPS>0) NFRG=1#                      Treat phi/fc as frag data        GS04  78
MARK=NFRG+7#                           Expand generator packet          GS04  79
MX2L=MXH2+MXH2+1#                      Set length h2 edge               GS04  80
MX3L=MXH3+MXH3+1#                      Set length of h3 edge            GS04  81
MX4L=MX2L+MX2L#                        Allow for two layers             GS04  82
IM00=MX4L*MXH3+MXH2+1+I1#              Point to 00 of table1            GS04  83
IP00=IM00+MX2L#                        Point to 00 of table2            GS04  84
Q2=I1+1#                               Mark start of h2h3 tables        GS04  85
Q3=Q2+MX4L*MX3L#                       Mark start generator list        GS04  86
incrqx:(Q4,Q3+NTOT*MARK,GS0410)#       Incr/exp qx ........ gs0410      GS04  87
DO I=Q2,Q3; QX(I)=-1.#                 Initialize h2h3 table            GS04  88
DO I=1,NRMZ#                           Loop hkl signs                   GS04  89
IS3(I)=IS3(I)*MX4L#                    Combine sign & h2h3 incr.        GS04  90
I0=IOMARK(1)+1#                        Start scratch pad in buffer      GS04  91
I1=IOMARK(3)-255#                      Mark (redun-tab start) &&        GS04  92
I2=IOMARK(3)#                          End of scratch pad               GS04  93
DO I=1,8#                              Loop sign codes                  GS04  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GS04  95
IH(1)=JS4(I); IH(2)=JS3(I); IH(3)=JS2(I)# Use phi sign codes            GS04  96
JH(I)=IH(JE1);JK(I)=IH(JE2);JL(I)=IH(JE3)# Encode codes for h1,h2,h3    GS04  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GS04  98
#                                                                       GS04  99
#   ENTER GENERATOR LIST FROM FILE3                                     GS04 100
#   -------------------------------                                     GS04 101
#                                                                       GS04 102
FOR(I=Q3+1;I<Q4;I=I+MARK)#             Loop generators                  GS04 103
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GS04 104
readwpkt:(3,2,MP,JP,0)#                Point to next packet             GS04 105
movereal:(QX,JP+1,QX,I,MP,1)#          Put packet in gen table          GS04 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GS04 107
#                                                                       GS04 108
#   SORT GENERATORS FOR DECREASING E|NGEN|NEQV                          GS04 109
#   ------------------------------------------                          GS04 110
#                                                                       GS04 111
FOR(I=Q3+1;I<Q4;I=I+MARK)#             Loop generator table             GS04 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GS04 113
movepakwd:(QX(I),A);   K=I#            Put e|ng|ne & pointer            GS04 114
FOR(J=I+MARK;J<Q4;J=J+MARK)#           Loop lower table                 GS04 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GS04 116
compakwd:(A,GE,QX(J),NEXT)#            Find biggest e|ng|ne             GS04 117
movepakwd:(QX(J),A);   K=J#            Put e|ng|ne & pointer            GS04 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GS04 119
movereal:(QX, I,QX,I0,MP,1)#           This series of moves is          GS04 120
movereal:(QX, K,QX, I,MP,1)#           A method of swapping a           GS04 121
movereal:(QX,I0,QX, K,MP,1)#           List of packed words.            GS04 122
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GS04 123
#                                                                       GS04 124
#   PREPARE SORTED GENERATOR LIST FOR SI GENERATION                     GS04 125
#   -----------------------------------------------                     GS04 126
#                                                                       GS04 127
N=Q3+1;   NGEN=0; L=INT(EMIN*1024.)-2# List pointer & ngen count        GS04 128
FOR(I=Q3+1;I<Q4;I=I+MARK)#             Loop generator list              GS04 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GS04 130
J=iqx:(I+4)#                           Get equiv refln count            GS04 131
IF(J==7)#                              Test if parent hkl               GS04 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GS04 133
intunpak:(QX(I),K,13,18)#              Get eval*1024                    GS04 134
IF(K<L) BREAK#                         Exit when psi0 encountered       GS04 135
IF(NGEN==MAXG) BREAK#                  Exit if max generators           GS04 136
NGEN=NGEN+1#                           Count parent as generator        GS04 137
movereal:(QX,I+1,QX,N+3,MP-1,1)#       Put other values                 GS04 138
QX(N+6)=FLOAT(K)/1024.#                Put eval as fp word              GS04 139
QX(N)=FLOAT(NGEN)#                     Put generator no. in list        GS04 140
intunpak:(QX(N+3),M, 0, 7)#            Get eval*16                      GS04 141
N=N+MARK#                              Incr. new gen pointer            GS04 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GS04 143
ELSE#                                  If non-parent hkl                GS04 144
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GS04 145
movereal:(QX,I+1,QX,N+3,2,1)#          Put packed hkl & sym point       GS04 146
QX(N)=-FLOAT(N-(6-J)*5-MARK)#          Put -pointer to parent hkl       GS04 147
N=N+5#                                 Incr. new list pointer           GS04 148
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GS04 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GS04 150
QQ=N-1;  MAXG=NGEN#                    Set gen limit & count            GS04 151
#                                                                       GS04 152
#                                                                       GS04 153
I=Q4-MAXP*MARK+1#                      Calc start of psi0 list          GS04 154
FOR(;I<Q4;I=I+MARK)#                   Loop psi0 list                   GS04 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GS04 156
NGEN=NGEN+1#                           Count number generators          GS04 157
#WRITE(6,*)QX(I),QX(I+1),QX(I+2),QX(I+3),QX(I+4),QX(I+5),QX(I+6)        GS04 158
#                                  N+0 =FLOAT(NGEN)                     GS04 159
#                                  N+1                                  GS04 160
#      I+0    SEQ EVAL             N+2                                  GS04 161
#      I+1    H1H2H3/EQUIV         N+3                                  GS04 162
#      I+2    SYMOP PTR            N+4                                  GS04 163
#      I+3    VAR E/E2             N+5                                  GS04 164
#      I+4    NEQV                 N+6 =2                               GS04 165
#      I+5    APHI                 N+7 =0                               GS04 166
#      I+6                                                              GS04 167
#                                                                       GS04 168
movereal:(QX,I+1,QX,N+3,MP-1,1)#       Put packed data                  GS04 169
QX(N)=FLOAT(NGEN)#                     Put generator number             GS04 170
QX(N+6)=2.#                            Set psi0 |e|s to 2.0             GS04 171
#WRITE(6,*)QX(N),QX(N+1),QX(N+2),QX(N+3),QX(N+4),QX(N+5),QX(N+6)        GS04 172
N=N+MARK#                              Incr list pointer                GS04 173
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GS04 174
EMIN=FLOAT(M)/16.-.0624#               Reset emin at current value      GS04 175
Q4=N-1#                                Reset end of generator list      GS04 176
#                                                                       GS04 177
#   SET SEARCH THRESHOLDS IF NOT INPUT                                  GS04 178
#   ----------------------------------                                  GS04 179
#                                                                       GS04 180
IF(XSLO<0.) XSLO=2.5#                  Set default xvec sum low         GS04 181
IF(XSHI<0.) XSHI=4.0#                  Set default xvec sum high        GS04 182
IF(MXSI(1)<0) MXSI(1)=MAX0(2000,25*NGEN)# Set default max triplets      GS04 183
I=INT(FLOAT(NGEN)*(20./(XSHI+.1)+XSLO))# Calc default max quartets      GS04 184
IF(MXSI(2)<0)#                         Test for default max quartet     GS04 185
MXSI(2)=MIN0(10*NGEN,I)#               Calc max quartets                GS04 186
A=2.*PFAC#                             Calc prob factor                 GS04 187
ifeq:(ABCT(1),999.)#                   Test if default a thresh         GS04 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GS04 189
IF(ICNT==0) ABCT(1)=A*(1.5)**3#        Set a-thresh for acentric        GS04 190
ELSE        ABCT(1)=A*(1.8)**3#        Set a-thresh for centric         GS04 191
ABCT(1)=AMAX1(ABCT(1),1.)#             Ensure at least one &&           GS04 192
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GS04 193
ifeq:(ABCT(2),999.)#                   Test if default b thresh         GS04 194
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GS04 195
IF(ICNT==0) ABCT(2)=A*PFAC*(1.8)**4#   Set b-thresh acentric            GS04 196
ELSE        ABCT(2)=A*PFAC*(2.2)**4#   Set b-thresh centric             GS04 197
ABCT(2)=AMAX1(ABCT(2),0.5)#            Ensure at least 0.5 &&           GS04 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GS04 199
#                                                                       GS04 200
#   PRINT GENSIN CONTROL PARAMETERS                                     GS04 201
#   -------------------------------                                     GS04 202
#                                                                       GS04 203
LINRM=12#                              Get print space for block        GS04 204
movechar:(SN11,21,CHROT,2,NSN1-1,2)#   Insert heading underline         GS04 205
writeline:(1,SN1,NSN1,2,3)#            Print control heading            GS04 206
ncodefld:(DSNM,1,SN2,380413.,1)#       Format data set number           GS04 207
writeline:(0,SN2,NSN2,3,3)#            Print data set number            GS04 208
ncodefld:(FLOAT(NREF),1,SN3,380513.,1)## Format no. refln.s             GS04 209
writeline:(0,SN3,NSN3,3,3)#            Print no. refln.s                GS04 210
ncodefld:(OSMX,1,SN10,380532.,1)#      Format overall data limit        GS04 211
writeline:(0,SN10,NSN10,3,3)#          Print overall data limit         GS04 212
ncodefld:(EMIN+.0624,1,SN4,470522.,1)# Format |e| minimum               GS04 213
ncodefld:(FLOAT(IETY),1,SN4,380113.,1)# Format |e|-type                 GS04 214
writeline:(0,SN4,NSN4,3,3)#            Print |e| min & type             GS04 215
movechar:(SN28,1,SN27,36,NSN28,0)#                                      GS04 216
IF(MODE==0) movechar:(SN11,25,SN27,36,3,0)# Insert 'no' in mess &&      GS04 217
writeline:(0,SN27,NSN27,3,3)#          Print atten. message             GS04 218
ncodefld:(FLOAT(MAXG),1,SN7,380413.,1)## Format no. generators          GS04 219
writeline:(0,SN7,NSN7,3,3)#            Print no. generators             GS04 220
ncodefld:(FLOAT(MAXP),1,SN6,380413.,1)## Format no. psi0 gen            GS04 221
writeline:(0,SN6,NSN6,3,3)#            Print no. psi0 gen               GS04 222
ncodefld:(SMIN,1,SN5,380532.,1)#       Format st/l minimum              GS04 223
ncodefld:(SMAX,1,SN5,470532.,1)#       Format st/l maximum              GS04 224
writeline:(0,SN5,NSN5,3,3)#            Print st/l range                 GS04 225
ncodefld:(PFAC,1,SN8,380542.,1)#       Format probability factor        GS04 226
writeline:(0,SN8,NSN8,3,3)#            Print probability factor         GS04 227
IF(IPS>0)#                             Tesyt if bdf phi/fc used         GS04 228
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GS04 229
writeline:(0,SN18,NSN18,3,3)#          Tell user phi used in psi        GS04 230
IFRG(1)=4#                             Label frag as positioned         GS04 231
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GS04 232
ELSE IF(NFRG>0)#                       Test if normal frag data         GS04 233
writeline:(0,SN9,NSN9,3,3)#            Print qpsi status                GS04 234
NGPT=MIN0(MAXG,NGPT)#                  Set gener print limit            GS04 235
ncodefld:(FLOAT(NGPT),1,SN23,380413.,1)# Format gen print limit         GS04 236
writeline:(0,SN23,NSN23,3,3)#          Print gen print limit            GS04 237
IF(N1PE>0)#                            Is n1 print limit in force       GS04 238
N1PE=MIN0(MAXG,N1PE)#                  Set gener prin limit             GS04 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GS04 240
ncodefld:(FLOAT(N1PS),1,SN24,380413.,1)# Format n1 min print limit      GS04 241
ncodefld:(FLOAT(N1PE),1,SN24,460413.,1)# Format n1 max print limit      GS04 242
writeline:(0,SN24,NSN24,3,3)#          Print n1 print limits            GS04 243
NNPE=MIN0(MAXG,NNPE)#                  Set n2,3,4 print limit           GS04 244
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GS04 245
IF(NNPE>0)#                            If n2- print limit is set        GS04 246
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GS04 247
ncodefld:(FLOAT(NNPE),1,SN25,380413.,1)# Format n2- print limit         GS04 248
writeline:(0,SN25,NSN25,3,3)#          Print n2- print limit            GS04 249
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GS04 250
IF(APMN>small:)#                       If prob print limit active       GS04 251
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GS04 252
ncodefld:(APMN,1,SN26,380522.,1)#      Format amin print limit          GS04 253
writeline:(0,SN26,NSN26,3,3)#          Print amin print limit           GS04 254
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GS04 255
#                                                                       GS04 256
# PRINT ORIGIN DEFINITION PARAMETERS                                    GS04 257
# ----------------------------------                                    GS04 258
#                                                                       GS04 259
N=37;    LINRM=8#                      Point to vector string           GS04 260
DO I=1,3#                              Loop possible odr7s              GS04 261
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GS04 262
J=MDSI(I)*3#                           Set pointer to mod string        GS04 263
movechar:(SN11,J+1,SN16,N,3,0)#        Insert mod string in mess        GS04 264
IF(J==0) NONR=NONR+1#                  Count nonrestricted odr          GS04 265
IF(J==0) MDSI(I)=100000#               Set mod to infinity!!            GS04 266
DO J=1,3#                              Inner loop of si vectors         GS04 267
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GS04 268
IF(ABS(SIVC(I,J))<0.5) NEXT#           Skip zero elements               GS04 269
IF(SIVC(I,J)>0.1) K=20#                Set positive sign                GS04 270
ELSE              K=21#                Set negative sign                GS04 271
movechar:(SN11,K,SN15,N,1,0)#          Insert vector sign in buff       GS04 272
IF(SIVC(I,J)>1.1)#                     Test if vector greater than on   GS04 273
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GS04 274
N=N+1; SN15(N^N)='2'#                  Can only be two                  GS04 275
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GS04 276
movechar:(SN11,J+15,SN15,N+1,1,0)#     Insert vector hkl in buff        GS04 277
N=N+2#                                 Increment buffer pointer         GS04 278
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GS04 279
N=N+2#                                 Put space between vectors        GS04 280
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GS04 281
movechar:(SN11,21,CHROT,2,NSN12-1,2)#  Underline odr heading            GS04 282
writeline:(1,SN12,NSN12,2,3)#          Print odr heading & ul           GS04 283
ncodefld:(FLOAT(NODR),1,SN13,380113.,1)# Format odr number              GS04 284
writeline:(0,SN13,NSN13,3,3)#          Print odr number                 GS04 285
IF(NODR!=0)#                           Test if odr required             GS04 286
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GS04 287
writeline:(0,SN15,NSN15,3,3)#          Print si vectors                 GS04 288
writeline:(0,SN16,NSN16,3,3)#          Print si moduli                  GS04 289
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GS04 290
IF(ICNT==0) writeline:(0,SN17,NSN17,2,3)# Print enantiomorph mess       GS04 291
#                                                                       GS04 292
RETURN#                                                                 GS04 293
END#                                                                    GS04 294
systemheader:(GS05)#                   Refln list & h2h3 tables         GS05   1
####################################################################    GS05   2
#                                                                  #    GS05   3
#                             GS05                                 #    GS05   4
#                                                                  #    GS05   5
####################################################################    GS05   6
SUBROUTINE GS05#                       S.r.hall  apr 81                 GS05   7
include:(AACOMN)#                                                       GS05   8
include:(GSCOMN)#                                                       GS05   9
#                                                                       GS05  10
INTEGER I,IE,II,J,JP,MP,K,L,M,N,N1,N2,N3#                               GS05  11
REAL A#                                                                 GS05  12
intdata:(INC,[1,2,3,2,1,1,1])#                                          GS05  13
intdata:(K1,0); intdata:(K2,0); intdata:(K3,0)#                         GS05  14
realdata:(EVAL,0.)#                                                     GS05  15
datastuff:#                                                             GS05  16
#                                                                       GS05  17
#   ENTER REFLN. LIST FROM FILE3                                        GS05  18
#   --------------------------------                                    GS05  19
#                                                                       GS05  20
qxmemory:(Q4);     II=Q4#              Set start of refln list          GS05  21
INCR=INC(LTYP)#                        Set sysabs incr                  GS05  22
REPEAT#                                Loop all refln.s                 GS05  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GS05  24
readwpkt:(3,3,MP,JP,0)#                Point to refln packet            GS05  25
IF(JP>0)#                              For each refln.                  GS05  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GS05  27
movepakwd:(QX(JP+1),A)#                Put packed h3|h2|h1|ie           GS05  28
intunpak:(A,IE, 0,7)#                  Get eval*16                      GS05  29
intunpak:(A,N1, 7,8)#                  Get h1                           GS05  30
intunpak:(A,N2,15,8)#                  Get h2+128                       GS05  31
intunpak:(A,N3,23,8)#                  Get h3+128                       GS05  32
N2=N2-128;  N3=N3-128#                 Convert to h2 & h3               GS05  33
EVAL=FLOAT(IE)/16.#                    Put eval in buff                 GS05  34
IF(II==Q4)#                            For first refln. only            GS05  35
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GS05  36
K1=0;  K2=N2;  K3=N3#                  Force prev. h1,h2,h3 values      GS05  37
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GS05  38
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GS05  39
ELSE#                                  Else when list exhausted         GS05  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GS05  41
N1=-1; N2=MXH2; N3=MXH3#               Set end data indicators          GS05  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GS05  43
###write(6,'(8i8)') ii,k1,k2,k3,n1,n2,n3##########                      GS05  44
#                                                                       GS05  45
IF(N1==K1&N2==K2&N3==K3) NEXT#         ********** skip duplicate        GS05  46
#                                                                       GS05  47
IF(N3!=K3\N2!=K2\N1!=K1&K1<INCR)#      ********** end of h2h3 row       GS05  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GS05  49
FOR(;K1>=INCR;K1=K1-INCR)#             Loop missing reflns              GS05  50
incrqx:(II,II+1,GS0510)#               Incr/exp qx ........ gs0510      GS05  51
DO J=1,NRMZ#                           Loop sign combinations           GS05  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GS05  53
L=N2*IS2(J)+N3*IS3(J)+IM00#            Point to n2n3 word table1        GS05  54
M=K2*IS2(J)+K3*IS3(J)+IP00#            Point to k2k3 word table2        GS05  55
QX(L)=N1#                              Put max h1 in h2h3 table1        GS05  56
QX(M)=II#                              Put h1=0 addr in h2h3 table      GS05  57
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GS05  58
IF(JP<=0) BREAK#                       Terminate list processing        GS05  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GS05  60
#                                                                       GS05  61
ELSE IF(N1==K1) NEXT#                  ******** duplicate refln         GS05  62
#                                                                       GS05  63
ELSE#                                  ******* h1 in same h2h3 row      GS05  64
FOR(;K1>N1+INCR;K1=K1-INCR)#           Loop missing h1                  GS05  65
incrqx:(II,II+1,GS0510)#               Incr/exp qx ........ gs0510      GS05  66
#                                                                       GS05  67
#                                       ********* put refln.            GS05  68
incrqx:(II,II+1,GS0510)#               Incr/exp qx ........ gs0510      GS05  69
QX(II)=-EVAL-2.#                       Put e for non-generators         GS05  70
#                                                                       GS05  71
IF(EVAL>=EMIN)#                        ******** set genlist pointer     GS05  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GS05  73
FOR(J=Q3;J<QQ;)#                       Loop generator table             GS05  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GS05  75
compakwd:(A,EQ,QX(J+4),BREAK)#         Compare packed h3/|2|h1|ie       GS05  76
IF(QX(J+1)>0.) J=J+MARK#               Incr loop for parent             GS05  77
ELSE           J=J+5#                  Incr loop for non-parent         GS05  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GS05  79
IF(J<QQ) QX(II)=J+1#                   If generator put pointer         GS05  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GS05  81
###write(6,'(6i10,f10.2)') ii,n1,n2,n3,l,m,qx(ii)###                    GS05  82
K1=N1;  K2=N2;  K3=N3#                 Reset previous indices           GS05  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GS05  84
Q5=II#                                 Mark end of refln. table         GS05  85
readwpkt:(3,endrecord:,MP,JP,0)#       Close and rewind file3           GS05  86
###do i=0,mx4l############################                              GS05  87
###write(6,'(17f6.0)') (qx(ii),ii=q2+i,q3-1,mx4l)##############         GS05  88
#                                                                       GS05  89
#   ENSURE H1=0 EQUIVALENTS IN H2H3 TABLE                               GS05  90
#   -------------------------------------                               GS05  91
#                                                                       GS05  92
IF(INCR==1)#                           For h2h3 rows sans sysabs        GS05  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GS05  94
FOR(I=-MXH2;I<=MXH2;I=I+1)#            Loop all h2                      GS05  95
FOR(J=0;    J<=MXH3;J=J+1)#            Loop all h3                      GS05  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GS05  97
N=+I+J*MX4L+IP00#                      Point to +h2,+h3                 GS05  98
M=-I-J*MX4L+IP00#                      Point to -h2,-h3                 GS05  99
ifeq:(QX(N),QX(M)) NEXT#               Skip if h1=0 addr same           GS05 100
K=N-MX2L;   L=M-MX2L#                  Point to h1max values            GS05 101
ifeq:(QX(N),-1.)#                      Test if value updated            GS05 102
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GS05 103
QX(N)=QX(M);  QX(K)=0.#                Make equivalent                  GS05 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GS05 105
ELSE ifeq:(QX(M),-1.)#                 Otherwise do the reverse         GS05 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GS05 107
QX(M)=QX(N);  QX(L)=0.#                Make equivalent                  GS05 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GS05 109
K=iqx:(N);   L=iqx:(M)#                Get h1=0 addresses               GS05 110
ifeq:(QX(K),QX(L)) NEXT#               Skip if list values same         GS05 111
ifeq:(QX(K),0.) QX(K)=QX(L)#           Set missing equivalent           GS05 112
ELSE            QX(L)=QX(K)#           Set missing equivalent           GS05 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GS05 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GS05 115
###do i=0,mx4l############################                              GS05 116
###write(6,'(17f6.0)') (qx(ii),ii=q2+i,q3-1,mx4l)##############         GS05 117
#                                                                       GS05 118
#  UNPACK H1,H2,H3 IN GENERATOR LIST                                    GS05 119
#  ---------------------------------                                    GS05 120
#                                                                       GS05 121
FOR(I=Q3;I<Q4;I=I+J)#                  Loop generator list              GS05 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GS05 123
intunpak:(QX(I+4),N1, 7,8)#            Extact h1 index                  GS05 124
intunpak:(QX(I+4),L ,15,8)#            Get h2+128                       GS05 125
intunpak:(QX(I+4),M ,23,8)#            Get h3+128                       GS05 126
N2=IABS(L-128);  N3=IABS(M-128)#       Form |h2| and |h3|               GS05 127
K=iqx:(I+5);  L=iqx:(K+1)#             Get hkl sign from symops         GS05 128
IF(JH(L)<0) N1=-N1#                    Sign h1 if negative              GS05 129
IF(JK(L)<0) N2=-N2#                    Sign h2 if negative              GS05 130
IF(JL(L)<0) N3=-N3#                    Sign h3 if negative              GS05 131
QX(I+2)=N1; QX(I+3)=N2; QX(I+4)=N3#    Put in generator list            GS05 132
IF(QX(I+1)>0.)  J=MARK#                Incr list for parents            GS05 133
ELSE            J=5#                   Else treat as equiv.s            GS05 134
###write(6,'(i8,13f10.2)') i,(qx(iii),iii=i+1,i+j)#                     GS05 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GS05 136
#                                                                       GS05 137
#   GENERATE SIN/COS TABLE IF FRAGS USED                                GS05 138
#   ------------------------------------                                GS05 139
#                                                                       GS05 140
IF(NFRG>0)#                            Test if frag info used           GS05 141
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GS05 142
incrqx:(Q6,Q5+450,GS0520)#             Expand qx ....... gs0520         GS05 143
FOR(I=Q5;I<Q6;I=I+1)#                  Loop 2.5 pi                      GS05 144
QX(I+1)=SIN(FLOAT(I-Q5)*.0174532925)#  Sine intervals 2pi/360           GS05 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GS05 146
#                                                                       GS05 147
RETURN#                                                                 GS05 148
END#                                                                    GS05 149
systemheader:(GS06)#                   Triplet struct. invariants       GS06   1
####################################################################    GS06   2
#                                                                  #    GS06   3
#                             GS06                                 #    GS06   4
#                                                                  #    GS06   5
####################################################################    GS06   6
SUBROUTINE GS06#                       S.r.hall  apr 81                 GS06   7
include:(AACOMN)#                                                       GS06   8
include:(GSCOMN)#                                                       GS06   9
#                                                                       GS06  10
REAL A,B,C,D,GENL,ACON,ATHR#                                            GS06  11
REAL CFAC,N1,N2,N3,M1,M2,M3#                                            GS06  12
INTEGER I,IB,IP,IPOP,J,K,L,M,MAXA,MXTG,N,NPSI#                          GS06  13
INTEGER L1,L2,L3,NU,MU,LU#                                              GS06  14
INTEGER NI,MI,LI,MS,LS,IQ,IA,IS,IPRC,IPSH#                              GS06  15
INTEGER NR,MR,LR,NN,MM,LL,IN,IM,IL,MAXT,NTPG#                           GS06  16
INTEGER NPAR,LPAR,NSYS,MSYM,LSYM,NSYE,MSYE,LSYE#                        GS06  17
INTEGER INCN,INCM,NTRI,MINV,LINV,MGEN,LGEN,ITOP#                        GS06  18
intdata:(KPR,[2,0,3,4,5,0,6,0,7,8,9,1])#                                GS06  19
realdata:(AFAC,0.);   realdata:(BFAC,0.)#                               GS06  20
intdata:(MPAR,0);  intdata:(IRED,0)#                                    GS06  21
datastuff:#                                                             GS06  22
#                                                                       GS06  23
#   SET TRIPLET PARAMETERS                                              GS06  24
#   -----------------------------                                       GS06  25
#                                                                       GS06  26
ACON=2.*PFAC#                          Prob. factor for triplets        GS06  27
ATHR=ABCT(1)#                          Set min a-value for search       GS06  28
MAXT=MXSI(1)#                          Set max triplets for search      GS06  29
MXTG=MXIG(1)#                          Set max triplets generator       GS06  30
IPOP=I1#                               Set a-popul. table pointer       GS06  31
ITOP=NINT(ATHR*128)#                   Set start pop table              GS06  32
NTRI=0#                                Set triplet count to zero        GS06  33
NPSI=0#                                Zero psi0 triplet count          GS06  34
MAXA=0#                                Set prob factor max              GS06  35
IQ=0#                                  Set default qpsi to zero         GS06  36
DO I=I0,I2#                            Loop buffer 1 scratch            GS06  37
QX(I)=0.#                              Zeroize dupl & pop. sums         GS06  38
#                                                                       GS06  39
#   FIRST GENERATOR LOOP N1                                             GS06  40
#   -----------------------                                             GS06  41
#                                                                       GS06  42
FOR(N=Q3+1;N<Q4;N=N+INCN)#             Loop generator list              GS06  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GS06  44
INCN=5#                                Set minimum generator incr.      GS06  45
IF(QX(N)<small:) NEXT#                 Test if parent refln.            GS06  46
INCN=MARK#                             Set pack length for parent       GS06  47
AFAC=ACON*QX(N+6)#                     Calc probability factor          GS06  48
NPAR=N;  NGEN=iqx:(N)#                 Set pointer & gener. no.         GS06  49
NSYS=iqx:(N+4);  NSYE=iqx:(NSYS)#      Get start/end of symops          GS06  50
N1=QX(N+1); N2=QX(N+2); N3=QX(N+3)#    Get signed h1,h2,h3              GS06  51
NTPG=0#                                Reset triplet/gen counter        GS06  52
IF(N<QQ) M=N#                          Test if normal generator         GS06  53
ELSE     M=Q3+1#                       Else is psi0 generator           GS06  54
#                                                                       GS06  55
#   SECOND GENERATOR LOOP N2                                            GS06  56
#   ------------------------                                            GS06  57
#                                                                       GS06  58
FOR(;M<QQ;M=M+INCM)#                   Loop generator list              GS06  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GS06  60
INCM=5#                                Set min packet for gen.          GS06  61
IF(QX(M)>small:)#                      Test if parent refln.            GS06  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GS06  63
INCM=MARK#                             Set parent packet size           GS06  64
BFAC=AFAC*QX(M+6)#                     Calc probability factor          GS06  65
IF(BFAC*QX(M+6)<ATHR) GO TO 100#       Pretest for maxa possible        GS06  66
MPAR=M;  MGEN=iqx:(M)#                 Set pointer & gener. no.         GS06  67
IRED=I0-1#                             Reset redun. table mark          GS06  68
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GS06  69
M1=QX(M+1); M2=QX(M+2); M3=QX(M+3)#    Get signed h1,h2,h3              GS06  70
MSYM=iqx:(M+4);  MSYE=iqx:(MSYM)#      Get start/end of symops          GS06  71
#                                                                       GS06  72
FOR(MS=MSYM;MS<MSYE;MS=MS+3)#          ******** n2 symop loop           GS06  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GS06  74
IF(MS>MSYM)#                           For symops beyond first          GS06  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GS06  76
I=iqx:(MS+1)#                          Get hkl sign code                GS06  77
IF(JH(I)<0) M1=-ABS(M1)#               Sign index h1                    GS06  78
ELSE        M1= ABS(M1)#               Sign index h1                    GS06  79
IF(JK(I)<0) M2=-ABS(M2)#               Sign index h2                    GS06  80
ELSE        M2= ABS(M2)#               Sign index h2                    GS06  81
IF(JL(I)<0) M3=-ABS(M3)#               Sign index h3                    GS06  82
ELSE        M3= ABS(M3)#               Sign index h3                    GS06  83
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GS06  84
#                                                                       GS06  85
#   FORM THIRD GENERATOR N3                                             GS06  86
#   -----------------------                                             GS06  87
#                                                                       GS06  88
L1=NINT(-N1-M1)#                       Form triplet h1                  GS06  89
IF(IABS(L1)>MXH1) NEXT#                Skip if outside data             GS06  90
L2=NINT(-N2-M2)#                       Form triplet h2                  GS06  91
IF(IABS(L2)>MXH2) NEXT#                Skip if outside data             GS06  92
L3=NINT(-N3-M3)#                       Form triplet h3                  GS06  93
IF(IABS(L3)>MXH3) NEXT#                Skip if outside data             GS06  94
IF(L1>=0) I= L3*MX4L+L2+IM00#          Point h1max in h2h3 table        GS06  95
ELSE      I=-L3*MX4L-L2+IM00#          Point h1max in h2h3 table        GS06  96
J=iqx:(I);  L=IABS(L1)#                Get |h1max| & |h1|               GS06  97
IF(L>J) NEXT#                          Test if |h1| in row line         GS06  98
I=I+MX2L#                              Point to addr of h1=0            GS06  99
J=iqx:(I)-L/INCR#                      Point to h1 in refln list        GS06 100
L=iqx:(J)#                             Put pointer to gen. list         GS06 101
IF(L<=0) NEXT#                         Skip non-generator reflns        GS06 102
IF(QX(L)<small:) LPAR=NINT(ABS(QX(L)))# Put pointer to parent           GS06 103
ELSE             LPAR=L#               Otherwise this is parent         GS06 104
IF(LPAR<MPAR) NEXT#                    N3 never less than n2            GS06 105
CFAC=BFAC*QX(LPAR+6)#                  Calc probability factor          GS06 106
IF(CFAC<ATHR) NEXT#                    Skip to next n2 symop            GS06 107
#                                                                       GS06 108
#                                       ****** check redund table       GS06 109
GENL=QX(LPAR)#                         Get gen. list no. n3             GS06 110
FOR(I=I0;I<=IRED;I=I+1)#               Loop redundancy table            GS06 111
ifeq:(QX(I),GENL) BREAK#               Exit if redundant                GS06 112
IF(I<=IRED) NEXT#                      Skip to next n2 symop            GS06 113
IRED=IRED+1#                           Incr redundancy table limit      GS06 114
IF(IRED<I1) QX(IRED)=GENL#             Put n3 value in tablt            GS06 115
ELSE           BREAK#                  Table limit to n3 values         GS06 116
LSYM=iqx:(L+4);   LSYE=iqx:(LSYM)#     Get start/end of symops          GS06 117
LGEN=iqx:(LPAR)#                       Get gen list no.                 GS06 118
#                                                                       GS06 119
#                                       ******** search for n3 symop    GS06 120
FOR(LS=LSYM;LS<LSYE;LS=LS+3)#          Loop n3 symops                   GS06 121
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GS06 122
I=iqx:(LS+1)#                          Get hkl sign code                GS06 123
IF(JH(I)<0) K=-IABS(L1)#               Form signed h1 index             GS06 124
ELSE        K= IABS(L1)#               Form signed h1 index             GS06 125
IF(L1!=K) NEXT#                        Skip if no match                 GS06 126
IF(JK(I)<0) K=-IABS(L2)#               Form signed h2 index             GS06 127
ELSE        K= IABS(L2)#               Form signed h2 index             GS06 128
IF(L2!=K) NEXT#                        Skip if no match                 GS06 129
IF(JL(I)<0) K=-IABS(L3)#               Form signed h3 index             GS06 130
ELSE        K= IABS(L3)#               Form signed h3 index             GS06 131
IF(L3==K) BREAK#                       Exit if match                    GS06 132
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GS06 133
IF(LS>=LSYE) iquit:(GS0610)#           Sym err ........ gs0610          GS06 134
IF(QX(LS+3)<small:) LINV=2#            Test if friedel equivalent       GS06 135
ELSE                LINV=0#            Else direct from matrices        GS06 136
IF(QX(MS+3)<small:) MINV=2#            Test if friedel equivalent       GS06 137
ELSE                MINV=1#            Else direct from matrices        GS06 138
IPSH=MOD(720-iqx:(LS+2)-iqx:(MS+2),360)# Calculate total phase shift    GS06 139
#                                                                       GS06 140
#    CALCULATE QPHI FROM FRAGMENTS                                      GS06 141
#    -----------------------------                                      GS06 142
#                                                                       GS06 143
IF((NFRG>0)&(N<QQ))#                   Test if qpsi requested           GS06 144
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GS06 145
MR=NINT(ABS(QX(MS+3)))#                Addr of row order table          GS06 146
LR=NINT(ABS(QX(LS+3)))#                Addr of row order table          GS06 147
IS=MINV+LINV#                          Calc sign of triplet phis        GS06 148
A=0.; B=0.; C=0.; NR=NROT#             Set for qphi calc                GS06 149
FOR(I=1;I<=NFRG;I=I+1)#                Loop group contributions         GS06 150
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GS06 151
IN=NPAR+I+6; IM=MPAR+I+6; IL=LPAR+I+6# Point group sf in gen list       GS06 152
IF(IFRG(I)==3)#                        For frag3 adjust point grp       GS06 153
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GS06 154
NR=MOD(NR,NROT)+1#                     Count point grps for frag3       GS06 155
MI=MR+NR;  LI=LR+NR#                   Point order value in table       GS06 156
IM=IM+iqx:(MI)-NR;  IL=IL+iqx:(LI)-NR# Point to equiv. group            GS06 157
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GS06 158
intunpak:(QX(IN),NN,9,23)#             Get n1 group s.f.                GS06 159
intunpak:(QX(IM),MM,9,23)#             Get n2 group s.f.                GS06 160
intunpak:(QX(IL),LL,9,23)#             Get n3 group s.f.                GS06 161
intunpak:(QX(IN),NI,0,9)#              Get qphi contribution            GS06 162
intunpak:(QX(IM),MI,0,9)#              Get qphi contribution            GS06 163
intunpak:(QX(IL),LI,0,9)#              Get qphi contribution            GS06 164
D=FLOAT(NN)*FLOAT(MM)*FLOAT(LL)#       Product of group s.f.            GS06 165
IF(MI>0) NI=NI+ISIGN(MI,JS2(IS))#      Sum n2 qpsi contribution         GS06 166
IF(LI>0) NI=NI+ISIGN(LI,JS3(IS))#      Sum n3 qpsi contribution         GS06 167
IF(IFRG(I)==4) NI=NI+IPSH#             Add phase shift for frag4        GS06 168
K=MOD(NI+3600,360)+Q5#                 Allow for equiv phase shift      GS06 169
IF(ICNT==0)#                           For noncentro s.g. only          GS06 170
B=B+D*QX(K+ 1)#                        Sum imag part of s.f.            GS06 171
A=A+D*QX(K+91)#                        Sum real part of s.f.            GS06 172
C=C+D#                                 Sum s.f. magnitudes              GS06 173
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GS06 174
CFAC=CFAC*SQRT(A*A+B*B)/C#             Scale pfac on agreement          GS06 175
IF(CFAC<ATHR) NEXT#                    Skip if pfac below thresh        GS06 176
IF((ABS(A)<0.01)&(ABS(B)<0.01)) A=1.#  Ensure zero length s.f.          GS06 177
D=ATAN2(B,A)*57.295779#                Deduce qphi for triplet          GS06 178
IQ=MOD(NINT(D)+360,360)#               Qphi modulo 360 (=2pi)           GS06 179
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GS06 180
#                                                                       GS06 181
#    DEDUCE PHASE RESTRICTIONS OF TRIPLET                               GS06 182
#    ------------------------------------                               GS06 183
#                                                                       GS06 184
IF(ICNT==0)#                           Test if non-centrosymmetric      GS06 185
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GS06 186
NU=iqx:(NSYE+1)/100#                   Phase restr in degrees           GS06 187
MU=iqx:(MSYE+1)/100#                   Phase restr in degrees           GS06 188
LU=iqx:(LSYE+1)/100#                   Phase restr in degrees           GS06 189
IF(MU!=180) IS=MINV#                   Include sign if rp not 0         GS06 190
ELSE        IS=1#                      Else reset phi signcode          GS06 191
IF(LU!=180) IS=IS+LINV#                Include sign if rp not 0         GS06 192
IF(NU!=0&MU!=0&LU!=0)#                 If all phis restricted           GS06 193
I=MOD(NU+ISIGN(MU,JS2(IS))$#           Add n1 and n2 restrict phis      GS06 194
+        ISIGN(LU,JS3(IS))+3600,180)/15+1# Add n3 restr & code          GS06 195
ELSE I=12#                             Force non-restr. phase code      GS06 196
IPRC=KPR(I)#                           Convert to phase restr code      GS06 197
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GS06 198
ELSE#                                  For centro invariants            GS06 199
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GS06 200
IPRC=2;     IS=1#                      Set restr & sign codes           GS06 201
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GS06 202
#                                                                       GS06 203
#                                       ****** put pfac population      GS06 204
IPSH=IPSH/30#                          Convert shift to 12ths           GS06 205
B=CFAC*SQRT(QX(N+5)+QX(MPAR+5)+QX(LPAR+5))# Calc sigma(a)               GS06 206
IA=AMIN1(CFAC,15.99)*128.#             Make cfac integer for o/p        GS06 207
IB=AMIN1(B   ,15.99)*128.#             Make siga integer for o/p        GS06 208
IF(N<QQ)#                              Test if normal generator         GS06 209
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GS06 210
MAXA=MAX0(MAXA,IA)#                    Put maximum prob factor          GS06 211
NTRI=NTRI+1#                           Sum number of triplets           GS06 212
NTPG=NTPG+1#                           Sum triplets/generator           GS06 213
I=MIN0(IA-ITOP,255)+I1#                Point to population table        GS06 214
QX(I)=QX(I)+1.#                        Log this a-value                 GS06 215
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GS06 216
ELSE#                                  This is a psi0 triplet           GS06 217
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GS06 218
NPSI=NPSI+1#                           Count psi0 triplets              GS06 219
IA=IA/2#                               Restore as psi0 e=1.             GS06 220
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GS06 221
#                                                                       GS06 222
#                                       ******* o/p triplets file3      GS06 223
writepkt:(3,3,pstrip:,IP)#             Get o/p packet pointer           GS06 224
pphaserestr:(IP,IPRC)#                 Pack trip restr  1 bits  3- 0    GS06 225
pphisigncode:(  IP,IS-1)#              Pack phi sign cd 1 bits  6- 4    GS06 226
pphiinvshift:(  IP,IPSH)#              Pack phi shift   1 bits 10- 7    GS06 227
pphifragment:(  IP,  IQ)#              Pack frag qphi   1 bits 19-11    GS06 228
pprobfactor:(   IP,  IA)#              Pack pfac*128    1 bits **-20    GS06 229
pprobfsigma:(   IP,  IB)#              Pack siga*128.   2 bits **-20    GS06 230
pgeneratornum:(IP,NGEN,1)#             Pack n3 in word  3               GS06 231
pgeneratornum:(IP,MGEN,2)#             Pack n2 in word  4               GS06 232
pgeneratornum:(IP,LGEN,3)#             Pack n1 in word  5               GS06 233
#                                                                       GS06 234
IF(NTPG==MXTG) GO TO 100#              Reset n1 if max trip/gen         GS06 235
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GS06 236
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GS06 237
100 CONTINUE#                          Breakpoint of n2 loop            GS06 238
#                                                                       GS06 239
#                                       ******* adjust amin to maxt     GS06 240
FOR(;NTRI-iqx:(IPOP)>MAXT;IPOP=IPOP+1)# Loop thru a-pop table           GS06 241
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GS06 242
NTRI=NTRI-iqx:(IPOP)#                  Reduce by pop in this range      GS06 243
ATHR=FLOAT(IPOP+ITOP-I1)/128.#         Adjust athresh accordingly       GS06 244
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GS06 245
IF(iqx:(I2)>MAXT) BREAK#               Finish if enough found           GS06 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GS06 247
#                                                                       GS06 248
#                                       ****** estimate amax            GS06 249
AMAX(1)=FLOAT(MAXA)/128.#              Save maximum prob factor         GS06 250
AMIN(1)=ATHR#                          Put final a-threshold            GS06 251
SIMX(1)=FLOAT(NTRI)#                   Put final triplet count          GS06 252
SIMX(3)=FLOAT(NPSI)#                   Put psi0 triplet count           GS06 253
#                                                                       GS06 254
RETURN#                                                                 GS06 255
END#                                                                    GS06 256
systemheader:(GS07)#                   Quartet struct. invariants       GS07   1
####################################################################    GS07   2
#                                                                  #    GS07   3
#                             GS07                                 #    GS07   4
#                                                                  #    GS07   5
####################################################################    GS07   6
SUBROUTINE GS07#                       S.r.hall  jun 81                 GS07   7
include:(AACOMN)#                                                       GS07   8
include:(GSCOMN)#                                                       GS07   9
#                                                                       GS07  10
REAL AFAC,DFAC,A,B,C,D,GENL,GENK,BCON,BTHR#                             GS07  11
REAL E1,E2,E3,N1,N2,N3,M1,M2,M3,L1,L2,L3,XVSM#                          GS07  12
INTEGER I,IB,IP,IPOP,IX,J,K,L,M,MAXA,MROT,MXQG,N#                       GS07  13
INTEGER K1,K2,K3,NU,MU,LU,KU,NR,MR,LR,KR#                               GS07  14
INTEGER NI,MI,LI,KI,MS,LS,KS,IQ,IA,IS,IPRC,IPSH#                        GS07  15
INTEGER NPAR,KPAR,NSYS,MSYM,LSYM,KSYM#                                  GS07  16
INTEGER INCN,INCM,INCL,MINV,LINV,KINV,MGEN,LGEN,KGEN#                   GS07  17
INTEGER NSYE,MSYE,LSYE,KSYE,ITOP#                                       GS07  18
INTEGER NN,MM,LL,KK,IN,IM,IL,IK,NQUA,NQPG,MAXQ#                         GS07  19
intdata:(KPR,[2,0,3,4,5,0,6,0,7,8,9,1])#                                GS07  20
realdata:(BFAC,0.);  realdata:(CFAC,0.)#                                GS07  21
intdata:(MPAR,0); intdata:(LPAR,0); intdata:(IRED,0)#                   GS07  22
datastuff:#                                                             GS07  23
#                                                                       GS07  24
#   SET QUARTET PARAMETERS                                              GS07  25
#   -----------------------------                                       GS07  26
#                                                                       GS07  27
BCON=2.*PFAC**2#                       Prob. factor for quartets        GS07  28
BTHR=ABCT(2)#                          Set min b-value for search       GS07  29
MAXQ=MXSI(2)#                          Set max quartets for search      GS07  30
MXQG=MXIG(2)#                          Set max quartets generator       GS07  31
IPOP=I1#                               Set a-popul. table pointer       GS07  32
ITOP=NINT(BTHR*128.)#                  Set start pop table              GS07  33
NQUA=0#                                Set quartet count to zero        GS07  34
MAXA=0#                                Set prob factor max              GS07  35
XVSM=0.#                               Set xvector sum                  GS07  36
IQ=0#                                  Set default qpsi to zero         GS07  37
DO I=I0,I2#                            Loop buffer 1 scratch            GS07  38
QX(I)=0.#                              Zeroize redun & pop. sums        GS07  39
#                                                                       GS07  40
#   FIRST GENERATOR LOOP N1                                             GS07  41
#   -----------------------                                             GS07  42
#                                                                       GS07  43
FOR(N=Q3+1;N<QQ;N=N+INCN)#             Loop generator list              GS07  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GS07  45
INCN=5#                                Set minimum generator incr.      GS07  46
IF(QX(N)<small:) NEXT#                 Test if parent refln.            GS07  47
INCN=MARK#                             Set pack length for parent       GS07  48
AFAC=BCON*QX(N+6)#                     Calc probability factor          GS07  49
NPAR=N;  NGEN=iqx:(N)#                 Set pointer & gener. no.         GS07  50
NSYS=iqx:(N+4);  NSYE=iqx:(NSYS)#      Get start/end of symops          GS07  51
NR=NINT(QX(NSYS+3))#                   Matrix-order pointer             GS07  52
N1=QX(N+1); N2=QX(N+2); N3=QX(N+3)#    Get signed h1,h2,h3              GS07  53
NQPG=0#                                Reset quartet/gen counter        GS07  54
#                                                                       GS07  55
#   SECOND GENERATOR LOOP N2                                            GS07  56
#   ------------------------                                            GS07  57
#                                                                       GS07  58
FOR(M=N;M<QQ;M=M+INCM)#                Loop generator list              GS07  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GS07  60
INCM=5#                                Set min packet for gener         GS07  61
IF(QX(M)>small:)#                      Test if parent refln.            GS07  62
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GS07  63
INCM=MARK#                             Set parent packet size           GS07  64
BFAC=AFAC*QX(M+6)#                     Calc probability factor          GS07  65
IF(BFAC*QX(M+6)**2<BTHR) GO TO 300#    Pretest for maxb possible        GS07  66
MPAR=M;  MGEN=iqx:(M)#                 Set pointer & gener. no.         GS07  67
IRED=I0-2#                             Reset redun. table mark          GS07  68
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GS07  69
M1=QX(M+1); M2=QX(M+2); M3=QX(M+3)#    Get signed h1,h2,h3              GS07  70
MSYM=iqx:(M+4);  MSYE=iqx:(MSYM)#      Get start/end of symops          GS07  71
#                                                                       GS07  72
FOR(MS=MSYM;MS<MSYE;MS=MS+3)#          ******** n2 symop loop           GS07  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GS07  74
IF(MS>MSYM)#                           For symops beyond first          GS07  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GS07  76
I=iqx:(MS+1)#                          Get hkl sign code                GS07  77
IF(JH(I)<0) M1=-ABS(M1)#               Sign index h1                    GS07  78
ELSE        M1= ABS(M1)#               Sign index h1                    GS07  79
IF(JK(I)<0) M2=-ABS(M2)#               Sign index h2                    GS07  80
ELSE        M2= ABS(M2)#               Sign index h2                    GS07  81
IF(JL(I)<0) M3=-ABS(M3)#               Sign index h3                    GS07  82
ELSE        M3= ABS(M3)#               Sign index h3                    GS07  83
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GS07  84
MR=NINT(QX(MS+3))#                     Matrix-order pointer             GS07  85
IF(M==N&MR==-NR) NEXT#                 Test trivial case h2+h1=0        GS07  86
IF(IXVF>0)#                            Test if xvectors requested       GS07  87
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GS07  88
CALL GS08(N1,N2,N3,M1,M2,M3,E1)#       Find xvector h1+h2 & |e|         GS07  89
IF((IXVF==1)&(E1<0.)) NEXT#            Test if inside xvector           GS07  90
IF((E1<XVMN)\(E1>XVMX)) NEXT#          Test if xvec |e| acceptable      GS07  91
IF((E1>XSLO)&(E1+4.<XSHI)) NEXT#       Skip if sum unsuitable           GS07  92
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GS07  93
#                                                                       GS07  94
#   THIRD GENERATOR LOOP N3                                             GS07  95
#   -----------------------                                             GS07  96
#                                                                       GS07  97
FOR(L=MPAR;L<QQ;L=L+INCL)#             Loop generator list              GS07  98
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GS07  99
INCL=5#                                Set min packet for gener         GS07 100
IF(QX(L)>small:)#                      Test if parent refln.            GS07 101
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GS07 102
INCL=MARK#                             Set parent packet size           GS07 103
CFAC=BFAC*QX(L+6)#                     Calc probability factor          GS07 104
IF(CFAC*QX(L+6)<BTHR) GO TO 100#       Pretest for maxb possible        GS07 105
LPAR=L;  LGEN=iqx:(L)#                 Set pointer & gener. no.         GS07 106
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GS07 107
L1=QX(L+1); L2=QX(L+2); L3=QX(L+3)#    Get signed h1,h2,h3              GS07 108
LSYM=iqx:(L+4);  LSYE=iqx:(LSYM)#      Get start/end of symops          GS07 109
#                                                                       GS07 110
FOR(LS=LSYM;LS<LSYE;LS=LS+3)#          ******** n3 symop loop           GS07 111
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GS07 112
IF(LS>LSYM)#                           For symops beyond first          GS07 113
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GS07 114
I=iqx:(LS+1)#                          Get hkl sign code                GS07 115
IF(JH(I)<0) L1=-ABS(L1)#               Sign index h1                    GS07 116
ELSE        L1= ABS(L1)#               Sign index h1                    GS07 117
IF(JK(I)<0) L2=-ABS(L2)#               Sign index h2                    GS07 118
ELSE        L2= ABS(L2)#               Sign index h2                    GS07 119
IF(JL(I)<0) L3=-ABS(L3)#               Sign index h3                    GS07 120
ELSE        L3= ABS(L3)#               Sign index h3                    GS07 121
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GS07 122
LR=NINT(QX(LS+3))#                     Matrix-order pointer             GS07 123
IF(L==N&LR==-NR) NEXT#                 Test trivial case h3+h1=0        GS07 124
IF(L==M&LR==-MR) NEXT#                 Test trivial case h3+h2=0        GS07 125
IF(IXVF>0)#                            Test if xvectors requested       GS07 126
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GS07 127
CALL GS08(N1,N2,N3,L1,L2,L3,E2)#       Find xvector h1+h3 & |e|         GS07 128
IF((IXVF==1)&(E2<0.)) NEXT#            Test if inside xvector           GS07 129
IF((E2<XVMN)\(E2>XVMX)) NEXT#          Test if xvec |e| acceptable      GS07 130
IF((E1+E2>XSLO)&(E1+E2+3.<XSHI)) NEXT# Skip if sum unsuitable           GS07 131
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GS07 132
#                                                                       GS07 133
#   FORM FOURTH GENERATOR N4                                            GS07 134
#   ------------------------                                            GS07 135
#                                                                       GS07 136
K1=NINT(-N1-M1-L1)#                    Form quartet h1                  GS07 137
IF(IABS(K1)>MXH1) NEXT#                Skip if outside data             GS07 138
K2=NINT(-N2-M2-L2)#                    Form quartet h2                  GS07 139
IF(IABS(K2)>MXH2) NEXT#                Skip if outside data             GS07 140
K3=NINT(-N3-M3-L3)#                    Form quartet h3                  GS07 141
IF(IABS(K3)>MXH3) NEXT#                Skip if outside data             GS07 142
IF(K1>=0) I= K3*MX4L+K2+IM00#          Point h1max in h2h3 table        GS07 143
ELSE      I=-K3*MX4L-K2+IM00#          Point h1max in h2h3 table        GS07 144
J=iqx:(I);  K=IABS(K1)#                Get |h1max| & |h1|               GS07 145
IF(K>J) NEXT#                          Test if |h1| in row line         GS07 146
I=I+MX2L#                              Point to addr of h1=0            GS07 147
J=iqx:(I)-K/INCR#                      Point to h1 in refln list        GS07 148
K=iqx:(J)#                             Put pointer to gen. list         GS07 149
IF(K<=0) NEXT#                         Skip non-generator reflns        GS07 150
IF(QX(K)<small:) KPAR=NINT(ABS(QX(K)))# Put pointer to parent           GS07 151
ELSE             KPAR=K#               Else this is parent              GS07 152
IF(KPAR<LPAR) NEXT#                    N4 never less than n3            GS07 153
DFAC=CFAC*QX(KPAR+6)#                  Calc probability factor          GS07 154
IF(DFAC<BTHR) NEXT#                    Skip to next n3 symop            GS07 155
KSYM=iqx:(K+4);   KSYE=iqx:(KSYM)#     Get start/end of symops          GS07 156
#                                                                       GS07 157
#                                       ******* search for n3 symop     GS07 158
FOR(KS=KSYM;KS<KSYE;KS=KS+3)#          Loop n4 symops                   GS07 159
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GS07 160
I=iqx:(KS+1)#                          Get hkl sign code                GS07 161
IF(JH(I)<0) J=-IABS(K1)#               Form signed h1 index             GS07 162
ELSE        J= IABS(K1)#               Form signed h1 index             GS07 163
IF(K1!=J) NEXT#                        Slip if no match                 GS07 164
IF(JK(I)<0) J=-IABS(K2)#               Form signed h2 index             GS07 165
ELSE        J= IABS(K2)#               Form signed h2 index             GS07 166
IF(K2!=J) NEXT#                        Slip if no match                 GS07 167
IF(JL(I)<0) J=-IABS(K3)#               Form signed h3 index             GS07 168
ELSE        J= IABS(K3)#               Form signed h3 index             GS07 169
IF(K3==J) BREAK#                       Exit if match                    GS07 170
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GS07 171
IF(KS>=KSYE) iquit:(GS0710)#           Sym err ........ gs0710          GS07 172
KR=NINT(QX(KS+3))#                     Matrix-order pointer             GS07 173
IF(K==N&KR==-NR) NEXT#                 Test trivial case h4+h1=0        GS07 174
IF(K==M&KR==-MR) NEXT#                 Test trivial case h4+h2=0        GS07 175
IF(K==L&KR==-LR) NEXT#                 Test trivial case h4+h3=0        GS07 176
#                                                                       GS07 177
#                                       ********* x-vector |e| sum      GS07 178
IF(IXVF>0)#                            Test if xvectors requested       GS07 179
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GS07 180
CALL GS08(M1,M2,M3,L1,L2,L3,E3)#       Find xvector h2+h3 & |e|         GS07 181
IF((IXVF==1)&(E3<0.)) NEXT#            Test if inside xvector           GS07 182
IF((E3<XVMN)\(E3>XVMX)) NEXT#          Test if xvec |e| acceptable      GS07 183
XVSM=AMIN1(63.99,ABS(E1)+ABS(E2)+ABS(E3))# Sum xvector |e| values       GS07 184
IF(E1<0.\E2<0.\E3<0.) XVSM=-XVSM#      Test if any vectors unknown      GS07 185
ELSE IF(IXVF==3) NEXT#                 Skip if not extra xvector        GS07 186
ELSE IF(XVSM>XSLO&XVSM<XSHI) NEXT#     Test if in forbidden zone        GS07 187
A=ABS(XVSM)#                           Get positive xvector sum         GS07 188
IF     (A>=XSHI) DFAC=DFAC*(1.0+A*PFAC)# Enhance prob fac pquar         GS07 189
ELSE IF(A<=XSLO) DFAC=DFAC*(2.5-A)#    Enhance prob fac nquar           GS07 190
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GS07 191
#                                                                       GS07 192
#                                       ****** check redund table       GS07 193
GENL=QX(LPAR);   GENK=QX(KPAR)#        Get gen. list no. n3 & n4        GS07 194
FOR(I=I0;I<=IRED;I=I+2)#               Loop redundancy table            GS07 195
ifeq:(QX(I),GENL)#                     Test if n3 redundant             GS07 196
ifeq:(QX(I+1),GENK) BREAK#             Test if n4 redundant             GS07 197
IF(I<=IRED) NEXT#                      Skip to next n3 symop            GS07 198
IRED=IRED+2#                           Incr redundancy table limit      GS07 199
IF(IRED>=I1) GO TO 300#                Truncate n2 if overflows         GS07 200
QX(IRED)=GENL;  QX(IRED+1)=GENK#       Put values of n3 & n4            GS07 201
#                                                                       GS07 202
#                                       ******** code phi reverses      GS07 203
KGEN=iqx:(KPAR)#                       Get n4 parent generator          GS07 204
IF(QX(MS+3)<small:) MINV=2#            Test if friedel equivalent       GS07 205
ELSE                MINV=1#            Else direct from matrices        GS07 206
IF(QX(LS+3)<small:) LINV=2#            Test if friedel equivalent       GS07 207
ELSE                LINV=0#            Else direct from matrices        GS07 208
IF(QX(KS+3)<small:) KINV=4#            Test if friedel equivalent       GS07 209
ELSE                KINV=0#            Else direct from matrices        GS07 210
IPSH=MOD(3600-iqx:(LS+2)-iqx:(MS+2)-iqx:(KS+2),360)# Calc phi shift     GS07 211
#                                                                       GS07 212
#    CALCULATE QPHI FROM FRAGMENTS                                      GS07 213
#    -----------------------------                                      GS07 214
#                                                                       GS07 215
IF(NFRG>0)#                            If qphi requested/possible       GS07 216
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GS07 217
IS=MINV+LINV+KINV#                     Calc sign of quartet phis        GS07 218
MR=IABS(MR); LR=IABS(LR); KR=IABS(KR)# Get matrix order pointer         GS07 219
A=0.; B=0.; C=0.; MROT=NROT#           Set for qphi calc                GS07 220
FOR(I=1;I<=NFRG;I=I+1)#                Loop group contributions         GS07 221
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GS07 222
J=I+6; IN=NPAR+J; IM=MPAR+J; IL=LPAR+J; IK=KPAR+J# Point to grp s.f.    GS07 223
IF(IFRG(I)==3)#                        For frag3 adjust point grp       GS07 224
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GS07 225
MROT=MOD(MROT,NROT)+1#                 Cnt point grps for frag3         GS07 226
MI=MR+MROT;  LI=LR+MROT;  KI=KR+MROT#  Point order value in table       GS07 227
IM=IM+iqx:(MI)-MROT#                   Use order matrix for equiv.      GS07 228
IL=IL+iqx:(LI)-MROT#                   Use order matrix for equiv.      GS07 229
IK=IK+iqx:(KI)-MROT#                   Use order matrix for equiv.      GS07 230
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GS07 231
intunpak:(QX(IN),NN,9,23)#             Get n1 group s.f.                GS07 232
intunpak:(QX(IM),MM,9,23)#             Get n2 group s.f.                GS07 233
intunpak:(QX(IL),LL,9,23)#             Get n3 group s.f.                GS07 234
intunpak:(QX(IK),KK,9,23)#             Get n4 group s.f.                GS07 235
intunpak:(QX(IN),NI,0,9)#              Get qphi contribution            GS07 236
intunpak:(QX(IM),MI,0,9)#              Get qphi contribution            GS07 237
intunpak:(QX(IL),LI,0,9)#              Get qphi contribution            GS07 238
intunpak:(QX(IK),KI,0,9)#              Get qphi contribution            GS07 239
D=FLOAT(NN)*FLOAT(MM)*FLOAT(LL)*FLOAT(KK)# Product of group s.f.        GS07 240
IF(MI>0) NI=NI+ISIGN(MI,JS2(IS))#      Sum n2 qpsi contribution         GS07 241
IF(LI>0) NI=NI+ISIGN(LI,JS3(IS))#      Sum n3 qpsi contribution         GS07 242
IF(KI>0) NI=NI+ISIGN(KI,JS4(IS))#      Sum n4 qpsi contribution         GS07 243
IF(IFRG(I)==4) NI=NI+IPSH#             Add phase shift if frag4         GS07 244
J=MOD(NI+3600,360)+Q5#                 Allow for equiv phase shift      GS07 245
IF(ICNT==0)#                           For noncentro s.g. only          GS07 246
B=B+D*QX(J+ 1)#                        Sum imag part of s.f.            GS07 247
A=A+D*QX(J+91)#                        Sum real part of s.f.            GS07 248
C=C+D#                                 Sum magnitude of s.f.            GS07 249
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GS07 250
DFAC=DFAC*SQRT(A*A+B*B)/C#             Scale pfac on agreement          GS07 251
IF(DFAC<BTHR) NEXT#                    Skip if pfac below thresh        GS07 252
IF((ABS(A)<0.01)&(ABS(B)<0.01)) A=1.#  Ensure zero length s.f.          GS07 253
D=ATAN2(B,A)*57.295779#                Deduce qphi for quartet          GS07 254
IQ=MOD(NINT(D)+360,360)#               Qphi modulo 360 (=2pi)           GS07 255
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GS07 256
#                                                                       GS07 257
#    DEDUCE PHASE RESTRICTIONS OF QUARTET                               GS07 258
#    ------------------------------------                               GS07 259
#                                                                       GS07 260
IF(ICNT==0)#                           Test if non-centro               GS07 261
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GS07 262
NU=iqx:(NSYE+1)/100#                   Phase restr in degrees           GS07 263
MU=iqx:(MSYE+1)/100#                   Phase restr in degrees           GS07 264
LU=iqx:(LSYE+1)/100#                   Phase restr in degrees           GS07 265
KU=iqx:(KSYE+1)/100#                   Phase restr in degrees           GS07 266
IF(MU!=180) IS=MINV#                   Include sign if rp not 0         GS07 267
ELSE        IS=1#                      Else reset phi sign              GS07 268
IF(LU!=180) IS=IS+LINV#                Include sign if rp not 0         GS07 269
IF(KU!=180) IS=IS+KINV#                Include sign if rp not 0         GS07 270
IF(NU!=0&MU!=0&LU!=0&KU!=0)#           If all phis restricted           GS07 271
I=MOD(NU+ISIGN(MU,JS2(IS))$#           Add n1 & n2 restr phis           GS07 272
+        ISIGN(LU,JS3(IS))$#           Add n3 restr phi                 GS07 273
+        ISIGN(KU,JS4(IS))+3600,180)/15+1# Add n4 & reduce to code      GS07 274
ELSE I=12#                             Force non-restr. phase code      GS07 275
IPRC=KPR(I)#                           Convert to phase restr code      GS07 276
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GS07 277
ELSE#                                  For centro invariants            GS07 278
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GS07 279
IPRC=2;     IS=1#                      Set restr phase & sign s         GS07 280
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GS07 281
#                                                                       GS07 282
#                                       ****** put pfac population      GS07 283
IPSH=IPSH/30#                          Convert shift to 12ths           GS07 284
B=DFAC*SQRT(QX(N+5)+QX(MPAR+5)+QX(LPAR+5)+QX(KPAR+5))# Calc sigma(b)    GS07 285
IA=AMIN1(DFAC,15.99)*128.#             Make dfac integer for o/p        GS07 286
IB=AMIN1(B   ,15.99)*128.#             Make sigb integer for o/p        GS07 287
MAXA=MAX0(MAXA,IA)#                    Put maximum prob factor          GS07 288
IX=NINT(XVSM*8.)+512#                  Encode xvector /sum for o/p      GS07 289
NQUA=NQUA+1#                           Sum number of quartets           GS07 290
NQPG=NQPG+1#                           Sum quartets per generator       GS07 291
I=MIN0(IA-ITOP,255)+I1#                Point to population table  &     GS07 292
QX(I)=QX(I)+1.#                        Log this b-value                 GS07 293
#                                                                       GS07 294
#                                       ******* o/p quartets file3      GS07 295
writepkt:(3,4,psquar:,IP)#             Get o/p packet pointer           GS07 296
pphaserestr:(  IP,IPRC)#               Pack trip restr  1 bits  3- 0    GS07 297
pphisigncode:( IP,IS-1)#               Pack phi sign cd 1 bits  6- 4    GS07 298
pphiinvshift:( IP,IPSH)#               Pack phi shift   1 bits 10- 7    GS07 299
pphifragment:( IP,  IQ)#               Pack frag qphi   1 bits 19-11    GS07 300
pprobfactor:(  IP,  IA)#               Pack pfac*128    1 bits **-20    GS07 301
pxvectorsum:(  IP,  IX)#               Pack xvsum*8     2 bits 10-19    GS07 302
pprobfsigma:(  IP,  IB)#               Pack siga*128.   2 bits **-20    GS07 303
pgeneratornum:(IP,NGEN,1)#             Pack n3 in word  3               GS07 304
pgeneratornum:(IP,MGEN,2)#             Pack n2 in word  4               GS07 305
pgeneratornum:(IP,LGEN,3)#             Pack n1 in word  5               GS07 306
pgeneratornum:(IP,KGEN,4)#             Pack n4 in word  6               GS07 307
#                                                                       GS07 308
IF(NQPG==MXQG) GO TO 300#              Reset n1 if max quar/gen         GS07 309
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GS07 310
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GS07 311
100 CONTINUE#                          Breakpoint of n3 loop            GS07 312
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GS07 313
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GS07 314
300 CONTINUE#                          Breakpoint of n2 loop            GS07 315
#                                                                       GS07 316
#                                       ******* adjust bmin to maxq     GS07 317
FOR(;NQUA-iqx:(IPOP)>MAXQ;IPOP=IPOP+1)# Loop thru b-pop table           GS07 318
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GS07 319
NQUA=NQUA-iqx:(IPOP)#                  Reduce by pop in this range      GS07 320
BTHR=FLOAT(IPOP+ITOP-I1)/128.#         Adjust bthresh accordingly &     GS07 321
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GS07 322
IF(iqx:(I2)>MAXQ) BREAK#               Finish if enough found           GS07 323
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GS07 324
#                                                                       GS07 325
#                                       ****** estimate amax            GS07 326
AMAX(2)=FLOAT(MAXA)/128.#              Save maximum prob factor         GS07 327
AMIN(2)=BTHR#                          Put final b-threshold            GS07 328
SIMX(2)=FLOAT(NQUA)#                   Put final quartet count          GS07 329
#                                                                       GS07 330
RETURN#                                                                 GS07 331
END#                                                                    GS07 332
systemheader:(GS08)#                   Locate invariant xvectors        GS08   1
####################################################################    GS08   2
#                                                                  #    GS08   3
#                             GS08                                 #    GS08   4
#                                                                  #    GS08   5
####################################################################    GS08   6
SUBROUTINE GS08(H1,H2,H3,K1,K2,K3,E)#                                   GS08   7
include:(AACOMN)#                                                       GS08   8
include:(GSCOMN)#                                                       GS08   9
#                                                                       GS08  10
REAL H1,H2,H3,K1,K2,K3,E#                                               GS08  11
INTEGER L1,L2,L3,I,J#                                                   GS08  12
#                                                                       GS08  13
E=-1.#                                 Set default xvector |e|          GS08  14
L1=NINT(H1+K1)#                        Form xvector h1                  GS08  15
IF(IABS(L1)>MXH1) GO TO 100#           Test if outside sphere           GS08  16
L2=NINT(H2+K2)#                        Form xvector h2                  GS08  17
IF(IABS(L2)>MXH2) GO TO 100#           Test if outside sphere           GS08  18
L3=NINT(H3+K3)#                        Form xvector h3                  GS08  19
IF(IABS(L3)>MXH3) GO TO 100#           Test if outside sphere           GS08  20
IF(L1>=0) I= L3*MX4L+L2+IM00#          Point to hmax in h2h3 table      GS08  21
ELSE      I=-L3*MX4L-L2+IM00#          Point to hmax in h2h3 table      GS08  22
IF(IABS(L1)>iqx:(I)) GO TO 100#        Test for row line max            GS08  23
I=I+MX2L#                              Point origin in h2h3 table       GS08  24
I=iqx:(I)-IABS(L1)/INCR#               Point refln l1,l2,l3             GS08  25
J=iqx:(I)#                             Get value |e| or pointer         GS08  26
IF(J==0) GO TO 100#                    Test if void refln.              GS08  27
IF(J>0)#                               Test if pointer genr list        GS08  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GS08  29
I=NINT(QX(J))#                         Get word1 genr list              GS08  30
IF(I<0) J=-I#                          Test if pointer parent |e|       GS08  31
E=QX(J+6)#                             Get |e| from gener list          GS08  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GS08  33
ELSE  E=-QX(I)-2.#                     Get |e| from refln list          GS08  34
100 RETURN#                                                             GS08  35
END#                                                                    GS08  36
systemheader:(GS10)#                   Review s.i. & list gener.s       GS10   1
####################################################################    GS10   2
#                                                                  #    GS10   3
#                             GS10                                 #    GS10   4
#                                                                  #    GS10   5
####################################################################    GS10   6
SUBROUTINE GS10#                       S.r.hall  apr 81                 GS10   7
include:(AACOMN)#                                                       GS10   8
include:(GSCOMN)#                                                       GS10   9
#                                                                       GS10  10
INTEGER I,III,J,K,L,M,N,IP,NP,JP,MP,N1,N2,N3,N4,NN,NTRI#                GS10  11
REAL A,SX1,SX2,SX3,XSMN,XSMX,XVSM#                                      GS10  12
chardata:(SN1, TRIPLET STRUCTURE INVARIANTS)#                           GS10  13
chardata:(SN2, NUMBER OF UNIQUE INVARIANTS          )#                  GS10  14
chardata:(SN3, RANGE OF PROBABILITY FACTORS          TO      )#         GS10  15
chardata:(SN4, QUARTET STRUCTURE INVARIANTS)#                           GS10  16
chardata:(SN5, MAXIMUM INVARIANTS/GENERATOR         )#                  GS10  17
chardata:(SN7,   NONE  0/180 30/210 45/225 60/240 90/270$#              GS10  18
120/300135/315150/330)#                                                 GS10  19
chardata:(SN8, NGEN    H   K   L    |E|   SIGE    U  V  W  $#           GS10  20
POS ODR  RESTR.  NT3  SUM A   NQ4  SUM B)#                              GS10  21
chardata:(SN9, NOYES-)#                                                 GS10  22
chardata:(SN11, QUARTETS WITH UNCERTAIN XVSUMS       )#                 GS10  23
chardata:(SN12, QUARTETS WITH XVSUMS IN RANGE         TO         )#     GS10  24
chardata:(SN13,[ NUMBER OF PSI(0) TRIPLETS             ])#              GS10  25
realdata:(FMT,[50413.,100413.,140413.,180413.,250522.,320522.,#         GS10  26
370313.,400313.,430313.])#                                              GS10  27
realdata:(RPC,[1.,0.,3.,4.,5.,0.,6.,0.,7.,8.,9.,0.,2.])#                GS10  28
realdata:(ATHR,0.)#                                                     GS10  29
datastuff:#                                                             GS10  30
#                                                                       GS10  31
#  OUTPUT GENSIN PARAMETERS ON FILE 3                                   GS10  32
#  ----------------------------------                                   GS10  33
#                                                                       GS10  34
writepkt:(3,5,100,IP)#                 Point to parameter packet        GS10  35
movereal:(0.,1,QX,IP+1,100,2)#         Zeroize parameter packet         GS10  36
QX(IP+ 1)=FLOAT(IETY)#                 Put |e| type (1,2)               GS10  37
QX(IP+ 2)=EMIN+.0624#                  Put |e| minimum                  GS10  38
QX(IP+ 3)=PFAC#                        Put probability factor           GS10  39
QX(IP+ 4)=FLOAT(MAXG)#                 Put number of generators         GS10  40
QX(IP+ 5)=SMIN#                        Put sin t/l minimum              GS10  41
QX(IP+ 6)=SMAX#                        Put sin t/l maximum              GS10  42
QX(IP+ 7)=SGET#                        Put sigma|e| factor              GS10  43
QX(IP+ 8)=FLOAT(LTYP)#                 Put lattice type (1-7)           GS10  44
QX(IP+ 9)=FLOAT(NFRG)#                 Put fragment flag/no.            GS10  45
QX(IP+10)=FLOAT(ICNT)#                 Put centre flag (c=1/n=0)        GS10  46
QX(IP+11)=FLOAT(MAXP)#                 Put number psi0 gen's            GS10  47
QX(IP+12)=HEAV#                        Put heavy atom factor            GS10  48
QX(IP+13)=FLOAT(NSYM)#                 Put total symops                 GS10  49
#                                                                       GS10  50
DO I=1,3#                              Loop invariant orders            GS10  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GS10  52
J=IP+25+I#                             Point to o/p buffer              GS10  53
QX(J   )=ABCT(I)#                      Put preset prob. thresholds      GS10  54
QX(J+ 3)=AMIN(I)#                      Put actual prob. minima          GS10  55
QX(J+ 6)=AMAX(I)#                      Put actual prob. maxima          GS10  56
QX(J+ 9)=MXSI(I)#                      Put preset si count maxima       GS10  57
QX(J+12)=SIMX(I)#                      Put actual si count total        GS10  58
QX(J+15)=FLOAT(MXIG(I))#               Put preset si/gen maxima         GS10  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GS10  60
QX(IP+45)=XVMN#                        Put xvec |e| min                 GS10  61
QX(IP+46)=XVMX#                        Put xvec |e| max                 GS10  62
QX(IP+47)=XSLO#                        Put xvec sum lo limit            GS10  63
QX(IP+48)=XSHI#                        Put xvec sum hi limit            GS10  64
#                                                                       GS10  65
QX(IP+76)=FLOAT(NODR)#                 Put number of odr's              GS10  66
QX(IP+77)=FLOAT(NONR)#                 Put number of restr. odr's       GS10  67
J=IP+79;   L=IP+82#                    Set buffer pointers              GS10  68
DO I=1,3#                              Loop possible odr's              GS10  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GS10  70
J=J+1#                                 Point to o/p buffer              GS10  71
QX(J)=FLOAT(MDSI(I))#                  Put si odr vectors               GS10  72
DO K=1,3#                              Inner odr loop                   GS10  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GS10  74
L=L+1#                                 Point to o/p buffer              GS10  75
QX(L)=SIVC(K,I)#                       Put odr vectors                  GS10  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GS10  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GS10  78
#                                                                       GS10  79
#  OUTPUT GENERATOR LIST ON FILE 3                                      GS10  80
#  -------------------------------                                      GS10  81
#                                                                       GS10  82
FOR(I=Q3+1;I<Q4;I=I+5)#                Loop generator list              GS10  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GS10  84
IF(QX(I)<0.) NEXT#                     Skip non-parent refln.s          GS10  85
writepkt:(3,6,7,IP)#                   Point to next o/p packet         GS10  86
J=iqx:(I+4)#                           Point to top of symop table      GS10  87
K=iqx:(J)#                             Get address  of parent           GS10  88
L=iqx:(J+1)-1#                         Get parent hkl sign code         GS10  89
QX(IP+1)=QX(I+JD1)#                    Put signed d                     GS10  90
QX(IP+2)=QX(I+JD2)#                    Put signed k                     GS10  91
QX(IP+3)=QX(I+JD3)#                    Put signed l                     GS10  92
IF((iqx:(IP+3)==0)&(MOD(L,2)>0))L=L-1# Correct sign code for zero       GS10  93
IF((iqx:(IP+2)==0)&(MOD(L,4)>1))L=L-2# Correct sign code for zero       GS10  94
IF((iqx:(IP+1)==0)&(L>3       ))L=L-4# Correct sign code for zero       GS10  95
N=iqx:(K+1);    K=N/1500+1#            Get phase restr pointer          GS10  96
QX(IP+4)=RPC(K)*100.+FLOAT(MOD(N,100))# Put phase restr/ epsilon        GS10  97
QX(IP+5)=SQRT(QX(I+5))*QX(I+6)#        Reput sigma |e|                  GS10  98
QX(IP+6)=QX(I+6)#                      Put |e|value                     GS10  99
QX(IP+7)=FLOAT(L)#                     Put parent hkl sign code         GS10 100
I=I+MARK-5#                            Reset gen list pointer           GS10 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GS10 102
writepkt:(3,endrecord:,1,IP)#          Rewind & close file 3            GS10 103
#                                                                       GS10 104
#  PROCESS INVARIANTS & COUNT REDUNDANTLY                               GS10 105
#  --------------------------------------                               GS10 106
#                                                                       GS10 107
qxmemory:(Q0)#                         Pushback qx to io buffers        GS10 108
Q1=Q0+MAXG; Q2=Q1+MAXG; Q3=Q2+MAXG#    Set storage markers              GS10 109
incrqx:(Q4,Q3+MAXG,GS1010)#            Expand qx ........ gs1010        GS10 110
L=2*MAXG#                              Set skip to a(est) sums          GS10 111
SX1=0.;  SX2=0.;  SX3=0.#              Zeroize xvector sums             GS10 112
XSMN=100.;      XSMX=0.#               Set xvector min & max            GS10 113
#                                                                       GS10 114
DO N=3,4#                              Loop invariant order             GS10 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GS10 116
M=Q0+(N-3)*MAXG#                       Point to start of si count       GS10 117
K=N-2#                                 Set invariant array pointer      GS10 118
IF(SIMX(K)<0.5) NEXT#                  Skip order if no invariants      GS10 119
I=NINT(AMIN(K)*128.)#                  Get store a min                  GS10 120
plastbitsword:(I,ATHR)#                Form packed a min bits **-20     GS10 121
NN=NGPT+M#                             Setup print threshold            GS10 122
NTRI=0#                                Zeroize invariant counter        GS10 123
REPEAT#                                Loop all invariants              GS10 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GS10 125
readwpkt:(3,N,MP,JP,0)#                Point to invariant packets       GS10 126
IF(JP<=0) BREAK#                       Exit after last packet           GS10 127
comppakwdone:(JP,LT,ATHR,NEXT)#        Test prob minimum                GS10 128
ugeneratornum:(JP,N1,1)#               Get gen number n1                GS10 129
IF(N1>MAXG) BREAK#                     Exit at start of psi0 trips      GS10 130
NTRI=NTRI+1#                           Count invariants                 GS10 131
IF(N==3) N4=0#                         Test if si is triplet            GS10 132
ELSE#                                  Else treat as quartet            GS10 133
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GS10 134
ugeneratornum:(JP,N4,4)#               Get gen number n4                GS10 135
uxvectorsum:(JP, I)#                   Get xvecsum*8                    GS10 136
XVSM=FLOAT(I-512)/8.#                  Float xvector sum value          GS10 137
IF     (XVSM<-.1 )  SX1=SX1+1.#        Sum q4 with uncertain xvec       GS10 138
ELSE IF(XVSM<=XSLO) SX2=SX2+1.#        Sum q4 with xvec< lo lim         GS10 139
ELSE IF(XVSM>=XSHI) SX3=SX3+1.#        Sum q4 with xvec> hi lim         GS10 140
XSMN=AMIN1(XSMN,ABS(XVSM))#            Find maximum xvec sum            GS10 141
XSMX=AMAX1(XSMX,ABS(XVSM))#            Find minimum xvec sum            GS10 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GS10 143
ugeneratornum:(JP,N3,3)#               Get gen number n3                GS10 144
ugeneratornum:(JP,N2,2)#               Get gen number n2                GS10 145
N1=N1+M; N2=N2+M; N3=N3+M; N4=N4+M#    Point to si counters             GS10 146
IF(N1!=N2) QX(N1)=QX(N1)+1.#           If n1 unique count si            GS10 147
IF(N2!=N3) QX(N2)=QX(N2)+1.#           If n2 unique count si            GS10 148
IF(N3!=N4) QX(N3)=QX(N3)+1.#           If n3 unique count si            GS10 149
IF(N4!=M ) QX(N4)=QX(N4)+1.#           If n4 active count si            GS10 150
#                                                                       GS10 151
IF(N1>NN) NEXT#                        Test if gen to be listed         GS10 152
uprobfactor:(JP,I)#                    Get probability factor           GS10 153
A=FLOAT(I)/128.#                       Float prob. factor               GS10 154
N1=N1+L; N2=N2+L; N3=N3+L; N4=N4+L#    Point to si a(est) sums          GS10 155
IF(N1!=N2) QX(N1)=QX(N1)+A#            If n1 unique sum a(est)          GS10 156
IF(N2!=N3) QX(N2)=QX(N2)+A#            If n2 unique sum a(est)          GS10 157
IF(N3!=N4) QX(N3)=QX(N3)+A#            If n3 unique sum a(est)          GS10 158
IF(N4!=L+M)QX(N4)=QX(N4)+A#            If n4 active sum a(est)          GS10 159
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GS10 160
SIMX(K)=FLOAT(NTRI)#                   Put number unique s.i.           GS10 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GS10 162
#                                                                       GS10 163
#  PRINT INVARIANT SUMMARY                                              GS10 164
#  -----------------------                                              GS10 165
#                                                                       GS10 166
IF(SIMX(1)>0.1)#                       If any triplets found            GS10 167
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GS10 168
LINRM=10#                              Get print space for block        GS10 169
movechar:(SN9,7,CHROT,2,NSN1-1,2)#     Put heading ul in buff           GS10 170
writeline:(1,SN1,NSN1,2,3)#            Print triplet si heading         GS10 171
ncodefld:(SIMX(1),1,SN2,380613.,1)#    Format triplet count             GS10 172
writeline:(0,SN2,NSN2,3,3)#            Print number of triplets         GS10 173
ncodefld:(AMIN(1),1,SN3,380522.,1)#    Format actual a min value        GS10 174
ncodefld:(AMAX(1),1,SN3,470522.,1)#    Format actual a max value        GS10 175
writeline:(0,SN3,NSN3,3,3)#            Print actual prob. limits        GS10 176
A=0.; FOR(I=Q0+1;I<=Q1;I=I+1)#         Scan generators for max t3       GS10 177
A=AMAX1(A,QX(I))#                      Calc max t3 per generator        GS10 178
ncodefld:(A,1,SN5,380513.,1)#          Format max t3/generator          GS10 179
writeline:(0,SN5,NSN5,3,3)#            Print max t3/generator           GS10 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GS10 181
ncodefld:(SIMX(3),1,SN13,380613.,1)#   Format numb psi0 trips           GS10 182
writeline:(0,SN13,NSN13,3,3)#          Print psi0 triplets              GS10 183
#                                                                       GS10 184
IF(SIMX(2)>0.1)#                       If any quartets found            GS10 185
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GS10 186
LINRM=14#                              Get print space for block        GS10 187
movechar:(SN9,7,CHROT,2,NSN4-1,2)#     Put heading ul in buff           GS10 188
writeline:(1,SN4,NSN4,2,3)#            Print quartet si heading         GS10 189
ncodefld:(SIMX(2),1,SN2,380613.,1)#    Format quartet count             GS10 190
writeline:(0,SN2,NSN2,3,3)#            Print number of quartets         GS10 191
ncodefld:(AMIN(2),1,SN3,380522.,1)#    Format actual b min value        GS10 192
ncodefld:(AMAX(2),1,SN3,470522.,1)#    Format actual b max value        GS10 193
writeline:(0,SN3,NSN3,3,3)#            Print actual prob. limits        GS10 194
A=0; FOR(I=Q1+1;I<=Q2;I=I+1)#          Scan generators for max q4       GS10 195
A=AMAX1(A,QX(I))#                      Calc max q4 per generator        GS10 196
ncodefld:(A,1,SN5,380513.,1)#          Format max q4/generator          GS10 197
writeline:(0,SN5,NSN5,3,3)#            Print max q4/generator           GS10 198
IF(SX1>small:)#                        Test if any uncertain xvec       GS10 199
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GS10 200
ncodefld:(SX1,1,SN11,380513.,1)#       Format no. q4 uncert xvec        GS10 201
writeline:(0,SN11,NSN11,3,3)#          Print number q4 uncert xvec      GS10 202
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GS10 203
IF(SX2>small:)#                        Test any q4 with xvs<lolim       GS10 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GS10 205
XSLO=AMIN1(XSLO,XSMX)#                 Get xvs lolim applied            GS10 206
movechar:(SN12,1,CHROT,1,NSN12,0)#     Put xvec range mess in buff      GS10 207
ncodefld:(SX2,1,CHROT,520513.,1)#      Format number q4 xvs<lolim       GS10 208
ncodefld:(XSMN,1,CHROT,380622.,1)#     Format lower xvs limit           GS10 209
ncodefld:(XSLO,1,CHROT,470622.,1)#     Format upper xvs limit           GS10 210
writeline:(0,0,0,1,3)#                 Print q4 first xvs range         GS10 211
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GS10 212
IF(SX3>small:)#                        If any q4 with xvs>hilim         GS10 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GS10 214
XSHI=AMAX1(XSHI,XSMN)#                 Get xvs hilim applied            GS10 215
movechar:(SN12,1,CHROT,1,NSN12,0)#     Put xvec range mess in buff      GS10 216
ncodefld:(SX3,1,CHROT,520513.,1)#      Format number q4 xvs>hilim       GS10 217
ncodefld:(XSHI,1,CHROT,380622.,1)#     Format lower xvs limit           GS10 218
ncodefld:(XSMX,1,CHROT,470622.,1)#     Format upper xvs limit           GS10 219
writeline:(0,0,0,1,3)#                 Print q4 second xvs range        GS10 220
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GS10 221
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GS10 222
#                                                                       GS10 223
#  MOVE UPDATED PARAMETERS TO FILE 4                                    GS10 224
#  -----------------------------------------                            GS10 225
#                                                                       GS10 226
IOMARK(4)=IOMARK(1)#                   Redefine buff 1 as buff 4        GS10 227
readwpkt:(3,5,NP,IP,0)#                Point to copied packet           GS10 228
QX(IP+38)=SIMX(1)#                     Put actual triplet count         GS10 229
QX(IP+39)=SIMX(2)#                     Put actual quartet count         GS10 230
QX(IP+40)=SIMX(3)#                     Put psi0 trip count              GS10 231
QX(IP+70)=XSMN#                        Put actual xvs minimum           GS10 232
QX(IP+71)=XSMX#                        Put actual xvs maximum           GS10 233
writepkt:(4,2,NP,JP)#                  Point output packet              GS10 234
movereal:(QX,IP+1,QX,JP+1,NP,1)#       Move parameter record            GS10 235
#                                                                       GS10 236
#  MOVE GENERATORS TO FILE 4 & LIST                                     GS10 237
#  ------------------------------------                                 GS10 238
#                                                                       GS10 239
NGEN=0#                                Reset generator counter          GS10 240
writeline:(0,0,0,1,3);   LINRM=5#      Allow for generator listing      GS10 241
IF(SIMX(2)<small:) NSN8=NSN8-12#       Truncate heading if no q4        GS10 242
#                                                                       GS10 243
#   THE ONLY COPPYING OF GENERATORS TO .INV FILE 4 REC 3 IS DONE HERE   GS10 244
#    ORIGINALLY ONLY GENERATORS 1 TO MAXG WERE COPPIED, BUT             GS10 245
#   NOW I THINK THAT THE MAXP PSI0 GENERATORS SHOULD ALSO BE COPPIED HE GS10 246
#   BUT I AM UNSURE ABOUT WHETHER THEY SHOULD BE "REARRANGED"           GS10 247
#   AS APPEARS TO BE HAPPENING WITH THE NORMAL GENRATORS                GS10 248
##DO III=1,MAXG#                       Loop generators in file 4        GS10 249
#                                                                       GS10 250
DO III=1,MAXG+MAXP#                    Loop generators in file 4        GS10 251
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GS10 252
readwpkt:(3,6,NP,IP,0)#                Point to next gener packet       GS10 253
IF(IP<=0) BREAK#                       Exit after last packet           GS10 254
writepkt:(4,3,5,JP)#                   Point to file 4 packet           GS10 255
IF (III<=MAXG)#                                                         GS10 256
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GS10 257
DO I=1,3#                              Loop si vectors                  GS10 258
IH(I)=MOD(NINT(SIVC(I,1)*QX(IP+1)$#    Form si vectors uvw              GS10 259
+              SIVC(I,2)*QX(IP+2)$#    Form  si vectors uvw             GS10 260
+              SIVC(I,3)*QX(IP+3)),MDSI(I))# Form  si vectors uvw       GS10 261
IF(IH(3)<0) I=1#                       Test for l neg                   GS10 262
ELSE        I=0#                       Else for w pos                   GS10 263
IF(IH(2)<0) I=I+2#                     Test for v neg                   GS10 264
IF(IH(1)<0) I=I+4#                     Test for u neg                   GS10 265
J=bitlen:(21)#                         Set bit span for |h|             GS10 266
intpak:(iqx:(IP+7),QX(JP+1),0,3)#      Pack hkl sign bits  2- 0         GS10 267
intpak:(NINT(ABS(QX(IP+3))),QX(JP+1), 3, 9)# Pack |l|  bits 11- 3       GS10 268
intpak:(NINT(ABS(QX(IP+2))),QX(JP+1),12, 9)# Pack |k|  bits 20-12       GS10 269
intpak:(NINT(ABS(QX(IP+1))),QX(JP+1),21, J)# Pack |h|  bits **-21       GS10 270
intpak:(          I,QX(JP+2), 0, 3)#   Pack uvw sign bits  2- 0         GS10 271
intpak:(IABS(IH(3)),QX(JP+2), 3, 9)#   Pack |w|      bits 11- 3         GS10 272
intpak:(IABS(IH(2)),QX(JP+2),12, 9)#   Pack |v|      bits 20-12         GS10 273
intpak:(IABS(IH(1)),QX(JP+2),21, J)#   Pack |u|      bits **-21         GS10 274
movereal:(QX,IP+4,QX,JP+3,3,1)#        Put rpc, |e| & sigma|e|          GS10 275
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GS10 276
ELSE movereal:(QX,IP+1,QX,JP+1,5,1)#                                    GS10 277
NGEN=NGEN+1#                           Count number of generators       GS10 278
#                                                                       GS10 279
#                                       ******** list generators        GS10 280
IF(NGEN>NGPT) NEXT#                    Test for list of generators      GS10 281
ncodefld:(FLOAT(NGEN),1,CHROT,FMT,1)#  Format generator number          GS10 282
ncodefld:(QX,IP+1,CHROT,FMT(2),3)#     Format h,k,l                     GS10 283
ncodefld:(QX,IP+6,CHROT,FMT(5),1)#     Format |e|value                  GS10 284
ncodefld:(QX,IP+5,CHROT,FMT(6),1)#     Format sigma |e|                 GS10 285
DO I=1,3#                              Loop u,v,w                       GS10 286
AH(I)=FLOAT(IH(I))#                    Float u,v,w                      GS10 287
ncodefld:(AH,1,CHROT,FMT(7),3)#        Format u,v,w                     GS10 288
I=IABS(IH(1))+IABS(IH(2))+IABS(IH(3))# Test if s.i. status              GS10 289
IF(I==0) J=1#                          Is s.i. if u,v,w=0               GS10 290
ELSE     J=4#                          Else suitable for odr            GS10 291
movechar:(SN9,J,CHROT,47,3,0)#         Deposit odr status in buff       GS10 292
J=(iqx:(IP+4)/100)*7-6#                Point to restr phi tag           GS10 293
movechar:(SN7,J,CHROT,53,7,0)#         Deposit restr. phi status        GS10 294
I=Q0+NGEN#                             Point to triplet count           GS10 295
IF(QX(I)>small:)#                      Skip if no triplets              GS10 296
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GS10 297
ncodefld:(QX,      I,CHROT,650403.,1)# Format triplet count             GS10 298
ncodefld:(QX,Q2+NGEN,CHROT,720712.,1)# Format sum a(est)                GS10 299
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GS10 300
I=Q1+NGEN#                             Point to quartet count           GS10 301
IF(QX(I)>small:)#                      Skip if no quartets              GS10 302
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GS10 303
ncodefld:(QX,      I,CHROT,780403.,1)# Format quartet count             GS10 304
ncodefld:(QX,Q3+NGEN,CHROT,850712.,1)# Format sum b(est)                GS10 305
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GS10 306
writeline:(0,SN8,NSN8,1,3)#            Print generator summary          GS10 307
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GS10 308
#                                                                       GS10 309
RETURN#                                                                 GS10 310
END#                                                                    GS10 311
systemheader:(GS11)#                   Prepare gentan s.i. file         GS11   1
####################################################################    GS11   2
#                                                                  #    GS11   3
#                             GS11                                 #    GS11   4
#                                                                  #    GS11   5
####################################################################    GS11   6
SUBROUTINE GS11#                       S.r.hall  apr 81                 GS11   7
include:(AACOMN)#                                                       GS11   8
include:(GSCOMN)#                                                       GS11   9
#                                                                       GS11  10
INTEGER I,J,K,KK,L,N,IP,NP#                                             GS11  11
INTEGER II,JJ,IA,IS,ID,IC,IQ,PSIZE#                                     GS11  12
INTEGER N1,N2,N3,N4,IB,IX#                                              GS11  13
INTEGER JP,MAX,NN,NTOP,NBOT#                                            GS11  14
REAL A,ATHR#                                                            GS11  15
chardata:(SN1, **  ** PFAC S-Q  N2  N3  N4 XVS  PFAC S-Q  N2  $#        GS11  16
N3  N4 XVS  PFAC S-Q  N2  N3  N4 XVS)#                                  GS11  17
chardata:(SN2, *@@@@@@@?)#                                              GS11  18
realdata:(FMT,[120412.,160313.,200413.,240413.,280403.,#                GS11  19
380412.,420313.,460413.,500413.,540403.,#                               GS11  20
640412.,680313.,720413.,760413.,800403.])#                              GS11  21
intdata:(NSN,[10000,1,2,4,8])#                                          GS11  22
intdata:(IN,[0,0,0,0,0,0])#                                             GS11  23
realdata:(AT,[0.,0.,0.])#                                               GS11  24
realdata:(APMIN,0.)#                                                    GS11  25
datastuff:#                                                             GS11  26
#                                                                       GS11  27
#  PREPARE FOR INVARIANT MOVE FILE3 TO FILE4                            GS11  28
#  ---------------------------------------------                        GS11  29
#                                                                       GS11  30
MAX=MIN(QXMAX,Q2+NINT(SIMX(1))*3*(pstrip:+1)$# Mem for triplet s.i.     GS11  31
+                NINT(SIMX(2))*4*(psquar:+1))# Mem for quartet s.i.     GS11  32
qxmemory:(MAX)#                        Get memory & set available       GS11  33
DO I=1,3#                              Loop invariant orders            GS11  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GS11  35
J=NINT(AMIN(I)*128.)#                  Get stored a min                 GS11  36
plastbitsword:(J,AT(I))#               Set up packed thresholds         GS11  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GS11  38
J=NINT(APMN*128.)#                     Integerize print a min           GS11  39
plastbitsword:(J,APMIN)#               Set up packed a-print min        GS11  40
#                                                                       GS11  41
#  MOVE REDUNDANT INVARIANTS PER GENERATOR                              GS11  42
#  -------------------------------------------                          GS11  43
#                                                                       GS11  44
FOR(NTOP=1;NTOP<=MAXG;NTOP=NBOT)#      Loop all generators              GS11  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GS11  46
MARK=Q2#                                                                GS11  47
rewindbdf:(3)#                         Rewind inv scratch file          GS11  48
#                                                                       GS11  49
#                                       ***** convert counts/markers    GS11  50
FOR(NBOT=NTOP;NBOT<=MAXG;NBOT=NBOT+1)# Count si blocks/memory           GS11  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GS11  52
I=Q0+NBOT;   J=Q1+NBOT#                Point to invariant totals        GS11  53
L=MARK#                                Mark top of invariant block      GS11  54
MARK=L+NINT(QX(I))*(pstrip:+1)$#       Space for trips and trip flag    GS11  55
+      NINT(QX(J))*(psquar:+1)#        Space for quarts and quart fla   GS11  56
IF(MARK>MAX) BREAK#                    Test if block > memory           GS11  57
QX(I)=L;    QX(J)=L#                   Put start of si blocks           GS11  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GS11  59
IF(NBOT==NTOP) iquit:(GS1120)#         Too big ........ gs1120          GS11  60
#                                                                       GS11  61
#                                       ****** put si into blocks       GS11  62
N4=0 ; IX=0#                           Set n4 for triplets              GS11  63
DO N=3,4#                              Loop invariant orders            GS11  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GS11  65
IF(SIMX(N-2)<0.5) NEXT#                Skip order if no invariants      GS11  66
movepakwd:(AT(N-2),ATHR)#              Set minimum prob factor          GS11  67
REPEAT#                                Loop invariant file 3            GS11  68
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GS11  69
readwpkt:(3,N,NP,IP,0)#                Point to invariant packet        GS11  70
IF(IP<=0) BREAK#                       Exit after last packet           GS11  71
ugeneratornum:(IP,N1,1)#               Get generator n1                 GS11  72
IF (N1>NBOT) BREAK#                    Exit if n1 > min                 GS11  73
comppakwdone:(IP,LT,ATHR,NEXT)#        Skip if abc < min                GS11  74
IF(N==4)#                              Test if invariant quartet        GS11  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GS11  76
ugeneratornum:(IP,N4,4)#               Unpack gen no. n4                GS11  77
uxvectorsum:(IP,IX)#                   Unpack xvectsum*8                GS11  78
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GS11  79
ugeneratornum:(IP,N3,3)#               Unpack gen no. n3                GS11  80
IN(3)=N3 ; IN(4)=N4#                   Store n3 and n4 as array         GS11  81
IF(IN(N)<NTOP) NEXT#                   Skip if n4/n3 < min              GS11  82
ugeneratornum:(IP,N2,2)#               Unpack gen no. n2                GS11  83
IN(1)=N1 ; IN(2)=N2#                   Store n1 and n2 as an array      GS11  84
uphaserestr:(IP,IC)#                   Unpack restr. phi code           GS11  85
uphisigncode:(IP,IS)#                  Unpack phi sign code             GS11  86
uphiinvshift:(IP,ID)#                  Unpack invariant shift code      GS11  87
uphifragment:(IP,IQ)#                  Unpack qphi in 360ths 2pi        GS11  88
uprobfactor:(IP,IA)#                   Unpack prob factor*128.          GS11  89
uprobfsigma:(IP,IB)#                   Unpack a,b variance*128.         GS11  90
DO K=1,N#                              Loop invariant reflns            GS11  91
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GS11  92
J=IN(K)#                               Put gen no. as temp              GS11  93
IF(J==IN(K+1)) NEXT#                   Skip non-unique gen numbers      GS11  94
IF(J<NTOP) NEXT#                       Skip if gen no. < min            GS11  95
IF(J>=NBOT) BREAK#                     Exit if gen no. > max            GS11  96
IN(K)=IN(1); NN=MAX0(IN(2),IN(3),IN(4))# Find largest gen no.           GS11  97
I=Q1+J;  L=iqx:(I)+1#                  Get current block pointer        GS11  98
pphaserestr:(L,IC)#                    Put phi restr.   1 bits  0- 3    GS11  99
IF(MOD(IS/NSN(K),2)!=0)#               Test for equiv invariant         GS11 100
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GS11 101
pphisigncode:(L,MOD( 7-IS+NSN(K),8))#  Put reordered phi sign code      GS11 102
pphiinvshift:(L,MOD( 12-ID, 12))#      Put reverse invt shift code      GS11 103
pphifragment:(L,MOD(360-IQ,360))#      Put reverse qphi in 360ths 2pi   GS11 104
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GS11 105
ELSE#                                  No change to signs etc           GS11 106
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GS11 107
pphisigncode:(L,IS)#                   Pack phi sign cd 1 bits  4- 6    GS11 108
pphiinvshift:(L,ID)#                   Pack phi shift   1 bits  7-10    GS11 109
pphifragment:(L,IQ)#                   Pack frag qphi   1 bits 11-19    GS11 110
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GS11 111
pprobfactor:(L,IA)#                    Put pfac*128.    1 bits 20-31    GS11 112
pxvectorsum:(L,IX)#                    Put x-vector     2 bits 10-19    GS11 113
pprobfsigma:(L,IB)#                    Put variance     2 bits 20-31    GS11 114
pgeneratornum:(L,NN,1)#                Put max gen no   3               GS11 115
pgeneratornum:(L,IN(2),2)#             Put gen no. n2   4               GS11 116
pgeneratornum:(L,IN(3),3)#             Put gen no. n3   5               GS11 117
QX(L)=FLOAT(pstrip:)#                  Flag invarint with pack size     GS11 118
IF(N==4)#                              Its a quartet                    GS11 119
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GS11 120
pgeneratornum:(L,IN(4),4)#             Put gen no. n4   6               GS11 121
QX(I)=QX(I)+FLOAT(1+psquar:)#          Increment block pointer          GS11 122
QX(L)=FLOAT(psquar:)#                  Flag invarint with pack size     GS11 123
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GS11 124
ELSE QX(I)=QX(I)+FLOAT(1+pstrip:)#     Adjust block pntr for trip       GS11 125
IN(K)=J#                               Reset original gen no.           GS11 126
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GS11 127
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GS11 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GS11 129
#                                                                       GS11 130
#  MOVE INVARIANT BLOCKS TO FILE 4                                      GS11 131
#  -----------------------------------                                  GS11 132
#                                                                       GS11 133
II=0;     JJ=17#                       Set print markers                GS11 134
FOR(N=NTOP;N<NBOT;N=N+1)#              Loop generators putd             GS11 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GS11 136
I=Q1+N;   K=Q0+N;    L=iqx:(I)#        Point to top/bot block addr      GS11 137
ncodefld:(FLOAT(N),1,SN1,50413.,1)#    Format n1 in heading             GS11 138
J=N+3;    LINRM=5#                     Set record num & print skip      GS11 139
IF(N>=N1PS&N<=N1PE)#                   Test if print possible           GS11 140
writeline:(1,SN1,NSN1,3,3)#            Print invariant heading          GS11 141
FOR(K=iqx:(K)+1;K<L;K=K+PSIZE+1)#      Loop invariants in block         GS11 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GS11 143
PSIZE=iqx:(K)#                         Size of record                   GS11 144
writepkt:(4,J,psquar:,IP)#             Point to invariant packet        GS11 145
movereal:(QX,K+1,QX,IP+1,PSIZE,1)#     Move invariant to buffer         GS11 146
IF(PSIZE<psquar:)#                     Empty bytes in packet            GS11 147
DO KK=IP+PSIZE+1,IP+psquar:;QX(KK)=0.0# Ensure empties are null         GS11 148
#                                                                       GS11 149
IF(N<N1PS\N>N1PE) NEXT#                Test for invariant printing      GS11 150
comppakwdone:(K,LT,APMIN,NEXT)#        Skip if < abc print limit        GS11 151
ugeneratornum:(K,NN,1)#                Get max gen other than n1        GS11 152
IF(NN>NNPE) NEXT#                      Skip if outside print limit      GS11 153
N4=0#                                  Assume triplet so null val       GS11 154
uphaserestr:(K,IC)#                    Unpack restr. phi code           GS11 155
uphisigncode:(K,IS)#                   Unpack phi sign code             GS11 156
uphiinvshift:(K,ID)#                   Unpack invariant shift code      GS11 157
uphifragment:(K,IQ)#                   Unpack qphi in 360ths 2pi        GS11 158
uprobfactor:(K,IA)#                    Unpack prob factor*128.          GS11 159
uxvectorsum:(K,IX)#                    Unpack xvectsum*8                GS11 160
ugeneratornum:(K,N3,3)#                Get gen no. n3                   GS11 161
ugeneratornum:(K,N2,2)#                Get gen no. n3                   GS11 162
IF(PSIZE>pstrip:)ugeneratornum:(K,N4,4)# Get gen no. n4                 GS11 163
IF(ICNT==0)#                           For noncentro sgroups            GS11 164
movechar:(SN2,IC,CHROT,JJ,1,0)#        Put phi restr flag in buf        GS11 165
BUFOT(II+1)=FLOAT(IA)/128.#            Put abc for printing             GS11 166
BUFOT(II+2)=MOD(360-IQ+ID*30,360)#     Put shift-qphi for printing      GS11 167
BUFOT(II+3)=ISIGN(N2,JS2(IS+1))#       Put signed n2 for printing       GS11 168
BUFOT(II+4)=ISIGN(N3,JS3(IS+1))#       Put signed n3 for printing       GS11 169
BUFOT(II+5)=0.#                        Put default n4 as null           GS11 170
IF(N4>0)#                              For active n4 value              GS11 171
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GS11 172
BUFOT(II+5)=ISIGN(N4,JS4(IS+1))#       Put signed n4 for printing       GS11 173
A=FLOAT(IABS(IX-512))/8.#              Decode & float xvector sum       GS11 174
ncodefld:(A,1,CHROT,JJ*10000.+150312.,1)# Format xvector sum            GS11 175
IF(IX<512)#                            If xvs has uncertain e's         GS11 176
movechar:(SN2,10,CHROT,JJ+16,1,0)#     Flag uncertain xvs with ?        GS11 177
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GS11 178
II=II+5;   JJ=JJ+26#                   Increment print storage          GS11 179
IF(II<15&K+PSIZE+1<L) NEXT#            Put if line not filled           GS11 180
ncodefld:(BUFOT,1,CHROT,FMT,II)#       Format putd invariants           GS11 181
writeline:(0,0,0,1,3)#                 Print invariant line             GS11 182
II=0;    JJ=17#                        Reset storage pointer            GS11 183
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GS11 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GS11 185
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GS11 186
#                                                                       GS11 187
#   APPEND PSI0 TRIPLETS TO FILE 4                                      GS11 188
#   ------------------------------                                      GS11 189
#                                                                       GS11 190
rewindbdf:(3)#                         Rewind input inv scratch         GS11 191
REPEAT#                                Loop invariant packets           GS11 192
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GS11 193
readwpkt:(3,3,NP,IP,0)#                Point to triplet packet          GS11 194
IF(IP<=0) BREAK#                       Exit after last packet           GS11 195
ugeneratornum:(IP,N1,1)#               Get gen number 1                 GS11 196
IF(N1<=MAXG) NEXT#                     Skip non psi0 triplets           GS11 197
writepkt:(4,N1+3,psquar:,JP)#          Point to output packet           GS11 198
ugeneratornum:(IP,N2,2)#               Extract gen number 2             GS11 199
ugeneratornum:(IP,N3,3)#               Extract gen number 3             GS11 200
N2=MAX0(N2,N3)#                        Find largest value               GS11 201
movereal:(QX,IP+1,QX,JP+1,NP,1)#       Move whole psio triplet          GS11 202
pprobfsigma:(JP,0)#                    Set sigma on pfac to be null     GS11 203
pgeneratornum:(JP,N2,4)#               Max gen numbr is in word 6       GS11 204
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GS11 205
readwpkt:(3,endrecord:,I,IP,0)#        Close off scratch file 3         GS11 206
writepkt:(4,endrecord:,3,IP)#          Close off output  file 4         GS11 207
#                                                                       GS11 208
RETURN#                                                                 GS11 209
END#                                                                    GS11 210
pmacro:([no:])#                                                         GS11 211
