systemheader:(GT    )#                                                  GT     1
####################################################################### GT     2
##      Copyright (C) 2000, The Xtal System, The University of        # GT     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # GT     4
## Distributed under the GNU General Public Licence as published by   # GT     5
## the Free Software Foundation, in the hope that it will be useful   # GT     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # GT     7
## for more details.                                                  # GT     8
#                                                                     # GT     9
#                            *** GENTAN ***                           # GT    10
#                                                                     # GT    11
#     THE PROGRAM GENTAN ESTIMATES AND REFINES STRUCTURE FACTOR       # GT    12
#     PHASES USING THE STRUCTURE INVARIANT TANGENT FORMULA.           # GT    13
####################################################################### GT    14
#                                                                       GT    15
include:(XMACRO)#                                                       GT    16
#                                                                       GT    17
macro:(raiseexception:,$(XCEPT=$1;RETURN$))# Throw an exception         GT    18
macro:(catchexception:,IF(XCEPT!=0)RETURN)#                             GT    19
macro:(ib:,NINT(BUFIN($1)))#                                            GT    20
macro:(bf:,BUFIN($1))#                                                  GT    21
macro:(iqx:,NINT(QX($1)))#                                              GT    22
macro:(swap:,$(QIQI=$1;$1=$2;$2=QIQI$))#                                GT    23
#                                                                       GT    24
macro:(genlist:,[ifelse:($1,,NG,$1)])# Define gen list pointer          GT    25
macro:(hkl:,[QX(genlist:($1)+ 1)])#    Define packed hkl    +1          GT    26
macro:(uvw:,[QX(genlist:($1)+ 2)])#    Define packed uvw    +2          GT    27
macro:(prc:,[QX(genlist:($1)+ 3)])#    Define restr code    +3          GT    28
macro:(alt:,[QX(genlist:($1)+ 4)])#    Define total alfa(e) +4          GT    29
macro:(evl:,[QX(genlist:($1)+ 5)])#    Define /e/-value     +5          GT    30
macro:(alp:,[QX(genlist:($1)+ 6)])#    Define part alfa(e)  +6          GT    31
macro:(sta:,[QX(genlist:($1)+ 7)])#    Define start status  +7          GT    32
macro:(pak:,[QX(genlist:($1)+ 8)])#    Define packed start  +8          GT    33
macro:(pnt:,[QX(genlist:($1)+ 9)])#    Define sort pointer  +9          GT    34
macro:(sma:,[QX(genlist:($1)+10)])#    Define sum w*alpha   +10         GT    35
macro:(top:,[QX(genlist:($1)+11)])#    Define top si block  +11         GT    36
macro:(bot:,[QX(genlist:($1)+12)])#    Define bot si block  +12         GT    37
macro:(phi:,[QX(genlist:($1)+ 2)])#    Define phase         +2          GT    38
macro:(wgt:,[QX(genlist:($1)+ 5)])#    Define refine weight +5          GT    39
macro:(sin:,[QX(genlist:($1)+ 7)])#    Define tang sin sum  +7          GT    40
macro:(cos:,[QX(genlist:($1)+10)])#    Define tang cos sum  +10         GT    41
macro:(seq:,[QX(genlist:($1)+10)])#    Define sequence ordr +10         GT    42
#                                                                       GT    43
macro:(phaserestr:, intunpak:(QX($1+1),$2, 0, 4))# 0 -  3               GT    44
macro:(phisigncode:,intunpak:(QX($1+1),$2, 4, 3))# 4 -  6               GT    45
macro:(phiinvshift:,intunpak:(QX($1+1),$2, 7, 4))# 7 - 10               GT    46
macro:(phifragment:,intunpak:(QX($1+1),$2,11, 9))# 11 - 19              GT    47
macro:(probfactor:, intunpak:(QX($1+1),$2,20,bitlen:(20)))# 20 - 31     GT    48
macro:(xvectorsum:, intunpak:(QX($1+2),$2,10,10))# 10 - 10              GT    49
macro:(probfsigma:, intunpak:(QX($1+2),$2,20,bitlen:(20)))# 20 - 31     GT    50
#                                                                       GT    51
macro:(generatornum:,         $2=NINT(QX($1+2+$3)))#                    GT    52
#                                                                       GT    53
macro:(comppakwdone:,compakwd:(QX($1+1),$2,$3,$4))# 1st inv word        GT    54
macro:(plastbitsword:,intpak:($1,$2,20,bitlen:(20)))# Pack pfactor      GT    55
#                                                                       GT    56
macro:(iprc:,[NINT(prc:($1))])#        Define integer restr code        GT    57
macro:(ista:,[NINT(sta:($1))])#        Define integer start status      GT    58
macro:(ipnt:,[NINT(pnt:($1))])#        Define integer sort order        GT    59
macro:(itop:,[NINT(top:($1))])#        Define integer si block          GT    60
macro:(ibot:,[NINT(bot:($1))])#        Define integer si block          GT    61
macro:(iseq:,[NINT(seq:($1))])#        Define integer sort order        GT    62
#                                                                       GT    63
extrude:(GTCOMN)#                                                       GT    64
REAL AMIN(3)#                          Minimum probability factors      GT    65
REAL AMOS#                             Measure of success minimum       GT    66
REAL A2MX#                             Al**2 refinement threshold       GT    67
REAL ARCH(70)#                         Bdf lrrefl archive list          GT    68
INTEGER BOT#                           Bot/len value of s.i. block      GT    69
REAL BIAS(6)#                          Starting phi weight bias         GT    70
REAL CONV#                             Iteration convergence limit      GT    71
REAL DSNM#                             Data set number                  GT    72
REAL EDR#                              Edr type no. = 3                 GT    73
INTEGER EFOM#                          Fom pretest flag (no=0,yes=1     GT    74
REAL EMIN#                             /e/ minimum for all gens         GT    75
REAL EPAR#                             /e/ min for bdf input phases     GT    76
REAL ETYP#                             Type of /e/ used (1 or 2)        GT    77
INTEGER FIX(6)#                        Iteration fixes for starters     GT    78
REAL FMIN(4),FMAX(4)#                  Detected min/max of fom's        GT    79
REAL FREJ(5),FOPT(4)#                  Fom rejection & optimum          GT    80
REAL FRAC#                             Molecular fraction for bdf p     GT    81
REAL H(3)#                             General hkl indices array        GT    82
REAL HEAV#                             Heavy atom factor                GT    83
INTEGER IACC#                          Refinement accelerator flag      GT    84
INTEGER ICNT#                          Centro flag (nc=0, c=1)          GT    85
INTEGER IDMP(10)#                      Dump start index yes>0           GT    86
INTEGER IEDR#                          Edr start status = 3             GT    87
INTEGER IH(3)#                         General hkl indices array        GT    88
INTEGER INPH#                          Input phi (no=0,fc=1,gt=2)       GT    89
INTEGER INOS#                          No-start status = 1              GT    90
INTEGER INUL#                          Suppress status = 6              GT    91
INTEGER IODR#                          Odr start status = 2             GT    92
INTEGER IPER#                          Permute start status = 4         GT    93
INTEGER IPNT#                          Phase set print (=no. sets)      GT    94
INTEGER IQPS#                          Qpsi flag (excl=0,else=1)        GT    95
INTEGER IREC#                          Current lead record number       GT    96
INTEGER IR(77)#                        Relative pkt pointer array       GT    97
INTEGER ISEL#                          Si select(all=-2,q4=0,t3=2)      GT    98
INTEGER ISET#                          Preset start status = 5          GT    99
INTEGER ITEM#                          Number of archiv items           GT   100
INTEGER ITMX#                          Max iterations for pmap          GT   101
INTEGER IW(76)#                        Item request (want) array        GT   102
INTEGER IWGT#                          Tangent weight flag (1 or 2)     GT   103
INTEGER IXVF#                          Xvf(all=1,ins=2,part=3,out=4)    GT   104
INTEGER LEDR#                          Edr permute limit                GT   105
INTEGER LTYP#                          Lattice type (1 to 7)            GT   106
INTEGER KEY(4)#                        Indexpkt signal array            GT   107
INTEGER MARK#                          Packet length of genlist         GT   108
INTEGER MDMP(10)#                      Max range for dump print         GT   109
INTEGER MDSI(3)#                       Structure invariant moduli       GT   110
REAL MINE#                             Min expect factor for ale        GT   111
INTEGER MODE#                          Calc mode (cas=1,blk=2,ran=3     GT   112
INTEGER MSEL#                          Start types to be selected       GT   113
INTEGER MSTR#                          Max phase set from path          GT   114
REAL    MXTG#                          Max trip/gen                     GT   115
REAL    MXQG#                          Max quar/gen                     GT   116
INTEGER MXIT#                          Max no. refine iterations        GT   117
INTEGER MXPS#                          Max no. phase sets allowed       GT   118
INTEGER M0#                            Start-1 of sin/cos tables        GT   119
INTEGER M1#                            Start-1 of generator list        GT   120
INTEGER MQ#                            Start-1 of psi(0) generators     GT   121
INTEGER MG#                            End of generator table           GT   122
INTEGER M2#                            Start-1 of ran. access buff      GT   123
INTEGER M3#                            End     of temporary buffer      GT   124
INTEGER NANT#                          Enantio definition flag          GT   125
INTEGER NCUT#                          Addr limit of top generators     GT   126
INTEGER NDMP(10)#                      Dump end index yes>0             GT   127
INTEGER NEGQ#                          Neg quartet indicator = 3        GT   128
INTEGER NGEN#                          Number of generators             GT   129
INTEGER NLIM#                          Highest addr of starter          GT   130
INTEGER NMDS#                          Dataset offset pointer           GT   131
INTEGER NMAG#                          Number of magic integers         GT   132
INTEGER NODR#                          Numb origin def. generators      GT   133
INTEGER NONR#                          No. of nonrestr. odr phases      GT   134
INTEGER NOPS#                          No. of requested phase sets      GT   135
REAL NOS#                              Non-starting phi = 1             GT   136
INTEGER NPER#                          Count of permute starters        GT   137
INTEGER NPSI#                          Count of psi(0) generators       GT   138
INTEGER NPST#                          Count of permuted phase sets     GT   139
INTEGER NQPS#                          Phase shift for nq4 psi          GT   140
INTEGER NSTR#                          Count of starting phases         GT   141
INTEGER NSEL#                          Num gens eligible as starts      GT   142
INTEGER NTES#                          Test no. for permute select      GT   143
INTEGER NTOT#                          Count of total generators        GT   144
INTEGER NTYP(4)#                       Count of invariant types         GT   145
REAL NUL#                              Null generator type = 6          GT   146
REAL ODR#                              Odr generator type = 2           GT   147
REAL PER#                              Permute generator type = 4       GT   148
INTEGER PERI(10)#                      Permute phase increments         GT   149
INTEGER PERN(10)#                      Permute phase genlist addr       GT   150
INTEGER PERS(2)#                       Permute incr. for nr/restr       GT   151
REAL PFAC#                             Sigma ratio of prob. factor      GT   152
REAL PHIAV#                            Average expected phase angle     GT   153
INTEGER POSQ#                          Positive quartet  = 2            GT   154
INTEGER POUT#                          Number phase sets output         GT   155
INTEGER PSET(8)#                       Requested phase set numbers      GT   156
INTEGER PSI0#                          Psi0 triplet indicator = 1       GT   157
REAL RATE#                             Rate of al**2 max reduction      GT   158
REAL RWGT#                             Start weight of random phi       GT   159
REAL SCAL#                             Frel scale for bdf phi test      GT   160
REAL SET#                              Set phi generator = 5            GT   161
INTEGER SEED#                          Random number seed               GT   162
REAL SIGA#                             Factor of siga to reduce a       GT   163
REAL SIMX(3)#                          Count of ivariant orders         GT   164
REAL SIVC(3,3)#                        Structure invariant vectors      GT   165
REAL STMN#                             Sin theta /lambda maximum        GT   166
REAL STMX#                             Sin theta /lambda minimum        GT   167
REAL STYP(4)#                          Counts of invariant types        GT   168
REAL SUMR#                             Sum of alpha(ran)                GT   169
INTEGER TMOS#                          Cycle termination flag           GT   170
INTEGER TOP#                           Top/nrec value of s.i. block     GT   171
INTEGER TRIP#                          Triplet indicator = 0            GT   172
INTEGER TYPE#                          Start phase (ran=0;per=1;mag     GT   173
REAL WFOM(4)#                          Fom weights for cfom             GT   174
REAL WMIN#                             Min extention weight             GT   175
INTEGER XCEPT#                         Exception flag                   GT   176
REAL XSHI#                             Xvec sum upper thresh.           GT   177
REAL XSLO#                             Xvec sum lower thresh.           GT   178
REAL XSMN#                             Xvec sum min found               GT   179
REAL XSMX#                             Xvec sum max found               GT   180
REAL XVMN#                             Xvector lower threshold          GT   181
REAL XVMX#                             Xvector upper threshold          GT   182
#                                                                       GT   183
COMMON /COMIGT/$#                                                       GT   184
BOT,EFOM,FIX,IEDR,ICNT,ISEL,IPNT,INPH,IQPS,IXVF,IREC,ITEM,IWGT,#        GT   185
ISET,IH,IR,IW,KEY,LTYP,MARK,MSEL,MXIT,MXPS,MDSI,M0,M1,MQ,M2,M3,#        GT   186
MSTR,NANT,NLIM,NODR,NONR,NPER,NPST,NPSI,NGEN,INOS,INUL,IODR,IPER,#      GT   187
LEDR,MODE,NEGQ,NMAG,NMDS,NQPS,NSEL,NSTR,NTES,NTOT,NTYP,POSQ,#           GT   188
PERI,PERN,PERS,POUT,PSI0,TOP,TRIP,NOPS,PSET,NCUT,SEED,TMOS,TYPE,#       GT   189
IDMP,NDMP,MDMP,MG,ITMX,IACC,XCEPT#                                      GT   190
#                                                                       GT   191
COMMON /COMFGT/$#                                                       GT   192
A2MX,AMIN,AMOS,ARCH,BIAS,CONV,DSNM,EDR,EMIN,EPAR,ETYP,FMIN,FREJ,#       GT   193
FMAX,FRAC,H,HEAV,NOS,NUL,ODR,PER,PFAC,RATE,SET,SIGA,SIMX,SCAL,#         GT   194
STMN,STYP,SIVC,STMX,WFOM,WMIN,XVMN,XVMX,XSLO,XSHI,XSMN,XSMX,#           GT   195
SUMR,RWGT,MINE,FOPT,MXTG,MXQG,PHIAV#                                    GT   196
endext:#                                                                GT   197
#                                                                       GT   198
systemheader:(GT00)#                   General tangent phasing          GT00   1
####################################################################    GT00   2
#                                                                  #    GT00   3
#                             GT00                                 #    GT00   4
#                                                                  #    GT00   5
####################################################################    GT00   6
SUBROUTINE GT00#                       S.r.hall  jun 81                 GT00   7
include:(AACOMN)#                                                       GT00   8
include:(GTCOMN)#                                                       GT00   9
#                                                                       GT00  10
FILEXT(IOUNIT(3))='XX1'#               Extension for scratch file       GT00  11
FILEXT(IOUNIT(4))='INV'#               Extension for ip invariant fil   GT00  12
FILEXT(iofm1:)   ='GT0'#               Gentan dump line file            GT00  13
FILEXT(iofm2:)   ='GT1'#               Potential re-entrant fmt file    GT00  14
#                                                                       GT00  15
CALL GT01#                             Enter control lines              GT00  16
catchexception:#                       Abandon run                      GT00  17
CALL GT02#                             Enter elist & invariants         GT00  18
catchexception:#                       Abandon run                      GT00  19
CALL GT03#                             Select odr/edr & phase path      GT00  20
CALL GT04#                             Select permutes maxext           GT00  21
CALL GT05#                             Print gentan parameters          GT00  22
IF(IDMP(10)==yes:)#                    Test if dumps required           GT00  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT00  24
IF(MODE==1)   CALL GT06#               Cascade tangent process          GT00  25
IF(MODE==2)   CALL GT07#               Block tangent process            GT00  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT00  27
ELSE#                                  No dumps - use fast versions     GT00  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT00  29
IF(MODE==1)   CALL GT08#               Cascade tangent process          GT00  30
IF(MODE==2)   CALL GT09#               Block tangent process            GT00  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT00  32
IF(NDMP(7)>0) CALL GT10#               Print phase map dump             GT00  33
CALL GT20#                             Test phase sets & op             GT00  34
#                                                                       GT00  35
RETURN#                                                                 GT00  36
END#                                                                    GT00  37
systemheader:(GT01)#                   Enter control lines              GT01   1
####################################################################    GT01   2
#                                                                  #    GT01   3
#                             GT01                                 #    GT01   4
#                                                                  #    GT01   5
####################################################################    GT01   6
SUBROUTINE GT01#                       S.r.hall  jun 81                 GT01   7
include:(AACOMN)#                                                       GT01   8
include:(GTCOMN)#                                                       GT01   9
#                                                                       GT01  10
INTEGER I,J,K,L,M,N,IP,NFRG,NG,NINV,NSYM,NP#                            GT01  11
INTEGER EXIST#                                                          GT01  12
chardata:(GT1, INVAR  SELECT REFINE PARTSF ASSIGN PHI    $#             GT01  13
SETFOM PSETS  DUMP   ARCHIV END    )#                                   GT01  14
chardata:(GT2,ALLTRIQUAALINPAOUACGENINVWALGWA)#                         GT01  15
chardata:(GT3,ODEDPESENUCABLRANOPR)#                                    GT01  16
chardata:(GT4,RAPEMAQPNQNOFCGTW1W2W3)#                                  GT01  17
chardata:(GT5,SEL PSE STA ITE GEN INV PMA FOM HAL )#                    GT01  18
chardata:(GT6,DSET EMIN RMAX PSET POUT PLIS PROB NACC PBDF $#           GT01  19
NBDF PACC )#                                                            GT01  20
chardata:(GT7," Gensin invariant file (.inv) not present -")#           GT01  21
chardata:(GT8," spawning GENEV and GENSIN calculations ...")#           GT01  22
intdata:(PRC,[45,0,30,45,60,90,120,135,150])#                           GT01  23
datastuff:#                                                             GT01  24
#                                                                       GT01  25
#                                                                       GT01  26
DSNM=1.#                               Set default data set number      GT01  27
EMIN=0.#                               Set default e-min                GT01  28
NGEN=999999#                           Set default generator n0.        GT01  29
MXPS=64#                               Set default max phase sets       GT01  30
POUT=4#                                Set default p.s. output          GT01  31
IPNT=0#                                Set default ps print limit       GT01  32
MINE=0.5#                              Default min expect value         GT01  33
IACC=yes:#                             Default ref accelerator on       GT01  34
INPH=0#                                Do not use bdf phis              GT01  35
XCEPT=0#                               No exception                     GT01  36
PHIAV=-1#                              Flag for not set                 GT01  37
inquirefile:(IOUNIT(4),EXIST,' ')#     Are the invariants there:        GT01  38
IF(EXIST==0)#                          Throw an exception               GT01  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT01  40
openfmt:(iofm1:,' ')#                                                   GT01  41
writefmt:(iofm1:,'(A)','GENEV ')#      Genev to reentrant file          GT01  42
writefmt:(iofm1:,'(A)','GENSIN ')#     Gensin to reentrant file         GT01  43
writefmt:(iofm1:,'(A)', CHRIP(1^80))#  Redo the gentan line             GT01  44
writeline:(2,GT7,NGT7,3,2)#            Output message                   GT01  45
writeline:(0,GT8,NGT8,3,2)#            Output message                   GT01  46
closefmt:(iofm1:)#                     Shut down the line file          GT01  47
linestream:('GT0')#                    Insert file into line stream     GT01  48
LINFLG=1#                              Force to read another line       GT01  49
XCEPT=1#                               Throw the exception              GT01  50
RETURN#                                Go no further                    GT01  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT01  52
#                                                                       GT01  53
#   PROCESS PARAMETERS ON GENTAN LINE                                   GT01  54
#   ---------------------------------                                   GT01  55
#                                                                       GT01  56
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop over input options          GT01  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT01  58
stringlim:(I,M,N)#                     Get string limits                GT01  59
compchar:(CHRIN,M,GT6,1,4,5,NGT6,N)#   Identify input option            GT01  60
IF(N<8) I=I+1#                         Incr to numeric follower         GT01  61
IF(N==0) iquit:(GT0101,I)#             Unrecognised input option        GT01  62
IF(N==1) DSNM=bf:(I)#                  Extract data set number          GT01  63
IF(N==2) EMIN=bf:(I)#                  Extract minimum e-value          GT01  64
IF(N==3) NGEN=ib:(I)#                  Extract number of generators     GT01  65
IF(N==4) MXPS=ib:(I)#                  Extract max no. of phase set     GT01  66
IF(N==5) POUT=MIN0(ib:(I),32)#         Extract phase sets out           GT01  67
IF(N==6) IPNT=ib:(I)#                  Extract phase set print          GT01  68
IF(N==8) IACC=no:#                     Switch off ref accelerator       GT01  69
IF(N==9) INPH=-1#                      Start phis at bdf values         GT01  70
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT01  71
openfmt:(iofm2:,' ')#                                                   GT01  72
writefmt:(iofm2:,'(A)','GENEV ')#      Genev to reentrant file          GT01  73
writefmt:(iofm2:,'(A)',CHRIP(1^80))#   Gentan to reentrant file         GT01  74
#                                                                       GT01  75
#   ASSIGN MEMORY AND BUFFERS                                           GT01  76
#   -------------------------                                           GT01  77
#                                                                       GT01  78
MARK=12#                               ****** genlist increment         GT01  79
IOMARK(4)=QXSTR#                       Start of buffer for file4        GT01  80
M0=IOMARK(4)+bdfbuf:#                  Mark start of sin/cos table      GT01  81
incrqx:(M1,M0+452,GT0110)#             Expand qx .........gt0110        GT01  82
#                                                                       GT01  83
#   ENTER GENSIN PARAMETERS FROM FILE4                                  GT01  84
#   ----------------------------------                                  GT01  85
#                                                                       GT01  86
readwpkt:(4,2,NP,IP,0)#                Point to record 2, file 4        GT01  87
IF(IP<=0) iquit:(GT0115)#              No bdf......gt0115               GT01  88
ETYP=QX(IP+1)#                         Extract /e/-type used (1 or      GT01  89
EMIN=AMAX1(EMIN,QX(IP+2))#             Extract /e/-min of generator     GT01  90
PFAC=QX(IP+3)#                         Extract probability factor       GT01  91
NTOT=iqx:(IP+4)#                       Extract no. nonpsi0 gens.        GT01  92
NGEN=MIN0(NGEN,NTOT)#                  Set no. gens to be used          GT01  93
STMN=QX(IP+5)#                         Extract st/l min                 GT01  94
STMX=QX(IP+6)#                         Extract st/l max                 GT01  95
LTYP=iqx:(IP+8)#                       Extract lattice type             GT01  96
NFRG=iqx:(IP+9)#                       Extract fragment count           GT01  97
ICNT=iqx:(IP+10)#                      Get centro flag (nc=0,c=1)       GT01  98
NPSI=iqx:(IP+11)#                      Extract no. psi0 gens.           GT01  99
HEAV=QX(IP+12)#                        Extract heavy atom factor        GT01 100
NSYM=iqx:(IP+13)#                      Extract number of symops         GT01 101
IF(NSYM<1) NSYM=2#                     Set default value                GT01 102
NTOT=NTOT+NPSI#                        Set total gens. (incl psi0)      GT01 103
AMIN(1)=QX(IP+29);  AMIN(2)=QX(IP+30)# Extract min prob factors         GT01 104
XVMN=QX(IP+45);     XVMX=QX(IP+46)#    Extract xvec limits              GT01 105
XSLO=QX(IP+47);     XSHI=QX(IP+48)#    Extract xvec sum limits          GT01 106
XSMN=QX(IP+70);     XSMX=QX(IP+71)#    Extract xvec sum min/max         GT01 107
NODR=iqx:(IP+76)#                      Extract no. of odr required      GT01 108
NONR=iqx:(IP+77)#                      Extract no. nonr odr allowed     GT01 109
J=IP+79;   L=IP+82#                    Point to buffer addresses        GT01 110
DO I=1,3#                              Outer odr loop                   GT01 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT01 112
J=J+1;  MDSI(I)=iqx:(J)#               Extract si vector moduli         GT01 113
DO K=1,3#                              Inner odr loop                   GT01 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT01 115
L=L+1;  SIVC(K,I)=QX(L)#               Extract si vectors               GT01 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT01 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT01 118
#                                                                       GT01 119
#   SET DEFAULT CONTROL PARAMETERS                                      GT01 120
#   ------------------------------                                      GT01 121
#                                                                       GT01 122
M1=M1-452*ICNT#                        Remove sin/cos area if centr     GT01 123
incrqx:(M2,M1+MARK*NTOT,GT0120)#       Expand qx ..........gt0120       GT01 124
#                                                                       GT01 125
IF(NONR==0) NANT=2#                    All odr restricted phis          GT01 126
ELSE        NANT=1#                    Some odr nonrestricted           GT01 127
IQPS=1;   NQPS=-1;   NPST=1#           Default control parameters &     GT01 128
NPER=0;  NTES=1;   ITEM=64;  EFOM=yes:# Default control parameters      GT01 129
PERS(1)=90;  PERS(2)=180;  NINV=1#     Default permute increments       GT01 130
EPAR=EMIN;  FRAC=.5;  SCAL=-1.#        Default control parameters       GT01 131
CONV=.02; WMIN=.15; A2MX=0.; RATE=0.7# Default control parameters       GT01 132
IXVF=3;   MXIT=30;  NSEL=100#          Default control parameters       GT01 133
ISEL=-2;   SIGA=1.;  MSEL=-1; MSTR=0#  Default control parameters       GT01 134
FIX(1)=0 ;   FIX(2)=30;   FIX(3)=10#   Set iteration fixes              GT01 135
FIX(4)=5;    FIX(5)=5 ;   FIX(6)=30#   Set iteration fixes              GT01 136
IF(IACC==yes:) FIX(3)=5#               Reset edr fix if blocks fixe     GT01 137
NMDS=NINT(DSNM)*1000#                  Set dataset offset               GT01 138
DO I=1,64; ARCH(I)=-FLOAT(NMDS+630+I)# Generate archive list            GT01 139
BIAS(1)=100000.;   BIAS(4)=7000000.#   Wgt bias for std, per            GT01 140
BIAS(2)=9000000.;  BIAS(5)=6000000.#   Wgt bias for odr, set            GT01 141
BIAS(3)=8000000.;  BIAS(6)=100.#       Wgt bias for edr, nul            GT01 142
NOS=1.;    ODR=2.;    EDR=3.#          Set status types                 GT01 143
PER=4.;    SET=5.;    NUL=6.#          Set status types                 GT01 144
INOS=1;    IODR=2;    IEDR=3#          Set status types                 GT01 145
IPER=4;    ISET=5;    INUL=6#          Set status types                 GT01 146
TRIP=0;  PSI0=1;  POSQ=2;  NEGQ=3#     Invariant type indicators        GT01 147
MXTG=100.;  MXQG=100.#                 Max t3 & pq per generator        GT01 148
WFOM(1)=1.;   WFOM(2)=1.#              Set default rfom weights         GT01 149
WFOM(3)=2.;   WFOM(4)=2.#              Set default rfom weights         GT01 150
FOPT(1)=1.;   FOPT(2)=.25#             Set default optimal values       GT01 151
FOPT(3)=.75;  FOPT(4)=60.#             Set default optimal values       GT01 152
FREJ(5)=0.25#                          Set lower rfom rejection         GT01 153
TMOS=0;       NOPS=0#                  Set default amos thresh.         GT01 154
MODE=1;       IWGT=2#                  Default casc & w2                GT01 155
RWGT=0.25;    SEED=137#                Set phase start flag & wgt       GT01 156
IF(ICNT>0) TYPE=1;  ELSE TYPE=2#       Set perm if cent else magic      GT01 157
DO I=1,4#                              Loop over fom types              GT01 158
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GT01 159
FMIN(I)=1000.;  FMAX(I)=-100.#         Set initial min/max values       GT01 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GT01 161
DO I=1,10#                             Loop over dump indices           GT01 162
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GT01 163
IDMP(I)=0;   NDMP(I)=0;   MDMP(I)=0#   Switch off dump flags            GT01 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GT01 165
#                                                                       GT01 166
#   ENTER GENERATOR LIST FROM FILE 4                                    GT01 167
#   --------------------------------                                    GT01 168
#                                                                       GT01 169
FOR(NG=M1;NG<M2;NG=NG+MARK)#           Loop over generator list         GT01 170
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GT01 171
readwpkt:(4,3,NP,IP,0)#                Point to next gen. packet        GT01 172
IF(IP<=0) iquit:(GT0123)#              Error reading invariant file     GT01 173
movereal:(QX,IP+1,QX,NG+1,NP,1)#       Store hkl,uvw,prc,sige,e         GT01 174
IF(evl:+.1>=EMIN) I=NG#                Store last accept pointer        GT01 175
prc:=FLOAT(iprc:/100)#                 Store restr phase code only      GT01 176
sta:=NOS#                              Set initial status as nos        GT01 177
alt:=0.#                               Clear alpha word                 GT01 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GT01 179
NGEN=MIN0(NGEN,(I-M1)/MARK+1)#         Calculate generators used        GT01 180
I=M1+MARK*NGEN;   J=MARK*NPSI#         Mark psi0 gen boundary           GT01 181
movereal:(QX,M2-J+1,QX,I+1,J,1)#       Remove unused normal gens.       GT01 182
MQ=I;   NLIM=NTOT-NGEN-NPSI#           Set gen. pointers                GT01 183
M2=I+J#                                Mark end of gen list             GT01 184
NTOT=NGEN+NPSI#                        Count all generators             GT01 185
readwpkt:(4,endrecord:,I,I,0)#         Rewind and close file 4          GT01 186
#                                                                       GT01 187
#    ENTER CONTROL LINES                                                GT01 188
#    -------------------                                                GT01 189
#                                                                       GT01 190
REPEAT#                                Loop input control lines         GT01 191
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GT01 192
readline:(GT1,NGT1)#                   Process input lines              GT01 193
#                                                                       GT01 194
IF(LINID==1)#                          ******  invar line *****         GT01 195
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GT01 196
IF(bf:(1)<voidflg:)#                   Test if character string         GT01 197
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GT01 198
stringlim:(1,M,N)#                     Get limits of string             GT01 199
compchar:(CHRIN,M,GT2,1,3,3,9,NINV)#   Search for match in gt2          GT01 200
IF(NINV==0) iquit:(GT0125)#            No match.......gt0125            GT01 201
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GT01 202
IF(bf:(2)>voidflg:) AMIN(1)=bf:(2)#    Set a min for triplets           GT01 203
IF(bf:(3)>voidflg:) AMIN(2)=bf:(3)#    Set b-min for quartets           GT01 204
IF(bf:(4)>voidflg:) MXTG=bf:(4)#       Set max trip/gen                 GT01 205
IF(bf:(5)>voidflg:) MXQG=bf:(5)#       Set max quar/gen                 GT01 206
IF(bf:(6)>voidflg:) SIGA=bf:(6)#       Set siga reduce factor           GT01 207
IF(bf:(7)<voidflg:)#                   Test for xvector control         GT01 208
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GT01 209
stringlim:(7,M,N)#                     Get char string limits           GT01 210
compchar:(CHRIN,M,GT2,10,2,2,19,IXVF)# Search for match in gt2          GT01 211
IF(IXVF==0) iquit:(GT0125)#            No match.......gt0125            GT01 212
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GT01 213
IF(bf:(8)>voidflg:) XSLO=bf:(8)#       Set lower xvs threshold          GT01 214
IF(bf:(9)>voidflg:) XSHI=bf:(9)#       Set upper xvs threshold          GT01 215
IF(bf:(10)>voidflg:) NQPS=ib:(10)#     Set psi for neg quartets         GT01 216
IF(bf:(11)>voidflg:) PHIAV=bf:(11)#    Override expected phi average    GT01 217
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GT01 218
#                                                                       GT01 219
ELSE IF(LINID==2)#                     ******  select line *****        GT01 220
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GT01 221
IF(bf:(1)<voidflg:)#                   Test if string present           GT01 222
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GT01 223
stringlim:(1,M,N)#                     Get limits of string             GT01 224
compchar:(CHRIN,M,GT4,1,2,2,6,TYPE)#   Match with start code            GT01 225
IF(TYPE==0) iquit:(GT0130)#            No match.......gt0130            GT01 226
TYPE=TYPE-1#                           Start flag(ra=0;pe=1;ma=2)       GT01 227
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GT01 228
IF(bf:(2)>voidflg:) MSTR=ib:(2)#       Set num phase path starters      GT01 229
IF(bf:(3)>voidflg:) MSEL=ib:(3)#       Set expected permute reflns      GT01 230
IF(bf:(4)>voidflg:) NSEL=ib:(4)#       Set ngen for select process      GT01 231
IF(bf:(5)<voidflg:)#                   Test for si selection codes      GT01 232
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GT01 233
stringlim:(5,M,N)#                     Get char string limits           GT01 234
compchar:(CHRIN,M,GT2,1,3,3,9,N)#      Search for match in gt2          GT01 235
IF(N>1) N=5-N#                         Reverse so n=3 for t3            GT01 236
ISEL=(N-2)*2#                          Store (all=-2,q4=0,t3=2)         GT01 237
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GT01 238
IF(bf:(6)<voidflg:)#                   Is select test active            GT01 239
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GT01 240
stringlim:(6,M,N)#                     Get char string limits           GT01 241
compchar:(CHRIN,M,GT2,20,3,3,31,NTES)## Search for match in gt2         GT01 242
IF(NTES==0) iquit:(GT0130)#            Ip error......gt0130             GT01 243
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GT01 244
IF(bf:(7)>voidflg:) PERS(1)=ib:(7)#    Set permute incr nr phi          GT01 245
IF(bf:(8)>voidflg:) PERS(2)=ib:(8)#    Set permute incr restr           GT01 246
IF(bf:(9)>voidflg:) RWGT=bf:(9)#       Set start wgt of random phi      GT01 247
IF(bf:(10)>0.1)     SEED=ib:(10)#      Set random number seed           GT01 248
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GT01 249
#                                                                       GT01 250
ELSE IF(LINID==3)#                     ******  refine line *****        GT01 251
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GT01 252
IF(bf:(1)<voidflg:)#                   Test if mode string present      GT01 253
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GT01 254
stringlim:(1,M,N)#                     Get limits of string             GT01 255
compchar:(CHRIN,M,GT3,11,2,2,14,MODE)# Match with mode code             GT01 256
IF(MODE==0) iquit:(GT0135)#            No match.......gt0135            GT01 257
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GT01 258
IF(bf:(2)<voidflg:)#                   Test if weight string presen     GT01 259
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GT01 260
stringlim:(2,M,N)#                     Get limits of string             GT01 261
compchar:(CHRIN,M,GT4,17,2,2,NGT4,IWGT)# Match with weight code         GT01 262
IF(IWGT==0) iquit:(GT0135)#            No match.......gt0135            GT01 263
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GT01 264
IF(bf:(3)>voidflg:) MXIT=ib:(3)#       Set max iteration limit          GT01 265
IF(bf:(4)>voidflg:) WMIN=bf:(4)#       Set minimum ext weight           GT01 266
IF(bf:(5)>voidflg:) A2MX=bf:(5)#       Set alpha**2 ext threshold       GT01 267
IF(bf:(6)>voidflg:) RATE=bf:(6)#       Set ext reduction rate           GT01 268
IF(bf:(7)>voidflg:) CONV=bf:(7)#       Set refine converge cutoff       GT01 269
DO I=1,5#                              Loop over start types            GT01 270
IF(bf:(I+7)>voidflg:) FIX(I+1)=bf:(I+7)# Set iter fix start type        GT01 271
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GT01 272
#                                                                       GT01 273
ELSE IF(LINID==4)#                     ******  partsf line *****        GT01 274
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GT01 275
IF(bf:(1)<voidflg:)#                   Test for qphi code               GT01 276
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GT01 277
stringlim:(1,M,N)#                     Get char string limits           GT01 278
compchar:(CHRIN,M,GT4,7,2,2,10,IQPS)#  Search for match in gt4          GT01 279
IF(IQPS==2) IQPS=0#                    Set qphi flag (no=0,yes=1)       GT01 280
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GT01 281
IF(bf:(2)<voidflg:)#                   Test for input phase code        GT01 282
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GT01 283
stringlim:(2,M,N)#                     Get char string limits           GT01 284
compchar:(CHRIN,M,GT4,11,2,2,14,N)#    Search for match in gt4          GT01 285
IF(N>0) INPH=N-1#                      Input mode (no=0,fc=1,gt=2)      GT01 286
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GT01 287
IF(bf:(3)>voidflg:) NPST=ib:(3)#       Set phase set required           GT01 288
IF(bf:(4)>voidflg:) EPAR=bf:(4)#       Set /e/ limit accepted phis      GT01 289
IF(bf:(5)>voidflg:) FRAC=bf:(5)#       Set frag fraction for fc         GT01 290
IF(bf:(6)>voidflg:) SCAL=bf:(6)#       Set scale for fo in test         GT01 291
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GT01 292
#                                                                       GT01 293
ELSE IF(LINID==5)#                     ******  assign line *****        GT01 294
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GT01 295
N=3#                                   Set default start type           GT01 296
DO L=1,30#                             Loop over possible fields        GT01 297
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GT01 298
IF(bf:(L)==voidflg:) BREAK#            Stop processing on void          GT01 299
IF(bf:(L)<voidflg:)#                   Test for start type code         GT01 300
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 GT01 301
stringlim:(L,M,N)#                     Get char string limits           GT01 302
compchar:(CHRIN,M,GT3,1,2,2,10,N)#     Search for match in gt3          GT01 303
IF(N==0) iquit:(GT0140)#               Unknown code.........gt0140      GT01 304
N=N+1#                                 Add storage increment            GT01 305
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 GT01 306
ELSE#                                  Else its a generator number      GT01 307
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 GT01 308
NG=M1+(ib:(L)-1)*MARK#                 Point to gen start address       GT01 309
IF(sta:>NOS) iquit:(GT0142)#           Dup start......gt0142            GT01 310
I=iprc:#                               Get phi restriction              GT01 311
sta:=FLOAT(N)#                         Set start  status                GT01 312
intpak:(PRC(I),pak:, 0, 9)#            Store starting phase             GT01 313
intpak:(FIX(N),pak:, 9, 5)#            Store iteration fix              GT01 314
IF(N!=INUL) intpak:(16,pak:,25,bitlen:(25))# Store weight =1. (*16)     GT01 315
IF((N==IPER)\((N==IEDR)&(I==1)))#      For all permuted phases          GT01 316
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 GT01 317
NPER=NPER+1#                           Count permute starters           GT01 318
intpak:(NPER,pak:,15, 4)#              Store permute pointer            GT01 319
IF(NPER>10) iquit:(GT0145)#            Exceed array.........gt0145      GT01 320
PERN(NPER)=NG#                         Save addr of permute gen         GT01 321
I=MIN0(2,I)#                           Resolve phi restriction          GT01 322
PERI(NPER)=PERS(I)#                    Store permute increment          GT01 323
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 GT01 324
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 GT01 325
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GT01 326
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GT01 327
#                                                                       GT01 328
ELSE IF(LINID==6)#                     ******  phi line *****           GT01 329
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT01 330
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 GT01 331
gethkl:(NG+1,H)#                       Extract h,k,l from list          GT01 332
ifne:(bf:(1),H(1)) NEXT#               Skip if h mismatch               GT01 333
ifne:(bf:(2),H(2)) NEXT#               Skip if k mismatch               GT01 334
ifne:(bf:(3),H(3)) NEXT#               Skip if l mismatch               GT01 335
IF(sta:>NOS) iquit:(GT0147)#           Dup start.......gt0147           GT01 336
I=iprc:#                               Extract phi restr. code          GT01 337
IF(bf:(4)<=voidflg:) K=PRC(I)#         Void phi at restr. value         GT01 338
ELSE IF(I==1)        K=ib:(4)#         Set unrestr. phi as input        GT01 339
ELSE#                                  For restr. phis test             GT01 340
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 GT01 341
J=ib:(4)-PRC(I)#                       Get difference with restr        GT01 342
J=MIN0(IABS(J),IABS(J+360),IABS(J-360))# Minimize phi difference        GT01 343
IF(J<=90) K=PRC(I)#                    Set to closest restr. phi        GT01 344
ELSE      K=PRC(I)+180#                Set to closest restr phi         GT01 345
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 GT01 346
IF(bf:(5)<voidflg:)#                   Test for start type code         GT01 347
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 GT01 348
stringlim:(5,M,N)#                     Get char string limits           GT01 349
compchar:(CHRIN,M,GT3,1,2,2,10,N)#     Search for match in gt3          GT01 350
IF(N==0) iquit:(GT0150)#               Unknown code.........gt0150      GT01 351
N=N+1#                                 Add storage increment            GT01 352
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 GT01 353
ELSE IF(bf:(5)>voidflg:) N=ib:(5)+1#   Set start type code              GT01 354
ELSE                     N=IPER#       Set start type permute           GT01 355
sta:=FLOAT(N)#                         Store start type in genlist      GT01 356
IF(bf:(6)>voidflg:) L=ib:(6)#          Store iter. fix limit            GT01 357
ELSE                L=FIX(N)#          Set default fix limit            GT01 358
intpak:(K  ,pak:, 0, 9)#               Store start phase                GT01 359
intpak:(L  ,pak:, 9, 5)#               Store iteration fix              GT01 360
IF((N==IPER)\((N==IEDR)&(I==1)))#      Test for permuted phis           GT01 361
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 GT01 362
NPER=NPER+1#                           Increment permutatin table       GT01 363
intpak:(NPER,pak:,15, 4)#              Store permute pointer            GT01 364
IF(NPER>10) iquit:(GT0160)#            Exceeds array........gt0160      GT01 365
I=MIN0(2,I)#                           Resolve phi restriction          GT01 366
PERN(NPER)=NG#                         Store generator address          GT01 367
IF(bf:(7)>voidflg:) PERI(NPER)=ib:(7)# Extract permute increment        GT01 368
ELSE                PERI(NPER)=PERS(I)## Store preset increments        GT01 369
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 GT01 370
IF(bf:(8)>voidflg:) M=NINT(bf:(8)*16.)# Extract start weight            GT01 371
ELSE IF(N!=INUL)    M=16#              Set default start weight         GT01 372
ELSE                M=0#               Set null start weight            GT01 373
intpak:(M  ,pak:,25,bitlen:(25))#      Store start weight               GT01 374
BREAK#                                 Exit when start set              GT01 375
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 GT01 376
#                                                                       GT01 377
ELSE IF(LINID==7)#                     ****** setfom line ******        GT01 378
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 GT01 379
IF(bf:(1)<voidflg:)#                   Test for pretest flag            GT01 380
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 GT01 381
stringlim:(1,M,N)#                     Get string limits                GT01 382
compchar:(CHRIN,M,GT3,17,2,2,20,EFOM)# Search for pretest code          GT01 383
IF(EFOM==0) iquit:(GT0165)#            No match........gt0165           GT01 384
EFOM=EFOM-1#                           Pretest flag (1=yes,0=no)        GT01 385
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 GT01 386
DO I=1,4#                              Loop over fom multipliers        GT01 387
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 GT01 388
IF(bf:(I+1)>voidflg:) FOPT(I)=bf:(I+1)# Get active fom opt values       GT01 389
IF(bf:(I+5)>voidflg:) WFOM(I)=bf:(I+5)# Get active fom weight           GT01 390
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 GT01 391
IF(bf:(10)<voidflg:) TMOS=1#           Get fom termination flag         GT01 392
IF(bf:(11)>voidflg:) FREJ(5)=bf:(11)#  Get fom lower rejection limit    GT01 393
WRITE(6,'(f10.4)') FREJ(5)#                                             GT01 394
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 GT01 395
#                                                                       GT01 396
ELSE IF(LINID==8)#                     ***** psets line ******          GT01 397
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 GT01 398
DO I=1,8#                              Loop over input fields           GT01 399
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 GT01 400
ifvo:(bf:(I)) BREAK#                   Exit on null field               GT01 401
NOPS=NOPS+1#                           Count selected psets             GT01 402
PSET(NOPS)=NINT(bf:(I))#               Store pset number                GT01 403
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 GT01 404
POUT=NOPS#                             Set psets limit for op           GT01 405
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 GT01 406
#                                                                       GT01 407
ELSE IF(LINID==9)#                     ***** dump line ******           GT01 408
DO I=1,30#                             Loop over possible fields        GT01 409
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 GT01 410
ifvo:(BUFIN(I)) BREAK#                 Exit on first void               GT01 411
IF(BUFIN(I)<voidflg:)#                 Test for char string             GT01 412
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 GT01 413
stringlim:(I,M,N)#                     Get string limits                GT01 414
compchar:(CHRIN,M,GT5,1,3,4,NGT5,N)#   Search for string match          GT01 415
IF(N==0) iquit:(GT0167)#               No match.......gt0167            GT01 416
IDMP(N)=yes:;   M=0#                   Store dump flag                  GT01 417
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 GT01 418
ELSE#                                  Else numeric entry               GT01 419
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 GT01 420
IF(M==0) NDMP(N)=NINT(BUFIN(I))#       Store start index                GT01 421
ELSE     MDMP(N)=NINT(BUFIN(I))#       Store stop  index                GT01 422
M=1#                                   Signify numeric entry            GT01 423
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 GT01 424
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 GT01 425
#                                                                       GT01 426
ELSE IF(LINID==10)#                    ***** archiv line ******         GT01 427
DO L=1,30#                             Loop over input fields           GT01 428
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 GT01 429
ifvo:(BUFIN(L)) BREAK#                 Exit on first void field         GT01 430
FOR(J=1;J<=ITEM;J=J+1)#                Loop over update list            GT01 431
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 GT01 432
ifeq:(BUFIN(L),ARCH(J)) BREAK#         Exit if delete on list           GT01 433
ifne:(BUFIN(L),(-ARCH(J))) NEXT#       Continue if not reverse          GT01 434
ARCH(J)=-ARCH(J)#                      Change delete to add             GT01 435
BREAK#                                 Exit when update complete        GT01 436
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 GT01 437
IF((J<=ITEM)\(BUFIN(L)>0.)) NEXT#      Skip if preset or illegal        GT01 438
ITEM=ITEM+1#                           Add item to update list          GT01 439
IF(ITEM>66) iquit:(GT0170)#            Exceed lim........gt0170         GT01 440
ARCH(ITEM)=BUFIN(L)#                   Add delete item to update        GT01 441
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 GT01 442
#                                                                       GT01 443
ELSE BREAK#                            ******  end line *****           GT01 444
writefmt:(iofm2:,'(A)',CHRIP(1^80))#   Option to reentrant file         GT01 445
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GT01 446
#                                                                       GT01 447
#                                                                       GT01 448
IF((ICNT==yes:)\(TYPE==0)) NANT=0#     Switch off edr selection         GT01 449
MSTR=NODR+MIN0(1,NANT)+MAX0(MSTR,TYPE)# Set starts for maxcon           GT01 450
MSTR=MAX0(MSTR,3)#                     Ensure min maxcon selected       GT01 451
MSEL=MAX0(MSEL,5-MSTR)#                Ensure min maxext selected       GT01 452
IF(NINV==2) XSHI=99.#                  Prohibit positive quartets       GT01 453
IF(NINV==3) AMIN(1)=16.#               Prohibit triplets                GT01 454
IF(NFRG==no:) IQPS=no:#                Only used if available           GT01 455
IF((IQPS==no: )&(NQPS<0)) NQPS=180#    Set nq4 psi for no frag          GT01 456
IF((IQPS==yes:)&(NQPS<0)) NQPS=0#      Set nq4 psi if frag used         GT01 457
ifeq:(XSHI,0.) XSHI=-.1#               Reset xvs hi limit if 0          GT01 458
IF (XSLO>99.) XSLO=AMIN1(1.5,XSMX*.25)# Set default low xvs limit       GT01 459
IF(XSHI<0.&IXVF!=3) XSHI=XSLO#         Set default upper xvs limit      GT01 460
ELSE IF(XSHI<0.)    XSHI=AMIN1(5.,XSMX*.75)# Set upper xvs limit        GT01 461
#                                                                       GT01 462
DO I=5,2,-1;IF(IDMP(I+1)>0) IDMP(I)=1# Chain dump flags                 GT01 463
DO I=1,8; IF(IDMP(I)>0&NDMP(I)==0)NDMP(I)=1# Set dump default           GT01 464
IF(IDMP(3)>0&MDMP(3)==0) MDMP(3)=MDMP(2)# Set to pset value             GT01 465
DO I=1,3; IF(NDMP(I)>0&MDMP(I)==0)MDMP(I)=NDMP(I)# Set dump default     GT01 466
DO I=4,6; IF(NDMP(I)>0&MDMP(I)==0)MDMP(I)=9999# Cyc/gen dump default    GT01 467
IF(IDMP(9)>0&NDMP(9)==0) NDMP(9)=MDMP(2)# Set kill at last pset         GT01 468
DO I=2,9; IF(IDMP(I)>0) IDMP(10)=yes:# Set general dump flag            GT01 469
#                                                                       GT01 470
RETURN#                                                                 GT01 471
END#                                                                    GT01 472
systemheader:(GT02)#                   Input bdf phis & invariants      GT02   1
####################################################################    GT02   2
#                                                                  #    GT02   3
#                             GT02                                 #    GT02   4
#                                                                  #    GT02   5
####################################################################    GT02   6
SUBROUTINE GT02#                       S.r.hall  jun 81                 GT02   7
include:(AACOMN)#                                                       GT02   8
include:(GTCOMN)#                                                       GT02   9
#                                                                       GT02  10
INTEGER I,J,M,N,IP,NP,NN#                                               GT02  11
INTEGER IA,IB,IC,ID,IQ,IS,IT,JP,MM,MREC,NG,NINV,NREC,N1,N2,N3,N4#       GT02  12
REAL D,EVAL,FCAL,FREL,XVS#                                              GT02  13
REAL A,B,C,W,SUMW,SSI(4)#                                               GT02  14
string:(LINE,80)#                                                       GT02  15
#                                                                       GT02  16
chardata:(GT1,  NGEN  H   K   L    |E|   TYPE  TRIP$#                   GT02  17
  PSI0  POSQ  NEGQ     SUMA)#                                           GT02  18
chardata:(GT2,   ODREDRPERSETNUL)#                                      GT02  19
chardata:(GT3, **********GENERATOR DUMP IN INPUT ORDER)#                GT02  20
chardata:(GT4," E values not on bdf - spawning GENEV ")#                GT02  21
intdata:(PRC,[0,0,30,45,60,90,120,135,150,180])#                        GT02  22
realdata:(PI2,6.28318);    realdata:(PHI,0.)#                           GT02  23
realdata:(FM,[90413.,130413.,170413.,50413.,#                           GT02  24
240522.,650802.,360603.,420603.,480603.,540603.])#                      GT02  25
realdata:(ATHR,0.); realdata:(BTHR,0.)#                                 GT02  26
datastuff:#                                                             GT02  27
#                                                                       GT02  28
#   ENTER BDF PHIS IF REQUESTED                                         GT02  29
#   ----------------------------                                        GT02  30
#                                                                       GT02  31
IOMARK(1)=QXSTR#                       Assign buffer to file 1          GT02  32
IF(INPH==1&SCAL<0.)#                   Test if fc scale required        GT02  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT02  34
IW(1)=1;   IW(2)=101#                  Set dsnm and scale idnm          GT02  35
KEY(1)=2;KEY(2)=0;KEY(3)=0;KEY(4)=0#   Set search delimiters            GT02  36
indexpkt:(1,lrexpl:,NP,IP,0,KEY,IW,IR)# Get packet pointer              GT02  37
IF(KEY(4)<0) iquit:(GT0230)#           Miss item ...........gt0230      GT02  38
ID=IP+IR(1)#                           Point to data set num            GT02  39
REPEAT#                                Loop over all data sets          GT02  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT02  41
readwpkt:(1,lrexpl:,NP,IP,0)#          Point to next packet             GT02  42
IF(IP<=0) BREAK#                       Exit when no more                GT02  43
ifne:(QX(ID),DSNM) NEXT#               Test if required dsnm            GT02  44
I=IP+IR(2); SCAL=QX(I)#                Store frel scale value           GT02  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT02  46
IF(SCAL<=0.) iquit:(GT0235)#           Miss scal..........gt0235        GT02  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT02  48
#                                                                       GT02  49
IW(1)=1#                               Idnum for hkl                    GT02  50
IW(2)=NMDS+599+NINT(ETYP)#             Idnum for /e/-value              GT02  51
IW(3)=NMDS+304; IW(4)=NMDS+800#        Idnums for frel & fcal           GT02  52
IW(5)=NMDS+801; IW(6)=NMDS+700#        Idnums for arel & fc-phi         GT02  53
IW(7)=NMDS+629+NPST*2#                 Idnum for gt phase               GT02  54
KEY(1)=2;KEY(2)=7;KEY(3)=0;KEY(4)=0#   Set search delimiters            GT02  55
indexpkt:(1,lrrefl:,NP,IP,0,KEY,IW,IR)# Point to idnums in refl         GT02  56
IF(KEY(4)<=0)#                         /e/ miss ........gt0240          GT02  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT02  58
writeline:(0,GT4,NGT4,3,2)#            Output message                   GT02  59
LINFLG=1#                              Force new read line              GT02  60
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  Next inpt line isn't end or eo   GT02  61
writefmt:(iofm2:,'(A)',CHRIP(1^80))#   Write header to file             GT02  62
rewindbdf:(1)#                         Half read this bdf so rewind     GT02  63
closefmt:(iofm2:)#                     Shut down the line file          GT02  64
openfmt:(iofm1:,' ')#                  Re open .gt0 file                GT02  65
openfmt:(iofm2:,' ')#                  Open the .gt1 file               GT02  66
REPEAT#                                Read until finished              GT02  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT02  68
readfmt:(iofm2:,'(A80)',150,LINE)#     Read a line of instructions      GT02  69
writefmt:(iofm1:,'(A80)',LINE)#        Add instructions to unused fil   GT02  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT02  71
150 closefmt:(iofm2:)#                 Close dump line file             GT02  72
closefmt:(iofm1:)#                     Close new linestream file        GT02  73
linestream:('GT0')#                    Insert file into line stream     GT02  74
XCEPT=1#                               Threw an exception               GT02  75
RETURN#                                Go no further                    GT02  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT02  77
closefmt:(iofm2:)#                     Close unrequired line file       GT02  78
IF(INPH==1&IR(3)*IR(4)==0) iquit:(GT0245)# Sf miss.......gt0245         GT02  79
IF(INPH==1&IR(5)+IR(6)==0) iquit:(GT0250)# Fc phi miss...gt0250         GT02  80
IF(INPH==2&IR(7)==0)       iquit:(GT0255)# Gt phi miss...gt0255         GT02  81
#                                                                       GT02  82
IF(INPH>0\(INPH<0&IR(5)+IR(6)>0))#     Test if reflections input        GT02  83
REPEAT#                                Loop over all records            GT02  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GT02  85
readwpkt:(1,lrrefl:,NP,IP,0)#          Point to next packet             GT02  86
IF(IP<=0) BREAK#                       Exit if no more                  GT02  87
I=IP+IR(2);  EVAL=QX(I)#               Extract /e/-value                GT02  88
IF(EVAL<EPAR) NEXT#                    Skip if below threshold          GT02  89
IF(INPH==1)#                           Test if phis from fc calc        GT02  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GT02  91
I=IP+IR(3);  FREL=QX(I)#               Extract frel value               GT02  92
I=IP+IR(4);  FCAL=QX(I)#               Extract fcal value               GT02  93
IF(FREL*SCAL*FRAC>FCAL) NEXT#          Skip if outside sf test          GT02  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GT02  95
I=IP+IR(1);  movepakwd:(QX(I),A)#      Put packed hkl in temp           GT02  96
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT02  97
compakwd:(A,EQ,hkl:,BREAK)#            Exit when hkl match found        GT02  98
IF(NG>=MQ) NEXT#                       Not on list- forget it           GT02  99
IF(sta:>NOS) NEXT#                     Skip if already starter          GT02 100
IF(INPH<=1)#                           Test if in fc phi mode           GT02 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GT02 102
I=IP+IR(6); IF(I>IP) PHI=QX(I)#        If available get fc phi          GT02 103
ELSE IF(IR(5)>0)#                      Else get fc phi from a & b       GT02 104
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GT02 105
I=IP+IR(5);  A=QX(I);  B=QX(I+1)#      Point to acal                    GT02 106
IF((ABS(A)<.01)&(ABS(B)<.01)) NEXT#    Avoid null phi case              GT02 107
PHI=ATAN2(B,A)/PI2#                    Calc phi in cycles (2pi=1.0)     GT02 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GT02 109
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GT02 110
ELSE#                                  If inph=2 extract gt phi         GT02 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GT02 112
I=IP+IR(7); PHI=QX(I)#                 Point and extract gt phi         GT02 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GT02 114
M=MOD(3600+NINT(PHI*360.),360)#        Convert phi to degrees           GT02 115
IF(prc:>1.5)#                          Test if phi restricted           GT02 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GT02 117
I=iprc:;    I=PRC(I)#                  Get phi resr & integer phi       GT02 118
M=IABS(I-M); M=MIN0(M,360-M)#          Get smallest difference          GT02 119
IF(M<90) M=I#                          Set at restr value               GT02 120
ELSE     M=I+180#                                                       GT02 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GT02 122
alt:=FLOAT(M+360)#                     Store refined phase in temp      GT02 123
IF(M==0) M=360#                        Ensure phase non-zero            GT02 124
intpak:(M   ,pak:, 0, 9)#              Store refined phase              GT02 125
IF(INPH<0) NEXT#                       Skip if not input starter        GT02 126
sta:=SET#                              Set status as set phi            GT02 127
N=FIX(ISET)#                           Extract iteration fix            GT02 128
intpak:(N   ,pak:, 9, 6)#              Store iteration fix              GT02 129
intpak:(INPH,pak:,19, 3)#              Store input mode(fc=1;gt=2)      GT02 130
intpak:(16  ,pak:,25,bitlen:(25))#     Store start weight               GT02 131
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GT02 132
readwpkt:(1,endrecord:,I,I,0)#         Rewind and close file 1          GT02 133
INPH=MAX0(INPH,0)#                     Reset phi flag                   GT02 134
#                                                                       GT02 135
#   ENTER INVARIANTS FROM FILE 4                                        GT02 136
#   ---------------------------                                         GT02 137
#                                                                       GT02 138
MG=M2#                                 Mark start of pmap               GT02 139
IF(IDMP(7)>0)#                         Is phase map requested           GT02 140
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GT02 141
I=NGEN*(MXIT+2)#                       Set possible phase map           GT02 142
incrqx:(M2,M2+I,GT0277)#               Dump map......gt0277             GT02 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GT02 144
I=NINT(AMIN(1)*128.);J=NINT(AMIN(2)*128.)# Convert to integer           GT02 145
plastbitsword:(I,ATHR)#                Pack a-limit for test            GT02 146
plastbitsword:(J,BTHR)#                Pack b-limit for test            GT02 147
DO I=1,4;  NTYP(I)=0#                  Zeroize invariant counters       GT02 148
NG=M1-MARK;    MM=NG;    MG=MQ#        Mark start of genlist            GT02 149
IF(IDMP(1)>0) writeline:(1,GT3,NGT3,2,3)# Print dump header             GT02 150
LINRM=3;  MREC=1;  BOT=M2#             Force first header               GT02 151
#                                                                       GT02 152
DO N1=1,NTOT#                          Loop over all generators         GT02 153
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GT02 154
NG=NG+MARK#                            Incr to start of this gen        GT02 155
top:=FLOAT(BOT);    pnt:=FLOAT(NG)#    Store genlist pointers           GT02 156
NREC=N1+3#                             Set correct file4 recnum         GT02 157
MREC=MREC+1#                           Set output file3 recnum          GT02 158
IF(N1>NGEN) NREC=NREC+NLIM#            Use skip for psi0 gens.          GT02 159
NINV=0; SUMW=0.#                       Initialize accumulators          GT02 160
DO I=1,4;  SSI(I)=0.#                  Zeri invariant counters          GT02 161
#                                                                       GT02 162
REPEAT#                                Loop over all invariants         GT02 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GT02 164
W=0.#                                  Reset weight sum                 GT02 165
IF(N1>NGEN) IT=PSI0#                   Set as triplet psi0              GT02 166
ELSE        IT=TRIP#                   Set as triplet                   GT02 167
readwpkt:(4,NREC,NP,IP,0)#             Point to invariant packet        GT02 168
IF(IP<=0) BREAK#                       Exit if no more                  GT02 169
IF(IT==PSI0)generatornum:(IP,NN,4)#    Max gen of a psi0 invariant      GT02 170
ELSE        generatornum:(IP,NN,1)#    Max gen of triplet or quartet    GT02 171
IF(NN>NGEN) NEXT#                      Ignore si with nn>ngen           GT02 172
N4=0#                                  Initialise for psi0              GT02 173
IF(IT!=PSI0)#                          Enter if not psi0 triplet        GT02 174
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GT02 175
generatornum:(IP,N4,4)#                Generator 4 of a quartet         GT02 176
IF(N4==0)#                             Test if invariant is triplet     GT02 177
comppakwdone:(IP,LT,ATHR,NEXT)#        Ignore trip if a<amin            GT02 178
ELSE#                                  Else must be quartet             GT02 179
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GT02 180
comppakwdone:(IP,LT,BTHR,NEXT)#        Ignore quar if b<bmin            GT02 181
xvectorsum:(IP,I)#                     Extract xvector sum*8            GT02 182
XVS=FLOAT(IABS(I-512))/8.#             Convert to +real value           GT02 183
IF((IXVF==2)&(I<512)) NEXT#            If inside & negative skip        GT02 184
IF((IXVF==4)&(I>512)) NEXT#            If outside & positive skip       GT02 185
IF(I<512) IT=POSQ#                     If negative set as posq          GT02 186
ELSE IF(XVS>=XSHI) IT=POSQ#            Set type as pos quartet          GT02 187
ELSE IF(XVS<=XSLO) IT=NEGQ#            Set type as neg quartet          GT02 188
ELSE                 NEXT#                                              GT02 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GT02 190
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GT02 191
IF((SSI(1)>=MXTG)&(IT==TRIP)) NEXT#    Skip if t3/gen exceeded          GT02 192
IF((SSI(3)>=MXQG)&(IT==POSQ)) NEXT#    Skip if pq/gen exceeded          GT02 193
IF((SSI(4)>= 100)&(IT==NEGQ)) NEXT#    Skip if nq/gen exceeded          GT02 194
#                                                                       GT02 195
phaserestr:(IP,IC)#                    Get restr phi code (1-10)        GT02 196
phisigncode:(IP,IS)#                   Get phi sign code (0-7)          GT02 197
phiinvshift:(IP,ID)#                   Get si shift (deg/30)            GT02 198
phifragment:(IP,IQ)#                   Get frag psi est (0-359)         GT02 199
probfactor:(IP,IA)#                    Get ab value*128                 GT02 200
probfsigma:(IP,IB)#                    Get sig(a)*128                   GT02 201
generatornum:(IP,N2,2)#                Get n2 value                     GT02 202
generatornum:(IP,N3,3)#                Get n3 value                     GT02 203
#                                                                       GT02 204
A=FLOAT(IA)/128.#                      Extract prob fact a or b         GT02 205
B=AMIN1(FLOAT(IB)/128.,A*.5)#          Extract sigma(a)                 GT02 206
A=A-B*SIGA#                            Reduce a by factor siga          GT02 207
D=EXP(A)#                              Exponential of a                 GT02 208
IF(IC==1) C=(D-1./D)/(D+1./D)#         Calc centro expect factor        GT02 209
ELSE C=A*(A+.4807)/(A*(A+.8636)+1.3943)# Calc noncen expect factor      GT02 210
C=AMAX1(C,MINE)#                       Ensure above min expect f        GT02 211
IA=MIN0(127,NINT(A*8.))#               Prepare ab for packing           GT02 212
IB=MIN0(127,NINT(C*64.))#              Prepare expectf for packing      GT02 213
ID=ID*30#                              Convert si shift to degrees      GT02 214
IF(IQPS==yes:)   ID=ID-IQ#             Adjust shift if qpsi used        GT02 215
IF(IT==NEGQ)     ID=ID-NQPS#           Adjust shift if neg quartet      GT02 216
ID=MOD(ID+3600,360)#                   Ensure total shift is 0-359      GT02 217
IF(IXVF==5) IT=MIN(IT,2)#              Make negq4 equiv to posq4        GT02 218
IF(N2!=N3) W=W+512.#                   Sum unique contributors          GT02 219
IF(N3!=N4) W=W+512.#                   Sum unique contributors          GT02 220
IF(N4!=0 ) W=W+512.#                   Sum unique contributors          GT02 221
IF((IT!=NEGQ)&(IT!=ISEL))#             Sum w*alpha for selection        GT02 222
SUMW=SUMW+A*C*W#                       Sum a*expf*ni to each gen        GT02 223
#                                                                       GT02 224
IF((N1<=N2)&(N1<=N3)&(N2<=N3))#        Test for unique invariant        GT02 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GT02 226
IF(IT==TRIP) NTYP(1)=NTYP(1)+1#        Count unique triplets            GT02 227
ELSE IF((N1<=N4)&(N2<=N4)&(N3<=N4))#   Test for unique quartet          GT02 228
NTYP(IT+1)=NTYP(IT+1)+1#               Count unique quartets            GT02 229
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GT02 230
IF(IT==PSI0) NTYP(2)=NTYP(2)+1#        Count psi(0) triplets            GT02 231
SSI(IT+1)=SSI(IT+1)+1.#                Count redundant invars           GT02 232
#                                                                       GT02 233
JP=BOT;  incrqx:(BOT,BOT+4,GT0280)#    Get mem for next invariant       GT02 234
intpak:(IT,QX(JP+1), 0, 2)#            Pack invar. type  bits  1- 0     GT02 235
intpak:(IS,QX(JP+1), 2, 3)#            Pack si sign code bits  4- 2     GT02 236
intpak:(IC,QX(JP+1), 5, 4)#            Pack si psi restr bits  8- 5     GT02 237
intpak:(ID,QX(JP+1), 9, 9)#            Pack total shift  bits 17- 9     GT02 238
intpak:(IB,QX(JP+1),18, 7)#            Pack expectf*64   bits 22-18     GT02 239
intpak:(IA,QX(JP+1),25,bitlen:(25))#   Pack ab value*8   bits **-25     GT02 240
QX(JP+2)=FLOAT(M1+(N2-1)*MARK)#        Convert n2 as genlist addr       GT02 241
QX(JP+3)=FLOAT(M1+(N3-1)*MARK)#        Convert n3 as genlist addr       GT02 242
QX(JP+4)=FLOAT(M1+(N4-1)*MARK)#        Convert n4 as genlist addr       GT02 243
NINV=NINV+4#                           Count words per si block         GT02 244
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GT02 245
I=ista:;   sma:=SUMW+BIAS(I)#          Store sum w*alf with bias        GT02 246
bot:=FLOAT(BOT)#                       Store end of genlist block       GT02 247
#                                                                       GT02 248
IF((NINV>12)&(N1>NGEN))#               Test if psi(0) gen active        GT02 249
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GT02 250
movereal:(QX,NG+1,QX,MG+1,MARK,1)#     Bubble up psi(o) gen's           GT02 251
MG=MG+MARK#                            Incr new psi(o) limit            GT02 252
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GT02 253
ELSE IF(N1>NGEN) NEXT#                 No record for null psi0          GT02 254
#                                                                       GT02 255
IF(IDMP(1)==0) NEXT#                   Skip if no dump                  GT02 256
gethkl:(NG+1,BUFOT)#                   Extract h,k,l                    GT02 257
BUFOT(4)=FLOAT(N1)#                    Store generator number           GT02 258
BUFOT(5)=evl:#                         Store /e/ value                  GT02 259
BUFOT(6)=SUMW#                         Store sum w*alpha                GT02 260
ncodefld:(BUFOT,1,CHROT,FM,6)#         Format above items               GT02 261
ncodefld:(SSI,1,CHROT,FM(7),4)#        Format invariant counters        GT02 262
movechar:(GT2,I*3-2,CHROT,28,3,0)#     Insert generator status          GT02 263
writeline:(0,GT1,NGT1,1,3)#            Print generator items            GT02 264
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GT02 265
NTOT=(MG-M1)/MARK#                     Reset total generators           GT02 266
NPSI=(MG-MQ)/MARK#                     Reset number psi(0)'s            GT02 267
#                                                                       GT02 268
IOMARK(3)=IOMARK(4)#                   Assign filec buffer start        GT02 269
readwpkt:(4,endrecord:,I,I,0)#         Rewind and close file 4          GT02 270
#                                                                       GT02 271
IF((ISEL==0)&(NTYP(3)==0)) iquit:(GT0270)# No pq4......gt0270           GT02 272
IF((ISEL==2)&(NTYP(1)==0)) iquit:(GT0275)# No t3 ......gt0275           GT02 273
IF((ISEL<0)&(NTYP(1)==0)) ISEL=0#      No t3 so limit select flag       GT02 274
IF((ISEL<0)&(NTYP(3)==0)) ISEL=2#      No q4 so limit select flag       GT02 275
#                                                                       GT02 276
RETURN#                                                                 GT02 277
END#                                                                    GT02 278
systemheader:(GT03)#                   Select odr,edr & phase path      GT03   1
####################################################################    GT03   2
#                                                                  #    GT03   3
#                             GT03                                 #    GT03   4
#                                                                  #    GT03   5
####################################################################    GT03   6
SUBROUTINE GT03#                       S.r.hall  jun 81                 GT03   7
include:(AACOMN)#                                                       GT03   8
include:(GTCOMN)#                                                       GT03   9
#                                                                       GT03  10
INTEGER I,J,K,L,M,N#                                                    GT03  11
INTEGER II,JJ,KK,NN,NTOP,NMID,NBOT,NTEM#                                GT03  12
INTEGER JPH(15),KPH(15)#                                                GT03  13
INTEGER IA,IB,IDET,IT,JEDR,NG,NORG,NR,NS,NT,NX,NY,N1,N2,N3,N4#          GT03  14
REAL AW#                                                                GT03  15
REAL AH(3),AK(3),AL(3),A#                                               GT03  16
REAL NOSP,ODRP#                                                         GT03  17
REAL ZERO#                                                              GT03  18
INTEGER NCUL,NEW#                                                       GT03  19
#                                                                       GT03  20
chardata:(GT1,  NSEQ   NGEN   H   K   L    |E|  TYPE     SUMA)#         GT03  21
chardata:(GT2,   ODREDRPERSETNUL)#                                      GT03  22
chardata:(GT3, **********MAXCON DUMP IN REVERSE ORDER)#                 GT03  23
chardata:(GT4, NGEN    ASSIGNED AS    )#                                GT03  24
intdata:(PRC,[0,0,30,45,60,90,120,135,150,180])#                        GT03  25
realdata:(FM,[170413.,210413.,250413.,50413.,#                          GT03  26
120413.,320622.,480802.,80313.])#                                       GT03  27
realdata:(Q,[0.,0.,0.,0.,0.,0.,0.,0.,0.])#                              GT03  28
intdata:(IRST,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])#                         GT03  29
intdata:(ISTR,[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])#                         GT03  30
datastuff:#                                                             GT03  31
#                                                                       GT03  32
#   ODR-EDR SELECTION & PHASE PATH DEFINITION                           GT03  33
#   =========================================                           GT03  34
#                                                                       GT03  35
intpak:(0,ZERO,0,mxbtwd:)#                                              GT03  36
NSTR=0;   NORG=NODR+MIN0(1,NANT)#      Initialize start set             GT03  37
NX=MIN0(MQ,M1+NSEL*MARK);  NY=NX#      Set initial odr & edr limits     GT03  38
ODRP=ODR+.5;   NOSP=NOS+.5#            Form fp test for odr, nop        GT03  39
IF(IDMP(1)>0) writeline:(1,GT3,NGT3,1,3)# Print dump header             GT03  40
LINRM=3#                               Force first header               GT03  41
#                                                                       GT03  42
FOR(NR=MQ-MARK;NR>=M1;NR=NR-MARK)#     Reverse genlist loop             GT03  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT03  44
#                                                                       GT03  45
#                                        ******* find low w*alpha       GT03  46
A=1.E10;  NT=1#                        Set initial sum & pointer        GT03  47
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT03  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT03  49
IF(evl:<0.) NEXT#                      Skip culled generators           GT03  50
IF(sma:>=A ) NEXT#                     Skip if > current min sum        GT03  51
A=sma:;   NCUL=NG#                     Store smaller sum & pointer      GT03  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT03  53
#                                                                       GT03  54
#                                        ******* not assigned starter   GT03  55
IF(A<5000000.&INPH==0)#                Test if assigned starter         GT03  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT03  57
sma:(NCUL)=-ABS(A)#                    Flag min sum found in list       GT03  58
FOR(NS=1;NS<=NSTR;NS=NS+1)#            Loop over start set              GT03  59
IF(ISTR(NS)==NCUL) BREAK#              Exit if genlist addr match       GT03  60
#                                                                       GT03  61
#                                        ****** is new start needed     GT03  62
IF(NS<=MSTR)#                          Test if new start required       GT03  63
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT03  64
NEW=no:#                               Reset new gen flag               GT03  65
#                                                                       GT03  66
#                                        ******** sort poss starts      GT03  67
FOR(NN=M1;NN<NR;NN=NN+MARK)#           Loop over generator list         GT03  68
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GT03  69
A=0.#                                  Initial sort sum                 GT03  70
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT03  71
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GT03  72
IF(sma:<=A) NEXT#                      Skip if a > this sum             GT03  73
A=sma:;    I=NG;#                      Store larger sum & pointer       GT03  74
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GT03  75
pnt:(NN)=FLOAT(I);    sma:(I)=-A#      Store order & disable sum        GT03  76
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GT03  77
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT03  78
IF(evl:>0.) sma:=ABS(sma:)#            Restore disabled sums            GT03  79
#                                                                       GT03  80
#   TEST IF NEW ODR SET REQUIRED                                        GT03  81
#   ----------------------------                                        GT03  82
#                                                                       GT03  83
IF(NS<=NORG)#                          Test if apriori or odr cull      GT03  84
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GT03  85
NT=NORG;   NS=1#                       Reset start set limits           GT03  86
#                                                                       GT03  87
REPEAT#                                Loop over odr attempts           GT03  88
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GT03  89
IF(NODR==0) GO TO 100#                 Test if any odr's                GT03  90
#                                                                       GT03  91
IF(NODR==1)#                           ****** nodr=1 *********          GT03  92
FOR(NG=M1;NG<NR;NG=NG+MARK)#           Loop over generator list         GT03  93
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GT03  94
II=ipnt:#                              Store sorted of generator        GT03  95
IF(II>NX) NEXT#                        Skip generators above limit      GT03  96
IF(sta:(II)>ODRP) NEXT#                Skip starts edr,per              GT03  97
IF(prc:(II)<1.5) NN=1#                 Count resr. phi generator        GT03  98
ELSE             NN=0#                 This not restricted phi          GT03  99
IF(NN>NONR) NEXT#                      Skip excess nonrestr gen         GT03 100
gethkl:(II+2,AH)#                      Unpack si vectors uvw            GT03 101
IDET=NINT(AH(1))#                      Get determinant of u             GT03 102
IF(IABS(IDET)!=1) NEXT#                Exit if /det/=1                  GT03 103
ISTR(1)=II;   Q(1)=AH(1);   GOTO 100#  Store addr of new odr            GT03 104
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GT03 105
#                                                                       GT03 106
IF(NODR==2)#                           ******* nodr=2 **********        GT03 107
FOR(NG=M1+MARK;NG<NR;NG=NG+MARK)#      Loop remainding genlist          GT03 108
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GT03 109
NBOT=NG#                               Reset bot pointer to start       GT03 110
FOR(NTOP=M1;NTOP<NBOT;NTOP=NTOP+MARK)# Inner genlist loop               GT03 111
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GT03 112
II=ipnt:(NTOP);  JJ=ipnt:(NBOT)#       Point sorted order of gen        GT03 113
NBOT=NBOT-MARK#                        Decrement bottom pointer         GT03 114
IF((II>NX)\(JJ>NX)) NEXT#              Skip generators above limit      GT03 115
IF((sta:(II)>ODRP)\(sta:(JJ)>ODRP))NEXT# Skip starts if edr, per        GT03 116
IF(prc:(II)>1.5) NN=0#                 Zero restr counter if not        GT03 117
ELSE             NN=1#                 Count if phi1 restricted         GT03 118
IF(prc:(JJ)<1.5) NN=NN+1#              Count if phi2 restricted         GT03 119
IF(NN>NONR) NEXT#                      Skip if nonrestr exceeded        GT03 120
gethkl:(II+2,AH)#                      Get si vectors for gen1          GT03 121
gethkl:(JJ+2,AK)#                      Get si vectors for gen2          GT03 122
IDET=NINT(AH(1)*AK(2)-AH(2)*AK(1))#    Calc si determinate              GT03 123
IF(IABS(IDET)!=1) NEXT#                Exit if /det/=1                  GT03 124
ISTR(1)=II;  ISTR(2)=JJ#               Store addr of new odr            GT03 125
Q(1)=+AK(2);  Q(2)=-AK(1)#             Store adjt. matrix for edr       GT03 126
Q(4)=-AH(2);  Q(5)=+AH(1)#             Store adjt. matrix for edr       GT03 127
GOTO 100#                              Exit odr search                  GT03 128
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GT03 129
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GT03 130
#                                                                       GT03 131
IF(NODR==3)#                           ********* nodr=3 *********       GT03 132
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GT03 133
K=2*MARK#                              Preset temp test decr.           GT03 134
FOR(NG=M1+K;NG<NR;NG=NG+MARK)#         Loop1 remainder genlist          GT03 135
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GT03 136
NTEM=NG+MARK#                          Set temp marker to start         GT03 137
FOR(NTOP=M1;NTOP<NTEM-K;NTOP=NTOP+MARK)# Loop2 remainder genlist        GT03 138
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GT03 139
NTEM=NTEM-K#                           Decr temp low ker                GT03 140
II=ipnt:(NTOP)#                        Point sorted order of list       GT03 141
IF(II>NX) NEXT#                        Skip generators above limit      GT03 142
compakwd:(uvw:(II),EQ,ZERO,NEXT)#      Skip if not eligible             GT03 143
IF(sta:(II)>ODRP) NEXT#                Skip starts edr,per              GT03 144
gethkl:(II+2,AH)#                      Unpack si vectors for gen1       GT03 145
NBOT=NTEM+MARK#                        Set start of bot pointer         GT03 146
FOR(NMID=NTOP+MARK;NMID<NBOT;NMID=NMID+MARK)# Loop3 of part genlist     GT03 147
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GT03 148
JJ=ipnt:(NMID);   KK=ipnt:(NBOT)#      Point sorted order of gen        GT03 149
NBOT=NBOT-MARK#                        Decrement bot list pointer       GT03 150
IF((JJ>NX)\(KK>NX)) NEXT#              Skip generators above limit      GT03 151
compakwd:(uvw:(JJ),EQ,ZERO,NEXT)#      Skip if not eligible             GT03 152
compakwd:(uvw:(KK),EQ,ZERO,NEXT)#      Skip if not eligible             GT03 153
IF((sta:(JJ)>ODRP)\(sta:(KK)>ODRP))NEXT# Skip starts if edr, per        GT03 154
IF(prc:(II)>1.5) NN=0#                 Zero nonrestr count if not       GT03 155
ELSE             NN=1#                 Count phi1 if nonrestr           GT03 156
IF(prc:(JJ)<1.5) NN=NN+1#              Count phi2 if nonrestr           GT03 157
IF(prc:(KK)<1.5) NN=NN+1#              Count phi2 if nonrestr           GT03 158
IF(NN>NONR) NEXT#                      Skip if nonrestr > limit         GT03 159
gethkl:(JJ+2,AK)#                      Extract si vectors for gen2      GT03 160
gethkl:(KK+2,AL)#                      Extract si vectors for gen3      GT03 161
IDET=NINT(AH(1)*(AK(2)*AL(3)-AK(3)*AL(2))$# Calc 3x3 determinant        GT03 162
+          AH(2)*(AK(3)*AL(1)-AK(1)*AL(3))$# Calc 3x3 determinant       GT03 163
+          AH(3)*(AK(1)*AL(2)-AK(2)*AL(1)))# Calc 3x3 determinant       GT03 164
IF(IABS(IDET)!=1) NEXT#                Exit if /det/=1                  GT03 165
ISTR(1)=II; ISTR(2)=JJ; ISTR(3)=KK#    Store addr of new odr            GT03 166
Q(1)=AK(2)*AL(3)-AK(3)*AL(2)#          Store adjt. matrix for edr       GT03 167
Q(2)=AH(3)*AL(2)-AH(2)*AL(3)#          Store adjt. matrix for edr       GT03 168
Q(3)=AH(2)*AK(3)-AH(3)*AK(2)#          Store adjt. matrix for edr       GT03 169
Q(4)=AK(3)*AL(1)-AK(1)*AL(3)#          Store adjt. matrix for edr       GT03 170
Q(5)=AH(1)*AL(3)-AH(3)*AL(1)#          Store adjt. matrix for edr       GT03 171
Q(6)=AH(3)*AK(1)-AH(1)*AK(3)#          Store adjt. matrix for edr       GT03 172
Q(7)=AK(1)*AL(2)-AK(2)*AL(1)#          Store adjt. matrix for edr       GT03 173
Q(8)=AH(2)*AL(1)-AH(1)*AL(2)#          Store adjt. matrix for edr       GT03 174
Q(9)=AH(1)*AK(2)-AH(2)*AK(1)#          Store adjt. matrix for edr       GT03 175
GOTO 100#                              Exit odr search loop             GT03 176
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GT03 177
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GT03 178
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GT03 179
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GT03 180
#                                                                       GT03 181
IF(NSTR!=0) BREAK#                     No new odr but old exists        GT03 182
IF(NX<MQ) NX=MIN0(MQ,NX+50*MARK)#      Expand odr limits                GT03 183
ELSE IF(NONR<NODR) NONR=NONR+1#        Include nonrestr odrs            GT03 184
ELSE iquit:(GT0310)#                   No odr.......gt0310              GT03 185
NEXT#                                  Try for new odr                  GT03 186
#                                                                       GT03 187
100 CONTINUE#                          Branch point for new odr         GT03 188
NSTR=MAX0(NSTR,NODR)#                  Update start set counter         GT03 189
NEW=IODR#                              Indicate new gen found           GT03 190
FOR(I=1;I<=NODR;I=I+1)#                Loop over odr's                  GT03 191
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GT03 192
J=ISTR(I);    K=iprc:(J)#              Extract gen addresses            GT03 193
IF(alt:(J)>1.) L=NINT(alt:(J))-360#    Get existing phase               GT03 194
ELSE IF(K==1)  L=45#                   Else set non-restr. phase        GT03 195
ELSE           L=PRC(K)#               Else set restr. phase            GT03 196
JPH(I)=L#                              Store current odr phases         GT03 197
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GT03 198
BREAK#                                 Exit after new odr set           GT03 199
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GT03 200
#                                                                       GT03 201
#    TEST IF EDR STARTER REQUIRED                                       GT03 202
#    ----------------------------                                       GT03 203
#                                                                       GT03 204
IF((NANT>0)&(NEW==IODR))#              Is edr needed for new odr        GT03 205
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GT03 206
NEW=no:#                               Reset flag for edr               GT03 207
REPEAT#                                Loop over starting set           GT03 208
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GT03 209
FOR(N=M1;N<NR;N=N+MARK)#               Loop over reduced genlist        GT03 210
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GT03 211
NG=ipnt:(N)#                           Sort order & start status        GT03 212
IF(NG>NY) NEXT#                        Skip generator if > limit        GT03 213
IF((sta:>NOSP)&(ista:!=IEDR)) NEXT#    Skip assigned starters           GT03 214
IF(NANT!=MIN0(2,iprc:)) NEXT#          Ignore if wrong restr type       GT03 215
gethkl:(NG+2,H);   L=0;   M=0#         Extract si vectors               GT03 216
FOR(I=1;I<=NODR;I=I+1)#                Loop over odr's                  GT03 217
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GT03 218
A=H(1)*Q(I)+H(2)*Q(I+3)+H(3)*Q(I+6)#   Find linear dependence           GT03 219
L=L+NINT(A)*IDET*JPH(I)#               Sum odr restricted phases        GT03 220
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GT03 221
IF(NANT==2)#                           Is restricted edr needed         GT03 222
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GT03 223
J=iprc:;    JEDR=PRC(J)#               Extract restr. phi of edr        GT03 224
M=MOD(L+360000,360)-JEDR#              Calc diff with edr restr         GT03 225
M=MIN0(IABS(M),M+180,IABS(M-180)$#     Find smallest difference         GT03 226
,      M+360,IABS(M-360))#             Find smallest difference         GT03 227
IF(M<30) NEXT#                         Skip if difference < 30          GT03 228
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GT03 229
ELSE JEDR=MOD(L+360045,360)#           Set unrestricted edr phase       GT03 230
IF((M==90)\(NANT==1)) LEDR=180#        Pi permute if pi/1 diff          GT03 231
ELSE                  LEDR=360#        2pi permute range if <           GT03 232
IF(alt:>1.) JEDR=NINT(alt:)-360#       Use input phi if available       GT03 233
NSTR=MAX0(NT,NSTR)#                    Update start set counter         GT03 234
ISTR(NT)=NG#                           Store gen addr of new start      GT03 235
JPH(NT)=JEDR#                          Store edr phase value            GT03 236
NEW=IODR#                              Identify as new set              GT03 237
GO TO 200#                             Exit search loop                 GT03 238
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GT03 239
IF(ISTR(NT)==0)#                       Test if edr ever found           GT03 240
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GT03 241
IF(NY<MQ) NY=MIN0(MQ,NY+50*MARK)#      Expand edr limits                GT03 242
ELSE IF(NANT==2)#                      Test if restricted edr           GT03 243
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GT03 244
NANT=1#                                Set edr as nonrestricted         GT03 245
NY=M1+NSEL*MARK#                       Reset edr gen limits             GT03 246
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GT03 247
ELSE        iquit:(GT0320)#            No edr........gt0320             GT03 248
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GT03 249
ELSE BREAK#                            Old odr/edr set exists           GT03 250
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GT03 251
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GT03 252
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GT03 253
#                                                                       GT03 254
#    TEST IF PERMUTE STARTER REQUIRED                                   GT03 255
#    --------------------------------                                   GT03 256
#                                                                       GT03 257
ELSE#                                  Else new permute required        GT03 258
FOR(N=M1;N<NR;N=N+MARK)#               Loop over reduced gen list       GT03 259
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 GT03 260
NG=ipnt:(N)#                           Get order and status             GT03 261
IF(sta:>NOSP) NEXT#                    Skip assigned starters           GT03 262
NSTR=MAX0(NS,NSTR)#                    Update start set counter         GT03 263
ISTR(NS)=NG#                           Insert new permute addr          GT03 264
NEW=IPER#                              Indicate new start found         GT03 265
K=iprc:#                               Get phase restriction code       GT03 266
IF(alt:>1.)    L=NINT(alt:)-360#       Get existing phase               GT03 267
ELSE IF(K==1)  L=45#                   Else set non-restr. phase        GT03 268
ELSE           L=PRC(K)#               Else set restr. phase            GT03 269
JPH(NS)=L#                             Store permute start phase        GT03 270
BREAK#                                 Exit if new start found          GT03 271
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 GT03 272
#                                                                       GT03 273
#   IF NO REPLACEMENT START FOUND - SAVE CURRENT                        GT03 274
#   --------------------------------------------                        GT03 275
#                                                                       GT03 276
200 CONTINUE#                          Odr/edr breakpoint               GT03 277
IF(NEW==no:)#                          Test if cull needed              GT03 278
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 GT03 279
DO I=1,NT#                             Loop over start update           GT03 280
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 GT03 281
J=I+NS-1;   K=IRST(J)#                 Get start refln addr             GT03 282
IF(K>0)#                               Test if addr already set         GT03 283
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 GT03 284
ISTR(J)=0#                             Switch off starter forever       GT03 285
intunpak:(pak:(K),L,19,3)#             Extract assign mode              GT03 286
IF(L>0) NEXT#                          Skip if already assigned         GT03 287
L=ista:(K)#                            Extract starting status          GT03 288
sma:(K)=sma:(K)+BIAS(L)#               Mark as assured starter          GT03 289
intpak:(KPH(J),pak:(K), 0, 9)#         Store start phase                GT03 290
intpak:(FIX(L),pak:(K), 9, 6)#         Store iteration fix              GT03 291
intpak:(0     ,pak:(K),15, 4)#         Zero permute pointer             GT03 292
intpak:(3     ,pak:(K),19, 3)#         Store assign mode                GT03 293
intpak:(16    ,pak:(K),25,bitlen:(25))# Store start weight as 1.        GT03 294
IF((L==IPER)\((L==IEDR)&(KPH(J)!=90)))# Test if permute start           GT03 295
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 GT03 296
NPER=NPER+1#                           Count number of permutes         GT03 297
IF(NPER>10) iquit:(GT0325)#            Exceed array......gt0325         GT03 298
intpak:(NPER,pak:(K),15, 4)#           Store permute pointer            GT03 299
N=MIN0(2,iprc:(K))#                    Resolve restr/norestr            GT03 300
PERN(NPER)=K#                          Store gen addr                   GT03 301
PERI(NPER)=PERS(N)#                    Store permute increment          GT03 302
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 GT03 303
NEXT#                                  Skip to next start               GT03 304
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 GT03 305
ELSE MSTR=MSTR-1#                      Reduce required starters         GT03 306
IF(MSTR<NODR) iquit:(GT0330)#          Min set......gt0330              GT03 307
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 GT03 308
NR=NR+MARK#                            Compensate reverse count         GT03 309
NEXT#                                  Repeat pass without cull         GT03 310
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 GT03 311
#                                                                       GT03 312
#    NEW START FOUND - PREPARE TO CULL CURRENT                          GT03 313
#    -----------------------------------------                          GT03 314
#                                                                       GT03 315
ELSE#                                  Else new start found             GT03 316
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 GT03 317
DO I=1,NT#                             Loop over old starts             GT03 318
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 GT03 319
J=I+NS-1;   K=IRST(J)#                 Get addr of previous start       GT03 320
IF(K>0) sta:(K)=NOS#                   Return to non-starter            GT03 321
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 GT03 322
DO I=1,NT#                             Loop over new starts             GT03 323
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 GT03 324
J=I+NS-1;   K=ISTR(J)#                 Point to start lists             GT03 325
IRST(J)=K;     KPH(J)=JPH(J)#          Store as current addr & phi      GT03 326
IF((NEW==IODR)&(I==NODR+1)) sta:(K)=EDR# Store edr start status         GT03 327
ELSE                        sta:(K)=FLOAT(NEW)# Store non-edr status    GT03 328
IF(K==NCUL) NCUL=0#                    Reset cull if start              GT03 329
#                                                                       GT03 330
IF(IDMP(1)==0) NEXT#                   Skip if no dump request          GT03 331
BUFOT(1)=FLOAT((K-M1)/MARK+1)#         Get generator number             GT03 332
II=ista:(K)*3-2#                       Point to start status            GT03 333
movechar:(GT2,II,GT4,22,3,0)#          Insert start status              GT03 334
ncodefld:(BUFOT,1,GT4,FM(8),1)#        Format ngen                      GT03 335
movechar:(GT4,1,CHROT,48,NGT4,0)#      Move to op buffer                GT03 336
writeline:(0,GT1,NGT1,1,3)#            Print start selection            GT03 337
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 GT03 338
IF(NCUL==0) NEXT#                      Skip if cull cancelled           GT03 339
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 GT03 340
#                                                                       GT03 341
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT03 342
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT03 343
#                                                                       GT03 344
#   CULL GENERATOR & REDUCE ALPHA SUMS                                  GT03 345
#   ----------------------------------                                  GT03 346
#                                                                       GT03 347
N1=(NCUL-M1)/MARK+1#                   Extract generator number         GT03 348
NS=(NR  -M1)/MARK+1#                   Get cull sequence number         GT03 349
#                                                                       GT03 350
IF(IDMP(1)>0)#                         Test if dump requested           GT03 351
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 GT03 352
gethkl:(NCUL+1,BUFOT)#                 Extract h,k,l                    GT03 353
BUFOT(4)=FLOAT(NS)#                    Store sequence number            GT03 354
BUFOT(5)=FLOAT(N1)#                    Store generator number           GT03 355
BUFOT(6)=ABS(evl:(NCUL))#              Store /e/                        GT03 356
BUFOT(7)=ABS(sma:(NCUL))#              Store sum w*alpha                GT03 357
II=ista:(NCUL)*3-2#                    Point to start status            GT03 358
movechar:(GT2,II,CHROT,35,3,0)#        Insert start status              GT03 359
ncodefld:(BUFOT,1,CHROT,FM,7)#         Format above items               GT03 360
writeline:(0,GT1,NGT1,1,3)#            Print above items                GT03 361
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 GT03 362
#                                                                       GT03 363
pnt:(NR)=FLOAT(NCUL)#                  Gen address reverse order        GT03 364
evl:(NCUL)=-ABS(evl:(NCUL))#           Disable culled generator         GT03 365
sma:(NCUL)=-ABS(sma:(NCUL))#           Disable culled generator         GT03 366
#                                                                       GT03 367
TOP=itop:(NCUL)#                       Get top/recn for si block        GT03 368
BOT=ibot:(NCUL)#                       Get bot/blen for si block        GT03 369
FOR(M=TOP;M<BOT;M=M+4)#                Loop over invariant block        GT03 370
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 GT03 371
intunpak:(QX(M+1),IT, 0, 2)#           Extract invariant type           GT03 372
IF(IT==NEGQ) NEXT#                     Ignore negative quartets         GT03 373
IF(IT==ISEL) NEXT#                     Ignore specified invariants      GT03 374
intunpak:(QX(M+1),IA,25, 7)#           Extract a*8                      GT03 375
intunpak:(QX(M+1),IB,18, 7)#           Extract expectf*64               GT03 376
AW=FLOAT(IA*IB)#                       Convert to real                  GT03 377
N2=NINT(QX(M+2))#                      Extract n2 genlist address       GT03 378
IF(evl:(N2)>0.) sma:(N2)=sma:(N2)-AW#  Reduce n2 sum alpha              GT03 379
N3=NINT(QX(M+3))#                      Extract n3 genlist address       GT03 380
IF(evl:(N3)>0.) sma:(N3)=sma:(N3)-AW#  Reduce n3 sum alpha              GT03 381
IF(IT==TRIP) NEXT#                     Skip to next if triplet          GT03 382
N4=NINT(QX(M+4))#                      Extract n4 genlist address       GT03 383
IF(evl:(N4)>0.) sma:(N4)=sma:(N4)-AW#  Reduce n4 sum alpha              GT03 384
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 GT03 385
#                                                                       GT03 386
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT03 387
#                                                                       GT03 388
RETURN#                                                                 GT03 389
END#                                                                    GT03 390
systemheader:(GT04)#                   Sort s.i. from phase path        GT04   1
####################################################################    GT04   2
#                                                                  #    GT04   3
#                             GT04                                 #    GT04   4
#                                                                  #    GT04   5
####################################################################    GT04   6
SUBROUTINE GT04#                       S.r.hall  jun 81                 GT04   7
include:(AACOMN)#                                                       GT04   8
include:(GTCOMN)#                                                       GT04   9
#                                                                       GT04  10
INTEGER I,J,K,L,M,N,IT,IZ,IL#                                           GT04  11
INTEGER NCON,TCON,GCON,MCON,NWGT,TEM#                                   GT04  12
INTEGER IA,LREC,MCUT,NBIAS,NG,NI,NN,NT,N1,N2,N3,N4#                     GT04  13
INTEGER TEST(4),BEST(4)#                                                GT04  14
INTEGER IN(4)#                                                          GT04  15
REAL A,B,NOSP,ODRP,QIQI,SETP#          Gt04                             GT04  16
#                                                                       GT04  17
chardata:(GT1,[  NSEQ  NGEN  CONGEN  CONINV  SUMWGT  (1)*(3)$#          GT04  18
   *** MAXEXT PHASE   ***])#                                            GT04  19
chardata:(GT2, **********MAXEXT DUMP IN MAXCON ORDER)#                  GT04  20
intdata:(ISGN,[0,1,2,3,4,5,6,7,0,2,1,3,4,6,5,7,0,4,2,6,1,5,3,7])#       GT04  21
intdata:(PRC,[45,180,30,45,60,90,120,135,150,180])#                     GT04  22
intdata:(MAGM,[0,1,2,3,5,8,13,21,34,55,89])#                            GT04  23
intdata:(MAGN,[1,4,12,20,32,50,80,128,206,332,536])#                    GT04  24
realdata:(FM,[50413.,110413.,190713.,270713.,350713.,440713.])#         GT04  25
intdata:(IS,0)#                                                         GT04  26
datastuff:#                                                             GT04  27
#                                                                       GT04  28
#   STORE PHASE PATH SEQUENCE & COUNT STARTERS                          GT04  29
#   ------------------------------------------                          GT04  30
#                                                                       GT04  31
NOSP=NOS+.5; ODRP=ODR+.5; SETP=SET+.5# Set nop & odr flags              GT04  32
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT04  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT04  34
I=ipnt:#                               Extract phase path order         GT04  35
seq:(I)=FLOAT(NG)#                     Store path sequence              GT04  36
pnt:   =FLOAT(NG)#                     Reset to /e/ order               GT04  37
evl:   =ABS(evl:)#                     Reset start flag                 GT04  38
IF(sta:<NOSP) NEXT#                    Ignore non-starters              GT04  39
IF(sta:>SETP) IS=IS+1#                 Count suppressed reflns          GT04  40
ELSE evl:=-evl:#                       Flag start generators            GT04  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT04  42
#                                                                       GT04  43
#     COUNT PERMUTED PHASE SETS                                         GT04  44
#     -------------------------                                         GT04  45
#                                                                       GT04  46
NPST=1;   NMAG=1#                      Initialize phase set cnt         GT04  47
FOR(I=1;I<=NPER;I=I+1)#                Loop over permuted phases        GT04  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT04  49
J=PERN(I);    K=iseq:(J)#              Extract generator addr           GT04  50
PERN(I)=K#                             Restore in new order             GT04  51
IF((TYPE==2)&(PERI(I)<180)) NMAG=NMAG+1# If nonrestr & magic flag       GT04  52
ELSE IF(ista:(J)==IEDR)#               Test if edr permute              GT04  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT04  54
PERN(I)=-K#                            Flag as limited permute          GT04  55
NPST=NPST*LEDR/PERI(I)#                Calc permutes for edr            GT04  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT04  57
ELSE NPST=NPST*360/PERI(I)#            Calculate other permutes         GT04  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT04  59
NSEL=MIN0(NSEL,NGEN)#                  Ensure select < genlist          GT04  60
NCUT=M1+NSEL*MARK#                     Sel start phase maximum          GT04  61
MCUT=M1+NSEL*MARK/2#                   Set prelim cutoff                GT04  62
TCON=NINT(FLOAT(NSEL)*.75)#            Calc start connect limit         GT04  63
NSEL=NSEL-IS#                          Allow for suppressed gens        GT04  64
IF(INPH==0) NLIM=M1+NSTR*MARK#         Set addr of highest starter      GT04  65
ELSE        NLIM=NCUT#                 Set limit if phis input          GT04  66
#                                                                       GT04  67
#   REORDER GENERATOR LIST IN PHASE PATH ORDER                          GT04  68
#   ------------------------------------------                          GT04  69
#                                                                       GT04  70
IS=QXSTR#                              Use buff for sort swap           GT04  71
FOR(N1=M1;N1<MQ;N1=N1+MARK)#           Loop over generator list         GT04  72
FOR(NG=N1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT04  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT04  74
IF(iseq:!=N1) NEXT#                                                     GT04  75
movereal:(QX,NG+1,QX,IS+1,MARK,1)#     Swap selected gen to buffer      GT04  76
movereal:(QX,N1+1,QX,NG+1,MARK,1)#     Swap running  gen to slot        GT04  77
movereal:(QX,IS+1,QX,N1+1,MARK,1)#     Swap selected gen to top         GT04  78
BREAK#                                 Exit after transfer of gen       GT04  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT04  80
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over genlist                GT04  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GT04  82
I=ipnt:;   seq:(I)=FLOAT(NG)#          Point to original order          GT04  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GT04  84
#                                                                       GT04  85
#   ACCESS SI DATA, SORT AND OUTPUT                                     GT04  86
#   -------------------------------                                     GT04  87
#                                                                       GT04  88
IOMARK(8)=M2;  TEM=M2;  IZ=M1#         Reset ra file parameters         GT04  89
SUMR=0.;   NBIAS=MG-M1+1#              Zero sum random alpha            GT04  90
#                                                                       GT04  91
FOR(NG=M1;NG<MG;NG=NG+MARK)#           Loop ordered gen list            GT04  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GT04  93
TOP=itop:;   BOT=ibot:#                Get top/bot of si block          GT04  94
B=0.#                                  Zero random alpha term           GT04  95
#                                                                       GT04  96
FOR(M=TOP;M<BOT;M=M+4)#                Loop over invariant block        GT04  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GT04  98
IN(2)=NINT(QX(M+2))#                   Extract in(2) genlist addres     GT04  99
IN(3)=NINT(QX(M+3))#                   Extract in(3) genlist addres     GT04 100
IN(4)=NINT(QX(M+4))#                   Extract in(4) genlist addres     GT04 101
intunpak:(QX(M+1),IT, 0, 2)#           Extract invariant type           GT04 102
intunpak:(QX(M+1),IS, 2, 3)#           Extract phi sign code            GT04 103
IF(IT<POSQ) L=3;   ELSE L=4#           Set order of invariant           GT04 104
DO I=2,L#                              Loop over si generators          GT04 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GT04 106
J=IN(I);  IN(I)=iseq:(J)#              Replace with new sort order      GT04 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GT04 108
IF(IT==NEGQ) IN(2)=IN(2)+NBIAS#        For neq q4 bias n2 addr          GT04 109
J=MAX0(IN(2),IN(3),IN(4))#             Find largest address             GT04 110
DO I=2,L#                              Loop over last generators        GT04 111
IF(IN(I)==J) BREAK#                    Find which is largest            GT04 112
IN(I)=IN(2);  IN(2)=J#                 Swap gein(2) with largest        GT04 113
IS=IS+I*8-15;  IS=ISGN(IS)#            Adjust phi sign codes            GT04 114
intpak:(IS,QX(M+1), 2, 3)#             Pack sign code  bits  4- 2       GT04 115
QX(M+2)=FLOAT(IN(2))#                  Store reordered n2               GT04 116
QX(M+3)=FLOAT(IN(3))#                  Store reordered n3               GT04 117
QX(M+4)=FLOAT(IN(4))#                  Store reordered n4               GT04 118
#                                                                       GT04 119
IF(IT==NEGQ) NEXT#                     Skip negative quartets           GT04 120
intunpak:(QX(M+1),IA,25,7)#            Extract a *8 of si               GT04 121
B=B+FLOAT(IA)**2#                      Sum a**2 *64                     GT04 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GT04 123
#                                                                       GT04 124
IF(NG<MQ) SUMR=SUMR+SQRT(B)/8.#        If not psi0 sum random al        GT04 125
#                                                                       GT04 126
#                                       ******** sort si block incr n2  GT04 127
FOR(M=TOP+2;M<BOT;M=M+4)#              Loop over invariant block        GT04 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GT04 129
A=QX(M);               I=M#            Reset sort value/pointer         GT04 130
FOR(L=M+4;L<BOT;L=L+4)#                Loop over reduced si block       GT04 131
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GT04 132
IF(QX(L)>=A) NEXT#                     Find smallest n2                 GT04 133
A=QX(L);               I=L#            Store smaller & pointer          GT04 134
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GT04 135
movepakwd:(QX(M-1),A)#                 Store packed word                GT04 136
movepakwd:(QX(I-1),QX(M-1))#           Store packed word                GT04 137
movepakwd:(A,QX(I-1))#                 Store packed word                GT04 138
swap:(QX(M  ),QX(I  ))#                Swap invariant n2                GT04 139
swap:(QX(M+1),QX(I+1))#                Swap invariant n3                GT04 140
swap:(QX(M+2),QX(I+2))#                Swap invariant n4                GT04 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GT04 142
#                                                                       GT04 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GT04 144
#                                                                       GT04 145
#                                                                       GT04 146
#   LOOP OVER REQUIRED STARTERS                                         GT04 147
#   ===========================                                         GT04 148
#                                                                       GT04 149
NSTR=0#                                Reset number of starters         GT04 150
IF(INPH==0&TYPE>0)#                    If phases to be selected         GT04 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GT04 152
IF(IDMP(1)>0) writeline:(1,GT2,NGT2,3,3)# Print dump header             GT04 153
#                                                                       GT04 154
REPEAT#                                Loop over selected per phis      GT04 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GT04 156
DO I=1,4;   BEST(I)=0#                 Initialize test storage          GT04 157
ncodefld:(FLOAT(NSTR+1),1,GT1,660213.,1)# Insert maxext number          GT04 158
IF(IDMP(1)>0) writeline:(1,GT1,NGT1,3,3)# Force new header              GT04 159
NN=0#                                  Zero generator counter           GT04 160
#                                                                       GT04 161
#                                        ****** select test starters    GT04 162
FOR(NT=M1;NT<NCUT;NT=NT+MARK)#         Loop over genlist                GT04 163
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GT04 164
NN=NN+1#                               Count generators                 GT04 165
IF(sta:(NT)>NOSP) NEXT#                Skip assigned starters           GT04 166
evl:(NT)=-evl:(NT)#                    Set as trial starter             GT04 167
N1=0; GCON=0; NCON=0; NWGT=0; LREC=0#  Reset start parameters           GT04 168
#                                                                       GT04 169
#                                        ******* find start connects    GT04 170
FOR(NG=M1;NG<NCUT;NG=NG+MARK)#         Loop genlist to nsel             GT04 171
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GT04 172
N1=N1+1#                               Count generator number           GT04 173
TOP=itop:;    BOT=ibot:#               Get si block limits              GT04 174
IF(sta:>SETP) NEXT#                    Skip suppressed gens             GT04 175
MCON=0#                                Reset gen connect counter        GT04 176
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        GT04 177
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GT04 178
intunpak:(QX(NI+1),IT, 0, 2)#          Extract invariant type           GT04 179
IF(IT==NEGQ) BREAK#                    Exit block if neq quartet        GT04 180
IF(IT==ISEL) NEXT#                     Use s.i. allowed for test        GT04 181
N2=NINT(QX(NI+2))#                     Extract n2 generator address     GT04 182
IF(N2>NCUT) BREAK#                     Exit if beyond test limit        GT04 183
IF(evl:(N2)>0.) NEXT#                  Skip if n2 gen not connected     GT04 184
N3=NINT(QX(NI+3))#                     Extract n3 generator address     GT04 185
IF(evl:(N3)>0.) NEXT#                  Skip if n3 gen unconnected       GT04 186
IF(IT!=TRIP)#                          For quartet invariants           GT04 187
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GT04 188
N4=NINT(QX(NI+4))#                     Extract n4 generator address     GT04 189
IF(evl:(N4)>0.) NEXT#                  Skip if n4 gen unconnected       GT04 190
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GT04 191
MCON=MCON+1#                           Sum number of connects           GT04 192
IF(NTES==1) BREAK#                     Exit if gen count only           GT04 193
IF(NTES==2) NEXT#                      Skip weights if inv count        GT04 194
intunpak:(QX(NI+1),IS,25, 7)#          Extract a*8 from s.i.            GT04 195
NWGT=NWGT+IS#                          Sum w*alpha of s.i.              GT04 196
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GT04 197
#                                                                       GT04 198
IF(MCON==0) NEXT#                      Ignore phi if no connects        GT04 199
IF(sta:<NOSP) evl:=-ABS(evl:)#         Flag gen as temp starter         GT04 200
GCON=GCON+1#                           Count connected generators       GT04 201
NCON=NCON+MCON#                        Count total connects             GT04 202
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GT04 203
TEST(1)=GCON;       TEST(2)=NCON#      Store gen & total connects       GT04 204
TEST(3)=NWGT;       TEST(4)=NWGT*GCON# Store w*alpha & product          GT04 205
IF(TEST(NTES)>BEST(NTES))#             Apply specified start test       GT04 206
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GT04 207
DO I=1,4;  BEST(I)=TEST(I)#            Transfer test results            GT04 208
IL=NT#                                 Store generator address          GT04 209
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GT04 210
IF((NT>MCUT)&(BEST(1)>TCON)) BREAK#    If prelim test ok exit           GT04 211
#                                                                       GT04 212
#                                       *******reset temp start phis    GT04 213
FOR(NG=M1;NG<NCUT;NG=NG+MARK)#         Loop genlist to first cutoff     GT04 214
IF(sta:<NOSP) evl:=ABS(evl:)#          Reset trial start flags          GT04 215
#                                                                       GT04 216
IF(IDMP(1)==0) NEXT#                   Skip if no dump                  GT04 217
BUFOT(1)=FLOAT(NN)#                    Store sequence number            GT04 218
BUFOT(2)=FLOAT((ipnt:(NT)-M1)/MARK+1)# Store generator number           GT04 219
DO I=1,4; BUFOT(I+2)=FLOAT(TEST(I))#   Float test values                GT04 220
IF(IL==NT) movechar:(GT1,49,CHROT,46,3,0)# Insert *** if top            GT04 221
ncodefld:(BUFOT,1,CHROT,FM,6)#         Format op items                  GT04 222
writeline:(0,GT1,NGT1,1,3)#            Print maxext dump                GT04 223
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GT04 224
#                                                                       GT04 225
#    ASSIGN NEW STARTING PHASE IF FOUND                                 GT04 226
#    ----------------------------------                                 GT04 227
#                                                                       GT04 228
IF((BEST(NTES)==0)\(NPER+1>10)) BREAK# Exit if no start or limit        GT04 229
NPER=NPER+1#                           Count new permute phase          GT04 230
NSTR=NSTR+1#                           Count new starting phase         GT04 231
sta:(IL)=PER#                          Flag generator as permute        GT04 232
evl:(IL)=-evl:(IL)#                    Flag as assigned start           GT04 233
NLIM=MAX0(NLIM,IL)#                    Set addr of highest starter      GT04 234
I=iprc:(IL)#                           Extract phi restriction          GT04 235
J=MIN0(2,I)#                           Resolve restr/norestr            GT04 236
PERN(NPER)=IL#                         Store addr of permute gen        GT04 237
PERI(NPER)=PERS(J)#                    Set permute pers from restr      GT04 238
intunpak:(pak:(IL),N,0,9)#             Extract refined phase            GT04 239
IF(N==0)#                              If no refined phase              GT04 240
intpak:(PRC(I),pak:(IL), 0, 9)#        Store start phase                GT04 241
intpak:(FIX(4),pak:(IL), 9, 6)#        Store iteration fix              GT04 242
intpak:(NPER  ,pak:(IL),15, 4)#        Store permute pointer            GT04 243
intpak:(4     ,pak:(IL),19, 3)#        Store assign mode                GT04 244
intpak:(16    ,pak:(IL),25,bitlen:(25))# Store weight (=1.*16)          GT04 245
IF((TYPE==2)&(I==1)) NMAG=NMAG+1#      If nonrestr & magic flag         GT04 246
ELSE NPST=NPST*360/PERS(J)#            Calc num permute phase set       GT04 247
IF(NPST*MAGN(NMAG)>=MXPS) BREAK#       Exit if set limit reached        GT04 248
IF(NSTR<MSEL) NEXT#                    Force new start if requested     GT04 249
IF(BEST(1)>=NSEL) BREAK#               Exit if selects connect          GT04 250
IF(BEST(1)>TCON) BREAK#                Exit if connects enough          GT04 251
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GT04 252
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GT04 253
NSTR=BEST(1)#                          Store max connects for gt05      GT04 254
M=1;  N=2*MAGM(NMAG)#                  Set count & last magic int       GT04 255
IF(NMAG>1)#                            Test if any magic integers       GT04 256
FOR(I=1;I<=NPER;I=I+1)#                Loop over permutes               GT04 257
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GT04 258
IF((TYPE<2)\(PERI(I)>179)) NEXT#       Test if restr or perm phi        GT04 259
M=M+1#                                 Count magic integers             GT04 260
PERI(I)=-(N-MAGM(M))#                  Store magic integer              GT04 261
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GT04 262
NMAG=MAGN(NMAG);   M=1#                Store magic permutes             GT04 263
NPST=NPST*NMAG#                        Total permutes                   GT04 264
IF(TYPE==0) NPST=MAX0(NPST,MXPS)#      Set max phi sets if random       GT04 265
IF(IDMP(1)>0) writeline:(1,GT2,NGT2,3,3)# Print dump header             GT04 266
#                                                                       GT04 267
RETURN#                                                                 GT04 268
END#                                                                    GT04 269
systemheader:(GT05)#                   List control/start/refine        GT05   1
####################################################################    GT05   2
#                                                                  #    GT05   3
#                             GT05                                 #    GT05   4
#                                                                  #    GT05   5
####################################################################    GT05   6
SUBROUTINE GT05#                       S.r.hall  jun 81                 GT05   7
include:(AACOMN)#                                                       GT05   8
include:(GTCOMN)#                                                       GT05   9
#                                                                       GT05  10
INTEGER I,K,L,M,N,IP,IX,NG#                                             GT05  11
REAL A,B,C,D#                                                           GT05  12
chardata:(GT1, GENTAN CONTROL PARAMETERS)#                              GT05  13
chardata:(GT2, PROCESS BDF DATA SET NUMBER      )#                      GT05  14
chardata:(GT3, GENERATOR |E|-TYPE |E|-MIN     E        )#               GT05  15
chardata:(GT4, NUMBER OF GENERATORS PHASED       )#                     GT05  16
chardata:(GT5, FRAGMENT PSI TO BE APPLIED         )#                    GT05  17
chardata:(GT6, NUMBER OF TRIPLETS ENTERED          AMIN=     )#         GT05  18
chardata:(GT7, NUMBER OF QUARTETS ENTERED          BMIN=     )#         GT05  19
chardata:(GT8,[ POSITIVE QUARTETS (PQ4)             XVSM>     ])#       GT05  20
chardata:(GT9,[ NEGATIVE QUARTETS (NQ4)             XVSM<     ])#       GT05  21
chardata:(GT10,[ NQ4 USED ONLY IN FOM, PSI=         ])#                 GT05  22
chardata:(GT11,NO YES-T3 + PQ4PQ4 ONLYT3 ONLY )#                        GT05  23
chardata:(GT12, REDUCE A AND B VALUES BY          SIGMA)#               GT05  24
chardata:(GT13, MAX ALLOWED TRIPLETS/GENER        )#                    GT05  25
chardata:(GT14, MAX ALLOWED QUARTETS/GENER        )#                    GT05  26
chardata:(GT20, STARTING PHASE INFORMATION)#                            GT05  27
chardata:(GT21, INVARIANTS USED IN SELECTION             )#             GT05  28
chardata:(GT22, NR180 30 45 60 90120135150180)#                         GT05  29
chardata:(GT23,ODREDRPERSETNUL)#                                        GT05  30
chardata:(GT24,LINEINBDF FCBDF GTMAXCONMAXEXT)#                         GT05  31
chardata:(GT25, SELECTION OF MAXEXT BASED ON            )#              GT05  32
chardata:(GT26,MAX GENSMAX INVSW*ALPHA MXG*W*AL)#                       GT05  33
chardata:(GT27,  NGEN   H   K   L   |E|  PHI RESTR  TYPE   $#           GT05  34
WGT  FIX   ASSIGNED  PERMUTE)#                                          GT05  35
chardata:(GT28,[ ** BDF PHASES ENTERED IF |E| >        ])#              GT05  36
chardata:(GT29, START SET CONNECTS     OF TOP     SORTED GEN$#          GT05  37
ERATORS IN FIRST PASS)#                                                 GT05  38
chardata:(GT30, MAX PHASE SETS TO BE TESTED         )#                  GT05  39
chardata:(GT31,[ ACCEPT PHASE IF AL**2 MAX >           ])#              GT05  40
chardata:(GT32, REDUCE AL**2 MAX AT RATE OF           )#                GT05  41
chardata:(GT40, PHASE REFINEMENT PARAMETERS)#                           GT05  42
chardata:(GT41, FIX PHASES WHEN BLOCK REFINED  NO)#                     GT05  43
chardata:(GT42,[ TERMINATE IF AL**2 SHIFT <        %])#                 GT05  44
chardata:(GT43,[ PHASE ACCEPTED IF WEIGHT >          ])#                GT05  45
chardata:(GT44, MAXIMUM REFINEMENT CYCLES          )#                   GT05  46
chardata:(GT45, TANGENT PHASING PROCEDURE              )#               GT05  47
chardata:(GT45A, START PHASING PROCEDURE                )#              GT05  48
chardata:(GT46,CASCADEBLOCK  RANDOM )#                                  GT05  49
chardata:(GT46A,RANDOM PERMUTEMAGIC  )#                                 GT05  50
chardata:(GT47, TANGENT WEIGHTING SCHEME       W     )#                 GT05  51
chardata:(GT48,[ EXPECTATION VALUE FORCED >             ])#             GT05  52
chardata:(GT49, START WEIGHT OF RANDOM PHASES          )#               GT05  53
chardata:(GT50,[ NUMBER OF PSI(0) TRIPLETS          ])#                 GT05  54
chardata:(GT51, FIGURE OF MERIT PARAMETERS)#                            GT05  55
chardata:(GT52, OPTIMAL      AND AMOS WEIGHT)#                          GT05  56
chardata:(GT53,RFOMRFACPSI0NEGQ)#                                       GT05  57
chardata:(GT54,[ EXPECTED AVERAGE PHI (APHI)         ])#                GT05  58
realdata:(FMT,[100413.,140413.,180413.,240522.,290313.,#                GT05  59
470512.,520503.,700303.,50413.])#                                       GT05  60
realdata:(FM2,[720512.,770313.])#                                       GT05  61
realdata:(AVPH,[180.,90.,120.,135.,150.,180.,210.,225.,240.,90.])#      GT05  62
datastuff:#                                                             GT05  63
#                                                                       GT05  64
#   PRINT CONTROL PARAMETERS                                            GT05  65
#   ------------------------                                            GT05  66
#                                                                       GT05  67
movechar:(GT11,7,CHROT,2,NGT1-1,2)#    Underline heading in buffer      GT05  68
writeline:(1,GT1,NGT1,2,3)#            Print parameter heading          GT05  69
movechar:(GT46A,TYPE*7+1,GT45A,33,7,0)## How are phases started         GT05  70
writeline:(0,GT45A,NGT45A,3,3)#        Print method of start            GT05  71
movechar:(GT46,MODE*7-6,GT45,33,7,0)#  Insert phase extension mode      GT05  72
writeline:(0,GT45,NGT45,3,3)#          Print calculation mode           GT05  73
ncodefld:(FLOAT(IWGT),1,GT47,340113.,1)# Format weight type             GT05  74
writeline:(0,GT47,NGT47,3,3)#          Print weight type                GT05  75
ncodefld:(DSNM,1,GT2,340413.,1)#       Format data set number           GT05  76
writeline:(0,GT2,NGT2,3,3)#            Print data set number            GT05  77
ncodefld:(ETYP,1,GT3,340113.,1)#       Format /e/-type                  GT05  78
ncodefld:(EMIN,1,GT3,400522.,1)#       Format /e/-min of geners         GT05  79
writeline:(0,GT3,NGT3,3,3)#            Print /e/-type and minim         GT05  80
ncodefld:(FLOAT(NGEN),1,GT4,340413.,1)# Format number of geners         GT05  81
writeline:(0,GT4,NGT4,3,3)#            Print number of generators       GT05  82
ncodefld:(SIGA,1,GT12,340432.,1)#      Format sigma reduce ratio        GT05  83
writeline:(0,GT12,NGT12,3,3)#          Print it                         GT05  84
IF(MINE>.01)#                          Test min expect in force         GT05  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT05  86
ncodefld:(MINE,1,GT48,340422.,1)#      Format min expect value          GT05  87
writeline:(0,GT48,NGT48,3,3)#          Print i1/i0 application          GT05  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT05  89
movechar:(GT11,IQPS*3+1,GT5,33,3,0)#   Insert yes/no for frag psi       GT05  90
writeline:(0,GT5,NGT5,3,3)#            Print frag psi information       GT05  91
IF(NTYP(1)>0)#                         Test if triplets applied         GT05  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT05  93
ncodefld:(MXTG,1,GT13,340413.,1)#      Format max triplets/gen          GT05  94
writeline:(0,GT13,NGT13,3,3)#          Print max t3/gen                 GT05  95
A=FLOAT(NTYP(1))#                      Float number of triplets         GT05  96
ncodefld:(A      ,1,GT6,340413.,1)#    Format number of triplets        GT05  97
ncodefld:(AMIN(1),1,GT6,460412.,1)#    Format a-min of triplets         GT05  98
writeline:(0,GT6,NGT6,3,3)#            Print triplet information        GT05  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT05 100
A=FLOAT(NTYP(3)+NTYP(4))#              Float number nq4 & pq4           GT05 101
IF(A>.1)#                              Test if any quartets             GT05 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT05 103
ncodefld:(MXQG,1,GT14,340413.,1)#      Format max quartets/gen          GT05 104
writeline:(0,GT14,NGT14,3,3)#          Print max pq/gen                 GT05 105
ncodefld:(A      ,1,GT7,340413.,1)#    Format number of quartets        GT05 106
ncodefld:(AMIN(2),1,GT7,460412.,1)#    Format b-min of quartets         GT05 107
writeline:(0,GT7,NGT7,3,3)#            Print quartet information        GT05 108
IF(IXVF<5)#                            Unless negq4 active              GT05 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT05 110
IF(NTYP(3)>0)#                         Test for positive quartets       GT05 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GT05 112
A=FLOAT(NTYP(3))#                      Float number pq4                 GT05 113
ncodefld:(A     ,1,GT8,340413.,1)#     Format numb of pos quartets      GT05 114
ncodefld:(XSHI  ,1,GT8,460412.,1)#     Format upper xvector limit       GT05 115
writeline:(0,GT8,NGT8,3,3)#            Print pos quartet info           GT05 116
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GT05 117
IF(NTYP(4)>0)#                         Test for negative quartets       GT05 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GT05 119
A=FLOAT(NTYP(4))#                      Float number nq4                 GT05 120
ncodefld:(A      ,1,GT9,340413.,1)#    Format num of neg quartets       GT05 121
ncodefld:(XSLO   ,1,GT9,460412.,1)#    Format lower xvector limit       GT05 122
writeline:(0,GT9,NGT9,3,3)#            Print neg quartet info           GT05 123
ncodefld:(FLOAT(NQPS),1,GT10,340413.,1)# Format si used for neg q4      GT05 124
writeline:(0,GT10,NGT10,3,3)#          Print neg q4 psi info            GT05 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GT05 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT05 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT05 128
#                                                                       GT05 129
#    PRINT STARTING PHASE DATA                                          GT05 130
#    -------------------------                                          GT05 131
#                                                                       GT05 132
movechar:(GT11,7,CHROT,2,NGT20-1,1)#   Insert underline in buffer       GT05 133
writeline:(1,GT20,NGT20,2,3)#          Print start phase heading        GT05 134
movechar:(GT11,ISEL*4+16,GT21,34,8,0)# Get string for si selection      GT05 135
writeline:(0,GT21,NGT21,3,3)#          Print si selection info          GT05 136
movechar:(GT26,NTES*8-7,GT25,34,8,0)#  Get string for start test        GT05 137
IF(INPH==0&TYPE>0)#                    If start phases selected         GT05 138
writeline:(0,GT25,NGT25,3,3)#          Print start test used            GT05 139
IF(INPH>0)#                            Test if phases from bdf          GT05 140
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GT05 141
movechar:(GT24,INPH*6+5,GT28,2,2,0)#   Insert bdf type (fc or gt)       GT05 142
ncodefld:(EPAR,1,GT28,360622.,1)#      Format bdf e minimum             GT05 143
writeline:(0,GT28,NGT28,3,3)#          Print bdf phase data             GT05 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GT05 145
#                                                                       GT05 146
LINRM=6;  writeline:(1,GT27,NGT27,1,3)# Print starters heading          GT05 147
B=0.;   C=0.;     D=0.#                Zero sum /e/ & start count       GT05 148
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT05 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GT05 150
N=ista:;  evl:=ABS(evl:)#              Get phase status                 GT05 151
I=iprc:;  C=C+AVPH(I)#                 Sum expected average phi         GT05 152
IF(N==INOS) NEXT#                      Skip all but starters            GT05 153
IF(N<INUL)#                            If starting phase                GT05 154
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GT05 155
B=B+evl:;    D=D+1.#                   Sum /e/s and count               GT05 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GT05 157
intunpak:(pak:,IP, 0, 9)#              Get start phase                  GT05 158
intunpak:(pak:,IX, 9, 6)#              Get iteration fix                GT05 159
intunpak:(pak:,M ,15, 4)#              Get permute pointer              GT05 160
intunpak:(pak:,L ,19, 3)#              Get assign mode                  GT05 161
intunpak:(pak:,K ,25, 7)#              Get start weight*16              GT05 162
intpak:(N,pak:,22, 3)#                 Put status in start word         GT05 163
IF(M>0) M=PERI(M)#                     Get permute increment            GT05 164
gethkl:(NG+1,BUFOT)#                   Extract generator h,k,l          GT05 165
BUFOT(4)=evl:#                         Put /e/-value in buffer          GT05 166
BUFOT(5)=FLOAT(MOD(IP,360))#           Put starting phi in buffer       GT05 167
BUFOT(6)=FLOAT(K)/16.#                 Put start weight in buffer       GT05 168
BUFOT(7)=FLOAT(IX)#                    Put fix iteration in buffer      GT05 169
BUFOT(8)=FLOAT(IABS(M))#               Put permute incr in buffer       GT05 170
BUFOT(9)=FLOAT((ipnt:-M1)/MARK+1)#     Put genlist no. in buffer        GT05 171
ncodefld:(BUFOT,1,CHROT,FMT,9)#        Format output fields             GT05 172
IF(M<0)#                               If magic permute                 GT05 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GT05 174
BUFOT(1)=360./FLOAT(NMAG)#             Store magic delx                 GT05 175
BUFOT(2)=-FLOAT(M)#                    Store magic integer              GT05 176
movechar:(GT28,2,CHROT,74,1,0)#        Insert * character               GT05 177
ncodefld:(BUFOT,1,CHROT,FM2,2)#        Format magic values              GT05 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GT05 179
movechar:(GT22,iprc:*3-2,CHROT,32,3,0)# Move restr alpha to buffer      GT05 180
movechar:(GT23,N*3-5,CHROT,39,3,0)#    Move start status to buffer      GT05 181
movechar:(GT24,L*6+1,CHROT,57,6,0)#    Move assign mode to buffer       GT05 182
writeline:(0,GT27,NGT27,1,3)#          Print starting phase info        GT05 183
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GT05 184
IF(PHIAV<0.)PHIAV=C/FLOAT(NGEN)#       Calc expected av phase       ^   GT05 185
#                                                                       GT05 186
XSHI=1.#                               Set ratio for fom test           GT05 187
IF(INPH==0&TYPE>0)#                    If phases not from bdf           GT05 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GT05 189
ncodefld:(FLOAT(NSTR),1,GT29,230413.,1)# Format max connects            GT05 190
ncodefld:(FLOAT(NSEL),1,GT29,340413.,1)# Format selection number        GT05 191
writeline:(1,GT29,NGT29,3,3)#          Print expected connectivity      GT05 192
IF(NSTR<1) iquit:(GT0505)#             Insufficient start reflns        GT05 193
XSHI=FLOAT(NSEL)/FLOAT(NSTR)#          Ratio for pre fom tests          GT05 194
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GT05 195
IF(TYPE==0)#                           Test if random starters          GT05 196
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GT05 197
ncodefld:(RWGT,1,GT49,340522.,1)#      Format ran start weight          GT05 198
writeline:(0,GT49,NGT49,3,3)#          Print random weight              GT05 199
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GT05 200
ncodefld:(FLOAT(NPST),1,GT30,340413.,1)# Format number phase sets       GT05 201
writeline:(0,GT30,NGT30,3,3)#          Print number phase sets          GT05 202
#                                                                       GT05 203
#   PRINT REFINEMENT PARAMETERS                                         GT05 204
#   ---------------------------                                         GT05 205
#                                                                       GT05 206
movechar:(GT11,7,CHROT,2,NGT40-1,1)#   Underline header                 GT05 207
writeline:(1,GT40,NGT40,2,3)#          Print refinement heading         GT05 208
movechar:(GT11,1,GT41,32,3,0)#                                          GT05 209
IF(IACC>0)movechar:(GT11,4,GT41,32,3,0)# Insert 'yes' in message        GT05 210
writeline:(0,GT41,NGT41,3,3)#          Print phase fix message          GT05 211
#                                                                       GT05 212
ncodefld:(FLOAT(MXIT),1,GT44,340313.,1)# Format maximum iterations      GT05 213
writeline:(0,GT44,NGT44,3,3)#          Print maximum iterations         GT05 214
ifeq:(A2MX,0.)#                        Test if alpha**2 is defined      GT05 215
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GT05 216
A2MX=PFAC*(B/AMAX1(D,1.0))**3#         Calc alpha start max             GT05 217
IF(NTYP(1)==0) A2MX=A2MX*PFAC*B/AMAX1(D,1.)# Adjust if quartets only    GT05 218
A2MX=AMIN1(25.,A2MX**2)#               Calc alpha**2 starting max       GT05 219
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GT05 220
ncodefld:(A2MX,1,GT31,340622.,1)#      Format alpha**2 start max        GT05 221
writeline:(0,GT31,NGT31,3,3)#          Print alpha**2 start max         GT05 222
ncodefld:(RATE,1,GT32,340422.,1)#      Format al**2 reduct rate         GT05 223
writeline:(0,GT32,NGT32,3,3)#          Print al**2 reduct rate          GT05 224
ncodefld:(CONV*100.,1,GT42,340313.,1)# Format convergence limit         GT05 225
writeline:(0,GT42,NGT42,3,3)#          Print convergence limit          GT05 226
ncodefld:(WMIN,1,GT43,340422.,1)#      Format min accept weight         GT05 227
writeline:(0,GT43,NGT43,3,3)#          Print phi accept limit           GT05 228
#                                                                       GT05 229
#   PRINT FOM PARAMETERS                                                GT05 230
#   --------------------                                                GT05 231
#                                                                       GT05 232
movechar:(GT11,7,CHROT,2,NGT51-1,1)#   Insert underline in head         GT05 233
writeline:(1,GT51,NGT51,2,3)#          Print fom header                 GT05 234
A=FLOAT(NTYP(2))#                      Float number of psi0 t3          GT05 235
WFOM(3)=WFOM(3)*AMIN1(A,100.)/100.#    Scale psi0 fom w to count        GT05 236
B=FLOAT(NTYP(4))#                      Float number of neg q4           GT05 237
WFOM(4)=WFOM(4)*AMIN1(B,100.)/100.#    Scale negq fom w ro count        GT05 238
ncodefld:(A,1,GT50,340413.,1)#         Format number psi0 t3            GT05 239
writeline:(0,GT50,NGT50,3,3)#          Print number psi0 t3             GT05 240
DO I=1,4#                              Loop over fom types              GT05 241
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GT05 242
FREJ(I)=2.*FOPT(I)#                    Set fom rejection limits         GT05 243
movechar:(GT52,1,CHROT,1,NGT52,0)#     Put header in buffer             GT05 244
movechar:(GT53,I*4-3,CHROT,10,4,0)#    Put fom type in header           GT05 245
ncodefld:(FOPT,I,CHROT,360422.,1)#     Format fom optimum value         GT05 246
ncodefld:(WFOM,I,CHROT,420422.,1)#     Format fom weight                GT05 247
writeline:(0,0,0,1,3)#                 Print fom weight                 GT05 248
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GT05 249
ncodefld:(PHIAV,1,GT54,360413.,1)#     Format average phi value     ^   GT05 250
writeline:(0,GT54,NGT54,3,3)#          Print average phi value          GT05 251
#                                                                       GT05 252
#    GENERATE SIN/COS TABLE                                             GT05 253
#    ----------------------                                             GT05 254
#                                                                       GT05 255
IF(ICNT==0)#                           Sin/cos if noncentrosymmetri     GT05 256
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GT05 257
FOR(I=M0;I<M1;I=I+1)#                  Loop over degree intervals       GT05 258
QX(I+1)=SIN(FLOAT(I-M0)*.0174532925)#  Sine 0/s/451                     GT05 259
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GT05 260
#                                                                       GT05 261
RETURN#                                                                 GT05 262
END#                                                                    GT05 263
systemheader:(GT06)#                   Cascade extension/refinement     GT06   1
####################################################################    GT06   2
#                                                                  #    GT06   3
#                             GT06                                 #    GT06   4
#                                                                  #    GT06   5
####################################################################    GT06   6
SUBROUTINE GT06#                       S.r.hall  dec 81                 GT06   7
include:(AACOMN)#                                                       GT06   8
include:(GTCOMN)#                                                       GT06   9
#                                                                       GT06  10
INTEGER I,J,K,L,N,IP,IS,NS,NI,NC,IT#                                    GT06  11
INTEGER MLIM,NDIF,NPHI,NINV,IPHI,NCON,MGEN,KGEN#                        GT06  12
INTEGER IA,IB,PERM(10),N1,N2,N3,N4#                                     GT06  13
INTEGER MITR,IDIF,MDIF,MINV,TEST,IFOM#                                  GT06  14
INTEGER  JDMP,KDMP#                                                     GT06  15
INTEGER IREJ,LGEN,LREC,NBIAS,NF,NG#                                     GT06  16
REAL AL2,ANQ4,APHI,PREJ3,SUMD,SUMN#                                     GT06  17
REAL WGT,SSIN,SCOS,SAL2,PSIA,PSIE,SUMX,DELX#                            GT06  18
REAL A,B,SUMA,SUMB,A2TH,DAL2,PHI#                                       GT06  19
REAL SUME,WSUM,WMUL,PREJ1,PREJ2#                                        GT06  20
#                                                                       GT06  21
chardata:(GT1, DUMP OF WEIGHTS   AL2    W1     AL2/AE2    W2)#          GT06  22
chardata:(GT2, **********DUMP OF PHASE SET   )#                         GT06  23
chardata:(GT3,  NSEQ  NGEN   TYPE   PHI   WGT)#                         GT06  24
chardata:(GT4, **********ITERATION CYCLE    NLIM=     AL2TH=       $#   GT06  25
SUMAL2=            )#                                                   GT06  26
chardata:(GT5, GENERATOR      PHI=     WGT=     NGEN=    $#             GT06  27
RSTR=   )#                                                              GT06  28
chardata:(GT6, NINV   PHI2  PHI3  PHI4  QPSI = PHI  DIF   $#            GT06  29
WGT2  WGT3  WGT4   WGT  PROD    N2  N3  N4)#                            GT06  30
chardata:(GT7,                                          $#              GT06  31
NINV=    AL2=      AE2=      AL=      ALE=      )#                      GT06  32
chardata:(GT8,                PHI=     WGT=     DIFF=    $#             GT06  33
RPHI=   )#                                                              GT06  34
chardata:(GT10, PRETEST    RFOM=      RFAC=       SUME=        $#       GT06  35
SUMR=         SUMA=        SUMD=        REJ1=       REJ2=       $#      GT06  36
REJ3=        )#                                                         GT06  37
chardata:(GT11, FINAL      RFOM=      RFAC=       SUME=        $#       GT06  38
SUMR=         SUMA=        SUMD=        PSIA=       PSIE=        $#     GT06  39
PSI0=        )#                                                         GT06  40
chardata:(GT12,   ODREDRPERSETNUL***)#                                  GT06  41
intdata:(NMAP,0);   intdata:(IMAP,0)#                                   GT06  42
realdata:(SOL2,0.);  realdata:(TAL2,0.);  realdata:(RFOM,0.)#           GT06  43
realdata:(RFAC,0.);  realdata:(APSI,0.)#                                GT06  44
intdata:(IS2,[+1,-1,+1,-1,+1,-1,+1,-1])#                                GT06  45
intdata:(IS3,[+1,+1,-1,-1,+1,+1,-1,-1])#                                GT06  46
intdata:(IS4,[+1,+1,+1,+1,-1,-1,-1,-1])#                                GT06  47
intdata:(PRC,[9999,0,30,45,60,90,120,135,150,180])#                     GT06  48
realdata:(WTAB1,[1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,#                        GT06  49
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.])#                         GT06  50
realdata:(WTAB2,[.12,.30,.46,.60,.72,.82,.89,.94,.98,1.0,#              GT06  51
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,#                          GT06  52
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.])#                         GT06  53
realdata:(FM1,[220622.,280622.,400622.,460622.])#                       GT06  54
realdata:(FM2,[50413.,110413.,250413.,310522.])#                        GT06  55
realdata:(FM3,[280213.,380313.,500412.,690912.])#                       GT06  56
realdata:(FM4,[230313.,330422.,420313.,510313.,130313.])#               GT06  57
realdata:(FM5,[50413.,120413.,180413.,240413.,300413.,360413.,#         GT06  58
410403.,480522.,540522.,600522.,660522.,720622.,#                       GT06  59
780403.,820403.,860403.])#                                              GT06  60
realdata:(FM6,[500313.,600512.,700512.,800512.,900512.])#               GT06  61
realdata:(FM7,[110203.,210422.,320422.,470602.,#                        GT06  62
610702.,740702.,870702.,990612.,1110612.,1240712.])#                    GT06  63
datastuff:#                                                             GT06  64
#                                                                       GT06  65
#   INITIALIZE PHASING PARAMETERS                                       GT06  66
#   -----------------------------                                       GT06  67
#                                                                       GT06  68
N4=M1;  NBIAS=MG-M1+1#                 Set dummy n4 for quartets        GT06  69
DAL2=AMIN1(A2MX/25.,1.)#               Calc al**2 incr for wgt          GT06  70
KGEN=MAX0(50,NGEN/4)*MARK#             Set refine block incr            GT06  71
DO I=1,24#                             Loop over weight table           GT06  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT06  73
A=SQRT(FLOAT(I)-.5)/2.#                Get weight increment             GT06  74
B=EXP(A)#                              Get exponential                  GT06  75
IF(ICNT==0) WTAB1(I)=A/2.5#            Calc acentric weight             GT06  76
ELSE        WTAB1(I)=(B-1./B)/(B+1./B)# Calc tanh(b/2) weight           GT06  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT06  78
DO I=1,28#                             For alf ratio > 1.               GT06  79
WTAB2(I+12)=EXP(-FLOAT(I-1)*PFAC)#     Generate weight scheme 2         GT06  80
SUMX=1000.;   DELX=360./FLOAT(NMAG)#   Set magic number intervals       GT06  81
DO I=1,10;  PERM(I)=0#                 Zero permutation array           GT06  82
PREJ1=FREJ(1)*XSHI; PREJ2=FREJ(2)*XSHI# Scale pretest fom limits        GT06  83
PREJ3=2.*PREJ1#                        Set rfom pretest limit           GT06  84
#                                                                       GT06  85
IF(IDMP(2)>0)#                         Test if phase dump request       GT06  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT06  87
writeline:(1,GT1,NGT1,3,3)#            Print weight header              GT06  88
A=DAL2*.5;     B=.05#                  Set initial args                 GT06  89
DO I=1,25#                             Loop over first 25 weightsd      GT06  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT06  91
BUFOT(1)=A;   BUFOT(2)=WTAB1(I)#       Store arg and wgt1               GT06  92
BUFOT(3)=B;   BUFOT(4)=WTAB2(I)#       Store arg and wgt2               GT06  93
ncodefld:(BUFOT,1,CHROT,FM1,4)#        Format above items               GT06  94
writeline:(0,GT1,NGT1,1,3)#            Print top weights                GT06  95
A=A+DAL2;     B=B+.1#                  Incr weight args                 GT06  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT06  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT06  98
#                                                                       GT06  99
#   PHASE SET LOOP                                                      GT06 100
#   --------------                                                      GT06 101
#                                                                       GT06 102
DO NS=1,NPST#                          Loop over phase sets             GT06 103
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT06 104
IF(NS>=NDMP(2)&NS<=MDMP(2)) JDMP=yes:# Switch on dump for pset          GT06 105
ELSE                        JDMP=no:#  Switch off dump                  GT06 106
DO I=3,7#                              Loop over specific dumps         GT06 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GT06 108
IF(JDMP==yes:) IDMP(I)=NDMP(I)#        Switch on specific dumps         GT06 109
ELSE IF(I<6)   IDMP(I)=999999#         Switch off cyc & gen dumps       GT06 110
ELSE           IDMP(I)=0#              Switch off inv & pmap dumps      GT06 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GT06 112
IF(JDMP>0)#                            If phase set dumped              GT06 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GT06 114
ncodefld:(FLOAT(NS),1,GT2,310313.,1)#  Format pset number               GT06 115
writeline:(1,GT2,NGT2,2,3);  LINRM=3#  Print pset header                GT06 116
IF(IDMP(7)>0)#                         Test if pmap dump                GT06 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GT06 118
NMAP=MXIT+2; IMAP=MG-NMAP; I=NMAP*NGEN# Phase map pointers              GT06 119
movereal:(0.,1,QX,MG+1,I,2)#           Zero pmap                        GT06 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GT06 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GT06 122
#                                                                       GT06 123
#   GET STARTING PHASES                                                 GT06 124
#   -------------------                                                 GT06 125
#                                                                       GT06 126
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over gener list             GT06 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GT06 128
phi:=-1.; wgt:=0.#                     Zero phase, weight, iter fix     GT06 129
intunpak:(pak:,K,25, 7)#               Get phase weight                 GT06 130
IF(K>0)#                               Test if starting phase           GT06 131
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GT06 132
intunpak:(pak:,N, 0, 9)#               Get starting phase               GT06 133
phi:=FLOAT(MOD(N,360))#                Reset starting phase             GT06 134
wgt:=FLOAT(K)/16.#                     Reset phase weight               GT06 135
NEXT#                                  Skip to next generator           GT06 136
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GT06 137
IF(TYPE!=0) NEXT#                      Skip if not random starter       GT06 138
SEED=MOD(SEED*25173+13849,65536)#      Generate random number           GT06 139
IPHI=MOD(SEED,360)#                    Convert to random phi 0-359      GT06 140
IF(prc:>1.5)#                          Test if phi restricted           GT06 141
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GT06 142
I=iprc:;  J=PRC(I)#                    Get phi restriction              GT06 143
K=IABS(IPHI-J);  K=MIN0(K,360-K)#      Get smallest difference          GT06 144
IF(K<90) IPHI=J#                       Set as closest restr             GT06 145
ELSE     IPHI=J+180#                   Set as closest restr             GT06 146
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GT06 147
phi:=FLOAT(IPHI)#                      Assign random phase              GT06 148
wgt:=RWGT#                             Assign random weight             GT06 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GT06 150
#                                                                       GT06 151
#                                        ******* permute starters       GT06 152
L=0#                                   Progressive permute flag         GT06 153
IF(NMAG>1)#                            Test if magic starters           GT06 154
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GT06 155
SUMX=SUMX+DELX#                        Incr magic phase constant        GT06 156
IF(SUMX>360.) SUMX=0.1#                Reset initial magic x            GT06 157
ELSE          L=1#                     Disable other permutes           GT06 158
DO I=1,NPER#                           Loop over permutes               GT06 159
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GT06 160
IF(PERI(I)>0) NEXT#                    Skip non-magic permutes          GT06 161
J=PERN(I);  K=IABS(J)#                 Extract genlist pointer          GT06 162
phi:(K)=AMOD(phi:(K)+SUMX*FLOAT(-PERI(I)),360.)# Add permutation        GT06 163
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GT06 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GT06 165
FOR(I=1;I<=NPER;I=I+1)#                Loop over all permutes           GT06 166
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GT06 167
IF(PERI(I)<0) NEXT#                    Skip magic permutes              GT06 168
J=PERN(I);  K=IABS(J)#                 Point to gener list              GT06 169
phi:(K)=AMOD(phi:(K)+FLOAT(PERM(I)),360.)# Add permutation              GT06 170
IF(L==1) NEXT#                         Skip further permutes            GT06 171
PERM(I)=PERM(I)+PERI(I)#               Increment permute phase          GT06 172
IF(((J>0)&(PERM(I)>=360))$#            Test for 2pi permute             GT06 173
\  ((J<0)&(PERM(I)>=LEDR)))PERM(I)=0#  Test for pi permute              GT06 174
ELSE L=1#                              Shutoff further permutes         GT06 175
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GT06 176
#                                                                       GT06 177
IF(NS>=IDMP(3)&NS<=MDMP(3))#           Test for start dump              GT06 178
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over gener list             GT06 179
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GT06 180
IF(phi:<0.) NEXT#                      Skip non-starters                GT06 181
BUFOT(1)=FLOAT((NG   -M1)/MARK+1)#     Get list seq number              GT06 182
BUFOT(2)=FLOAT((ipnt:-M1)/MARK+1)#     Get ngen seq number              GT06 183
BUFOT(3)=phi:#                         Get start phase                  GT06 184
BUFOT(4)=wgt:#                         Get start weight                 GT06 185
N=ista:*3-2#                           Point to start type              GT06 186
movechar:(GT12,N,CHROT,16,3,0)#        Insert start type                GT06 187
ncodefld:(BUFOT,1,CHROT,FM2,4)#        Format above items               GT06 188
writeline:(0,GT3,NGT3,1,3)#            Print start phase                GT06 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GT06 190
#                                                                       GT06 191
#    INITIALIZE PHASE SET PARAMETERS                                    GT06 192
#    -------------------------------                                    GT06 193
#                                                                       GT06 194
A2TH=A2MX#                             Reset al**2 threshold            GT06 195
TEST=-1;    IREJ=0#                    Reset iteration flag             GT06 196
MITR=MXIT#                             Reset iteration limit            GT06 197
MLIM=NLIM#                             Reset genlist penetration        GT06 198
MGEN=NCUT;   LGEN=M1#                  Reset genlist limit              GT06 199
NPHI=0;  IDIF=0;  SAL2=0.#             Reset accumulators               GT06 200
NDIF=0;   MDIF=0;   NINV=0;   MINV=0#  Reset fom accumulators           GT06 201
PSIA=0.;   PSIE=0.;   IFOM=yes:#       Reset fom accumulators           GT06 202
NF=0#                                  Reset iteration fix count        GT06 203
#                                                                       GT06 204
#   ITERATION LOOP                                                      GT06 205
#   --------------                                                      GT06 206
#                                                                       GT06 207
FOR(NC=1;NC<=MITR;NC=NC+1)#            Loop over phasing cycles         GT06 208
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GT06 209
IF(NC>=IDMP(4)&NC<=MDMP(4))#           Test for iteration dump          GT06 210
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GT06 211
BUFOT(1)=FLOAT(NC)#                    Store iteration number:          GT06 212
BUFOT(2)=FLOAT((MGEN-M1)/MARK+1)#      Store penetration limit          GT06 213
BUFOT(3)=A2TH#                         Store alsqd threshold            GT06 214
BUFOT(4)=SAL2#                         Store sum al2                    GT06 215
ncodefld:(BUFOT,1,GT4,FM3,4)#          Format above items               GT06 216
writeline:(1,GT4,NGT4,3,3)#            Print iteration items            GT06 217
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GT06 218
IF(IDMP(7)>0&TEST!=2) IMAP=IMAP+1#     Incr phase map pointer           GT06 219
NF=MAX0(NF,NC)#                        Set iteration fix limit          GT06 220
N1=0;   LREC=0#                        Reset generator count            GT06 221
IF(TEST<2) SOL2=SAL2#                  If not pretest reset old al2     GT06 222
ELSE       TAL2=SAL2#                  Else keep for later              GT06 223
SAL2=0.;  NCON=0#                      Reset al**2 & connects           GT06 224
SUMA=0.;  SUMD=0.;  SUMB=0.#           Reset fom sums                   GT06 225
#                                                                       GT06 226
#    GENERATOR LOOP                                                     GT06 227
#    --------------                                                     GT06 228
#                                                                       GT06 229
FOR(NG=M1;NG<MGEN;NG=NG+MARK)#         Loop over generator list         GT06 230
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GT06 231
N1=N1+1#                               Incr generator count             GT06 232
TOP=itop:;    BOT=ibot:#               Get si block limits              GT06 233
IF((NG<LGEN)&(wgt:>.9)) NEXT#          Skip reliable phi last block     GT06 234
intunpak:(pak:,I,9,6)#                 Extract iter fix-limit           GT06 235
IF((TEST<=0)&(NF<I)) NEXT#             Skip if phase fixed              GT06 236
#                                                                       GT06 237
IF(N1>=IDMP(5)&N1<=MDMP(5))#           Test for generator dump          GT06 238
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GT06 239
J=iprc:;   J=PRC(J)#                   Extract phase restr.             GT06 240
BUFOT(1)=phi:#                         Store current phase              GT06 241
BUFOT(2)=wgt:#                         Store current weight             GT06 242
BUFOT(3)=FLOAT((ipnt:-M1)/MARK+1)#     Point to gener number            GT06 243
BUFOT(4)=FLOAT(J)#                     Store phase restriction          GT06 244
BUFOT(5)=FLOAT(N1)#                    Store generator seq num          GT06 245
ncodefld:(BUFOT,1,GT5,FM4,5)#          Format gener items               GT06 246
writeline:(1,GT5,NGT5,3,3)#            Print gener line                 GT06 247
KDMP=yes:; LINRM=4;  N4=M1#            Set gen dump on                  GT06 248
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GT06 249
ELSE KDMP=no:#                         Switch gen dump off              GT06 250
IF(NG<MQ) IPHI=NINT(phi:)#             Get currnt phi fo test           GT06 251
SSIN=0.; SCOS=0.; SUMN=0.; SUME=0.#    Zero sincos sums                 GT06 252
#                                                                       GT06 253
#   INVARIANT LOOP                                                      GT06 254
#   --------------                                                      GT06 255
#                                                                       GT06 256
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        GT06 257
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GT06 258
N2=NINT(QX(NI+2))#                     Extract n2 genlist address       GT06 259
IF(N2>MLIM) BREAK#                     Exit if beyond limit             GT06 260
IF(N2>MG) N2=N2-NBIAS#                 Adjust n2 for negq4              GT06 261
IF(wgt:(N2)<WMIN) NEXT#                Skip unphased generator          GT06 262
N3=NINT(QX(NI+3))#                     Extract n3 genlist address       GT06 263
IF(wgt:(N3)<WMIN) NEXT#                Skip unphased generator          GT06 264
WMUL=2.*wgt:(N2)*wgt:(N3)#             Product triplet weights          GT06 265
WSUM=wgt:(N2)+wgt:(N3)#                Sum of triplet weights           GT06 266
intunpak:(QX(NI+1),IT, 0, 2)#          Extract invariant type           GT06 267
IF(IT>1)#                              Test if active quartet           GT06 268
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GT06 269
N4=NINT(QX(NI+4))#                     Extract n4 genlist address       GT06 270
IF(wgt:(N4)<WMIN) NEXT#                Skip unphased generator          GT06 271
WMUL=1.5*WMUL*wgt:(N4)#                Product quartet weight           GT06 272
WSUM=WSUM+wgt:(N4)#                    Sum of quartet weights           GT06 273
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GT06 274
WGT=WMUL/WSUM#                         Calculate weight of cos(psi)     GT06 275
intunpak:(QX(NI+1),IP, 9, 9)#          Extract shift-qpsi-negq          GT06 276
intunpak:(QX(NI+1),IA,25, 7)#          Extract modified a*8             GT06 277
A=FLOAT(IA)*WGT*.125#                  Form total inv weight            GT06 278
IF((IWGT>1)\(TEST>0))#                 Test if weight scheme 2 or 3     GT06 279
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GT06 280
intunpak:(QX(NI+1),IB,18, 7)#          Extract probf *64                GT06 281
SUME=SUME+FLOAT(IB)*A#                 Sum weighted a*probf             GT06 282
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GT06 283
IF(ICNT==1)#                           Test if centrosymmetric          GT06 284
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GT06 285
ifne:(phi:(N2),phi:(N3)) A=-A#         Reverse sign if diff =pi         GT06 286
IF(IP>0)                 A=-A#         Reverse sign if shift=pi         GT06 287
IF((IT>1)&(phi:(N4)>.5)) A=-A#         Reverse sign if phi4 =pi         GT06 288
IF(IT!=NEGQ) SCOS=SCOS+A#              Sum tangent denominator          GT06 289
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GT06 290
ELSE#                                  Else phases noncentrosymmetr     GT06 291
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GT06 292
intunpak:(QX(NI+1),IS, 2, 3); IS=IS+1# Extract phi sign code            GT06 293
IF(IS2(IS)>0)         PHI=    phi:(N2)# Test if  phi2 is +ve            GT06 294
ELSE                  PHI=   -phi:(N2)# Else     phi2 is -ve            GT06 295
IF(IS3(IS)>0)         PHI=PHI+phi:(N3)## Test if  phi3 is +ve           GT06 296
ELSE                  PHI=PHI-phi:(N3)## Else     phi3 is -ve           GT06 297
IF((IT>1)&(IS4(IS)>0))PHI=PHI+phi:(N4)## Test if  phi4 is +ve           GT06 298
ELSE IF(IT>1)         PHI=PHI-phi:(N4)## Else     phi4 is -ve           GT06 299
J=MOD(3600-NINT(PHI)-IP,360)+M0#       Phase est for invariant          GT06 300
IF(IT!=NEGQ)#                          Test if active invariant         GT06 301
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 GT06 302
SSIN=SSIN+A*QX(J+1)#                   Sum  sin component               GT06 303
SCOS=SCOS+A*QX(J+91)#                  Sum  cos component               GT06 304
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 GT06 305
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GT06 306
SUMN=SUMN+1.#                          Count invariants used            GT06 307
#                                                                       GT06 308
IF(IDMP(6)>0)#                         Test if inv dump request         GT06 309
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 GT06 310
IF(ICNT==1) J=90-NINT(SIGN(90.,A))+M0## Get phase for centro            GT06 311
K=IABS(IPHI-J+M0); K=MIN0(K,360-K)#    Get smallest difference          GT06 312
IF(IPHI<0) K=0#                        Reset diff if new phase          GT06 313
BUFOT(1)=SUMN#                         Store inv number                 GT06 314
BUFOT(2)=phi:(N2)#                     Store phase2                     GT06 315
BUFOT(3)=phi:(N3)#                     Store phase3                     GT06 316
BUFOT(4)=phi:(N4)#                     Store phase4                     GT06 317
BUFOT(5)=FLOAT(-IP)#                   Store phase shift-qpsi           GT06 318
BUFOT(6)=FLOAT(J-M0)#                  Store new phase                  GT06 319
BUFOT(7)=FLOAT(K)#                     Store phase diff                 GT06 320
BUFOT(8)=wgt:(N2)#                     Store weight2                    GT06 321
BUFOT(9)=wgt:(N3)#                     Store weight3                    GT06 322
BUFOT(10)=wgt:(N4)#                    Store weight4                    GT06 323
BUFOT(11)=WGT#                         Store total weight               GT06 324
BUFOT(12)=A#                           Store w*prob factor              GT06 325
BUFOT(13)=FLOAT((N2-M1)/MARK+1)#       Store seq number 2               GT06 326
BUFOT(14)=FLOAT((N3-M1)/MARK+1)#       Store seq number 3               GT06 327
IF(IT>1)BUFOT(15)=FLOAT((N4-M1)/MARK+1)# Store seq number 4             GT06 328
ELSE    BUFOT(15)=0.#                  Store null seq number            GT06 329
IF(IT<1)BUFOT(4 )=0.#                  Store null phase4 for trip       GT06 330
IF(IS2(IS)>0) BUFOT(2)=-BUFOT(2)#      Test sign of phi2                GT06 331
IF(IS3(IS)>0) BUFOT(3)=-BUFOT(3)#      Test sign of phi3                GT06 332
IF(IS4(IS)>0) BUFOT(4)=-BUFOT(4)#      Test sign of phi4                GT06 333
ncodefld:(BUFOT,1,CHROT,FM5,15)#       Format above items               GT06 334
writeline:(0,GT6,NGT6,1,3)#            Print inv items                  GT06 335
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 GT06 336
#                                                                       GT06 337
IF((IT==PSI0)\(TEST!=1)\(IPHI<0)) NEXT# Skip if psi0 or pretest         GT06 338
IF(ICNT==1) J=90-NINT(SIGN(90.,A))+M0## Get phase for centro            GT06 339
J=IABS(IPHI-J+M0); J=MIN0(J,360-J)#    Get smallest difference          GT06 340
NINV=NINV+1#                           Count all invariants             GT06 341
NDIF=NDIF+J**2#                        Sum new/old differences          GT06 342
IF(IT!=NEGQ) NEXT#                     Skip if t3 or pq4                GT06 343
MINV=MINV+1#                           Count neg quartets               GT06 344
MDIF=MDIF+J**2#                        Sum phi differences              GT06 345
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GT06 346
#                                                                       GT06 347
#                                                                       GT06 348
#    END INV LOOP -- ASSESS PHASE                                       GT06 349
#    ---------------------------                                        GT06 350
#                                                                       GT06 351
IF(SUMN<.5) NEXT#                      Skip if no connects              GT06 352
AL2=SSIN**2 + SCOS**2#                 Calculate alpha squared          GT06 353
SAL2=SAL2+AL2#                         Sum alpha squared                GT06 354
SUME=SUME/64.#                         Remove packing factor            GT06 355
#                                                                       GT06 356
IF(NG<MQ)#                             If normal gens (not psi0)        GT06 357
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 GT06 358
IF(TEST>0\KDMP==yes:)#                 If fom test or dump              GT06 359
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 GT06 360
A=SQRT(AL2)#                           Calculate alpha                  GT06 361
SUMA=SUMA+A#                           Sum actual alphas                GT06 362
SUMB=SUMB+SUME#                        Sum expect alphas                GT06 363
SUMD=SUMD+ABS(A-SUME)#                 Sum diff in alpha                GT06 364
#                                                                       GT06 365
IF(KDMP==yes:)#                        Test for generator dump          GT06 366
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 GT06 367
BUFOT(1)=SUMN#                         Store total invariants           GT06 368
BUFOT(2)=AL2#                          Store alpha sqrd                 GT06 369
BUFOT(3)=SUME**2#                      Store alpha exp sqrd             GT06 370
BUFOT(4)=A#                            Store ratio al/ale               GT06 371
BUFOT(5)=SUME#                         Store expected alpha             GT06 372
ncodefld:(BUFOT,1,GT7,FM6,5)#          Format above items               GT06 373
writeline:(0,GT7,NGT7,3,3)#            Print gener parametrs            GT06 374
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 GT06 375
IF(TEST==2) NEXT#                      Skip if pre-test                 GT06 376
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 GT06 377
#                                                                       GT06 378
IF(AL2<A2TH) NEXT#                     Skip if al**2 below thresh       GT06 379
IF(ICNT==1) IP=90-NINT(SIGN(90.,SCOS))# Convert centro ccos to deg.     GT06 380
ELSE#                                  Else calc noncentro phase        GT06 381
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 GT06 382
IF((ABS(SSIN)<.01)&(ABS(SCOS)<.01))NEXT# Skip if phi uncertain          GT06 383
B=ATAN2(SSIN,SCOS)*57.2957795#         Calc phi est in degrees          GT06 384
IP=MOD(360+NINT(B),360)#               Phi as modulo 360                GT06 385
IF(prc:>1.5)#                          Test if phi restricted           GT06 386
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 GT06 387
I=iprc:;  J=PRC(I)#                    Get phi restriction              GT06 388
K=IABS(IP-J);  K=MIN0(K,360-K)#        Get smalllest difference         GT06 389
IF(K==90) NEXT#                        Skip if ambiguous                GT06 390
IF(K<90) IP=J#                         Set as closest restr             GT06 391
ELSE     IP=J+180#                     Set as closest restr             GT06 392
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 GT06 393
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 GT06 394
IF(IWGT>1)#                            Test if weight 2 or 3            GT06 395
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 GT06 396
IF(IWGT==2)#                           Get table index on ratio**2      GT06 397
I=MIN0(40,INT(AL2*10./SUME**2)+1)#     Get index for x**2               GT06 398
ELSE#                                  Get table index on ratio         GT06 399
I=MIN0(40,INT(SQRT(AL2)*10./SUME)+1)#  Get index for x                  GT06 400
WGT=WTAB2(I)#                          Store weight 2                   GT06 401
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 GT06 402
ELSE#                                  Else apply weight 1              GT06 403
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 GT06 404
I=MIN0(25,INT(AL2/DAL2)+1)#            Form index from alpha**2         GT06 405
WGT=WTAB1(I)#                          Store weight 1                   GT06 406
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 GT06 407
IF((TYPE==0)&(WGT<RWGT)) NEXT#         Skip if new ran wgt < start      GT06 408
wgt:=WGT#                              Translate into phi weight        GT06 409
phi:=FLOAT(IP)#                        Store new phi estimate           GT06 410
NCON=NCON+1#                           Count connected generators       GT06 411
MLIM=MAX0(MLIM,NG)#                    Reset penetration limit          GT06 412
IF(KDMP==yes:)#                        Test for generator dump          GT06 413
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 GT06 414
J=IABS(IPHI-IP);  J=MIN0(J,360-J)#     Get smallest difference          GT06 415
IF(IPHI<0) J=0#                        Diff=0 if new phase              GT06 416
BUFOT(1)=phi:#                         Store new phase                  GT06 417
BUFOT(2)=wgt:#                         Store new weight                 GT06 418
BUFOT(3)=FLOAT(J)#                     Store phase diff                 GT06 419
intunpak:(pak:,K,0,9)#                 Unpack start/refined phase       GT06 420
IF(K>0)#                               Test phase present               GT06 421
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 GT06 422
I=IABS(K-IP); I=MIN0(I,360-I)#         Get diff new & refine phase      GT06 423
movechar:(GT12,1,GT8,12,3,0)#          Blank out possible ***           GT06 424
IF(I>45) movechar:(GT12,19,GT8,12,3,0)# Insert *** if diff large        GT06 425
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 GT06 426
BUFOT(4)=FLOAT(MOD(K,360))#            Store start/refine phase         GT06 427
ncodefld:(BUFOT,1,GT8,FM4,4)#          Format above items               GT06 428
writeline:(0,GT8,NGT8,3,3)#            Print new phase                  GT06 429
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 GT06 430
IF(IDMP(7)>0)#                         Test if phase map requested      GT06 431
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 GT06 432
I=IMAP+N1*NMAP#                        Point to map word                GT06 433
J=NINT(WGT*100.);   K=NINT(SUMN)#      Integer weight & inv count       GT06 434
intpak:(IP,QX(I), 0,9)#                Pack phase   bits  8 - 0         GT06 435
intpak:(J ,QX(I), 9,9)#                Pack weight  bits 17 - 9         GT06 436
intpak:(K ,QX(I),18,bitlen:(18))#      Pack inv num bits ** -18         GT06 437
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 GT06 438
#                                                                       GT06 439
IF((TEST<1)\(IPHI<0)) NEXT#            Skip if not fom or known         GT06 440
NPHI=NPHI+IP#                          Sum total phi estimates          GT06 441
J=IABS(IPHI-IP);  J=MIN0(J,360-J)#     Get smallest difference          GT06 442
IDIF=IDIF+J#                           Sum dif with prev phi            GT06 443
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 GT06 444
ELSE#                                  These are psi0 triplets          GT06 445
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 GT06 446
PSIA=PSIA+SQRT(AL2)#                   Sum psi0 alphas                  GT06 447
PSIE=PSIE+SUME#                        Sum expected psi0 alphas         GT06 448
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 GT06 449
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GT06 450
#                                                                       GT06 451
#   END GEN LOOP -- ADJUST CYCLE LIMITS                                 GT06 452
#   -----------------------------------                                 GT06 453
#                                                                       GT06 454
A2TH=A2TH*RATE#                        Reduce alpha**2 threshold        GT06 455
IF(NC<6) NEXT#                         Force min iterations             GT06 456
IF(SAL2<.1) BREAK#                     Exit if no connects              GT06 457
#                                                                       GT06 458
IF(IFOM==yes:)#                        Is fom pretest requested         GT06 459
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 GT06 460
IFOM=no:;  TEST=2;  NC=NC-1;  NEXT#    Reset test flags & recycle       GT06 461
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 GT06 462
#                                                                       GT06 463
IF(TEST==1)#                           If final fom test                GT06 464
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 GT06 465
RFOM=MAX(.1,SUMB-SUMR)/MAX(.1,SUMA-SUMR)# Calc relative fom             GT06 466
IF(RFOM>FREJ(1)) IREJ=21#              Test rejection limit             GT06 467
RFAC=SUMD/SUMB#                        Calc karle rfactor               GT06 468
IF(RFAC>FREJ(2)) IREJ=22#              Test rejection limit             GT06 469
IF(PSIE>.1)#                           Test for psi0 triplets           GT06 470
APSI=PSIA/PSIE#                        Calculate psi0 fom value         GT06 471
ELSE APSI=-.00001#                     Psi(0) value unavailable         GT06 472
IF(APSI>FREJ(3)) IREJ=23#              Test for rejection               GT06 473
IF(RFOM<FREJ(5)) IREJ=24#              Test rejection limit             GT06 474
IF(IDMP(8)>0)#                         Test for fom dump                GT06 475
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 GT06 476
BUFOT(1)=FLOAT(NS)#                    Store rejection flag             GT06 477
BUFOT(2)=RFOM#                         Store rel fom                    GT06 478
BUFOT(3)=RFAC#                         Store r-factor                   GT06 479
BUFOT(4)=SUMB#                         Store sum alfexp tot             GT06 480
BUFOT(5)=SUMR#                         Store sum alfran tot             GT06 481
BUFOT(6)=SUMA#                         Store sum alpha                  GT06 482
BUFOT(7)=SUMD#                         Store sum alpha-alfexp           GT06 483
BUFOT(8)=PSIA#                         Store psi0 alpha                 GT06 484
BUFOT(9)=PSIE#                         Store psi0 alfexp                GT06 485
BUFOT(10)=APSI#                        Store psi0 fom                   GT06 486
ncodefld:(BUFOT,1,GT11,FM7,10)#        Format above items               GT06 487
writeline:(1,GT11,NGT11,3,3)#          Print final foms                 GT06 488
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 GT06 489
BREAK#                                 Exit after last fom test         GT06 490
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 GT06 491
ELSE IF(TEST==2)#                      Now if prelimonary test          GT06 492
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 GT06 493
RFOM=SUMB/AMAX1(.1,SUMA)#              Calc relative fom                GT06 494
IF(RFOM>PREJ3) IREJ=11#                Test rejection limit             GT06 495
RFAC=SUMD/SUMB#                        Calc karle rfactor               GT06 496
IF((RFOM>PREJ1)&(RFAC>PREJ2)) IREJ=12# Test rejection limit             GT06 497
IF(RFOM<FREJ(5)) IREJ=14#              Test rejection limit             GT06 498
IF(IDMP(8)>0)#                         Test for pretest fom dump        GT06 499
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 GT06 500
BUFOT(1)=FLOAT(NS)#                    Store rejection flag             GT06 501
BUFOT(2)=RFOM#                         Store rel fom                    GT06 502
BUFOT(3)=RFAC#                         Store r-factor                   GT06 503
BUFOT(4)=SUMB#                         Store sum alfexp part            GT06 504
BUFOT(5)=SUMR#                         Store sumfal ran part            GT06 505
BUFOT(6)=SUMA#                         Store sum alpha                  GT06 506
BUFOT(7)=SUMD#                         Store sum alpha-alfexp           GT06 507
BUFOT(8)=PREJ1#                        Store rej thr 1                  GT06 508
BUFOT(9)=PREJ2#                        Store rej thr 2                  GT06 509
BUFOT(10)=PREJ3#                       Store rej thr 3                  GT06 510
ncodefld:(BUFOT,1,GT10,FM7,10)#        Format above items               GT06 511
writeline:(1,GT10,NGT10,3,3)#          Print pretest foms               GT06 512
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 GT06 513
IF((EFOM==yes:)&(IREJ>0)) BREAK#       Exit if foms rejected            GT06 514
TEST=-1;    IREJ=0;   SAL2=TAL2#       Start next iter if ok            GT06 515
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 GT06 516
#                                                                       GT06 517
A=ABS(SAL2-SOL2)/SAL2#                 Calc converge ratio              GT06 518
IF((TEST<0)&(A>CONV)) NEXT#            Recycle if not converged         GT06 519
IF(IACC==yes:) LGEN=MGEN#              Reset to last block limit        GT06 520
IF((MGEN<MQ)&(NC<MITR))#               Test if all gen used yet         GT06 521
MGEN=MIN0(MQ,MGEN+KGEN)#               Add gens as 1/4 list             GT06 522
ELSE TEST=TEST+1#                      Flag as final iterations         GT06 523
IF(TEST==0)#                           Test if 2nd test iteration       GT06 524
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 GT06 525
NF=10000#                              Release all fixed phases         GT06 526
MITR=NC+2#                             Set new iteration limit          GT06 527
MGEN=MQ;   LGEN=M1#                    Ensure all gens phased           GT06 528
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 GT06 529
ELSE IF(TEST==1)#                      Test iter release negq           GT06 530
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 GT06 531
MLIM=16777216## 2^24                  Enable all inv. incl negq         GT06 532
MGEN=MG;   LGEN=M1#                    Enable psi0 triplets             GT06 533
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 GT06 534
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GT06 535
IF(TEST<0) IREJ=25#                    Reject if refine incomplete      GT06 536
IF(IDMP(7)>0) ITMX=MITR#               Store pmap iter limit            GT06 537
#                                                                       GT06 538
#  END OF ITER LOOP -- OUTPUT PHASES ON FILE 3                          GT06 539
#  -------------------------------------------                          GT06 540
#                                                                       GT06 541
writepkt:(3,NS*2,15,IP)#               Set pointer for o/p packet       GT06 542
ANQ4=SQRT(FLOAT(MDIF/(MINV+1)))#       Calc av nq4 diff                 GT06 543
APHI=FLOAT(NPHI/(NCON+1))#             Calc mean phase                  GT06 544
QX(IP+1)=FLOAT(NS)#                    Store phase set number           GT06 545
QX(IP+2)=FLOAT(NCON)#                  Store ngen connected             GT06 546
QX(IP+3)=APHI#                         Store mean phase                 GT06 547
QX(IP+4)=FLOAT(IDIF/(NCON+1))#         Store test av phi dif            GT06 548
QX(IP+5)=SQRT(FLOAT(NDIF/(NINV+1)))#   Store rmsd phi all               GT06 549
QX(IP+6)=ANQ4#                         Store rmsd phi nq4               GT06 550
QX(IP+7)=FLOAT(NINV)#                  Store total invar test used      GT06 551
QX(IP+8)=FLOAT(MINV)#                  Store total negq  test used      GT06 552
QX(IP+9)=FLOAT(MITR)#                  Store number iterations          GT06 553
QX(IP+10)=RFOM#                        Store abs fom                    GT06 554
QX(IP+11)=RFAC#                        Store karle rfactor              GT06 555
QX(IP+12)=APSI#                        Store psi(0) value               GT06 556
IF(MINV==0) QX(IP+13)=-.0001#          Store null negq for max          GT06 557
ELSE        QX(IP+13)=QX(IP+6)#        Store negq for max/min           GT06 558
QX(IP+14)=FLOAT(IREJ)#                 Store rejection flag             GT06 559
IF(IREJ>0) NEXT#                       Skip phases if rejected          GT06 560
#                                                                       GT06 561
DO I=1,4#                              Loop over stored foms            GT06 562
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 GT06 563
J=IP+I+9#                              Point to stored fom              GT06 564
FMIN(I)=AMIN1(FMIN(I),QX(J))#          Find smallest fom                GT06 565
FMAX(I)=AMAX1(FMAX(I),QX(J))#          Find largest  fom                GT06 566
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 GT06 567
N=2*NS+1#                              Set phase set record number      GT06 568
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT06 569
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 GT06 570
writepkt:(3,N,2,IP)#                   Point to next o/p packet         GT06 571
QX(IP+1)=phi:#                         Store phase estimate             GT06 572
QX(IP+2)=wgt:#                         Store phase estimate weight      GT06 573
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 GT06 574
#                                                                       GT06 575
#    TEST FOR TERMINATION                                               GT06 576
#    --------------------                                               GT06 577
#                                                                       GT06 578
IF(NDMP(9)>=NS)  BREAK#                Forced termination of dump       GT06 579
IF(TMOS>0)       NEXT#                 Skip if termination flag off     GT06 580
IF(RFOM>FOPT(1)) NEXT#                 Skip if rfom too large           GT06 581
IF(RFAC>FOPT(2)) NEXT#                 Skip if rfac too large           GT06 582
IF(APSI>FOPT(3)) NEXT#                 Skip if apsi too large           GT06 583
IF(ANQ4>FOPT(4)) NEXT#                 Skip if negq too large           GT06 584
IF(MINV==0\APSI<0.) NEXT#              Skip if no negq or psi0          GT06 585
IF(APHI>45.)     BREAK#                Exit if all optimal              GT06 586
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT06 587
writepkt:(3,endrecord:,4,I)#           Finish off scratch file          GT06 588
#                                                                       GT06 589
RETURN#                                                                 GT06 590
END#                                                                    GT06 591
systemheader:(GT07)#                   Block extension/refinement       GT07   1
####################################################################    GT07   2
#                                                                  #    GT07   3
#                             GT07                                 #    GT07   4
#                                                                  #    GT07   5
####################################################################    GT07   6
SUBROUTINE GT07#                       S.r.hall  dec 81                 GT07   7
include:(AACOMN)#                                                       GT07   8
include:(GTCOMN)#                                                       GT07   9
#                                                                       GT07  10
INTEGER I,J,K,L,N,IP,IS,NS,NI,NC,IT#                                    GT07  11
INTEGER MLIM,NDIF,NPHI,NINV,IPHI,NCON,MGEN,KGEN#                        GT07  12
INTEGER IA,IB,PERM(10),N1,N2,N3,N4#                                     GT07  13
INTEGER MITR,IDIF,MDIF,MINV,TEST,IFOM#                                  GT07  14
INTEGER  JDMP,KDMP#                                                     GT07  15
INTEGER IREJ,LGEN,LREC,NBIAS,NF,NG#                                     GT07  16
REAL AL2,ANQ4,APHI,PREJ3,PSIA,SUMD#                                     GT07  17
REAL SUMX,DELX,SUMB,PSIE#                                               GT07  18
REAL WGT,SSIN,SCOS,SAL2,SUMN#                                           GT07  19
REAL A,B,SUMA,A2TH,DAL2,PHI#                                            GT07  20
REAL SUME,WSUM,WMUL,PREJ1,PREJ2#                                        GT07  21
#                                                                       GT07  22
chardata:(GT1, DUMP OF WEIGHTS   AL2    W1     AL2/AE2    W2)#          GT07  23
chardata:(GT2, **********DUMP OF PHASE SET   )#                         GT07  24
chardata:(GT3,  NSEQ  NGEN   TYPE   PHI   WGT)#                         GT07  25
chardata:(GT4, **********ITERATION CYCLE    NLIM=     AL2TH=      $#    GT07  26
 SUMAL2=            )#                                                  GT07  27
chardata:(GT5, GENERATOR      PHI=     WGT=     NGEN=    $#             GT07  28
RSTR=   )#                                                              GT07  29
chardata:(GT6, NINV   PHI2  PHI3  PHI4  QPSI = PHI  DIF$#               GT07  30
   WGT2  WGT3  WGT4   WGT  PROD    N2  N3  N4)#                         GT07  31
chardata:(GT7,                                          $#              GT07  32
NINV=    AL2=      AE2=       AL=      ALE=      )#                     GT07  33
chardata:(GT8,                PHI=     WGT=     DIFF=    $#             GT07  34
RPHI=   )#                                                              GT07  35
chardata:(GT10, PRETEST    RFOM=      RFAC=       SUME=        $#       GT07  36
SUMR=         SUMA=        SUMD=        REJ1=       REJ2=       $#      GT07  37
REJ3=        )#                                                         GT07  38
chardata:(GT11, FINAL      RFOM=      RFAC=       SUME=        $#       GT07  39
SUMR=         SUMA=        SUMD=        PSIA=       PSIE=        $#     GT07  40
PSI0=        )#                                                         GT07  41
chardata:(GT12,   ODREDRPERSETNUL***)#                                  GT07  42
intdata:(NMAP,0);   intdata:(IMAP,0)#                                   GT07  43
realdata:(SOL2,0.);  realdata:(TAL2,0.);  realdata:(RFOM,0.)#           GT07  44
realdata:(RFAC,0.);  realdata:(APSI,0.)#                                GT07  45
intdata:(IS2,[+1,-1,+1,-1,+1,-1,+1,-1])#                                GT07  46
intdata:(IS3,[+1,+1,-1,-1,+1,+1,-1,-1])#                                GT07  47
intdata:(IS4,[+1,+1,+1,+1,-1,-1,-1,-1])#                                GT07  48
intdata:(PRC,[9999,0,30,45,60,90,120,135,150,180])#                     GT07  49
realdata:(WTAB1,[1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,#                        GT07  50
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.])#                         GT07  51
realdata:(WTAB2,[.12,.30,.46,.60,.72,.82,.89,.94,.98,1.0,#              GT07  52
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,#                          GT07  53
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.])#                         GT07  54
realdata:(FM1,[220622.,280622.,400622.,460622.])#                       GT07  55
realdata:(FM2,[50413.,110413.,250413.,310522.])#                        GT07  56
realdata:(FM3,[280213.,380313.,500412.,690912.])#                       GT07  57
realdata:(FM4,[230313.,330422.,420313.,510313.,130313.])#               GT07  58
realdata:(FM5,[50413.,120413.,180413.,240413.,300413.,360413.,#         GT07  59
410403.,480522.,540522.,600522.,660522.,720622.,#                       GT07  60
780403.,820403.,860403.])#                                              GT07  61
realdata:(FM6,[500313.,600512.,700512.,800512.,900512.])#               GT07  62
realdata:(FM7,[110203.,210422.,320422.,470602.,#                        GT07  63
610702.,740702.,870702.,990612.,1110612.,1240712.])#                    GT07  64
datastuff:#                                                             GT07  65
#                                                                       GT07  66
#   INITIALIZE PHASING PARAMETERS                                       GT07  67
#   -----------------------------                                       GT07  68
#                                                                       GT07  69
N4=M1;    NBIAS=MG-M1+1#               Set dummy n4 for quartets        GT07  70
DAL2=AMIN1(A2MX/25.,1.)#               Calc al**2 incr for wgt          GT07  71
KGEN=MAX0(50,NGEN/4)*MARK#             Set refine block incr            GT07  72
DO I=1,24#                             Loop over weight table           GT07  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT07  74
A=SQRT(FLOAT(I)-.5)/2.#                Get weight increment             GT07  75
B=EXP(A)#                              Get exponential                  GT07  76
IF(ICNT==0) WTAB1(I)=A/2.5#            Calc acentric weight             GT07  77
ELSE        WTAB1(I)=(B-1./B)/(B+1./B)# Calc tanh(b/2) weight           GT07  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT07  79
DO I=1,28#                             For alf ratio > 1.               GT07  80
WTAB2(I+12)=EXP(-FLOAT(I-1)*PFAC)#     Generate weight scheme 2         GT07  81
SUMX=1000.;   DELX=360./FLOAT(NMAG)#   Set magic number intervals       GT07  82
DO I=1,10;  PERM(I)=0#                 Zero permutation array           GT07  83
PREJ1=FREJ(1)*XSHI; PREJ2=FREJ(2)*XSHI# Scale pretest fom limits        GT07  84
PREJ3=2.*PREJ1#                        Get rfom pretest limit           GT07  85
#                                                                       GT07  86
IF(IDMP(2)>0)#                         Test if phase dump request       GT07  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT07  88
writeline:(1,GT1,NGT1,3,3)#            Print weight header              GT07  89
A=DAL2*.5;     B=.05#                  Set initial args                 GT07  90
DO I=1,25#                             Loop over first 25 weightsd      GT07  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT07  92
BUFOT(1)=A;   BUFOT(2)=WTAB1(I)#       Store arg and wgt1               GT07  93
BUFOT(3)=B;   BUFOT(4)=WTAB2(I)#       Store arg and wgt2               GT07  94
ncodefld:(BUFOT,1,CHROT,FM1,4)#        Format above items               GT07  95
writeline:(0,GT1,NGT1,1,3)#            Print top weights                GT07  96
A=A+DAL2;     B=B+.1#                  Incr weight args                 GT07  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT07  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT07  99
#                                                                       GT07 100
#   PHASE SET LOOP                                                      GT07 101
#   --------------                                                      GT07 102
#                                                                       GT07 103
DO NS=1,NPST#                          Loop over phase sets             GT07 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT07 105
IF(NS>=NDMP(2)&NS<=MDMP(2)) JDMP=yes:# Switch on dump for pset          GT07 106
ELSE                        JDMP=no:#  Switch off dump                  GT07 107
DO I=3,7#                              Loop over specific dumps         GT07 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GT07 109
IF(JDMP==yes:) IDMP(I)=NDMP(I)#        Switch on specific dumps         GT07 110
ELSE IF(I<6)   IDMP(I)=999999#         Switch off cyc & gen dumps       GT07 111
ELSE           IDMP(I)=0#              Switch off inv & pmap dumps      GT07 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GT07 113
IF(JDMP>0)#                            If phase set dumped              GT07 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GT07 115
ncodefld:(FLOAT(NS),1,GT2,310313.,1)#  Format pset number               GT07 116
writeline:(1,GT2,NGT2,2,3);  LINRM=3#  Print pset header                GT07 117
IF(IDMP(7)>0)#                         Test if pmap dump                GT07 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GT07 119
NMAP=MXIT+2; IMAP=MG-NMAP; I=NMAP*NGEN# Phase map pointers              GT07 120
movereal:(0.,1,QX,MG+1,I,2)#           Zero pmap                        GT07 121
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GT07 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GT07 123
#                                                                       GT07 124
#   GET STARTING PHASES                                                 GT07 125
#   -------------------                                                 GT07 126
#                                                                       GT07 127
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over gener list             GT07 128
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GT07 129
phi:=-1.; wgt:=0.#                     Zero phase, weight, iter fix     GT07 130
intunpak:(pak:,K,25, 7)#               Get phase weight                 GT07 131
IF(K>0)#                               Test if starting phase           GT07 132
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GT07 133
intunpak:(pak:,N, 0, 9)#               Get starting phase               GT07 134
phi:=FLOAT(MOD(N,360))#                Reset starting phase             GT07 135
wgt:=FLOAT(K)/16.#                     Reset phase weight               GT07 136
NEXT#                                  Skip to next generator           GT07 137
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GT07 138
IF(TYPE!=0) NEXT#                      Skip if not random starter       GT07 139
SEED=MOD(SEED*25173+13849,65536)#      Generate random number           GT07 140
IPHI=MOD(SEED,360)#                    Convert to random phi 0-359      GT07 141
IF(prc:>1.5)#                          Test if phi restricted           GT07 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GT07 143
I=iprc:;  J=PRC(I)#                    Get phi restriction              GT07 144
K=IABS(IPHI-J);  K=MIN0(K,360-K)#      Get smallest difference          GT07 145
IF(K<90) IPHI=J#                       Set as closest restr             GT07 146
ELSE     IPHI=J+180#                   Set as closest restr             GT07 147
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GT07 148
phi:=FLOAT(IPHI)#                      Assign random phase              GT07 149
wgt:=RWGT#                             Assign random weight             GT07 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GT07 151
#                                                                       GT07 152
#                                        ******* permute starters       GT07 153
L=0#                                   Progressive permute flag         GT07 154
IF(NMAG>1)#                            Test if magic starters           GT07 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GT07 156
SUMX=SUMX+DELX#                        Incr magic phase constant        GT07 157
IF(SUMX>360.) SUMX=0.1#                Reset initial magic x            GT07 158
ELSE          L=1#                     Disable other permutes           GT07 159
DO I=1,NPER#                           Loop over permutes               GT07 160
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GT07 161
IF(PERI(I)>0) NEXT#                    Skip non-magic permutes          GT07 162
J=PERN(I);  K=IABS(J)#                 Extract genlist pointer          GT07 163
phi:(K)=AMOD(phi:(K)+SUMX*FLOAT(-PERI(I)),360.)# Add permutation        GT07 164
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GT07 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GT07 166
FOR(I=1;I<=NPER;I=I+1)#                Loop over all permutes           GT07 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GT07 168
IF(PERI(I)<0) NEXT#                    Skip magic permutes              GT07 169
J=PERN(I);   K=IABS(J)#                Point to gener list              GT07 170
phi:(K)=AMOD(phi:(K)+FLOAT(PERM(I)),360.)# Add permutation              GT07 171
IF(L==1) NEXT#                         Skip further permutes            GT07 172
PERM(I)=PERM(I)+PERI(I)#               Increment permute phase          GT07 173
IF(((J>0)&(PERM(I)>=360))$#            Test for 2pi permute             GT07 174
\  ((J<0)&(PERM(I)>=LEDR)))PERM(I)=0#  Test for pi permute              GT07 175
ELSE L=1#                              Shutoff further permutes         GT07 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GT07 177
#                                                                       GT07 178
IF(NS>=IDMP(3)&NS<=MDMP(3))#           Test if start dump request       GT07 179
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over gener list             GT07 180
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GT07 181
IF(phi:<0.) NEXT#                      Skip non-starters                GT07 182
BUFOT(1)=FLOAT((NG   -M1)/MARK+1)#     Get list seq number              GT07 183
BUFOT(2)=FLOAT((ipnt:-M1)/MARK+1)#     Get ngen seq number              GT07 184
BUFOT(3)=phi:#                         Get start phase                  GT07 185
BUFOT(4)=wgt:#                         Get start weight                 GT07 186
intunpak:(pak:,N,22,3)#                Get start status                 GT07 187
movechar:(GT12,N*3-2,CHROT,16,3,0)#    Insert start type                GT07 188
ncodefld:(BUFOT,1,CHROT,FM2,4)#        Format above items               GT07 189
writeline:(0,GT3,NGT3,1,3)#            Print start phase                GT07 190
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GT07 191
#                                                                       GT07 192
#    INITIALIZE PHASE SET PARAMETERS                                    GT07 193
#    -------------------------------                                    GT07 194
#                                                                       GT07 195
A2TH=A2MX#                             Reset al**2 threshold            GT07 196
TEST=-1;    IREJ=0#                    Reset iteration flag             GT07 197
MITR=MXIT#                             Reset iteration limit            GT07 198
MLIM=NLIM#                             Reset genlist penetration        GT07 199
MGEN=NCUT;     LGEN=M1#                Reset genlist limit              GT07 200
NPHI=0;  IDIF=0;  SAL2=0.#             Reset accumulators               GT07 201
NDIF=0;   MDIF=0;   NINV=0;   MINV=0#  Reset fom accumulators           GT07 202
PSIA=0.;   PSIE=0.;   IFOM=yes:#       Reset fom accumulators           GT07 203
NF=0#                                  Reset iteration fix count        GT07 204
#                                                                       GT07 205
#   ITERATION LOOP                                                      GT07 206
#   --------------                                                      GT07 207
#                                                                       GT07 208
FOR(NC=1;NC<=MITR;NC=NC+1)#            Loop over phasing cycles         GT07 209
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GT07 210
IF(NC>=IDMP(4)&NC<=MDMP(4))#           Test for iteration dump          GT07 211
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GT07 212
BUFOT(1)=FLOAT(NC)#                    Store iteration number:          GT07 213
BUFOT(2)=FLOAT((MGEN-M1)/MARK+1)#      Store penetration limit          GT07 214
BUFOT(3)=A2TH#                         Store alsqd threshold            GT07 215
BUFOT(4)=SAL2#                         Store sum al2                    GT07 216
ncodefld:(BUFOT,1,GT4,FM3,4)#          Format above items               GT07 217
writeline:(1,GT4,NGT4,3,3)#            Print iteration items            GT07 218
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GT07 219
IF(IDMP(7)>0&TEST!=2) IMAP=IMAP+1#     Incr phase map pointer           GT07 220
NF=MAX0(NF,NC)#                        Set iteration fix limit          GT07 221
N1=0;   LREC=0#                        Reset generator count            GT07 222
IF(TEST<2) SOL2=SAL2#                  Reset old al2 if not pret        GT07 223
ELSE       TAL2=SAL2#                  Else save curr al2 later         GT07 224
SAL2=0.;  NCON=0#                      Reset al**2 & connects           GT07 225
SUMA=0.;  SUMD=0.;  SUMB=0.#           Reset fom sums                   GT07 226
#                                                                       GT07 227
#    GENERATOR LOOP                                                     GT07 228
#    --------------                                                     GT07 229
#                                                                       GT07 230
FOR(NG=M1;NG<MGEN;NG=NG+MARK)#         Loop over generator list         GT07 231
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GT07 232
N1=N1+1#                               Incr generator count             GT07 233
TOP=itop:;    BOT=ibot:#               Get si block limits              GT07 234
alp:=0.#                               Reset invariant count            GT07 235
IF((NG<LGEN)&(wgt:>.9)) NEXT#          Skip stable phis last block      GT07 236
intunpak:(pak:,I,9,6)#                 Extract iter fix limit           GT07 237
IF((TEST<=0)&(I>NF)) NEXT#             Test if this phase fixed         GT07 238
IF(NDMP(6)>0&N1>=IDMP(5)&N1<=MDMP(5))# Test for generator dump          GT07 239
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GT07 240
J=iprc:;   J=PRC(J)#                   Extract phase restr.             GT07 241
BUFOT(1)=phi:#                         Store current phase              GT07 242
BUFOT(2)=wgt:#                         Store current weight             GT07 243
BUFOT(3)=FLOAT((ipnt:-M1)/MARK+1)#     Point to gener number            GT07 244
BUFOT(4)=FLOAT(J)#                     Store phase restriction          GT07 245
BUFOT(5)=FLOAT(N1)#                    Store generator seq num          GT07 246
ncodefld:(BUFOT,1,GT5,FM4,5)#          Format gener items               GT07 247
writeline:(1,GT5,NGT5,3,3)#            Print gener line                 GT07 248
LINRM=4;  N4=M1#                       Get phi for inv dump             GT07 249
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GT07 250
IF(NG<MQ) IPHI=NINT(phi:)#             Get current phi value            GT07 251
SSIN=0.; SCOS=0.; SUMN=0.; SUME=0.#    Zero sincos sums                 GT07 252
#                                                                       GT07 253
#   INVARIANT LOOP                                                      GT07 254
#   --------------                                                      GT07 255
#                                                                       GT07 256
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        GT07 257
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GT07 258
N2=NINT(QX(NI+2))#                     Extract n2 genlist address       GT07 259
IF(N2>MLIM) BREAK#                     Exit if beyond limit             GT07 260
IF(N2>MG) N2=N2-NBIAS#                 Adjust n2 for negq4              GT07 261
IF(wgt:(N2)<WMIN) NEXT#                Skip unphased generator          GT07 262
N3=NINT(QX(NI+3))#                     Extract n3 genlist address       GT07 263
IF(wgt:(N3)<WMIN) NEXT#                Skip unphased generator          GT07 264
WMUL=2.*wgt:(N2)*wgt:(N3)#             Product triplet weights          GT07 265
WSUM=wgt:(N2)+wgt:(N3)#                Sum of triplet weights           GT07 266
intunpak:(QX(NI+1),IT, 0, 2)#          Extract invariant type           GT07 267
IF(IT>1)#                              Test if active quartet           GT07 268
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GT07 269
N4=NINT(QX(NI+4))#                     Extract n4 genlist address       GT07 270
IF(wgt:(N4)<WMIN) NEXT#                Skip unphased generator          GT07 271
WMUL=1.5*WMUL*wgt:(N4)#                Product quartet weight           GT07 272
WSUM=WSUM+wgt:(N4)#                    Sum of quartet weights           GT07 273
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GT07 274
WGT=WMUL/WSUM#                         Calculate weight of cos(psi)     GT07 275
intunpak:(QX(NI+1),IP, 9, 9)#          Extract shift-qpsi-negq          GT07 276
intunpak:(QX(NI+1),IA,25, 7)#          Extract modified a*8             GT07 277
A=FLOAT(IA)*WGT*0.125#                 Form total inv weight            GT07 278
IF((IWGT>1)\(TEST>0))#                 Test if weight scheme 2 or 3     GT07 279
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GT07 280
intunpak:(QX(NI+1),IB,18, 7)#          Extract probf *64                GT07 281
SUME=SUME+FLOAT(IB)*A#                 Sum weighted a*probf             GT07 282
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GT07 283
IF(ICNT==1)#                           Test if centrosymmetric          GT07 284
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GT07 285
ifne:(phi:(N2),phi:(N3)) A=-A#         Reverse sign if diff =pi         GT07 286
IF(IP>0)                 A=-A#         Reverse sign if shift=pi         GT07 287
IF((IT>1)&(phi:(N4)>.5)) A=-A#         Reverse sign if phi4 =pi         GT07 288
IF(IT!=NEGQ) SCOS=SCOS+A#              Sum tangent denominator          GT07 289
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GT07 290
ELSE#                                  Else phases noncentrosymmetr     GT07 291
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GT07 292
intunpak:(QX(NI+1),IS, 2, 3); IS=IS+1# Extract phi sign code            GT07 293
IF(IS2(IS)>0)         PHI=    phi:(N2)# Test if  phi2 is +ve            GT07 294
ELSE                  PHI=   -phi:(N2)# Else     phi2 is -ve            GT07 295
IF(IS3(IS)>0)         PHI=PHI+phi:(N3)## Test if  phi3 is +ve           GT07 296
ELSE                  PHI=PHI-phi:(N3)## Else     phi3 is -ve           GT07 297
IF((IT>1)&(IS4(IS)>0))PHI=PHI+phi:(N4)## Test if  phi4 is +ve           GT07 298
ELSE IF(IT>1)         PHI=PHI-phi:(N4)## Else     phi4 is -ve           GT07 299
J=MOD(3600-NINT(PHI)-IP,360)+M0#       Phase est for invariant          GT07 300
IF(IT!=NEGQ)#                          Test if active invariant         GT07 301
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 GT07 302
SSIN=SSIN+A*QX(J+1)#                   Sum  sin component               GT07 303
SCOS=SCOS+A*QX(J+91)#                  Sum  cos component               GT07 304
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 GT07 305
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GT07 306
SUMN=SUMN+1.#                          Count invariants used            GT07 307
#                                                                       GT07 308
IF(IDMP(6)>0)#                         Test if inv dump request         GT07 309
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 GT07 310
IF(ICNT==1) J=90-NINT(SIGN(90.,A))+M0## Get phase for centro            GT07 311
K=IABS(IPHI-J+M0); K=MIN0(K,360-K)#    Get smallest difference          GT07 312
IF(IPHI<0) K=0#                        Reset diff if new phase          GT07 313
BUFOT(1)=SUMN#                         Store inv number                 GT07 314
BUFOT(2)=phi:(N2)#                     Store phase2                     GT07 315
BUFOT(3)=phi:(N3)#                     Store phase3                     GT07 316
BUFOT(4)=phi:(N4)#                     Store phase4                     GT07 317
BUFOT(5)=FLOAT(-IP)#                   Store phase shift-qpsi           GT07 318
BUFOT(6)=FLOAT(J-M0)#                  Store new phase                  GT07 319
BUFOT(7)=FLOAT(K)#                     Store phase diff                 GT07 320
BUFOT(8)=wgt:(N2)#                     Store weight2                    GT07 321
BUFOT(9)=wgt:(N3)#                     Store weight3                    GT07 322
BUFOT(10)=wgt:(N4)#                    Store weight4                    GT07 323
BUFOT(11)=WGT#                         Store total weight               GT07 324
BUFOT(12)=A#                           Store w*prob factor              GT07 325
BUFOT(13)=FLOAT((N2-M1)/MARK+1)#       Store seq number 2               GT07 326
BUFOT(14)=FLOAT((N3-M1)/MARK+1)#       Store seq number 3               GT07 327
IF(IT>1)BUFOT(15)=FLOAT((N4-M1)/MARK+1)# Store seq number 4             GT07 328
ELSE    BUFOT(15)=0.#                  Store null seq number            GT07 329
IF(IT<1)BUFOT(4 )=0.#                  Store null phase4 for trip       GT07 330
IF(IS2(IS)>0) BUFOT(2)=-BUFOT(2)#      Test sign of phi2                GT07 331
IF(IS3(IS)>0) BUFOT(3)=-BUFOT(3)#      Test sign of phi3                GT07 332
IF(IS4(IS)>0) BUFOT(4)=-BUFOT(4)#      Test sign of phi4                GT07 333
ncodefld:(BUFOT,1,CHROT,FM5,15)#       Format above items               GT07 334
writeline:(0,GT6,NGT6,1,3)#            Print inv items                  GT07 335
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 GT07 336
#                                                                       GT07 337
IF((IT==PSI0)\(TEST!=1)\(IPHI<0)) NEXT# Skip if psi0 or pretest         GT07 338
IF(ICNT==1) J=90-NINT(SIGN(90.,A))+M0## Get phase for centro            GT07 339
J=IABS(IPHI-J+M0); J=MIN0(J,360-J)#    Get smallest difference          GT07 340
NINV=NINV+1#                           Count all invariants             GT07 341
NDIF=NDIF+J**2#                        Sum new/old differences          GT07 342
IF(IT!=NEGQ) NEXT#                     Skip if t3 or pq4                GT07 343
MINV=MINV+1#                           Count neg quartets               GT07 344
MDIF=MDIF+J**2#                        Sum phi differences              GT07 345
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GT07 346
#                                                                       GT07 347
#                                                                       GT07 348
#    END INV LOOP -- STORE GENERATOR SUMS                               GT07 349
#    ---------------------------                                        GT07 350
#                                                                       GT07 351
sin:=SSIN;  cos:=SCOS#                 Store tangent numer & denom      GT07 352
alt:=SUME/64.;  alp:=SUMN#             Store alfex & count              GT07 353
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GT07 354
#                                                                       GT07 355
#   END GEN LOOP -- CALC PHASE VALUES                                   GT07 356
#   ---------------------------------                                   GT07 357
#                                                                       GT07 358
N1=0#                                  Reset generator counter          GT07 359
FOR(NG=M1;NG<MGEN;NG=NG+MARK)#         Loop over generator list         GT07 360
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 GT07 361
N1=N1+1#                               Count generators                 GT07 362
IF(alp:<.5) NEXT#                      Skip if no estimate              GT07 363
SSIN=sin:;   SCOS=cos:#                Make sums local variables        GT07 364
AL2=SSIN**2 + SCOS**2#                 Calculate alpha squared          GT07 365
SAL2=SAL2+AL2#                         Sum alpha squared                GT07 366
IF(N1>=IDMP(5)&N1<=MDMP(5))#           Test for generator dump          GT07 367
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 GT07 368
J=iprc:;   J=PRC(J)#                   Extract phase restr.             GT07 369
BUFOT(1)=phi:#                         Store current phase              GT07 370
BUFOT(2)=wgt:#                         Store current weight             GT07 371
BUFOT(3)=FLOAT((ipnt:-M1)/MARK+1)#     Point to gener number            GT07 372
BUFOT(4)=FLOAT(J)#                     Store phase restriction          GT07 373
BUFOT(5)=FLOAT(N1)#                    Store generator seq num          GT07 374
ncodefld:(BUFOT,1,GT5,FM4,5)#          Format gener items               GT07 375
writeline:(1,GT5,NGT5,3,3)#            Print gener line                 GT07 376
IPHI=NINT(phi:);  LINRM=4;  N4=M1#     Get phi for inv dump             GT07 377
KDMP=yes:#                             Switch on generator dump         GT07 378
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 GT07 379
ELSE KDMP=no:#                         Switch off generaor dump         GT07 380
#                                                                       GT07 381
IF(NG<MQ)#                             If normal gens (not psi0)        GT07 382
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 GT07 383
IF(TEST>0\KDMP==yes:)#                 If fom test iteration            GT07 384
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 GT07 385
A=SQRT(AL2)#                           Calculate alpha                  GT07 386
SUMA=SUMA+A#                           Sum alpha                        GT07 387
SUMB=SUMB+alt:#                        Sum expected alpha               GT07 388
SUMD=SUMD+ABS(A-alt:)#                 Sum alpha diff for rfac          GT07 389
IF(KDMP==yes:)#                        Test for genr dump               GT07 390
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 GT07 391
BUFOT(1)=alp:#                         Store total invariants           GT07 392
BUFOT(2)=AL2#                          Store alpha sqrd                 GT07 393
BUFOT(3)=alt:**2#                      Store alpha exp sqrd             GT07 394
BUFOT(4)=A#                            Store alpha                      GT07 395
BUFOT(5)=alt:#                         Store alpha expect               GT07 396
ncodefld:(BUFOT,1,GT7,FM6,5)#          Format above items               GT07 397
writeline:(0,GT7,NGT7,3,3)#            Print gener parametrs            GT07 398
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 GT07 399
IF(TEST==2) NEXT#                      Skip phi calc for pretest        GT07 400
IPHI=NINT(phi:)#                       Get current phi for test         GT07 401
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 GT07 402
#                                                                       GT07 403
IF(AL2<A2TH) NEXT#                     Skip if al**2 below thresh       GT07 404
IF(ICNT==1) IP=90-NINT(SIGN(90.,SCOS))# Convert centro ccos to deg.     GT07 405
ELSE#                                  Else calc noncentro phase        GT07 406
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 GT07 407
IF((ABS(SSIN)<.01)&(ABS(SCOS)<.01))NEXT# Skip if phi uncertain          GT07 408
B=ATAN2(SSIN,SCOS)*57.2957795#         Calc phi est in degrees          GT07 409
IP=MOD(360+NINT(B),360)#               Phi as modulo 360                GT07 410
IF(prc:>1.5)#                          Test if phi restricted           GT07 411
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 GT07 412
I=iprc:;  J=PRC(I)#                    Get phi restriction              GT07 413
K=IABS(IP-J);  K=MIN0(K,360-K)#        Get smallest difference          GT07 414
IF(K==90) NEXT#                        Skip if ambiguous                GT07 415
IF(K<90) IP=J#                         Set as closest restr             GT07 416
ELSE     IP=J+180#                     Set as closest restr             GT07 417
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 GT07 418
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 GT07 419
IF(IWGT>1)#                            Test if weight 2 or 3            GT07 420
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 GT07 421
IF(IWGT==2)#                           Get table index on ratio**2      GT07 422
I=MIN0(40,INT(AL2*10./alt:**2)+1)#     Get index for x**2               GT07 423
ELSE#                                  Get table index on ratio         GT07 424
I=MIN0(40,INT(SQRT(AL2)*10./alt:)+1)#  Get index for x                  GT07 425
WGT=WTAB2(I)#                          Store weight 2                   GT07 426
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 GT07 427
ELSE#                                  Else apply weight 1              GT07 428
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 GT07 429
I=MIN0(25,INT(AL2/DAL2)+1)#            Form index from alpha**2         GT07 430
WGT=WTAB1(I)#                          Store weight 1                   GT07 431
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 GT07 432
IF((TYPE==0)&(WGT<RWGT)) NEXT#         Skip if new ran wgt < start      GT07 433
wgt:=WGT#                              Translate into phi weight        GT07 434
phi:=FLOAT(IP)#                        Store new phi estimate           GT07 435
NCON=NCON+1#                           Count connected generators       GT07 436
MLIM=MAX0(MLIM,NG)#                    Reset penetration limit          GT07 437
IF(KDMP==yes:)#                        Test for gener dump              GT07 438
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 GT07 439
J=IABS(IPHI-IP);  J=MIN0(J,360-J)#     Get smallest difference          GT07 440
IF(IPHI<0) J=0#                        Diff=0 if new phase              GT07 441
BUFOT(1)=phi:#                         Store new phase                  GT07 442
BUFOT(2)=wgt:#                         Store new weight                 GT07 443
BUFOT(3)=FLOAT(J)#                     Store phase diff                 GT07 444
intunpak:(pak:,K,0,9)#                 Unpack start/refined phase       GT07 445
IF(K>0)#                               Test phase present               GT07 446
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 GT07 447
I=IABS(K-IP); I=MIN0(I,360-I)#         Get diff new & refine phase      GT07 448
movechar:(GT12,1,GT8,12,3,0)#          Blank out possible ***           GT07 449
IF(I>45) movechar:(GT12,19,GT8,12,3,0)# Insert *** if diff large        GT07 450
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 GT07 451
BUFOT(4)=FLOAT(MOD(K,360))#            Store start/refine phase         GT07 452
ncodefld:(BUFOT,1,GT8,FM4,4)#          Format above items               GT07 453
writeline:(0,GT8,NGT8,3,3)#            Print new phase                  GT07 454
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 GT07 455
IF(IDMP(7)>0)#                         Test if phase map requested      GT07 456
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 GT07 457
I=IMAP+N1*NMAP#                        Point to map word                GT07 458
J=NINT(WGT*100.);   K=NINT(alp:)#      Integer weight & inv count       GT07 459
intpak:(IP,QX(I), 0,9)#                Pack phase   bits  8 - 0         GT07 460
intpak:(J ,QX(I), 9,9)#                Pack weight  bits 17 - 9         GT07 461
intpak:(K ,QX(I),18,bitlen:(18))#      Pack inv num bits ** -18         GT07 462
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 GT07 463
#                                                                       GT07 464
IF((TEST<1)\(IPHI<0)) NEXT#            Skip if not fom or known         GT07 465
NPHI=NPHI+IP#                          Sum total phi estimates          GT07 466
J=IABS(IPHI-IP); J=MIN0(J,360-J)#      Get smallest difference          GT07 467
IDIF=IDIF+J#                           Sum dif with prev phi            GT07 468
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 GT07 469
#                                                                       GT07 470
ELSE#                                  Else must be psi0 triplets       GT07 471
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 GT07 472
PSIA=PSIA+SQRT(AL2)#                   Sum actual psi0 alphas           GT07 473
PSIE=PSIE+alt:#                        Sum expected psi0 alphas         GT07 474
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 GT07 475
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 GT07 476
#                                                                       GT07 477
A2TH=A2TH*RATE#                        Reduce alpha**2 threshold        GT07 478
IF(NC<6) NEXT#                         Force min iterations             GT07 479
IF(SAL2<.1) BREAK#                     Exit if no connects              GT07 480
#                                                                       GT07 481
IF(IFOM==yes:)#                        Is fom pretest requested         GT07 482
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 GT07 483
IFOM=no:;  TEST=2;  NC=NC-1;   NEXT#   Reset test flags                 GT07 484
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 GT07 485
#                                                                       GT07 486
IF(TEST==1)#                           If final fom test                GT07 487
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 GT07 488
RFOM=MAX(.1,SUMB-SUMR)/MAX(.1,SUMA-SUMR)# Calc relative fom             GT07 489
IF(RFOM>FREJ(1)) IREJ=21#              Test rejection limit             GT07 490
RFAC=SUMD/SUMB#                        Calc karle rfactor               GT07 491
IF(RFAC>FREJ(2)) IREJ=22#              Test rejection limit             GT07 492
IF(PSIE>.1)#                           Test for psi0 triplets           GT07 493
APSI=PSIA/PSIE#                        Calculate psi0 fom value         GT07 494
ELSE APSI=-.00001#                     Psi(0) value unavailable         GT07 495
IF(APSI>FREJ(3)) IREJ=23#              Test for rejection               GT07 496
IF(RFOM<FREJ(5)) IREJ=24#              Test rejection limit             GT07 497
IF(IDMP(8)>0)#                         Test for fom dump                GT07 498
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 GT07 499
BUFOT(1)=FLOAT(NS)#                    Store rejection flag             GT07 500
BUFOT(2)=RFOM#                         Store rel fom                    GT07 501
BUFOT(3)=RFAC#                         Store r-factor                   GT07 502
BUFOT(4)=SUMB#                         Store sum alfexp tot             GT07 503
BUFOT(5)=SUMR#                         Store sum alfran tot             GT07 504
BUFOT(6)=SUMA#                         Store sum alpha                  GT07 505
BUFOT(7)=SUMD#                         Store sum alpha-alfexp           GT07 506
BUFOT(8)=PSIA#                         Store psi0 alpha                 GT07 507
BUFOT(9)=PSIE#                         Store psi0 alfexp                GT07 508
BUFOT(10)=APSI#                        Store psi0 fom                   GT07 509
ncodefld:(BUFOT,1,GT11,FM7,10)#        Format above items               GT07 510
writeline:(1,GT11,NGT11,3,3)#          Print final foms                 GT07 511
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 GT07 512
BREAK#                                 Exit after last fom test         GT07 513
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 GT07 514
ELSE IF(TEST==2)#                      Now if prelimonary test          GT07 515
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 GT07 516
RFOM=SUMB/SUMA#                        Calc pretest rel fom             GT07 517
IF(RFOM>PREJ3) IREJ=11#                Test rejection limit             GT07 518
RFAC=SUMD/SUMB#                        Calc karle rfactor               GT07 519
IF((RFOM>PREJ1)&(RFAC>PREJ2)) IREJ=12# Test rejection limit             GT07 520
IF(RFOM<FREJ(5)) IREJ=14#              Test rejection limit             GT07 521
IF(IDMP(8)>0)#                         Test for pretest fom dump        GT07 522
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 GT07 523
BUFOT(1)=FLOAT(NS)#                    Store rejection flag             GT07 524
BUFOT(2)=RFOM#                         Store rel fom                    GT07 525
BUFOT(3)=RFAC#                         Store r-factor                   GT07 526
BUFOT(4)=SUMB#                         Store sum alfexp part            GT07 527
BUFOT(5)=SUMR#                         Store sumfal ran part            GT07 528
BUFOT(6)=SUMA#                         Store sum alpha                  GT07 529
BUFOT(7)=SUMD#                         Store sum alpha-alfexp           GT07 530
BUFOT(8)=PREJ1#                        Store rej thr 1                  GT07 531
BUFOT(9)=PREJ2#                        Store rej thr 2                  GT07 532
BUFOT(10)=PREJ3#                       Store rej thr 3                  GT07 533
ncodefld:(BUFOT,1,GT10,FM7,10)#        Format above items               GT07 534
writeline:(1,GT10,NGT10,3,3)#          Print pretest foms               GT07 535
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 GT07 536
IF((EFOM==yes:)&(IREJ>0)) BREAK#       Exit if pretest failed           GT07 537
TEST=-1;  IREJ=0;   SAL2=TAL2#         Start next iteration if ok       GT07 538
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 GT07 539
#                                                                       GT07 540
A=ABS(SAL2-SOL2)/SAL2#                 Calc converge ratio              GT07 541
IF((TEST<0)&(A>CONV)) NEXT#            Recycle if not converged         GT07 542
IF(IACC==yes:) LGEN=MGEN#              Set last gen block limit         GT07 543
IF((MGEN<MQ)&(NC<MITR))#               Test if all gen used yet         GT07 544
MGEN=MIN0(MQ,MGEN+KGEN)#               Add gens as 1/4 list             GT07 545
ELSE TEST=TEST+1#                      Flag as final iterations         GT07 546
IF(TEST==0)#                           Test if 2nd test iteration       GT07 547
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 GT07 548
NF=10000#                              Release all fixed phases         GT07 549
MITR=NC+2#                             Set new iteration limit          GT07 550
MGEN=MQ;    LGEN=M1#                   Ensure all gens phased           GT07 551
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 GT07 552
ELSE IF(TEST==1)#                      Test iter release negq           GT07 553
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 GT07 554
MLIM=16777216## 2^24                  Enable all inv. incl negq         GT07 555
MGEN=MG;     LGEN=M1#                  Enable psi0 triplets             GT07 556
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 GT07 557
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GT07 558
IF(TEST<0) IREJ=25#                    Reject if refine incomplete      GT07 559
IF(IDMP(7)>0) ITMX=MITR#               Store pmap iter limit            GT07 560
#                                                                       GT07 561
#  END OF ITER LOOP -- OUTPUT PHASES ON FILE 3                          GT07 562
#  -------------------------------------------                          GT07 563
#                                                                       GT07 564
writepkt:(3,NS*2,15,IP)#               Set pointer for o/p packet       GT07 565
ANQ4=SQRT(FLOAT(MDIF/(MINV+1)))#       Calc av nq4 diff                 GT07 566
APHI=FLOAT(NPHI/(NCON+1))#             Calc mean phase                  GT07 567
QX(IP+1)=FLOAT(NS)#                    Store phase set number           GT07 568
QX(IP+2)=FLOAT(NCON)#                  Store ngen connected             GT07 569
QX(IP+3)=APHI#                         Store mean phase                 GT07 570
QX(IP+4)=FLOAT(IDIF/(NCON+1))#         Store test av phi dif            GT07 571
QX(IP+5)=SQRT(FLOAT(NDIF/(NINV+1)))#   Store rmsd phi all               GT07 572
QX(IP+6)=ANQ4#                         Store rmsd phi nq4               GT07 573
QX(IP+7)=FLOAT(NINV)#                  Store total invar test used      GT07 574
QX(IP+8)=FLOAT(MINV)#                  Store total negq  test used      GT07 575
QX(IP+9)=FLOAT(MITR)#                  Store number iterations          GT07 576
QX(IP+10)=RFOM#                        Store abs fom                    GT07 577
QX(IP+11)=RFAC#                        Store karle rfactor              GT07 578
QX(IP+12)=APSI#                        Store psi(0) value               GT07 579
IF(MINV==0) QX(IP+13)=-.0001#          Store null negq for max          GT07 580
ELSE        QX(IP+13)=QX(IP+6)#        Store negq for max/min           GT07 581
QX(IP+14)=FLOAT(IREJ)#                 Store rejection flag             GT07 582
IF(IREJ>0) NEXT#                       Skip phases if rejected          GT07 583
#                                                                       GT07 584
DO I=1,4#                              Loop over stored foms            GT07 585
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 GT07 586
J=IP+I+9#                              Point to stored fom              GT07 587
FMIN(I)=AMIN1(FMIN(I),QX(J))#          Find smallest fom                GT07 588
FMAX(I)=AMAX1(FMAX(I),QX(J))#          Find largest  fom                GT07 589
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 GT07 590
N=2*NS+1#                              Set phase set record number      GT07 591
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT07 592
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 GT07 593
writepkt:(3,N,2,IP)#                   Point to next o/p packet         GT07 594
QX(IP+1)=phi:#                         Store phase estimate             GT07 595
QX(IP+2)=wgt:#                         Store phase estimate weight      GT07 596
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 GT07 597
#                                                                       GT07 598
#    TEST FOR TERMINATION                                               GT07 599
#    --------------------                                               GT07 600
#                                                                       GT07 601
IF(NDMP(9)>=NS)  BREAK#                Forced termination of dump       GT07 602
IF(TMOS>0)       NEXT#                 Skip if termination flag off     GT07 603
IF(RFOM>FOPT(1)) NEXT#                 Skip if rfom too large           GT07 604
IF(RFAC>FOPT(2)) NEXT#                 Skip if rfac too large           GT07 605
IF(APSI>FOPT(3)) NEXT#                 Skip if apsi too large           GT07 606
IF(ANQ4>FOPT(4)) NEXT#                 Skip if negq too large           GT07 607
IF(MINV==0\APSI<0.) NEXT#              Skip if no negq or psi0          GT07 608
IF(APHI>45.)     BREAK#                Exit if all optimal              GT07 609
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT07 610
writepkt:(3,endrecord:,4,I)#           Finish off scratch file          GT07 611
#                                                                       GT07 612
RETURN#                                                                 GT07 613
END#                                                                    GT07 614
systemheader:(GT08)#                   Cascade extension/refinement     GT08   1
####################################################################    GT08   2
#                                                                  #    GT08   3
#                             GT08                                 #    GT08   4
#                                                                  #    GT08   5
####################################################################    GT08   6
SUBROUTINE GT08#                       S.r.hall  dec 81                 GT08   7
include:(AACOMN)#                                                       GT08   8
include:(GTCOMN)#                                                       GT08   9
#                                                                       GT08  10
INTEGER I,J,K,L,N,IP,IS,NS,NI,NC,IT#                                    GT08  11
INTEGER MLIM,NDIF,NPHI,NINV,IPHI,NCON,MGEN,KGEN#                        GT08  12
INTEGER IA,IB,PERM(10),N1,N2,N3,N4#                                     GT08  13
INTEGER MITR,IDIF,MDIF,MINV,TEST,IFOM#                                  GT08  14
INTEGER IREJ,LGEN,LREC,NBIAS,NF,NG#                                     GT08  15
REAL AL2,ANQ4,APHI,PREJ3,PSIA,SUMD,SUMN#                                GT08  16
REAL WGT,SSIN,SCOS,SAL2,PSIE,SUMX,DELX#                                 GT08  17
REAL A,B,SUMA,SUMB,A2TH,DAL2,PHI#                                       GT08  18
REAL SUME,WSUM,WMUL,PREJ1,PREJ2#                                        GT08  19
#                                                                       GT08  20
realdata:(SOL2,0.);  realdata:(TAL2,0.);  realdata:(RFOM,0.)#           GT08  21
realdata:(RFAC,0.);  realdata:(APSI,0.)#                                GT08  22
intdata:(IS2,[+1,-1,+1,-1,+1,-1,+1,-1])#                                GT08  23
intdata:(IS3,[+1,+1,-1,-1,+1,+1,-1,-1])#                                GT08  24
intdata:(IS4,[+1,+1,+1,+1,-1,-1,-1,-1])#                                GT08  25
intdata:(PRC,[9999,0,30,45,60,90,120,135,150,180])#                     GT08  26
realdata:(WTAB1,[1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,#                        GT08  27
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.])#                         GT08  28
realdata:(WTAB2,[.12,.30,.46,.60,.72,.82,.89,.94,.98,1.0,#              GT08  29
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,#                          GT08  30
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.])#                         GT08  31
datastuff:#                                                             GT08  32
#                                                                       GT08  33
#   INITIALIZE PHASING PARAMETERS                                       GT08  34
#   -----------------------------                                       GT08  35
#                                                                       GT08  36
N4=M1;   NBIAS=MG-M1+1#                Set dummy n4 for quartets        GT08  37
DAL2=AMIN1(A2MX/25.,1.)#               Calc al**2 incr for wgt          GT08  38
KGEN=MAX0(50,NGEN/4)*MARK#             Set refine block incr            GT08  39
DO I=1,24#                             Loop over weight table           GT08  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT08  41
A=SQRT(FLOAT(I)-.5)/2.#                Get weight increment             GT08  42
B=EXP(A)#                              Get exponential                  GT08  43
IF(ICNT==0) WTAB1(I)=A/2.5#            Calc acentric weight             GT08  44
ELSE        WTAB1(I)=(B-1./B)/(B+1./B)# Calc tanh(b/2) weight           GT08  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT08  46
DO I=1,28#                             For alf ratio > 1.               GT08  47
WTAB2(I+12)=EXP(-FLOAT(I-1)*PFAC)#     Generate weight scheme 2         GT08  48
SUMX=1000.;   DELX=360./FLOAT(NMAG)#   Set magic number intervals       GT08  49
DO I=1,10;  PERM(I)=0#                 Zero permutation array           GT08  50
PREJ1=FREJ(1)*XSHI; PREJ2=FREJ(2)*XSHI# Scale pretest fom limits        GT08  51
PREJ3=2.*PREJ1#                        Set rfom pretest limit           GT08  52
#                                                                       GT08  53
#   PHASE SET LOOP                                                      GT08  54
#   --------------                                                      GT08  55
#                                                                       GT08  56
DO NS=1,NPST#                          Loop over phase sets             GT08  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT08  58
#                                                                       GT08  59
#   GET STARTING PHASES                                                 GT08  60
#   -------------------                                                 GT08  61
#                                                                       GT08  62
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over gener list             GT08  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT08  64
phi:=-1.; wgt:=0.#                     Zero phase, weight, iter fix     GT08  65
intunpak:(pak:,K,25, 7)#               Get phase weight                 GT08  66
IF(K>0)#                               Test if starting phase           GT08  67
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT08  68
intunpak:(pak:,N, 0, 9)#               Get starting phase               GT08  69
phi:=FLOAT(MOD(N,360))#                Reset starting phase             GT08  70
wgt:=FLOAT(K)/16.#                     Reset phase weight               GT08  71
NEXT#                                  Skip to next generator           GT08  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT08  73
IF(TYPE!=0) NEXT#                      Skip if not random starter       GT08  74
SEED=MOD(SEED*25173+13849,65536)#      Generate random number           GT08  75
IPHI=MOD(SEED,360)#                    Convert to random phi 0-359      GT08  76
IF(prc:>1.5)#                          Test if phi restricted           GT08  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GT08  78
I=iprc:;  J=PRC(I)#                    Get phi restriction              GT08  79
K=IABS(IPHI-J);  K=MIN0(K,360-K)#      Get smallest difference          GT08  80
IF(K<90) IPHI=J#                       Set as closest restr             GT08  81
ELSE     IPHI=J+180#                   Set as closest restr             GT08  82
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GT08  83
phi:=FLOAT(IPHI)#                      Assign random phase              GT08  84
wgt:=RWGT#                             Assign random weight             GT08  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT08  86
#                                                                       GT08  87
#                                        ******* permute starters       GT08  88
L=0#                                   Progressive permute flag         GT08  89
IF(NMAG>1)#                            Test if magic starters           GT08  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GT08  91
SUMX=SUMX+DELX#                        Incr magic phase constant        GT08  92
IF(SUMX>360.) SUMX=0.1#                Reset initial magic x            GT08  93
ELSE          L=1#                     Disable other permutes           GT08  94
DO I=1,NPER#                           Loop over permutes               GT08  95
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GT08  96
IF(PERI(I)>0) NEXT#                    Skip non-magic permutes          GT08  97
J=PERN(I);  K=IABS(J)#                 Extract genlist pointer          GT08  98
phi:(K)=AMOD(phi:(K)+SUMX*FLOAT(-PERI(I)),360.)# Add permutation        GT08  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GT08 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GT08 101
FOR(I=1;I<=NPER;I=I+1)#                Loop over all permutes           GT08 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GT08 103
IF(PERI(I)<0) NEXT#                    Skip magic permutes              GT08 104
J=PERN(I);   K=IABS(J)#                Point to gener list              GT08 105
phi:(K)=AMOD(phi:(K)+FLOAT(PERM(I)),360.)# Add permutation              GT08 106
IF(L==1) NEXT#                         Skip further permutes            GT08 107
PERM(I)=PERM(I)+PERI(I)#               Increment permute phase          GT08 108
IF(((J>0)&(PERM(I)>=360))$#            Test for 2pi permute             GT08 109
\  ((J<0)&(PERM(I)>=LEDR)))PERM(I)=0#  Test for pi permute              GT08 110
ELSE L=1#                              Shutoff further permutes         GT08 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GT08 112
#                                                                       GT08 113
#    INITIALIZE PHASE SET PARAMETERS                                    GT08 114
#    -------------------------------                                    GT08 115
#                                                                       GT08 116
A2TH=A2MX#                             Reset al**2 threshold            GT08 117
TEST=-1;    IREJ=0#                    Reset iteration flag             GT08 118
MITR=MXIT#                             Reset iteration limit            GT08 119
MLIM=NLIM#                             Reset genlist penetration        GT08 120
MGEN=NCUT;   LGEN=M1#                  Reset genlist limit              GT08 121
NPHI=0;  IDIF=0;  SAL2=0.#             Reset accumulators               GT08 122
NDIF=0;   MDIF=0;   NINV=0;   MINV=0#  Reset fom accumulators           GT08 123
PSIA=0.;   PSIE=0.;   IFOM=yes:#       Reset fom accumulators           GT08 124
NF=0#                                  Reset iteration fix count        GT08 125
#                                                                       GT08 126
#   ITERATION LOOP                                                      GT08 127
#   --------------                                                      GT08 128
#                                                                       GT08 129
FOR(NC=1;NC<=MITR;NC=NC+1)#            Loop over phasing cycles         GT08 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GT08 131
NF=MAX0(NF,NC)#                        Set iteration fix limit          GT08 132
N1=0;   LREC=0#                        Reset generator count            GT08 133
IF(TEST<2) SOL2=SAL2#                  If not pretest reset old al2     GT08 134
ELSE       TAL2=SAL2#                  Else keep for later              GT08 135
SAL2=0.;  NCON=0#                      Reset al**2 & connects           GT08 136
SUMA=0.;  SUMD=0.;  SUMB=0.#           Reset fom sums                   GT08 137
#                                                                       GT08 138
#    GENERATOR LOOP                                                     GT08 139
#    --------------                                                     GT08 140
#                                                                       GT08 141
FOR(NG=M1;NG<MGEN;NG=NG+MARK)#         Loop over generator list         GT08 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GT08 143
N1=N1+1#                               Incr generator count             GT08 144
TOP=itop:;    BOT=ibot:#               Get si block limits              GT08 145
IF((NG<LGEN)&(wgt:>.9)) NEXT#          Skip reliable phi last block     GT08 146
intunpak:(pak:,I,9,6)#                 Extract iter fix-limit           GT08 147
IF((TEST<=0)&(NF<I)) NEXT#             Skip if phase fixed              GT08 148
IF(NG<MQ) IPHI=NINT(phi:)#             Get currnt phi fo test           GT08 149
SSIN=0.; SCOS=0.; SUMN=0.; SUME=0.#    Zero sincos sums                 GT08 150
#                                                                       GT08 151
#   INVARIANT LOOP                                                      GT08 152
#   --------------                                                      GT08 153
#                                                                       GT08 154
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        GT08 155
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GT08 156
N2=NINT(QX(NI+2))#                     Extract n2 genlist address       GT08 157
IF(N2>MLIM) BREAK#                     Exit if beyond limit             GT08 158
IF(N2>MG) N2=N2-NBIAS#                 Adjust n2 for negq4              GT08 159
IF(wgt:(N2)<WMIN) NEXT#                Skip unphased generator          GT08 160
N3=NINT(QX(NI+3))#                     Extract n3 genlist address       GT08 161
IF(wgt:(N3)<WMIN) NEXT#                Skip unphased generator          GT08 162
WMUL=2.*wgt:(N2)*wgt:(N3)#             Product triplet weights          GT08 163
WSUM=wgt:(N2)+wgt:(N3)#                Sum of triplet weights           GT08 164
intunpak:(QX(NI+1),IT, 0, 2)#          Extract invariant type           GT08 165
IF(IT>1)#                              Test if active quartet           GT08 166
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GT08 167
N4=NINT(QX(NI+4))#                     Extract n4 genlist address       GT08 168
IF(wgt:(N4)<WMIN) NEXT#                Skip unphased generator          GT08 169
WMUL=1.5*WMUL*wgt:(N4)#                Product quartet weight           GT08 170
WSUM=WSUM+wgt:(N4)#                    Sum of quartet weights           GT08 171
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GT08 172
WGT=WMUL/WSUM#                         Calculate weight of cos(psi)     GT08 173
intunpak:(QX(NI+1),IP, 9, 9)#          Extract shift-qpsi-negq          GT08 174
intunpak:(QX(NI+1),IA,25, 7)#          Extract modified a or b          GT08 175
A=FLOAT(IA)*WGT*.125#                  Form total inv weight            GT08 176
IF((IWGT>1)\(TEST>0))#                 Test if weight scheme 2 or 3     GT08 177
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GT08 178
intunpak:(QX(NI+1),IB,18, 7)#          Extract probf *64                GT08 179
SUME=SUME+FLOAT(IB)*A#                 Sum weighted a*probf             GT08 180
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GT08 181
IF(ICNT==1)#                           Test if centrosymmetric          GT08 182
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GT08 183
ifne:(phi:(N2),phi:(N3)) A=-A#         Reverse sign if diff =pi         GT08 184
IF(IP>0)                 A=-A#         Reverse sign if shift=pi         GT08 185
IF((IT>1)&(phi:(N4)>.5)) A=-A#         Reverse sign if phi4 =pi         GT08 186
IF(IT!=NEGQ) SCOS=SCOS+A#              Sum tangent denominator          GT08 187
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GT08 188
ELSE#                                  Else phases noncentrosymmetr     GT08 189
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GT08 190
intunpak:(QX(NI+1),IS, 2, 3); IS=IS+1# Extract phi sign code            GT08 191
IF(IS2(IS)>0)         PHI=    phi:(N2)# Test if  phi2 is +ve            GT08 192
ELSE                  PHI=   -phi:(N2)# Else     phi2 is -ve            GT08 193
IF(IS3(IS)>0)         PHI=PHI+phi:(N3)## Test if  phi3 is +ve           GT08 194
ELSE                  PHI=PHI-phi:(N3)## Else     phi3 is -ve           GT08 195
IF((IT>1)&(IS4(IS)>0))PHI=PHI+phi:(N4)## Test if  phi4 is +ve           GT08 196
ELSE IF(IT>1)         PHI=PHI-phi:(N4)## Else     phi4 is -ve           GT08 197
J=MOD(3600-NINT(PHI)-IP,360)+M0#       Phase est for invariant          GT08 198
IF(IT!=NEGQ)#                          Test if active invariant         GT08 199
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GT08 200
SSIN=SSIN+A*QX(J+1)#                   Sum  sin component               GT08 201
SCOS=SCOS+A*QX(J+91)#                  Sum  cos component               GT08 202
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GT08 203
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GT08 204
SUMN=SUMN+1.#                          Count invariants used            GT08 205
#                                                                       GT08 206
IF((IT==PSI0)\(TEST!=1)\(IPHI<0)) NEXT# Skip if psi0 or pretest         GT08 207
IF(ICNT==1) J=90-NINT(SIGN(90.,A))+M0## Get phase for centro            GT08 208
J=IABS(IPHI-J+M0); J=MIN0(J,360-J)#    Get smallest difference          GT08 209
NINV=NINV+1#                           Count all invariants             GT08 210
NDIF=NDIF+J**2#                        Sum new/old differences          GT08 211
IF(IT!=NEGQ) NEXT#                     Skip if t3 or pq4                GT08 212
MINV=MINV+1#                           Count neg quartets               GT08 213
MDIF=MDIF+J**2#                        Sum phi differences              GT08 214
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GT08 215
#                                                                       GT08 216
#                                                                       GT08 217
#    END INV LOOP -- ASSESS PHASE                                       GT08 218
#    ---------------------------                                        GT08 219
#                                                                       GT08 220
IF(SUMN<.5) NEXT#                      Skip if no connects              GT08 221
AL2=SSIN**2 + SCOS**2#                 Calculate alpha squared          GT08 222
SAL2=SAL2+AL2#                         Sum alpha squared                GT08 223
SUME=SUME/64.#                         Remove packing factor            GT08 224
#                                                                       GT08 225
IF(NG<MQ)#                             If normal gens (not psi0)        GT08 226
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GT08 227
IF(TEST>0)#                            If fom test or dump              GT08 228
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GT08 229
A=SQRT(AL2)#                           Calculate alpha                  GT08 230
SUMA=SUMA+A#                           Sum actual alphas                GT08 231
SUMB=SUMB+SUME#                        Sum expect alphas                GT08 232
SUMD=SUMD+ABS(A-SUME)#                 Sum diff in alpha                GT08 233
IF(TEST==2) NEXT#                      Skip if pre-test                 GT08 234
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GT08 235
#                                                                       GT08 236
IF(AL2<A2TH) NEXT#                     Skip if al**2 below thresh       GT08 237
IF(ICNT==1) IP=90-NINT(SIGN(90.,SCOS))# Convert centro ccos to deg.     GT08 238
ELSE#                                  Else calc noncentro phase        GT08 239
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GT08 240
IF((ABS(SSIN)<.01)&(ABS(SCOS)<.01))NEXT# Skip if phi uncertain          GT08 241
B=ATAN2(SSIN,SCOS)*57.2957795#         Calc phi est in degrees          GT08 242
IP=MOD(360+NINT(B),360)#               Phi as modulo 360                GT08 243
IF(prc:>1.5)#                          Test if phi restricted           GT08 244
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GT08 245
I=iprc:;  J=PRC(I)#                    Get phi restriction              GT08 246
K=IABS(IP-J);  K=MIN0(K,360-K)#        Get smalllest difference         GT08 247
IF(K==90) NEXT#                        Skip if ambiguous                GT08 248
IF(K<90) IP=J#                         Set as closest restr             GT08 249
ELSE     IP=J+180#                     Set as closest restr             GT08 250
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GT08 251
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GT08 252
IF(IWGT>1)#                            Test if weight 2 or 3            GT08 253
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GT08 254
IF(IWGT==2)#                           Get table index on ratio**2      GT08 255
I=MIN0(40,INT(AL2*10./SUME**2)+1)#     Get index for x**2               GT08 256
ELSE#                                  Get table index on ratio         GT08 257
I=MIN0(40,INT(SQRT(AL2)*10./SUME)+1)#  Get index for x                  GT08 258
WGT=WTAB2(I)#                          Store weight 2                   GT08 259
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GT08 260
ELSE#                                  Else apply weight 1              GT08 261
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GT08 262
I=MIN0(25,INT(AL2/DAL2)+1)#            Form index from alpha**2         GT08 263
WGT=WTAB1(I)#                          Store weight 1                   GT08 264
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GT08 265
IF((TYPE==0)&(WGT<RWGT)) NEXT#         Skip if new ran wgt < start      GT08 266
wgt:=WGT#                              Translate into phi weight        GT08 267
phi:=FLOAT(IP)#                        Store new phi estimate           GT08 268
NCON=NCON+1#                           Count connected generators       GT08 269
MLIM=MAX0(MLIM,NG)#                    Reset penetration limit          GT08 270
#                                                                       GT08 271
IF((TEST<1)\(IPHI<0)) NEXT#            Skip if not fom or known         GT08 272
NPHI=NPHI+IP#                          Sum total phi estimates          GT08 273
J=IABS(IPHI-IP);  J=MIN0(J,360-J)#     Get smallest difference          GT08 274
IDIF=IDIF+J#                           Sum dif with prev phi            GT08 275
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GT08 276
ELSE#                                  These are psi0 triplets          GT08 277
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GT08 278
PSIA=PSIA+SQRT(AL2)#                   Sum psi0 alphas                  GT08 279
PSIE=PSIE+SUME#                        Sum expected psi0 alphas         GT08 280
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GT08 281
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GT08 282
#                                                                       GT08 283
#   END GEN LOOP -- ADJUST CYCLE LIMITS                                 GT08 284
#   -----------------------------------                                 GT08 285
#                                                                       GT08 286
A2TH=A2TH*RATE#                        Reduce alpha**2 threshold        GT08 287
IF(NC<6) NEXT#                         Force min iterations             GT08 288
IF(SAL2<.1) BREAK#                     Exit if no connects              GT08 289
#                                                                       GT08 290
IF(IFOM==yes:)#                        Is fom pretest requested         GT08 291
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 GT08 292
IFOM=no:;  TEST=2;  NC=NC-1;  NEXT#    Reset test flags & recycle       GT08 293
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 GT08 294
#                                                                       GT08 295
IF(TEST==1)#                           If final fom test                GT08 296
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 GT08 297
RFOM=MAX(.1,SUMB-SUMR)/MAX(.1,SUMA-SUMR)# Calc relative fom             GT08 298
IF(RFOM>FREJ(1)) IREJ=21#              Test rejection limit             GT08 299
RFAC=SUMD/SUMB#                        Calc karle rfactor               GT08 300
IF(RFAC>FREJ(2)) IREJ=22#              Test rejection limit             GT08 301
IF(PSIE>.1)#                           Test for psi0 triplets           GT08 302
APSI=PSIA/PSIE#                        Calculate psi0 fom value         GT08 303
ELSE APSI=-.00001#                     Psi(0) value unavailable         GT08 304
IF(APSI>FREJ(3)) IREJ=23#              Test for rejection               GT08 305
IF(RFOM<FREJ(5)) IREJ=24#              Test rejection limit             GT08 306
BREAK#                                 Exit after last fom test         GT08 307
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 GT08 308
ELSE IF(TEST==2)#                      Now if prelimonary test          GT08 309
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 GT08 310
RFOM=SUMB/AMAX1(.1,SUMA)#              Calc relative fom                GT08 311
IF(RFOM>PREJ3) IREJ=11#                Test rejection limit             GT08 312
RFAC=SUMD/SUMB#                        Calc karle rfactor               GT08 313
IF((RFOM>PREJ1)&(RFAC>PREJ2)) IREJ=12# Test rejection limit             GT08 314
IF(RFOM<FREJ(5)) IREJ=14#              Test rejection limit             GT08 315
IF((EFOM==yes:)&(IREJ>0)) BREAK#       Exit if foms rejected            GT08 316
TEST=-1;    IREJ=0;   SAL2=TAL2#       Start next iter if ok            GT08 317
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 GT08 318
#                                                                       GT08 319
A=ABS(SAL2-SOL2)/SAL2#                 Calc converge ratio              GT08 320
IF((TEST<0)&(A>CONV)) NEXT#            Recycle if not converged         GT08 321
IF(IACC==yes:) LGEN=MGEN#              Reset to last block limit        GT08 322
IF((MGEN<MQ)&(NC<MITR))#               Test if all gen used yet         GT08 323
MGEN=MIN0(MQ,MGEN+KGEN)#               Add gens as 1/4 list             GT08 324
ELSE TEST=TEST+1#                      Flag as final iterations         GT08 325
IF(TEST==0)#                           Test if 2nd test iteration       GT08 326
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 GT08 327
NF=10000#                              Release all fixed phases         GT08 328
MITR=NC+2#                             Set new iteration limit          GT08 329
MGEN=MQ;   LGEN=M1#                    Ensure all gens phased           GT08 330
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 GT08 331
ELSE IF(TEST==1)#                      Test iter release negq           GT08 332
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 GT08 333
MLIM=16777216## 2^24                  Enable all inv. incl negq         GT08 334
MGEN=MG;   LGEN=M1#                    Enable psi0 triplets             GT08 335
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 GT08 336
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GT08 337
IF(TEST<0) IREJ=25#                    Reject if refine incomplete      GT08 338
#                                                                       GT08 339
#  END OF ITER LOOP -- OUTPUT PHASES ON FILE 3                          GT08 340
#  -------------------------------------------                          GT08 341
#                                                                       GT08 342
writepkt:(3,NS*2,15,IP)#               Set pointer for o/p packet       GT08 343
ANQ4=SQRT(FLOAT(MDIF/(MINV+1)))#       Calc av nq4 diff                 GT08 344
APHI=FLOAT(NPHI/(NCON+1))#             Calc mean phase                  GT08 345
QX(IP+1)=FLOAT(NS)#                    Store phase set number           GT08 346
QX(IP+2)=FLOAT(NCON)#                  Store ngen connected             GT08 347
QX(IP+3)=APHI#                         Store mean phase                 GT08 348
QX(IP+4)=FLOAT(IDIF/(NCON+1))#         Store test av phi dif            GT08 349
QX(IP+5)=SQRT(FLOAT(NDIF/(NINV+1)))#   Store rmsd phi all               GT08 350
QX(IP+6)=ANQ4#                         Store rmsd phi nq4               GT08 351
QX(IP+7)=FLOAT(NINV)#                  Store total invar test used      GT08 352
QX(IP+8)=FLOAT(MINV)#                  Store total negq  test used      GT08 353
QX(IP+9)=FLOAT(MITR)#                  Store number iterations          GT08 354
QX(IP+10)=RFOM#                        Store abs fom                    GT08 355
QX(IP+11)=RFAC#                        Store karle rfactor              GT08 356
QX(IP+12)=APSI#                        Store psi(0) value               GT08 357
IF(MINV==0) QX(IP+13)=-.0001#          Store null negq for max          GT08 358
ELSE        QX(IP+13)=QX(IP+6)#        Store negq for max/min           GT08 359
QX(IP+14)=FLOAT(IREJ)#                 Store rejection flag             GT08 360
IF(IREJ>0) NEXT#                       Skip phases if rejected          GT08 361
#                                                                       GT08 362
DO I=1,4#                              Loop over stored foms            GT08 363
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 GT08 364
J=IP+I+9#                              Point to stored fom              GT08 365
FMIN(I)=AMIN1(FMIN(I),QX(J))#          Find smallest fom                GT08 366
FMAX(I)=AMAX1(FMAX(I),QX(J))#          Find largest  fom                GT08 367
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 GT08 368
N=2*NS+1#                              Set phase set record number      GT08 369
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT08 370
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 GT08 371
writepkt:(3,N,2,IP)#                   Point to next o/p packet         GT08 372
QX(IP+1)=phi:#                         Store phase estimate             GT08 373
QX(IP+2)=wgt:#                         Store phase estimate weight      GT08 374
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 GT08 375
#                                                                       GT08 376
#    TEST FOR TERMINATION                                               GT08 377
#    --------------------                                               GT08 378
#                                                                       GT08 379
IF(TMOS>0)       NEXT#                 Skip if termination flag off     GT08 380
IF(RFOM>FOPT(1)) NEXT#                 Skip if rfom too large           GT08 381
IF(RFAC>FOPT(2)) NEXT#                 Skip if rfac too large           GT08 382
IF(APSI>FOPT(3)) NEXT#                 Skip if apsi too large           GT08 383
IF(ANQ4>FOPT(4)) NEXT#                 Skip if negq too large           GT08 384
IF(MINV==0\APSI<0.) NEXT#              Skip if no negq or psi0          GT08 385
IF(APHI>45.)     BREAK#                Exit if all optimal              GT08 386
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT08 387
writepkt:(3,endrecord:,4,I)#           Finish off scratch file          GT08 388
#                                                                       GT08 389
RETURN#                                                                 GT08 390
END#                                                                    GT08 391
systemheader:(GT09)#                   Block extension/refinement       GT09   1
####################################################################    GT09   2
#                                                                  #    GT09   3
#                             GT09                                 #    GT09   4
#                                                                  #    GT09   5
####################################################################    GT09   6
SUBROUTINE GT09#                       S.r.hall  dec 81                 GT09   7
include:(AACOMN)#                                                       GT09   8
include:(GTCOMN)#                                                       GT09   9
#                                                                       GT09  10
INTEGER I,J,K,L,N,IP,IS,NS,NI,NC,IT#                                    GT09  11
INTEGER MLIM,NDIF,NPHI,NINV,IPHI,NCON,MGEN,KGEN#                        GT09  12
INTEGER IA,IB,PERM(10),N1,N2,N3,N4#                                     GT09  13
INTEGER MITR,IDIF,MDIF,MINV,TEST,IFOM#                                  GT09  14
INTEGER IREJ,LGEN,LREC,NBIAS,NF,NG#                                     GT09  15
REAL AL2,ANQ4,APHI,PREJ3,PSIA,SUMD#                                     GT09  16
REAL SUMX,DELX,SUMB,PSIE#                                               GT09  17
REAL WGT,SSIN,SCOS,SAL2,SUMN#                                           GT09  18
REAL A,B,SUMA,A2TH,DAL2,PHI#                                            GT09  19
REAL SUME,WSUM,WMUL,PREJ1,PREJ2#                                        GT09  20
#                                                                       GT09  21
realdata:(SOL2,0.);  realdata:(TAL2,0.);  realdata:(RFOM,0.)#           GT09  22
realdata:(RFAC,0.);  realdata:(APSI,0.)#                                GT09  23
intdata:(IS2,[+1,-1,+1,-1,+1,-1,+1,-1])#                                GT09  24
intdata:(IS3,[+1,+1,-1,-1,+1,+1,-1,-1])#                                GT09  25
intdata:(IS4,[+1,+1,+1,+1,-1,-1,-1,-1])#                                GT09  26
intdata:(PRC,[9999,0,30,45,60,90,120,135,150,180])#                     GT09  27
realdata:(WTAB1,[1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,#                        GT09  28
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.])#                         GT09  29
realdata:(WTAB2,[.12,.30,.46,.60,.72,.82,.89,.94,.98,1.0,#              GT09  30
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,#                          GT09  31
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.])#                         GT09  32
datastuff:#                                                             GT09  33
#                                                                       GT09  34
#   INITIALIZE PHASING PARAMETERS                                       GT09  35
#   -----------------------------                                       GT09  36
#                                                                       GT09  37
N4=M1;    NBIAS=MG-M1+1#               Set dummy n4 for quartets        GT09  38
DAL2=AMIN1(A2MX/25.,1.)#               Calc al**2 incr for wgt          GT09  39
KGEN=MAX0(50,NGEN/4)*MARK#             Set refine block incr            GT09  40
DO I=1,24#                             Loop over weight table           GT09  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT09  42
A=SQRT(FLOAT(I)-.5)/2.#                Get weight increment             GT09  43
B=EXP(A)#                              Get exponential                  GT09  44
IF(ICNT==0) WTAB1(I)=A/2.5#            Calc acentric weight             GT09  45
ELSE        WTAB1(I)=(B-1./B)/(B+1./B)# Calc tanh(b/2) weight           GT09  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT09  47
DO I=1,28#                             For alf ratio > 1.               GT09  48
WTAB2(I+12)=EXP(-FLOAT(I-1)*PFAC)#     Generate weight scheme 2         GT09  49
SUMX=1000.;   DELX=360./FLOAT(NMAG)#   Set magic number intervals       GT09  50
DO I=1,10;  PERM(I)=0#                 Zero permutation array           GT09  51
PREJ1=FREJ(1)*XSHI; PREJ2=FREJ(2)*XSHI# Scale pretest fom limits        GT09  52
PREJ3=2.*PREJ1#                        Get rfom pretest limit           GT09  53
#                                                                       GT09  54
#   PHASE SET LOOP                                                      GT09  55
#   --------------                                                      GT09  56
#                                                                       GT09  57
DO NS=1,NPST#                          Loop over phase sets             GT09  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT09  59
#                                                                       GT09  60
#   GET STARTING PHASES                                                 GT09  61
#   -------------------                                                 GT09  62
#                                                                       GT09  63
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over gener list             GT09  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT09  65
phi:=-1.; wgt:=0.#                     Zero phase, weight, iter fix     GT09  66
intunpak:(pak:,K,25, 7)#               Get phase weight                 GT09  67
IF(K>0)#                               Test if starting phase           GT09  68
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT09  69
intunpak:(pak:,N, 0, 9)#               Get starting phase               GT09  70
phi:=FLOAT(MOD(N,360))#                Reset starting phase             GT09  71
wgt:=FLOAT(K)/16.#                     Reset phase weight               GT09  72
NEXT#                                  Skip to next generator           GT09  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT09  74
IF(TYPE!=0) NEXT#                      Skip if not random starter       GT09  75
SEED=MOD(SEED*25173+13849,65536)#      Generate random number           GT09  76
IPHI=MOD(SEED,360)#                    Convert to random phi 0-359      GT09  77
IF(prc:>1.5)#                          Test if phi restricted           GT09  78
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GT09  79
I=iprc:;  J=PRC(I)#                    Get phi restriction              GT09  80
K=IABS(IPHI-J);  K=MIN0(K,360-K)#      Get smallest difference          GT09  81
IF(K<90) IPHI=J#                       Set as closest restr             GT09  82
ELSE     IPHI=J+180#                   Set as closest restr             GT09  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GT09  84
phi:=FLOAT(IPHI)#                      Assign random phase              GT09  85
wgt:=RWGT#                             Assign random weight             GT09  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT09  87
#                                                                       GT09  88
#                                        ******* permute starters       GT09  89
L=0#                                   Progressive permute flag         GT09  90
IF(NMAG>1)#                            Test if magic starters           GT09  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GT09  92
SUMX=SUMX+DELX#                        Incr magic phase constant        GT09  93
IF(SUMX>360.) SUMX=0.1#                Reset initial magic x            GT09  94
ELSE          L=1#                     Disable other permutes           GT09  95
DO I=1,NPER#                           Loop over permutes               GT09  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GT09  97
IF(PERI(I)>0) NEXT#                    Skip non-magic permutes          GT09  98
J=PERN(I);  K=IABS(J)#                 Extract genlist pointer          GT09  99
phi:(K)=AMOD(phi:(K)+SUMX*FLOAT(-PERI(I)),360.)# Add permutation        GT09 100
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GT09 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GT09 102
FOR(I=1;I<=NPER;I=I+1)#                Loop over all permutes           GT09 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GT09 104
IF(PERI(I)<0) NEXT#                    Skip magic permutes              GT09 105
J=PERN(I);   K=IABS(J)#                Point to gener list              GT09 106
phi:(K)=AMOD(phi:(K)+FLOAT(PERM(I)),360.)# Add permutation              GT09 107
IF(L==1) NEXT#                         Skip further permutes            GT09 108
PERM(I)=PERM(I)+PERI(I)#               Increment permute phase          GT09 109
IF(((J>0)&(PERM(I)>=360))$#            Test for 2pi permute             GT09 110
\  ((J<0)&(PERM(I)>=LEDR)))PERM(I)=0#  Test for pi permute              GT09 111
ELSE L=1#                              Shutoff further permutes         GT09 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GT09 113
#                                                                       GT09 114
#    INITIALIZE PHASE SET PARAMETERS                                    GT09 115
#    -------------------------------                                    GT09 116
#                                                                       GT09 117
A2TH=A2MX#                             Reset al**2 threshold            GT09 118
TEST=-1;    IREJ=0#                    Reset iteration flag             GT09 119
MITR=MXIT#                             Reset iteration limit            GT09 120
MLIM=NLIM#                             Reset genlist penetration        GT09 121
MGEN=NCUT;     LGEN=M1#                Reset genlist limit              GT09 122
NPHI=0;  IDIF=0;  SAL2=0.#             Reset accumulators               GT09 123
NDIF=0;   MDIF=0;   NINV=0;   MINV=0#  Reset fom accumulators           GT09 124
PSIA=0.;   PSIE=0.;   IFOM=yes:#       Reset fom accumulators           GT09 125
NF=0#                                  Reset iteration fix count        GT09 126
#                                                                       GT09 127
#   ITERATION LOOP                                                      GT09 128
#   --------------                                                      GT09 129
#                                                                       GT09 130
FOR(NC=1;NC<=MITR;NC=NC+1)#            Loop over phasing cycles         GT09 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GT09 132
NF=MAX0(NF,NC)#                        Set iteration fix limit          GT09 133
N1=0;   LREC=0#                        Reset generator count            GT09 134
IF(TEST<2) SOL2=SAL2#                  Reset old al2 if not pret        GT09 135
ELSE       TAL2=SAL2#                  Else save curr al2 later         GT09 136
SAL2=0.;  NCON=0#                      Reset al**2 & connects           GT09 137
SUMA=0.;  SUMD=0.;  SUMB=0.#           Reset fom sums                   GT09 138
#                                                                       GT09 139
#    GENERATOR LOOP                                                     GT09 140
#    --------------                                                     GT09 141
#                                                                       GT09 142
FOR(NG=M1;NG<MGEN;NG=NG+MARK)#         Loop over generator list         GT09 143
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GT09 144
N1=N1+1#                               Incr generator count             GT09 145
TOP=itop:;    BOT=ibot:#               Get si block limits              GT09 146
alp:=0.#                               Reset invariant count            GT09 147
IF((NG<LGEN)&(wgt:>.9)) NEXT#          Skip stable phis last block      GT09 148
intunpak:(pak:,I,9,6)#                 Extract iter fix limit           GT09 149
IF((TEST<=0)&(I>NF)) NEXT#             Test if this phase fixed         GT09 150
IF(NG<MQ) IPHI=NINT(phi:)#             Get current phi value            GT09 151
SSIN=0.; SCOS=0.; SUMN=0.; SUME=0.#    Zero sincos sums                 GT09 152
#                                                                       GT09 153
#   INVARIANT LOOP                                                      GT09 154
#   --------------                                                      GT09 155
#                                                                       GT09 156
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        GT09 157
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GT09 158
N2=NINT(QX(NI+2))#                     Extract n2 genlist address       GT09 159
IF(N2>MLIM) BREAK#                     Exit if beyond limit             GT09 160
IF(N2>MG) N2=N2-NBIAS#                 Adjust n2 for negq4              GT09 161
IF(wgt:(N2)<WMIN) NEXT#                Skip unphased generator          GT09 162
N3=NINT(QX(NI+3))#                     Extract n3 genlist address       GT09 163
IF(wgt:(N3)<WMIN) NEXT#                Skip unphased generator          GT09 164
WMUL=2.*wgt:(N2)*wgt:(N3)#             Product triplet weights          GT09 165
WSUM=wgt:(N2)+wgt:(N3)#                Sum of triplet weights           GT09 166
intunpak:(QX(NI+1),IT, 0, 2)#          Extract invariant type           GT09 167
IF(IT>1)#                              Test if active quartet           GT09 168
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GT09 169
N4=NINT(QX(NI+4))#                     Extract n4 genlist address       GT09 170
IF(wgt:(N4)<WMIN) NEXT#                Skip unphased generator          GT09 171
WMUL=1.5*WMUL*wgt:(N4)#                Product quartet weight           GT09 172
WSUM=WSUM+wgt:(N4)#                    Sum of quartet weights           GT09 173
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GT09 174
WGT=WMUL/WSUM#                         Calculate weight of cos(psi)     GT09 175
intunpak:(QX(NI+1),IP, 9, 9)#          Extract shift-qpsi-negq          GT09 176
intunpak:(QX(NI+1),IA,25, 7)#          Extract modified a or b *8       GT09 177
A=FLOAT(IA)*WGT*0.125#                 Form total inv weight            GT09 178
IF((IWGT>1)\(TEST>0))#                 Test if weight scheme 2 or 3     GT09 179
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GT09 180
intunpak:(QX(NI+1),IB,18, 7)#          Extract probf *64                GT09 181
SUME=SUME+FLOAT(IB)*A#                 Sum weighted a*probf             GT09 182
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GT09 183
IF(ICNT==1)#                           Test if centrosymmetric          GT09 184
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GT09 185
ifne:(phi:(N2),phi:(N3)) A=-A#         Reverse sign if diff =pi         GT09 186
IF(IP>0)                 A=-A#         Reverse sign if shift=pi         GT09 187
IF((IT>1)&(phi:(N4)>.5)) A=-A#         Reverse sign if phi4 =pi         GT09 188
IF(IT!=NEGQ) SCOS=SCOS+A#              Sum tangent denominator          GT09 189
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GT09 190
ELSE#                                  Else phases noncentrosymmetr     GT09 191
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GT09 192
intunpak:(QX(NI+1),IS, 2, 3); IS=IS+1# Extract phi sign code            GT09 193
IF(IS2(IS)>0)         PHI=    phi:(N2)# Test if  phi2 is +ve            GT09 194
ELSE                  PHI=   -phi:(N2)# Else     phi2 is -ve            GT09 195
IF(IS3(IS)>0)         PHI=PHI+phi:(N3)## Test if  phi3 is +ve           GT09 196
ELSE                  PHI=PHI-phi:(N3)## Else     phi3 is -ve           GT09 197
IF((IT>1)&(IS4(IS)>0))PHI=PHI+phi:(N4)## Test if  phi4 is +ve           GT09 198
ELSE IF(IT>1)         PHI=PHI-phi:(N4)## Else     phi4 is -ve           GT09 199
J=MOD(3600-NINT(PHI)-IP,360)+M0#       Phase est for invariant          GT09 200
IF(IT!=NEGQ)#                          Test if active invariant         GT09 201
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GT09 202
SSIN=SSIN+A*QX(J+1)#                   Sum  sin component               GT09 203
SCOS=SCOS+A*QX(J+91)#                  Sum  cos component               GT09 204
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GT09 205
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GT09 206
SUMN=SUMN+1.#                          Count invariants used            GT09 207
#                                                                       GT09 208
IF((IT==PSI0)\(TEST!=1)\(IPHI<0)) NEXT# Skip if psi0 or pretest         GT09 209
IF(ICNT==1) J=90-NINT(SIGN(90.,A))+M0## Get phase for centro            GT09 210
J=IABS(IPHI-J+M0); J=MIN0(J,360-J)#    Get smallest difference          GT09 211
NINV=NINV+1#                           Count all invariants             GT09 212
NDIF=NDIF+J**2#                        Sum new/old differences          GT09 213
IF(IT!=NEGQ) NEXT#                     Skip if t3 or pq4                GT09 214
MINV=MINV+1#                           Count neg quartets               GT09 215
MDIF=MDIF+J**2#                        Sum phi differences              GT09 216
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GT09 217
#                                                                       GT09 218
#                                                                       GT09 219
#    END INV LOOP -- STORE GENERATOR SUMS                               GT09 220
#    ---------------------------                                        GT09 221
#                                                                       GT09 222
sin:=SSIN;  cos:=SCOS#                 Store tangent numer & denom      GT09 223
alt:=SUME/64.;  alp:=SUMN#             Store alfex & count              GT09 224
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GT09 225
#                                                                       GT09 226
#   END GEN LOOP -- CALC PHASE VALUES                                   GT09 227
#   ---------------------------------                                   GT09 228
#                                                                       GT09 229
N1=0#                                  Reset generator counter          GT09 230
FOR(NG=M1;NG<MGEN;NG=NG+MARK)#         Loop over generator list         GT09 231
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GT09 232
N1=N1+1#                               Count generators                 GT09 233
IF(alp:<.5) NEXT#                      Skip if no estimate              GT09 234
SSIN=sin:;   SCOS=cos:#                Make sums local variables        GT09 235
AL2=SSIN**2 + SCOS**2#                 Calculate alpha squared          GT09 236
SAL2=SAL2+AL2#                         Sum alpha squared                GT09 237
IF(NG<MQ)#                             If normal gens (not psi0)        GT09 238
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GT09 239
IF(TEST>0)#                            If fom test iteration            GT09 240
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GT09 241
A=SQRT(AL2)#                           Calculate alpha                  GT09 242
SUMA=SUMA+A#                           Sum alpha                        GT09 243
SUMB=SUMB+alt:#                        Sum expected alpha               GT09 244
SUMD=SUMD+ABS(A-alt:)#                 Sum alpha diff for rfac          GT09 245
IF(TEST==2) NEXT#                      Skip phi calc for pretest        GT09 246
IPHI=NINT(phi:)#                       Get current phi for test         GT09 247
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GT09 248
#                                                                       GT09 249
IF(AL2<A2TH) NEXT#                     Skip if al**2 below thresh       GT09 250
IF(ICNT==1) IP=90-NINT(SIGN(90.,SCOS))# Convert centro ccos to deg.     GT09 251
ELSE#                                  Else calc noncentro phase        GT09 252
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GT09 253
IF((ABS(SSIN)<.01)&(ABS(SCOS)<.01))NEXT# Skip if phi uncertain          GT09 254
B=ATAN2(SSIN,SCOS)*57.2957795#         Calc phi est in degrees          GT09 255
IP=MOD(360+NINT(B),360)#               Phi as modulo 360                GT09 256
IF(prc:>1.5)#                          Test if phi restricted           GT09 257
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GT09 258
I=iprc:;  J=PRC(I)#                    Get phi restriction              GT09 259
K=IABS(IP-J);  K=MIN0(K,360-K)#        Get smallest difference          GT09 260
IF(K==90) NEXT#                        Skip if ambiguous                GT09 261
IF(K<90) IP=J#                         Set as closest restr             GT09 262
ELSE     IP=J+180#                     Set as closest restr             GT09 263
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GT09 264
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GT09 265
IF(IWGT>1)#                            Test if weight 2 or 3            GT09 266
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GT09 267
IF(IWGT==2)#                           Get table index on ratio**2      GT09 268
I=MIN0(40,INT(AL2*10./alt:**2)+1)#     Get index for x**2               GT09 269
ELSE#                                  Get table index on ratio         GT09 270
I=MIN0(40,INT(SQRT(AL2)*10./alt:)+1)#  Get index for x                  GT09 271
WGT=WTAB2(I)#                          Store weight 2                   GT09 272
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GT09 273
ELSE#                                  Else apply weight 1              GT09 274
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GT09 275
I=MIN0(25,INT(AL2/DAL2)+1)#            Form index from alpha**2         GT09 276
WGT=WTAB1(I)#                          Store weight 1                   GT09 277
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GT09 278
IF((TYPE==0)&(WGT<RWGT)) NEXT#         Skip if new ran wgt < start      GT09 279
wgt:=WGT#                              Translate into phi weight        GT09 280
phi:=FLOAT(IP)#                        Store new phi estimate           GT09 281
NCON=NCON+1#                           Count connected generators       GT09 282
MLIM=MAX0(MLIM,NG)#                    Reset penetration limit          GT09 283
IF((TEST<1)\(IPHI<0)) NEXT#            Skip if not fom or known         GT09 284
NPHI=NPHI+IP#                          Sum total phi estimates          GT09 285
J=IABS(IPHI-IP); J=MIN0(J,360-J)#      Get smallest difference          GT09 286
IDIF=IDIF+J#                           Sum dif with prev phi            GT09 287
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GT09 288
#                                                                       GT09 289
ELSE#                                  Else must be psi0 triplets       GT09 290
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 GT09 291
PSIA=PSIA+SQRT(AL2)#                   Sum actual psi0 alphas           GT09 292
PSIE=PSIE+alt:#                        Sum expected psi0 alphas         GT09 293
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 GT09 294
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GT09 295
#                                                                       GT09 296
A2TH=A2TH*RATE#                        Reduce alpha**2 threshold        GT09 297
IF(NC<6) NEXT#                         Force min iterations             GT09 298
IF(SAL2<.1) BREAK#                     Exit if no connects              GT09 299
#                                                                       GT09 300
IF(IFOM==yes:)#                        Is fom pretest requested         GT09 301
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 GT09 302
IFOM=no:;  TEST=2;  NC=NC-1;   NEXT#   Reset test flags                 GT09 303
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 GT09 304
#                                                                       GT09 305
IF(TEST==1)#                           If final fom test                GT09 306
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 GT09 307
RFOM=MAX(.1,SUMB-SUMR)/MAX(.1,SUMA-SUMR)# Calc relative fom             GT09 308
IF(RFOM>FREJ(1)) IREJ=21#              Test rejection limit             GT09 309
RFAC=SUMD/SUMB#                        Calc karle rfactor               GT09 310
IF(RFAC>FREJ(2)) IREJ=22#              Test rejection limit             GT09 311
IF(PSIE>.1)#                           Test for psi0 triplets           GT09 312
APSI=PSIA/PSIE#                        Calculate psi0 fom value         GT09 313
ELSE APSI=-.00001#                     Psi(0) value unavailable         GT09 314
IF(APSI>FREJ(3)) IREJ=23#              Test for rejection               GT09 315
IF(RFOM<FREJ(5)) IREJ=24#              Test rejection limit             GT09 316
BREAK#                                 Exit after last fom test         GT09 317
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 GT09 318
ELSE IF(TEST==2)#                      Now if prelimonary test          GT09 319
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 GT09 320
RFOM=SUMB/SUMA#                        Calc pretest rel fom             GT09 321
IF(RFOM>PREJ3) IREJ=11#                Test rejection limit             GT09 322
RFAC=SUMD/SUMB#                        Calc karle rfactor               GT09 323
IF((RFOM>PREJ1)&(RFAC>PREJ2)) IREJ=12# Test rejection limit             GT09 324
IF(RFOM<FREJ(5)) IREJ=14#              Test rejection limit             GT09 325
IF((EFOM==yes:)&(IREJ>0)) BREAK#       Exit if pretest failed           GT09 326
TEST=-1;  IREJ=0;   SAL2=TAL2#         Start next iteration if ok       GT09 327
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 GT09 328
#                                                                       GT09 329
A=ABS(SAL2-SOL2)/SAL2#                 Calc converge ratio              GT09 330
IF((TEST<0)&(A>CONV)) NEXT#            Recycle if not converged         GT09 331
IF(IACC==yes:) LGEN=MGEN#              Set last gen block limit         GT09 332
IF((MGEN<MQ)&(NC<MITR))#               Test if all gen used yet         GT09 333
MGEN=MIN0(MQ,MGEN+KGEN)#               Add gens as 1/4 list             GT09 334
ELSE TEST=TEST+1#                      Flag as final iterations         GT09 335
IF(TEST==0)#                           Test if 2nd test iteration       GT09 336
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 GT09 337
NF=10000#                              Release all fixed phases         GT09 338
MITR=NC+2#                             Set new iteration limit          GT09 339
MGEN=MQ;    LGEN=M1#                   Ensure all gens phased           GT09 340
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 GT09 341
ELSE IF(TEST==1)#                      Test iter release negq           GT09 342
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 GT09 343
MLIM=16777216## 2^24                  Enable all inv. incl negq         GT09 344
MGEN=MG;     LGEN=M1#                  Enable psi0 triplets             GT09 345
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 GT09 346
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GT09 347
IF(TEST<0) IREJ=25#                    Reject if refine incomplete      GT09 348
#                                                                       GT09 349
#  END OF ITER LOOP -- OUTPUT PHASES ON FILE 3                          GT09 350
#  -------------------------------------------                          GT09 351
#                                                                       GT09 352
writepkt:(3,NS*2,15,IP)#               Set pointer for o/p packet       GT09 353
ANQ4=SQRT(FLOAT(MDIF/(MINV+1)))#       Calc av nq4 diff                 GT09 354
APHI=FLOAT(NPHI/(NCON+1))#             Calc mean phase                  GT09 355
QX(IP+1)=FLOAT(NS)#                    Store phase set number           GT09 356
QX(IP+2)=FLOAT(NCON)#                  Store ngen connected             GT09 357
QX(IP+3)=APHI#                         Store mean phase                 GT09 358
QX(IP+4)=FLOAT(IDIF/(NCON+1))#         Store test av phi dif            GT09 359
QX(IP+5)=SQRT(FLOAT(NDIF/(NINV+1)))#   Store rmsd phi all               GT09 360
QX(IP+6)=ANQ4#                         Store rmsd phi nq4               GT09 361
QX(IP+7)=FLOAT(NINV)#                  Store total invar test used      GT09 362
QX(IP+8)=FLOAT(MINV)#                  Store total negq  test used      GT09 363
QX(IP+9)=FLOAT(MITR)#                  Store number iterations          GT09 364
QX(IP+10)=RFOM#                        Store abs fom                    GT09 365
QX(IP+11)=RFAC#                        Store karle rfactor              GT09 366
QX(IP+12)=APSI#                        Store psi(0) value               GT09 367
IF(MINV==0) QX(IP+13)=-.0001#          Store null negq for max          GT09 368
ELSE        QX(IP+13)=QX(IP+6)#        Store negq for max/min           GT09 369
QX(IP+14)=FLOAT(IREJ)#                 Store rejection flag             GT09 370
IF(IREJ>0) NEXT#                       Skip phases if rejected          GT09 371
#                                                                       GT09 372
DO I=1,4#                              Loop over stored foms            GT09 373
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 GT09 374
J=IP+I+9#                              Point to stored fom              GT09 375
FMIN(I)=AMIN1(FMIN(I),QX(J))#          Find smallest fom                GT09 376
FMAX(I)=AMAX1(FMAX(I),QX(J))#          Find largest  fom                GT09 377
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 GT09 378
N=2*NS+1#                              Set phase set record number      GT09 379
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT09 380
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 GT09 381
writepkt:(3,N,2,IP)#                   Point to next o/p packet         GT09 382
QX(IP+1)=phi:#                         Store phase estimate             GT09 383
QX(IP+2)=wgt:#                         Store phase estimate weight      GT09 384
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 GT09 385
#                                                                       GT09 386
#    TEST FOR TERMINATION                                               GT09 387
#    --------------------                                               GT09 388
#                                                                       GT09 389
IF(TMOS>0)       NEXT#                 Skip if termination flag off     GT09 390
IF(RFOM>FOPT(1)) NEXT#                 Skip if rfom too large           GT09 391
IF(RFAC>FOPT(2)) NEXT#                 Skip if rfac too large           GT09 392
IF(APSI>FOPT(3)) NEXT#                 Skip if apsi too large           GT09 393
IF(ANQ4>FOPT(4)) NEXT#                 Skip if negq too large           GT09 394
IF(MINV==0\APSI<0.) NEXT#              Skip if no negq or psi0          GT09 395
IF(APHI>45.)     BREAK#                Exit if all optimal              GT09 396
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT09 397
writepkt:(3,endrecord:,4,I)#           Finish off scratch file          GT09 398
#                                                                       GT09 399
RETURN#                                                                 GT09 400
END#                                                                    GT09 401
systemheader:(GT10)#                   General tangent phasing          GT10   1
####################################################################    GT10   2
#                                                                  #    GT10   3
#                             GT10                                 #    GT10   4
#                                                                  #    GT10   5
####################################################################    GT10   6
SUBROUTINE GT10#                       S.r.hall  jun 83                 GT10   7
include:(AACOMN)#                                                       GT10   8
include:(GTCOMN)#                                                       GT10   9
#                                                                       GT10  10
INTEGER I,J,K,L,M,N,NG,NMAX#                                            GT10  11
INTEGER NMAP,NP#                                                        GT10  12
REAL PHI(50),WGT(50),SSI(50)#                                           GT10  13
REAL FM2(30),FM3(30),FM4(30)#                                           GT10  14
#                                                                       GT10  15
chardata:(GT1, GENERATOR      NGEN=     RSTR=     RPHI=     $#          GT10  16
DIFF=             )#                                                    GT10  17
chardata:(GT2,   ODREDRPERSETNUL***PHIWGTNSI)#                          GT10  18
#CHARDATA:(GT3,DIFF=   )#                                               GT10  19
realdata:(FM1,[140413.,240313.,340313.,440313.,540313.])#               GT10  20
realdata:(PRC,[9999.,180.,30.,45.,60.,90.,120.,135.,150.,180.])#        GT10  21
datastuff:#                                                             GT10  22
#                                                                       GT10  23
#    SETUP INITIAL PARAMETERS                                           GT10  24
#    ------------------------                                           GT10  25
#                                                                       GT10  26
DO I=1,30#                             Loop over formats                GT10  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT10  28
FM2(I)=FLOAT(I*40000+50313)#           Setup op formats                 GT10  29
FM3(I)=FLOAT(I*40000+50322)#           Setup op formats                 GT10  30
FM4(I)=FLOAT(I*40000+50303)#           Setup op formats                 GT10  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT10  32
NMAP=MXIT+2#                           Set maximum cycles               GT10  33
NMAX=MIN0(30,ITMX)#                    Set format maximum               GT10  34
NP=MG#                                 Set initial pointer              GT10  35
#                                                                       GT10  36
#     LOOP OVER STORED PHASES                                           GT10  37
#     -----------------------                                           GT10  38
#                                                                       GT10  39
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generators             GT10  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT10  41
#                                                                       GT10  42
DO J=1,NMAX#                           Loop over cycles                 GT10  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT10  44
K=NP+J#                                Point to packed word             GT10  45
intunpak:(QX(K),L, 0, 9)#              Unpack phase                     GT10  46
intunpak:(QX(K),M, 9, 9)#              Unpack weight                    GT10  47
intunpak:(QX(K),N,18,bitlen:(18))#     Unpack number si                 GT10  48
PHI(J)=FLOAT(L)#                       Store phase                      GT10  49
WGT(J)=FLOAT(M)*.01#                   Store weight                     GT10  50
SSI(J)=FLOAT(N)#                       Store number si                  GT10  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT10  52
NP=NP+NMAP#                            Incr to next generator           GT10  53
#                                                                       GT10  54
#   PRINT PHASE MAP HEADER                                              GT10  55
#   ----------------------                                              GT10  56
#                                                                       GT10  57
I=ipnt:;   J=iprc:#                    Extract pointer & restr code     GT10  58
BUFOT(1)=FLOAT((NG-M1)/MARK+1)#        Store seq number                 GT10  59
BUFOT(2)=FLOAT((I -M1)/MARK+1)#        Store gen number                 GT10  60
BUFOT(3)=PRC(J)#                       Store phase restr.               GT10  61
intunpak:(pak:,I,0,9)#                 Unpack input phase               GT10  62
IF((I>0)&(N>0))#                       If phase input & estimated       GT10  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT10  64
I=MOD(I,360)#                          Reduce to mod 2pi                GT10  65
J=IABS(I-NINT(phi:))#                  Reduce to mod 2pi                GT10  66
BUFOT(4)=FLOAT(I)#                     Store input phase                GT10  67
BUFOT(5)=FLOAT(MIN0(J,360-J))#         Get smallest diff                GT10  68
ncodefld:(BUFOT,4,GT1,FM1(4),2)#       Format input phase               GT10  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT10  70
intunpak:(pak:,I,22,3)#                Get start status code            GT10  71
movechar:(GT2,I*3-2,GT1,57,3,0)#       Insert start status              GT10  72
IF(TYPE==0) movechar:(GT1,1,GT1,47,8,2)# Blank out diff                 GT10  73
ncodefld:(BUFOT,1,GT1,FM1,3)#          Format gen items                 GT10  74
writeline:(1,GT1,NGT1,2,3)#            Print gener heading              GT10  75
IF(N==0) NEXT#                         Skip if phase not est.           GT10  76
movechar:(GT2,22,CHROT,3,3,0)#         Insert phi header                GT10  77
ncodefld:(PHI,1,CHROT,FM2,NMAX)#       Format phi values                GT10  78
writeline:(0,0,0,1,3)#                 Print phases                     GT10  79
movechar:(GT2,25,CHROT,3,3,0)#         Insert wgt header                GT10  80
ncodefld:(WGT,1,CHROT,FM3,NMAX)#       Format wgt values                GT10  81
writeline:(0,0,0,1,3)#                 Print weights                    GT10  82
movechar:(GT2,28,CHROT,3,3,0)#         Insert phi header                GT10  83
ncodefld:(SSI,1,CHROT,FM4,NMAX)#       Format number si                 GT10  84
writeline:(0,0,0,1,3)#                 Print si numbers                 GT10  85
#                                                                       GT10  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT10  87
#                                                                       GT10  88
RETURN#                                                                 GT10  89
END#                                                                    GT10  90
systemheader:(GT20)#                   List & archive phase sets        GT20   1
###################################################################     GT20   2
#                                                                  #    GT20   3
#                             GT20                                 #    GT20   4
#                                                                  #    GT20   5
###################################################################     GT20   6
SUBROUTINE GT20#                       S.r.hall  dec 81                 GT20   7
include:(AACOMN)#                                                       GT20   8
include:(GTCOMN)#                                                       GT20   9
#                                                                       GT20  10
INTEGER I,J,K,L,N#                                                      GT20  11
INTEGER NSET#                                                           GT20  12
INTEGER IP,IREJ,IRP,JP,MGEN,MM,MN,MP,M4,NG,NN,NP,NPNT,N1#               GT20  13
REAL A,AH,AL,B,EVAL,STOL#                                               GT20  14
REAL FMMX,SUMD(32),SUMW(32)#                                            GT20  15
#                                                                       GT20  16
chardata:(GT1, REJECT)#                                                 GT20  17
chardata:(GT2, EQUIV TO PSET)#                                          GT20  18
chardata:(GT4, **** CAUTION PHASE SETS RESTRICTED BY MEMORY SIZE)#      GT20  19
chardata:(GT5, NSET NPHI APHI DPHI RMSD NEGQ NINV NNQ4 NCYC  $#         GT20  20
RFOM RFAC PSI0)#                                                        GT20  21
chardata:(GT6,[ PSET   NSET    RFOM   RFAC   PSI0   NEGQ    *CFOM*$#    GT20  22
   AMOS(%)])#                                                           GT20  23
chardata:(GT7,   ODREDRPERSETNUL-)#                                     GT20  24
chardata:(GT8,  NGEN  H   K   L   PHI  START   PHI  WGT    $#           GT20  25
PHI  WGT    PHI  WGT    PHI  WGT    PHI  WGT    PHI  WGT    $#          GT20  26
PHI  WGT    PHI  WGT  )#                                                GT20  27
chardata:(GT9,[ PHASE SET ASSESSMENT (IN ORDER O/P TO BDF)])#           GT20  28
chardata:(GT11, LIST OF TOP PHASE SETS)#                                GT20  29
chardata:(GT12, NS          NS          NS          NS          $#      GT20  30
NS          NS          NS          NS          BDF)#                   GT20  31
chardata:(GT13, SUMMARY OF PHASE SET RESULTS)#                          GT20  32
chardata:(GT14,[ WEIGHTED PHASE DIFF (IN DEGREES) FROM BDF VALUES])#    GT20  33
realdata:(FMT1,[40413.,100413.,150413.,190413.,240413.,290413.,#        GT20  34
350513.,400413.,440413.,510522.,560522.,610522.])#                      GT20  35
realdata:(FMT2,[110413.,200522.,270522.,340522.,410513.,500522.,#       GT20  36
580513.])#                                                              GT20  37
realdata:(FMT3,[90413.,130413.,170413.,360313.,410322.,#                GT20  38
480313.,530322.,600313.,650322.,720313.,770322.,840313.,890322.,#       GT20  39
960313.,1010322.,1080313.,1130322.,1200313.,1250322.])#                 GT20  40
realdata:(PI2,6.2831852)#                                               GT20  41
realdata:(FOM,[2.,5.,2.,2.,2.,10.,5.,2.,.05,.05,.05,2.])#               GT20  42
intdata:(M,0);   realdata:(PHI,0.)#                                     GT20  43
datastuff:#                                                             GT20  44
#                                                                       GT20  45
#   PREPARE TO ASSESS PHASE SETS                                        GT20  46
#  -----------------------------                                        GT20  47
#                                                                       GT20  48
M0=MQ;      MM=M0;      MN=M0+960#     Space for top fom 64 sets        GT20  49
qxmemory:(MN)#                         Request new qx limit             GT20  50
movereal:(-1.,1,QX,M0+1,960,2)#        Zero fom storage                 GT20  51
movechar:(GT7,NGT7,CHROT,2,NGT13-1,2)# Underline summary header         GT20  52
LINRM=10;  writeline:(1,GT13,NGT13,1,3)# Header for fom list            GT20  53
LINRM=1;   writeline:(0,0,0,1,3)#      Force header space               GT20  54
A=0.01;   DO I=1,4#                    Loop over fom weights            GT20  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GT20  56
IF(FMAX(I)>(-.000001)) A=A+WFOM(I)#    Sum weights of active fom        GT20  57
ELSE                   WFOM(I)=0.#     Exclude inactive fom's           GT20  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GT20  59
DO I=1,4#                              Loop over fom types              GT20  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GT20  61
WFOM(I)=WFOM(I)/A#                     Normalize fom weights            GT20  62
FOPT(I)=FREJ(I)-AMIN1(FOPT(I),FMIN(I))# Calc active fom range           GT20  63
FMIN(I)=AMAX1(.001,FMAX(I)-FMIN(I))#   Calc largest range               GT20  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GT20  65
AL=PHIAV-45.;   AH=PHIAV+45.#          Set expected range av phi    ^   GT20  66
NSET=0;  FMMX=0.;  IREJ=0;  LINRM=1#   Reset phase set counter          GT20  67
#                                                                       GT20  68
#    ENTER PHASE SETS FROM FILE 3                                       GT20  69
#    ----------------------------                                       GT20  70
#                                                                       GT20  71
DO N=1,NPST#                           Loop over phase sets             GT20  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GT20  73
readwpkt:(3,N*2,NP,IP,0)#              Point to fom packet              GT20  74
IF(IP<=0) BREAK#                       Exit if run terminated           GT20  75
#                                                                       GT20  76
ifne:(QX(IP+14),0.)#                   ****** test if reject            GT20  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GT20  78
ncodefld:(FLOAT(N),1,CHROT,FMT1,1)#    Format phase set number          GT20  79
movechar:(GT1,1,CHROT,64,NGT1,0)#      Insert reject message            GT20  80
ncodefld:(QX,IP+14,CHROT,740233.,1)#   Format reject number             GT20  81
writeline:(0,GT5,NGT5,1,3)#            Print reject message             GT20  82
NEXT#                                  Skip to next phase set           GT20  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GT20  84
#                                                                       GT20  85
A=0.;    B=0.#                         Set accumulators                 GT20  86
DO I=1,4#                              Loop over fom's                  GT20  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GT20  88
J=IP+I+9#                              Point to fom's                   GT20  89
A=A+WFOM(I)*(FMAX(I)-QX(J))/FMIN(I)#   Form rfom value                  GT20  90
IF(QX(J)>FREJ(I)) NEXT#                Skip rejected fom's              GT20  91
B=B+WFOM(I)*(FREJ(I)-QX(J))/FOPT(I)#   Form amos value                  GT20  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GT20  93
QX(IP+14)=A; QX(IP+15)=B#              Store rfom and amos              GT20  94
FMMX=AMAX1(FMMX,QX(IP+15));  IREJ=0#   Find max mos value               GT20  95
#                                                                       GT20  96
IF((QX(IP+3)<AL)\(QX(IP+3)>AH)) IREJ=36# ****** <phi> rejection         GT20  97
#                                                                       GT20  98
ELSE IF(QX(IP+15)<0.05)         IREJ=37# ****** afom rejection          GT20  99
#                                                                       GT20 100
#   STORE SORTED TOP 64 PHASE SETS                                      GT20 101
#   ------------------------------                                      GT20 102
#                                                                       GT20 103
ELSE#                                  Only if not rejected             GT20 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GT20 105
IF(NOPS==0)#                           Test if op psets specified       GT20 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GT20 107
FOR(M=M0;M<MM;M=M+15)#                 Loop over stored fom's           GT20 108
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GT20 109
FOR(I=2;I<14;I=I+1)#                   Loop over ps parameters          GT20 110
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GT20 111
J=M+I;   K=IP+I#                       Point to stored/new fom          GT20 112
IF(ABS(QX(J)-QX(K))>FOM(I-1)) BREAK#   Exit if outside window           GT20 113
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GT20 114
IF(I==14) BREAK#                       Exit if found equivalent         GT20 115
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GT20 116
IF(M==MM)#                             If non-equiv phase set           GT20 117
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GT20 118
FOR(M=M0;M<MM;M=M+15)#                 Loop over stored sets            GT20 119
IF(QX(IP+15)>QX(M+15)) BREAK#          Break if new amos larger         GT20 120
NSET=NSET+1#                           Count accepted phase set         GT20 121
movereal:(QX,M+1,QX,M+16,MM-M,1)#      Push down fom stack              GT20 122
movereal:(QX,IP+1,QX,M+1,15,1)#        Insert new fom's                 GT20 123
MM=MIN0(MN,MM+15)#                     Expand the list size             GT20 124
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GT20 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GT20 126
ELSE#                                  Else specific psets requeste     GT20 127
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GT20 128
DO I=1,NOPS#                           Loop over requested psets        GT20 129
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GT20 130
IF(PSET(I)!=N) NEXT#                   Skip if no match                 GT20 131
M=M0+(I-1)*15#                         Get list pointer                 GT20 132
movereal:(QX,IP+1,QX,M+1,15,1)#        Store fom values                 GT20 133
NSET=NSET+1#                           Count sets to be output          GT20 134
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GT20 135
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GT20 136
IF(I==14)#                             Test for equiv phase set         GT20 137
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GT20 138
ncodefld:(QX,IP+1,CHROT,FMT1,1)#       Format phases set number         GT20 139
ncodefld:(QX,M+1,CHROT,800413.,1)#     Format equiv ps number           GT20 140
movechar:(GT2,1,CHROT,64,NGT2,0)#      Insert equiv ps mess.            GT20 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GT20 142
ncodefld:(QX,IP+1,CHROT,FMT1,12)#      Format values on scratch         GT20 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GT20 144
IF(IREJ>0)#                            Test for if rejected             GT20 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GT20 146
ncodefld:(FLOAT(IREJ),1,CHROT,740233.,1)# Format rejection reason       GT20 147
movechar:(GT1,1,CHROT,64,NGT1,0)#      Insert rejection message         GT20 148
ncodefld:(QX,IP+1,CHROT,FMT1,12)#      Format values on scratch         GT20 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GT20 150
writeline:(0,GT5,NGT5,1,3)#            Print phase set info             GT20 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GT20 152
rewindbdf:(3)#                                                          GT20 153
#                                                                       GT20 154
#   ENTER PHASE SETS & STORE FOR OUTPUT                                 GT20 155
#   -----------------------------------                                 GT20 156
#                                                                       GT20 157
POUT=MIN0(POUT,NSET)#                  Adjust number op sets            GT20 158
MGEN=NGEN*2#                           Set length of ps block           GT20 159
IOMARK(1)=MN#                          Define start of buffer 1         GT20 160
IOMARK(2)=MN+bdfbuf:#                  Define start of buffer 2         GT20 161
M3=IOMARK(2)+bdfbuf:#                  Define start of ps store         GT20 162
M4=M3+POUT*MGEN#                       Define end of ps store           GT20 163
IF(M4>QXMAX)#                          Test memory available            GT20 164
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GT20 165
writeline:(1,GT4,NGT4,3,3)#            Print warning message            GT20 166
POUT=(QXMAX-M3)/MGEN#                  Calc phase sets possible         GT20 167
IF(POUT<1) iquit:(GT2010)#             No ps op.......gt2010            GT20 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GT20 169
NSET=POUT*2;  M4=M3+POUT*MGEN#         Set length of phi+wgt/gen        GT20 170
qxmemory:(M4)#                         Get memory needed                GT20 171
NPNT=MIN0(NSET,16)#                    Limit print of phase sets        GT20 172
movechar:(GT7,NGT7,CHROT,2,NGT9-1,2)#  Underline fom header             GT20 173
LINRM=12;   writeline:(1,GT9,NGT9,1,3)# Force phase set heading         GT20 174
writeline:(0,GT6,NGT6,3,3)#            Print phase set subheader        GT20 175
K=0;    LINRM=1;  A=50323.#            Temp store for prior ps          GT20 176
#                                                                       GT20 177
DO N=1,POUT#                           Loop over op phase sets          GT20 178
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GT20 179
SUMD(N)=0.;    SUMW(N)=0.#             Zero phase diff sums             GT20 180
M=M0+(N-1)*15#                         Point to stored fom's            GT20 181
QX(M+15)=100.*QX(M+15)/AMAX1(1.,FMMX)# Scale mos values                 GT20 182
ncodefld:(FLOAT(N),1,CHROT,40313.,1)#  Format pset number               GT20 183
ncodefld:(QX,M+1,CHROT,FMT2,1)#        Format stored ps num             GT20 184
ncodefld:(QX,M+10,CHROT,FMT2(2),6)#    Format stored fom's              GT20 185
writeline:(0,0,0,1,3)#                 Print stored fom's               GT20 186
IF(N<NPNT) ncodefld:(QX,M+1,GT12,A,1)# Format phase set numbers         GT20 187
A=A+120000.#                           Incr format for ps no.           GT20 188
L=NINT(QX(M+1))*2+1#                   Get recnum from ps num           GT20 189
IF(L<K) rewindbdf:(3)#                 Test posn of next record         GT20 190
K=(N-1)*2#                             Calc phase set offset            GT20 191
#                                                                       GT20 192
FOR(J=M3;J<M4;J=J+NSET)#               Loop over generators             GT20 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GT20 194
readwpkt:(3,L,NP,IP,0)#                Enter phase and weight           GT20 195
QX(J+K+1)=QX(IP+1)#                    Store phase                      GT20 196
QX(J+K+2)=QX(IP+2)#                    Store weight                     GT20 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GT20 198
K=L#                                   Reset last record number         GT20 199
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GT20 200
readwpkt:(3,endrecord:,I,I,0)#         Rewind & close file 3            GT20 201
#                                                                       GT20 202
#   PREPARE TO OP PHASES ON BDF                                         GT20 203
#   ---------------------------                                         GT20 204
#                                                                       GT20 205
copyfile:(1,2,1,decr:(lrrefl:))#       Copy up to lr refl               GT20 206
DO I=1,NSET;  ARCH(I)=ABS(ARCH(I))#    Set up add items                 GT20 207
IW(1)=1;   IW(2)=2#                    Request hkl and stol idnms       GT20 208
IW(3)=NMDS+599+NINT(ETYP)#             Request eval idnum               GT20 209
IW(4)=NMDS+700#                        Request phi  idnum               GT20 210
IW(5)=NMDS+801#                        Request acal idnum               GT20 211
IW(6)=NMDS+802#                        Request bcal idnum               GT20 212
DO I=1,ITEM;  IW(I+6)=NINT(ARCH(I))#   Set archive list                 GT20 213
KEY(1)=3;   KEY(3)=ITEM+6#             Set search limits                GT20 214
KEY(2)=6;   KEY(4)=1#                  Set search limits                GT20 215
indexpkt:(1,lrrefl:,NP,IP,2,KEY,IW,IR)# Search & output idnums          GT20 216
IF(KEY(4)<1) iquit:(GT2020)#           No /e/ ......gt2020              GT20 217
MP=KEY(4)#                             Store output packet size         GT20 218
IRP=IR(4)+IR(5)+IR(6);  MM=27#         Set calc phase flag              GT20 219
#                                                                       GT20 220
IF(IPNT>0)#                            Test for p.s. listing            GT20 221
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GT20 222
movechar:(GT7,NGT7,CHROT,2,NGT11-1,2)# Insert header underline          GT20 223
LINRM=10;  writeline:(1,GT11,NGT11,2,3)# Print p.s. header              GT20 224
IF(IRP==0)#                            Test if calc phase present       GT20 225
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GT20 226
DO I=1,16; FMT3(I+3)=FMT3(I+3)-60000.# Adjust op formats                GT20 227
movechar:(GT8,24,GT8,18,NGT8-23,0)#    Adjust op heading                GT20 228
MM=21#                                 Set length of op line            GT20 229
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GT20 230
movechar:(GT12,1,CHROT,MM+8,NPNT*6,0)# Put phase set no. in buff        GT20 231
LINRM=1;  writeline:(0,0,0,0,3);  LINRM=1# Force first subheader        GT20 232
NN=MM+NPNT*6+5#                        Calc length of header            GT20 233
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GT20 234
#                                                                       GT20 235
#   READ & UPDATE RECORD 20 BDF                                         GT20 236
#   ---------------------------                                         GT20 237
#                                                                       GT20 238
REPEAT#                                Loop over reflection packets     GT20 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GT20 240
readwpkt:(1,lrrefl:,NP,IP,0)#          Point to next ip packet          GT20 241
IF(IP<=0) BREAK#                       Exit after last packet           GT20 242
#                                                                       GT20 243
writepkt:(2,lrrefl:,MP,JP)#            Point to next op packet          GT20 244
N=JP+1;   M=KEY(2)+1#                  Point to op & rel array          GT20 245
DO I=1,NP#                             Loop over ip packet              GT20 246
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GT20 247
J=IP+I#                                Point to ip pack word            GT20 248
movepakwd:(QX(J),QX(N))#               Put ip item in op                GT20 249
IF(IR(M)==I) M=M+1#                    Test if delete item              GT20 250
ELSE         N=N+1#                    Else is add    item              GT20 251
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GT20 252
movereal:(voidflg:,1,QX,N,NSET,2)#     Initialize add-on area           GT20 253
#                                                                       GT20 254
I=IP+IR(3);  EVAL=QX(I)#               Extract /e/ value                GT20 255
IF(EVAL<EMIN) NEXT#                    Test if /e/ acceptable           GT20 256
I=IP+IR(2);  STOL=QX(I)#               Extract st/l value               GT20 257
IF((STOL<STMN)\(STOL>STMX)) NEXT#      Is st/l inside limits            GT20 258
I=IP+IR(1); movepakwd:(QX(I),A)#       Stored packed hkl                GT20 259
FOR(NG=M1;NG<MQ;NG=NG+MARK)#           Loop over generator list         GT20 260
compakwd:(hkl:,EQ,A,BREAK)#            Exit when match found            GT20 261
IF(NG>=MQ) NEXT#                       Skip refn if no match            GT20 262
N1=((NG-M1)/MARK)*NSET+M3#             Convert to ps pointer            GT20 263
movereal:(QX,N1+1,QX,N,NSET,1)#        Store phases in op buffer        GT20 264
FOR(J=N;J<N+NSET;J=J+2) QX(J)=QX(J)/360.# Convert phi to cycles         GT20 265
#                                                                       GT20 266
IF(IRP>0)#                             Test if phase on bdf             GT20 267
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GT20 268
I=IP+IR(4); IF(I>IP) PHI=QX(I)#        Extract phase in cycles          GT20 269
ELSE#                                  Else acal $ bcal present         GT20 270
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GT20 271
I=IP+IR(5);  A=QX(I)#                  Extract acal value               GT20 272
I=IP+IR(6);  B=QX(I)#                  Extract bcal value               GT20 273
IF((ABS(A)<.01)&(ABS(B)<.01)) A=.1#    Avoid indeterminancy             GT20 274
PHI=ATAN2(B,A)/PI2#                    Calc phase in cycles             GT20 275
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GT20 276
PHI=AMOD(PHI*360.+3600.,360.)#         Convert to degrees               GT20 277
FOR(J=N1;J<N1+NSET;J=J+2)#             Loop over output sets            GT20 278
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 GT20 279
I=(J-N1)/2+1#                          Get index to sums                GT20 280
A=ABS(PHI-QX(J+1))#                    Get difference with bdf phi      GT20 281
SUMD(I)=SUMD(I)+AMIN1(A,360.-A)*QX(J+2)# Accumulate differences         GT20 282
SUMW(I)=SUMW(I)+QX(J+2)#               Accumulate weights               GT20 283
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 GT20 284
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GT20 285
IF(IPNT==0) NEXT#                      Skip if not listed               GT20 286
A=FLOAT((ipnt:-M1)/MARK+1)#            Get original genlist order       GT20 287
ncodefld:(A,1,CHROT,50413.,1)#         Format genlist number            GT20 288
ncodefld:(PHI,1,CHROT,230313.,1)#      Format calc phase                GT20 289
I=IP+IR(1);  gethkl:(I,H)#             Extract hkl indices              GT20 290
ncodefld:(H,1,CHROT,FMT3,3)#           Format indices hkl               GT20 291
intunpak:(pak:,I,22,3); I=MAX0(I,1)#   Extract start status             GT20 292
movechar:(GT7,I*3-2,CHROT,MM,3,0)#     Insert start status              GT20 293
ncodefld:(QX,N1+1,CHROT,FMT3(4),NPNT)# Format phi & wgt's               GT20 294
writeline:(0,GT8,NN,1,3)#              Print phase line                 GT20 295
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GT20 296
IF(IRP>0)#                             Test if bdf phases used          GT20 297
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 GT20 298
writeline:(1,GT14,NGT14,3,3)#          Print phi diff header            GT20 299
DO I=1,POUT#                           Loop over phase sets             GT20 300
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 GT20 301
J=MOD(I-1,10)#                         Reduce to mod 10                 GT20 302
IF(J==0) A=80612.#                     Test if first of 10              GT20 303
B=SUMD(I)/SUMW(I)#                     Get weighted difference          GT20 304
ncodefld:(B,1,CHROT,A,1)#              Format phi difference            GT20 305
A=A+80000.#                            Incr formats                     GT20 306
IF((J==9)\(I==POUT))writeline:(0,0,0,2,3)# Print phi diff values        GT20 307
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 GT20 308
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 GT20 309
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off bdf copy           GT20 310
#                                                                       GT20 311
RETURN#                                                                 GT20 312
END#                                                                    GT20 313
pmacro:([no:])#                        Purge xtal system macros         GT20 314
