systemheader:(RE    )#                                                  RE     1
####################################################################### RE     2
##      Copyright (C) 2000, The Xtal System, The University of        # RE     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # RE     4
## Distributed under the GNU General Public Licence as published by   # RE     5
## the Free Software Foundation, in the hope that it will be useful   # RE     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # RE     7
## for more details.                                                  # RE     8
#                                                                     # RE     9
#                            *** REFM90 ***                           # RE    10
#                                                                     # RE    11
#     THE PROGRAM REFM90 REFORMATS DATA FROM AN XTAL BDF              # RE    12
#     TO THE STANDARD SCFS FILE, AND REVERSE.  THIS PROGRAM PROVIDES  # RE    13
#     BOTH A MACHINE INDEPENDENT ARCHIVAL AND COMMUNICATION FACILITY. # RE    14
#                                                                     # RE    15
####################################################################### RE    16
#                                                                       RE    17
include:(XMACRO)#                                                       RE    18
#                                                                       RE    19
macro:(mxwdim:,incr:(arith:(decr:(80),/,mxchwd:)))# No. words/image     RE    20
macro:(mw02dm:,incr:(arith:( 1,/,mxchwd:)))# No. words for  2 chars     RE    21
macro:(mw04dm:,incr:(arith:( 3,/,mxchwd:)))# No. words for  4 chars     RE    22
macro:(mw06dm:,incr:(arith:( 5,/,mxchwd:)))# No. words for  6 chars     RE    23
macro:(mw08dm:,incr:(arith:( 7,/,mxchwd:)))# No. words for  8 chars     RE    24
macro:(mw12dm:,incr:(arith:(11,/,mxchwd:)))# No. words for 12 chars     RE    25
macro:(mw20dm:,incr:(arith:(19,/,mxchwd:)))# No. words for 20 chars     RE    26
macro:(mw24dm:,incr:(arith:(23,/,mxchwd:)))# No. words for 24 chars     RE    27
macro:(mw40dm:,incr:(arith:(39,/,mxchwd:)))# No. words for 40 chars     RE    28
macro:(mw65dm:,incr:(arith:(64,/,mxchwd:)))# No. words for 65 chars     RE    29
macro:(mw75dm:,incr:(arith:(74,/,mxchwd:)))# No. words for 75 chars     RE    30
macro:(mw424dm:,arith:(mw04dm:,+,mw24dm:))#                             RE    31
macro:(mw82dm:,arith:(mw08dm:,+,mw02dm:))#                              RE    32
#                                                                       RE    33
macro:(putrecd:,$(#                                                     RE    34
SEQNUM = SEQNUM + 1.0;ncodefld:(SEQNUM,1,CHRIN,0800553.,1)#             RE    35
writefmt:(iofm1:,'(A80)',CHRIN(1^80))#                                  RE    36
movechar:(BLANK,1,CHRIN,1,80,1)$))#                                     RE    37
macro:(puthead:,$(#                                                     RE    38
movechar:($1,1,CHRIN,1,N$1,0);putrecd:$))#                              RE    39
macro:(putlast:,$(#                                                     RE    40
movechar:('*EOS',1,CHRIN,1,4,0);putrecd:;putrecd:$))#                   RE    41
macro:(checksq:,IF(CHKSEQ==yes:)$(IF(PEQNUM>=SEQNUM)$(#                 RE    42
movechar:(RE3B,1,CHROT,1,NRE3B,0)#                                      RE    43
ncodefld:(PEQNUM,1,CHROT,500613.,1)#                                    RE    44
ncodefld:(SEQNUM,1,CHROT,660613.,1)#                                    RE    45
writeline:(0,0,0,1,3)$);PEQNUM=SEQNUM$))#                               RE    46
macro:(ifnz:,IF(ABS($1)>small:))#                                       RE    47
#                                                                       RE    48
extrude:(RECOMN)#                                                       RE    49
REAL DSNM#                             Data set number                  RE    50
REAL PEQNUM#                           Previous sequence no.            RE    51
REAL SEQNUM#                           Sequence number of records       RE    52
REAL AMUL,ZMOL#                        Multiplicity and z               RE    53
REAL UOV,UOVE,SYMCNT#                  Overall u and symmetry count     RE    54
REAL UIJ#                              Iso/aniso switch                 RE    55
#                                                                       RE    56
INTEGER INTEN#                         Intensity data type              RE    57
INTEGER CHKSEQ#                        Sequence checking flag           RE    58
INTEGER MARK1,MARK2,MARK3,MARK4,MARK5# Qx array starting pointers       RE    59
INTEGER MARK6,MARK7,MARK8,MARK9,MARK9B,MARK9C,MARK9D,MARKZ#             RE    60
INTEGER MARKA,MARKB,MARKC,MARKD,MARKE# Qx array starting pointers       RE    61
INTEGER STEP1,STEP2,STEP3,STEP4,STEP5# Qx array steps                   RE    62
INTEGER STEP6,STEP7,STEP8,STEP9#                                        RE    63
INTEGER STEPA,STEPB,STEPC,STEPD,STEPE# Qx array steps                   RE    64
INTEGER POINT1,POINT2,POINT3,POINT4,POINT5# Qx array temp pointers      RE    65
INTEGER POINT6,POINT7,POINT8,POINT9#                                    RE    66
INTEGER POINTA,POINTB,POINTC,POINTD,POINTE# Qx array temp pointers      RE    67
INTEGER NDSK,PDSK,MXDSK,LDSKYS#        Data set key variables           RE    68
INTEGER NMDS#                          Integer data set number          RE    69
INTEGER IR(401),IW(400),KEY(4)#        Packet request variables         RE    70
INTEGER SLOW,MEDIUM,FAST#              H k l sort order                 RE    71
INTEGER NSFS#                          No. scattering factor tables     RE    72
#                                                                       RE    73
string:(CID,4)#                                                         RE    74
string:(DSK,4)#                                                         RE    75
string:(DSKYS,80)#                     Space for 20 data set keys       RE    76
#                                                                       RE    77
COMMON/COMIRE/ INTEN,CHKSEQ,#                                           RE    78
MARK1,MARK2,MARK3,MARK4,MARK5,MARK6,MARK7,MARK8,MARK9,MARK9B,#          RE    79
MARK9C,MARK9D,MARKZ,MARKA,MARKB,MARKC,MARKD,MARKE,#                     RE    80
STEP1,STEP2,STEP3,STEP4,STEP5,STEP6,STEP7,STEP8,STEP9,#                 RE    81
STEPA,STEPB,STEPC,STEPD,STEPE,#                                         RE    82
POINT1,POINT2,POINT3,POINT4,POINT5,POINT6,POINT7,POINT8,POINT9,#        RE    83
POINTA,POINTB,POINTC,POINTD,POINTE,#                                    RE    84
NDSK,PDSK,MXDSK,LDSKYS,#                                                RE    85
NMDS,IR,IW,KEY,SLOW,MEDIUM,FAST,NSFS#                                   RE    86
#                                                                       RE    87
COMMON/COMFRE/ DSNM,SEQNUM,AMUL,ZMOL,PEQNUM,UOV,UOVE,SYMCNT,#           RE    88
UIJ#                                                                    RE    89
#                                                                       RE    90
COMMON/COMCRE/ CID,DSK,DSKYS#                                           RE    91
#                                                                       RE    92
endext:#                                                                RE    93
#                                                                       RE    94
systemheader:(RE00)#                   Read refm90 record & setup       RE00   1
####################################################################    RE00   2
#                                                                       RE00   3
#                        RE00                                           RE00   4
#                                                                       RE00   5
####################################################################    RE00   6
SUBROUTINE RE00#                       H.d. flack 1988                  RE00   7
include:(AACOMN)#                      H.d. flack 1990                  RE00   8
include:(RECOMN)#                                                       RE00   9
#                                                                       RE00  10
INTEGER KAY,K#                                                          RE00  11
chardata:(RE0,END    )#                                                 RE00  12
chardata:(RE2, REFM90 CONTROL PARAMETERS-)#                             RE00  13
chardata:(RE3,SCFS TO XTALXTAL TO SCFS)#                                RE00  14
chardata:(RE4, CALCULATION MODE                     )#                  RE00  15
chardata:(RE7, SCFS XTAL PACK GRAT CMFO CMSQ CMIN FOBS FSQR INTN $#     RE00  16
CALC CHEK NOCH DSET )#                                                  RE00  17
intdata:(I,0);  intdata:(J,0); intdata:(MODE,2)#                        RE00  18
datastuff:#                                                             RE00  19
#                                                                       RE00  20
#        SET UP DEFAULT PARAMETERS                                      RE00  21
#        -------------------------                                      RE00  22
#                                                                       RE00  23
DSNM=1.;NMDS=1#                        Set default data set num         RE00  24
INTEN=1#                               Say want to generate hkl pack    RE00  25
SEQNUM=0.#                             Initialise count of records      RE00  26
CHKSEQ=yes:#                           Set sequence checking on         RE00  27
PRVOID=no:#                            Print blank for voidflg:         RE00  28
#                                                                       RE00  29
#        CHECK SIZE OF INPUT RECORD BUFFER                              RE00  30
#        ---------------------------------                              RE00  31
#                                                                       RE00  32
K=80;IF(mxchim:<K)iquit:(RE0010)#      Record buffer must be at least   RE00  33
#                                                                       RE00  34
#     LOOP OVER REFM90 FIELDS                                           RE00  35
#     -----------------------                                           RE00  36
#                                                                       RE00  37
FOR(K=1;K<=mxfdim:;K=K+1)#             Loop over refcal line fields     RE00  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RE00  39
ifvo:(BUFIN(K)) BREAK#                 Quit on first void field         RE00  40
ifnm:(BUFIN(K)) NEXT#                  Check for alphabetics            RE00  41
stringlim:(K,I,J)#                     Get limits of character field    RE00  42
compchar:(CHRIN,I,RE7,2,4,5,NRE7,KAY)# Identify key                     RE00  43
IF(KAY==0) iquit:(RE0020,K)#           Unrecognizable input field       RE00  44
IF(KAY==1) MODE=1#                     Set scfs to xtal mode            RE00  45
IF(KAY==2) MODE=2#                     Set xtal to scfs mode            RE00  46
IF((KAY>2)&(KAY<12))INTEN=KAY-2#       Set intensity output mode        RE00  47
ELSE IF(KAY==12) CHKSEQ=yes:#          Sequence checking on             RE00  48
ELSE IF(KAY==13) CHKSEQ=no:#           Sequence checking off            RE00  49
ELSE IF(KAY==14)#                      Data set number                  RE00  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RE00  51
IF(BUFIN(K+1)<1.) iquit:(RE0030,K+1)#  Test data set number             RE00  52
NMDS=NINT(BUFIN(K+1));DSNM=REAL(NMDS)# Data set number                  RE00  53
K=K+1#                                                                  RE00  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RE00  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RE00  56
#                                                                       RE00  57
#        PRINT PROGRAM PARAMETERS                                       RE00  58
#       -------------------------                                       RE00  59
#                                                                       RE00  60
LINRM=4#                               Force control header             RE00  61
movechar:(RE2,27,CHROT,2,NRE2-2,2)#    Underline control header         RE00  62
writeline:(1,RE2,NRE2-1,1,3)#          Print control header             RE00  63
movechar:(RE3,MODE*12-11,RE4,25,12,0)# Insert calculation mode          RE00  64
writeline:(0,RE4,NRE4,3,3)#            Print calculation mode           RE00  65
#                                                                       RE00  66
#                                                                       RE00  67
#                                                                       RE00  68
#                                                                       RE00  69
#      CALL APPROPRIATE SUBROUTINE                                      RE00  70
#      ---------------------------                                      RE00  71
#                                                                       RE00  72
IF(MODE==1)#                                                            RE00  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RE00  74
CALL RE31#                             Std file to xtal bdf (part 1)    RE00  75
CALL RE32#                             Std file to xtal bdf (part 2)    RE00  76
CALL RE33#                             Std file to xtal bdf (part 3)    RE00  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RE00  78
ELSE IF(MODE==2)#                                                       RE00  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RE00  80
CALL RE51#                             Xtal bdf to std file (part 1)    RE00  81
CALL RE52#                             Xtal bdf to std file (part 2)    RE00  82
CALL RE53#                             Xtal bdf to std file (part 3)    RE00  83
CALL RE54#                             Xtal bdf to std file (part 4)    RE00  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RE00  85
readline:(RE0,NRE0)#                   Get rid of end record            RE00  86
#                                                                       RE00  87
RETURN#                                                                 RE00  88
END#                                                                    RE00  89
systemheader:(RE31)#                   Std file to xtal bdf (part 1)    RE31   1
####################################################################    RE31   2
#                                                                       RE31   3
#                        RE31                                           RE31   4
#                                                                       RE31   5
####################################################################    RE31   6
SUBROUTINE RE31#                                                        RE31   7
include:(AACOMN)#                                                       RE31   8
include:(RECOMN)#                      H.d. flack 1988, 1990            RE31   9
#                                                                       RE31  10
chardata:(RE39,EOS SYOPSPOSTWIN)#                                       RE31  11
datastuff:#                                                             RE31  12
#                                                                       RE31  13
#    INITIALIZE INPUT & OUTPUT FILES                                    RE31  14
#    -------------------------------                                    RE31  15
#                                                                       RE31  16
FILEXT(iofm1:)='SFI'#                  Scfs input file                  RE31  17
openfmt:(iofm1:,' ')#                  Open formatted scfs file         RE31  18
#                                                                       RE31  19
#    INITIALISE MEMORY                                                  RE31  20
#    -----------------                                                  RE31  21
#                                                                       RE31  22
IOMARK(1)=QXSTR+1#                     Start of bdf1 buffer             RE31  23
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of bdf2 buffer             RE31  24
MARK1=IOMARK(2)+bdfbuf:#               End   of bdf2 buffer             RE31  25
STEP1=9;MARK2=MARK1+ 40*STEP1#         Space for cell dim - m1 to m2    RE31  26
POINT1=MARK1#                                                           RE31  27
STEP2=mw24dm:+ 2;MARK3=MARK2+  6*STEP2# Space for sg name  - m2 to m3   RE31  28
POINT2=MARK2#                                                           RE31  29
STEP3=mw04dm:+16;MARK4=MARK3+100*STEP3# Space for symmetry - m3 to m4   RE31  30
POINT3=MARK3#                          Stop of used mark3               RE31  31
STEP4=mw424dm:+24;MARK5=MARK4+200*STEP4# Space for atoms    - m4 to m   RE31  32
POINT4=MARK4#                          Stop of used mark4               RE31  33
STEP5=mw06dm:+214;MARK6=MARK5+20*STEP5# Space for form fac - m5 to m6   RE31  34
POINT5=MARK5#                                                           RE31  35
STEP6=mw02dm:+ 8;MARK7=MARK6+ 60*STEP6# Space for conditio - m6 to m7   RE31  36
POINT6=MARK6#                                                           RE31  37
STEP7=mw12dm:+ 8;MARK8=MARK7+ 30*STEP7# Space for formula  - m7 to m8   RE31  38
POINT7=MARK7#                                                           RE31  39
STEP8=mw06dm:+ 8;MARK9=MARK8+ 30*STEP8# Space for crystal  - m8 to m9   RE31  40
POINT8=MARK8#                                                           RE31  41
STEP9=800;MARKA=MARK9+4*STEP9;POINT9=MARK9# Space for lrexpl:           RE31  42
MARK9B=MARK9+STEP9;MARK9C=MARK9B+STEP9#                                 RE31  43
MARK9D=MARK9C+STEP9#                                                    RE31  44
STEPA=mw65dm:+2; MARKB=MARKA+100*STEPA# Space for comments              RE31  45
POINTA=MARKA#                                                           RE31  46
STEPB=6;MARKC=MARKB+ 200*STEPB#        Space for 2 theta angle          RE31  47
POINTB=MARKB#                                                           RE31  48
STEPC=0;MARKD=MARKC#                                                    RE31  49
POINTC=MARKC#                                                           RE31  50
STEPD=0;MARKE=MARKD#                                                    RE31  51
POINTD=MARKD#                                                           RE31  52
STEPE=0;MARKZ=MARKE#                                                    RE31  53
POINTE=MARKE#                                                           RE31  54
incrqx:(MARKZ,MARKZ,RE3110)#           Expand qx                        RE31  55
#                                                                       RE31  56
#    INITIALIZE COUNTERS                                                RE31  57
#    -------------------                                                RE31  58
#                                                                       RE31  59
SYMCNT=0.#                             Count the symmetry records       RE31  60
UIJ=no:#                               No anisotropic displ. parms.     RE31  61
PEQNUM=-1.#                            Sequence number of line -1       RE31  62
movector:(RE39,1,QX(POINT5+1),1,6,0)#  Dummy fill of 1st atom type fo   RE31  63
POINT5=POINT5+STEP5#                   Marking used s values            RE31  64
movereal:(voidflg:,1,QX,MARK5+1,MARK6-MARK5,2)# Fill sf's with voidfl   RE31  65
MXDSK=20;PDSK=1;LDSKYS=4#              Initialize dsk                   RE31  66
movechar:(BLANK,1,DSKYS,1,4,1)#        Always have a blank dsk          RE31  67
UOV=voidflg:;UOVE=voidflg:#            Void uov and its esd             RE31  68
NSFS=0#                                Zero scattering factor tables    RE31  69
#                                                                       RE31  70
RETURN#                                                                 RE31  71
END#                                                                    RE31  72
systemheader:(RE32)#                   Std file to xtal bdf (part 2)    RE32   1
####################################################################    RE32   2
#                                                                       RE32   3
#                        RE32                                           RE32   4
#                                                                       RE32   5
####################################################################    RE32   6
SUBROUTINE RE32#                                                        RE32   7
include:(AACOMN)#                                                       RE32   8
include:(RECOMN)#                      H.d. flack 1988, 1990            RE32   9
#                                                                       RE32  10
INTEGER I,J,K,N,II,LL#                                                  RE32  11
INTEGER IP,NCID#                                                        RE32  12
INTEGER FLAG,IH(3),IK(3),NCHR,NCIDLD,PRCN#                              RE32  13
string:(NAME,8)#                                                        RE32  14
string:(POSONE,1)#                                                      RE32  15
#                                                                       RE32  16
chardata:(RE3A,TITLE   END     UNITS   CELL DIMSG NAME SYMMETRY$#       RE32  17
ATOMS   FORM FACHKL     CONDITIOFORMULA REMARK  CRYSTAL COMMENTS$#      RE32  18
HKL INTEGEOMETRYHKL PACKHKL COMP)#                                      RE32  19
chardata:(RE3J,EOS MICRMACRANGLTEMP)#                                   RE32  20
chardata:(RE37,EOS CELLERRSVOL PHYS)#                                   RE32  21
chardata:(RE35,EOS LATTHERMHALLSCHNSYSTBRAV)#                           RE32  22
chardata:(RE36,EOS SYOPSPOSTWIN)#                                       RE32  23
chardata:(RE33,EOS ATCOATCEUALLUALEUIJ UIJECHEM)#                       RE32  24
chardata:(RE34,EOS TABLEXP1EXP2)#                                       RE32  25
chardata:(RE3C,EOS FOBSFSQRINT CALCANGL)#                               RE32  26
chardata:(RE3D,EOS CELLINT HKL STD ABS FACEFAREORNTOUB1OUB2EQIV$#       RE32  27
REFNSTATVAR SHAPDETRBFILATTFPOLOWAVL)#                                  RE32  28
chardata:(RE3E,EOS FORLCRYSECRYANALENALAWPCEWPC)#                       RE32  29
chardata:(RE3F,EOS SCALEXTNEXTEABSRTWIN)#                               RE32  30
chardata:(RE3P,EOS JRNLAUTHTITLCAS PDB CSD ICSDMDF PDF ABSTINTR$#       RE32  31
EXPTDESCDISCCITAUPACNAMESRCEPREPFORMPEARPHASANGLABS OUB EXTNSSOL$#      RE32  32
SCATWGHTHYDRPROGORIGSYOPSPOSDISOHISTRMRK)#                              RE32  33
chardata:(RE3N,EOS INT )#                                               RE32  34
chardata:(RE3Q,EOS BONDBNDATORALSLNLSPLRBNDRANGRTORRPLNRRBN)#           RE32  35
chardata:(RE3R,EOINSQFOEO)#                                             RE32  36
chardata:(RE3S,HKL)#                                                    RE32  37
chardata:(RE3B, SCFS INPUT LINE OUT OF SEQUENCE. previous:        $#    RE32  38
current:        )#                                                      RE32  39
chardata:(RE3I, *** CAN NOT STORE THIS VALUE OF SINTH/L IN FORM $#      RE32  40
FACTOR section:          )#                                             RE32  41
chardata:(RE3G,ABCD)#                                                   RE32  42
chardata:(RE3H,AZ09)#                                                   RE32  43
chardata:(RE3K,ANGSPM  NM  )#                                           RE32  44
chardata:(STAR,*)#                                                      RE32  45
intdata:(TRUZRO,0)#                                                     RE32  46
intdata:(FRST,yes:)#                                                    RE32  47
intdata:(UNITS,0)#                     0=angstroms,1=picom,2=nanom      RE32  48
datastuff:#                                                             RE32  49
#                                                                       RE32  50
#     LOOK FOR SECTION HEADERS                                          RE32  51
#     ------------------------                                          RE32  52
#                                                                       RE32  53
FLAG=-1#                               Set flag - looking for title     RE32  54
REPEAT#                                Loop over all input records      RE32  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RE32  56
#                                                                       RE32  57
IF(FLAG<=0)#                           Looking for section headers      RE32  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RE32  59
readfmt:(iofm1:,'(A8,67X,F5.0)',999,[CHRIN(1^8),SEQNUM])# Read for      RE32  60
checksq:#                              Check sequence numbers           RE32  61
compchar:(CHRIN,1,RE3A,1,8,8,NRE3A,J)# Find section id code             RE32  62
IF((FLAG==-1)&(J!=1))J=-1#             Only title to start              RE32  63
IF((FLAG== 0)&(J==1))J= 0#             No title in middle               RE32  64
FLAG=J;NEXT#                           Set to read this section         RE32  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RE32  66
#                                                                       RE32  67
#     TITLE SECTION                                                     RE32  68
#     -------------                                                     RE32  69
#                                                                       RE32  70
ELSE IF (FLAG==1)#                     Test if title section            RE32  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RE32  72
readfmt:(iofm1:,'(A1,A74,F5.0)',999,[POSONE,CHRIN(1^74),SEQNUM])# R     RE32  73
checksq:#                              Check sequence numbers           RE32  74
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32  75
#                                                                       RE32  76
# WRITE PACKET 1 OF LOGICAL RECORD 1                                    RE32  77
#                                                                       RE32  78
writepkt:(1,lrhist:,3,IP)#             Point to history packet          RE32  79
#                                                                       RE32  80
# WRITE PACKET 1 OF LOGICAL RECORD LRLABL:                              RE32  81
#                                                                       RE32  82
NCHR=MIN0(mxchim:,72)#                 Protect against overwriting      RE32  83
writepkt:(1,lrlabl:,mxwdim:,IP)#       Point to creation packet         RE32  84
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               RE32  85
movector:(TITLE,1,QX(IP+1),1,NCHR,0)#  Insert current title             RE32  86
#                                                                       RE32  87
# WRITE PACKET 2 OF LOGICAL RECORD LRLABL:                              RE32  88
#                                                                       RE32  89
writepkt:(1,lrlabl:,mxwdim:,IP)#       Point to title packet            RE32  90
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               RE32  91
movector:(TITLE,40,QX(IP+1),1,NCHR,0)# Insert current title             RE32  92
#                                                                       RE32  93
# WRITE PACKET 3 OF LOGICAL RECORD LRLABL:                              RE32  94
#                                                                       RE32  95
NCHR=MIN0(mxchim:,74)#                 Protect against overwriting      RE32  96
writepkt:(1,lrlabl:,mxwdim:,IP)#       Point to label packet            RE32  97
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               RE32  98
movector:(CHRIN,1,QX(IP+1),1,74,0)#    Place the current title          RE32  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RE32 100
#                                                                       RE32 101
#     END SECTION                                                       RE32 102
#     -----------                                                       RE32 103
#                                                                       RE32 104
ELSE IF (FLAG==2)BREAK#                Test if end section              RE32 105
#                                                                       RE32 106
#     UNITS SECTION                                                     RE32 107
#     -------------                                                     RE32 108
#                                                                       RE32 109
ELSE IF (FLAG==3)#                                                      RE32 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RE32 111
readfmt:(iofm1:,'(A1,2A4,1X,A4,61X,F5.0)',#                             RE32 112
999,[POSONE,CID,DSK,CHRIN(1^4),SEQNUM])# Read record                    RE32 113
checksq:#                              Check sequence numbers           RE32 114
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 115
compchar:(CID,1,RE3J,1,4,4,NRE3J,NCID)# Pick up the cid number          RE32 116
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 117
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 118
ELSE IF (NCID==2)#                                                      RE32 119
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RE32 120
CALL RE38#                             Decode the dsk                   RE32 121
compchar:(CHRIN,1,RE3K,1,4,4,NRE3K,UNITS)# Find out the type of units   RE32 122
IF(UNITS>0) UNITS=UNITS-1#             Set units 0,1,2 ang,pm,nm        RE32 123
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RE32 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RE32 125
#                                                                       RE32 126
#     CELL DIMENSION SECTION  - STORE IN MEMORY                         RE32 127
#     ----------------------                                            RE32 128
#                                                                       RE32 129
ELSE IF(FLAG==4)#                      Test if cell section             RE32 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RE32 131
readfmt:(iofm1:,'(A1,2A4,1X,6F10.4,F5.0,F5.0)',#                        RE32 132
999,[POSONE,CID,DSK,(BUFIN(I),I=1,7),SEQNUM])# Read record              RE32 133
checksq:#                              Check sequence numbers           RE32 134
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 135
compchar:(CID,1,RE37,1,4,4,NRE37,NCID)# Pick up the cid number          RE32 136
#                                      Cell dim cid's stored one after  RE32 137
#                                      The other in the order of        RE32 138
#                                      Arrival.                         RE32 139
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 140
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 141
ELSE#                                                                   RE32 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RE32 143
CALL RE38#                             Decode the dsk                   RE32 144
movereal:(REAL(NCID),1,QX,POINT1+1,1,0)# Move ncid as real to memory    RE32 145
movereal:(REAL(NDSK),1,QX,POINT1+2,1,0)# Move ndsk as real to memory    RE32 146
movereal:(BUFIN,1,QX,POINT1+3,7,0)#    Move 7 reals to memory           RE32 147
POINT1=POINT1+STEP1#                   Up the mark1 pointer             RE32 148
IF(POINT1==MARK2)iquit:(RE3205)#       Quit if list space used up       RE32 149
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RE32 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RE32 151
#                                                                       RE32 152
#                                                                       RE32 153
#     SG NAME SECTION - STORE IN MEMORY                                 RE32 154
#     ---------------                                                   RE32 155
#                                                                       RE32 156
ELSE IF(FLAG==5)#                      Test if sg name section          RE32 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RE32 158
readfmt:(iofm1:,'(A1,2A4,1X,A24,41X,F5.0)',#                            RE32 159
999,[POSONE,CID,DSK,CHRIN(1^24),SEQNUM])# Read record                   RE32 160
checksq:#                              Check sequence numbers           RE32 161
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 162
compchar:(CID,1,RE35,1,4,4,NRE35,NCID)# Pick up the cid number          RE32 163
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 164
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 165
ELSE#                                                                   RE32 166
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RE32 167
CALL RE38#                             Decode the dsk                   RE32 168
movector:(CHRIN,1,QX(POINT2+1),1,24,0)# Move 24 characters to memory    RE32 169
movereal:(REAL(NCID),1,QX,POINT2+mw24dm:+1,1,0)# Move ncid to memory    RE32 170
movereal:(REAL(NDSK),1,QX,POINT2+mw24dm:+2,1,0)# Move ndsk to memory    RE32 171
POINT2=POINT2+STEP2#                   Up the mark2 pointer             RE32 172
IF(POINT2==MARK3)iquit:(RE3210)#       Quit if list space used up       RE32 173
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RE32 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RE32 175
#                                                                       RE32 176
#                                                                       RE32 177
#     SYMMETRY SECTION - STORE IN MEMORY                                RE32 178
#     ----------------                                                  RE32 179
#                                                                       RE32 180
ELSE IF(FLAG==6)#                      Test if symmetry section         RE32 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RE32 182
readfmt:(iofm1:,$#                                                      RE32 183
'(A1,2A4,A1,2(3F2.0,F10.7,4X),3F2.0,F10.7,A3,2F2.0,2X,F5.0)',#          RE32 184
999,[POSONE,CID,DSK,CHRIN(9^9),(BUFIN(I),I=1,12),#                      RE32 185
CHRIN(10^12),(BUFIN(I),I=13,14),SEQNUM])# Read record                   RE32 186
checksq:#                              Check sequence numbers           RE32 187
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 188
compchar:(CID,1,RE36,1,4,4,NRE36,NCID)# Pick up the cid number          RE32 189
#                                      Symmetry cid's stored one after  RE32 190
#                                      The other in the order of        RE32 191
#                                      Arrival.                         RE32 192
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 193
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 194
ELSE#                                                                   RE32 195
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RE32 196
IF(NCID==2)SYMCNT=SYMCNT+1.#           Count number of sym ops          RE32 197
CALL RE38#                             Decode the dsk                   RE32 198
movector:(CHRIN,9,QX(POINT3+1),1,4,0)# Move 4 characters to memory      RE32 199
movereal:(REAL(NCID),1,QX,POINT3+mw04dm:+1,1,0)# Move ncid to memory    RE32 200
movereal:(REAL(NDSK),1,QX,POINT3+mw04dm:+2,1,0)# Move ndsk to memory    RE32 201
movereal:(BUFIN,1,QX,POINT3+mw04dm:+3,14,0)# Move 14 reals to memory    RE32 202
POINT3=POINT3+STEP3#                   Up the mark3 pointer             RE32 203
IF(POINT3==MARK4)iquit:(RE3215)#       Quit if list space used up       RE32 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RE32 205
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RE32 206
#                                                                       RE32 207
#    ATOMS SECTION - STORE IN MEMORY                                    RE32 208
#    -------------                                                      RE32 209
#                                                                       RE32 210
ELSE IF(FLAG==7)#                      Test if atoms section            RE32 211
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RE32 212
readfmt:(iofm1:,'(A1,2A4,A2,A6,6F8.5,F3.0,A1,1X,A4,F1.0,F5.0)',#        RE32 213
999,[POSONE,CID,DSK,CHRIN(1^2),CHRIN(3^8),(BUFIN(I),I=1,7),#            RE32 214
CHRIN(9^9),CHRIN(10^13),BUFIN(8),SEQNUM])# Read record                  RE32 215
checksq:#                              Check sequence numbers           RE32 216
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 217
compchar:(CID,1,RE33,1,4,4,NRE33,NCID)# Pick up the cid number          RE32 218
#                                      Atco, atce, uij and uije stored  RE32 219
#                                      In the following order:          RE32 220
#  ATOM TYPE NAME, ATOM NAME, DISPLACEMENT PARAMETER TYPE, SF POINTER   RE32 221
#  X, Y, Z, U ISO, PP, SIGMA{ X, Y, Z, U ISO, PP},                      RE32 222
#  U11, U22, U33, U12, U13, U23, SIGMA{ U11, U22, U33, U12, U13, U23}   RE32 223
#                                                                       RE32 224
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 225
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 226
ELSE IF (NCID==4) UOV=BUFIN(1)#        Uall store u overall             RE32 227
ELSE IF (NCID==5) UOVE=BUFIN(1)#       Uale store sigma(uov)            RE32 228
ELSE#                                                                   RE32 229
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RE32 230
IF(NCID==2)#                           For atco need to make sure bot   RE32 231
#                                      An and ai are present            RE32 232
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RE32 233
IF(CHRIN(10^13)==BLANK(1^4))$#         If at is blank make it an        RE32 234
movechar:(CHRIN,1,CHRIN,10,2,0)#                                        RE32 235
IF(CHRIN(1^2)==BLANK(1^2))#            If an is blank make it at with   RE32 236
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RE32 237
movechar:(CHRIN,10,CHRIN,1,2,0)#                                        RE32 238
IF((CHRIN(2^2)<RE3H(1^1))\(CHRIN(2^2)>RE3H(2^2)))$# Make proper el na   RE32 239
movechar:(BLANK,1,CHRIN,2,1,0)#        2nd. char must be alphabetic     RE32 240
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RE32 241
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RE32 242
DO I=MARK4,POINT4-1,STEP4#             Look to see if atom name known   RE32 243
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RE32 244
movertoc:(QX(I+1+mw04dm:),1,NAME,1,8,0)# Get el-number string           RE32 245
IF(NAME==CHRIN(1^8)) BREAK#                                             RE32 246
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RE32 247
IF(I==POINT4)#                         New atom name                    RE32 248
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RE32 249
IF(POINT4==MARK5)iquit:(RE3220)#       Check enough space for new ato   RE32 250
movereal:(voidflg:,1,QX,POINT4+1,STEP4,2)# Void all words in packet     RE32 251
POINT4=POINT4+STEP4#                   Make room for new atom           RE32 252
movector:(CHRIN,1,QX(I+1+mw04dm:),1,8,0)# Move atom name scfs format    RE32 253
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RE32 254
#                                      I points into qx for this atom   RE32 255
IF (NCID==2)#                          Atco record                      RE32 256
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RE32 257
movereal:(BUFIN,1,QX,I+mw424dm:+ 3,5,0)# Move x,y,z,u,pp                RE32 258
IF(BUFIN(8)>7.0) BUFIN(8)=0.#          Dt type 8 or 9 (scfs) => 0       RE32 259
movereal:(BUFIN,8,QX,I+mw424dm:+ 1,1,0)# Move dt type                   RE32 260
movector:(CHRIN,10,QX(I+1),1,4,0)#     Atom type for ff                 RE32 261
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RE32 262
ELSE IF (NCID==3)$#                    Atce record                      RE32 263
movereal:(BUFIN,1,QX,I+mw424dm:+ 8,5,0)# Move sigma x,y,z,u,pp          RE32 264
ELSE IF (NCID==6)#                     Uij  record                      RE32 265
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RE32 266
UIJ=yes:#                              Anisotropic displ. parms. here   RE32 267
movereal:(BUFIN,1,QX,I+mw424dm:+13,6,0)# Move u11, etc                  RE32 268
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RE32 269
ELSE IF (NCID==7)#                     Uije record                      RE32 270
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RE32 271
UIJ=yes:#                              Anisotropic displ. parms. here   RE32 272
movereal:(BUFIN,1,QX,I+mw424dm:+19,6,0)# Move sigma u11, etc            RE32 273
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RE32 274
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RE32 275
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RE32 276
#                                                                       RE32 277
#                                                                       RE32 278
#     FORM FACTOR SECTION - STORE IN MEMORY                             RE32 279
#     -------------------                                               RE32 280
#                                                                       RE32 281
ELSE IF(FLAG==8)#                      Test if form factor section      RE32 282
#                                                                       RE32 283
#TABLES OF ATOMIC SCATTERING FACTORS ARE STORED STARTING AT MARK5,      RE32 284
#WITH ITEMS ARRANGED IN THE FOLLOWING ORDER: AT NAME (4 CHARS)+ELEMENT  RE32 285
#NAME AN (2CHARS); NUMBER OF ATOMS; MASS%; ESD MASS%; F'; F'';          RE32 286
#9 COEFFICIENTS OF CROMER-MANN TABLES; 200 ITEMS OF F AT S=0.00,0.01,   RE32 287
#                                                                       RE32 288
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RE32 289
readfmt:(iofm1:,'(A1,2A4,A2,A4,6F10.6,F5.0)',999,#                      RE32 290
[POSONE,CID,DSK,CHRIN(9^10),CHRIN(11^14),#                              RE32 291
(BUFIN(I),I=1,6),SEQNUM])#             Read line                        RE32 292
checksq:#                              Check sequence numbers           RE32 293
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 294
compchar:(CID,1,RE34,1,4,4,NRE34,NCID)# Pick up the cid number          RE32 295
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 296
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 297
ELSE IF (NCID>=2)#                     Treat tabl/exp1/exp2 lines       RE32 298
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 RE32 299
IF(CHRIN(11^14)==BLANK(1^4))$#         Make sure both at and an are t   RE32 300
movechar:(CHRIN,9,CHRIN,11,2,0)#       If at is blank make it an        RE32 301
IF(CHRIN(9^10)==BLANK(1^2))#           If an is blank make it at with   RE32 302
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 RE32 303
movechar:(CHRIN,11,CHRIN,9,2,0)#                                        RE32 304
IF((CHRIN(10^10)<RE3H(1^1))\(CHRIN(10^10)>RE3H(2^2)))$# Make proper e   RE32 305
movechar:(BLANK,1,CHRIN,10,1,0)#       2nd. char must be alphabetic     RE32 306
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 RE32 307
DO I=MARK5,POINT5-1,STEP5#             Find pointer i to table          RE32 308
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 RE32 309
movertoc:(QX(I+1),1,CHRIN,1,4,0)#      Pick up table at                 RE32 310
IF(CHRIN(1^4)==CHRIN(11^14)) BREAK#                                     RE32 311
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 RE32 312
IF(I==POINT5)#                         Its a new entry                  RE32 313
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 RE32 314
IF(POINT5==MARK6)iquit:(RE3225)#       Quit if list space used up       RE32 315
movector:(CHRIN,11,QX(POINT5+1),1,4,0)# Put at and an into memory       RE32 316
movector:(CHRIN, 9,QX(POINT5+1),5,2,0)# Its a new atom type             RE32 317
POINT5=POINT5+STEP5#                   Up the mark5 pointer             RE32 318
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 RE32 319
IF(NCID==2)#                           Treat table line                 RE32 320
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 RE32 321
movereal:(BUFIN,3,QX,I+mw06dm:+4,2,0)# Put f' and f''                   RE32 322
# FILL QX TABLE WITH THE VALUE OF F(S).  MARK S IN DUMMY AT TABLE       RE32 323
J=NINT(100.*BUFIN(1))#                 Get s pointer                    RE32 324
IF(ABS(BUFIN(1)-0.01*REAL(J))<0.0001)# Is s close to a storable value   RE32 325
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 RE32 326
ifne:(QX(MARK5+mw06dm:+15+J),1.0)#     Is this s value known ?          RE32 327
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 RE32 328
QX(MARK5+mw06dm:+15+J)=1.0#            Atom type 1 marks s as used      RE32 329
NSFS=NSFS+1#                           Count number of s values         RE32 330
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 RE32 331
QX(I+mw06dm:+15+J)=BUFIN(2)#           Keep f                           RE32 332
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 RE32 333
ELSE#                                                                   RE32 334
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 RE32 335
ncodefld:(BUFIN,1,RE3I,740642.,1)#     Format the odd value of s        RE32 336
writeline:(1,RE3I,NRE3I,3,1)#          Print the warning                RE32 337
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 RE32 338
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 RE32 339
ELSE IF(NCID==3)movereal:(BUFIN,1,QX,I+mw06dm:+6,6,0)# Put a1 .. b3     RE32 340
ELSE IF(NCID==4)#                      Exp2 line                        RE32 341
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 RE32 342
movereal:(BUFIN,1,QX,I+mw06dm:+12,3,0)# Put a4 b4 c                     RE32 343
movereal:(BUFIN,4,QX,I+mw06dm:+4,2,0)# Put f' and f''                   RE32 344
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 RE32 345
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 RE32 346
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RE32 347
#                                                                       RE32 348
#    HKL SECTION - STORE 2THETA ANGLES - COPY INTENSITIES TO BDF        RE32 349
#    -----------                                                        RE32 350
#                                                                       RE32 351
ELSE IF(FLAG==9)#                      Test if hkl section              RE32 352
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 RE32 353
readfmt:(iofm1:,'(A1,2A4,3F5.0,A1,5F10.3,F5.0)',999,#                   RE32 354
[POSONE,CID,DSK,(BUFIN(I),I=1,3),CHRIN(1^1),#                           RE32 355
(BUFIN(I),I=4,8),SEQNUM])#             Read line                        RE32 356
checksq:#                              Check sequence numbers           RE32 357
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 358
compchar:(CID,1,RE3C,1,4,4,NRE3C,NCID)# Pick up the cid number          RE32 359
#                                      Hkl lines written straight to bd RE32 360
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 361
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 362
ELSE IF (NCID==6)#                     Angl (2 theta lines)             RE32 363
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 RE32 364
CALL RE38#                             Keep data set key                RE32 365
QX(POINTB+1)=REAL(NDSK)#               Store data set key               RE32 366
movereal:(BUFIN,1,QX,POINTB+2,4,0)#    Move h k l 2theta to memory      RE32 367
IF      (CHRIN(1^1)=='1') QX(POINTB+6)=1.0# Alpha 1 pointer             RE32 368
ELSE IF (CHRIN(1^1)=='2') QX(POINTB+6)=2.0# Alpha 2 pointer             RE32 369
ELSE QX(POINTB+6)=0.0#                 Default wavelength pointer       RE32 370
POINTB=POINTB+STEPB#                   Up the markb pointer             RE32 371
IF(POINTB==MARKC)iquit:(RE3255)#       Quit if list space used up       RE32 372
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 RE32 373
ELSE#                                                                   RE32 374
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 RE32 375
IF(FRST==yes:)#                        Test if first entry              RE32 376
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 RE32 377
CALL RE38#                             Keep data set key                RE32 378
FRST=no:#                              Reset first entry flag           RE32 379
NCIDLD=NCID#                           Keep first ncid                  RE32 380
IF(NCID<4) N=4#                                                         RE32 381
ELSE N=6#                                                               RE32 382
writepkt:(1,lrrefl:,N,IP)#             Point to hkl dir packet          RE32 383
QX(IP+1)=1.;QX(IP+2)=1308.#            Set hkl and rcode                RE32 384
QX(IP+3)=1304.;QX(IP+4)=1305.#         Set fobs and sigma(fobs)         RE32 385
IF(NCID==3)#                           Fsqr                             RE32 386
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 RE32 387
QX(IP+3)=1302.;QX(IP+4)=1303.#         Set f**2 obs and sigma           RE32 388
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 RE32 389
ELSE IF(NCID==4)#                      Int                              RE32 390
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 RE32 391
QX(IP+5)=1300.;QX(IP+6)=1301.#         Set intensity and sigma i        RE32 392
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 RE32 393
ELSE IF(NCID==5)#                      Calc                             RE32 394
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 RE32 395
QX(IP+5)=1805.;QX(IP+6)=1806.#         A and b                          RE32 396
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 RE32 397
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 RE32 398
IF(NCIDLD==NCID)#                      Only treat the same cid          RE32 399
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 RE32 400
writepkt:(1,lrrefl:,N,IP)#             Point to hkl packet              RE32 401
DO I=1,N; QX(IP+I)=voidflg:#           Void fill                        RE32 402
DO I=1,3; IH(I)=NINT(ABS(BUFIN(I)))#   Integerize hkl                   RE32 403
K=0#                                   Start hkl sign code              RE32 404
IF(BUFIN(3)<(-.5)) K=K+1#              Test for sign of l               RE32 405
IF(BUFIN(2)<(-.5)) K=K+2#              Test for sign of k               RE32 406
IF(BUFIN(1)<(-.5)) K=K+4#              Test for sign of h               RE32 407
intpak:(TRUZRO,QX(IP+1),0,mxbtwd:)#    Clear packed word                RE32 408
intpak:(K    ,QX(IP+1), 0,3)#          Pack sigk ik bits  2- 0          RE32 409
intpak:(IH(3),QX(IP+1), 3,9)#          Pack /l/  in bits 11- 3          RE32 410
intpak:(IH(2),QX(IP+1),12,9)#          Pack /k/  in bits 20-12          RE32 411
intpak:(IH(1),QX(IP+1),21,9)#          Pack /h/  in bits 29-21          RE32 412
QX(IP+2)=1.#                           Put default rcode - observed     RE32 413
IF(CHRIN(1^1)==RE3G(2^2)) QX(IP+2)=2.# A less-than                      RE32 414
IF(CHRIN(1^1)==RE3G(3^3)) QX(IP+2)=3.# An unreliable measurement        RE32 415
IF(CHRIN(1^1)==RE3G(4^4)) QX(IP+2)=5.# A space-group absent reflect.    RE32 416
QX(IP+3)=BUFIN(4)#                     Put fobs or f**2obs              RE32 417
QX(IP+4)=BUFIN(5)#                     Put sigma fobs or f**2           RE32 418
IF(NCID==4)#                           Int                              RE32 419
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 RE32 420
QX(IP+5)=BUFIN(6)#                     I(net)                           RE32 421
QX(IP+6)=BUFIN(8)#                     Sigma i(net)                     RE32 422
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 RE32 423
ELSE IF(NCID==5)#                      Calc                             RE32 424
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 RE32 425
QX(IP+5)=BUFIN(7)#                     A                                RE32 426
QX(IP+6)=BUFIN(8)#                     B                                RE32 427
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 RE32 428
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 RE32 429
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 RE32 430
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 RE32 431
#                                                                       RE32 432
#   CONDITIONS SECTION - STORE IN MEMORY                                RE32 433
#   ------------------                                                  RE32 434
#                                                                       RE32 435
ELSE IF(FLAG==10)#                     Test if conditions section       RE32 436
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 RE32 437
readfmt:(iofm1:,'(A1,2A4,A1,6F10.0,5X,F5.0)',999,#                      RE32 438
[POSONE,CID,DSK,CHRIN(1^1),(BUFIN(I),I=1,6),SEQNUM])# Read line         RE32 439
checksq:#                              Check sequence numbers           RE32 440
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 441
compchar:(CID,1,RE3D,1,4,4,NRE3D,NCID)# Pick up the cid number          RE32 442
#                                      Conditio cid's stored one after  RE32 443
#                                      The other in the order of        RE32 444
#                                      Arrival.                         RE32 445
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 446
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 447
ELSE#                                                                   RE32 448
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 RE32 449
CALL RE38#                             Decode the dsk                   RE32 450
movector:(CHRIN,1,QX(POINT6+1),1, 1,0)# Move  1 character to memory     RE32 451
movereal:(REAL(NCID),1,QX,POINT6+mw02dm:+1,1,0)# Move real ncid to me   RE32 452
movereal:(REAL(NDSK),1,QX,POINT6+mw02dm:+2,1,0)# Move real ndsk to me   RE32 453
movereal:(BUFIN,1,QX,POINT6+mw02dm:+3,6,0)# Move 6 reals to memory      RE32 454
POINT6=POINT6+STEP6#                   Up the mark6 pointer             RE32 455
IF(POINT6==MARK7)iquit:(RE3230)#       Quit if list space used up       RE32 456
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 RE32 457
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 RE32 458
#                                                                       RE32 459
#   FORMULA SECTION - STORE IN MEMORY                                   RE32 460
#   ---------------                                                     RE32 461
#                                                                       RE32 462
ELSE IF(FLAG==11)#                     Test if formula section          RE32 463
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 RE32 464
readfmt:(iofm1:,'(A1,2A4,6(A2,F8.4),6X,F5.0)',999,#                     RE32 465
[POSONE,CID,DSK,CHRIN(9^10),BUFIN(1),CHRIN(11^12),BUFIN(2),#            RE32 466
CHRIN(13^14),BUFIN(3),CHRIN(15^16),BUFIN(4),CHRIN(17^18),BUFIN(5),#     RE32 467
CHRIN(19^20),BUFIN(6),SEQNUM])#        Read line                        RE32 468
checksq:#                              Check sequence numbers           RE32 469
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 470
compchar:(CID,1,RE3E,1,4,4,NRE3E,NCID)# Pick up the cid number          RE32 471
#                                      Formula cid's stored one after   RE32 472
#                                      The other in the order of        RE32 473
#                                      Arrival.                         RE32 474
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 475
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 476
ELSE#                                                                   RE32 477
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 RE32 478
CALL RE38#                             Decode the dsk                   RE32 479
movereal:(REAL(NCID),1,QX,POINT7+mw12dm:+1,1,0)# Move real ncid to me   RE32 480
movereal:(REAL(NDSK),1,QX,POINT7+mw12dm:+2,1,0)# Move real ndsk to me   RE32 481
movereal:(BUFIN,1,QX,POINT7+mw12dm:+3,6,0)# Move 6 reals to memory      RE32 482
movector:(CHRIN,9,QX(POINT7+1),1,12,0)# Move 6 el. names to memory      RE32 483
POINT7=POINT7+STEP7#                   Up the mark7 pointer             RE32 484
IF(POINT7==MARK8)iquit:(RE3235)#       Quit if list space used up       RE32 485
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 RE32 486
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 RE32 487
#                                                                       RE32 488
#     REMARK SECTION                                                    RE32 489
#     --------------                                                    RE32 490
#                                                                       RE32 491
ELSE IF (FLAG==12)#                                                     RE32 492
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 RE32 493
readfmt:(iofm1:,'(A1,A74,F5.0)',#                                       RE32 494
999,[POSONE,CHRIN(1^74),SEQNUM])#      Read record                      RE32 495
checksq:#                              Check sequence numbers           RE32 496
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 497
writeline:(1,CHRIN,74,3,3)#                                             RE32 498
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 RE32 499
#                                                                       RE32 500
#   CRYSTAL SECTION - STORE IN MEMORY                                   RE32 501
#   ---------------                                                     RE32 502
#                                                                       RE32 503
ELSE IF(FLAG==13)#                     Test if crystal section          RE32 504
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 RE32 505
readfmt:(iofm1:,'(A1,2A4,2A3,6F10.0,F5.0)',999,#                        RE32 506
[POSONE,CID,DSK,CHRIN(9^11),CHRIN(12^14),#                              RE32 507
(BUFIN(I),I=1,6),SEQNUM])#             Read line                        RE32 508
checksq:#                              Check sequence numbers           RE32 509
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 510
compchar:(CID,1,RE3F,1,4,4,NRE3F,NCID)# Pick up the cid number          RE32 511
#                                      Crystal cid's stored one after   RE32 512
#                                      The other in the order of        RE32 513
#                                      Arrival.                         RE32 514
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 515
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 516
ELSE#                                                                   RE32 517
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 RE32 518
CALL RE38#                             Decode the dsk                   RE32 519
movector:(CHRIN,1,QX(POINT8+1),1,6,0)# Move 6 characters to memory      RE32 520
movereal:(REAL(NCID),1,QX,POINT8+mw06dm:+1,1,0)# Move real ncid to me   RE32 521
movereal:(REAL(NDSK),1,QX,POINT8+mw06dm:+2,1,0)# Move real ndsk to me   RE32 522
movereal:(BUFIN,1,QX,POINT8+mw06dm:+3,6,0)# Move 6 reals to memory      RE32 523
POINT8=POINT8+STEP8#                   Up the mark8 pointer             RE32 524
IF(POINT8==MARK9)iquit:(RE3240)#       Quit if list space used up       RE32 525
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 RE32 526
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 RE32 527
#                                                                       RE32 528
#     COMMENTS SECTION                                                  RE32 529
#     -------------                                                     RE32 530
#                                                                       RE32 531
ELSE IF (FLAG==14)#                                                     RE32 532
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 RE32 533
readfmt:(iofm1:,'(A1,2A4,1X,A65,F5.0)',999,#                            RE32 534
[POSONE,CID,DSK,CHRIN(1^65),SEQNUM])#  Read line                        RE32 535
checksq:#                              Check sequence numbers           RE32 536
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 537
compchar:(CID,1,RE3P,1,4,4,NRE3P,NCID)# Pick up the cid number          RE32 538
#                                      Comment cid's stored one after   RE32 539
#                                      The other in the order of        RE32 540
#                                      Arrival.                         RE32 541
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 542
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 543
ELSE#                                                                   RE32 544
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 RE32 545
CALL RE38#                             Decode the dsk                   RE32 546
movector:(CHRIN,1,QX(POINTA+1),1,65,0)# Pick up comment                 RE32 547
movereal:(REAL(NCID),1,QX,POINTA+mw65dm:+1,1,0)# Move real ncid to me   RE32 548
movereal:(REAL(NDSK),1,QX,POINTA+mw65dm:+2,1,0)# Move real ndsk to me   RE32 549
POINTA=POINTA+STEPA#                   Up the marka pointer             RE32 550
IF(POINTA==MARKB)iquit:(RE3245)#       Quit if list space used up       RE32 551
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 RE32 552
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 RE32 553
#                                                                       RE32 554
#    HKL INTEGRATED SECTION - COPY DIRECTLY TO BDF                      RE32 555
#    ----------------------                                             RE32 556
#                                                                       RE32 557
ELSE IF(FLAG==15)#                     Test if hkl inte section         RE32 558
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 RE32 559
readfmt:(iofm1:,'(A1,2A4,I2,3F5.0,3F10.0,F9.3,F10.0,F5.0)',999,#        RE32 560
[POSONE,CID,DSK,PRCN,(BUFIN(I),I=1,8),SEQNUM])# Read 1st. pr            RE32 561
checksq:#                              Check sequence numbers           RE32 562
IF(PRCN==2)#                           Get 2nd. pr                      RE32 563
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 RE32 564
readfmt:(iofm1:,'(5X,4F2.0,6F8.3,2F7.3,F5.0)',999,#                     RE32 565
[(BUFIN(I),I=9,20),SEQNUM])#           Read 2nd. pr                     RE32 566
checksq:#                              Check sequence numbers           RE32 567
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 RE32 568
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 569
compchar:(CID,1,RE3N,1,4,4,NRE3N,NCID)# Pick up the cid number          RE32 570
#                                      Hkl lines written straight to bd RE32 571
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 572
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 573
ELSE#                                                                   RE32 574
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 RE32 575
IF(FRST==yes:)#                        Test if first entry              RE32 576
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 RE32 577
CALL RE38#                             Keep data set key                RE32 578
FRST=no:#                              Reset first entry flag           RE32 579
NCIDLD=NCID#                           Keep first ncid                  RE32 580
N= 18#                                                                  RE32 581
writepkt:(1,lrrefl:,N,IP)#             Point to hkl dir packet          RE32 582
QX(IP+1)=1.;QX(IP+2)=1021.#            Set hkl & peak counts            RE32 583
QX(IP+3)=1023.;QX(IP+4)=1024.#         Set left & right background      RE32 584
QX(IP+5)=1011.;QX(IP+6)=1014.#         Set azimuth & elapsed time       RE32 585
QX(IP+7)=1026.;QX(IP+8)=1309.#         Set attenuator & scale set       RE32 586
QX(IP+9)=1018.;QX(IP+10)=1046.#        Set standard flag & back scan    RE32 587
QX(IP+11)=1047.;QX(IP+12)=1048.#       Set flack-blanc coefficients:    RE32 588
QX(IP+13)=1049.;QX(IP+14)=1050.#       Cnp, cnb, cnl & cnr              RE32 589
QX(IP+15)=1010.;QX(IP+16)=1051.#       Set scan width & type            RE32 590
QX(IP+17)=1052.;QX(IP+18)=1053.#       Set hor & vert detector apertu   RE32 591
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 RE32 592
IF(NCIDLD==NCID)#                      Only treat the same cid          RE32 593
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 RE32 594
writepkt:(1,lrrefl:,N,IP)#             Point to hkl packet              RE32 595
DO I=1,N; QX(IP+I)=voidflg:#           Void fill                        RE32 596
DO I=2,N; QX(IP+I)=BUFIN(I+2)#         Fill bdf from scfs 90            RE32 597
DO I=1,3; IH(I)=NINT(ABS(BUFIN(I)))#   Integerize hkl                   RE32 598
K=0#                                   Start hkl sign code              RE32 599
IF(BUFIN(3)<(-.5)) K=K+1#              Test for sign of l               RE32 600
IF(BUFIN(2)<(-.5)) K=K+2#              Test for sign of k               RE32 601
IF(BUFIN(1)<(-.5)) K=K+4#              Test for sign of h               RE32 602
intpak:(TRUZRO,QX(IP+1),0,mxbtwd:)#    Clear packed word                RE32 603
intpak:(K    ,QX(IP+1), 0,3)#          Pack sigk ik bits  2- 0          RE32 604
intpak:(IH(3),QX(IP+1), 3,9)#          Pack /l/  in bits 11- 3          RE32 605
intpak:(IH(2),QX(IP+1),12,9)#          Pack /k/  in bits 20-12          RE32 606
intpak:(IH(1),QX(IP+1),21,9)#          Pack /h/  in bits 29-21          RE32 607
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 RE32 608
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 RE32 609
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 RE32 610
#                                                                       RE32 611
#     GEOMETRY SECTION                                                  RE32 612
#     ----------------                                                  RE32 613
#                                                                       RE32 614
ELSE IF (FLAG==16)#                                                     RE32 615
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 RE32 616
readfmt:(iofm1:,'(A1,2A4,I2,6F8.4,2F2.0,A1,11X,F5.0)',999,#             RE32 617
[POSONE,CID,DSK,PRCN,(BUFIN(I),I=1,8),CHRIN(1^1),SEQNUM])# Read 1st.    RE32 618
checksq:#                              Check sequence numbers           RE32 619
DO J=2,PRCN#                           Get following physical recs      RE32 620
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 RE32 621
readfmt:(iofm1:,'(6X,A11,3F2.0,2F8.4,36X,F5.0)',999,#                   RE32 622
[CHRIN(2^12),(BUFIN(I),I=9,13),SEQNUM])# Read following physical recs   RE32 623
checksq:#                              Check sequence numbers           RE32 624
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 RE32 625
compchar:(CID,1,RE3Q,1,4,4,NRE3Q,NCID)# Pick up the cid number          RE32 626
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 627
#                                                                       RE32 628
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 629
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 630
ELSE#                                                                   RE32 631
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 RE32 632
# PROGRAMME THE REST WHEN WE KNOW WHAT USE TO MAKE OF IT AND WHERE      RE32 633
# TO PUT IT IN THE BDF.                                                 RE32 634
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 RE32 635
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 RE32 636
#                                                                       RE32 637
#    HKL PACK SECTION - COPY DIRECTLY TO BDF                            RE32 638
#    ----------------                                                   RE32 639
#                                                                       RE32 640
ELSE IF(FLAG==17)#                     Test if hkl pack section         RE32 641
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 58 RE32 642
readfmt:(iofm1:,#                                                       RE32 643
'(A1,3F3.0,F8.2,F6.2,A1,2(1X,3F3.0,F8.2,F6.2,A1),F5.0)',999,#           RE32 644
[POSONE,(BUFIN(I),I=1,5),CHRIN(1^1),(BUFIN(I),I=6,10),CHRIN(2^2),#      RE32 645
(BUFIN(I),I=11,15),CHRIN(3^3),SEQNUM])# Read line                       RE32 646
checksq:#                              Check sequence numbers           RE32 647
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 648
#                                      Hkl lines written straight to bd RE32 649
IF(FRST==yes:)#                        Test if first entry              RE32 650
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 RE32 651
FRST=no:#                              Reset first entry flag           RE32 652
N=4#                                                                    RE32 653
writepkt:(1,lrrefl:,N,IP)#             Point to hkl dir packet          RE32 654
QX(IP+1)=1.;QX(IP+2)=1308.#            Set hkl and rcode                RE32 655
QX(IP+3)=1304.;QX(IP+4)=1305.#         Set fobs and sigma(fobs)         RE32 656
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 RE32 657
DO J=1,3#                              Loop over the 3 reflections/li   RE32 658
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 60 RE32 659
I=5*J-5#                                                                RE32 660
DO K=1,3; IH(K)=NINT(ABS(BUFIN(I+K)))# Integerize hkl                   RE32 661
IF(IH(1)!=999)#                        Omit the fill on last line       RE32 662
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 61 RE32 663
writepkt:(1,lrrefl:,N,IP)#             Point to hkl packet              RE32 664
DO II=1,N; QX(IP+II)=voidflg:#         Void fill                        RE32 665
K=0#                                   Start hkl sign code              RE32 666
IF(BUFIN(I+3)<(-.5)) K=K+1#            Test for sign of l               RE32 667
IF(BUFIN(I+2)<(-.5)) K=K+2#            Test for sign of k               RE32 668
IF(BUFIN(I+1)<(-.5)) K=K+4#            Test for sign of h               RE32 669
intpak:(TRUZRO,QX(IP+1),0,mxbtwd:)#    Clear packed word                RE32 670
intpak:(K    ,QX(IP+1), 0,3)#          Pack sigk ik bits  2- 0          RE32 671
intpak:(IH(3),QX(IP+1), 3,9)#          Pack /l/  in bits 11- 3          RE32 672
intpak:(IH(2),QX(IP+1),12,9)#          Pack /k/  in bits 20-12          RE32 673
intpak:(IH(1),QX(IP+1),21,9)#          Pack /h/  in bits 29-21          RE32 674
QX(IP+2)=1.#                           Put default rcode - observed     RE32 675
IF(CHRIN(J^J)==RE3G(2^2)) QX(IP+2)=2.# A less-than                      RE32 676
IF(CHRIN(J^J)==RE3G(3^3)) QX(IP+2)=3.# An unreliable measurement        RE32 677
IF(CHRIN(J^J)==RE3G(4^4)) QX(IP+2)=5.# A space-group absent reflect.    RE32 678
QX(IP+3)=BUFIN(I+4)#                   Put fobs                         RE32 679
QX(IP+4)=BUFIN(I+5)#                   Put sigma fobs                   RE32 680
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 61 RE32 681
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 60 RE32 682
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 58 RE32 683
#                                                                       RE32 684
#    HKL COMP SECTION - COPY DIRECTLY TO BDF                            RE32 685
#    ----------------                                                   RE32 686
#                                                                       RE32 687
ELSE IF(FLAG==18)#                     Test if hkl comp section         RE32 688
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 62 RE32 689
readfmt:(iofm1:,#                                                       RE32 690
'(A1,A2,A1,2F3.0,5(F3.0,F7.0,F3.0),F5.0)',999,#                         RE32 691
[POSONE,CID,CHRIN(1^1),(BUFIN(I),I=1,17),SEQNUM])# Read line            RE32 692
checksq:#                              Check sequence numbers           RE32 693
compchar:(CID,1,RE3R,1,2,2,NRE3R,NCID)# Pick up the rid number          RE32 694
IF(POSONE==STAR) FLAG=0#               Eos - look for new section hea   RE32 695
#                                      Hkl lines written straight to bd RE32 696
IF      (NCID==0)#                     Unrecognized cid - do nothing    RE32 697
ELSE IF (NCID==1) FLAG=0#              Eos  record                      RE32 698
ELSE#                                                                   RE32 699
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 63 RE32 700
IF(FRST==yes:)#                        Test if first entry              RE32 701
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 64 RE32 702
FRST=no:#                              Reset first entry flag           RE32 703
writepkt:(1,lrrefl:,3,IP)#             Point to hkl dir packet          RE32 704
QX(IP+1)=1.#                           Set hkl                          RE32 705
QX(IP+2)=1296.+REAL(2*NCID)#           Irel/f**2rel/frel                RE32 706
QX(IP+3)=1297.+REAL(2*NCID)#           E.s.d of above                   RE32 707
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 64 RE32 708
DO K=1,3; IK(K)=NINT(BUFIN(K))#        Integerize hkl first reflectio   RE32 709
DO K=1,3; IH(K)=ABS(IK(K))#            |h| |k| |l| first reflection     RE32 710
compchar:(CHRIN,1,RE3S,1,1,1,3,LL)#    Find fast moving index           RE32 711
DO J=1,5#                              Loop over the 5 reflections/li   RE32 712
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 65 RE32 713
IF(J!=1)IK(LL)=NINT(BUFIN(3*J))#       Fast moving index for this ref   RE32 714
IH(LL)=ABS(IK(LL))#                    Absolute value of above          RE32 715
IF(IK(LL)!=999)#                       Omit the fill reflections        RE32 716
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 66 RE32 717
writepkt:(1,lrrefl:,3,IP)#             Point to hkl packet              RE32 718
DO II=1,3; QX(IP+II)=voidflg:#         Void fill                        RE32 719
K=0#                                   Start hkl sign code              RE32 720
IF(IK(3)<0) K=K+1#                     Test for sign of l               RE32 721
IF(IK(2)<0) K=K+2#                     Test for sign of k               RE32 722
IF(IK(1)<0) K=K+4#                     Test for sign of h               RE32 723
intpak:(TRUZRO,QX(IP+1),0,mxbtwd:)#    Clear packed word                RE32 724
intpak:(K    ,QX(IP+1), 0,3)#          Pack sigk ik bits  2- 0          RE32 725
intpak:(IH(3),QX(IP+1), 3,9)#          Pack /l/  in bits 11- 3          RE32 726
intpak:(IH(2),QX(IP+1),12,9)#          Pack /k/  in bits 20-12          RE32 727
intpak:(IH(1),QX(IP+1),21,9)#          Pack /h/  in bits 29-21          RE32 728
QX(IP+2)=BUFIN(3*J+1)#                 Put obs value                    RE32 729
QX(IP+3)=BUFIN(3*J+2)#                 Put sigma obs value              RE32 730
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 66 RE32 731
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 65 RE32 732
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 63 RE32 733
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 62 RE32 734
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RE32 735
#                                                                       RE32 736
RETURN#                                                                 RE32 737
999CONTINUE#                                                            RE32 738
iquit:(RE3250)#                        Unexpected eof on scfs           RE32 739
END#                                                                    RE32 740
systemheader:(RE33)#                   Std file to xtal bdf (part 3)    RE33   1
####################################################################    RE33   2
#                                                                       RE33   3
#                        RE33                                           RE33   4
#                                                                       RE33   5
####################################################################    RE33   6
SUBROUTINE RE33#                                                        RE33   7
include:(AACOMN)#                                                       RE33   8
include:(RECOMN)#                      H.d. flack 1988, 1990            RE33   9
#                                                                       RE33  10
INTEGER I,J,K,L,M,N,K1,K2,K3,K4,K5,K6#                                  RE33  11
INTEGER KS,II,NCID,FRST#                                                RE33  12
INTEGER IP,JP,KP#                                                       RE33  13
#                                                                       RE33  14
chardata:(RE3O,PIRFABCH N +C-)#                                         RE33  15
chardata:(RE3L,TRICMONOORTHTETRTRIGRHOMHEXACUBI)#                       RE33  16
chardata:(RE3M,PARE)#                                                   RE33  17
datastuff:#                                                             RE33  18
#                                                                       RE33  19
#====================================================================== RE33  20
#                                                                       RE33  21
closefmt:(iofm1:)#                     Close the scfs file              RE33  22
writepkt:(1,endrecord:,1,IP)#          Finish off history, label,       RE33  23
#                                      Reflection bdf.                  RE33  24
copyfile:(1,2,1,lrlabl:)#              Copy history and label info.     RE33  25
#                                                                       RE33  26
#====================================================================== RE33  27
# MAKE SURE THERE IS AT LEAST ONE DATA SET WITH A NAME                  RE33  28
IF(PDSK==1)#                           We must have one named data se   RE33  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RE33  30
PDSK=2;LDSKYS=8;movechar:(RE3M,1,DSKYS,5,4,0)# One pare data set        RE33  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RE33  32
#====================================================================== RE33  33
#                                                                       RE33  34
#   LRCELL:   -   FILL FROM MEMORY                                      RE33  35
#                                                                       RE33  36
#  TAKE INFORMATION FROM BLANK OR FIRST NAMED DSK                       RE33  37
#                                                                       RE33  38
K1=0;K2=0;K3=0;K4=0#                   Set pointers to cell dim cids    RE33  39
DO J=MARK1,POINT1-1,STEP1#             Turn over stored cell dimensio   RE33  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RE33  41
NCID=NINT(QX(J+1))#                    Pick up ncid                     RE33  42
IF(NINT(QX(J+2))<=2)#                  Is it the dsk we want?           RE33  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RE33  44
IF(NCID==2)K1=J+2#                     Cell line                        RE33  45
ELSE IF(NCID==3)K2=J+2#                Errs line                        RE33  46
ELSE IF(NCID==4)K3=J+2#                Vol  line                        RE33  47
ELSE IF(NCID==5)K4=J+2#                Phys line                        RE33  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RE33  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RE33  50
writepkt:(2,lrcell:,9,IP)#             Point to real cell packet        RE33  51
DO I=1,9; QX(IP+I)=voidflg:#           Void fill                        RE33  52
IF(K1!=0)#                                                              RE33  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RE33  54
QX(IP+1)=QX(K1+ 1)#                    Store a                          RE33  55
QX(IP+2)=QX(K1+ 2)#                    Store b                          RE33  56
QX(IP+3)=QX(K1+ 3)#                    Store c                          RE33  57
QX(IP+7)=QX(K1+ 4)/360.#               Store alpha in cycles            RE33  58
QX(IP+8)=QX(K1+ 5)/360.#               Store beta  in cycles            RE33  59
QX(IP+9)=QX(K1+ 6)/360.#               Store gamma in cycles            RE33  60
ZMOL=QX(K1+7)#                         Save no. molecules per cell      RE33  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RE33  62
#                                                                       RE33  63
writepkt:(2,lrcell:,9,IP)#             Point to error packet            RE33  64
DO I=1,9; QX(IP+I)=voidflg:#           Void fill                        RE33  65
IF(K2!=0)#                                                              RE33  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RE33  67
QX(IP+1)=QX(K2+ 1)#                    Store sigma a                    RE33  68
QX(IP+2)=QX(K2+ 2)#                    Store sigma b                    RE33  69
QX(IP+3)=QX(K2+ 3)#                    Store sigma c                    RE33  70
QX(IP+7)=QX(K2+ 4)/360.#               Store sigma alpha in cycles      RE33  71
QX(IP+8)=QX(K2+ 5)/360.#               Store sigma beta  in cycles      RE33  72
QX(IP+9)=QX(K2+ 6)/360.#               Store sigma gamma in cycles      RE33  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RE33  74
#                                                                       RE33  75
writepkt:(2,lrcell:,9,IP)#             Point to recip cell pak          RE33  76
DO I=1,9; QX(IP+I)=voidflg:#           Void fill                        RE33  77
writepkt:(2,lrcell:,9,IP)#             Point to transform packet        RE33  78
DO I=1,9; QX(IP+I)=voidflg:#           Void fill                        RE33  79
writepkt:(2,lrcell:,9,IP)#             Point inv transform pkt          RE33  80
DO I=1,9; QX(IP+I)=voidflg:#           Void fill                        RE33  81
writepkt:(2,lrcell:,9,IP)#             Point to volume packet           RE33  82
DO I=1,9; QX(IP+I)=voidflg:#           Void fill                        RE33  83
IF(K3!=0)#                                                              RE33  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RE33  85
QX(IP+1)=QX(K3+ 1)#                    Store cell volume                RE33  86
QX(IP+2)=QX(K3+ 2)#                    Store e.s.d. cell volume         RE33  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RE33  88
#                                                                       RE33  89
#   LRSYMM:   -   FILL FROM MEMORY                                      RE33  90
#                                                                       RE33  91
#                                                                       RE33  92
#  TAKE INFORMATION FROM PARENT DSK IF PRESENT OTHERWISE FIRST DSK      RE33  93
#                                                                       RE33  94
K1=0;K2=0;K3=0;K4=0;K5=0;K6=0#         Set pointers to sg name cids     RE33  95
DO J=MARK2,POINT2-1,STEP2#             Turn over stored sg names        RE33  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RE33  97
NCID=NINT(QX(J+mw24dm:+1))#            Pick up ncid                     RE33  98
IF(NINT(QX(J+mw24dm:+2))<=2)#          Is it the dsk we want?           RE33  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RE33 100
IF(NCID==2)K1=J#                       Latt line                        RE33 101
ELSE IF(NCID==3)K2=J#                  Herm line                        RE33 102
ELSE IF(NCID==4)K3=J#                  Hall line                        RE33 103
ELSE IF(NCID==5)K4=J#                  Schn line                        RE33 104
ELSE IF(NCID==6)K5=J#                  Syst line                        RE33 105
ELSE IF(NCID==7)K6=J#                  Brav line                        RE33 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RE33 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RE33 108
writepkt:(2,lrsymm:,12,IP)#            Point to symmetry packet         RE33 109
DO I=1,12; QX(IP+I)=voidflg:#          Void fill                        RE33 110
IF(K1!=0)#                             Latt line                        RE33 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RE33 112
movertoc:(QX(K1+1),1,CHRIN,1,24,0)#    Get latt char info.              RE33 113
compchar:(CHRIN,1,RE3O,10,1,1,5,M)#    Get centrosymmetry flag          RE33 114
compchar:(CHRIN,2,RE3O, 1,1,1,9,N)#    Get lattice code                 RE33 115
IF(M>=3)  QX(IP+2)=0.#                 Store centrosymmetric code       RE33 116
ELSE      QX(IP+2)=1.#                 Store non-centrosymmetric code   RE33 117
IF(N==0) N=1#                          Unknown code is primitive        RE33 118
IF(N==8) N=3#                          H is r is 3                      RE33 119
IF(N==9) N=1#                          Blank is p is 1                  RE33 120
QX(IP+1)=FLOAT(N)+(1.-QX(IP+2))*7.#    Store lattice code (1-14)        RE33 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RE33 122
QX(IP+4)=SYMCNT#                       Number of symop on symmetry      RE33 123
QX(IP+8)=ZMOL#                         Number of molecules in cell      RE33 124
IF(K5!=0)#                                                              RE33 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RE33 126
movertoc:(QX(K5+1),1,CHRIN,1,4,0)#     Get the crystal system           RE33 127
compchar:(CHRIN,1,RE3L,1,4,4,NRE3L,J)# Code the crystal system          RE33 128
IF(J==0) J=1#                          Set unknown as triclinic         RE33 129
QX(IP+9)=REAL(J)#                      Store the crystal system         RE33 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RE33 131
IF(K6!=0)#                                                              RE33 132
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RE33 133
movertoc:(QX(K6+1),1,CHRIN,1,4,0)#     Get the bravais system           RE33 134
compchar:(CHRIN,1,RE3L,1,4,4,NRE3L,J)# Code the bravais system          RE33 135
IF(J==0) J=1#                          Set unknown as triclinic         RE33 136
QX(IP+9)=REAL(J)#                      Store the bravais system         RE33 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RE33 138
#                                                                       RE33 139
#                                      Output the symops to b.d.f       RE33 140
#                                                                       RE33 141
#                                                                       RE33 142
#  TAKE INFORMATION FROM PARENT DSK IF PRESENT OTHERWISE FIRST DSK      RE33 143
#                                                                       RE33 144
DO J=MARK3,POINT3-1,STEP3#             Loop over records in mark3       RE33 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RE33 146
NCID=NINT(QX(J+mw04dm:+1))#            Pick up ncid                     RE33 147
IF(NINT(QX(J+mw04dm:+2))<=2)#          Is it the dsk we want?           RE33 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RE33 149
IF(NCID==2)#                           Only store syop ops              RE33 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RE33 151
writepkt:(2,lrsymm:,12,IP)#            Point to symmetry packet         RE33 152
QX(IP+ 1)=QX(J+ 3+mw04dm:)#            Store w11                        RE33 153
QX(IP+ 4)=QX(J+ 4+mw04dm:)#            Store w12                        RE33 154
QX(IP+ 7)=QX(J+ 5+mw04dm:)#            Store w13                        RE33 155
QX(IP+10)=QX(J+ 6+mw04dm:)#            Store w1                         RE33 156
QX(IP+ 2)=QX(J+ 7+mw04dm:)#            Store w21                        RE33 157
QX(IP+ 5)=QX(J+ 8+mw04dm:)#            Store w22                        RE33 158
QX(IP+ 8)=QX(J+ 9+mw04dm:)#            Store w23                        RE33 159
QX(IP+11)=QX(J+10+mw04dm:)#            Store w2                         RE33 160
QX(IP+ 3)=QX(J+11+mw04dm:)#            Store w31                        RE33 161
QX(IP+ 6)=QX(J+12+mw04dm:)#            Store w32                        RE33 162
QX(IP+ 9)=QX(J+13+mw04dm:)#            Store w33                        RE33 163
QX(IP+12)=QX(J+14+mw04dm:)#            Store w3                         RE33 164
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RE33 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RE33 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RE33 167
#                                                                       RE33 168
#   LRSGNM:   -   FILL FROM MEMORY                                      RE33 169
#                                                                       RE33 170
#  TAKE INFORMATION FROM PARENT DSK IF PRESENT OTHERWISE FIRST DSK      RE33 171
#                                                                       RE33 172
writepkt:(2,lrsgnm:,mw40dm:,IP)#       Point to sgnm packet             RE33 173
DO I=1,mw40dm:; QX(IP+I)=voidflg:#     Void fill                        RE33 174
IF(K3!=0)#                             Hall line                        RE33 175
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RE33 176
movereal:(QX,K3+1,QX,IP+1,mw24dm:,0)#  Move hall symbol to bdf          RE33 177
movector:(BLANK,1,QX(IP+1),25,16,1)#   Blank the rest                   RE33 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RE33 179
writepkt:(2,lrsgnm:,mw40dm:,IP)#       Point to next sgnm packet        RE33 180
DO I=1,mw40dm:; QX(IP+I)=voidflg:#     Void fill                        RE33 181
IF(K2!=0)#                             Herm line                        RE33 182
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RE33 183
movereal:(QX,K2+1,QX,IP+1,mw24dm:,0)#  Move herm symbol to bdf          RE33 184
movector:(BLANK,1,QX(IP+1),25,16,1)#   Blank the rest                   RE33 185
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RE33 186
#                                                                       RE33 187
#   LRSCAT:  -   INSERT NUMBER OF ATOMS FROM FORMULA                    RE33 188
#                                                                       RE33 189
DO L=MARK7,POINT7-1,STEP7#             Loop over stored formula lines   RE33 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RE33 191
NCID=NINT(QX(L+mw12dm:+1))#            Pick up cid pointer              RE33 192
movertoc:(QX(L+1),1,CHRIN,1,12,0)#     Get characters in formula        RE33 193
DO J=1,6#                              Loop over 6 elements/line        RE33 194
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RE33 195
K=2*J-1#                               Pointer to el name in chrin      RE33 196
IF (CHRIN(K^K+1)!=BLANK(1^2))#         Only want non blank names        RE33 197
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RE33 198
DO I=MARK5,POINT5-1,STEP5#             Find pointer i to ff table       RE33 199
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RE33 200
movertoc:(QX(I+1),5,CHRIN,21,2,0)#     Pick up element name             RE33 201
IF(CHRIN(21^22)==CHRIN(K^K+1)) BREAK#                                   RE33 202
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RE33 203
IF(I==POINT5)#                         Its a new entry                  RE33 204
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RE33 205
IF(POINT5==MARK6)iquit:(RE3310)#       Quit if list space used up       RE33 206
movector:(CHRIN, K,QX(POINT5+1),1,2,0)# Put at and an into memory       RE33 207
movector:(BLANK, 1,QX(POINT5+1),3,2,0)# Blank chars 3,4 of at           RE33 208
movector:(CHRIN, K,QX(POINT5+1),5,2,0)# Its a new atom type             RE33 209
POINT5=POINT5+STEP5#                   Up the mark5 pointer             RE33 210
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RE33 211
IF(NCID==2)#                           Forl cid                         RE33 212
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 RE33 213
BUFIN(1)=QX(L+mw12dm:+J+2)*ZMOL#       Multiply by z cell               RE33 214
movereal:(BUFIN,1,QX,I+mw06dm:+1,1,0)# Put number of atoms              RE33 215
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 RE33 216
ELSE IF(NCID==7) ifnz:(QX(L+mw12dm:+J+2))$# Mass % formula              RE33 217
movereal:(QX(L+mw12dm:+J+2),1,QX,I+mw06dm:+2,1,0)# A                    RE33 218
ELSE IF(NCID==8) ifnz:(QX(L+mw12dm:+J+2))$# Esd of same                 RE33 219
movereal:(QX(L+mw12dm:+J+2),1,QX,I+mw06dm:+3,1,0)# E                    RE33 220
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RE33 221
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RE33 222
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RE33 223
#                                                                       RE33 224
#   LRSCAT:   -   FILL FROM MEMORY                                      RE33 225
#                                                                       RE33 226
NSFS=NSFS+15+mw08dm:+mw40dm:#          Number of item in packet         RE33 227
writepkt:(2,lrscat:,NSFS,IP)#          Point to directory packet        RE33 228
DO I=1,mw08dm:;QX(IP+I)=11.#           Sfname                           RE33 229
DO I=1,mw40dm:;QX(IP+I+mw08dm:)=95.#   Source of scattering data        RE33 230
J=IP+mw08dm:+mw40dm:#                                                   RE33 231
QX(J+1)=1.;QX(J+2)=7.#                 Num atoms, flag inter            RE33 232
DO I=1,9; QX(J+I+2)=REAL(I+11)#        9 cromer mann coefficients       RE33 233
QX(J+12)=21.;QX(J+13)=61.#             F', f''                          RE33 234
QX(J+14)=98.;QX(J+15)=99.#             Mass % and esd                   RE33 235
J=J+15#                                                                 RE33 236
DO I=1,200#                            Pick up the values of s          RE33 237
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 RE33 238
ifeq:(QX(MARK5+mw06dm:+14+I),1.0)#     Valid values only                RE33 239
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 RE33 240
J=J+1;QX(J)=REAL(99+I)#                Fill directory entry             RE33 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 RE33 242
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 RE33 243
DO K=MARK5+STEP5,POINT5-1,STEP5#       Loop over stored atom types      RE33 244
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 RE33 245
writepkt:(2,lrscat:,NSFS,IP)#          Advance packet pointer           RE33 246
DO I=1,NSFS; QX(IP+I)=voidflg:#        Void fill                        RE33 247
movereal:(QX,K+1,QX,IP+1,mw08dm:,1)#   Put at into buffer               RE33 248
movector:(BLANK,1,QX(IP+1),5,mw08dm:*mxchwd:-4,1)# Blank out rest       RE33 249
J=IP+mw08dm:#                                                           RE33 250
DO L=MARKA,POINTA-1,STEPA#             Loop over comments in marka      RE33 251
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 RE33 252
NCID=NINT(QX(L+mw65dm:+1))#            Pick up ncid                     RE33 253
NDSK=NINT(QX(L+mw65dm:+2))#            Pick up dsk                      RE33 254
IF((NDSK<=2)&(NCID==29))#              Correct dsk and cid?             RE33 255
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 RE33 256
movertoc:(QX(L+1),1,CHRIN,1,44,0)#     Get comment line 1 to 44         RE33 257
movertoc:(QX(K+1),1,CHRIN,45,4,0)#     Get atom type symbol form fac    RE33 258
IF (CHRIN(1^4)==CHRIN(45^48))#         Want comment for this atom       RE33 259
movector:(CHRIN,5,QX(J+1),1,40,0)#     Put comment into bdf             RE33 260
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 RE33 261
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 RE33 262
J=J+mw40dm:#                                                            RE33 263
QX(J+1)=QX(K+mw06dm:+1);QX(J+2)=0.#    No.atoms, no interpol sf         RE33 264
DO I=1,9; QX(J+I+2)=QX(K+mw06dm:+I+5)# Cromer-mann coefficients         RE33 265
QX(J+12)=QX(K+mw06dm:+4)#              F'                               RE33 266
QX(J+13)=QX(K+mw06dm:+5)#              F''                              RE33 267
QX(J+14)=QX(K+mw06dm:+2)#              Mass %                           RE33 268
QX(J+15)=QX(K+mw06dm:+3)#              Esd mass %                       RE33 269
J=J+15#                                                                 RE33 270
DO I=1,200#                            Pick up the values of s          RE33 271
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 RE33 272
ifeq:(QX(MARK5+mw06dm:+14+I),1.0)#     Valid values only                RE33 273
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 RE33 274
J=J+1;QX(J)=QX(K+mw06dm:+14+I)#        Fill buffer f(s)                 RE33 275
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 RE33 276
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 RE33 277
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 RE33 278
#                                                                       RE33 279
#   LRDDEF:   -   FILL FROM MEMORY                                      RE33 280
#                                                                       RE33 281
DO I=2,PDSK#                           Loop over dsk's in memory        RE33 282
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 RE33 283
writepkt:(2,lrddef:,mw12dm:,IP)#       Get the packet to fill           RE33 284
movector:(DSKYS,4*I-3,QX(IP+1),1,4,0)# 4 chars of dsk                   RE33 285
movector:(BLANK,1,QX(IP+1),5,8,1)#     8 chars of blank                 RE33 286
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 RE33 287
#                                                                       RE33 288
#   LREXPL:   -   FILL FROM MEMORY                                      RE33 289
#                                                                       RE33 290
# FOUR SCRATCH ARRAYS WILL BE USED IN QX FOR BUILDING UP THE EXPERIMENT RE33 291
# PARAMETERS SECTION. THEY BOTH WILL BE OF THE LENGTH OF THE HIGHEST ID RE33 292
# IN LREXPL:. THE FIRST ARRAY MARK9 WILL BE USED FOR BUILDING UP THE    RE33 293
# PACKET DIRECTORY. THE SECOND ARRAY MARK9B WILL BE USED FOR HOLDING TH RE33 294
# RELEVANT VALUES FOR ONE DATA SET AT A TIME.                           RE33 295
# THE THIRD AND FOURTH ARRAYS DO THE SAME AS THE FIRST AND SECOND BUT   RE33 296
# ARE USED FOR THE STRING (CHARACTER) DATA ELEMENTS OF LREXPL: WHICH    RE33 297
# ARE ADDED AT THE END OF LREXPL:                                       RE33 298
# IN A FIRST PASS TO DERIVE THE DIRECTORY PACKET, MARK9BD ARE FILLED FO RE33 299
# DATASET AT A TIME. FOR EVERY VALUE PRESENT, A 1 IS THEN MARKED IN MAR RE33 300
# THE DIRECTORY PACKET IS WRITTEN AS THOSE VALUES WHERE THERE IS A 1 IN RE33 301
# MARK9. THE SECOND PASS FILLS THE INDIVIDUAL DATA PACKETS WITH ITS VAL RE33 302
#                                                                       RE33 303
#                                      First pass to build directory pa RE33 304
DO K=MARK9+1,MARK9B; QX(K)=0.#         Clear mark9                      RE33 305
DO K=MARK9C+1,MARK9D; QX(K)=0.#        Clear mark9c                     RE33 306
K=MARK9C+1#                                                             RE33 307
FOR (KS=K;K-KS<mw20dm:;K=K+1) QX(K)=-93.# Radiation string idns         RE33 308
FOR (KS=K;K-KS<mw40dm:;K=K+1) QX(K)=-511.# Intensity measurement stri   RE33 309
FOR (KS=K;K-KS<mw40dm:;K=K+1) QX(K)=-512.# Radiation monochrom string   RE33 310
FOR (KS=K;K-KS<mw40dm:;K=K+1) QX(K)=-513.# Absorption method string i   RE33 311
FOR (KS=K;K-KS<mw40dm:;K=K+1) QX(K)=-514.# Intensity averaging string   RE33 312
FOR (KS=K;K-KS<mw40dm:;K=K+1) QX(K)=-531.# Criteria for rcode 1 strin   RE33 313
FOR (KS=K;K-KS<mw40dm:;K=K+1) QX(K)=-532.# Criteria for rcode 2 strin   RE33 314
FOR (KS=K;K-KS<mw40dm:;K=K+1) QX(K)=-533.# Criteria for rcode 3 strin   RE33 315
FOR (KS=K;K-KS<mw40dm:;K=K+1) QX(K)=-534.# Criteria for rcode 4 strin   RE33 316
FOR (KS=K;K-KS<mw40dm:;K=K+1) QX(K)=-535.# Criteria for rcode 5 strin   RE33 317
DO I=2,PDSK#                           Loop over dsk's in memory        RE33 318
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 RE33 319
CALL RE39(I)#                          Fill up mark9b/d for data set    RE33 320
DO K=MARK9+1,MARK9B#                                                    RE33 321
ifnv:(QX(K+STEP9)) QX(K)=1.0#          Mark those present               RE33 322
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 RE33 323
N=0#                                   Compose the directory packet     RE33 324
DO K=MARK9+1,MARK9B#                                                    RE33 325
IF(NINT(QX(K))!=0)N=N+1#               Count number of items for pack   RE33 326
DO K=MARK9C+1,MARK9D#                                                   RE33 327
IF(NINT(QX(K))>0)N=N+1#                Count number of strin items fo   RE33 328
writepkt:(2,lrexpl:,N,IP)#             Point to directory packet        RE33 329
L=IP#                                                                   RE33 330
DO K=MARK9+1,MARK9B#                                                    RE33 331
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 RE33 332
IF(NINT(QX(K))!=0)#                                                     RE33 333
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 RE33 334
L=L+1;QX(L)=REAL(K-MARK9)#             Directory packet values          RE33 335
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 RE33 336
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 RE33 337
DO K=MARK9C+1,MARK9D#                  String values                    RE33 338
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 RE33 339
IF(NINT(QX(K))>0)#                                                      RE33 340
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 RE33 341
L=L+1;QX(L)=QX(K)#                     Directory packet values          RE33 342
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 RE33 343
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 RE33 344
DO I=2,PDSK#                           Loop over dsk's in memory        RE33 345
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 RE33 346
writepkt:(2,lrexpl:,N,IP)#             Packet for data set i            RE33 347
CALL RE39(I)#                          Fill values for data set i       RE33 348
L=IP#                                                                   RE33 349
DO K=MARK9+1,MARK9B#                                                    RE33 350
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 RE33 351
IF(NINT(QX(K))!=0)#                                                     RE33 352
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 RE33 353
L=L+1;QX(L)=QX(K+STEP9)#               Datum value                      RE33 354
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 RE33 355
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 RE33 356
DO K=MARK9C+1,MARK9D#                                                   RE33 357
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 RE33 358
IF(NINT(QX(K))>0)#                                                      RE33 359
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 RE33 360
L=L+1;QX(L)=QX(K+STEP9)#               Datum value                      RE33 361
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 RE33 362
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 RE33 363
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 RE33 364
#                                                                       RE33 365
#   LRDSET:   -   FILL FROM MEMORY                                      RE33 366
#                                                                       RE33 367
N=24#                                                                   RE33 368
writepkt:(2,lrdset:,N,IP)#             Point to directory packet        RE33 369
QX(IP+1)=1.;QX(IP+2)=2.;QX(IP+3)=3.#   Dsk num, uov, chirality x        RE33 370
QX(IP+4)=14.;QX(IP+5)=15.;QX(IP+6)=81.# Sint/l min, max, nref           RE33 371
QX(IP+7)=87.;QX(IP+8)=88.#             Threshold values                 RE33 372
DO I=1,16; QX(IP+I+8)=100.+REAL(I)#    Extinction values                RE33 373
DO I=2,PDSK#                           Loop over dsk's in memory        RE33 374
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 RE33 375
writepkt:(2,lrdset:,N,IP)#             Packet for data set i            RE33 376
DO II=1,N; QX(IP+II)=voidflg:#         Void fill                        RE33 377
QX(IP+1)=REAL(I-1)#                    Store data set num               RE33 378
QX(IP+2)=UOV#                          Store uov                        RE33 379
DO J=MARK6,POINT6-1,STEP6#             Swing over conditions            RE33 380
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 RE33 381
NCID=NINT(QX(J+mw02dm:+1))#            Pick up cid number               RE33 382
NDSK=NINT(QX(J+mw02dm:+2))#            Pick up dsk number               RE33 383
IF(NDSK==I\(I==2&NDSK==1))#            Is it the dsk we want?           RE33 384
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 RE33 385
IF(NCID==3)#                           Int line                         RE33 386
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 RE33 387
QX(IP+4)=QX(J+mw02dm:+5)#              Sint/l min                       RE33 388
QX(IP+5)=QX(J+mw02dm:+6)#              Sint/l max                       RE33 389
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 RE33 390
ELSE IF(NCID==13)#                     Refn line                        RE33 391
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 RE33 392
QX(IP+7)=QX(J+mw02dm:+7)#              Intensity threshold factor       RE33 393
QX(IP+8)=3.0#                          Intensities                      RE33 394
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 RE33 395
ELSE IF(NCID==15)#                     Var line                         RE33 396
ifnz:(QX(J+mw02dm:+3)) QX(IP+6)=QX(J+mw02dm:+3)# No. reflns             RE33 397
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 RE33 398
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 RE33 399
FRST=yes:#                             Initialize first read extincti   RE33 400
DO J=MARK8,POINT8-1,STEP8#             Swing over crystal               RE33 401
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 RE33 402
NCID=NINT(QX(J+mw06dm:+1))#            Pick up cid number               RE33 403
NDSK=NINT(QX(J+mw06dm:+2))#            Pick up dsk number               RE33 404
IF(NDSK==I)#                           Is it the dsk we want?           RE33 405
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 RE33 406
IF(NCID==3)#                           Extn line                        RE33 407
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 RE33 408
movertoc:(QX(IP+1),1,CHRIN,1,6,0)#     Fish out extinction codes        RE33 409
IF(CHRIN(1^3)=='BAC')#                 Becker/coppens                   RE33 410
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 RE33 411
IF(CHRIN(5^5)=='L') QX(IP+10)=1.0#     Lorentzian mosaic distribut      RE33 412
IF(CHRIN(5^5)=='G') QX(IP+10)=0.0#     Gaussian mosaic distribut        RE33 413
IF(CHRIN(4^4)=='I')#                   Isotropic                        RE33 414
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 RE33 415
IF (FRST==yes:)#                                                        RE33 416
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 RE33 417
FRST=no:;QX(IP+9)=0.#                  Initialize extinction type       RE33 418
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 RE33 419
IF(CHRIN(5^5)=='D')#                   Isotropic domain type 2          RE33 420
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 RE33 421
QX(IP+9)=QX(IP+9)+2.0#                 Code type                        RE33 422
QX(IP+12)=QX(J+mw06dm:+3)#             Iso domain width                 RE33 423
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 RE33 424
ELSE#                                  Isotropic mosaic type 1          RE33 425
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 RE33 426
QX(IP+9)=QX(IP+9)+1.0#                 Code type                        RE33 427
QX(IP+11)=QX(J+mw06dm:+3)#             Iso mosaic spread                RE33 428
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 RE33 429
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 RE33 430
ELSE IF(CHRIN(4^4)=='A')#              Anisotropic                      RE33 431
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 RE33 432
IF (FRST==yes:)#                                                        RE33 433
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 RE33 434
FRST=no:;QX(IP+9)=3.#                  Initialize extinction type       RE33 435
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 RE33 436
IF(CHRIN(5^5)=='D')#                   Aniso domain type 2              RE33 437
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 RE33 438
QX(IP+9)=QX(IP+9)+2.0#                 Code type                        RE33 439
DO II=1,6; QX(IP+18+II)=QX(J+mw06dm:+2+II)# Aniso domain width          RE33 440
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 RE33 441
ELSE#                                  Aniso mosaic type 1              RE33 442
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 RE33 443
QX(IP+9)=QX(IP+9)+1.0#                 Code type                        RE33 444
DO II=1,6; QX(IP+12+II)=QX(J+mw06dm:+2+II)# Aniso mosaic                RE33 445
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 RE33 446
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 RE33 447
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 RE33 448
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 RE33 449
ELSE IF(NCID==5)#                      Absr line                        RE33 450
QX(IP+3)=QX(J+mw06dm:+3)#              Chirality/polarity               RE33 451
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 RE33 452
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 RE33 453
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 RE33 454
#                                                                       RE33 455
#   LRATOM:   -   FILL FROM MEMORY                                      RE33 456
#                                                                       RE33 457
# COMPOSE THE DIRECTORY PACKET                                          RE33 458
#                                                                       RE33 459
M=24+mw24dm:#                          Set packet length for aniso      RE33 460
IF(UIJ==no:)M=M-12#                    Shorten no aniso                 RE33 461
writepkt:(2,lratom:,M,IP)#             Point to atom dir packet         RE33 462
DO I=1,mw24dm:; QX(IP+I)=14.#          Store name idnum                 RE33 463
QX(IP+mw24dm:+1)=23.#                  Put displacement parm type idn   RE33 464
QX(IP+mw24dm:+2)=22.#                  Put in sf pointer                RE33 465
DO I=1,3; QX(IP+mw24dm:+I+2)=FLOAT(I)# Put x,y,z idnums in pkt          RE33 466
QX(IP+mw24dm:+6)=4#                    Put individual iso u             RE33 467
QX(IP+mw24dm:+7)=11.#                  Put pp idnum in pkt              RE33 468
DO I=1,3; QX(IP+mw24dm:+I+7)=FLOAT(I+100)# Put sig x,y,z idnums in pk   RE33 469
QX(IP+mw24dm:+11)=104#                 Put sig individual iso u         RE33 470
QX(IP+mw24dm:+12)=111.#                Put error pp idnum in pkt        RE33 471
IF(UIJ ==yes:)#                        Test if uij present              RE33 472
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 58 RE33 473
DO I=0,5; QX(IP+mw24dm:+I+13)=FLOAT(I+5)# Put uij idnums in pkt         RE33 474
DO I=0,5; QX(IP+mw24dm:+I+19)=FLOAT(I+105)# Put sigma uij idn           RE33 475
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 58 RE33 476
#                                                                       RE33 477
# OUTPUT THE DATA PACKETS                                               RE33 478
#                                                                       RE33 479
DO JP=MARK4,POINT4-1,STEP4#            Loop over all atoms              RE33 480
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 RE33 481
writepkt:(2,lratom:,M,IP)#             Point to next atom packet        RE33 482
DO I=1,M; QX(IP+I)=voidflg:#           Void fill                        RE33 483
# CHANGE ATOM NAME FORMAT FROM SCFS TO XTAL - NO BLANK IN POSITION 2    RE33 484
movertoc:(QX(JP+1+mw04dm:),1,CHRIN,1,8,0)# Get scfs el + num            RE33 485
movechar:(BLANK,1,CHRIN,9,17,1)#       Blank the rest                   RE33 486
IF(CHRIN(2^2)==BLANK(1^1))#            Is there a blank                 RE33 487
movechar:(CHRIN,3,CHRIN,2,6,0)#        Move left one place              RE33 488
movector:(CHRIN,1,QX(JP+1+mw04dm:),1,24,0)# Keep xtal atom name         RE33 489
#                                                                       RE33 490
#                                      Insert scattering factor pointer RE33 491
#                                                                       RE33 492
K=0#                                   Scattering factor pointer        RE33 493
movertoc:(QX(JP+1),1,CHRIN,1,4,0)#     Get atom at name                 RE33 494
DO KP=MARK5+STEP5,POINT5-1,STEP5#      Swing over form factor names     RE33 495
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 60 RE33 496
K=K+1#                                 Update ff list pointer           RE33 497
movertoc:(QX(KP+1),1,CHRIN,5,4,0)#     Get form factor at name          RE33 498
IF(CHRIN(1^4)==CHRIN(5^8)) BREAK#      Stop on hit                      RE33 499
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 60 RE33 500
QX(JP+2+mw424dm:)=REAL(K)#             Store ff pointer                 RE33 501
#                                                                       RE33 502
movereal:(QX,JP+1+mw04dm:,QX,IP+1,M,1)# Move atom information           RE33 503
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 RE33 504
#                                                                       RE33 505
#   LRMOLE:   -   FILL FROM MEMORY                                      RE33 506
#                                                                       RE33 507
N=6#                                                                    RE33 508
writepkt:(2,lrmole:,N,IP)#             Point to directory packet        RE33 509
QX(IP+1)=1.;QX(IP+2)=12.;QX(IP+3)=13.# Data set no., calc mass, z       RE33 510
QX(IP+4)=14.;QX(IP+5)=15.;QX(IP+6)=21.# Obs mass, esd, density          RE33 511
DO I=2,PDSK#                           Loop over dsk's in memory        RE33 512
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 61 RE33 513
writepkt:(2,lrmole:,N,IP)#             Packet for data set i            RE33 514
DO II=1,N; QX(IP+II)=voidflg:#         Void fill                        RE33 515
QX(IP+1)=REAL(I-1)#                    Store data set num               RE33 516
DO J=MARK1,POINT1-1,STEP1#             Turn over stored cell dimensio   RE33 517
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 62 RE33 518
NCID=NINT(QX(J+1))#                    Pick up cid number               RE33 519
NDSK=NINT(QX(J+2))#                    Pick up dsk number               RE33 520
IF((NDSK==I)\((I==2)&(NDSK==1)))#      Is it the dsk we want?           RE33 521
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 63 RE33 522
IF(NCID==2) QX(IP+3)=QX(J+9)#          Cell line/zmol                   RE33 523
ELSE IF(NCID==4)#                      Vol line                         RE33 524
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 64 RE33 525
ifnz:(QX(J+5)) QX(IP+2)=QX(J+5)#       Calc formula mass                RE33 526
ifnz:(QX(J+6)) QX(IP+6)=QX(J+6)#       Calc density                     RE33 527
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 64 RE33 528
ELSE IF(NCID==5)#                      Phys line                        RE33 529
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 65 RE33 530
ifnz:(QX(J+6)) QX(IP+4)=QX(J+6)#       Measured formula mass            RE33 531
ifnz:(QX(J+7)) QX(IP+5)=QX(J+7)#       E.s.d. measured formula mass     RE33 532
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 65 RE33 533
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 63 RE33 534
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 62 RE33 535
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 61 RE33 536
#                                                                       RE33 537
#   LRREFL:   -   COPY FROM SCRATCH FILE                                RE33 538
#                                                                       RE33 539
copyfile:(1,2,lrrefl:,lrrefl:)#        Copy reflection info.            RE33 540
#                                                                       RE33 541
#   LRTHET:   -   FILL FROM MEMORY                                      RE33 542
#                                                                       RE33 543
#                                                                       RE33 544
DO J=MARKB,POINTB-1,STEPB#             Turn over stored angles          RE33 545
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 66 RE33 546
writepkt:(2,lrthet:,STEPB,IP)#         Point to packet                  RE33 547
QX(IP+1)=QX(J+1)-1.0#                  Correct data set num for blank   RE33 548
movereal:(QX,J+2,QX,IP+2,STEPB-1,1)#   Move data                        RE33 549
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 66 RE33 550
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Copy reflection info.         RE33 551
#                                                                       RE33 552
#                                                                       RE33 553
RETURN#                                                                 RE33 554
END#                                                                    RE33 555
systemheader:(RE38)#                   Find data set key pointer        RE38   1
####################################################################    RE38   2
#                                                                       RE38   3
#                       RE38                                            RE38   4
#                                                                       RE38   5
####################################################################    RE38   6
SUBROUTINE RE38#                       H.d. flack sept 1989, 1990       RE38   7
include:(AACOMN)#                                                       RE38   8
include:(RECOMN)#                                                       RE38   9
#                                      Decode the dsk and add new       RE38  10
#                                      Ones to memory                   RE38  11
compchar:(DSK,1,DSKYS,1,4,4,LDSKYS,NDSK)# Pick up the dsk number        RE38  12
IF(NDSK==0)#                           New dsk name                     RE38  13
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RE38  14
IF(PDSK==MXDSK)iquit:(RE3810)#         Too many data set's              RE38  15
ELSE#                                                                   RE38  16
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RE38  17
PDSK=PDSK+1#                           Increase end pointer to dsky     RE38  18
movechar:(DSK,1,DSKYS,LDSKYS+1,4,0)#   Store new dsk in dsky            RE38  19
NDSK=PDSK;LDSKYS=LDSKYS+4#             Point to dsk;count dskys         RE38  20
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RE38  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RE38  22
#                                                                       RE38  23
RETURN#                                                                 RE38  24
END#                                                                    RE38  25
systemheader:(RE39)#                   Fill qx for lrexpl: data set i   RE39   1
####################################################################    RE39   2
#                                                                       RE39   3
#                       RE39                                            RE39   4
#                                                                       RE39   5
####################################################################    RE39   6
SUBROUTINE RE39(I)#                    H.d. flack sept 1989, 1990       RE39   7
include:(AACOMN)#                                                       RE39   8
include:(RECOMN)#                                                       RE39   9
INTEGER I,J,K,L,II,KS#                                                  RE39  10
INTEGER NCID#                                                           RE39  11
REAL    A#                                                              RE39  12
chardata:(RE391,NEXS)#                                                  RE39  13
realdata:(RAD,57.2957795)#                                              RE39  14
datastuff:#                                                             RE39  15
#                                                                       RE39  16
DO K=MARK9B+1,MARK9C; QX(K)=voidflg:#  Clear mark9b for this data set   RE39  17
QX(MARK9B+300)=0.;QX(MARK9B+601)=0.#   Set counts of faces, standards   RE39  18
QX(MARK9B+701)=0.;QX(MARK9B+100)=0.#   Attenuators & scales to zero     RE39  19
QX(MARK9B+1)=REAL(I-1)#                Put in the data set number       RE39  20
DO J=MARK6,POINT6-1,STEP6#             Turn over stored conditions      RE39  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RE39  22
NCID=NINT(QX(J+mw02dm:+1))#            Pick up cid number               RE39  23
NDSK=NINT(QX(J+mw02dm:+2))#            Pick up dsk number               RE39  24
IF(NDSK==I)#                           Is it the dsk we want?           RE39  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RE39  26
IF(NCID==2)#                           Cell cid / conditions            RE39  27
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RE39  28
movertoc:(QX(J+1),1,CHRIN,1,2,0)#      Pick up radiation type           RE39  29
compchar:(CHRIN,1,RE391,1,1,1,NRE391,L)# Decode radiation type          RE39  30
IF(L!=0) QX(MARK9B+94)=REAL(L)#        Store radiation type of datase   RE39  31
ifnz:(QX(J+mw02dm:+4)) QX(MARK9B+81)=QX(J+mw02dm:+4)-273.# Temp in k    RE39  32
ifnz:(QX(J+mw02dm:+5)) QX(MARK9B+91)=0.5*QX(J+mw02dm:+5)# Min theta c   RE39  33
ifnz:(QX(J+mw02dm:+6)) QX(MARK9B+92)=0.5*QX(J+mw02dm:+6)# Max theta c   RE39  34
ifnz:(QX(J+mw02dm:+7)) QX(MARK9B+90)=QX(J+mw02dm:+7)# No. of hkl for    RE39  35
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RE39  36
ELSE IF(NCID==3)#                      Int cid / conditions             RE39  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RE39  38
movertoc:(QX(J+1),1,CHRIN,1,2,0)#      Pick up radiation type           RE39  39
compchar:(CHRIN,1,RE391,1,1,1,NRE391,L)# Decode radiation type          RE39  40
IF(L!=0) QX(MARK9B+94)=REAL(L)#        Store radiation type of datase   RE39  41
ifnz:(QX(J+mw02dm:+3))#                                                 RE39  42
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RE39  43
QX(MARK9B+2)=QX(J+mw02dm:+3)#          Mean wavelength                  RE39  44
ifnz:(QX(J+mw02dm:+5))#                                                 RE39  45
QX(MARK9B+507)=RAD*ASIN(QX(J+mw02dm:+5)*QX(MARK9B+2))# Minimum theta    RE39  46
ifnz:(QX(J+mw02dm:+6))#                                                 RE39  47
QX(MARK9B+508)=RAD*ASIN(QX(J+mw02dm:+6)*QX(MARK9B+2))# Maximum theta    RE39  48
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RE39  49
ifnz:(QX(J+mw02dm:+4)) QX(MARK9B+81)=QX(J+mw02dm:+4)-273.# Temp in k    RE39  50
ifnz:(QX(J+mw02dm:+7)) QX(MARK9B+521)=QX(J+mw02dm:+7)# No. int meas     RE39  51
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RE39  52
ELSE IF(NCID==4)#                      Hkl cid / conditions             RE39  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RE39  54
CHRIN=' '#                             Blank char input buffer          RE39  55
movertoc:(QX(J+1),1,CHRIN,1,1,0)#      Pick up diffractometer type      RE39  56
IF(CHRIN(1^1)!=' ')movector:(CHRIN,1,QX(MARK9B+40),1,4,0)# Transfer     RE39  57
QX(MARK9B+501)=QX(J+mw02dm:+3)#        H min                            RE39  58
QX(MARK9B+502)=QX(J+mw02dm:+4)#        H max                            RE39  59
QX(MARK9B+503)=QX(J+mw02dm:+5)#        K min                            RE39  60
QX(MARK9B+504)=QX(J+mw02dm:+6)#        K max                            RE39  61
QX(MARK9B+505)=QX(J+mw02dm:+7)#        L min                            RE39  62
QX(MARK9B+506)=QX(J+mw02dm:+8)#        L max                            RE39  63
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RE39  64
ELSE IF(NCID==5)#                      Std cid / conditions             RE39  65
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RE39  66
QX(MARK9B+601)=QX(MARK9B+601)+1.0#     Count the number of standards    RE39  67
K=MARK9B+3*NINT(QX(MARK9B+601))+606#   Point to indexes                 RE39  68
QX(K+1)=QX(J+mw02dm:+3)#               H of standard                    RE39  69
QX(K+2)=QX(J+mw02dm:+4)#               K of standard                    RE39  70
QX(K+3)=QX(J+mw02dm:+5)#               L of standard                    RE39  71
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RE39  72
ELSE IF(NCID==6)#                      Abs cid / conditions             RE39  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RE39  74
ifnz:(QX(J+mw02dm:+3)) QX(MARK9B+10)=QX(J+mw02dm:+3)# Lin abs coef.     RE39  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RE39  76
ELSE IF(NCID==7)#                      Face cid / conditions            RE39  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RE39  78
QX(MARK9B+300)=QX(MARK9B+300)+1.0#     Count the number of faces        RE39  79
K=MARK9B+10*NINT(QX(MARK9B+300))+290#  Point to indexes                 RE39  80
QX(K+4)=QX(J+mw02dm:+3)#               Distance of face from centre     RE39  81
QX(K+1)=QX(J+mw02dm:+4)#               H of face                        RE39  82
QX(K+2)=QX(J+mw02dm:+5)#               K of face                        RE39  83
QX(K+3)=QX(J+mw02dm:+6)#               L of face                        RE39  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RE39  85
ELSE IF(NCID==8)#                      Fare cid / conditions            RE39  86
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RE39  87
K=MARK9B+10*NINT(QX(MARK9B+300))+290#  Point to indexes                 RE39  88
QX(K+8)=QX(J+mw02dm:+3)#               Esd distance of face from cent   RE39  89
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RE39  90
ELSE IF(NCID==10)#                     Oub1 cid / conditions            RE39  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RE39  92
CHRIN=' '#                             Blank char input buffer          RE39  93
movertoc:(QX(J+1),1,CHRIN,1,1,0)#      Pick up diffractometer type      RE39  94
IF(CHRIN(1^1)!=' ')movector:(CHRIN,1,QX(MARK9B+40),1,4,0)# Transfer     RE39  95
DO II=1,6#                                                              RE39  96
ifnz:(QX(J+mw02dm:+II+2)) QX(K+I+40)=QX(J+mw02dm:+II+2)# Ub 11 ... 23   RE39  97
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RE39  98
ELSE IF(NCID==11)#                     Oub2 cid / conditions            RE39  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RE39 100
DO II=1,3#                                                              RE39 101
ifnz:(QX(J+mw02dm:+II+2)) QX(K+I+46)=QX(J+mw02dm:+II+2)# Ub 11 ... 23   RE39 102
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RE39 103
ELSE IF(NCID==12)#                     Eqiv cid / conditions            RE39 104
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RE39 105
ifnz:(QX(J+mw02dm:+3)) QX(MARK9B+521)=QX(J+mw02dm:+3)# No. meas refln   RE39 106
ifnz:(QX(J+mw02dm:+4)) QX(MARK9B+522)=QX(J+mw02dm:+4)# No. symm indep   RE39 107
ifnz:(QX(J+mw02dm:+5)) QX(MARK9B+523)=QX(J+mw02dm:+5)# R-factor aver    RE39 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RE39 109
ELSE IF(NCID==16)#                     Shap cid / conditions            RE39 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RE39 111
QX(MARK9B+541)=QX(J+mw02dm:+3)#        Radius of crystal sphere/cylin   RE39 112
QX(MARK9B+542)=QX(J+mw02dm:+4)#        E.s.d. radius                    RE39 113
QX(MARK9B+543)=1.0/QX(J+mw02dm:+4)#    Weight radius                    RE39 114
ifnz:(QX(J+mw02dm:+5))#                                                 RE39 115
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RE39 116
QX(MARK9B+544)=QX(J+mw02dm:+5)#        Length of cylinder               RE39 117
QX(MARK9B+545)=QX(J+mw02dm:+6)#        E.s.d. cylinder                  RE39 118
QX(MARK9B+546)=1.0/QX(J+mw02dm:+6)#    Weight cylinder                  RE39 119
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RE39 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RE39 121
ELSE IF(NCID==17)#                     Detr cid / conditions            RE39 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RE39 123
QX(MARK9B+547)=QX(J+mw02dm:+3)#        Detector dead time in microsec   RE39 124
QX(MARK9B+548)=QX(J+mw02dm:+4)#        E.s.d. dead time                 RE39 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RE39 126
ELSE IF(NCID==18)$#                    Bfil cid / conditions            RE39 127
QX(MARK9B+550)=QX(J+mw02dm:+3)#        Beta filter absorption edge      RE39 128
ELSE IF(NCID==19)#                     Attf cid / conditions            RE39 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RE39 130
QX(MARK9B+701)=QX(MARK9B+701)+1.0#     Count the number of filters      RE39 131
K=MARK9B+4*NINT(QX(MARK9B+701))+697#   Point to indexes                 RE39 132
QX(K+1)=QX(J+mw02dm:+3)#               Attenuator filter index          RE39 133
QX(K+2)=QX(J+mw02dm:+4)#               Reciprocal transmission          RE39 134
QX(K+3)=QX(J+mw02dm:+5)#               E.s.d. of reciprocal transmiss   RE39 135
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RE39 136
ELSE IF(NCID==20)#                     Polo cid / conditions            RE39 137
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RE39 138
QX(MARK9B+52)=QX(J+mw02dm:+3)#         Incident beam polarization rat   RE39 139
QX(MARK9B+53)=QX(J+mw02dm:+4)#         E.s.d. of polarization ratio     RE39 140
QX(MARK9B+55)=QX(J+mw02dm:+5)#         Dihedral angle between diffrac   RE39 141
ifnz:(QX(J+mw02dm:+6)) QX(MARK9B+56)=QX(J+mw02dm:+6)# Incid beam widt   RE39 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RE39 143
ELSE IF(NCID==21)#                     Wavl cid / conditions            RE39 144
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RE39 145
ifnz:(QX(J+mw02dm:+3))#                                                 RE39 146
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RE39 147
QX(MARK9B+3)=QX(J+mw02dm:+3)#          Wavelength line 1                RE39 148
QX(MARK9B+6)=QX(J+mw02dm:+4)#          Weight line 1                    RE39 149
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RE39 150
ifnz:(QX(J+mw02dm:+5))#                                                 RE39 151
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RE39 152
QX(MARK9B+4)=QX(J+mw02dm:+5)#          Wavelength line 2                RE39 153
QX(MARK9B+7)=QX(J+mw02dm:+6)#          Weight line 2                    RE39 154
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RE39 155
ifnz:(QX(J+mw02dm:+7))#                                                 RE39 156
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 RE39 157
QX(MARK9B+5)=QX(J+mw02dm:+7)#          Wavelength line 3                RE39 158
QX(MARK9B+8)=QX(J+mw02dm:+8)#          Weight line 3                    RE39 159
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 RE39 160
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RE39 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RE39 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RE39 163
#                                                                       RE39 164
DO J=MARK1,POINT1-1,STEP1#             Turn over stored cell dimensio   RE39 165
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 RE39 166
NCID=NINT(QX(J+1))#                    Pick up cid number               RE39 167
NDSK=NINT(QX(J+2))#                    Pick up dsk number               RE39 168
IF(NDSK==I)#                           Is it the dsk we want?           RE39 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 RE39 170
IF(NCID==2)#                           Cell line                        RE39 171
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 RE39 172
QX(MARK9B+13)=QX(J+3)#                 A cell dimension                 RE39 173
QX(MARK9B+14)=QX(J+4)#                 B cell dimension                 RE39 174
QX(MARK9B+15)=QX(J+5)#                 C cell dimension                 RE39 175
QX(MARK9B+19)=QX(J+6)/360.0#           Alpha cell dimension             RE39 176
QX(MARK9B+20)=QX(J+7)/360.0#           Beta  cell dimension             RE39 177
QX(MARK9B+21)=QX(J+8)/360.0#           Gamma cell dimension             RE39 178
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 RE39 179
ELSE IF(NCID==3)#                      Errs line                        RE39 180
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 RE39 181
QX(MARK9B+23)=QX(J+3)#                 A cell dimension                 RE39 182
QX(MARK9B+24)=QX(J+4)#                 B cell dimension                 RE39 183
QX(MARK9B+25)=QX(J+5)#                 C cell dimension                 RE39 184
QX(MARK9B+26)=QX(J+6)/360.0#           Alpha cell dimension             RE39 185
QX(MARK9B+27)=QX(J+7)/360.0#           Beta  cell dimension             RE39 186
QX(MARK9B+28)=QX(J+8)/360.0#           Gamma cell dimension             RE39 187
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 RE39 188
ELSE IF(NCID==4)#                      Vol line                         RE39 189
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 RE39 190
ifnz:(QX(J+3)) QX(MARK9B+22)=QX(J+3)#  Volume cell                      RE39 191
ifnz:(QX(J+4)) QX(MARK9B+29)=QX(J+4)#  E.s.d. vol                       RE39 192
ifnz:(QX(J+6)) QX(MARK9B+87)=QX(J+6)#  E.s.d. vol                       RE39 193
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 RE39 194
ELSE IF(NCID==5)#                      Phys line                        RE39 195
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 RE39 196
QX(MARK9B+85)=QX(J+3)#                 Measured density                 RE39 197
QX(MARK9B+86)=QX(J+4)#                 E.s.d. measured density          RE39 198
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 RE39 199
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 RE39 200
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 RE39 201
#                                                                       RE39 202
DO J=MARK8,POINT8-1,STEP8#             Turn over stored crystal lines   RE39 203
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 RE39 204
NCID=NINT(QX(J+mw06dm:+1))#            Pick up cid number               RE39 205
NDSK=NINT(QX(J+mw06dm:+2))#            Pick up dsk number               RE39 206
IF(NDSK==I)#                           Is it the dsk we want?           RE39 207
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 RE39 208
IF(NCID==2)#                           Scal line                        RE39 209
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 RE39 210
QX(MARK9B+100)=QX(MARK9B+100)+1.0#     Count the number of scales       RE39 211
K=MARK9B+NINT(QX(MARK9B+100))+100#     Point to scale value             RE39 212
QX(K)=QX(J+mw06dm:+3)#                 Scale value                      RE39 213
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 RE39 214
ELSE IF(NCID==3) A=A#                  Extn line                        RE39 215
ELSE IF(NCID==4) A=A#                  Exte line                        RE39 216
ELSE IF(NCID==5) A=A#                  Absr line                        RE39 217
ELSE IF(NCID==6) A=A#                  Twin line                        RE39 218
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 RE39 219
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 RE39 220
#                                                                       RE39 221
DO J=MARKA,POINTA-1,STEPA#             Turn over stored comments        RE39 222
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 RE39 223
NCID=NINT(QX(J+mw65dm:+1))#            Pick up cid number               RE39 224
NDSK=NINT(QX(J+mw65dm:+2))#            Pick up dsk number               RE39 225
IF(NDSK==I)#                           Is it the dsk we want?           RE39 226
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 RE39 227
IF(NCID==13)#                          Expt line                        RE39 228
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 RE39 229
FOR (K=MARK9C+1;K<=MARK9D;K=K+1) ifeq:(ABS(QX(K)),511.)BREAK# Find po   RE39 230
movereal:(QX,J+1,QX,K+STEP9,mw40dm:,1)# Get comment line 1 to 40 char   RE39 231
FOR (KS=K;K-KS<mw40dm:;K=K+1) QX(K)=511.# Intensity measurement strin   RE39 232
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 RE39 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 RE39 234
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 RE39 235
#                                                                       RE39 236
ifeq:(QX(MARK9B+300),0.) QX(MARK9B+300)=voidflg:# Void no faces         RE39 237
ifeq:(QX(MARK9B+601),0.) QX(MARK9B+601)=voidflg:# Void no standards     RE39 238
ifeq:(QX(MARK9B+701),0.) QX(MARK9B+701)=voidflg:# Void no attenuators   RE39 239
ifeq:(QX(MARK9B+100),0.) QX(MARK9B+100)=voidflg:# Void no scales        RE39 240
#                                                                       RE39 241
RETURN#                                                                 RE39 242
END#                                                                    RE39 243
systemheader:(RE51)#                   Xtal bdf to std file (part 1)    RE51   1
####################################################################    RE51   2
#                                                                       RE51   3
#                        RE51                                           RE51   4
#                                                                       RE51   5
####################################################################    RE51   6
SUBROUTINE RE51#                                                        RE51   7
include:(AACOMN)#                                                       RE51   8
include:(RECOMN)#                      H.d. flack 1988, 1990            RE51   9
#                                                                       RE51  10
INTEGER I,J,K,IP,NP#                                                    RE51  11
INTEGER LTYP,ICNT,JSYS#                                                 RE51  12
REAL A,B,SYMM#                                                          RE51  13
string:(CH,1)#                                                          RE51  14
chardata:(RE50,TITLE)#                                                  RE51  15
chardata:(RE53,SYMMETRY R11 2 3     T1      R21 2 3     $#              RE51  16
T2      R31 2 3     T3)#                                                RE51  17
chardata:(RE53A,SYOP)#                                                  RE51  18
chardata:(RE54,FORM FACTOR)#                                            RE51  19
chardata:(RE54A,TABLEXP1EXP2)#                                          RE51  20
chardata:(RE57,SG NAME)#                                                RE51  21
chardata:(RE57A,PIRFABCLATTNCHALLHERMSYSTBRAV)#                         RE51  22
chardata:(RE57B,TRICLINIC   MONOCLINIC  ORTHORHOMBICTETRAGONAL  $#      RE51  23
TRIGONAL    RHOMBOHEDRALHEXAGONAL   CUBIC       )#                      RE51  24
chardata:(RE5G,AZ09*)#                                                  RE51  25
chardata:(RE5IA,SCATEXPTEXPTABS EXPTWGHTEXTNRMRKHYDRRMRK)#              RE51  26
realdata:(FMT2,[120213.,320213.,520213.,140213.,340213.,540213.,#       RE51  27
160213.,360213.,560213.,261072.,461072.,661072.])#                      RE51  28
realdata:(FMT3,[251042.,351042.,451042.,551042.,651042.,751042.])#      RE51  29
intdata:(N,0)#                                                          RE51  30
datastuff:#                                                             RE51  31
#                                                                       RE51  32
#   INITIALIZE SCFS & BDF FILES                                         RE51  33
#   ---------------------------                                         RE51  34
#                                                                       RE51  35
FILEXT(iofm1:)='SCF'#                  Scfs output file                 RE51  36
openfmt:(iofm1:,' ')#                  Open formatted output file       RE51  37
#                                                                       RE51  38
#   SET UP MEMORY - QX                                                  RE51  39
#   ------------------                                                  RE51  40
#                                                                       RE51  41
IOMARK(1)=QXSTR+1#                     Start of xtal bdf buffer         RE51  42
MARK1=IOMARK(1)+bdfbuf:#               Xtal bdf buffer space            RE51  43
MARK2=MARK1+23#                        Mark1 contains cell dime         RE51  44
STEP2=mw75dm:;POINT2=MARK2;MARK3=MARK2+100*STEP2# Mark2 comments data   RE51  45
MARK8=MARK3#                           Mark8 used for temporary space   RE51  46
MARK9=MARK8#                           Mark9 used for temporary space   RE51  47
incrqx:(MARKZ,MARK9,RE5101)#           Expand qx                        RE51  48
#                                                                       RE51  49
#                                                                       RE51  50
#    READ LRHIST: AND LRLABL: AND OUTPUT TITLE RECORD                   RE51  51
#    ------------------------------------------------                   RE51  52
#                                                                       RE51  53
movechar:(BLANK,1,CHRIN,1,80,1)#       Clear chrin                      RE51  54
movechar:(TITLE,59,CHRIN,9,67,0)#      Move the current title to buff   RE51  55
puthead:(RE50)#                        Output title header              RE51  56
readwpkt:(1,lrhist:,NP,IP,0)#          Get pointer for compid           RE51  57
movertoc:(QX(IP+1),1,CHRIN,68,8,0)#    Extract compid from title        RE51  58
readwpkt:(1,lrlabl:,NP,IP,0)#          Get pointer for lr 2 skip date   RE51  59
readwpkt:(1,lrlabl:,NP,IP,0)#          Get pointer for lr 2 get title   RE51  60
movechar:(RE5G,5,CHRIN,1,1,0)#         Put * into char 1 of scfs        RE51  61
movertoc:(QX(IP+1),1,CHRIN,2,66,0)#    Extract file title               RE51  62
putrecd:#                              Output title record              RE51  63
movechar:(BLANK,1,CHRIN,1,80,1)#       Clear chrin                      RE51  64
putrecd:#                              Output blank line                RE51  65
#                                                                       RE51  66
#    READ LRCELL:  AND STORE CELL DIMENSION RECORDS                     RE51  67
#    ----------------------------------------------                     RE51  68
#                                                                       RE51  69
movereal:(voidflg:,1,QX(MARK1+1),1,23,2)# Void cell dime                RE51  70
readwpkt:(1,lrcell:,NP,IP,0)#          Point to cell packet             RE51  71
QX(MARK1+1)=QX(IP+1)#                  Lattice parameter a              RE51  72
QX(MARK1+2)=QX(IP+2)#                  Lattice parameter b              RE51  73
QX(MARK1+3)=QX(IP+3)#                  Lattice parameter c              RE51  74
QX(MARK1+4)=QX(IP+7)*360.#             Alpha                            RE51  75
QX(MARK1+5)=QX(IP+8)*360.#             Beta                             RE51  76
QX(MARK1+6)=QX(IP+9)*360.#             Gamma                            RE51  77
readwpkt:(1,lrcell:,NP,IP,0)#          Point to cell errs pkt           RE51  78
QX(MARK1+8)=QX(IP+1)#                  Esd in a                         RE51  79
QX(MARK1+9)=QX(IP+2)#                  Esd in b                         RE51  80
QX(MARK1+10)=QX(IP+3)#                 Esd in c                         RE51  81
QX(MARK1+11)=QX(IP+7)*360.#            Esd of alpha                     RE51  82
QX(MARK1+12)=QX(IP+8)*360.#            Esd of beta                      RE51  83
QX(MARK1+13)=QX(IP+9)*360.#            Esd of gamma                     RE51  84
readwpkt:(1,lrcell:,NP,IP,0)#          Point to recipr. cell cons pkt   RE51  85
#                                                                       RE51  86
readwpkt:(1,lrcell:,NP,IP,0)#          Point to 1st. transform. mat.    RE51  87
readwpkt:(1,lrcell:,NP,IP,0)#          Point to 2nd. transform. mat.    RE51  88
readwpkt:(1,lrcell:,NP,IP,0)#          Point to miscellansous info.     RE51  89
QX(MARK1+14)=QX(IP+1)#                 Cell volume                      RE51  90
QX(MARK1+15)=QX(IP+2)#                 E.s.d cell volume                RE51  91
#                                                                       RE51  92
#     READ LRSYMM:                                                      RE51  93
#     ------------                                                      RE51  94
#                                                                       RE51  95
readwpkt:(1,lrsymm:,NP,IP,0)#          Point to symmetry consts         RE51  96
QX(MARK1+7)=QX(IP+8)#                  Get number of molecules in cel   RE51  97
ZMOL=QX(MARK1+7)#                      Save z                           RE51  98
LTYP=NINT(QX(IP+1))#                   Extract lattice code without     RE51  99
IF(LTYP>7) LTYP=LTYP-7#                Centro/no-centrosymmetric flag   RE51 100
ICNT=NINT(ABS(1.-QX(IP+2)))#           Extract centro/non-centro code   RE51 101
AMUL=QX(IP+6)*QX(IP+4)#                Calc no. equiv posns             RE51 102
JSYS=NINT(QX(IP+9))#                   Crystal/bravais system           RE51 103
#                                      Get symmetry operations          RE51 104
MARKZ=MARK9;STEP9=12#                  Set storage pointer              RE51 105
REPEAT#                                Loop all symmetry records        RE51 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RE51 107
readwpkt:(1,lrsymm:,NP,IP,0)#          Point to sym matrix pkt          RE51 108
IF(IP<=0) BREAK#                       Exit on last pkt                 RE51 109
incrqx:(MARKZ,MARKZ+STEP9,RE5102)#     Expand qx                        RE51 110
movereal:(QX(IP+1),1,QX(MARKZ-STEP9+1),1,STEP9,0)# Store symm operat    RE51 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RE51 112
#                                                                       RE51 113
#     OUTPUT SG NAME AND READ LRSGNM:                                   RE51 114
#     -------------------------------                                   RE51 115
#                                                                       RE51 116
puthead:(RE57)#                        Output sgname head               RE51 117
movechar:(RE57A,8,CHRIN,2,4,0)#        Insert 'latt' string             RE51 118
movechar:(RE57A,LTYP,CHRIN,12,1,0)#    Insert lattice in record         RE51 119
movechar:(RE57A,ICNT+12,CHRIN,11,1,0)# Insert centrosymmetric code in   RE51 120
putrecd:#                              Output latt record               RE51 121
IF(JSYS>0)#                                                             RE51 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RE51 123
movechar:(RE57A,22,CHRIN,2,4,0)#       Crystal system "syst"            RE51 124
I=12*JSYS-11; IF (JSYS==6) I=49#       Rhombo bravais syst is trigona   RE51 125
movechar:(RE57B,I,CHRIN,11,12,0)#      Insert system in record          RE51 126
putrecd:#                              Output syst record               RE51 127
movechar:(RE57A,26,CHRIN,2,4,0)#       Crystal system "brav"            RE51 128
I=12*JSYS-11#                          Pointer to bravais system        RE51 129
IF(JSYS==5) I=73#                      Assume trigonal is hexagonal     RE51 130
IF(LTYP==3) I=61#                      3 primitive cell is rhombohedr   RE51 131
movechar:(RE57B,I,CHRIN,11,12,0)#      Insert system in record          RE51 132
putrecd:#                              Output syst record               RE51 133
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RE51 134
readwpkt:(1,lrsgnm:,NP,IP,0)#          Read hall space group symbol     RE51 135
IF(IP>0)#                                                               RE51 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RE51 137
movechar:(RE57A,14,CHRIN,2,4,0)#       Insert hall                      RE51 138
movertoc:(QX(IP+1),1,CHRIN,11,24,0)#   Insert sgname in record          RE51 139
putrecd:#                              Output hall record               RE51 140
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RE51 141
readwpkt:(1,lrsgnm:,NP,IP,0)#          Read hermann space group symbo   RE51 142
IF(IP>0)#                                                               RE51 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RE51 144
movechar:(RE57A,18,CHRIN,2,4,0)#       Insert hermann                   RE51 145
movertoc:(QX(IP+1),1,CHRIN,11,24,0)#   Insert sgname in record          RE51 146
putrecd:#                              Output herm record               RE51 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RE51 148
putlast:#                              Output *eos record               RE51 149
#                                                                       RE51 150
#     OUTPUT SYMMETRY RECORDS                                           RE51 151
#     -----------------------                                           RE51 152
#                                                                       RE51 153
puthead:(RE53)#                        Output symmetry head             RE51 154
SYMM=0.#                               Number symmetry operators        RE51 155
FOR(I=MARK9;I<MARKZ;I=I+STEP9)#        Loop all symmetry records        RE51 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RE51 157
movechar:(RE53A,1,CHRIN,2,4,0)#        Insert 'syop' string             RE51 158
SYMM=SYMM+1.0;ncodefld:(SYMM,1,CHRIN,690313.,1)# Output symmetry no.    RE51 159
ncodefld:(QX,I+1,CHRIN,FMT2,12)#       Format symmetry matrix           RE51 160
putrecd:#                              Output symmetry record           RE51 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RE51 162
putlast:#                              Output *eos  record              RE51 163
#                                                                       RE51 164
#    OUTPUT FORM FACTOR RECORDS AND STORE VALUES FOR FORMULA            RE51 165
#    -------------------------------------------------------            RE51 166
#                                                                       RE51 167
puthead:(RE54)#                        Output form factor head          RE51 168
#                                      Treat directory packet           RE51 169
IW(1)=11; IW(2)=1; IW(3)=95#           Ff name, no. atoms, source       RE51 170
IW(4)=98; IW(5)=99#                    Mass %, esd                      RE51 171
DO I=1,9; IW(I+5)=I+11#                Cromer-mann coefficients         RE51 172
IW(15)=NMDS+20; IW(16)=NMDS+60#        F', f'' anomalous coefficients   RE51 173
KEY(1)=1; KEY(2)=16; KEY(3)=0;KEY(4)=0# Set dir search keys             RE51 174
indexpkt:(1,lrscat:,NP,IP,0,KEY,IW,IR)# Get idnum positions             RE51 175
MARK9=MARK8;STEP8=2#                   Set storage                      RE51 176
FOR(J=IP+1;J<=IP+NP;J=J+1)#            Loop over ff intervals           RE51 177
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RE51 178
IF((QX(J)<99.1)\(QX(J)>299.1)) NEXT#   Skip non-ff idnums               RE51 179
incrqx:(MARK9,MARK9+STEP8,RE5102)#     Expand qx                        RE51 180
QX(MARK9-1)=FLOAT(J-IP)#               Store relative ff pointer        RE51 181
QX(MARK9  )=(QX(J)-100.)/100.#         Store st/l values                RE51 182
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RE51 183
#                                      Treat individual packets         RE51 184
MARKZ=MARK9;STEP9=mw82dm:+3#           Storage for formula              RE51 185
# STORAGE IS: ELEMENT NAME (A2), ATOM-TYPE NAME (A8), NO. ATOMS/CELL,   RE51 186
#             OBS MASS %, ESD OBS MASS %                                RE51 187
REPEAT#                                Loop over all ff packets         RE51 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RE51 189
readwpkt:(1,lrscat:,NP,IP,0)#          Point to ff packet               RE51 190
IF(IP<=0) BREAK#                       Exit after last packet           RE51 191
incrqx:(MARKZ,MARKZ+STEP9,RE5102)#     Storage for formula              RE51 192
movereal:(voidflg:,1,QX(MARKZ-STEP9+1),1,STEP9,2)# Void new memory      RE51 193
K=IP+IR(1)#                            Point to ff name                 RE51 194
movertoc:(QX(K),1,CHRIN,10,2,0)#       Move ff (2 chars) name to chri   RE51 195
upcase:(CHRIN(11^11),CH,1)#            Take upcase of second char       RE51 196
IF(CH<'A'\CH>'Z') CHRIN(11^11)=' '#    Blank out 2nd                    RE51 197
movector:(CHRIN,10,QX(MARKZ-STEP9+1),1,2,0)# Save el name for forl      RE51 198
movereal:(QX,K,QX,MARKZ-STEP9+1+mw02dm:,mw08dm:,1)# At name for atom    RE51 199
IF(IR(2)>0) movereal:(QX,IP+IR(2),QX,MARKZ-2,1,1)# No. atoms/cell       RE51 200
IF(IR(3)>0)#                           Source data into comments        RE51 201
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RE51 202
movechar:(BLANK,1,CHRIN,1,75,1)#       Blank chrin                      RE51 203
movechar:(RE5IA,1,CHRIN,2,4,0)#        Move scat to chrin               RE51 204
movertoc:(QX(K),1,CHRIN,11,4,0)#       Insert ff name in at for tabl    RE51 205
movertoc:(QX(IP+IR(3)),1,CHRIN,17,40,0)# Get source                     RE51 206
movector:(CHRIN,1,QX(POINT2+1),1,75,0)# Store the comment               RE51 207
POINT2=POINT2+STEP2#                                                    RE51 208
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RE51 209
IF(IR(4)>0) movereal:(QX,IP+IR(4),QX,MARKZ-1,1,1)# Mass %               RE51 210
IF(IR(5)>0) movereal:(QX,IP+IR(5),QX,MARKZ,1,1)# Esd mass %             RE51 211
IF(IR(6)>0) ifnv:(QX(IP+IR(6)))#       Output cromer-mann values        RE51 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RE51 213
DO I=1,6; BUFOT(I)=QX(IP+IR(I+5))#     Get a1 b1 a2 b2 a3 b3            RE51 214
movertoc:(QX(K),1,CHRIN,12,4,0)#       Insert ff name in at for tabl    RE51 215
movertoc:(QX(MARKZ-STEP9+1),1,CHRIN,10,2,0)# Insert el name in an fo    RE51 216
movechar:(RE54A,5,CHRIN,2,4,0)#        Insert exp1 in record            RE51 217
ncodefld:(BUFOT,1,CHRIN,FMT3,6)#       Format a1 b1 a2 b2 a3 b3         RE51 218
putrecd:#                              Output exp1 record               RE51 219
DO I=1,3; BUFOT(I)=QX(IP+IR(I+11))#    Get a4 b4 c                      RE51 220
IF(IR(15)>0) BUFOT(4)=QX(IP+IR(15))#   F'                               RE51 221
IF(IR(16)>0) BUFOT(5)=QX(IP+IR(16))#   F''                              RE51 222
movertoc:(QX(K),1,CHRIN,12,4,0)#       Insert ff name in at for tabl    RE51 223
movertoc:(QX(MARKZ-STEP9+1),1,CHRIN,10,2,0)# Insert el name in an fo    RE51 224
movechar:(RE54A,9,CHRIN,2,4,0)#        Insert exp2 in record            RE51 225
ncodefld:(BUFOT,1,CHRIN,FMT3,5)#       Format a4 b4 c f' f''            RE51 226
putrecd:#                              Output exp2 record               RE51 227
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RE51 228
ELSE#                                  Output table values              RE51 229
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RE51 230
IF(IR(15)>0) A=QX(IP+IR(15))#          Extract real disp f'             RE51 231
ELSE         A=voidflg:#                                                RE51 232
IF(IR(16)>0) B=QX(IP+IR(16))#          Extract real disp f'             RE51 233
ELSE         B=voidflg:#                                                RE51 234
FOR(I=MARK8;I<MARK9;I=I+2)#            Loop over ff intervals           RE51 235
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RE51 236
J=IP+NINT(QX(I+1))#                    Point to ff in pkt               RE51 237
BUFOT(1)=QX(I+2);BUFOT(2)=QX(J)#       Store st/l & f value             RE51 238
BUFOT(3)=A;BUFOT(4)=B#                 Store f'& f'' value              RE51 239
movertoc:(QX(K),1,CHRIN,12,4,0)#       Insert ff name in at for tabl    RE51 240
movertoc:(QX(MARKZ-STEP9+1),1,CHRIN,10,2,0)# Insert el name in an fo    RE51 241
movechar:(RE54A,1,CHRIN,2,4,0)#        Insert tabl in record            RE51 242
ncodefld:(BUFOT,1,CHRIN,FMT3,4)#       Format ff values                 RE51 243
putrecd:#                              Output ff record                 RE51 244
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RE51 245
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RE51 246
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RE51 247
putlast:#                              Output *eos                      RE51 248
#                                                                       RE51 249
RETURN#                                                                 RE51 250
END#                                                                    RE51 251
systemheader:(RE52)#                   Xtal bdf to std file (part 2)    RE52   1
####################################################################    RE52   2
#                                                                       RE52   3
#                        RE52                                           RE52   4
#                                                                       RE52   5
####################################################################    RE52   6
SUBROUTINE RE52#                                                        RE52   7
include:(AACOMN)#                                                       RE52   8
include:(RECOMN)#                      H.d. flack 1988, 1990            RE52   9
#                                                                       RE52  10
INTEGER I,J,K,L,IP,NP#                                                  RE52  11
INTEGER RADTYP#                                                         RE52  12
REAL KELVIN, LAMBDA#                                                    RE52  13
chardata:(RE5A,CONDITIONS)#                                             RE52  14
chardata:(RE5AA,CELLINT HKL STD ABS FACEFAREORNTOUB1OUB2EQIVREFN$#      RE52  15
STATVAR SHAPDETRBFILATTFPOLOWAVL)#                                      RE52  16
chardata:(RE5AB, NEXS FSI)#                                             RE52  17
chardata:(RE5C,FORMULA  EL  NUM)#                                       RE52  18
chardata:(RE5CA,FORLAWPCEWPC)#                                          RE52  19
chardata:(RE5IA,SCATEXPTEXPTABS EXPTWGHTEXTNRMRKHYDRRMRK)#              RE52  20
realdata:(FMT7,[201042.,301022.,401062.,501042.,601042.,701042.])#      RE52  21
realdata:(FMT7A,[201042.,301022.,401032.,501032.,601013.,701042.])#     RE52  22
realdata:(FMT7B,[201013.,301013.,401013.,501013.,601013.,701013.])#     RE52  23
realdata:(FMT7C,[201062.,301062.,401062.,501062.,601062.,701062.])#     RE52  24
realdata:(FMT7D,[201032.,301013.,401013.,501013.,601013.,701013.])#     RE52  25
realdata:(FMT7E,[201013.,301032.,401032.,501013.,601013.,701013.])#     RE52  26
realdata:(FMT7F,[201013.,301013.,401032.,501013.,601013.,701013.])#     RE52  27
realdata:(FMT8,[190842.,290842.,390842.,490842.,590842.,690842.])#      RE52  28
realdata:(DAR,0.01745329)#                                              RE52  29
intdata:(N,0)#                                                          RE52  30
datastuff:#                                                             RE52  31
#                                                                       RE52  32
#                                                                       RE52  33
#    OUTPUT FORMULA RECORDS                                             RE52  34
#    ----------------------                                             RE52  35
#                                                                       RE52  36
puthead:(RE5C)#                        Ouput formula head               RE52  37
DO L=1,3#                              Forl, awpc & ewpc                RE52  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RE52  39
J=0;K=0#                               Set pointers to bufot and chri   RE52  40
FOR(I=MARK9;I<MARKZ;I=I+STEP9)#        Loop over atom types             RE52  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RE52  42
J=J+1;K=K+10#                          Point to free bufot and chrin    RE52  43
IF(L==1) BUFOT(J)=QX(I+STEP9-2)/ZMOL#  Store no. atoms per molecule     RE52  44
ELSE BUFOT(J)=QX(I+STEP9+L-3)#         Mass % and esd                   RE52  45
movertoc:(QX(I+1),1,CHRIN,K,2,0)#      Move element name to chrin       RE52  46
IF(J==6\(I+STEP9==MARKZ&J!=0))#        Ready to output forl record      RE52  47
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RE52  48
movechar:(RE5CA,4*L-3,CHRIN,2,4,0)#    Put forl awpc ewpc in record     RE52  49
ncodefld:(BUFOT,1,CHRIN,FMT8,J)#       Encode atom names and numbers    RE52  50
DO K=1,J#                                                               RE52  51
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RE52  52
ifnv:(BUFOT(K))#                                                        RE52  53
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RE52  54
putrecd:;BREAK#                        Output record if something       RE52  55
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RE52  56
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RE52  57
J=0;K=0#                               Reset bufot and chrin pointers   RE52  58
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RE52  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RE52  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RE52  61
movechar:(BLANK,1,CHRIN,1,80,1)#       Clear chrin                      RE52  62
putlast:#                              Ouput *eos                       RE52  63
#                                                                       RE52  64
J=MARKZ-MARK9#                         Number of elements in mark9      RE52  65
movereal:(QX,MARK9+1,QX,MARK8+1,J,1)#  Move ff names to mark8           RE52  66
STEP8=STEP9;MARK9=MARK8+J#             Set step and markers of mark8    RE52  67
#                                                                       RE52  68
#    OUTPUT CONDITIONS RECORDS                                          RE52  69
#    -------------------------                                          RE52  70
#                                                                       RE52  71
puthead:(RE5A)#                        Output conditions head           RE52  72
#                                                                       RE52  73
#    PULL IN NAME OF DATA SET FROM LRDDEF:                              RE52  74
#                                                                       RE52  75
J=0#                                   Data set number                  RE52  76
REPEAT#                                Loop over datasets               RE52  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RE52  78
readwpkt:(1,lrddef:,NP,IP,0)#          Point to parameter pkt           RE52  79
J=J+1#                                 Count data set number            RE52  80
IF(IP<=0) iquit:(RE5210)#              Record missing                   RE52  81
IF(NMDS==J) BREAK#                     Exit when requ ds found          RE52  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RE52  83
movertoc:(QX(IP+1),1,DSK,1,4,0)#       Store data set name              RE52  84
#                                                                       RE52  85
#    PULL IN EXPERIMENTAL PARAMETERS FROM LREXPL:                       RE52  86
#                                                                       RE52  87
DO I=1,8;  IW(I)=I#                    Data set key, wavelengths        RE52  88
DO I=10,12;  IW(I)=I+3#                A, b, c                          RE52  89
DO I=13,15;  IW(I)=I+6#                Alpha, beta, gamma               RE52  90
DO I=16,21;  IW(I)=I+7#                Esd(a,b,c,alpha,beta,gamma)      RE52  91
IW(9)=10; IW(22)=22; IW(23)=29#        Absorption mu, vol, esd(vol)     RE52  92
IW(24)=35; IW(41)=81; IW(42)=82#       Scantype, temperature pressure   RE52  93
DO I=25,40;  IW(I)=I+16#               Ub matrix ... half width         RE52  94
DO I=43,46;  IW(I)=I+42#               Obs esd calc esd density         RE52  95
DO I=47,51;  IW(I)=I+43#               No hkl ... type radiation        RE52  96
IW(52)=300;K=46#                       No of faces, set counter         RE52  97
DO J=0,190,10#                         Twenty crystal faces             RE52  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RE52  99
K=K+6#                                                                  RE52 100
IW(K+1)=301+J;IW(K+2)=302+J;IW(K+3)=303+J# H k l face (j+9)/10          RE52 101
IW(K+4)=304+J;IW(K+5)=308+J;IW(K+6)=309+J# D esd(d) weight              RE52 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RE52 103
DO I=172,179;  IW(I)=I+329#            Min max h k l theta              RE52 104
DO I=180,183;  IW(I)=I+331#            Int rad abs int av strings       RE52 105
DO I=184,190;  IW(I)=I+337#            No reflectns ... max abs corr    RE52 106
DO I=191,213;  IW(I)=I+340#            Criteria .... min size           RE52 107
DO I=214,312;  IW(I)=I+387#            No standards ... l (30)          RE52 108
DO I=313,353;  IW(I)=I+388#            Attenuators 10 of them           RE52 109
DO I=354,364; IW(I)=I-254#             No of scales 10 scales           RE52 110
DO I=365,374; IW(I)=I-164#             10 scales group numbers          RE52 111
IW(375)=12;IW(376)=40#                 Sorting order, diffract type     RE52 112
KEY(1)=1; KEY(2)=376; KEY(3)=0;KEY(4)=0# Set search limits              RE52 113
indexpkt:(1,lrexpl:,NP,IP,0,KEY,IW,IR)# Get relative pointers           RE52 114
REPEAT#                                Loop over datasets               RE52 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RE52 116
readwpkt:(1,lrexpl:,NP,IP,0)#          Point to parameter pkt           RE52 117
IF(IP<=0) iquit:(RE5220)#              Record missing                   RE52 118
ifeq:(DSNM,QX(IP+IR(1))) BREAK#        Exit when requ ds found          RE52 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RE52 120
#                                      Extract general values           RE52 121
K=123#                                 Sorting order                    RE52 122
IF(IR(375)>0) ifnv:(QX(IP+IR(375))) K=NINT(QX(IP+IR(375)))#             RE52 123
SLOW=K/100; MEDIUM=K/10-10*SLOW; FAST=MOD(K,10)#                        RE52 124
RADTYP=0#                              Radiation type                   RE52 125
IF(IR(51)>0) ifnv:(QX(IP+IR(51))) RADTYP=NINT(QX(IP+IR(51)))#           RE52 126
KELVIN=voidflg:;LAMBDA=voidflg:#                                        RE52 127
IF(IR(2)>0)  LAMBDA=QX(IP+IR(2))#      Wavelength                       RE52 128
IF(IR(41)>0) KELVIN=QX(IP+IR(41))+273.# Temperature                     RE52 129
IF(IR(10)>0) ifnv:(QX(IP+IR(10)))#     Non void cell dimensions         RE52 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RE52 131
QX(MARK1+1)=QX(IP+IR(10))#             Lattice parameter a              RE52 132
QX(MARK1+2)=QX(IP+IR(11))#             Lattice parameter b              RE52 133
QX(MARK1+3)=QX(IP+IR(12))#             Lattice parameter c              RE52 134
QX(MARK1+4)=QX(IP+IR(13))*360.#        Alpha                            RE52 135
QX(MARK1+5)=QX(IP+IR(14))*360.#        Beta                             RE52 136
QX(MARK1+6)=QX(IP+IR(15))*360.#        Gamma                            RE52 137
QX(MARK1+8)=QX(IP+IR(16))#             Esd in a                         RE52 138
QX(MARK1+9)=QX(IP+IR(17))#             Esd in b                         RE52 139
QX(MARK1+10)=QX(IP+IR(18))#            Esd in c                         RE52 140
QX(MARK1+11)=QX(IP+IR(19))*360.#       Esd of alpha                     RE52 141
QX(MARK1+12)=QX(IP+IR(20))*360.#       Esd of beta                      RE52 142
QX(MARK1+13)=QX(IP+IR(21))*360.#       Esd of gamma                     RE52 143
QX(MARK1+14)=QX(IP+IR(22))#            Cell volume                      RE52 144
QX(MARK1+15)=QX(IP+IR(23))#            E.s.d cell volume                RE52 145
QX(MARK1+17)=QX(IP+IR(45))#            Calculated density               RE52 146
QX(MARK1+19)=QX(IP+IR(43))#            Measured density                 RE52 147
QX(MARK1+20)=QX(IP+IR(44))#            Esd measured density             RE52 148
QX(MARK1+21)=KELVIN#                   Temperature meas density         RE52 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RE52 150
#                                      Keep scale factors in mark9      RE52 151
STEP9=2;POINT9=MARK9#                                                   RE52 152
incrqx:(MARKZ,MARK9+10*STEP9,RE5230)#  Storage for scale factors        RE52 153
movereal:(voidflg:,1,QX(MARK9+1),1,10*STEP9,2)# Void scales             RE52 154
DO I=1,10#                             10 scale factors max             RE52 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RE52 156
IF(IR(I+354)>0) QX(POINT9+2*I-1)=QX(IP+IR(I+354))# Scale                RE52 157
IF(IR(I+365)>0) QX(POINT9+2*I)=QX(IP+IR(I+365))# Group                  RE52 158
POINT9=POINT9+STEP9#                                                    RE52 159
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RE52 160
DO I=1,4#                              4 strings to store               RE52 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RE52 162
IF(IR(179+I)>0) ifnv:(QX(IP+IR(179+I)))# String data into comments      RE52 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RE52 164
movechar:(BLANK,1,CHRIN,1,75,1)#       Blank chrin                      RE52 165
movechar:(RE5IA,4*I+1,CHRIN,2,4,0)#    Move cid to chrin                RE52 166
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 167
movertoc:(QX(IP+IR(179+I)),1,CHRIN,11,40,0)# Get string                 RE52 168
movector:(CHRIN,1,QX(POINT2+1),1,75,0)# Store the comment               RE52 169
POINT2=POINT2+STEP2#                                                    RE52 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RE52 171
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RE52 172
DO I=1,5#                              5 strings to store               RE52 173
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RE52 174
IF(IR(190+I)>0) ifnv:(QX(IP+IR(190+I)))# String data into comments      RE52 175
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RE52 176
movechar:(BLANK,1,CHRIN,1,75,1)#       Blank chrin                      RE52 177
movechar:(RE5IA,29,CHRIN,2,4,0)#       Move rmrk cid to chrin           RE52 178
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 179
movertoc:(QX(IP+IR(190+I)),1,CHRIN,11,40,0)# Get string                 RE52 180
movector:(CHRIN,1,QX(POINT2+1),1,75,0)# Store the comment               RE52 181
POINT2=POINT2+STEP2#                                                    RE52 182
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RE52 183
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RE52 184
#                                      Conditions cell                  RE52 185
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 186
movechar:(RE5AA,1,CHRIN,2,4,0)#        Store cell into record           RE52 187
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 188
movechar:(RE5AB,RADTYP+1,CHRIN,10,1,0)# Store radiation                 RE52 189
BUFOT(1)=LAMBDA;BUFOT(2)=KELVIN#       Wavelength temperature           RE52 190
IF(IR(48)>0) ifnv:(QX(IP+IR(48))) BUFOT(3)=2.*QX(IP+IR(48))# Min 2 th   RE52 191
IF(IR(49)>0) ifnv:(QX(IP+IR(49))) BUFOT(4)=2.*QX(IP+IR(49))# Max 2 th   RE52 192
IF(IR(47)>0) BUFOT(5)=QX(IP+IR(47))#   Number                           RE52 193
ncodefld:(BUFOT,1,CHRIN,FMT7A,6)#      Format cell parameters           RE52 194
putrecd:#                              Output cell record               RE52 195
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 196
movechar:(RE5AA,5,CHRIN,2,4,0)#        Store int into record            RE52 197
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 198
movechar:(RE5AB,RADTYP+1,CHRIN,10,1,0)# Store radiation                 RE52 199
BUFOT(1)=LAMBDA;BUFOT(2)=KELVIN#       Wavelength temperature           RE52 200
ifnv:(LAMBDA)#                                                          RE52 201
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RE52 202
IF(IR(178)>0) ifnv:(QX(IP+IR(178))) $#                                  RE52 203
BUFOT(3)=SIN(DAR*QX(IP+IR(178)))/LAMBDA# Min sint/l                     RE52 204
IF(IR(179)>0) ifnv:(QX(IP+IR(179))) $#                                  RE52 205
BUFOT(4)=SIN(DAR*QX(IP+IR(179)))/LAMBDA# Max sint/l                     RE52 206
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RE52 207
IF(IR(184)>0) BUFOT(5)=QX(IP+IR(184))# Number                           RE52 208
ncodefld:(BUFOT,1,CHRIN,FMT7A,6)#      Format int parameters            RE52 209
putrecd:#                              Output int record                RE52 210
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 211
movechar:(RE5AA,9,CHRIN,2,4,0)#        Store hkl into record            RE52 212
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 213
IF(IR(376)>0) ifnv:(QX(IP+IR(376)))#   Get diffractometer type          RE52 214
movertoc:(QX(IP+IR(376)),1,CHRIN,10,1,0)# Put diffracto type            RE52 215
IF(IR(172)>0)#                                                          RE52 216
FOR(I=1;I<=6;I=I+1) BUFOT(I)=QX(IP+IR(171+I))# H k l min max            RE52 217
ncodefld:(BUFOT,1,CHRIN,FMT7B,6)#      Format hkl parameters            RE52 218
putrecd:#                              Output hkl record                RE52 219
IF(IR(214)>0) ifnv:(QX(IP+IR(214)))#   Any standards ?                  RE52 220
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RE52 221
K=NINT(QX(IP+IR(214)))#                No. standards                    RE52 222
DO I=1,K#                                                               RE52 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RE52 224
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 225
movechar:(RE5AA,13,CHRIN,2,4,0)#       Store std into record            RE52 226
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 227
DO J=1,3; BUFOT(J)=QX(IP+IR(3*I+J+219))# H k l standard                 RE52 228
ncodefld:(BUFOT,1,CHRIN,FMT7B,6)#      Format std parameters            RE52 229
putrecd:#                              Output std record                RE52 230
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RE52 231
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RE52 232
IF(IR(9)>0) ifnm:(QX(IP+IR(9)))#       Abs record only when value       RE52 233
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RE52 234
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 235
movechar:(RE5AA,17,CHRIN,2,4,0)#       Store abs into record            RE52 236
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 237
IF(IR(182)>0) ifnv:(QX(IP+IR(182)))#   Get character code of absorpti   RE52 238
movertoc:(QX(IP+IR(182)),1,CHRIN,10,1,0)#                               RE52 239
BUFOT(1)=QX(IP+IR(9))#                 Mu in mm-1                       RE52 240
IF(IR(189)>0) BUFOT(2)=QX(IP+IR(189))# A* min                           RE52 241
IF(IR(190)>0) BUFOT(3)=QX(IP+IR(190))# A* max                           RE52 242
ncodefld:(BUFOT,1,CHRIN,FMT7,6)#       Format abs parameters            RE52 243
putrecd:#                              Output abs record                RE52 244
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RE52 245
IF(IR(52)>0) ifnv:(QX(IP+IR(52)))#     Any faces ?                      RE52 246
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RE52 247
K=NINT(QX(IP+IR(52)))#                 No. faces                        RE52 248
DO I=1,K#                                                               RE52 249
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RE52 250
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 251
movechar:(RE5AA,21,CHRIN,2,4,0)#       Store face into record           RE52 252
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 253
BUFOT(1)=QX(IP+IR(6*I+50))#            Get d                            RE52 254
DO J=2,4; BUFOT(J)=QX(IP+IR(6*I+J+45))# H k l face                      RE52 255
ncodefld:(BUFOT,1,CHRIN,FMT7D,6)#      Format face parameters           RE52 256
putrecd:#                              Output face record               RE52 257
IF(IR(6*I+51)>0) ifnv:(QX(IP+IR(6*I+51)))# Esd present?                 RE52 258
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RE52 259
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 260
movechar:(RE5AA,25,CHRIN,2,4,0)#       Store fare into record           RE52 261
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 262
BUFOT(1)=QX(IP+IR(6*I+51))#            Get esd d                        RE52 263
DO J=2,4; BUFOT(J)=QX(IP+IR(6*I+J+45))# H k l fare                      RE52 264
ncodefld:(BUFOT,1,CHRIN,FMT7D,6)#      Format fare parameters           RE52 265
putrecd:#                              Output fare record               RE52 266
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RE52 267
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RE52 268
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RE52 269
IF(IR(25)>0) ifnv:(QX(IP+IR(25)))#     Any ub matrix ?                  RE52 270
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 RE52 271
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 272
movechar:(RE5AA,33,CHRIN,2,4,0)#       Store oub1 into record           RE52 273
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 274
IF(IR(376)>0) ifnv:(QX(IP+IR(376)))#   Get diffractometer type          RE52 275
movertoc:(QX(IP+IR(376)),1,CHRIN,10,1,0)# Put diffracto type            RE52 276
DO J=1,6; BUFOT(J)=QX(IP+IR(J+24))#    Ub11 .. ub23                     RE52 277
ncodefld:(BUFOT,1,CHRIN,FMT7B,6)#      Format oub1 parameters           RE52 278
putrecd:#                              Output oub1 record               RE52 279
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 280
movechar:(RE5AA,37,CHRIN,2,4,0)#       Store oub2 into record           RE52 281
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 282
DO J=1,3; BUFOT(J)=QX(IP+IR(J+30))#    Ub31 .. ub33                     RE52 283
ncodefld:(BUFOT,1,CHRIN,FMT7B,6)#      Format oub2 parameters           RE52 284
putrecd:#                              Output oub2 record               RE52 285
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 RE52 286
#                                                                       RE52 287
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 288
movechar:(RE5AA,41,CHRIN,2,4,0)#       Store eqiv into record           RE52 289
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 290
IF(IR(184)>0) BUFOT(1)=QX(IP+IR(184))# Store no measured reflections    RE52 291
BUFOT(2)=QX(IP+IR(185))#               No averaged reflections          RE52 292
IF(IR(187)>0) BUFOT(3)=QX(IP+IR(187))# Store r index                    RE52 293
ncodefld:(BUFOT,1,CHRIN,FMT7F,6)#      Format eqiv parameters           RE52 294
putrecd:#                              Output eqiv record               RE52 295
#                                                                       RE52 296
IF(IR(201)>0) ifnv:(QX(IP+IR(201)))#   Any shape ?                      RE52 297
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 RE52 298
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 299
movechar:(RE5AA,57,CHRIN,2,4,0)#       Store shap into record           RE52 300
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 301
BUFOT(1)=QX(IP+IR(201))#               Store radius                     RE52 302
IF(IR(202)>0) BUFOT(2)=QX(IP+IR(202))# Store esd radius                 RE52 303
IF(IR(204)>0) BUFOT(3)=QX(IP+IR(204))# Store length                     RE52 304
IF(IR(205)>0) BUFOT(4)=QX(IP+IR(205))# Store esd length                 RE52 305
ncodefld:(BUFOT,1,CHRIN,FMT7,6)#       Format shap parameters           RE52 306
putrecd:#                              Output shap record               RE52 307
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 RE52 308
IF(IR(207)>0) ifnv:(QX(IP+IR(207)))#   Any dead time ?                  RE52 309
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 RE52 310
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 311
movechar:(RE5AA,61,CHRIN,2,4,0)#       Store deadtime into record       RE52 312
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 313
BUFOT(1)=QX(IP+IR(207))#               Store dead time                  RE52 314
IF(IR(208)>0) BUFOT(2)=QX(IP+IR(208))# Store esd dead time              RE52 315
ncodefld:(BUFOT,1,CHRIN,FMT7,6)#       Format detr parameters           RE52 316
putrecd:#                              Output detr record               RE52 317
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 RE52 318
IF(IR(210)>0) ifnv:(QX(IP+IR(210)))#   Any beta filter                  RE52 319
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 RE52 320
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 321
movechar:(RE5AA,65,CHRIN,2,4,0)#       Store bfil into record           RE52 322
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 323
BUFOT(1)=QX(IP+IR(210))#               Store bfilter                    RE52 324
ncodefld:(BUFOT,1,CHRIN,FMT7,6)#       Format bfil parameters           RE52 325
putrecd:#                              Output bfil record               RE52 326
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 RE52 327
IF(IR(313)>0) ifnv:(QX(IP+IR(313)))#   Any attenuators ?                RE52 328
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 RE52 329
K=NINT(QX(IP+IR(313)))#                No. attenuators                  RE52 330
DO I=1,K#                                                               RE52 331
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 RE52 332
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 333
movechar:(RE5AA,69,CHRIN,2,4,0)#       Store attf into record           RE52 334
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 335
DO J=1,3; BUFOT(J)=QX(IP+IR(4*I+J+309))# Index fac esd                  RE52 336
ncodefld:(BUFOT,1,CHRIN,FMT7E,6)#      Format attf parameters           RE52 337
putrecd:#                              Output attf record               RE52 338
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 RE52 339
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 RE52 340
IF((IR(36)+IR(37)+IR(38)+IR(39))>0)#   Put out polo line with values    RE52 341
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 RE52 342
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 343
movechar:(RE5AA,73,CHRIN,2,4,0)#       Store polo into record           RE52 344
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 345
IF(IR(36)>0) BUFOT(1)=QX(IP+IR(36))#   Polarization ratio               RE52 346
IF(IR(37)>0) BUFOT(2)=QX(IP+IR(37))#   Esd polarization ratio           RE52 347
IF(IR(39)>0) BUFOT(3)=QX(IP+IR(39))#   Dihedral angle                   RE52 348
IF(IR(40)>0) BUFOT(4)=QX(IP+IR(40))#   Incident beam half width         RE52 349
ncodefld:(BUFOT,1,CHRIN,FMT7,6)#       Format polo parameters           RE52 350
putrecd:#                              Output polo record               RE52 351
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 RE52 352
IF(IR(3)>0) ifnv:(QX(IP+IR(3)))#       Wavelength data ?                RE52 353
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 RE52 354
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE52 355
movechar:(RE5AA,77,CHRIN,2,4,0)#       Store wavl into record           RE52 356
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE52 357
DO I=1,3; BUFOT(2*I-1)=QX(IP+IR(I+2))# Wavelengths                      RE52 358
DO I=1,3; BUFOT(2*I)=QX(IP+IR(I+5))#   Weights                          RE52 359
ncodefld:(BUFOT,1,CHRIN,FMT7C,6)#      Format wavl parameters           RE52 360
putrecd:#                              Output wavl record               RE52 361
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 RE52 362
putlast:#                              Output *eos record for conditi   RE52 363
#                                                                       RE52 364
RETURN#                                                                 RE52 365
END#                                                                    RE52 366
systemheader:(RE53)#                   Xtal bdf to std file (part 3)    RE53   1
####################################################################    RE53   2
#                                                                       RE53   3
#                        RE53                                           RE53   4
#                                                                       RE53   5
####################################################################    RE53   6
SUBROUTINE RE53#                                                        RE53   7
include:(AACOMN)#                                                       RE53   8
include:(RECOMN)#                      H.d. flack 1988, 1990            RE53   9
#                                                                       RE53  10
INTEGER I,J,K,L,M,IP,NP,MP#                                             RE53  11
INTEGER NM#                                                             RE53  12
REAL A#                                                                 RE53  13
string:(ATEL,2)#                                                        RE53  14
string:(ATNUM,6)#                                                       RE53  15
string:(ATNAME,8)#                                                      RE53  16
chardata:(REXX,*EOS )#                                                  RE53  17
chardata:(RE52,CELL DIMENSIONS  A         B         $#                  RE53  18
C       ALPHA     BETA      GAMMA   Z)#                                 RE53  19
chardata:(RE52A,CELLERRSVOL PHYS)#                                      RE53  20
chardata:(RE55,ATOMS    NAME    X U11   Y U22   Z U33   U U12   $#      RE53  21
P U13     U23  MUL AT  DT)#                                             RE53  22
chardata:(RE55A,UALLUALEATCOATCEUIJ UIJE)#                              RE53  23
chardata:(RE5D,CRYSTAL)#                                                RE53  24
chardata:(RE5DA,SCALEXTNEXTEABSR)#                                      RE53  25
chardata:(RE5E,BACIAGLD T)#            Extinction codes                 RE53  26
chardata:(RE5G,AZ09)#                                                   RE53  27
chardata:(RE5I,COMMENTS)#                                               RE53  28
chardata:(RE5IA,SCATEXPTEXPTABS EXPTWGHTEXTNRMRKHYDRRMRK)#              RE53  29
realdata:(FMT1,[201042.,301042.,401042.,501042.,601042.,701042.,#       RE53  30
750512])#                                                               RE53  31
realdata:(FMT4,[250852.,330852.,410852.,490852.,570852.,650852.,#       RE53  32
680313.,750113.])#                                                      RE53  33
realdata:(FMT9,[251042.])#                                              RE53  34
realdata:(FMT10,[251051.,351051.,451051.,551051.,651051.,751051.])#     RE53  35
intdata:(N,0)#                                                          RE53  36
datastuff:#                                                             RE53  37
#                                                                       RE53  38
#                                                                       RE53  39
#     OUTPUT CRYSTAL RECORDS                                            RE53  40
#     ----------------------                                            RE53  41
#                                                                       RE53  42
puthead:(RE5D)#                        Output crystal records           RE53  43
FOR(I=MARK9;I<MARKZ;I=I+STEP9)#        Loop over scale groups           RE53  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RE53  45
ifnv:(QX(I+1))#                                                         RE53  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RE53  47
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE53  48
movechar:(RE5DA,1,CHRIN,2,4,0)#        Store scal into record           RE53  49
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE53  50
BUFOT(1)=QX(I+1)#                      Store scales for data set        RE53  51
ncodefld:(BUFOT,1,CHRIN,FMT9,1)#       Format scal parameters           RE53  52
putrecd:#                              Output scal record               RE53  53
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RE53  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RE53  55
#                                                                       RE53  56
#  PULL IN GENERAL DATA FOR DATASET FROM B.D.F.                         RE53  57
#                                                                       RE53  58
DO I=1,4; IW(I)=I#                     Data set, uov, x, eta            RE53  59
DO I=5,20; IW(I)=I+96#                 Set required bin numbers         RE53  60
KEY(1)=1; KEY(2)=20; KEY(3)=0;KEY(4)=0# Set search limits               RE53  61
indexpkt:(1,lrdset:,NP,IP,0,KEY,IW,IR)# Get relative pointers           RE53  62
REPEAT#                                Loop over datasets               RE53  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RE53  64
readwpkt:(1,lrdset:,NP,IP,0)#          Point to parameter pkt           RE53  65
IF(IP<=0) iquit:(RE5310)#              Rec miss                         RE53  66
ifeq:(DSNM,QX(IP+IR(1))) BREAK#        Exit when requ ds found          RE53  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RE53  68
IF(IR(2)>0) UOV=QX(IP+(IR(2)))#        Overall displacement parameter   RE53  69
IF(IR(3)>0) ifnv:(QX(IP+IR(3)))#                                        RE53  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RE53  71
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE53  72
movechar:(RE5DA,13,CHRIN,2,4,0)#       Store absr into record           RE53  73
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE53  74
BUFOT(1)=QX(IP+IR(3))#                 X enantio-polarity               RE53  75
ncodefld:(BUFOT,1,CHRIN,FMT9,1)#       Format absr parameters           RE53  76
putrecd:#                              Output absr record               RE53  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RE53  78
# OUTPUT EXTN OF CRYSTAL.  DO THE MOSAIC SPREAD PARAMETERS ON THE FIRST RE53  79
# RECORD AND THE DOMAIN SIZE ON THE SECOND RECORD. POINTERS INTO RE5E A RE53  80
# L (4/5) FOR ISOTROPIC/ANISO, M (6/7/8) FOR GAUSSIAN, LORENTZIAN,      RE53  81
# DOMAIN, N (9/10) FOR NO SUB-TYPE OR NELMES THORNLEY, NM NUMBER OF     RE53  82
# PARAMETERS ON RECORD.                                                 RE53  83
I=IP+IR(5);IF(I>IP) ifnm:(QX(I)) I=NINT(QX(I))# Point to extinct type   RE53  84
ELSE  I=0#                                                              RE53  85
L=0#                                   Mark for no record to output     RE53  86
IF(I==1\I==3)#                         Isotropic mosaic values presen   RE53  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RE53  88
J=IP+IR(7); BUFOT(1)=QX(J)#            Parameter value                  RE53  89
L=4;J=IP+IR(6);M=6+NINT(QX(J));N=9;NM=1# Set pointers                   RE53  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RE53  91
IF(I==4\I==6)#                         Anisotropic mosaic values        RE53  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RE53  93
DO K=1,6#                                                               RE53  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RE53  95
J=IP+IR(K+8); BUFOT(K)=QX(J)#          Parameter values                 RE53  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RE53  97
L=5;J=IP+IR(6);M=6+NINT(QX(J));N=10;NM=6# Set pointers                  RE53  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RE53  99
IF(L!=0)#                              Is there a record to output?     RE53 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RE53 101
movechar:(RE5DA,5,CHRIN,2,4,0)#        Store extn into record           RE53 102
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE53 103
movechar:(RE5E,1,CHRIN,10,3,0)#        Fill extinction theory flag      RE53 104
movechar:(RE5E,L,CHRIN,13,1,0)#        Fill directionality flag         RE53 105
movechar:(RE5E,M,CHRIN,14,1,0)#        Fill parameter type flag         RE53 106
movechar:(RE5E,N,CHRIN,15,1,0)#        Fill theory subflag              RE53 107
ncodefld:(BUFOT,1,CHRIN,FMT10,NM)#     Format extn mosaic parameters    RE53 108
putrecd:#                                                               RE53 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RE53 110
L=0#                                   Mark for no record to output     RE53 111
IF(I==2\I==3\I==6)#                    Isotropic domain values presen   RE53 112
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RE53 113
J=IP+IR(8); BUFOT(1)=QX(J)#            Parameter value                  RE53 114
L=4;M=8;N=9;NM=1#                      Set pointers                     RE53 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RE53 116
IF(I==5)#                              Anisotropic domain values        RE53 117
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RE53 118
DO K=1,6#                                                               RE53 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RE53 120
J=IP+IR(K+15); BUFOT(K)=QX(J)#         Parameter values                 RE53 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RE53 122
L=5;M=8;N=9;NM=6#                      Set pointers                     RE53 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RE53 124
IF(L!=0)#                              Is there a record to output?     RE53 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RE53 126
movechar:(RE5DA,5,CHRIN,2,4,0)#        Store extn into record           RE53 127
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE53 128
movechar:(RE5E,1,CHRIN,10,3,0)#        Fill extinction theory flag      RE53 129
movechar:(RE5E,L,CHRIN,13,1,0)#        Fill directionality flag         RE53 130
movechar:(RE5E,M,CHRIN,14,1,0)#        Fill parameter type flag         RE53 131
movechar:(RE5E,N,CHRIN,15,1,0)#        Fill theory subflag              RE53 132
ncodefld:(BUFOT,1,CHRIN,FMT10,NM)#     Format extn domain parameters    RE53 133
putrecd:#                                                               RE53 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RE53 135
putlast:#                              Output *eos record               RE53 136
#                                                                       RE53 137
#     OUTPUT ATOMS RECORDS                                              RE53 138
#     --------------------                                              RE53 139
#                                                                       RE53 140
DO I=1,11;  IW(I)=I#                   Set required idnums              RE53 141
IW(12)=21; IW(13)=22; IW(14)=23#       Set required idnums              RE53 142
DO I=15,17; IW(I)=I+86#                Set required idnums              RE53 143
DO I=20,25; IW(I)=I+85#                Set required idnums              RE53 144
IW(18)=104#                            Set esd(u) idnum                 RE53 145
IW(19)=111;  IW(26)=14#                Set pp & name idnum              RE53 146
DO I=27,29; IW(I)=I+29#                String data                      RE53 147
KEY(1)=0;KEY(2)=29; KEY(3)=0;KEY(4)=0# Set search limits                RE53 148
indexpkt:(1,lratom:,MP,IP,0,KEY,IW,IR)# Get relative pointers           RE53 149
IF(IR(1)>0)#                           Test if coords present           RE53 150
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RE53 151
puthead:(RE55)#                        Output atom header               RE53 152
#                   OVERALL ATOMIC DISPLACEMENT PARAMETER               RE53 153
movechar:(RE55A,1,CHRIN,2,4,0)#        Move 'uall'                      RE53 154
ncodefld:(UOV,1,CHRIN,FMT4,1)#         Format uov etc.                  RE53 155
putrecd:#                              Output atom details              RE53 156
REPEAT#                                Loop over atom packets           RE53 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RE53 158
readwpkt:(1,lratom:,MP,IP,0)#          Point to atom pkt                RE53 159
IF(IP<=0) BREAK#                       Exit after last packet           RE53 160
#                                      Atco  record                     RE53 161
movereal:(voidflg:,1,BUFOT,1,8,2)#     Void bufot                       RE53 162
movechar:(RE55A,9,CHRIN,2,4,0)#        Move atco                        RE53 163
DO I=1,3; BUFOT(I)=QX(IP+IR(I))#       Store x y z coords               RE53 164
IF(IR(11)>0) BUFOT(5)=QX(IP+IR(11))#   Store pp value                   RE53 165
IF(IR(12)>0) ifnv:(QX(IP+IR(12))) BUFOT(6)=QX(IP+IR(12))*AMUL# Wychof   RE53 166
I=IP+IR(13); IF(I>IP) N=MARK8+1+STEP8*(NINT(QX(I))-1)# Ffn pointer      RE53 167
ELSE      N=MARK8 + 1#                 Store default ff no.             RE53 168
IF(IR(14)>0) BUFOT(7)=QX(IP+IR(14))#   Store ndp value                  RE53 169
ifeq:(BUFOT(7),0.) BUFOT(7)=8.#        Overall xtal 0.; scfs, 8.        RE53 170
movertoc:(QX(N),1,ATEL,1,2,0)#         El name from lrscat              RE53 171
K=IP+IR(26)#                           Point to atom name               RE53 172
# MAKE ATOM NUMBER ACCORDING TO SCFS RULES                              RE53 173
movechar:(BLANK,1,ATNAME,1,8,1)#       Blank out atom number            RE53 174
movertoc:(QX(N+mw02dm:),1,ATNAME,1,8,0)# At name from lrscat:           RE53 175
FOR(I=8;I>1;I=I-1)IF(ATNAME(I^I)!=BLANK(1^1)) BREAK# Go backwards       RE53 176
I=I+1;J=MIN(25-I,6)#                   First and num of chars.          RE53 177
movechar:(BLANK,1,ATNUM,1,6,1)#        Blank out atom number            RE53 178
movertoc:(QX(K),I,ATNUM,1,J,0)#        Fill atnum with atom number      RE53 179
movechar:(ATEL,1,CHRIN,10,2,0)#        Move el name to buffer           RE53 180
movechar:(ATNUM,1,CHRIN,12,6,0)#       Move atom number to buffer       RE53 181
ncodefld:(BUFOT,1,CHRIN,FMT4,3)#       Format x,y,z                     RE53 182
ifeq:(BUFOT(7),1.)#                    Get isotropic u                  RE53 183
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RE53 184
IF(IR(4)>0) BUFOT(4)=QX(IP+IR(4))#     Store u value                    RE53 185
ncodefld:(BUFOT,4,CHRIN,FMT4(4),1)#    Format u                         RE53 186
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RE53 187
ncodefld:(BUFOT,5,CHRIN,FMT4(5),1)#    Format pp                        RE53 188
ncodefld:(BUFOT,6,CHRIN,FMT4(7),2)#    Format wycoff & dt               RE53 189
movertoc:(QX(N+mw02dm:),1,CHRIN,71,4,0)# At name from lrscat:           RE53 190
putrecd:#                              Output atom details              RE53 191
#                                      Atce                             RE53 192
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE53 193
movechar:(RE55A,13,CHRIN,2,4,0)#       Move atce                        RE53 194
movechar:(ATEL,1,CHRIN,10,2,0)#        Move el name to buffer           RE53 195
movechar:(ATNUM,1,CHRIN,12,6,0)#       Move atom number to buffer       RE53 196
DO I=1,3#                              Loop over e.s.d. of x,y,z        RE53 197
IF(IR(I+14)>0) ncodefld:(QX,IP+IR(I+14),CHRIN,FMT4(I),1)# Format sigm   RE53 198
IF(IR(18)>0) ifeq:(BUFOT(7),1.)#       Valid isotropic sigma u?         RE53 199
ncodefld:(QX,IP+IR(18),CHRIN,FMT4(4),1)# Sigma u                        RE53 200
IF(IR(19)>0)ncodefld:(QX,IP+IR(19),CHRIN,FMT4(5),1)# Format sigma pp    RE53 201
putrecd:#                              Output sigma details             RE53 202
ifne:(BUFOT(7),2.0) NEXT#              Only need uij & uije for aniso   RE53 203
#                                      Uij                              RE53 204
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE53 205
movechar:(RE55A,17,CHRIN,2,4,0)#       Move 'uij '                      RE53 206
movechar:(ATEL,1,CHRIN,10,2,0)#        Move el name to buffer           RE53 207
movechar:(ATNUM,1,CHRIN,12,6,0)#       Move atom number to buffer       RE53 208
IF(IR(5)>0) ifnv:(QX(IP+IR(5)))#       Treat uij                        RE53 209
FOR (I=1;I<=6;I=I+1) BUFOT(I)=QX(IP+IR(I+4))# Store uij                 RE53 210
ncodefld:(BUFOT,1,CHRIN,FMT4,6)#       Format u11 etc.                  RE53 211
putrecd:#                              Output atom details              RE53 212
#                                      Uije                             RE53 213
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE53 214
movechar:(RE55A,21,CHRIN,2,4,0)#       Move 'uije'                      RE53 215
movechar:(ATEL,1,CHRIN,10,2,0)#        Move el name to buffer           RE53 216
movechar:(ATNUM,1,CHRIN,12,6,0)#       Move atom number to buffer       RE53 217
IF(IR(20)>0) ifnv:(QX(IP+IR(20)))#     Sigma uij                        RE53 218
FOR (I=1;I<=6;I=I+1) BUFOT(I)=QX(IP+IR(I+19))# Store esd uij            RE53 219
ncodefld:(BUFOT,1,CHRIN,FMT4,6)#       Format u11 etc.                  RE53 220
putrecd:#                              Output atom details              RE53 221
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RE53 222
DO I=1,3#                              3 strings to store               RE53 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RE53 224
IF(IR(26+I)>0) ifnv:(QX(IP+IR(26+I)))# String data into comments        RE53 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RE53 226
movechar:(BLANK,1,CHRIN,1,75,1)#       Blank chrin                      RE53 227
movechar:(RE5IA,4*I+1,CHRIN,2,4,0)#    Move cid to chrin                RE53 228
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE53 229
movertoc:(QX(IP+IR(26)),1,CHRIN,11,40,0)# Atom name                     RE53 230
movertoc:(QX(IP+IR(26+I)),1,CHRIN,35,40,0)# Get string                  RE53 231
movector:(CHRIN,1,QX(POINT2+1),1,75,0)# Store the comment               RE53 232
POINT2=POINT2+STEP2#                                                    RE53 233
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RE53 234
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RE53 235
putlast:#                              Output eos * record              RE53 236
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RE53 237
#                                                                       RE53 238
#    READ LRMOLE:  AND STORE VALUES                                     RE53 239
#    ------------------------------                                     RE53 240
#                                                                       RE53 241
IW(1)=1; IW(2)=11; IW(3)=12; IW(4)=13# Data set no., form, mass, z      RE53 242
IW(5)=14; IW(6)=15; IW(7)=21; IW(8)=22# Obs mass, esd, calc den, f000   RE53 243
KEY(1)=1; KEY(2)=8; KEY(3)=0;KEY(4)=0# Set dir search keys              RE53 244
indexpkt:(1,lrmole:,NP,IP,0,KEY,IW,IR)# Get idnum positions             RE53 245
REPEAT#                                Loop over datasets               RE53 246
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RE53 247
readwpkt:(1,lrmole:,NP,IP,0)#          Point to parameter pkt           RE53 248
IF(IP<=0) BREAK#                       Finished lrmole:                 RE53 249
ifeq:(DSNM,QX(IP+IR(1)))#              Find required data set           RE53 250
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RE53 251
IF(IR(2)>0) ifnv:(QX(IP+IR(2)))#       Molecular formula to comments    RE53 252
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RE53 253
movechar:(BLANK,1,CHRIN,1,75,1)#       Blank chrin                      RE53 254
movechar:(RE5IA,1,CHRIN,2,4,0)#        Move form to chrin               RE53 255
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE53 256
movertoc:(QX(IP+IR(2)),1,CHRIN,11,36,0)# Get formula (1st part)         RE53 257
movector:(CHRIN,1,QX(POINT2+1),1,75,0)# Store the comment               RE53 258
POINT2=POINT2+STEP2#                                                    RE53 259
movertoc:(QX(IP+IR(2)),37,CHRIN,11,36,0)# Get formula (2nd part)        RE53 260
movector:(CHRIN,1,QX(POINT2+1),1,75,0)# Store the comment               RE53 261
POINT2=POINT2+STEP2#                                                    RE53 262
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RE53 263
IF(IR(3)>0) QX(MARK1+16)=QX(IP+IR(3))# Calculated formula mass          RE53 264
IF(IR(4)>0) ifnm:(QX(IP+IR(4))) ZMOL=QX(IP+IR(4))# Molec or formula z   RE53 265
IF(IR(5)>0) QX(MARK1+22)=QX(IP+IR(5))# Measured formula mass            RE53 266
IF(IR(6)>0) QX(MARK1+23)=QX(IP+IR(6))# Esd measured formula mass        RE53 267
IF(IR(7)>0) ifnm:(QX(IP+IR(7))) QX(MARK1+17)=QX(IP+IR(7))# Calc densi   RE53 268
IF(IR(8)>0) A=QX(IP+IR(8))#            F(000) - to be done              RE53 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RE53 270
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RE53 271
#                                                                       RE53 272
#    OUTPUT CELL DIMENSION RECORDS                                      RE53 273
#    -----------------------------                                      RE53 274
#                                                                       RE53 275
puthead:(RE52)#                        Output cell header               RE53 276
movechar:(RE52A,1,CHRIN,2,4,0)#        Insert cell                      RE53 277
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE53 278
ncodefld:(QX(MARK1),2,CHRIN,FMT1,7)#   Format cell constants            RE53 279
putrecd:#                              Output cell constants            RE53 280
movechar:(RE52A,5,CHRIN,2,4,0)#        Insert errs                      RE53 281
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE53 282
ncodefld:(QX(MARK1),9,CHRIN,FMT1,6)#   Format sigma in cell dim         RE53 283
putrecd:#                              Output sigma in cell dim         RE53 284
movechar:(RE52A,9,CHRIN,2,4,0)#        Insert vol                       RE53 285
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE53 286
ncodefld:(QX(MARK1),15,CHRIN,FMT1,5)#  Format vol in cell dim           RE53 287
putrecd:#                              Output vol in cell dim           RE53 288
movechar:(RE52A,13,CHRIN,2,4,0)#       Insert phys                      RE53 289
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE53 290
ncodefld:(QX(MARK1),20,CHRIN,FMT1,5)#  Format phys in cell dim          RE53 291
putrecd:#                              Output phys in cell dim          RE53 292
putlast:#                              Output *eos record               RE53 293
#                                                                       RE53 294
RETURN#                                                                 RE53 295
END#                                                                    RE53 296
systemheader:(RE54)#                   Xtal bdf to std file (part 4)    RE54   1
####################################################################    RE54   2
#                                                                       RE54   3
#                        RE54                                           RE54   4
#                                                                       RE54   5
####################################################################    RE54   6
SUBROUTINE RE54#                                                        RE54   7
include:(AACOMN)#                                                       RE54   8
include:(RECOMN)#                      H.d. flack 1988, 1990            RE54   9
#                                                                       RE54  10
INTEGER I,J,K,L,IP,NP#                                                  RE54  11
INTEGER HKLPT#                                                          RE54  12
INTEGER NFLDX#                                                          RE54  13
INTEGER ANTE,JKL,MREF,KSV#                                              RE54  14
REAL H(3),ZGN#                                                          RE54  15
REAL   MEDHKL, SLWHKL#                                                  RE54  16
string:(ATNUM,6)#                                                       RE54  17
string:(CHONE,1)#                                                       RE54  18
chardata:(REEN,END)#                                                    RE54  19
chardata:(RE56,HKL          H    K    L        OBS     SIGMA)#          RE54  20
chardata:(RE56A,FOBSFSQRINT CALCANGL)#                                  RE54  21
chardata:(RE5F,ABCAD )#                Reflection observation flags     RE54  22
chardata:(RE5B,HKL PACK L    FOBS  SIGM    H  K  L    FOBS  SIGM$#      RE54  23
    H  K  L    FOBS  SIGM)#                                             RE54  24
chardata:(RE56C,HKL INTEGRATED)#                                        RE54  25
chardata:(RE56D,HKL COMPRESSED)#                                        RE54  26
chardata:(RE56E,FOSQINHKL)#                                             RE54  27
chardata:(RE5A,CONDITIONS)#                                             RE54  28
chardata:(RE5AA,CELLINT HKL STD ABS FACEFAREORNTOUB1OUB2EQIVREFN$#      RE54  29
STATVAR SHAPDETRBFILATTFPOLOWAVL)#                                      RE54  30
chardata:(RE5AB, NEXS FSI)#                                             RE54  31
chardata:(RE5G,AZ09*)#                                                  RE54  32
chardata:(RE5H,GEOMETRY)#                                               RE54  33
chardata:(RE5HA,BOND)#                                                  RE54  34
chardata:(RE5HB,123)#                                                   RE54  35
chardata:(RE5I,COMMENTS)#                                               RE54  36
chardata:(RE5IA,SCATEXPTEXPTABS EXPTWGHTEXTNRMRKHYDRRMRK)#              RE54  37
chardata:(RE5IB,"Refinement Process    Weighting Scheme      $#         RE54  38
Extinction Model      Least-Squares Matrix  Hydrogen atoms        $#    RE54  39
Enantiomorph-Polarity ")#                                               RE54  40
realdata:(FMT5,[140513.,190513.,240513.,351032.,451032.,551032.,#       RE54  41
651032.,751032.])#                                                      RE54  42
realdata:(FMT5A,[140513.,190513.,240513.,351042.,250103.])#             RE54  43
realdata:(FMT7,[201042.,301042.,401062.,501042.,601042.,701042.])#      RE54  44
realdata:(FMT7A,[201042.,301022.,401032.,501032.,601013.,701042.])#     RE54  45
realdata:(FMT7B,[201013.,301013.,401013.,501013.,601013.,701013.])#     RE54  46
realdata:(FMT7C,[201062.,301062.,401062.,501062.,601062.,701062.])#     RE54  47
realdata:(FMT11,[040313.,070313.,100313.,180822.,240622.,290313.,#      RE54  48
320313.,350313.,430822.,490622.,540313.,570313.,600313.,680822.,#       RE54  49
740622.])#                                                              RE54  50
realdata:(FMT12,[190842.,270842.,350842.,430842.,510842.,590842.])#     RE54  51
realdata:(FMT13A,[160513.,210513.,260513.,361002.,461002.,561002.,#     RE54  52
650932.,751012.])#                                                      RE54  53
realdata:(FMT13B,[70213.,90213.,110213.,130213.,210832.,290832.,#       RE54  54
370832.,450832.,530832.,610832.,680732.,750732.])#                      RE54  55
realdata:(FMT14, [70313.,100313.,130313.,200722.,230312.,$#             RE54  56
260313.,330722.,360312.,390313.,460722.,490312.,520313.,$#              RE54  57
590722.,620312.,650313.,720722.,750312.])#                              RE54  58
realdata:(FMT15,[170313.,190213.,210213.,230213.])#                     RE54  59
intdata:(N,0)#                                                          RE54  60
datastuff:#                                                             RE54  61
#                                                                       RE54  62
#                                                                       RE54  63
#    OUTPUT REFLECTION RECORDS                                          RE54  64
#    -------------------------                                          RE54  65
#                                                                       RE54  66
#   INTEN  1  OUTPUT HKL PACK SECTION                                   RE54  67
#   INTEN  2  OUTPUT HKL INTEGRATED                                     RE54  68
#   INTEN  3  OUTPUT HKL COMPRESSED FOBS                                RE54  69
#   INTEN  4  OUTPUT HKL COMPRESSED FSQR                                RE54  70
#   INTEN  5  OUTPUT HKL COMPRESSED INTENSITY                           RE54  71
#   INTEN  6  OUTPUT HKL WITH FOBS SECTION                              RE54  72
#   INTEN  7  OUTPUT HKL WITH FSQR SECTION                              RE54  73
#   INTEN  8  OUTPUT HKL WITH INT  SECTION                              RE54  74
#   INTEN  9  OUTPUT HKL WITH CALC SECTION                              RE54  75
#                                                                       RE54  76
J=NMDS*1000#                           Data set bias                    RE54  77
DO I=1,18; IW(I)=1#                    Hkl and dummies                  RE54  78
IW(2)=J+308; IW(3)=J+304; IW(4)=J+305# Rcod, frel, sigf                 RE54  79
IW(8)=J+318; IW(9)=J+314; IW(10)=J+315# Rcod, frel, sigf for antirefl   RE54  80
NFLDX=5; HKLPT=-1#                     Basic 5 fp. hkl point reset      RE54  81
DO I=1,17; BUFOT(I)=voidflg:#          Default op buffer                RE54  82
DO I=6,15,3; BUFOT(I)=999.#            Void indices                     RE54  83
#                                                                       RE54  84
IF(INTEN==1)#                          Hkl pack set up                  RE54  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RE54  86
HKLPT=0;DO I=1,15; BUFOT(I)=999.#      Default op buffer                RE54  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RE54  88
ELSE IF(INTEN==2)#                     Hkl integrated section set up    RE54  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RE54  90
IW(2)=J+21; IW(3)=J+23; IW(4)=J+24#    Peak back l back r counts        RE54  91
IW(5)=J+11; IW(6)=J+14; IW(7)=J+26#    Azimuth, time, attenuator        RE54  92
IW(8)=J+309; IW(9)=J+18; IW(10)=J+46#  Scale set, standard, backsn      RE54  93
IW(11)=J+47; IW(12)=J+48; IW(13)=J+49# Cnp cnb cnl                      RE54  94
IW(14)=J+50; IW(15)=J+10; IW(16)=J+51# Cnr swom scntp                   RE54  95
IW(17)=J+52; IW(18)=J+53; NFLDX=18#    Detector horiz vert. 18 fp fie   RE54  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RE54  97
ELSE IF(INTEN==4)#                     Compressed fsqr section set up   RE54  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RE54  99
IW(3)=J+302; IW(4)=J+303#              Set frel**2, sigf**2             RE54 100
IW(9)=J+312; IW(10)=J+313#             Set frel**2, sigf**2 anti refs   RE54 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RE54 102
ELSE IF(INTEN==5)#                     Compressed int  section set up   RE54 103
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RE54 104
IW(3)=J+300; IW(4)=J+301#              Set inet, sigi                   RE54 105
IW(9)=J+310; IW(10)=J+311#             Set inet, sigi anti reflns       RE54 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RE54 107
ELSE IF(INTEN==7)#                     Fsqr section set up              RE54 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RE54 109
IW(3)=J+302; IW(4)=J+303#              Set frel**2, sigf**2             RE54 110
IW(5)=J+800; NFLDX=6#                  Set f calc, 6 fp fields          RE54 111
IW(9)=J+312; IW(10)=J+313#             Set frel**2, sigf**2 anti refl   RE54 112
IW(11)=J+800#                          Set f calc anti reflns           RE54 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RE54 114
ELSE IF(INTEN==8)#                     Int  section set up              RE54 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RE54 116
IW(5)=J+300; IW(6)=22; IW(7)=J+301#    Set inet, dummy, sigi            RE54 117
IW(11)=J+310; IW(12)=22; IW(13)=J+311# Set inet, dummy, sigi anti ref   RE54 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RE54 119
ELSE IF(INTEN==9)#                     Calc section set up              RE54 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RE54 121
IW(5)=J+820; IW(6)=J+805; IW(7)=J+806# Set fcalc, a, b                  RE54 122
IW(11)=J+820;IW(12)=J+805;IW(13)=J+806# Set fcalc, a, b                 RE54 123
NFLDX=8#                               Calc has 8 fp fields             RE54 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RE54 125
#                                                                       RE54 126
KEY(1)=0; KEY(2)=18; KEY(3)=0;KEY(4)=0# Set search limits               RE54 127
indexpkt:(1,lrrefl:,NP,IP,0,KEY,IW,IR)# Get relative pointers           RE54 128
IF(IR(1)>0)#                           Data present                     RE54 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RE54 130
ANTE=1#                                No antireflns in same packet     RE54 131
IF((INTEN!=2)&(IR(9)>0)) ANTE=-1#      Reflns and antis together        RE54 132
IF (INTEN==1) puthead:(RE5B)#          Hkl pack header                  RE54 133
ELSE IF (INTEN==2) puthead:(RE56C)#    Hkl integrated header            RE54 134
ELSE IF((INTEN>2)&(INTEN<6)) puthead:(RE56D)# Hkl compressed header     RE54 135
ELSE puthead:(RE56)#                   Hkl header                       RE54 136
REPEAT#                                Loop over reflection pkts        RE54 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RE54 138
readwpkt:(1,lrrefl:,NP,IP,0)#          Point to next packet             RE54 139
IF(IP<=0) BREAK#                       Exit after last pkt              RE54 140
JKL=-6#                                                                 RE54 141
DO MREF=1,ANTE,-2#                     Loop reflns and (perhaps) anti   RE54 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RE54 143
JKL=JKL+6;ZGN=FLOAT(MREF)#             Qx pointer/index multiplier      RE54 144
IF(IR(JKL+3)==0) NEXT#                                                  RE54 145
ELSE ifvo:(QX(IP+IR(JKL+3))) NEXT#     Skip void reflection             RE54 146
IF(INTEN==1)#                          Hkl pack section                 RE54 147
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RE54 148
IF(HKLPT==15)#                         Need to empty buffer?            RE54 149
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RE54 150
ncodefld:(BUFOT,1,CHRIN,FMT11,15)#     Format h,k,l,fobs,sigf 3 times   RE54 151
putrecd:#                              Output h,k,l etc.                RE54 152
DO I=1,15; BUFOT(I)=999.#              Default op buffer                RE54 153
HKLPT=0#                               Hkl pointer reset                RE54 154
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RE54 155
I=IP+IR(1); gethkl:(I,H)#              Unpack  h,k,l                    RE54 156
BUFOT(HKLPT+1)=ZGN*H(1);BUFOT(HKLPT+2)=ZGN*H(2)# Store hkl in bufot     RE54 157
BUFOT(HKLPT+3)=ZGN*H(3)#                                                RE54 158
I=IP+IR(JKL+2); I=NINT(QX(I))#         Retrieve refln code              RE54 159
J=5*HKLPT+25#                          Pointer of rcode in chrin        RE54 160
movechar:(RE5F,I,CHRIN,J,1,0)#         Store code as letter             RE54 161
I=IP+IR(JKL+3); BUFOT(HKLPT+4)=QX(I)#  Store fobs                       RE54 162
I=IP+IR(JKL+4); BUFOT(HKLPT+5)=QX(I)#  Store sigma                      RE54 163
HKLPT=HKLPT+5#                         Up the bufot pointer             RE54 164
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RE54 165
ELSE IF(INTEN==2)#                     Hkl integrated section           RE54 166
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RE54 167
movereal:(voidflg:,1,BUFOT,1,18,2)#    Void bufot                       RE54 168
I=IP+IR(1); gethkl:(I,BUFOT)#          Unpack & store h,k,l             RE54 169
DO I=2,18; IF(IR(I)>0) BUFOT(I+2)=QX(IP+IR(I))# Hkl integrated stuff    RE54 170
movechar:(RE5HB,1,CHRIN,1,1,0)#        Insert 1 as phys rec no.         RE54 171
movechar:(RE56A,9,CHRIN,2,4,0)#        Insert cid int header            RE54 172
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE54 173
movechar:(RE5HB,2,CHRIN,11,1,0)#       Insert prcn                      RE54 174
ncodefld:(BUFOT,1,CHRIN,FMT13A,8)#     Format 1st phys rec              RE54 175
putrecd:#                              Output h,k,l compressed          RE54 176
movechar:(RE5HB,2,CHRIN,1,1,0)#        Insert 2 as phys rec no.         RE54 177
movechar:(RE56A,9,CHRIN,2,4,0)#        Insert cid int header            RE54 178
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE54 179
ncodefld:(BUFOT,9,CHRIN,FMT13B,12)#    Format 2nd phys rec              RE54 180
putrecd:#                              Output h,k,l integrated          RE54 181
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RE54 182
ELSE IF((INTEN>=3)&(INTEN<=5))#        Hkl compressed section           RE54 183
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RE54 184
I=IP+IR(1); gethkl:(I,H)#              Unpack  h,k,l                    RE54 185
DO I=1,3; H(I)=ZGN*H(I)#               Allow for antireflns             RE54 186
IF(HKLPT>0) ifne:(H(MEDIUM),MEDHKL) HKLPT=15# Force buffer out if       RE54 187
IF(HKLPT>0) ifne:(H(SLOW),SLWHKL) HKLPT=15# Medium or slow hkl chang    RE54 188
IF(HKLPT==15)#                         Need to empty buffer?            RE54 189
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RE54 190
movechar:(RE56E,2*INTEN-5,CHRIN,2,2,0)# Insert section header           RE54 191
movechar:(RE56E,FAST+6,CHRIN,4,1,0)#   Insert fast index symbol         RE54 192
ncodefld:(BUFOT,1,CHRIN,FMT14,17)#     Format h,k,l,val,sig 5 times     RE54 193
putrecd:#                              Output h,k,l etc.                RE54 194
DO I=1,17; BUFOT(I)=voidflg:#          Default op buffer                RE54 195
DO I=6,15,3; BUFOT(I)=999.#            Void indices                     RE54 196
HKLPT=-1#                              Do next block as well            RE54 197
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RE54 198
IF(HKLPT==-1)#                         Initialize values                RE54 199
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RE54 200
HKLPT=0#                               Hkl pointer reset                RE54 201
BUFOT(1)=H(1);BUFOT(2)=H(2)#           Store hkl in bufot               RE54 202
BUFOT(3)=H(3)#                                                          RE54 203
MEDHKL=H(MEDIUM);SLWHKL=H(SLOW)#       Keep medium & slow indices       RE54 204
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RE54 205
IF(HKLPT!=0) BUFOT(HKLPT+3)=H(FAST)#   Store fast index                 RE54 206
IF(IR(JKL+3)>0) BUFOT(HKLPT+4)=QX(IP+IR(JKL+3))# Store fobs             RE54 207
IF(IR(JKL+4)>0) BUFOT(HKLPT+5)=QX(IP+IR(JKL+4))# Store sigma            RE54 208
HKLPT=HKLPT+3#                         Up the bufot pointer             RE54 209
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RE54 210
ELSE#                                  Hkl section                      RE54 211
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RE54 212
movechar:(RE56A,4*INTEN-23,CHRIN,2,4,0)# Insert section header          RE54 213
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE54 214
I=IP+IR(1); gethkl:(I,H)#              Unpack & store h,k,l             RE54 215
DO I=1,3; BUFOT(I)=ZGN*H(I)#           Allow for antireflns             RE54 216
I=6; IF(IR(JKL+2)>0) ifnv:(QX(IP+IR(JKL+2))) $# Retreive jcode          RE54 217
I=NINT(QX(IP+IR(JKL+2)))#                                               RE54 218
movechar:(RE5F,I,CHRIN,25,1,0)#        Store code as letter             RE54 219
IF(IR(JKL+3)>0) BUFOT(4)=QX(MARK9+1)*QX(IP+IR(JKL+3))# Store fobs or    RE54 220
IF(IR(JKL+4)>0) BUFOT(5)=QX(MARK9+1)*QX(IP+IR(JKL+4))# Store sigma      RE54 221
IF(INTEN==7)#                                                           RE54 222
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RE54 223
IF(IR(JKL+5)>0) ifnv:(QX(IP+IR(JKL+5)))$# Fsqr section                  RE54 224
BUFOT(6)=QX(IP+IR(JKL+5))**2#          Fcalc**2                         RE54 225
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RE54 226
ELSE IF(INTEN>=8)#                                                      RE54 227
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RE54 228
IF(IR(JKL+5)>0) BUFOT(6)=QX(IP+IR(JKL+5))# I(rel) or fcalc              RE54 229
IF(IR(JKL+6)>0) BUFOT(7)=QX(IP+IR(JKL+6))# Blank  or a                  RE54 230
IF(IR(JKL+7)>0) BUFOT(8)=QX(IP+IR(JKL+7))# Sigma(irel) or b             RE54 231
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RE54 232
ncodefld:(BUFOT,1,CHRIN,FMT5,NFLDX)#   Format h,k,l,fobs,sigf and res   RE54 233
putrecd:#                              Output h,k,l etc.                RE54 234
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RE54 235
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RE54 236
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RE54 237
IF(INTEN==1)#                          Finish off hkl pack              RE54 238
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RE54 239
movechar:(RE5G,5,CHRIN,1,1,0)#         * in position 1                  RE54 240
ncodefld:(BUFOT,1,CHRIN,FMT11,15)#     Format h,k,l,fobs,sigf 3 times   RE54 241
putrecd:#                              Output h,k,l etc.                RE54 242
movechar:(BLANK,1,CHRIN,1,80,1)#       Blank out chrin                  RE54 243
putrecd:#                                                               RE54 244
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RE54 245
ELSE IF((INTEN>=3)&(INTEN<=5)&(HKLPT!=0))# Finish hkl compressed        RE54 246
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RE54 247
movechar:(RE56E,2*INTEN-5,CHRIN,2,2,0)# Insert section header           RE54 248
movechar:(RE56E,FAST+6,CHRIN,4,1,0)#   Insert fast index symbol         RE54 249
ncodefld:(BUFOT,1,CHRIN,FMT14,17)#     Format h,k,l,val,sig 5 times     RE54 250
putrecd:#                              Output h,k,l etc.                RE54 251
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RE54 252
IF(INTEN!=1) putlast:#                 Output *eos record               RE54 253
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RE54 254
#                                                                       RE54 255
#     READ LRTHET: AND OUTPUT HKL/ANGL                                  RE54 256
#     --------------------------------                                  RE54 257
#                                                                       RE54 258
J=0#                                   Any lines?                       RE54 259
REPEAT#                                Loop over data angles            RE54 260
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 RE54 261
readwpkt:(1,lrthet:,NP,IP,0)#          Point to sym matrix pkt          RE54 262
IF(IP<=0) BREAK#                       Exit on last pkt                 RE54 263
ifne:(DSNM,QX(IP+1)) NEXT#             Treat requested dataset          RE54 264
IF(J==0)#                              Output the header line           RE54 265
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 RE54 266
J=1;puthead:(RE56)#                    Output hkl head once only        RE54 267
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 RE54 268
movechar:(RE56A,17,CHRIN,2,4,0)#       Insert 'angl' string             RE54 269
ncodefld:(QX,IP+2,CHRIN,FMT5A,5)#      Format h,k,l, two-theta, index   RE54 270
putrecd:#                              Output angl record               RE54 271
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 RE54 272
IF(J!=0) putlast:#                     Output *eos record               RE54 273
#                                                                       RE54 274
#    READ LRSFLS:                                                       RE54 275
#                                                                       RE54 276
DO I=1,45; IW(I)=I#                    Ask for everything               RE54 277
KEY(1)=1; KEY(2)=45; KEY(3)=0;KEY(4)=0# Set dir search keys             RE54 278
indexpkt:(1,lrsfls:,NP,IP,0,KEY,IW,IR)# Get idnum positions             RE54 279
REPEAT#                                Find required data set           RE54 280
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 RE54 281
readwpkt:(1,lrsfls:,NP,IP,0)#          Point to parameter pkt           RE54 282
IF(IP<=0) BREAK#                       Finished lrsfls:                 RE54 283
ifeq:(DSNM,QX(IP+IR(1))) BREAK#        Find required data set           RE54 284
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 RE54 285
IF(IP>0)#                              Got something for dsnm           RE54 286
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 RE54 287
DO I=1,6#                              Save 6 strings for comments      RE54 288
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 RE54 289
IF(IR(10+I)>0) ifnv:(QX(IP+IR(10+I)))# Valid comment?                   RE54 290
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 RE54 291
movechar:(BLANK,1,CHRIN,1,75,1)#       Blank chrin                      RE54 292
movechar:(RE5IA,4*I+13,CHRIN,2,4,0)#   Move cid to chrin                RE54 293
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE54 294
movechar:(RE5IB,22*I-21,CHRIN,11,22,0)# Get comment                     RE54 295
movertoc:(QX(IP+IR(10+I)),1,CHRIN,33,40,0)# Get comment                 RE54 296
movector:(CHRIN,1,QX(POINT2+1),1,75,0)# Store the comment               RE54 297
movechar:(BLANK,1,CHRIN,1,75,1)#       Blank chrin                      RE54 298
POINT2=POINT2+STEP2#                                                    RE54 299
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 RE54 300
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 RE54 301
#                                                                       RE54 302
#    OUTPUT CONDITIONS RECORDS FOR REFINEMENT STATISTICS                RE54 303
#    ---------------------------------------------------                RE54 304
#                                                                       RE54 305
puthead:(RE5A)#                        Output conditions head           RE54 306
movereal:(voidflg:,1,BUFOT,31,6,2)#    Void high bufot                  RE54 307
KSV=0;L=IP+IR(41);IF(L>IP) ifnv:(QX(L)) KSV=NINT(QX(L))#                RE54 308
IF(IR(29)>0) BUFOT(31)=QX(IP+IR(29))#  Max shift/error                  RE54 309
IF(IR(30)>0) BUFOT(32)=QX(IP+IR(30))#  Average shift/error              RE54 310
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE54 311
movechar:(RE5AA,49,CHRIN,2,4,0)#       Store stat into record           RE54 312
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE54 313
movechar:(RE5AB,7,CHRIN,10,1,0)#       R factor code                    RE54 314
IF(IR(21)>0) BUFOT(1)=QX(IP+IR(21))#   |f| r factor all data            RE54 315
IF(IR(27)>0) BUFOT(3)=QX(IP+IR(27))#   Goodness of fit                  RE54 316
IF(IR(22)>0) BUFOT(4)=QX(IP+IR(22))#   |f| r factor "observed" only     RE54 317
ncodefld:(BUFOT,1,CHRIN,FMT7,6)#       Format stat parameters           RE54 318
putrecd:#                              Output stat record               RE54 319
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE54 320
movechar:(RE5AA,49,CHRIN,2,4,0)#       Store stat into record           RE54 321
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE54 322
movechar:(RE5AB,8,CHRIN,10,1,0)#       R factor code                    RE54 323
IF(IR(23)>0) BUFOT(1)=QX(IP+IR(23))#   |f|**2 r factor all data         RE54 324
IF(IR(25)>0) BUFOT(2)=QX(IP+IR(25))#   Weighted |f|**2 r factor all d   RE54 325
IF(IR(27)>0) BUFOT(3)=QX(IP+IR(27))#   Goodness of fit                  RE54 326
IF(IR(24)>0) BUFOT(4)=QX(IP+IR(24))#   |f|**2 r factor "observed" onl   RE54 327
ncodefld:(BUFOT,1,CHRIN,FMT7,6)#       Format stat parameters           RE54 328
putrecd:#                              Output stat record               RE54 329
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE54 330
movechar:(RE5AA,53,CHRIN,2,4,0)#       Store var into record            RE54 331
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE54 332
IF(IR(43)>0) BUFOT(1)=QX(IP+IR(43))#   Number of reflections            RE54 333
IF(IR(42)>0) BUFOT(2)=QX(IP+IR(42))#   Number of parameters refined     RE54 334
ncodefld:(BUFOT,1,CHRIN,FMT7B,6)#      Format var parameters            RE54 335
putrecd:#                              Output var record                RE54 336
#                                                                       RE54 337
#                                                                       RE54 338
#                                                                       RE54 339
#    READ LRDENS:                                                       RE54 340
#                                                                       RE54 341
DO I=1,2; IW(I)=I+10#                  Ask for everything               RE54 342
KEY(1)=1; KEY(2)=2; KEY(3)=0;KEY(4)=0# Set dir search keys              RE54 343
indexpkt:(1,lrdens:,NP,IP,0,KEY,IW,IR)# Get idnum positions             RE54 344
readwpkt:(1,lrdens:,NP,IP,0)#          Point to parameter pkt           RE54 345
IF(IP>0)#                              Finished lrsfls:                 RE54 346
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 RE54 347
IF(IR(1)>0) BUFOT(34)=QX(IP+IR(1))#    Min density                      RE54 348
IF(IR(2)>0) BUFOT(33)=QX(IP+IR(2))#    Max density                      RE54 349
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 RE54 350
#                                      Ouput refn from high bufot       RE54 351
movechar:(RE5AA,45,CHRIN,2,4,0)#       Store refn into record           RE54 352
movechar:(DSK,1,CHRIN,6,4,0)#          Store dsk into record            RE54 353
movechar:(RE5AB,KSV+6,CHRIN,10,1,0)#   Refinement code                  RE54 354
ncodefld:(BUFOT,31,CHRIN,FMT7,6)#      Format refn parameters           RE54 355
putrecd:#                              Output var record                RE54 356
putlast:#                              Output *eos record               RE54 357
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 RE54 358
#                                                                       RE54 359
#    OUTPUT COMMENTS RECORDS                                            RE54 360
#    -----------------------                                            RE54 361
#                                                                       RE54 362
IF(POINT2>MARK2)#                      Something to do?                 RE54 363
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 RE54 364
puthead:(RE5I)#                        Output comments header           RE54 365
FOR(I=MARK2;I<POINT2;I=I+STEP2)#       Loop over comments               RE54 366
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 RE54 367
movertoc:(QX(I+1),1,CHRIN,1,75,0)#     Transfer comment                 RE54 368
putrecd:#                              Output phys in cell dim          RE54 369
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 RE54 370
putlast:#                              Output *eos record               RE54 371
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 RE54 372
#                                                                       RE54 373
#    READ LRBOND: AND OUTPUT GEOMETRY BOND                              RE54 374
#                                                                       RE54 375
IW(1)=91;IW(2)=92;IW(3)=11;IW(4)=15;IW(5)=16# Dist esd label, sym, tr   RE54 376
IW(6)=21;IW(7)=25;IW(8)=26#            Label sym translation            RE54 377
KEY(1)=0; KEY(2)=8; KEY(3)=0;KEY(4)=0# Set dir search keys              RE54 378
indexpkt:(1,lrbond:,NP,IP,0,KEY,IW,IR)# Get idnum positions             RE54 379
IF(IP>0)#                              Anything to do                   RE54 380
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 RE54 381
puthead:(RE5H)#                        Output geometry head             RE54 382
REPEAT#                                Loop over distances              RE54 383
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 RE54 384
readwpkt:(1,lrbond:,NP,IP,0)#          Point to parameter pkt           RE54 385
IF(IP<=0) BREAK#                       Finished lrbond:                 RE54 386
movereal:(voidflg:,1,BUFOT,1,6,2)#     Void bufot                       RE54 387
movechar:(RE5HA,1,CHRIN,2,4,0)#        Store bond into record           RE54 388
movechar:(RE5HB,1,CHRIN,1,1,0)#        Store 1 into position 1          RE54 389
movechar:(RE5HB,3,CHRIN,11,1,0)#       Store 3 into position 11         RE54 390
IF(IR(1)>0) BUFOT(1)=QX(IP+IR(1))#     Bond length                      RE54 391
IF(IR(2)>0) BUFOT(2)=QX(IP+IR(2))#     Esd bond length                  RE54 392
ncodefld:(BUFOT,1,CHRIN,FMT12,6)#      Format phys record 1             RE54 393
putrecd:#                              Output phys record 1             RE54 394
DO L=1,2#                              Two names to output              RE54 395
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 RE54 396
movechar:(RE5HA,1,CHRIN,2,4,0)#        Store bond into record           RE54 397
movechar:(RE5HB,L+1,CHRIN,1,1,0)#      Store 2/3 into position 1/2      RE54 398
K=IP+IR(3*L)#                          Point to atom name               RE54 399
# MAKE ATOM NUMBER ACCORDING TO SCFS RULES                              RE54 400
movertoc:(QX(K),1,CHRIN,7,2,0)#        Move ff (2 chars) name to chri   RE54 401
upcase:(CHRIN(8^8),CHONE,1)#                                            RE54 402
IF((CHONE<RE5G(1^1))\(CHONE>RE5G(2^2)))$# Blank out 2nd                 RE54 403
movechar:(BLANK,1,CHRIN,8,1,0)#        If it is not alphabetic          RE54 404
movertoc:(QX(K),1,ATNUM,1,4,0)#        Pick up first 4 chars of atom    RE54 405
FOR(I=4;I>1;I=I-1) IF(((ATNUM(I^I)<RE5G(3^3))$# Backwards to last       RE54 406
\(ATNUM(I^I)>RE5G(4^4)))&(ATNUM(I^I)!=BLANK(1^1))) BREAK# Non-number    RE54 407
I=I+1;J=MIN(9-I,6)#                    First and num of chars.          RE54 408
movechar:(BLANK,1,ATNUM,1,6,1)#        Blank out atom number            RE54 409
movertoc:(QX(K),I,CHRIN,9,J,0)#        Fill atnum with atom number      RE54 410
BUFOT(1)=QX(IP+IR(3*L+1))#             Symmetry operator                RE54 411
ifeq:(BUFOT(1),0.0) BUFOT(1)=1.0#      0 is the identity operator       RE54 412
J=NINT(QX(IP+IR(3*L+2)))#              Translation operator             RE54 413
IF(J==0)J=555#                         Set default origin               RE54 414
BUFOT(2)=REAL(-5+J/100)#               X translation                    RE54 415
BUFOT(3)=REAL(-5+MOD(J/10,10))#        Y translation                    RE54 416
BUFOT(4)=REAL(-5+MOD(J,10))#           Z translation                    RE54 417
ncodefld:(BUFOT,1,CHRIN,FMT15,4)#      Fill symmetry / translation      RE54 418
putrecd:#                              Output phys record 2/3           RE54 419
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 RE54 420
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 RE54 421
putlast:#                              Output *eos record               RE54 422
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 RE54 423
#                                                                       RE54 424
#    OUTPUT END RECORD                                                  RE54 425
#    -----------------                                                  RE54 426
#                                                                       RE54 427
movechar:(REEN,1,CHRIN,1,3,0)#         Insert end header                RE54 428
putrecd:#                              Output end header                RE54 429
closefmt:(iofm1:)#                     Close off formatted output fil   RE54 430
readwpkt:(1,endrecord:,NP,IP,0)#       Close off bdf input file         RE54 431
#                                                                       RE54 432
RETURN#                                                                 RE54 433
END#                                                                    RE54 434
pmacro:([no:])#                                                         RE54 435
